library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
 
entity pet816test is
end entity;
	 
architecture test of pet816test is
	 
    component pet816_tb
       port(
                control_reg_init_val :in std_logic_vector(7 downto 0);
                clock_reg_init_val   :in std_logic_vector(7 downto 0);
                cpu_addr_bank        :in std_logic_vector(7 downto 0);
                rom_addr             :out std_logic_vector (14 downto 0);
                rom_data             :in std_logic_vector (7 downto 0);
                from_addr            :out std_logic_vector (14 downto 0);
                from_data            :in std_logic_vector (7 downto 0);
                clksel               :in std_logic      -- 0 is 1MHz, 1 is 2MHz system clock
        );
    end component;

  component pet_rom_short 
    port (
	addr  :in std_logic_vector (14 downto 0);
        data  :out std_logic_vector (7 downto 0)
    );
  end component;

  constant control_reg_init_val : std_logic_vector(7 downto 0) := "00100000";
  constant clock_reg_init_val 	: std_logic_vector(7 downto 0) := "10000110";
  constant cpu_addr_bank_init	: std_logic_vector(7 downto 0) := "00000000";
  constant clksel 		: std_logic := '1';

  signal cpu_addr_bank		: std_logic_vector(7 downto 0);
  signal rom_addr		: std_logic_vector(14 downto 0);
  signal rom_data		: std_logic_vector(7 downto 0);
  signal from_addr		: std_logic_vector(14 downto 0);
  signal from_data		: std_logic_vector(7 downto 0);

begin

    cpu_addr_bank <= cpu_addr_bank_init;	-- CPU bank to run on

    tb: pet816_tb port map (
	control_reg_init_val,
	clock_reg_init_val,
	cpu_addr_bank,
	rom_addr,
	rom_data,
	from_addr,
	from_data,
	clksel
    );

    rom: pet_rom_short port map (
        rom_addr,
        rom_data
    );

    from: pet_rom_short port map (
        from_addr,
        from_data
    );

end;
