----------------------------------------------------------------------------
----------------------------------------------------------------------------
--  The Free IP Project
--  VHDL DES Core
--  (c) 1999, The Free IP Project and David Kessner
--
--
--  FREE IP GENERAL PUBLIC LICENSE
--  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION
--
--  1.  You may copy and distribute verbatim copies of this core, as long
--      as this file, and the other associated files, remain intact and
--      unmodified.  Modifications are outlined below.  Also, see the
--      import/export warning above for further restrictions on
--      distribution.
--  2.  You may use this core in any way, be it academic, commercial, or
--      military.  Modified or not.
--  3.  Distribution of this core must be free of charge.  Charging is
--      allowed only for value added services.  Value added services
--      would include copying fees, modifications, customizations, and
--      inclusion in other products.
--  4.  If a modified source code is distributed, the original unmodified
--      source code must also be included (or a link to the Free IP web
--      site).  In the modified source code there must be clear
--      identification of the modified version.
--  5.  Visit the Free IP web site for additional information.
--      http://www.free-ip.com
--
----------------------------------------------------------------------------
----------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;

package rom_suite is
  component pet_rom
    port (addr	:in std_logic_vector (14 downto 0);
          data  :out std_logic_vector (7 downto 0)
         );
  end component;
end rom_suite;


------------------------------------------------------------------------------
------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library work;
--use work.test_suite.all;

entity pet_rom is
    port (addr	:in std_logic_vector (14 downto 0);
          data  :out std_logic_vector (7 downto 0)
         );
end pet_rom;

architecture arch_test_rom of pet_rom is
begin
  process (addr)
  begin
    case addr(14 downto 0) is
      --addrbits 15
      --databits 8
      --varname data
      --little-endian
      --start_of_rom      -- rom2vhdl output.  Fri Apr 16 23:04:55 2010      -- rom2vhdl output.  Fri Apr 16 23:11:06 2010
      when "000000000000000" =>  data <= "11111111";  -- 0 = FF
      when "000000000000001" =>  data <= "11111111";  -- 1 = FF
      when "000000000000010" =>  data <= "11111111";  -- 2 = FF
      when "000000000000011" =>  data <= "11111111";  -- 3 = FF
      when "000000000000100" =>  data <= "11111111";  -- 4 = FF
      when "000000000000101" =>  data <= "11111111";  -- 5 = FF
      when "000000000000110" =>  data <= "11111111";  -- 6 = FF
      when "000000000000111" =>  data <= "11111111";  -- 7 = FF
      when "000000000001000" =>  data <= "11111111";  -- 8 = FF
      when "000000000001001" =>  data <= "11111111";  -- 9 = FF
      when "000000000001010" =>  data <= "11111111";  -- A = FF
      when "000000000001011" =>  data <= "11111111";  -- B = FF
      when "000000000001100" =>  data <= "11111111";  -- C = FF
      when "000000000001101" =>  data <= "11111111";  -- D = FF
      when "000000000001110" =>  data <= "11111111";  -- E = FF
      when "000000000001111" =>  data <= "11111111";  -- F = FF
      when "000000000010000" =>  data <= "11111111";  -- 10 = FF
      when "000000000010001" =>  data <= "11111111";  -- 11 = FF
      when "000000000010010" =>  data <= "11111111";  -- 12 = FF
      when "000000000010011" =>  data <= "11111111";  -- 13 = FF
      when "000000000010100" =>  data <= "11111111";  -- 14 = FF
      when "000000000010101" =>  data <= "11111111";  -- 15 = FF
      when "000000000010110" =>  data <= "11111111";  -- 16 = FF
      when "000000000010111" =>  data <= "11111111";  -- 17 = FF
      when "000000000011000" =>  data <= "11111111";  -- 18 = FF
      when "000000000011001" =>  data <= "11111111";  -- 19 = FF
      when "000000000011010" =>  data <= "11111111";  -- 1A = FF
      when "000000000011011" =>  data <= "11111111";  -- 1B = FF
      when "000000000011100" =>  data <= "11111111";  -- 1C = FF
      when "000000000011101" =>  data <= "11111111";  -- 1D = FF
      when "000000000011110" =>  data <= "11111111";  -- 1E = FF
      when "000000000011111" =>  data <= "11111111";  -- 1F = FF
      when "000000000100000" =>  data <= "11111111";  -- 20 = FF
      when "000000000100001" =>  data <= "11111111";  -- 21 = FF
      when "000000000100010" =>  data <= "11111111";  -- 22 = FF
      when "000000000100011" =>  data <= "11111111";  -- 23 = FF
      when "000000000100100" =>  data <= "11111111";  -- 24 = FF
      when "000000000100101" =>  data <= "11111111";  -- 25 = FF
      when "000000000100110" =>  data <= "11111111";  -- 26 = FF
      when "000000000100111" =>  data <= "11111111";  -- 27 = FF
      when "000000000101000" =>  data <= "11111111";  -- 28 = FF
      when "000000000101001" =>  data <= "11111111";  -- 29 = FF
      when "000000000101010" =>  data <= "11111111";  -- 2A = FF
      when "000000000101011" =>  data <= "11111111";  -- 2B = FF
      when "000000000101100" =>  data <= "11111111";  -- 2C = FF
      when "000000000101101" =>  data <= "11111111";  -- 2D = FF
      when "000000000101110" =>  data <= "11111111";  -- 2E = FF
      when "000000000101111" =>  data <= "11111111";  -- 2F = FF
      when "000000000110000" =>  data <= "11111111";  -- 30 = FF
      when "000000000110001" =>  data <= "11111111";  -- 31 = FF
      when "000000000110010" =>  data <= "11111111";  -- 32 = FF
      when "000000000110011" =>  data <= "11111111";  -- 33 = FF
      when "000000000110100" =>  data <= "11111111";  -- 34 = FF
      when "000000000110101" =>  data <= "11111111";  -- 35 = FF
      when "000000000110110" =>  data <= "11111111";  -- 36 = FF
      when "000000000110111" =>  data <= "11111111";  -- 37 = FF
      when "000000000111000" =>  data <= "11111111";  -- 38 = FF
      when "000000000111001" =>  data <= "11111111";  -- 39 = FF
      when "000000000111010" =>  data <= "11111111";  -- 3A = FF
      when "000000000111011" =>  data <= "11111111";  -- 3B = FF
      when "000000000111100" =>  data <= "11111111";  -- 3C = FF
      when "000000000111101" =>  data <= "11111111";  -- 3D = FF
      when "000000000111110" =>  data <= "11111111";  -- 3E = FF
      when "000000000111111" =>  data <= "11111111";  -- 3F = FF
      when "000000001000000" =>  data <= "11111111";  -- 40 = FF
      when "000000001000001" =>  data <= "11111111";  -- 41 = FF
      when "000000001000010" =>  data <= "11111111";  -- 42 = FF
      when "000000001000011" =>  data <= "11111111";  -- 43 = FF
      when "000000001000100" =>  data <= "11111111";  -- 44 = FF
      when "000000001000101" =>  data <= "11111111";  -- 45 = FF
      when "000000001000110" =>  data <= "11111111";  -- 46 = FF
      when "000000001000111" =>  data <= "11111111";  -- 47 = FF
      when "000000001001000" =>  data <= "11111111";  -- 48 = FF
      when "000000001001001" =>  data <= "11111111";  -- 49 = FF
      when "000000001001010" =>  data <= "11111111";  -- 4A = FF
      when "000000001001011" =>  data <= "11111111";  -- 4B = FF
      when "000000001001100" =>  data <= "11111111";  -- 4C = FF
      when "000000001001101" =>  data <= "11111111";  -- 4D = FF
      when "000000001001110" =>  data <= "11111111";  -- 4E = FF
      when "000000001001111" =>  data <= "11111111";  -- 4F = FF
      when "000000001010000" =>  data <= "11111111";  -- 50 = FF
      when "000000001010001" =>  data <= "11111111";  -- 51 = FF
      when "000000001010010" =>  data <= "11111111";  -- 52 = FF
      when "000000001010011" =>  data <= "11111111";  -- 53 = FF
      when "000000001010100" =>  data <= "11111111";  -- 54 = FF
      when "000000001010101" =>  data <= "11111111";  -- 55 = FF
      when "000000001010110" =>  data <= "11111111";  -- 56 = FF
      when "000000001010111" =>  data <= "11111111";  -- 57 = FF
      when "000000001011000" =>  data <= "11111111";  -- 58 = FF
      when "000000001011001" =>  data <= "11111111";  -- 59 = FF
      when "000000001011010" =>  data <= "11111111";  -- 5A = FF
      when "000000001011011" =>  data <= "11111111";  -- 5B = FF
      when "000000001011100" =>  data <= "11111111";  -- 5C = FF
      when "000000001011101" =>  data <= "11111111";  -- 5D = FF
      when "000000001011110" =>  data <= "11111111";  -- 5E = FF
      when "000000001011111" =>  data <= "11111111";  -- 5F = FF
      when "000000001100000" =>  data <= "11111111";  -- 60 = FF
      when "000000001100001" =>  data <= "11111111";  -- 61 = FF
      when "000000001100010" =>  data <= "11111111";  -- 62 = FF
      when "000000001100011" =>  data <= "11111111";  -- 63 = FF
      when "000000001100100" =>  data <= "11111111";  -- 64 = FF
      when "000000001100101" =>  data <= "11111111";  -- 65 = FF
      when "000000001100110" =>  data <= "11111111";  -- 66 = FF
      when "000000001100111" =>  data <= "11111111";  -- 67 = FF
      when "000000001101000" =>  data <= "11111111";  -- 68 = FF
      when "000000001101001" =>  data <= "11111111";  -- 69 = FF
      when "000000001101010" =>  data <= "11111111";  -- 6A = FF
      when "000000001101011" =>  data <= "11111111";  -- 6B = FF
      when "000000001101100" =>  data <= "11111111";  -- 6C = FF
      when "000000001101101" =>  data <= "11111111";  -- 6D = FF
      when "000000001101110" =>  data <= "11111111";  -- 6E = FF
      when "000000001101111" =>  data <= "11111111";  -- 6F = FF
      when "000000001110000" =>  data <= "11111111";  -- 70 = FF
      when "000000001110001" =>  data <= "11111111";  -- 71 = FF
      when "000000001110010" =>  data <= "11111111";  -- 72 = FF
      when "000000001110011" =>  data <= "11111111";  -- 73 = FF
      when "000000001110100" =>  data <= "11111111";  -- 74 = FF
      when "000000001110101" =>  data <= "11111111";  -- 75 = FF
      when "000000001110110" =>  data <= "11111111";  -- 76 = FF
      when "000000001110111" =>  data <= "11111111";  -- 77 = FF
      when "000000001111000" =>  data <= "11111111";  -- 78 = FF
      when "000000001111001" =>  data <= "11111111";  -- 79 = FF
      when "000000001111010" =>  data <= "11111111";  -- 7A = FF
      when "000000001111011" =>  data <= "11111111";  -- 7B = FF
      when "000000001111100" =>  data <= "11111111";  -- 7C = FF
      when "000000001111101" =>  data <= "11111111";  -- 7D = FF
      when "000000001111110" =>  data <= "11111111";  -- 7E = FF
      when "000000001111111" =>  data <= "11111111";  -- 7F = FF
      when "000000010000000" =>  data <= "11111111";  -- 80 = FF
      when "000000010000001" =>  data <= "11111111";  -- 81 = FF
      when "000000010000010" =>  data <= "11111111";  -- 82 = FF
      when "000000010000011" =>  data <= "11111111";  -- 83 = FF
      when "000000010000100" =>  data <= "11111111";  -- 84 = FF
      when "000000010000101" =>  data <= "11111111";  -- 85 = FF
      when "000000010000110" =>  data <= "11111111";  -- 86 = FF
      when "000000010000111" =>  data <= "11111111";  -- 87 = FF
      when "000000010001000" =>  data <= "11111111";  -- 88 = FF
      when "000000010001001" =>  data <= "11111111";  -- 89 = FF
      when "000000010001010" =>  data <= "11111111";  -- 8A = FF
      when "000000010001011" =>  data <= "11111111";  -- 8B = FF
      when "000000010001100" =>  data <= "11111111";  -- 8C = FF
      when "000000010001101" =>  data <= "11111111";  -- 8D = FF
      when "000000010001110" =>  data <= "11111111";  -- 8E = FF
      when "000000010001111" =>  data <= "11111111";  -- 8F = FF
      when "000000010010000" =>  data <= "11111111";  -- 90 = FF
      when "000000010010001" =>  data <= "11111111";  -- 91 = FF
      when "000000010010010" =>  data <= "11111111";  -- 92 = FF
      when "000000010010011" =>  data <= "11111111";  -- 93 = FF
      when "000000010010100" =>  data <= "11111111";  -- 94 = FF
      when "000000010010101" =>  data <= "11111111";  -- 95 = FF
      when "000000010010110" =>  data <= "11111111";  -- 96 = FF
      when "000000010010111" =>  data <= "11111111";  -- 97 = FF
      when "000000010011000" =>  data <= "11111111";  -- 98 = FF
      when "000000010011001" =>  data <= "11111111";  -- 99 = FF
      when "000000010011010" =>  data <= "11111111";  -- 9A = FF
      when "000000010011011" =>  data <= "11111111";  -- 9B = FF
      when "000000010011100" =>  data <= "11111111";  -- 9C = FF
      when "000000010011101" =>  data <= "11111111";  -- 9D = FF
      when "000000010011110" =>  data <= "11111111";  -- 9E = FF
      when "000000010011111" =>  data <= "11111111";  -- 9F = FF
      when "000000010100000" =>  data <= "11111111";  -- A0 = FF
      when "000000010100001" =>  data <= "11111111";  -- A1 = FF
      when "000000010100010" =>  data <= "11111111";  -- A2 = FF
      when "000000010100011" =>  data <= "11111111";  -- A3 = FF
      when "000000010100100" =>  data <= "11111111";  -- A4 = FF
      when "000000010100101" =>  data <= "11111111";  -- A5 = FF
      when "000000010100110" =>  data <= "11111111";  -- A6 = FF
      when "000000010100111" =>  data <= "11111111";  -- A7 = FF
      when "000000010101000" =>  data <= "11111111";  -- A8 = FF
      when "000000010101001" =>  data <= "11111111";  -- A9 = FF
      when "000000010101010" =>  data <= "11111111";  -- AA = FF
      when "000000010101011" =>  data <= "11111111";  -- AB = FF
      when "000000010101100" =>  data <= "11111111";  -- AC = FF
      when "000000010101101" =>  data <= "11111111";  -- AD = FF
      when "000000010101110" =>  data <= "11111111";  -- AE = FF
      when "000000010101111" =>  data <= "11111111";  -- AF = FF
      when "000000010110000" =>  data <= "11111111";  -- B0 = FF
      when "000000010110001" =>  data <= "11111111";  -- B1 = FF
      when "000000010110010" =>  data <= "11111111";  -- B2 = FF
      when "000000010110011" =>  data <= "11111111";  -- B3 = FF
      when "000000010110100" =>  data <= "11111111";  -- B4 = FF
      when "000000010110101" =>  data <= "11111111";  -- B5 = FF
      when "000000010110110" =>  data <= "11111111";  -- B6 = FF
      when "000000010110111" =>  data <= "11111111";  -- B7 = FF
      when "000000010111000" =>  data <= "11111111";  -- B8 = FF
      when "000000010111001" =>  data <= "11111111";  -- B9 = FF
      when "000000010111010" =>  data <= "11111111";  -- BA = FF
      when "000000010111011" =>  data <= "11111111";  -- BB = FF
      when "000000010111100" =>  data <= "11111111";  -- BC = FF
      when "000000010111101" =>  data <= "11111111";  -- BD = FF
      when "000000010111110" =>  data <= "11111111";  -- BE = FF
      when "000000010111111" =>  data <= "11111111";  -- BF = FF
      when "000000011000000" =>  data <= "11111111";  -- C0 = FF
      when "000000011000001" =>  data <= "11111111";  -- C1 = FF
      when "000000011000010" =>  data <= "11111111";  -- C2 = FF
      when "000000011000011" =>  data <= "11111111";  -- C3 = FF
      when "000000011000100" =>  data <= "11111111";  -- C4 = FF
      when "000000011000101" =>  data <= "11111111";  -- C5 = FF
      when "000000011000110" =>  data <= "11111111";  -- C6 = FF
      when "000000011000111" =>  data <= "11111111";  -- C7 = FF
      when "000000011001000" =>  data <= "11111111";  -- C8 = FF
      when "000000011001001" =>  data <= "11111111";  -- C9 = FF
      when "000000011001010" =>  data <= "11111111";  -- CA = FF
      when "000000011001011" =>  data <= "11111111";  -- CB = FF
      when "000000011001100" =>  data <= "11111111";  -- CC = FF
      when "000000011001101" =>  data <= "11111111";  -- CD = FF
      when "000000011001110" =>  data <= "11111111";  -- CE = FF
      when "000000011001111" =>  data <= "11111111";  -- CF = FF
      when "000000011010000" =>  data <= "11111111";  -- D0 = FF
      when "000000011010001" =>  data <= "11111111";  -- D1 = FF
      when "000000011010010" =>  data <= "11111111";  -- D2 = FF
      when "000000011010011" =>  data <= "11111111";  -- D3 = FF
      when "000000011010100" =>  data <= "11111111";  -- D4 = FF
      when "000000011010101" =>  data <= "11111111";  -- D5 = FF
      when "000000011010110" =>  data <= "11111111";  -- D6 = FF
      when "000000011010111" =>  data <= "11111111";  -- D7 = FF
      when "000000011011000" =>  data <= "11111111";  -- D8 = FF
      when "000000011011001" =>  data <= "11111111";  -- D9 = FF
      when "000000011011010" =>  data <= "11111111";  -- DA = FF
      when "000000011011011" =>  data <= "11111111";  -- DB = FF
      when "000000011011100" =>  data <= "11111111";  -- DC = FF
      when "000000011011101" =>  data <= "11111111";  -- DD = FF
      when "000000011011110" =>  data <= "11111111";  -- DE = FF
      when "000000011011111" =>  data <= "11111111";  -- DF = FF
      when "000000011100000" =>  data <= "11111111";  -- E0 = FF
      when "000000011100001" =>  data <= "11111111";  -- E1 = FF
      when "000000011100010" =>  data <= "11111111";  -- E2 = FF
      when "000000011100011" =>  data <= "11111111";  -- E3 = FF
      when "000000011100100" =>  data <= "11111111";  -- E4 = FF
      when "000000011100101" =>  data <= "11111111";  -- E5 = FF
      when "000000011100110" =>  data <= "11111111";  -- E6 = FF
      when "000000011100111" =>  data <= "11111111";  -- E7 = FF
      when "000000011101000" =>  data <= "11111111";  -- E8 = FF
      when "000000011101001" =>  data <= "11111111";  -- E9 = FF
      when "000000011101010" =>  data <= "11111111";  -- EA = FF
      when "000000011101011" =>  data <= "11111111";  -- EB = FF
      when "000000011101100" =>  data <= "11111111";  -- EC = FF
      when "000000011101101" =>  data <= "11111111";  -- ED = FF
      when "000000011101110" =>  data <= "11111111";  -- EE = FF
      when "000000011101111" =>  data <= "11111111";  -- EF = FF
      when "000000011110000" =>  data <= "11111111";  -- F0 = FF
      when "000000011110001" =>  data <= "11111111";  -- F1 = FF
      when "000000011110010" =>  data <= "11111111";  -- F2 = FF
      when "000000011110011" =>  data <= "11111111";  -- F3 = FF
      when "000000011110100" =>  data <= "11111111";  -- F4 = FF
      when "000000011110101" =>  data <= "11111111";  -- F5 = FF
      when "000000011110110" =>  data <= "11111111";  -- F6 = FF
      when "000000011110111" =>  data <= "11111111";  -- F7 = FF
      when "000000011111000" =>  data <= "11111111";  -- F8 = FF
      when "000000011111001" =>  data <= "11111111";  -- F9 = FF
      when "000000011111010" =>  data <= "11111111";  -- FA = FF
      when "000000011111011" =>  data <= "11111111";  -- FB = FF
      when "000000011111100" =>  data <= "11111111";  -- FC = FF
      when "000000011111101" =>  data <= "11111111";  -- FD = FF
      when "000000011111110" =>  data <= "11111111";  -- FE = FF
      when "000000011111111" =>  data <= "11111111";  -- FF = FF
      when "000000100000000" =>  data <= "11111111";  -- 100 = FF
      when "000000100000001" =>  data <= "11111111";  -- 101 = FF
      when "000000100000010" =>  data <= "11111111";  -- 102 = FF
      when "000000100000011" =>  data <= "11111111";  -- 103 = FF
      when "000000100000100" =>  data <= "11111111";  -- 104 = FF
      when "000000100000101" =>  data <= "11111111";  -- 105 = FF
      when "000000100000110" =>  data <= "11111111";  -- 106 = FF
      when "000000100000111" =>  data <= "11111111";  -- 107 = FF
      when "000000100001000" =>  data <= "11111111";  -- 108 = FF
      when "000000100001001" =>  data <= "11111111";  -- 109 = FF
      when "000000100001010" =>  data <= "11111111";  -- 10A = FF
      when "000000100001011" =>  data <= "11111111";  -- 10B = FF
      when "000000100001100" =>  data <= "11111111";  -- 10C = FF
      when "000000100001101" =>  data <= "11111111";  -- 10D = FF
      when "000000100001110" =>  data <= "11111111";  -- 10E = FF
      when "000000100001111" =>  data <= "11111111";  -- 10F = FF
      when "000000100010000" =>  data <= "11111111";  -- 110 = FF
      when "000000100010001" =>  data <= "11111111";  -- 111 = FF
      when "000000100010010" =>  data <= "11111111";  -- 112 = FF
      when "000000100010011" =>  data <= "11111111";  -- 113 = FF
      when "000000100010100" =>  data <= "11111111";  -- 114 = FF
      when "000000100010101" =>  data <= "11111111";  -- 115 = FF
      when "000000100010110" =>  data <= "11111111";  -- 116 = FF
      when "000000100010111" =>  data <= "11111111";  -- 117 = FF
      when "000000100011000" =>  data <= "11111111";  -- 118 = FF
      when "000000100011001" =>  data <= "11111111";  -- 119 = FF
      when "000000100011010" =>  data <= "11111111";  -- 11A = FF
      when "000000100011011" =>  data <= "11111111";  -- 11B = FF
      when "000000100011100" =>  data <= "11111111";  -- 11C = FF
      when "000000100011101" =>  data <= "11111111";  -- 11D = FF
      when "000000100011110" =>  data <= "11111111";  -- 11E = FF
      when "000000100011111" =>  data <= "11111111";  -- 11F = FF
      when "000000100100000" =>  data <= "11111111";  -- 120 = FF
      when "000000100100001" =>  data <= "11111111";  -- 121 = FF
      when "000000100100010" =>  data <= "11111111";  -- 122 = FF
      when "000000100100011" =>  data <= "11111111";  -- 123 = FF
      when "000000100100100" =>  data <= "11111111";  -- 124 = FF
      when "000000100100101" =>  data <= "11111111";  -- 125 = FF
      when "000000100100110" =>  data <= "11111111";  -- 126 = FF
      when "000000100100111" =>  data <= "11111111";  -- 127 = FF
      when "000000100101000" =>  data <= "11111111";  -- 128 = FF
      when "000000100101001" =>  data <= "11111111";  -- 129 = FF
      when "000000100101010" =>  data <= "11111111";  -- 12A = FF
      when "000000100101011" =>  data <= "11111111";  -- 12B = FF
      when "000000100101100" =>  data <= "11111111";  -- 12C = FF
      when "000000100101101" =>  data <= "11111111";  -- 12D = FF
      when "000000100101110" =>  data <= "11111111";  -- 12E = FF
      when "000000100101111" =>  data <= "11111111";  -- 12F = FF
      when "000000100110000" =>  data <= "11111111";  -- 130 = FF
      when "000000100110001" =>  data <= "11111111";  -- 131 = FF
      when "000000100110010" =>  data <= "11111111";  -- 132 = FF
      when "000000100110011" =>  data <= "11111111";  -- 133 = FF
      when "000000100110100" =>  data <= "11111111";  -- 134 = FF
      when "000000100110101" =>  data <= "11111111";  -- 135 = FF
      when "000000100110110" =>  data <= "11111111";  -- 136 = FF
      when "000000100110111" =>  data <= "11111111";  -- 137 = FF
      when "000000100111000" =>  data <= "11111111";  -- 138 = FF
      when "000000100111001" =>  data <= "11111111";  -- 139 = FF
      when "000000100111010" =>  data <= "11111111";  -- 13A = FF
      when "000000100111011" =>  data <= "11111111";  -- 13B = FF
      when "000000100111100" =>  data <= "11111111";  -- 13C = FF
      when "000000100111101" =>  data <= "11111111";  -- 13D = FF
      when "000000100111110" =>  data <= "11111111";  -- 13E = FF
      when "000000100111111" =>  data <= "11111111";  -- 13F = FF
      when "000000101000000" =>  data <= "11111111";  -- 140 = FF
      when "000000101000001" =>  data <= "11111111";  -- 141 = FF
      when "000000101000010" =>  data <= "11111111";  -- 142 = FF
      when "000000101000011" =>  data <= "11111111";  -- 143 = FF
      when "000000101000100" =>  data <= "11111111";  -- 144 = FF
      when "000000101000101" =>  data <= "11111111";  -- 145 = FF
      when "000000101000110" =>  data <= "11111111";  -- 146 = FF
      when "000000101000111" =>  data <= "11111111";  -- 147 = FF
      when "000000101001000" =>  data <= "11111111";  -- 148 = FF
      when "000000101001001" =>  data <= "11111111";  -- 149 = FF
      when "000000101001010" =>  data <= "11111111";  -- 14A = FF
      when "000000101001011" =>  data <= "11111111";  -- 14B = FF
      when "000000101001100" =>  data <= "11111111";  -- 14C = FF
      when "000000101001101" =>  data <= "11111111";  -- 14D = FF
      when "000000101001110" =>  data <= "11111111";  -- 14E = FF
      when "000000101001111" =>  data <= "11111111";  -- 14F = FF
      when "000000101010000" =>  data <= "11111111";  -- 150 = FF
      when "000000101010001" =>  data <= "11111111";  -- 151 = FF
      when "000000101010010" =>  data <= "11111111";  -- 152 = FF
      when "000000101010011" =>  data <= "11111111";  -- 153 = FF
      when "000000101010100" =>  data <= "11111111";  -- 154 = FF
      when "000000101010101" =>  data <= "11111111";  -- 155 = FF
      when "000000101010110" =>  data <= "11111111";  -- 156 = FF
      when "000000101010111" =>  data <= "11111111";  -- 157 = FF
      when "000000101011000" =>  data <= "11111111";  -- 158 = FF
      when "000000101011001" =>  data <= "11111111";  -- 159 = FF
      when "000000101011010" =>  data <= "11111111";  -- 15A = FF
      when "000000101011011" =>  data <= "11111111";  -- 15B = FF
      when "000000101011100" =>  data <= "11111111";  -- 15C = FF
      when "000000101011101" =>  data <= "11111111";  -- 15D = FF
      when "000000101011110" =>  data <= "11111111";  -- 15E = FF
      when "000000101011111" =>  data <= "11111111";  -- 15F = FF
      when "000000101100000" =>  data <= "11111111";  -- 160 = FF
      when "000000101100001" =>  data <= "11111111";  -- 161 = FF
      when "000000101100010" =>  data <= "11111111";  -- 162 = FF
      when "000000101100011" =>  data <= "11111111";  -- 163 = FF
      when "000000101100100" =>  data <= "11111111";  -- 164 = FF
      when "000000101100101" =>  data <= "11111111";  -- 165 = FF
      when "000000101100110" =>  data <= "11111111";  -- 166 = FF
      when "000000101100111" =>  data <= "11111111";  -- 167 = FF
      when "000000101101000" =>  data <= "11111111";  -- 168 = FF
      when "000000101101001" =>  data <= "11111111";  -- 169 = FF
      when "000000101101010" =>  data <= "11111111";  -- 16A = FF
      when "000000101101011" =>  data <= "11111111";  -- 16B = FF
      when "000000101101100" =>  data <= "11111111";  -- 16C = FF
      when "000000101101101" =>  data <= "11111111";  -- 16D = FF
      when "000000101101110" =>  data <= "11111111";  -- 16E = FF
      when "000000101101111" =>  data <= "11111111";  -- 16F = FF
      when "000000101110000" =>  data <= "11111111";  -- 170 = FF
      when "000000101110001" =>  data <= "11111111";  -- 171 = FF
      when "000000101110010" =>  data <= "11111111";  -- 172 = FF
      when "000000101110011" =>  data <= "11111111";  -- 173 = FF
      when "000000101110100" =>  data <= "11111111";  -- 174 = FF
      when "000000101110101" =>  data <= "11111111";  -- 175 = FF
      when "000000101110110" =>  data <= "11111111";  -- 176 = FF
      when "000000101110111" =>  data <= "11111111";  -- 177 = FF
      when "000000101111000" =>  data <= "11111111";  -- 178 = FF
      when "000000101111001" =>  data <= "11111111";  -- 179 = FF
      when "000000101111010" =>  data <= "11111111";  -- 17A = FF
      when "000000101111011" =>  data <= "11111111";  -- 17B = FF
      when "000000101111100" =>  data <= "11111111";  -- 17C = FF
      when "000000101111101" =>  data <= "11111111";  -- 17D = FF
      when "000000101111110" =>  data <= "11111111";  -- 17E = FF
      when "000000101111111" =>  data <= "11111111";  -- 17F = FF
      when "000000110000000" =>  data <= "11111111";  -- 180 = FF
      when "000000110000001" =>  data <= "11111111";  -- 181 = FF
      when "000000110000010" =>  data <= "11111111";  -- 182 = FF
      when "000000110000011" =>  data <= "11111111";  -- 183 = FF
      when "000000110000100" =>  data <= "11111111";  -- 184 = FF
      when "000000110000101" =>  data <= "11111111";  -- 185 = FF
      when "000000110000110" =>  data <= "11111111";  -- 186 = FF
      when "000000110000111" =>  data <= "11111111";  -- 187 = FF
      when "000000110001000" =>  data <= "11111111";  -- 188 = FF
      when "000000110001001" =>  data <= "11111111";  -- 189 = FF
      when "000000110001010" =>  data <= "11111111";  -- 18A = FF
      when "000000110001011" =>  data <= "11111111";  -- 18B = FF
      when "000000110001100" =>  data <= "11111111";  -- 18C = FF
      when "000000110001101" =>  data <= "11111111";  -- 18D = FF
      when "000000110001110" =>  data <= "11111111";  -- 18E = FF
      when "000000110001111" =>  data <= "11111111";  -- 18F = FF
      when "000000110010000" =>  data <= "11111111";  -- 190 = FF
      when "000000110010001" =>  data <= "11111111";  -- 191 = FF
      when "000000110010010" =>  data <= "11111111";  -- 192 = FF
      when "000000110010011" =>  data <= "11111111";  -- 193 = FF
      when "000000110010100" =>  data <= "11111111";  -- 194 = FF
      when "000000110010101" =>  data <= "11111111";  -- 195 = FF
      when "000000110010110" =>  data <= "11111111";  -- 196 = FF
      when "000000110010111" =>  data <= "11111111";  -- 197 = FF
      when "000000110011000" =>  data <= "11111111";  -- 198 = FF
      when "000000110011001" =>  data <= "11111111";  -- 199 = FF
      when "000000110011010" =>  data <= "11111111";  -- 19A = FF
      when "000000110011011" =>  data <= "11111111";  -- 19B = FF
      when "000000110011100" =>  data <= "11111111";  -- 19C = FF
      when "000000110011101" =>  data <= "11111111";  -- 19D = FF
      when "000000110011110" =>  data <= "11111111";  -- 19E = FF
      when "000000110011111" =>  data <= "11111111";  -- 19F = FF
      when "000000110100000" =>  data <= "11111111";  -- 1A0 = FF
      when "000000110100001" =>  data <= "11111111";  -- 1A1 = FF
      when "000000110100010" =>  data <= "11111111";  -- 1A2 = FF
      when "000000110100011" =>  data <= "11111111";  -- 1A3 = FF
      when "000000110100100" =>  data <= "11111111";  -- 1A4 = FF
      when "000000110100101" =>  data <= "11111111";  -- 1A5 = FF
      when "000000110100110" =>  data <= "11111111";  -- 1A6 = FF
      when "000000110100111" =>  data <= "11111111";  -- 1A7 = FF
      when "000000110101000" =>  data <= "11111111";  -- 1A8 = FF
      when "000000110101001" =>  data <= "11111111";  -- 1A9 = FF
      when "000000110101010" =>  data <= "11111111";  -- 1AA = FF
      when "000000110101011" =>  data <= "11111111";  -- 1AB = FF
      when "000000110101100" =>  data <= "11111111";  -- 1AC = FF
      when "000000110101101" =>  data <= "11111111";  -- 1AD = FF
      when "000000110101110" =>  data <= "11111111";  -- 1AE = FF
      when "000000110101111" =>  data <= "11111111";  -- 1AF = FF
      when "000000110110000" =>  data <= "11111111";  -- 1B0 = FF
      when "000000110110001" =>  data <= "11111111";  -- 1B1 = FF
      when "000000110110010" =>  data <= "11111111";  -- 1B2 = FF
      when "000000110110011" =>  data <= "11111111";  -- 1B3 = FF
      when "000000110110100" =>  data <= "11111111";  -- 1B4 = FF
      when "000000110110101" =>  data <= "11111111";  -- 1B5 = FF
      when "000000110110110" =>  data <= "11111111";  -- 1B6 = FF
      when "000000110110111" =>  data <= "11111111";  -- 1B7 = FF
      when "000000110111000" =>  data <= "11111111";  -- 1B8 = FF
      when "000000110111001" =>  data <= "11111111";  -- 1B9 = FF
      when "000000110111010" =>  data <= "11111111";  -- 1BA = FF
      when "000000110111011" =>  data <= "11111111";  -- 1BB = FF
      when "000000110111100" =>  data <= "11111111";  -- 1BC = FF
      when "000000110111101" =>  data <= "11111111";  -- 1BD = FF
      when "000000110111110" =>  data <= "11111111";  -- 1BE = FF
      when "000000110111111" =>  data <= "11111111";  -- 1BF = FF
      when "000000111000000" =>  data <= "11111111";  -- 1C0 = FF
      when "000000111000001" =>  data <= "11111111";  -- 1C1 = FF
      when "000000111000010" =>  data <= "11111111";  -- 1C2 = FF
      when "000000111000011" =>  data <= "11111111";  -- 1C3 = FF
      when "000000111000100" =>  data <= "11111111";  -- 1C4 = FF
      when "000000111000101" =>  data <= "11111111";  -- 1C5 = FF
      when "000000111000110" =>  data <= "11111111";  -- 1C6 = FF
      when "000000111000111" =>  data <= "11111111";  -- 1C7 = FF
      when "000000111001000" =>  data <= "11111111";  -- 1C8 = FF
      when "000000111001001" =>  data <= "11111111";  -- 1C9 = FF
      when "000000111001010" =>  data <= "11111111";  -- 1CA = FF
      when "000000111001011" =>  data <= "11111111";  -- 1CB = FF
      when "000000111001100" =>  data <= "11111111";  -- 1CC = FF
      when "000000111001101" =>  data <= "11111111";  -- 1CD = FF
      when "000000111001110" =>  data <= "11111111";  -- 1CE = FF
      when "000000111001111" =>  data <= "11111111";  -- 1CF = FF
      when "000000111010000" =>  data <= "11111111";  -- 1D0 = FF
      when "000000111010001" =>  data <= "11111111";  -- 1D1 = FF
      when "000000111010010" =>  data <= "11111111";  -- 1D2 = FF
      when "000000111010011" =>  data <= "11111111";  -- 1D3 = FF
      when "000000111010100" =>  data <= "11111111";  -- 1D4 = FF
      when "000000111010101" =>  data <= "11111111";  -- 1D5 = FF
      when "000000111010110" =>  data <= "11111111";  -- 1D6 = FF
      when "000000111010111" =>  data <= "11111111";  -- 1D7 = FF
      when "000000111011000" =>  data <= "11111111";  -- 1D8 = FF
      when "000000111011001" =>  data <= "11111111";  -- 1D9 = FF
      when "000000111011010" =>  data <= "11111111";  -- 1DA = FF
      when "000000111011011" =>  data <= "11111111";  -- 1DB = FF
      when "000000111011100" =>  data <= "11111111";  -- 1DC = FF
      when "000000111011101" =>  data <= "11111111";  -- 1DD = FF
      when "000000111011110" =>  data <= "11111111";  -- 1DE = FF
      when "000000111011111" =>  data <= "11111111";  -- 1DF = FF
      when "000000111100000" =>  data <= "11111111";  -- 1E0 = FF
      when "000000111100001" =>  data <= "11111111";  -- 1E1 = FF
      when "000000111100010" =>  data <= "11111111";  -- 1E2 = FF
      when "000000111100011" =>  data <= "11111111";  -- 1E3 = FF
      when "000000111100100" =>  data <= "11111111";  -- 1E4 = FF
      when "000000111100101" =>  data <= "11111111";  -- 1E5 = FF
      when "000000111100110" =>  data <= "11111111";  -- 1E6 = FF
      when "000000111100111" =>  data <= "11111111";  -- 1E7 = FF
      when "000000111101000" =>  data <= "11111111";  -- 1E8 = FF
      when "000000111101001" =>  data <= "11111111";  -- 1E9 = FF
      when "000000111101010" =>  data <= "11111111";  -- 1EA = FF
      when "000000111101011" =>  data <= "11111111";  -- 1EB = FF
      when "000000111101100" =>  data <= "11111111";  -- 1EC = FF
      when "000000111101101" =>  data <= "11111111";  -- 1ED = FF
      when "000000111101110" =>  data <= "11111111";  -- 1EE = FF
      when "000000111101111" =>  data <= "11111111";  -- 1EF = FF
      when "000000111110000" =>  data <= "11111111";  -- 1F0 = FF
      when "000000111110001" =>  data <= "11111111";  -- 1F1 = FF
      when "000000111110010" =>  data <= "11111111";  -- 1F2 = FF
      when "000000111110011" =>  data <= "11111111";  -- 1F3 = FF
      when "000000111110100" =>  data <= "11111111";  -- 1F4 = FF
      when "000000111110101" =>  data <= "11111111";  -- 1F5 = FF
      when "000000111110110" =>  data <= "11111111";  -- 1F6 = FF
      when "000000111110111" =>  data <= "11111111";  -- 1F7 = FF
      when "000000111111000" =>  data <= "11111111";  -- 1F8 = FF
      when "000000111111001" =>  data <= "11111111";  -- 1F9 = FF
      when "000000111111010" =>  data <= "11111111";  -- 1FA = FF
      when "000000111111011" =>  data <= "11111111";  -- 1FB = FF
      when "000000111111100" =>  data <= "11111111";  -- 1FC = FF
      when "000000111111101" =>  data <= "11111111";  -- 1FD = FF
      when "000000111111110" =>  data <= "11111111";  -- 1FE = FF
      when "000000111111111" =>  data <= "11111111";  -- 1FF = FF
      when "000001000000000" =>  data <= "11111111";  -- 200 = FF
      when "000001000000001" =>  data <= "11111111";  -- 201 = FF
      when "000001000000010" =>  data <= "11111111";  -- 202 = FF
      when "000001000000011" =>  data <= "11111111";  -- 203 = FF
      when "000001000000100" =>  data <= "11111111";  -- 204 = FF
      when "000001000000101" =>  data <= "11111111";  -- 205 = FF
      when "000001000000110" =>  data <= "11111111";  -- 206 = FF
      when "000001000000111" =>  data <= "11111111";  -- 207 = FF
      when "000001000001000" =>  data <= "11111111";  -- 208 = FF
      when "000001000001001" =>  data <= "11111111";  -- 209 = FF
      when "000001000001010" =>  data <= "11111111";  -- 20A = FF
      when "000001000001011" =>  data <= "11111111";  -- 20B = FF
      when "000001000001100" =>  data <= "11111111";  -- 20C = FF
      when "000001000001101" =>  data <= "11111111";  -- 20D = FF
      when "000001000001110" =>  data <= "11111111";  -- 20E = FF
      when "000001000001111" =>  data <= "11111111";  -- 20F = FF
      when "000001000010000" =>  data <= "11111111";  -- 210 = FF
      when "000001000010001" =>  data <= "11111111";  -- 211 = FF
      when "000001000010010" =>  data <= "11111111";  -- 212 = FF
      when "000001000010011" =>  data <= "11111111";  -- 213 = FF
      when "000001000010100" =>  data <= "11111111";  -- 214 = FF
      when "000001000010101" =>  data <= "11111111";  -- 215 = FF
      when "000001000010110" =>  data <= "11111111";  -- 216 = FF
      when "000001000010111" =>  data <= "11111111";  -- 217 = FF
      when "000001000011000" =>  data <= "11111111";  -- 218 = FF
      when "000001000011001" =>  data <= "11111111";  -- 219 = FF
      when "000001000011010" =>  data <= "11111111";  -- 21A = FF
      when "000001000011011" =>  data <= "11111111";  -- 21B = FF
      when "000001000011100" =>  data <= "11111111";  -- 21C = FF
      when "000001000011101" =>  data <= "11111111";  -- 21D = FF
      when "000001000011110" =>  data <= "11111111";  -- 21E = FF
      when "000001000011111" =>  data <= "11111111";  -- 21F = FF
      when "000001000100000" =>  data <= "11111111";  -- 220 = FF
      when "000001000100001" =>  data <= "11111111";  -- 221 = FF
      when "000001000100010" =>  data <= "11111111";  -- 222 = FF
      when "000001000100011" =>  data <= "11111111";  -- 223 = FF
      when "000001000100100" =>  data <= "11111111";  -- 224 = FF
      when "000001000100101" =>  data <= "11111111";  -- 225 = FF
      when "000001000100110" =>  data <= "11111111";  -- 226 = FF
      when "000001000100111" =>  data <= "11111111";  -- 227 = FF
      when "000001000101000" =>  data <= "11111111";  -- 228 = FF
      when "000001000101001" =>  data <= "11111111";  -- 229 = FF
      when "000001000101010" =>  data <= "11111111";  -- 22A = FF
      when "000001000101011" =>  data <= "11111111";  -- 22B = FF
      when "000001000101100" =>  data <= "11111111";  -- 22C = FF
      when "000001000101101" =>  data <= "11111111";  -- 22D = FF
      when "000001000101110" =>  data <= "11111111";  -- 22E = FF
      when "000001000101111" =>  data <= "11111111";  -- 22F = FF
      when "000001000110000" =>  data <= "11111111";  -- 230 = FF
      when "000001000110001" =>  data <= "11111111";  -- 231 = FF
      when "000001000110010" =>  data <= "11111111";  -- 232 = FF
      when "000001000110011" =>  data <= "11111111";  -- 233 = FF
      when "000001000110100" =>  data <= "11111111";  -- 234 = FF
      when "000001000110101" =>  data <= "11111111";  -- 235 = FF
      when "000001000110110" =>  data <= "11111111";  -- 236 = FF
      when "000001000110111" =>  data <= "11111111";  -- 237 = FF
      when "000001000111000" =>  data <= "11111111";  -- 238 = FF
      when "000001000111001" =>  data <= "11111111";  -- 239 = FF
      when "000001000111010" =>  data <= "11111111";  -- 23A = FF
      when "000001000111011" =>  data <= "11111111";  -- 23B = FF
      when "000001000111100" =>  data <= "11111111";  -- 23C = FF
      when "000001000111101" =>  data <= "11111111";  -- 23D = FF
      when "000001000111110" =>  data <= "11111111";  -- 23E = FF
      when "000001000111111" =>  data <= "11111111";  -- 23F = FF
      when "000001001000000" =>  data <= "11111111";  -- 240 = FF
      when "000001001000001" =>  data <= "11111111";  -- 241 = FF
      when "000001001000010" =>  data <= "11111111";  -- 242 = FF
      when "000001001000011" =>  data <= "11111111";  -- 243 = FF
      when "000001001000100" =>  data <= "11111111";  -- 244 = FF
      when "000001001000101" =>  data <= "11111111";  -- 245 = FF
      when "000001001000110" =>  data <= "11111111";  -- 246 = FF
      when "000001001000111" =>  data <= "11111111";  -- 247 = FF
      when "000001001001000" =>  data <= "11111111";  -- 248 = FF
      when "000001001001001" =>  data <= "11111111";  -- 249 = FF
      when "000001001001010" =>  data <= "11111111";  -- 24A = FF
      when "000001001001011" =>  data <= "11111111";  -- 24B = FF
      when "000001001001100" =>  data <= "11111111";  -- 24C = FF
      when "000001001001101" =>  data <= "11111111";  -- 24D = FF
      when "000001001001110" =>  data <= "11111111";  -- 24E = FF
      when "000001001001111" =>  data <= "11111111";  -- 24F = FF
      when "000001001010000" =>  data <= "11111111";  -- 250 = FF
      when "000001001010001" =>  data <= "11111111";  -- 251 = FF
      when "000001001010010" =>  data <= "11111111";  -- 252 = FF
      when "000001001010011" =>  data <= "11111111";  -- 253 = FF
      when "000001001010100" =>  data <= "11111111";  -- 254 = FF
      when "000001001010101" =>  data <= "11111111";  -- 255 = FF
      when "000001001010110" =>  data <= "11111111";  -- 256 = FF
      when "000001001010111" =>  data <= "11111111";  -- 257 = FF
      when "000001001011000" =>  data <= "11111111";  -- 258 = FF
      when "000001001011001" =>  data <= "11111111";  -- 259 = FF
      when "000001001011010" =>  data <= "11111111";  -- 25A = FF
      when "000001001011011" =>  data <= "11111111";  -- 25B = FF
      when "000001001011100" =>  data <= "11111111";  -- 25C = FF
      when "000001001011101" =>  data <= "11111111";  -- 25D = FF
      when "000001001011110" =>  data <= "11111111";  -- 25E = FF
      when "000001001011111" =>  data <= "11111111";  -- 25F = FF
      when "000001001100000" =>  data <= "11111111";  -- 260 = FF
      when "000001001100001" =>  data <= "11111111";  -- 261 = FF
      when "000001001100010" =>  data <= "11111111";  -- 262 = FF
      when "000001001100011" =>  data <= "11111111";  -- 263 = FF
      when "000001001100100" =>  data <= "11111111";  -- 264 = FF
      when "000001001100101" =>  data <= "11111111";  -- 265 = FF
      when "000001001100110" =>  data <= "11111111";  -- 266 = FF
      when "000001001100111" =>  data <= "11111111";  -- 267 = FF
      when "000001001101000" =>  data <= "11111111";  -- 268 = FF
      when "000001001101001" =>  data <= "11111111";  -- 269 = FF
      when "000001001101010" =>  data <= "11111111";  -- 26A = FF
      when "000001001101011" =>  data <= "11111111";  -- 26B = FF
      when "000001001101100" =>  data <= "11111111";  -- 26C = FF
      when "000001001101101" =>  data <= "11111111";  -- 26D = FF
      when "000001001101110" =>  data <= "11111111";  -- 26E = FF
      when "000001001101111" =>  data <= "11111111";  -- 26F = FF
      when "000001001110000" =>  data <= "11111111";  -- 270 = FF
      when "000001001110001" =>  data <= "11111111";  -- 271 = FF
      when "000001001110010" =>  data <= "11111111";  -- 272 = FF
      when "000001001110011" =>  data <= "11111111";  -- 273 = FF
      when "000001001110100" =>  data <= "11111111";  -- 274 = FF
      when "000001001110101" =>  data <= "11111111";  -- 275 = FF
      when "000001001110110" =>  data <= "11111111";  -- 276 = FF
      when "000001001110111" =>  data <= "11111111";  -- 277 = FF
      when "000001001111000" =>  data <= "11111111";  -- 278 = FF
      when "000001001111001" =>  data <= "11111111";  -- 279 = FF
      when "000001001111010" =>  data <= "11111111";  -- 27A = FF
      when "000001001111011" =>  data <= "11111111";  -- 27B = FF
      when "000001001111100" =>  data <= "11111111";  -- 27C = FF
      when "000001001111101" =>  data <= "11111111";  -- 27D = FF
      when "000001001111110" =>  data <= "11111111";  -- 27E = FF
      when "000001001111111" =>  data <= "11111111";  -- 27F = FF
      when "000001010000000" =>  data <= "11111111";  -- 280 = FF
      when "000001010000001" =>  data <= "11111111";  -- 281 = FF
      when "000001010000010" =>  data <= "11111111";  -- 282 = FF
      when "000001010000011" =>  data <= "11111111";  -- 283 = FF
      when "000001010000100" =>  data <= "11111111";  -- 284 = FF
      when "000001010000101" =>  data <= "11111111";  -- 285 = FF
      when "000001010000110" =>  data <= "11111111";  -- 286 = FF
      when "000001010000111" =>  data <= "11111111";  -- 287 = FF
      when "000001010001000" =>  data <= "11111111";  -- 288 = FF
      when "000001010001001" =>  data <= "11111111";  -- 289 = FF
      when "000001010001010" =>  data <= "11111111";  -- 28A = FF
      when "000001010001011" =>  data <= "11111111";  -- 28B = FF
      when "000001010001100" =>  data <= "11111111";  -- 28C = FF
      when "000001010001101" =>  data <= "11111111";  -- 28D = FF
      when "000001010001110" =>  data <= "11111111";  -- 28E = FF
      when "000001010001111" =>  data <= "11111111";  -- 28F = FF
      when "000001010010000" =>  data <= "11111111";  -- 290 = FF
      when "000001010010001" =>  data <= "11111111";  -- 291 = FF
      when "000001010010010" =>  data <= "11111111";  -- 292 = FF
      when "000001010010011" =>  data <= "11111111";  -- 293 = FF
      when "000001010010100" =>  data <= "11111111";  -- 294 = FF
      when "000001010010101" =>  data <= "11111111";  -- 295 = FF
      when "000001010010110" =>  data <= "11111111";  -- 296 = FF
      when "000001010010111" =>  data <= "11111111";  -- 297 = FF
      when "000001010011000" =>  data <= "11111111";  -- 298 = FF
      when "000001010011001" =>  data <= "11111111";  -- 299 = FF
      when "000001010011010" =>  data <= "11111111";  -- 29A = FF
      when "000001010011011" =>  data <= "11111111";  -- 29B = FF
      when "000001010011100" =>  data <= "11111111";  -- 29C = FF
      when "000001010011101" =>  data <= "11111111";  -- 29D = FF
      when "000001010011110" =>  data <= "11111111";  -- 29E = FF
      when "000001010011111" =>  data <= "11111111";  -- 29F = FF
      when "000001010100000" =>  data <= "11111111";  -- 2A0 = FF
      when "000001010100001" =>  data <= "11111111";  -- 2A1 = FF
      when "000001010100010" =>  data <= "11111111";  -- 2A2 = FF
      when "000001010100011" =>  data <= "11111111";  -- 2A3 = FF
      when "000001010100100" =>  data <= "11111111";  -- 2A4 = FF
      when "000001010100101" =>  data <= "11111111";  -- 2A5 = FF
      when "000001010100110" =>  data <= "11111111";  -- 2A6 = FF
      when "000001010100111" =>  data <= "11111111";  -- 2A7 = FF
      when "000001010101000" =>  data <= "11111111";  -- 2A8 = FF
      when "000001010101001" =>  data <= "11111111";  -- 2A9 = FF
      when "000001010101010" =>  data <= "11111111";  -- 2AA = FF
      when "000001010101011" =>  data <= "11111111";  -- 2AB = FF
      when "000001010101100" =>  data <= "11111111";  -- 2AC = FF
      when "000001010101101" =>  data <= "11111111";  -- 2AD = FF
      when "000001010101110" =>  data <= "11111111";  -- 2AE = FF
      when "000001010101111" =>  data <= "11111111";  -- 2AF = FF
      when "000001010110000" =>  data <= "11111111";  -- 2B0 = FF
      when "000001010110001" =>  data <= "11111111";  -- 2B1 = FF
      when "000001010110010" =>  data <= "11111111";  -- 2B2 = FF
      when "000001010110011" =>  data <= "11111111";  -- 2B3 = FF
      when "000001010110100" =>  data <= "11111111";  -- 2B4 = FF
      when "000001010110101" =>  data <= "11111111";  -- 2B5 = FF
      when "000001010110110" =>  data <= "11111111";  -- 2B6 = FF
      when "000001010110111" =>  data <= "11111111";  -- 2B7 = FF
      when "000001010111000" =>  data <= "11111111";  -- 2B8 = FF
      when "000001010111001" =>  data <= "11111111";  -- 2B9 = FF
      when "000001010111010" =>  data <= "11111111";  -- 2BA = FF
      when "000001010111011" =>  data <= "11111111";  -- 2BB = FF
      when "000001010111100" =>  data <= "11111111";  -- 2BC = FF
      when "000001010111101" =>  data <= "11111111";  -- 2BD = FF
      when "000001010111110" =>  data <= "11111111";  -- 2BE = FF
      when "000001010111111" =>  data <= "11111111";  -- 2BF = FF
      when "000001011000000" =>  data <= "11111111";  -- 2C0 = FF
      when "000001011000001" =>  data <= "11111111";  -- 2C1 = FF
      when "000001011000010" =>  data <= "11111111";  -- 2C2 = FF
      when "000001011000011" =>  data <= "11111111";  -- 2C3 = FF
      when "000001011000100" =>  data <= "11111111";  -- 2C4 = FF
      when "000001011000101" =>  data <= "11111111";  -- 2C5 = FF
      when "000001011000110" =>  data <= "11111111";  -- 2C6 = FF
      when "000001011000111" =>  data <= "11111111";  -- 2C7 = FF
      when "000001011001000" =>  data <= "11111111";  -- 2C8 = FF
      when "000001011001001" =>  data <= "11111111";  -- 2C9 = FF
      when "000001011001010" =>  data <= "11111111";  -- 2CA = FF
      when "000001011001011" =>  data <= "11111111";  -- 2CB = FF
      when "000001011001100" =>  data <= "11111111";  -- 2CC = FF
      when "000001011001101" =>  data <= "11111111";  -- 2CD = FF
      when "000001011001110" =>  data <= "11111111";  -- 2CE = FF
      when "000001011001111" =>  data <= "11111111";  -- 2CF = FF
      when "000001011010000" =>  data <= "11111111";  -- 2D0 = FF
      when "000001011010001" =>  data <= "11111111";  -- 2D1 = FF
      when "000001011010010" =>  data <= "11111111";  -- 2D2 = FF
      when "000001011010011" =>  data <= "11111111";  -- 2D3 = FF
      when "000001011010100" =>  data <= "11111111";  -- 2D4 = FF
      when "000001011010101" =>  data <= "11111111";  -- 2D5 = FF
      when "000001011010110" =>  data <= "11111111";  -- 2D6 = FF
      when "000001011010111" =>  data <= "11111111";  -- 2D7 = FF
      when "000001011011000" =>  data <= "11111111";  -- 2D8 = FF
      when "000001011011001" =>  data <= "11111111";  -- 2D9 = FF
      when "000001011011010" =>  data <= "11111111";  -- 2DA = FF
      when "000001011011011" =>  data <= "11111111";  -- 2DB = FF
      when "000001011011100" =>  data <= "11111111";  -- 2DC = FF
      when "000001011011101" =>  data <= "11111111";  -- 2DD = FF
      when "000001011011110" =>  data <= "11111111";  -- 2DE = FF
      when "000001011011111" =>  data <= "11111111";  -- 2DF = FF
      when "000001011100000" =>  data <= "11111111";  -- 2E0 = FF
      when "000001011100001" =>  data <= "11111111";  -- 2E1 = FF
      when "000001011100010" =>  data <= "11111111";  -- 2E2 = FF
      when "000001011100011" =>  data <= "11111111";  -- 2E3 = FF
      when "000001011100100" =>  data <= "11111111";  -- 2E4 = FF
      when "000001011100101" =>  data <= "11111111";  -- 2E5 = FF
      when "000001011100110" =>  data <= "11111111";  -- 2E6 = FF
      when "000001011100111" =>  data <= "11111111";  -- 2E7 = FF
      when "000001011101000" =>  data <= "11111111";  -- 2E8 = FF
      when "000001011101001" =>  data <= "11111111";  -- 2E9 = FF
      when "000001011101010" =>  data <= "11111111";  -- 2EA = FF
      when "000001011101011" =>  data <= "11111111";  -- 2EB = FF
      when "000001011101100" =>  data <= "11111111";  -- 2EC = FF
      when "000001011101101" =>  data <= "11111111";  -- 2ED = FF
      when "000001011101110" =>  data <= "11111111";  -- 2EE = FF
      when "000001011101111" =>  data <= "11111111";  -- 2EF = FF
      when "000001011110000" =>  data <= "11111111";  -- 2F0 = FF
      when "000001011110001" =>  data <= "11111111";  -- 2F1 = FF
      when "000001011110010" =>  data <= "11111111";  -- 2F2 = FF
      when "000001011110011" =>  data <= "11111111";  -- 2F3 = FF
      when "000001011110100" =>  data <= "11111111";  -- 2F4 = FF
      when "000001011110101" =>  data <= "11111111";  -- 2F5 = FF
      when "000001011110110" =>  data <= "11111111";  -- 2F6 = FF
      when "000001011110111" =>  data <= "11111111";  -- 2F7 = FF
      when "000001011111000" =>  data <= "11111111";  -- 2F8 = FF
      when "000001011111001" =>  data <= "11111111";  -- 2F9 = FF
      when "000001011111010" =>  data <= "11111111";  -- 2FA = FF
      when "000001011111011" =>  data <= "11111111";  -- 2FB = FF
      when "000001011111100" =>  data <= "11111111";  -- 2FC = FF
      when "000001011111101" =>  data <= "11111111";  -- 2FD = FF
      when "000001011111110" =>  data <= "11111111";  -- 2FE = FF
      when "000001011111111" =>  data <= "11111111";  -- 2FF = FF
      when "000001100000000" =>  data <= "11111111";  -- 300 = FF
      when "000001100000001" =>  data <= "11111111";  -- 301 = FF
      when "000001100000010" =>  data <= "11111111";  -- 302 = FF
      when "000001100000011" =>  data <= "11111111";  -- 303 = FF
      when "000001100000100" =>  data <= "11111111";  -- 304 = FF
      when "000001100000101" =>  data <= "11111111";  -- 305 = FF
      when "000001100000110" =>  data <= "11111111";  -- 306 = FF
      when "000001100000111" =>  data <= "11111111";  -- 307 = FF
      when "000001100001000" =>  data <= "11111111";  -- 308 = FF
      when "000001100001001" =>  data <= "11111111";  -- 309 = FF
      when "000001100001010" =>  data <= "11111111";  -- 30A = FF
      when "000001100001011" =>  data <= "11111111";  -- 30B = FF
      when "000001100001100" =>  data <= "11111111";  -- 30C = FF
      when "000001100001101" =>  data <= "11111111";  -- 30D = FF
      when "000001100001110" =>  data <= "11111111";  -- 30E = FF
      when "000001100001111" =>  data <= "11111111";  -- 30F = FF
      when "000001100010000" =>  data <= "11111111";  -- 310 = FF
      when "000001100010001" =>  data <= "11111111";  -- 311 = FF
      when "000001100010010" =>  data <= "11111111";  -- 312 = FF
      when "000001100010011" =>  data <= "11111111";  -- 313 = FF
      when "000001100010100" =>  data <= "11111111";  -- 314 = FF
      when "000001100010101" =>  data <= "11111111";  -- 315 = FF
      when "000001100010110" =>  data <= "11111111";  -- 316 = FF
      when "000001100010111" =>  data <= "11111111";  -- 317 = FF
      when "000001100011000" =>  data <= "11111111";  -- 318 = FF
      when "000001100011001" =>  data <= "11111111";  -- 319 = FF
      when "000001100011010" =>  data <= "11111111";  -- 31A = FF
      when "000001100011011" =>  data <= "11111111";  -- 31B = FF
      when "000001100011100" =>  data <= "11111111";  -- 31C = FF
      when "000001100011101" =>  data <= "11111111";  -- 31D = FF
      when "000001100011110" =>  data <= "11111111";  -- 31E = FF
      when "000001100011111" =>  data <= "11111111";  -- 31F = FF
      when "000001100100000" =>  data <= "11111111";  -- 320 = FF
      when "000001100100001" =>  data <= "11111111";  -- 321 = FF
      when "000001100100010" =>  data <= "11111111";  -- 322 = FF
      when "000001100100011" =>  data <= "11111111";  -- 323 = FF
      when "000001100100100" =>  data <= "11111111";  -- 324 = FF
      when "000001100100101" =>  data <= "11111111";  -- 325 = FF
      when "000001100100110" =>  data <= "11111111";  -- 326 = FF
      when "000001100100111" =>  data <= "11111111";  -- 327 = FF
      when "000001100101000" =>  data <= "11111111";  -- 328 = FF
      when "000001100101001" =>  data <= "11111111";  -- 329 = FF
      when "000001100101010" =>  data <= "11111111";  -- 32A = FF
      when "000001100101011" =>  data <= "11111111";  -- 32B = FF
      when "000001100101100" =>  data <= "11111111";  -- 32C = FF
      when "000001100101101" =>  data <= "11111111";  -- 32D = FF
      when "000001100101110" =>  data <= "11111111";  -- 32E = FF
      when "000001100101111" =>  data <= "11111111";  -- 32F = FF
      when "000001100110000" =>  data <= "11111111";  -- 330 = FF
      when "000001100110001" =>  data <= "11111111";  -- 331 = FF
      when "000001100110010" =>  data <= "11111111";  -- 332 = FF
      when "000001100110011" =>  data <= "11111111";  -- 333 = FF
      when "000001100110100" =>  data <= "11111111";  -- 334 = FF
      when "000001100110101" =>  data <= "11111111";  -- 335 = FF
      when "000001100110110" =>  data <= "11111111";  -- 336 = FF
      when "000001100110111" =>  data <= "11111111";  -- 337 = FF
      when "000001100111000" =>  data <= "11111111";  -- 338 = FF
      when "000001100111001" =>  data <= "11111111";  -- 339 = FF
      when "000001100111010" =>  data <= "11111111";  -- 33A = FF
      when "000001100111011" =>  data <= "11111111";  -- 33B = FF
      when "000001100111100" =>  data <= "11111111";  -- 33C = FF
      when "000001100111101" =>  data <= "11111111";  -- 33D = FF
      when "000001100111110" =>  data <= "11111111";  -- 33E = FF
      when "000001100111111" =>  data <= "11111111";  -- 33F = FF
      when "000001101000000" =>  data <= "11111111";  -- 340 = FF
      when "000001101000001" =>  data <= "11111111";  -- 341 = FF
      when "000001101000010" =>  data <= "11111111";  -- 342 = FF
      when "000001101000011" =>  data <= "11111111";  -- 343 = FF
      when "000001101000100" =>  data <= "11111111";  -- 344 = FF
      when "000001101000101" =>  data <= "11111111";  -- 345 = FF
      when "000001101000110" =>  data <= "11111111";  -- 346 = FF
      when "000001101000111" =>  data <= "11111111";  -- 347 = FF
      when "000001101001000" =>  data <= "11111111";  -- 348 = FF
      when "000001101001001" =>  data <= "11111111";  -- 349 = FF
      when "000001101001010" =>  data <= "11111111";  -- 34A = FF
      when "000001101001011" =>  data <= "11111111";  -- 34B = FF
      when "000001101001100" =>  data <= "11111111";  -- 34C = FF
      when "000001101001101" =>  data <= "11111111";  -- 34D = FF
      when "000001101001110" =>  data <= "11111111";  -- 34E = FF
      when "000001101001111" =>  data <= "11111111";  -- 34F = FF
      when "000001101010000" =>  data <= "11111111";  -- 350 = FF
      when "000001101010001" =>  data <= "11111111";  -- 351 = FF
      when "000001101010010" =>  data <= "11111111";  -- 352 = FF
      when "000001101010011" =>  data <= "11111111";  -- 353 = FF
      when "000001101010100" =>  data <= "11111111";  -- 354 = FF
      when "000001101010101" =>  data <= "11111111";  -- 355 = FF
      when "000001101010110" =>  data <= "11111111";  -- 356 = FF
      when "000001101010111" =>  data <= "11111111";  -- 357 = FF
      when "000001101011000" =>  data <= "11111111";  -- 358 = FF
      when "000001101011001" =>  data <= "11111111";  -- 359 = FF
      when "000001101011010" =>  data <= "11111111";  -- 35A = FF
      when "000001101011011" =>  data <= "11111111";  -- 35B = FF
      when "000001101011100" =>  data <= "11111111";  -- 35C = FF
      when "000001101011101" =>  data <= "11111111";  -- 35D = FF
      when "000001101011110" =>  data <= "11111111";  -- 35E = FF
      when "000001101011111" =>  data <= "11111111";  -- 35F = FF
      when "000001101100000" =>  data <= "11111111";  -- 360 = FF
      when "000001101100001" =>  data <= "11111111";  -- 361 = FF
      when "000001101100010" =>  data <= "11111111";  -- 362 = FF
      when "000001101100011" =>  data <= "11111111";  -- 363 = FF
      when "000001101100100" =>  data <= "11111111";  -- 364 = FF
      when "000001101100101" =>  data <= "11111111";  -- 365 = FF
      when "000001101100110" =>  data <= "11111111";  -- 366 = FF
      when "000001101100111" =>  data <= "11111111";  -- 367 = FF
      when "000001101101000" =>  data <= "11111111";  -- 368 = FF
      when "000001101101001" =>  data <= "11111111";  -- 369 = FF
      when "000001101101010" =>  data <= "11111111";  -- 36A = FF
      when "000001101101011" =>  data <= "11111111";  -- 36B = FF
      when "000001101101100" =>  data <= "11111111";  -- 36C = FF
      when "000001101101101" =>  data <= "11111111";  -- 36D = FF
      when "000001101101110" =>  data <= "11111111";  -- 36E = FF
      when "000001101101111" =>  data <= "11111111";  -- 36F = FF
      when "000001101110000" =>  data <= "11111111";  -- 370 = FF
      when "000001101110001" =>  data <= "11111111";  -- 371 = FF
      when "000001101110010" =>  data <= "11111111";  -- 372 = FF
      when "000001101110011" =>  data <= "11111111";  -- 373 = FF
      when "000001101110100" =>  data <= "11111111";  -- 374 = FF
      when "000001101110101" =>  data <= "11111111";  -- 375 = FF
      when "000001101110110" =>  data <= "11111111";  -- 376 = FF
      when "000001101110111" =>  data <= "11111111";  -- 377 = FF
      when "000001101111000" =>  data <= "11111111";  -- 378 = FF
      when "000001101111001" =>  data <= "11111111";  -- 379 = FF
      when "000001101111010" =>  data <= "11111111";  -- 37A = FF
      when "000001101111011" =>  data <= "11111111";  -- 37B = FF
      when "000001101111100" =>  data <= "11111111";  -- 37C = FF
      when "000001101111101" =>  data <= "11111111";  -- 37D = FF
      when "000001101111110" =>  data <= "11111111";  -- 37E = FF
      when "000001101111111" =>  data <= "11111111";  -- 37F = FF
      when "000001110000000" =>  data <= "11111111";  -- 380 = FF
      when "000001110000001" =>  data <= "11111111";  -- 381 = FF
      when "000001110000010" =>  data <= "11111111";  -- 382 = FF
      when "000001110000011" =>  data <= "11111111";  -- 383 = FF
      when "000001110000100" =>  data <= "11111111";  -- 384 = FF
      when "000001110000101" =>  data <= "11111111";  -- 385 = FF
      when "000001110000110" =>  data <= "11111111";  -- 386 = FF
      when "000001110000111" =>  data <= "11111111";  -- 387 = FF
      when "000001110001000" =>  data <= "11111111";  -- 388 = FF
      when "000001110001001" =>  data <= "11111111";  -- 389 = FF
      when "000001110001010" =>  data <= "11111111";  -- 38A = FF
      when "000001110001011" =>  data <= "11111111";  -- 38B = FF
      when "000001110001100" =>  data <= "11111111";  -- 38C = FF
      when "000001110001101" =>  data <= "11111111";  -- 38D = FF
      when "000001110001110" =>  data <= "11111111";  -- 38E = FF
      when "000001110001111" =>  data <= "11111111";  -- 38F = FF
      when "000001110010000" =>  data <= "11111111";  -- 390 = FF
      when "000001110010001" =>  data <= "11111111";  -- 391 = FF
      when "000001110010010" =>  data <= "11111111";  -- 392 = FF
      when "000001110010011" =>  data <= "11111111";  -- 393 = FF
      when "000001110010100" =>  data <= "11111111";  -- 394 = FF
      when "000001110010101" =>  data <= "11111111";  -- 395 = FF
      when "000001110010110" =>  data <= "11111111";  -- 396 = FF
      when "000001110010111" =>  data <= "11111111";  -- 397 = FF
      when "000001110011000" =>  data <= "11111111";  -- 398 = FF
      when "000001110011001" =>  data <= "11111111";  -- 399 = FF
      when "000001110011010" =>  data <= "11111111";  -- 39A = FF
      when "000001110011011" =>  data <= "11111111";  -- 39B = FF
      when "000001110011100" =>  data <= "11111111";  -- 39C = FF
      when "000001110011101" =>  data <= "11111111";  -- 39D = FF
      when "000001110011110" =>  data <= "11111111";  -- 39E = FF
      when "000001110011111" =>  data <= "11111111";  -- 39F = FF
      when "000001110100000" =>  data <= "11111111";  -- 3A0 = FF
      when "000001110100001" =>  data <= "11111111";  -- 3A1 = FF
      when "000001110100010" =>  data <= "11111111";  -- 3A2 = FF
      when "000001110100011" =>  data <= "11111111";  -- 3A3 = FF
      when "000001110100100" =>  data <= "11111111";  -- 3A4 = FF
      when "000001110100101" =>  data <= "11111111";  -- 3A5 = FF
      when "000001110100110" =>  data <= "11111111";  -- 3A6 = FF
      when "000001110100111" =>  data <= "11111111";  -- 3A7 = FF
      when "000001110101000" =>  data <= "11111111";  -- 3A8 = FF
      when "000001110101001" =>  data <= "11111111";  -- 3A9 = FF
      when "000001110101010" =>  data <= "11111111";  -- 3AA = FF
      when "000001110101011" =>  data <= "11111111";  -- 3AB = FF
      when "000001110101100" =>  data <= "11111111";  -- 3AC = FF
      when "000001110101101" =>  data <= "11111111";  -- 3AD = FF
      when "000001110101110" =>  data <= "11111111";  -- 3AE = FF
      when "000001110101111" =>  data <= "11111111";  -- 3AF = FF
      when "000001110110000" =>  data <= "11111111";  -- 3B0 = FF
      when "000001110110001" =>  data <= "11111111";  -- 3B1 = FF
      when "000001110110010" =>  data <= "11111111";  -- 3B2 = FF
      when "000001110110011" =>  data <= "11111111";  -- 3B3 = FF
      when "000001110110100" =>  data <= "11111111";  -- 3B4 = FF
      when "000001110110101" =>  data <= "11111111";  -- 3B5 = FF
      when "000001110110110" =>  data <= "11111111";  -- 3B6 = FF
      when "000001110110111" =>  data <= "11111111";  -- 3B7 = FF
      when "000001110111000" =>  data <= "11111111";  -- 3B8 = FF
      when "000001110111001" =>  data <= "11111111";  -- 3B9 = FF
      when "000001110111010" =>  data <= "11111111";  -- 3BA = FF
      when "000001110111011" =>  data <= "11111111";  -- 3BB = FF
      when "000001110111100" =>  data <= "11111111";  -- 3BC = FF
      when "000001110111101" =>  data <= "11111111";  -- 3BD = FF
      when "000001110111110" =>  data <= "11111111";  -- 3BE = FF
      when "000001110111111" =>  data <= "11111111";  -- 3BF = FF
      when "000001111000000" =>  data <= "11111111";  -- 3C0 = FF
      when "000001111000001" =>  data <= "11111111";  -- 3C1 = FF
      when "000001111000010" =>  data <= "11111111";  -- 3C2 = FF
      when "000001111000011" =>  data <= "11111111";  -- 3C3 = FF
      when "000001111000100" =>  data <= "11111111";  -- 3C4 = FF
      when "000001111000101" =>  data <= "11111111";  -- 3C5 = FF
      when "000001111000110" =>  data <= "11111111";  -- 3C6 = FF
      when "000001111000111" =>  data <= "11111111";  -- 3C7 = FF
      when "000001111001000" =>  data <= "11111111";  -- 3C8 = FF
      when "000001111001001" =>  data <= "11111111";  -- 3C9 = FF
      when "000001111001010" =>  data <= "11111111";  -- 3CA = FF
      when "000001111001011" =>  data <= "11111111";  -- 3CB = FF
      when "000001111001100" =>  data <= "11111111";  -- 3CC = FF
      when "000001111001101" =>  data <= "11111111";  -- 3CD = FF
      when "000001111001110" =>  data <= "11111111";  -- 3CE = FF
      when "000001111001111" =>  data <= "11111111";  -- 3CF = FF
      when "000001111010000" =>  data <= "11111111";  -- 3D0 = FF
      when "000001111010001" =>  data <= "11111111";  -- 3D1 = FF
      when "000001111010010" =>  data <= "11111111";  -- 3D2 = FF
      when "000001111010011" =>  data <= "11111111";  -- 3D3 = FF
      when "000001111010100" =>  data <= "11111111";  -- 3D4 = FF
      when "000001111010101" =>  data <= "11111111";  -- 3D5 = FF
      when "000001111010110" =>  data <= "11111111";  -- 3D6 = FF
      when "000001111010111" =>  data <= "11111111";  -- 3D7 = FF
      when "000001111011000" =>  data <= "11111111";  -- 3D8 = FF
      when "000001111011001" =>  data <= "11111111";  -- 3D9 = FF
      when "000001111011010" =>  data <= "11111111";  -- 3DA = FF
      when "000001111011011" =>  data <= "11111111";  -- 3DB = FF
      when "000001111011100" =>  data <= "11111111";  -- 3DC = FF
      when "000001111011101" =>  data <= "11111111";  -- 3DD = FF
      when "000001111011110" =>  data <= "11111111";  -- 3DE = FF
      when "000001111011111" =>  data <= "11111111";  -- 3DF = FF
      when "000001111100000" =>  data <= "11111111";  -- 3E0 = FF
      when "000001111100001" =>  data <= "11111111";  -- 3E1 = FF
      when "000001111100010" =>  data <= "11111111";  -- 3E2 = FF
      when "000001111100011" =>  data <= "11111111";  -- 3E3 = FF
      when "000001111100100" =>  data <= "11111111";  -- 3E4 = FF
      when "000001111100101" =>  data <= "11111111";  -- 3E5 = FF
      when "000001111100110" =>  data <= "11111111";  -- 3E6 = FF
      when "000001111100111" =>  data <= "11111111";  -- 3E7 = FF
      when "000001111101000" =>  data <= "11111111";  -- 3E8 = FF
      when "000001111101001" =>  data <= "11111111";  -- 3E9 = FF
      when "000001111101010" =>  data <= "11111111";  -- 3EA = FF
      when "000001111101011" =>  data <= "11111111";  -- 3EB = FF
      when "000001111101100" =>  data <= "11111111";  -- 3EC = FF
      when "000001111101101" =>  data <= "11111111";  -- 3ED = FF
      when "000001111101110" =>  data <= "11111111";  -- 3EE = FF
      when "000001111101111" =>  data <= "11111111";  -- 3EF = FF
      when "000001111110000" =>  data <= "11111111";  -- 3F0 = FF
      when "000001111110001" =>  data <= "11111111";  -- 3F1 = FF
      when "000001111110010" =>  data <= "11111111";  -- 3F2 = FF
      when "000001111110011" =>  data <= "11111111";  -- 3F3 = FF
      when "000001111110100" =>  data <= "11111111";  -- 3F4 = FF
      when "000001111110101" =>  data <= "11111111";  -- 3F5 = FF
      when "000001111110110" =>  data <= "11111111";  -- 3F6 = FF
      when "000001111110111" =>  data <= "11111111";  -- 3F7 = FF
      when "000001111111000" =>  data <= "11111111";  -- 3F8 = FF
      when "000001111111001" =>  data <= "11111111";  -- 3F9 = FF
      when "000001111111010" =>  data <= "11111111";  -- 3FA = FF
      when "000001111111011" =>  data <= "11111111";  -- 3FB = FF
      when "000001111111100" =>  data <= "11111111";  -- 3FC = FF
      when "000001111111101" =>  data <= "11111111";  -- 3FD = FF
      when "000001111111110" =>  data <= "11111111";  -- 3FE = FF
      when "000001111111111" =>  data <= "11111111";  -- 3FF = FF
      when "000010000000000" =>  data <= "11111111";  -- 400 = FF
      when "000010000000001" =>  data <= "11111111";  -- 401 = FF
      when "000010000000010" =>  data <= "11111111";  -- 402 = FF
      when "000010000000011" =>  data <= "11111111";  -- 403 = FF
      when "000010000000100" =>  data <= "11111111";  -- 404 = FF
      when "000010000000101" =>  data <= "11111111";  -- 405 = FF
      when "000010000000110" =>  data <= "11111111";  -- 406 = FF
      when "000010000000111" =>  data <= "11111111";  -- 407 = FF
      when "000010000001000" =>  data <= "11111111";  -- 408 = FF
      when "000010000001001" =>  data <= "11111111";  -- 409 = FF
      when "000010000001010" =>  data <= "11111111";  -- 40A = FF
      when "000010000001011" =>  data <= "11111111";  -- 40B = FF
      when "000010000001100" =>  data <= "11111111";  -- 40C = FF
      when "000010000001101" =>  data <= "11111111";  -- 40D = FF
      when "000010000001110" =>  data <= "11111111";  -- 40E = FF
      when "000010000001111" =>  data <= "11111111";  -- 40F = FF
      when "000010000010000" =>  data <= "11111111";  -- 410 = FF
      when "000010000010001" =>  data <= "11111111";  -- 411 = FF
      when "000010000010010" =>  data <= "11111111";  -- 412 = FF
      when "000010000010011" =>  data <= "11111111";  -- 413 = FF
      when "000010000010100" =>  data <= "11111111";  -- 414 = FF
      when "000010000010101" =>  data <= "11111111";  -- 415 = FF
      when "000010000010110" =>  data <= "11111111";  -- 416 = FF
      when "000010000010111" =>  data <= "11111111";  -- 417 = FF
      when "000010000011000" =>  data <= "11111111";  -- 418 = FF
      when "000010000011001" =>  data <= "11111111";  -- 419 = FF
      when "000010000011010" =>  data <= "11111111";  -- 41A = FF
      when "000010000011011" =>  data <= "11111111";  -- 41B = FF
      when "000010000011100" =>  data <= "11111111";  -- 41C = FF
      when "000010000011101" =>  data <= "11111111";  -- 41D = FF
      when "000010000011110" =>  data <= "11111111";  -- 41E = FF
      when "000010000011111" =>  data <= "11111111";  -- 41F = FF
      when "000010000100000" =>  data <= "11111111";  -- 420 = FF
      when "000010000100001" =>  data <= "11111111";  -- 421 = FF
      when "000010000100010" =>  data <= "11111111";  -- 422 = FF
      when "000010000100011" =>  data <= "11111111";  -- 423 = FF
      when "000010000100100" =>  data <= "11111111";  -- 424 = FF
      when "000010000100101" =>  data <= "11111111";  -- 425 = FF
      when "000010000100110" =>  data <= "11111111";  -- 426 = FF
      when "000010000100111" =>  data <= "11111111";  -- 427 = FF
      when "000010000101000" =>  data <= "11111111";  -- 428 = FF
      when "000010000101001" =>  data <= "11111111";  -- 429 = FF
      when "000010000101010" =>  data <= "11111111";  -- 42A = FF
      when "000010000101011" =>  data <= "11111111";  -- 42B = FF
      when "000010000101100" =>  data <= "11111111";  -- 42C = FF
      when "000010000101101" =>  data <= "11111111";  -- 42D = FF
      when "000010000101110" =>  data <= "11111111";  -- 42E = FF
      when "000010000101111" =>  data <= "11111111";  -- 42F = FF
      when "000010000110000" =>  data <= "11111111";  -- 430 = FF
      when "000010000110001" =>  data <= "11111111";  -- 431 = FF
      when "000010000110010" =>  data <= "11111111";  -- 432 = FF
      when "000010000110011" =>  data <= "11111111";  -- 433 = FF
      when "000010000110100" =>  data <= "11111111";  -- 434 = FF
      when "000010000110101" =>  data <= "11111111";  -- 435 = FF
      when "000010000110110" =>  data <= "11111111";  -- 436 = FF
      when "000010000110111" =>  data <= "11111111";  -- 437 = FF
      when "000010000111000" =>  data <= "11111111";  -- 438 = FF
      when "000010000111001" =>  data <= "11111111";  -- 439 = FF
      when "000010000111010" =>  data <= "11111111";  -- 43A = FF
      when "000010000111011" =>  data <= "11111111";  -- 43B = FF
      when "000010000111100" =>  data <= "11111111";  -- 43C = FF
      when "000010000111101" =>  data <= "11111111";  -- 43D = FF
      when "000010000111110" =>  data <= "11111111";  -- 43E = FF
      when "000010000111111" =>  data <= "11111111";  -- 43F = FF
      when "000010001000000" =>  data <= "11111111";  -- 440 = FF
      when "000010001000001" =>  data <= "11111111";  -- 441 = FF
      when "000010001000010" =>  data <= "11111111";  -- 442 = FF
      when "000010001000011" =>  data <= "11111111";  -- 443 = FF
      when "000010001000100" =>  data <= "11111111";  -- 444 = FF
      when "000010001000101" =>  data <= "11111111";  -- 445 = FF
      when "000010001000110" =>  data <= "11111111";  -- 446 = FF
      when "000010001000111" =>  data <= "11111111";  -- 447 = FF
      when "000010001001000" =>  data <= "11111111";  -- 448 = FF
      when "000010001001001" =>  data <= "11111111";  -- 449 = FF
      when "000010001001010" =>  data <= "11111111";  -- 44A = FF
      when "000010001001011" =>  data <= "11111111";  -- 44B = FF
      when "000010001001100" =>  data <= "11111111";  -- 44C = FF
      when "000010001001101" =>  data <= "11111111";  -- 44D = FF
      when "000010001001110" =>  data <= "11111111";  -- 44E = FF
      when "000010001001111" =>  data <= "11111111";  -- 44F = FF
      when "000010001010000" =>  data <= "11111111";  -- 450 = FF
      when "000010001010001" =>  data <= "11111111";  -- 451 = FF
      when "000010001010010" =>  data <= "11111111";  -- 452 = FF
      when "000010001010011" =>  data <= "11111111";  -- 453 = FF
      when "000010001010100" =>  data <= "11111111";  -- 454 = FF
      when "000010001010101" =>  data <= "11111111";  -- 455 = FF
      when "000010001010110" =>  data <= "11111111";  -- 456 = FF
      when "000010001010111" =>  data <= "11111111";  -- 457 = FF
      when "000010001011000" =>  data <= "11111111";  -- 458 = FF
      when "000010001011001" =>  data <= "11111111";  -- 459 = FF
      when "000010001011010" =>  data <= "11111111";  -- 45A = FF
      when "000010001011011" =>  data <= "11111111";  -- 45B = FF
      when "000010001011100" =>  data <= "11111111";  -- 45C = FF
      when "000010001011101" =>  data <= "11111111";  -- 45D = FF
      when "000010001011110" =>  data <= "11111111";  -- 45E = FF
      when "000010001011111" =>  data <= "11111111";  -- 45F = FF
      when "000010001100000" =>  data <= "11111111";  -- 460 = FF
      when "000010001100001" =>  data <= "11111111";  -- 461 = FF
      when "000010001100010" =>  data <= "11111111";  -- 462 = FF
      when "000010001100011" =>  data <= "11111111";  -- 463 = FF
      when "000010001100100" =>  data <= "11111111";  -- 464 = FF
      when "000010001100101" =>  data <= "11111111";  -- 465 = FF
      when "000010001100110" =>  data <= "11111111";  -- 466 = FF
      when "000010001100111" =>  data <= "11111111";  -- 467 = FF
      when "000010001101000" =>  data <= "11111111";  -- 468 = FF
      when "000010001101001" =>  data <= "11111111";  -- 469 = FF
      when "000010001101010" =>  data <= "11111111";  -- 46A = FF
      when "000010001101011" =>  data <= "11111111";  -- 46B = FF
      when "000010001101100" =>  data <= "11111111";  -- 46C = FF
      when "000010001101101" =>  data <= "11111111";  -- 46D = FF
      when "000010001101110" =>  data <= "11111111";  -- 46E = FF
      when "000010001101111" =>  data <= "11111111";  -- 46F = FF
      when "000010001110000" =>  data <= "11111111";  -- 470 = FF
      when "000010001110001" =>  data <= "11111111";  -- 471 = FF
      when "000010001110010" =>  data <= "11111111";  -- 472 = FF
      when "000010001110011" =>  data <= "11111111";  -- 473 = FF
      when "000010001110100" =>  data <= "11111111";  -- 474 = FF
      when "000010001110101" =>  data <= "11111111";  -- 475 = FF
      when "000010001110110" =>  data <= "11111111";  -- 476 = FF
      when "000010001110111" =>  data <= "11111111";  -- 477 = FF
      when "000010001111000" =>  data <= "11111111";  -- 478 = FF
      when "000010001111001" =>  data <= "11111111";  -- 479 = FF
      when "000010001111010" =>  data <= "11111111";  -- 47A = FF
      when "000010001111011" =>  data <= "11111111";  -- 47B = FF
      when "000010001111100" =>  data <= "11111111";  -- 47C = FF
      when "000010001111101" =>  data <= "11111111";  -- 47D = FF
      when "000010001111110" =>  data <= "11111111";  -- 47E = FF
      when "000010001111111" =>  data <= "11111111";  -- 47F = FF
      when "000010010000000" =>  data <= "11111111";  -- 480 = FF
      when "000010010000001" =>  data <= "11111111";  -- 481 = FF
      when "000010010000010" =>  data <= "11111111";  -- 482 = FF
      when "000010010000011" =>  data <= "11111111";  -- 483 = FF
      when "000010010000100" =>  data <= "11111111";  -- 484 = FF
      when "000010010000101" =>  data <= "11111111";  -- 485 = FF
      when "000010010000110" =>  data <= "11111111";  -- 486 = FF
      when "000010010000111" =>  data <= "11111111";  -- 487 = FF
      when "000010010001000" =>  data <= "11111111";  -- 488 = FF
      when "000010010001001" =>  data <= "11111111";  -- 489 = FF
      when "000010010001010" =>  data <= "11111111";  -- 48A = FF
      when "000010010001011" =>  data <= "11111111";  -- 48B = FF
      when "000010010001100" =>  data <= "11111111";  -- 48C = FF
      when "000010010001101" =>  data <= "11111111";  -- 48D = FF
      when "000010010001110" =>  data <= "11111111";  -- 48E = FF
      when "000010010001111" =>  data <= "11111111";  -- 48F = FF
      when "000010010010000" =>  data <= "11111111";  -- 490 = FF
      when "000010010010001" =>  data <= "11111111";  -- 491 = FF
      when "000010010010010" =>  data <= "11111111";  -- 492 = FF
      when "000010010010011" =>  data <= "11111111";  -- 493 = FF
      when "000010010010100" =>  data <= "11111111";  -- 494 = FF
      when "000010010010101" =>  data <= "11111111";  -- 495 = FF
      when "000010010010110" =>  data <= "11111111";  -- 496 = FF
      when "000010010010111" =>  data <= "11111111";  -- 497 = FF
      when "000010010011000" =>  data <= "11111111";  -- 498 = FF
      when "000010010011001" =>  data <= "11111111";  -- 499 = FF
      when "000010010011010" =>  data <= "11111111";  -- 49A = FF
      when "000010010011011" =>  data <= "11111111";  -- 49B = FF
      when "000010010011100" =>  data <= "11111111";  -- 49C = FF
      when "000010010011101" =>  data <= "11111111";  -- 49D = FF
      when "000010010011110" =>  data <= "11111111";  -- 49E = FF
      when "000010010011111" =>  data <= "11111111";  -- 49F = FF
      when "000010010100000" =>  data <= "11111111";  -- 4A0 = FF
      when "000010010100001" =>  data <= "11111111";  -- 4A1 = FF
      when "000010010100010" =>  data <= "11111111";  -- 4A2 = FF
      when "000010010100011" =>  data <= "11111111";  -- 4A3 = FF
      when "000010010100100" =>  data <= "11111111";  -- 4A4 = FF
      when "000010010100101" =>  data <= "11111111";  -- 4A5 = FF
      when "000010010100110" =>  data <= "11111111";  -- 4A6 = FF
      when "000010010100111" =>  data <= "11111111";  -- 4A7 = FF
      when "000010010101000" =>  data <= "11111111";  -- 4A8 = FF
      when "000010010101001" =>  data <= "11111111";  -- 4A9 = FF
      when "000010010101010" =>  data <= "11111111";  -- 4AA = FF
      when "000010010101011" =>  data <= "11111111";  -- 4AB = FF
      when "000010010101100" =>  data <= "11111111";  -- 4AC = FF
      when "000010010101101" =>  data <= "11111111";  -- 4AD = FF
      when "000010010101110" =>  data <= "11111111";  -- 4AE = FF
      when "000010010101111" =>  data <= "11111111";  -- 4AF = FF
      when "000010010110000" =>  data <= "11111111";  -- 4B0 = FF
      when "000010010110001" =>  data <= "11111111";  -- 4B1 = FF
      when "000010010110010" =>  data <= "11111111";  -- 4B2 = FF
      when "000010010110011" =>  data <= "11111111";  -- 4B3 = FF
      when "000010010110100" =>  data <= "11111111";  -- 4B4 = FF
      when "000010010110101" =>  data <= "11111111";  -- 4B5 = FF
      when "000010010110110" =>  data <= "11111111";  -- 4B6 = FF
      when "000010010110111" =>  data <= "11111111";  -- 4B7 = FF
      when "000010010111000" =>  data <= "11111111";  -- 4B8 = FF
      when "000010010111001" =>  data <= "11111111";  -- 4B9 = FF
      when "000010010111010" =>  data <= "11111111";  -- 4BA = FF
      when "000010010111011" =>  data <= "11111111";  -- 4BB = FF
      when "000010010111100" =>  data <= "11111111";  -- 4BC = FF
      when "000010010111101" =>  data <= "11111111";  -- 4BD = FF
      when "000010010111110" =>  data <= "11111111";  -- 4BE = FF
      when "000010010111111" =>  data <= "11111111";  -- 4BF = FF
      when "000010011000000" =>  data <= "11111111";  -- 4C0 = FF
      when "000010011000001" =>  data <= "11111111";  -- 4C1 = FF
      when "000010011000010" =>  data <= "11111111";  -- 4C2 = FF
      when "000010011000011" =>  data <= "11111111";  -- 4C3 = FF
      when "000010011000100" =>  data <= "11111111";  -- 4C4 = FF
      when "000010011000101" =>  data <= "11111111";  -- 4C5 = FF
      when "000010011000110" =>  data <= "11111111";  -- 4C6 = FF
      when "000010011000111" =>  data <= "11111111";  -- 4C7 = FF
      when "000010011001000" =>  data <= "11111111";  -- 4C8 = FF
      when "000010011001001" =>  data <= "11111111";  -- 4C9 = FF
      when "000010011001010" =>  data <= "11111111";  -- 4CA = FF
      when "000010011001011" =>  data <= "11111111";  -- 4CB = FF
      when "000010011001100" =>  data <= "11111111";  -- 4CC = FF
      when "000010011001101" =>  data <= "11111111";  -- 4CD = FF
      when "000010011001110" =>  data <= "11111111";  -- 4CE = FF
      when "000010011001111" =>  data <= "11111111";  -- 4CF = FF
      when "000010011010000" =>  data <= "11111111";  -- 4D0 = FF
      when "000010011010001" =>  data <= "11111111";  -- 4D1 = FF
      when "000010011010010" =>  data <= "11111111";  -- 4D2 = FF
      when "000010011010011" =>  data <= "11111111";  -- 4D3 = FF
      when "000010011010100" =>  data <= "11111111";  -- 4D4 = FF
      when "000010011010101" =>  data <= "11111111";  -- 4D5 = FF
      when "000010011010110" =>  data <= "11111111";  -- 4D6 = FF
      when "000010011010111" =>  data <= "11111111";  -- 4D7 = FF
      when "000010011011000" =>  data <= "11111111";  -- 4D8 = FF
      when "000010011011001" =>  data <= "11111111";  -- 4D9 = FF
      when "000010011011010" =>  data <= "11111111";  -- 4DA = FF
      when "000010011011011" =>  data <= "11111111";  -- 4DB = FF
      when "000010011011100" =>  data <= "11111111";  -- 4DC = FF
      when "000010011011101" =>  data <= "11111111";  -- 4DD = FF
      when "000010011011110" =>  data <= "11111111";  -- 4DE = FF
      when "000010011011111" =>  data <= "11111111";  -- 4DF = FF
      when "000010011100000" =>  data <= "11111111";  -- 4E0 = FF
      when "000010011100001" =>  data <= "11111111";  -- 4E1 = FF
      when "000010011100010" =>  data <= "11111111";  -- 4E2 = FF
      when "000010011100011" =>  data <= "11111111";  -- 4E3 = FF
      when "000010011100100" =>  data <= "11111111";  -- 4E4 = FF
      when "000010011100101" =>  data <= "11111111";  -- 4E5 = FF
      when "000010011100110" =>  data <= "11111111";  -- 4E6 = FF
      when "000010011100111" =>  data <= "11111111";  -- 4E7 = FF
      when "000010011101000" =>  data <= "11111111";  -- 4E8 = FF
      when "000010011101001" =>  data <= "11111111";  -- 4E9 = FF
      when "000010011101010" =>  data <= "11111111";  -- 4EA = FF
      when "000010011101011" =>  data <= "11111111";  -- 4EB = FF
      when "000010011101100" =>  data <= "11111111";  -- 4EC = FF
      when "000010011101101" =>  data <= "11111111";  -- 4ED = FF
      when "000010011101110" =>  data <= "11111111";  -- 4EE = FF
      when "000010011101111" =>  data <= "11111111";  -- 4EF = FF
      when "000010011110000" =>  data <= "11111111";  -- 4F0 = FF
      when "000010011110001" =>  data <= "11111111";  -- 4F1 = FF
      when "000010011110010" =>  data <= "11111111";  -- 4F2 = FF
      when "000010011110011" =>  data <= "11111111";  -- 4F3 = FF
      when "000010011110100" =>  data <= "11111111";  -- 4F4 = FF
      when "000010011110101" =>  data <= "11111111";  -- 4F5 = FF
      when "000010011110110" =>  data <= "11111111";  -- 4F6 = FF
      when "000010011110111" =>  data <= "11111111";  -- 4F7 = FF
      when "000010011111000" =>  data <= "11111111";  -- 4F8 = FF
      when "000010011111001" =>  data <= "11111111";  -- 4F9 = FF
      when "000010011111010" =>  data <= "11111111";  -- 4FA = FF
      when "000010011111011" =>  data <= "11111111";  -- 4FB = FF
      when "000010011111100" =>  data <= "11111111";  -- 4FC = FF
      when "000010011111101" =>  data <= "11111111";  -- 4FD = FF
      when "000010011111110" =>  data <= "11111111";  -- 4FE = FF
      when "000010011111111" =>  data <= "11111111";  -- 4FF = FF
      when "000010100000000" =>  data <= "11111111";  -- 500 = FF
      when "000010100000001" =>  data <= "11111111";  -- 501 = FF
      when "000010100000010" =>  data <= "11111111";  -- 502 = FF
      when "000010100000011" =>  data <= "11111111";  -- 503 = FF
      when "000010100000100" =>  data <= "11111111";  -- 504 = FF
      when "000010100000101" =>  data <= "11111111";  -- 505 = FF
      when "000010100000110" =>  data <= "11111111";  -- 506 = FF
      when "000010100000111" =>  data <= "11111111";  -- 507 = FF
      when "000010100001000" =>  data <= "11111111";  -- 508 = FF
      when "000010100001001" =>  data <= "11111111";  -- 509 = FF
      when "000010100001010" =>  data <= "11111111";  -- 50A = FF
      when "000010100001011" =>  data <= "11111111";  -- 50B = FF
      when "000010100001100" =>  data <= "11111111";  -- 50C = FF
      when "000010100001101" =>  data <= "11111111";  -- 50D = FF
      when "000010100001110" =>  data <= "11111111";  -- 50E = FF
      when "000010100001111" =>  data <= "11111111";  -- 50F = FF
      when "000010100010000" =>  data <= "11111111";  -- 510 = FF
      when "000010100010001" =>  data <= "11111111";  -- 511 = FF
      when "000010100010010" =>  data <= "11111111";  -- 512 = FF
      when "000010100010011" =>  data <= "11111111";  -- 513 = FF
      when "000010100010100" =>  data <= "11111111";  -- 514 = FF
      when "000010100010101" =>  data <= "11111111";  -- 515 = FF
      when "000010100010110" =>  data <= "11111111";  -- 516 = FF
      when "000010100010111" =>  data <= "11111111";  -- 517 = FF
      when "000010100011000" =>  data <= "11111111";  -- 518 = FF
      when "000010100011001" =>  data <= "11111111";  -- 519 = FF
      when "000010100011010" =>  data <= "11111111";  -- 51A = FF
      when "000010100011011" =>  data <= "11111111";  -- 51B = FF
      when "000010100011100" =>  data <= "11111111";  -- 51C = FF
      when "000010100011101" =>  data <= "11111111";  -- 51D = FF
      when "000010100011110" =>  data <= "11111111";  -- 51E = FF
      when "000010100011111" =>  data <= "11111111";  -- 51F = FF
      when "000010100100000" =>  data <= "11111111";  -- 520 = FF
      when "000010100100001" =>  data <= "11111111";  -- 521 = FF
      when "000010100100010" =>  data <= "11111111";  -- 522 = FF
      when "000010100100011" =>  data <= "11111111";  -- 523 = FF
      when "000010100100100" =>  data <= "11111111";  -- 524 = FF
      when "000010100100101" =>  data <= "11111111";  -- 525 = FF
      when "000010100100110" =>  data <= "11111111";  -- 526 = FF
      when "000010100100111" =>  data <= "11111111";  -- 527 = FF
      when "000010100101000" =>  data <= "11111111";  -- 528 = FF
      when "000010100101001" =>  data <= "11111111";  -- 529 = FF
      when "000010100101010" =>  data <= "11111111";  -- 52A = FF
      when "000010100101011" =>  data <= "11111111";  -- 52B = FF
      when "000010100101100" =>  data <= "11111111";  -- 52C = FF
      when "000010100101101" =>  data <= "11111111";  -- 52D = FF
      when "000010100101110" =>  data <= "11111111";  -- 52E = FF
      when "000010100101111" =>  data <= "11111111";  -- 52F = FF
      when "000010100110000" =>  data <= "11111111";  -- 530 = FF
      when "000010100110001" =>  data <= "11111111";  -- 531 = FF
      when "000010100110010" =>  data <= "11111111";  -- 532 = FF
      when "000010100110011" =>  data <= "11111111";  -- 533 = FF
      when "000010100110100" =>  data <= "11111111";  -- 534 = FF
      when "000010100110101" =>  data <= "11111111";  -- 535 = FF
      when "000010100110110" =>  data <= "11111111";  -- 536 = FF
      when "000010100110111" =>  data <= "11111111";  -- 537 = FF
      when "000010100111000" =>  data <= "11111111";  -- 538 = FF
      when "000010100111001" =>  data <= "11111111";  -- 539 = FF
      when "000010100111010" =>  data <= "11111111";  -- 53A = FF
      when "000010100111011" =>  data <= "11111111";  -- 53B = FF
      when "000010100111100" =>  data <= "11111111";  -- 53C = FF
      when "000010100111101" =>  data <= "11111111";  -- 53D = FF
      when "000010100111110" =>  data <= "11111111";  -- 53E = FF
      when "000010100111111" =>  data <= "11111111";  -- 53F = FF
      when "000010101000000" =>  data <= "11111111";  -- 540 = FF
      when "000010101000001" =>  data <= "11111111";  -- 541 = FF
      when "000010101000010" =>  data <= "11111111";  -- 542 = FF
      when "000010101000011" =>  data <= "11111111";  -- 543 = FF
      when "000010101000100" =>  data <= "11111111";  -- 544 = FF
      when "000010101000101" =>  data <= "11111111";  -- 545 = FF
      when "000010101000110" =>  data <= "11111111";  -- 546 = FF
      when "000010101000111" =>  data <= "11111111";  -- 547 = FF
      when "000010101001000" =>  data <= "11111111";  -- 548 = FF
      when "000010101001001" =>  data <= "11111111";  -- 549 = FF
      when "000010101001010" =>  data <= "11111111";  -- 54A = FF
      when "000010101001011" =>  data <= "11111111";  -- 54B = FF
      when "000010101001100" =>  data <= "11111111";  -- 54C = FF
      when "000010101001101" =>  data <= "11111111";  -- 54D = FF
      when "000010101001110" =>  data <= "11111111";  -- 54E = FF
      when "000010101001111" =>  data <= "11111111";  -- 54F = FF
      when "000010101010000" =>  data <= "11111111";  -- 550 = FF
      when "000010101010001" =>  data <= "11111111";  -- 551 = FF
      when "000010101010010" =>  data <= "11111111";  -- 552 = FF
      when "000010101010011" =>  data <= "11111111";  -- 553 = FF
      when "000010101010100" =>  data <= "11111111";  -- 554 = FF
      when "000010101010101" =>  data <= "11111111";  -- 555 = FF
      when "000010101010110" =>  data <= "11111111";  -- 556 = FF
      when "000010101010111" =>  data <= "11111111";  -- 557 = FF
      when "000010101011000" =>  data <= "11111111";  -- 558 = FF
      when "000010101011001" =>  data <= "11111111";  -- 559 = FF
      when "000010101011010" =>  data <= "11111111";  -- 55A = FF
      when "000010101011011" =>  data <= "11111111";  -- 55B = FF
      when "000010101011100" =>  data <= "11111111";  -- 55C = FF
      when "000010101011101" =>  data <= "11111111";  -- 55D = FF
      when "000010101011110" =>  data <= "11111111";  -- 55E = FF
      when "000010101011111" =>  data <= "11111111";  -- 55F = FF
      when "000010101100000" =>  data <= "11111111";  -- 560 = FF
      when "000010101100001" =>  data <= "11111111";  -- 561 = FF
      when "000010101100010" =>  data <= "11111111";  -- 562 = FF
      when "000010101100011" =>  data <= "11111111";  -- 563 = FF
      when "000010101100100" =>  data <= "11111111";  -- 564 = FF
      when "000010101100101" =>  data <= "11111111";  -- 565 = FF
      when "000010101100110" =>  data <= "11111111";  -- 566 = FF
      when "000010101100111" =>  data <= "11111111";  -- 567 = FF
      when "000010101101000" =>  data <= "11111111";  -- 568 = FF
      when "000010101101001" =>  data <= "11111111";  -- 569 = FF
      when "000010101101010" =>  data <= "11111111";  -- 56A = FF
      when "000010101101011" =>  data <= "11111111";  -- 56B = FF
      when "000010101101100" =>  data <= "11111111";  -- 56C = FF
      when "000010101101101" =>  data <= "11111111";  -- 56D = FF
      when "000010101101110" =>  data <= "11111111";  -- 56E = FF
      when "000010101101111" =>  data <= "11111111";  -- 56F = FF
      when "000010101110000" =>  data <= "11111111";  -- 570 = FF
      when "000010101110001" =>  data <= "11111111";  -- 571 = FF
      when "000010101110010" =>  data <= "11111111";  -- 572 = FF
      when "000010101110011" =>  data <= "11111111";  -- 573 = FF
      when "000010101110100" =>  data <= "11111111";  -- 574 = FF
      when "000010101110101" =>  data <= "11111111";  -- 575 = FF
      when "000010101110110" =>  data <= "11111111";  -- 576 = FF
      when "000010101110111" =>  data <= "11111111";  -- 577 = FF
      when "000010101111000" =>  data <= "11111111";  -- 578 = FF
      when "000010101111001" =>  data <= "11111111";  -- 579 = FF
      when "000010101111010" =>  data <= "11111111";  -- 57A = FF
      when "000010101111011" =>  data <= "11111111";  -- 57B = FF
      when "000010101111100" =>  data <= "11111111";  -- 57C = FF
      when "000010101111101" =>  data <= "11111111";  -- 57D = FF
      when "000010101111110" =>  data <= "11111111";  -- 57E = FF
      when "000010101111111" =>  data <= "11111111";  -- 57F = FF
      when "000010110000000" =>  data <= "11111111";  -- 580 = FF
      when "000010110000001" =>  data <= "11111111";  -- 581 = FF
      when "000010110000010" =>  data <= "11111111";  -- 582 = FF
      when "000010110000011" =>  data <= "11111111";  -- 583 = FF
      when "000010110000100" =>  data <= "11111111";  -- 584 = FF
      when "000010110000101" =>  data <= "11111111";  -- 585 = FF
      when "000010110000110" =>  data <= "11111111";  -- 586 = FF
      when "000010110000111" =>  data <= "11111111";  -- 587 = FF
      when "000010110001000" =>  data <= "11111111";  -- 588 = FF
      when "000010110001001" =>  data <= "11111111";  -- 589 = FF
      when "000010110001010" =>  data <= "11111111";  -- 58A = FF
      when "000010110001011" =>  data <= "11111111";  -- 58B = FF
      when "000010110001100" =>  data <= "11111111";  -- 58C = FF
      when "000010110001101" =>  data <= "11111111";  -- 58D = FF
      when "000010110001110" =>  data <= "11111111";  -- 58E = FF
      when "000010110001111" =>  data <= "11111111";  -- 58F = FF
      when "000010110010000" =>  data <= "11111111";  -- 590 = FF
      when "000010110010001" =>  data <= "11111111";  -- 591 = FF
      when "000010110010010" =>  data <= "11111111";  -- 592 = FF
      when "000010110010011" =>  data <= "11111111";  -- 593 = FF
      when "000010110010100" =>  data <= "11111111";  -- 594 = FF
      when "000010110010101" =>  data <= "11111111";  -- 595 = FF
      when "000010110010110" =>  data <= "11111111";  -- 596 = FF
      when "000010110010111" =>  data <= "11111111";  -- 597 = FF
      when "000010110011000" =>  data <= "11111111";  -- 598 = FF
      when "000010110011001" =>  data <= "11111111";  -- 599 = FF
      when "000010110011010" =>  data <= "11111111";  -- 59A = FF
      when "000010110011011" =>  data <= "11111111";  -- 59B = FF
      when "000010110011100" =>  data <= "11111111";  -- 59C = FF
      when "000010110011101" =>  data <= "11111111";  -- 59D = FF
      when "000010110011110" =>  data <= "11111111";  -- 59E = FF
      when "000010110011111" =>  data <= "11111111";  -- 59F = FF
      when "000010110100000" =>  data <= "11111111";  -- 5A0 = FF
      when "000010110100001" =>  data <= "11111111";  -- 5A1 = FF
      when "000010110100010" =>  data <= "11111111";  -- 5A2 = FF
      when "000010110100011" =>  data <= "11111111";  -- 5A3 = FF
      when "000010110100100" =>  data <= "11111111";  -- 5A4 = FF
      when "000010110100101" =>  data <= "11111111";  -- 5A5 = FF
      when "000010110100110" =>  data <= "11111111";  -- 5A6 = FF
      when "000010110100111" =>  data <= "11111111";  -- 5A7 = FF
      when "000010110101000" =>  data <= "11111111";  -- 5A8 = FF
      when "000010110101001" =>  data <= "11111111";  -- 5A9 = FF
      when "000010110101010" =>  data <= "11111111";  -- 5AA = FF
      when "000010110101011" =>  data <= "11111111";  -- 5AB = FF
      when "000010110101100" =>  data <= "11111111";  -- 5AC = FF
      when "000010110101101" =>  data <= "11111111";  -- 5AD = FF
      when "000010110101110" =>  data <= "11111111";  -- 5AE = FF
      when "000010110101111" =>  data <= "11111111";  -- 5AF = FF
      when "000010110110000" =>  data <= "11111111";  -- 5B0 = FF
      when "000010110110001" =>  data <= "11111111";  -- 5B1 = FF
      when "000010110110010" =>  data <= "11111111";  -- 5B2 = FF
      when "000010110110011" =>  data <= "11111111";  -- 5B3 = FF
      when "000010110110100" =>  data <= "11111111";  -- 5B4 = FF
      when "000010110110101" =>  data <= "11111111";  -- 5B5 = FF
      when "000010110110110" =>  data <= "11111111";  -- 5B6 = FF
      when "000010110110111" =>  data <= "11111111";  -- 5B7 = FF
      when "000010110111000" =>  data <= "11111111";  -- 5B8 = FF
      when "000010110111001" =>  data <= "11111111";  -- 5B9 = FF
      when "000010110111010" =>  data <= "11111111";  -- 5BA = FF
      when "000010110111011" =>  data <= "11111111";  -- 5BB = FF
      when "000010110111100" =>  data <= "11111111";  -- 5BC = FF
      when "000010110111101" =>  data <= "11111111";  -- 5BD = FF
      when "000010110111110" =>  data <= "11111111";  -- 5BE = FF
      when "000010110111111" =>  data <= "11111111";  -- 5BF = FF
      when "000010111000000" =>  data <= "11111111";  -- 5C0 = FF
      when "000010111000001" =>  data <= "11111111";  -- 5C1 = FF
      when "000010111000010" =>  data <= "11111111";  -- 5C2 = FF
      when "000010111000011" =>  data <= "11111111";  -- 5C3 = FF
      when "000010111000100" =>  data <= "11111111";  -- 5C4 = FF
      when "000010111000101" =>  data <= "11111111";  -- 5C5 = FF
      when "000010111000110" =>  data <= "11111111";  -- 5C6 = FF
      when "000010111000111" =>  data <= "11111111";  -- 5C7 = FF
      when "000010111001000" =>  data <= "11111111";  -- 5C8 = FF
      when "000010111001001" =>  data <= "11111111";  -- 5C9 = FF
      when "000010111001010" =>  data <= "11111111";  -- 5CA = FF
      when "000010111001011" =>  data <= "11111111";  -- 5CB = FF
      when "000010111001100" =>  data <= "11111111";  -- 5CC = FF
      when "000010111001101" =>  data <= "11111111";  -- 5CD = FF
      when "000010111001110" =>  data <= "11111111";  -- 5CE = FF
      when "000010111001111" =>  data <= "11111111";  -- 5CF = FF
      when "000010111010000" =>  data <= "11111111";  -- 5D0 = FF
      when "000010111010001" =>  data <= "11111111";  -- 5D1 = FF
      when "000010111010010" =>  data <= "11111111";  -- 5D2 = FF
      when "000010111010011" =>  data <= "11111111";  -- 5D3 = FF
      when "000010111010100" =>  data <= "11111111";  -- 5D4 = FF
      when "000010111010101" =>  data <= "11111111";  -- 5D5 = FF
      when "000010111010110" =>  data <= "11111111";  -- 5D6 = FF
      when "000010111010111" =>  data <= "11111111";  -- 5D7 = FF
      when "000010111011000" =>  data <= "11111111";  -- 5D8 = FF
      when "000010111011001" =>  data <= "11111111";  -- 5D9 = FF
      when "000010111011010" =>  data <= "11111111";  -- 5DA = FF
      when "000010111011011" =>  data <= "11111111";  -- 5DB = FF
      when "000010111011100" =>  data <= "11111111";  -- 5DC = FF
      when "000010111011101" =>  data <= "11111111";  -- 5DD = FF
      when "000010111011110" =>  data <= "11111111";  -- 5DE = FF
      when "000010111011111" =>  data <= "11111111";  -- 5DF = FF
      when "000010111100000" =>  data <= "11111111";  -- 5E0 = FF
      when "000010111100001" =>  data <= "11111111";  -- 5E1 = FF
      when "000010111100010" =>  data <= "11111111";  -- 5E2 = FF
      when "000010111100011" =>  data <= "11111111";  -- 5E3 = FF
      when "000010111100100" =>  data <= "11111111";  -- 5E4 = FF
      when "000010111100101" =>  data <= "11111111";  -- 5E5 = FF
      when "000010111100110" =>  data <= "11111111";  -- 5E6 = FF
      when "000010111100111" =>  data <= "11111111";  -- 5E7 = FF
      when "000010111101000" =>  data <= "11111111";  -- 5E8 = FF
      when "000010111101001" =>  data <= "11111111";  -- 5E9 = FF
      when "000010111101010" =>  data <= "11111111";  -- 5EA = FF
      when "000010111101011" =>  data <= "11111111";  -- 5EB = FF
      when "000010111101100" =>  data <= "11111111";  -- 5EC = FF
      when "000010111101101" =>  data <= "11111111";  -- 5ED = FF
      when "000010111101110" =>  data <= "11111111";  -- 5EE = FF
      when "000010111101111" =>  data <= "11111111";  -- 5EF = FF
      when "000010111110000" =>  data <= "11111111";  -- 5F0 = FF
      when "000010111110001" =>  data <= "11111111";  -- 5F1 = FF
      when "000010111110010" =>  data <= "11111111";  -- 5F2 = FF
      when "000010111110011" =>  data <= "11111111";  -- 5F3 = FF
      when "000010111110100" =>  data <= "11111111";  -- 5F4 = FF
      when "000010111110101" =>  data <= "11111111";  -- 5F5 = FF
      when "000010111110110" =>  data <= "11111111";  -- 5F6 = FF
      when "000010111110111" =>  data <= "11111111";  -- 5F7 = FF
      when "000010111111000" =>  data <= "11111111";  -- 5F8 = FF
      when "000010111111001" =>  data <= "11111111";  -- 5F9 = FF
      when "000010111111010" =>  data <= "11111111";  -- 5FA = FF
      when "000010111111011" =>  data <= "11111111";  -- 5FB = FF
      when "000010111111100" =>  data <= "11111111";  -- 5FC = FF
      when "000010111111101" =>  data <= "11111111";  -- 5FD = FF
      when "000010111111110" =>  data <= "11111111";  -- 5FE = FF
      when "000010111111111" =>  data <= "11111111";  -- 5FF = FF
      when "000011000000000" =>  data <= "11111111";  -- 600 = FF
      when "000011000000001" =>  data <= "11111111";  -- 601 = FF
      when "000011000000010" =>  data <= "11111111";  -- 602 = FF
      when "000011000000011" =>  data <= "11111111";  -- 603 = FF
      when "000011000000100" =>  data <= "11111111";  -- 604 = FF
      when "000011000000101" =>  data <= "11111111";  -- 605 = FF
      when "000011000000110" =>  data <= "11111111";  -- 606 = FF
      when "000011000000111" =>  data <= "11111111";  -- 607 = FF
      when "000011000001000" =>  data <= "11111111";  -- 608 = FF
      when "000011000001001" =>  data <= "11111111";  -- 609 = FF
      when "000011000001010" =>  data <= "11111111";  -- 60A = FF
      when "000011000001011" =>  data <= "11111111";  -- 60B = FF
      when "000011000001100" =>  data <= "11111111";  -- 60C = FF
      when "000011000001101" =>  data <= "11111111";  -- 60D = FF
      when "000011000001110" =>  data <= "11111111";  -- 60E = FF
      when "000011000001111" =>  data <= "11111111";  -- 60F = FF
      when "000011000010000" =>  data <= "11111111";  -- 610 = FF
      when "000011000010001" =>  data <= "11111111";  -- 611 = FF
      when "000011000010010" =>  data <= "11111111";  -- 612 = FF
      when "000011000010011" =>  data <= "11111111";  -- 613 = FF
      when "000011000010100" =>  data <= "11111111";  -- 614 = FF
      when "000011000010101" =>  data <= "11111111";  -- 615 = FF
      when "000011000010110" =>  data <= "11111111";  -- 616 = FF
      when "000011000010111" =>  data <= "11111111";  -- 617 = FF
      when "000011000011000" =>  data <= "11111111";  -- 618 = FF
      when "000011000011001" =>  data <= "11111111";  -- 619 = FF
      when "000011000011010" =>  data <= "11111111";  -- 61A = FF
      when "000011000011011" =>  data <= "11111111";  -- 61B = FF
      when "000011000011100" =>  data <= "11111111";  -- 61C = FF
      when "000011000011101" =>  data <= "11111111";  -- 61D = FF
      when "000011000011110" =>  data <= "11111111";  -- 61E = FF
      when "000011000011111" =>  data <= "11111111";  -- 61F = FF
      when "000011000100000" =>  data <= "11111111";  -- 620 = FF
      when "000011000100001" =>  data <= "11111111";  -- 621 = FF
      when "000011000100010" =>  data <= "11111111";  -- 622 = FF
      when "000011000100011" =>  data <= "11111111";  -- 623 = FF
      when "000011000100100" =>  data <= "11111111";  -- 624 = FF
      when "000011000100101" =>  data <= "11111111";  -- 625 = FF
      when "000011000100110" =>  data <= "11111111";  -- 626 = FF
      when "000011000100111" =>  data <= "11111111";  -- 627 = FF
      when "000011000101000" =>  data <= "11111111";  -- 628 = FF
      when "000011000101001" =>  data <= "11111111";  -- 629 = FF
      when "000011000101010" =>  data <= "11111111";  -- 62A = FF
      when "000011000101011" =>  data <= "11111111";  -- 62B = FF
      when "000011000101100" =>  data <= "11111111";  -- 62C = FF
      when "000011000101101" =>  data <= "11111111";  -- 62D = FF
      when "000011000101110" =>  data <= "11111111";  -- 62E = FF
      when "000011000101111" =>  data <= "11111111";  -- 62F = FF
      when "000011000110000" =>  data <= "11111111";  -- 630 = FF
      when "000011000110001" =>  data <= "11111111";  -- 631 = FF
      when "000011000110010" =>  data <= "11111111";  -- 632 = FF
      when "000011000110011" =>  data <= "11111111";  -- 633 = FF
      when "000011000110100" =>  data <= "11111111";  -- 634 = FF
      when "000011000110101" =>  data <= "11111111";  -- 635 = FF
      when "000011000110110" =>  data <= "11111111";  -- 636 = FF
      when "000011000110111" =>  data <= "11111111";  -- 637 = FF
      when "000011000111000" =>  data <= "11111111";  -- 638 = FF
      when "000011000111001" =>  data <= "11111111";  -- 639 = FF
      when "000011000111010" =>  data <= "11111111";  -- 63A = FF
      when "000011000111011" =>  data <= "11111111";  -- 63B = FF
      when "000011000111100" =>  data <= "11111111";  -- 63C = FF
      when "000011000111101" =>  data <= "11111111";  -- 63D = FF
      when "000011000111110" =>  data <= "11111111";  -- 63E = FF
      when "000011000111111" =>  data <= "11111111";  -- 63F = FF
      when "000011001000000" =>  data <= "11111111";  -- 640 = FF
      when "000011001000001" =>  data <= "11111111";  -- 641 = FF
      when "000011001000010" =>  data <= "11111111";  -- 642 = FF
      when "000011001000011" =>  data <= "11111111";  -- 643 = FF
      when "000011001000100" =>  data <= "11111111";  -- 644 = FF
      when "000011001000101" =>  data <= "11111111";  -- 645 = FF
      when "000011001000110" =>  data <= "11111111";  -- 646 = FF
      when "000011001000111" =>  data <= "11111111";  -- 647 = FF
      when "000011001001000" =>  data <= "11111111";  -- 648 = FF
      when "000011001001001" =>  data <= "11111111";  -- 649 = FF
      when "000011001001010" =>  data <= "11111111";  -- 64A = FF
      when "000011001001011" =>  data <= "11111111";  -- 64B = FF
      when "000011001001100" =>  data <= "11111111";  -- 64C = FF
      when "000011001001101" =>  data <= "11111111";  -- 64D = FF
      when "000011001001110" =>  data <= "11111111";  -- 64E = FF
      when "000011001001111" =>  data <= "11111111";  -- 64F = FF
      when "000011001010000" =>  data <= "11111111";  -- 650 = FF
      when "000011001010001" =>  data <= "11111111";  -- 651 = FF
      when "000011001010010" =>  data <= "11111111";  -- 652 = FF
      when "000011001010011" =>  data <= "11111111";  -- 653 = FF
      when "000011001010100" =>  data <= "11111111";  -- 654 = FF
      when "000011001010101" =>  data <= "11111111";  -- 655 = FF
      when "000011001010110" =>  data <= "11111111";  -- 656 = FF
      when "000011001010111" =>  data <= "11111111";  -- 657 = FF
      when "000011001011000" =>  data <= "11111111";  -- 658 = FF
      when "000011001011001" =>  data <= "11111111";  -- 659 = FF
      when "000011001011010" =>  data <= "11111111";  -- 65A = FF
      when "000011001011011" =>  data <= "11111111";  -- 65B = FF
      when "000011001011100" =>  data <= "11111111";  -- 65C = FF
      when "000011001011101" =>  data <= "11111111";  -- 65D = FF
      when "000011001011110" =>  data <= "11111111";  -- 65E = FF
      when "000011001011111" =>  data <= "11111111";  -- 65F = FF
      when "000011001100000" =>  data <= "11111111";  -- 660 = FF
      when "000011001100001" =>  data <= "11111111";  -- 661 = FF
      when "000011001100010" =>  data <= "11111111";  -- 662 = FF
      when "000011001100011" =>  data <= "11111111";  -- 663 = FF
      when "000011001100100" =>  data <= "11111111";  -- 664 = FF
      when "000011001100101" =>  data <= "11111111";  -- 665 = FF
      when "000011001100110" =>  data <= "11111111";  -- 666 = FF
      when "000011001100111" =>  data <= "11111111";  -- 667 = FF
      when "000011001101000" =>  data <= "11111111";  -- 668 = FF
      when "000011001101001" =>  data <= "11111111";  -- 669 = FF
      when "000011001101010" =>  data <= "11111111";  -- 66A = FF
      when "000011001101011" =>  data <= "11111111";  -- 66B = FF
      when "000011001101100" =>  data <= "11111111";  -- 66C = FF
      when "000011001101101" =>  data <= "11111111";  -- 66D = FF
      when "000011001101110" =>  data <= "11111111";  -- 66E = FF
      when "000011001101111" =>  data <= "11111111";  -- 66F = FF
      when "000011001110000" =>  data <= "11111111";  -- 670 = FF
      when "000011001110001" =>  data <= "11111111";  -- 671 = FF
      when "000011001110010" =>  data <= "11111111";  -- 672 = FF
      when "000011001110011" =>  data <= "11111111";  -- 673 = FF
      when "000011001110100" =>  data <= "11111111";  -- 674 = FF
      when "000011001110101" =>  data <= "11111111";  -- 675 = FF
      when "000011001110110" =>  data <= "11111111";  -- 676 = FF
      when "000011001110111" =>  data <= "11111111";  -- 677 = FF
      when "000011001111000" =>  data <= "11111111";  -- 678 = FF
      when "000011001111001" =>  data <= "11111111";  -- 679 = FF
      when "000011001111010" =>  data <= "11111111";  -- 67A = FF
      when "000011001111011" =>  data <= "11111111";  -- 67B = FF
      when "000011001111100" =>  data <= "11111111";  -- 67C = FF
      when "000011001111101" =>  data <= "11111111";  -- 67D = FF
      when "000011001111110" =>  data <= "11111111";  -- 67E = FF
      when "000011001111111" =>  data <= "11111111";  -- 67F = FF
      when "000011010000000" =>  data <= "11111111";  -- 680 = FF
      when "000011010000001" =>  data <= "11111111";  -- 681 = FF
      when "000011010000010" =>  data <= "11111111";  -- 682 = FF
      when "000011010000011" =>  data <= "11111111";  -- 683 = FF
      when "000011010000100" =>  data <= "11111111";  -- 684 = FF
      when "000011010000101" =>  data <= "11111111";  -- 685 = FF
      when "000011010000110" =>  data <= "11111111";  -- 686 = FF
      when "000011010000111" =>  data <= "11111111";  -- 687 = FF
      when "000011010001000" =>  data <= "11111111";  -- 688 = FF
      when "000011010001001" =>  data <= "11111111";  -- 689 = FF
      when "000011010001010" =>  data <= "11111111";  -- 68A = FF
      when "000011010001011" =>  data <= "11111111";  -- 68B = FF
      when "000011010001100" =>  data <= "11111111";  -- 68C = FF
      when "000011010001101" =>  data <= "11111111";  -- 68D = FF
      when "000011010001110" =>  data <= "11111111";  -- 68E = FF
      when "000011010001111" =>  data <= "11111111";  -- 68F = FF
      when "000011010010000" =>  data <= "11111111";  -- 690 = FF
      when "000011010010001" =>  data <= "11111111";  -- 691 = FF
      when "000011010010010" =>  data <= "11111111";  -- 692 = FF
      when "000011010010011" =>  data <= "11111111";  -- 693 = FF
      when "000011010010100" =>  data <= "11111111";  -- 694 = FF
      when "000011010010101" =>  data <= "11111111";  -- 695 = FF
      when "000011010010110" =>  data <= "11111111";  -- 696 = FF
      when "000011010010111" =>  data <= "11111111";  -- 697 = FF
      when "000011010011000" =>  data <= "11111111";  -- 698 = FF
      when "000011010011001" =>  data <= "11111111";  -- 699 = FF
      when "000011010011010" =>  data <= "11111111";  -- 69A = FF
      when "000011010011011" =>  data <= "11111111";  -- 69B = FF
      when "000011010011100" =>  data <= "11111111";  -- 69C = FF
      when "000011010011101" =>  data <= "11111111";  -- 69D = FF
      when "000011010011110" =>  data <= "11111111";  -- 69E = FF
      when "000011010011111" =>  data <= "11111111";  -- 69F = FF
      when "000011010100000" =>  data <= "11111111";  -- 6A0 = FF
      when "000011010100001" =>  data <= "11111111";  -- 6A1 = FF
      when "000011010100010" =>  data <= "11111111";  -- 6A2 = FF
      when "000011010100011" =>  data <= "11111111";  -- 6A3 = FF
      when "000011010100100" =>  data <= "11111111";  -- 6A4 = FF
      when "000011010100101" =>  data <= "11111111";  -- 6A5 = FF
      when "000011010100110" =>  data <= "11111111";  -- 6A6 = FF
      when "000011010100111" =>  data <= "11111111";  -- 6A7 = FF
      when "000011010101000" =>  data <= "11111111";  -- 6A8 = FF
      when "000011010101001" =>  data <= "11111111";  -- 6A9 = FF
      when "000011010101010" =>  data <= "11111111";  -- 6AA = FF
      when "000011010101011" =>  data <= "11111111";  -- 6AB = FF
      when "000011010101100" =>  data <= "11111111";  -- 6AC = FF
      when "000011010101101" =>  data <= "11111111";  -- 6AD = FF
      when "000011010101110" =>  data <= "11111111";  -- 6AE = FF
      when "000011010101111" =>  data <= "11111111";  -- 6AF = FF
      when "000011010110000" =>  data <= "11111111";  -- 6B0 = FF
      when "000011010110001" =>  data <= "11111111";  -- 6B1 = FF
      when "000011010110010" =>  data <= "11111111";  -- 6B2 = FF
      when "000011010110011" =>  data <= "11111111";  -- 6B3 = FF
      when "000011010110100" =>  data <= "11111111";  -- 6B4 = FF
      when "000011010110101" =>  data <= "11111111";  -- 6B5 = FF
      when "000011010110110" =>  data <= "11111111";  -- 6B6 = FF
      when "000011010110111" =>  data <= "11111111";  -- 6B7 = FF
      when "000011010111000" =>  data <= "11111111";  -- 6B8 = FF
      when "000011010111001" =>  data <= "11111111";  -- 6B9 = FF
      when "000011010111010" =>  data <= "11111111";  -- 6BA = FF
      when "000011010111011" =>  data <= "11111111";  -- 6BB = FF
      when "000011010111100" =>  data <= "11111111";  -- 6BC = FF
      when "000011010111101" =>  data <= "11111111";  -- 6BD = FF
      when "000011010111110" =>  data <= "11111111";  -- 6BE = FF
      when "000011010111111" =>  data <= "11111111";  -- 6BF = FF
      when "000011011000000" =>  data <= "11111111";  -- 6C0 = FF
      when "000011011000001" =>  data <= "11111111";  -- 6C1 = FF
      when "000011011000010" =>  data <= "11111111";  -- 6C2 = FF
      when "000011011000011" =>  data <= "11111111";  -- 6C3 = FF
      when "000011011000100" =>  data <= "11111111";  -- 6C4 = FF
      when "000011011000101" =>  data <= "11111111";  -- 6C5 = FF
      when "000011011000110" =>  data <= "11111111";  -- 6C6 = FF
      when "000011011000111" =>  data <= "11111111";  -- 6C7 = FF
      when "000011011001000" =>  data <= "11111111";  -- 6C8 = FF
      when "000011011001001" =>  data <= "11111111";  -- 6C9 = FF
      when "000011011001010" =>  data <= "11111111";  -- 6CA = FF
      when "000011011001011" =>  data <= "11111111";  -- 6CB = FF
      when "000011011001100" =>  data <= "11111111";  -- 6CC = FF
      when "000011011001101" =>  data <= "11111111";  -- 6CD = FF
      when "000011011001110" =>  data <= "11111111";  -- 6CE = FF
      when "000011011001111" =>  data <= "11111111";  -- 6CF = FF
      when "000011011010000" =>  data <= "11111111";  -- 6D0 = FF
      when "000011011010001" =>  data <= "11111111";  -- 6D1 = FF
      when "000011011010010" =>  data <= "11111111";  -- 6D2 = FF
      when "000011011010011" =>  data <= "11111111";  -- 6D3 = FF
      when "000011011010100" =>  data <= "11111111";  -- 6D4 = FF
      when "000011011010101" =>  data <= "11111111";  -- 6D5 = FF
      when "000011011010110" =>  data <= "11111111";  -- 6D6 = FF
      when "000011011010111" =>  data <= "11111111";  -- 6D7 = FF
      when "000011011011000" =>  data <= "11111111";  -- 6D8 = FF
      when "000011011011001" =>  data <= "11111111";  -- 6D9 = FF
      when "000011011011010" =>  data <= "11111111";  -- 6DA = FF
      when "000011011011011" =>  data <= "11111111";  -- 6DB = FF
      when "000011011011100" =>  data <= "11111111";  -- 6DC = FF
      when "000011011011101" =>  data <= "11111111";  -- 6DD = FF
      when "000011011011110" =>  data <= "11111111";  -- 6DE = FF
      when "000011011011111" =>  data <= "11111111";  -- 6DF = FF
      when "000011011100000" =>  data <= "11111111";  -- 6E0 = FF
      when "000011011100001" =>  data <= "11111111";  -- 6E1 = FF
      when "000011011100010" =>  data <= "11111111";  -- 6E2 = FF
      when "000011011100011" =>  data <= "11111111";  -- 6E3 = FF
      when "000011011100100" =>  data <= "11111111";  -- 6E4 = FF
      when "000011011100101" =>  data <= "11111111";  -- 6E5 = FF
      when "000011011100110" =>  data <= "11111111";  -- 6E6 = FF
      when "000011011100111" =>  data <= "11111111";  -- 6E7 = FF
      when "000011011101000" =>  data <= "11111111";  -- 6E8 = FF
      when "000011011101001" =>  data <= "11111111";  -- 6E9 = FF
      when "000011011101010" =>  data <= "11111111";  -- 6EA = FF
      when "000011011101011" =>  data <= "11111111";  -- 6EB = FF
      when "000011011101100" =>  data <= "11111111";  -- 6EC = FF
      when "000011011101101" =>  data <= "11111111";  -- 6ED = FF
      when "000011011101110" =>  data <= "11111111";  -- 6EE = FF
      when "000011011101111" =>  data <= "11111111";  -- 6EF = FF
      when "000011011110000" =>  data <= "11111111";  -- 6F0 = FF
      when "000011011110001" =>  data <= "11111111";  -- 6F1 = FF
      when "000011011110010" =>  data <= "11111111";  -- 6F2 = FF
      when "000011011110011" =>  data <= "11111111";  -- 6F3 = FF
      when "000011011110100" =>  data <= "11111111";  -- 6F4 = FF
      when "000011011110101" =>  data <= "11111111";  -- 6F5 = FF
      when "000011011110110" =>  data <= "11111111";  -- 6F6 = FF
      when "000011011110111" =>  data <= "11111111";  -- 6F7 = FF
      when "000011011111000" =>  data <= "11111111";  -- 6F8 = FF
      when "000011011111001" =>  data <= "11111111";  -- 6F9 = FF
      when "000011011111010" =>  data <= "11111111";  -- 6FA = FF
      when "000011011111011" =>  data <= "11111111";  -- 6FB = FF
      when "000011011111100" =>  data <= "11111111";  -- 6FC = FF
      when "000011011111101" =>  data <= "11111111";  -- 6FD = FF
      when "000011011111110" =>  data <= "11111111";  -- 6FE = FF
      when "000011011111111" =>  data <= "11111111";  -- 6FF = FF
      when "000011100000000" =>  data <= "11111111";  -- 700 = FF
      when "000011100000001" =>  data <= "11111111";  -- 701 = FF
      when "000011100000010" =>  data <= "11111111";  -- 702 = FF
      when "000011100000011" =>  data <= "11111111";  -- 703 = FF
      when "000011100000100" =>  data <= "11111111";  -- 704 = FF
      when "000011100000101" =>  data <= "11111111";  -- 705 = FF
      when "000011100000110" =>  data <= "11111111";  -- 706 = FF
      when "000011100000111" =>  data <= "11111111";  -- 707 = FF
      when "000011100001000" =>  data <= "11111111";  -- 708 = FF
      when "000011100001001" =>  data <= "11111111";  -- 709 = FF
      when "000011100001010" =>  data <= "11111111";  -- 70A = FF
      when "000011100001011" =>  data <= "11111111";  -- 70B = FF
      when "000011100001100" =>  data <= "11111111";  -- 70C = FF
      when "000011100001101" =>  data <= "11111111";  -- 70D = FF
      when "000011100001110" =>  data <= "11111111";  -- 70E = FF
      when "000011100001111" =>  data <= "11111111";  -- 70F = FF
      when "000011100010000" =>  data <= "11111111";  -- 710 = FF
      when "000011100010001" =>  data <= "11111111";  -- 711 = FF
      when "000011100010010" =>  data <= "11111111";  -- 712 = FF
      when "000011100010011" =>  data <= "11111111";  -- 713 = FF
      when "000011100010100" =>  data <= "11111111";  -- 714 = FF
      when "000011100010101" =>  data <= "11111111";  -- 715 = FF
      when "000011100010110" =>  data <= "11111111";  -- 716 = FF
      when "000011100010111" =>  data <= "11111111";  -- 717 = FF
      when "000011100011000" =>  data <= "11111111";  -- 718 = FF
      when "000011100011001" =>  data <= "11111111";  -- 719 = FF
      when "000011100011010" =>  data <= "11111111";  -- 71A = FF
      when "000011100011011" =>  data <= "11111111";  -- 71B = FF
      when "000011100011100" =>  data <= "11111111";  -- 71C = FF
      when "000011100011101" =>  data <= "11111111";  -- 71D = FF
      when "000011100011110" =>  data <= "11111111";  -- 71E = FF
      when "000011100011111" =>  data <= "11111111";  -- 71F = FF
      when "000011100100000" =>  data <= "11111111";  -- 720 = FF
      when "000011100100001" =>  data <= "11111111";  -- 721 = FF
      when "000011100100010" =>  data <= "11111111";  -- 722 = FF
      when "000011100100011" =>  data <= "11111111";  -- 723 = FF
      when "000011100100100" =>  data <= "11111111";  -- 724 = FF
      when "000011100100101" =>  data <= "11111111";  -- 725 = FF
      when "000011100100110" =>  data <= "11111111";  -- 726 = FF
      when "000011100100111" =>  data <= "11111111";  -- 727 = FF
      when "000011100101000" =>  data <= "11111111";  -- 728 = FF
      when "000011100101001" =>  data <= "11111111";  -- 729 = FF
      when "000011100101010" =>  data <= "11111111";  -- 72A = FF
      when "000011100101011" =>  data <= "11111111";  -- 72B = FF
      when "000011100101100" =>  data <= "11111111";  -- 72C = FF
      when "000011100101101" =>  data <= "11111111";  -- 72D = FF
      when "000011100101110" =>  data <= "11111111";  -- 72E = FF
      when "000011100101111" =>  data <= "11111111";  -- 72F = FF
      when "000011100110000" =>  data <= "11111111";  -- 730 = FF
      when "000011100110001" =>  data <= "11111111";  -- 731 = FF
      when "000011100110010" =>  data <= "11111111";  -- 732 = FF
      when "000011100110011" =>  data <= "11111111";  -- 733 = FF
      when "000011100110100" =>  data <= "11111111";  -- 734 = FF
      when "000011100110101" =>  data <= "11111111";  -- 735 = FF
      when "000011100110110" =>  data <= "11111111";  -- 736 = FF
      when "000011100110111" =>  data <= "11111111";  -- 737 = FF
      when "000011100111000" =>  data <= "11111111";  -- 738 = FF
      when "000011100111001" =>  data <= "11111111";  -- 739 = FF
      when "000011100111010" =>  data <= "11111111";  -- 73A = FF
      when "000011100111011" =>  data <= "11111111";  -- 73B = FF
      when "000011100111100" =>  data <= "11111111";  -- 73C = FF
      when "000011100111101" =>  data <= "11111111";  -- 73D = FF
      when "000011100111110" =>  data <= "11111111";  -- 73E = FF
      when "000011100111111" =>  data <= "11111111";  -- 73F = FF
      when "000011101000000" =>  data <= "11111111";  -- 740 = FF
      when "000011101000001" =>  data <= "11111111";  -- 741 = FF
      when "000011101000010" =>  data <= "11111111";  -- 742 = FF
      when "000011101000011" =>  data <= "11111111";  -- 743 = FF
      when "000011101000100" =>  data <= "11111111";  -- 744 = FF
      when "000011101000101" =>  data <= "11111111";  -- 745 = FF
      when "000011101000110" =>  data <= "11111111";  -- 746 = FF
      when "000011101000111" =>  data <= "11111111";  -- 747 = FF
      when "000011101001000" =>  data <= "11111111";  -- 748 = FF
      when "000011101001001" =>  data <= "11111111";  -- 749 = FF
      when "000011101001010" =>  data <= "11111111";  -- 74A = FF
      when "000011101001011" =>  data <= "11111111";  -- 74B = FF
      when "000011101001100" =>  data <= "11111111";  -- 74C = FF
      when "000011101001101" =>  data <= "11111111";  -- 74D = FF
      when "000011101001110" =>  data <= "11111111";  -- 74E = FF
      when "000011101001111" =>  data <= "11111111";  -- 74F = FF
      when "000011101010000" =>  data <= "11111111";  -- 750 = FF
      when "000011101010001" =>  data <= "11111111";  -- 751 = FF
      when "000011101010010" =>  data <= "11111111";  -- 752 = FF
      when "000011101010011" =>  data <= "11111111";  -- 753 = FF
      when "000011101010100" =>  data <= "11111111";  -- 754 = FF
      when "000011101010101" =>  data <= "11111111";  -- 755 = FF
      when "000011101010110" =>  data <= "11111111";  -- 756 = FF
      when "000011101010111" =>  data <= "11111111";  -- 757 = FF
      when "000011101011000" =>  data <= "11111111";  -- 758 = FF
      when "000011101011001" =>  data <= "11111111";  -- 759 = FF
      when "000011101011010" =>  data <= "11111111";  -- 75A = FF
      when "000011101011011" =>  data <= "11111111";  -- 75B = FF
      when "000011101011100" =>  data <= "11111111";  -- 75C = FF
      when "000011101011101" =>  data <= "11111111";  -- 75D = FF
      when "000011101011110" =>  data <= "11111111";  -- 75E = FF
      when "000011101011111" =>  data <= "11111111";  -- 75F = FF
      when "000011101100000" =>  data <= "11111111";  -- 760 = FF
      when "000011101100001" =>  data <= "11111111";  -- 761 = FF
      when "000011101100010" =>  data <= "11111111";  -- 762 = FF
      when "000011101100011" =>  data <= "11111111";  -- 763 = FF
      when "000011101100100" =>  data <= "11111111";  -- 764 = FF
      when "000011101100101" =>  data <= "11111111";  -- 765 = FF
      when "000011101100110" =>  data <= "11111111";  -- 766 = FF
      when "000011101100111" =>  data <= "11111111";  -- 767 = FF
      when "000011101101000" =>  data <= "11111111";  -- 768 = FF
      when "000011101101001" =>  data <= "11111111";  -- 769 = FF
      when "000011101101010" =>  data <= "11111111";  -- 76A = FF
      when "000011101101011" =>  data <= "11111111";  -- 76B = FF
      when "000011101101100" =>  data <= "11111111";  -- 76C = FF
      when "000011101101101" =>  data <= "11111111";  -- 76D = FF
      when "000011101101110" =>  data <= "11111111";  -- 76E = FF
      when "000011101101111" =>  data <= "11111111";  -- 76F = FF
      when "000011101110000" =>  data <= "11111111";  -- 770 = FF
      when "000011101110001" =>  data <= "11111111";  -- 771 = FF
      when "000011101110010" =>  data <= "11111111";  -- 772 = FF
      when "000011101110011" =>  data <= "11111111";  -- 773 = FF
      when "000011101110100" =>  data <= "11111111";  -- 774 = FF
      when "000011101110101" =>  data <= "11111111";  -- 775 = FF
      when "000011101110110" =>  data <= "11111111";  -- 776 = FF
      when "000011101110111" =>  data <= "11111111";  -- 777 = FF
      when "000011101111000" =>  data <= "11111111";  -- 778 = FF
      when "000011101111001" =>  data <= "11111111";  -- 779 = FF
      when "000011101111010" =>  data <= "11111111";  -- 77A = FF
      when "000011101111011" =>  data <= "11111111";  -- 77B = FF
      when "000011101111100" =>  data <= "11111111";  -- 77C = FF
      when "000011101111101" =>  data <= "11111111";  -- 77D = FF
      when "000011101111110" =>  data <= "11111111";  -- 77E = FF
      when "000011101111111" =>  data <= "11111111";  -- 77F = FF
      when "000011110000000" =>  data <= "11111111";  -- 780 = FF
      when "000011110000001" =>  data <= "11111111";  -- 781 = FF
      when "000011110000010" =>  data <= "11111111";  -- 782 = FF
      when "000011110000011" =>  data <= "11111111";  -- 783 = FF
      when "000011110000100" =>  data <= "11111111";  -- 784 = FF
      when "000011110000101" =>  data <= "11111111";  -- 785 = FF
      when "000011110000110" =>  data <= "11111111";  -- 786 = FF
      when "000011110000111" =>  data <= "11111111";  -- 787 = FF
      when "000011110001000" =>  data <= "11111111";  -- 788 = FF
      when "000011110001001" =>  data <= "11111111";  -- 789 = FF
      when "000011110001010" =>  data <= "11111111";  -- 78A = FF
      when "000011110001011" =>  data <= "11111111";  -- 78B = FF
      when "000011110001100" =>  data <= "11111111";  -- 78C = FF
      when "000011110001101" =>  data <= "11111111";  -- 78D = FF
      when "000011110001110" =>  data <= "11111111";  -- 78E = FF
      when "000011110001111" =>  data <= "11111111";  -- 78F = FF
      when "000011110010000" =>  data <= "11111111";  -- 790 = FF
      when "000011110010001" =>  data <= "11111111";  -- 791 = FF
      when "000011110010010" =>  data <= "11111111";  -- 792 = FF
      when "000011110010011" =>  data <= "11111111";  -- 793 = FF
      when "000011110010100" =>  data <= "11111111";  -- 794 = FF
      when "000011110010101" =>  data <= "11111111";  -- 795 = FF
      when "000011110010110" =>  data <= "11111111";  -- 796 = FF
      when "000011110010111" =>  data <= "11111111";  -- 797 = FF
      when "000011110011000" =>  data <= "11111111";  -- 798 = FF
      when "000011110011001" =>  data <= "11111111";  -- 799 = FF
      when "000011110011010" =>  data <= "11111111";  -- 79A = FF
      when "000011110011011" =>  data <= "11111111";  -- 79B = FF
      when "000011110011100" =>  data <= "11111111";  -- 79C = FF
      when "000011110011101" =>  data <= "11111111";  -- 79D = FF
      when "000011110011110" =>  data <= "11111111";  -- 79E = FF
      when "000011110011111" =>  data <= "11111111";  -- 79F = FF
      when "000011110100000" =>  data <= "11111111";  -- 7A0 = FF
      when "000011110100001" =>  data <= "11111111";  -- 7A1 = FF
      when "000011110100010" =>  data <= "11111111";  -- 7A2 = FF
      when "000011110100011" =>  data <= "11111111";  -- 7A3 = FF
      when "000011110100100" =>  data <= "11111111";  -- 7A4 = FF
      when "000011110100101" =>  data <= "11111111";  -- 7A5 = FF
      when "000011110100110" =>  data <= "11111111";  -- 7A6 = FF
      when "000011110100111" =>  data <= "11111111";  -- 7A7 = FF
      when "000011110101000" =>  data <= "11111111";  -- 7A8 = FF
      when "000011110101001" =>  data <= "11111111";  -- 7A9 = FF
      when "000011110101010" =>  data <= "11111111";  -- 7AA = FF
      when "000011110101011" =>  data <= "11111111";  -- 7AB = FF
      when "000011110101100" =>  data <= "11111111";  -- 7AC = FF
      when "000011110101101" =>  data <= "11111111";  -- 7AD = FF
      when "000011110101110" =>  data <= "11111111";  -- 7AE = FF
      when "000011110101111" =>  data <= "11111111";  -- 7AF = FF
      when "000011110110000" =>  data <= "11111111";  -- 7B0 = FF
      when "000011110110001" =>  data <= "11111111";  -- 7B1 = FF
      when "000011110110010" =>  data <= "11111111";  -- 7B2 = FF
      when "000011110110011" =>  data <= "11111111";  -- 7B3 = FF
      when "000011110110100" =>  data <= "11111111";  -- 7B4 = FF
      when "000011110110101" =>  data <= "11111111";  -- 7B5 = FF
      when "000011110110110" =>  data <= "11111111";  -- 7B6 = FF
      when "000011110110111" =>  data <= "11111111";  -- 7B7 = FF
      when "000011110111000" =>  data <= "11111111";  -- 7B8 = FF
      when "000011110111001" =>  data <= "11111111";  -- 7B9 = FF
      when "000011110111010" =>  data <= "11111111";  -- 7BA = FF
      when "000011110111011" =>  data <= "11111111";  -- 7BB = FF
      when "000011110111100" =>  data <= "11111111";  -- 7BC = FF
      when "000011110111101" =>  data <= "11111111";  -- 7BD = FF
      when "000011110111110" =>  data <= "11111111";  -- 7BE = FF
      when "000011110111111" =>  data <= "11111111";  -- 7BF = FF
      when "000011111000000" =>  data <= "11111111";  -- 7C0 = FF
      when "000011111000001" =>  data <= "11111111";  -- 7C1 = FF
      when "000011111000010" =>  data <= "11111111";  -- 7C2 = FF
      when "000011111000011" =>  data <= "11111111";  -- 7C3 = FF
      when "000011111000100" =>  data <= "11111111";  -- 7C4 = FF
      when "000011111000101" =>  data <= "11111111";  -- 7C5 = FF
      when "000011111000110" =>  data <= "11111111";  -- 7C6 = FF
      when "000011111000111" =>  data <= "11111111";  -- 7C7 = FF
      when "000011111001000" =>  data <= "11111111";  -- 7C8 = FF
      when "000011111001001" =>  data <= "11111111";  -- 7C9 = FF
      when "000011111001010" =>  data <= "11111111";  -- 7CA = FF
      when "000011111001011" =>  data <= "11111111";  -- 7CB = FF
      when "000011111001100" =>  data <= "11111111";  -- 7CC = FF
      when "000011111001101" =>  data <= "11111111";  -- 7CD = FF
      when "000011111001110" =>  data <= "11111111";  -- 7CE = FF
      when "000011111001111" =>  data <= "11111111";  -- 7CF = FF
      when "000011111010000" =>  data <= "11111111";  -- 7D0 = FF
      when "000011111010001" =>  data <= "11111111";  -- 7D1 = FF
      when "000011111010010" =>  data <= "11111111";  -- 7D2 = FF
      when "000011111010011" =>  data <= "11111111";  -- 7D3 = FF
      when "000011111010100" =>  data <= "11111111";  -- 7D4 = FF
      when "000011111010101" =>  data <= "11111111";  -- 7D5 = FF
      when "000011111010110" =>  data <= "11111111";  -- 7D6 = FF
      when "000011111010111" =>  data <= "11111111";  -- 7D7 = FF
      when "000011111011000" =>  data <= "11111111";  -- 7D8 = FF
      when "000011111011001" =>  data <= "11111111";  -- 7D9 = FF
      when "000011111011010" =>  data <= "11111111";  -- 7DA = FF
      when "000011111011011" =>  data <= "11111111";  -- 7DB = FF
      when "000011111011100" =>  data <= "11111111";  -- 7DC = FF
      when "000011111011101" =>  data <= "11111111";  -- 7DD = FF
      when "000011111011110" =>  data <= "11111111";  -- 7DE = FF
      when "000011111011111" =>  data <= "11111111";  -- 7DF = FF
      when "000011111100000" =>  data <= "11111111";  -- 7E0 = FF
      when "000011111100001" =>  data <= "11111111";  -- 7E1 = FF
      when "000011111100010" =>  data <= "11111111";  -- 7E2 = FF
      when "000011111100011" =>  data <= "11111111";  -- 7E3 = FF
      when "000011111100100" =>  data <= "11111111";  -- 7E4 = FF
      when "000011111100101" =>  data <= "11111111";  -- 7E5 = FF
      when "000011111100110" =>  data <= "11111111";  -- 7E6 = FF
      when "000011111100111" =>  data <= "11111111";  -- 7E7 = FF
      when "000011111101000" =>  data <= "11111111";  -- 7E8 = FF
      when "000011111101001" =>  data <= "11111111";  -- 7E9 = FF
      when "000011111101010" =>  data <= "11111111";  -- 7EA = FF
      when "000011111101011" =>  data <= "11111111";  -- 7EB = FF
      when "000011111101100" =>  data <= "11111111";  -- 7EC = FF
      when "000011111101101" =>  data <= "11111111";  -- 7ED = FF
      when "000011111101110" =>  data <= "11111111";  -- 7EE = FF
      when "000011111101111" =>  data <= "11111111";  -- 7EF = FF
      when "000011111110000" =>  data <= "11111111";  -- 7F0 = FF
      when "000011111110001" =>  data <= "11111111";  -- 7F1 = FF
      when "000011111110010" =>  data <= "11111111";  -- 7F2 = FF
      when "000011111110011" =>  data <= "11111111";  -- 7F3 = FF
      when "000011111110100" =>  data <= "11111111";  -- 7F4 = FF
      when "000011111110101" =>  data <= "11111111";  -- 7F5 = FF
      when "000011111110110" =>  data <= "11111111";  -- 7F6 = FF
      when "000011111110111" =>  data <= "11111111";  -- 7F7 = FF
      when "000011111111000" =>  data <= "11111111";  -- 7F8 = FF
      when "000011111111001" =>  data <= "11111111";  -- 7F9 = FF
      when "000011111111010" =>  data <= "11111111";  -- 7FA = FF
      when "000011111111011" =>  data <= "11111111";  -- 7FB = FF
      when "000011111111100" =>  data <= "11111111";  -- 7FC = FF
      when "000011111111101" =>  data <= "11111111";  -- 7FD = FF
      when "000011111111110" =>  data <= "11111111";  -- 7FE = FF
      when "000011111111111" =>  data <= "11111111";  -- 7FF = FF
      when "000100000000000" =>  data <= "11111111";  -- 800 = FF
      when "000100000000001" =>  data <= "11111111";  -- 801 = FF
      when "000100000000010" =>  data <= "11111111";  -- 802 = FF
      when "000100000000011" =>  data <= "11111111";  -- 803 = FF
      when "000100000000100" =>  data <= "11111111";  -- 804 = FF
      when "000100000000101" =>  data <= "11111111";  -- 805 = FF
      when "000100000000110" =>  data <= "11111111";  -- 806 = FF
      when "000100000000111" =>  data <= "11111111";  -- 807 = FF
      when "000100000001000" =>  data <= "11111111";  -- 808 = FF
      when "000100000001001" =>  data <= "11111111";  -- 809 = FF
      when "000100000001010" =>  data <= "11111111";  -- 80A = FF
      when "000100000001011" =>  data <= "11111111";  -- 80B = FF
      when "000100000001100" =>  data <= "11111111";  -- 80C = FF
      when "000100000001101" =>  data <= "11111111";  -- 80D = FF
      when "000100000001110" =>  data <= "11111111";  -- 80E = FF
      when "000100000001111" =>  data <= "11111111";  -- 80F = FF
      when "000100000010000" =>  data <= "11111111";  -- 810 = FF
      when "000100000010001" =>  data <= "11111111";  -- 811 = FF
      when "000100000010010" =>  data <= "11111111";  -- 812 = FF
      when "000100000010011" =>  data <= "11111111";  -- 813 = FF
      when "000100000010100" =>  data <= "11111111";  -- 814 = FF
      when "000100000010101" =>  data <= "11111111";  -- 815 = FF
      when "000100000010110" =>  data <= "11111111";  -- 816 = FF
      when "000100000010111" =>  data <= "11111111";  -- 817 = FF
      when "000100000011000" =>  data <= "11111111";  -- 818 = FF
      when "000100000011001" =>  data <= "11111111";  -- 819 = FF
      when "000100000011010" =>  data <= "11111111";  -- 81A = FF
      when "000100000011011" =>  data <= "11111111";  -- 81B = FF
      when "000100000011100" =>  data <= "11111111";  -- 81C = FF
      when "000100000011101" =>  data <= "11111111";  -- 81D = FF
      when "000100000011110" =>  data <= "11111111";  -- 81E = FF
      when "000100000011111" =>  data <= "11111111";  -- 81F = FF
      when "000100000100000" =>  data <= "11111111";  -- 820 = FF
      when "000100000100001" =>  data <= "11111111";  -- 821 = FF
      when "000100000100010" =>  data <= "11111111";  -- 822 = FF
      when "000100000100011" =>  data <= "11111111";  -- 823 = FF
      when "000100000100100" =>  data <= "11111111";  -- 824 = FF
      when "000100000100101" =>  data <= "11111111";  -- 825 = FF
      when "000100000100110" =>  data <= "11111111";  -- 826 = FF
      when "000100000100111" =>  data <= "11111111";  -- 827 = FF
      when "000100000101000" =>  data <= "11111111";  -- 828 = FF
      when "000100000101001" =>  data <= "11111111";  -- 829 = FF
      when "000100000101010" =>  data <= "11111111";  -- 82A = FF
      when "000100000101011" =>  data <= "11111111";  -- 82B = FF
      when "000100000101100" =>  data <= "11111111";  -- 82C = FF
      when "000100000101101" =>  data <= "11111111";  -- 82D = FF
      when "000100000101110" =>  data <= "11111111";  -- 82E = FF
      when "000100000101111" =>  data <= "11111111";  -- 82F = FF
      when "000100000110000" =>  data <= "11111111";  -- 830 = FF
      when "000100000110001" =>  data <= "11111111";  -- 831 = FF
      when "000100000110010" =>  data <= "11111111";  -- 832 = FF
      when "000100000110011" =>  data <= "11111111";  -- 833 = FF
      when "000100000110100" =>  data <= "11111111";  -- 834 = FF
      when "000100000110101" =>  data <= "11111111";  -- 835 = FF
      when "000100000110110" =>  data <= "11111111";  -- 836 = FF
      when "000100000110111" =>  data <= "11111111";  -- 837 = FF
      when "000100000111000" =>  data <= "11111111";  -- 838 = FF
      when "000100000111001" =>  data <= "11111111";  -- 839 = FF
      when "000100000111010" =>  data <= "11111111";  -- 83A = FF
      when "000100000111011" =>  data <= "11111111";  -- 83B = FF
      when "000100000111100" =>  data <= "11111111";  -- 83C = FF
      when "000100000111101" =>  data <= "11111111";  -- 83D = FF
      when "000100000111110" =>  data <= "11111111";  -- 83E = FF
      when "000100000111111" =>  data <= "11111111";  -- 83F = FF
      when "000100001000000" =>  data <= "11111111";  -- 840 = FF
      when "000100001000001" =>  data <= "11111111";  -- 841 = FF
      when "000100001000010" =>  data <= "11111111";  -- 842 = FF
      when "000100001000011" =>  data <= "11111111";  -- 843 = FF
      when "000100001000100" =>  data <= "11111111";  -- 844 = FF
      when "000100001000101" =>  data <= "11111111";  -- 845 = FF
      when "000100001000110" =>  data <= "11111111";  -- 846 = FF
      when "000100001000111" =>  data <= "11111111";  -- 847 = FF
      when "000100001001000" =>  data <= "11111111";  -- 848 = FF
      when "000100001001001" =>  data <= "11111111";  -- 849 = FF
      when "000100001001010" =>  data <= "11111111";  -- 84A = FF
      when "000100001001011" =>  data <= "11111111";  -- 84B = FF
      when "000100001001100" =>  data <= "11111111";  -- 84C = FF
      when "000100001001101" =>  data <= "11111111";  -- 84D = FF
      when "000100001001110" =>  data <= "11111111";  -- 84E = FF
      when "000100001001111" =>  data <= "11111111";  -- 84F = FF
      when "000100001010000" =>  data <= "11111111";  -- 850 = FF
      when "000100001010001" =>  data <= "11111111";  -- 851 = FF
      when "000100001010010" =>  data <= "11111111";  -- 852 = FF
      when "000100001010011" =>  data <= "11111111";  -- 853 = FF
      when "000100001010100" =>  data <= "11111111";  -- 854 = FF
      when "000100001010101" =>  data <= "11111111";  -- 855 = FF
      when "000100001010110" =>  data <= "11111111";  -- 856 = FF
      when "000100001010111" =>  data <= "11111111";  -- 857 = FF
      when "000100001011000" =>  data <= "11111111";  -- 858 = FF
      when "000100001011001" =>  data <= "11111111";  -- 859 = FF
      when "000100001011010" =>  data <= "11111111";  -- 85A = FF
      when "000100001011011" =>  data <= "11111111";  -- 85B = FF
      when "000100001011100" =>  data <= "11111111";  -- 85C = FF
      when "000100001011101" =>  data <= "11111111";  -- 85D = FF
      when "000100001011110" =>  data <= "11111111";  -- 85E = FF
      when "000100001011111" =>  data <= "11111111";  -- 85F = FF
      when "000100001100000" =>  data <= "11111111";  -- 860 = FF
      when "000100001100001" =>  data <= "11111111";  -- 861 = FF
      when "000100001100010" =>  data <= "11111111";  -- 862 = FF
      when "000100001100011" =>  data <= "11111111";  -- 863 = FF
      when "000100001100100" =>  data <= "11111111";  -- 864 = FF
      when "000100001100101" =>  data <= "11111111";  -- 865 = FF
      when "000100001100110" =>  data <= "11111111";  -- 866 = FF
      when "000100001100111" =>  data <= "11111111";  -- 867 = FF
      when "000100001101000" =>  data <= "11111111";  -- 868 = FF
      when "000100001101001" =>  data <= "11111111";  -- 869 = FF
      when "000100001101010" =>  data <= "11111111";  -- 86A = FF
      when "000100001101011" =>  data <= "11111111";  -- 86B = FF
      when "000100001101100" =>  data <= "11111111";  -- 86C = FF
      when "000100001101101" =>  data <= "11111111";  -- 86D = FF
      when "000100001101110" =>  data <= "11111111";  -- 86E = FF
      when "000100001101111" =>  data <= "11111111";  -- 86F = FF
      when "000100001110000" =>  data <= "11111111";  -- 870 = FF
      when "000100001110001" =>  data <= "11111111";  -- 871 = FF
      when "000100001110010" =>  data <= "11111111";  -- 872 = FF
      when "000100001110011" =>  data <= "11111111";  -- 873 = FF
      when "000100001110100" =>  data <= "11111111";  -- 874 = FF
      when "000100001110101" =>  data <= "11111111";  -- 875 = FF
      when "000100001110110" =>  data <= "11111111";  -- 876 = FF
      when "000100001110111" =>  data <= "11111111";  -- 877 = FF
      when "000100001111000" =>  data <= "11111111";  -- 878 = FF
      when "000100001111001" =>  data <= "11111111";  -- 879 = FF
      when "000100001111010" =>  data <= "11111111";  -- 87A = FF
      when "000100001111011" =>  data <= "11111111";  -- 87B = FF
      when "000100001111100" =>  data <= "11111111";  -- 87C = FF
      when "000100001111101" =>  data <= "11111111";  -- 87D = FF
      when "000100001111110" =>  data <= "11111111";  -- 87E = FF
      when "000100001111111" =>  data <= "11111111";  -- 87F = FF
      when "000100010000000" =>  data <= "11111111";  -- 880 = FF
      when "000100010000001" =>  data <= "11111111";  -- 881 = FF
      when "000100010000010" =>  data <= "11111111";  -- 882 = FF
      when "000100010000011" =>  data <= "11111111";  -- 883 = FF
      when "000100010000100" =>  data <= "11111111";  -- 884 = FF
      when "000100010000101" =>  data <= "11111111";  -- 885 = FF
      when "000100010000110" =>  data <= "11111111";  -- 886 = FF
      when "000100010000111" =>  data <= "11111111";  -- 887 = FF
      when "000100010001000" =>  data <= "11111111";  -- 888 = FF
      when "000100010001001" =>  data <= "11111111";  -- 889 = FF
      when "000100010001010" =>  data <= "11111111";  -- 88A = FF
      when "000100010001011" =>  data <= "11111111";  -- 88B = FF
      when "000100010001100" =>  data <= "11111111";  -- 88C = FF
      when "000100010001101" =>  data <= "11111111";  -- 88D = FF
      when "000100010001110" =>  data <= "11111111";  -- 88E = FF
      when "000100010001111" =>  data <= "11111111";  -- 88F = FF
      when "000100010010000" =>  data <= "11111111";  -- 890 = FF
      when "000100010010001" =>  data <= "11111111";  -- 891 = FF
      when "000100010010010" =>  data <= "11111111";  -- 892 = FF
      when "000100010010011" =>  data <= "11111111";  -- 893 = FF
      when "000100010010100" =>  data <= "11111111";  -- 894 = FF
      when "000100010010101" =>  data <= "11111111";  -- 895 = FF
      when "000100010010110" =>  data <= "11111111";  -- 896 = FF
      when "000100010010111" =>  data <= "11111111";  -- 897 = FF
      when "000100010011000" =>  data <= "11111111";  -- 898 = FF
      when "000100010011001" =>  data <= "11111111";  -- 899 = FF
      when "000100010011010" =>  data <= "11111111";  -- 89A = FF
      when "000100010011011" =>  data <= "11111111";  -- 89B = FF
      when "000100010011100" =>  data <= "11111111";  -- 89C = FF
      when "000100010011101" =>  data <= "11111111";  -- 89D = FF
      when "000100010011110" =>  data <= "11111111";  -- 89E = FF
      when "000100010011111" =>  data <= "11111111";  -- 89F = FF
      when "000100010100000" =>  data <= "11111111";  -- 8A0 = FF
      when "000100010100001" =>  data <= "11111111";  -- 8A1 = FF
      when "000100010100010" =>  data <= "11111111";  -- 8A2 = FF
      when "000100010100011" =>  data <= "11111111";  -- 8A3 = FF
      when "000100010100100" =>  data <= "11111111";  -- 8A4 = FF
      when "000100010100101" =>  data <= "11111111";  -- 8A5 = FF
      when "000100010100110" =>  data <= "11111111";  -- 8A6 = FF
      when "000100010100111" =>  data <= "11111111";  -- 8A7 = FF
      when "000100010101000" =>  data <= "11111111";  -- 8A8 = FF
      when "000100010101001" =>  data <= "11111111";  -- 8A9 = FF
      when "000100010101010" =>  data <= "11111111";  -- 8AA = FF
      when "000100010101011" =>  data <= "11111111";  -- 8AB = FF
      when "000100010101100" =>  data <= "11111111";  -- 8AC = FF
      when "000100010101101" =>  data <= "11111111";  -- 8AD = FF
      when "000100010101110" =>  data <= "11111111";  -- 8AE = FF
      when "000100010101111" =>  data <= "11111111";  -- 8AF = FF
      when "000100010110000" =>  data <= "11111111";  -- 8B0 = FF
      when "000100010110001" =>  data <= "11111111";  -- 8B1 = FF
      when "000100010110010" =>  data <= "11111111";  -- 8B2 = FF
      when "000100010110011" =>  data <= "11111111";  -- 8B3 = FF
      when "000100010110100" =>  data <= "11111111";  -- 8B4 = FF
      when "000100010110101" =>  data <= "11111111";  -- 8B5 = FF
      when "000100010110110" =>  data <= "11111111";  -- 8B6 = FF
      when "000100010110111" =>  data <= "11111111";  -- 8B7 = FF
      when "000100010111000" =>  data <= "11111111";  -- 8B8 = FF
      when "000100010111001" =>  data <= "11111111";  -- 8B9 = FF
      when "000100010111010" =>  data <= "11111111";  -- 8BA = FF
      when "000100010111011" =>  data <= "11111111";  -- 8BB = FF
      when "000100010111100" =>  data <= "11111111";  -- 8BC = FF
      when "000100010111101" =>  data <= "11111111";  -- 8BD = FF
      when "000100010111110" =>  data <= "11111111";  -- 8BE = FF
      when "000100010111111" =>  data <= "11111111";  -- 8BF = FF
      when "000100011000000" =>  data <= "11111111";  -- 8C0 = FF
      when "000100011000001" =>  data <= "11111111";  -- 8C1 = FF
      when "000100011000010" =>  data <= "11111111";  -- 8C2 = FF
      when "000100011000011" =>  data <= "11111111";  -- 8C3 = FF
      when "000100011000100" =>  data <= "11111111";  -- 8C4 = FF
      when "000100011000101" =>  data <= "11111111";  -- 8C5 = FF
      when "000100011000110" =>  data <= "11111111";  -- 8C6 = FF
      when "000100011000111" =>  data <= "11111111";  -- 8C7 = FF
      when "000100011001000" =>  data <= "11111111";  -- 8C8 = FF
      when "000100011001001" =>  data <= "11111111";  -- 8C9 = FF
      when "000100011001010" =>  data <= "11111111";  -- 8CA = FF
      when "000100011001011" =>  data <= "11111111";  -- 8CB = FF
      when "000100011001100" =>  data <= "11111111";  -- 8CC = FF
      when "000100011001101" =>  data <= "11111111";  -- 8CD = FF
      when "000100011001110" =>  data <= "11111111";  -- 8CE = FF
      when "000100011001111" =>  data <= "11111111";  -- 8CF = FF
      when "000100011010000" =>  data <= "11111111";  -- 8D0 = FF
      when "000100011010001" =>  data <= "11111111";  -- 8D1 = FF
      when "000100011010010" =>  data <= "11111111";  -- 8D2 = FF
      when "000100011010011" =>  data <= "11111111";  -- 8D3 = FF
      when "000100011010100" =>  data <= "11111111";  -- 8D4 = FF
      when "000100011010101" =>  data <= "11111111";  -- 8D5 = FF
      when "000100011010110" =>  data <= "11111111";  -- 8D6 = FF
      when "000100011010111" =>  data <= "11111111";  -- 8D7 = FF
      when "000100011011000" =>  data <= "11111111";  -- 8D8 = FF
      when "000100011011001" =>  data <= "11111111";  -- 8D9 = FF
      when "000100011011010" =>  data <= "11111111";  -- 8DA = FF
      when "000100011011011" =>  data <= "11111111";  -- 8DB = FF
      when "000100011011100" =>  data <= "11111111";  -- 8DC = FF
      when "000100011011101" =>  data <= "11111111";  -- 8DD = FF
      when "000100011011110" =>  data <= "11111111";  -- 8DE = FF
      when "000100011011111" =>  data <= "11111111";  -- 8DF = FF
      when "000100011100000" =>  data <= "11111111";  -- 8E0 = FF
      when "000100011100001" =>  data <= "11111111";  -- 8E1 = FF
      when "000100011100010" =>  data <= "11111111";  -- 8E2 = FF
      when "000100011100011" =>  data <= "11111111";  -- 8E3 = FF
      when "000100011100100" =>  data <= "11111111";  -- 8E4 = FF
      when "000100011100101" =>  data <= "11111111";  -- 8E5 = FF
      when "000100011100110" =>  data <= "11111111";  -- 8E6 = FF
      when "000100011100111" =>  data <= "11111111";  -- 8E7 = FF
      when "000100011101000" =>  data <= "11111111";  -- 8E8 = FF
      when "000100011101001" =>  data <= "11111111";  -- 8E9 = FF
      when "000100011101010" =>  data <= "11111111";  -- 8EA = FF
      when "000100011101011" =>  data <= "11111111";  -- 8EB = FF
      when "000100011101100" =>  data <= "11111111";  -- 8EC = FF
      when "000100011101101" =>  data <= "11111111";  -- 8ED = FF
      when "000100011101110" =>  data <= "11111111";  -- 8EE = FF
      when "000100011101111" =>  data <= "11111111";  -- 8EF = FF
      when "000100011110000" =>  data <= "11111111";  -- 8F0 = FF
      when "000100011110001" =>  data <= "11111111";  -- 8F1 = FF
      when "000100011110010" =>  data <= "11111111";  -- 8F2 = FF
      when "000100011110011" =>  data <= "11111111";  -- 8F3 = FF
      when "000100011110100" =>  data <= "11111111";  -- 8F4 = FF
      when "000100011110101" =>  data <= "11111111";  -- 8F5 = FF
      when "000100011110110" =>  data <= "11111111";  -- 8F6 = FF
      when "000100011110111" =>  data <= "11111111";  -- 8F7 = FF
      when "000100011111000" =>  data <= "11111111";  -- 8F8 = FF
      when "000100011111001" =>  data <= "11111111";  -- 8F9 = FF
      when "000100011111010" =>  data <= "11111111";  -- 8FA = FF
      when "000100011111011" =>  data <= "11111111";  -- 8FB = FF
      when "000100011111100" =>  data <= "11111111";  -- 8FC = FF
      when "000100011111101" =>  data <= "11111111";  -- 8FD = FF
      when "000100011111110" =>  data <= "11111111";  -- 8FE = FF
      when "000100011111111" =>  data <= "11111111";  -- 8FF = FF
      when "000100100000000" =>  data <= "11111111";  -- 900 = FF
      when "000100100000001" =>  data <= "11111111";  -- 901 = FF
      when "000100100000010" =>  data <= "11111111";  -- 902 = FF
      when "000100100000011" =>  data <= "11111111";  -- 903 = FF
      when "000100100000100" =>  data <= "11111111";  -- 904 = FF
      when "000100100000101" =>  data <= "11111111";  -- 905 = FF
      when "000100100000110" =>  data <= "11111111";  -- 906 = FF
      when "000100100000111" =>  data <= "11111111";  -- 907 = FF
      when "000100100001000" =>  data <= "11111111";  -- 908 = FF
      when "000100100001001" =>  data <= "11111111";  -- 909 = FF
      when "000100100001010" =>  data <= "11111111";  -- 90A = FF
      when "000100100001011" =>  data <= "11111111";  -- 90B = FF
      when "000100100001100" =>  data <= "11111111";  -- 90C = FF
      when "000100100001101" =>  data <= "11111111";  -- 90D = FF
      when "000100100001110" =>  data <= "11111111";  -- 90E = FF
      when "000100100001111" =>  data <= "11111111";  -- 90F = FF
      when "000100100010000" =>  data <= "11111111";  -- 910 = FF
      when "000100100010001" =>  data <= "11111111";  -- 911 = FF
      when "000100100010010" =>  data <= "11111111";  -- 912 = FF
      when "000100100010011" =>  data <= "11111111";  -- 913 = FF
      when "000100100010100" =>  data <= "11111111";  -- 914 = FF
      when "000100100010101" =>  data <= "11111111";  -- 915 = FF
      when "000100100010110" =>  data <= "11111111";  -- 916 = FF
      when "000100100010111" =>  data <= "11111111";  -- 917 = FF
      when "000100100011000" =>  data <= "11111111";  -- 918 = FF
      when "000100100011001" =>  data <= "11111111";  -- 919 = FF
      when "000100100011010" =>  data <= "11111111";  -- 91A = FF
      when "000100100011011" =>  data <= "11111111";  -- 91B = FF
      when "000100100011100" =>  data <= "11111111";  -- 91C = FF
      when "000100100011101" =>  data <= "11111111";  -- 91D = FF
      when "000100100011110" =>  data <= "11111111";  -- 91E = FF
      when "000100100011111" =>  data <= "11111111";  -- 91F = FF
      when "000100100100000" =>  data <= "11111111";  -- 920 = FF
      when "000100100100001" =>  data <= "11111111";  -- 921 = FF
      when "000100100100010" =>  data <= "11111111";  -- 922 = FF
      when "000100100100011" =>  data <= "11111111";  -- 923 = FF
      when "000100100100100" =>  data <= "11111111";  -- 924 = FF
      when "000100100100101" =>  data <= "11111111";  -- 925 = FF
      when "000100100100110" =>  data <= "11111111";  -- 926 = FF
      when "000100100100111" =>  data <= "11111111";  -- 927 = FF
      when "000100100101000" =>  data <= "11111111";  -- 928 = FF
      when "000100100101001" =>  data <= "11111111";  -- 929 = FF
      when "000100100101010" =>  data <= "11111111";  -- 92A = FF
      when "000100100101011" =>  data <= "11111111";  -- 92B = FF
      when "000100100101100" =>  data <= "11111111";  -- 92C = FF
      when "000100100101101" =>  data <= "11111111";  -- 92D = FF
      when "000100100101110" =>  data <= "11111111";  -- 92E = FF
      when "000100100101111" =>  data <= "11111111";  -- 92F = FF
      when "000100100110000" =>  data <= "11111111";  -- 930 = FF
      when "000100100110001" =>  data <= "11111111";  -- 931 = FF
      when "000100100110010" =>  data <= "11111111";  -- 932 = FF
      when "000100100110011" =>  data <= "11111111";  -- 933 = FF
      when "000100100110100" =>  data <= "11111111";  -- 934 = FF
      when "000100100110101" =>  data <= "11111111";  -- 935 = FF
      when "000100100110110" =>  data <= "11111111";  -- 936 = FF
      when "000100100110111" =>  data <= "11111111";  -- 937 = FF
      when "000100100111000" =>  data <= "11111111";  -- 938 = FF
      when "000100100111001" =>  data <= "11111111";  -- 939 = FF
      when "000100100111010" =>  data <= "11111111";  -- 93A = FF
      when "000100100111011" =>  data <= "11111111";  -- 93B = FF
      when "000100100111100" =>  data <= "11111111";  -- 93C = FF
      when "000100100111101" =>  data <= "11111111";  -- 93D = FF
      when "000100100111110" =>  data <= "11111111";  -- 93E = FF
      when "000100100111111" =>  data <= "11111111";  -- 93F = FF
      when "000100101000000" =>  data <= "11111111";  -- 940 = FF
      when "000100101000001" =>  data <= "11111111";  -- 941 = FF
      when "000100101000010" =>  data <= "11111111";  -- 942 = FF
      when "000100101000011" =>  data <= "11111111";  -- 943 = FF
      when "000100101000100" =>  data <= "11111111";  -- 944 = FF
      when "000100101000101" =>  data <= "11111111";  -- 945 = FF
      when "000100101000110" =>  data <= "11111111";  -- 946 = FF
      when "000100101000111" =>  data <= "11111111";  -- 947 = FF
      when "000100101001000" =>  data <= "11111111";  -- 948 = FF
      when "000100101001001" =>  data <= "11111111";  -- 949 = FF
      when "000100101001010" =>  data <= "11111111";  -- 94A = FF
      when "000100101001011" =>  data <= "11111111";  -- 94B = FF
      when "000100101001100" =>  data <= "11111111";  -- 94C = FF
      when "000100101001101" =>  data <= "11111111";  -- 94D = FF
      when "000100101001110" =>  data <= "11111111";  -- 94E = FF
      when "000100101001111" =>  data <= "11111111";  -- 94F = FF
      when "000100101010000" =>  data <= "11111111";  -- 950 = FF
      when "000100101010001" =>  data <= "11111111";  -- 951 = FF
      when "000100101010010" =>  data <= "11111111";  -- 952 = FF
      when "000100101010011" =>  data <= "11111111";  -- 953 = FF
      when "000100101010100" =>  data <= "11111111";  -- 954 = FF
      when "000100101010101" =>  data <= "11111111";  -- 955 = FF
      when "000100101010110" =>  data <= "11111111";  -- 956 = FF
      when "000100101010111" =>  data <= "11111111";  -- 957 = FF
      when "000100101011000" =>  data <= "11111111";  -- 958 = FF
      when "000100101011001" =>  data <= "11111111";  -- 959 = FF
      when "000100101011010" =>  data <= "11111111";  -- 95A = FF
      when "000100101011011" =>  data <= "11111111";  -- 95B = FF
      when "000100101011100" =>  data <= "11111111";  -- 95C = FF
      when "000100101011101" =>  data <= "11111111";  -- 95D = FF
      when "000100101011110" =>  data <= "11111111";  -- 95E = FF
      when "000100101011111" =>  data <= "11111111";  -- 95F = FF
      when "000100101100000" =>  data <= "11111111";  -- 960 = FF
      when "000100101100001" =>  data <= "11111111";  -- 961 = FF
      when "000100101100010" =>  data <= "11111111";  -- 962 = FF
      when "000100101100011" =>  data <= "11111111";  -- 963 = FF
      when "000100101100100" =>  data <= "11111111";  -- 964 = FF
      when "000100101100101" =>  data <= "11111111";  -- 965 = FF
      when "000100101100110" =>  data <= "11111111";  -- 966 = FF
      when "000100101100111" =>  data <= "11111111";  -- 967 = FF
      when "000100101101000" =>  data <= "11111111";  -- 968 = FF
      when "000100101101001" =>  data <= "11111111";  -- 969 = FF
      when "000100101101010" =>  data <= "11111111";  -- 96A = FF
      when "000100101101011" =>  data <= "11111111";  -- 96B = FF
      when "000100101101100" =>  data <= "11111111";  -- 96C = FF
      when "000100101101101" =>  data <= "11111111";  -- 96D = FF
      when "000100101101110" =>  data <= "11111111";  -- 96E = FF
      when "000100101101111" =>  data <= "11111111";  -- 96F = FF
      when "000100101110000" =>  data <= "11111111";  -- 970 = FF
      when "000100101110001" =>  data <= "11111111";  -- 971 = FF
      when "000100101110010" =>  data <= "11111111";  -- 972 = FF
      when "000100101110011" =>  data <= "11111111";  -- 973 = FF
      when "000100101110100" =>  data <= "11111111";  -- 974 = FF
      when "000100101110101" =>  data <= "11111111";  -- 975 = FF
      when "000100101110110" =>  data <= "11111111";  -- 976 = FF
      when "000100101110111" =>  data <= "11111111";  -- 977 = FF
      when "000100101111000" =>  data <= "11111111";  -- 978 = FF
      when "000100101111001" =>  data <= "11111111";  -- 979 = FF
      when "000100101111010" =>  data <= "11111111";  -- 97A = FF
      when "000100101111011" =>  data <= "11111111";  -- 97B = FF
      when "000100101111100" =>  data <= "11111111";  -- 97C = FF
      when "000100101111101" =>  data <= "11111111";  -- 97D = FF
      when "000100101111110" =>  data <= "11111111";  -- 97E = FF
      when "000100101111111" =>  data <= "11111111";  -- 97F = FF
      when "000100110000000" =>  data <= "11111111";  -- 980 = FF
      when "000100110000001" =>  data <= "11111111";  -- 981 = FF
      when "000100110000010" =>  data <= "11111111";  -- 982 = FF
      when "000100110000011" =>  data <= "11111111";  -- 983 = FF
      when "000100110000100" =>  data <= "11111111";  -- 984 = FF
      when "000100110000101" =>  data <= "11111111";  -- 985 = FF
      when "000100110000110" =>  data <= "11111111";  -- 986 = FF
      when "000100110000111" =>  data <= "11111111";  -- 987 = FF
      when "000100110001000" =>  data <= "11111111";  -- 988 = FF
      when "000100110001001" =>  data <= "11111111";  -- 989 = FF
      when "000100110001010" =>  data <= "11111111";  -- 98A = FF
      when "000100110001011" =>  data <= "11111111";  -- 98B = FF
      when "000100110001100" =>  data <= "11111111";  -- 98C = FF
      when "000100110001101" =>  data <= "11111111";  -- 98D = FF
      when "000100110001110" =>  data <= "11111111";  -- 98E = FF
      when "000100110001111" =>  data <= "11111111";  -- 98F = FF
      when "000100110010000" =>  data <= "11111111";  -- 990 = FF
      when "000100110010001" =>  data <= "11111111";  -- 991 = FF
      when "000100110010010" =>  data <= "11111111";  -- 992 = FF
      when "000100110010011" =>  data <= "11111111";  -- 993 = FF
      when "000100110010100" =>  data <= "11111111";  -- 994 = FF
      when "000100110010101" =>  data <= "11111111";  -- 995 = FF
      when "000100110010110" =>  data <= "11111111";  -- 996 = FF
      when "000100110010111" =>  data <= "11111111";  -- 997 = FF
      when "000100110011000" =>  data <= "11111111";  -- 998 = FF
      when "000100110011001" =>  data <= "11111111";  -- 999 = FF
      when "000100110011010" =>  data <= "11111111";  -- 99A = FF
      when "000100110011011" =>  data <= "11111111";  -- 99B = FF
      when "000100110011100" =>  data <= "11111111";  -- 99C = FF
      when "000100110011101" =>  data <= "11111111";  -- 99D = FF
      when "000100110011110" =>  data <= "11111111";  -- 99E = FF
      when "000100110011111" =>  data <= "11111111";  -- 99F = FF
      when "000100110100000" =>  data <= "11111111";  -- 9A0 = FF
      when "000100110100001" =>  data <= "11111111";  -- 9A1 = FF
      when "000100110100010" =>  data <= "11111111";  -- 9A2 = FF
      when "000100110100011" =>  data <= "11111111";  -- 9A3 = FF
      when "000100110100100" =>  data <= "11111111";  -- 9A4 = FF
      when "000100110100101" =>  data <= "11111111";  -- 9A5 = FF
      when "000100110100110" =>  data <= "11111111";  -- 9A6 = FF
      when "000100110100111" =>  data <= "11111111";  -- 9A7 = FF
      when "000100110101000" =>  data <= "11111111";  -- 9A8 = FF
      when "000100110101001" =>  data <= "11111111";  -- 9A9 = FF
      when "000100110101010" =>  data <= "11111111";  -- 9AA = FF
      when "000100110101011" =>  data <= "11111111";  -- 9AB = FF
      when "000100110101100" =>  data <= "11111111";  -- 9AC = FF
      when "000100110101101" =>  data <= "11111111";  -- 9AD = FF
      when "000100110101110" =>  data <= "11111111";  -- 9AE = FF
      when "000100110101111" =>  data <= "11111111";  -- 9AF = FF
      when "000100110110000" =>  data <= "11111111";  -- 9B0 = FF
      when "000100110110001" =>  data <= "11111111";  -- 9B1 = FF
      when "000100110110010" =>  data <= "11111111";  -- 9B2 = FF
      when "000100110110011" =>  data <= "11111111";  -- 9B3 = FF
      when "000100110110100" =>  data <= "11111111";  -- 9B4 = FF
      when "000100110110101" =>  data <= "11111111";  -- 9B5 = FF
      when "000100110110110" =>  data <= "11111111";  -- 9B6 = FF
      when "000100110110111" =>  data <= "11111111";  -- 9B7 = FF
      when "000100110111000" =>  data <= "11111111";  -- 9B8 = FF
      when "000100110111001" =>  data <= "11111111";  -- 9B9 = FF
      when "000100110111010" =>  data <= "11111111";  -- 9BA = FF
      when "000100110111011" =>  data <= "11111111";  -- 9BB = FF
      when "000100110111100" =>  data <= "11111111";  -- 9BC = FF
      when "000100110111101" =>  data <= "11111111";  -- 9BD = FF
      when "000100110111110" =>  data <= "11111111";  -- 9BE = FF
      when "000100110111111" =>  data <= "11111111";  -- 9BF = FF
      when "000100111000000" =>  data <= "11111111";  -- 9C0 = FF
      when "000100111000001" =>  data <= "11111111";  -- 9C1 = FF
      when "000100111000010" =>  data <= "11111111";  -- 9C2 = FF
      when "000100111000011" =>  data <= "11111111";  -- 9C3 = FF
      when "000100111000100" =>  data <= "11111111";  -- 9C4 = FF
      when "000100111000101" =>  data <= "11111111";  -- 9C5 = FF
      when "000100111000110" =>  data <= "11111111";  -- 9C6 = FF
      when "000100111000111" =>  data <= "11111111";  -- 9C7 = FF
      when "000100111001000" =>  data <= "11111111";  -- 9C8 = FF
      when "000100111001001" =>  data <= "11111111";  -- 9C9 = FF
      when "000100111001010" =>  data <= "11111111";  -- 9CA = FF
      when "000100111001011" =>  data <= "11111111";  -- 9CB = FF
      when "000100111001100" =>  data <= "11111111";  -- 9CC = FF
      when "000100111001101" =>  data <= "11111111";  -- 9CD = FF
      when "000100111001110" =>  data <= "11111111";  -- 9CE = FF
      when "000100111001111" =>  data <= "11111111";  -- 9CF = FF
      when "000100111010000" =>  data <= "11111111";  -- 9D0 = FF
      when "000100111010001" =>  data <= "11111111";  -- 9D1 = FF
      when "000100111010010" =>  data <= "11111111";  -- 9D2 = FF
      when "000100111010011" =>  data <= "11111111";  -- 9D3 = FF
      when "000100111010100" =>  data <= "11111111";  -- 9D4 = FF
      when "000100111010101" =>  data <= "11111111";  -- 9D5 = FF
      when "000100111010110" =>  data <= "11111111";  -- 9D6 = FF
      when "000100111010111" =>  data <= "11111111";  -- 9D7 = FF
      when "000100111011000" =>  data <= "11111111";  -- 9D8 = FF
      when "000100111011001" =>  data <= "11111111";  -- 9D9 = FF
      when "000100111011010" =>  data <= "11111111";  -- 9DA = FF
      when "000100111011011" =>  data <= "11111111";  -- 9DB = FF
      when "000100111011100" =>  data <= "11111111";  -- 9DC = FF
      when "000100111011101" =>  data <= "11111111";  -- 9DD = FF
      when "000100111011110" =>  data <= "11111111";  -- 9DE = FF
      when "000100111011111" =>  data <= "11111111";  -- 9DF = FF
      when "000100111100000" =>  data <= "11111111";  -- 9E0 = FF
      when "000100111100001" =>  data <= "11111111";  -- 9E1 = FF
      when "000100111100010" =>  data <= "11111111";  -- 9E2 = FF
      when "000100111100011" =>  data <= "11111111";  -- 9E3 = FF
      when "000100111100100" =>  data <= "11111111";  -- 9E4 = FF
      when "000100111100101" =>  data <= "11111111";  -- 9E5 = FF
      when "000100111100110" =>  data <= "11111111";  -- 9E6 = FF
      when "000100111100111" =>  data <= "11111111";  -- 9E7 = FF
      when "000100111101000" =>  data <= "11111111";  -- 9E8 = FF
      when "000100111101001" =>  data <= "11111111";  -- 9E9 = FF
      when "000100111101010" =>  data <= "11111111";  -- 9EA = FF
      when "000100111101011" =>  data <= "11111111";  -- 9EB = FF
      when "000100111101100" =>  data <= "11111111";  -- 9EC = FF
      when "000100111101101" =>  data <= "11111111";  -- 9ED = FF
      when "000100111101110" =>  data <= "11111111";  -- 9EE = FF
      when "000100111101111" =>  data <= "11111111";  -- 9EF = FF
      when "000100111110000" =>  data <= "11111111";  -- 9F0 = FF
      when "000100111110001" =>  data <= "11111111";  -- 9F1 = FF
      when "000100111110010" =>  data <= "11111111";  -- 9F2 = FF
      when "000100111110011" =>  data <= "11111111";  -- 9F3 = FF
      when "000100111110100" =>  data <= "11111111";  -- 9F4 = FF
      when "000100111110101" =>  data <= "11111111";  -- 9F5 = FF
      when "000100111110110" =>  data <= "11111111";  -- 9F6 = FF
      when "000100111110111" =>  data <= "11111111";  -- 9F7 = FF
      when "000100111111000" =>  data <= "11111111";  -- 9F8 = FF
      when "000100111111001" =>  data <= "11111111";  -- 9F9 = FF
      when "000100111111010" =>  data <= "11111111";  -- 9FA = FF
      when "000100111111011" =>  data <= "11111111";  -- 9FB = FF
      when "000100111111100" =>  data <= "11111111";  -- 9FC = FF
      when "000100111111101" =>  data <= "11111111";  -- 9FD = FF
      when "000100111111110" =>  data <= "11111111";  -- 9FE = FF
      when "000100111111111" =>  data <= "11111111";  -- 9FF = FF
      when "000101000000000" =>  data <= "11111111";  -- A00 = FF
      when "000101000000001" =>  data <= "11111111";  -- A01 = FF
      when "000101000000010" =>  data <= "11111111";  -- A02 = FF
      when "000101000000011" =>  data <= "11111111";  -- A03 = FF
      when "000101000000100" =>  data <= "11111111";  -- A04 = FF
      when "000101000000101" =>  data <= "11111111";  -- A05 = FF
      when "000101000000110" =>  data <= "11111111";  -- A06 = FF
      when "000101000000111" =>  data <= "11111111";  -- A07 = FF
      when "000101000001000" =>  data <= "11111111";  -- A08 = FF
      when "000101000001001" =>  data <= "11111111";  -- A09 = FF
      when "000101000001010" =>  data <= "11111111";  -- A0A = FF
      when "000101000001011" =>  data <= "11111111";  -- A0B = FF
      when "000101000001100" =>  data <= "11111111";  -- A0C = FF
      when "000101000001101" =>  data <= "11111111";  -- A0D = FF
      when "000101000001110" =>  data <= "11111111";  -- A0E = FF
      when "000101000001111" =>  data <= "11111111";  -- A0F = FF
      when "000101000010000" =>  data <= "11111111";  -- A10 = FF
      when "000101000010001" =>  data <= "11111111";  -- A11 = FF
      when "000101000010010" =>  data <= "11111111";  -- A12 = FF
      when "000101000010011" =>  data <= "11111111";  -- A13 = FF
      when "000101000010100" =>  data <= "11111111";  -- A14 = FF
      when "000101000010101" =>  data <= "11111111";  -- A15 = FF
      when "000101000010110" =>  data <= "11111111";  -- A16 = FF
      when "000101000010111" =>  data <= "11111111";  -- A17 = FF
      when "000101000011000" =>  data <= "11111111";  -- A18 = FF
      when "000101000011001" =>  data <= "11111111";  -- A19 = FF
      when "000101000011010" =>  data <= "11111111";  -- A1A = FF
      when "000101000011011" =>  data <= "11111111";  -- A1B = FF
      when "000101000011100" =>  data <= "11111111";  -- A1C = FF
      when "000101000011101" =>  data <= "11111111";  -- A1D = FF
      when "000101000011110" =>  data <= "11111111";  -- A1E = FF
      when "000101000011111" =>  data <= "11111111";  -- A1F = FF
      when "000101000100000" =>  data <= "11111111";  -- A20 = FF
      when "000101000100001" =>  data <= "11111111";  -- A21 = FF
      when "000101000100010" =>  data <= "11111111";  -- A22 = FF
      when "000101000100011" =>  data <= "11111111";  -- A23 = FF
      when "000101000100100" =>  data <= "11111111";  -- A24 = FF
      when "000101000100101" =>  data <= "11111111";  -- A25 = FF
      when "000101000100110" =>  data <= "11111111";  -- A26 = FF
      when "000101000100111" =>  data <= "11111111";  -- A27 = FF
      when "000101000101000" =>  data <= "11111111";  -- A28 = FF
      when "000101000101001" =>  data <= "11111111";  -- A29 = FF
      when "000101000101010" =>  data <= "11111111";  -- A2A = FF
      when "000101000101011" =>  data <= "11111111";  -- A2B = FF
      when "000101000101100" =>  data <= "11111111";  -- A2C = FF
      when "000101000101101" =>  data <= "11111111";  -- A2D = FF
      when "000101000101110" =>  data <= "11111111";  -- A2E = FF
      when "000101000101111" =>  data <= "11111111";  -- A2F = FF
      when "000101000110000" =>  data <= "11111111";  -- A30 = FF
      when "000101000110001" =>  data <= "11111111";  -- A31 = FF
      when "000101000110010" =>  data <= "11111111";  -- A32 = FF
      when "000101000110011" =>  data <= "11111111";  -- A33 = FF
      when "000101000110100" =>  data <= "11111111";  -- A34 = FF
      when "000101000110101" =>  data <= "11111111";  -- A35 = FF
      when "000101000110110" =>  data <= "11111111";  -- A36 = FF
      when "000101000110111" =>  data <= "11111111";  -- A37 = FF
      when "000101000111000" =>  data <= "11111111";  -- A38 = FF
      when "000101000111001" =>  data <= "11111111";  -- A39 = FF
      when "000101000111010" =>  data <= "11111111";  -- A3A = FF
      when "000101000111011" =>  data <= "11111111";  -- A3B = FF
      when "000101000111100" =>  data <= "11111111";  -- A3C = FF
      when "000101000111101" =>  data <= "11111111";  -- A3D = FF
      when "000101000111110" =>  data <= "11111111";  -- A3E = FF
      when "000101000111111" =>  data <= "11111111";  -- A3F = FF
      when "000101001000000" =>  data <= "11111111";  -- A40 = FF
      when "000101001000001" =>  data <= "11111111";  -- A41 = FF
      when "000101001000010" =>  data <= "11111111";  -- A42 = FF
      when "000101001000011" =>  data <= "11111111";  -- A43 = FF
      when "000101001000100" =>  data <= "11111111";  -- A44 = FF
      when "000101001000101" =>  data <= "11111111";  -- A45 = FF
      when "000101001000110" =>  data <= "11111111";  -- A46 = FF
      when "000101001000111" =>  data <= "11111111";  -- A47 = FF
      when "000101001001000" =>  data <= "11111111";  -- A48 = FF
      when "000101001001001" =>  data <= "11111111";  -- A49 = FF
      when "000101001001010" =>  data <= "11111111";  -- A4A = FF
      when "000101001001011" =>  data <= "11111111";  -- A4B = FF
      when "000101001001100" =>  data <= "11111111";  -- A4C = FF
      when "000101001001101" =>  data <= "11111111";  -- A4D = FF
      when "000101001001110" =>  data <= "11111111";  -- A4E = FF
      when "000101001001111" =>  data <= "11111111";  -- A4F = FF
      when "000101001010000" =>  data <= "11111111";  -- A50 = FF
      when "000101001010001" =>  data <= "11111111";  -- A51 = FF
      when "000101001010010" =>  data <= "11111111";  -- A52 = FF
      when "000101001010011" =>  data <= "11111111";  -- A53 = FF
      when "000101001010100" =>  data <= "11111111";  -- A54 = FF
      when "000101001010101" =>  data <= "11111111";  -- A55 = FF
      when "000101001010110" =>  data <= "11111111";  -- A56 = FF
      when "000101001010111" =>  data <= "11111111";  -- A57 = FF
      when "000101001011000" =>  data <= "11111111";  -- A58 = FF
      when "000101001011001" =>  data <= "11111111";  -- A59 = FF
      when "000101001011010" =>  data <= "11111111";  -- A5A = FF
      when "000101001011011" =>  data <= "11111111";  -- A5B = FF
      when "000101001011100" =>  data <= "11111111";  -- A5C = FF
      when "000101001011101" =>  data <= "11111111";  -- A5D = FF
      when "000101001011110" =>  data <= "11111111";  -- A5E = FF
      when "000101001011111" =>  data <= "11111111";  -- A5F = FF
      when "000101001100000" =>  data <= "11111111";  -- A60 = FF
      when "000101001100001" =>  data <= "11111111";  -- A61 = FF
      when "000101001100010" =>  data <= "11111111";  -- A62 = FF
      when "000101001100011" =>  data <= "11111111";  -- A63 = FF
      when "000101001100100" =>  data <= "11111111";  -- A64 = FF
      when "000101001100101" =>  data <= "11111111";  -- A65 = FF
      when "000101001100110" =>  data <= "11111111";  -- A66 = FF
      when "000101001100111" =>  data <= "11111111";  -- A67 = FF
      when "000101001101000" =>  data <= "11111111";  -- A68 = FF
      when "000101001101001" =>  data <= "11111111";  -- A69 = FF
      when "000101001101010" =>  data <= "11111111";  -- A6A = FF
      when "000101001101011" =>  data <= "11111111";  -- A6B = FF
      when "000101001101100" =>  data <= "11111111";  -- A6C = FF
      when "000101001101101" =>  data <= "11111111";  -- A6D = FF
      when "000101001101110" =>  data <= "11111111";  -- A6E = FF
      when "000101001101111" =>  data <= "11111111";  -- A6F = FF
      when "000101001110000" =>  data <= "11111111";  -- A70 = FF
      when "000101001110001" =>  data <= "11111111";  -- A71 = FF
      when "000101001110010" =>  data <= "11111111";  -- A72 = FF
      when "000101001110011" =>  data <= "11111111";  -- A73 = FF
      when "000101001110100" =>  data <= "11111111";  -- A74 = FF
      when "000101001110101" =>  data <= "11111111";  -- A75 = FF
      when "000101001110110" =>  data <= "11111111";  -- A76 = FF
      when "000101001110111" =>  data <= "11111111";  -- A77 = FF
      when "000101001111000" =>  data <= "11111111";  -- A78 = FF
      when "000101001111001" =>  data <= "11111111";  -- A79 = FF
      when "000101001111010" =>  data <= "11111111";  -- A7A = FF
      when "000101001111011" =>  data <= "11111111";  -- A7B = FF
      when "000101001111100" =>  data <= "11111111";  -- A7C = FF
      when "000101001111101" =>  data <= "11111111";  -- A7D = FF
      when "000101001111110" =>  data <= "11111111";  -- A7E = FF
      when "000101001111111" =>  data <= "11111111";  -- A7F = FF
      when "000101010000000" =>  data <= "11111111";  -- A80 = FF
      when "000101010000001" =>  data <= "11111111";  -- A81 = FF
      when "000101010000010" =>  data <= "11111111";  -- A82 = FF
      when "000101010000011" =>  data <= "11111111";  -- A83 = FF
      when "000101010000100" =>  data <= "11111111";  -- A84 = FF
      when "000101010000101" =>  data <= "11111111";  -- A85 = FF
      when "000101010000110" =>  data <= "11111111";  -- A86 = FF
      when "000101010000111" =>  data <= "11111111";  -- A87 = FF
      when "000101010001000" =>  data <= "11111111";  -- A88 = FF
      when "000101010001001" =>  data <= "11111111";  -- A89 = FF
      when "000101010001010" =>  data <= "11111111";  -- A8A = FF
      when "000101010001011" =>  data <= "11111111";  -- A8B = FF
      when "000101010001100" =>  data <= "11111111";  -- A8C = FF
      when "000101010001101" =>  data <= "11111111";  -- A8D = FF
      when "000101010001110" =>  data <= "11111111";  -- A8E = FF
      when "000101010001111" =>  data <= "11111111";  -- A8F = FF
      when "000101010010000" =>  data <= "11111111";  -- A90 = FF
      when "000101010010001" =>  data <= "11111111";  -- A91 = FF
      when "000101010010010" =>  data <= "11111111";  -- A92 = FF
      when "000101010010011" =>  data <= "11111111";  -- A93 = FF
      when "000101010010100" =>  data <= "11111111";  -- A94 = FF
      when "000101010010101" =>  data <= "11111111";  -- A95 = FF
      when "000101010010110" =>  data <= "11111111";  -- A96 = FF
      when "000101010010111" =>  data <= "11111111";  -- A97 = FF
      when "000101010011000" =>  data <= "11111111";  -- A98 = FF
      when "000101010011001" =>  data <= "11111111";  -- A99 = FF
      when "000101010011010" =>  data <= "11111111";  -- A9A = FF
      when "000101010011011" =>  data <= "11111111";  -- A9B = FF
      when "000101010011100" =>  data <= "11111111";  -- A9C = FF
      when "000101010011101" =>  data <= "11111111";  -- A9D = FF
      when "000101010011110" =>  data <= "11111111";  -- A9E = FF
      when "000101010011111" =>  data <= "11111111";  -- A9F = FF
      when "000101010100000" =>  data <= "11111111";  -- AA0 = FF
      when "000101010100001" =>  data <= "11111111";  -- AA1 = FF
      when "000101010100010" =>  data <= "11111111";  -- AA2 = FF
      when "000101010100011" =>  data <= "11111111";  -- AA3 = FF
      when "000101010100100" =>  data <= "11111111";  -- AA4 = FF
      when "000101010100101" =>  data <= "11111111";  -- AA5 = FF
      when "000101010100110" =>  data <= "11111111";  -- AA6 = FF
      when "000101010100111" =>  data <= "11111111";  -- AA7 = FF
      when "000101010101000" =>  data <= "11111111";  -- AA8 = FF
      when "000101010101001" =>  data <= "11111111";  -- AA9 = FF
      when "000101010101010" =>  data <= "11111111";  -- AAA = FF
      when "000101010101011" =>  data <= "11111111";  -- AAB = FF
      when "000101010101100" =>  data <= "11111111";  -- AAC = FF
      when "000101010101101" =>  data <= "11111111";  -- AAD = FF
      when "000101010101110" =>  data <= "11111111";  -- AAE = FF
      when "000101010101111" =>  data <= "11111111";  -- AAF = FF
      when "000101010110000" =>  data <= "11111111";  -- AB0 = FF
      when "000101010110001" =>  data <= "11111111";  -- AB1 = FF
      when "000101010110010" =>  data <= "11111111";  -- AB2 = FF
      when "000101010110011" =>  data <= "11111111";  -- AB3 = FF
      when "000101010110100" =>  data <= "11111111";  -- AB4 = FF
      when "000101010110101" =>  data <= "11111111";  -- AB5 = FF
      when "000101010110110" =>  data <= "11111111";  -- AB6 = FF
      when "000101010110111" =>  data <= "11111111";  -- AB7 = FF
      when "000101010111000" =>  data <= "11111111";  -- AB8 = FF
      when "000101010111001" =>  data <= "11111111";  -- AB9 = FF
      when "000101010111010" =>  data <= "11111111";  -- ABA = FF
      when "000101010111011" =>  data <= "11111111";  -- ABB = FF
      when "000101010111100" =>  data <= "11111111";  -- ABC = FF
      when "000101010111101" =>  data <= "11111111";  -- ABD = FF
      when "000101010111110" =>  data <= "11111111";  -- ABE = FF
      when "000101010111111" =>  data <= "11111111";  -- ABF = FF
      when "000101011000000" =>  data <= "11111111";  -- AC0 = FF
      when "000101011000001" =>  data <= "11111111";  -- AC1 = FF
      when "000101011000010" =>  data <= "11111111";  -- AC2 = FF
      when "000101011000011" =>  data <= "11111111";  -- AC3 = FF
      when "000101011000100" =>  data <= "11111111";  -- AC4 = FF
      when "000101011000101" =>  data <= "11111111";  -- AC5 = FF
      when "000101011000110" =>  data <= "11111111";  -- AC6 = FF
      when "000101011000111" =>  data <= "11111111";  -- AC7 = FF
      when "000101011001000" =>  data <= "11111111";  -- AC8 = FF
      when "000101011001001" =>  data <= "11111111";  -- AC9 = FF
      when "000101011001010" =>  data <= "11111111";  -- ACA = FF
      when "000101011001011" =>  data <= "11111111";  -- ACB = FF
      when "000101011001100" =>  data <= "11111111";  -- ACC = FF
      when "000101011001101" =>  data <= "11111111";  -- ACD = FF
      when "000101011001110" =>  data <= "11111111";  -- ACE = FF
      when "000101011001111" =>  data <= "11111111";  -- ACF = FF
      when "000101011010000" =>  data <= "11111111";  -- AD0 = FF
      when "000101011010001" =>  data <= "11111111";  -- AD1 = FF
      when "000101011010010" =>  data <= "11111111";  -- AD2 = FF
      when "000101011010011" =>  data <= "11111111";  -- AD3 = FF
      when "000101011010100" =>  data <= "11111111";  -- AD4 = FF
      when "000101011010101" =>  data <= "11111111";  -- AD5 = FF
      when "000101011010110" =>  data <= "11111111";  -- AD6 = FF
      when "000101011010111" =>  data <= "11111111";  -- AD7 = FF
      when "000101011011000" =>  data <= "11111111";  -- AD8 = FF
      when "000101011011001" =>  data <= "11111111";  -- AD9 = FF
      when "000101011011010" =>  data <= "11111111";  -- ADA = FF
      when "000101011011011" =>  data <= "11111111";  -- ADB = FF
      when "000101011011100" =>  data <= "11111111";  -- ADC = FF
      when "000101011011101" =>  data <= "11111111";  -- ADD = FF
      when "000101011011110" =>  data <= "11111111";  -- ADE = FF
      when "000101011011111" =>  data <= "11111111";  -- ADF = FF
      when "000101011100000" =>  data <= "11111111";  -- AE0 = FF
      when "000101011100001" =>  data <= "11111111";  -- AE1 = FF
      when "000101011100010" =>  data <= "11111111";  -- AE2 = FF
      when "000101011100011" =>  data <= "11111111";  -- AE3 = FF
      when "000101011100100" =>  data <= "11111111";  -- AE4 = FF
      when "000101011100101" =>  data <= "11111111";  -- AE5 = FF
      when "000101011100110" =>  data <= "11111111";  -- AE6 = FF
      when "000101011100111" =>  data <= "11111111";  -- AE7 = FF
      when "000101011101000" =>  data <= "11111111";  -- AE8 = FF
      when "000101011101001" =>  data <= "11111111";  -- AE9 = FF
      when "000101011101010" =>  data <= "11111111";  -- AEA = FF
      when "000101011101011" =>  data <= "11111111";  -- AEB = FF
      when "000101011101100" =>  data <= "11111111";  -- AEC = FF
      when "000101011101101" =>  data <= "11111111";  -- AED = FF
      when "000101011101110" =>  data <= "11111111";  -- AEE = FF
      when "000101011101111" =>  data <= "11111111";  -- AEF = FF
      when "000101011110000" =>  data <= "11111111";  -- AF0 = FF
      when "000101011110001" =>  data <= "11111111";  -- AF1 = FF
      when "000101011110010" =>  data <= "11111111";  -- AF2 = FF
      when "000101011110011" =>  data <= "11111111";  -- AF3 = FF
      when "000101011110100" =>  data <= "11111111";  -- AF4 = FF
      when "000101011110101" =>  data <= "11111111";  -- AF5 = FF
      when "000101011110110" =>  data <= "11111111";  -- AF6 = FF
      when "000101011110111" =>  data <= "11111111";  -- AF7 = FF
      when "000101011111000" =>  data <= "11111111";  -- AF8 = FF
      when "000101011111001" =>  data <= "11111111";  -- AF9 = FF
      when "000101011111010" =>  data <= "11111111";  -- AFA = FF
      when "000101011111011" =>  data <= "11111111";  -- AFB = FF
      when "000101011111100" =>  data <= "11111111";  -- AFC = FF
      when "000101011111101" =>  data <= "11111111";  -- AFD = FF
      when "000101011111110" =>  data <= "11111111";  -- AFE = FF
      when "000101011111111" =>  data <= "11111111";  -- AFF = FF
      when "000101100000000" =>  data <= "11111111";  -- B00 = FF
      when "000101100000001" =>  data <= "11111111";  -- B01 = FF
      when "000101100000010" =>  data <= "11111111";  -- B02 = FF
      when "000101100000011" =>  data <= "11111111";  -- B03 = FF
      when "000101100000100" =>  data <= "11111111";  -- B04 = FF
      when "000101100000101" =>  data <= "11111111";  -- B05 = FF
      when "000101100000110" =>  data <= "11111111";  -- B06 = FF
      when "000101100000111" =>  data <= "11111111";  -- B07 = FF
      when "000101100001000" =>  data <= "11111111";  -- B08 = FF
      when "000101100001001" =>  data <= "11111111";  -- B09 = FF
      when "000101100001010" =>  data <= "11111111";  -- B0A = FF
      when "000101100001011" =>  data <= "11111111";  -- B0B = FF
      when "000101100001100" =>  data <= "11111111";  -- B0C = FF
      when "000101100001101" =>  data <= "11111111";  -- B0D = FF
      when "000101100001110" =>  data <= "11111111";  -- B0E = FF
      when "000101100001111" =>  data <= "11111111";  -- B0F = FF
      when "000101100010000" =>  data <= "11111111";  -- B10 = FF
      when "000101100010001" =>  data <= "11111111";  -- B11 = FF
      when "000101100010010" =>  data <= "11111111";  -- B12 = FF
      when "000101100010011" =>  data <= "11111111";  -- B13 = FF
      when "000101100010100" =>  data <= "11111111";  -- B14 = FF
      when "000101100010101" =>  data <= "11111111";  -- B15 = FF
      when "000101100010110" =>  data <= "11111111";  -- B16 = FF
      when "000101100010111" =>  data <= "11111111";  -- B17 = FF
      when "000101100011000" =>  data <= "11111111";  -- B18 = FF
      when "000101100011001" =>  data <= "11111111";  -- B19 = FF
      when "000101100011010" =>  data <= "11111111";  -- B1A = FF
      when "000101100011011" =>  data <= "11111111";  -- B1B = FF
      when "000101100011100" =>  data <= "11111111";  -- B1C = FF
      when "000101100011101" =>  data <= "11111111";  -- B1D = FF
      when "000101100011110" =>  data <= "11111111";  -- B1E = FF
      when "000101100011111" =>  data <= "11111111";  -- B1F = FF
      when "000101100100000" =>  data <= "11111111";  -- B20 = FF
      when "000101100100001" =>  data <= "11111111";  -- B21 = FF
      when "000101100100010" =>  data <= "11111111";  -- B22 = FF
      when "000101100100011" =>  data <= "11111111";  -- B23 = FF
      when "000101100100100" =>  data <= "11111111";  -- B24 = FF
      when "000101100100101" =>  data <= "11111111";  -- B25 = FF
      when "000101100100110" =>  data <= "11111111";  -- B26 = FF
      when "000101100100111" =>  data <= "11111111";  -- B27 = FF
      when "000101100101000" =>  data <= "11111111";  -- B28 = FF
      when "000101100101001" =>  data <= "11111111";  -- B29 = FF
      when "000101100101010" =>  data <= "11111111";  -- B2A = FF
      when "000101100101011" =>  data <= "11111111";  -- B2B = FF
      when "000101100101100" =>  data <= "11111111";  -- B2C = FF
      when "000101100101101" =>  data <= "11111111";  -- B2D = FF
      when "000101100101110" =>  data <= "11111111";  -- B2E = FF
      when "000101100101111" =>  data <= "11111111";  -- B2F = FF
      when "000101100110000" =>  data <= "11111111";  -- B30 = FF
      when "000101100110001" =>  data <= "11111111";  -- B31 = FF
      when "000101100110010" =>  data <= "11111111";  -- B32 = FF
      when "000101100110011" =>  data <= "11111111";  -- B33 = FF
      when "000101100110100" =>  data <= "11111111";  -- B34 = FF
      when "000101100110101" =>  data <= "11111111";  -- B35 = FF
      when "000101100110110" =>  data <= "11111111";  -- B36 = FF
      when "000101100110111" =>  data <= "11111111";  -- B37 = FF
      when "000101100111000" =>  data <= "11111111";  -- B38 = FF
      when "000101100111001" =>  data <= "11111111";  -- B39 = FF
      when "000101100111010" =>  data <= "11111111";  -- B3A = FF
      when "000101100111011" =>  data <= "11111111";  -- B3B = FF
      when "000101100111100" =>  data <= "11111111";  -- B3C = FF
      when "000101100111101" =>  data <= "11111111";  -- B3D = FF
      when "000101100111110" =>  data <= "11111111";  -- B3E = FF
      when "000101100111111" =>  data <= "11111111";  -- B3F = FF
      when "000101101000000" =>  data <= "11111111";  -- B40 = FF
      when "000101101000001" =>  data <= "11111111";  -- B41 = FF
      when "000101101000010" =>  data <= "11111111";  -- B42 = FF
      when "000101101000011" =>  data <= "11111111";  -- B43 = FF
      when "000101101000100" =>  data <= "11111111";  -- B44 = FF
      when "000101101000101" =>  data <= "11111111";  -- B45 = FF
      when "000101101000110" =>  data <= "11111111";  -- B46 = FF
      when "000101101000111" =>  data <= "11111111";  -- B47 = FF
      when "000101101001000" =>  data <= "11111111";  -- B48 = FF
      when "000101101001001" =>  data <= "11111111";  -- B49 = FF
      when "000101101001010" =>  data <= "11111111";  -- B4A = FF
      when "000101101001011" =>  data <= "11111111";  -- B4B = FF
      when "000101101001100" =>  data <= "11111111";  -- B4C = FF
      when "000101101001101" =>  data <= "11111111";  -- B4D = FF
      when "000101101001110" =>  data <= "11111111";  -- B4E = FF
      when "000101101001111" =>  data <= "11111111";  -- B4F = FF
      when "000101101010000" =>  data <= "11111111";  -- B50 = FF
      when "000101101010001" =>  data <= "11111111";  -- B51 = FF
      when "000101101010010" =>  data <= "11111111";  -- B52 = FF
      when "000101101010011" =>  data <= "11111111";  -- B53 = FF
      when "000101101010100" =>  data <= "11111111";  -- B54 = FF
      when "000101101010101" =>  data <= "11111111";  -- B55 = FF
      when "000101101010110" =>  data <= "11111111";  -- B56 = FF
      when "000101101010111" =>  data <= "11111111";  -- B57 = FF
      when "000101101011000" =>  data <= "11111111";  -- B58 = FF
      when "000101101011001" =>  data <= "11111111";  -- B59 = FF
      when "000101101011010" =>  data <= "11111111";  -- B5A = FF
      when "000101101011011" =>  data <= "11111111";  -- B5B = FF
      when "000101101011100" =>  data <= "11111111";  -- B5C = FF
      when "000101101011101" =>  data <= "11111111";  -- B5D = FF
      when "000101101011110" =>  data <= "11111111";  -- B5E = FF
      when "000101101011111" =>  data <= "11111111";  -- B5F = FF
      when "000101101100000" =>  data <= "11111111";  -- B60 = FF
      when "000101101100001" =>  data <= "11111111";  -- B61 = FF
      when "000101101100010" =>  data <= "11111111";  -- B62 = FF
      when "000101101100011" =>  data <= "11111111";  -- B63 = FF
      when "000101101100100" =>  data <= "11111111";  -- B64 = FF
      when "000101101100101" =>  data <= "11111111";  -- B65 = FF
      when "000101101100110" =>  data <= "11111111";  -- B66 = FF
      when "000101101100111" =>  data <= "11111111";  -- B67 = FF
      when "000101101101000" =>  data <= "11111111";  -- B68 = FF
      when "000101101101001" =>  data <= "11111111";  -- B69 = FF
      when "000101101101010" =>  data <= "11111111";  -- B6A = FF
      when "000101101101011" =>  data <= "11111111";  -- B6B = FF
      when "000101101101100" =>  data <= "11111111";  -- B6C = FF
      when "000101101101101" =>  data <= "11111111";  -- B6D = FF
      when "000101101101110" =>  data <= "11111111";  -- B6E = FF
      when "000101101101111" =>  data <= "11111111";  -- B6F = FF
      when "000101101110000" =>  data <= "11111111";  -- B70 = FF
      when "000101101110001" =>  data <= "11111111";  -- B71 = FF
      when "000101101110010" =>  data <= "11111111";  -- B72 = FF
      when "000101101110011" =>  data <= "11111111";  -- B73 = FF
      when "000101101110100" =>  data <= "11111111";  -- B74 = FF
      when "000101101110101" =>  data <= "11111111";  -- B75 = FF
      when "000101101110110" =>  data <= "11111111";  -- B76 = FF
      when "000101101110111" =>  data <= "11111111";  -- B77 = FF
      when "000101101111000" =>  data <= "11111111";  -- B78 = FF
      when "000101101111001" =>  data <= "11111111";  -- B79 = FF
      when "000101101111010" =>  data <= "11111111";  -- B7A = FF
      when "000101101111011" =>  data <= "11111111";  -- B7B = FF
      when "000101101111100" =>  data <= "11111111";  -- B7C = FF
      when "000101101111101" =>  data <= "11111111";  -- B7D = FF
      when "000101101111110" =>  data <= "11111111";  -- B7E = FF
      when "000101101111111" =>  data <= "11111111";  -- B7F = FF
      when "000101110000000" =>  data <= "11111111";  -- B80 = FF
      when "000101110000001" =>  data <= "11111111";  -- B81 = FF
      when "000101110000010" =>  data <= "11111111";  -- B82 = FF
      when "000101110000011" =>  data <= "11111111";  -- B83 = FF
      when "000101110000100" =>  data <= "11111111";  -- B84 = FF
      when "000101110000101" =>  data <= "11111111";  -- B85 = FF
      when "000101110000110" =>  data <= "11111111";  -- B86 = FF
      when "000101110000111" =>  data <= "11111111";  -- B87 = FF
      when "000101110001000" =>  data <= "11111111";  -- B88 = FF
      when "000101110001001" =>  data <= "11111111";  -- B89 = FF
      when "000101110001010" =>  data <= "11111111";  -- B8A = FF
      when "000101110001011" =>  data <= "11111111";  -- B8B = FF
      when "000101110001100" =>  data <= "11111111";  -- B8C = FF
      when "000101110001101" =>  data <= "11111111";  -- B8D = FF
      when "000101110001110" =>  data <= "11111111";  -- B8E = FF
      when "000101110001111" =>  data <= "11111111";  -- B8F = FF
      when "000101110010000" =>  data <= "11111111";  -- B90 = FF
      when "000101110010001" =>  data <= "11111111";  -- B91 = FF
      when "000101110010010" =>  data <= "11111111";  -- B92 = FF
      when "000101110010011" =>  data <= "11111111";  -- B93 = FF
      when "000101110010100" =>  data <= "11111111";  -- B94 = FF
      when "000101110010101" =>  data <= "11111111";  -- B95 = FF
      when "000101110010110" =>  data <= "11111111";  -- B96 = FF
      when "000101110010111" =>  data <= "11111111";  -- B97 = FF
      when "000101110011000" =>  data <= "11111111";  -- B98 = FF
      when "000101110011001" =>  data <= "11111111";  -- B99 = FF
      when "000101110011010" =>  data <= "11111111";  -- B9A = FF
      when "000101110011011" =>  data <= "11111111";  -- B9B = FF
      when "000101110011100" =>  data <= "11111111";  -- B9C = FF
      when "000101110011101" =>  data <= "11111111";  -- B9D = FF
      when "000101110011110" =>  data <= "11111111";  -- B9E = FF
      when "000101110011111" =>  data <= "11111111";  -- B9F = FF
      when "000101110100000" =>  data <= "11111111";  -- BA0 = FF
      when "000101110100001" =>  data <= "11111111";  -- BA1 = FF
      when "000101110100010" =>  data <= "11111111";  -- BA2 = FF
      when "000101110100011" =>  data <= "11111111";  -- BA3 = FF
      when "000101110100100" =>  data <= "11111111";  -- BA4 = FF
      when "000101110100101" =>  data <= "11111111";  -- BA5 = FF
      when "000101110100110" =>  data <= "11111111";  -- BA6 = FF
      when "000101110100111" =>  data <= "11111111";  -- BA7 = FF
      when "000101110101000" =>  data <= "11111111";  -- BA8 = FF
      when "000101110101001" =>  data <= "11111111";  -- BA9 = FF
      when "000101110101010" =>  data <= "11111111";  -- BAA = FF
      when "000101110101011" =>  data <= "11111111";  -- BAB = FF
      when "000101110101100" =>  data <= "11111111";  -- BAC = FF
      when "000101110101101" =>  data <= "11111111";  -- BAD = FF
      when "000101110101110" =>  data <= "11111111";  -- BAE = FF
      when "000101110101111" =>  data <= "11111111";  -- BAF = FF
      when "000101110110000" =>  data <= "11111111";  -- BB0 = FF
      when "000101110110001" =>  data <= "11111111";  -- BB1 = FF
      when "000101110110010" =>  data <= "11111111";  -- BB2 = FF
      when "000101110110011" =>  data <= "11111111";  -- BB3 = FF
      when "000101110110100" =>  data <= "11111111";  -- BB4 = FF
      when "000101110110101" =>  data <= "11111111";  -- BB5 = FF
      when "000101110110110" =>  data <= "11111111";  -- BB6 = FF
      when "000101110110111" =>  data <= "11111111";  -- BB7 = FF
      when "000101110111000" =>  data <= "11111111";  -- BB8 = FF
      when "000101110111001" =>  data <= "11111111";  -- BB9 = FF
      when "000101110111010" =>  data <= "11111111";  -- BBA = FF
      when "000101110111011" =>  data <= "11111111";  -- BBB = FF
      when "000101110111100" =>  data <= "11111111";  -- BBC = FF
      when "000101110111101" =>  data <= "11111111";  -- BBD = FF
      when "000101110111110" =>  data <= "11111111";  -- BBE = FF
      when "000101110111111" =>  data <= "11111111";  -- BBF = FF
      when "000101111000000" =>  data <= "11111111";  -- BC0 = FF
      when "000101111000001" =>  data <= "11111111";  -- BC1 = FF
      when "000101111000010" =>  data <= "11111111";  -- BC2 = FF
      when "000101111000011" =>  data <= "11111111";  -- BC3 = FF
      when "000101111000100" =>  data <= "11111111";  -- BC4 = FF
      when "000101111000101" =>  data <= "11111111";  -- BC5 = FF
      when "000101111000110" =>  data <= "11111111";  -- BC6 = FF
      when "000101111000111" =>  data <= "11111111";  -- BC7 = FF
      when "000101111001000" =>  data <= "11111111";  -- BC8 = FF
      when "000101111001001" =>  data <= "11111111";  -- BC9 = FF
      when "000101111001010" =>  data <= "11111111";  -- BCA = FF
      when "000101111001011" =>  data <= "11111111";  -- BCB = FF
      when "000101111001100" =>  data <= "11111111";  -- BCC = FF
      when "000101111001101" =>  data <= "11111111";  -- BCD = FF
      when "000101111001110" =>  data <= "11111111";  -- BCE = FF
      when "000101111001111" =>  data <= "11111111";  -- BCF = FF
      when "000101111010000" =>  data <= "11111111";  -- BD0 = FF
      when "000101111010001" =>  data <= "11111111";  -- BD1 = FF
      when "000101111010010" =>  data <= "11111111";  -- BD2 = FF
      when "000101111010011" =>  data <= "11111111";  -- BD3 = FF
      when "000101111010100" =>  data <= "11111111";  -- BD4 = FF
      when "000101111010101" =>  data <= "11111111";  -- BD5 = FF
      when "000101111010110" =>  data <= "11111111";  -- BD6 = FF
      when "000101111010111" =>  data <= "11111111";  -- BD7 = FF
      when "000101111011000" =>  data <= "11111111";  -- BD8 = FF
      when "000101111011001" =>  data <= "11111111";  -- BD9 = FF
      when "000101111011010" =>  data <= "11111111";  -- BDA = FF
      when "000101111011011" =>  data <= "11111111";  -- BDB = FF
      when "000101111011100" =>  data <= "11111111";  -- BDC = FF
      when "000101111011101" =>  data <= "11111111";  -- BDD = FF
      when "000101111011110" =>  data <= "11111111";  -- BDE = FF
      when "000101111011111" =>  data <= "11111111";  -- BDF = FF
      when "000101111100000" =>  data <= "11111111";  -- BE0 = FF
      when "000101111100001" =>  data <= "11111111";  -- BE1 = FF
      when "000101111100010" =>  data <= "11111111";  -- BE2 = FF
      when "000101111100011" =>  data <= "11111111";  -- BE3 = FF
      when "000101111100100" =>  data <= "11111111";  -- BE4 = FF
      when "000101111100101" =>  data <= "11111111";  -- BE5 = FF
      when "000101111100110" =>  data <= "11111111";  -- BE6 = FF
      when "000101111100111" =>  data <= "11111111";  -- BE7 = FF
      when "000101111101000" =>  data <= "11111111";  -- BE8 = FF
      when "000101111101001" =>  data <= "11111111";  -- BE9 = FF
      when "000101111101010" =>  data <= "11111111";  -- BEA = FF
      when "000101111101011" =>  data <= "11111111";  -- BEB = FF
      when "000101111101100" =>  data <= "11111111";  -- BEC = FF
      when "000101111101101" =>  data <= "11111111";  -- BED = FF
      when "000101111101110" =>  data <= "11111111";  -- BEE = FF
      when "000101111101111" =>  data <= "11111111";  -- BEF = FF
      when "000101111110000" =>  data <= "11111111";  -- BF0 = FF
      when "000101111110001" =>  data <= "11111111";  -- BF1 = FF
      when "000101111110010" =>  data <= "11111111";  -- BF2 = FF
      when "000101111110011" =>  data <= "11111111";  -- BF3 = FF
      when "000101111110100" =>  data <= "11111111";  -- BF4 = FF
      when "000101111110101" =>  data <= "11111111";  -- BF5 = FF
      when "000101111110110" =>  data <= "11111111";  -- BF6 = FF
      when "000101111110111" =>  data <= "11111111";  -- BF7 = FF
      when "000101111111000" =>  data <= "11111111";  -- BF8 = FF
      when "000101111111001" =>  data <= "11111111";  -- BF9 = FF
      when "000101111111010" =>  data <= "11111111";  -- BFA = FF
      when "000101111111011" =>  data <= "11111111";  -- BFB = FF
      when "000101111111100" =>  data <= "11111111";  -- BFC = FF
      when "000101111111101" =>  data <= "11111111";  -- BFD = FF
      when "000101111111110" =>  data <= "11111111";  -- BFE = FF
      when "000101111111111" =>  data <= "11111111";  -- BFF = FF
      when "000110000000000" =>  data <= "11111111";  -- C00 = FF
      when "000110000000001" =>  data <= "11111111";  -- C01 = FF
      when "000110000000010" =>  data <= "11111111";  -- C02 = FF
      when "000110000000011" =>  data <= "11111111";  -- C03 = FF
      when "000110000000100" =>  data <= "11111111";  -- C04 = FF
      when "000110000000101" =>  data <= "11111111";  -- C05 = FF
      when "000110000000110" =>  data <= "11111111";  -- C06 = FF
      when "000110000000111" =>  data <= "11111111";  -- C07 = FF
      when "000110000001000" =>  data <= "11111111";  -- C08 = FF
      when "000110000001001" =>  data <= "11111111";  -- C09 = FF
      when "000110000001010" =>  data <= "11111111";  -- C0A = FF
      when "000110000001011" =>  data <= "11111111";  -- C0B = FF
      when "000110000001100" =>  data <= "11111111";  -- C0C = FF
      when "000110000001101" =>  data <= "11111111";  -- C0D = FF
      when "000110000001110" =>  data <= "11111111";  -- C0E = FF
      when "000110000001111" =>  data <= "11111111";  -- C0F = FF
      when "000110000010000" =>  data <= "11111111";  -- C10 = FF
      when "000110000010001" =>  data <= "11111111";  -- C11 = FF
      when "000110000010010" =>  data <= "11111111";  -- C12 = FF
      when "000110000010011" =>  data <= "11111111";  -- C13 = FF
      when "000110000010100" =>  data <= "11111111";  -- C14 = FF
      when "000110000010101" =>  data <= "11111111";  -- C15 = FF
      when "000110000010110" =>  data <= "11111111";  -- C16 = FF
      when "000110000010111" =>  data <= "11111111";  -- C17 = FF
      when "000110000011000" =>  data <= "11111111";  -- C18 = FF
      when "000110000011001" =>  data <= "11111111";  -- C19 = FF
      when "000110000011010" =>  data <= "11111111";  -- C1A = FF
      when "000110000011011" =>  data <= "11111111";  -- C1B = FF
      when "000110000011100" =>  data <= "11111111";  -- C1C = FF
      when "000110000011101" =>  data <= "11111111";  -- C1D = FF
      when "000110000011110" =>  data <= "11111111";  -- C1E = FF
      when "000110000011111" =>  data <= "11111111";  -- C1F = FF
      when "000110000100000" =>  data <= "11111111";  -- C20 = FF
      when "000110000100001" =>  data <= "11111111";  -- C21 = FF
      when "000110000100010" =>  data <= "11111111";  -- C22 = FF
      when "000110000100011" =>  data <= "11111111";  -- C23 = FF
      when "000110000100100" =>  data <= "11111111";  -- C24 = FF
      when "000110000100101" =>  data <= "11111111";  -- C25 = FF
      when "000110000100110" =>  data <= "11111111";  -- C26 = FF
      when "000110000100111" =>  data <= "11111111";  -- C27 = FF
      when "000110000101000" =>  data <= "11111111";  -- C28 = FF
      when "000110000101001" =>  data <= "11111111";  -- C29 = FF
      when "000110000101010" =>  data <= "11111111";  -- C2A = FF
      when "000110000101011" =>  data <= "11111111";  -- C2B = FF
      when "000110000101100" =>  data <= "11111111";  -- C2C = FF
      when "000110000101101" =>  data <= "11111111";  -- C2D = FF
      when "000110000101110" =>  data <= "11111111";  -- C2E = FF
      when "000110000101111" =>  data <= "11111111";  -- C2F = FF
      when "000110000110000" =>  data <= "11111111";  -- C30 = FF
      when "000110000110001" =>  data <= "11111111";  -- C31 = FF
      when "000110000110010" =>  data <= "11111111";  -- C32 = FF
      when "000110000110011" =>  data <= "11111111";  -- C33 = FF
      when "000110000110100" =>  data <= "11111111";  -- C34 = FF
      when "000110000110101" =>  data <= "11111111";  -- C35 = FF
      when "000110000110110" =>  data <= "11111111";  -- C36 = FF
      when "000110000110111" =>  data <= "11111111";  -- C37 = FF
      when "000110000111000" =>  data <= "11111111";  -- C38 = FF
      when "000110000111001" =>  data <= "11111111";  -- C39 = FF
      when "000110000111010" =>  data <= "11111111";  -- C3A = FF
      when "000110000111011" =>  data <= "11111111";  -- C3B = FF
      when "000110000111100" =>  data <= "11111111";  -- C3C = FF
      when "000110000111101" =>  data <= "11111111";  -- C3D = FF
      when "000110000111110" =>  data <= "11111111";  -- C3E = FF
      when "000110000111111" =>  data <= "11111111";  -- C3F = FF
      when "000110001000000" =>  data <= "11111111";  -- C40 = FF
      when "000110001000001" =>  data <= "11111111";  -- C41 = FF
      when "000110001000010" =>  data <= "11111111";  -- C42 = FF
      when "000110001000011" =>  data <= "11111111";  -- C43 = FF
      when "000110001000100" =>  data <= "11111111";  -- C44 = FF
      when "000110001000101" =>  data <= "11111111";  -- C45 = FF
      when "000110001000110" =>  data <= "11111111";  -- C46 = FF
      when "000110001000111" =>  data <= "11111111";  -- C47 = FF
      when "000110001001000" =>  data <= "11111111";  -- C48 = FF
      when "000110001001001" =>  data <= "11111111";  -- C49 = FF
      when "000110001001010" =>  data <= "11111111";  -- C4A = FF
      when "000110001001011" =>  data <= "11111111";  -- C4B = FF
      when "000110001001100" =>  data <= "11111111";  -- C4C = FF
      when "000110001001101" =>  data <= "11111111";  -- C4D = FF
      when "000110001001110" =>  data <= "11111111";  -- C4E = FF
      when "000110001001111" =>  data <= "11111111";  -- C4F = FF
      when "000110001010000" =>  data <= "11111111";  -- C50 = FF
      when "000110001010001" =>  data <= "11111111";  -- C51 = FF
      when "000110001010010" =>  data <= "11111111";  -- C52 = FF
      when "000110001010011" =>  data <= "11111111";  -- C53 = FF
      when "000110001010100" =>  data <= "11111111";  -- C54 = FF
      when "000110001010101" =>  data <= "11111111";  -- C55 = FF
      when "000110001010110" =>  data <= "11111111";  -- C56 = FF
      when "000110001010111" =>  data <= "11111111";  -- C57 = FF
      when "000110001011000" =>  data <= "11111111";  -- C58 = FF
      when "000110001011001" =>  data <= "11111111";  -- C59 = FF
      when "000110001011010" =>  data <= "11111111";  -- C5A = FF
      when "000110001011011" =>  data <= "11111111";  -- C5B = FF
      when "000110001011100" =>  data <= "11111111";  -- C5C = FF
      when "000110001011101" =>  data <= "11111111";  -- C5D = FF
      when "000110001011110" =>  data <= "11111111";  -- C5E = FF
      when "000110001011111" =>  data <= "11111111";  -- C5F = FF
      when "000110001100000" =>  data <= "11111111";  -- C60 = FF
      when "000110001100001" =>  data <= "11111111";  -- C61 = FF
      when "000110001100010" =>  data <= "11111111";  -- C62 = FF
      when "000110001100011" =>  data <= "11111111";  -- C63 = FF
      when "000110001100100" =>  data <= "11111111";  -- C64 = FF
      when "000110001100101" =>  data <= "11111111";  -- C65 = FF
      when "000110001100110" =>  data <= "11111111";  -- C66 = FF
      when "000110001100111" =>  data <= "11111111";  -- C67 = FF
      when "000110001101000" =>  data <= "11111111";  -- C68 = FF
      when "000110001101001" =>  data <= "11111111";  -- C69 = FF
      when "000110001101010" =>  data <= "11111111";  -- C6A = FF
      when "000110001101011" =>  data <= "11111111";  -- C6B = FF
      when "000110001101100" =>  data <= "11111111";  -- C6C = FF
      when "000110001101101" =>  data <= "11111111";  -- C6D = FF
      when "000110001101110" =>  data <= "11111111";  -- C6E = FF
      when "000110001101111" =>  data <= "11111111";  -- C6F = FF
      when "000110001110000" =>  data <= "11111111";  -- C70 = FF
      when "000110001110001" =>  data <= "11111111";  -- C71 = FF
      when "000110001110010" =>  data <= "11111111";  -- C72 = FF
      when "000110001110011" =>  data <= "11111111";  -- C73 = FF
      when "000110001110100" =>  data <= "11111111";  -- C74 = FF
      when "000110001110101" =>  data <= "11111111";  -- C75 = FF
      when "000110001110110" =>  data <= "11111111";  -- C76 = FF
      when "000110001110111" =>  data <= "11111111";  -- C77 = FF
      when "000110001111000" =>  data <= "11111111";  -- C78 = FF
      when "000110001111001" =>  data <= "11111111";  -- C79 = FF
      when "000110001111010" =>  data <= "11111111";  -- C7A = FF
      when "000110001111011" =>  data <= "11111111";  -- C7B = FF
      when "000110001111100" =>  data <= "11111111";  -- C7C = FF
      when "000110001111101" =>  data <= "11111111";  -- C7D = FF
      when "000110001111110" =>  data <= "11111111";  -- C7E = FF
      when "000110001111111" =>  data <= "11111111";  -- C7F = FF
      when "000110010000000" =>  data <= "11111111";  -- C80 = FF
      when "000110010000001" =>  data <= "11111111";  -- C81 = FF
      when "000110010000010" =>  data <= "11111111";  -- C82 = FF
      when "000110010000011" =>  data <= "11111111";  -- C83 = FF
      when "000110010000100" =>  data <= "11111111";  -- C84 = FF
      when "000110010000101" =>  data <= "11111111";  -- C85 = FF
      when "000110010000110" =>  data <= "11111111";  -- C86 = FF
      when "000110010000111" =>  data <= "11111111";  -- C87 = FF
      when "000110010001000" =>  data <= "11111111";  -- C88 = FF
      when "000110010001001" =>  data <= "11111111";  -- C89 = FF
      when "000110010001010" =>  data <= "11111111";  -- C8A = FF
      when "000110010001011" =>  data <= "11111111";  -- C8B = FF
      when "000110010001100" =>  data <= "11111111";  -- C8C = FF
      when "000110010001101" =>  data <= "11111111";  -- C8D = FF
      when "000110010001110" =>  data <= "11111111";  -- C8E = FF
      when "000110010001111" =>  data <= "11111111";  -- C8F = FF
      when "000110010010000" =>  data <= "11111111";  -- C90 = FF
      when "000110010010001" =>  data <= "11111111";  -- C91 = FF
      when "000110010010010" =>  data <= "11111111";  -- C92 = FF
      when "000110010010011" =>  data <= "11111111";  -- C93 = FF
      when "000110010010100" =>  data <= "11111111";  -- C94 = FF
      when "000110010010101" =>  data <= "11111111";  -- C95 = FF
      when "000110010010110" =>  data <= "11111111";  -- C96 = FF
      when "000110010010111" =>  data <= "11111111";  -- C97 = FF
      when "000110010011000" =>  data <= "11111111";  -- C98 = FF
      when "000110010011001" =>  data <= "11111111";  -- C99 = FF
      when "000110010011010" =>  data <= "11111111";  -- C9A = FF
      when "000110010011011" =>  data <= "11111111";  -- C9B = FF
      when "000110010011100" =>  data <= "11111111";  -- C9C = FF
      when "000110010011101" =>  data <= "11111111";  -- C9D = FF
      when "000110010011110" =>  data <= "11111111";  -- C9E = FF
      when "000110010011111" =>  data <= "11111111";  -- C9F = FF
      when "000110010100000" =>  data <= "11111111";  -- CA0 = FF
      when "000110010100001" =>  data <= "11111111";  -- CA1 = FF
      when "000110010100010" =>  data <= "11111111";  -- CA2 = FF
      when "000110010100011" =>  data <= "11111111";  -- CA3 = FF
      when "000110010100100" =>  data <= "11111111";  -- CA4 = FF
      when "000110010100101" =>  data <= "11111111";  -- CA5 = FF
      when "000110010100110" =>  data <= "11111111";  -- CA6 = FF
      when "000110010100111" =>  data <= "11111111";  -- CA7 = FF
      when "000110010101000" =>  data <= "11111111";  -- CA8 = FF
      when "000110010101001" =>  data <= "11111111";  -- CA9 = FF
      when "000110010101010" =>  data <= "11111111";  -- CAA = FF
      when "000110010101011" =>  data <= "11111111";  -- CAB = FF
      when "000110010101100" =>  data <= "11111111";  -- CAC = FF
      when "000110010101101" =>  data <= "11111111";  -- CAD = FF
      when "000110010101110" =>  data <= "11111111";  -- CAE = FF
      when "000110010101111" =>  data <= "11111111";  -- CAF = FF
      when "000110010110000" =>  data <= "11111111";  -- CB0 = FF
      when "000110010110001" =>  data <= "11111111";  -- CB1 = FF
      when "000110010110010" =>  data <= "11111111";  -- CB2 = FF
      when "000110010110011" =>  data <= "11111111";  -- CB3 = FF
      when "000110010110100" =>  data <= "11111111";  -- CB4 = FF
      when "000110010110101" =>  data <= "11111111";  -- CB5 = FF
      when "000110010110110" =>  data <= "11111111";  -- CB6 = FF
      when "000110010110111" =>  data <= "11111111";  -- CB7 = FF
      when "000110010111000" =>  data <= "11111111";  -- CB8 = FF
      when "000110010111001" =>  data <= "11111111";  -- CB9 = FF
      when "000110010111010" =>  data <= "11111111";  -- CBA = FF
      when "000110010111011" =>  data <= "11111111";  -- CBB = FF
      when "000110010111100" =>  data <= "11111111";  -- CBC = FF
      when "000110010111101" =>  data <= "11111111";  -- CBD = FF
      when "000110010111110" =>  data <= "11111111";  -- CBE = FF
      when "000110010111111" =>  data <= "11111111";  -- CBF = FF
      when "000110011000000" =>  data <= "11111111";  -- CC0 = FF
      when "000110011000001" =>  data <= "11111111";  -- CC1 = FF
      when "000110011000010" =>  data <= "11111111";  -- CC2 = FF
      when "000110011000011" =>  data <= "11111111";  -- CC3 = FF
      when "000110011000100" =>  data <= "11111111";  -- CC4 = FF
      when "000110011000101" =>  data <= "11111111";  -- CC5 = FF
      when "000110011000110" =>  data <= "11111111";  -- CC6 = FF
      when "000110011000111" =>  data <= "11111111";  -- CC7 = FF
      when "000110011001000" =>  data <= "11111111";  -- CC8 = FF
      when "000110011001001" =>  data <= "11111111";  -- CC9 = FF
      when "000110011001010" =>  data <= "11111111";  -- CCA = FF
      when "000110011001011" =>  data <= "11111111";  -- CCB = FF
      when "000110011001100" =>  data <= "11111111";  -- CCC = FF
      when "000110011001101" =>  data <= "11111111";  -- CCD = FF
      when "000110011001110" =>  data <= "11111111";  -- CCE = FF
      when "000110011001111" =>  data <= "11111111";  -- CCF = FF
      when "000110011010000" =>  data <= "11111111";  -- CD0 = FF
      when "000110011010001" =>  data <= "11111111";  -- CD1 = FF
      when "000110011010010" =>  data <= "11111111";  -- CD2 = FF
      when "000110011010011" =>  data <= "11111111";  -- CD3 = FF
      when "000110011010100" =>  data <= "11111111";  -- CD4 = FF
      when "000110011010101" =>  data <= "11111111";  -- CD5 = FF
      when "000110011010110" =>  data <= "11111111";  -- CD6 = FF
      when "000110011010111" =>  data <= "11111111";  -- CD7 = FF
      when "000110011011000" =>  data <= "11111111";  -- CD8 = FF
      when "000110011011001" =>  data <= "11111111";  -- CD9 = FF
      when "000110011011010" =>  data <= "11111111";  -- CDA = FF
      when "000110011011011" =>  data <= "11111111";  -- CDB = FF
      when "000110011011100" =>  data <= "11111111";  -- CDC = FF
      when "000110011011101" =>  data <= "11111111";  -- CDD = FF
      when "000110011011110" =>  data <= "11111111";  -- CDE = FF
      when "000110011011111" =>  data <= "11111111";  -- CDF = FF
      when "000110011100000" =>  data <= "11111111";  -- CE0 = FF
      when "000110011100001" =>  data <= "11111111";  -- CE1 = FF
      when "000110011100010" =>  data <= "11111111";  -- CE2 = FF
      when "000110011100011" =>  data <= "11111111";  -- CE3 = FF
      when "000110011100100" =>  data <= "11111111";  -- CE4 = FF
      when "000110011100101" =>  data <= "11111111";  -- CE5 = FF
      when "000110011100110" =>  data <= "11111111";  -- CE6 = FF
      when "000110011100111" =>  data <= "11111111";  -- CE7 = FF
      when "000110011101000" =>  data <= "11111111";  -- CE8 = FF
      when "000110011101001" =>  data <= "11111111";  -- CE9 = FF
      when "000110011101010" =>  data <= "11111111";  -- CEA = FF
      when "000110011101011" =>  data <= "11111111";  -- CEB = FF
      when "000110011101100" =>  data <= "11111111";  -- CEC = FF
      when "000110011101101" =>  data <= "11111111";  -- CED = FF
      when "000110011101110" =>  data <= "11111111";  -- CEE = FF
      when "000110011101111" =>  data <= "11111111";  -- CEF = FF
      when "000110011110000" =>  data <= "11111111";  -- CF0 = FF
      when "000110011110001" =>  data <= "11111111";  -- CF1 = FF
      when "000110011110010" =>  data <= "11111111";  -- CF2 = FF
      when "000110011110011" =>  data <= "11111111";  -- CF3 = FF
      when "000110011110100" =>  data <= "11111111";  -- CF4 = FF
      when "000110011110101" =>  data <= "11111111";  -- CF5 = FF
      when "000110011110110" =>  data <= "11111111";  -- CF6 = FF
      when "000110011110111" =>  data <= "11111111";  -- CF7 = FF
      when "000110011111000" =>  data <= "11111111";  -- CF8 = FF
      when "000110011111001" =>  data <= "11111111";  -- CF9 = FF
      when "000110011111010" =>  data <= "11111111";  -- CFA = FF
      when "000110011111011" =>  data <= "11111111";  -- CFB = FF
      when "000110011111100" =>  data <= "11111111";  -- CFC = FF
      when "000110011111101" =>  data <= "11111111";  -- CFD = FF
      when "000110011111110" =>  data <= "11111111";  -- CFE = FF
      when "000110011111111" =>  data <= "11111111";  -- CFF = FF
      when "000110100000000" =>  data <= "11111111";  -- D00 = FF
      when "000110100000001" =>  data <= "11111111";  -- D01 = FF
      when "000110100000010" =>  data <= "11111111";  -- D02 = FF
      when "000110100000011" =>  data <= "11111111";  -- D03 = FF
      when "000110100000100" =>  data <= "11111111";  -- D04 = FF
      when "000110100000101" =>  data <= "11111111";  -- D05 = FF
      when "000110100000110" =>  data <= "11111111";  -- D06 = FF
      when "000110100000111" =>  data <= "11111111";  -- D07 = FF
      when "000110100001000" =>  data <= "11111111";  -- D08 = FF
      when "000110100001001" =>  data <= "11111111";  -- D09 = FF
      when "000110100001010" =>  data <= "11111111";  -- D0A = FF
      when "000110100001011" =>  data <= "11111111";  -- D0B = FF
      when "000110100001100" =>  data <= "11111111";  -- D0C = FF
      when "000110100001101" =>  data <= "11111111";  -- D0D = FF
      when "000110100001110" =>  data <= "11111111";  -- D0E = FF
      when "000110100001111" =>  data <= "11111111";  -- D0F = FF
      when "000110100010000" =>  data <= "11111111";  -- D10 = FF
      when "000110100010001" =>  data <= "11111111";  -- D11 = FF
      when "000110100010010" =>  data <= "11111111";  -- D12 = FF
      when "000110100010011" =>  data <= "11111111";  -- D13 = FF
      when "000110100010100" =>  data <= "11111111";  -- D14 = FF
      when "000110100010101" =>  data <= "11111111";  -- D15 = FF
      when "000110100010110" =>  data <= "11111111";  -- D16 = FF
      when "000110100010111" =>  data <= "11111111";  -- D17 = FF
      when "000110100011000" =>  data <= "11111111";  -- D18 = FF
      when "000110100011001" =>  data <= "11111111";  -- D19 = FF
      when "000110100011010" =>  data <= "11111111";  -- D1A = FF
      when "000110100011011" =>  data <= "11111111";  -- D1B = FF
      when "000110100011100" =>  data <= "11111111";  -- D1C = FF
      when "000110100011101" =>  data <= "11111111";  -- D1D = FF
      when "000110100011110" =>  data <= "11111111";  -- D1E = FF
      when "000110100011111" =>  data <= "11111111";  -- D1F = FF
      when "000110100100000" =>  data <= "11111111";  -- D20 = FF
      when "000110100100001" =>  data <= "11111111";  -- D21 = FF
      when "000110100100010" =>  data <= "11111111";  -- D22 = FF
      when "000110100100011" =>  data <= "11111111";  -- D23 = FF
      when "000110100100100" =>  data <= "11111111";  -- D24 = FF
      when "000110100100101" =>  data <= "11111111";  -- D25 = FF
      when "000110100100110" =>  data <= "11111111";  -- D26 = FF
      when "000110100100111" =>  data <= "11111111";  -- D27 = FF
      when "000110100101000" =>  data <= "11111111";  -- D28 = FF
      when "000110100101001" =>  data <= "11111111";  -- D29 = FF
      when "000110100101010" =>  data <= "11111111";  -- D2A = FF
      when "000110100101011" =>  data <= "11111111";  -- D2B = FF
      when "000110100101100" =>  data <= "11111111";  -- D2C = FF
      when "000110100101101" =>  data <= "11111111";  -- D2D = FF
      when "000110100101110" =>  data <= "11111111";  -- D2E = FF
      when "000110100101111" =>  data <= "11111111";  -- D2F = FF
      when "000110100110000" =>  data <= "11111111";  -- D30 = FF
      when "000110100110001" =>  data <= "11111111";  -- D31 = FF
      when "000110100110010" =>  data <= "11111111";  -- D32 = FF
      when "000110100110011" =>  data <= "11111111";  -- D33 = FF
      when "000110100110100" =>  data <= "11111111";  -- D34 = FF
      when "000110100110101" =>  data <= "11111111";  -- D35 = FF
      when "000110100110110" =>  data <= "11111111";  -- D36 = FF
      when "000110100110111" =>  data <= "11111111";  -- D37 = FF
      when "000110100111000" =>  data <= "11111111";  -- D38 = FF
      when "000110100111001" =>  data <= "11111111";  -- D39 = FF
      when "000110100111010" =>  data <= "11111111";  -- D3A = FF
      when "000110100111011" =>  data <= "11111111";  -- D3B = FF
      when "000110100111100" =>  data <= "11111111";  -- D3C = FF
      when "000110100111101" =>  data <= "11111111";  -- D3D = FF
      when "000110100111110" =>  data <= "11111111";  -- D3E = FF
      when "000110100111111" =>  data <= "11111111";  -- D3F = FF
      when "000110101000000" =>  data <= "11111111";  -- D40 = FF
      when "000110101000001" =>  data <= "11111111";  -- D41 = FF
      when "000110101000010" =>  data <= "11111111";  -- D42 = FF
      when "000110101000011" =>  data <= "11111111";  -- D43 = FF
      when "000110101000100" =>  data <= "11111111";  -- D44 = FF
      when "000110101000101" =>  data <= "11111111";  -- D45 = FF
      when "000110101000110" =>  data <= "11111111";  -- D46 = FF
      when "000110101000111" =>  data <= "11111111";  -- D47 = FF
      when "000110101001000" =>  data <= "11111111";  -- D48 = FF
      when "000110101001001" =>  data <= "11111111";  -- D49 = FF
      when "000110101001010" =>  data <= "11111111";  -- D4A = FF
      when "000110101001011" =>  data <= "11111111";  -- D4B = FF
      when "000110101001100" =>  data <= "11111111";  -- D4C = FF
      when "000110101001101" =>  data <= "11111111";  -- D4D = FF
      when "000110101001110" =>  data <= "11111111";  -- D4E = FF
      when "000110101001111" =>  data <= "11111111";  -- D4F = FF
      when "000110101010000" =>  data <= "11111111";  -- D50 = FF
      when "000110101010001" =>  data <= "11111111";  -- D51 = FF
      when "000110101010010" =>  data <= "11111111";  -- D52 = FF
      when "000110101010011" =>  data <= "11111111";  -- D53 = FF
      when "000110101010100" =>  data <= "11111111";  -- D54 = FF
      when "000110101010101" =>  data <= "11111111";  -- D55 = FF
      when "000110101010110" =>  data <= "11111111";  -- D56 = FF
      when "000110101010111" =>  data <= "11111111";  -- D57 = FF
      when "000110101011000" =>  data <= "11111111";  -- D58 = FF
      when "000110101011001" =>  data <= "11111111";  -- D59 = FF
      when "000110101011010" =>  data <= "11111111";  -- D5A = FF
      when "000110101011011" =>  data <= "11111111";  -- D5B = FF
      when "000110101011100" =>  data <= "11111111";  -- D5C = FF
      when "000110101011101" =>  data <= "11111111";  -- D5D = FF
      when "000110101011110" =>  data <= "11111111";  -- D5E = FF
      when "000110101011111" =>  data <= "11111111";  -- D5F = FF
      when "000110101100000" =>  data <= "11111111";  -- D60 = FF
      when "000110101100001" =>  data <= "11111111";  -- D61 = FF
      when "000110101100010" =>  data <= "11111111";  -- D62 = FF
      when "000110101100011" =>  data <= "11111111";  -- D63 = FF
      when "000110101100100" =>  data <= "11111111";  -- D64 = FF
      when "000110101100101" =>  data <= "11111111";  -- D65 = FF
      when "000110101100110" =>  data <= "11111111";  -- D66 = FF
      when "000110101100111" =>  data <= "11111111";  -- D67 = FF
      when "000110101101000" =>  data <= "11111111";  -- D68 = FF
      when "000110101101001" =>  data <= "11111111";  -- D69 = FF
      when "000110101101010" =>  data <= "11111111";  -- D6A = FF
      when "000110101101011" =>  data <= "11111111";  -- D6B = FF
      when "000110101101100" =>  data <= "11111111";  -- D6C = FF
      when "000110101101101" =>  data <= "11111111";  -- D6D = FF
      when "000110101101110" =>  data <= "11111111";  -- D6E = FF
      when "000110101101111" =>  data <= "11111111";  -- D6F = FF
      when "000110101110000" =>  data <= "11111111";  -- D70 = FF
      when "000110101110001" =>  data <= "11111111";  -- D71 = FF
      when "000110101110010" =>  data <= "11111111";  -- D72 = FF
      when "000110101110011" =>  data <= "11111111";  -- D73 = FF
      when "000110101110100" =>  data <= "11111111";  -- D74 = FF
      when "000110101110101" =>  data <= "11111111";  -- D75 = FF
      when "000110101110110" =>  data <= "11111111";  -- D76 = FF
      when "000110101110111" =>  data <= "11111111";  -- D77 = FF
      when "000110101111000" =>  data <= "11111111";  -- D78 = FF
      when "000110101111001" =>  data <= "11111111";  -- D79 = FF
      when "000110101111010" =>  data <= "11111111";  -- D7A = FF
      when "000110101111011" =>  data <= "11111111";  -- D7B = FF
      when "000110101111100" =>  data <= "11111111";  -- D7C = FF
      when "000110101111101" =>  data <= "11111111";  -- D7D = FF
      when "000110101111110" =>  data <= "11111111";  -- D7E = FF
      when "000110101111111" =>  data <= "11111111";  -- D7F = FF
      when "000110110000000" =>  data <= "11111111";  -- D80 = FF
      when "000110110000001" =>  data <= "11111111";  -- D81 = FF
      when "000110110000010" =>  data <= "11111111";  -- D82 = FF
      when "000110110000011" =>  data <= "11111111";  -- D83 = FF
      when "000110110000100" =>  data <= "11111111";  -- D84 = FF
      when "000110110000101" =>  data <= "11111111";  -- D85 = FF
      when "000110110000110" =>  data <= "11111111";  -- D86 = FF
      when "000110110000111" =>  data <= "11111111";  -- D87 = FF
      when "000110110001000" =>  data <= "11111111";  -- D88 = FF
      when "000110110001001" =>  data <= "11111111";  -- D89 = FF
      when "000110110001010" =>  data <= "11111111";  -- D8A = FF
      when "000110110001011" =>  data <= "11111111";  -- D8B = FF
      when "000110110001100" =>  data <= "11111111";  -- D8C = FF
      when "000110110001101" =>  data <= "11111111";  -- D8D = FF
      when "000110110001110" =>  data <= "11111111";  -- D8E = FF
      when "000110110001111" =>  data <= "11111111";  -- D8F = FF
      when "000110110010000" =>  data <= "11111111";  -- D90 = FF
      when "000110110010001" =>  data <= "11111111";  -- D91 = FF
      when "000110110010010" =>  data <= "11111111";  -- D92 = FF
      when "000110110010011" =>  data <= "11111111";  -- D93 = FF
      when "000110110010100" =>  data <= "11111111";  -- D94 = FF
      when "000110110010101" =>  data <= "11111111";  -- D95 = FF
      when "000110110010110" =>  data <= "11111111";  -- D96 = FF
      when "000110110010111" =>  data <= "11111111";  -- D97 = FF
      when "000110110011000" =>  data <= "11111111";  -- D98 = FF
      when "000110110011001" =>  data <= "11111111";  -- D99 = FF
      when "000110110011010" =>  data <= "11111111";  -- D9A = FF
      when "000110110011011" =>  data <= "11111111";  -- D9B = FF
      when "000110110011100" =>  data <= "11111111";  -- D9C = FF
      when "000110110011101" =>  data <= "11111111";  -- D9D = FF
      when "000110110011110" =>  data <= "11111111";  -- D9E = FF
      when "000110110011111" =>  data <= "11111111";  -- D9F = FF
      when "000110110100000" =>  data <= "11111111";  -- DA0 = FF
      when "000110110100001" =>  data <= "11111111";  -- DA1 = FF
      when "000110110100010" =>  data <= "11111111";  -- DA2 = FF
      when "000110110100011" =>  data <= "11111111";  -- DA3 = FF
      when "000110110100100" =>  data <= "11111111";  -- DA4 = FF
      when "000110110100101" =>  data <= "11111111";  -- DA5 = FF
      when "000110110100110" =>  data <= "11111111";  -- DA6 = FF
      when "000110110100111" =>  data <= "11111111";  -- DA7 = FF
      when "000110110101000" =>  data <= "11111111";  -- DA8 = FF
      when "000110110101001" =>  data <= "11111111";  -- DA9 = FF
      when "000110110101010" =>  data <= "11111111";  -- DAA = FF
      when "000110110101011" =>  data <= "11111111";  -- DAB = FF
      when "000110110101100" =>  data <= "11111111";  -- DAC = FF
      when "000110110101101" =>  data <= "11111111";  -- DAD = FF
      when "000110110101110" =>  data <= "11111111";  -- DAE = FF
      when "000110110101111" =>  data <= "11111111";  -- DAF = FF
      when "000110110110000" =>  data <= "11111111";  -- DB0 = FF
      when "000110110110001" =>  data <= "11111111";  -- DB1 = FF
      when "000110110110010" =>  data <= "11111111";  -- DB2 = FF
      when "000110110110011" =>  data <= "11111111";  -- DB3 = FF
      when "000110110110100" =>  data <= "11111111";  -- DB4 = FF
      when "000110110110101" =>  data <= "11111111";  -- DB5 = FF
      when "000110110110110" =>  data <= "11111111";  -- DB6 = FF
      when "000110110110111" =>  data <= "11111111";  -- DB7 = FF
      when "000110110111000" =>  data <= "11111111";  -- DB8 = FF
      when "000110110111001" =>  data <= "11111111";  -- DB9 = FF
      when "000110110111010" =>  data <= "11111111";  -- DBA = FF
      when "000110110111011" =>  data <= "11111111";  -- DBB = FF
      when "000110110111100" =>  data <= "11111111";  -- DBC = FF
      when "000110110111101" =>  data <= "11111111";  -- DBD = FF
      when "000110110111110" =>  data <= "11111111";  -- DBE = FF
      when "000110110111111" =>  data <= "11111111";  -- DBF = FF
      when "000110111000000" =>  data <= "11111111";  -- DC0 = FF
      when "000110111000001" =>  data <= "11111111";  -- DC1 = FF
      when "000110111000010" =>  data <= "11111111";  -- DC2 = FF
      when "000110111000011" =>  data <= "11111111";  -- DC3 = FF
      when "000110111000100" =>  data <= "11111111";  -- DC4 = FF
      when "000110111000101" =>  data <= "11111111";  -- DC5 = FF
      when "000110111000110" =>  data <= "11111111";  -- DC6 = FF
      when "000110111000111" =>  data <= "11111111";  -- DC7 = FF
      when "000110111001000" =>  data <= "11111111";  -- DC8 = FF
      when "000110111001001" =>  data <= "11111111";  -- DC9 = FF
      when "000110111001010" =>  data <= "11111111";  -- DCA = FF
      when "000110111001011" =>  data <= "11111111";  -- DCB = FF
      when "000110111001100" =>  data <= "11111111";  -- DCC = FF
      when "000110111001101" =>  data <= "11111111";  -- DCD = FF
      when "000110111001110" =>  data <= "11111111";  -- DCE = FF
      when "000110111001111" =>  data <= "11111111";  -- DCF = FF
      when "000110111010000" =>  data <= "11111111";  -- DD0 = FF
      when "000110111010001" =>  data <= "11111111";  -- DD1 = FF
      when "000110111010010" =>  data <= "11111111";  -- DD2 = FF
      when "000110111010011" =>  data <= "11111111";  -- DD3 = FF
      when "000110111010100" =>  data <= "11111111";  -- DD4 = FF
      when "000110111010101" =>  data <= "11111111";  -- DD5 = FF
      when "000110111010110" =>  data <= "11111111";  -- DD6 = FF
      when "000110111010111" =>  data <= "11111111";  -- DD7 = FF
      when "000110111011000" =>  data <= "11111111";  -- DD8 = FF
      when "000110111011001" =>  data <= "11111111";  -- DD9 = FF
      when "000110111011010" =>  data <= "11111111";  -- DDA = FF
      when "000110111011011" =>  data <= "11111111";  -- DDB = FF
      when "000110111011100" =>  data <= "11111111";  -- DDC = FF
      when "000110111011101" =>  data <= "11111111";  -- DDD = FF
      when "000110111011110" =>  data <= "11111111";  -- DDE = FF
      when "000110111011111" =>  data <= "11111111";  -- DDF = FF
      when "000110111100000" =>  data <= "11111111";  -- DE0 = FF
      when "000110111100001" =>  data <= "11111111";  -- DE1 = FF
      when "000110111100010" =>  data <= "11111111";  -- DE2 = FF
      when "000110111100011" =>  data <= "11111111";  -- DE3 = FF
      when "000110111100100" =>  data <= "11111111";  -- DE4 = FF
      when "000110111100101" =>  data <= "11111111";  -- DE5 = FF
      when "000110111100110" =>  data <= "11111111";  -- DE6 = FF
      when "000110111100111" =>  data <= "11111111";  -- DE7 = FF
      when "000110111101000" =>  data <= "11111111";  -- DE8 = FF
      when "000110111101001" =>  data <= "11111111";  -- DE9 = FF
      when "000110111101010" =>  data <= "11111111";  -- DEA = FF
      when "000110111101011" =>  data <= "11111111";  -- DEB = FF
      when "000110111101100" =>  data <= "11111111";  -- DEC = FF
      when "000110111101101" =>  data <= "11111111";  -- DED = FF
      when "000110111101110" =>  data <= "11111111";  -- DEE = FF
      when "000110111101111" =>  data <= "11111111";  -- DEF = FF
      when "000110111110000" =>  data <= "11111111";  -- DF0 = FF
      when "000110111110001" =>  data <= "11111111";  -- DF1 = FF
      when "000110111110010" =>  data <= "11111111";  -- DF2 = FF
      when "000110111110011" =>  data <= "11111111";  -- DF3 = FF
      when "000110111110100" =>  data <= "11111111";  -- DF4 = FF
      when "000110111110101" =>  data <= "11111111";  -- DF5 = FF
      when "000110111110110" =>  data <= "11111111";  -- DF6 = FF
      when "000110111110111" =>  data <= "11111111";  -- DF7 = FF
      when "000110111111000" =>  data <= "11111111";  -- DF8 = FF
      when "000110111111001" =>  data <= "11111111";  -- DF9 = FF
      when "000110111111010" =>  data <= "11111111";  -- DFA = FF
      when "000110111111011" =>  data <= "11111111";  -- DFB = FF
      when "000110111111100" =>  data <= "11111111";  -- DFC = FF
      when "000110111111101" =>  data <= "11111111";  -- DFD = FF
      when "000110111111110" =>  data <= "11111111";  -- DFE = FF
      when "000110111111111" =>  data <= "11111111";  -- DFF = FF
      when "000111000000000" =>  data <= "11111111";  -- E00 = FF
      when "000111000000001" =>  data <= "11111111";  -- E01 = FF
      when "000111000000010" =>  data <= "11111111";  -- E02 = FF
      when "000111000000011" =>  data <= "11111111";  -- E03 = FF
      when "000111000000100" =>  data <= "11111111";  -- E04 = FF
      when "000111000000101" =>  data <= "11111111";  -- E05 = FF
      when "000111000000110" =>  data <= "11111111";  -- E06 = FF
      when "000111000000111" =>  data <= "11111111";  -- E07 = FF
      when "000111000001000" =>  data <= "11111111";  -- E08 = FF
      when "000111000001001" =>  data <= "11111111";  -- E09 = FF
      when "000111000001010" =>  data <= "11111111";  -- E0A = FF
      when "000111000001011" =>  data <= "11111111";  -- E0B = FF
      when "000111000001100" =>  data <= "11111111";  -- E0C = FF
      when "000111000001101" =>  data <= "11111111";  -- E0D = FF
      when "000111000001110" =>  data <= "11111111";  -- E0E = FF
      when "000111000001111" =>  data <= "11111111";  -- E0F = FF
      when "000111000010000" =>  data <= "11111111";  -- E10 = FF
      when "000111000010001" =>  data <= "11111111";  -- E11 = FF
      when "000111000010010" =>  data <= "11111111";  -- E12 = FF
      when "000111000010011" =>  data <= "11111111";  -- E13 = FF
      when "000111000010100" =>  data <= "11111111";  -- E14 = FF
      when "000111000010101" =>  data <= "11111111";  -- E15 = FF
      when "000111000010110" =>  data <= "11111111";  -- E16 = FF
      when "000111000010111" =>  data <= "11111111";  -- E17 = FF
      when "000111000011000" =>  data <= "11111111";  -- E18 = FF
      when "000111000011001" =>  data <= "11111111";  -- E19 = FF
      when "000111000011010" =>  data <= "11111111";  -- E1A = FF
      when "000111000011011" =>  data <= "11111111";  -- E1B = FF
      when "000111000011100" =>  data <= "11111111";  -- E1C = FF
      when "000111000011101" =>  data <= "11111111";  -- E1D = FF
      when "000111000011110" =>  data <= "11111111";  -- E1E = FF
      when "000111000011111" =>  data <= "11111111";  -- E1F = FF
      when "000111000100000" =>  data <= "11111111";  -- E20 = FF
      when "000111000100001" =>  data <= "11111111";  -- E21 = FF
      when "000111000100010" =>  data <= "11111111";  -- E22 = FF
      when "000111000100011" =>  data <= "11111111";  -- E23 = FF
      when "000111000100100" =>  data <= "11111111";  -- E24 = FF
      when "000111000100101" =>  data <= "11111111";  -- E25 = FF
      when "000111000100110" =>  data <= "11111111";  -- E26 = FF
      when "000111000100111" =>  data <= "11111111";  -- E27 = FF
      when "000111000101000" =>  data <= "11111111";  -- E28 = FF
      when "000111000101001" =>  data <= "11111111";  -- E29 = FF
      when "000111000101010" =>  data <= "11111111";  -- E2A = FF
      when "000111000101011" =>  data <= "11111111";  -- E2B = FF
      when "000111000101100" =>  data <= "11111111";  -- E2C = FF
      when "000111000101101" =>  data <= "11111111";  -- E2D = FF
      when "000111000101110" =>  data <= "11111111";  -- E2E = FF
      when "000111000101111" =>  data <= "11111111";  -- E2F = FF
      when "000111000110000" =>  data <= "11111111";  -- E30 = FF
      when "000111000110001" =>  data <= "11111111";  -- E31 = FF
      when "000111000110010" =>  data <= "11111111";  -- E32 = FF
      when "000111000110011" =>  data <= "11111111";  -- E33 = FF
      when "000111000110100" =>  data <= "11111111";  -- E34 = FF
      when "000111000110101" =>  data <= "11111111";  -- E35 = FF
      when "000111000110110" =>  data <= "11111111";  -- E36 = FF
      when "000111000110111" =>  data <= "11111111";  -- E37 = FF
      when "000111000111000" =>  data <= "11111111";  -- E38 = FF
      when "000111000111001" =>  data <= "11111111";  -- E39 = FF
      when "000111000111010" =>  data <= "11111111";  -- E3A = FF
      when "000111000111011" =>  data <= "11111111";  -- E3B = FF
      when "000111000111100" =>  data <= "11111111";  -- E3C = FF
      when "000111000111101" =>  data <= "11111111";  -- E3D = FF
      when "000111000111110" =>  data <= "11111111";  -- E3E = FF
      when "000111000111111" =>  data <= "11111111";  -- E3F = FF
      when "000111001000000" =>  data <= "11111111";  -- E40 = FF
      when "000111001000001" =>  data <= "11111111";  -- E41 = FF
      when "000111001000010" =>  data <= "11111111";  -- E42 = FF
      when "000111001000011" =>  data <= "11111111";  -- E43 = FF
      when "000111001000100" =>  data <= "11111111";  -- E44 = FF
      when "000111001000101" =>  data <= "11111111";  -- E45 = FF
      when "000111001000110" =>  data <= "11111111";  -- E46 = FF
      when "000111001000111" =>  data <= "11111111";  -- E47 = FF
      when "000111001001000" =>  data <= "11111111";  -- E48 = FF
      when "000111001001001" =>  data <= "11111111";  -- E49 = FF
      when "000111001001010" =>  data <= "11111111";  -- E4A = FF
      when "000111001001011" =>  data <= "11111111";  -- E4B = FF
      when "000111001001100" =>  data <= "11111111";  -- E4C = FF
      when "000111001001101" =>  data <= "11111111";  -- E4D = FF
      when "000111001001110" =>  data <= "11111111";  -- E4E = FF
      when "000111001001111" =>  data <= "11111111";  -- E4F = FF
      when "000111001010000" =>  data <= "11111111";  -- E50 = FF
      when "000111001010001" =>  data <= "11111111";  -- E51 = FF
      when "000111001010010" =>  data <= "11111111";  -- E52 = FF
      when "000111001010011" =>  data <= "11111111";  -- E53 = FF
      when "000111001010100" =>  data <= "11111111";  -- E54 = FF
      when "000111001010101" =>  data <= "11111111";  -- E55 = FF
      when "000111001010110" =>  data <= "11111111";  -- E56 = FF
      when "000111001010111" =>  data <= "11111111";  -- E57 = FF
      when "000111001011000" =>  data <= "11111111";  -- E58 = FF
      when "000111001011001" =>  data <= "11111111";  -- E59 = FF
      when "000111001011010" =>  data <= "11111111";  -- E5A = FF
      when "000111001011011" =>  data <= "11111111";  -- E5B = FF
      when "000111001011100" =>  data <= "11111111";  -- E5C = FF
      when "000111001011101" =>  data <= "11111111";  -- E5D = FF
      when "000111001011110" =>  data <= "11111111";  -- E5E = FF
      when "000111001011111" =>  data <= "11111111";  -- E5F = FF
      when "000111001100000" =>  data <= "11111111";  -- E60 = FF
      when "000111001100001" =>  data <= "11111111";  -- E61 = FF
      when "000111001100010" =>  data <= "11111111";  -- E62 = FF
      when "000111001100011" =>  data <= "11111111";  -- E63 = FF
      when "000111001100100" =>  data <= "11111111";  -- E64 = FF
      when "000111001100101" =>  data <= "11111111";  -- E65 = FF
      when "000111001100110" =>  data <= "11111111";  -- E66 = FF
      when "000111001100111" =>  data <= "11111111";  -- E67 = FF
      when "000111001101000" =>  data <= "11111111";  -- E68 = FF
      when "000111001101001" =>  data <= "11111111";  -- E69 = FF
      when "000111001101010" =>  data <= "11111111";  -- E6A = FF
      when "000111001101011" =>  data <= "11111111";  -- E6B = FF
      when "000111001101100" =>  data <= "11111111";  -- E6C = FF
      when "000111001101101" =>  data <= "11111111";  -- E6D = FF
      when "000111001101110" =>  data <= "11111111";  -- E6E = FF
      when "000111001101111" =>  data <= "11111111";  -- E6F = FF
      when "000111001110000" =>  data <= "11111111";  -- E70 = FF
      when "000111001110001" =>  data <= "11111111";  -- E71 = FF
      when "000111001110010" =>  data <= "11111111";  -- E72 = FF
      when "000111001110011" =>  data <= "11111111";  -- E73 = FF
      when "000111001110100" =>  data <= "11111111";  -- E74 = FF
      when "000111001110101" =>  data <= "11111111";  -- E75 = FF
      when "000111001110110" =>  data <= "11111111";  -- E76 = FF
      when "000111001110111" =>  data <= "11111111";  -- E77 = FF
      when "000111001111000" =>  data <= "11111111";  -- E78 = FF
      when "000111001111001" =>  data <= "11111111";  -- E79 = FF
      when "000111001111010" =>  data <= "11111111";  -- E7A = FF
      when "000111001111011" =>  data <= "11111111";  -- E7B = FF
      when "000111001111100" =>  data <= "11111111";  -- E7C = FF
      when "000111001111101" =>  data <= "11111111";  -- E7D = FF
      when "000111001111110" =>  data <= "11111111";  -- E7E = FF
      when "000111001111111" =>  data <= "11111111";  -- E7F = FF
      when "000111010000000" =>  data <= "11111111";  -- E80 = FF
      when "000111010000001" =>  data <= "11111111";  -- E81 = FF
      when "000111010000010" =>  data <= "11111111";  -- E82 = FF
      when "000111010000011" =>  data <= "11111111";  -- E83 = FF
      when "000111010000100" =>  data <= "11111111";  -- E84 = FF
      when "000111010000101" =>  data <= "11111111";  -- E85 = FF
      when "000111010000110" =>  data <= "11111111";  -- E86 = FF
      when "000111010000111" =>  data <= "11111111";  -- E87 = FF
      when "000111010001000" =>  data <= "11111111";  -- E88 = FF
      when "000111010001001" =>  data <= "11111111";  -- E89 = FF
      when "000111010001010" =>  data <= "11111111";  -- E8A = FF
      when "000111010001011" =>  data <= "11111111";  -- E8B = FF
      when "000111010001100" =>  data <= "11111111";  -- E8C = FF
      when "000111010001101" =>  data <= "11111111";  -- E8D = FF
      when "000111010001110" =>  data <= "11111111";  -- E8E = FF
      when "000111010001111" =>  data <= "11111111";  -- E8F = FF
      when "000111010010000" =>  data <= "11111111";  -- E90 = FF
      when "000111010010001" =>  data <= "11111111";  -- E91 = FF
      when "000111010010010" =>  data <= "11111111";  -- E92 = FF
      when "000111010010011" =>  data <= "11111111";  -- E93 = FF
      when "000111010010100" =>  data <= "11111111";  -- E94 = FF
      when "000111010010101" =>  data <= "11111111";  -- E95 = FF
      when "000111010010110" =>  data <= "11111111";  -- E96 = FF
      when "000111010010111" =>  data <= "11111111";  -- E97 = FF
      when "000111010011000" =>  data <= "11111111";  -- E98 = FF
      when "000111010011001" =>  data <= "11111111";  -- E99 = FF
      when "000111010011010" =>  data <= "11111111";  -- E9A = FF
      when "000111010011011" =>  data <= "11111111";  -- E9B = FF
      when "000111010011100" =>  data <= "11111111";  -- E9C = FF
      when "000111010011101" =>  data <= "11111111";  -- E9D = FF
      when "000111010011110" =>  data <= "11111111";  -- E9E = FF
      when "000111010011111" =>  data <= "11111111";  -- E9F = FF
      when "000111010100000" =>  data <= "11111111";  -- EA0 = FF
      when "000111010100001" =>  data <= "11111111";  -- EA1 = FF
      when "000111010100010" =>  data <= "11111111";  -- EA2 = FF
      when "000111010100011" =>  data <= "11111111";  -- EA3 = FF
      when "000111010100100" =>  data <= "11111111";  -- EA4 = FF
      when "000111010100101" =>  data <= "11111111";  -- EA5 = FF
      when "000111010100110" =>  data <= "11111111";  -- EA6 = FF
      when "000111010100111" =>  data <= "11111111";  -- EA7 = FF
      when "000111010101000" =>  data <= "11111111";  -- EA8 = FF
      when "000111010101001" =>  data <= "11111111";  -- EA9 = FF
      when "000111010101010" =>  data <= "11111111";  -- EAA = FF
      when "000111010101011" =>  data <= "11111111";  -- EAB = FF
      when "000111010101100" =>  data <= "11111111";  -- EAC = FF
      when "000111010101101" =>  data <= "11111111";  -- EAD = FF
      when "000111010101110" =>  data <= "11111111";  -- EAE = FF
      when "000111010101111" =>  data <= "11111111";  -- EAF = FF
      when "000111010110000" =>  data <= "11111111";  -- EB0 = FF
      when "000111010110001" =>  data <= "11111111";  -- EB1 = FF
      when "000111010110010" =>  data <= "11111111";  -- EB2 = FF
      when "000111010110011" =>  data <= "11111111";  -- EB3 = FF
      when "000111010110100" =>  data <= "11111111";  -- EB4 = FF
      when "000111010110101" =>  data <= "11111111";  -- EB5 = FF
      when "000111010110110" =>  data <= "11111111";  -- EB6 = FF
      when "000111010110111" =>  data <= "11111111";  -- EB7 = FF
      when "000111010111000" =>  data <= "11111111";  -- EB8 = FF
      when "000111010111001" =>  data <= "11111111";  -- EB9 = FF
      when "000111010111010" =>  data <= "11111111";  -- EBA = FF
      when "000111010111011" =>  data <= "11111111";  -- EBB = FF
      when "000111010111100" =>  data <= "11111111";  -- EBC = FF
      when "000111010111101" =>  data <= "11111111";  -- EBD = FF
      when "000111010111110" =>  data <= "11111111";  -- EBE = FF
      when "000111010111111" =>  data <= "11111111";  -- EBF = FF
      when "000111011000000" =>  data <= "11111111";  -- EC0 = FF
      when "000111011000001" =>  data <= "11111111";  -- EC1 = FF
      when "000111011000010" =>  data <= "11111111";  -- EC2 = FF
      when "000111011000011" =>  data <= "11111111";  -- EC3 = FF
      when "000111011000100" =>  data <= "11111111";  -- EC4 = FF
      when "000111011000101" =>  data <= "11111111";  -- EC5 = FF
      when "000111011000110" =>  data <= "11111111";  -- EC6 = FF
      when "000111011000111" =>  data <= "11111111";  -- EC7 = FF
      when "000111011001000" =>  data <= "11111111";  -- EC8 = FF
      when "000111011001001" =>  data <= "11111111";  -- EC9 = FF
      when "000111011001010" =>  data <= "11111111";  -- ECA = FF
      when "000111011001011" =>  data <= "11111111";  -- ECB = FF
      when "000111011001100" =>  data <= "11111111";  -- ECC = FF
      when "000111011001101" =>  data <= "11111111";  -- ECD = FF
      when "000111011001110" =>  data <= "11111111";  -- ECE = FF
      when "000111011001111" =>  data <= "11111111";  -- ECF = FF
      when "000111011010000" =>  data <= "11111111";  -- ED0 = FF
      when "000111011010001" =>  data <= "11111111";  -- ED1 = FF
      when "000111011010010" =>  data <= "11111111";  -- ED2 = FF
      when "000111011010011" =>  data <= "11111111";  -- ED3 = FF
      when "000111011010100" =>  data <= "11111111";  -- ED4 = FF
      when "000111011010101" =>  data <= "11111111";  -- ED5 = FF
      when "000111011010110" =>  data <= "11111111";  -- ED6 = FF
      when "000111011010111" =>  data <= "11111111";  -- ED7 = FF
      when "000111011011000" =>  data <= "11111111";  -- ED8 = FF
      when "000111011011001" =>  data <= "11111111";  -- ED9 = FF
      when "000111011011010" =>  data <= "11111111";  -- EDA = FF
      when "000111011011011" =>  data <= "11111111";  -- EDB = FF
      when "000111011011100" =>  data <= "11111111";  -- EDC = FF
      when "000111011011101" =>  data <= "11111111";  -- EDD = FF
      when "000111011011110" =>  data <= "11111111";  -- EDE = FF
      when "000111011011111" =>  data <= "11111111";  -- EDF = FF
      when "000111011100000" =>  data <= "11111111";  -- EE0 = FF
      when "000111011100001" =>  data <= "11111111";  -- EE1 = FF
      when "000111011100010" =>  data <= "11111111";  -- EE2 = FF
      when "000111011100011" =>  data <= "11111111";  -- EE3 = FF
      when "000111011100100" =>  data <= "11111111";  -- EE4 = FF
      when "000111011100101" =>  data <= "11111111";  -- EE5 = FF
      when "000111011100110" =>  data <= "11111111";  -- EE6 = FF
      when "000111011100111" =>  data <= "11111111";  -- EE7 = FF
      when "000111011101000" =>  data <= "11111111";  -- EE8 = FF
      when "000111011101001" =>  data <= "11111111";  -- EE9 = FF
      when "000111011101010" =>  data <= "11111111";  -- EEA = FF
      when "000111011101011" =>  data <= "11111111";  -- EEB = FF
      when "000111011101100" =>  data <= "11111111";  -- EEC = FF
      when "000111011101101" =>  data <= "11111111";  -- EED = FF
      when "000111011101110" =>  data <= "11111111";  -- EEE = FF
      when "000111011101111" =>  data <= "11111111";  -- EEF = FF
      when "000111011110000" =>  data <= "11111111";  -- EF0 = FF
      when "000111011110001" =>  data <= "11111111";  -- EF1 = FF
      when "000111011110010" =>  data <= "11111111";  -- EF2 = FF
      when "000111011110011" =>  data <= "11111111";  -- EF3 = FF
      when "000111011110100" =>  data <= "11111111";  -- EF4 = FF
      when "000111011110101" =>  data <= "11111111";  -- EF5 = FF
      when "000111011110110" =>  data <= "11111111";  -- EF6 = FF
      when "000111011110111" =>  data <= "11111111";  -- EF7 = FF
      when "000111011111000" =>  data <= "11111111";  -- EF8 = FF
      when "000111011111001" =>  data <= "11111111";  -- EF9 = FF
      when "000111011111010" =>  data <= "11111111";  -- EFA = FF
      when "000111011111011" =>  data <= "11111111";  -- EFB = FF
      when "000111011111100" =>  data <= "11111111";  -- EFC = FF
      when "000111011111101" =>  data <= "11111111";  -- EFD = FF
      when "000111011111110" =>  data <= "11111111";  -- EFE = FF
      when "000111011111111" =>  data <= "11111111";  -- EFF = FF
      when "000111100000000" =>  data <= "11111111";  -- F00 = FF
      when "000111100000001" =>  data <= "11111111";  -- F01 = FF
      when "000111100000010" =>  data <= "11111111";  -- F02 = FF
      when "000111100000011" =>  data <= "11111111";  -- F03 = FF
      when "000111100000100" =>  data <= "11111111";  -- F04 = FF
      when "000111100000101" =>  data <= "11111111";  -- F05 = FF
      when "000111100000110" =>  data <= "11111111";  -- F06 = FF
      when "000111100000111" =>  data <= "11111111";  -- F07 = FF
      when "000111100001000" =>  data <= "11111111";  -- F08 = FF
      when "000111100001001" =>  data <= "11111111";  -- F09 = FF
      when "000111100001010" =>  data <= "11111111";  -- F0A = FF
      when "000111100001011" =>  data <= "11111111";  -- F0B = FF
      when "000111100001100" =>  data <= "11111111";  -- F0C = FF
      when "000111100001101" =>  data <= "11111111";  -- F0D = FF
      when "000111100001110" =>  data <= "11111111";  -- F0E = FF
      when "000111100001111" =>  data <= "11111111";  -- F0F = FF
      when "000111100010000" =>  data <= "11111111";  -- F10 = FF
      when "000111100010001" =>  data <= "11111111";  -- F11 = FF
      when "000111100010010" =>  data <= "11111111";  -- F12 = FF
      when "000111100010011" =>  data <= "11111111";  -- F13 = FF
      when "000111100010100" =>  data <= "11111111";  -- F14 = FF
      when "000111100010101" =>  data <= "11111111";  -- F15 = FF
      when "000111100010110" =>  data <= "11111111";  -- F16 = FF
      when "000111100010111" =>  data <= "11111111";  -- F17 = FF
      when "000111100011000" =>  data <= "11111111";  -- F18 = FF
      when "000111100011001" =>  data <= "11111111";  -- F19 = FF
      when "000111100011010" =>  data <= "11111111";  -- F1A = FF
      when "000111100011011" =>  data <= "11111111";  -- F1B = FF
      when "000111100011100" =>  data <= "11111111";  -- F1C = FF
      when "000111100011101" =>  data <= "11111111";  -- F1D = FF
      when "000111100011110" =>  data <= "11111111";  -- F1E = FF
      when "000111100011111" =>  data <= "11111111";  -- F1F = FF
      when "000111100100000" =>  data <= "11111111";  -- F20 = FF
      when "000111100100001" =>  data <= "11111111";  -- F21 = FF
      when "000111100100010" =>  data <= "11111111";  -- F22 = FF
      when "000111100100011" =>  data <= "11111111";  -- F23 = FF
      when "000111100100100" =>  data <= "11111111";  -- F24 = FF
      when "000111100100101" =>  data <= "11111111";  -- F25 = FF
      when "000111100100110" =>  data <= "11111111";  -- F26 = FF
      when "000111100100111" =>  data <= "11111111";  -- F27 = FF
      when "000111100101000" =>  data <= "11111111";  -- F28 = FF
      when "000111100101001" =>  data <= "11111111";  -- F29 = FF
      when "000111100101010" =>  data <= "11111111";  -- F2A = FF
      when "000111100101011" =>  data <= "11111111";  -- F2B = FF
      when "000111100101100" =>  data <= "11111111";  -- F2C = FF
      when "000111100101101" =>  data <= "11111111";  -- F2D = FF
      when "000111100101110" =>  data <= "11111111";  -- F2E = FF
      when "000111100101111" =>  data <= "11111111";  -- F2F = FF
      when "000111100110000" =>  data <= "11111111";  -- F30 = FF
      when "000111100110001" =>  data <= "11111111";  -- F31 = FF
      when "000111100110010" =>  data <= "11111111";  -- F32 = FF
      when "000111100110011" =>  data <= "11111111";  -- F33 = FF
      when "000111100110100" =>  data <= "11111111";  -- F34 = FF
      when "000111100110101" =>  data <= "11111111";  -- F35 = FF
      when "000111100110110" =>  data <= "11111111";  -- F36 = FF
      when "000111100110111" =>  data <= "11111111";  -- F37 = FF
      when "000111100111000" =>  data <= "11111111";  -- F38 = FF
      when "000111100111001" =>  data <= "11111111";  -- F39 = FF
      when "000111100111010" =>  data <= "11111111";  -- F3A = FF
      when "000111100111011" =>  data <= "11111111";  -- F3B = FF
      when "000111100111100" =>  data <= "11111111";  -- F3C = FF
      when "000111100111101" =>  data <= "11111111";  -- F3D = FF
      when "000111100111110" =>  data <= "11111111";  -- F3E = FF
      when "000111100111111" =>  data <= "11111111";  -- F3F = FF
      when "000111101000000" =>  data <= "11111111";  -- F40 = FF
      when "000111101000001" =>  data <= "11111111";  -- F41 = FF
      when "000111101000010" =>  data <= "11111111";  -- F42 = FF
      when "000111101000011" =>  data <= "11111111";  -- F43 = FF
      when "000111101000100" =>  data <= "11111111";  -- F44 = FF
      when "000111101000101" =>  data <= "11111111";  -- F45 = FF
      when "000111101000110" =>  data <= "11111111";  -- F46 = FF
      when "000111101000111" =>  data <= "11111111";  -- F47 = FF
      when "000111101001000" =>  data <= "11111111";  -- F48 = FF
      when "000111101001001" =>  data <= "11111111";  -- F49 = FF
      when "000111101001010" =>  data <= "11111111";  -- F4A = FF
      when "000111101001011" =>  data <= "11111111";  -- F4B = FF
      when "000111101001100" =>  data <= "11111111";  -- F4C = FF
      when "000111101001101" =>  data <= "11111111";  -- F4D = FF
      when "000111101001110" =>  data <= "11111111";  -- F4E = FF
      when "000111101001111" =>  data <= "11111111";  -- F4F = FF
      when "000111101010000" =>  data <= "11111111";  -- F50 = FF
      when "000111101010001" =>  data <= "11111111";  -- F51 = FF
      when "000111101010010" =>  data <= "11111111";  -- F52 = FF
      when "000111101010011" =>  data <= "11111111";  -- F53 = FF
      when "000111101010100" =>  data <= "11111111";  -- F54 = FF
      when "000111101010101" =>  data <= "11111111";  -- F55 = FF
      when "000111101010110" =>  data <= "11111111";  -- F56 = FF
      when "000111101010111" =>  data <= "11111111";  -- F57 = FF
      when "000111101011000" =>  data <= "11111111";  -- F58 = FF
      when "000111101011001" =>  data <= "11111111";  -- F59 = FF
      when "000111101011010" =>  data <= "11111111";  -- F5A = FF
      when "000111101011011" =>  data <= "11111111";  -- F5B = FF
      when "000111101011100" =>  data <= "11111111";  -- F5C = FF
      when "000111101011101" =>  data <= "11111111";  -- F5D = FF
      when "000111101011110" =>  data <= "11111111";  -- F5E = FF
      when "000111101011111" =>  data <= "11111111";  -- F5F = FF
      when "000111101100000" =>  data <= "11111111";  -- F60 = FF
      when "000111101100001" =>  data <= "11111111";  -- F61 = FF
      when "000111101100010" =>  data <= "11111111";  -- F62 = FF
      when "000111101100011" =>  data <= "11111111";  -- F63 = FF
      when "000111101100100" =>  data <= "11111111";  -- F64 = FF
      when "000111101100101" =>  data <= "11111111";  -- F65 = FF
      when "000111101100110" =>  data <= "11111111";  -- F66 = FF
      when "000111101100111" =>  data <= "11111111";  -- F67 = FF
      when "000111101101000" =>  data <= "11111111";  -- F68 = FF
      when "000111101101001" =>  data <= "11111111";  -- F69 = FF
      when "000111101101010" =>  data <= "11111111";  -- F6A = FF
      when "000111101101011" =>  data <= "11111111";  -- F6B = FF
      when "000111101101100" =>  data <= "11111111";  -- F6C = FF
      when "000111101101101" =>  data <= "11111111";  -- F6D = FF
      when "000111101101110" =>  data <= "11111111";  -- F6E = FF
      when "000111101101111" =>  data <= "11111111";  -- F6F = FF
      when "000111101110000" =>  data <= "11111111";  -- F70 = FF
      when "000111101110001" =>  data <= "11111111";  -- F71 = FF
      when "000111101110010" =>  data <= "11111111";  -- F72 = FF
      when "000111101110011" =>  data <= "11111111";  -- F73 = FF
      when "000111101110100" =>  data <= "11111111";  -- F74 = FF
      when "000111101110101" =>  data <= "11111111";  -- F75 = FF
      when "000111101110110" =>  data <= "11111111";  -- F76 = FF
      when "000111101110111" =>  data <= "11111111";  -- F77 = FF
      when "000111101111000" =>  data <= "11111111";  -- F78 = FF
      when "000111101111001" =>  data <= "11111111";  -- F79 = FF
      when "000111101111010" =>  data <= "11111111";  -- F7A = FF
      when "000111101111011" =>  data <= "11111111";  -- F7B = FF
      when "000111101111100" =>  data <= "11111111";  -- F7C = FF
      when "000111101111101" =>  data <= "11111111";  -- F7D = FF
      when "000111101111110" =>  data <= "11111111";  -- F7E = FF
      when "000111101111111" =>  data <= "11111111";  -- F7F = FF
      when "000111110000000" =>  data <= "11111111";  -- F80 = FF
      when "000111110000001" =>  data <= "11111111";  -- F81 = FF
      when "000111110000010" =>  data <= "11111111";  -- F82 = FF
      when "000111110000011" =>  data <= "11111111";  -- F83 = FF
      when "000111110000100" =>  data <= "11111111";  -- F84 = FF
      when "000111110000101" =>  data <= "11111111";  -- F85 = FF
      when "000111110000110" =>  data <= "11111111";  -- F86 = FF
      when "000111110000111" =>  data <= "11111111";  -- F87 = FF
      when "000111110001000" =>  data <= "11111111";  -- F88 = FF
      when "000111110001001" =>  data <= "11111111";  -- F89 = FF
      when "000111110001010" =>  data <= "11111111";  -- F8A = FF
      when "000111110001011" =>  data <= "11111111";  -- F8B = FF
      when "000111110001100" =>  data <= "11111111";  -- F8C = FF
      when "000111110001101" =>  data <= "11111111";  -- F8D = FF
      when "000111110001110" =>  data <= "11111111";  -- F8E = FF
      when "000111110001111" =>  data <= "11111111";  -- F8F = FF
      when "000111110010000" =>  data <= "11111111";  -- F90 = FF
      when "000111110010001" =>  data <= "11111111";  -- F91 = FF
      when "000111110010010" =>  data <= "11111111";  -- F92 = FF
      when "000111110010011" =>  data <= "11111111";  -- F93 = FF
      when "000111110010100" =>  data <= "11111111";  -- F94 = FF
      when "000111110010101" =>  data <= "11111111";  -- F95 = FF
      when "000111110010110" =>  data <= "11111111";  -- F96 = FF
      when "000111110010111" =>  data <= "11111111";  -- F97 = FF
      when "000111110011000" =>  data <= "11111111";  -- F98 = FF
      when "000111110011001" =>  data <= "11111111";  -- F99 = FF
      when "000111110011010" =>  data <= "11111111";  -- F9A = FF
      when "000111110011011" =>  data <= "11111111";  -- F9B = FF
      when "000111110011100" =>  data <= "11111111";  -- F9C = FF
      when "000111110011101" =>  data <= "11111111";  -- F9D = FF
      when "000111110011110" =>  data <= "11111111";  -- F9E = FF
      when "000111110011111" =>  data <= "11111111";  -- F9F = FF
      when "000111110100000" =>  data <= "11111111";  -- FA0 = FF
      when "000111110100001" =>  data <= "11111111";  -- FA1 = FF
      when "000111110100010" =>  data <= "11111111";  -- FA2 = FF
      when "000111110100011" =>  data <= "11111111";  -- FA3 = FF
      when "000111110100100" =>  data <= "11111111";  -- FA4 = FF
      when "000111110100101" =>  data <= "11111111";  -- FA5 = FF
      when "000111110100110" =>  data <= "11111111";  -- FA6 = FF
      when "000111110100111" =>  data <= "11111111";  -- FA7 = FF
      when "000111110101000" =>  data <= "11111111";  -- FA8 = FF
      when "000111110101001" =>  data <= "11111111";  -- FA9 = FF
      when "000111110101010" =>  data <= "11111111";  -- FAA = FF
      when "000111110101011" =>  data <= "11111111";  -- FAB = FF
      when "000111110101100" =>  data <= "11111111";  -- FAC = FF
      when "000111110101101" =>  data <= "11111111";  -- FAD = FF
      when "000111110101110" =>  data <= "11111111";  -- FAE = FF
      when "000111110101111" =>  data <= "11111111";  -- FAF = FF
      when "000111110110000" =>  data <= "11111111";  -- FB0 = FF
      when "000111110110001" =>  data <= "11111111";  -- FB1 = FF
      when "000111110110010" =>  data <= "11111111";  -- FB2 = FF
      when "000111110110011" =>  data <= "11111111";  -- FB3 = FF
      when "000111110110100" =>  data <= "11111111";  -- FB4 = FF
      when "000111110110101" =>  data <= "11111111";  -- FB5 = FF
      when "000111110110110" =>  data <= "11111111";  -- FB6 = FF
      when "000111110110111" =>  data <= "11111111";  -- FB7 = FF
      when "000111110111000" =>  data <= "11111111";  -- FB8 = FF
      when "000111110111001" =>  data <= "11111111";  -- FB9 = FF
      when "000111110111010" =>  data <= "11111111";  -- FBA = FF
      when "000111110111011" =>  data <= "11111111";  -- FBB = FF
      when "000111110111100" =>  data <= "11111111";  -- FBC = FF
      when "000111110111101" =>  data <= "11111111";  -- FBD = FF
      when "000111110111110" =>  data <= "11111111";  -- FBE = FF
      when "000111110111111" =>  data <= "11111111";  -- FBF = FF
      when "000111111000000" =>  data <= "11111111";  -- FC0 = FF
      when "000111111000001" =>  data <= "11111111";  -- FC1 = FF
      when "000111111000010" =>  data <= "11111111";  -- FC2 = FF
      when "000111111000011" =>  data <= "11111111";  -- FC3 = FF
      when "000111111000100" =>  data <= "11111111";  -- FC4 = FF
      when "000111111000101" =>  data <= "11111111";  -- FC5 = FF
      when "000111111000110" =>  data <= "11111111";  -- FC6 = FF
      when "000111111000111" =>  data <= "11111111";  -- FC7 = FF
      when "000111111001000" =>  data <= "11111111";  -- FC8 = FF
      when "000111111001001" =>  data <= "11111111";  -- FC9 = FF
      when "000111111001010" =>  data <= "11111111";  -- FCA = FF
      when "000111111001011" =>  data <= "11111111";  -- FCB = FF
      when "000111111001100" =>  data <= "11111111";  -- FCC = FF
      when "000111111001101" =>  data <= "11111111";  -- FCD = FF
      when "000111111001110" =>  data <= "11111111";  -- FCE = FF
      when "000111111001111" =>  data <= "11111111";  -- FCF = FF
      when "000111111010000" =>  data <= "11111111";  -- FD0 = FF
      when "000111111010001" =>  data <= "11111111";  -- FD1 = FF
      when "000111111010010" =>  data <= "11111111";  -- FD2 = FF
      when "000111111010011" =>  data <= "11111111";  -- FD3 = FF
      when "000111111010100" =>  data <= "11111111";  -- FD4 = FF
      when "000111111010101" =>  data <= "11111111";  -- FD5 = FF
      when "000111111010110" =>  data <= "11111111";  -- FD6 = FF
      when "000111111010111" =>  data <= "11111111";  -- FD7 = FF
      when "000111111011000" =>  data <= "11111111";  -- FD8 = FF
      when "000111111011001" =>  data <= "11111111";  -- FD9 = FF
      when "000111111011010" =>  data <= "11111111";  -- FDA = FF
      when "000111111011011" =>  data <= "11111111";  -- FDB = FF
      when "000111111011100" =>  data <= "11111111";  -- FDC = FF
      when "000111111011101" =>  data <= "11111111";  -- FDD = FF
      when "000111111011110" =>  data <= "11111111";  -- FDE = FF
      when "000111111011111" =>  data <= "11111111";  -- FDF = FF
      when "000111111100000" =>  data <= "11111111";  -- FE0 = FF
      when "000111111100001" =>  data <= "11111111";  -- FE1 = FF
      when "000111111100010" =>  data <= "11111111";  -- FE2 = FF
      when "000111111100011" =>  data <= "11111111";  -- FE3 = FF
      when "000111111100100" =>  data <= "11111111";  -- FE4 = FF
      when "000111111100101" =>  data <= "11111111";  -- FE5 = FF
      when "000111111100110" =>  data <= "11111111";  -- FE6 = FF
      when "000111111100111" =>  data <= "11111111";  -- FE7 = FF
      when "000111111101000" =>  data <= "11111111";  -- FE8 = FF
      when "000111111101001" =>  data <= "11111111";  -- FE9 = FF
      when "000111111101010" =>  data <= "11111111";  -- FEA = FF
      when "000111111101011" =>  data <= "11111111";  -- FEB = FF
      when "000111111101100" =>  data <= "11111111";  -- FEC = FF
      when "000111111101101" =>  data <= "11111111";  -- FED = FF
      when "000111111101110" =>  data <= "11111111";  -- FEE = FF
      when "000111111101111" =>  data <= "11111111";  -- FEF = FF
      when "000111111110000" =>  data <= "11111111";  -- FF0 = FF
      when "000111111110001" =>  data <= "11111111";  -- FF1 = FF
      when "000111111110010" =>  data <= "11111111";  -- FF2 = FF
      when "000111111110011" =>  data <= "11111111";  -- FF3 = FF
      when "000111111110100" =>  data <= "11111111";  -- FF4 = FF
      when "000111111110101" =>  data <= "11111111";  -- FF5 = FF
      when "000111111110110" =>  data <= "11111111";  -- FF6 = FF
      when "000111111110111" =>  data <= "11111111";  -- FF7 = FF
      when "000111111111000" =>  data <= "11111111";  -- FF8 = FF
      when "000111111111001" =>  data <= "11111111";  -- FF9 = FF
      when "000111111111010" =>  data <= "11111111";  -- FFA = FF
      when "000111111111011" =>  data <= "11111111";  -- FFB = FF
      when "000111111111100" =>  data <= "11111111";  -- FFC = FF
      when "000111111111101" =>  data <= "11111111";  -- FFD = FF
      when "000111111111110" =>  data <= "11111111";  -- FFE = FF
      when "000111111111111" =>  data <= "11111111";  -- FFF = FF
      when "001000000000000" =>  data <= "11111111";  -- 1000 = FF
      when "001000000000001" =>  data <= "11111111";  -- 1001 = FF
      when "001000000000010" =>  data <= "11111111";  -- 1002 = FF
      when "001000000000011" =>  data <= "11111111";  -- 1003 = FF
      when "001000000000100" =>  data <= "11111111";  -- 1004 = FF
      when "001000000000101" =>  data <= "11111111";  -- 1005 = FF
      when "001000000000110" =>  data <= "11111111";  -- 1006 = FF
      when "001000000000111" =>  data <= "11111111";  -- 1007 = FF
      when "001000000001000" =>  data <= "11111111";  -- 1008 = FF
      when "001000000001001" =>  data <= "11111111";  -- 1009 = FF
      when "001000000001010" =>  data <= "11111111";  -- 100A = FF
      when "001000000001011" =>  data <= "11111111";  -- 100B = FF
      when "001000000001100" =>  data <= "11111111";  -- 100C = FF
      when "001000000001101" =>  data <= "11111111";  -- 100D = FF
      when "001000000001110" =>  data <= "11111111";  -- 100E = FF
      when "001000000001111" =>  data <= "11111111";  -- 100F = FF
      when "001000000010000" =>  data <= "11111111";  -- 1010 = FF
      when "001000000010001" =>  data <= "11111111";  -- 1011 = FF
      when "001000000010010" =>  data <= "11111111";  -- 1012 = FF
      when "001000000010011" =>  data <= "11111111";  -- 1013 = FF
      when "001000000010100" =>  data <= "11111111";  -- 1014 = FF
      when "001000000010101" =>  data <= "11111111";  -- 1015 = FF
      when "001000000010110" =>  data <= "11111111";  -- 1016 = FF
      when "001000000010111" =>  data <= "11111111";  -- 1017 = FF
      when "001000000011000" =>  data <= "11111111";  -- 1018 = FF
      when "001000000011001" =>  data <= "11111111";  -- 1019 = FF
      when "001000000011010" =>  data <= "11111111";  -- 101A = FF
      when "001000000011011" =>  data <= "11111111";  -- 101B = FF
      when "001000000011100" =>  data <= "11111111";  -- 101C = FF
      when "001000000011101" =>  data <= "11111111";  -- 101D = FF
      when "001000000011110" =>  data <= "11111111";  -- 101E = FF
      when "001000000011111" =>  data <= "11111111";  -- 101F = FF
      when "001000000100000" =>  data <= "11111111";  -- 1020 = FF
      when "001000000100001" =>  data <= "11111111";  -- 1021 = FF
      when "001000000100010" =>  data <= "11111111";  -- 1022 = FF
      when "001000000100011" =>  data <= "11111111";  -- 1023 = FF
      when "001000000100100" =>  data <= "11111111";  -- 1024 = FF
      when "001000000100101" =>  data <= "11111111";  -- 1025 = FF
      when "001000000100110" =>  data <= "11111111";  -- 1026 = FF
      when "001000000100111" =>  data <= "11111111";  -- 1027 = FF
      when "001000000101000" =>  data <= "11111111";  -- 1028 = FF
      when "001000000101001" =>  data <= "11111111";  -- 1029 = FF
      when "001000000101010" =>  data <= "11111111";  -- 102A = FF
      when "001000000101011" =>  data <= "11111111";  -- 102B = FF
      when "001000000101100" =>  data <= "11111111";  -- 102C = FF
      when "001000000101101" =>  data <= "11111111";  -- 102D = FF
      when "001000000101110" =>  data <= "11111111";  -- 102E = FF
      when "001000000101111" =>  data <= "11111111";  -- 102F = FF
      when "001000000110000" =>  data <= "11111111";  -- 1030 = FF
      when "001000000110001" =>  data <= "11111111";  -- 1031 = FF
      when "001000000110010" =>  data <= "11111111";  -- 1032 = FF
      when "001000000110011" =>  data <= "11111111";  -- 1033 = FF
      when "001000000110100" =>  data <= "11111111";  -- 1034 = FF
      when "001000000110101" =>  data <= "11111111";  -- 1035 = FF
      when "001000000110110" =>  data <= "11111111";  -- 1036 = FF
      when "001000000110111" =>  data <= "11111111";  -- 1037 = FF
      when "001000000111000" =>  data <= "11111111";  -- 1038 = FF
      when "001000000111001" =>  data <= "11111111";  -- 1039 = FF
      when "001000000111010" =>  data <= "11111111";  -- 103A = FF
      when "001000000111011" =>  data <= "11111111";  -- 103B = FF
      when "001000000111100" =>  data <= "11111111";  -- 103C = FF
      when "001000000111101" =>  data <= "11111111";  -- 103D = FF
      when "001000000111110" =>  data <= "11111111";  -- 103E = FF
      when "001000000111111" =>  data <= "11111111";  -- 103F = FF
      when "001000001000000" =>  data <= "11111111";  -- 1040 = FF
      when "001000001000001" =>  data <= "11111111";  -- 1041 = FF
      when "001000001000010" =>  data <= "11111111";  -- 1042 = FF
      when "001000001000011" =>  data <= "11111111";  -- 1043 = FF
      when "001000001000100" =>  data <= "11111111";  -- 1044 = FF
      when "001000001000101" =>  data <= "11111111";  -- 1045 = FF
      when "001000001000110" =>  data <= "11111111";  -- 1046 = FF
      when "001000001000111" =>  data <= "11111111";  -- 1047 = FF
      when "001000001001000" =>  data <= "11111111";  -- 1048 = FF
      when "001000001001001" =>  data <= "11111111";  -- 1049 = FF
      when "001000001001010" =>  data <= "11111111";  -- 104A = FF
      when "001000001001011" =>  data <= "11111111";  -- 104B = FF
      when "001000001001100" =>  data <= "11111111";  -- 104C = FF
      when "001000001001101" =>  data <= "11111111";  -- 104D = FF
      when "001000001001110" =>  data <= "11111111";  -- 104E = FF
      when "001000001001111" =>  data <= "11111111";  -- 104F = FF
      when "001000001010000" =>  data <= "11111111";  -- 1050 = FF
      when "001000001010001" =>  data <= "11111111";  -- 1051 = FF
      when "001000001010010" =>  data <= "11111111";  -- 1052 = FF
      when "001000001010011" =>  data <= "11111111";  -- 1053 = FF
      when "001000001010100" =>  data <= "11111111";  -- 1054 = FF
      when "001000001010101" =>  data <= "11111111";  -- 1055 = FF
      when "001000001010110" =>  data <= "11111111";  -- 1056 = FF
      when "001000001010111" =>  data <= "11111111";  -- 1057 = FF
      when "001000001011000" =>  data <= "11111111";  -- 1058 = FF
      when "001000001011001" =>  data <= "11111111";  -- 1059 = FF
      when "001000001011010" =>  data <= "11111111";  -- 105A = FF
      when "001000001011011" =>  data <= "11111111";  -- 105B = FF
      when "001000001011100" =>  data <= "11111111";  -- 105C = FF
      when "001000001011101" =>  data <= "11111111";  -- 105D = FF
      when "001000001011110" =>  data <= "11111111";  -- 105E = FF
      when "001000001011111" =>  data <= "11111111";  -- 105F = FF
      when "001000001100000" =>  data <= "11111111";  -- 1060 = FF
      when "001000001100001" =>  data <= "11111111";  -- 1061 = FF
      when "001000001100010" =>  data <= "11111111";  -- 1062 = FF
      when "001000001100011" =>  data <= "11111111";  -- 1063 = FF
      when "001000001100100" =>  data <= "11111111";  -- 1064 = FF
      when "001000001100101" =>  data <= "11111111";  -- 1065 = FF
      when "001000001100110" =>  data <= "11111111";  -- 1066 = FF
      when "001000001100111" =>  data <= "11111111";  -- 1067 = FF
      when "001000001101000" =>  data <= "11111111";  -- 1068 = FF
      when "001000001101001" =>  data <= "11111111";  -- 1069 = FF
      when "001000001101010" =>  data <= "11111111";  -- 106A = FF
      when "001000001101011" =>  data <= "11111111";  -- 106B = FF
      when "001000001101100" =>  data <= "11111111";  -- 106C = FF
      when "001000001101101" =>  data <= "11111111";  -- 106D = FF
      when "001000001101110" =>  data <= "11111111";  -- 106E = FF
      when "001000001101111" =>  data <= "11111111";  -- 106F = FF
      when "001000001110000" =>  data <= "11111111";  -- 1070 = FF
      when "001000001110001" =>  data <= "11111111";  -- 1071 = FF
      when "001000001110010" =>  data <= "11111111";  -- 1072 = FF
      when "001000001110011" =>  data <= "11111111";  -- 1073 = FF
      when "001000001110100" =>  data <= "11111111";  -- 1074 = FF
      when "001000001110101" =>  data <= "11111111";  -- 1075 = FF
      when "001000001110110" =>  data <= "11111111";  -- 1076 = FF
      when "001000001110111" =>  data <= "11111111";  -- 1077 = FF
      when "001000001111000" =>  data <= "11111111";  -- 1078 = FF
      when "001000001111001" =>  data <= "11111111";  -- 1079 = FF
      when "001000001111010" =>  data <= "11111111";  -- 107A = FF
      when "001000001111011" =>  data <= "11111111";  -- 107B = FF
      when "001000001111100" =>  data <= "11111111";  -- 107C = FF
      when "001000001111101" =>  data <= "11111111";  -- 107D = FF
      when "001000001111110" =>  data <= "11111111";  -- 107E = FF
      when "001000001111111" =>  data <= "11111111";  -- 107F = FF
      when "001000010000000" =>  data <= "11111111";  -- 1080 = FF
      when "001000010000001" =>  data <= "11111111";  -- 1081 = FF
      when "001000010000010" =>  data <= "11111111";  -- 1082 = FF
      when "001000010000011" =>  data <= "11111111";  -- 1083 = FF
      when "001000010000100" =>  data <= "11111111";  -- 1084 = FF
      when "001000010000101" =>  data <= "11111111";  -- 1085 = FF
      when "001000010000110" =>  data <= "11111111";  -- 1086 = FF
      when "001000010000111" =>  data <= "11111111";  -- 1087 = FF
      when "001000010001000" =>  data <= "11111111";  -- 1088 = FF
      when "001000010001001" =>  data <= "11111111";  -- 1089 = FF
      when "001000010001010" =>  data <= "11111111";  -- 108A = FF
      when "001000010001011" =>  data <= "11111111";  -- 108B = FF
      when "001000010001100" =>  data <= "11111111";  -- 108C = FF
      when "001000010001101" =>  data <= "11111111";  -- 108D = FF
      when "001000010001110" =>  data <= "11111111";  -- 108E = FF
      when "001000010001111" =>  data <= "11111111";  -- 108F = FF
      when "001000010010000" =>  data <= "11111111";  -- 1090 = FF
      when "001000010010001" =>  data <= "11111111";  -- 1091 = FF
      when "001000010010010" =>  data <= "11111111";  -- 1092 = FF
      when "001000010010011" =>  data <= "11111111";  -- 1093 = FF
      when "001000010010100" =>  data <= "11111111";  -- 1094 = FF
      when "001000010010101" =>  data <= "11111111";  -- 1095 = FF
      when "001000010010110" =>  data <= "11111111";  -- 1096 = FF
      when "001000010010111" =>  data <= "11111111";  -- 1097 = FF
      when "001000010011000" =>  data <= "11111111";  -- 1098 = FF
      when "001000010011001" =>  data <= "11111111";  -- 1099 = FF
      when "001000010011010" =>  data <= "11111111";  -- 109A = FF
      when "001000010011011" =>  data <= "11111111";  -- 109B = FF
      when "001000010011100" =>  data <= "11111111";  -- 109C = FF
      when "001000010011101" =>  data <= "11111111";  -- 109D = FF
      when "001000010011110" =>  data <= "11111111";  -- 109E = FF
      when "001000010011111" =>  data <= "11111111";  -- 109F = FF
      when "001000010100000" =>  data <= "11111111";  -- 10A0 = FF
      when "001000010100001" =>  data <= "11111111";  -- 10A1 = FF
      when "001000010100010" =>  data <= "11111111";  -- 10A2 = FF
      when "001000010100011" =>  data <= "11111111";  -- 10A3 = FF
      when "001000010100100" =>  data <= "11111111";  -- 10A4 = FF
      when "001000010100101" =>  data <= "11111111";  -- 10A5 = FF
      when "001000010100110" =>  data <= "11111111";  -- 10A6 = FF
      when "001000010100111" =>  data <= "11111111";  -- 10A7 = FF
      when "001000010101000" =>  data <= "11111111";  -- 10A8 = FF
      when "001000010101001" =>  data <= "11111111";  -- 10A9 = FF
      when "001000010101010" =>  data <= "11111111";  -- 10AA = FF
      when "001000010101011" =>  data <= "11111111";  -- 10AB = FF
      when "001000010101100" =>  data <= "11111111";  -- 10AC = FF
      when "001000010101101" =>  data <= "11111111";  -- 10AD = FF
      when "001000010101110" =>  data <= "11111111";  -- 10AE = FF
      when "001000010101111" =>  data <= "11111111";  -- 10AF = FF
      when "001000010110000" =>  data <= "11111111";  -- 10B0 = FF
      when "001000010110001" =>  data <= "11111111";  -- 10B1 = FF
      when "001000010110010" =>  data <= "11111111";  -- 10B2 = FF
      when "001000010110011" =>  data <= "11111111";  -- 10B3 = FF
      when "001000010110100" =>  data <= "11111111";  -- 10B4 = FF
      when "001000010110101" =>  data <= "11111111";  -- 10B5 = FF
      when "001000010110110" =>  data <= "11111111";  -- 10B6 = FF
      when "001000010110111" =>  data <= "11111111";  -- 10B7 = FF
      when "001000010111000" =>  data <= "11111111";  -- 10B8 = FF
      when "001000010111001" =>  data <= "11111111";  -- 10B9 = FF
      when "001000010111010" =>  data <= "11111111";  -- 10BA = FF
      when "001000010111011" =>  data <= "11111111";  -- 10BB = FF
      when "001000010111100" =>  data <= "11111111";  -- 10BC = FF
      when "001000010111101" =>  data <= "11111111";  -- 10BD = FF
      when "001000010111110" =>  data <= "11111111";  -- 10BE = FF
      when "001000010111111" =>  data <= "11111111";  -- 10BF = FF
      when "001000011000000" =>  data <= "11111111";  -- 10C0 = FF
      when "001000011000001" =>  data <= "11111111";  -- 10C1 = FF
      when "001000011000010" =>  data <= "11111111";  -- 10C2 = FF
      when "001000011000011" =>  data <= "11111111";  -- 10C3 = FF
      when "001000011000100" =>  data <= "11111111";  -- 10C4 = FF
      when "001000011000101" =>  data <= "11111111";  -- 10C5 = FF
      when "001000011000110" =>  data <= "11111111";  -- 10C6 = FF
      when "001000011000111" =>  data <= "11111111";  -- 10C7 = FF
      when "001000011001000" =>  data <= "11111111";  -- 10C8 = FF
      when "001000011001001" =>  data <= "11111111";  -- 10C9 = FF
      when "001000011001010" =>  data <= "11111111";  -- 10CA = FF
      when "001000011001011" =>  data <= "11111111";  -- 10CB = FF
      when "001000011001100" =>  data <= "11111111";  -- 10CC = FF
      when "001000011001101" =>  data <= "11111111";  -- 10CD = FF
      when "001000011001110" =>  data <= "11111111";  -- 10CE = FF
      when "001000011001111" =>  data <= "11111111";  -- 10CF = FF
      when "001000011010000" =>  data <= "11111111";  -- 10D0 = FF
      when "001000011010001" =>  data <= "11111111";  -- 10D1 = FF
      when "001000011010010" =>  data <= "11111111";  -- 10D2 = FF
      when "001000011010011" =>  data <= "11111111";  -- 10D3 = FF
      when "001000011010100" =>  data <= "11111111";  -- 10D4 = FF
      when "001000011010101" =>  data <= "11111111";  -- 10D5 = FF
      when "001000011010110" =>  data <= "11111111";  -- 10D6 = FF
      when "001000011010111" =>  data <= "11111111";  -- 10D7 = FF
      when "001000011011000" =>  data <= "11111111";  -- 10D8 = FF
      when "001000011011001" =>  data <= "11111111";  -- 10D9 = FF
      when "001000011011010" =>  data <= "11111111";  -- 10DA = FF
      when "001000011011011" =>  data <= "11111111";  -- 10DB = FF
      when "001000011011100" =>  data <= "11111111";  -- 10DC = FF
      when "001000011011101" =>  data <= "11111111";  -- 10DD = FF
      when "001000011011110" =>  data <= "11111111";  -- 10DE = FF
      when "001000011011111" =>  data <= "11111111";  -- 10DF = FF
      when "001000011100000" =>  data <= "11111111";  -- 10E0 = FF
      when "001000011100001" =>  data <= "11111111";  -- 10E1 = FF
      when "001000011100010" =>  data <= "11111111";  -- 10E2 = FF
      when "001000011100011" =>  data <= "11111111";  -- 10E3 = FF
      when "001000011100100" =>  data <= "11111111";  -- 10E4 = FF
      when "001000011100101" =>  data <= "11111111";  -- 10E5 = FF
      when "001000011100110" =>  data <= "11111111";  -- 10E6 = FF
      when "001000011100111" =>  data <= "11111111";  -- 10E7 = FF
      when "001000011101000" =>  data <= "11111111";  -- 10E8 = FF
      when "001000011101001" =>  data <= "11111111";  -- 10E9 = FF
      when "001000011101010" =>  data <= "11111111";  -- 10EA = FF
      when "001000011101011" =>  data <= "11111111";  -- 10EB = FF
      when "001000011101100" =>  data <= "11111111";  -- 10EC = FF
      when "001000011101101" =>  data <= "11111111";  -- 10ED = FF
      when "001000011101110" =>  data <= "11111111";  -- 10EE = FF
      when "001000011101111" =>  data <= "11111111";  -- 10EF = FF
      when "001000011110000" =>  data <= "11111111";  -- 10F0 = FF
      when "001000011110001" =>  data <= "11111111";  -- 10F1 = FF
      when "001000011110010" =>  data <= "11111111";  -- 10F2 = FF
      when "001000011110011" =>  data <= "11111111";  -- 10F3 = FF
      when "001000011110100" =>  data <= "11111111";  -- 10F4 = FF
      when "001000011110101" =>  data <= "11111111";  -- 10F5 = FF
      when "001000011110110" =>  data <= "11111111";  -- 10F6 = FF
      when "001000011110111" =>  data <= "11111111";  -- 10F7 = FF
      when "001000011111000" =>  data <= "11111111";  -- 10F8 = FF
      when "001000011111001" =>  data <= "11111111";  -- 10F9 = FF
      when "001000011111010" =>  data <= "11111111";  -- 10FA = FF
      when "001000011111011" =>  data <= "11111111";  -- 10FB = FF
      when "001000011111100" =>  data <= "11111111";  -- 10FC = FF
      when "001000011111101" =>  data <= "11111111";  -- 10FD = FF
      when "001000011111110" =>  data <= "11111111";  -- 10FE = FF
      when "001000011111111" =>  data <= "11111111";  -- 10FF = FF
      when "001000100000000" =>  data <= "11111111";  -- 1100 = FF
      when "001000100000001" =>  data <= "11111111";  -- 1101 = FF
      when "001000100000010" =>  data <= "11111111";  -- 1102 = FF
      when "001000100000011" =>  data <= "11111111";  -- 1103 = FF
      when "001000100000100" =>  data <= "11111111";  -- 1104 = FF
      when "001000100000101" =>  data <= "11111111";  -- 1105 = FF
      when "001000100000110" =>  data <= "11111111";  -- 1106 = FF
      when "001000100000111" =>  data <= "11111111";  -- 1107 = FF
      when "001000100001000" =>  data <= "11111111";  -- 1108 = FF
      when "001000100001001" =>  data <= "11111111";  -- 1109 = FF
      when "001000100001010" =>  data <= "11111111";  -- 110A = FF
      when "001000100001011" =>  data <= "11111111";  -- 110B = FF
      when "001000100001100" =>  data <= "11111111";  -- 110C = FF
      when "001000100001101" =>  data <= "11111111";  -- 110D = FF
      when "001000100001110" =>  data <= "11111111";  -- 110E = FF
      when "001000100001111" =>  data <= "11111111";  -- 110F = FF
      when "001000100010000" =>  data <= "11111111";  -- 1110 = FF
      when "001000100010001" =>  data <= "11111111";  -- 1111 = FF
      when "001000100010010" =>  data <= "11111111";  -- 1112 = FF
      when "001000100010011" =>  data <= "11111111";  -- 1113 = FF
      when "001000100010100" =>  data <= "11111111";  -- 1114 = FF
      when "001000100010101" =>  data <= "11111111";  -- 1115 = FF
      when "001000100010110" =>  data <= "11111111";  -- 1116 = FF
      when "001000100010111" =>  data <= "11111111";  -- 1117 = FF
      when "001000100011000" =>  data <= "11111111";  -- 1118 = FF
      when "001000100011001" =>  data <= "11111111";  -- 1119 = FF
      when "001000100011010" =>  data <= "11111111";  -- 111A = FF
      when "001000100011011" =>  data <= "11111111";  -- 111B = FF
      when "001000100011100" =>  data <= "11111111";  -- 111C = FF
      when "001000100011101" =>  data <= "11111111";  -- 111D = FF
      when "001000100011110" =>  data <= "11111111";  -- 111E = FF
      when "001000100011111" =>  data <= "11111111";  -- 111F = FF
      when "001000100100000" =>  data <= "11111111";  -- 1120 = FF
      when "001000100100001" =>  data <= "11111111";  -- 1121 = FF
      when "001000100100010" =>  data <= "11111111";  -- 1122 = FF
      when "001000100100011" =>  data <= "11111111";  -- 1123 = FF
      when "001000100100100" =>  data <= "11111111";  -- 1124 = FF
      when "001000100100101" =>  data <= "11111111";  -- 1125 = FF
      when "001000100100110" =>  data <= "11111111";  -- 1126 = FF
      when "001000100100111" =>  data <= "11111111";  -- 1127 = FF
      when "001000100101000" =>  data <= "11111111";  -- 1128 = FF
      when "001000100101001" =>  data <= "11111111";  -- 1129 = FF
      when "001000100101010" =>  data <= "11111111";  -- 112A = FF
      when "001000100101011" =>  data <= "11111111";  -- 112B = FF
      when "001000100101100" =>  data <= "11111111";  -- 112C = FF
      when "001000100101101" =>  data <= "11111111";  -- 112D = FF
      when "001000100101110" =>  data <= "11111111";  -- 112E = FF
      when "001000100101111" =>  data <= "11111111";  -- 112F = FF
      when "001000100110000" =>  data <= "11111111";  -- 1130 = FF
      when "001000100110001" =>  data <= "11111111";  -- 1131 = FF
      when "001000100110010" =>  data <= "11111111";  -- 1132 = FF
      when "001000100110011" =>  data <= "11111111";  -- 1133 = FF
      when "001000100110100" =>  data <= "11111111";  -- 1134 = FF
      when "001000100110101" =>  data <= "11111111";  -- 1135 = FF
      when "001000100110110" =>  data <= "11111111";  -- 1136 = FF
      when "001000100110111" =>  data <= "11111111";  -- 1137 = FF
      when "001000100111000" =>  data <= "11111111";  -- 1138 = FF
      when "001000100111001" =>  data <= "11111111";  -- 1139 = FF
      when "001000100111010" =>  data <= "11111111";  -- 113A = FF
      when "001000100111011" =>  data <= "11111111";  -- 113B = FF
      when "001000100111100" =>  data <= "11111111";  -- 113C = FF
      when "001000100111101" =>  data <= "11111111";  -- 113D = FF
      when "001000100111110" =>  data <= "11111111";  -- 113E = FF
      when "001000100111111" =>  data <= "11111111";  -- 113F = FF
      when "001000101000000" =>  data <= "11111111";  -- 1140 = FF
      when "001000101000001" =>  data <= "11111111";  -- 1141 = FF
      when "001000101000010" =>  data <= "11111111";  -- 1142 = FF
      when "001000101000011" =>  data <= "11111111";  -- 1143 = FF
      when "001000101000100" =>  data <= "11111111";  -- 1144 = FF
      when "001000101000101" =>  data <= "11111111";  -- 1145 = FF
      when "001000101000110" =>  data <= "11111111";  -- 1146 = FF
      when "001000101000111" =>  data <= "11111111";  -- 1147 = FF
      when "001000101001000" =>  data <= "11111111";  -- 1148 = FF
      when "001000101001001" =>  data <= "11111111";  -- 1149 = FF
      when "001000101001010" =>  data <= "11111111";  -- 114A = FF
      when "001000101001011" =>  data <= "11111111";  -- 114B = FF
      when "001000101001100" =>  data <= "11111111";  -- 114C = FF
      when "001000101001101" =>  data <= "11111111";  -- 114D = FF
      when "001000101001110" =>  data <= "11111111";  -- 114E = FF
      when "001000101001111" =>  data <= "11111111";  -- 114F = FF
      when "001000101010000" =>  data <= "11111111";  -- 1150 = FF
      when "001000101010001" =>  data <= "11111111";  -- 1151 = FF
      when "001000101010010" =>  data <= "11111111";  -- 1152 = FF
      when "001000101010011" =>  data <= "11111111";  -- 1153 = FF
      when "001000101010100" =>  data <= "11111111";  -- 1154 = FF
      when "001000101010101" =>  data <= "11111111";  -- 1155 = FF
      when "001000101010110" =>  data <= "11111111";  -- 1156 = FF
      when "001000101010111" =>  data <= "11111111";  -- 1157 = FF
      when "001000101011000" =>  data <= "11111111";  -- 1158 = FF
      when "001000101011001" =>  data <= "11111111";  -- 1159 = FF
      when "001000101011010" =>  data <= "11111111";  -- 115A = FF
      when "001000101011011" =>  data <= "11111111";  -- 115B = FF
      when "001000101011100" =>  data <= "11111111";  -- 115C = FF
      when "001000101011101" =>  data <= "11111111";  -- 115D = FF
      when "001000101011110" =>  data <= "11111111";  -- 115E = FF
      when "001000101011111" =>  data <= "11111111";  -- 115F = FF
      when "001000101100000" =>  data <= "11111111";  -- 1160 = FF
      when "001000101100001" =>  data <= "11111111";  -- 1161 = FF
      when "001000101100010" =>  data <= "11111111";  -- 1162 = FF
      when "001000101100011" =>  data <= "11111111";  -- 1163 = FF
      when "001000101100100" =>  data <= "11111111";  -- 1164 = FF
      when "001000101100101" =>  data <= "11111111";  -- 1165 = FF
      when "001000101100110" =>  data <= "11111111";  -- 1166 = FF
      when "001000101100111" =>  data <= "11111111";  -- 1167 = FF
      when "001000101101000" =>  data <= "11111111";  -- 1168 = FF
      when "001000101101001" =>  data <= "11111111";  -- 1169 = FF
      when "001000101101010" =>  data <= "11111111";  -- 116A = FF
      when "001000101101011" =>  data <= "11111111";  -- 116B = FF
      when "001000101101100" =>  data <= "11111111";  -- 116C = FF
      when "001000101101101" =>  data <= "11111111";  -- 116D = FF
      when "001000101101110" =>  data <= "11111111";  -- 116E = FF
      when "001000101101111" =>  data <= "11111111";  -- 116F = FF
      when "001000101110000" =>  data <= "11111111";  -- 1170 = FF
      when "001000101110001" =>  data <= "11111111";  -- 1171 = FF
      when "001000101110010" =>  data <= "11111111";  -- 1172 = FF
      when "001000101110011" =>  data <= "11111111";  -- 1173 = FF
      when "001000101110100" =>  data <= "11111111";  -- 1174 = FF
      when "001000101110101" =>  data <= "11111111";  -- 1175 = FF
      when "001000101110110" =>  data <= "11111111";  -- 1176 = FF
      when "001000101110111" =>  data <= "11111111";  -- 1177 = FF
      when "001000101111000" =>  data <= "11111111";  -- 1178 = FF
      when "001000101111001" =>  data <= "11111111";  -- 1179 = FF
      when "001000101111010" =>  data <= "11111111";  -- 117A = FF
      when "001000101111011" =>  data <= "11111111";  -- 117B = FF
      when "001000101111100" =>  data <= "11111111";  -- 117C = FF
      when "001000101111101" =>  data <= "11111111";  -- 117D = FF
      when "001000101111110" =>  data <= "11111111";  -- 117E = FF
      when "001000101111111" =>  data <= "11111111";  -- 117F = FF
      when "001000110000000" =>  data <= "11111111";  -- 1180 = FF
      when "001000110000001" =>  data <= "11111111";  -- 1181 = FF
      when "001000110000010" =>  data <= "11111111";  -- 1182 = FF
      when "001000110000011" =>  data <= "11111111";  -- 1183 = FF
      when "001000110000100" =>  data <= "11111111";  -- 1184 = FF
      when "001000110000101" =>  data <= "11111111";  -- 1185 = FF
      when "001000110000110" =>  data <= "11111111";  -- 1186 = FF
      when "001000110000111" =>  data <= "11111111";  -- 1187 = FF
      when "001000110001000" =>  data <= "11111111";  -- 1188 = FF
      when "001000110001001" =>  data <= "11111111";  -- 1189 = FF
      when "001000110001010" =>  data <= "11111111";  -- 118A = FF
      when "001000110001011" =>  data <= "11111111";  -- 118B = FF
      when "001000110001100" =>  data <= "11111111";  -- 118C = FF
      when "001000110001101" =>  data <= "11111111";  -- 118D = FF
      when "001000110001110" =>  data <= "11111111";  -- 118E = FF
      when "001000110001111" =>  data <= "11111111";  -- 118F = FF
      when "001000110010000" =>  data <= "11111111";  -- 1190 = FF
      when "001000110010001" =>  data <= "11111111";  -- 1191 = FF
      when "001000110010010" =>  data <= "11111111";  -- 1192 = FF
      when "001000110010011" =>  data <= "11111111";  -- 1193 = FF
      when "001000110010100" =>  data <= "11111111";  -- 1194 = FF
      when "001000110010101" =>  data <= "11111111";  -- 1195 = FF
      when "001000110010110" =>  data <= "11111111";  -- 1196 = FF
      when "001000110010111" =>  data <= "11111111";  -- 1197 = FF
      when "001000110011000" =>  data <= "11111111";  -- 1198 = FF
      when "001000110011001" =>  data <= "11111111";  -- 1199 = FF
      when "001000110011010" =>  data <= "11111111";  -- 119A = FF
      when "001000110011011" =>  data <= "11111111";  -- 119B = FF
      when "001000110011100" =>  data <= "11111111";  -- 119C = FF
      when "001000110011101" =>  data <= "11111111";  -- 119D = FF
      when "001000110011110" =>  data <= "11111111";  -- 119E = FF
      when "001000110011111" =>  data <= "11111111";  -- 119F = FF
      when "001000110100000" =>  data <= "11111111";  -- 11A0 = FF
      when "001000110100001" =>  data <= "11111111";  -- 11A1 = FF
      when "001000110100010" =>  data <= "11111111";  -- 11A2 = FF
      when "001000110100011" =>  data <= "11111111";  -- 11A3 = FF
      when "001000110100100" =>  data <= "11111111";  -- 11A4 = FF
      when "001000110100101" =>  data <= "11111111";  -- 11A5 = FF
      when "001000110100110" =>  data <= "11111111";  -- 11A6 = FF
      when "001000110100111" =>  data <= "11111111";  -- 11A7 = FF
      when "001000110101000" =>  data <= "11111111";  -- 11A8 = FF
      when "001000110101001" =>  data <= "11111111";  -- 11A9 = FF
      when "001000110101010" =>  data <= "11111111";  -- 11AA = FF
      when "001000110101011" =>  data <= "11111111";  -- 11AB = FF
      when "001000110101100" =>  data <= "11111111";  -- 11AC = FF
      when "001000110101101" =>  data <= "11111111";  -- 11AD = FF
      when "001000110101110" =>  data <= "11111111";  -- 11AE = FF
      when "001000110101111" =>  data <= "11111111";  -- 11AF = FF
      when "001000110110000" =>  data <= "11111111";  -- 11B0 = FF
      when "001000110110001" =>  data <= "11111111";  -- 11B1 = FF
      when "001000110110010" =>  data <= "11111111";  -- 11B2 = FF
      when "001000110110011" =>  data <= "11111111";  -- 11B3 = FF
      when "001000110110100" =>  data <= "11111111";  -- 11B4 = FF
      when "001000110110101" =>  data <= "11111111";  -- 11B5 = FF
      when "001000110110110" =>  data <= "11111111";  -- 11B6 = FF
      when "001000110110111" =>  data <= "11111111";  -- 11B7 = FF
      when "001000110111000" =>  data <= "11111111";  -- 11B8 = FF
      when "001000110111001" =>  data <= "11111111";  -- 11B9 = FF
      when "001000110111010" =>  data <= "11111111";  -- 11BA = FF
      when "001000110111011" =>  data <= "11111111";  -- 11BB = FF
      when "001000110111100" =>  data <= "11111111";  -- 11BC = FF
      when "001000110111101" =>  data <= "11111111";  -- 11BD = FF
      when "001000110111110" =>  data <= "11111111";  -- 11BE = FF
      when "001000110111111" =>  data <= "11111111";  -- 11BF = FF
      when "001000111000000" =>  data <= "11111111";  -- 11C0 = FF
      when "001000111000001" =>  data <= "11111111";  -- 11C1 = FF
      when "001000111000010" =>  data <= "11111111";  -- 11C2 = FF
      when "001000111000011" =>  data <= "11111111";  -- 11C3 = FF
      when "001000111000100" =>  data <= "11111111";  -- 11C4 = FF
      when "001000111000101" =>  data <= "11111111";  -- 11C5 = FF
      when "001000111000110" =>  data <= "11111111";  -- 11C6 = FF
      when "001000111000111" =>  data <= "11111111";  -- 11C7 = FF
      when "001000111001000" =>  data <= "11111111";  -- 11C8 = FF
      when "001000111001001" =>  data <= "11111111";  -- 11C9 = FF
      when "001000111001010" =>  data <= "11111111";  -- 11CA = FF
      when "001000111001011" =>  data <= "11111111";  -- 11CB = FF
      when "001000111001100" =>  data <= "11111111";  -- 11CC = FF
      when "001000111001101" =>  data <= "11111111";  -- 11CD = FF
      when "001000111001110" =>  data <= "11111111";  -- 11CE = FF
      when "001000111001111" =>  data <= "11111111";  -- 11CF = FF
      when "001000111010000" =>  data <= "11111111";  -- 11D0 = FF
      when "001000111010001" =>  data <= "11111111";  -- 11D1 = FF
      when "001000111010010" =>  data <= "11111111";  -- 11D2 = FF
      when "001000111010011" =>  data <= "11111111";  -- 11D3 = FF
      when "001000111010100" =>  data <= "11111111";  -- 11D4 = FF
      when "001000111010101" =>  data <= "11111111";  -- 11D5 = FF
      when "001000111010110" =>  data <= "11111111";  -- 11D6 = FF
      when "001000111010111" =>  data <= "11111111";  -- 11D7 = FF
      when "001000111011000" =>  data <= "11111111";  -- 11D8 = FF
      when "001000111011001" =>  data <= "11111111";  -- 11D9 = FF
      when "001000111011010" =>  data <= "11111111";  -- 11DA = FF
      when "001000111011011" =>  data <= "11111111";  -- 11DB = FF
      when "001000111011100" =>  data <= "11111111";  -- 11DC = FF
      when "001000111011101" =>  data <= "11111111";  -- 11DD = FF
      when "001000111011110" =>  data <= "11111111";  -- 11DE = FF
      when "001000111011111" =>  data <= "11111111";  -- 11DF = FF
      when "001000111100000" =>  data <= "11111111";  -- 11E0 = FF
      when "001000111100001" =>  data <= "11111111";  -- 11E1 = FF
      when "001000111100010" =>  data <= "11111111";  -- 11E2 = FF
      when "001000111100011" =>  data <= "11111111";  -- 11E3 = FF
      when "001000111100100" =>  data <= "11111111";  -- 11E4 = FF
      when "001000111100101" =>  data <= "11111111";  -- 11E5 = FF
      when "001000111100110" =>  data <= "11111111";  -- 11E6 = FF
      when "001000111100111" =>  data <= "11111111";  -- 11E7 = FF
      when "001000111101000" =>  data <= "11111111";  -- 11E8 = FF
      when "001000111101001" =>  data <= "11111111";  -- 11E9 = FF
      when "001000111101010" =>  data <= "11111111";  -- 11EA = FF
      when "001000111101011" =>  data <= "11111111";  -- 11EB = FF
      when "001000111101100" =>  data <= "11111111";  -- 11EC = FF
      when "001000111101101" =>  data <= "11111111";  -- 11ED = FF
      when "001000111101110" =>  data <= "11111111";  -- 11EE = FF
      when "001000111101111" =>  data <= "11111111";  -- 11EF = FF
      when "001000111110000" =>  data <= "11111111";  -- 11F0 = FF
      when "001000111110001" =>  data <= "11111111";  -- 11F1 = FF
      when "001000111110010" =>  data <= "11111111";  -- 11F2 = FF
      when "001000111110011" =>  data <= "11111111";  -- 11F3 = FF
      when "001000111110100" =>  data <= "11111111";  -- 11F4 = FF
      when "001000111110101" =>  data <= "11111111";  -- 11F5 = FF
      when "001000111110110" =>  data <= "11111111";  -- 11F6 = FF
      when "001000111110111" =>  data <= "11111111";  -- 11F7 = FF
      when "001000111111000" =>  data <= "11111111";  -- 11F8 = FF
      when "001000111111001" =>  data <= "11111111";  -- 11F9 = FF
      when "001000111111010" =>  data <= "11111111";  -- 11FA = FF
      when "001000111111011" =>  data <= "11111111";  -- 11FB = FF
      when "001000111111100" =>  data <= "11111111";  -- 11FC = FF
      when "001000111111101" =>  data <= "11111111";  -- 11FD = FF
      when "001000111111110" =>  data <= "11111111";  -- 11FE = FF
      when "001000111111111" =>  data <= "11111111";  -- 11FF = FF
      when "001001000000000" =>  data <= "11111111";  -- 1200 = FF
      when "001001000000001" =>  data <= "11111111";  -- 1201 = FF
      when "001001000000010" =>  data <= "11111111";  -- 1202 = FF
      when "001001000000011" =>  data <= "11111111";  -- 1203 = FF
      when "001001000000100" =>  data <= "11111111";  -- 1204 = FF
      when "001001000000101" =>  data <= "11111111";  -- 1205 = FF
      when "001001000000110" =>  data <= "11111111";  -- 1206 = FF
      when "001001000000111" =>  data <= "11111111";  -- 1207 = FF
      when "001001000001000" =>  data <= "11111111";  -- 1208 = FF
      when "001001000001001" =>  data <= "11111111";  -- 1209 = FF
      when "001001000001010" =>  data <= "11111111";  -- 120A = FF
      when "001001000001011" =>  data <= "11111111";  -- 120B = FF
      when "001001000001100" =>  data <= "11111111";  -- 120C = FF
      when "001001000001101" =>  data <= "11111111";  -- 120D = FF
      when "001001000001110" =>  data <= "11111111";  -- 120E = FF
      when "001001000001111" =>  data <= "11111111";  -- 120F = FF
      when "001001000010000" =>  data <= "11111111";  -- 1210 = FF
      when "001001000010001" =>  data <= "11111111";  -- 1211 = FF
      when "001001000010010" =>  data <= "11111111";  -- 1212 = FF
      when "001001000010011" =>  data <= "11111111";  -- 1213 = FF
      when "001001000010100" =>  data <= "11111111";  -- 1214 = FF
      when "001001000010101" =>  data <= "11111111";  -- 1215 = FF
      when "001001000010110" =>  data <= "11111111";  -- 1216 = FF
      when "001001000010111" =>  data <= "11111111";  -- 1217 = FF
      when "001001000011000" =>  data <= "11111111";  -- 1218 = FF
      when "001001000011001" =>  data <= "11111111";  -- 1219 = FF
      when "001001000011010" =>  data <= "11111111";  -- 121A = FF
      when "001001000011011" =>  data <= "11111111";  -- 121B = FF
      when "001001000011100" =>  data <= "11111111";  -- 121C = FF
      when "001001000011101" =>  data <= "11111111";  -- 121D = FF
      when "001001000011110" =>  data <= "11111111";  -- 121E = FF
      when "001001000011111" =>  data <= "11111111";  -- 121F = FF
      when "001001000100000" =>  data <= "11111111";  -- 1220 = FF
      when "001001000100001" =>  data <= "11111111";  -- 1221 = FF
      when "001001000100010" =>  data <= "11111111";  -- 1222 = FF
      when "001001000100011" =>  data <= "11111111";  -- 1223 = FF
      when "001001000100100" =>  data <= "11111111";  -- 1224 = FF
      when "001001000100101" =>  data <= "11111111";  -- 1225 = FF
      when "001001000100110" =>  data <= "11111111";  -- 1226 = FF
      when "001001000100111" =>  data <= "11111111";  -- 1227 = FF
      when "001001000101000" =>  data <= "11111111";  -- 1228 = FF
      when "001001000101001" =>  data <= "11111111";  -- 1229 = FF
      when "001001000101010" =>  data <= "11111111";  -- 122A = FF
      when "001001000101011" =>  data <= "11111111";  -- 122B = FF
      when "001001000101100" =>  data <= "11111111";  -- 122C = FF
      when "001001000101101" =>  data <= "11111111";  -- 122D = FF
      when "001001000101110" =>  data <= "11111111";  -- 122E = FF
      when "001001000101111" =>  data <= "11111111";  -- 122F = FF
      when "001001000110000" =>  data <= "11111111";  -- 1230 = FF
      when "001001000110001" =>  data <= "11111111";  -- 1231 = FF
      when "001001000110010" =>  data <= "11111111";  -- 1232 = FF
      when "001001000110011" =>  data <= "11111111";  -- 1233 = FF
      when "001001000110100" =>  data <= "11111111";  -- 1234 = FF
      when "001001000110101" =>  data <= "11111111";  -- 1235 = FF
      when "001001000110110" =>  data <= "11111111";  -- 1236 = FF
      when "001001000110111" =>  data <= "11111111";  -- 1237 = FF
      when "001001000111000" =>  data <= "11111111";  -- 1238 = FF
      when "001001000111001" =>  data <= "11111111";  -- 1239 = FF
      when "001001000111010" =>  data <= "11111111";  -- 123A = FF
      when "001001000111011" =>  data <= "11111111";  -- 123B = FF
      when "001001000111100" =>  data <= "11111111";  -- 123C = FF
      when "001001000111101" =>  data <= "11111111";  -- 123D = FF
      when "001001000111110" =>  data <= "11111111";  -- 123E = FF
      when "001001000111111" =>  data <= "11111111";  -- 123F = FF
      when "001001001000000" =>  data <= "11111111";  -- 1240 = FF
      when "001001001000001" =>  data <= "11111111";  -- 1241 = FF
      when "001001001000010" =>  data <= "11111111";  -- 1242 = FF
      when "001001001000011" =>  data <= "11111111";  -- 1243 = FF
      when "001001001000100" =>  data <= "11111111";  -- 1244 = FF
      when "001001001000101" =>  data <= "11111111";  -- 1245 = FF
      when "001001001000110" =>  data <= "11111111";  -- 1246 = FF
      when "001001001000111" =>  data <= "11111111";  -- 1247 = FF
      when "001001001001000" =>  data <= "11111111";  -- 1248 = FF
      when "001001001001001" =>  data <= "11111111";  -- 1249 = FF
      when "001001001001010" =>  data <= "11111111";  -- 124A = FF
      when "001001001001011" =>  data <= "11111111";  -- 124B = FF
      when "001001001001100" =>  data <= "11111111";  -- 124C = FF
      when "001001001001101" =>  data <= "11111111";  -- 124D = FF
      when "001001001001110" =>  data <= "11111111";  -- 124E = FF
      when "001001001001111" =>  data <= "11111111";  -- 124F = FF
      when "001001001010000" =>  data <= "11111111";  -- 1250 = FF
      when "001001001010001" =>  data <= "11111111";  -- 1251 = FF
      when "001001001010010" =>  data <= "11111111";  -- 1252 = FF
      when "001001001010011" =>  data <= "11111111";  -- 1253 = FF
      when "001001001010100" =>  data <= "11111111";  -- 1254 = FF
      when "001001001010101" =>  data <= "11111111";  -- 1255 = FF
      when "001001001010110" =>  data <= "11111111";  -- 1256 = FF
      when "001001001010111" =>  data <= "11111111";  -- 1257 = FF
      when "001001001011000" =>  data <= "11111111";  -- 1258 = FF
      when "001001001011001" =>  data <= "11111111";  -- 1259 = FF
      when "001001001011010" =>  data <= "11111111";  -- 125A = FF
      when "001001001011011" =>  data <= "11111111";  -- 125B = FF
      when "001001001011100" =>  data <= "11111111";  -- 125C = FF
      when "001001001011101" =>  data <= "11111111";  -- 125D = FF
      when "001001001011110" =>  data <= "11111111";  -- 125E = FF
      when "001001001011111" =>  data <= "11111111";  -- 125F = FF
      when "001001001100000" =>  data <= "11111111";  -- 1260 = FF
      when "001001001100001" =>  data <= "11111111";  -- 1261 = FF
      when "001001001100010" =>  data <= "11111111";  -- 1262 = FF
      when "001001001100011" =>  data <= "11111111";  -- 1263 = FF
      when "001001001100100" =>  data <= "11111111";  -- 1264 = FF
      when "001001001100101" =>  data <= "11111111";  -- 1265 = FF
      when "001001001100110" =>  data <= "11111111";  -- 1266 = FF
      when "001001001100111" =>  data <= "11111111";  -- 1267 = FF
      when "001001001101000" =>  data <= "11111111";  -- 1268 = FF
      when "001001001101001" =>  data <= "11111111";  -- 1269 = FF
      when "001001001101010" =>  data <= "11111111";  -- 126A = FF
      when "001001001101011" =>  data <= "11111111";  -- 126B = FF
      when "001001001101100" =>  data <= "11111111";  -- 126C = FF
      when "001001001101101" =>  data <= "11111111";  -- 126D = FF
      when "001001001101110" =>  data <= "11111111";  -- 126E = FF
      when "001001001101111" =>  data <= "11111111";  -- 126F = FF
      when "001001001110000" =>  data <= "11111111";  -- 1270 = FF
      when "001001001110001" =>  data <= "11111111";  -- 1271 = FF
      when "001001001110010" =>  data <= "11111111";  -- 1272 = FF
      when "001001001110011" =>  data <= "11111111";  -- 1273 = FF
      when "001001001110100" =>  data <= "11111111";  -- 1274 = FF
      when "001001001110101" =>  data <= "11111111";  -- 1275 = FF
      when "001001001110110" =>  data <= "11111111";  -- 1276 = FF
      when "001001001110111" =>  data <= "11111111";  -- 1277 = FF
      when "001001001111000" =>  data <= "11111111";  -- 1278 = FF
      when "001001001111001" =>  data <= "11111111";  -- 1279 = FF
      when "001001001111010" =>  data <= "11111111";  -- 127A = FF
      when "001001001111011" =>  data <= "11111111";  -- 127B = FF
      when "001001001111100" =>  data <= "11111111";  -- 127C = FF
      when "001001001111101" =>  data <= "11111111";  -- 127D = FF
      when "001001001111110" =>  data <= "11111111";  -- 127E = FF
      when "001001001111111" =>  data <= "11111111";  -- 127F = FF
      when "001001010000000" =>  data <= "11111111";  -- 1280 = FF
      when "001001010000001" =>  data <= "11111111";  -- 1281 = FF
      when "001001010000010" =>  data <= "11111111";  -- 1282 = FF
      when "001001010000011" =>  data <= "11111111";  -- 1283 = FF
      when "001001010000100" =>  data <= "11111111";  -- 1284 = FF
      when "001001010000101" =>  data <= "11111111";  -- 1285 = FF
      when "001001010000110" =>  data <= "11111111";  -- 1286 = FF
      when "001001010000111" =>  data <= "11111111";  -- 1287 = FF
      when "001001010001000" =>  data <= "11111111";  -- 1288 = FF
      when "001001010001001" =>  data <= "11111111";  -- 1289 = FF
      when "001001010001010" =>  data <= "11111111";  -- 128A = FF
      when "001001010001011" =>  data <= "11111111";  -- 128B = FF
      when "001001010001100" =>  data <= "11111111";  -- 128C = FF
      when "001001010001101" =>  data <= "11111111";  -- 128D = FF
      when "001001010001110" =>  data <= "11111111";  -- 128E = FF
      when "001001010001111" =>  data <= "11111111";  -- 128F = FF
      when "001001010010000" =>  data <= "11111111";  -- 1290 = FF
      when "001001010010001" =>  data <= "11111111";  -- 1291 = FF
      when "001001010010010" =>  data <= "11111111";  -- 1292 = FF
      when "001001010010011" =>  data <= "11111111";  -- 1293 = FF
      when "001001010010100" =>  data <= "11111111";  -- 1294 = FF
      when "001001010010101" =>  data <= "11111111";  -- 1295 = FF
      when "001001010010110" =>  data <= "11111111";  -- 1296 = FF
      when "001001010010111" =>  data <= "11111111";  -- 1297 = FF
      when "001001010011000" =>  data <= "11111111";  -- 1298 = FF
      when "001001010011001" =>  data <= "11111111";  -- 1299 = FF
      when "001001010011010" =>  data <= "11111111";  -- 129A = FF
      when "001001010011011" =>  data <= "11111111";  -- 129B = FF
      when "001001010011100" =>  data <= "11111111";  -- 129C = FF
      when "001001010011101" =>  data <= "11111111";  -- 129D = FF
      when "001001010011110" =>  data <= "11111111";  -- 129E = FF
      when "001001010011111" =>  data <= "11111111";  -- 129F = FF
      when "001001010100000" =>  data <= "11111111";  -- 12A0 = FF
      when "001001010100001" =>  data <= "11111111";  -- 12A1 = FF
      when "001001010100010" =>  data <= "11111111";  -- 12A2 = FF
      when "001001010100011" =>  data <= "11111111";  -- 12A3 = FF
      when "001001010100100" =>  data <= "11111111";  -- 12A4 = FF
      when "001001010100101" =>  data <= "11111111";  -- 12A5 = FF
      when "001001010100110" =>  data <= "11111111";  -- 12A6 = FF
      when "001001010100111" =>  data <= "11111111";  -- 12A7 = FF
      when "001001010101000" =>  data <= "11111111";  -- 12A8 = FF
      when "001001010101001" =>  data <= "11111111";  -- 12A9 = FF
      when "001001010101010" =>  data <= "11111111";  -- 12AA = FF
      when "001001010101011" =>  data <= "11111111";  -- 12AB = FF
      when "001001010101100" =>  data <= "11111111";  -- 12AC = FF
      when "001001010101101" =>  data <= "11111111";  -- 12AD = FF
      when "001001010101110" =>  data <= "11111111";  -- 12AE = FF
      when "001001010101111" =>  data <= "11111111";  -- 12AF = FF
      when "001001010110000" =>  data <= "11111111";  -- 12B0 = FF
      when "001001010110001" =>  data <= "11111111";  -- 12B1 = FF
      when "001001010110010" =>  data <= "11111111";  -- 12B2 = FF
      when "001001010110011" =>  data <= "11111111";  -- 12B3 = FF
      when "001001010110100" =>  data <= "11111111";  -- 12B4 = FF
      when "001001010110101" =>  data <= "11111111";  -- 12B5 = FF
      when "001001010110110" =>  data <= "11111111";  -- 12B6 = FF
      when "001001010110111" =>  data <= "11111111";  -- 12B7 = FF
      when "001001010111000" =>  data <= "11111111";  -- 12B8 = FF
      when "001001010111001" =>  data <= "11111111";  -- 12B9 = FF
      when "001001010111010" =>  data <= "11111111";  -- 12BA = FF
      when "001001010111011" =>  data <= "11111111";  -- 12BB = FF
      when "001001010111100" =>  data <= "11111111";  -- 12BC = FF
      when "001001010111101" =>  data <= "11111111";  -- 12BD = FF
      when "001001010111110" =>  data <= "11111111";  -- 12BE = FF
      when "001001010111111" =>  data <= "11111111";  -- 12BF = FF
      when "001001011000000" =>  data <= "11111111";  -- 12C0 = FF
      when "001001011000001" =>  data <= "11111111";  -- 12C1 = FF
      when "001001011000010" =>  data <= "11111111";  -- 12C2 = FF
      when "001001011000011" =>  data <= "11111111";  -- 12C3 = FF
      when "001001011000100" =>  data <= "11111111";  -- 12C4 = FF
      when "001001011000101" =>  data <= "11111111";  -- 12C5 = FF
      when "001001011000110" =>  data <= "11111111";  -- 12C6 = FF
      when "001001011000111" =>  data <= "11111111";  -- 12C7 = FF
      when "001001011001000" =>  data <= "11111111";  -- 12C8 = FF
      when "001001011001001" =>  data <= "11111111";  -- 12C9 = FF
      when "001001011001010" =>  data <= "11111111";  -- 12CA = FF
      when "001001011001011" =>  data <= "11111111";  -- 12CB = FF
      when "001001011001100" =>  data <= "11111111";  -- 12CC = FF
      when "001001011001101" =>  data <= "11111111";  -- 12CD = FF
      when "001001011001110" =>  data <= "11111111";  -- 12CE = FF
      when "001001011001111" =>  data <= "11111111";  -- 12CF = FF
      when "001001011010000" =>  data <= "11111111";  -- 12D0 = FF
      when "001001011010001" =>  data <= "11111111";  -- 12D1 = FF
      when "001001011010010" =>  data <= "11111111";  -- 12D2 = FF
      when "001001011010011" =>  data <= "11111111";  -- 12D3 = FF
      when "001001011010100" =>  data <= "11111111";  -- 12D4 = FF
      when "001001011010101" =>  data <= "11111111";  -- 12D5 = FF
      when "001001011010110" =>  data <= "11111111";  -- 12D6 = FF
      when "001001011010111" =>  data <= "11111111";  -- 12D7 = FF
      when "001001011011000" =>  data <= "11111111";  -- 12D8 = FF
      when "001001011011001" =>  data <= "11111111";  -- 12D9 = FF
      when "001001011011010" =>  data <= "11111111";  -- 12DA = FF
      when "001001011011011" =>  data <= "11111111";  -- 12DB = FF
      when "001001011011100" =>  data <= "11111111";  -- 12DC = FF
      when "001001011011101" =>  data <= "11111111";  -- 12DD = FF
      when "001001011011110" =>  data <= "11111111";  -- 12DE = FF
      when "001001011011111" =>  data <= "11111111";  -- 12DF = FF
      when "001001011100000" =>  data <= "11111111";  -- 12E0 = FF
      when "001001011100001" =>  data <= "11111111";  -- 12E1 = FF
      when "001001011100010" =>  data <= "11111111";  -- 12E2 = FF
      when "001001011100011" =>  data <= "11111111";  -- 12E3 = FF
      when "001001011100100" =>  data <= "11111111";  -- 12E4 = FF
      when "001001011100101" =>  data <= "11111111";  -- 12E5 = FF
      when "001001011100110" =>  data <= "11111111";  -- 12E6 = FF
      when "001001011100111" =>  data <= "11111111";  -- 12E7 = FF
      when "001001011101000" =>  data <= "11111111";  -- 12E8 = FF
      when "001001011101001" =>  data <= "11111111";  -- 12E9 = FF
      when "001001011101010" =>  data <= "11111111";  -- 12EA = FF
      when "001001011101011" =>  data <= "11111111";  -- 12EB = FF
      when "001001011101100" =>  data <= "11111111";  -- 12EC = FF
      when "001001011101101" =>  data <= "11111111";  -- 12ED = FF
      when "001001011101110" =>  data <= "11111111";  -- 12EE = FF
      when "001001011101111" =>  data <= "11111111";  -- 12EF = FF
      when "001001011110000" =>  data <= "11111111";  -- 12F0 = FF
      when "001001011110001" =>  data <= "11111111";  -- 12F1 = FF
      when "001001011110010" =>  data <= "11111111";  -- 12F2 = FF
      when "001001011110011" =>  data <= "11111111";  -- 12F3 = FF
      when "001001011110100" =>  data <= "11111111";  -- 12F4 = FF
      when "001001011110101" =>  data <= "11111111";  -- 12F5 = FF
      when "001001011110110" =>  data <= "11111111";  -- 12F6 = FF
      when "001001011110111" =>  data <= "11111111";  -- 12F7 = FF
      when "001001011111000" =>  data <= "11111111";  -- 12F8 = FF
      when "001001011111001" =>  data <= "11111111";  -- 12F9 = FF
      when "001001011111010" =>  data <= "11111111";  -- 12FA = FF
      when "001001011111011" =>  data <= "11111111";  -- 12FB = FF
      when "001001011111100" =>  data <= "11111111";  -- 12FC = FF
      when "001001011111101" =>  data <= "11111111";  -- 12FD = FF
      when "001001011111110" =>  data <= "11111111";  -- 12FE = FF
      when "001001011111111" =>  data <= "11111111";  -- 12FF = FF
      when "001001100000000" =>  data <= "11111111";  -- 1300 = FF
      when "001001100000001" =>  data <= "11111111";  -- 1301 = FF
      when "001001100000010" =>  data <= "11111111";  -- 1302 = FF
      when "001001100000011" =>  data <= "11111111";  -- 1303 = FF
      when "001001100000100" =>  data <= "11111111";  -- 1304 = FF
      when "001001100000101" =>  data <= "11111111";  -- 1305 = FF
      when "001001100000110" =>  data <= "11111111";  -- 1306 = FF
      when "001001100000111" =>  data <= "11111111";  -- 1307 = FF
      when "001001100001000" =>  data <= "11111111";  -- 1308 = FF
      when "001001100001001" =>  data <= "11111111";  -- 1309 = FF
      when "001001100001010" =>  data <= "11111111";  -- 130A = FF
      when "001001100001011" =>  data <= "11111111";  -- 130B = FF
      when "001001100001100" =>  data <= "11111111";  -- 130C = FF
      when "001001100001101" =>  data <= "11111111";  -- 130D = FF
      when "001001100001110" =>  data <= "11111111";  -- 130E = FF
      when "001001100001111" =>  data <= "11111111";  -- 130F = FF
      when "001001100010000" =>  data <= "11111111";  -- 1310 = FF
      when "001001100010001" =>  data <= "11111111";  -- 1311 = FF
      when "001001100010010" =>  data <= "11111111";  -- 1312 = FF
      when "001001100010011" =>  data <= "11111111";  -- 1313 = FF
      when "001001100010100" =>  data <= "11111111";  -- 1314 = FF
      when "001001100010101" =>  data <= "11111111";  -- 1315 = FF
      when "001001100010110" =>  data <= "11111111";  -- 1316 = FF
      when "001001100010111" =>  data <= "11111111";  -- 1317 = FF
      when "001001100011000" =>  data <= "11111111";  -- 1318 = FF
      when "001001100011001" =>  data <= "11111111";  -- 1319 = FF
      when "001001100011010" =>  data <= "11111111";  -- 131A = FF
      when "001001100011011" =>  data <= "11111111";  -- 131B = FF
      when "001001100011100" =>  data <= "11111111";  -- 131C = FF
      when "001001100011101" =>  data <= "11111111";  -- 131D = FF
      when "001001100011110" =>  data <= "11111111";  -- 131E = FF
      when "001001100011111" =>  data <= "11111111";  -- 131F = FF
      when "001001100100000" =>  data <= "11111111";  -- 1320 = FF
      when "001001100100001" =>  data <= "11111111";  -- 1321 = FF
      when "001001100100010" =>  data <= "11111111";  -- 1322 = FF
      when "001001100100011" =>  data <= "11111111";  -- 1323 = FF
      when "001001100100100" =>  data <= "11111111";  -- 1324 = FF
      when "001001100100101" =>  data <= "11111111";  -- 1325 = FF
      when "001001100100110" =>  data <= "11111111";  -- 1326 = FF
      when "001001100100111" =>  data <= "11111111";  -- 1327 = FF
      when "001001100101000" =>  data <= "11111111";  -- 1328 = FF
      when "001001100101001" =>  data <= "11111111";  -- 1329 = FF
      when "001001100101010" =>  data <= "11111111";  -- 132A = FF
      when "001001100101011" =>  data <= "11111111";  -- 132B = FF
      when "001001100101100" =>  data <= "11111111";  -- 132C = FF
      when "001001100101101" =>  data <= "11111111";  -- 132D = FF
      when "001001100101110" =>  data <= "11111111";  -- 132E = FF
      when "001001100101111" =>  data <= "11111111";  -- 132F = FF
      when "001001100110000" =>  data <= "11111111";  -- 1330 = FF
      when "001001100110001" =>  data <= "11111111";  -- 1331 = FF
      when "001001100110010" =>  data <= "11111111";  -- 1332 = FF
      when "001001100110011" =>  data <= "11111111";  -- 1333 = FF
      when "001001100110100" =>  data <= "11111111";  -- 1334 = FF
      when "001001100110101" =>  data <= "11111111";  -- 1335 = FF
      when "001001100110110" =>  data <= "11111111";  -- 1336 = FF
      when "001001100110111" =>  data <= "11111111";  -- 1337 = FF
      when "001001100111000" =>  data <= "11111111";  -- 1338 = FF
      when "001001100111001" =>  data <= "11111111";  -- 1339 = FF
      when "001001100111010" =>  data <= "11111111";  -- 133A = FF
      when "001001100111011" =>  data <= "11111111";  -- 133B = FF
      when "001001100111100" =>  data <= "11111111";  -- 133C = FF
      when "001001100111101" =>  data <= "11111111";  -- 133D = FF
      when "001001100111110" =>  data <= "11111111";  -- 133E = FF
      when "001001100111111" =>  data <= "11111111";  -- 133F = FF
      when "001001101000000" =>  data <= "11111111";  -- 1340 = FF
      when "001001101000001" =>  data <= "11111111";  -- 1341 = FF
      when "001001101000010" =>  data <= "11111111";  -- 1342 = FF
      when "001001101000011" =>  data <= "11111111";  -- 1343 = FF
      when "001001101000100" =>  data <= "11111111";  -- 1344 = FF
      when "001001101000101" =>  data <= "11111111";  -- 1345 = FF
      when "001001101000110" =>  data <= "11111111";  -- 1346 = FF
      when "001001101000111" =>  data <= "11111111";  -- 1347 = FF
      when "001001101001000" =>  data <= "11111111";  -- 1348 = FF
      when "001001101001001" =>  data <= "11111111";  -- 1349 = FF
      when "001001101001010" =>  data <= "11111111";  -- 134A = FF
      when "001001101001011" =>  data <= "11111111";  -- 134B = FF
      when "001001101001100" =>  data <= "11111111";  -- 134C = FF
      when "001001101001101" =>  data <= "11111111";  -- 134D = FF
      when "001001101001110" =>  data <= "11111111";  -- 134E = FF
      when "001001101001111" =>  data <= "11111111";  -- 134F = FF
      when "001001101010000" =>  data <= "11111111";  -- 1350 = FF
      when "001001101010001" =>  data <= "11111111";  -- 1351 = FF
      when "001001101010010" =>  data <= "11111111";  -- 1352 = FF
      when "001001101010011" =>  data <= "11111111";  -- 1353 = FF
      when "001001101010100" =>  data <= "11111111";  -- 1354 = FF
      when "001001101010101" =>  data <= "11111111";  -- 1355 = FF
      when "001001101010110" =>  data <= "11111111";  -- 1356 = FF
      when "001001101010111" =>  data <= "11111111";  -- 1357 = FF
      when "001001101011000" =>  data <= "11111111";  -- 1358 = FF
      when "001001101011001" =>  data <= "11111111";  -- 1359 = FF
      when "001001101011010" =>  data <= "11111111";  -- 135A = FF
      when "001001101011011" =>  data <= "11111111";  -- 135B = FF
      when "001001101011100" =>  data <= "11111111";  -- 135C = FF
      when "001001101011101" =>  data <= "11111111";  -- 135D = FF
      when "001001101011110" =>  data <= "11111111";  -- 135E = FF
      when "001001101011111" =>  data <= "11111111";  -- 135F = FF
      when "001001101100000" =>  data <= "11111111";  -- 1360 = FF
      when "001001101100001" =>  data <= "11111111";  -- 1361 = FF
      when "001001101100010" =>  data <= "11111111";  -- 1362 = FF
      when "001001101100011" =>  data <= "11111111";  -- 1363 = FF
      when "001001101100100" =>  data <= "11111111";  -- 1364 = FF
      when "001001101100101" =>  data <= "11111111";  -- 1365 = FF
      when "001001101100110" =>  data <= "11111111";  -- 1366 = FF
      when "001001101100111" =>  data <= "11111111";  -- 1367 = FF
      when "001001101101000" =>  data <= "11111111";  -- 1368 = FF
      when "001001101101001" =>  data <= "11111111";  -- 1369 = FF
      when "001001101101010" =>  data <= "11111111";  -- 136A = FF
      when "001001101101011" =>  data <= "11111111";  -- 136B = FF
      when "001001101101100" =>  data <= "11111111";  -- 136C = FF
      when "001001101101101" =>  data <= "11111111";  -- 136D = FF
      when "001001101101110" =>  data <= "11111111";  -- 136E = FF
      when "001001101101111" =>  data <= "11111111";  -- 136F = FF
      when "001001101110000" =>  data <= "11111111";  -- 1370 = FF
      when "001001101110001" =>  data <= "11111111";  -- 1371 = FF
      when "001001101110010" =>  data <= "11111111";  -- 1372 = FF
      when "001001101110011" =>  data <= "11111111";  -- 1373 = FF
      when "001001101110100" =>  data <= "11111111";  -- 1374 = FF
      when "001001101110101" =>  data <= "11111111";  -- 1375 = FF
      when "001001101110110" =>  data <= "11111111";  -- 1376 = FF
      when "001001101110111" =>  data <= "11111111";  -- 1377 = FF
      when "001001101111000" =>  data <= "11111111";  -- 1378 = FF
      when "001001101111001" =>  data <= "11111111";  -- 1379 = FF
      when "001001101111010" =>  data <= "11111111";  -- 137A = FF
      when "001001101111011" =>  data <= "11111111";  -- 137B = FF
      when "001001101111100" =>  data <= "11111111";  -- 137C = FF
      when "001001101111101" =>  data <= "11111111";  -- 137D = FF
      when "001001101111110" =>  data <= "11111111";  -- 137E = FF
      when "001001101111111" =>  data <= "11111111";  -- 137F = FF
      when "001001110000000" =>  data <= "11111111";  -- 1380 = FF
      when "001001110000001" =>  data <= "11111111";  -- 1381 = FF
      when "001001110000010" =>  data <= "11111111";  -- 1382 = FF
      when "001001110000011" =>  data <= "11111111";  -- 1383 = FF
      when "001001110000100" =>  data <= "11111111";  -- 1384 = FF
      when "001001110000101" =>  data <= "11111111";  -- 1385 = FF
      when "001001110000110" =>  data <= "11111111";  -- 1386 = FF
      when "001001110000111" =>  data <= "11111111";  -- 1387 = FF
      when "001001110001000" =>  data <= "11111111";  -- 1388 = FF
      when "001001110001001" =>  data <= "11111111";  -- 1389 = FF
      when "001001110001010" =>  data <= "11111111";  -- 138A = FF
      when "001001110001011" =>  data <= "11111111";  -- 138B = FF
      when "001001110001100" =>  data <= "11111111";  -- 138C = FF
      when "001001110001101" =>  data <= "11111111";  -- 138D = FF
      when "001001110001110" =>  data <= "11111111";  -- 138E = FF
      when "001001110001111" =>  data <= "11111111";  -- 138F = FF
      when "001001110010000" =>  data <= "11111111";  -- 1390 = FF
      when "001001110010001" =>  data <= "11111111";  -- 1391 = FF
      when "001001110010010" =>  data <= "11111111";  -- 1392 = FF
      when "001001110010011" =>  data <= "11111111";  -- 1393 = FF
      when "001001110010100" =>  data <= "11111111";  -- 1394 = FF
      when "001001110010101" =>  data <= "11111111";  -- 1395 = FF
      when "001001110010110" =>  data <= "11111111";  -- 1396 = FF
      when "001001110010111" =>  data <= "11111111";  -- 1397 = FF
      when "001001110011000" =>  data <= "11111111";  -- 1398 = FF
      when "001001110011001" =>  data <= "11111111";  -- 1399 = FF
      when "001001110011010" =>  data <= "11111111";  -- 139A = FF
      when "001001110011011" =>  data <= "11111111";  -- 139B = FF
      when "001001110011100" =>  data <= "11111111";  -- 139C = FF
      when "001001110011101" =>  data <= "11111111";  -- 139D = FF
      when "001001110011110" =>  data <= "11111111";  -- 139E = FF
      when "001001110011111" =>  data <= "11111111";  -- 139F = FF
      when "001001110100000" =>  data <= "11111111";  -- 13A0 = FF
      when "001001110100001" =>  data <= "11111111";  -- 13A1 = FF
      when "001001110100010" =>  data <= "11111111";  -- 13A2 = FF
      when "001001110100011" =>  data <= "11111111";  -- 13A3 = FF
      when "001001110100100" =>  data <= "11111111";  -- 13A4 = FF
      when "001001110100101" =>  data <= "11111111";  -- 13A5 = FF
      when "001001110100110" =>  data <= "11111111";  -- 13A6 = FF
      when "001001110100111" =>  data <= "11111111";  -- 13A7 = FF
      when "001001110101000" =>  data <= "11111111";  -- 13A8 = FF
      when "001001110101001" =>  data <= "11111111";  -- 13A9 = FF
      when "001001110101010" =>  data <= "11111111";  -- 13AA = FF
      when "001001110101011" =>  data <= "11111111";  -- 13AB = FF
      when "001001110101100" =>  data <= "11111111";  -- 13AC = FF
      when "001001110101101" =>  data <= "11111111";  -- 13AD = FF
      when "001001110101110" =>  data <= "11111111";  -- 13AE = FF
      when "001001110101111" =>  data <= "11111111";  -- 13AF = FF
      when "001001110110000" =>  data <= "11111111";  -- 13B0 = FF
      when "001001110110001" =>  data <= "11111111";  -- 13B1 = FF
      when "001001110110010" =>  data <= "11111111";  -- 13B2 = FF
      when "001001110110011" =>  data <= "11111111";  -- 13B3 = FF
      when "001001110110100" =>  data <= "11111111";  -- 13B4 = FF
      when "001001110110101" =>  data <= "11111111";  -- 13B5 = FF
      when "001001110110110" =>  data <= "11111111";  -- 13B6 = FF
      when "001001110110111" =>  data <= "11111111";  -- 13B7 = FF
      when "001001110111000" =>  data <= "11111111";  -- 13B8 = FF
      when "001001110111001" =>  data <= "11111111";  -- 13B9 = FF
      when "001001110111010" =>  data <= "11111111";  -- 13BA = FF
      when "001001110111011" =>  data <= "11111111";  -- 13BB = FF
      when "001001110111100" =>  data <= "11111111";  -- 13BC = FF
      when "001001110111101" =>  data <= "11111111";  -- 13BD = FF
      when "001001110111110" =>  data <= "11111111";  -- 13BE = FF
      when "001001110111111" =>  data <= "11111111";  -- 13BF = FF
      when "001001111000000" =>  data <= "11111111";  -- 13C0 = FF
      when "001001111000001" =>  data <= "11111111";  -- 13C1 = FF
      when "001001111000010" =>  data <= "11111111";  -- 13C2 = FF
      when "001001111000011" =>  data <= "11111111";  -- 13C3 = FF
      when "001001111000100" =>  data <= "11111111";  -- 13C4 = FF
      when "001001111000101" =>  data <= "11111111";  -- 13C5 = FF
      when "001001111000110" =>  data <= "11111111";  -- 13C6 = FF
      when "001001111000111" =>  data <= "11111111";  -- 13C7 = FF
      when "001001111001000" =>  data <= "11111111";  -- 13C8 = FF
      when "001001111001001" =>  data <= "11111111";  -- 13C9 = FF
      when "001001111001010" =>  data <= "11111111";  -- 13CA = FF
      when "001001111001011" =>  data <= "11111111";  -- 13CB = FF
      when "001001111001100" =>  data <= "11111111";  -- 13CC = FF
      when "001001111001101" =>  data <= "11111111";  -- 13CD = FF
      when "001001111001110" =>  data <= "11111111";  -- 13CE = FF
      when "001001111001111" =>  data <= "11111111";  -- 13CF = FF
      when "001001111010000" =>  data <= "11111111";  -- 13D0 = FF
      when "001001111010001" =>  data <= "11111111";  -- 13D1 = FF
      when "001001111010010" =>  data <= "11111111";  -- 13D2 = FF
      when "001001111010011" =>  data <= "11111111";  -- 13D3 = FF
      when "001001111010100" =>  data <= "11111111";  -- 13D4 = FF
      when "001001111010101" =>  data <= "11111111";  -- 13D5 = FF
      when "001001111010110" =>  data <= "11111111";  -- 13D6 = FF
      when "001001111010111" =>  data <= "11111111";  -- 13D7 = FF
      when "001001111011000" =>  data <= "11111111";  -- 13D8 = FF
      when "001001111011001" =>  data <= "11111111";  -- 13D9 = FF
      when "001001111011010" =>  data <= "11111111";  -- 13DA = FF
      when "001001111011011" =>  data <= "11111111";  -- 13DB = FF
      when "001001111011100" =>  data <= "11111111";  -- 13DC = FF
      when "001001111011101" =>  data <= "11111111";  -- 13DD = FF
      when "001001111011110" =>  data <= "11111111";  -- 13DE = FF
      when "001001111011111" =>  data <= "11111111";  -- 13DF = FF
      when "001001111100000" =>  data <= "11111111";  -- 13E0 = FF
      when "001001111100001" =>  data <= "11111111";  -- 13E1 = FF
      when "001001111100010" =>  data <= "11111111";  -- 13E2 = FF
      when "001001111100011" =>  data <= "11111111";  -- 13E3 = FF
      when "001001111100100" =>  data <= "11111111";  -- 13E4 = FF
      when "001001111100101" =>  data <= "11111111";  -- 13E5 = FF
      when "001001111100110" =>  data <= "11111111";  -- 13E6 = FF
      when "001001111100111" =>  data <= "11111111";  -- 13E7 = FF
      when "001001111101000" =>  data <= "11111111";  -- 13E8 = FF
      when "001001111101001" =>  data <= "11111111";  -- 13E9 = FF
      when "001001111101010" =>  data <= "11111111";  -- 13EA = FF
      when "001001111101011" =>  data <= "11111111";  -- 13EB = FF
      when "001001111101100" =>  data <= "11111111";  -- 13EC = FF
      when "001001111101101" =>  data <= "11111111";  -- 13ED = FF
      when "001001111101110" =>  data <= "11111111";  -- 13EE = FF
      when "001001111101111" =>  data <= "11111111";  -- 13EF = FF
      when "001001111110000" =>  data <= "11111111";  -- 13F0 = FF
      when "001001111110001" =>  data <= "11111111";  -- 13F1 = FF
      when "001001111110010" =>  data <= "11111111";  -- 13F2 = FF
      when "001001111110011" =>  data <= "11111111";  -- 13F3 = FF
      when "001001111110100" =>  data <= "11111111";  -- 13F4 = FF
      when "001001111110101" =>  data <= "11111111";  -- 13F5 = FF
      when "001001111110110" =>  data <= "11111111";  -- 13F6 = FF
      when "001001111110111" =>  data <= "11111111";  -- 13F7 = FF
      when "001001111111000" =>  data <= "11111111";  -- 13F8 = FF
      when "001001111111001" =>  data <= "11111111";  -- 13F9 = FF
      when "001001111111010" =>  data <= "11111111";  -- 13FA = FF
      when "001001111111011" =>  data <= "11111111";  -- 13FB = FF
      when "001001111111100" =>  data <= "11111111";  -- 13FC = FF
      when "001001111111101" =>  data <= "11111111";  -- 13FD = FF
      when "001001111111110" =>  data <= "11111111";  -- 13FE = FF
      when "001001111111111" =>  data <= "11111111";  -- 13FF = FF
      when "001010000000000" =>  data <= "11111111";  -- 1400 = FF
      when "001010000000001" =>  data <= "11111111";  -- 1401 = FF
      when "001010000000010" =>  data <= "11111111";  -- 1402 = FF
      when "001010000000011" =>  data <= "11111111";  -- 1403 = FF
      when "001010000000100" =>  data <= "11111111";  -- 1404 = FF
      when "001010000000101" =>  data <= "11111111";  -- 1405 = FF
      when "001010000000110" =>  data <= "11111111";  -- 1406 = FF
      when "001010000000111" =>  data <= "11111111";  -- 1407 = FF
      when "001010000001000" =>  data <= "11111111";  -- 1408 = FF
      when "001010000001001" =>  data <= "11111111";  -- 1409 = FF
      when "001010000001010" =>  data <= "11111111";  -- 140A = FF
      when "001010000001011" =>  data <= "11111111";  -- 140B = FF
      when "001010000001100" =>  data <= "11111111";  -- 140C = FF
      when "001010000001101" =>  data <= "11111111";  -- 140D = FF
      when "001010000001110" =>  data <= "11111111";  -- 140E = FF
      when "001010000001111" =>  data <= "11111111";  -- 140F = FF
      when "001010000010000" =>  data <= "11111111";  -- 1410 = FF
      when "001010000010001" =>  data <= "11111111";  -- 1411 = FF
      when "001010000010010" =>  data <= "11111111";  -- 1412 = FF
      when "001010000010011" =>  data <= "11111111";  -- 1413 = FF
      when "001010000010100" =>  data <= "11111111";  -- 1414 = FF
      when "001010000010101" =>  data <= "11111111";  -- 1415 = FF
      when "001010000010110" =>  data <= "11111111";  -- 1416 = FF
      when "001010000010111" =>  data <= "11111111";  -- 1417 = FF
      when "001010000011000" =>  data <= "11111111";  -- 1418 = FF
      when "001010000011001" =>  data <= "11111111";  -- 1419 = FF
      when "001010000011010" =>  data <= "11111111";  -- 141A = FF
      when "001010000011011" =>  data <= "11111111";  -- 141B = FF
      when "001010000011100" =>  data <= "11111111";  -- 141C = FF
      when "001010000011101" =>  data <= "11111111";  -- 141D = FF
      when "001010000011110" =>  data <= "11111111";  -- 141E = FF
      when "001010000011111" =>  data <= "11111111";  -- 141F = FF
      when "001010000100000" =>  data <= "11111111";  -- 1420 = FF
      when "001010000100001" =>  data <= "11111111";  -- 1421 = FF
      when "001010000100010" =>  data <= "11111111";  -- 1422 = FF
      when "001010000100011" =>  data <= "11111111";  -- 1423 = FF
      when "001010000100100" =>  data <= "11111111";  -- 1424 = FF
      when "001010000100101" =>  data <= "11111111";  -- 1425 = FF
      when "001010000100110" =>  data <= "11111111";  -- 1426 = FF
      when "001010000100111" =>  data <= "11111111";  -- 1427 = FF
      when "001010000101000" =>  data <= "11111111";  -- 1428 = FF
      when "001010000101001" =>  data <= "11111111";  -- 1429 = FF
      when "001010000101010" =>  data <= "11111111";  -- 142A = FF
      when "001010000101011" =>  data <= "11111111";  -- 142B = FF
      when "001010000101100" =>  data <= "11111111";  -- 142C = FF
      when "001010000101101" =>  data <= "11111111";  -- 142D = FF
      when "001010000101110" =>  data <= "11111111";  -- 142E = FF
      when "001010000101111" =>  data <= "11111111";  -- 142F = FF
      when "001010000110000" =>  data <= "11111111";  -- 1430 = FF
      when "001010000110001" =>  data <= "11111111";  -- 1431 = FF
      when "001010000110010" =>  data <= "11111111";  -- 1432 = FF
      when "001010000110011" =>  data <= "11111111";  -- 1433 = FF
      when "001010000110100" =>  data <= "11111111";  -- 1434 = FF
      when "001010000110101" =>  data <= "11111111";  -- 1435 = FF
      when "001010000110110" =>  data <= "11111111";  -- 1436 = FF
      when "001010000110111" =>  data <= "11111111";  -- 1437 = FF
      when "001010000111000" =>  data <= "11111111";  -- 1438 = FF
      when "001010000111001" =>  data <= "11111111";  -- 1439 = FF
      when "001010000111010" =>  data <= "11111111";  -- 143A = FF
      when "001010000111011" =>  data <= "11111111";  -- 143B = FF
      when "001010000111100" =>  data <= "11111111";  -- 143C = FF
      when "001010000111101" =>  data <= "11111111";  -- 143D = FF
      when "001010000111110" =>  data <= "11111111";  -- 143E = FF
      when "001010000111111" =>  data <= "11111111";  -- 143F = FF
      when "001010001000000" =>  data <= "11111111";  -- 1440 = FF
      when "001010001000001" =>  data <= "11111111";  -- 1441 = FF
      when "001010001000010" =>  data <= "11111111";  -- 1442 = FF
      when "001010001000011" =>  data <= "11111111";  -- 1443 = FF
      when "001010001000100" =>  data <= "11111111";  -- 1444 = FF
      when "001010001000101" =>  data <= "11111111";  -- 1445 = FF
      when "001010001000110" =>  data <= "11111111";  -- 1446 = FF
      when "001010001000111" =>  data <= "11111111";  -- 1447 = FF
      when "001010001001000" =>  data <= "11111111";  -- 1448 = FF
      when "001010001001001" =>  data <= "11111111";  -- 1449 = FF
      when "001010001001010" =>  data <= "11111111";  -- 144A = FF
      when "001010001001011" =>  data <= "11111111";  -- 144B = FF
      when "001010001001100" =>  data <= "11111111";  -- 144C = FF
      when "001010001001101" =>  data <= "11111111";  -- 144D = FF
      when "001010001001110" =>  data <= "11111111";  -- 144E = FF
      when "001010001001111" =>  data <= "11111111";  -- 144F = FF
      when "001010001010000" =>  data <= "11111111";  -- 1450 = FF
      when "001010001010001" =>  data <= "11111111";  -- 1451 = FF
      when "001010001010010" =>  data <= "11111111";  -- 1452 = FF
      when "001010001010011" =>  data <= "11111111";  -- 1453 = FF
      when "001010001010100" =>  data <= "11111111";  -- 1454 = FF
      when "001010001010101" =>  data <= "11111111";  -- 1455 = FF
      when "001010001010110" =>  data <= "11111111";  -- 1456 = FF
      when "001010001010111" =>  data <= "11111111";  -- 1457 = FF
      when "001010001011000" =>  data <= "11111111";  -- 1458 = FF
      when "001010001011001" =>  data <= "11111111";  -- 1459 = FF
      when "001010001011010" =>  data <= "11111111";  -- 145A = FF
      when "001010001011011" =>  data <= "11111111";  -- 145B = FF
      when "001010001011100" =>  data <= "11111111";  -- 145C = FF
      when "001010001011101" =>  data <= "11111111";  -- 145D = FF
      when "001010001011110" =>  data <= "11111111";  -- 145E = FF
      when "001010001011111" =>  data <= "11111111";  -- 145F = FF
      when "001010001100000" =>  data <= "11111111";  -- 1460 = FF
      when "001010001100001" =>  data <= "11111111";  -- 1461 = FF
      when "001010001100010" =>  data <= "11111111";  -- 1462 = FF
      when "001010001100011" =>  data <= "11111111";  -- 1463 = FF
      when "001010001100100" =>  data <= "11111111";  -- 1464 = FF
      when "001010001100101" =>  data <= "11111111";  -- 1465 = FF
      when "001010001100110" =>  data <= "11111111";  -- 1466 = FF
      when "001010001100111" =>  data <= "11111111";  -- 1467 = FF
      when "001010001101000" =>  data <= "11111111";  -- 1468 = FF
      when "001010001101001" =>  data <= "11111111";  -- 1469 = FF
      when "001010001101010" =>  data <= "11111111";  -- 146A = FF
      when "001010001101011" =>  data <= "11111111";  -- 146B = FF
      when "001010001101100" =>  data <= "11111111";  -- 146C = FF
      when "001010001101101" =>  data <= "11111111";  -- 146D = FF
      when "001010001101110" =>  data <= "11111111";  -- 146E = FF
      when "001010001101111" =>  data <= "11111111";  -- 146F = FF
      when "001010001110000" =>  data <= "11111111";  -- 1470 = FF
      when "001010001110001" =>  data <= "11111111";  -- 1471 = FF
      when "001010001110010" =>  data <= "11111111";  -- 1472 = FF
      when "001010001110011" =>  data <= "11111111";  -- 1473 = FF
      when "001010001110100" =>  data <= "11111111";  -- 1474 = FF
      when "001010001110101" =>  data <= "11111111";  -- 1475 = FF
      when "001010001110110" =>  data <= "11111111";  -- 1476 = FF
      when "001010001110111" =>  data <= "11111111";  -- 1477 = FF
      when "001010001111000" =>  data <= "11111111";  -- 1478 = FF
      when "001010001111001" =>  data <= "11111111";  -- 1479 = FF
      when "001010001111010" =>  data <= "11111111";  -- 147A = FF
      when "001010001111011" =>  data <= "11111111";  -- 147B = FF
      when "001010001111100" =>  data <= "11111111";  -- 147C = FF
      when "001010001111101" =>  data <= "11111111";  -- 147D = FF
      when "001010001111110" =>  data <= "11111111";  -- 147E = FF
      when "001010001111111" =>  data <= "11111111";  -- 147F = FF
      when "001010010000000" =>  data <= "11111111";  -- 1480 = FF
      when "001010010000001" =>  data <= "11111111";  -- 1481 = FF
      when "001010010000010" =>  data <= "11111111";  -- 1482 = FF
      when "001010010000011" =>  data <= "11111111";  -- 1483 = FF
      when "001010010000100" =>  data <= "11111111";  -- 1484 = FF
      when "001010010000101" =>  data <= "11111111";  -- 1485 = FF
      when "001010010000110" =>  data <= "11111111";  -- 1486 = FF
      when "001010010000111" =>  data <= "11111111";  -- 1487 = FF
      when "001010010001000" =>  data <= "11111111";  -- 1488 = FF
      when "001010010001001" =>  data <= "11111111";  -- 1489 = FF
      when "001010010001010" =>  data <= "11111111";  -- 148A = FF
      when "001010010001011" =>  data <= "11111111";  -- 148B = FF
      when "001010010001100" =>  data <= "11111111";  -- 148C = FF
      when "001010010001101" =>  data <= "11111111";  -- 148D = FF
      when "001010010001110" =>  data <= "11111111";  -- 148E = FF
      when "001010010001111" =>  data <= "11111111";  -- 148F = FF
      when "001010010010000" =>  data <= "11111111";  -- 1490 = FF
      when "001010010010001" =>  data <= "11111111";  -- 1491 = FF
      when "001010010010010" =>  data <= "11111111";  -- 1492 = FF
      when "001010010010011" =>  data <= "11111111";  -- 1493 = FF
      when "001010010010100" =>  data <= "11111111";  -- 1494 = FF
      when "001010010010101" =>  data <= "11111111";  -- 1495 = FF
      when "001010010010110" =>  data <= "11111111";  -- 1496 = FF
      when "001010010010111" =>  data <= "11111111";  -- 1497 = FF
      when "001010010011000" =>  data <= "11111111";  -- 1498 = FF
      when "001010010011001" =>  data <= "11111111";  -- 1499 = FF
      when "001010010011010" =>  data <= "11111111";  -- 149A = FF
      when "001010010011011" =>  data <= "11111111";  -- 149B = FF
      when "001010010011100" =>  data <= "11111111";  -- 149C = FF
      when "001010010011101" =>  data <= "11111111";  -- 149D = FF
      when "001010010011110" =>  data <= "11111111";  -- 149E = FF
      when "001010010011111" =>  data <= "11111111";  -- 149F = FF
      when "001010010100000" =>  data <= "11111111";  -- 14A0 = FF
      when "001010010100001" =>  data <= "11111111";  -- 14A1 = FF
      when "001010010100010" =>  data <= "11111111";  -- 14A2 = FF
      when "001010010100011" =>  data <= "11111111";  -- 14A3 = FF
      when "001010010100100" =>  data <= "11111111";  -- 14A4 = FF
      when "001010010100101" =>  data <= "11111111";  -- 14A5 = FF
      when "001010010100110" =>  data <= "11111111";  -- 14A6 = FF
      when "001010010100111" =>  data <= "11111111";  -- 14A7 = FF
      when "001010010101000" =>  data <= "11111111";  -- 14A8 = FF
      when "001010010101001" =>  data <= "11111111";  -- 14A9 = FF
      when "001010010101010" =>  data <= "11111111";  -- 14AA = FF
      when "001010010101011" =>  data <= "11111111";  -- 14AB = FF
      when "001010010101100" =>  data <= "11111111";  -- 14AC = FF
      when "001010010101101" =>  data <= "11111111";  -- 14AD = FF
      when "001010010101110" =>  data <= "11111111";  -- 14AE = FF
      when "001010010101111" =>  data <= "11111111";  -- 14AF = FF
      when "001010010110000" =>  data <= "11111111";  -- 14B0 = FF
      when "001010010110001" =>  data <= "11111111";  -- 14B1 = FF
      when "001010010110010" =>  data <= "11111111";  -- 14B2 = FF
      when "001010010110011" =>  data <= "11111111";  -- 14B3 = FF
      when "001010010110100" =>  data <= "11111111";  -- 14B4 = FF
      when "001010010110101" =>  data <= "11111111";  -- 14B5 = FF
      when "001010010110110" =>  data <= "11111111";  -- 14B6 = FF
      when "001010010110111" =>  data <= "11111111";  -- 14B7 = FF
      when "001010010111000" =>  data <= "11111111";  -- 14B8 = FF
      when "001010010111001" =>  data <= "11111111";  -- 14B9 = FF
      when "001010010111010" =>  data <= "11111111";  -- 14BA = FF
      when "001010010111011" =>  data <= "11111111";  -- 14BB = FF
      when "001010010111100" =>  data <= "11111111";  -- 14BC = FF
      when "001010010111101" =>  data <= "11111111";  -- 14BD = FF
      when "001010010111110" =>  data <= "11111111";  -- 14BE = FF
      when "001010010111111" =>  data <= "11111111";  -- 14BF = FF
      when "001010011000000" =>  data <= "11111111";  -- 14C0 = FF
      when "001010011000001" =>  data <= "11111111";  -- 14C1 = FF
      when "001010011000010" =>  data <= "11111111";  -- 14C2 = FF
      when "001010011000011" =>  data <= "11111111";  -- 14C3 = FF
      when "001010011000100" =>  data <= "11111111";  -- 14C4 = FF
      when "001010011000101" =>  data <= "11111111";  -- 14C5 = FF
      when "001010011000110" =>  data <= "11111111";  -- 14C6 = FF
      when "001010011000111" =>  data <= "11111111";  -- 14C7 = FF
      when "001010011001000" =>  data <= "11111111";  -- 14C8 = FF
      when "001010011001001" =>  data <= "11111111";  -- 14C9 = FF
      when "001010011001010" =>  data <= "11111111";  -- 14CA = FF
      when "001010011001011" =>  data <= "11111111";  -- 14CB = FF
      when "001010011001100" =>  data <= "11111111";  -- 14CC = FF
      when "001010011001101" =>  data <= "11111111";  -- 14CD = FF
      when "001010011001110" =>  data <= "11111111";  -- 14CE = FF
      when "001010011001111" =>  data <= "11111111";  -- 14CF = FF
      when "001010011010000" =>  data <= "11111111";  -- 14D0 = FF
      when "001010011010001" =>  data <= "11111111";  -- 14D1 = FF
      when "001010011010010" =>  data <= "11111111";  -- 14D2 = FF
      when "001010011010011" =>  data <= "11111111";  -- 14D3 = FF
      when "001010011010100" =>  data <= "11111111";  -- 14D4 = FF
      when "001010011010101" =>  data <= "11111111";  -- 14D5 = FF
      when "001010011010110" =>  data <= "11111111";  -- 14D6 = FF
      when "001010011010111" =>  data <= "11111111";  -- 14D7 = FF
      when "001010011011000" =>  data <= "11111111";  -- 14D8 = FF
      when "001010011011001" =>  data <= "11111111";  -- 14D9 = FF
      when "001010011011010" =>  data <= "11111111";  -- 14DA = FF
      when "001010011011011" =>  data <= "11111111";  -- 14DB = FF
      when "001010011011100" =>  data <= "11111111";  -- 14DC = FF
      when "001010011011101" =>  data <= "11111111";  -- 14DD = FF
      when "001010011011110" =>  data <= "11111111";  -- 14DE = FF
      when "001010011011111" =>  data <= "11111111";  -- 14DF = FF
      when "001010011100000" =>  data <= "11111111";  -- 14E0 = FF
      when "001010011100001" =>  data <= "11111111";  -- 14E1 = FF
      when "001010011100010" =>  data <= "11111111";  -- 14E2 = FF
      when "001010011100011" =>  data <= "11111111";  -- 14E3 = FF
      when "001010011100100" =>  data <= "11111111";  -- 14E4 = FF
      when "001010011100101" =>  data <= "11111111";  -- 14E5 = FF
      when "001010011100110" =>  data <= "11111111";  -- 14E6 = FF
      when "001010011100111" =>  data <= "11111111";  -- 14E7 = FF
      when "001010011101000" =>  data <= "11111111";  -- 14E8 = FF
      when "001010011101001" =>  data <= "11111111";  -- 14E9 = FF
      when "001010011101010" =>  data <= "11111111";  -- 14EA = FF
      when "001010011101011" =>  data <= "11111111";  -- 14EB = FF
      when "001010011101100" =>  data <= "11111111";  -- 14EC = FF
      when "001010011101101" =>  data <= "11111111";  -- 14ED = FF
      when "001010011101110" =>  data <= "11111111";  -- 14EE = FF
      when "001010011101111" =>  data <= "11111111";  -- 14EF = FF
      when "001010011110000" =>  data <= "11111111";  -- 14F0 = FF
      when "001010011110001" =>  data <= "11111111";  -- 14F1 = FF
      when "001010011110010" =>  data <= "11111111";  -- 14F2 = FF
      when "001010011110011" =>  data <= "11111111";  -- 14F3 = FF
      when "001010011110100" =>  data <= "11111111";  -- 14F4 = FF
      when "001010011110101" =>  data <= "11111111";  -- 14F5 = FF
      when "001010011110110" =>  data <= "11111111";  -- 14F6 = FF
      when "001010011110111" =>  data <= "11111111";  -- 14F7 = FF
      when "001010011111000" =>  data <= "11111111";  -- 14F8 = FF
      when "001010011111001" =>  data <= "11111111";  -- 14F9 = FF
      when "001010011111010" =>  data <= "11111111";  -- 14FA = FF
      when "001010011111011" =>  data <= "11111111";  -- 14FB = FF
      when "001010011111100" =>  data <= "11111111";  -- 14FC = FF
      when "001010011111101" =>  data <= "11111111";  -- 14FD = FF
      when "001010011111110" =>  data <= "11111111";  -- 14FE = FF
      when "001010011111111" =>  data <= "11111111";  -- 14FF = FF
      when "001010100000000" =>  data <= "11111111";  -- 1500 = FF
      when "001010100000001" =>  data <= "11111111";  -- 1501 = FF
      when "001010100000010" =>  data <= "11111111";  -- 1502 = FF
      when "001010100000011" =>  data <= "11111111";  -- 1503 = FF
      when "001010100000100" =>  data <= "11111111";  -- 1504 = FF
      when "001010100000101" =>  data <= "11111111";  -- 1505 = FF
      when "001010100000110" =>  data <= "11111111";  -- 1506 = FF
      when "001010100000111" =>  data <= "11111111";  -- 1507 = FF
      when "001010100001000" =>  data <= "11111111";  -- 1508 = FF
      when "001010100001001" =>  data <= "11111111";  -- 1509 = FF
      when "001010100001010" =>  data <= "11111111";  -- 150A = FF
      when "001010100001011" =>  data <= "11111111";  -- 150B = FF
      when "001010100001100" =>  data <= "11111111";  -- 150C = FF
      when "001010100001101" =>  data <= "11111111";  -- 150D = FF
      when "001010100001110" =>  data <= "11111111";  -- 150E = FF
      when "001010100001111" =>  data <= "11111111";  -- 150F = FF
      when "001010100010000" =>  data <= "11111111";  -- 1510 = FF
      when "001010100010001" =>  data <= "11111111";  -- 1511 = FF
      when "001010100010010" =>  data <= "11111111";  -- 1512 = FF
      when "001010100010011" =>  data <= "11111111";  -- 1513 = FF
      when "001010100010100" =>  data <= "11111111";  -- 1514 = FF
      when "001010100010101" =>  data <= "11111111";  -- 1515 = FF
      when "001010100010110" =>  data <= "11111111";  -- 1516 = FF
      when "001010100010111" =>  data <= "11111111";  -- 1517 = FF
      when "001010100011000" =>  data <= "11111111";  -- 1518 = FF
      when "001010100011001" =>  data <= "11111111";  -- 1519 = FF
      when "001010100011010" =>  data <= "11111111";  -- 151A = FF
      when "001010100011011" =>  data <= "11111111";  -- 151B = FF
      when "001010100011100" =>  data <= "11111111";  -- 151C = FF
      when "001010100011101" =>  data <= "11111111";  -- 151D = FF
      when "001010100011110" =>  data <= "11111111";  -- 151E = FF
      when "001010100011111" =>  data <= "11111111";  -- 151F = FF
      when "001010100100000" =>  data <= "11111111";  -- 1520 = FF
      when "001010100100001" =>  data <= "11111111";  -- 1521 = FF
      when "001010100100010" =>  data <= "11111111";  -- 1522 = FF
      when "001010100100011" =>  data <= "11111111";  -- 1523 = FF
      when "001010100100100" =>  data <= "11111111";  -- 1524 = FF
      when "001010100100101" =>  data <= "11111111";  -- 1525 = FF
      when "001010100100110" =>  data <= "11111111";  -- 1526 = FF
      when "001010100100111" =>  data <= "11111111";  -- 1527 = FF
      when "001010100101000" =>  data <= "11111111";  -- 1528 = FF
      when "001010100101001" =>  data <= "11111111";  -- 1529 = FF
      when "001010100101010" =>  data <= "11111111";  -- 152A = FF
      when "001010100101011" =>  data <= "11111111";  -- 152B = FF
      when "001010100101100" =>  data <= "11111111";  -- 152C = FF
      when "001010100101101" =>  data <= "11111111";  -- 152D = FF
      when "001010100101110" =>  data <= "11111111";  -- 152E = FF
      when "001010100101111" =>  data <= "11111111";  -- 152F = FF
      when "001010100110000" =>  data <= "11111111";  -- 1530 = FF
      when "001010100110001" =>  data <= "11111111";  -- 1531 = FF
      when "001010100110010" =>  data <= "11111111";  -- 1532 = FF
      when "001010100110011" =>  data <= "11111111";  -- 1533 = FF
      when "001010100110100" =>  data <= "11111111";  -- 1534 = FF
      when "001010100110101" =>  data <= "11111111";  -- 1535 = FF
      when "001010100110110" =>  data <= "11111111";  -- 1536 = FF
      when "001010100110111" =>  data <= "11111111";  -- 1537 = FF
      when "001010100111000" =>  data <= "11111111";  -- 1538 = FF
      when "001010100111001" =>  data <= "11111111";  -- 1539 = FF
      when "001010100111010" =>  data <= "11111111";  -- 153A = FF
      when "001010100111011" =>  data <= "11111111";  -- 153B = FF
      when "001010100111100" =>  data <= "11111111";  -- 153C = FF
      when "001010100111101" =>  data <= "11111111";  -- 153D = FF
      when "001010100111110" =>  data <= "11111111";  -- 153E = FF
      when "001010100111111" =>  data <= "11111111";  -- 153F = FF
      when "001010101000000" =>  data <= "11111111";  -- 1540 = FF
      when "001010101000001" =>  data <= "11111111";  -- 1541 = FF
      when "001010101000010" =>  data <= "11111111";  -- 1542 = FF
      when "001010101000011" =>  data <= "11111111";  -- 1543 = FF
      when "001010101000100" =>  data <= "11111111";  -- 1544 = FF
      when "001010101000101" =>  data <= "11111111";  -- 1545 = FF
      when "001010101000110" =>  data <= "11111111";  -- 1546 = FF
      when "001010101000111" =>  data <= "11111111";  -- 1547 = FF
      when "001010101001000" =>  data <= "11111111";  -- 1548 = FF
      when "001010101001001" =>  data <= "11111111";  -- 1549 = FF
      when "001010101001010" =>  data <= "11111111";  -- 154A = FF
      when "001010101001011" =>  data <= "11111111";  -- 154B = FF
      when "001010101001100" =>  data <= "11111111";  -- 154C = FF
      when "001010101001101" =>  data <= "11111111";  -- 154D = FF
      when "001010101001110" =>  data <= "11111111";  -- 154E = FF
      when "001010101001111" =>  data <= "11111111";  -- 154F = FF
      when "001010101010000" =>  data <= "11111111";  -- 1550 = FF
      when "001010101010001" =>  data <= "11111111";  -- 1551 = FF
      when "001010101010010" =>  data <= "11111111";  -- 1552 = FF
      when "001010101010011" =>  data <= "11111111";  -- 1553 = FF
      when "001010101010100" =>  data <= "11111111";  -- 1554 = FF
      when "001010101010101" =>  data <= "11111111";  -- 1555 = FF
      when "001010101010110" =>  data <= "11111111";  -- 1556 = FF
      when "001010101010111" =>  data <= "11111111";  -- 1557 = FF
      when "001010101011000" =>  data <= "11111111";  -- 1558 = FF
      when "001010101011001" =>  data <= "11111111";  -- 1559 = FF
      when "001010101011010" =>  data <= "11111111";  -- 155A = FF
      when "001010101011011" =>  data <= "11111111";  -- 155B = FF
      when "001010101011100" =>  data <= "11111111";  -- 155C = FF
      when "001010101011101" =>  data <= "11111111";  -- 155D = FF
      when "001010101011110" =>  data <= "11111111";  -- 155E = FF
      when "001010101011111" =>  data <= "11111111";  -- 155F = FF
      when "001010101100000" =>  data <= "11111111";  -- 1560 = FF
      when "001010101100001" =>  data <= "11111111";  -- 1561 = FF
      when "001010101100010" =>  data <= "11111111";  -- 1562 = FF
      when "001010101100011" =>  data <= "11111111";  -- 1563 = FF
      when "001010101100100" =>  data <= "11111111";  -- 1564 = FF
      when "001010101100101" =>  data <= "11111111";  -- 1565 = FF
      when "001010101100110" =>  data <= "11111111";  -- 1566 = FF
      when "001010101100111" =>  data <= "11111111";  -- 1567 = FF
      when "001010101101000" =>  data <= "11111111";  -- 1568 = FF
      when "001010101101001" =>  data <= "11111111";  -- 1569 = FF
      when "001010101101010" =>  data <= "11111111";  -- 156A = FF
      when "001010101101011" =>  data <= "11111111";  -- 156B = FF
      when "001010101101100" =>  data <= "11111111";  -- 156C = FF
      when "001010101101101" =>  data <= "11111111";  -- 156D = FF
      when "001010101101110" =>  data <= "11111111";  -- 156E = FF
      when "001010101101111" =>  data <= "11111111";  -- 156F = FF
      when "001010101110000" =>  data <= "11111111";  -- 1570 = FF
      when "001010101110001" =>  data <= "11111111";  -- 1571 = FF
      when "001010101110010" =>  data <= "11111111";  -- 1572 = FF
      when "001010101110011" =>  data <= "11111111";  -- 1573 = FF
      when "001010101110100" =>  data <= "11111111";  -- 1574 = FF
      when "001010101110101" =>  data <= "11111111";  -- 1575 = FF
      when "001010101110110" =>  data <= "11111111";  -- 1576 = FF
      when "001010101110111" =>  data <= "11111111";  -- 1577 = FF
      when "001010101111000" =>  data <= "11111111";  -- 1578 = FF
      when "001010101111001" =>  data <= "11111111";  -- 1579 = FF
      when "001010101111010" =>  data <= "11111111";  -- 157A = FF
      when "001010101111011" =>  data <= "11111111";  -- 157B = FF
      when "001010101111100" =>  data <= "11111111";  -- 157C = FF
      when "001010101111101" =>  data <= "11111111";  -- 157D = FF
      when "001010101111110" =>  data <= "11111111";  -- 157E = FF
      when "001010101111111" =>  data <= "11111111";  -- 157F = FF
      when "001010110000000" =>  data <= "11111111";  -- 1580 = FF
      when "001010110000001" =>  data <= "11111111";  -- 1581 = FF
      when "001010110000010" =>  data <= "11111111";  -- 1582 = FF
      when "001010110000011" =>  data <= "11111111";  -- 1583 = FF
      when "001010110000100" =>  data <= "11111111";  -- 1584 = FF
      when "001010110000101" =>  data <= "11111111";  -- 1585 = FF
      when "001010110000110" =>  data <= "11111111";  -- 1586 = FF
      when "001010110000111" =>  data <= "11111111";  -- 1587 = FF
      when "001010110001000" =>  data <= "11111111";  -- 1588 = FF
      when "001010110001001" =>  data <= "11111111";  -- 1589 = FF
      when "001010110001010" =>  data <= "11111111";  -- 158A = FF
      when "001010110001011" =>  data <= "11111111";  -- 158B = FF
      when "001010110001100" =>  data <= "11111111";  -- 158C = FF
      when "001010110001101" =>  data <= "11111111";  -- 158D = FF
      when "001010110001110" =>  data <= "11111111";  -- 158E = FF
      when "001010110001111" =>  data <= "11111111";  -- 158F = FF
      when "001010110010000" =>  data <= "11111111";  -- 1590 = FF
      when "001010110010001" =>  data <= "11111111";  -- 1591 = FF
      when "001010110010010" =>  data <= "11111111";  -- 1592 = FF
      when "001010110010011" =>  data <= "11111111";  -- 1593 = FF
      when "001010110010100" =>  data <= "11111111";  -- 1594 = FF
      when "001010110010101" =>  data <= "11111111";  -- 1595 = FF
      when "001010110010110" =>  data <= "11111111";  -- 1596 = FF
      when "001010110010111" =>  data <= "11111111";  -- 1597 = FF
      when "001010110011000" =>  data <= "11111111";  -- 1598 = FF
      when "001010110011001" =>  data <= "11111111";  -- 1599 = FF
      when "001010110011010" =>  data <= "11111111";  -- 159A = FF
      when "001010110011011" =>  data <= "11111111";  -- 159B = FF
      when "001010110011100" =>  data <= "11111111";  -- 159C = FF
      when "001010110011101" =>  data <= "11111111";  -- 159D = FF
      when "001010110011110" =>  data <= "11111111";  -- 159E = FF
      when "001010110011111" =>  data <= "11111111";  -- 159F = FF
      when "001010110100000" =>  data <= "11111111";  -- 15A0 = FF
      when "001010110100001" =>  data <= "11111111";  -- 15A1 = FF
      when "001010110100010" =>  data <= "11111111";  -- 15A2 = FF
      when "001010110100011" =>  data <= "11111111";  -- 15A3 = FF
      when "001010110100100" =>  data <= "11111111";  -- 15A4 = FF
      when "001010110100101" =>  data <= "11111111";  -- 15A5 = FF
      when "001010110100110" =>  data <= "11111111";  -- 15A6 = FF
      when "001010110100111" =>  data <= "11111111";  -- 15A7 = FF
      when "001010110101000" =>  data <= "11111111";  -- 15A8 = FF
      when "001010110101001" =>  data <= "11111111";  -- 15A9 = FF
      when "001010110101010" =>  data <= "11111111";  -- 15AA = FF
      when "001010110101011" =>  data <= "11111111";  -- 15AB = FF
      when "001010110101100" =>  data <= "11111111";  -- 15AC = FF
      when "001010110101101" =>  data <= "11111111";  -- 15AD = FF
      when "001010110101110" =>  data <= "11111111";  -- 15AE = FF
      when "001010110101111" =>  data <= "11111111";  -- 15AF = FF
      when "001010110110000" =>  data <= "11111111";  -- 15B0 = FF
      when "001010110110001" =>  data <= "11111111";  -- 15B1 = FF
      when "001010110110010" =>  data <= "11111111";  -- 15B2 = FF
      when "001010110110011" =>  data <= "11111111";  -- 15B3 = FF
      when "001010110110100" =>  data <= "11111111";  -- 15B4 = FF
      when "001010110110101" =>  data <= "11111111";  -- 15B5 = FF
      when "001010110110110" =>  data <= "11111111";  -- 15B6 = FF
      when "001010110110111" =>  data <= "11111111";  -- 15B7 = FF
      when "001010110111000" =>  data <= "11111111";  -- 15B8 = FF
      when "001010110111001" =>  data <= "11111111";  -- 15B9 = FF
      when "001010110111010" =>  data <= "11111111";  -- 15BA = FF
      when "001010110111011" =>  data <= "11111111";  -- 15BB = FF
      when "001010110111100" =>  data <= "11111111";  -- 15BC = FF
      when "001010110111101" =>  data <= "11111111";  -- 15BD = FF
      when "001010110111110" =>  data <= "11111111";  -- 15BE = FF
      when "001010110111111" =>  data <= "11111111";  -- 15BF = FF
      when "001010111000000" =>  data <= "11111111";  -- 15C0 = FF
      when "001010111000001" =>  data <= "11111111";  -- 15C1 = FF
      when "001010111000010" =>  data <= "11111111";  -- 15C2 = FF
      when "001010111000011" =>  data <= "11111111";  -- 15C3 = FF
      when "001010111000100" =>  data <= "11111111";  -- 15C4 = FF
      when "001010111000101" =>  data <= "11111111";  -- 15C5 = FF
      when "001010111000110" =>  data <= "11111111";  -- 15C6 = FF
      when "001010111000111" =>  data <= "11111111";  -- 15C7 = FF
      when "001010111001000" =>  data <= "11111111";  -- 15C8 = FF
      when "001010111001001" =>  data <= "11111111";  -- 15C9 = FF
      when "001010111001010" =>  data <= "11111111";  -- 15CA = FF
      when "001010111001011" =>  data <= "11111111";  -- 15CB = FF
      when "001010111001100" =>  data <= "11111111";  -- 15CC = FF
      when "001010111001101" =>  data <= "11111111";  -- 15CD = FF
      when "001010111001110" =>  data <= "11111111";  -- 15CE = FF
      when "001010111001111" =>  data <= "11111111";  -- 15CF = FF
      when "001010111010000" =>  data <= "11111111";  -- 15D0 = FF
      when "001010111010001" =>  data <= "11111111";  -- 15D1 = FF
      when "001010111010010" =>  data <= "11111111";  -- 15D2 = FF
      when "001010111010011" =>  data <= "11111111";  -- 15D3 = FF
      when "001010111010100" =>  data <= "11111111";  -- 15D4 = FF
      when "001010111010101" =>  data <= "11111111";  -- 15D5 = FF
      when "001010111010110" =>  data <= "11111111";  -- 15D6 = FF
      when "001010111010111" =>  data <= "11111111";  -- 15D7 = FF
      when "001010111011000" =>  data <= "11111111";  -- 15D8 = FF
      when "001010111011001" =>  data <= "11111111";  -- 15D9 = FF
      when "001010111011010" =>  data <= "11111111";  -- 15DA = FF
      when "001010111011011" =>  data <= "11111111";  -- 15DB = FF
      when "001010111011100" =>  data <= "11111111";  -- 15DC = FF
      when "001010111011101" =>  data <= "11111111";  -- 15DD = FF
      when "001010111011110" =>  data <= "11111111";  -- 15DE = FF
      when "001010111011111" =>  data <= "11111111";  -- 15DF = FF
      when "001010111100000" =>  data <= "11111111";  -- 15E0 = FF
      when "001010111100001" =>  data <= "11111111";  -- 15E1 = FF
      when "001010111100010" =>  data <= "11111111";  -- 15E2 = FF
      when "001010111100011" =>  data <= "11111111";  -- 15E3 = FF
      when "001010111100100" =>  data <= "11111111";  -- 15E4 = FF
      when "001010111100101" =>  data <= "11111111";  -- 15E5 = FF
      when "001010111100110" =>  data <= "11111111";  -- 15E6 = FF
      when "001010111100111" =>  data <= "11111111";  -- 15E7 = FF
      when "001010111101000" =>  data <= "11111111";  -- 15E8 = FF
      when "001010111101001" =>  data <= "11111111";  -- 15E9 = FF
      when "001010111101010" =>  data <= "11111111";  -- 15EA = FF
      when "001010111101011" =>  data <= "11111111";  -- 15EB = FF
      when "001010111101100" =>  data <= "11111111";  -- 15EC = FF
      when "001010111101101" =>  data <= "11111111";  -- 15ED = FF
      when "001010111101110" =>  data <= "11111111";  -- 15EE = FF
      when "001010111101111" =>  data <= "11111111";  -- 15EF = FF
      when "001010111110000" =>  data <= "11111111";  -- 15F0 = FF
      when "001010111110001" =>  data <= "11111111";  -- 15F1 = FF
      when "001010111110010" =>  data <= "11111111";  -- 15F2 = FF
      when "001010111110011" =>  data <= "11111111";  -- 15F3 = FF
      when "001010111110100" =>  data <= "11111111";  -- 15F4 = FF
      when "001010111110101" =>  data <= "11111111";  -- 15F5 = FF
      when "001010111110110" =>  data <= "11111111";  -- 15F6 = FF
      when "001010111110111" =>  data <= "11111111";  -- 15F7 = FF
      when "001010111111000" =>  data <= "11111111";  -- 15F8 = FF
      when "001010111111001" =>  data <= "11111111";  -- 15F9 = FF
      when "001010111111010" =>  data <= "11111111";  -- 15FA = FF
      when "001010111111011" =>  data <= "11111111";  -- 15FB = FF
      when "001010111111100" =>  data <= "11111111";  -- 15FC = FF
      when "001010111111101" =>  data <= "11111111";  -- 15FD = FF
      when "001010111111110" =>  data <= "11111111";  -- 15FE = FF
      when "001010111111111" =>  data <= "11111111";  -- 15FF = FF
      when "001011000000000" =>  data <= "11111111";  -- 1600 = FF
      when "001011000000001" =>  data <= "11111111";  -- 1601 = FF
      when "001011000000010" =>  data <= "11111111";  -- 1602 = FF
      when "001011000000011" =>  data <= "11111111";  -- 1603 = FF
      when "001011000000100" =>  data <= "11111111";  -- 1604 = FF
      when "001011000000101" =>  data <= "11111111";  -- 1605 = FF
      when "001011000000110" =>  data <= "11111111";  -- 1606 = FF
      when "001011000000111" =>  data <= "11111111";  -- 1607 = FF
      when "001011000001000" =>  data <= "11111111";  -- 1608 = FF
      when "001011000001001" =>  data <= "11111111";  -- 1609 = FF
      when "001011000001010" =>  data <= "11111111";  -- 160A = FF
      when "001011000001011" =>  data <= "11111111";  -- 160B = FF
      when "001011000001100" =>  data <= "11111111";  -- 160C = FF
      when "001011000001101" =>  data <= "11111111";  -- 160D = FF
      when "001011000001110" =>  data <= "11111111";  -- 160E = FF
      when "001011000001111" =>  data <= "11111111";  -- 160F = FF
      when "001011000010000" =>  data <= "11111111";  -- 1610 = FF
      when "001011000010001" =>  data <= "11111111";  -- 1611 = FF
      when "001011000010010" =>  data <= "11111111";  -- 1612 = FF
      when "001011000010011" =>  data <= "11111111";  -- 1613 = FF
      when "001011000010100" =>  data <= "11111111";  -- 1614 = FF
      when "001011000010101" =>  data <= "11111111";  -- 1615 = FF
      when "001011000010110" =>  data <= "11111111";  -- 1616 = FF
      when "001011000010111" =>  data <= "11111111";  -- 1617 = FF
      when "001011000011000" =>  data <= "11111111";  -- 1618 = FF
      when "001011000011001" =>  data <= "11111111";  -- 1619 = FF
      when "001011000011010" =>  data <= "11111111";  -- 161A = FF
      when "001011000011011" =>  data <= "11111111";  -- 161B = FF
      when "001011000011100" =>  data <= "11111111";  -- 161C = FF
      when "001011000011101" =>  data <= "11111111";  -- 161D = FF
      when "001011000011110" =>  data <= "11111111";  -- 161E = FF
      when "001011000011111" =>  data <= "11111111";  -- 161F = FF
      when "001011000100000" =>  data <= "11111111";  -- 1620 = FF
      when "001011000100001" =>  data <= "11111111";  -- 1621 = FF
      when "001011000100010" =>  data <= "11111111";  -- 1622 = FF
      when "001011000100011" =>  data <= "11111111";  -- 1623 = FF
      when "001011000100100" =>  data <= "11111111";  -- 1624 = FF
      when "001011000100101" =>  data <= "11111111";  -- 1625 = FF
      when "001011000100110" =>  data <= "11111111";  -- 1626 = FF
      when "001011000100111" =>  data <= "11111111";  -- 1627 = FF
      when "001011000101000" =>  data <= "11111111";  -- 1628 = FF
      when "001011000101001" =>  data <= "11111111";  -- 1629 = FF
      when "001011000101010" =>  data <= "11111111";  -- 162A = FF
      when "001011000101011" =>  data <= "11111111";  -- 162B = FF
      when "001011000101100" =>  data <= "11111111";  -- 162C = FF
      when "001011000101101" =>  data <= "11111111";  -- 162D = FF
      when "001011000101110" =>  data <= "11111111";  -- 162E = FF
      when "001011000101111" =>  data <= "11111111";  -- 162F = FF
      when "001011000110000" =>  data <= "11111111";  -- 1630 = FF
      when "001011000110001" =>  data <= "11111111";  -- 1631 = FF
      when "001011000110010" =>  data <= "11111111";  -- 1632 = FF
      when "001011000110011" =>  data <= "11111111";  -- 1633 = FF
      when "001011000110100" =>  data <= "11111111";  -- 1634 = FF
      when "001011000110101" =>  data <= "11111111";  -- 1635 = FF
      when "001011000110110" =>  data <= "11111111";  -- 1636 = FF
      when "001011000110111" =>  data <= "11111111";  -- 1637 = FF
      when "001011000111000" =>  data <= "11111111";  -- 1638 = FF
      when "001011000111001" =>  data <= "11111111";  -- 1639 = FF
      when "001011000111010" =>  data <= "11111111";  -- 163A = FF
      when "001011000111011" =>  data <= "11111111";  -- 163B = FF
      when "001011000111100" =>  data <= "11111111";  -- 163C = FF
      when "001011000111101" =>  data <= "11111111";  -- 163D = FF
      when "001011000111110" =>  data <= "11111111";  -- 163E = FF
      when "001011000111111" =>  data <= "11111111";  -- 163F = FF
      when "001011001000000" =>  data <= "11111111";  -- 1640 = FF
      when "001011001000001" =>  data <= "11111111";  -- 1641 = FF
      when "001011001000010" =>  data <= "11111111";  -- 1642 = FF
      when "001011001000011" =>  data <= "11111111";  -- 1643 = FF
      when "001011001000100" =>  data <= "11111111";  -- 1644 = FF
      when "001011001000101" =>  data <= "11111111";  -- 1645 = FF
      when "001011001000110" =>  data <= "11111111";  -- 1646 = FF
      when "001011001000111" =>  data <= "11111111";  -- 1647 = FF
      when "001011001001000" =>  data <= "11111111";  -- 1648 = FF
      when "001011001001001" =>  data <= "11111111";  -- 1649 = FF
      when "001011001001010" =>  data <= "11111111";  -- 164A = FF
      when "001011001001011" =>  data <= "11111111";  -- 164B = FF
      when "001011001001100" =>  data <= "11111111";  -- 164C = FF
      when "001011001001101" =>  data <= "11111111";  -- 164D = FF
      when "001011001001110" =>  data <= "11111111";  -- 164E = FF
      when "001011001001111" =>  data <= "11111111";  -- 164F = FF
      when "001011001010000" =>  data <= "11111111";  -- 1650 = FF
      when "001011001010001" =>  data <= "11111111";  -- 1651 = FF
      when "001011001010010" =>  data <= "11111111";  -- 1652 = FF
      when "001011001010011" =>  data <= "11111111";  -- 1653 = FF
      when "001011001010100" =>  data <= "11111111";  -- 1654 = FF
      when "001011001010101" =>  data <= "11111111";  -- 1655 = FF
      when "001011001010110" =>  data <= "11111111";  -- 1656 = FF
      when "001011001010111" =>  data <= "11111111";  -- 1657 = FF
      when "001011001011000" =>  data <= "11111111";  -- 1658 = FF
      when "001011001011001" =>  data <= "11111111";  -- 1659 = FF
      when "001011001011010" =>  data <= "11111111";  -- 165A = FF
      when "001011001011011" =>  data <= "11111111";  -- 165B = FF
      when "001011001011100" =>  data <= "11111111";  -- 165C = FF
      when "001011001011101" =>  data <= "11111111";  -- 165D = FF
      when "001011001011110" =>  data <= "11111111";  -- 165E = FF
      when "001011001011111" =>  data <= "11111111";  -- 165F = FF
      when "001011001100000" =>  data <= "11111111";  -- 1660 = FF
      when "001011001100001" =>  data <= "11111111";  -- 1661 = FF
      when "001011001100010" =>  data <= "11111111";  -- 1662 = FF
      when "001011001100011" =>  data <= "11111111";  -- 1663 = FF
      when "001011001100100" =>  data <= "11111111";  -- 1664 = FF
      when "001011001100101" =>  data <= "11111111";  -- 1665 = FF
      when "001011001100110" =>  data <= "11111111";  -- 1666 = FF
      when "001011001100111" =>  data <= "11111111";  -- 1667 = FF
      when "001011001101000" =>  data <= "11111111";  -- 1668 = FF
      when "001011001101001" =>  data <= "11111111";  -- 1669 = FF
      when "001011001101010" =>  data <= "11111111";  -- 166A = FF
      when "001011001101011" =>  data <= "11111111";  -- 166B = FF
      when "001011001101100" =>  data <= "11111111";  -- 166C = FF
      when "001011001101101" =>  data <= "11111111";  -- 166D = FF
      when "001011001101110" =>  data <= "11111111";  -- 166E = FF
      when "001011001101111" =>  data <= "11111111";  -- 166F = FF
      when "001011001110000" =>  data <= "11111111";  -- 1670 = FF
      when "001011001110001" =>  data <= "11111111";  -- 1671 = FF
      when "001011001110010" =>  data <= "11111111";  -- 1672 = FF
      when "001011001110011" =>  data <= "11111111";  -- 1673 = FF
      when "001011001110100" =>  data <= "11111111";  -- 1674 = FF
      when "001011001110101" =>  data <= "11111111";  -- 1675 = FF
      when "001011001110110" =>  data <= "11111111";  -- 1676 = FF
      when "001011001110111" =>  data <= "11111111";  -- 1677 = FF
      when "001011001111000" =>  data <= "11111111";  -- 1678 = FF
      when "001011001111001" =>  data <= "11111111";  -- 1679 = FF
      when "001011001111010" =>  data <= "11111111";  -- 167A = FF
      when "001011001111011" =>  data <= "11111111";  -- 167B = FF
      when "001011001111100" =>  data <= "11111111";  -- 167C = FF
      when "001011001111101" =>  data <= "11111111";  -- 167D = FF
      when "001011001111110" =>  data <= "11111111";  -- 167E = FF
      when "001011001111111" =>  data <= "11111111";  -- 167F = FF
      when "001011010000000" =>  data <= "11111111";  -- 1680 = FF
      when "001011010000001" =>  data <= "11111111";  -- 1681 = FF
      when "001011010000010" =>  data <= "11111111";  -- 1682 = FF
      when "001011010000011" =>  data <= "11111111";  -- 1683 = FF
      when "001011010000100" =>  data <= "11111111";  -- 1684 = FF
      when "001011010000101" =>  data <= "11111111";  -- 1685 = FF
      when "001011010000110" =>  data <= "11111111";  -- 1686 = FF
      when "001011010000111" =>  data <= "11111111";  -- 1687 = FF
      when "001011010001000" =>  data <= "11111111";  -- 1688 = FF
      when "001011010001001" =>  data <= "11111111";  -- 1689 = FF
      when "001011010001010" =>  data <= "11111111";  -- 168A = FF
      when "001011010001011" =>  data <= "11111111";  -- 168B = FF
      when "001011010001100" =>  data <= "11111111";  -- 168C = FF
      when "001011010001101" =>  data <= "11111111";  -- 168D = FF
      when "001011010001110" =>  data <= "11111111";  -- 168E = FF
      when "001011010001111" =>  data <= "11111111";  -- 168F = FF
      when "001011010010000" =>  data <= "11111111";  -- 1690 = FF
      when "001011010010001" =>  data <= "11111111";  -- 1691 = FF
      when "001011010010010" =>  data <= "11111111";  -- 1692 = FF
      when "001011010010011" =>  data <= "11111111";  -- 1693 = FF
      when "001011010010100" =>  data <= "11111111";  -- 1694 = FF
      when "001011010010101" =>  data <= "11111111";  -- 1695 = FF
      when "001011010010110" =>  data <= "11111111";  -- 1696 = FF
      when "001011010010111" =>  data <= "11111111";  -- 1697 = FF
      when "001011010011000" =>  data <= "11111111";  -- 1698 = FF
      when "001011010011001" =>  data <= "11111111";  -- 1699 = FF
      when "001011010011010" =>  data <= "11111111";  -- 169A = FF
      when "001011010011011" =>  data <= "11111111";  -- 169B = FF
      when "001011010011100" =>  data <= "11111111";  -- 169C = FF
      when "001011010011101" =>  data <= "11111111";  -- 169D = FF
      when "001011010011110" =>  data <= "11111111";  -- 169E = FF
      when "001011010011111" =>  data <= "11111111";  -- 169F = FF
      when "001011010100000" =>  data <= "11111111";  -- 16A0 = FF
      when "001011010100001" =>  data <= "11111111";  -- 16A1 = FF
      when "001011010100010" =>  data <= "11111111";  -- 16A2 = FF
      when "001011010100011" =>  data <= "11111111";  -- 16A3 = FF
      when "001011010100100" =>  data <= "11111111";  -- 16A4 = FF
      when "001011010100101" =>  data <= "11111111";  -- 16A5 = FF
      when "001011010100110" =>  data <= "11111111";  -- 16A6 = FF
      when "001011010100111" =>  data <= "11111111";  -- 16A7 = FF
      when "001011010101000" =>  data <= "11111111";  -- 16A8 = FF
      when "001011010101001" =>  data <= "11111111";  -- 16A9 = FF
      when "001011010101010" =>  data <= "11111111";  -- 16AA = FF
      when "001011010101011" =>  data <= "11111111";  -- 16AB = FF
      when "001011010101100" =>  data <= "11111111";  -- 16AC = FF
      when "001011010101101" =>  data <= "11111111";  -- 16AD = FF
      when "001011010101110" =>  data <= "11111111";  -- 16AE = FF
      when "001011010101111" =>  data <= "11111111";  -- 16AF = FF
      when "001011010110000" =>  data <= "11111111";  -- 16B0 = FF
      when "001011010110001" =>  data <= "11111111";  -- 16B1 = FF
      when "001011010110010" =>  data <= "11111111";  -- 16B2 = FF
      when "001011010110011" =>  data <= "11111111";  -- 16B3 = FF
      when "001011010110100" =>  data <= "11111111";  -- 16B4 = FF
      when "001011010110101" =>  data <= "11111111";  -- 16B5 = FF
      when "001011010110110" =>  data <= "11111111";  -- 16B6 = FF
      when "001011010110111" =>  data <= "11111111";  -- 16B7 = FF
      when "001011010111000" =>  data <= "11111111";  -- 16B8 = FF
      when "001011010111001" =>  data <= "11111111";  -- 16B9 = FF
      when "001011010111010" =>  data <= "11111111";  -- 16BA = FF
      when "001011010111011" =>  data <= "11111111";  -- 16BB = FF
      when "001011010111100" =>  data <= "11111111";  -- 16BC = FF
      when "001011010111101" =>  data <= "11111111";  -- 16BD = FF
      when "001011010111110" =>  data <= "11111111";  -- 16BE = FF
      when "001011010111111" =>  data <= "11111111";  -- 16BF = FF
      when "001011011000000" =>  data <= "11111111";  -- 16C0 = FF
      when "001011011000001" =>  data <= "11111111";  -- 16C1 = FF
      when "001011011000010" =>  data <= "11111111";  -- 16C2 = FF
      when "001011011000011" =>  data <= "11111111";  -- 16C3 = FF
      when "001011011000100" =>  data <= "11111111";  -- 16C4 = FF
      when "001011011000101" =>  data <= "11111111";  -- 16C5 = FF
      when "001011011000110" =>  data <= "11111111";  -- 16C6 = FF
      when "001011011000111" =>  data <= "11111111";  -- 16C7 = FF
      when "001011011001000" =>  data <= "11111111";  -- 16C8 = FF
      when "001011011001001" =>  data <= "11111111";  -- 16C9 = FF
      when "001011011001010" =>  data <= "11111111";  -- 16CA = FF
      when "001011011001011" =>  data <= "11111111";  -- 16CB = FF
      when "001011011001100" =>  data <= "11111111";  -- 16CC = FF
      when "001011011001101" =>  data <= "11111111";  -- 16CD = FF
      when "001011011001110" =>  data <= "11111111";  -- 16CE = FF
      when "001011011001111" =>  data <= "11111111";  -- 16CF = FF
      when "001011011010000" =>  data <= "11111111";  -- 16D0 = FF
      when "001011011010001" =>  data <= "11111111";  -- 16D1 = FF
      when "001011011010010" =>  data <= "11111111";  -- 16D2 = FF
      when "001011011010011" =>  data <= "11111111";  -- 16D3 = FF
      when "001011011010100" =>  data <= "11111111";  -- 16D4 = FF
      when "001011011010101" =>  data <= "11111111";  -- 16D5 = FF
      when "001011011010110" =>  data <= "11111111";  -- 16D6 = FF
      when "001011011010111" =>  data <= "11111111";  -- 16D7 = FF
      when "001011011011000" =>  data <= "11111111";  -- 16D8 = FF
      when "001011011011001" =>  data <= "11111111";  -- 16D9 = FF
      when "001011011011010" =>  data <= "11111111";  -- 16DA = FF
      when "001011011011011" =>  data <= "11111111";  -- 16DB = FF
      when "001011011011100" =>  data <= "11111111";  -- 16DC = FF
      when "001011011011101" =>  data <= "11111111";  -- 16DD = FF
      when "001011011011110" =>  data <= "11111111";  -- 16DE = FF
      when "001011011011111" =>  data <= "11111111";  -- 16DF = FF
      when "001011011100000" =>  data <= "11111111";  -- 16E0 = FF
      when "001011011100001" =>  data <= "11111111";  -- 16E1 = FF
      when "001011011100010" =>  data <= "11111111";  -- 16E2 = FF
      when "001011011100011" =>  data <= "11111111";  -- 16E3 = FF
      when "001011011100100" =>  data <= "11111111";  -- 16E4 = FF
      when "001011011100101" =>  data <= "11111111";  -- 16E5 = FF
      when "001011011100110" =>  data <= "11111111";  -- 16E6 = FF
      when "001011011100111" =>  data <= "11111111";  -- 16E7 = FF
      when "001011011101000" =>  data <= "11111111";  -- 16E8 = FF
      when "001011011101001" =>  data <= "11111111";  -- 16E9 = FF
      when "001011011101010" =>  data <= "11111111";  -- 16EA = FF
      when "001011011101011" =>  data <= "11111111";  -- 16EB = FF
      when "001011011101100" =>  data <= "11111111";  -- 16EC = FF
      when "001011011101101" =>  data <= "11111111";  -- 16ED = FF
      when "001011011101110" =>  data <= "11111111";  -- 16EE = FF
      when "001011011101111" =>  data <= "11111111";  -- 16EF = FF
      when "001011011110000" =>  data <= "11111111";  -- 16F0 = FF
      when "001011011110001" =>  data <= "11111111";  -- 16F1 = FF
      when "001011011110010" =>  data <= "11111111";  -- 16F2 = FF
      when "001011011110011" =>  data <= "11111111";  -- 16F3 = FF
      when "001011011110100" =>  data <= "11111111";  -- 16F4 = FF
      when "001011011110101" =>  data <= "11111111";  -- 16F5 = FF
      when "001011011110110" =>  data <= "11111111";  -- 16F6 = FF
      when "001011011110111" =>  data <= "11111111";  -- 16F7 = FF
      when "001011011111000" =>  data <= "11111111";  -- 16F8 = FF
      when "001011011111001" =>  data <= "11111111";  -- 16F9 = FF
      when "001011011111010" =>  data <= "11111111";  -- 16FA = FF
      when "001011011111011" =>  data <= "11111111";  -- 16FB = FF
      when "001011011111100" =>  data <= "11111111";  -- 16FC = FF
      when "001011011111101" =>  data <= "11111111";  -- 16FD = FF
      when "001011011111110" =>  data <= "11111111";  -- 16FE = FF
      when "001011011111111" =>  data <= "11111111";  -- 16FF = FF
      when "001011100000000" =>  data <= "11111111";  -- 1700 = FF
      when "001011100000001" =>  data <= "11111111";  -- 1701 = FF
      when "001011100000010" =>  data <= "11111111";  -- 1702 = FF
      when "001011100000011" =>  data <= "11111111";  -- 1703 = FF
      when "001011100000100" =>  data <= "11111111";  -- 1704 = FF
      when "001011100000101" =>  data <= "11111111";  -- 1705 = FF
      when "001011100000110" =>  data <= "11111111";  -- 1706 = FF
      when "001011100000111" =>  data <= "11111111";  -- 1707 = FF
      when "001011100001000" =>  data <= "11111111";  -- 1708 = FF
      when "001011100001001" =>  data <= "11111111";  -- 1709 = FF
      when "001011100001010" =>  data <= "11111111";  -- 170A = FF
      when "001011100001011" =>  data <= "11111111";  -- 170B = FF
      when "001011100001100" =>  data <= "11111111";  -- 170C = FF
      when "001011100001101" =>  data <= "11111111";  -- 170D = FF
      when "001011100001110" =>  data <= "11111111";  -- 170E = FF
      when "001011100001111" =>  data <= "11111111";  -- 170F = FF
      when "001011100010000" =>  data <= "11111111";  -- 1710 = FF
      when "001011100010001" =>  data <= "11111111";  -- 1711 = FF
      when "001011100010010" =>  data <= "11111111";  -- 1712 = FF
      when "001011100010011" =>  data <= "11111111";  -- 1713 = FF
      when "001011100010100" =>  data <= "11111111";  -- 1714 = FF
      when "001011100010101" =>  data <= "11111111";  -- 1715 = FF
      when "001011100010110" =>  data <= "11111111";  -- 1716 = FF
      when "001011100010111" =>  data <= "11111111";  -- 1717 = FF
      when "001011100011000" =>  data <= "11111111";  -- 1718 = FF
      when "001011100011001" =>  data <= "11111111";  -- 1719 = FF
      when "001011100011010" =>  data <= "11111111";  -- 171A = FF
      when "001011100011011" =>  data <= "11111111";  -- 171B = FF
      when "001011100011100" =>  data <= "11111111";  -- 171C = FF
      when "001011100011101" =>  data <= "11111111";  -- 171D = FF
      when "001011100011110" =>  data <= "11111111";  -- 171E = FF
      when "001011100011111" =>  data <= "11111111";  -- 171F = FF
      when "001011100100000" =>  data <= "11111111";  -- 1720 = FF
      when "001011100100001" =>  data <= "11111111";  -- 1721 = FF
      when "001011100100010" =>  data <= "11111111";  -- 1722 = FF
      when "001011100100011" =>  data <= "11111111";  -- 1723 = FF
      when "001011100100100" =>  data <= "11111111";  -- 1724 = FF
      when "001011100100101" =>  data <= "11111111";  -- 1725 = FF
      when "001011100100110" =>  data <= "11111111";  -- 1726 = FF
      when "001011100100111" =>  data <= "11111111";  -- 1727 = FF
      when "001011100101000" =>  data <= "11111111";  -- 1728 = FF
      when "001011100101001" =>  data <= "11111111";  -- 1729 = FF
      when "001011100101010" =>  data <= "11111111";  -- 172A = FF
      when "001011100101011" =>  data <= "11111111";  -- 172B = FF
      when "001011100101100" =>  data <= "11111111";  -- 172C = FF
      when "001011100101101" =>  data <= "11111111";  -- 172D = FF
      when "001011100101110" =>  data <= "11111111";  -- 172E = FF
      when "001011100101111" =>  data <= "11111111";  -- 172F = FF
      when "001011100110000" =>  data <= "11111111";  -- 1730 = FF
      when "001011100110001" =>  data <= "11111111";  -- 1731 = FF
      when "001011100110010" =>  data <= "11111111";  -- 1732 = FF
      when "001011100110011" =>  data <= "11111111";  -- 1733 = FF
      when "001011100110100" =>  data <= "11111111";  -- 1734 = FF
      when "001011100110101" =>  data <= "11111111";  -- 1735 = FF
      when "001011100110110" =>  data <= "11111111";  -- 1736 = FF
      when "001011100110111" =>  data <= "11111111";  -- 1737 = FF
      when "001011100111000" =>  data <= "11111111";  -- 1738 = FF
      when "001011100111001" =>  data <= "11111111";  -- 1739 = FF
      when "001011100111010" =>  data <= "11111111";  -- 173A = FF
      when "001011100111011" =>  data <= "11111111";  -- 173B = FF
      when "001011100111100" =>  data <= "11111111";  -- 173C = FF
      when "001011100111101" =>  data <= "11111111";  -- 173D = FF
      when "001011100111110" =>  data <= "11111111";  -- 173E = FF
      when "001011100111111" =>  data <= "11111111";  -- 173F = FF
      when "001011101000000" =>  data <= "11111111";  -- 1740 = FF
      when "001011101000001" =>  data <= "11111111";  -- 1741 = FF
      when "001011101000010" =>  data <= "11111111";  -- 1742 = FF
      when "001011101000011" =>  data <= "11111111";  -- 1743 = FF
      when "001011101000100" =>  data <= "11111111";  -- 1744 = FF
      when "001011101000101" =>  data <= "11111111";  -- 1745 = FF
      when "001011101000110" =>  data <= "11111111";  -- 1746 = FF
      when "001011101000111" =>  data <= "11111111";  -- 1747 = FF
      when "001011101001000" =>  data <= "11111111";  -- 1748 = FF
      when "001011101001001" =>  data <= "11111111";  -- 1749 = FF
      when "001011101001010" =>  data <= "11111111";  -- 174A = FF
      when "001011101001011" =>  data <= "11111111";  -- 174B = FF
      when "001011101001100" =>  data <= "11111111";  -- 174C = FF
      when "001011101001101" =>  data <= "11111111";  -- 174D = FF
      when "001011101001110" =>  data <= "11111111";  -- 174E = FF
      when "001011101001111" =>  data <= "11111111";  -- 174F = FF
      when "001011101010000" =>  data <= "11111111";  -- 1750 = FF
      when "001011101010001" =>  data <= "11111111";  -- 1751 = FF
      when "001011101010010" =>  data <= "11111111";  -- 1752 = FF
      when "001011101010011" =>  data <= "11111111";  -- 1753 = FF
      when "001011101010100" =>  data <= "11111111";  -- 1754 = FF
      when "001011101010101" =>  data <= "11111111";  -- 1755 = FF
      when "001011101010110" =>  data <= "11111111";  -- 1756 = FF
      when "001011101010111" =>  data <= "11111111";  -- 1757 = FF
      when "001011101011000" =>  data <= "11111111";  -- 1758 = FF
      when "001011101011001" =>  data <= "11111111";  -- 1759 = FF
      when "001011101011010" =>  data <= "11111111";  -- 175A = FF
      when "001011101011011" =>  data <= "11111111";  -- 175B = FF
      when "001011101011100" =>  data <= "11111111";  -- 175C = FF
      when "001011101011101" =>  data <= "11111111";  -- 175D = FF
      when "001011101011110" =>  data <= "11111111";  -- 175E = FF
      when "001011101011111" =>  data <= "11111111";  -- 175F = FF
      when "001011101100000" =>  data <= "11111111";  -- 1760 = FF
      when "001011101100001" =>  data <= "11111111";  -- 1761 = FF
      when "001011101100010" =>  data <= "11111111";  -- 1762 = FF
      when "001011101100011" =>  data <= "11111111";  -- 1763 = FF
      when "001011101100100" =>  data <= "11111111";  -- 1764 = FF
      when "001011101100101" =>  data <= "11111111";  -- 1765 = FF
      when "001011101100110" =>  data <= "11111111";  -- 1766 = FF
      when "001011101100111" =>  data <= "11111111";  -- 1767 = FF
      when "001011101101000" =>  data <= "11111111";  -- 1768 = FF
      when "001011101101001" =>  data <= "11111111";  -- 1769 = FF
      when "001011101101010" =>  data <= "11111111";  -- 176A = FF
      when "001011101101011" =>  data <= "11111111";  -- 176B = FF
      when "001011101101100" =>  data <= "11111111";  -- 176C = FF
      when "001011101101101" =>  data <= "11111111";  -- 176D = FF
      when "001011101101110" =>  data <= "11111111";  -- 176E = FF
      when "001011101101111" =>  data <= "11111111";  -- 176F = FF
      when "001011101110000" =>  data <= "11111111";  -- 1770 = FF
      when "001011101110001" =>  data <= "11111111";  -- 1771 = FF
      when "001011101110010" =>  data <= "11111111";  -- 1772 = FF
      when "001011101110011" =>  data <= "11111111";  -- 1773 = FF
      when "001011101110100" =>  data <= "11111111";  -- 1774 = FF
      when "001011101110101" =>  data <= "11111111";  -- 1775 = FF
      when "001011101110110" =>  data <= "11111111";  -- 1776 = FF
      when "001011101110111" =>  data <= "11111111";  -- 1777 = FF
      when "001011101111000" =>  data <= "11111111";  -- 1778 = FF
      when "001011101111001" =>  data <= "11111111";  -- 1779 = FF
      when "001011101111010" =>  data <= "11111111";  -- 177A = FF
      when "001011101111011" =>  data <= "11111111";  -- 177B = FF
      when "001011101111100" =>  data <= "11111111";  -- 177C = FF
      when "001011101111101" =>  data <= "11111111";  -- 177D = FF
      when "001011101111110" =>  data <= "11111111";  -- 177E = FF
      when "001011101111111" =>  data <= "11111111";  -- 177F = FF
      when "001011110000000" =>  data <= "11111111";  -- 1780 = FF
      when "001011110000001" =>  data <= "11111111";  -- 1781 = FF
      when "001011110000010" =>  data <= "11111111";  -- 1782 = FF
      when "001011110000011" =>  data <= "11111111";  -- 1783 = FF
      when "001011110000100" =>  data <= "11111111";  -- 1784 = FF
      when "001011110000101" =>  data <= "11111111";  -- 1785 = FF
      when "001011110000110" =>  data <= "11111111";  -- 1786 = FF
      when "001011110000111" =>  data <= "11111111";  -- 1787 = FF
      when "001011110001000" =>  data <= "11111111";  -- 1788 = FF
      when "001011110001001" =>  data <= "11111111";  -- 1789 = FF
      when "001011110001010" =>  data <= "11111111";  -- 178A = FF
      when "001011110001011" =>  data <= "11111111";  -- 178B = FF
      when "001011110001100" =>  data <= "11111111";  -- 178C = FF
      when "001011110001101" =>  data <= "11111111";  -- 178D = FF
      when "001011110001110" =>  data <= "11111111";  -- 178E = FF
      when "001011110001111" =>  data <= "11111111";  -- 178F = FF
      when "001011110010000" =>  data <= "11111111";  -- 1790 = FF
      when "001011110010001" =>  data <= "11111111";  -- 1791 = FF
      when "001011110010010" =>  data <= "11111111";  -- 1792 = FF
      when "001011110010011" =>  data <= "11111111";  -- 1793 = FF
      when "001011110010100" =>  data <= "11111111";  -- 1794 = FF
      when "001011110010101" =>  data <= "11111111";  -- 1795 = FF
      when "001011110010110" =>  data <= "11111111";  -- 1796 = FF
      when "001011110010111" =>  data <= "11111111";  -- 1797 = FF
      when "001011110011000" =>  data <= "11111111";  -- 1798 = FF
      when "001011110011001" =>  data <= "11111111";  -- 1799 = FF
      when "001011110011010" =>  data <= "11111111";  -- 179A = FF
      when "001011110011011" =>  data <= "11111111";  -- 179B = FF
      when "001011110011100" =>  data <= "11111111";  -- 179C = FF
      when "001011110011101" =>  data <= "11111111";  -- 179D = FF
      when "001011110011110" =>  data <= "11111111";  -- 179E = FF
      when "001011110011111" =>  data <= "11111111";  -- 179F = FF
      when "001011110100000" =>  data <= "11111111";  -- 17A0 = FF
      when "001011110100001" =>  data <= "11111111";  -- 17A1 = FF
      when "001011110100010" =>  data <= "11111111";  -- 17A2 = FF
      when "001011110100011" =>  data <= "11111111";  -- 17A3 = FF
      when "001011110100100" =>  data <= "11111111";  -- 17A4 = FF
      when "001011110100101" =>  data <= "11111111";  -- 17A5 = FF
      when "001011110100110" =>  data <= "11111111";  -- 17A6 = FF
      when "001011110100111" =>  data <= "11111111";  -- 17A7 = FF
      when "001011110101000" =>  data <= "11111111";  -- 17A8 = FF
      when "001011110101001" =>  data <= "11111111";  -- 17A9 = FF
      when "001011110101010" =>  data <= "11111111";  -- 17AA = FF
      when "001011110101011" =>  data <= "11111111";  -- 17AB = FF
      when "001011110101100" =>  data <= "11111111";  -- 17AC = FF
      when "001011110101101" =>  data <= "11111111";  -- 17AD = FF
      when "001011110101110" =>  data <= "11111111";  -- 17AE = FF
      when "001011110101111" =>  data <= "11111111";  -- 17AF = FF
      when "001011110110000" =>  data <= "11111111";  -- 17B0 = FF
      when "001011110110001" =>  data <= "11111111";  -- 17B1 = FF
      when "001011110110010" =>  data <= "11111111";  -- 17B2 = FF
      when "001011110110011" =>  data <= "11111111";  -- 17B3 = FF
      when "001011110110100" =>  data <= "11111111";  -- 17B4 = FF
      when "001011110110101" =>  data <= "11111111";  -- 17B5 = FF
      when "001011110110110" =>  data <= "11111111";  -- 17B6 = FF
      when "001011110110111" =>  data <= "11111111";  -- 17B7 = FF
      when "001011110111000" =>  data <= "11111111";  -- 17B8 = FF
      when "001011110111001" =>  data <= "11111111";  -- 17B9 = FF
      when "001011110111010" =>  data <= "11111111";  -- 17BA = FF
      when "001011110111011" =>  data <= "11111111";  -- 17BB = FF
      when "001011110111100" =>  data <= "11111111";  -- 17BC = FF
      when "001011110111101" =>  data <= "11111111";  -- 17BD = FF
      when "001011110111110" =>  data <= "11111111";  -- 17BE = FF
      when "001011110111111" =>  data <= "11111111";  -- 17BF = FF
      when "001011111000000" =>  data <= "11111111";  -- 17C0 = FF
      when "001011111000001" =>  data <= "11111111";  -- 17C1 = FF
      when "001011111000010" =>  data <= "11111111";  -- 17C2 = FF
      when "001011111000011" =>  data <= "11111111";  -- 17C3 = FF
      when "001011111000100" =>  data <= "11111111";  -- 17C4 = FF
      when "001011111000101" =>  data <= "11111111";  -- 17C5 = FF
      when "001011111000110" =>  data <= "11111111";  -- 17C6 = FF
      when "001011111000111" =>  data <= "11111111";  -- 17C7 = FF
      when "001011111001000" =>  data <= "11111111";  -- 17C8 = FF
      when "001011111001001" =>  data <= "11111111";  -- 17C9 = FF
      when "001011111001010" =>  data <= "11111111";  -- 17CA = FF
      when "001011111001011" =>  data <= "11111111";  -- 17CB = FF
      when "001011111001100" =>  data <= "11111111";  -- 17CC = FF
      when "001011111001101" =>  data <= "11111111";  -- 17CD = FF
      when "001011111001110" =>  data <= "11111111";  -- 17CE = FF
      when "001011111001111" =>  data <= "11111111";  -- 17CF = FF
      when "001011111010000" =>  data <= "11111111";  -- 17D0 = FF
      when "001011111010001" =>  data <= "11111111";  -- 17D1 = FF
      when "001011111010010" =>  data <= "11111111";  -- 17D2 = FF
      when "001011111010011" =>  data <= "11111111";  -- 17D3 = FF
      when "001011111010100" =>  data <= "11111111";  -- 17D4 = FF
      when "001011111010101" =>  data <= "11111111";  -- 17D5 = FF
      when "001011111010110" =>  data <= "11111111";  -- 17D6 = FF
      when "001011111010111" =>  data <= "11111111";  -- 17D7 = FF
      when "001011111011000" =>  data <= "11111111";  -- 17D8 = FF
      when "001011111011001" =>  data <= "11111111";  -- 17D9 = FF
      when "001011111011010" =>  data <= "11111111";  -- 17DA = FF
      when "001011111011011" =>  data <= "11111111";  -- 17DB = FF
      when "001011111011100" =>  data <= "11111111";  -- 17DC = FF
      when "001011111011101" =>  data <= "11111111";  -- 17DD = FF
      when "001011111011110" =>  data <= "11111111";  -- 17DE = FF
      when "001011111011111" =>  data <= "11111111";  -- 17DF = FF
      when "001011111100000" =>  data <= "11111111";  -- 17E0 = FF
      when "001011111100001" =>  data <= "11111111";  -- 17E1 = FF
      when "001011111100010" =>  data <= "11111111";  -- 17E2 = FF
      when "001011111100011" =>  data <= "11111111";  -- 17E3 = FF
      when "001011111100100" =>  data <= "11111111";  -- 17E4 = FF
      when "001011111100101" =>  data <= "11111111";  -- 17E5 = FF
      when "001011111100110" =>  data <= "11111111";  -- 17E6 = FF
      when "001011111100111" =>  data <= "11111111";  -- 17E7 = FF
      when "001011111101000" =>  data <= "11111111";  -- 17E8 = FF
      when "001011111101001" =>  data <= "11111111";  -- 17E9 = FF
      when "001011111101010" =>  data <= "11111111";  -- 17EA = FF
      when "001011111101011" =>  data <= "11111111";  -- 17EB = FF
      when "001011111101100" =>  data <= "11111111";  -- 17EC = FF
      when "001011111101101" =>  data <= "11111111";  -- 17ED = FF
      when "001011111101110" =>  data <= "11111111";  -- 17EE = FF
      when "001011111101111" =>  data <= "11111111";  -- 17EF = FF
      when "001011111110000" =>  data <= "11111111";  -- 17F0 = FF
      when "001011111110001" =>  data <= "11111111";  -- 17F1 = FF
      when "001011111110010" =>  data <= "11111111";  -- 17F2 = FF
      when "001011111110011" =>  data <= "11111111";  -- 17F3 = FF
      when "001011111110100" =>  data <= "11111111";  -- 17F4 = FF
      when "001011111110101" =>  data <= "11111111";  -- 17F5 = FF
      when "001011111110110" =>  data <= "11111111";  -- 17F6 = FF
      when "001011111110111" =>  data <= "11111111";  -- 17F7 = FF
      when "001011111111000" =>  data <= "11111111";  -- 17F8 = FF
      when "001011111111001" =>  data <= "11111111";  -- 17F9 = FF
      when "001011111111010" =>  data <= "11111111";  -- 17FA = FF
      when "001011111111011" =>  data <= "11111111";  -- 17FB = FF
      when "001011111111100" =>  data <= "11111111";  -- 17FC = FF
      when "001011111111101" =>  data <= "11111111";  -- 17FD = FF
      when "001011111111110" =>  data <= "11111111";  -- 17FE = FF
      when "001011111111111" =>  data <= "11111111";  -- 17FF = FF
      when "001100000000000" =>  data <= "11111111";  -- 1800 = FF
      when "001100000000001" =>  data <= "11111111";  -- 1801 = FF
      when "001100000000010" =>  data <= "11111111";  -- 1802 = FF
      when "001100000000011" =>  data <= "11111111";  -- 1803 = FF
      when "001100000000100" =>  data <= "11111111";  -- 1804 = FF
      when "001100000000101" =>  data <= "11111111";  -- 1805 = FF
      when "001100000000110" =>  data <= "11111111";  -- 1806 = FF
      when "001100000000111" =>  data <= "11111111";  -- 1807 = FF
      when "001100000001000" =>  data <= "11111111";  -- 1808 = FF
      when "001100000001001" =>  data <= "11111111";  -- 1809 = FF
      when "001100000001010" =>  data <= "11111111";  -- 180A = FF
      when "001100000001011" =>  data <= "11111111";  -- 180B = FF
      when "001100000001100" =>  data <= "11111111";  -- 180C = FF
      when "001100000001101" =>  data <= "11111111";  -- 180D = FF
      when "001100000001110" =>  data <= "11111111";  -- 180E = FF
      when "001100000001111" =>  data <= "11111111";  -- 180F = FF
      when "001100000010000" =>  data <= "11111111";  -- 1810 = FF
      when "001100000010001" =>  data <= "11111111";  -- 1811 = FF
      when "001100000010010" =>  data <= "11111111";  -- 1812 = FF
      when "001100000010011" =>  data <= "11111111";  -- 1813 = FF
      when "001100000010100" =>  data <= "11111111";  -- 1814 = FF
      when "001100000010101" =>  data <= "11111111";  -- 1815 = FF
      when "001100000010110" =>  data <= "11111111";  -- 1816 = FF
      when "001100000010111" =>  data <= "11111111";  -- 1817 = FF
      when "001100000011000" =>  data <= "11111111";  -- 1818 = FF
      when "001100000011001" =>  data <= "11111111";  -- 1819 = FF
      when "001100000011010" =>  data <= "11111111";  -- 181A = FF
      when "001100000011011" =>  data <= "11111111";  -- 181B = FF
      when "001100000011100" =>  data <= "11111111";  -- 181C = FF
      when "001100000011101" =>  data <= "11111111";  -- 181D = FF
      when "001100000011110" =>  data <= "11111111";  -- 181E = FF
      when "001100000011111" =>  data <= "11111111";  -- 181F = FF
      when "001100000100000" =>  data <= "11111111";  -- 1820 = FF
      when "001100000100001" =>  data <= "11111111";  -- 1821 = FF
      when "001100000100010" =>  data <= "11111111";  -- 1822 = FF
      when "001100000100011" =>  data <= "11111111";  -- 1823 = FF
      when "001100000100100" =>  data <= "11111111";  -- 1824 = FF
      when "001100000100101" =>  data <= "11111111";  -- 1825 = FF
      when "001100000100110" =>  data <= "11111111";  -- 1826 = FF
      when "001100000100111" =>  data <= "11111111";  -- 1827 = FF
      when "001100000101000" =>  data <= "11111111";  -- 1828 = FF
      when "001100000101001" =>  data <= "11111111";  -- 1829 = FF
      when "001100000101010" =>  data <= "11111111";  -- 182A = FF
      when "001100000101011" =>  data <= "11111111";  -- 182B = FF
      when "001100000101100" =>  data <= "11111111";  -- 182C = FF
      when "001100000101101" =>  data <= "11111111";  -- 182D = FF
      when "001100000101110" =>  data <= "11111111";  -- 182E = FF
      when "001100000101111" =>  data <= "11111111";  -- 182F = FF
      when "001100000110000" =>  data <= "11111111";  -- 1830 = FF
      when "001100000110001" =>  data <= "11111111";  -- 1831 = FF
      when "001100000110010" =>  data <= "11111111";  -- 1832 = FF
      when "001100000110011" =>  data <= "11111111";  -- 1833 = FF
      when "001100000110100" =>  data <= "11111111";  -- 1834 = FF
      when "001100000110101" =>  data <= "11111111";  -- 1835 = FF
      when "001100000110110" =>  data <= "11111111";  -- 1836 = FF
      when "001100000110111" =>  data <= "11111111";  -- 1837 = FF
      when "001100000111000" =>  data <= "11111111";  -- 1838 = FF
      when "001100000111001" =>  data <= "11111111";  -- 1839 = FF
      when "001100000111010" =>  data <= "11111111";  -- 183A = FF
      when "001100000111011" =>  data <= "11111111";  -- 183B = FF
      when "001100000111100" =>  data <= "11111111";  -- 183C = FF
      when "001100000111101" =>  data <= "11111111";  -- 183D = FF
      when "001100000111110" =>  data <= "11111111";  -- 183E = FF
      when "001100000111111" =>  data <= "11111111";  -- 183F = FF
      when "001100001000000" =>  data <= "11111111";  -- 1840 = FF
      when "001100001000001" =>  data <= "11111111";  -- 1841 = FF
      when "001100001000010" =>  data <= "11111111";  -- 1842 = FF
      when "001100001000011" =>  data <= "11111111";  -- 1843 = FF
      when "001100001000100" =>  data <= "11111111";  -- 1844 = FF
      when "001100001000101" =>  data <= "11111111";  -- 1845 = FF
      when "001100001000110" =>  data <= "11111111";  -- 1846 = FF
      when "001100001000111" =>  data <= "11111111";  -- 1847 = FF
      when "001100001001000" =>  data <= "11111111";  -- 1848 = FF
      when "001100001001001" =>  data <= "11111111";  -- 1849 = FF
      when "001100001001010" =>  data <= "11111111";  -- 184A = FF
      when "001100001001011" =>  data <= "11111111";  -- 184B = FF
      when "001100001001100" =>  data <= "11111111";  -- 184C = FF
      when "001100001001101" =>  data <= "11111111";  -- 184D = FF
      when "001100001001110" =>  data <= "11111111";  -- 184E = FF
      when "001100001001111" =>  data <= "11111111";  -- 184F = FF
      when "001100001010000" =>  data <= "11111111";  -- 1850 = FF
      when "001100001010001" =>  data <= "11111111";  -- 1851 = FF
      when "001100001010010" =>  data <= "11111111";  -- 1852 = FF
      when "001100001010011" =>  data <= "11111111";  -- 1853 = FF
      when "001100001010100" =>  data <= "11111111";  -- 1854 = FF
      when "001100001010101" =>  data <= "11111111";  -- 1855 = FF
      when "001100001010110" =>  data <= "11111111";  -- 1856 = FF
      when "001100001010111" =>  data <= "11111111";  -- 1857 = FF
      when "001100001011000" =>  data <= "11111111";  -- 1858 = FF
      when "001100001011001" =>  data <= "11111111";  -- 1859 = FF
      when "001100001011010" =>  data <= "11111111";  -- 185A = FF
      when "001100001011011" =>  data <= "11111111";  -- 185B = FF
      when "001100001011100" =>  data <= "11111111";  -- 185C = FF
      when "001100001011101" =>  data <= "11111111";  -- 185D = FF
      when "001100001011110" =>  data <= "11111111";  -- 185E = FF
      when "001100001011111" =>  data <= "11111111";  -- 185F = FF
      when "001100001100000" =>  data <= "11111111";  -- 1860 = FF
      when "001100001100001" =>  data <= "11111111";  -- 1861 = FF
      when "001100001100010" =>  data <= "11111111";  -- 1862 = FF
      when "001100001100011" =>  data <= "11111111";  -- 1863 = FF
      when "001100001100100" =>  data <= "11111111";  -- 1864 = FF
      when "001100001100101" =>  data <= "11111111";  -- 1865 = FF
      when "001100001100110" =>  data <= "11111111";  -- 1866 = FF
      when "001100001100111" =>  data <= "11111111";  -- 1867 = FF
      when "001100001101000" =>  data <= "11111111";  -- 1868 = FF
      when "001100001101001" =>  data <= "11111111";  -- 1869 = FF
      when "001100001101010" =>  data <= "11111111";  -- 186A = FF
      when "001100001101011" =>  data <= "11111111";  -- 186B = FF
      when "001100001101100" =>  data <= "11111111";  -- 186C = FF
      when "001100001101101" =>  data <= "11111111";  -- 186D = FF
      when "001100001101110" =>  data <= "11111111";  -- 186E = FF
      when "001100001101111" =>  data <= "11111111";  -- 186F = FF
      when "001100001110000" =>  data <= "11111111";  -- 1870 = FF
      when "001100001110001" =>  data <= "11111111";  -- 1871 = FF
      when "001100001110010" =>  data <= "11111111";  -- 1872 = FF
      when "001100001110011" =>  data <= "11111111";  -- 1873 = FF
      when "001100001110100" =>  data <= "11111111";  -- 1874 = FF
      when "001100001110101" =>  data <= "11111111";  -- 1875 = FF
      when "001100001110110" =>  data <= "11111111";  -- 1876 = FF
      when "001100001110111" =>  data <= "11111111";  -- 1877 = FF
      when "001100001111000" =>  data <= "11111111";  -- 1878 = FF
      when "001100001111001" =>  data <= "11111111";  -- 1879 = FF
      when "001100001111010" =>  data <= "11111111";  -- 187A = FF
      when "001100001111011" =>  data <= "11111111";  -- 187B = FF
      when "001100001111100" =>  data <= "11111111";  -- 187C = FF
      when "001100001111101" =>  data <= "11111111";  -- 187D = FF
      when "001100001111110" =>  data <= "11111111";  -- 187E = FF
      when "001100001111111" =>  data <= "11111111";  -- 187F = FF
      when "001100010000000" =>  data <= "11111111";  -- 1880 = FF
      when "001100010000001" =>  data <= "11111111";  -- 1881 = FF
      when "001100010000010" =>  data <= "11111111";  -- 1882 = FF
      when "001100010000011" =>  data <= "11111111";  -- 1883 = FF
      when "001100010000100" =>  data <= "11111111";  -- 1884 = FF
      when "001100010000101" =>  data <= "11111111";  -- 1885 = FF
      when "001100010000110" =>  data <= "11111111";  -- 1886 = FF
      when "001100010000111" =>  data <= "11111111";  -- 1887 = FF
      when "001100010001000" =>  data <= "11111111";  -- 1888 = FF
      when "001100010001001" =>  data <= "11111111";  -- 1889 = FF
      when "001100010001010" =>  data <= "11111111";  -- 188A = FF
      when "001100010001011" =>  data <= "11111111";  -- 188B = FF
      when "001100010001100" =>  data <= "11111111";  -- 188C = FF
      when "001100010001101" =>  data <= "11111111";  -- 188D = FF
      when "001100010001110" =>  data <= "11111111";  -- 188E = FF
      when "001100010001111" =>  data <= "11111111";  -- 188F = FF
      when "001100010010000" =>  data <= "11111111";  -- 1890 = FF
      when "001100010010001" =>  data <= "11111111";  -- 1891 = FF
      when "001100010010010" =>  data <= "11111111";  -- 1892 = FF
      when "001100010010011" =>  data <= "11111111";  -- 1893 = FF
      when "001100010010100" =>  data <= "11111111";  -- 1894 = FF
      when "001100010010101" =>  data <= "11111111";  -- 1895 = FF
      when "001100010010110" =>  data <= "11111111";  -- 1896 = FF
      when "001100010010111" =>  data <= "11111111";  -- 1897 = FF
      when "001100010011000" =>  data <= "11111111";  -- 1898 = FF
      when "001100010011001" =>  data <= "11111111";  -- 1899 = FF
      when "001100010011010" =>  data <= "11111111";  -- 189A = FF
      when "001100010011011" =>  data <= "11111111";  -- 189B = FF
      when "001100010011100" =>  data <= "11111111";  -- 189C = FF
      when "001100010011101" =>  data <= "11111111";  -- 189D = FF
      when "001100010011110" =>  data <= "11111111";  -- 189E = FF
      when "001100010011111" =>  data <= "11111111";  -- 189F = FF
      when "001100010100000" =>  data <= "11111111";  -- 18A0 = FF
      when "001100010100001" =>  data <= "11111111";  -- 18A1 = FF
      when "001100010100010" =>  data <= "11111111";  -- 18A2 = FF
      when "001100010100011" =>  data <= "11111111";  -- 18A3 = FF
      when "001100010100100" =>  data <= "11111111";  -- 18A4 = FF
      when "001100010100101" =>  data <= "11111111";  -- 18A5 = FF
      when "001100010100110" =>  data <= "11111111";  -- 18A6 = FF
      when "001100010100111" =>  data <= "11111111";  -- 18A7 = FF
      when "001100010101000" =>  data <= "11111111";  -- 18A8 = FF
      when "001100010101001" =>  data <= "11111111";  -- 18A9 = FF
      when "001100010101010" =>  data <= "11111111";  -- 18AA = FF
      when "001100010101011" =>  data <= "11111111";  -- 18AB = FF
      when "001100010101100" =>  data <= "11111111";  -- 18AC = FF
      when "001100010101101" =>  data <= "11111111";  -- 18AD = FF
      when "001100010101110" =>  data <= "11111111";  -- 18AE = FF
      when "001100010101111" =>  data <= "11111111";  -- 18AF = FF
      when "001100010110000" =>  data <= "11111111";  -- 18B0 = FF
      when "001100010110001" =>  data <= "11111111";  -- 18B1 = FF
      when "001100010110010" =>  data <= "11111111";  -- 18B2 = FF
      when "001100010110011" =>  data <= "11111111";  -- 18B3 = FF
      when "001100010110100" =>  data <= "11111111";  -- 18B4 = FF
      when "001100010110101" =>  data <= "11111111";  -- 18B5 = FF
      when "001100010110110" =>  data <= "11111111";  -- 18B6 = FF
      when "001100010110111" =>  data <= "11111111";  -- 18B7 = FF
      when "001100010111000" =>  data <= "11111111";  -- 18B8 = FF
      when "001100010111001" =>  data <= "11111111";  -- 18B9 = FF
      when "001100010111010" =>  data <= "11111111";  -- 18BA = FF
      when "001100010111011" =>  data <= "11111111";  -- 18BB = FF
      when "001100010111100" =>  data <= "11111111";  -- 18BC = FF
      when "001100010111101" =>  data <= "11111111";  -- 18BD = FF
      when "001100010111110" =>  data <= "11111111";  -- 18BE = FF
      when "001100010111111" =>  data <= "11111111";  -- 18BF = FF
      when "001100011000000" =>  data <= "11111111";  -- 18C0 = FF
      when "001100011000001" =>  data <= "11111111";  -- 18C1 = FF
      when "001100011000010" =>  data <= "11111111";  -- 18C2 = FF
      when "001100011000011" =>  data <= "11111111";  -- 18C3 = FF
      when "001100011000100" =>  data <= "11111111";  -- 18C4 = FF
      when "001100011000101" =>  data <= "11111111";  -- 18C5 = FF
      when "001100011000110" =>  data <= "11111111";  -- 18C6 = FF
      when "001100011000111" =>  data <= "11111111";  -- 18C7 = FF
      when "001100011001000" =>  data <= "11111111";  -- 18C8 = FF
      when "001100011001001" =>  data <= "11111111";  -- 18C9 = FF
      when "001100011001010" =>  data <= "11111111";  -- 18CA = FF
      when "001100011001011" =>  data <= "11111111";  -- 18CB = FF
      when "001100011001100" =>  data <= "11111111";  -- 18CC = FF
      when "001100011001101" =>  data <= "11111111";  -- 18CD = FF
      when "001100011001110" =>  data <= "11111111";  -- 18CE = FF
      when "001100011001111" =>  data <= "11111111";  -- 18CF = FF
      when "001100011010000" =>  data <= "11111111";  -- 18D0 = FF
      when "001100011010001" =>  data <= "11111111";  -- 18D1 = FF
      when "001100011010010" =>  data <= "11111111";  -- 18D2 = FF
      when "001100011010011" =>  data <= "11111111";  -- 18D3 = FF
      when "001100011010100" =>  data <= "11111111";  -- 18D4 = FF
      when "001100011010101" =>  data <= "11111111";  -- 18D5 = FF
      when "001100011010110" =>  data <= "11111111";  -- 18D6 = FF
      when "001100011010111" =>  data <= "11111111";  -- 18D7 = FF
      when "001100011011000" =>  data <= "11111111";  -- 18D8 = FF
      when "001100011011001" =>  data <= "11111111";  -- 18D9 = FF
      when "001100011011010" =>  data <= "11111111";  -- 18DA = FF
      when "001100011011011" =>  data <= "11111111";  -- 18DB = FF
      when "001100011011100" =>  data <= "11111111";  -- 18DC = FF
      when "001100011011101" =>  data <= "11111111";  -- 18DD = FF
      when "001100011011110" =>  data <= "11111111";  -- 18DE = FF
      when "001100011011111" =>  data <= "11111111";  -- 18DF = FF
      when "001100011100000" =>  data <= "11111111";  -- 18E0 = FF
      when "001100011100001" =>  data <= "11111111";  -- 18E1 = FF
      when "001100011100010" =>  data <= "11111111";  -- 18E2 = FF
      when "001100011100011" =>  data <= "11111111";  -- 18E3 = FF
      when "001100011100100" =>  data <= "11111111";  -- 18E4 = FF
      when "001100011100101" =>  data <= "11111111";  -- 18E5 = FF
      when "001100011100110" =>  data <= "11111111";  -- 18E6 = FF
      when "001100011100111" =>  data <= "11111111";  -- 18E7 = FF
      when "001100011101000" =>  data <= "11111111";  -- 18E8 = FF
      when "001100011101001" =>  data <= "11111111";  -- 18E9 = FF
      when "001100011101010" =>  data <= "11111111";  -- 18EA = FF
      when "001100011101011" =>  data <= "11111111";  -- 18EB = FF
      when "001100011101100" =>  data <= "11111111";  -- 18EC = FF
      when "001100011101101" =>  data <= "11111111";  -- 18ED = FF
      when "001100011101110" =>  data <= "11111111";  -- 18EE = FF
      when "001100011101111" =>  data <= "11111111";  -- 18EF = FF
      when "001100011110000" =>  data <= "11111111";  -- 18F0 = FF
      when "001100011110001" =>  data <= "11111111";  -- 18F1 = FF
      when "001100011110010" =>  data <= "11111111";  -- 18F2 = FF
      when "001100011110011" =>  data <= "11111111";  -- 18F3 = FF
      when "001100011110100" =>  data <= "11111111";  -- 18F4 = FF
      when "001100011110101" =>  data <= "11111111";  -- 18F5 = FF
      when "001100011110110" =>  data <= "11111111";  -- 18F6 = FF
      when "001100011110111" =>  data <= "11111111";  -- 18F7 = FF
      when "001100011111000" =>  data <= "11111111";  -- 18F8 = FF
      when "001100011111001" =>  data <= "11111111";  -- 18F9 = FF
      when "001100011111010" =>  data <= "11111111";  -- 18FA = FF
      when "001100011111011" =>  data <= "11111111";  -- 18FB = FF
      when "001100011111100" =>  data <= "11111111";  -- 18FC = FF
      when "001100011111101" =>  data <= "11111111";  -- 18FD = FF
      when "001100011111110" =>  data <= "11111111";  -- 18FE = FF
      when "001100011111111" =>  data <= "11111111";  -- 18FF = FF
      when "001100100000000" =>  data <= "11111111";  -- 1900 = FF
      when "001100100000001" =>  data <= "11111111";  -- 1901 = FF
      when "001100100000010" =>  data <= "11111111";  -- 1902 = FF
      when "001100100000011" =>  data <= "11111111";  -- 1903 = FF
      when "001100100000100" =>  data <= "11111111";  -- 1904 = FF
      when "001100100000101" =>  data <= "11111111";  -- 1905 = FF
      when "001100100000110" =>  data <= "11111111";  -- 1906 = FF
      when "001100100000111" =>  data <= "11111111";  -- 1907 = FF
      when "001100100001000" =>  data <= "11111111";  -- 1908 = FF
      when "001100100001001" =>  data <= "11111111";  -- 1909 = FF
      when "001100100001010" =>  data <= "11111111";  -- 190A = FF
      when "001100100001011" =>  data <= "11111111";  -- 190B = FF
      when "001100100001100" =>  data <= "11111111";  -- 190C = FF
      when "001100100001101" =>  data <= "11111111";  -- 190D = FF
      when "001100100001110" =>  data <= "11111111";  -- 190E = FF
      when "001100100001111" =>  data <= "11111111";  -- 190F = FF
      when "001100100010000" =>  data <= "11111111";  -- 1910 = FF
      when "001100100010001" =>  data <= "11111111";  -- 1911 = FF
      when "001100100010010" =>  data <= "11111111";  -- 1912 = FF
      when "001100100010011" =>  data <= "11111111";  -- 1913 = FF
      when "001100100010100" =>  data <= "11111111";  -- 1914 = FF
      when "001100100010101" =>  data <= "11111111";  -- 1915 = FF
      when "001100100010110" =>  data <= "11111111";  -- 1916 = FF
      when "001100100010111" =>  data <= "11111111";  -- 1917 = FF
      when "001100100011000" =>  data <= "11111111";  -- 1918 = FF
      when "001100100011001" =>  data <= "11111111";  -- 1919 = FF
      when "001100100011010" =>  data <= "11111111";  -- 191A = FF
      when "001100100011011" =>  data <= "11111111";  -- 191B = FF
      when "001100100011100" =>  data <= "11111111";  -- 191C = FF
      when "001100100011101" =>  data <= "11111111";  -- 191D = FF
      when "001100100011110" =>  data <= "11111111";  -- 191E = FF
      when "001100100011111" =>  data <= "11111111";  -- 191F = FF
      when "001100100100000" =>  data <= "11111111";  -- 1920 = FF
      when "001100100100001" =>  data <= "11111111";  -- 1921 = FF
      when "001100100100010" =>  data <= "11111111";  -- 1922 = FF
      when "001100100100011" =>  data <= "11111111";  -- 1923 = FF
      when "001100100100100" =>  data <= "11111111";  -- 1924 = FF
      when "001100100100101" =>  data <= "11111111";  -- 1925 = FF
      when "001100100100110" =>  data <= "11111111";  -- 1926 = FF
      when "001100100100111" =>  data <= "11111111";  -- 1927 = FF
      when "001100100101000" =>  data <= "11111111";  -- 1928 = FF
      when "001100100101001" =>  data <= "11111111";  -- 1929 = FF
      when "001100100101010" =>  data <= "11111111";  -- 192A = FF
      when "001100100101011" =>  data <= "11111111";  -- 192B = FF
      when "001100100101100" =>  data <= "11111111";  -- 192C = FF
      when "001100100101101" =>  data <= "11111111";  -- 192D = FF
      when "001100100101110" =>  data <= "11111111";  -- 192E = FF
      when "001100100101111" =>  data <= "11111111";  -- 192F = FF
      when "001100100110000" =>  data <= "11111111";  -- 1930 = FF
      when "001100100110001" =>  data <= "11111111";  -- 1931 = FF
      when "001100100110010" =>  data <= "11111111";  -- 1932 = FF
      when "001100100110011" =>  data <= "11111111";  -- 1933 = FF
      when "001100100110100" =>  data <= "11111111";  -- 1934 = FF
      when "001100100110101" =>  data <= "11111111";  -- 1935 = FF
      when "001100100110110" =>  data <= "11111111";  -- 1936 = FF
      when "001100100110111" =>  data <= "11111111";  -- 1937 = FF
      when "001100100111000" =>  data <= "11111111";  -- 1938 = FF
      when "001100100111001" =>  data <= "11111111";  -- 1939 = FF
      when "001100100111010" =>  data <= "11111111";  -- 193A = FF
      when "001100100111011" =>  data <= "11111111";  -- 193B = FF
      when "001100100111100" =>  data <= "11111111";  -- 193C = FF
      when "001100100111101" =>  data <= "11111111";  -- 193D = FF
      when "001100100111110" =>  data <= "11111111";  -- 193E = FF
      when "001100100111111" =>  data <= "11111111";  -- 193F = FF
      when "001100101000000" =>  data <= "11111111";  -- 1940 = FF
      when "001100101000001" =>  data <= "11111111";  -- 1941 = FF
      when "001100101000010" =>  data <= "11111111";  -- 1942 = FF
      when "001100101000011" =>  data <= "11111111";  -- 1943 = FF
      when "001100101000100" =>  data <= "11111111";  -- 1944 = FF
      when "001100101000101" =>  data <= "11111111";  -- 1945 = FF
      when "001100101000110" =>  data <= "11111111";  -- 1946 = FF
      when "001100101000111" =>  data <= "11111111";  -- 1947 = FF
      when "001100101001000" =>  data <= "11111111";  -- 1948 = FF
      when "001100101001001" =>  data <= "11111111";  -- 1949 = FF
      when "001100101001010" =>  data <= "11111111";  -- 194A = FF
      when "001100101001011" =>  data <= "11111111";  -- 194B = FF
      when "001100101001100" =>  data <= "11111111";  -- 194C = FF
      when "001100101001101" =>  data <= "11111111";  -- 194D = FF
      when "001100101001110" =>  data <= "11111111";  -- 194E = FF
      when "001100101001111" =>  data <= "11111111";  -- 194F = FF
      when "001100101010000" =>  data <= "11111111";  -- 1950 = FF
      when "001100101010001" =>  data <= "11111111";  -- 1951 = FF
      when "001100101010010" =>  data <= "11111111";  -- 1952 = FF
      when "001100101010011" =>  data <= "11111111";  -- 1953 = FF
      when "001100101010100" =>  data <= "11111111";  -- 1954 = FF
      when "001100101010101" =>  data <= "11111111";  -- 1955 = FF
      when "001100101010110" =>  data <= "11111111";  -- 1956 = FF
      when "001100101010111" =>  data <= "11111111";  -- 1957 = FF
      when "001100101011000" =>  data <= "11111111";  -- 1958 = FF
      when "001100101011001" =>  data <= "11111111";  -- 1959 = FF
      when "001100101011010" =>  data <= "11111111";  -- 195A = FF
      when "001100101011011" =>  data <= "11111111";  -- 195B = FF
      when "001100101011100" =>  data <= "11111111";  -- 195C = FF
      when "001100101011101" =>  data <= "11111111";  -- 195D = FF
      when "001100101011110" =>  data <= "11111111";  -- 195E = FF
      when "001100101011111" =>  data <= "11111111";  -- 195F = FF
      when "001100101100000" =>  data <= "11111111";  -- 1960 = FF
      when "001100101100001" =>  data <= "11111111";  -- 1961 = FF
      when "001100101100010" =>  data <= "11111111";  -- 1962 = FF
      when "001100101100011" =>  data <= "11111111";  -- 1963 = FF
      when "001100101100100" =>  data <= "11111111";  -- 1964 = FF
      when "001100101100101" =>  data <= "11111111";  -- 1965 = FF
      when "001100101100110" =>  data <= "11111111";  -- 1966 = FF
      when "001100101100111" =>  data <= "11111111";  -- 1967 = FF
      when "001100101101000" =>  data <= "11111111";  -- 1968 = FF
      when "001100101101001" =>  data <= "11111111";  -- 1969 = FF
      when "001100101101010" =>  data <= "11111111";  -- 196A = FF
      when "001100101101011" =>  data <= "11111111";  -- 196B = FF
      when "001100101101100" =>  data <= "11111111";  -- 196C = FF
      when "001100101101101" =>  data <= "11111111";  -- 196D = FF
      when "001100101101110" =>  data <= "11111111";  -- 196E = FF
      when "001100101101111" =>  data <= "11111111";  -- 196F = FF
      when "001100101110000" =>  data <= "11111111";  -- 1970 = FF
      when "001100101110001" =>  data <= "11111111";  -- 1971 = FF
      when "001100101110010" =>  data <= "11111111";  -- 1972 = FF
      when "001100101110011" =>  data <= "11111111";  -- 1973 = FF
      when "001100101110100" =>  data <= "11111111";  -- 1974 = FF
      when "001100101110101" =>  data <= "11111111";  -- 1975 = FF
      when "001100101110110" =>  data <= "11111111";  -- 1976 = FF
      when "001100101110111" =>  data <= "11111111";  -- 1977 = FF
      when "001100101111000" =>  data <= "11111111";  -- 1978 = FF
      when "001100101111001" =>  data <= "11111111";  -- 1979 = FF
      when "001100101111010" =>  data <= "11111111";  -- 197A = FF
      when "001100101111011" =>  data <= "11111111";  -- 197B = FF
      when "001100101111100" =>  data <= "11111111";  -- 197C = FF
      when "001100101111101" =>  data <= "11111111";  -- 197D = FF
      when "001100101111110" =>  data <= "11111111";  -- 197E = FF
      when "001100101111111" =>  data <= "11111111";  -- 197F = FF
      when "001100110000000" =>  data <= "11111111";  -- 1980 = FF
      when "001100110000001" =>  data <= "11111111";  -- 1981 = FF
      when "001100110000010" =>  data <= "11111111";  -- 1982 = FF
      when "001100110000011" =>  data <= "11111111";  -- 1983 = FF
      when "001100110000100" =>  data <= "11111111";  -- 1984 = FF
      when "001100110000101" =>  data <= "11111111";  -- 1985 = FF
      when "001100110000110" =>  data <= "11111111";  -- 1986 = FF
      when "001100110000111" =>  data <= "11111111";  -- 1987 = FF
      when "001100110001000" =>  data <= "11111111";  -- 1988 = FF
      when "001100110001001" =>  data <= "11111111";  -- 1989 = FF
      when "001100110001010" =>  data <= "11111111";  -- 198A = FF
      when "001100110001011" =>  data <= "11111111";  -- 198B = FF
      when "001100110001100" =>  data <= "11111111";  -- 198C = FF
      when "001100110001101" =>  data <= "11111111";  -- 198D = FF
      when "001100110001110" =>  data <= "11111111";  -- 198E = FF
      when "001100110001111" =>  data <= "11111111";  -- 198F = FF
      when "001100110010000" =>  data <= "11111111";  -- 1990 = FF
      when "001100110010001" =>  data <= "11111111";  -- 1991 = FF
      when "001100110010010" =>  data <= "11111111";  -- 1992 = FF
      when "001100110010011" =>  data <= "11111111";  -- 1993 = FF
      when "001100110010100" =>  data <= "11111111";  -- 1994 = FF
      when "001100110010101" =>  data <= "11111111";  -- 1995 = FF
      when "001100110010110" =>  data <= "11111111";  -- 1996 = FF
      when "001100110010111" =>  data <= "11111111";  -- 1997 = FF
      when "001100110011000" =>  data <= "11111111";  -- 1998 = FF
      when "001100110011001" =>  data <= "11111111";  -- 1999 = FF
      when "001100110011010" =>  data <= "11111111";  -- 199A = FF
      when "001100110011011" =>  data <= "11111111";  -- 199B = FF
      when "001100110011100" =>  data <= "11111111";  -- 199C = FF
      when "001100110011101" =>  data <= "11111111";  -- 199D = FF
      when "001100110011110" =>  data <= "11111111";  -- 199E = FF
      when "001100110011111" =>  data <= "11111111";  -- 199F = FF
      when "001100110100000" =>  data <= "11111111";  -- 19A0 = FF
      when "001100110100001" =>  data <= "11111111";  -- 19A1 = FF
      when "001100110100010" =>  data <= "11111111";  -- 19A2 = FF
      when "001100110100011" =>  data <= "11111111";  -- 19A3 = FF
      when "001100110100100" =>  data <= "11111111";  -- 19A4 = FF
      when "001100110100101" =>  data <= "11111111";  -- 19A5 = FF
      when "001100110100110" =>  data <= "11111111";  -- 19A6 = FF
      when "001100110100111" =>  data <= "11111111";  -- 19A7 = FF
      when "001100110101000" =>  data <= "11111111";  -- 19A8 = FF
      when "001100110101001" =>  data <= "11111111";  -- 19A9 = FF
      when "001100110101010" =>  data <= "11111111";  -- 19AA = FF
      when "001100110101011" =>  data <= "11111111";  -- 19AB = FF
      when "001100110101100" =>  data <= "11111111";  -- 19AC = FF
      when "001100110101101" =>  data <= "11111111";  -- 19AD = FF
      when "001100110101110" =>  data <= "11111111";  -- 19AE = FF
      when "001100110101111" =>  data <= "11111111";  -- 19AF = FF
      when "001100110110000" =>  data <= "11111111";  -- 19B0 = FF
      when "001100110110001" =>  data <= "11111111";  -- 19B1 = FF
      when "001100110110010" =>  data <= "11111111";  -- 19B2 = FF
      when "001100110110011" =>  data <= "11111111";  -- 19B3 = FF
      when "001100110110100" =>  data <= "11111111";  -- 19B4 = FF
      when "001100110110101" =>  data <= "11111111";  -- 19B5 = FF
      when "001100110110110" =>  data <= "11111111";  -- 19B6 = FF
      when "001100110110111" =>  data <= "11111111";  -- 19B7 = FF
      when "001100110111000" =>  data <= "11111111";  -- 19B8 = FF
      when "001100110111001" =>  data <= "11111111";  -- 19B9 = FF
      when "001100110111010" =>  data <= "11111111";  -- 19BA = FF
      when "001100110111011" =>  data <= "11111111";  -- 19BB = FF
      when "001100110111100" =>  data <= "11111111";  -- 19BC = FF
      when "001100110111101" =>  data <= "11111111";  -- 19BD = FF
      when "001100110111110" =>  data <= "11111111";  -- 19BE = FF
      when "001100110111111" =>  data <= "11111111";  -- 19BF = FF
      when "001100111000000" =>  data <= "11111111";  -- 19C0 = FF
      when "001100111000001" =>  data <= "11111111";  -- 19C1 = FF
      when "001100111000010" =>  data <= "11111111";  -- 19C2 = FF
      when "001100111000011" =>  data <= "11111111";  -- 19C3 = FF
      when "001100111000100" =>  data <= "11111111";  -- 19C4 = FF
      when "001100111000101" =>  data <= "11111111";  -- 19C5 = FF
      when "001100111000110" =>  data <= "11111111";  -- 19C6 = FF
      when "001100111000111" =>  data <= "11111111";  -- 19C7 = FF
      when "001100111001000" =>  data <= "11111111";  -- 19C8 = FF
      when "001100111001001" =>  data <= "11111111";  -- 19C9 = FF
      when "001100111001010" =>  data <= "11111111";  -- 19CA = FF
      when "001100111001011" =>  data <= "11111111";  -- 19CB = FF
      when "001100111001100" =>  data <= "11111111";  -- 19CC = FF
      when "001100111001101" =>  data <= "11111111";  -- 19CD = FF
      when "001100111001110" =>  data <= "11111111";  -- 19CE = FF
      when "001100111001111" =>  data <= "11111111";  -- 19CF = FF
      when "001100111010000" =>  data <= "11111111";  -- 19D0 = FF
      when "001100111010001" =>  data <= "11111111";  -- 19D1 = FF
      when "001100111010010" =>  data <= "11111111";  -- 19D2 = FF
      when "001100111010011" =>  data <= "11111111";  -- 19D3 = FF
      when "001100111010100" =>  data <= "11111111";  -- 19D4 = FF
      when "001100111010101" =>  data <= "11111111";  -- 19D5 = FF
      when "001100111010110" =>  data <= "11111111";  -- 19D6 = FF
      when "001100111010111" =>  data <= "11111111";  -- 19D7 = FF
      when "001100111011000" =>  data <= "11111111";  -- 19D8 = FF
      when "001100111011001" =>  data <= "11111111";  -- 19D9 = FF
      when "001100111011010" =>  data <= "11111111";  -- 19DA = FF
      when "001100111011011" =>  data <= "11111111";  -- 19DB = FF
      when "001100111011100" =>  data <= "11111111";  -- 19DC = FF
      when "001100111011101" =>  data <= "11111111";  -- 19DD = FF
      when "001100111011110" =>  data <= "11111111";  -- 19DE = FF
      when "001100111011111" =>  data <= "11111111";  -- 19DF = FF
      when "001100111100000" =>  data <= "11111111";  -- 19E0 = FF
      when "001100111100001" =>  data <= "11111111";  -- 19E1 = FF
      when "001100111100010" =>  data <= "11111111";  -- 19E2 = FF
      when "001100111100011" =>  data <= "11111111";  -- 19E3 = FF
      when "001100111100100" =>  data <= "11111111";  -- 19E4 = FF
      when "001100111100101" =>  data <= "11111111";  -- 19E5 = FF
      when "001100111100110" =>  data <= "11111111";  -- 19E6 = FF
      when "001100111100111" =>  data <= "11111111";  -- 19E7 = FF
      when "001100111101000" =>  data <= "11111111";  -- 19E8 = FF
      when "001100111101001" =>  data <= "11111111";  -- 19E9 = FF
      when "001100111101010" =>  data <= "11111111";  -- 19EA = FF
      when "001100111101011" =>  data <= "11111111";  -- 19EB = FF
      when "001100111101100" =>  data <= "11111111";  -- 19EC = FF
      when "001100111101101" =>  data <= "11111111";  -- 19ED = FF
      when "001100111101110" =>  data <= "11111111";  -- 19EE = FF
      when "001100111101111" =>  data <= "11111111";  -- 19EF = FF
      when "001100111110000" =>  data <= "11111111";  -- 19F0 = FF
      when "001100111110001" =>  data <= "11111111";  -- 19F1 = FF
      when "001100111110010" =>  data <= "11111111";  -- 19F2 = FF
      when "001100111110011" =>  data <= "11111111";  -- 19F3 = FF
      when "001100111110100" =>  data <= "11111111";  -- 19F4 = FF
      when "001100111110101" =>  data <= "11111111";  -- 19F5 = FF
      when "001100111110110" =>  data <= "11111111";  -- 19F6 = FF
      when "001100111110111" =>  data <= "11111111";  -- 19F7 = FF
      when "001100111111000" =>  data <= "11111111";  -- 19F8 = FF
      when "001100111111001" =>  data <= "11111111";  -- 19F9 = FF
      when "001100111111010" =>  data <= "11111111";  -- 19FA = FF
      when "001100111111011" =>  data <= "11111111";  -- 19FB = FF
      when "001100111111100" =>  data <= "11111111";  -- 19FC = FF
      when "001100111111101" =>  data <= "11111111";  -- 19FD = FF
      when "001100111111110" =>  data <= "11111111";  -- 19FE = FF
      when "001100111111111" =>  data <= "11111111";  -- 19FF = FF
      when "001101000000000" =>  data <= "11111111";  -- 1A00 = FF
      when "001101000000001" =>  data <= "11111111";  -- 1A01 = FF
      when "001101000000010" =>  data <= "11111111";  -- 1A02 = FF
      when "001101000000011" =>  data <= "11111111";  -- 1A03 = FF
      when "001101000000100" =>  data <= "11111111";  -- 1A04 = FF
      when "001101000000101" =>  data <= "11111111";  -- 1A05 = FF
      when "001101000000110" =>  data <= "11111111";  -- 1A06 = FF
      when "001101000000111" =>  data <= "11111111";  -- 1A07 = FF
      when "001101000001000" =>  data <= "11111111";  -- 1A08 = FF
      when "001101000001001" =>  data <= "11111111";  -- 1A09 = FF
      when "001101000001010" =>  data <= "11111111";  -- 1A0A = FF
      when "001101000001011" =>  data <= "11111111";  -- 1A0B = FF
      when "001101000001100" =>  data <= "11111111";  -- 1A0C = FF
      when "001101000001101" =>  data <= "11111111";  -- 1A0D = FF
      when "001101000001110" =>  data <= "11111111";  -- 1A0E = FF
      when "001101000001111" =>  data <= "11111111";  -- 1A0F = FF
      when "001101000010000" =>  data <= "11111111";  -- 1A10 = FF
      when "001101000010001" =>  data <= "11111111";  -- 1A11 = FF
      when "001101000010010" =>  data <= "11111111";  -- 1A12 = FF
      when "001101000010011" =>  data <= "11111111";  -- 1A13 = FF
      when "001101000010100" =>  data <= "11111111";  -- 1A14 = FF
      when "001101000010101" =>  data <= "11111111";  -- 1A15 = FF
      when "001101000010110" =>  data <= "11111111";  -- 1A16 = FF
      when "001101000010111" =>  data <= "11111111";  -- 1A17 = FF
      when "001101000011000" =>  data <= "11111111";  -- 1A18 = FF
      when "001101000011001" =>  data <= "11111111";  -- 1A19 = FF
      when "001101000011010" =>  data <= "11111111";  -- 1A1A = FF
      when "001101000011011" =>  data <= "11111111";  -- 1A1B = FF
      when "001101000011100" =>  data <= "11111111";  -- 1A1C = FF
      when "001101000011101" =>  data <= "11111111";  -- 1A1D = FF
      when "001101000011110" =>  data <= "11111111";  -- 1A1E = FF
      when "001101000011111" =>  data <= "11111111";  -- 1A1F = FF
      when "001101000100000" =>  data <= "11111111";  -- 1A20 = FF
      when "001101000100001" =>  data <= "11111111";  -- 1A21 = FF
      when "001101000100010" =>  data <= "11111111";  -- 1A22 = FF
      when "001101000100011" =>  data <= "11111111";  -- 1A23 = FF
      when "001101000100100" =>  data <= "11111111";  -- 1A24 = FF
      when "001101000100101" =>  data <= "11111111";  -- 1A25 = FF
      when "001101000100110" =>  data <= "11111111";  -- 1A26 = FF
      when "001101000100111" =>  data <= "11111111";  -- 1A27 = FF
      when "001101000101000" =>  data <= "11111111";  -- 1A28 = FF
      when "001101000101001" =>  data <= "11111111";  -- 1A29 = FF
      when "001101000101010" =>  data <= "11111111";  -- 1A2A = FF
      when "001101000101011" =>  data <= "11111111";  -- 1A2B = FF
      when "001101000101100" =>  data <= "11111111";  -- 1A2C = FF
      when "001101000101101" =>  data <= "11111111";  -- 1A2D = FF
      when "001101000101110" =>  data <= "11111111";  -- 1A2E = FF
      when "001101000101111" =>  data <= "11111111";  -- 1A2F = FF
      when "001101000110000" =>  data <= "11111111";  -- 1A30 = FF
      when "001101000110001" =>  data <= "11111111";  -- 1A31 = FF
      when "001101000110010" =>  data <= "11111111";  -- 1A32 = FF
      when "001101000110011" =>  data <= "11111111";  -- 1A33 = FF
      when "001101000110100" =>  data <= "11111111";  -- 1A34 = FF
      when "001101000110101" =>  data <= "11111111";  -- 1A35 = FF
      when "001101000110110" =>  data <= "11111111";  -- 1A36 = FF
      when "001101000110111" =>  data <= "11111111";  -- 1A37 = FF
      when "001101000111000" =>  data <= "11111111";  -- 1A38 = FF
      when "001101000111001" =>  data <= "11111111";  -- 1A39 = FF
      when "001101000111010" =>  data <= "11111111";  -- 1A3A = FF
      when "001101000111011" =>  data <= "11111111";  -- 1A3B = FF
      when "001101000111100" =>  data <= "11111111";  -- 1A3C = FF
      when "001101000111101" =>  data <= "11111111";  -- 1A3D = FF
      when "001101000111110" =>  data <= "11111111";  -- 1A3E = FF
      when "001101000111111" =>  data <= "11111111";  -- 1A3F = FF
      when "001101001000000" =>  data <= "11111111";  -- 1A40 = FF
      when "001101001000001" =>  data <= "11111111";  -- 1A41 = FF
      when "001101001000010" =>  data <= "11111111";  -- 1A42 = FF
      when "001101001000011" =>  data <= "11111111";  -- 1A43 = FF
      when "001101001000100" =>  data <= "11111111";  -- 1A44 = FF
      when "001101001000101" =>  data <= "11111111";  -- 1A45 = FF
      when "001101001000110" =>  data <= "11111111";  -- 1A46 = FF
      when "001101001000111" =>  data <= "11111111";  -- 1A47 = FF
      when "001101001001000" =>  data <= "11111111";  -- 1A48 = FF
      when "001101001001001" =>  data <= "11111111";  -- 1A49 = FF
      when "001101001001010" =>  data <= "11111111";  -- 1A4A = FF
      when "001101001001011" =>  data <= "11111111";  -- 1A4B = FF
      when "001101001001100" =>  data <= "11111111";  -- 1A4C = FF
      when "001101001001101" =>  data <= "11111111";  -- 1A4D = FF
      when "001101001001110" =>  data <= "11111111";  -- 1A4E = FF
      when "001101001001111" =>  data <= "11111111";  -- 1A4F = FF
      when "001101001010000" =>  data <= "11111111";  -- 1A50 = FF
      when "001101001010001" =>  data <= "11111111";  -- 1A51 = FF
      when "001101001010010" =>  data <= "11111111";  -- 1A52 = FF
      when "001101001010011" =>  data <= "11111111";  -- 1A53 = FF
      when "001101001010100" =>  data <= "11111111";  -- 1A54 = FF
      when "001101001010101" =>  data <= "11111111";  -- 1A55 = FF
      when "001101001010110" =>  data <= "11111111";  -- 1A56 = FF
      when "001101001010111" =>  data <= "11111111";  -- 1A57 = FF
      when "001101001011000" =>  data <= "11111111";  -- 1A58 = FF
      when "001101001011001" =>  data <= "11111111";  -- 1A59 = FF
      when "001101001011010" =>  data <= "11111111";  -- 1A5A = FF
      when "001101001011011" =>  data <= "11111111";  -- 1A5B = FF
      when "001101001011100" =>  data <= "11111111";  -- 1A5C = FF
      when "001101001011101" =>  data <= "11111111";  -- 1A5D = FF
      when "001101001011110" =>  data <= "11111111";  -- 1A5E = FF
      when "001101001011111" =>  data <= "11111111";  -- 1A5F = FF
      when "001101001100000" =>  data <= "11111111";  -- 1A60 = FF
      when "001101001100001" =>  data <= "11111111";  -- 1A61 = FF
      when "001101001100010" =>  data <= "11111111";  -- 1A62 = FF
      when "001101001100011" =>  data <= "11111111";  -- 1A63 = FF
      when "001101001100100" =>  data <= "11111111";  -- 1A64 = FF
      when "001101001100101" =>  data <= "11111111";  -- 1A65 = FF
      when "001101001100110" =>  data <= "11111111";  -- 1A66 = FF
      when "001101001100111" =>  data <= "11111111";  -- 1A67 = FF
      when "001101001101000" =>  data <= "11111111";  -- 1A68 = FF
      when "001101001101001" =>  data <= "11111111";  -- 1A69 = FF
      when "001101001101010" =>  data <= "11111111";  -- 1A6A = FF
      when "001101001101011" =>  data <= "11111111";  -- 1A6B = FF
      when "001101001101100" =>  data <= "11111111";  -- 1A6C = FF
      when "001101001101101" =>  data <= "11111111";  -- 1A6D = FF
      when "001101001101110" =>  data <= "11111111";  -- 1A6E = FF
      when "001101001101111" =>  data <= "11111111";  -- 1A6F = FF
      when "001101001110000" =>  data <= "11111111";  -- 1A70 = FF
      when "001101001110001" =>  data <= "11111111";  -- 1A71 = FF
      when "001101001110010" =>  data <= "11111111";  -- 1A72 = FF
      when "001101001110011" =>  data <= "11111111";  -- 1A73 = FF
      when "001101001110100" =>  data <= "11111111";  -- 1A74 = FF
      when "001101001110101" =>  data <= "11111111";  -- 1A75 = FF
      when "001101001110110" =>  data <= "11111111";  -- 1A76 = FF
      when "001101001110111" =>  data <= "11111111";  -- 1A77 = FF
      when "001101001111000" =>  data <= "11111111";  -- 1A78 = FF
      when "001101001111001" =>  data <= "11111111";  -- 1A79 = FF
      when "001101001111010" =>  data <= "11111111";  -- 1A7A = FF
      when "001101001111011" =>  data <= "11111111";  -- 1A7B = FF
      when "001101001111100" =>  data <= "11111111";  -- 1A7C = FF
      when "001101001111101" =>  data <= "11111111";  -- 1A7D = FF
      when "001101001111110" =>  data <= "11111111";  -- 1A7E = FF
      when "001101001111111" =>  data <= "11111111";  -- 1A7F = FF
      when "001101010000000" =>  data <= "11111111";  -- 1A80 = FF
      when "001101010000001" =>  data <= "11111111";  -- 1A81 = FF
      when "001101010000010" =>  data <= "11111111";  -- 1A82 = FF
      when "001101010000011" =>  data <= "11111111";  -- 1A83 = FF
      when "001101010000100" =>  data <= "11111111";  -- 1A84 = FF
      when "001101010000101" =>  data <= "11111111";  -- 1A85 = FF
      when "001101010000110" =>  data <= "11111111";  -- 1A86 = FF
      when "001101010000111" =>  data <= "11111111";  -- 1A87 = FF
      when "001101010001000" =>  data <= "11111111";  -- 1A88 = FF
      when "001101010001001" =>  data <= "11111111";  -- 1A89 = FF
      when "001101010001010" =>  data <= "11111111";  -- 1A8A = FF
      when "001101010001011" =>  data <= "11111111";  -- 1A8B = FF
      when "001101010001100" =>  data <= "11111111";  -- 1A8C = FF
      when "001101010001101" =>  data <= "11111111";  -- 1A8D = FF
      when "001101010001110" =>  data <= "11111111";  -- 1A8E = FF
      when "001101010001111" =>  data <= "11111111";  -- 1A8F = FF
      when "001101010010000" =>  data <= "11111111";  -- 1A90 = FF
      when "001101010010001" =>  data <= "11111111";  -- 1A91 = FF
      when "001101010010010" =>  data <= "11111111";  -- 1A92 = FF
      when "001101010010011" =>  data <= "11111111";  -- 1A93 = FF
      when "001101010010100" =>  data <= "11111111";  -- 1A94 = FF
      when "001101010010101" =>  data <= "11111111";  -- 1A95 = FF
      when "001101010010110" =>  data <= "11111111";  -- 1A96 = FF
      when "001101010010111" =>  data <= "11111111";  -- 1A97 = FF
      when "001101010011000" =>  data <= "11111111";  -- 1A98 = FF
      when "001101010011001" =>  data <= "11111111";  -- 1A99 = FF
      when "001101010011010" =>  data <= "11111111";  -- 1A9A = FF
      when "001101010011011" =>  data <= "11111111";  -- 1A9B = FF
      when "001101010011100" =>  data <= "11111111";  -- 1A9C = FF
      when "001101010011101" =>  data <= "11111111";  -- 1A9D = FF
      when "001101010011110" =>  data <= "11111111";  -- 1A9E = FF
      when "001101010011111" =>  data <= "11111111";  -- 1A9F = FF
      when "001101010100000" =>  data <= "11111111";  -- 1AA0 = FF
      when "001101010100001" =>  data <= "11111111";  -- 1AA1 = FF
      when "001101010100010" =>  data <= "11111111";  -- 1AA2 = FF
      when "001101010100011" =>  data <= "11111111";  -- 1AA3 = FF
      when "001101010100100" =>  data <= "11111111";  -- 1AA4 = FF
      when "001101010100101" =>  data <= "11111111";  -- 1AA5 = FF
      when "001101010100110" =>  data <= "11111111";  -- 1AA6 = FF
      when "001101010100111" =>  data <= "11111111";  -- 1AA7 = FF
      when "001101010101000" =>  data <= "11111111";  -- 1AA8 = FF
      when "001101010101001" =>  data <= "11111111";  -- 1AA9 = FF
      when "001101010101010" =>  data <= "11111111";  -- 1AAA = FF
      when "001101010101011" =>  data <= "11111111";  -- 1AAB = FF
      when "001101010101100" =>  data <= "11111111";  -- 1AAC = FF
      when "001101010101101" =>  data <= "11111111";  -- 1AAD = FF
      when "001101010101110" =>  data <= "11111111";  -- 1AAE = FF
      when "001101010101111" =>  data <= "11111111";  -- 1AAF = FF
      when "001101010110000" =>  data <= "11111111";  -- 1AB0 = FF
      when "001101010110001" =>  data <= "11111111";  -- 1AB1 = FF
      when "001101010110010" =>  data <= "11111111";  -- 1AB2 = FF
      when "001101010110011" =>  data <= "11111111";  -- 1AB3 = FF
      when "001101010110100" =>  data <= "11111111";  -- 1AB4 = FF
      when "001101010110101" =>  data <= "11111111";  -- 1AB5 = FF
      when "001101010110110" =>  data <= "11111111";  -- 1AB6 = FF
      when "001101010110111" =>  data <= "11111111";  -- 1AB7 = FF
      when "001101010111000" =>  data <= "11111111";  -- 1AB8 = FF
      when "001101010111001" =>  data <= "11111111";  -- 1AB9 = FF
      when "001101010111010" =>  data <= "11111111";  -- 1ABA = FF
      when "001101010111011" =>  data <= "11111111";  -- 1ABB = FF
      when "001101010111100" =>  data <= "11111111";  -- 1ABC = FF
      when "001101010111101" =>  data <= "11111111";  -- 1ABD = FF
      when "001101010111110" =>  data <= "11111111";  -- 1ABE = FF
      when "001101010111111" =>  data <= "11111111";  -- 1ABF = FF
      when "001101011000000" =>  data <= "11111111";  -- 1AC0 = FF
      when "001101011000001" =>  data <= "11111111";  -- 1AC1 = FF
      when "001101011000010" =>  data <= "11111111";  -- 1AC2 = FF
      when "001101011000011" =>  data <= "11111111";  -- 1AC3 = FF
      when "001101011000100" =>  data <= "11111111";  -- 1AC4 = FF
      when "001101011000101" =>  data <= "11111111";  -- 1AC5 = FF
      when "001101011000110" =>  data <= "11111111";  -- 1AC6 = FF
      when "001101011000111" =>  data <= "11111111";  -- 1AC7 = FF
      when "001101011001000" =>  data <= "11111111";  -- 1AC8 = FF
      when "001101011001001" =>  data <= "11111111";  -- 1AC9 = FF
      when "001101011001010" =>  data <= "11111111";  -- 1ACA = FF
      when "001101011001011" =>  data <= "11111111";  -- 1ACB = FF
      when "001101011001100" =>  data <= "11111111";  -- 1ACC = FF
      when "001101011001101" =>  data <= "11111111";  -- 1ACD = FF
      when "001101011001110" =>  data <= "11111111";  -- 1ACE = FF
      when "001101011001111" =>  data <= "11111111";  -- 1ACF = FF
      when "001101011010000" =>  data <= "11111111";  -- 1AD0 = FF
      when "001101011010001" =>  data <= "11111111";  -- 1AD1 = FF
      when "001101011010010" =>  data <= "11111111";  -- 1AD2 = FF
      when "001101011010011" =>  data <= "11111111";  -- 1AD3 = FF
      when "001101011010100" =>  data <= "11111111";  -- 1AD4 = FF
      when "001101011010101" =>  data <= "11111111";  -- 1AD5 = FF
      when "001101011010110" =>  data <= "11111111";  -- 1AD6 = FF
      when "001101011010111" =>  data <= "11111111";  -- 1AD7 = FF
      when "001101011011000" =>  data <= "11111111";  -- 1AD8 = FF
      when "001101011011001" =>  data <= "11111111";  -- 1AD9 = FF
      when "001101011011010" =>  data <= "11111111";  -- 1ADA = FF
      when "001101011011011" =>  data <= "11111111";  -- 1ADB = FF
      when "001101011011100" =>  data <= "11111111";  -- 1ADC = FF
      when "001101011011101" =>  data <= "11111111";  -- 1ADD = FF
      when "001101011011110" =>  data <= "11111111";  -- 1ADE = FF
      when "001101011011111" =>  data <= "11111111";  -- 1ADF = FF
      when "001101011100000" =>  data <= "11111111";  -- 1AE0 = FF
      when "001101011100001" =>  data <= "11111111";  -- 1AE1 = FF
      when "001101011100010" =>  data <= "11111111";  -- 1AE2 = FF
      when "001101011100011" =>  data <= "11111111";  -- 1AE3 = FF
      when "001101011100100" =>  data <= "11111111";  -- 1AE4 = FF
      when "001101011100101" =>  data <= "11111111";  -- 1AE5 = FF
      when "001101011100110" =>  data <= "11111111";  -- 1AE6 = FF
      when "001101011100111" =>  data <= "11111111";  -- 1AE7 = FF
      when "001101011101000" =>  data <= "11111111";  -- 1AE8 = FF
      when "001101011101001" =>  data <= "11111111";  -- 1AE9 = FF
      when "001101011101010" =>  data <= "11111111";  -- 1AEA = FF
      when "001101011101011" =>  data <= "11111111";  -- 1AEB = FF
      when "001101011101100" =>  data <= "11111111";  -- 1AEC = FF
      when "001101011101101" =>  data <= "11111111";  -- 1AED = FF
      when "001101011101110" =>  data <= "11111111";  -- 1AEE = FF
      when "001101011101111" =>  data <= "11111111";  -- 1AEF = FF
      when "001101011110000" =>  data <= "11111111";  -- 1AF0 = FF
      when "001101011110001" =>  data <= "11111111";  -- 1AF1 = FF
      when "001101011110010" =>  data <= "11111111";  -- 1AF2 = FF
      when "001101011110011" =>  data <= "11111111";  -- 1AF3 = FF
      when "001101011110100" =>  data <= "11111111";  -- 1AF4 = FF
      when "001101011110101" =>  data <= "11111111";  -- 1AF5 = FF
      when "001101011110110" =>  data <= "11111111";  -- 1AF6 = FF
      when "001101011110111" =>  data <= "11111111";  -- 1AF7 = FF
      when "001101011111000" =>  data <= "11111111";  -- 1AF8 = FF
      when "001101011111001" =>  data <= "11111111";  -- 1AF9 = FF
      when "001101011111010" =>  data <= "11111111";  -- 1AFA = FF
      when "001101011111011" =>  data <= "11111111";  -- 1AFB = FF
      when "001101011111100" =>  data <= "11111111";  -- 1AFC = FF
      when "001101011111101" =>  data <= "11111111";  -- 1AFD = FF
      when "001101011111110" =>  data <= "11111111";  -- 1AFE = FF
      when "001101011111111" =>  data <= "11111111";  -- 1AFF = FF
      when "001101100000000" =>  data <= "11111111";  -- 1B00 = FF
      when "001101100000001" =>  data <= "11111111";  -- 1B01 = FF
      when "001101100000010" =>  data <= "11111111";  -- 1B02 = FF
      when "001101100000011" =>  data <= "11111111";  -- 1B03 = FF
      when "001101100000100" =>  data <= "11111111";  -- 1B04 = FF
      when "001101100000101" =>  data <= "11111111";  -- 1B05 = FF
      when "001101100000110" =>  data <= "11111111";  -- 1B06 = FF
      when "001101100000111" =>  data <= "11111111";  -- 1B07 = FF
      when "001101100001000" =>  data <= "11111111";  -- 1B08 = FF
      when "001101100001001" =>  data <= "11111111";  -- 1B09 = FF
      when "001101100001010" =>  data <= "11111111";  -- 1B0A = FF
      when "001101100001011" =>  data <= "11111111";  -- 1B0B = FF
      when "001101100001100" =>  data <= "11111111";  -- 1B0C = FF
      when "001101100001101" =>  data <= "11111111";  -- 1B0D = FF
      when "001101100001110" =>  data <= "11111111";  -- 1B0E = FF
      when "001101100001111" =>  data <= "11111111";  -- 1B0F = FF
      when "001101100010000" =>  data <= "11111111";  -- 1B10 = FF
      when "001101100010001" =>  data <= "11111111";  -- 1B11 = FF
      when "001101100010010" =>  data <= "11111111";  -- 1B12 = FF
      when "001101100010011" =>  data <= "11111111";  -- 1B13 = FF
      when "001101100010100" =>  data <= "11111111";  -- 1B14 = FF
      when "001101100010101" =>  data <= "11111111";  -- 1B15 = FF
      when "001101100010110" =>  data <= "11111111";  -- 1B16 = FF
      when "001101100010111" =>  data <= "11111111";  -- 1B17 = FF
      when "001101100011000" =>  data <= "11111111";  -- 1B18 = FF
      when "001101100011001" =>  data <= "11111111";  -- 1B19 = FF
      when "001101100011010" =>  data <= "11111111";  -- 1B1A = FF
      when "001101100011011" =>  data <= "11111111";  -- 1B1B = FF
      when "001101100011100" =>  data <= "11111111";  -- 1B1C = FF
      when "001101100011101" =>  data <= "11111111";  -- 1B1D = FF
      when "001101100011110" =>  data <= "11111111";  -- 1B1E = FF
      when "001101100011111" =>  data <= "11111111";  -- 1B1F = FF
      when "001101100100000" =>  data <= "11111111";  -- 1B20 = FF
      when "001101100100001" =>  data <= "11111111";  -- 1B21 = FF
      when "001101100100010" =>  data <= "11111111";  -- 1B22 = FF
      when "001101100100011" =>  data <= "11111111";  -- 1B23 = FF
      when "001101100100100" =>  data <= "11111111";  -- 1B24 = FF
      when "001101100100101" =>  data <= "11111111";  -- 1B25 = FF
      when "001101100100110" =>  data <= "11111111";  -- 1B26 = FF
      when "001101100100111" =>  data <= "11111111";  -- 1B27 = FF
      when "001101100101000" =>  data <= "11111111";  -- 1B28 = FF
      when "001101100101001" =>  data <= "11111111";  -- 1B29 = FF
      when "001101100101010" =>  data <= "11111111";  -- 1B2A = FF
      when "001101100101011" =>  data <= "11111111";  -- 1B2B = FF
      when "001101100101100" =>  data <= "11111111";  -- 1B2C = FF
      when "001101100101101" =>  data <= "11111111";  -- 1B2D = FF
      when "001101100101110" =>  data <= "11111111";  -- 1B2E = FF
      when "001101100101111" =>  data <= "11111111";  -- 1B2F = FF
      when "001101100110000" =>  data <= "11111111";  -- 1B30 = FF
      when "001101100110001" =>  data <= "11111111";  -- 1B31 = FF
      when "001101100110010" =>  data <= "11111111";  -- 1B32 = FF
      when "001101100110011" =>  data <= "11111111";  -- 1B33 = FF
      when "001101100110100" =>  data <= "11111111";  -- 1B34 = FF
      when "001101100110101" =>  data <= "11111111";  -- 1B35 = FF
      when "001101100110110" =>  data <= "11111111";  -- 1B36 = FF
      when "001101100110111" =>  data <= "11111111";  -- 1B37 = FF
      when "001101100111000" =>  data <= "11111111";  -- 1B38 = FF
      when "001101100111001" =>  data <= "11111111";  -- 1B39 = FF
      when "001101100111010" =>  data <= "11111111";  -- 1B3A = FF
      when "001101100111011" =>  data <= "11111111";  -- 1B3B = FF
      when "001101100111100" =>  data <= "11111111";  -- 1B3C = FF
      when "001101100111101" =>  data <= "11111111";  -- 1B3D = FF
      when "001101100111110" =>  data <= "11111111";  -- 1B3E = FF
      when "001101100111111" =>  data <= "11111111";  -- 1B3F = FF
      when "001101101000000" =>  data <= "11111111";  -- 1B40 = FF
      when "001101101000001" =>  data <= "11111111";  -- 1B41 = FF
      when "001101101000010" =>  data <= "11111111";  -- 1B42 = FF
      when "001101101000011" =>  data <= "11111111";  -- 1B43 = FF
      when "001101101000100" =>  data <= "11111111";  -- 1B44 = FF
      when "001101101000101" =>  data <= "11111111";  -- 1B45 = FF
      when "001101101000110" =>  data <= "11111111";  -- 1B46 = FF
      when "001101101000111" =>  data <= "11111111";  -- 1B47 = FF
      when "001101101001000" =>  data <= "11111111";  -- 1B48 = FF
      when "001101101001001" =>  data <= "11111111";  -- 1B49 = FF
      when "001101101001010" =>  data <= "11111111";  -- 1B4A = FF
      when "001101101001011" =>  data <= "11111111";  -- 1B4B = FF
      when "001101101001100" =>  data <= "11111111";  -- 1B4C = FF
      when "001101101001101" =>  data <= "11111111";  -- 1B4D = FF
      when "001101101001110" =>  data <= "11111111";  -- 1B4E = FF
      when "001101101001111" =>  data <= "11111111";  -- 1B4F = FF
      when "001101101010000" =>  data <= "11111111";  -- 1B50 = FF
      when "001101101010001" =>  data <= "11111111";  -- 1B51 = FF
      when "001101101010010" =>  data <= "11111111";  -- 1B52 = FF
      when "001101101010011" =>  data <= "11111111";  -- 1B53 = FF
      when "001101101010100" =>  data <= "11111111";  -- 1B54 = FF
      when "001101101010101" =>  data <= "11111111";  -- 1B55 = FF
      when "001101101010110" =>  data <= "11111111";  -- 1B56 = FF
      when "001101101010111" =>  data <= "11111111";  -- 1B57 = FF
      when "001101101011000" =>  data <= "11111111";  -- 1B58 = FF
      when "001101101011001" =>  data <= "11111111";  -- 1B59 = FF
      when "001101101011010" =>  data <= "11111111";  -- 1B5A = FF
      when "001101101011011" =>  data <= "11111111";  -- 1B5B = FF
      when "001101101011100" =>  data <= "11111111";  -- 1B5C = FF
      when "001101101011101" =>  data <= "11111111";  -- 1B5D = FF
      when "001101101011110" =>  data <= "11111111";  -- 1B5E = FF
      when "001101101011111" =>  data <= "11111111";  -- 1B5F = FF
      when "001101101100000" =>  data <= "11111111";  -- 1B60 = FF
      when "001101101100001" =>  data <= "11111111";  -- 1B61 = FF
      when "001101101100010" =>  data <= "11111111";  -- 1B62 = FF
      when "001101101100011" =>  data <= "11111111";  -- 1B63 = FF
      when "001101101100100" =>  data <= "11111111";  -- 1B64 = FF
      when "001101101100101" =>  data <= "11111111";  -- 1B65 = FF
      when "001101101100110" =>  data <= "11111111";  -- 1B66 = FF
      when "001101101100111" =>  data <= "11111111";  -- 1B67 = FF
      when "001101101101000" =>  data <= "11111111";  -- 1B68 = FF
      when "001101101101001" =>  data <= "11111111";  -- 1B69 = FF
      when "001101101101010" =>  data <= "11111111";  -- 1B6A = FF
      when "001101101101011" =>  data <= "11111111";  -- 1B6B = FF
      when "001101101101100" =>  data <= "11111111";  -- 1B6C = FF
      when "001101101101101" =>  data <= "11111111";  -- 1B6D = FF
      when "001101101101110" =>  data <= "11111111";  -- 1B6E = FF
      when "001101101101111" =>  data <= "11111111";  -- 1B6F = FF
      when "001101101110000" =>  data <= "11111111";  -- 1B70 = FF
      when "001101101110001" =>  data <= "11111111";  -- 1B71 = FF
      when "001101101110010" =>  data <= "11111111";  -- 1B72 = FF
      when "001101101110011" =>  data <= "11111111";  -- 1B73 = FF
      when "001101101110100" =>  data <= "11111111";  -- 1B74 = FF
      when "001101101110101" =>  data <= "11111111";  -- 1B75 = FF
      when "001101101110110" =>  data <= "11111111";  -- 1B76 = FF
      when "001101101110111" =>  data <= "11111111";  -- 1B77 = FF
      when "001101101111000" =>  data <= "11111111";  -- 1B78 = FF
      when "001101101111001" =>  data <= "11111111";  -- 1B79 = FF
      when "001101101111010" =>  data <= "11111111";  -- 1B7A = FF
      when "001101101111011" =>  data <= "11111111";  -- 1B7B = FF
      when "001101101111100" =>  data <= "11111111";  -- 1B7C = FF
      when "001101101111101" =>  data <= "11111111";  -- 1B7D = FF
      when "001101101111110" =>  data <= "11111111";  -- 1B7E = FF
      when "001101101111111" =>  data <= "11111111";  -- 1B7F = FF
      when "001101110000000" =>  data <= "11111111";  -- 1B80 = FF
      when "001101110000001" =>  data <= "11111111";  -- 1B81 = FF
      when "001101110000010" =>  data <= "11111111";  -- 1B82 = FF
      when "001101110000011" =>  data <= "11111111";  -- 1B83 = FF
      when "001101110000100" =>  data <= "11111111";  -- 1B84 = FF
      when "001101110000101" =>  data <= "11111111";  -- 1B85 = FF
      when "001101110000110" =>  data <= "11111111";  -- 1B86 = FF
      when "001101110000111" =>  data <= "11111111";  -- 1B87 = FF
      when "001101110001000" =>  data <= "11111111";  -- 1B88 = FF
      when "001101110001001" =>  data <= "11111111";  -- 1B89 = FF
      when "001101110001010" =>  data <= "11111111";  -- 1B8A = FF
      when "001101110001011" =>  data <= "11111111";  -- 1B8B = FF
      when "001101110001100" =>  data <= "11111111";  -- 1B8C = FF
      when "001101110001101" =>  data <= "11111111";  -- 1B8D = FF
      when "001101110001110" =>  data <= "11111111";  -- 1B8E = FF
      when "001101110001111" =>  data <= "11111111";  -- 1B8F = FF
      when "001101110010000" =>  data <= "11111111";  -- 1B90 = FF
      when "001101110010001" =>  data <= "11111111";  -- 1B91 = FF
      when "001101110010010" =>  data <= "11111111";  -- 1B92 = FF
      when "001101110010011" =>  data <= "11111111";  -- 1B93 = FF
      when "001101110010100" =>  data <= "11111111";  -- 1B94 = FF
      when "001101110010101" =>  data <= "11111111";  -- 1B95 = FF
      when "001101110010110" =>  data <= "11111111";  -- 1B96 = FF
      when "001101110010111" =>  data <= "11111111";  -- 1B97 = FF
      when "001101110011000" =>  data <= "11111111";  -- 1B98 = FF
      when "001101110011001" =>  data <= "11111111";  -- 1B99 = FF
      when "001101110011010" =>  data <= "11111111";  -- 1B9A = FF
      when "001101110011011" =>  data <= "11111111";  -- 1B9B = FF
      when "001101110011100" =>  data <= "11111111";  -- 1B9C = FF
      when "001101110011101" =>  data <= "11111111";  -- 1B9D = FF
      when "001101110011110" =>  data <= "11111111";  -- 1B9E = FF
      when "001101110011111" =>  data <= "11111111";  -- 1B9F = FF
      when "001101110100000" =>  data <= "11111111";  -- 1BA0 = FF
      when "001101110100001" =>  data <= "11111111";  -- 1BA1 = FF
      when "001101110100010" =>  data <= "11111111";  -- 1BA2 = FF
      when "001101110100011" =>  data <= "11111111";  -- 1BA3 = FF
      when "001101110100100" =>  data <= "11111111";  -- 1BA4 = FF
      when "001101110100101" =>  data <= "11111111";  -- 1BA5 = FF
      when "001101110100110" =>  data <= "11111111";  -- 1BA6 = FF
      when "001101110100111" =>  data <= "11111111";  -- 1BA7 = FF
      when "001101110101000" =>  data <= "11111111";  -- 1BA8 = FF
      when "001101110101001" =>  data <= "11111111";  -- 1BA9 = FF
      when "001101110101010" =>  data <= "11111111";  -- 1BAA = FF
      when "001101110101011" =>  data <= "11111111";  -- 1BAB = FF
      when "001101110101100" =>  data <= "11111111";  -- 1BAC = FF
      when "001101110101101" =>  data <= "11111111";  -- 1BAD = FF
      when "001101110101110" =>  data <= "11111111";  -- 1BAE = FF
      when "001101110101111" =>  data <= "11111111";  -- 1BAF = FF
      when "001101110110000" =>  data <= "11111111";  -- 1BB0 = FF
      when "001101110110001" =>  data <= "11111111";  -- 1BB1 = FF
      when "001101110110010" =>  data <= "11111111";  -- 1BB2 = FF
      when "001101110110011" =>  data <= "11111111";  -- 1BB3 = FF
      when "001101110110100" =>  data <= "11111111";  -- 1BB4 = FF
      when "001101110110101" =>  data <= "11111111";  -- 1BB5 = FF
      when "001101110110110" =>  data <= "11111111";  -- 1BB6 = FF
      when "001101110110111" =>  data <= "11111111";  -- 1BB7 = FF
      when "001101110111000" =>  data <= "11111111";  -- 1BB8 = FF
      when "001101110111001" =>  data <= "11111111";  -- 1BB9 = FF
      when "001101110111010" =>  data <= "11111111";  -- 1BBA = FF
      when "001101110111011" =>  data <= "11111111";  -- 1BBB = FF
      when "001101110111100" =>  data <= "11111111";  -- 1BBC = FF
      when "001101110111101" =>  data <= "11111111";  -- 1BBD = FF
      when "001101110111110" =>  data <= "11111111";  -- 1BBE = FF
      when "001101110111111" =>  data <= "11111111";  -- 1BBF = FF
      when "001101111000000" =>  data <= "11111111";  -- 1BC0 = FF
      when "001101111000001" =>  data <= "11111111";  -- 1BC1 = FF
      when "001101111000010" =>  data <= "11111111";  -- 1BC2 = FF
      when "001101111000011" =>  data <= "11111111";  -- 1BC3 = FF
      when "001101111000100" =>  data <= "11111111";  -- 1BC4 = FF
      when "001101111000101" =>  data <= "11111111";  -- 1BC5 = FF
      when "001101111000110" =>  data <= "11111111";  -- 1BC6 = FF
      when "001101111000111" =>  data <= "11111111";  -- 1BC7 = FF
      when "001101111001000" =>  data <= "11111111";  -- 1BC8 = FF
      when "001101111001001" =>  data <= "11111111";  -- 1BC9 = FF
      when "001101111001010" =>  data <= "11111111";  -- 1BCA = FF
      when "001101111001011" =>  data <= "11111111";  -- 1BCB = FF
      when "001101111001100" =>  data <= "11111111";  -- 1BCC = FF
      when "001101111001101" =>  data <= "11111111";  -- 1BCD = FF
      when "001101111001110" =>  data <= "11111111";  -- 1BCE = FF
      when "001101111001111" =>  data <= "11111111";  -- 1BCF = FF
      when "001101111010000" =>  data <= "11111111";  -- 1BD0 = FF
      when "001101111010001" =>  data <= "11111111";  -- 1BD1 = FF
      when "001101111010010" =>  data <= "11111111";  -- 1BD2 = FF
      when "001101111010011" =>  data <= "11111111";  -- 1BD3 = FF
      when "001101111010100" =>  data <= "11111111";  -- 1BD4 = FF
      when "001101111010101" =>  data <= "11111111";  -- 1BD5 = FF
      when "001101111010110" =>  data <= "11111111";  -- 1BD6 = FF
      when "001101111010111" =>  data <= "11111111";  -- 1BD7 = FF
      when "001101111011000" =>  data <= "11111111";  -- 1BD8 = FF
      when "001101111011001" =>  data <= "11111111";  -- 1BD9 = FF
      when "001101111011010" =>  data <= "11111111";  -- 1BDA = FF
      when "001101111011011" =>  data <= "11111111";  -- 1BDB = FF
      when "001101111011100" =>  data <= "11111111";  -- 1BDC = FF
      when "001101111011101" =>  data <= "11111111";  -- 1BDD = FF
      when "001101111011110" =>  data <= "11111111";  -- 1BDE = FF
      when "001101111011111" =>  data <= "11111111";  -- 1BDF = FF
      when "001101111100000" =>  data <= "11111111";  -- 1BE0 = FF
      when "001101111100001" =>  data <= "11111111";  -- 1BE1 = FF
      when "001101111100010" =>  data <= "11111111";  -- 1BE2 = FF
      when "001101111100011" =>  data <= "11111111";  -- 1BE3 = FF
      when "001101111100100" =>  data <= "11111111";  -- 1BE4 = FF
      when "001101111100101" =>  data <= "11111111";  -- 1BE5 = FF
      when "001101111100110" =>  data <= "11111111";  -- 1BE6 = FF
      when "001101111100111" =>  data <= "11111111";  -- 1BE7 = FF
      when "001101111101000" =>  data <= "11111111";  -- 1BE8 = FF
      when "001101111101001" =>  data <= "11111111";  -- 1BE9 = FF
      when "001101111101010" =>  data <= "11111111";  -- 1BEA = FF
      when "001101111101011" =>  data <= "11111111";  -- 1BEB = FF
      when "001101111101100" =>  data <= "11111111";  -- 1BEC = FF
      when "001101111101101" =>  data <= "11111111";  -- 1BED = FF
      when "001101111101110" =>  data <= "11111111";  -- 1BEE = FF
      when "001101111101111" =>  data <= "11111111";  -- 1BEF = FF
      when "001101111110000" =>  data <= "11111111";  -- 1BF0 = FF
      when "001101111110001" =>  data <= "11111111";  -- 1BF1 = FF
      when "001101111110010" =>  data <= "11111111";  -- 1BF2 = FF
      when "001101111110011" =>  data <= "11111111";  -- 1BF3 = FF
      when "001101111110100" =>  data <= "11111111";  -- 1BF4 = FF
      when "001101111110101" =>  data <= "11111111";  -- 1BF5 = FF
      when "001101111110110" =>  data <= "11111111";  -- 1BF6 = FF
      when "001101111110111" =>  data <= "11111111";  -- 1BF7 = FF
      when "001101111111000" =>  data <= "11111111";  -- 1BF8 = FF
      when "001101111111001" =>  data <= "11111111";  -- 1BF9 = FF
      when "001101111111010" =>  data <= "11111111";  -- 1BFA = FF
      when "001101111111011" =>  data <= "11111111";  -- 1BFB = FF
      when "001101111111100" =>  data <= "11111111";  -- 1BFC = FF
      when "001101111111101" =>  data <= "11111111";  -- 1BFD = FF
      when "001101111111110" =>  data <= "11111111";  -- 1BFE = FF
      when "001101111111111" =>  data <= "11111111";  -- 1BFF = FF
      when "001110000000000" =>  data <= "11111111";  -- 1C00 = FF
      when "001110000000001" =>  data <= "11111111";  -- 1C01 = FF
      when "001110000000010" =>  data <= "11111111";  -- 1C02 = FF
      when "001110000000011" =>  data <= "11111111";  -- 1C03 = FF
      when "001110000000100" =>  data <= "11111111";  -- 1C04 = FF
      when "001110000000101" =>  data <= "11111111";  -- 1C05 = FF
      when "001110000000110" =>  data <= "11111111";  -- 1C06 = FF
      when "001110000000111" =>  data <= "11111111";  -- 1C07 = FF
      when "001110000001000" =>  data <= "11111111";  -- 1C08 = FF
      when "001110000001001" =>  data <= "11111111";  -- 1C09 = FF
      when "001110000001010" =>  data <= "11111111";  -- 1C0A = FF
      when "001110000001011" =>  data <= "11111111";  -- 1C0B = FF
      when "001110000001100" =>  data <= "11111111";  -- 1C0C = FF
      when "001110000001101" =>  data <= "11111111";  -- 1C0D = FF
      when "001110000001110" =>  data <= "11111111";  -- 1C0E = FF
      when "001110000001111" =>  data <= "11111111";  -- 1C0F = FF
      when "001110000010000" =>  data <= "11111111";  -- 1C10 = FF
      when "001110000010001" =>  data <= "11111111";  -- 1C11 = FF
      when "001110000010010" =>  data <= "11111111";  -- 1C12 = FF
      when "001110000010011" =>  data <= "11111111";  -- 1C13 = FF
      when "001110000010100" =>  data <= "11111111";  -- 1C14 = FF
      when "001110000010101" =>  data <= "11111111";  -- 1C15 = FF
      when "001110000010110" =>  data <= "11111111";  -- 1C16 = FF
      when "001110000010111" =>  data <= "11111111";  -- 1C17 = FF
      when "001110000011000" =>  data <= "11111111";  -- 1C18 = FF
      when "001110000011001" =>  data <= "11111111";  -- 1C19 = FF
      when "001110000011010" =>  data <= "11111111";  -- 1C1A = FF
      when "001110000011011" =>  data <= "11111111";  -- 1C1B = FF
      when "001110000011100" =>  data <= "11111111";  -- 1C1C = FF
      when "001110000011101" =>  data <= "11111111";  -- 1C1D = FF
      when "001110000011110" =>  data <= "11111111";  -- 1C1E = FF
      when "001110000011111" =>  data <= "11111111";  -- 1C1F = FF
      when "001110000100000" =>  data <= "11111111";  -- 1C20 = FF
      when "001110000100001" =>  data <= "11111111";  -- 1C21 = FF
      when "001110000100010" =>  data <= "11111111";  -- 1C22 = FF
      when "001110000100011" =>  data <= "11111111";  -- 1C23 = FF
      when "001110000100100" =>  data <= "11111111";  -- 1C24 = FF
      when "001110000100101" =>  data <= "11111111";  -- 1C25 = FF
      when "001110000100110" =>  data <= "11111111";  -- 1C26 = FF
      when "001110000100111" =>  data <= "11111111";  -- 1C27 = FF
      when "001110000101000" =>  data <= "11111111";  -- 1C28 = FF
      when "001110000101001" =>  data <= "11111111";  -- 1C29 = FF
      when "001110000101010" =>  data <= "11111111";  -- 1C2A = FF
      when "001110000101011" =>  data <= "11111111";  -- 1C2B = FF
      when "001110000101100" =>  data <= "11111111";  -- 1C2C = FF
      when "001110000101101" =>  data <= "11111111";  -- 1C2D = FF
      when "001110000101110" =>  data <= "11111111";  -- 1C2E = FF
      when "001110000101111" =>  data <= "11111111";  -- 1C2F = FF
      when "001110000110000" =>  data <= "11111111";  -- 1C30 = FF
      when "001110000110001" =>  data <= "11111111";  -- 1C31 = FF
      when "001110000110010" =>  data <= "11111111";  -- 1C32 = FF
      when "001110000110011" =>  data <= "11111111";  -- 1C33 = FF
      when "001110000110100" =>  data <= "11111111";  -- 1C34 = FF
      when "001110000110101" =>  data <= "11111111";  -- 1C35 = FF
      when "001110000110110" =>  data <= "11111111";  -- 1C36 = FF
      when "001110000110111" =>  data <= "11111111";  -- 1C37 = FF
      when "001110000111000" =>  data <= "11111111";  -- 1C38 = FF
      when "001110000111001" =>  data <= "11111111";  -- 1C39 = FF
      when "001110000111010" =>  data <= "11111111";  -- 1C3A = FF
      when "001110000111011" =>  data <= "11111111";  -- 1C3B = FF
      when "001110000111100" =>  data <= "11111111";  -- 1C3C = FF
      when "001110000111101" =>  data <= "11111111";  -- 1C3D = FF
      when "001110000111110" =>  data <= "11111111";  -- 1C3E = FF
      when "001110000111111" =>  data <= "11111111";  -- 1C3F = FF
      when "001110001000000" =>  data <= "11111111";  -- 1C40 = FF
      when "001110001000001" =>  data <= "11111111";  -- 1C41 = FF
      when "001110001000010" =>  data <= "11111111";  -- 1C42 = FF
      when "001110001000011" =>  data <= "11111111";  -- 1C43 = FF
      when "001110001000100" =>  data <= "11111111";  -- 1C44 = FF
      when "001110001000101" =>  data <= "11111111";  -- 1C45 = FF
      when "001110001000110" =>  data <= "11111111";  -- 1C46 = FF
      when "001110001000111" =>  data <= "11111111";  -- 1C47 = FF
      when "001110001001000" =>  data <= "11111111";  -- 1C48 = FF
      when "001110001001001" =>  data <= "11111111";  -- 1C49 = FF
      when "001110001001010" =>  data <= "11111111";  -- 1C4A = FF
      when "001110001001011" =>  data <= "11111111";  -- 1C4B = FF
      when "001110001001100" =>  data <= "11111111";  -- 1C4C = FF
      when "001110001001101" =>  data <= "11111111";  -- 1C4D = FF
      when "001110001001110" =>  data <= "11111111";  -- 1C4E = FF
      when "001110001001111" =>  data <= "11111111";  -- 1C4F = FF
      when "001110001010000" =>  data <= "11111111";  -- 1C50 = FF
      when "001110001010001" =>  data <= "11111111";  -- 1C51 = FF
      when "001110001010010" =>  data <= "11111111";  -- 1C52 = FF
      when "001110001010011" =>  data <= "11111111";  -- 1C53 = FF
      when "001110001010100" =>  data <= "11111111";  -- 1C54 = FF
      when "001110001010101" =>  data <= "11111111";  -- 1C55 = FF
      when "001110001010110" =>  data <= "11111111";  -- 1C56 = FF
      when "001110001010111" =>  data <= "11111111";  -- 1C57 = FF
      when "001110001011000" =>  data <= "11111111";  -- 1C58 = FF
      when "001110001011001" =>  data <= "11111111";  -- 1C59 = FF
      when "001110001011010" =>  data <= "11111111";  -- 1C5A = FF
      when "001110001011011" =>  data <= "11111111";  -- 1C5B = FF
      when "001110001011100" =>  data <= "11111111";  -- 1C5C = FF
      when "001110001011101" =>  data <= "11111111";  -- 1C5D = FF
      when "001110001011110" =>  data <= "11111111";  -- 1C5E = FF
      when "001110001011111" =>  data <= "11111111";  -- 1C5F = FF
      when "001110001100000" =>  data <= "11111111";  -- 1C60 = FF
      when "001110001100001" =>  data <= "11111111";  -- 1C61 = FF
      when "001110001100010" =>  data <= "11111111";  -- 1C62 = FF
      when "001110001100011" =>  data <= "11111111";  -- 1C63 = FF
      when "001110001100100" =>  data <= "11111111";  -- 1C64 = FF
      when "001110001100101" =>  data <= "11111111";  -- 1C65 = FF
      when "001110001100110" =>  data <= "11111111";  -- 1C66 = FF
      when "001110001100111" =>  data <= "11111111";  -- 1C67 = FF
      when "001110001101000" =>  data <= "11111111";  -- 1C68 = FF
      when "001110001101001" =>  data <= "11111111";  -- 1C69 = FF
      when "001110001101010" =>  data <= "11111111";  -- 1C6A = FF
      when "001110001101011" =>  data <= "11111111";  -- 1C6B = FF
      when "001110001101100" =>  data <= "11111111";  -- 1C6C = FF
      when "001110001101101" =>  data <= "11111111";  -- 1C6D = FF
      when "001110001101110" =>  data <= "11111111";  -- 1C6E = FF
      when "001110001101111" =>  data <= "11111111";  -- 1C6F = FF
      when "001110001110000" =>  data <= "11111111";  -- 1C70 = FF
      when "001110001110001" =>  data <= "11111111";  -- 1C71 = FF
      when "001110001110010" =>  data <= "11111111";  -- 1C72 = FF
      when "001110001110011" =>  data <= "11111111";  -- 1C73 = FF
      when "001110001110100" =>  data <= "11111111";  -- 1C74 = FF
      when "001110001110101" =>  data <= "11111111";  -- 1C75 = FF
      when "001110001110110" =>  data <= "11111111";  -- 1C76 = FF
      when "001110001110111" =>  data <= "11111111";  -- 1C77 = FF
      when "001110001111000" =>  data <= "11111111";  -- 1C78 = FF
      when "001110001111001" =>  data <= "11111111";  -- 1C79 = FF
      when "001110001111010" =>  data <= "11111111";  -- 1C7A = FF
      when "001110001111011" =>  data <= "11111111";  -- 1C7B = FF
      when "001110001111100" =>  data <= "11111111";  -- 1C7C = FF
      when "001110001111101" =>  data <= "11111111";  -- 1C7D = FF
      when "001110001111110" =>  data <= "11111111";  -- 1C7E = FF
      when "001110001111111" =>  data <= "11111111";  -- 1C7F = FF
      when "001110010000000" =>  data <= "11111111";  -- 1C80 = FF
      when "001110010000001" =>  data <= "11111111";  -- 1C81 = FF
      when "001110010000010" =>  data <= "11111111";  -- 1C82 = FF
      when "001110010000011" =>  data <= "11111111";  -- 1C83 = FF
      when "001110010000100" =>  data <= "11111111";  -- 1C84 = FF
      when "001110010000101" =>  data <= "11111111";  -- 1C85 = FF
      when "001110010000110" =>  data <= "11111111";  -- 1C86 = FF
      when "001110010000111" =>  data <= "11111111";  -- 1C87 = FF
      when "001110010001000" =>  data <= "11111111";  -- 1C88 = FF
      when "001110010001001" =>  data <= "11111111";  -- 1C89 = FF
      when "001110010001010" =>  data <= "11111111";  -- 1C8A = FF
      when "001110010001011" =>  data <= "11111111";  -- 1C8B = FF
      when "001110010001100" =>  data <= "11111111";  -- 1C8C = FF
      when "001110010001101" =>  data <= "11111111";  -- 1C8D = FF
      when "001110010001110" =>  data <= "11111111";  -- 1C8E = FF
      when "001110010001111" =>  data <= "11111111";  -- 1C8F = FF
      when "001110010010000" =>  data <= "11111111";  -- 1C90 = FF
      when "001110010010001" =>  data <= "11111111";  -- 1C91 = FF
      when "001110010010010" =>  data <= "11111111";  -- 1C92 = FF
      when "001110010010011" =>  data <= "11111111";  -- 1C93 = FF
      when "001110010010100" =>  data <= "11111111";  -- 1C94 = FF
      when "001110010010101" =>  data <= "11111111";  -- 1C95 = FF
      when "001110010010110" =>  data <= "11111111";  -- 1C96 = FF
      when "001110010010111" =>  data <= "11111111";  -- 1C97 = FF
      when "001110010011000" =>  data <= "11111111";  -- 1C98 = FF
      when "001110010011001" =>  data <= "11111111";  -- 1C99 = FF
      when "001110010011010" =>  data <= "11111111";  -- 1C9A = FF
      when "001110010011011" =>  data <= "11111111";  -- 1C9B = FF
      when "001110010011100" =>  data <= "11111111";  -- 1C9C = FF
      when "001110010011101" =>  data <= "11111111";  -- 1C9D = FF
      when "001110010011110" =>  data <= "11111111";  -- 1C9E = FF
      when "001110010011111" =>  data <= "11111111";  -- 1C9F = FF
      when "001110010100000" =>  data <= "11111111";  -- 1CA0 = FF
      when "001110010100001" =>  data <= "11111111";  -- 1CA1 = FF
      when "001110010100010" =>  data <= "11111111";  -- 1CA2 = FF
      when "001110010100011" =>  data <= "11111111";  -- 1CA3 = FF
      when "001110010100100" =>  data <= "11111111";  -- 1CA4 = FF
      when "001110010100101" =>  data <= "11111111";  -- 1CA5 = FF
      when "001110010100110" =>  data <= "11111111";  -- 1CA6 = FF
      when "001110010100111" =>  data <= "11111111";  -- 1CA7 = FF
      when "001110010101000" =>  data <= "11111111";  -- 1CA8 = FF
      when "001110010101001" =>  data <= "11111111";  -- 1CA9 = FF
      when "001110010101010" =>  data <= "11111111";  -- 1CAA = FF
      when "001110010101011" =>  data <= "11111111";  -- 1CAB = FF
      when "001110010101100" =>  data <= "11111111";  -- 1CAC = FF
      when "001110010101101" =>  data <= "11111111";  -- 1CAD = FF
      when "001110010101110" =>  data <= "11111111";  -- 1CAE = FF
      when "001110010101111" =>  data <= "11111111";  -- 1CAF = FF
      when "001110010110000" =>  data <= "11111111";  -- 1CB0 = FF
      when "001110010110001" =>  data <= "11111111";  -- 1CB1 = FF
      when "001110010110010" =>  data <= "11111111";  -- 1CB2 = FF
      when "001110010110011" =>  data <= "11111111";  -- 1CB3 = FF
      when "001110010110100" =>  data <= "11111111";  -- 1CB4 = FF
      when "001110010110101" =>  data <= "11111111";  -- 1CB5 = FF
      when "001110010110110" =>  data <= "11111111";  -- 1CB6 = FF
      when "001110010110111" =>  data <= "11111111";  -- 1CB7 = FF
      when "001110010111000" =>  data <= "11111111";  -- 1CB8 = FF
      when "001110010111001" =>  data <= "11111111";  -- 1CB9 = FF
      when "001110010111010" =>  data <= "11111111";  -- 1CBA = FF
      when "001110010111011" =>  data <= "11111111";  -- 1CBB = FF
      when "001110010111100" =>  data <= "11111111";  -- 1CBC = FF
      when "001110010111101" =>  data <= "11111111";  -- 1CBD = FF
      when "001110010111110" =>  data <= "11111111";  -- 1CBE = FF
      when "001110010111111" =>  data <= "11111111";  -- 1CBF = FF
      when "001110011000000" =>  data <= "11111111";  -- 1CC0 = FF
      when "001110011000001" =>  data <= "11111111";  -- 1CC1 = FF
      when "001110011000010" =>  data <= "11111111";  -- 1CC2 = FF
      when "001110011000011" =>  data <= "11111111";  -- 1CC3 = FF
      when "001110011000100" =>  data <= "11111111";  -- 1CC4 = FF
      when "001110011000101" =>  data <= "11111111";  -- 1CC5 = FF
      when "001110011000110" =>  data <= "11111111";  -- 1CC6 = FF
      when "001110011000111" =>  data <= "11111111";  -- 1CC7 = FF
      when "001110011001000" =>  data <= "11111111";  -- 1CC8 = FF
      when "001110011001001" =>  data <= "11111111";  -- 1CC9 = FF
      when "001110011001010" =>  data <= "11111111";  -- 1CCA = FF
      when "001110011001011" =>  data <= "11111111";  -- 1CCB = FF
      when "001110011001100" =>  data <= "11111111";  -- 1CCC = FF
      when "001110011001101" =>  data <= "11111111";  -- 1CCD = FF
      when "001110011001110" =>  data <= "11111111";  -- 1CCE = FF
      when "001110011001111" =>  data <= "11111111";  -- 1CCF = FF
      when "001110011010000" =>  data <= "11111111";  -- 1CD0 = FF
      when "001110011010001" =>  data <= "11111111";  -- 1CD1 = FF
      when "001110011010010" =>  data <= "11111111";  -- 1CD2 = FF
      when "001110011010011" =>  data <= "11111111";  -- 1CD3 = FF
      when "001110011010100" =>  data <= "11111111";  -- 1CD4 = FF
      when "001110011010101" =>  data <= "11111111";  -- 1CD5 = FF
      when "001110011010110" =>  data <= "11111111";  -- 1CD6 = FF
      when "001110011010111" =>  data <= "11111111";  -- 1CD7 = FF
      when "001110011011000" =>  data <= "11111111";  -- 1CD8 = FF
      when "001110011011001" =>  data <= "11111111";  -- 1CD9 = FF
      when "001110011011010" =>  data <= "11111111";  -- 1CDA = FF
      when "001110011011011" =>  data <= "11111111";  -- 1CDB = FF
      when "001110011011100" =>  data <= "11111111";  -- 1CDC = FF
      when "001110011011101" =>  data <= "11111111";  -- 1CDD = FF
      when "001110011011110" =>  data <= "11111111";  -- 1CDE = FF
      when "001110011011111" =>  data <= "11111111";  -- 1CDF = FF
      when "001110011100000" =>  data <= "11111111";  -- 1CE0 = FF
      when "001110011100001" =>  data <= "11111111";  -- 1CE1 = FF
      when "001110011100010" =>  data <= "11111111";  -- 1CE2 = FF
      when "001110011100011" =>  data <= "11111111";  -- 1CE3 = FF
      when "001110011100100" =>  data <= "11111111";  -- 1CE4 = FF
      when "001110011100101" =>  data <= "11111111";  -- 1CE5 = FF
      when "001110011100110" =>  data <= "11111111";  -- 1CE6 = FF
      when "001110011100111" =>  data <= "11111111";  -- 1CE7 = FF
      when "001110011101000" =>  data <= "11111111";  -- 1CE8 = FF
      when "001110011101001" =>  data <= "11111111";  -- 1CE9 = FF
      when "001110011101010" =>  data <= "11111111";  -- 1CEA = FF
      when "001110011101011" =>  data <= "11111111";  -- 1CEB = FF
      when "001110011101100" =>  data <= "11111111";  -- 1CEC = FF
      when "001110011101101" =>  data <= "11111111";  -- 1CED = FF
      when "001110011101110" =>  data <= "11111111";  -- 1CEE = FF
      when "001110011101111" =>  data <= "11111111";  -- 1CEF = FF
      when "001110011110000" =>  data <= "11111111";  -- 1CF0 = FF
      when "001110011110001" =>  data <= "11111111";  -- 1CF1 = FF
      when "001110011110010" =>  data <= "11111111";  -- 1CF2 = FF
      when "001110011110011" =>  data <= "11111111";  -- 1CF3 = FF
      when "001110011110100" =>  data <= "11111111";  -- 1CF4 = FF
      when "001110011110101" =>  data <= "11111111";  -- 1CF5 = FF
      when "001110011110110" =>  data <= "11111111";  -- 1CF6 = FF
      when "001110011110111" =>  data <= "11111111";  -- 1CF7 = FF
      when "001110011111000" =>  data <= "11111111";  -- 1CF8 = FF
      when "001110011111001" =>  data <= "11111111";  -- 1CF9 = FF
      when "001110011111010" =>  data <= "11111111";  -- 1CFA = FF
      when "001110011111011" =>  data <= "11111111";  -- 1CFB = FF
      when "001110011111100" =>  data <= "11111111";  -- 1CFC = FF
      when "001110011111101" =>  data <= "11111111";  -- 1CFD = FF
      when "001110011111110" =>  data <= "11111111";  -- 1CFE = FF
      when "001110011111111" =>  data <= "11111111";  -- 1CFF = FF
      when "001110100000000" =>  data <= "11111111";  -- 1D00 = FF
      when "001110100000001" =>  data <= "11111111";  -- 1D01 = FF
      when "001110100000010" =>  data <= "11111111";  -- 1D02 = FF
      when "001110100000011" =>  data <= "11111111";  -- 1D03 = FF
      when "001110100000100" =>  data <= "11111111";  -- 1D04 = FF
      when "001110100000101" =>  data <= "11111111";  -- 1D05 = FF
      when "001110100000110" =>  data <= "11111111";  -- 1D06 = FF
      when "001110100000111" =>  data <= "11111111";  -- 1D07 = FF
      when "001110100001000" =>  data <= "11111111";  -- 1D08 = FF
      when "001110100001001" =>  data <= "11111111";  -- 1D09 = FF
      when "001110100001010" =>  data <= "11111111";  -- 1D0A = FF
      when "001110100001011" =>  data <= "11111111";  -- 1D0B = FF
      when "001110100001100" =>  data <= "11111111";  -- 1D0C = FF
      when "001110100001101" =>  data <= "11111111";  -- 1D0D = FF
      when "001110100001110" =>  data <= "11111111";  -- 1D0E = FF
      when "001110100001111" =>  data <= "11111111";  -- 1D0F = FF
      when "001110100010000" =>  data <= "11111111";  -- 1D10 = FF
      when "001110100010001" =>  data <= "11111111";  -- 1D11 = FF
      when "001110100010010" =>  data <= "11111111";  -- 1D12 = FF
      when "001110100010011" =>  data <= "11111111";  -- 1D13 = FF
      when "001110100010100" =>  data <= "11111111";  -- 1D14 = FF
      when "001110100010101" =>  data <= "11111111";  -- 1D15 = FF
      when "001110100010110" =>  data <= "11111111";  -- 1D16 = FF
      when "001110100010111" =>  data <= "11111111";  -- 1D17 = FF
      when "001110100011000" =>  data <= "11111111";  -- 1D18 = FF
      when "001110100011001" =>  data <= "11111111";  -- 1D19 = FF
      when "001110100011010" =>  data <= "11111111";  -- 1D1A = FF
      when "001110100011011" =>  data <= "11111111";  -- 1D1B = FF
      when "001110100011100" =>  data <= "11111111";  -- 1D1C = FF
      when "001110100011101" =>  data <= "11111111";  -- 1D1D = FF
      when "001110100011110" =>  data <= "11111111";  -- 1D1E = FF
      when "001110100011111" =>  data <= "11111111";  -- 1D1F = FF
      when "001110100100000" =>  data <= "11111111";  -- 1D20 = FF
      when "001110100100001" =>  data <= "11111111";  -- 1D21 = FF
      when "001110100100010" =>  data <= "11111111";  -- 1D22 = FF
      when "001110100100011" =>  data <= "11111111";  -- 1D23 = FF
      when "001110100100100" =>  data <= "11111111";  -- 1D24 = FF
      when "001110100100101" =>  data <= "11111111";  -- 1D25 = FF
      when "001110100100110" =>  data <= "11111111";  -- 1D26 = FF
      when "001110100100111" =>  data <= "11111111";  -- 1D27 = FF
      when "001110100101000" =>  data <= "11111111";  -- 1D28 = FF
      when "001110100101001" =>  data <= "11111111";  -- 1D29 = FF
      when "001110100101010" =>  data <= "11111111";  -- 1D2A = FF
      when "001110100101011" =>  data <= "11111111";  -- 1D2B = FF
      when "001110100101100" =>  data <= "11111111";  -- 1D2C = FF
      when "001110100101101" =>  data <= "11111111";  -- 1D2D = FF
      when "001110100101110" =>  data <= "11111111";  -- 1D2E = FF
      when "001110100101111" =>  data <= "11111111";  -- 1D2F = FF
      when "001110100110000" =>  data <= "11111111";  -- 1D30 = FF
      when "001110100110001" =>  data <= "11111111";  -- 1D31 = FF
      when "001110100110010" =>  data <= "11111111";  -- 1D32 = FF
      when "001110100110011" =>  data <= "11111111";  -- 1D33 = FF
      when "001110100110100" =>  data <= "11111111";  -- 1D34 = FF
      when "001110100110101" =>  data <= "11111111";  -- 1D35 = FF
      when "001110100110110" =>  data <= "11111111";  -- 1D36 = FF
      when "001110100110111" =>  data <= "11111111";  -- 1D37 = FF
      when "001110100111000" =>  data <= "11111111";  -- 1D38 = FF
      when "001110100111001" =>  data <= "11111111";  -- 1D39 = FF
      when "001110100111010" =>  data <= "11111111";  -- 1D3A = FF
      when "001110100111011" =>  data <= "11111111";  -- 1D3B = FF
      when "001110100111100" =>  data <= "11111111";  -- 1D3C = FF
      when "001110100111101" =>  data <= "11111111";  -- 1D3D = FF
      when "001110100111110" =>  data <= "11111111";  -- 1D3E = FF
      when "001110100111111" =>  data <= "11111111";  -- 1D3F = FF
      when "001110101000000" =>  data <= "11111111";  -- 1D40 = FF
      when "001110101000001" =>  data <= "11111111";  -- 1D41 = FF
      when "001110101000010" =>  data <= "11111111";  -- 1D42 = FF
      when "001110101000011" =>  data <= "11111111";  -- 1D43 = FF
      when "001110101000100" =>  data <= "11111111";  -- 1D44 = FF
      when "001110101000101" =>  data <= "11111111";  -- 1D45 = FF
      when "001110101000110" =>  data <= "11111111";  -- 1D46 = FF
      when "001110101000111" =>  data <= "11111111";  -- 1D47 = FF
      when "001110101001000" =>  data <= "11111111";  -- 1D48 = FF
      when "001110101001001" =>  data <= "11111111";  -- 1D49 = FF
      when "001110101001010" =>  data <= "11111111";  -- 1D4A = FF
      when "001110101001011" =>  data <= "11111111";  -- 1D4B = FF
      when "001110101001100" =>  data <= "11111111";  -- 1D4C = FF
      when "001110101001101" =>  data <= "11111111";  -- 1D4D = FF
      when "001110101001110" =>  data <= "11111111";  -- 1D4E = FF
      when "001110101001111" =>  data <= "11111111";  -- 1D4F = FF
      when "001110101010000" =>  data <= "11111111";  -- 1D50 = FF
      when "001110101010001" =>  data <= "11111111";  -- 1D51 = FF
      when "001110101010010" =>  data <= "11111111";  -- 1D52 = FF
      when "001110101010011" =>  data <= "11111111";  -- 1D53 = FF
      when "001110101010100" =>  data <= "11111111";  -- 1D54 = FF
      when "001110101010101" =>  data <= "11111111";  -- 1D55 = FF
      when "001110101010110" =>  data <= "11111111";  -- 1D56 = FF
      when "001110101010111" =>  data <= "11111111";  -- 1D57 = FF
      when "001110101011000" =>  data <= "11111111";  -- 1D58 = FF
      when "001110101011001" =>  data <= "11111111";  -- 1D59 = FF
      when "001110101011010" =>  data <= "11111111";  -- 1D5A = FF
      when "001110101011011" =>  data <= "11111111";  -- 1D5B = FF
      when "001110101011100" =>  data <= "11111111";  -- 1D5C = FF
      when "001110101011101" =>  data <= "11111111";  -- 1D5D = FF
      when "001110101011110" =>  data <= "11111111";  -- 1D5E = FF
      when "001110101011111" =>  data <= "11111111";  -- 1D5F = FF
      when "001110101100000" =>  data <= "11111111";  -- 1D60 = FF
      when "001110101100001" =>  data <= "11111111";  -- 1D61 = FF
      when "001110101100010" =>  data <= "11111111";  -- 1D62 = FF
      when "001110101100011" =>  data <= "11111111";  -- 1D63 = FF
      when "001110101100100" =>  data <= "11111111";  -- 1D64 = FF
      when "001110101100101" =>  data <= "11111111";  -- 1D65 = FF
      when "001110101100110" =>  data <= "11111111";  -- 1D66 = FF
      when "001110101100111" =>  data <= "11111111";  -- 1D67 = FF
      when "001110101101000" =>  data <= "11111111";  -- 1D68 = FF
      when "001110101101001" =>  data <= "11111111";  -- 1D69 = FF
      when "001110101101010" =>  data <= "11111111";  -- 1D6A = FF
      when "001110101101011" =>  data <= "11111111";  -- 1D6B = FF
      when "001110101101100" =>  data <= "11111111";  -- 1D6C = FF
      when "001110101101101" =>  data <= "11111111";  -- 1D6D = FF
      when "001110101101110" =>  data <= "11111111";  -- 1D6E = FF
      when "001110101101111" =>  data <= "11111111";  -- 1D6F = FF
      when "001110101110000" =>  data <= "11111111";  -- 1D70 = FF
      when "001110101110001" =>  data <= "11111111";  -- 1D71 = FF
      when "001110101110010" =>  data <= "11111111";  -- 1D72 = FF
      when "001110101110011" =>  data <= "11111111";  -- 1D73 = FF
      when "001110101110100" =>  data <= "11111111";  -- 1D74 = FF
      when "001110101110101" =>  data <= "11111111";  -- 1D75 = FF
      when "001110101110110" =>  data <= "11111111";  -- 1D76 = FF
      when "001110101110111" =>  data <= "11111111";  -- 1D77 = FF
      when "001110101111000" =>  data <= "11111111";  -- 1D78 = FF
      when "001110101111001" =>  data <= "11111111";  -- 1D79 = FF
      when "001110101111010" =>  data <= "11111111";  -- 1D7A = FF
      when "001110101111011" =>  data <= "11111111";  -- 1D7B = FF
      when "001110101111100" =>  data <= "11111111";  -- 1D7C = FF
      when "001110101111101" =>  data <= "11111111";  -- 1D7D = FF
      when "001110101111110" =>  data <= "11111111";  -- 1D7E = FF
      when "001110101111111" =>  data <= "11111111";  -- 1D7F = FF
      when "001110110000000" =>  data <= "11111111";  -- 1D80 = FF
      when "001110110000001" =>  data <= "11111111";  -- 1D81 = FF
      when "001110110000010" =>  data <= "11111111";  -- 1D82 = FF
      when "001110110000011" =>  data <= "11111111";  -- 1D83 = FF
      when "001110110000100" =>  data <= "11111111";  -- 1D84 = FF
      when "001110110000101" =>  data <= "11111111";  -- 1D85 = FF
      when "001110110000110" =>  data <= "11111111";  -- 1D86 = FF
      when "001110110000111" =>  data <= "11111111";  -- 1D87 = FF
      when "001110110001000" =>  data <= "11111111";  -- 1D88 = FF
      when "001110110001001" =>  data <= "11111111";  -- 1D89 = FF
      when "001110110001010" =>  data <= "11111111";  -- 1D8A = FF
      when "001110110001011" =>  data <= "11111111";  -- 1D8B = FF
      when "001110110001100" =>  data <= "11111111";  -- 1D8C = FF
      when "001110110001101" =>  data <= "11111111";  -- 1D8D = FF
      when "001110110001110" =>  data <= "11111111";  -- 1D8E = FF
      when "001110110001111" =>  data <= "11111111";  -- 1D8F = FF
      when "001110110010000" =>  data <= "11111111";  -- 1D90 = FF
      when "001110110010001" =>  data <= "11111111";  -- 1D91 = FF
      when "001110110010010" =>  data <= "11111111";  -- 1D92 = FF
      when "001110110010011" =>  data <= "11111111";  -- 1D93 = FF
      when "001110110010100" =>  data <= "11111111";  -- 1D94 = FF
      when "001110110010101" =>  data <= "11111111";  -- 1D95 = FF
      when "001110110010110" =>  data <= "11111111";  -- 1D96 = FF
      when "001110110010111" =>  data <= "11111111";  -- 1D97 = FF
      when "001110110011000" =>  data <= "11111111";  -- 1D98 = FF
      when "001110110011001" =>  data <= "11111111";  -- 1D99 = FF
      when "001110110011010" =>  data <= "11111111";  -- 1D9A = FF
      when "001110110011011" =>  data <= "11111111";  -- 1D9B = FF
      when "001110110011100" =>  data <= "11111111";  -- 1D9C = FF
      when "001110110011101" =>  data <= "11111111";  -- 1D9D = FF
      when "001110110011110" =>  data <= "11111111";  -- 1D9E = FF
      when "001110110011111" =>  data <= "11111111";  -- 1D9F = FF
      when "001110110100000" =>  data <= "11111111";  -- 1DA0 = FF
      when "001110110100001" =>  data <= "11111111";  -- 1DA1 = FF
      when "001110110100010" =>  data <= "11111111";  -- 1DA2 = FF
      when "001110110100011" =>  data <= "11111111";  -- 1DA3 = FF
      when "001110110100100" =>  data <= "11111111";  -- 1DA4 = FF
      when "001110110100101" =>  data <= "11111111";  -- 1DA5 = FF
      when "001110110100110" =>  data <= "11111111";  -- 1DA6 = FF
      when "001110110100111" =>  data <= "11111111";  -- 1DA7 = FF
      when "001110110101000" =>  data <= "11111111";  -- 1DA8 = FF
      when "001110110101001" =>  data <= "11111111";  -- 1DA9 = FF
      when "001110110101010" =>  data <= "11111111";  -- 1DAA = FF
      when "001110110101011" =>  data <= "11111111";  -- 1DAB = FF
      when "001110110101100" =>  data <= "11111111";  -- 1DAC = FF
      when "001110110101101" =>  data <= "11111111";  -- 1DAD = FF
      when "001110110101110" =>  data <= "11111111";  -- 1DAE = FF
      when "001110110101111" =>  data <= "11111111";  -- 1DAF = FF
      when "001110110110000" =>  data <= "11111111";  -- 1DB0 = FF
      when "001110110110001" =>  data <= "11111111";  -- 1DB1 = FF
      when "001110110110010" =>  data <= "11111111";  -- 1DB2 = FF
      when "001110110110011" =>  data <= "11111111";  -- 1DB3 = FF
      when "001110110110100" =>  data <= "11111111";  -- 1DB4 = FF
      when "001110110110101" =>  data <= "11111111";  -- 1DB5 = FF
      when "001110110110110" =>  data <= "11111111";  -- 1DB6 = FF
      when "001110110110111" =>  data <= "11111111";  -- 1DB7 = FF
      when "001110110111000" =>  data <= "11111111";  -- 1DB8 = FF
      when "001110110111001" =>  data <= "11111111";  -- 1DB9 = FF
      when "001110110111010" =>  data <= "11111111";  -- 1DBA = FF
      when "001110110111011" =>  data <= "11111111";  -- 1DBB = FF
      when "001110110111100" =>  data <= "11111111";  -- 1DBC = FF
      when "001110110111101" =>  data <= "11111111";  -- 1DBD = FF
      when "001110110111110" =>  data <= "11111111";  -- 1DBE = FF
      when "001110110111111" =>  data <= "11111111";  -- 1DBF = FF
      when "001110111000000" =>  data <= "11111111";  -- 1DC0 = FF
      when "001110111000001" =>  data <= "11111111";  -- 1DC1 = FF
      when "001110111000010" =>  data <= "11111111";  -- 1DC2 = FF
      when "001110111000011" =>  data <= "11111111";  -- 1DC3 = FF
      when "001110111000100" =>  data <= "11111111";  -- 1DC4 = FF
      when "001110111000101" =>  data <= "11111111";  -- 1DC5 = FF
      when "001110111000110" =>  data <= "11111111";  -- 1DC6 = FF
      when "001110111000111" =>  data <= "11111111";  -- 1DC7 = FF
      when "001110111001000" =>  data <= "11111111";  -- 1DC8 = FF
      when "001110111001001" =>  data <= "11111111";  -- 1DC9 = FF
      when "001110111001010" =>  data <= "11111111";  -- 1DCA = FF
      when "001110111001011" =>  data <= "11111111";  -- 1DCB = FF
      when "001110111001100" =>  data <= "11111111";  -- 1DCC = FF
      when "001110111001101" =>  data <= "11111111";  -- 1DCD = FF
      when "001110111001110" =>  data <= "11111111";  -- 1DCE = FF
      when "001110111001111" =>  data <= "11111111";  -- 1DCF = FF
      when "001110111010000" =>  data <= "11111111";  -- 1DD0 = FF
      when "001110111010001" =>  data <= "11111111";  -- 1DD1 = FF
      when "001110111010010" =>  data <= "11111111";  -- 1DD2 = FF
      when "001110111010011" =>  data <= "11111111";  -- 1DD3 = FF
      when "001110111010100" =>  data <= "11111111";  -- 1DD4 = FF
      when "001110111010101" =>  data <= "11111111";  -- 1DD5 = FF
      when "001110111010110" =>  data <= "11111111";  -- 1DD6 = FF
      when "001110111010111" =>  data <= "11111111";  -- 1DD7 = FF
      when "001110111011000" =>  data <= "11111111";  -- 1DD8 = FF
      when "001110111011001" =>  data <= "11111111";  -- 1DD9 = FF
      when "001110111011010" =>  data <= "11111111";  -- 1DDA = FF
      when "001110111011011" =>  data <= "11111111";  -- 1DDB = FF
      when "001110111011100" =>  data <= "11111111";  -- 1DDC = FF
      when "001110111011101" =>  data <= "11111111";  -- 1DDD = FF
      when "001110111011110" =>  data <= "11111111";  -- 1DDE = FF
      when "001110111011111" =>  data <= "11111111";  -- 1DDF = FF
      when "001110111100000" =>  data <= "11111111";  -- 1DE0 = FF
      when "001110111100001" =>  data <= "11111111";  -- 1DE1 = FF
      when "001110111100010" =>  data <= "11111111";  -- 1DE2 = FF
      when "001110111100011" =>  data <= "11111111";  -- 1DE3 = FF
      when "001110111100100" =>  data <= "11111111";  -- 1DE4 = FF
      when "001110111100101" =>  data <= "11111111";  -- 1DE5 = FF
      when "001110111100110" =>  data <= "11111111";  -- 1DE6 = FF
      when "001110111100111" =>  data <= "11111111";  -- 1DE7 = FF
      when "001110111101000" =>  data <= "11111111";  -- 1DE8 = FF
      when "001110111101001" =>  data <= "11111111";  -- 1DE9 = FF
      when "001110111101010" =>  data <= "11111111";  -- 1DEA = FF
      when "001110111101011" =>  data <= "11111111";  -- 1DEB = FF
      when "001110111101100" =>  data <= "11111111";  -- 1DEC = FF
      when "001110111101101" =>  data <= "11111111";  -- 1DED = FF
      when "001110111101110" =>  data <= "11111111";  -- 1DEE = FF
      when "001110111101111" =>  data <= "11111111";  -- 1DEF = FF
      when "001110111110000" =>  data <= "11111111";  -- 1DF0 = FF
      when "001110111110001" =>  data <= "11111111";  -- 1DF1 = FF
      when "001110111110010" =>  data <= "11111111";  -- 1DF2 = FF
      when "001110111110011" =>  data <= "11111111";  -- 1DF3 = FF
      when "001110111110100" =>  data <= "11111111";  -- 1DF4 = FF
      when "001110111110101" =>  data <= "11111111";  -- 1DF5 = FF
      when "001110111110110" =>  data <= "11111111";  -- 1DF6 = FF
      when "001110111110111" =>  data <= "11111111";  -- 1DF7 = FF
      when "001110111111000" =>  data <= "11111111";  -- 1DF8 = FF
      when "001110111111001" =>  data <= "11111111";  -- 1DF9 = FF
      when "001110111111010" =>  data <= "11111111";  -- 1DFA = FF
      when "001110111111011" =>  data <= "11111111";  -- 1DFB = FF
      when "001110111111100" =>  data <= "11111111";  -- 1DFC = FF
      when "001110111111101" =>  data <= "11111111";  -- 1DFD = FF
      when "001110111111110" =>  data <= "11111111";  -- 1DFE = FF
      when "001110111111111" =>  data <= "11111111";  -- 1DFF = FF
      when "001111000000000" =>  data <= "11111111";  -- 1E00 = FF
      when "001111000000001" =>  data <= "11111111";  -- 1E01 = FF
      when "001111000000010" =>  data <= "11111111";  -- 1E02 = FF
      when "001111000000011" =>  data <= "11111111";  -- 1E03 = FF
      when "001111000000100" =>  data <= "11111111";  -- 1E04 = FF
      when "001111000000101" =>  data <= "11111111";  -- 1E05 = FF
      when "001111000000110" =>  data <= "11111111";  -- 1E06 = FF
      when "001111000000111" =>  data <= "11111111";  -- 1E07 = FF
      when "001111000001000" =>  data <= "11111111";  -- 1E08 = FF
      when "001111000001001" =>  data <= "11111111";  -- 1E09 = FF
      when "001111000001010" =>  data <= "11111111";  -- 1E0A = FF
      when "001111000001011" =>  data <= "11111111";  -- 1E0B = FF
      when "001111000001100" =>  data <= "11111111";  -- 1E0C = FF
      when "001111000001101" =>  data <= "11111111";  -- 1E0D = FF
      when "001111000001110" =>  data <= "11111111";  -- 1E0E = FF
      when "001111000001111" =>  data <= "11111111";  -- 1E0F = FF
      when "001111000010000" =>  data <= "11111111";  -- 1E10 = FF
      when "001111000010001" =>  data <= "11111111";  -- 1E11 = FF
      when "001111000010010" =>  data <= "11111111";  -- 1E12 = FF
      when "001111000010011" =>  data <= "11111111";  -- 1E13 = FF
      when "001111000010100" =>  data <= "11111111";  -- 1E14 = FF
      when "001111000010101" =>  data <= "11111111";  -- 1E15 = FF
      when "001111000010110" =>  data <= "11111111";  -- 1E16 = FF
      when "001111000010111" =>  data <= "11111111";  -- 1E17 = FF
      when "001111000011000" =>  data <= "11111111";  -- 1E18 = FF
      when "001111000011001" =>  data <= "11111111";  -- 1E19 = FF
      when "001111000011010" =>  data <= "11111111";  -- 1E1A = FF
      when "001111000011011" =>  data <= "11111111";  -- 1E1B = FF
      when "001111000011100" =>  data <= "11111111";  -- 1E1C = FF
      when "001111000011101" =>  data <= "11111111";  -- 1E1D = FF
      when "001111000011110" =>  data <= "11111111";  -- 1E1E = FF
      when "001111000011111" =>  data <= "11111111";  -- 1E1F = FF
      when "001111000100000" =>  data <= "11111111";  -- 1E20 = FF
      when "001111000100001" =>  data <= "11111111";  -- 1E21 = FF
      when "001111000100010" =>  data <= "11111111";  -- 1E22 = FF
      when "001111000100011" =>  data <= "11111111";  -- 1E23 = FF
      when "001111000100100" =>  data <= "11111111";  -- 1E24 = FF
      when "001111000100101" =>  data <= "11111111";  -- 1E25 = FF
      when "001111000100110" =>  data <= "11111111";  -- 1E26 = FF
      when "001111000100111" =>  data <= "11111111";  -- 1E27 = FF
      when "001111000101000" =>  data <= "11111111";  -- 1E28 = FF
      when "001111000101001" =>  data <= "11111111";  -- 1E29 = FF
      when "001111000101010" =>  data <= "11111111";  -- 1E2A = FF
      when "001111000101011" =>  data <= "11111111";  -- 1E2B = FF
      when "001111000101100" =>  data <= "11111111";  -- 1E2C = FF
      when "001111000101101" =>  data <= "11111111";  -- 1E2D = FF
      when "001111000101110" =>  data <= "11111111";  -- 1E2E = FF
      when "001111000101111" =>  data <= "11111111";  -- 1E2F = FF
      when "001111000110000" =>  data <= "11111111";  -- 1E30 = FF
      when "001111000110001" =>  data <= "11111111";  -- 1E31 = FF
      when "001111000110010" =>  data <= "11111111";  -- 1E32 = FF
      when "001111000110011" =>  data <= "11111111";  -- 1E33 = FF
      when "001111000110100" =>  data <= "11111111";  -- 1E34 = FF
      when "001111000110101" =>  data <= "11111111";  -- 1E35 = FF
      when "001111000110110" =>  data <= "11111111";  -- 1E36 = FF
      when "001111000110111" =>  data <= "11111111";  -- 1E37 = FF
      when "001111000111000" =>  data <= "11111111";  -- 1E38 = FF
      when "001111000111001" =>  data <= "11111111";  -- 1E39 = FF
      when "001111000111010" =>  data <= "11111111";  -- 1E3A = FF
      when "001111000111011" =>  data <= "11111111";  -- 1E3B = FF
      when "001111000111100" =>  data <= "11111111";  -- 1E3C = FF
      when "001111000111101" =>  data <= "11111111";  -- 1E3D = FF
      when "001111000111110" =>  data <= "11111111";  -- 1E3E = FF
      when "001111000111111" =>  data <= "11111111";  -- 1E3F = FF
      when "001111001000000" =>  data <= "11111111";  -- 1E40 = FF
      when "001111001000001" =>  data <= "11111111";  -- 1E41 = FF
      when "001111001000010" =>  data <= "11111111";  -- 1E42 = FF
      when "001111001000011" =>  data <= "11111111";  -- 1E43 = FF
      when "001111001000100" =>  data <= "11111111";  -- 1E44 = FF
      when "001111001000101" =>  data <= "11111111";  -- 1E45 = FF
      when "001111001000110" =>  data <= "11111111";  -- 1E46 = FF
      when "001111001000111" =>  data <= "11111111";  -- 1E47 = FF
      when "001111001001000" =>  data <= "11111111";  -- 1E48 = FF
      when "001111001001001" =>  data <= "11111111";  -- 1E49 = FF
      when "001111001001010" =>  data <= "11111111";  -- 1E4A = FF
      when "001111001001011" =>  data <= "11111111";  -- 1E4B = FF
      when "001111001001100" =>  data <= "11111111";  -- 1E4C = FF
      when "001111001001101" =>  data <= "11111111";  -- 1E4D = FF
      when "001111001001110" =>  data <= "11111111";  -- 1E4E = FF
      when "001111001001111" =>  data <= "11111111";  -- 1E4F = FF
      when "001111001010000" =>  data <= "11111111";  -- 1E50 = FF
      when "001111001010001" =>  data <= "11111111";  -- 1E51 = FF
      when "001111001010010" =>  data <= "11111111";  -- 1E52 = FF
      when "001111001010011" =>  data <= "11111111";  -- 1E53 = FF
      when "001111001010100" =>  data <= "11111111";  -- 1E54 = FF
      when "001111001010101" =>  data <= "11111111";  -- 1E55 = FF
      when "001111001010110" =>  data <= "11111111";  -- 1E56 = FF
      when "001111001010111" =>  data <= "11111111";  -- 1E57 = FF
      when "001111001011000" =>  data <= "11111111";  -- 1E58 = FF
      when "001111001011001" =>  data <= "11111111";  -- 1E59 = FF
      when "001111001011010" =>  data <= "11111111";  -- 1E5A = FF
      when "001111001011011" =>  data <= "11111111";  -- 1E5B = FF
      when "001111001011100" =>  data <= "11111111";  -- 1E5C = FF
      when "001111001011101" =>  data <= "11111111";  -- 1E5D = FF
      when "001111001011110" =>  data <= "11111111";  -- 1E5E = FF
      when "001111001011111" =>  data <= "11111111";  -- 1E5F = FF
      when "001111001100000" =>  data <= "11111111";  -- 1E60 = FF
      when "001111001100001" =>  data <= "11111111";  -- 1E61 = FF
      when "001111001100010" =>  data <= "11111111";  -- 1E62 = FF
      when "001111001100011" =>  data <= "11111111";  -- 1E63 = FF
      when "001111001100100" =>  data <= "11111111";  -- 1E64 = FF
      when "001111001100101" =>  data <= "11111111";  -- 1E65 = FF
      when "001111001100110" =>  data <= "11111111";  -- 1E66 = FF
      when "001111001100111" =>  data <= "11111111";  -- 1E67 = FF
      when "001111001101000" =>  data <= "11111111";  -- 1E68 = FF
      when "001111001101001" =>  data <= "11111111";  -- 1E69 = FF
      when "001111001101010" =>  data <= "11111111";  -- 1E6A = FF
      when "001111001101011" =>  data <= "11111111";  -- 1E6B = FF
      when "001111001101100" =>  data <= "11111111";  -- 1E6C = FF
      when "001111001101101" =>  data <= "11111111";  -- 1E6D = FF
      when "001111001101110" =>  data <= "11111111";  -- 1E6E = FF
      when "001111001101111" =>  data <= "11111111";  -- 1E6F = FF
      when "001111001110000" =>  data <= "11111111";  -- 1E70 = FF
      when "001111001110001" =>  data <= "11111111";  -- 1E71 = FF
      when "001111001110010" =>  data <= "11111111";  -- 1E72 = FF
      when "001111001110011" =>  data <= "11111111";  -- 1E73 = FF
      when "001111001110100" =>  data <= "11111111";  -- 1E74 = FF
      when "001111001110101" =>  data <= "11111111";  -- 1E75 = FF
      when "001111001110110" =>  data <= "11111111";  -- 1E76 = FF
      when "001111001110111" =>  data <= "11111111";  -- 1E77 = FF
      when "001111001111000" =>  data <= "11111111";  -- 1E78 = FF
      when "001111001111001" =>  data <= "11111111";  -- 1E79 = FF
      when "001111001111010" =>  data <= "11111111";  -- 1E7A = FF
      when "001111001111011" =>  data <= "11111111";  -- 1E7B = FF
      when "001111001111100" =>  data <= "11111111";  -- 1E7C = FF
      when "001111001111101" =>  data <= "11111111";  -- 1E7D = FF
      when "001111001111110" =>  data <= "11111111";  -- 1E7E = FF
      when "001111001111111" =>  data <= "11111111";  -- 1E7F = FF
      when "001111010000000" =>  data <= "11111111";  -- 1E80 = FF
      when "001111010000001" =>  data <= "11111111";  -- 1E81 = FF
      when "001111010000010" =>  data <= "11111111";  -- 1E82 = FF
      when "001111010000011" =>  data <= "11111111";  -- 1E83 = FF
      when "001111010000100" =>  data <= "11111111";  -- 1E84 = FF
      when "001111010000101" =>  data <= "11111111";  -- 1E85 = FF
      when "001111010000110" =>  data <= "11111111";  -- 1E86 = FF
      when "001111010000111" =>  data <= "11111111";  -- 1E87 = FF
      when "001111010001000" =>  data <= "11111111";  -- 1E88 = FF
      when "001111010001001" =>  data <= "11111111";  -- 1E89 = FF
      when "001111010001010" =>  data <= "11111111";  -- 1E8A = FF
      when "001111010001011" =>  data <= "11111111";  -- 1E8B = FF
      when "001111010001100" =>  data <= "11111111";  -- 1E8C = FF
      when "001111010001101" =>  data <= "11111111";  -- 1E8D = FF
      when "001111010001110" =>  data <= "11111111";  -- 1E8E = FF
      when "001111010001111" =>  data <= "11111111";  -- 1E8F = FF
      when "001111010010000" =>  data <= "11111111";  -- 1E90 = FF
      when "001111010010001" =>  data <= "11111111";  -- 1E91 = FF
      when "001111010010010" =>  data <= "11111111";  -- 1E92 = FF
      when "001111010010011" =>  data <= "11111111";  -- 1E93 = FF
      when "001111010010100" =>  data <= "11111111";  -- 1E94 = FF
      when "001111010010101" =>  data <= "11111111";  -- 1E95 = FF
      when "001111010010110" =>  data <= "11111111";  -- 1E96 = FF
      when "001111010010111" =>  data <= "11111111";  -- 1E97 = FF
      when "001111010011000" =>  data <= "11111111";  -- 1E98 = FF
      when "001111010011001" =>  data <= "11111111";  -- 1E99 = FF
      when "001111010011010" =>  data <= "11111111";  -- 1E9A = FF
      when "001111010011011" =>  data <= "11111111";  -- 1E9B = FF
      when "001111010011100" =>  data <= "11111111";  -- 1E9C = FF
      when "001111010011101" =>  data <= "11111111";  -- 1E9D = FF
      when "001111010011110" =>  data <= "11111111";  -- 1E9E = FF
      when "001111010011111" =>  data <= "11111111";  -- 1E9F = FF
      when "001111010100000" =>  data <= "11111111";  -- 1EA0 = FF
      when "001111010100001" =>  data <= "11111111";  -- 1EA1 = FF
      when "001111010100010" =>  data <= "11111111";  -- 1EA2 = FF
      when "001111010100011" =>  data <= "11111111";  -- 1EA3 = FF
      when "001111010100100" =>  data <= "11111111";  -- 1EA4 = FF
      when "001111010100101" =>  data <= "11111111";  -- 1EA5 = FF
      when "001111010100110" =>  data <= "11111111";  -- 1EA6 = FF
      when "001111010100111" =>  data <= "11111111";  -- 1EA7 = FF
      when "001111010101000" =>  data <= "11111111";  -- 1EA8 = FF
      when "001111010101001" =>  data <= "11111111";  -- 1EA9 = FF
      when "001111010101010" =>  data <= "11111111";  -- 1EAA = FF
      when "001111010101011" =>  data <= "11111111";  -- 1EAB = FF
      when "001111010101100" =>  data <= "11111111";  -- 1EAC = FF
      when "001111010101101" =>  data <= "11111111";  -- 1EAD = FF
      when "001111010101110" =>  data <= "11111111";  -- 1EAE = FF
      when "001111010101111" =>  data <= "11111111";  -- 1EAF = FF
      when "001111010110000" =>  data <= "11111111";  -- 1EB0 = FF
      when "001111010110001" =>  data <= "11111111";  -- 1EB1 = FF
      when "001111010110010" =>  data <= "11111111";  -- 1EB2 = FF
      when "001111010110011" =>  data <= "11111111";  -- 1EB3 = FF
      when "001111010110100" =>  data <= "11111111";  -- 1EB4 = FF
      when "001111010110101" =>  data <= "11111111";  -- 1EB5 = FF
      when "001111010110110" =>  data <= "11111111";  -- 1EB6 = FF
      when "001111010110111" =>  data <= "11111111";  -- 1EB7 = FF
      when "001111010111000" =>  data <= "11111111";  -- 1EB8 = FF
      when "001111010111001" =>  data <= "11111111";  -- 1EB9 = FF
      when "001111010111010" =>  data <= "11111111";  -- 1EBA = FF
      when "001111010111011" =>  data <= "11111111";  -- 1EBB = FF
      when "001111010111100" =>  data <= "11111111";  -- 1EBC = FF
      when "001111010111101" =>  data <= "11111111";  -- 1EBD = FF
      when "001111010111110" =>  data <= "11111111";  -- 1EBE = FF
      when "001111010111111" =>  data <= "11111111";  -- 1EBF = FF
      when "001111011000000" =>  data <= "11111111";  -- 1EC0 = FF
      when "001111011000001" =>  data <= "11111111";  -- 1EC1 = FF
      when "001111011000010" =>  data <= "11111111";  -- 1EC2 = FF
      when "001111011000011" =>  data <= "11111111";  -- 1EC3 = FF
      when "001111011000100" =>  data <= "11111111";  -- 1EC4 = FF
      when "001111011000101" =>  data <= "11111111";  -- 1EC5 = FF
      when "001111011000110" =>  data <= "11111111";  -- 1EC6 = FF
      when "001111011000111" =>  data <= "11111111";  -- 1EC7 = FF
      when "001111011001000" =>  data <= "11111111";  -- 1EC8 = FF
      when "001111011001001" =>  data <= "11111111";  -- 1EC9 = FF
      when "001111011001010" =>  data <= "11111111";  -- 1ECA = FF
      when "001111011001011" =>  data <= "11111111";  -- 1ECB = FF
      when "001111011001100" =>  data <= "11111111";  -- 1ECC = FF
      when "001111011001101" =>  data <= "11111111";  -- 1ECD = FF
      when "001111011001110" =>  data <= "11111111";  -- 1ECE = FF
      when "001111011001111" =>  data <= "11111111";  -- 1ECF = FF
      when "001111011010000" =>  data <= "11111111";  -- 1ED0 = FF
      when "001111011010001" =>  data <= "11111111";  -- 1ED1 = FF
      when "001111011010010" =>  data <= "11111111";  -- 1ED2 = FF
      when "001111011010011" =>  data <= "11111111";  -- 1ED3 = FF
      when "001111011010100" =>  data <= "11111111";  -- 1ED4 = FF
      when "001111011010101" =>  data <= "11111111";  -- 1ED5 = FF
      when "001111011010110" =>  data <= "11111111";  -- 1ED6 = FF
      when "001111011010111" =>  data <= "11111111";  -- 1ED7 = FF
      when "001111011011000" =>  data <= "11111111";  -- 1ED8 = FF
      when "001111011011001" =>  data <= "11111111";  -- 1ED9 = FF
      when "001111011011010" =>  data <= "11111111";  -- 1EDA = FF
      when "001111011011011" =>  data <= "11111111";  -- 1EDB = FF
      when "001111011011100" =>  data <= "11111111";  -- 1EDC = FF
      when "001111011011101" =>  data <= "11111111";  -- 1EDD = FF
      when "001111011011110" =>  data <= "11111111";  -- 1EDE = FF
      when "001111011011111" =>  data <= "11111111";  -- 1EDF = FF
      when "001111011100000" =>  data <= "11111111";  -- 1EE0 = FF
      when "001111011100001" =>  data <= "11111111";  -- 1EE1 = FF
      when "001111011100010" =>  data <= "11111111";  -- 1EE2 = FF
      when "001111011100011" =>  data <= "11111111";  -- 1EE3 = FF
      when "001111011100100" =>  data <= "11111111";  -- 1EE4 = FF
      when "001111011100101" =>  data <= "11111111";  -- 1EE5 = FF
      when "001111011100110" =>  data <= "11111111";  -- 1EE6 = FF
      when "001111011100111" =>  data <= "11111111";  -- 1EE7 = FF
      when "001111011101000" =>  data <= "11111111";  -- 1EE8 = FF
      when "001111011101001" =>  data <= "11111111";  -- 1EE9 = FF
      when "001111011101010" =>  data <= "11111111";  -- 1EEA = FF
      when "001111011101011" =>  data <= "11111111";  -- 1EEB = FF
      when "001111011101100" =>  data <= "11111111";  -- 1EEC = FF
      when "001111011101101" =>  data <= "11111111";  -- 1EED = FF
      when "001111011101110" =>  data <= "11111111";  -- 1EEE = FF
      when "001111011101111" =>  data <= "11111111";  -- 1EEF = FF
      when "001111011110000" =>  data <= "11111111";  -- 1EF0 = FF
      when "001111011110001" =>  data <= "11111111";  -- 1EF1 = FF
      when "001111011110010" =>  data <= "11111111";  -- 1EF2 = FF
      when "001111011110011" =>  data <= "11111111";  -- 1EF3 = FF
      when "001111011110100" =>  data <= "11111111";  -- 1EF4 = FF
      when "001111011110101" =>  data <= "11111111";  -- 1EF5 = FF
      when "001111011110110" =>  data <= "11111111";  -- 1EF6 = FF
      when "001111011110111" =>  data <= "11111111";  -- 1EF7 = FF
      when "001111011111000" =>  data <= "11111111";  -- 1EF8 = FF
      when "001111011111001" =>  data <= "11111111";  -- 1EF9 = FF
      when "001111011111010" =>  data <= "11111111";  -- 1EFA = FF
      when "001111011111011" =>  data <= "11111111";  -- 1EFB = FF
      when "001111011111100" =>  data <= "11111111";  -- 1EFC = FF
      when "001111011111101" =>  data <= "11111111";  -- 1EFD = FF
      when "001111011111110" =>  data <= "11111111";  -- 1EFE = FF
      when "001111011111111" =>  data <= "11111111";  -- 1EFF = FF
      when "001111100000000" =>  data <= "11111111";  -- 1F00 = FF
      when "001111100000001" =>  data <= "11111111";  -- 1F01 = FF
      when "001111100000010" =>  data <= "11111111";  -- 1F02 = FF
      when "001111100000011" =>  data <= "11111111";  -- 1F03 = FF
      when "001111100000100" =>  data <= "11111111";  -- 1F04 = FF
      when "001111100000101" =>  data <= "11111111";  -- 1F05 = FF
      when "001111100000110" =>  data <= "11111111";  -- 1F06 = FF
      when "001111100000111" =>  data <= "11111111";  -- 1F07 = FF
      when "001111100001000" =>  data <= "11111111";  -- 1F08 = FF
      when "001111100001001" =>  data <= "11111111";  -- 1F09 = FF
      when "001111100001010" =>  data <= "11111111";  -- 1F0A = FF
      when "001111100001011" =>  data <= "11111111";  -- 1F0B = FF
      when "001111100001100" =>  data <= "11111111";  -- 1F0C = FF
      when "001111100001101" =>  data <= "11111111";  -- 1F0D = FF
      when "001111100001110" =>  data <= "11111111";  -- 1F0E = FF
      when "001111100001111" =>  data <= "11111111";  -- 1F0F = FF
      when "001111100010000" =>  data <= "11111111";  -- 1F10 = FF
      when "001111100010001" =>  data <= "11111111";  -- 1F11 = FF
      when "001111100010010" =>  data <= "11111111";  -- 1F12 = FF
      when "001111100010011" =>  data <= "11111111";  -- 1F13 = FF
      when "001111100010100" =>  data <= "11111111";  -- 1F14 = FF
      when "001111100010101" =>  data <= "11111111";  -- 1F15 = FF
      when "001111100010110" =>  data <= "11111111";  -- 1F16 = FF
      when "001111100010111" =>  data <= "11111111";  -- 1F17 = FF
      when "001111100011000" =>  data <= "11111111";  -- 1F18 = FF
      when "001111100011001" =>  data <= "11111111";  -- 1F19 = FF
      when "001111100011010" =>  data <= "11111111";  -- 1F1A = FF
      when "001111100011011" =>  data <= "11111111";  -- 1F1B = FF
      when "001111100011100" =>  data <= "11111111";  -- 1F1C = FF
      when "001111100011101" =>  data <= "11111111";  -- 1F1D = FF
      when "001111100011110" =>  data <= "11111111";  -- 1F1E = FF
      when "001111100011111" =>  data <= "11111111";  -- 1F1F = FF
      when "001111100100000" =>  data <= "11111111";  -- 1F20 = FF
      when "001111100100001" =>  data <= "11111111";  -- 1F21 = FF
      when "001111100100010" =>  data <= "11111111";  -- 1F22 = FF
      when "001111100100011" =>  data <= "11111111";  -- 1F23 = FF
      when "001111100100100" =>  data <= "11111111";  -- 1F24 = FF
      when "001111100100101" =>  data <= "11111111";  -- 1F25 = FF
      when "001111100100110" =>  data <= "11111111";  -- 1F26 = FF
      when "001111100100111" =>  data <= "11111111";  -- 1F27 = FF
      when "001111100101000" =>  data <= "11111111";  -- 1F28 = FF
      when "001111100101001" =>  data <= "11111111";  -- 1F29 = FF
      when "001111100101010" =>  data <= "11111111";  -- 1F2A = FF
      when "001111100101011" =>  data <= "11111111";  -- 1F2B = FF
      when "001111100101100" =>  data <= "11111111";  -- 1F2C = FF
      when "001111100101101" =>  data <= "11111111";  -- 1F2D = FF
      when "001111100101110" =>  data <= "11111111";  -- 1F2E = FF
      when "001111100101111" =>  data <= "11111111";  -- 1F2F = FF
      when "001111100110000" =>  data <= "11111111";  -- 1F30 = FF
      when "001111100110001" =>  data <= "11111111";  -- 1F31 = FF
      when "001111100110010" =>  data <= "11111111";  -- 1F32 = FF
      when "001111100110011" =>  data <= "11111111";  -- 1F33 = FF
      when "001111100110100" =>  data <= "11111111";  -- 1F34 = FF
      when "001111100110101" =>  data <= "11111111";  -- 1F35 = FF
      when "001111100110110" =>  data <= "11111111";  -- 1F36 = FF
      when "001111100110111" =>  data <= "11111111";  -- 1F37 = FF
      when "001111100111000" =>  data <= "11111111";  -- 1F38 = FF
      when "001111100111001" =>  data <= "11111111";  -- 1F39 = FF
      when "001111100111010" =>  data <= "11111111";  -- 1F3A = FF
      when "001111100111011" =>  data <= "11111111";  -- 1F3B = FF
      when "001111100111100" =>  data <= "11111111";  -- 1F3C = FF
      when "001111100111101" =>  data <= "11111111";  -- 1F3D = FF
      when "001111100111110" =>  data <= "11111111";  -- 1F3E = FF
      when "001111100111111" =>  data <= "11111111";  -- 1F3F = FF
      when "001111101000000" =>  data <= "11111111";  -- 1F40 = FF
      when "001111101000001" =>  data <= "11111111";  -- 1F41 = FF
      when "001111101000010" =>  data <= "11111111";  -- 1F42 = FF
      when "001111101000011" =>  data <= "11111111";  -- 1F43 = FF
      when "001111101000100" =>  data <= "11111111";  -- 1F44 = FF
      when "001111101000101" =>  data <= "11111111";  -- 1F45 = FF
      when "001111101000110" =>  data <= "11111111";  -- 1F46 = FF
      when "001111101000111" =>  data <= "11111111";  -- 1F47 = FF
      when "001111101001000" =>  data <= "11111111";  -- 1F48 = FF
      when "001111101001001" =>  data <= "11111111";  -- 1F49 = FF
      when "001111101001010" =>  data <= "11111111";  -- 1F4A = FF
      when "001111101001011" =>  data <= "11111111";  -- 1F4B = FF
      when "001111101001100" =>  data <= "11111111";  -- 1F4C = FF
      when "001111101001101" =>  data <= "11111111";  -- 1F4D = FF
      when "001111101001110" =>  data <= "11111111";  -- 1F4E = FF
      when "001111101001111" =>  data <= "11111111";  -- 1F4F = FF
      when "001111101010000" =>  data <= "11111111";  -- 1F50 = FF
      when "001111101010001" =>  data <= "11111111";  -- 1F51 = FF
      when "001111101010010" =>  data <= "11111111";  -- 1F52 = FF
      when "001111101010011" =>  data <= "11111111";  -- 1F53 = FF
      when "001111101010100" =>  data <= "11111111";  -- 1F54 = FF
      when "001111101010101" =>  data <= "11111111";  -- 1F55 = FF
      when "001111101010110" =>  data <= "11111111";  -- 1F56 = FF
      when "001111101010111" =>  data <= "11111111";  -- 1F57 = FF
      when "001111101011000" =>  data <= "11111111";  -- 1F58 = FF
      when "001111101011001" =>  data <= "11111111";  -- 1F59 = FF
      when "001111101011010" =>  data <= "11111111";  -- 1F5A = FF
      when "001111101011011" =>  data <= "11111111";  -- 1F5B = FF
      when "001111101011100" =>  data <= "11111111";  -- 1F5C = FF
      when "001111101011101" =>  data <= "11111111";  -- 1F5D = FF
      when "001111101011110" =>  data <= "11111111";  -- 1F5E = FF
      when "001111101011111" =>  data <= "11111111";  -- 1F5F = FF
      when "001111101100000" =>  data <= "11111111";  -- 1F60 = FF
      when "001111101100001" =>  data <= "11111111";  -- 1F61 = FF
      when "001111101100010" =>  data <= "11111111";  -- 1F62 = FF
      when "001111101100011" =>  data <= "11111111";  -- 1F63 = FF
      when "001111101100100" =>  data <= "11111111";  -- 1F64 = FF
      when "001111101100101" =>  data <= "11111111";  -- 1F65 = FF
      when "001111101100110" =>  data <= "11111111";  -- 1F66 = FF
      when "001111101100111" =>  data <= "11111111";  -- 1F67 = FF
      when "001111101101000" =>  data <= "11111111";  -- 1F68 = FF
      when "001111101101001" =>  data <= "11111111";  -- 1F69 = FF
      when "001111101101010" =>  data <= "11111111";  -- 1F6A = FF
      when "001111101101011" =>  data <= "11111111";  -- 1F6B = FF
      when "001111101101100" =>  data <= "11111111";  -- 1F6C = FF
      when "001111101101101" =>  data <= "11111111";  -- 1F6D = FF
      when "001111101101110" =>  data <= "11111111";  -- 1F6E = FF
      when "001111101101111" =>  data <= "11111111";  -- 1F6F = FF
      when "001111101110000" =>  data <= "11111111";  -- 1F70 = FF
      when "001111101110001" =>  data <= "11111111";  -- 1F71 = FF
      when "001111101110010" =>  data <= "11111111";  -- 1F72 = FF
      when "001111101110011" =>  data <= "11111111";  -- 1F73 = FF
      when "001111101110100" =>  data <= "11111111";  -- 1F74 = FF
      when "001111101110101" =>  data <= "11111111";  -- 1F75 = FF
      when "001111101110110" =>  data <= "11111111";  -- 1F76 = FF
      when "001111101110111" =>  data <= "11111111";  -- 1F77 = FF
      when "001111101111000" =>  data <= "11111111";  -- 1F78 = FF
      when "001111101111001" =>  data <= "11111111";  -- 1F79 = FF
      when "001111101111010" =>  data <= "11111111";  -- 1F7A = FF
      when "001111101111011" =>  data <= "11111111";  -- 1F7B = FF
      when "001111101111100" =>  data <= "11111111";  -- 1F7C = FF
      when "001111101111101" =>  data <= "11111111";  -- 1F7D = FF
      when "001111101111110" =>  data <= "11111111";  -- 1F7E = FF
      when "001111101111111" =>  data <= "11111111";  -- 1F7F = FF
      when "001111110000000" =>  data <= "11111111";  -- 1F80 = FF
      when "001111110000001" =>  data <= "11111111";  -- 1F81 = FF
      when "001111110000010" =>  data <= "11111111";  -- 1F82 = FF
      when "001111110000011" =>  data <= "11111111";  -- 1F83 = FF
      when "001111110000100" =>  data <= "11111111";  -- 1F84 = FF
      when "001111110000101" =>  data <= "11111111";  -- 1F85 = FF
      when "001111110000110" =>  data <= "11111111";  -- 1F86 = FF
      when "001111110000111" =>  data <= "11111111";  -- 1F87 = FF
      when "001111110001000" =>  data <= "11111111";  -- 1F88 = FF
      when "001111110001001" =>  data <= "11111111";  -- 1F89 = FF
      when "001111110001010" =>  data <= "11111111";  -- 1F8A = FF
      when "001111110001011" =>  data <= "11111111";  -- 1F8B = FF
      when "001111110001100" =>  data <= "11111111";  -- 1F8C = FF
      when "001111110001101" =>  data <= "11111111";  -- 1F8D = FF
      when "001111110001110" =>  data <= "11111111";  -- 1F8E = FF
      when "001111110001111" =>  data <= "11111111";  -- 1F8F = FF
      when "001111110010000" =>  data <= "11111111";  -- 1F90 = FF
      when "001111110010001" =>  data <= "11111111";  -- 1F91 = FF
      when "001111110010010" =>  data <= "11111111";  -- 1F92 = FF
      when "001111110010011" =>  data <= "11111111";  -- 1F93 = FF
      when "001111110010100" =>  data <= "11111111";  -- 1F94 = FF
      when "001111110010101" =>  data <= "11111111";  -- 1F95 = FF
      when "001111110010110" =>  data <= "11111111";  -- 1F96 = FF
      when "001111110010111" =>  data <= "11111111";  -- 1F97 = FF
      when "001111110011000" =>  data <= "11111111";  -- 1F98 = FF
      when "001111110011001" =>  data <= "11111111";  -- 1F99 = FF
      when "001111110011010" =>  data <= "11111111";  -- 1F9A = FF
      when "001111110011011" =>  data <= "11111111";  -- 1F9B = FF
      when "001111110011100" =>  data <= "11111111";  -- 1F9C = FF
      when "001111110011101" =>  data <= "11111111";  -- 1F9D = FF
      when "001111110011110" =>  data <= "11111111";  -- 1F9E = FF
      when "001111110011111" =>  data <= "11111111";  -- 1F9F = FF
      when "001111110100000" =>  data <= "11111111";  -- 1FA0 = FF
      when "001111110100001" =>  data <= "11111111";  -- 1FA1 = FF
      when "001111110100010" =>  data <= "11111111";  -- 1FA2 = FF
      when "001111110100011" =>  data <= "11111111";  -- 1FA3 = FF
      when "001111110100100" =>  data <= "11111111";  -- 1FA4 = FF
      when "001111110100101" =>  data <= "11111111";  -- 1FA5 = FF
      when "001111110100110" =>  data <= "11111111";  -- 1FA6 = FF
      when "001111110100111" =>  data <= "11111111";  -- 1FA7 = FF
      when "001111110101000" =>  data <= "11111111";  -- 1FA8 = FF
      when "001111110101001" =>  data <= "11111111";  -- 1FA9 = FF
      when "001111110101010" =>  data <= "11111111";  -- 1FAA = FF
      when "001111110101011" =>  data <= "11111111";  -- 1FAB = FF
      when "001111110101100" =>  data <= "11111111";  -- 1FAC = FF
      when "001111110101101" =>  data <= "11111111";  -- 1FAD = FF
      when "001111110101110" =>  data <= "11111111";  -- 1FAE = FF
      when "001111110101111" =>  data <= "11111111";  -- 1FAF = FF
      when "001111110110000" =>  data <= "11111111";  -- 1FB0 = FF
      when "001111110110001" =>  data <= "11111111";  -- 1FB1 = FF
      when "001111110110010" =>  data <= "11111111";  -- 1FB2 = FF
      when "001111110110011" =>  data <= "11111111";  -- 1FB3 = FF
      when "001111110110100" =>  data <= "11111111";  -- 1FB4 = FF
      when "001111110110101" =>  data <= "11111111";  -- 1FB5 = FF
      when "001111110110110" =>  data <= "11111111";  -- 1FB6 = FF
      when "001111110110111" =>  data <= "11111111";  -- 1FB7 = FF
      when "001111110111000" =>  data <= "11111111";  -- 1FB8 = FF
      when "001111110111001" =>  data <= "11111111";  -- 1FB9 = FF
      when "001111110111010" =>  data <= "11111111";  -- 1FBA = FF
      when "001111110111011" =>  data <= "11111111";  -- 1FBB = FF
      when "001111110111100" =>  data <= "11111111";  -- 1FBC = FF
      when "001111110111101" =>  data <= "11111111";  -- 1FBD = FF
      when "001111110111110" =>  data <= "11111111";  -- 1FBE = FF
      when "001111110111111" =>  data <= "11111111";  -- 1FBF = FF
      when "001111111000000" =>  data <= "11111111";  -- 1FC0 = FF
      when "001111111000001" =>  data <= "11111111";  -- 1FC1 = FF
      when "001111111000010" =>  data <= "11111111";  -- 1FC2 = FF
      when "001111111000011" =>  data <= "11111111";  -- 1FC3 = FF
      when "001111111000100" =>  data <= "11111111";  -- 1FC4 = FF
      when "001111111000101" =>  data <= "11111111";  -- 1FC5 = FF
      when "001111111000110" =>  data <= "11111111";  -- 1FC6 = FF
      when "001111111000111" =>  data <= "11111111";  -- 1FC7 = FF
      when "001111111001000" =>  data <= "11111111";  -- 1FC8 = FF
      when "001111111001001" =>  data <= "11111111";  -- 1FC9 = FF
      when "001111111001010" =>  data <= "11111111";  -- 1FCA = FF
      when "001111111001011" =>  data <= "11111111";  -- 1FCB = FF
      when "001111111001100" =>  data <= "11111111";  -- 1FCC = FF
      when "001111111001101" =>  data <= "11111111";  -- 1FCD = FF
      when "001111111001110" =>  data <= "11111111";  -- 1FCE = FF
      when "001111111001111" =>  data <= "11111111";  -- 1FCF = FF
      when "001111111010000" =>  data <= "11111111";  -- 1FD0 = FF
      when "001111111010001" =>  data <= "11111111";  -- 1FD1 = FF
      when "001111111010010" =>  data <= "11111111";  -- 1FD2 = FF
      when "001111111010011" =>  data <= "11111111";  -- 1FD3 = FF
      when "001111111010100" =>  data <= "11111111";  -- 1FD4 = FF
      when "001111111010101" =>  data <= "11111111";  -- 1FD5 = FF
      when "001111111010110" =>  data <= "11111111";  -- 1FD6 = FF
      when "001111111010111" =>  data <= "11111111";  -- 1FD7 = FF
      when "001111111011000" =>  data <= "11111111";  -- 1FD8 = FF
      when "001111111011001" =>  data <= "11111111";  -- 1FD9 = FF
      when "001111111011010" =>  data <= "11111111";  -- 1FDA = FF
      when "001111111011011" =>  data <= "11111111";  -- 1FDB = FF
      when "001111111011100" =>  data <= "11111111";  -- 1FDC = FF
      when "001111111011101" =>  data <= "11111111";  -- 1FDD = FF
      when "001111111011110" =>  data <= "11111111";  -- 1FDE = FF
      when "001111111011111" =>  data <= "11111111";  -- 1FDF = FF
      when "001111111100000" =>  data <= "11111111";  -- 1FE0 = FF
      when "001111111100001" =>  data <= "11111111";  -- 1FE1 = FF
      when "001111111100010" =>  data <= "11111111";  -- 1FE2 = FF
      when "001111111100011" =>  data <= "11111111";  -- 1FE3 = FF
      when "001111111100100" =>  data <= "11111111";  -- 1FE4 = FF
      when "001111111100101" =>  data <= "11111111";  -- 1FE5 = FF
      when "001111111100110" =>  data <= "11111111";  -- 1FE6 = FF
      when "001111111100111" =>  data <= "11111111";  -- 1FE7 = FF
      when "001111111101000" =>  data <= "11111111";  -- 1FE8 = FF
      when "001111111101001" =>  data <= "11111111";  -- 1FE9 = FF
      when "001111111101010" =>  data <= "11111111";  -- 1FEA = FF
      when "001111111101011" =>  data <= "11111111";  -- 1FEB = FF
      when "001111111101100" =>  data <= "11111111";  -- 1FEC = FF
      when "001111111101101" =>  data <= "11111111";  -- 1FED = FF
      when "001111111101110" =>  data <= "11111111";  -- 1FEE = FF
      when "001111111101111" =>  data <= "11111111";  -- 1FEF = FF
      when "001111111110000" =>  data <= "11111111";  -- 1FF0 = FF
      when "001111111110001" =>  data <= "11111111";  -- 1FF1 = FF
      when "001111111110010" =>  data <= "11111111";  -- 1FF2 = FF
      when "001111111110011" =>  data <= "11111111";  -- 1FF3 = FF
      when "001111111110100" =>  data <= "11111111";  -- 1FF4 = FF
      when "001111111110101" =>  data <= "11111111";  -- 1FF5 = FF
      when "001111111110110" =>  data <= "11111111";  -- 1FF6 = FF
      when "001111111110111" =>  data <= "11111111";  -- 1FF7 = FF
      when "001111111111000" =>  data <= "11111111";  -- 1FF8 = FF
      when "001111111111001" =>  data <= "11111111";  -- 1FF9 = FF
      when "001111111111010" =>  data <= "11111111";  -- 1FFA = FF
      when "001111111111011" =>  data <= "11111111";  -- 1FFB = FF
      when "001111111111100" =>  data <= "11111111";  -- 1FFC = FF
      when "001111111111101" =>  data <= "11111111";  -- 1FFD = FF
      when "001111111111110" =>  data <= "11111111";  -- 1FFE = FF
      when "001111111111111" =>  data <= "11111111";  -- 1FFF = FF
      when "010000000000000" =>  data <= "11111111";  -- 2000 = FF
      when "010000000000001" =>  data <= "11111111";  -- 2001 = FF
      when "010000000000010" =>  data <= "11111111";  -- 2002 = FF
      when "010000000000011" =>  data <= "11111111";  -- 2003 = FF
      when "010000000000100" =>  data <= "11111111";  -- 2004 = FF
      when "010000000000101" =>  data <= "11111111";  -- 2005 = FF
      when "010000000000110" =>  data <= "11111111";  -- 2006 = FF
      when "010000000000111" =>  data <= "11111111";  -- 2007 = FF
      when "010000000001000" =>  data <= "11111111";  -- 2008 = FF
      when "010000000001001" =>  data <= "11111111";  -- 2009 = FF
      when "010000000001010" =>  data <= "11111111";  -- 200A = FF
      when "010000000001011" =>  data <= "11111111";  -- 200B = FF
      when "010000000001100" =>  data <= "11111111";  -- 200C = FF
      when "010000000001101" =>  data <= "11111111";  -- 200D = FF
      when "010000000001110" =>  data <= "11111111";  -- 200E = FF
      when "010000000001111" =>  data <= "11111111";  -- 200F = FF
      when "010000000010000" =>  data <= "11111111";  -- 2010 = FF
      when "010000000010001" =>  data <= "11111111";  -- 2011 = FF
      when "010000000010010" =>  data <= "11111111";  -- 2012 = FF
      when "010000000010011" =>  data <= "11111111";  -- 2013 = FF
      when "010000000010100" =>  data <= "11111111";  -- 2014 = FF
      when "010000000010101" =>  data <= "11111111";  -- 2015 = FF
      when "010000000010110" =>  data <= "11111111";  -- 2016 = FF
      when "010000000010111" =>  data <= "11111111";  -- 2017 = FF
      when "010000000011000" =>  data <= "11111111";  -- 2018 = FF
      when "010000000011001" =>  data <= "11111111";  -- 2019 = FF
      when "010000000011010" =>  data <= "11111111";  -- 201A = FF
      when "010000000011011" =>  data <= "11111111";  -- 201B = FF
      when "010000000011100" =>  data <= "11111111";  -- 201C = FF
      when "010000000011101" =>  data <= "11111111";  -- 201D = FF
      when "010000000011110" =>  data <= "11111111";  -- 201E = FF
      when "010000000011111" =>  data <= "11111111";  -- 201F = FF
      when "010000000100000" =>  data <= "11111111";  -- 2020 = FF
      when "010000000100001" =>  data <= "11111111";  -- 2021 = FF
      when "010000000100010" =>  data <= "11111111";  -- 2022 = FF
      when "010000000100011" =>  data <= "11111111";  -- 2023 = FF
      when "010000000100100" =>  data <= "11111111";  -- 2024 = FF
      when "010000000100101" =>  data <= "11111111";  -- 2025 = FF
      when "010000000100110" =>  data <= "11111111";  -- 2026 = FF
      when "010000000100111" =>  data <= "11111111";  -- 2027 = FF
      when "010000000101000" =>  data <= "11111111";  -- 2028 = FF
      when "010000000101001" =>  data <= "11111111";  -- 2029 = FF
      when "010000000101010" =>  data <= "11111111";  -- 202A = FF
      when "010000000101011" =>  data <= "11111111";  -- 202B = FF
      when "010000000101100" =>  data <= "11111111";  -- 202C = FF
      when "010000000101101" =>  data <= "11111111";  -- 202D = FF
      when "010000000101110" =>  data <= "11111111";  -- 202E = FF
      when "010000000101111" =>  data <= "11111111";  -- 202F = FF
      when "010000000110000" =>  data <= "11111111";  -- 2030 = FF
      when "010000000110001" =>  data <= "11111111";  -- 2031 = FF
      when "010000000110010" =>  data <= "11111111";  -- 2032 = FF
      when "010000000110011" =>  data <= "11111111";  -- 2033 = FF
      when "010000000110100" =>  data <= "11111111";  -- 2034 = FF
      when "010000000110101" =>  data <= "11111111";  -- 2035 = FF
      when "010000000110110" =>  data <= "11111111";  -- 2036 = FF
      when "010000000110111" =>  data <= "11111111";  -- 2037 = FF
      when "010000000111000" =>  data <= "11111111";  -- 2038 = FF
      when "010000000111001" =>  data <= "11111111";  -- 2039 = FF
      when "010000000111010" =>  data <= "11111111";  -- 203A = FF
      when "010000000111011" =>  data <= "11111111";  -- 203B = FF
      when "010000000111100" =>  data <= "11111111";  -- 203C = FF
      when "010000000111101" =>  data <= "11111111";  -- 203D = FF
      when "010000000111110" =>  data <= "11111111";  -- 203E = FF
      when "010000000111111" =>  data <= "11111111";  -- 203F = FF
      when "010000001000000" =>  data <= "11111111";  -- 2040 = FF
      when "010000001000001" =>  data <= "11111111";  -- 2041 = FF
      when "010000001000010" =>  data <= "11111111";  -- 2042 = FF
      when "010000001000011" =>  data <= "11111111";  -- 2043 = FF
      when "010000001000100" =>  data <= "11111111";  -- 2044 = FF
      when "010000001000101" =>  data <= "11111111";  -- 2045 = FF
      when "010000001000110" =>  data <= "11111111";  -- 2046 = FF
      when "010000001000111" =>  data <= "11111111";  -- 2047 = FF
      when "010000001001000" =>  data <= "11111111";  -- 2048 = FF
      when "010000001001001" =>  data <= "11111111";  -- 2049 = FF
      when "010000001001010" =>  data <= "11111111";  -- 204A = FF
      when "010000001001011" =>  data <= "11111111";  -- 204B = FF
      when "010000001001100" =>  data <= "11111111";  -- 204C = FF
      when "010000001001101" =>  data <= "11111111";  -- 204D = FF
      when "010000001001110" =>  data <= "11111111";  -- 204E = FF
      when "010000001001111" =>  data <= "11111111";  -- 204F = FF
      when "010000001010000" =>  data <= "11111111";  -- 2050 = FF
      when "010000001010001" =>  data <= "11111111";  -- 2051 = FF
      when "010000001010010" =>  data <= "11111111";  -- 2052 = FF
      when "010000001010011" =>  data <= "11111111";  -- 2053 = FF
      when "010000001010100" =>  data <= "11111111";  -- 2054 = FF
      when "010000001010101" =>  data <= "11111111";  -- 2055 = FF
      when "010000001010110" =>  data <= "11111111";  -- 2056 = FF
      when "010000001010111" =>  data <= "11111111";  -- 2057 = FF
      when "010000001011000" =>  data <= "11111111";  -- 2058 = FF
      when "010000001011001" =>  data <= "11111111";  -- 2059 = FF
      when "010000001011010" =>  data <= "11111111";  -- 205A = FF
      when "010000001011011" =>  data <= "11111111";  -- 205B = FF
      when "010000001011100" =>  data <= "11111111";  -- 205C = FF
      when "010000001011101" =>  data <= "11111111";  -- 205D = FF
      when "010000001011110" =>  data <= "11111111";  -- 205E = FF
      when "010000001011111" =>  data <= "11111111";  -- 205F = FF
      when "010000001100000" =>  data <= "11111111";  -- 2060 = FF
      when "010000001100001" =>  data <= "11111111";  -- 2061 = FF
      when "010000001100010" =>  data <= "11111111";  -- 2062 = FF
      when "010000001100011" =>  data <= "11111111";  -- 2063 = FF
      when "010000001100100" =>  data <= "11111111";  -- 2064 = FF
      when "010000001100101" =>  data <= "11111111";  -- 2065 = FF
      when "010000001100110" =>  data <= "11111111";  -- 2066 = FF
      when "010000001100111" =>  data <= "11111111";  -- 2067 = FF
      when "010000001101000" =>  data <= "11111111";  -- 2068 = FF
      when "010000001101001" =>  data <= "11111111";  -- 2069 = FF
      when "010000001101010" =>  data <= "11111111";  -- 206A = FF
      when "010000001101011" =>  data <= "11111111";  -- 206B = FF
      when "010000001101100" =>  data <= "11111111";  -- 206C = FF
      when "010000001101101" =>  data <= "11111111";  -- 206D = FF
      when "010000001101110" =>  data <= "11111111";  -- 206E = FF
      when "010000001101111" =>  data <= "11111111";  -- 206F = FF
      when "010000001110000" =>  data <= "11111111";  -- 2070 = FF
      when "010000001110001" =>  data <= "11111111";  -- 2071 = FF
      when "010000001110010" =>  data <= "11111111";  -- 2072 = FF
      when "010000001110011" =>  data <= "11111111";  -- 2073 = FF
      when "010000001110100" =>  data <= "11111111";  -- 2074 = FF
      when "010000001110101" =>  data <= "11111111";  -- 2075 = FF
      when "010000001110110" =>  data <= "11111111";  -- 2076 = FF
      when "010000001110111" =>  data <= "11111111";  -- 2077 = FF
      when "010000001111000" =>  data <= "11111111";  -- 2078 = FF
      when "010000001111001" =>  data <= "11111111";  -- 2079 = FF
      when "010000001111010" =>  data <= "11111111";  -- 207A = FF
      when "010000001111011" =>  data <= "11111111";  -- 207B = FF
      when "010000001111100" =>  data <= "11111111";  -- 207C = FF
      when "010000001111101" =>  data <= "11111111";  -- 207D = FF
      when "010000001111110" =>  data <= "11111111";  -- 207E = FF
      when "010000001111111" =>  data <= "11111111";  -- 207F = FF
      when "010000010000000" =>  data <= "11111111";  -- 2080 = FF
      when "010000010000001" =>  data <= "11111111";  -- 2081 = FF
      when "010000010000010" =>  data <= "11111111";  -- 2082 = FF
      when "010000010000011" =>  data <= "11111111";  -- 2083 = FF
      when "010000010000100" =>  data <= "11111111";  -- 2084 = FF
      when "010000010000101" =>  data <= "11111111";  -- 2085 = FF
      when "010000010000110" =>  data <= "11111111";  -- 2086 = FF
      when "010000010000111" =>  data <= "11111111";  -- 2087 = FF
      when "010000010001000" =>  data <= "11111111";  -- 2088 = FF
      when "010000010001001" =>  data <= "11111111";  -- 2089 = FF
      when "010000010001010" =>  data <= "11111111";  -- 208A = FF
      when "010000010001011" =>  data <= "11111111";  -- 208B = FF
      when "010000010001100" =>  data <= "11111111";  -- 208C = FF
      when "010000010001101" =>  data <= "11111111";  -- 208D = FF
      when "010000010001110" =>  data <= "11111111";  -- 208E = FF
      when "010000010001111" =>  data <= "11111111";  -- 208F = FF
      when "010000010010000" =>  data <= "11111111";  -- 2090 = FF
      when "010000010010001" =>  data <= "11111111";  -- 2091 = FF
      when "010000010010010" =>  data <= "11111111";  -- 2092 = FF
      when "010000010010011" =>  data <= "11111111";  -- 2093 = FF
      when "010000010010100" =>  data <= "11111111";  -- 2094 = FF
      when "010000010010101" =>  data <= "11111111";  -- 2095 = FF
      when "010000010010110" =>  data <= "11111111";  -- 2096 = FF
      when "010000010010111" =>  data <= "11111111";  -- 2097 = FF
      when "010000010011000" =>  data <= "11111111";  -- 2098 = FF
      when "010000010011001" =>  data <= "11111111";  -- 2099 = FF
      when "010000010011010" =>  data <= "11111111";  -- 209A = FF
      when "010000010011011" =>  data <= "11111111";  -- 209B = FF
      when "010000010011100" =>  data <= "11111111";  -- 209C = FF
      when "010000010011101" =>  data <= "11111111";  -- 209D = FF
      when "010000010011110" =>  data <= "11111111";  -- 209E = FF
      when "010000010011111" =>  data <= "11111111";  -- 209F = FF
      when "010000010100000" =>  data <= "11111111";  -- 20A0 = FF
      when "010000010100001" =>  data <= "11111111";  -- 20A1 = FF
      when "010000010100010" =>  data <= "11111111";  -- 20A2 = FF
      when "010000010100011" =>  data <= "11111111";  -- 20A3 = FF
      when "010000010100100" =>  data <= "11111111";  -- 20A4 = FF
      when "010000010100101" =>  data <= "11111111";  -- 20A5 = FF
      when "010000010100110" =>  data <= "11111111";  -- 20A6 = FF
      when "010000010100111" =>  data <= "11111111";  -- 20A7 = FF
      when "010000010101000" =>  data <= "11111111";  -- 20A8 = FF
      when "010000010101001" =>  data <= "11111111";  -- 20A9 = FF
      when "010000010101010" =>  data <= "11111111";  -- 20AA = FF
      when "010000010101011" =>  data <= "11111111";  -- 20AB = FF
      when "010000010101100" =>  data <= "11111111";  -- 20AC = FF
      when "010000010101101" =>  data <= "11111111";  -- 20AD = FF
      when "010000010101110" =>  data <= "11111111";  -- 20AE = FF
      when "010000010101111" =>  data <= "11111111";  -- 20AF = FF
      when "010000010110000" =>  data <= "11111111";  -- 20B0 = FF
      when "010000010110001" =>  data <= "11111111";  -- 20B1 = FF
      when "010000010110010" =>  data <= "11111111";  -- 20B2 = FF
      when "010000010110011" =>  data <= "11111111";  -- 20B3 = FF
      when "010000010110100" =>  data <= "11111111";  -- 20B4 = FF
      when "010000010110101" =>  data <= "11111111";  -- 20B5 = FF
      when "010000010110110" =>  data <= "11111111";  -- 20B6 = FF
      when "010000010110111" =>  data <= "11111111";  -- 20B7 = FF
      when "010000010111000" =>  data <= "11111111";  -- 20B8 = FF
      when "010000010111001" =>  data <= "11111111";  -- 20B9 = FF
      when "010000010111010" =>  data <= "11111111";  -- 20BA = FF
      when "010000010111011" =>  data <= "11111111";  -- 20BB = FF
      when "010000010111100" =>  data <= "11111111";  -- 20BC = FF
      when "010000010111101" =>  data <= "11111111";  -- 20BD = FF
      when "010000010111110" =>  data <= "11111111";  -- 20BE = FF
      when "010000010111111" =>  data <= "11111111";  -- 20BF = FF
      when "010000011000000" =>  data <= "11111111";  -- 20C0 = FF
      when "010000011000001" =>  data <= "11111111";  -- 20C1 = FF
      when "010000011000010" =>  data <= "11111111";  -- 20C2 = FF
      when "010000011000011" =>  data <= "11111111";  -- 20C3 = FF
      when "010000011000100" =>  data <= "11111111";  -- 20C4 = FF
      when "010000011000101" =>  data <= "11111111";  -- 20C5 = FF
      when "010000011000110" =>  data <= "11111111";  -- 20C6 = FF
      when "010000011000111" =>  data <= "11111111";  -- 20C7 = FF
      when "010000011001000" =>  data <= "11111111";  -- 20C8 = FF
      when "010000011001001" =>  data <= "11111111";  -- 20C9 = FF
      when "010000011001010" =>  data <= "11111111";  -- 20CA = FF
      when "010000011001011" =>  data <= "11111111";  -- 20CB = FF
      when "010000011001100" =>  data <= "11111111";  -- 20CC = FF
      when "010000011001101" =>  data <= "11111111";  -- 20CD = FF
      when "010000011001110" =>  data <= "11111111";  -- 20CE = FF
      when "010000011001111" =>  data <= "11111111";  -- 20CF = FF
      when "010000011010000" =>  data <= "11111111";  -- 20D0 = FF
      when "010000011010001" =>  data <= "11111111";  -- 20D1 = FF
      when "010000011010010" =>  data <= "11111111";  -- 20D2 = FF
      when "010000011010011" =>  data <= "11111111";  -- 20D3 = FF
      when "010000011010100" =>  data <= "11111111";  -- 20D4 = FF
      when "010000011010101" =>  data <= "11111111";  -- 20D5 = FF
      when "010000011010110" =>  data <= "11111111";  -- 20D6 = FF
      when "010000011010111" =>  data <= "11111111";  -- 20D7 = FF
      when "010000011011000" =>  data <= "11111111";  -- 20D8 = FF
      when "010000011011001" =>  data <= "11111111";  -- 20D9 = FF
      when "010000011011010" =>  data <= "11111111";  -- 20DA = FF
      when "010000011011011" =>  data <= "11111111";  -- 20DB = FF
      when "010000011011100" =>  data <= "11111111";  -- 20DC = FF
      when "010000011011101" =>  data <= "11111111";  -- 20DD = FF
      when "010000011011110" =>  data <= "11111111";  -- 20DE = FF
      when "010000011011111" =>  data <= "11111111";  -- 20DF = FF
      when "010000011100000" =>  data <= "11111111";  -- 20E0 = FF
      when "010000011100001" =>  data <= "11111111";  -- 20E1 = FF
      when "010000011100010" =>  data <= "11111111";  -- 20E2 = FF
      when "010000011100011" =>  data <= "11111111";  -- 20E3 = FF
      when "010000011100100" =>  data <= "11111111";  -- 20E4 = FF
      when "010000011100101" =>  data <= "11111111";  -- 20E5 = FF
      when "010000011100110" =>  data <= "11111111";  -- 20E6 = FF
      when "010000011100111" =>  data <= "11111111";  -- 20E7 = FF
      when "010000011101000" =>  data <= "11111111";  -- 20E8 = FF
      when "010000011101001" =>  data <= "11111111";  -- 20E9 = FF
      when "010000011101010" =>  data <= "11111111";  -- 20EA = FF
      when "010000011101011" =>  data <= "11111111";  -- 20EB = FF
      when "010000011101100" =>  data <= "11111111";  -- 20EC = FF
      when "010000011101101" =>  data <= "11111111";  -- 20ED = FF
      when "010000011101110" =>  data <= "11111111";  -- 20EE = FF
      when "010000011101111" =>  data <= "11111111";  -- 20EF = FF
      when "010000011110000" =>  data <= "11111111";  -- 20F0 = FF
      when "010000011110001" =>  data <= "11111111";  -- 20F1 = FF
      when "010000011110010" =>  data <= "11111111";  -- 20F2 = FF
      when "010000011110011" =>  data <= "11111111";  -- 20F3 = FF
      when "010000011110100" =>  data <= "11111111";  -- 20F4 = FF
      when "010000011110101" =>  data <= "11111111";  -- 20F5 = FF
      when "010000011110110" =>  data <= "11111111";  -- 20F6 = FF
      when "010000011110111" =>  data <= "11111111";  -- 20F7 = FF
      when "010000011111000" =>  data <= "11111111";  -- 20F8 = FF
      when "010000011111001" =>  data <= "11111111";  -- 20F9 = FF
      when "010000011111010" =>  data <= "11111111";  -- 20FA = FF
      when "010000011111011" =>  data <= "11111111";  -- 20FB = FF
      when "010000011111100" =>  data <= "11111111";  -- 20FC = FF
      when "010000011111101" =>  data <= "11111111";  -- 20FD = FF
      when "010000011111110" =>  data <= "11111111";  -- 20FE = FF
      when "010000011111111" =>  data <= "11111111";  -- 20FF = FF
      when "010000100000000" =>  data <= "11111111";  -- 2100 = FF
      when "010000100000001" =>  data <= "11111111";  -- 2101 = FF
      when "010000100000010" =>  data <= "11111111";  -- 2102 = FF
      when "010000100000011" =>  data <= "11111111";  -- 2103 = FF
      when "010000100000100" =>  data <= "11111111";  -- 2104 = FF
      when "010000100000101" =>  data <= "11111111";  -- 2105 = FF
      when "010000100000110" =>  data <= "11111111";  -- 2106 = FF
      when "010000100000111" =>  data <= "11111111";  -- 2107 = FF
      when "010000100001000" =>  data <= "11111111";  -- 2108 = FF
      when "010000100001001" =>  data <= "11111111";  -- 2109 = FF
      when "010000100001010" =>  data <= "11111111";  -- 210A = FF
      when "010000100001011" =>  data <= "11111111";  -- 210B = FF
      when "010000100001100" =>  data <= "11111111";  -- 210C = FF
      when "010000100001101" =>  data <= "11111111";  -- 210D = FF
      when "010000100001110" =>  data <= "11111111";  -- 210E = FF
      when "010000100001111" =>  data <= "11111111";  -- 210F = FF
      when "010000100010000" =>  data <= "11111111";  -- 2110 = FF
      when "010000100010001" =>  data <= "11111111";  -- 2111 = FF
      when "010000100010010" =>  data <= "11111111";  -- 2112 = FF
      when "010000100010011" =>  data <= "11111111";  -- 2113 = FF
      when "010000100010100" =>  data <= "11111111";  -- 2114 = FF
      when "010000100010101" =>  data <= "11111111";  -- 2115 = FF
      when "010000100010110" =>  data <= "11111111";  -- 2116 = FF
      when "010000100010111" =>  data <= "11111111";  -- 2117 = FF
      when "010000100011000" =>  data <= "11111111";  -- 2118 = FF
      when "010000100011001" =>  data <= "11111111";  -- 2119 = FF
      when "010000100011010" =>  data <= "11111111";  -- 211A = FF
      when "010000100011011" =>  data <= "11111111";  -- 211B = FF
      when "010000100011100" =>  data <= "11111111";  -- 211C = FF
      when "010000100011101" =>  data <= "11111111";  -- 211D = FF
      when "010000100011110" =>  data <= "11111111";  -- 211E = FF
      when "010000100011111" =>  data <= "11111111";  -- 211F = FF
      when "010000100100000" =>  data <= "11111111";  -- 2120 = FF
      when "010000100100001" =>  data <= "11111111";  -- 2121 = FF
      when "010000100100010" =>  data <= "11111111";  -- 2122 = FF
      when "010000100100011" =>  data <= "11111111";  -- 2123 = FF
      when "010000100100100" =>  data <= "11111111";  -- 2124 = FF
      when "010000100100101" =>  data <= "11111111";  -- 2125 = FF
      when "010000100100110" =>  data <= "11111111";  -- 2126 = FF
      when "010000100100111" =>  data <= "11111111";  -- 2127 = FF
      when "010000100101000" =>  data <= "11111111";  -- 2128 = FF
      when "010000100101001" =>  data <= "11111111";  -- 2129 = FF
      when "010000100101010" =>  data <= "11111111";  -- 212A = FF
      when "010000100101011" =>  data <= "11111111";  -- 212B = FF
      when "010000100101100" =>  data <= "11111111";  -- 212C = FF
      when "010000100101101" =>  data <= "11111111";  -- 212D = FF
      when "010000100101110" =>  data <= "11111111";  -- 212E = FF
      when "010000100101111" =>  data <= "11111111";  -- 212F = FF
      when "010000100110000" =>  data <= "11111111";  -- 2130 = FF
      when "010000100110001" =>  data <= "11111111";  -- 2131 = FF
      when "010000100110010" =>  data <= "11111111";  -- 2132 = FF
      when "010000100110011" =>  data <= "11111111";  -- 2133 = FF
      when "010000100110100" =>  data <= "11111111";  -- 2134 = FF
      when "010000100110101" =>  data <= "11111111";  -- 2135 = FF
      when "010000100110110" =>  data <= "11111111";  -- 2136 = FF
      when "010000100110111" =>  data <= "11111111";  -- 2137 = FF
      when "010000100111000" =>  data <= "11111111";  -- 2138 = FF
      when "010000100111001" =>  data <= "11111111";  -- 2139 = FF
      when "010000100111010" =>  data <= "11111111";  -- 213A = FF
      when "010000100111011" =>  data <= "11111111";  -- 213B = FF
      when "010000100111100" =>  data <= "11111111";  -- 213C = FF
      when "010000100111101" =>  data <= "11111111";  -- 213D = FF
      when "010000100111110" =>  data <= "11111111";  -- 213E = FF
      when "010000100111111" =>  data <= "11111111";  -- 213F = FF
      when "010000101000000" =>  data <= "11111111";  -- 2140 = FF
      when "010000101000001" =>  data <= "11111111";  -- 2141 = FF
      when "010000101000010" =>  data <= "11111111";  -- 2142 = FF
      when "010000101000011" =>  data <= "11111111";  -- 2143 = FF
      when "010000101000100" =>  data <= "11111111";  -- 2144 = FF
      when "010000101000101" =>  data <= "11111111";  -- 2145 = FF
      when "010000101000110" =>  data <= "11111111";  -- 2146 = FF
      when "010000101000111" =>  data <= "11111111";  -- 2147 = FF
      when "010000101001000" =>  data <= "11111111";  -- 2148 = FF
      when "010000101001001" =>  data <= "11111111";  -- 2149 = FF
      when "010000101001010" =>  data <= "11111111";  -- 214A = FF
      when "010000101001011" =>  data <= "11111111";  -- 214B = FF
      when "010000101001100" =>  data <= "11111111";  -- 214C = FF
      when "010000101001101" =>  data <= "11111111";  -- 214D = FF
      when "010000101001110" =>  data <= "11111111";  -- 214E = FF
      when "010000101001111" =>  data <= "11111111";  -- 214F = FF
      when "010000101010000" =>  data <= "11111111";  -- 2150 = FF
      when "010000101010001" =>  data <= "11111111";  -- 2151 = FF
      when "010000101010010" =>  data <= "11111111";  -- 2152 = FF
      when "010000101010011" =>  data <= "11111111";  -- 2153 = FF
      when "010000101010100" =>  data <= "11111111";  -- 2154 = FF
      when "010000101010101" =>  data <= "11111111";  -- 2155 = FF
      when "010000101010110" =>  data <= "11111111";  -- 2156 = FF
      when "010000101010111" =>  data <= "11111111";  -- 2157 = FF
      when "010000101011000" =>  data <= "11111111";  -- 2158 = FF
      when "010000101011001" =>  data <= "11111111";  -- 2159 = FF
      when "010000101011010" =>  data <= "11111111";  -- 215A = FF
      when "010000101011011" =>  data <= "11111111";  -- 215B = FF
      when "010000101011100" =>  data <= "11111111";  -- 215C = FF
      when "010000101011101" =>  data <= "11111111";  -- 215D = FF
      when "010000101011110" =>  data <= "11111111";  -- 215E = FF
      when "010000101011111" =>  data <= "11111111";  -- 215F = FF
      when "010000101100000" =>  data <= "11111111";  -- 2160 = FF
      when "010000101100001" =>  data <= "11111111";  -- 2161 = FF
      when "010000101100010" =>  data <= "11111111";  -- 2162 = FF
      when "010000101100011" =>  data <= "11111111";  -- 2163 = FF
      when "010000101100100" =>  data <= "11111111";  -- 2164 = FF
      when "010000101100101" =>  data <= "11111111";  -- 2165 = FF
      when "010000101100110" =>  data <= "11111111";  -- 2166 = FF
      when "010000101100111" =>  data <= "11111111";  -- 2167 = FF
      when "010000101101000" =>  data <= "11111111";  -- 2168 = FF
      when "010000101101001" =>  data <= "11111111";  -- 2169 = FF
      when "010000101101010" =>  data <= "11111111";  -- 216A = FF
      when "010000101101011" =>  data <= "11111111";  -- 216B = FF
      when "010000101101100" =>  data <= "11111111";  -- 216C = FF
      when "010000101101101" =>  data <= "11111111";  -- 216D = FF
      when "010000101101110" =>  data <= "11111111";  -- 216E = FF
      when "010000101101111" =>  data <= "11111111";  -- 216F = FF
      when "010000101110000" =>  data <= "11111111";  -- 2170 = FF
      when "010000101110001" =>  data <= "11111111";  -- 2171 = FF
      when "010000101110010" =>  data <= "11111111";  -- 2172 = FF
      when "010000101110011" =>  data <= "11111111";  -- 2173 = FF
      when "010000101110100" =>  data <= "11111111";  -- 2174 = FF
      when "010000101110101" =>  data <= "11111111";  -- 2175 = FF
      when "010000101110110" =>  data <= "11111111";  -- 2176 = FF
      when "010000101110111" =>  data <= "11111111";  -- 2177 = FF
      when "010000101111000" =>  data <= "11111111";  -- 2178 = FF
      when "010000101111001" =>  data <= "11111111";  -- 2179 = FF
      when "010000101111010" =>  data <= "11111111";  -- 217A = FF
      when "010000101111011" =>  data <= "11111111";  -- 217B = FF
      when "010000101111100" =>  data <= "11111111";  -- 217C = FF
      when "010000101111101" =>  data <= "11111111";  -- 217D = FF
      when "010000101111110" =>  data <= "11111111";  -- 217E = FF
      when "010000101111111" =>  data <= "11111111";  -- 217F = FF
      when "010000110000000" =>  data <= "11111111";  -- 2180 = FF
      when "010000110000001" =>  data <= "11111111";  -- 2181 = FF
      when "010000110000010" =>  data <= "11111111";  -- 2182 = FF
      when "010000110000011" =>  data <= "11111111";  -- 2183 = FF
      when "010000110000100" =>  data <= "11111111";  -- 2184 = FF
      when "010000110000101" =>  data <= "11111111";  -- 2185 = FF
      when "010000110000110" =>  data <= "11111111";  -- 2186 = FF
      when "010000110000111" =>  data <= "11111111";  -- 2187 = FF
      when "010000110001000" =>  data <= "11111111";  -- 2188 = FF
      when "010000110001001" =>  data <= "11111111";  -- 2189 = FF
      when "010000110001010" =>  data <= "11111111";  -- 218A = FF
      when "010000110001011" =>  data <= "11111111";  -- 218B = FF
      when "010000110001100" =>  data <= "11111111";  -- 218C = FF
      when "010000110001101" =>  data <= "11111111";  -- 218D = FF
      when "010000110001110" =>  data <= "11111111";  -- 218E = FF
      when "010000110001111" =>  data <= "11111111";  -- 218F = FF
      when "010000110010000" =>  data <= "11111111";  -- 2190 = FF
      when "010000110010001" =>  data <= "11111111";  -- 2191 = FF
      when "010000110010010" =>  data <= "11111111";  -- 2192 = FF
      when "010000110010011" =>  data <= "11111111";  -- 2193 = FF
      when "010000110010100" =>  data <= "11111111";  -- 2194 = FF
      when "010000110010101" =>  data <= "11111111";  -- 2195 = FF
      when "010000110010110" =>  data <= "11111111";  -- 2196 = FF
      when "010000110010111" =>  data <= "11111111";  -- 2197 = FF
      when "010000110011000" =>  data <= "11111111";  -- 2198 = FF
      when "010000110011001" =>  data <= "11111111";  -- 2199 = FF
      when "010000110011010" =>  data <= "11111111";  -- 219A = FF
      when "010000110011011" =>  data <= "11111111";  -- 219B = FF
      when "010000110011100" =>  data <= "11111111";  -- 219C = FF
      when "010000110011101" =>  data <= "11111111";  -- 219D = FF
      when "010000110011110" =>  data <= "11111111";  -- 219E = FF
      when "010000110011111" =>  data <= "11111111";  -- 219F = FF
      when "010000110100000" =>  data <= "11111111";  -- 21A0 = FF
      when "010000110100001" =>  data <= "11111111";  -- 21A1 = FF
      when "010000110100010" =>  data <= "11111111";  -- 21A2 = FF
      when "010000110100011" =>  data <= "11111111";  -- 21A3 = FF
      when "010000110100100" =>  data <= "11111111";  -- 21A4 = FF
      when "010000110100101" =>  data <= "11111111";  -- 21A5 = FF
      when "010000110100110" =>  data <= "11111111";  -- 21A6 = FF
      when "010000110100111" =>  data <= "11111111";  -- 21A7 = FF
      when "010000110101000" =>  data <= "11111111";  -- 21A8 = FF
      when "010000110101001" =>  data <= "11111111";  -- 21A9 = FF
      when "010000110101010" =>  data <= "11111111";  -- 21AA = FF
      when "010000110101011" =>  data <= "11111111";  -- 21AB = FF
      when "010000110101100" =>  data <= "11111111";  -- 21AC = FF
      when "010000110101101" =>  data <= "11111111";  -- 21AD = FF
      when "010000110101110" =>  data <= "11111111";  -- 21AE = FF
      when "010000110101111" =>  data <= "11111111";  -- 21AF = FF
      when "010000110110000" =>  data <= "11111111";  -- 21B0 = FF
      when "010000110110001" =>  data <= "11111111";  -- 21B1 = FF
      when "010000110110010" =>  data <= "11111111";  -- 21B2 = FF
      when "010000110110011" =>  data <= "11111111";  -- 21B3 = FF
      when "010000110110100" =>  data <= "11111111";  -- 21B4 = FF
      when "010000110110101" =>  data <= "11111111";  -- 21B5 = FF
      when "010000110110110" =>  data <= "11111111";  -- 21B6 = FF
      when "010000110110111" =>  data <= "11111111";  -- 21B7 = FF
      when "010000110111000" =>  data <= "11111111";  -- 21B8 = FF
      when "010000110111001" =>  data <= "11111111";  -- 21B9 = FF
      when "010000110111010" =>  data <= "11111111";  -- 21BA = FF
      when "010000110111011" =>  data <= "11111111";  -- 21BB = FF
      when "010000110111100" =>  data <= "11111111";  -- 21BC = FF
      when "010000110111101" =>  data <= "11111111";  -- 21BD = FF
      when "010000110111110" =>  data <= "11111111";  -- 21BE = FF
      when "010000110111111" =>  data <= "11111111";  -- 21BF = FF
      when "010000111000000" =>  data <= "11111111";  -- 21C0 = FF
      when "010000111000001" =>  data <= "11111111";  -- 21C1 = FF
      when "010000111000010" =>  data <= "11111111";  -- 21C2 = FF
      when "010000111000011" =>  data <= "11111111";  -- 21C3 = FF
      when "010000111000100" =>  data <= "11111111";  -- 21C4 = FF
      when "010000111000101" =>  data <= "11111111";  -- 21C5 = FF
      when "010000111000110" =>  data <= "11111111";  -- 21C6 = FF
      when "010000111000111" =>  data <= "11111111";  -- 21C7 = FF
      when "010000111001000" =>  data <= "11111111";  -- 21C8 = FF
      when "010000111001001" =>  data <= "11111111";  -- 21C9 = FF
      when "010000111001010" =>  data <= "11111111";  -- 21CA = FF
      when "010000111001011" =>  data <= "11111111";  -- 21CB = FF
      when "010000111001100" =>  data <= "11111111";  -- 21CC = FF
      when "010000111001101" =>  data <= "11111111";  -- 21CD = FF
      when "010000111001110" =>  data <= "11111111";  -- 21CE = FF
      when "010000111001111" =>  data <= "11111111";  -- 21CF = FF
      when "010000111010000" =>  data <= "11111111";  -- 21D0 = FF
      when "010000111010001" =>  data <= "11111111";  -- 21D1 = FF
      when "010000111010010" =>  data <= "11111111";  -- 21D2 = FF
      when "010000111010011" =>  data <= "11111111";  -- 21D3 = FF
      when "010000111010100" =>  data <= "11111111";  -- 21D4 = FF
      when "010000111010101" =>  data <= "11111111";  -- 21D5 = FF
      when "010000111010110" =>  data <= "11111111";  -- 21D6 = FF
      when "010000111010111" =>  data <= "11111111";  -- 21D7 = FF
      when "010000111011000" =>  data <= "11111111";  -- 21D8 = FF
      when "010000111011001" =>  data <= "11111111";  -- 21D9 = FF
      when "010000111011010" =>  data <= "11111111";  -- 21DA = FF
      when "010000111011011" =>  data <= "11111111";  -- 21DB = FF
      when "010000111011100" =>  data <= "11111111";  -- 21DC = FF
      when "010000111011101" =>  data <= "11111111";  -- 21DD = FF
      when "010000111011110" =>  data <= "11111111";  -- 21DE = FF
      when "010000111011111" =>  data <= "11111111";  -- 21DF = FF
      when "010000111100000" =>  data <= "11111111";  -- 21E0 = FF
      when "010000111100001" =>  data <= "11111111";  -- 21E1 = FF
      when "010000111100010" =>  data <= "11111111";  -- 21E2 = FF
      when "010000111100011" =>  data <= "11111111";  -- 21E3 = FF
      when "010000111100100" =>  data <= "11111111";  -- 21E4 = FF
      when "010000111100101" =>  data <= "11111111";  -- 21E5 = FF
      when "010000111100110" =>  data <= "11111111";  -- 21E6 = FF
      when "010000111100111" =>  data <= "11111111";  -- 21E7 = FF
      when "010000111101000" =>  data <= "11111111";  -- 21E8 = FF
      when "010000111101001" =>  data <= "11111111";  -- 21E9 = FF
      when "010000111101010" =>  data <= "11111111";  -- 21EA = FF
      when "010000111101011" =>  data <= "11111111";  -- 21EB = FF
      when "010000111101100" =>  data <= "11111111";  -- 21EC = FF
      when "010000111101101" =>  data <= "11111111";  -- 21ED = FF
      when "010000111101110" =>  data <= "11111111";  -- 21EE = FF
      when "010000111101111" =>  data <= "11111111";  -- 21EF = FF
      when "010000111110000" =>  data <= "11111111";  -- 21F0 = FF
      when "010000111110001" =>  data <= "11111111";  -- 21F1 = FF
      when "010000111110010" =>  data <= "11111111";  -- 21F2 = FF
      when "010000111110011" =>  data <= "11111111";  -- 21F3 = FF
      when "010000111110100" =>  data <= "11111111";  -- 21F4 = FF
      when "010000111110101" =>  data <= "11111111";  -- 21F5 = FF
      when "010000111110110" =>  data <= "11111111";  -- 21F6 = FF
      when "010000111110111" =>  data <= "11111111";  -- 21F7 = FF
      when "010000111111000" =>  data <= "11111111";  -- 21F8 = FF
      when "010000111111001" =>  data <= "11111111";  -- 21F9 = FF
      when "010000111111010" =>  data <= "11111111";  -- 21FA = FF
      when "010000111111011" =>  data <= "11111111";  -- 21FB = FF
      when "010000111111100" =>  data <= "11111111";  -- 21FC = FF
      when "010000111111101" =>  data <= "11111111";  -- 21FD = FF
      when "010000111111110" =>  data <= "11111111";  -- 21FE = FF
      when "010000111111111" =>  data <= "11111111";  -- 21FF = FF
      when "010001000000000" =>  data <= "11111111";  -- 2200 = FF
      when "010001000000001" =>  data <= "11111111";  -- 2201 = FF
      when "010001000000010" =>  data <= "11111111";  -- 2202 = FF
      when "010001000000011" =>  data <= "11111111";  -- 2203 = FF
      when "010001000000100" =>  data <= "11111111";  -- 2204 = FF
      when "010001000000101" =>  data <= "11111111";  -- 2205 = FF
      when "010001000000110" =>  data <= "11111111";  -- 2206 = FF
      when "010001000000111" =>  data <= "11111111";  -- 2207 = FF
      when "010001000001000" =>  data <= "11111111";  -- 2208 = FF
      when "010001000001001" =>  data <= "11111111";  -- 2209 = FF
      when "010001000001010" =>  data <= "11111111";  -- 220A = FF
      when "010001000001011" =>  data <= "11111111";  -- 220B = FF
      when "010001000001100" =>  data <= "11111111";  -- 220C = FF
      when "010001000001101" =>  data <= "11111111";  -- 220D = FF
      when "010001000001110" =>  data <= "11111111";  -- 220E = FF
      when "010001000001111" =>  data <= "11111111";  -- 220F = FF
      when "010001000010000" =>  data <= "11111111";  -- 2210 = FF
      when "010001000010001" =>  data <= "11111111";  -- 2211 = FF
      when "010001000010010" =>  data <= "11111111";  -- 2212 = FF
      when "010001000010011" =>  data <= "11111111";  -- 2213 = FF
      when "010001000010100" =>  data <= "11111111";  -- 2214 = FF
      when "010001000010101" =>  data <= "11111111";  -- 2215 = FF
      when "010001000010110" =>  data <= "11111111";  -- 2216 = FF
      when "010001000010111" =>  data <= "11111111";  -- 2217 = FF
      when "010001000011000" =>  data <= "11111111";  -- 2218 = FF
      when "010001000011001" =>  data <= "11111111";  -- 2219 = FF
      when "010001000011010" =>  data <= "11111111";  -- 221A = FF
      when "010001000011011" =>  data <= "11111111";  -- 221B = FF
      when "010001000011100" =>  data <= "11111111";  -- 221C = FF
      when "010001000011101" =>  data <= "11111111";  -- 221D = FF
      when "010001000011110" =>  data <= "11111111";  -- 221E = FF
      when "010001000011111" =>  data <= "11111111";  -- 221F = FF
      when "010001000100000" =>  data <= "11111111";  -- 2220 = FF
      when "010001000100001" =>  data <= "11111111";  -- 2221 = FF
      when "010001000100010" =>  data <= "11111111";  -- 2222 = FF
      when "010001000100011" =>  data <= "11111111";  -- 2223 = FF
      when "010001000100100" =>  data <= "11111111";  -- 2224 = FF
      when "010001000100101" =>  data <= "11111111";  -- 2225 = FF
      when "010001000100110" =>  data <= "11111111";  -- 2226 = FF
      when "010001000100111" =>  data <= "11111111";  -- 2227 = FF
      when "010001000101000" =>  data <= "11111111";  -- 2228 = FF
      when "010001000101001" =>  data <= "11111111";  -- 2229 = FF
      when "010001000101010" =>  data <= "11111111";  -- 222A = FF
      when "010001000101011" =>  data <= "11111111";  -- 222B = FF
      when "010001000101100" =>  data <= "11111111";  -- 222C = FF
      when "010001000101101" =>  data <= "11111111";  -- 222D = FF
      when "010001000101110" =>  data <= "11111111";  -- 222E = FF
      when "010001000101111" =>  data <= "11111111";  -- 222F = FF
      when "010001000110000" =>  data <= "11111111";  -- 2230 = FF
      when "010001000110001" =>  data <= "11111111";  -- 2231 = FF
      when "010001000110010" =>  data <= "11111111";  -- 2232 = FF
      when "010001000110011" =>  data <= "11111111";  -- 2233 = FF
      when "010001000110100" =>  data <= "11111111";  -- 2234 = FF
      when "010001000110101" =>  data <= "11111111";  -- 2235 = FF
      when "010001000110110" =>  data <= "11111111";  -- 2236 = FF
      when "010001000110111" =>  data <= "11111111";  -- 2237 = FF
      when "010001000111000" =>  data <= "11111111";  -- 2238 = FF
      when "010001000111001" =>  data <= "11111111";  -- 2239 = FF
      when "010001000111010" =>  data <= "11111111";  -- 223A = FF
      when "010001000111011" =>  data <= "11111111";  -- 223B = FF
      when "010001000111100" =>  data <= "11111111";  -- 223C = FF
      when "010001000111101" =>  data <= "11111111";  -- 223D = FF
      when "010001000111110" =>  data <= "11111111";  -- 223E = FF
      when "010001000111111" =>  data <= "11111111";  -- 223F = FF
      when "010001001000000" =>  data <= "11111111";  -- 2240 = FF
      when "010001001000001" =>  data <= "11111111";  -- 2241 = FF
      when "010001001000010" =>  data <= "11111111";  -- 2242 = FF
      when "010001001000011" =>  data <= "11111111";  -- 2243 = FF
      when "010001001000100" =>  data <= "11111111";  -- 2244 = FF
      when "010001001000101" =>  data <= "11111111";  -- 2245 = FF
      when "010001001000110" =>  data <= "11111111";  -- 2246 = FF
      when "010001001000111" =>  data <= "11111111";  -- 2247 = FF
      when "010001001001000" =>  data <= "11111111";  -- 2248 = FF
      when "010001001001001" =>  data <= "11111111";  -- 2249 = FF
      when "010001001001010" =>  data <= "11111111";  -- 224A = FF
      when "010001001001011" =>  data <= "11111111";  -- 224B = FF
      when "010001001001100" =>  data <= "11111111";  -- 224C = FF
      when "010001001001101" =>  data <= "11111111";  -- 224D = FF
      when "010001001001110" =>  data <= "11111111";  -- 224E = FF
      when "010001001001111" =>  data <= "11111111";  -- 224F = FF
      when "010001001010000" =>  data <= "11111111";  -- 2250 = FF
      when "010001001010001" =>  data <= "11111111";  -- 2251 = FF
      when "010001001010010" =>  data <= "11111111";  -- 2252 = FF
      when "010001001010011" =>  data <= "11111111";  -- 2253 = FF
      when "010001001010100" =>  data <= "11111111";  -- 2254 = FF
      when "010001001010101" =>  data <= "11111111";  -- 2255 = FF
      when "010001001010110" =>  data <= "11111111";  -- 2256 = FF
      when "010001001010111" =>  data <= "11111111";  -- 2257 = FF
      when "010001001011000" =>  data <= "11111111";  -- 2258 = FF
      when "010001001011001" =>  data <= "11111111";  -- 2259 = FF
      when "010001001011010" =>  data <= "11111111";  -- 225A = FF
      when "010001001011011" =>  data <= "11111111";  -- 225B = FF
      when "010001001011100" =>  data <= "11111111";  -- 225C = FF
      when "010001001011101" =>  data <= "11111111";  -- 225D = FF
      when "010001001011110" =>  data <= "11111111";  -- 225E = FF
      when "010001001011111" =>  data <= "11111111";  -- 225F = FF
      when "010001001100000" =>  data <= "11111111";  -- 2260 = FF
      when "010001001100001" =>  data <= "11111111";  -- 2261 = FF
      when "010001001100010" =>  data <= "11111111";  -- 2262 = FF
      when "010001001100011" =>  data <= "11111111";  -- 2263 = FF
      when "010001001100100" =>  data <= "11111111";  -- 2264 = FF
      when "010001001100101" =>  data <= "11111111";  -- 2265 = FF
      when "010001001100110" =>  data <= "11111111";  -- 2266 = FF
      when "010001001100111" =>  data <= "11111111";  -- 2267 = FF
      when "010001001101000" =>  data <= "11111111";  -- 2268 = FF
      when "010001001101001" =>  data <= "11111111";  -- 2269 = FF
      when "010001001101010" =>  data <= "11111111";  -- 226A = FF
      when "010001001101011" =>  data <= "11111111";  -- 226B = FF
      when "010001001101100" =>  data <= "11111111";  -- 226C = FF
      when "010001001101101" =>  data <= "11111111";  -- 226D = FF
      when "010001001101110" =>  data <= "11111111";  -- 226E = FF
      when "010001001101111" =>  data <= "11111111";  -- 226F = FF
      when "010001001110000" =>  data <= "11111111";  -- 2270 = FF
      when "010001001110001" =>  data <= "11111111";  -- 2271 = FF
      when "010001001110010" =>  data <= "11111111";  -- 2272 = FF
      when "010001001110011" =>  data <= "11111111";  -- 2273 = FF
      when "010001001110100" =>  data <= "11111111";  -- 2274 = FF
      when "010001001110101" =>  data <= "11111111";  -- 2275 = FF
      when "010001001110110" =>  data <= "11111111";  -- 2276 = FF
      when "010001001110111" =>  data <= "11111111";  -- 2277 = FF
      when "010001001111000" =>  data <= "11111111";  -- 2278 = FF
      when "010001001111001" =>  data <= "11111111";  -- 2279 = FF
      when "010001001111010" =>  data <= "11111111";  -- 227A = FF
      when "010001001111011" =>  data <= "11111111";  -- 227B = FF
      when "010001001111100" =>  data <= "11111111";  -- 227C = FF
      when "010001001111101" =>  data <= "11111111";  -- 227D = FF
      when "010001001111110" =>  data <= "11111111";  -- 227E = FF
      when "010001001111111" =>  data <= "11111111";  -- 227F = FF
      when "010001010000000" =>  data <= "11111111";  -- 2280 = FF
      when "010001010000001" =>  data <= "11111111";  -- 2281 = FF
      when "010001010000010" =>  data <= "11111111";  -- 2282 = FF
      when "010001010000011" =>  data <= "11111111";  -- 2283 = FF
      when "010001010000100" =>  data <= "11111111";  -- 2284 = FF
      when "010001010000101" =>  data <= "11111111";  -- 2285 = FF
      when "010001010000110" =>  data <= "11111111";  -- 2286 = FF
      when "010001010000111" =>  data <= "11111111";  -- 2287 = FF
      when "010001010001000" =>  data <= "11111111";  -- 2288 = FF
      when "010001010001001" =>  data <= "11111111";  -- 2289 = FF
      when "010001010001010" =>  data <= "11111111";  -- 228A = FF
      when "010001010001011" =>  data <= "11111111";  -- 228B = FF
      when "010001010001100" =>  data <= "11111111";  -- 228C = FF
      when "010001010001101" =>  data <= "11111111";  -- 228D = FF
      when "010001010001110" =>  data <= "11111111";  -- 228E = FF
      when "010001010001111" =>  data <= "11111111";  -- 228F = FF
      when "010001010010000" =>  data <= "11111111";  -- 2290 = FF
      when "010001010010001" =>  data <= "11111111";  -- 2291 = FF
      when "010001010010010" =>  data <= "11111111";  -- 2292 = FF
      when "010001010010011" =>  data <= "11111111";  -- 2293 = FF
      when "010001010010100" =>  data <= "11111111";  -- 2294 = FF
      when "010001010010101" =>  data <= "11111111";  -- 2295 = FF
      when "010001010010110" =>  data <= "11111111";  -- 2296 = FF
      when "010001010010111" =>  data <= "11111111";  -- 2297 = FF
      when "010001010011000" =>  data <= "11111111";  -- 2298 = FF
      when "010001010011001" =>  data <= "11111111";  -- 2299 = FF
      when "010001010011010" =>  data <= "11111111";  -- 229A = FF
      when "010001010011011" =>  data <= "11111111";  -- 229B = FF
      when "010001010011100" =>  data <= "11111111";  -- 229C = FF
      when "010001010011101" =>  data <= "11111111";  -- 229D = FF
      when "010001010011110" =>  data <= "11111111";  -- 229E = FF
      when "010001010011111" =>  data <= "11111111";  -- 229F = FF
      when "010001010100000" =>  data <= "11111111";  -- 22A0 = FF
      when "010001010100001" =>  data <= "11111111";  -- 22A1 = FF
      when "010001010100010" =>  data <= "11111111";  -- 22A2 = FF
      when "010001010100011" =>  data <= "11111111";  -- 22A3 = FF
      when "010001010100100" =>  data <= "11111111";  -- 22A4 = FF
      when "010001010100101" =>  data <= "11111111";  -- 22A5 = FF
      when "010001010100110" =>  data <= "11111111";  -- 22A6 = FF
      when "010001010100111" =>  data <= "11111111";  -- 22A7 = FF
      when "010001010101000" =>  data <= "11111111";  -- 22A8 = FF
      when "010001010101001" =>  data <= "11111111";  -- 22A9 = FF
      when "010001010101010" =>  data <= "11111111";  -- 22AA = FF
      when "010001010101011" =>  data <= "11111111";  -- 22AB = FF
      when "010001010101100" =>  data <= "11111111";  -- 22AC = FF
      when "010001010101101" =>  data <= "11111111";  -- 22AD = FF
      when "010001010101110" =>  data <= "11111111";  -- 22AE = FF
      when "010001010101111" =>  data <= "11111111";  -- 22AF = FF
      when "010001010110000" =>  data <= "11111111";  -- 22B0 = FF
      when "010001010110001" =>  data <= "11111111";  -- 22B1 = FF
      when "010001010110010" =>  data <= "11111111";  -- 22B2 = FF
      when "010001010110011" =>  data <= "11111111";  -- 22B3 = FF
      when "010001010110100" =>  data <= "11111111";  -- 22B4 = FF
      when "010001010110101" =>  data <= "11111111";  -- 22B5 = FF
      when "010001010110110" =>  data <= "11111111";  -- 22B6 = FF
      when "010001010110111" =>  data <= "11111111";  -- 22B7 = FF
      when "010001010111000" =>  data <= "11111111";  -- 22B8 = FF
      when "010001010111001" =>  data <= "11111111";  -- 22B9 = FF
      when "010001010111010" =>  data <= "11111111";  -- 22BA = FF
      when "010001010111011" =>  data <= "11111111";  -- 22BB = FF
      when "010001010111100" =>  data <= "11111111";  -- 22BC = FF
      when "010001010111101" =>  data <= "11111111";  -- 22BD = FF
      when "010001010111110" =>  data <= "11111111";  -- 22BE = FF
      when "010001010111111" =>  data <= "11111111";  -- 22BF = FF
      when "010001011000000" =>  data <= "11111111";  -- 22C0 = FF
      when "010001011000001" =>  data <= "11111111";  -- 22C1 = FF
      when "010001011000010" =>  data <= "11111111";  -- 22C2 = FF
      when "010001011000011" =>  data <= "11111111";  -- 22C3 = FF
      when "010001011000100" =>  data <= "11111111";  -- 22C4 = FF
      when "010001011000101" =>  data <= "11111111";  -- 22C5 = FF
      when "010001011000110" =>  data <= "11111111";  -- 22C6 = FF
      when "010001011000111" =>  data <= "11111111";  -- 22C7 = FF
      when "010001011001000" =>  data <= "11111111";  -- 22C8 = FF
      when "010001011001001" =>  data <= "11111111";  -- 22C9 = FF
      when "010001011001010" =>  data <= "11111111";  -- 22CA = FF
      when "010001011001011" =>  data <= "11111111";  -- 22CB = FF
      when "010001011001100" =>  data <= "11111111";  -- 22CC = FF
      when "010001011001101" =>  data <= "11111111";  -- 22CD = FF
      when "010001011001110" =>  data <= "11111111";  -- 22CE = FF
      when "010001011001111" =>  data <= "11111111";  -- 22CF = FF
      when "010001011010000" =>  data <= "11111111";  -- 22D0 = FF
      when "010001011010001" =>  data <= "11111111";  -- 22D1 = FF
      when "010001011010010" =>  data <= "11111111";  -- 22D2 = FF
      when "010001011010011" =>  data <= "11111111";  -- 22D3 = FF
      when "010001011010100" =>  data <= "11111111";  -- 22D4 = FF
      when "010001011010101" =>  data <= "11111111";  -- 22D5 = FF
      when "010001011010110" =>  data <= "11111111";  -- 22D6 = FF
      when "010001011010111" =>  data <= "11111111";  -- 22D7 = FF
      when "010001011011000" =>  data <= "11111111";  -- 22D8 = FF
      when "010001011011001" =>  data <= "11111111";  -- 22D9 = FF
      when "010001011011010" =>  data <= "11111111";  -- 22DA = FF
      when "010001011011011" =>  data <= "11111111";  -- 22DB = FF
      when "010001011011100" =>  data <= "11111111";  -- 22DC = FF
      when "010001011011101" =>  data <= "11111111";  -- 22DD = FF
      when "010001011011110" =>  data <= "11111111";  -- 22DE = FF
      when "010001011011111" =>  data <= "11111111";  -- 22DF = FF
      when "010001011100000" =>  data <= "11111111";  -- 22E0 = FF
      when "010001011100001" =>  data <= "11111111";  -- 22E1 = FF
      when "010001011100010" =>  data <= "11111111";  -- 22E2 = FF
      when "010001011100011" =>  data <= "11111111";  -- 22E3 = FF
      when "010001011100100" =>  data <= "11111111";  -- 22E4 = FF
      when "010001011100101" =>  data <= "11111111";  -- 22E5 = FF
      when "010001011100110" =>  data <= "11111111";  -- 22E6 = FF
      when "010001011100111" =>  data <= "11111111";  -- 22E7 = FF
      when "010001011101000" =>  data <= "11111111";  -- 22E8 = FF
      when "010001011101001" =>  data <= "11111111";  -- 22E9 = FF
      when "010001011101010" =>  data <= "11111111";  -- 22EA = FF
      when "010001011101011" =>  data <= "11111111";  -- 22EB = FF
      when "010001011101100" =>  data <= "11111111";  -- 22EC = FF
      when "010001011101101" =>  data <= "11111111";  -- 22ED = FF
      when "010001011101110" =>  data <= "11111111";  -- 22EE = FF
      when "010001011101111" =>  data <= "11111111";  -- 22EF = FF
      when "010001011110000" =>  data <= "11111111";  -- 22F0 = FF
      when "010001011110001" =>  data <= "11111111";  -- 22F1 = FF
      when "010001011110010" =>  data <= "11111111";  -- 22F2 = FF
      when "010001011110011" =>  data <= "11111111";  -- 22F3 = FF
      when "010001011110100" =>  data <= "11111111";  -- 22F4 = FF
      when "010001011110101" =>  data <= "11111111";  -- 22F5 = FF
      when "010001011110110" =>  data <= "11111111";  -- 22F6 = FF
      when "010001011110111" =>  data <= "11111111";  -- 22F7 = FF
      when "010001011111000" =>  data <= "11111111";  -- 22F8 = FF
      when "010001011111001" =>  data <= "11111111";  -- 22F9 = FF
      when "010001011111010" =>  data <= "11111111";  -- 22FA = FF
      when "010001011111011" =>  data <= "11111111";  -- 22FB = FF
      when "010001011111100" =>  data <= "11111111";  -- 22FC = FF
      when "010001011111101" =>  data <= "11111111";  -- 22FD = FF
      when "010001011111110" =>  data <= "11111111";  -- 22FE = FF
      when "010001011111111" =>  data <= "11111111";  -- 22FF = FF
      when "010001100000000" =>  data <= "11111111";  -- 2300 = FF
      when "010001100000001" =>  data <= "11111111";  -- 2301 = FF
      when "010001100000010" =>  data <= "11111111";  -- 2302 = FF
      when "010001100000011" =>  data <= "11111111";  -- 2303 = FF
      when "010001100000100" =>  data <= "11111111";  -- 2304 = FF
      when "010001100000101" =>  data <= "11111111";  -- 2305 = FF
      when "010001100000110" =>  data <= "11111111";  -- 2306 = FF
      when "010001100000111" =>  data <= "11111111";  -- 2307 = FF
      when "010001100001000" =>  data <= "11111111";  -- 2308 = FF
      when "010001100001001" =>  data <= "11111111";  -- 2309 = FF
      when "010001100001010" =>  data <= "11111111";  -- 230A = FF
      when "010001100001011" =>  data <= "11111111";  -- 230B = FF
      when "010001100001100" =>  data <= "11111111";  -- 230C = FF
      when "010001100001101" =>  data <= "11111111";  -- 230D = FF
      when "010001100001110" =>  data <= "11111111";  -- 230E = FF
      when "010001100001111" =>  data <= "11111111";  -- 230F = FF
      when "010001100010000" =>  data <= "11111111";  -- 2310 = FF
      when "010001100010001" =>  data <= "11111111";  -- 2311 = FF
      when "010001100010010" =>  data <= "11111111";  -- 2312 = FF
      when "010001100010011" =>  data <= "11111111";  -- 2313 = FF
      when "010001100010100" =>  data <= "11111111";  -- 2314 = FF
      when "010001100010101" =>  data <= "11111111";  -- 2315 = FF
      when "010001100010110" =>  data <= "11111111";  -- 2316 = FF
      when "010001100010111" =>  data <= "11111111";  -- 2317 = FF
      when "010001100011000" =>  data <= "11111111";  -- 2318 = FF
      when "010001100011001" =>  data <= "11111111";  -- 2319 = FF
      when "010001100011010" =>  data <= "11111111";  -- 231A = FF
      when "010001100011011" =>  data <= "11111111";  -- 231B = FF
      when "010001100011100" =>  data <= "11111111";  -- 231C = FF
      when "010001100011101" =>  data <= "11111111";  -- 231D = FF
      when "010001100011110" =>  data <= "11111111";  -- 231E = FF
      when "010001100011111" =>  data <= "11111111";  -- 231F = FF
      when "010001100100000" =>  data <= "11111111";  -- 2320 = FF
      when "010001100100001" =>  data <= "11111111";  -- 2321 = FF
      when "010001100100010" =>  data <= "11111111";  -- 2322 = FF
      when "010001100100011" =>  data <= "11111111";  -- 2323 = FF
      when "010001100100100" =>  data <= "11111111";  -- 2324 = FF
      when "010001100100101" =>  data <= "11111111";  -- 2325 = FF
      when "010001100100110" =>  data <= "11111111";  -- 2326 = FF
      when "010001100100111" =>  data <= "11111111";  -- 2327 = FF
      when "010001100101000" =>  data <= "11111111";  -- 2328 = FF
      when "010001100101001" =>  data <= "11111111";  -- 2329 = FF
      when "010001100101010" =>  data <= "11111111";  -- 232A = FF
      when "010001100101011" =>  data <= "11111111";  -- 232B = FF
      when "010001100101100" =>  data <= "11111111";  -- 232C = FF
      when "010001100101101" =>  data <= "11111111";  -- 232D = FF
      when "010001100101110" =>  data <= "11111111";  -- 232E = FF
      when "010001100101111" =>  data <= "11111111";  -- 232F = FF
      when "010001100110000" =>  data <= "11111111";  -- 2330 = FF
      when "010001100110001" =>  data <= "11111111";  -- 2331 = FF
      when "010001100110010" =>  data <= "11111111";  -- 2332 = FF
      when "010001100110011" =>  data <= "11111111";  -- 2333 = FF
      when "010001100110100" =>  data <= "11111111";  -- 2334 = FF
      when "010001100110101" =>  data <= "11111111";  -- 2335 = FF
      when "010001100110110" =>  data <= "11111111";  -- 2336 = FF
      when "010001100110111" =>  data <= "11111111";  -- 2337 = FF
      when "010001100111000" =>  data <= "11111111";  -- 2338 = FF
      when "010001100111001" =>  data <= "11111111";  -- 2339 = FF
      when "010001100111010" =>  data <= "11111111";  -- 233A = FF
      when "010001100111011" =>  data <= "11111111";  -- 233B = FF
      when "010001100111100" =>  data <= "11111111";  -- 233C = FF
      when "010001100111101" =>  data <= "11111111";  -- 233D = FF
      when "010001100111110" =>  data <= "11111111";  -- 233E = FF
      when "010001100111111" =>  data <= "11111111";  -- 233F = FF
      when "010001101000000" =>  data <= "11111111";  -- 2340 = FF
      when "010001101000001" =>  data <= "11111111";  -- 2341 = FF
      when "010001101000010" =>  data <= "11111111";  -- 2342 = FF
      when "010001101000011" =>  data <= "11111111";  -- 2343 = FF
      when "010001101000100" =>  data <= "11111111";  -- 2344 = FF
      when "010001101000101" =>  data <= "11111111";  -- 2345 = FF
      when "010001101000110" =>  data <= "11111111";  -- 2346 = FF
      when "010001101000111" =>  data <= "11111111";  -- 2347 = FF
      when "010001101001000" =>  data <= "11111111";  -- 2348 = FF
      when "010001101001001" =>  data <= "11111111";  -- 2349 = FF
      when "010001101001010" =>  data <= "11111111";  -- 234A = FF
      when "010001101001011" =>  data <= "11111111";  -- 234B = FF
      when "010001101001100" =>  data <= "11111111";  -- 234C = FF
      when "010001101001101" =>  data <= "11111111";  -- 234D = FF
      when "010001101001110" =>  data <= "11111111";  -- 234E = FF
      when "010001101001111" =>  data <= "11111111";  -- 234F = FF
      when "010001101010000" =>  data <= "11111111";  -- 2350 = FF
      when "010001101010001" =>  data <= "11111111";  -- 2351 = FF
      when "010001101010010" =>  data <= "11111111";  -- 2352 = FF
      when "010001101010011" =>  data <= "11111111";  -- 2353 = FF
      when "010001101010100" =>  data <= "11111111";  -- 2354 = FF
      when "010001101010101" =>  data <= "11111111";  -- 2355 = FF
      when "010001101010110" =>  data <= "11111111";  -- 2356 = FF
      when "010001101010111" =>  data <= "11111111";  -- 2357 = FF
      when "010001101011000" =>  data <= "11111111";  -- 2358 = FF
      when "010001101011001" =>  data <= "11111111";  -- 2359 = FF
      when "010001101011010" =>  data <= "11111111";  -- 235A = FF
      when "010001101011011" =>  data <= "11111111";  -- 235B = FF
      when "010001101011100" =>  data <= "11111111";  -- 235C = FF
      when "010001101011101" =>  data <= "11111111";  -- 235D = FF
      when "010001101011110" =>  data <= "11111111";  -- 235E = FF
      when "010001101011111" =>  data <= "11111111";  -- 235F = FF
      when "010001101100000" =>  data <= "11111111";  -- 2360 = FF
      when "010001101100001" =>  data <= "11111111";  -- 2361 = FF
      when "010001101100010" =>  data <= "11111111";  -- 2362 = FF
      when "010001101100011" =>  data <= "11111111";  -- 2363 = FF
      when "010001101100100" =>  data <= "11111111";  -- 2364 = FF
      when "010001101100101" =>  data <= "11111111";  -- 2365 = FF
      when "010001101100110" =>  data <= "11111111";  -- 2366 = FF
      when "010001101100111" =>  data <= "11111111";  -- 2367 = FF
      when "010001101101000" =>  data <= "11111111";  -- 2368 = FF
      when "010001101101001" =>  data <= "11111111";  -- 2369 = FF
      when "010001101101010" =>  data <= "11111111";  -- 236A = FF
      when "010001101101011" =>  data <= "11111111";  -- 236B = FF
      when "010001101101100" =>  data <= "11111111";  -- 236C = FF
      when "010001101101101" =>  data <= "11111111";  -- 236D = FF
      when "010001101101110" =>  data <= "11111111";  -- 236E = FF
      when "010001101101111" =>  data <= "11111111";  -- 236F = FF
      when "010001101110000" =>  data <= "11111111";  -- 2370 = FF
      when "010001101110001" =>  data <= "11111111";  -- 2371 = FF
      when "010001101110010" =>  data <= "11111111";  -- 2372 = FF
      when "010001101110011" =>  data <= "11111111";  -- 2373 = FF
      when "010001101110100" =>  data <= "11111111";  -- 2374 = FF
      when "010001101110101" =>  data <= "11111111";  -- 2375 = FF
      when "010001101110110" =>  data <= "11111111";  -- 2376 = FF
      when "010001101110111" =>  data <= "11111111";  -- 2377 = FF
      when "010001101111000" =>  data <= "11111111";  -- 2378 = FF
      when "010001101111001" =>  data <= "11111111";  -- 2379 = FF
      when "010001101111010" =>  data <= "11111111";  -- 237A = FF
      when "010001101111011" =>  data <= "11111111";  -- 237B = FF
      when "010001101111100" =>  data <= "11111111";  -- 237C = FF
      when "010001101111101" =>  data <= "11111111";  -- 237D = FF
      when "010001101111110" =>  data <= "11111111";  -- 237E = FF
      when "010001101111111" =>  data <= "11111111";  -- 237F = FF
      when "010001110000000" =>  data <= "11111111";  -- 2380 = FF
      when "010001110000001" =>  data <= "11111111";  -- 2381 = FF
      when "010001110000010" =>  data <= "11111111";  -- 2382 = FF
      when "010001110000011" =>  data <= "11111111";  -- 2383 = FF
      when "010001110000100" =>  data <= "11111111";  -- 2384 = FF
      when "010001110000101" =>  data <= "11111111";  -- 2385 = FF
      when "010001110000110" =>  data <= "11111111";  -- 2386 = FF
      when "010001110000111" =>  data <= "11111111";  -- 2387 = FF
      when "010001110001000" =>  data <= "11111111";  -- 2388 = FF
      when "010001110001001" =>  data <= "11111111";  -- 2389 = FF
      when "010001110001010" =>  data <= "11111111";  -- 238A = FF
      when "010001110001011" =>  data <= "11111111";  -- 238B = FF
      when "010001110001100" =>  data <= "11111111";  -- 238C = FF
      when "010001110001101" =>  data <= "11111111";  -- 238D = FF
      when "010001110001110" =>  data <= "11111111";  -- 238E = FF
      when "010001110001111" =>  data <= "11111111";  -- 238F = FF
      when "010001110010000" =>  data <= "11111111";  -- 2390 = FF
      when "010001110010001" =>  data <= "11111111";  -- 2391 = FF
      when "010001110010010" =>  data <= "11111111";  -- 2392 = FF
      when "010001110010011" =>  data <= "11111111";  -- 2393 = FF
      when "010001110010100" =>  data <= "11111111";  -- 2394 = FF
      when "010001110010101" =>  data <= "11111111";  -- 2395 = FF
      when "010001110010110" =>  data <= "11111111";  -- 2396 = FF
      when "010001110010111" =>  data <= "11111111";  -- 2397 = FF
      when "010001110011000" =>  data <= "11111111";  -- 2398 = FF
      when "010001110011001" =>  data <= "11111111";  -- 2399 = FF
      when "010001110011010" =>  data <= "11111111";  -- 239A = FF
      when "010001110011011" =>  data <= "11111111";  -- 239B = FF
      when "010001110011100" =>  data <= "11111111";  -- 239C = FF
      when "010001110011101" =>  data <= "11111111";  -- 239D = FF
      when "010001110011110" =>  data <= "11111111";  -- 239E = FF
      when "010001110011111" =>  data <= "11111111";  -- 239F = FF
      when "010001110100000" =>  data <= "11111111";  -- 23A0 = FF
      when "010001110100001" =>  data <= "11111111";  -- 23A1 = FF
      when "010001110100010" =>  data <= "11111111";  -- 23A2 = FF
      when "010001110100011" =>  data <= "11111111";  -- 23A3 = FF
      when "010001110100100" =>  data <= "11111111";  -- 23A4 = FF
      when "010001110100101" =>  data <= "11111111";  -- 23A5 = FF
      when "010001110100110" =>  data <= "11111111";  -- 23A6 = FF
      when "010001110100111" =>  data <= "11111111";  -- 23A7 = FF
      when "010001110101000" =>  data <= "11111111";  -- 23A8 = FF
      when "010001110101001" =>  data <= "11111111";  -- 23A9 = FF
      when "010001110101010" =>  data <= "11111111";  -- 23AA = FF
      when "010001110101011" =>  data <= "11111111";  -- 23AB = FF
      when "010001110101100" =>  data <= "11111111";  -- 23AC = FF
      when "010001110101101" =>  data <= "11111111";  -- 23AD = FF
      when "010001110101110" =>  data <= "11111111";  -- 23AE = FF
      when "010001110101111" =>  data <= "11111111";  -- 23AF = FF
      when "010001110110000" =>  data <= "11111111";  -- 23B0 = FF
      when "010001110110001" =>  data <= "11111111";  -- 23B1 = FF
      when "010001110110010" =>  data <= "11111111";  -- 23B2 = FF
      when "010001110110011" =>  data <= "11111111";  -- 23B3 = FF
      when "010001110110100" =>  data <= "11111111";  -- 23B4 = FF
      when "010001110110101" =>  data <= "11111111";  -- 23B5 = FF
      when "010001110110110" =>  data <= "11111111";  -- 23B6 = FF
      when "010001110110111" =>  data <= "11111111";  -- 23B7 = FF
      when "010001110111000" =>  data <= "11111111";  -- 23B8 = FF
      when "010001110111001" =>  data <= "11111111";  -- 23B9 = FF
      when "010001110111010" =>  data <= "11111111";  -- 23BA = FF
      when "010001110111011" =>  data <= "11111111";  -- 23BB = FF
      when "010001110111100" =>  data <= "11111111";  -- 23BC = FF
      when "010001110111101" =>  data <= "11111111";  -- 23BD = FF
      when "010001110111110" =>  data <= "11111111";  -- 23BE = FF
      when "010001110111111" =>  data <= "11111111";  -- 23BF = FF
      when "010001111000000" =>  data <= "11111111";  -- 23C0 = FF
      when "010001111000001" =>  data <= "11111111";  -- 23C1 = FF
      when "010001111000010" =>  data <= "11111111";  -- 23C2 = FF
      when "010001111000011" =>  data <= "11111111";  -- 23C3 = FF
      when "010001111000100" =>  data <= "11111111";  -- 23C4 = FF
      when "010001111000101" =>  data <= "11111111";  -- 23C5 = FF
      when "010001111000110" =>  data <= "11111111";  -- 23C6 = FF
      when "010001111000111" =>  data <= "11111111";  -- 23C7 = FF
      when "010001111001000" =>  data <= "11111111";  -- 23C8 = FF
      when "010001111001001" =>  data <= "11111111";  -- 23C9 = FF
      when "010001111001010" =>  data <= "11111111";  -- 23CA = FF
      when "010001111001011" =>  data <= "11111111";  -- 23CB = FF
      when "010001111001100" =>  data <= "11111111";  -- 23CC = FF
      when "010001111001101" =>  data <= "11111111";  -- 23CD = FF
      when "010001111001110" =>  data <= "11111111";  -- 23CE = FF
      when "010001111001111" =>  data <= "11111111";  -- 23CF = FF
      when "010001111010000" =>  data <= "11111111";  -- 23D0 = FF
      when "010001111010001" =>  data <= "11111111";  -- 23D1 = FF
      when "010001111010010" =>  data <= "11111111";  -- 23D2 = FF
      when "010001111010011" =>  data <= "11111111";  -- 23D3 = FF
      when "010001111010100" =>  data <= "11111111";  -- 23D4 = FF
      when "010001111010101" =>  data <= "11111111";  -- 23D5 = FF
      when "010001111010110" =>  data <= "11111111";  -- 23D6 = FF
      when "010001111010111" =>  data <= "11111111";  -- 23D7 = FF
      when "010001111011000" =>  data <= "11111111";  -- 23D8 = FF
      when "010001111011001" =>  data <= "11111111";  -- 23D9 = FF
      when "010001111011010" =>  data <= "11111111";  -- 23DA = FF
      when "010001111011011" =>  data <= "11111111";  -- 23DB = FF
      when "010001111011100" =>  data <= "11111111";  -- 23DC = FF
      when "010001111011101" =>  data <= "11111111";  -- 23DD = FF
      when "010001111011110" =>  data <= "11111111";  -- 23DE = FF
      when "010001111011111" =>  data <= "11111111";  -- 23DF = FF
      when "010001111100000" =>  data <= "11111111";  -- 23E0 = FF
      when "010001111100001" =>  data <= "11111111";  -- 23E1 = FF
      when "010001111100010" =>  data <= "11111111";  -- 23E2 = FF
      when "010001111100011" =>  data <= "11111111";  -- 23E3 = FF
      when "010001111100100" =>  data <= "11111111";  -- 23E4 = FF
      when "010001111100101" =>  data <= "11111111";  -- 23E5 = FF
      when "010001111100110" =>  data <= "11111111";  -- 23E6 = FF
      when "010001111100111" =>  data <= "11111111";  -- 23E7 = FF
      when "010001111101000" =>  data <= "11111111";  -- 23E8 = FF
      when "010001111101001" =>  data <= "11111111";  -- 23E9 = FF
      when "010001111101010" =>  data <= "11111111";  -- 23EA = FF
      when "010001111101011" =>  data <= "11111111";  -- 23EB = FF
      when "010001111101100" =>  data <= "11111111";  -- 23EC = FF
      when "010001111101101" =>  data <= "11111111";  -- 23ED = FF
      when "010001111101110" =>  data <= "11111111";  -- 23EE = FF
      when "010001111101111" =>  data <= "11111111";  -- 23EF = FF
      when "010001111110000" =>  data <= "11111111";  -- 23F0 = FF
      when "010001111110001" =>  data <= "11111111";  -- 23F1 = FF
      when "010001111110010" =>  data <= "11111111";  -- 23F2 = FF
      when "010001111110011" =>  data <= "11111111";  -- 23F3 = FF
      when "010001111110100" =>  data <= "11111111";  -- 23F4 = FF
      when "010001111110101" =>  data <= "11111111";  -- 23F5 = FF
      when "010001111110110" =>  data <= "11111111";  -- 23F6 = FF
      when "010001111110111" =>  data <= "11111111";  -- 23F7 = FF
      when "010001111111000" =>  data <= "11111111";  -- 23F8 = FF
      when "010001111111001" =>  data <= "11111111";  -- 23F9 = FF
      when "010001111111010" =>  data <= "11111111";  -- 23FA = FF
      when "010001111111011" =>  data <= "11111111";  -- 23FB = FF
      when "010001111111100" =>  data <= "11111111";  -- 23FC = FF
      when "010001111111101" =>  data <= "11111111";  -- 23FD = FF
      when "010001111111110" =>  data <= "11111111";  -- 23FE = FF
      when "010001111111111" =>  data <= "11111111";  -- 23FF = FF
      when "010010000000000" =>  data <= "11111111";  -- 2400 = FF
      when "010010000000001" =>  data <= "11111111";  -- 2401 = FF
      when "010010000000010" =>  data <= "11111111";  -- 2402 = FF
      when "010010000000011" =>  data <= "11111111";  -- 2403 = FF
      when "010010000000100" =>  data <= "11111111";  -- 2404 = FF
      when "010010000000101" =>  data <= "11111111";  -- 2405 = FF
      when "010010000000110" =>  data <= "11111111";  -- 2406 = FF
      when "010010000000111" =>  data <= "11111111";  -- 2407 = FF
      when "010010000001000" =>  data <= "11111111";  -- 2408 = FF
      when "010010000001001" =>  data <= "11111111";  -- 2409 = FF
      when "010010000001010" =>  data <= "11111111";  -- 240A = FF
      when "010010000001011" =>  data <= "11111111";  -- 240B = FF
      when "010010000001100" =>  data <= "11111111";  -- 240C = FF
      when "010010000001101" =>  data <= "11111111";  -- 240D = FF
      when "010010000001110" =>  data <= "11111111";  -- 240E = FF
      when "010010000001111" =>  data <= "11111111";  -- 240F = FF
      when "010010000010000" =>  data <= "11111111";  -- 2410 = FF
      when "010010000010001" =>  data <= "11111111";  -- 2411 = FF
      when "010010000010010" =>  data <= "11111111";  -- 2412 = FF
      when "010010000010011" =>  data <= "11111111";  -- 2413 = FF
      when "010010000010100" =>  data <= "11111111";  -- 2414 = FF
      when "010010000010101" =>  data <= "11111111";  -- 2415 = FF
      when "010010000010110" =>  data <= "11111111";  -- 2416 = FF
      when "010010000010111" =>  data <= "11111111";  -- 2417 = FF
      when "010010000011000" =>  data <= "11111111";  -- 2418 = FF
      when "010010000011001" =>  data <= "11111111";  -- 2419 = FF
      when "010010000011010" =>  data <= "11111111";  -- 241A = FF
      when "010010000011011" =>  data <= "11111111";  -- 241B = FF
      when "010010000011100" =>  data <= "11111111";  -- 241C = FF
      when "010010000011101" =>  data <= "11111111";  -- 241D = FF
      when "010010000011110" =>  data <= "11111111";  -- 241E = FF
      when "010010000011111" =>  data <= "11111111";  -- 241F = FF
      when "010010000100000" =>  data <= "11111111";  -- 2420 = FF
      when "010010000100001" =>  data <= "11111111";  -- 2421 = FF
      when "010010000100010" =>  data <= "11111111";  -- 2422 = FF
      when "010010000100011" =>  data <= "11111111";  -- 2423 = FF
      when "010010000100100" =>  data <= "11111111";  -- 2424 = FF
      when "010010000100101" =>  data <= "11111111";  -- 2425 = FF
      when "010010000100110" =>  data <= "11111111";  -- 2426 = FF
      when "010010000100111" =>  data <= "11111111";  -- 2427 = FF
      when "010010000101000" =>  data <= "11111111";  -- 2428 = FF
      when "010010000101001" =>  data <= "11111111";  -- 2429 = FF
      when "010010000101010" =>  data <= "11111111";  -- 242A = FF
      when "010010000101011" =>  data <= "11111111";  -- 242B = FF
      when "010010000101100" =>  data <= "11111111";  -- 242C = FF
      when "010010000101101" =>  data <= "11111111";  -- 242D = FF
      when "010010000101110" =>  data <= "11111111";  -- 242E = FF
      when "010010000101111" =>  data <= "11111111";  -- 242F = FF
      when "010010000110000" =>  data <= "11111111";  -- 2430 = FF
      when "010010000110001" =>  data <= "11111111";  -- 2431 = FF
      when "010010000110010" =>  data <= "11111111";  -- 2432 = FF
      when "010010000110011" =>  data <= "11111111";  -- 2433 = FF
      when "010010000110100" =>  data <= "11111111";  -- 2434 = FF
      when "010010000110101" =>  data <= "11111111";  -- 2435 = FF
      when "010010000110110" =>  data <= "11111111";  -- 2436 = FF
      when "010010000110111" =>  data <= "11111111";  -- 2437 = FF
      when "010010000111000" =>  data <= "11111111";  -- 2438 = FF
      when "010010000111001" =>  data <= "11111111";  -- 2439 = FF
      when "010010000111010" =>  data <= "11111111";  -- 243A = FF
      when "010010000111011" =>  data <= "11111111";  -- 243B = FF
      when "010010000111100" =>  data <= "11111111";  -- 243C = FF
      when "010010000111101" =>  data <= "11111111";  -- 243D = FF
      when "010010000111110" =>  data <= "11111111";  -- 243E = FF
      when "010010000111111" =>  data <= "11111111";  -- 243F = FF
      when "010010001000000" =>  data <= "11111111";  -- 2440 = FF
      when "010010001000001" =>  data <= "11111111";  -- 2441 = FF
      when "010010001000010" =>  data <= "11111111";  -- 2442 = FF
      when "010010001000011" =>  data <= "11111111";  -- 2443 = FF
      when "010010001000100" =>  data <= "11111111";  -- 2444 = FF
      when "010010001000101" =>  data <= "11111111";  -- 2445 = FF
      when "010010001000110" =>  data <= "11111111";  -- 2446 = FF
      when "010010001000111" =>  data <= "11111111";  -- 2447 = FF
      when "010010001001000" =>  data <= "11111111";  -- 2448 = FF
      when "010010001001001" =>  data <= "11111111";  -- 2449 = FF
      when "010010001001010" =>  data <= "11111111";  -- 244A = FF
      when "010010001001011" =>  data <= "11111111";  -- 244B = FF
      when "010010001001100" =>  data <= "11111111";  -- 244C = FF
      when "010010001001101" =>  data <= "11111111";  -- 244D = FF
      when "010010001001110" =>  data <= "11111111";  -- 244E = FF
      when "010010001001111" =>  data <= "11111111";  -- 244F = FF
      when "010010001010000" =>  data <= "11111111";  -- 2450 = FF
      when "010010001010001" =>  data <= "11111111";  -- 2451 = FF
      when "010010001010010" =>  data <= "11111111";  -- 2452 = FF
      when "010010001010011" =>  data <= "11111111";  -- 2453 = FF
      when "010010001010100" =>  data <= "11111111";  -- 2454 = FF
      when "010010001010101" =>  data <= "11111111";  -- 2455 = FF
      when "010010001010110" =>  data <= "11111111";  -- 2456 = FF
      when "010010001010111" =>  data <= "11111111";  -- 2457 = FF
      when "010010001011000" =>  data <= "11111111";  -- 2458 = FF
      when "010010001011001" =>  data <= "11111111";  -- 2459 = FF
      when "010010001011010" =>  data <= "11111111";  -- 245A = FF
      when "010010001011011" =>  data <= "11111111";  -- 245B = FF
      when "010010001011100" =>  data <= "11111111";  -- 245C = FF
      when "010010001011101" =>  data <= "11111111";  -- 245D = FF
      when "010010001011110" =>  data <= "11111111";  -- 245E = FF
      when "010010001011111" =>  data <= "11111111";  -- 245F = FF
      when "010010001100000" =>  data <= "11111111";  -- 2460 = FF
      when "010010001100001" =>  data <= "11111111";  -- 2461 = FF
      when "010010001100010" =>  data <= "11111111";  -- 2462 = FF
      when "010010001100011" =>  data <= "11111111";  -- 2463 = FF
      when "010010001100100" =>  data <= "11111111";  -- 2464 = FF
      when "010010001100101" =>  data <= "11111111";  -- 2465 = FF
      when "010010001100110" =>  data <= "11111111";  -- 2466 = FF
      when "010010001100111" =>  data <= "11111111";  -- 2467 = FF
      when "010010001101000" =>  data <= "11111111";  -- 2468 = FF
      when "010010001101001" =>  data <= "11111111";  -- 2469 = FF
      when "010010001101010" =>  data <= "11111111";  -- 246A = FF
      when "010010001101011" =>  data <= "11111111";  -- 246B = FF
      when "010010001101100" =>  data <= "11111111";  -- 246C = FF
      when "010010001101101" =>  data <= "11111111";  -- 246D = FF
      when "010010001101110" =>  data <= "11111111";  -- 246E = FF
      when "010010001101111" =>  data <= "11111111";  -- 246F = FF
      when "010010001110000" =>  data <= "11111111";  -- 2470 = FF
      when "010010001110001" =>  data <= "11111111";  -- 2471 = FF
      when "010010001110010" =>  data <= "11111111";  -- 2472 = FF
      when "010010001110011" =>  data <= "11111111";  -- 2473 = FF
      when "010010001110100" =>  data <= "11111111";  -- 2474 = FF
      when "010010001110101" =>  data <= "11111111";  -- 2475 = FF
      when "010010001110110" =>  data <= "11111111";  -- 2476 = FF
      when "010010001110111" =>  data <= "11111111";  -- 2477 = FF
      when "010010001111000" =>  data <= "11111111";  -- 2478 = FF
      when "010010001111001" =>  data <= "11111111";  -- 2479 = FF
      when "010010001111010" =>  data <= "11111111";  -- 247A = FF
      when "010010001111011" =>  data <= "11111111";  -- 247B = FF
      when "010010001111100" =>  data <= "11111111";  -- 247C = FF
      when "010010001111101" =>  data <= "11111111";  -- 247D = FF
      when "010010001111110" =>  data <= "11111111";  -- 247E = FF
      when "010010001111111" =>  data <= "11111111";  -- 247F = FF
      when "010010010000000" =>  data <= "11111111";  -- 2480 = FF
      when "010010010000001" =>  data <= "11111111";  -- 2481 = FF
      when "010010010000010" =>  data <= "11111111";  -- 2482 = FF
      when "010010010000011" =>  data <= "11111111";  -- 2483 = FF
      when "010010010000100" =>  data <= "11111111";  -- 2484 = FF
      when "010010010000101" =>  data <= "11111111";  -- 2485 = FF
      when "010010010000110" =>  data <= "11111111";  -- 2486 = FF
      when "010010010000111" =>  data <= "11111111";  -- 2487 = FF
      when "010010010001000" =>  data <= "11111111";  -- 2488 = FF
      when "010010010001001" =>  data <= "11111111";  -- 2489 = FF
      when "010010010001010" =>  data <= "11111111";  -- 248A = FF
      when "010010010001011" =>  data <= "11111111";  -- 248B = FF
      when "010010010001100" =>  data <= "11111111";  -- 248C = FF
      when "010010010001101" =>  data <= "11111111";  -- 248D = FF
      when "010010010001110" =>  data <= "11111111";  -- 248E = FF
      when "010010010001111" =>  data <= "11111111";  -- 248F = FF
      when "010010010010000" =>  data <= "11111111";  -- 2490 = FF
      when "010010010010001" =>  data <= "11111111";  -- 2491 = FF
      when "010010010010010" =>  data <= "11111111";  -- 2492 = FF
      when "010010010010011" =>  data <= "11111111";  -- 2493 = FF
      when "010010010010100" =>  data <= "11111111";  -- 2494 = FF
      when "010010010010101" =>  data <= "11111111";  -- 2495 = FF
      when "010010010010110" =>  data <= "11111111";  -- 2496 = FF
      when "010010010010111" =>  data <= "11111111";  -- 2497 = FF
      when "010010010011000" =>  data <= "11111111";  -- 2498 = FF
      when "010010010011001" =>  data <= "11111111";  -- 2499 = FF
      when "010010010011010" =>  data <= "11111111";  -- 249A = FF
      when "010010010011011" =>  data <= "11111111";  -- 249B = FF
      when "010010010011100" =>  data <= "11111111";  -- 249C = FF
      when "010010010011101" =>  data <= "11111111";  -- 249D = FF
      when "010010010011110" =>  data <= "11111111";  -- 249E = FF
      when "010010010011111" =>  data <= "11111111";  -- 249F = FF
      when "010010010100000" =>  data <= "11111111";  -- 24A0 = FF
      when "010010010100001" =>  data <= "11111111";  -- 24A1 = FF
      when "010010010100010" =>  data <= "11111111";  -- 24A2 = FF
      when "010010010100011" =>  data <= "11111111";  -- 24A3 = FF
      when "010010010100100" =>  data <= "11111111";  -- 24A4 = FF
      when "010010010100101" =>  data <= "11111111";  -- 24A5 = FF
      when "010010010100110" =>  data <= "11111111";  -- 24A6 = FF
      when "010010010100111" =>  data <= "11111111";  -- 24A7 = FF
      when "010010010101000" =>  data <= "11111111";  -- 24A8 = FF
      when "010010010101001" =>  data <= "11111111";  -- 24A9 = FF
      when "010010010101010" =>  data <= "11111111";  -- 24AA = FF
      when "010010010101011" =>  data <= "11111111";  -- 24AB = FF
      when "010010010101100" =>  data <= "11111111";  -- 24AC = FF
      when "010010010101101" =>  data <= "11111111";  -- 24AD = FF
      when "010010010101110" =>  data <= "11111111";  -- 24AE = FF
      when "010010010101111" =>  data <= "11111111";  -- 24AF = FF
      when "010010010110000" =>  data <= "11111111";  -- 24B0 = FF
      when "010010010110001" =>  data <= "11111111";  -- 24B1 = FF
      when "010010010110010" =>  data <= "11111111";  -- 24B2 = FF
      when "010010010110011" =>  data <= "11111111";  -- 24B3 = FF
      when "010010010110100" =>  data <= "11111111";  -- 24B4 = FF
      when "010010010110101" =>  data <= "11111111";  -- 24B5 = FF
      when "010010010110110" =>  data <= "11111111";  -- 24B6 = FF
      when "010010010110111" =>  data <= "11111111";  -- 24B7 = FF
      when "010010010111000" =>  data <= "11111111";  -- 24B8 = FF
      when "010010010111001" =>  data <= "11111111";  -- 24B9 = FF
      when "010010010111010" =>  data <= "11111111";  -- 24BA = FF
      when "010010010111011" =>  data <= "11111111";  -- 24BB = FF
      when "010010010111100" =>  data <= "11111111";  -- 24BC = FF
      when "010010010111101" =>  data <= "11111111";  -- 24BD = FF
      when "010010010111110" =>  data <= "11111111";  -- 24BE = FF
      when "010010010111111" =>  data <= "11111111";  -- 24BF = FF
      when "010010011000000" =>  data <= "11111111";  -- 24C0 = FF
      when "010010011000001" =>  data <= "11111111";  -- 24C1 = FF
      when "010010011000010" =>  data <= "11111111";  -- 24C2 = FF
      when "010010011000011" =>  data <= "11111111";  -- 24C3 = FF
      when "010010011000100" =>  data <= "11111111";  -- 24C4 = FF
      when "010010011000101" =>  data <= "11111111";  -- 24C5 = FF
      when "010010011000110" =>  data <= "11111111";  -- 24C6 = FF
      when "010010011000111" =>  data <= "11111111";  -- 24C7 = FF
      when "010010011001000" =>  data <= "11111111";  -- 24C8 = FF
      when "010010011001001" =>  data <= "11111111";  -- 24C9 = FF
      when "010010011001010" =>  data <= "11111111";  -- 24CA = FF
      when "010010011001011" =>  data <= "11111111";  -- 24CB = FF
      when "010010011001100" =>  data <= "11111111";  -- 24CC = FF
      when "010010011001101" =>  data <= "11111111";  -- 24CD = FF
      when "010010011001110" =>  data <= "11111111";  -- 24CE = FF
      when "010010011001111" =>  data <= "11111111";  -- 24CF = FF
      when "010010011010000" =>  data <= "11111111";  -- 24D0 = FF
      when "010010011010001" =>  data <= "11111111";  -- 24D1 = FF
      when "010010011010010" =>  data <= "11111111";  -- 24D2 = FF
      when "010010011010011" =>  data <= "11111111";  -- 24D3 = FF
      when "010010011010100" =>  data <= "11111111";  -- 24D4 = FF
      when "010010011010101" =>  data <= "11111111";  -- 24D5 = FF
      when "010010011010110" =>  data <= "11111111";  -- 24D6 = FF
      when "010010011010111" =>  data <= "11111111";  -- 24D7 = FF
      when "010010011011000" =>  data <= "11111111";  -- 24D8 = FF
      when "010010011011001" =>  data <= "11111111";  -- 24D9 = FF
      when "010010011011010" =>  data <= "11111111";  -- 24DA = FF
      when "010010011011011" =>  data <= "11111111";  -- 24DB = FF
      when "010010011011100" =>  data <= "11111111";  -- 24DC = FF
      when "010010011011101" =>  data <= "11111111";  -- 24DD = FF
      when "010010011011110" =>  data <= "11111111";  -- 24DE = FF
      when "010010011011111" =>  data <= "11111111";  -- 24DF = FF
      when "010010011100000" =>  data <= "11111111";  -- 24E0 = FF
      when "010010011100001" =>  data <= "11111111";  -- 24E1 = FF
      when "010010011100010" =>  data <= "11111111";  -- 24E2 = FF
      when "010010011100011" =>  data <= "11111111";  -- 24E3 = FF
      when "010010011100100" =>  data <= "11111111";  -- 24E4 = FF
      when "010010011100101" =>  data <= "11111111";  -- 24E5 = FF
      when "010010011100110" =>  data <= "11111111";  -- 24E6 = FF
      when "010010011100111" =>  data <= "11111111";  -- 24E7 = FF
      when "010010011101000" =>  data <= "11111111";  -- 24E8 = FF
      when "010010011101001" =>  data <= "11111111";  -- 24E9 = FF
      when "010010011101010" =>  data <= "11111111";  -- 24EA = FF
      when "010010011101011" =>  data <= "11111111";  -- 24EB = FF
      when "010010011101100" =>  data <= "11111111";  -- 24EC = FF
      when "010010011101101" =>  data <= "11111111";  -- 24ED = FF
      when "010010011101110" =>  data <= "11111111";  -- 24EE = FF
      when "010010011101111" =>  data <= "11111111";  -- 24EF = FF
      when "010010011110000" =>  data <= "11111111";  -- 24F0 = FF
      when "010010011110001" =>  data <= "11111111";  -- 24F1 = FF
      when "010010011110010" =>  data <= "11111111";  -- 24F2 = FF
      when "010010011110011" =>  data <= "11111111";  -- 24F3 = FF
      when "010010011110100" =>  data <= "11111111";  -- 24F4 = FF
      when "010010011110101" =>  data <= "11111111";  -- 24F5 = FF
      when "010010011110110" =>  data <= "11111111";  -- 24F6 = FF
      when "010010011110111" =>  data <= "11111111";  -- 24F7 = FF
      when "010010011111000" =>  data <= "11111111";  -- 24F8 = FF
      when "010010011111001" =>  data <= "11111111";  -- 24F9 = FF
      when "010010011111010" =>  data <= "11111111";  -- 24FA = FF
      when "010010011111011" =>  data <= "11111111";  -- 24FB = FF
      when "010010011111100" =>  data <= "11111111";  -- 24FC = FF
      when "010010011111101" =>  data <= "11111111";  -- 24FD = FF
      when "010010011111110" =>  data <= "11111111";  -- 24FE = FF
      when "010010011111111" =>  data <= "11111111";  -- 24FF = FF
      when "010010100000000" =>  data <= "11111111";  -- 2500 = FF
      when "010010100000001" =>  data <= "11111111";  -- 2501 = FF
      when "010010100000010" =>  data <= "11111111";  -- 2502 = FF
      when "010010100000011" =>  data <= "11111111";  -- 2503 = FF
      when "010010100000100" =>  data <= "11111111";  -- 2504 = FF
      when "010010100000101" =>  data <= "11111111";  -- 2505 = FF
      when "010010100000110" =>  data <= "11111111";  -- 2506 = FF
      when "010010100000111" =>  data <= "11111111";  -- 2507 = FF
      when "010010100001000" =>  data <= "11111111";  -- 2508 = FF
      when "010010100001001" =>  data <= "11111111";  -- 2509 = FF
      when "010010100001010" =>  data <= "11111111";  -- 250A = FF
      when "010010100001011" =>  data <= "11111111";  -- 250B = FF
      when "010010100001100" =>  data <= "11111111";  -- 250C = FF
      when "010010100001101" =>  data <= "11111111";  -- 250D = FF
      when "010010100001110" =>  data <= "11111111";  -- 250E = FF
      when "010010100001111" =>  data <= "11111111";  -- 250F = FF
      when "010010100010000" =>  data <= "11111111";  -- 2510 = FF
      when "010010100010001" =>  data <= "11111111";  -- 2511 = FF
      when "010010100010010" =>  data <= "11111111";  -- 2512 = FF
      when "010010100010011" =>  data <= "11111111";  -- 2513 = FF
      when "010010100010100" =>  data <= "11111111";  -- 2514 = FF
      when "010010100010101" =>  data <= "11111111";  -- 2515 = FF
      when "010010100010110" =>  data <= "11111111";  -- 2516 = FF
      when "010010100010111" =>  data <= "11111111";  -- 2517 = FF
      when "010010100011000" =>  data <= "11111111";  -- 2518 = FF
      when "010010100011001" =>  data <= "11111111";  -- 2519 = FF
      when "010010100011010" =>  data <= "11111111";  -- 251A = FF
      when "010010100011011" =>  data <= "11111111";  -- 251B = FF
      when "010010100011100" =>  data <= "11111111";  -- 251C = FF
      when "010010100011101" =>  data <= "11111111";  -- 251D = FF
      when "010010100011110" =>  data <= "11111111";  -- 251E = FF
      when "010010100011111" =>  data <= "11111111";  -- 251F = FF
      when "010010100100000" =>  data <= "11111111";  -- 2520 = FF
      when "010010100100001" =>  data <= "11111111";  -- 2521 = FF
      when "010010100100010" =>  data <= "11111111";  -- 2522 = FF
      when "010010100100011" =>  data <= "11111111";  -- 2523 = FF
      when "010010100100100" =>  data <= "11111111";  -- 2524 = FF
      when "010010100100101" =>  data <= "11111111";  -- 2525 = FF
      when "010010100100110" =>  data <= "11111111";  -- 2526 = FF
      when "010010100100111" =>  data <= "11111111";  -- 2527 = FF
      when "010010100101000" =>  data <= "11111111";  -- 2528 = FF
      when "010010100101001" =>  data <= "11111111";  -- 2529 = FF
      when "010010100101010" =>  data <= "11111111";  -- 252A = FF
      when "010010100101011" =>  data <= "11111111";  -- 252B = FF
      when "010010100101100" =>  data <= "11111111";  -- 252C = FF
      when "010010100101101" =>  data <= "11111111";  -- 252D = FF
      when "010010100101110" =>  data <= "11111111";  -- 252E = FF
      when "010010100101111" =>  data <= "11111111";  -- 252F = FF
      when "010010100110000" =>  data <= "11111111";  -- 2530 = FF
      when "010010100110001" =>  data <= "11111111";  -- 2531 = FF
      when "010010100110010" =>  data <= "11111111";  -- 2532 = FF
      when "010010100110011" =>  data <= "11111111";  -- 2533 = FF
      when "010010100110100" =>  data <= "11111111";  -- 2534 = FF
      when "010010100110101" =>  data <= "11111111";  -- 2535 = FF
      when "010010100110110" =>  data <= "11111111";  -- 2536 = FF
      when "010010100110111" =>  data <= "11111111";  -- 2537 = FF
      when "010010100111000" =>  data <= "11111111";  -- 2538 = FF
      when "010010100111001" =>  data <= "11111111";  -- 2539 = FF
      when "010010100111010" =>  data <= "11111111";  -- 253A = FF
      when "010010100111011" =>  data <= "11111111";  -- 253B = FF
      when "010010100111100" =>  data <= "11111111";  -- 253C = FF
      when "010010100111101" =>  data <= "11111111";  -- 253D = FF
      when "010010100111110" =>  data <= "11111111";  -- 253E = FF
      when "010010100111111" =>  data <= "11111111";  -- 253F = FF
      when "010010101000000" =>  data <= "11111111";  -- 2540 = FF
      when "010010101000001" =>  data <= "11111111";  -- 2541 = FF
      when "010010101000010" =>  data <= "11111111";  -- 2542 = FF
      when "010010101000011" =>  data <= "11111111";  -- 2543 = FF
      when "010010101000100" =>  data <= "11111111";  -- 2544 = FF
      when "010010101000101" =>  data <= "11111111";  -- 2545 = FF
      when "010010101000110" =>  data <= "11111111";  -- 2546 = FF
      when "010010101000111" =>  data <= "11111111";  -- 2547 = FF
      when "010010101001000" =>  data <= "11111111";  -- 2548 = FF
      when "010010101001001" =>  data <= "11111111";  -- 2549 = FF
      when "010010101001010" =>  data <= "11111111";  -- 254A = FF
      when "010010101001011" =>  data <= "11111111";  -- 254B = FF
      when "010010101001100" =>  data <= "11111111";  -- 254C = FF
      when "010010101001101" =>  data <= "11111111";  -- 254D = FF
      when "010010101001110" =>  data <= "11111111";  -- 254E = FF
      when "010010101001111" =>  data <= "11111111";  -- 254F = FF
      when "010010101010000" =>  data <= "11111111";  -- 2550 = FF
      when "010010101010001" =>  data <= "11111111";  -- 2551 = FF
      when "010010101010010" =>  data <= "11111111";  -- 2552 = FF
      when "010010101010011" =>  data <= "11111111";  -- 2553 = FF
      when "010010101010100" =>  data <= "11111111";  -- 2554 = FF
      when "010010101010101" =>  data <= "11111111";  -- 2555 = FF
      when "010010101010110" =>  data <= "11111111";  -- 2556 = FF
      when "010010101010111" =>  data <= "11111111";  -- 2557 = FF
      when "010010101011000" =>  data <= "11111111";  -- 2558 = FF
      when "010010101011001" =>  data <= "11111111";  -- 2559 = FF
      when "010010101011010" =>  data <= "11111111";  -- 255A = FF
      when "010010101011011" =>  data <= "11111111";  -- 255B = FF
      when "010010101011100" =>  data <= "11111111";  -- 255C = FF
      when "010010101011101" =>  data <= "11111111";  -- 255D = FF
      when "010010101011110" =>  data <= "11111111";  -- 255E = FF
      when "010010101011111" =>  data <= "11111111";  -- 255F = FF
      when "010010101100000" =>  data <= "11111111";  -- 2560 = FF
      when "010010101100001" =>  data <= "11111111";  -- 2561 = FF
      when "010010101100010" =>  data <= "11111111";  -- 2562 = FF
      when "010010101100011" =>  data <= "11111111";  -- 2563 = FF
      when "010010101100100" =>  data <= "11111111";  -- 2564 = FF
      when "010010101100101" =>  data <= "11111111";  -- 2565 = FF
      when "010010101100110" =>  data <= "11111111";  -- 2566 = FF
      when "010010101100111" =>  data <= "11111111";  -- 2567 = FF
      when "010010101101000" =>  data <= "11111111";  -- 2568 = FF
      when "010010101101001" =>  data <= "11111111";  -- 2569 = FF
      when "010010101101010" =>  data <= "11111111";  -- 256A = FF
      when "010010101101011" =>  data <= "11111111";  -- 256B = FF
      when "010010101101100" =>  data <= "11111111";  -- 256C = FF
      when "010010101101101" =>  data <= "11111111";  -- 256D = FF
      when "010010101101110" =>  data <= "11111111";  -- 256E = FF
      when "010010101101111" =>  data <= "11111111";  -- 256F = FF
      when "010010101110000" =>  data <= "11111111";  -- 2570 = FF
      when "010010101110001" =>  data <= "11111111";  -- 2571 = FF
      when "010010101110010" =>  data <= "11111111";  -- 2572 = FF
      when "010010101110011" =>  data <= "11111111";  -- 2573 = FF
      when "010010101110100" =>  data <= "11111111";  -- 2574 = FF
      when "010010101110101" =>  data <= "11111111";  -- 2575 = FF
      when "010010101110110" =>  data <= "11111111";  -- 2576 = FF
      when "010010101110111" =>  data <= "11111111";  -- 2577 = FF
      when "010010101111000" =>  data <= "11111111";  -- 2578 = FF
      when "010010101111001" =>  data <= "11111111";  -- 2579 = FF
      when "010010101111010" =>  data <= "11111111";  -- 257A = FF
      when "010010101111011" =>  data <= "11111111";  -- 257B = FF
      when "010010101111100" =>  data <= "11111111";  -- 257C = FF
      when "010010101111101" =>  data <= "11111111";  -- 257D = FF
      when "010010101111110" =>  data <= "11111111";  -- 257E = FF
      when "010010101111111" =>  data <= "11111111";  -- 257F = FF
      when "010010110000000" =>  data <= "11111111";  -- 2580 = FF
      when "010010110000001" =>  data <= "11111111";  -- 2581 = FF
      when "010010110000010" =>  data <= "11111111";  -- 2582 = FF
      when "010010110000011" =>  data <= "11111111";  -- 2583 = FF
      when "010010110000100" =>  data <= "11111111";  -- 2584 = FF
      when "010010110000101" =>  data <= "11111111";  -- 2585 = FF
      when "010010110000110" =>  data <= "11111111";  -- 2586 = FF
      when "010010110000111" =>  data <= "11111111";  -- 2587 = FF
      when "010010110001000" =>  data <= "11111111";  -- 2588 = FF
      when "010010110001001" =>  data <= "11111111";  -- 2589 = FF
      when "010010110001010" =>  data <= "11111111";  -- 258A = FF
      when "010010110001011" =>  data <= "11111111";  -- 258B = FF
      when "010010110001100" =>  data <= "11111111";  -- 258C = FF
      when "010010110001101" =>  data <= "11111111";  -- 258D = FF
      when "010010110001110" =>  data <= "11111111";  -- 258E = FF
      when "010010110001111" =>  data <= "11111111";  -- 258F = FF
      when "010010110010000" =>  data <= "11111111";  -- 2590 = FF
      when "010010110010001" =>  data <= "11111111";  -- 2591 = FF
      when "010010110010010" =>  data <= "11111111";  -- 2592 = FF
      when "010010110010011" =>  data <= "11111111";  -- 2593 = FF
      when "010010110010100" =>  data <= "11111111";  -- 2594 = FF
      when "010010110010101" =>  data <= "11111111";  -- 2595 = FF
      when "010010110010110" =>  data <= "11111111";  -- 2596 = FF
      when "010010110010111" =>  data <= "11111111";  -- 2597 = FF
      when "010010110011000" =>  data <= "11111111";  -- 2598 = FF
      when "010010110011001" =>  data <= "11111111";  -- 2599 = FF
      when "010010110011010" =>  data <= "11111111";  -- 259A = FF
      when "010010110011011" =>  data <= "11111111";  -- 259B = FF
      when "010010110011100" =>  data <= "11111111";  -- 259C = FF
      when "010010110011101" =>  data <= "11111111";  -- 259D = FF
      when "010010110011110" =>  data <= "11111111";  -- 259E = FF
      when "010010110011111" =>  data <= "11111111";  -- 259F = FF
      when "010010110100000" =>  data <= "11111111";  -- 25A0 = FF
      when "010010110100001" =>  data <= "11111111";  -- 25A1 = FF
      when "010010110100010" =>  data <= "11111111";  -- 25A2 = FF
      when "010010110100011" =>  data <= "11111111";  -- 25A3 = FF
      when "010010110100100" =>  data <= "11111111";  -- 25A4 = FF
      when "010010110100101" =>  data <= "11111111";  -- 25A5 = FF
      when "010010110100110" =>  data <= "11111111";  -- 25A6 = FF
      when "010010110100111" =>  data <= "11111111";  -- 25A7 = FF
      when "010010110101000" =>  data <= "11111111";  -- 25A8 = FF
      when "010010110101001" =>  data <= "11111111";  -- 25A9 = FF
      when "010010110101010" =>  data <= "11111111";  -- 25AA = FF
      when "010010110101011" =>  data <= "11111111";  -- 25AB = FF
      when "010010110101100" =>  data <= "11111111";  -- 25AC = FF
      when "010010110101101" =>  data <= "11111111";  -- 25AD = FF
      when "010010110101110" =>  data <= "11111111";  -- 25AE = FF
      when "010010110101111" =>  data <= "11111111";  -- 25AF = FF
      when "010010110110000" =>  data <= "11111111";  -- 25B0 = FF
      when "010010110110001" =>  data <= "11111111";  -- 25B1 = FF
      when "010010110110010" =>  data <= "11111111";  -- 25B2 = FF
      when "010010110110011" =>  data <= "11111111";  -- 25B3 = FF
      when "010010110110100" =>  data <= "11111111";  -- 25B4 = FF
      when "010010110110101" =>  data <= "11111111";  -- 25B5 = FF
      when "010010110110110" =>  data <= "11111111";  -- 25B6 = FF
      when "010010110110111" =>  data <= "11111111";  -- 25B7 = FF
      when "010010110111000" =>  data <= "11111111";  -- 25B8 = FF
      when "010010110111001" =>  data <= "11111111";  -- 25B9 = FF
      when "010010110111010" =>  data <= "11111111";  -- 25BA = FF
      when "010010110111011" =>  data <= "11111111";  -- 25BB = FF
      when "010010110111100" =>  data <= "11111111";  -- 25BC = FF
      when "010010110111101" =>  data <= "11111111";  -- 25BD = FF
      when "010010110111110" =>  data <= "11111111";  -- 25BE = FF
      when "010010110111111" =>  data <= "11111111";  -- 25BF = FF
      when "010010111000000" =>  data <= "11111111";  -- 25C0 = FF
      when "010010111000001" =>  data <= "11111111";  -- 25C1 = FF
      when "010010111000010" =>  data <= "11111111";  -- 25C2 = FF
      when "010010111000011" =>  data <= "11111111";  -- 25C3 = FF
      when "010010111000100" =>  data <= "11111111";  -- 25C4 = FF
      when "010010111000101" =>  data <= "11111111";  -- 25C5 = FF
      when "010010111000110" =>  data <= "11111111";  -- 25C6 = FF
      when "010010111000111" =>  data <= "11111111";  -- 25C7 = FF
      when "010010111001000" =>  data <= "11111111";  -- 25C8 = FF
      when "010010111001001" =>  data <= "11111111";  -- 25C9 = FF
      when "010010111001010" =>  data <= "11111111";  -- 25CA = FF
      when "010010111001011" =>  data <= "11111111";  -- 25CB = FF
      when "010010111001100" =>  data <= "11111111";  -- 25CC = FF
      when "010010111001101" =>  data <= "11111111";  -- 25CD = FF
      when "010010111001110" =>  data <= "11111111";  -- 25CE = FF
      when "010010111001111" =>  data <= "11111111";  -- 25CF = FF
      when "010010111010000" =>  data <= "11111111";  -- 25D0 = FF
      when "010010111010001" =>  data <= "11111111";  -- 25D1 = FF
      when "010010111010010" =>  data <= "11111111";  -- 25D2 = FF
      when "010010111010011" =>  data <= "11111111";  -- 25D3 = FF
      when "010010111010100" =>  data <= "11111111";  -- 25D4 = FF
      when "010010111010101" =>  data <= "11111111";  -- 25D5 = FF
      when "010010111010110" =>  data <= "11111111";  -- 25D6 = FF
      when "010010111010111" =>  data <= "11111111";  -- 25D7 = FF
      when "010010111011000" =>  data <= "11111111";  -- 25D8 = FF
      when "010010111011001" =>  data <= "11111111";  -- 25D9 = FF
      when "010010111011010" =>  data <= "11111111";  -- 25DA = FF
      when "010010111011011" =>  data <= "11111111";  -- 25DB = FF
      when "010010111011100" =>  data <= "11111111";  -- 25DC = FF
      when "010010111011101" =>  data <= "11111111";  -- 25DD = FF
      when "010010111011110" =>  data <= "11111111";  -- 25DE = FF
      when "010010111011111" =>  data <= "11111111";  -- 25DF = FF
      when "010010111100000" =>  data <= "11111111";  -- 25E0 = FF
      when "010010111100001" =>  data <= "11111111";  -- 25E1 = FF
      when "010010111100010" =>  data <= "11111111";  -- 25E2 = FF
      when "010010111100011" =>  data <= "11111111";  -- 25E3 = FF
      when "010010111100100" =>  data <= "11111111";  -- 25E4 = FF
      when "010010111100101" =>  data <= "11111111";  -- 25E5 = FF
      when "010010111100110" =>  data <= "11111111";  -- 25E6 = FF
      when "010010111100111" =>  data <= "11111111";  -- 25E7 = FF
      when "010010111101000" =>  data <= "11111111";  -- 25E8 = FF
      when "010010111101001" =>  data <= "11111111";  -- 25E9 = FF
      when "010010111101010" =>  data <= "11111111";  -- 25EA = FF
      when "010010111101011" =>  data <= "11111111";  -- 25EB = FF
      when "010010111101100" =>  data <= "11111111";  -- 25EC = FF
      when "010010111101101" =>  data <= "11111111";  -- 25ED = FF
      when "010010111101110" =>  data <= "11111111";  -- 25EE = FF
      when "010010111101111" =>  data <= "11111111";  -- 25EF = FF
      when "010010111110000" =>  data <= "11111111";  -- 25F0 = FF
      when "010010111110001" =>  data <= "11111111";  -- 25F1 = FF
      when "010010111110010" =>  data <= "11111111";  -- 25F2 = FF
      when "010010111110011" =>  data <= "11111111";  -- 25F3 = FF
      when "010010111110100" =>  data <= "11111111";  -- 25F4 = FF
      when "010010111110101" =>  data <= "11111111";  -- 25F5 = FF
      when "010010111110110" =>  data <= "11111111";  -- 25F6 = FF
      when "010010111110111" =>  data <= "11111111";  -- 25F7 = FF
      when "010010111111000" =>  data <= "11111111";  -- 25F8 = FF
      when "010010111111001" =>  data <= "11111111";  -- 25F9 = FF
      when "010010111111010" =>  data <= "11111111";  -- 25FA = FF
      when "010010111111011" =>  data <= "11111111";  -- 25FB = FF
      when "010010111111100" =>  data <= "11111111";  -- 25FC = FF
      when "010010111111101" =>  data <= "11111111";  -- 25FD = FF
      when "010010111111110" =>  data <= "11111111";  -- 25FE = FF
      when "010010111111111" =>  data <= "11111111";  -- 25FF = FF
      when "010011000000000" =>  data <= "11111111";  -- 2600 = FF
      when "010011000000001" =>  data <= "11111111";  -- 2601 = FF
      when "010011000000010" =>  data <= "11111111";  -- 2602 = FF
      when "010011000000011" =>  data <= "11111111";  -- 2603 = FF
      when "010011000000100" =>  data <= "11111111";  -- 2604 = FF
      when "010011000000101" =>  data <= "11111111";  -- 2605 = FF
      when "010011000000110" =>  data <= "11111111";  -- 2606 = FF
      when "010011000000111" =>  data <= "11111111";  -- 2607 = FF
      when "010011000001000" =>  data <= "11111111";  -- 2608 = FF
      when "010011000001001" =>  data <= "11111111";  -- 2609 = FF
      when "010011000001010" =>  data <= "11111111";  -- 260A = FF
      when "010011000001011" =>  data <= "11111111";  -- 260B = FF
      when "010011000001100" =>  data <= "11111111";  -- 260C = FF
      when "010011000001101" =>  data <= "11111111";  -- 260D = FF
      when "010011000001110" =>  data <= "11111111";  -- 260E = FF
      when "010011000001111" =>  data <= "11111111";  -- 260F = FF
      when "010011000010000" =>  data <= "11111111";  -- 2610 = FF
      when "010011000010001" =>  data <= "11111111";  -- 2611 = FF
      when "010011000010010" =>  data <= "11111111";  -- 2612 = FF
      when "010011000010011" =>  data <= "11111111";  -- 2613 = FF
      when "010011000010100" =>  data <= "11111111";  -- 2614 = FF
      when "010011000010101" =>  data <= "11111111";  -- 2615 = FF
      when "010011000010110" =>  data <= "11111111";  -- 2616 = FF
      when "010011000010111" =>  data <= "11111111";  -- 2617 = FF
      when "010011000011000" =>  data <= "11111111";  -- 2618 = FF
      when "010011000011001" =>  data <= "11111111";  -- 2619 = FF
      when "010011000011010" =>  data <= "11111111";  -- 261A = FF
      when "010011000011011" =>  data <= "11111111";  -- 261B = FF
      when "010011000011100" =>  data <= "11111111";  -- 261C = FF
      when "010011000011101" =>  data <= "11111111";  -- 261D = FF
      when "010011000011110" =>  data <= "11111111";  -- 261E = FF
      when "010011000011111" =>  data <= "11111111";  -- 261F = FF
      when "010011000100000" =>  data <= "11111111";  -- 2620 = FF
      when "010011000100001" =>  data <= "11111111";  -- 2621 = FF
      when "010011000100010" =>  data <= "11111111";  -- 2622 = FF
      when "010011000100011" =>  data <= "11111111";  -- 2623 = FF
      when "010011000100100" =>  data <= "11111111";  -- 2624 = FF
      when "010011000100101" =>  data <= "11111111";  -- 2625 = FF
      when "010011000100110" =>  data <= "11111111";  -- 2626 = FF
      when "010011000100111" =>  data <= "11111111";  -- 2627 = FF
      when "010011000101000" =>  data <= "11111111";  -- 2628 = FF
      when "010011000101001" =>  data <= "11111111";  -- 2629 = FF
      when "010011000101010" =>  data <= "11111111";  -- 262A = FF
      when "010011000101011" =>  data <= "11111111";  -- 262B = FF
      when "010011000101100" =>  data <= "11111111";  -- 262C = FF
      when "010011000101101" =>  data <= "11111111";  -- 262D = FF
      when "010011000101110" =>  data <= "11111111";  -- 262E = FF
      when "010011000101111" =>  data <= "11111111";  -- 262F = FF
      when "010011000110000" =>  data <= "11111111";  -- 2630 = FF
      when "010011000110001" =>  data <= "11111111";  -- 2631 = FF
      when "010011000110010" =>  data <= "11111111";  -- 2632 = FF
      when "010011000110011" =>  data <= "11111111";  -- 2633 = FF
      when "010011000110100" =>  data <= "11111111";  -- 2634 = FF
      when "010011000110101" =>  data <= "11111111";  -- 2635 = FF
      when "010011000110110" =>  data <= "11111111";  -- 2636 = FF
      when "010011000110111" =>  data <= "11111111";  -- 2637 = FF
      when "010011000111000" =>  data <= "11111111";  -- 2638 = FF
      when "010011000111001" =>  data <= "11111111";  -- 2639 = FF
      when "010011000111010" =>  data <= "11111111";  -- 263A = FF
      when "010011000111011" =>  data <= "11111111";  -- 263B = FF
      when "010011000111100" =>  data <= "11111111";  -- 263C = FF
      when "010011000111101" =>  data <= "11111111";  -- 263D = FF
      when "010011000111110" =>  data <= "11111111";  -- 263E = FF
      when "010011000111111" =>  data <= "11111111";  -- 263F = FF
      when "010011001000000" =>  data <= "11111111";  -- 2640 = FF
      when "010011001000001" =>  data <= "11111111";  -- 2641 = FF
      when "010011001000010" =>  data <= "11111111";  -- 2642 = FF
      when "010011001000011" =>  data <= "11111111";  -- 2643 = FF
      when "010011001000100" =>  data <= "11111111";  -- 2644 = FF
      when "010011001000101" =>  data <= "11111111";  -- 2645 = FF
      when "010011001000110" =>  data <= "11111111";  -- 2646 = FF
      when "010011001000111" =>  data <= "11111111";  -- 2647 = FF
      when "010011001001000" =>  data <= "11111111";  -- 2648 = FF
      when "010011001001001" =>  data <= "11111111";  -- 2649 = FF
      when "010011001001010" =>  data <= "11111111";  -- 264A = FF
      when "010011001001011" =>  data <= "11111111";  -- 264B = FF
      when "010011001001100" =>  data <= "11111111";  -- 264C = FF
      when "010011001001101" =>  data <= "11111111";  -- 264D = FF
      when "010011001001110" =>  data <= "11111111";  -- 264E = FF
      when "010011001001111" =>  data <= "11111111";  -- 264F = FF
      when "010011001010000" =>  data <= "11111111";  -- 2650 = FF
      when "010011001010001" =>  data <= "11111111";  -- 2651 = FF
      when "010011001010010" =>  data <= "11111111";  -- 2652 = FF
      when "010011001010011" =>  data <= "11111111";  -- 2653 = FF
      when "010011001010100" =>  data <= "11111111";  -- 2654 = FF
      when "010011001010101" =>  data <= "11111111";  -- 2655 = FF
      when "010011001010110" =>  data <= "11111111";  -- 2656 = FF
      when "010011001010111" =>  data <= "11111111";  -- 2657 = FF
      when "010011001011000" =>  data <= "11111111";  -- 2658 = FF
      when "010011001011001" =>  data <= "11111111";  -- 2659 = FF
      when "010011001011010" =>  data <= "11111111";  -- 265A = FF
      when "010011001011011" =>  data <= "11111111";  -- 265B = FF
      when "010011001011100" =>  data <= "11111111";  -- 265C = FF
      when "010011001011101" =>  data <= "11111111";  -- 265D = FF
      when "010011001011110" =>  data <= "11111111";  -- 265E = FF
      when "010011001011111" =>  data <= "11111111";  -- 265F = FF
      when "010011001100000" =>  data <= "11111111";  -- 2660 = FF
      when "010011001100001" =>  data <= "11111111";  -- 2661 = FF
      when "010011001100010" =>  data <= "11111111";  -- 2662 = FF
      when "010011001100011" =>  data <= "11111111";  -- 2663 = FF
      when "010011001100100" =>  data <= "11111111";  -- 2664 = FF
      when "010011001100101" =>  data <= "11111111";  -- 2665 = FF
      when "010011001100110" =>  data <= "11111111";  -- 2666 = FF
      when "010011001100111" =>  data <= "11111111";  -- 2667 = FF
      when "010011001101000" =>  data <= "11111111";  -- 2668 = FF
      when "010011001101001" =>  data <= "11111111";  -- 2669 = FF
      when "010011001101010" =>  data <= "11111111";  -- 266A = FF
      when "010011001101011" =>  data <= "11111111";  -- 266B = FF
      when "010011001101100" =>  data <= "11111111";  -- 266C = FF
      when "010011001101101" =>  data <= "11111111";  -- 266D = FF
      when "010011001101110" =>  data <= "11111111";  -- 266E = FF
      when "010011001101111" =>  data <= "11111111";  -- 266F = FF
      when "010011001110000" =>  data <= "11111111";  -- 2670 = FF
      when "010011001110001" =>  data <= "11111111";  -- 2671 = FF
      when "010011001110010" =>  data <= "11111111";  -- 2672 = FF
      when "010011001110011" =>  data <= "11111111";  -- 2673 = FF
      when "010011001110100" =>  data <= "11111111";  -- 2674 = FF
      when "010011001110101" =>  data <= "11111111";  -- 2675 = FF
      when "010011001110110" =>  data <= "11111111";  -- 2676 = FF
      when "010011001110111" =>  data <= "11111111";  -- 2677 = FF
      when "010011001111000" =>  data <= "11111111";  -- 2678 = FF
      when "010011001111001" =>  data <= "11111111";  -- 2679 = FF
      when "010011001111010" =>  data <= "11111111";  -- 267A = FF
      when "010011001111011" =>  data <= "11111111";  -- 267B = FF
      when "010011001111100" =>  data <= "11111111";  -- 267C = FF
      when "010011001111101" =>  data <= "11111111";  -- 267D = FF
      when "010011001111110" =>  data <= "11111111";  -- 267E = FF
      when "010011001111111" =>  data <= "11111111";  -- 267F = FF
      when "010011010000000" =>  data <= "11111111";  -- 2680 = FF
      when "010011010000001" =>  data <= "11111111";  -- 2681 = FF
      when "010011010000010" =>  data <= "11111111";  -- 2682 = FF
      when "010011010000011" =>  data <= "11111111";  -- 2683 = FF
      when "010011010000100" =>  data <= "11111111";  -- 2684 = FF
      when "010011010000101" =>  data <= "11111111";  -- 2685 = FF
      when "010011010000110" =>  data <= "11111111";  -- 2686 = FF
      when "010011010000111" =>  data <= "11111111";  -- 2687 = FF
      when "010011010001000" =>  data <= "11111111";  -- 2688 = FF
      when "010011010001001" =>  data <= "11111111";  -- 2689 = FF
      when "010011010001010" =>  data <= "11111111";  -- 268A = FF
      when "010011010001011" =>  data <= "11111111";  -- 268B = FF
      when "010011010001100" =>  data <= "11111111";  -- 268C = FF
      when "010011010001101" =>  data <= "11111111";  -- 268D = FF
      when "010011010001110" =>  data <= "11111111";  -- 268E = FF
      when "010011010001111" =>  data <= "11111111";  -- 268F = FF
      when "010011010010000" =>  data <= "11111111";  -- 2690 = FF
      when "010011010010001" =>  data <= "11111111";  -- 2691 = FF
      when "010011010010010" =>  data <= "11111111";  -- 2692 = FF
      when "010011010010011" =>  data <= "11111111";  -- 2693 = FF
      when "010011010010100" =>  data <= "11111111";  -- 2694 = FF
      when "010011010010101" =>  data <= "11111111";  -- 2695 = FF
      when "010011010010110" =>  data <= "11111111";  -- 2696 = FF
      when "010011010010111" =>  data <= "11111111";  -- 2697 = FF
      when "010011010011000" =>  data <= "11111111";  -- 2698 = FF
      when "010011010011001" =>  data <= "11111111";  -- 2699 = FF
      when "010011010011010" =>  data <= "11111111";  -- 269A = FF
      when "010011010011011" =>  data <= "11111111";  -- 269B = FF
      when "010011010011100" =>  data <= "11111111";  -- 269C = FF
      when "010011010011101" =>  data <= "11111111";  -- 269D = FF
      when "010011010011110" =>  data <= "11111111";  -- 269E = FF
      when "010011010011111" =>  data <= "11111111";  -- 269F = FF
      when "010011010100000" =>  data <= "11111111";  -- 26A0 = FF
      when "010011010100001" =>  data <= "11111111";  -- 26A1 = FF
      when "010011010100010" =>  data <= "11111111";  -- 26A2 = FF
      when "010011010100011" =>  data <= "11111111";  -- 26A3 = FF
      when "010011010100100" =>  data <= "11111111";  -- 26A4 = FF
      when "010011010100101" =>  data <= "11111111";  -- 26A5 = FF
      when "010011010100110" =>  data <= "11111111";  -- 26A6 = FF
      when "010011010100111" =>  data <= "11111111";  -- 26A7 = FF
      when "010011010101000" =>  data <= "11111111";  -- 26A8 = FF
      when "010011010101001" =>  data <= "11111111";  -- 26A9 = FF
      when "010011010101010" =>  data <= "11111111";  -- 26AA = FF
      when "010011010101011" =>  data <= "11111111";  -- 26AB = FF
      when "010011010101100" =>  data <= "11111111";  -- 26AC = FF
      when "010011010101101" =>  data <= "11111111";  -- 26AD = FF
      when "010011010101110" =>  data <= "11111111";  -- 26AE = FF
      when "010011010101111" =>  data <= "11111111";  -- 26AF = FF
      when "010011010110000" =>  data <= "11111111";  -- 26B0 = FF
      when "010011010110001" =>  data <= "11111111";  -- 26B1 = FF
      when "010011010110010" =>  data <= "11111111";  -- 26B2 = FF
      when "010011010110011" =>  data <= "11111111";  -- 26B3 = FF
      when "010011010110100" =>  data <= "11111111";  -- 26B4 = FF
      when "010011010110101" =>  data <= "11111111";  -- 26B5 = FF
      when "010011010110110" =>  data <= "11111111";  -- 26B6 = FF
      when "010011010110111" =>  data <= "11111111";  -- 26B7 = FF
      when "010011010111000" =>  data <= "11111111";  -- 26B8 = FF
      when "010011010111001" =>  data <= "11111111";  -- 26B9 = FF
      when "010011010111010" =>  data <= "11111111";  -- 26BA = FF
      when "010011010111011" =>  data <= "11111111";  -- 26BB = FF
      when "010011010111100" =>  data <= "11111111";  -- 26BC = FF
      when "010011010111101" =>  data <= "11111111";  -- 26BD = FF
      when "010011010111110" =>  data <= "11111111";  -- 26BE = FF
      when "010011010111111" =>  data <= "11111111";  -- 26BF = FF
      when "010011011000000" =>  data <= "11111111";  -- 26C0 = FF
      when "010011011000001" =>  data <= "11111111";  -- 26C1 = FF
      when "010011011000010" =>  data <= "11111111";  -- 26C2 = FF
      when "010011011000011" =>  data <= "11111111";  -- 26C3 = FF
      when "010011011000100" =>  data <= "11111111";  -- 26C4 = FF
      when "010011011000101" =>  data <= "11111111";  -- 26C5 = FF
      when "010011011000110" =>  data <= "11111111";  -- 26C6 = FF
      when "010011011000111" =>  data <= "11111111";  -- 26C7 = FF
      when "010011011001000" =>  data <= "11111111";  -- 26C8 = FF
      when "010011011001001" =>  data <= "11111111";  -- 26C9 = FF
      when "010011011001010" =>  data <= "11111111";  -- 26CA = FF
      when "010011011001011" =>  data <= "11111111";  -- 26CB = FF
      when "010011011001100" =>  data <= "11111111";  -- 26CC = FF
      when "010011011001101" =>  data <= "11111111";  -- 26CD = FF
      when "010011011001110" =>  data <= "11111111";  -- 26CE = FF
      when "010011011001111" =>  data <= "11111111";  -- 26CF = FF
      when "010011011010000" =>  data <= "11111111";  -- 26D0 = FF
      when "010011011010001" =>  data <= "11111111";  -- 26D1 = FF
      when "010011011010010" =>  data <= "11111111";  -- 26D2 = FF
      when "010011011010011" =>  data <= "11111111";  -- 26D3 = FF
      when "010011011010100" =>  data <= "11111111";  -- 26D4 = FF
      when "010011011010101" =>  data <= "11111111";  -- 26D5 = FF
      when "010011011010110" =>  data <= "11111111";  -- 26D6 = FF
      when "010011011010111" =>  data <= "11111111";  -- 26D7 = FF
      when "010011011011000" =>  data <= "11111111";  -- 26D8 = FF
      when "010011011011001" =>  data <= "11111111";  -- 26D9 = FF
      when "010011011011010" =>  data <= "11111111";  -- 26DA = FF
      when "010011011011011" =>  data <= "11111111";  -- 26DB = FF
      when "010011011011100" =>  data <= "11111111";  -- 26DC = FF
      when "010011011011101" =>  data <= "11111111";  -- 26DD = FF
      when "010011011011110" =>  data <= "11111111";  -- 26DE = FF
      when "010011011011111" =>  data <= "11111111";  -- 26DF = FF
      when "010011011100000" =>  data <= "11111111";  -- 26E0 = FF
      when "010011011100001" =>  data <= "11111111";  -- 26E1 = FF
      when "010011011100010" =>  data <= "11111111";  -- 26E2 = FF
      when "010011011100011" =>  data <= "11111111";  -- 26E3 = FF
      when "010011011100100" =>  data <= "11111111";  -- 26E4 = FF
      when "010011011100101" =>  data <= "11111111";  -- 26E5 = FF
      when "010011011100110" =>  data <= "11111111";  -- 26E6 = FF
      when "010011011100111" =>  data <= "11111111";  -- 26E7 = FF
      when "010011011101000" =>  data <= "11111111";  -- 26E8 = FF
      when "010011011101001" =>  data <= "11111111";  -- 26E9 = FF
      when "010011011101010" =>  data <= "11111111";  -- 26EA = FF
      when "010011011101011" =>  data <= "11111111";  -- 26EB = FF
      when "010011011101100" =>  data <= "11111111";  -- 26EC = FF
      when "010011011101101" =>  data <= "11111111";  -- 26ED = FF
      when "010011011101110" =>  data <= "11111111";  -- 26EE = FF
      when "010011011101111" =>  data <= "11111111";  -- 26EF = FF
      when "010011011110000" =>  data <= "11111111";  -- 26F0 = FF
      when "010011011110001" =>  data <= "11111111";  -- 26F1 = FF
      when "010011011110010" =>  data <= "11111111";  -- 26F2 = FF
      when "010011011110011" =>  data <= "11111111";  -- 26F3 = FF
      when "010011011110100" =>  data <= "11111111";  -- 26F4 = FF
      when "010011011110101" =>  data <= "11111111";  -- 26F5 = FF
      when "010011011110110" =>  data <= "11111111";  -- 26F6 = FF
      when "010011011110111" =>  data <= "11111111";  -- 26F7 = FF
      when "010011011111000" =>  data <= "11111111";  -- 26F8 = FF
      when "010011011111001" =>  data <= "11111111";  -- 26F9 = FF
      when "010011011111010" =>  data <= "11111111";  -- 26FA = FF
      when "010011011111011" =>  data <= "11111111";  -- 26FB = FF
      when "010011011111100" =>  data <= "11111111";  -- 26FC = FF
      when "010011011111101" =>  data <= "11111111";  -- 26FD = FF
      when "010011011111110" =>  data <= "11111111";  -- 26FE = FF
      when "010011011111111" =>  data <= "11111111";  -- 26FF = FF
      when "010011100000000" =>  data <= "11111111";  -- 2700 = FF
      when "010011100000001" =>  data <= "11111111";  -- 2701 = FF
      when "010011100000010" =>  data <= "11111111";  -- 2702 = FF
      when "010011100000011" =>  data <= "11111111";  -- 2703 = FF
      when "010011100000100" =>  data <= "11111111";  -- 2704 = FF
      when "010011100000101" =>  data <= "11111111";  -- 2705 = FF
      when "010011100000110" =>  data <= "11111111";  -- 2706 = FF
      when "010011100000111" =>  data <= "11111111";  -- 2707 = FF
      when "010011100001000" =>  data <= "11111111";  -- 2708 = FF
      when "010011100001001" =>  data <= "11111111";  -- 2709 = FF
      when "010011100001010" =>  data <= "11111111";  -- 270A = FF
      when "010011100001011" =>  data <= "11111111";  -- 270B = FF
      when "010011100001100" =>  data <= "11111111";  -- 270C = FF
      when "010011100001101" =>  data <= "11111111";  -- 270D = FF
      when "010011100001110" =>  data <= "11111111";  -- 270E = FF
      when "010011100001111" =>  data <= "11111111";  -- 270F = FF
      when "010011100010000" =>  data <= "11111111";  -- 2710 = FF
      when "010011100010001" =>  data <= "11111111";  -- 2711 = FF
      when "010011100010010" =>  data <= "11111111";  -- 2712 = FF
      when "010011100010011" =>  data <= "11111111";  -- 2713 = FF
      when "010011100010100" =>  data <= "11111111";  -- 2714 = FF
      when "010011100010101" =>  data <= "11111111";  -- 2715 = FF
      when "010011100010110" =>  data <= "11111111";  -- 2716 = FF
      when "010011100010111" =>  data <= "11111111";  -- 2717 = FF
      when "010011100011000" =>  data <= "11111111";  -- 2718 = FF
      when "010011100011001" =>  data <= "11111111";  -- 2719 = FF
      when "010011100011010" =>  data <= "11111111";  -- 271A = FF
      when "010011100011011" =>  data <= "11111111";  -- 271B = FF
      when "010011100011100" =>  data <= "11111111";  -- 271C = FF
      when "010011100011101" =>  data <= "11111111";  -- 271D = FF
      when "010011100011110" =>  data <= "11111111";  -- 271E = FF
      when "010011100011111" =>  data <= "11111111";  -- 271F = FF
      when "010011100100000" =>  data <= "11111111";  -- 2720 = FF
      when "010011100100001" =>  data <= "11111111";  -- 2721 = FF
      when "010011100100010" =>  data <= "11111111";  -- 2722 = FF
      when "010011100100011" =>  data <= "11111111";  -- 2723 = FF
      when "010011100100100" =>  data <= "11111111";  -- 2724 = FF
      when "010011100100101" =>  data <= "11111111";  -- 2725 = FF
      when "010011100100110" =>  data <= "11111111";  -- 2726 = FF
      when "010011100100111" =>  data <= "11111111";  -- 2727 = FF
      when "010011100101000" =>  data <= "11111111";  -- 2728 = FF
      when "010011100101001" =>  data <= "11111111";  -- 2729 = FF
      when "010011100101010" =>  data <= "11111111";  -- 272A = FF
      when "010011100101011" =>  data <= "11111111";  -- 272B = FF
      when "010011100101100" =>  data <= "11111111";  -- 272C = FF
      when "010011100101101" =>  data <= "11111111";  -- 272D = FF
      when "010011100101110" =>  data <= "11111111";  -- 272E = FF
      when "010011100101111" =>  data <= "11111111";  -- 272F = FF
      when "010011100110000" =>  data <= "11111111";  -- 2730 = FF
      when "010011100110001" =>  data <= "11111111";  -- 2731 = FF
      when "010011100110010" =>  data <= "11111111";  -- 2732 = FF
      when "010011100110011" =>  data <= "11111111";  -- 2733 = FF
      when "010011100110100" =>  data <= "11111111";  -- 2734 = FF
      when "010011100110101" =>  data <= "11111111";  -- 2735 = FF
      when "010011100110110" =>  data <= "11111111";  -- 2736 = FF
      when "010011100110111" =>  data <= "11111111";  -- 2737 = FF
      when "010011100111000" =>  data <= "11111111";  -- 2738 = FF
      when "010011100111001" =>  data <= "11111111";  -- 2739 = FF
      when "010011100111010" =>  data <= "11111111";  -- 273A = FF
      when "010011100111011" =>  data <= "11111111";  -- 273B = FF
      when "010011100111100" =>  data <= "11111111";  -- 273C = FF
      when "010011100111101" =>  data <= "11111111";  -- 273D = FF
      when "010011100111110" =>  data <= "11111111";  -- 273E = FF
      when "010011100111111" =>  data <= "11111111";  -- 273F = FF
      when "010011101000000" =>  data <= "11111111";  -- 2740 = FF
      when "010011101000001" =>  data <= "11111111";  -- 2741 = FF
      when "010011101000010" =>  data <= "11111111";  -- 2742 = FF
      when "010011101000011" =>  data <= "11111111";  -- 2743 = FF
      when "010011101000100" =>  data <= "11111111";  -- 2744 = FF
      when "010011101000101" =>  data <= "11111111";  -- 2745 = FF
      when "010011101000110" =>  data <= "11111111";  -- 2746 = FF
      when "010011101000111" =>  data <= "11111111";  -- 2747 = FF
      when "010011101001000" =>  data <= "11111111";  -- 2748 = FF
      when "010011101001001" =>  data <= "11111111";  -- 2749 = FF
      when "010011101001010" =>  data <= "11111111";  -- 274A = FF
      when "010011101001011" =>  data <= "11111111";  -- 274B = FF
      when "010011101001100" =>  data <= "11111111";  -- 274C = FF
      when "010011101001101" =>  data <= "11111111";  -- 274D = FF
      when "010011101001110" =>  data <= "11111111";  -- 274E = FF
      when "010011101001111" =>  data <= "11111111";  -- 274F = FF
      when "010011101010000" =>  data <= "11111111";  -- 2750 = FF
      when "010011101010001" =>  data <= "11111111";  -- 2751 = FF
      when "010011101010010" =>  data <= "11111111";  -- 2752 = FF
      when "010011101010011" =>  data <= "11111111";  -- 2753 = FF
      when "010011101010100" =>  data <= "11111111";  -- 2754 = FF
      when "010011101010101" =>  data <= "11111111";  -- 2755 = FF
      when "010011101010110" =>  data <= "11111111";  -- 2756 = FF
      when "010011101010111" =>  data <= "11111111";  -- 2757 = FF
      when "010011101011000" =>  data <= "11111111";  -- 2758 = FF
      when "010011101011001" =>  data <= "11111111";  -- 2759 = FF
      when "010011101011010" =>  data <= "11111111";  -- 275A = FF
      when "010011101011011" =>  data <= "11111111";  -- 275B = FF
      when "010011101011100" =>  data <= "11111111";  -- 275C = FF
      when "010011101011101" =>  data <= "11111111";  -- 275D = FF
      when "010011101011110" =>  data <= "11111111";  -- 275E = FF
      when "010011101011111" =>  data <= "11111111";  -- 275F = FF
      when "010011101100000" =>  data <= "11111111";  -- 2760 = FF
      when "010011101100001" =>  data <= "11111111";  -- 2761 = FF
      when "010011101100010" =>  data <= "11111111";  -- 2762 = FF
      when "010011101100011" =>  data <= "11111111";  -- 2763 = FF
      when "010011101100100" =>  data <= "11111111";  -- 2764 = FF
      when "010011101100101" =>  data <= "11111111";  -- 2765 = FF
      when "010011101100110" =>  data <= "11111111";  -- 2766 = FF
      when "010011101100111" =>  data <= "11111111";  -- 2767 = FF
      when "010011101101000" =>  data <= "11111111";  -- 2768 = FF
      when "010011101101001" =>  data <= "11111111";  -- 2769 = FF
      when "010011101101010" =>  data <= "11111111";  -- 276A = FF
      when "010011101101011" =>  data <= "11111111";  -- 276B = FF
      when "010011101101100" =>  data <= "11111111";  -- 276C = FF
      when "010011101101101" =>  data <= "11111111";  -- 276D = FF
      when "010011101101110" =>  data <= "11111111";  -- 276E = FF
      when "010011101101111" =>  data <= "11111111";  -- 276F = FF
      when "010011101110000" =>  data <= "11111111";  -- 2770 = FF
      when "010011101110001" =>  data <= "11111111";  -- 2771 = FF
      when "010011101110010" =>  data <= "11111111";  -- 2772 = FF
      when "010011101110011" =>  data <= "11111111";  -- 2773 = FF
      when "010011101110100" =>  data <= "11111111";  -- 2774 = FF
      when "010011101110101" =>  data <= "11111111";  -- 2775 = FF
      when "010011101110110" =>  data <= "11111111";  -- 2776 = FF
      when "010011101110111" =>  data <= "11111111";  -- 2777 = FF
      when "010011101111000" =>  data <= "11111111";  -- 2778 = FF
      when "010011101111001" =>  data <= "11111111";  -- 2779 = FF
      when "010011101111010" =>  data <= "11111111";  -- 277A = FF
      when "010011101111011" =>  data <= "11111111";  -- 277B = FF
      when "010011101111100" =>  data <= "11111111";  -- 277C = FF
      when "010011101111101" =>  data <= "11111111";  -- 277D = FF
      when "010011101111110" =>  data <= "11111111";  -- 277E = FF
      when "010011101111111" =>  data <= "11111111";  -- 277F = FF
      when "010011110000000" =>  data <= "11111111";  -- 2780 = FF
      when "010011110000001" =>  data <= "11111111";  -- 2781 = FF
      when "010011110000010" =>  data <= "11111111";  -- 2782 = FF
      when "010011110000011" =>  data <= "11111111";  -- 2783 = FF
      when "010011110000100" =>  data <= "11111111";  -- 2784 = FF
      when "010011110000101" =>  data <= "11111111";  -- 2785 = FF
      when "010011110000110" =>  data <= "11111111";  -- 2786 = FF
      when "010011110000111" =>  data <= "11111111";  -- 2787 = FF
      when "010011110001000" =>  data <= "11111111";  -- 2788 = FF
      when "010011110001001" =>  data <= "11111111";  -- 2789 = FF
      when "010011110001010" =>  data <= "11111111";  -- 278A = FF
      when "010011110001011" =>  data <= "11111111";  -- 278B = FF
      when "010011110001100" =>  data <= "11111111";  -- 278C = FF
      when "010011110001101" =>  data <= "11111111";  -- 278D = FF
      when "010011110001110" =>  data <= "11111111";  -- 278E = FF
      when "010011110001111" =>  data <= "11111111";  -- 278F = FF
      when "010011110010000" =>  data <= "11111111";  -- 2790 = FF
      when "010011110010001" =>  data <= "11111111";  -- 2791 = FF
      when "010011110010010" =>  data <= "11111111";  -- 2792 = FF
      when "010011110010011" =>  data <= "11111111";  -- 2793 = FF
      when "010011110010100" =>  data <= "11111111";  -- 2794 = FF
      when "010011110010101" =>  data <= "11111111";  -- 2795 = FF
      when "010011110010110" =>  data <= "11111111";  -- 2796 = FF
      when "010011110010111" =>  data <= "11111111";  -- 2797 = FF
      when "010011110011000" =>  data <= "11111111";  -- 2798 = FF
      when "010011110011001" =>  data <= "11111111";  -- 2799 = FF
      when "010011110011010" =>  data <= "11111111";  -- 279A = FF
      when "010011110011011" =>  data <= "11111111";  -- 279B = FF
      when "010011110011100" =>  data <= "11111111";  -- 279C = FF
      when "010011110011101" =>  data <= "11111111";  -- 279D = FF
      when "010011110011110" =>  data <= "11111111";  -- 279E = FF
      when "010011110011111" =>  data <= "11111111";  -- 279F = FF
      when "010011110100000" =>  data <= "11111111";  -- 27A0 = FF
      when "010011110100001" =>  data <= "11111111";  -- 27A1 = FF
      when "010011110100010" =>  data <= "11111111";  -- 27A2 = FF
      when "010011110100011" =>  data <= "11111111";  -- 27A3 = FF
      when "010011110100100" =>  data <= "11111111";  -- 27A4 = FF
      when "010011110100101" =>  data <= "11111111";  -- 27A5 = FF
      when "010011110100110" =>  data <= "11111111";  -- 27A6 = FF
      when "010011110100111" =>  data <= "11111111";  -- 27A7 = FF
      when "010011110101000" =>  data <= "11111111";  -- 27A8 = FF
      when "010011110101001" =>  data <= "11111111";  -- 27A9 = FF
      when "010011110101010" =>  data <= "11111111";  -- 27AA = FF
      when "010011110101011" =>  data <= "11111111";  -- 27AB = FF
      when "010011110101100" =>  data <= "11111111";  -- 27AC = FF
      when "010011110101101" =>  data <= "11111111";  -- 27AD = FF
      when "010011110101110" =>  data <= "11111111";  -- 27AE = FF
      when "010011110101111" =>  data <= "11111111";  -- 27AF = FF
      when "010011110110000" =>  data <= "11111111";  -- 27B0 = FF
      when "010011110110001" =>  data <= "11111111";  -- 27B1 = FF
      when "010011110110010" =>  data <= "11111111";  -- 27B2 = FF
      when "010011110110011" =>  data <= "11111111";  -- 27B3 = FF
      when "010011110110100" =>  data <= "11111111";  -- 27B4 = FF
      when "010011110110101" =>  data <= "11111111";  -- 27B5 = FF
      when "010011110110110" =>  data <= "11111111";  -- 27B6 = FF
      when "010011110110111" =>  data <= "11111111";  -- 27B7 = FF
      when "010011110111000" =>  data <= "11111111";  -- 27B8 = FF
      when "010011110111001" =>  data <= "11111111";  -- 27B9 = FF
      when "010011110111010" =>  data <= "11111111";  -- 27BA = FF
      when "010011110111011" =>  data <= "11111111";  -- 27BB = FF
      when "010011110111100" =>  data <= "11111111";  -- 27BC = FF
      when "010011110111101" =>  data <= "11111111";  -- 27BD = FF
      when "010011110111110" =>  data <= "11111111";  -- 27BE = FF
      when "010011110111111" =>  data <= "11111111";  -- 27BF = FF
      when "010011111000000" =>  data <= "11111111";  -- 27C0 = FF
      when "010011111000001" =>  data <= "11111111";  -- 27C1 = FF
      when "010011111000010" =>  data <= "11111111";  -- 27C2 = FF
      when "010011111000011" =>  data <= "11111111";  -- 27C3 = FF
      when "010011111000100" =>  data <= "11111111";  -- 27C4 = FF
      when "010011111000101" =>  data <= "11111111";  -- 27C5 = FF
      when "010011111000110" =>  data <= "11111111";  -- 27C6 = FF
      when "010011111000111" =>  data <= "11111111";  -- 27C7 = FF
      when "010011111001000" =>  data <= "11111111";  -- 27C8 = FF
      when "010011111001001" =>  data <= "11111111";  -- 27C9 = FF
      when "010011111001010" =>  data <= "11111111";  -- 27CA = FF
      when "010011111001011" =>  data <= "11111111";  -- 27CB = FF
      when "010011111001100" =>  data <= "11111111";  -- 27CC = FF
      when "010011111001101" =>  data <= "11111111";  -- 27CD = FF
      when "010011111001110" =>  data <= "11111111";  -- 27CE = FF
      when "010011111001111" =>  data <= "11111111";  -- 27CF = FF
      when "010011111010000" =>  data <= "11111111";  -- 27D0 = FF
      when "010011111010001" =>  data <= "11111111";  -- 27D1 = FF
      when "010011111010010" =>  data <= "11111111";  -- 27D2 = FF
      when "010011111010011" =>  data <= "11111111";  -- 27D3 = FF
      when "010011111010100" =>  data <= "11111111";  -- 27D4 = FF
      when "010011111010101" =>  data <= "11111111";  -- 27D5 = FF
      when "010011111010110" =>  data <= "11111111";  -- 27D6 = FF
      when "010011111010111" =>  data <= "11111111";  -- 27D7 = FF
      when "010011111011000" =>  data <= "11111111";  -- 27D8 = FF
      when "010011111011001" =>  data <= "11111111";  -- 27D9 = FF
      when "010011111011010" =>  data <= "11111111";  -- 27DA = FF
      when "010011111011011" =>  data <= "11111111";  -- 27DB = FF
      when "010011111011100" =>  data <= "11111111";  -- 27DC = FF
      when "010011111011101" =>  data <= "11111111";  -- 27DD = FF
      when "010011111011110" =>  data <= "11111111";  -- 27DE = FF
      when "010011111011111" =>  data <= "11111111";  -- 27DF = FF
      when "010011111100000" =>  data <= "11111111";  -- 27E0 = FF
      when "010011111100001" =>  data <= "11111111";  -- 27E1 = FF
      when "010011111100010" =>  data <= "11111111";  -- 27E2 = FF
      when "010011111100011" =>  data <= "11111111";  -- 27E3 = FF
      when "010011111100100" =>  data <= "11111111";  -- 27E4 = FF
      when "010011111100101" =>  data <= "11111111";  -- 27E5 = FF
      when "010011111100110" =>  data <= "11111111";  -- 27E6 = FF
      when "010011111100111" =>  data <= "11111111";  -- 27E7 = FF
      when "010011111101000" =>  data <= "11111111";  -- 27E8 = FF
      when "010011111101001" =>  data <= "11111111";  -- 27E9 = FF
      when "010011111101010" =>  data <= "11111111";  -- 27EA = FF
      when "010011111101011" =>  data <= "11111111";  -- 27EB = FF
      when "010011111101100" =>  data <= "11111111";  -- 27EC = FF
      when "010011111101101" =>  data <= "11111111";  -- 27ED = FF
      when "010011111101110" =>  data <= "11111111";  -- 27EE = FF
      when "010011111101111" =>  data <= "11111111";  -- 27EF = FF
      when "010011111110000" =>  data <= "11111111";  -- 27F0 = FF
      when "010011111110001" =>  data <= "11111111";  -- 27F1 = FF
      when "010011111110010" =>  data <= "11111111";  -- 27F2 = FF
      when "010011111110011" =>  data <= "11111111";  -- 27F3 = FF
      when "010011111110100" =>  data <= "11111111";  -- 27F4 = FF
      when "010011111110101" =>  data <= "11111111";  -- 27F5 = FF
      when "010011111110110" =>  data <= "11111111";  -- 27F6 = FF
      when "010011111110111" =>  data <= "11111111";  -- 27F7 = FF
      when "010011111111000" =>  data <= "11111111";  -- 27F8 = FF
      when "010011111111001" =>  data <= "11111111";  -- 27F9 = FF
      when "010011111111010" =>  data <= "11111111";  -- 27FA = FF
      when "010011111111011" =>  data <= "11111111";  -- 27FB = FF
      when "010011111111100" =>  data <= "11111111";  -- 27FC = FF
      when "010011111111101" =>  data <= "11111111";  -- 27FD = FF
      when "010011111111110" =>  data <= "11111111";  -- 27FE = FF
      when "010011111111111" =>  data <= "11111111";  -- 27FF = FF
      when "010100000000000" =>  data <= "11111111";  -- 2800 = FF
      when "010100000000001" =>  data <= "11111111";  -- 2801 = FF
      when "010100000000010" =>  data <= "11111111";  -- 2802 = FF
      when "010100000000011" =>  data <= "11111111";  -- 2803 = FF
      when "010100000000100" =>  data <= "11111111";  -- 2804 = FF
      when "010100000000101" =>  data <= "11111111";  -- 2805 = FF
      when "010100000000110" =>  data <= "11111111";  -- 2806 = FF
      when "010100000000111" =>  data <= "11111111";  -- 2807 = FF
      when "010100000001000" =>  data <= "11111111";  -- 2808 = FF
      when "010100000001001" =>  data <= "11111111";  -- 2809 = FF
      when "010100000001010" =>  data <= "11111111";  -- 280A = FF
      when "010100000001011" =>  data <= "11111111";  -- 280B = FF
      when "010100000001100" =>  data <= "11111111";  -- 280C = FF
      when "010100000001101" =>  data <= "11111111";  -- 280D = FF
      when "010100000001110" =>  data <= "11111111";  -- 280E = FF
      when "010100000001111" =>  data <= "11111111";  -- 280F = FF
      when "010100000010000" =>  data <= "11111111";  -- 2810 = FF
      when "010100000010001" =>  data <= "11111111";  -- 2811 = FF
      when "010100000010010" =>  data <= "11111111";  -- 2812 = FF
      when "010100000010011" =>  data <= "11111111";  -- 2813 = FF
      when "010100000010100" =>  data <= "11111111";  -- 2814 = FF
      when "010100000010101" =>  data <= "11111111";  -- 2815 = FF
      when "010100000010110" =>  data <= "11111111";  -- 2816 = FF
      when "010100000010111" =>  data <= "11111111";  -- 2817 = FF
      when "010100000011000" =>  data <= "11111111";  -- 2818 = FF
      when "010100000011001" =>  data <= "11111111";  -- 2819 = FF
      when "010100000011010" =>  data <= "11111111";  -- 281A = FF
      when "010100000011011" =>  data <= "11111111";  -- 281B = FF
      when "010100000011100" =>  data <= "11111111";  -- 281C = FF
      when "010100000011101" =>  data <= "11111111";  -- 281D = FF
      when "010100000011110" =>  data <= "11111111";  -- 281E = FF
      when "010100000011111" =>  data <= "11111111";  -- 281F = FF
      when "010100000100000" =>  data <= "11111111";  -- 2820 = FF
      when "010100000100001" =>  data <= "11111111";  -- 2821 = FF
      when "010100000100010" =>  data <= "11111111";  -- 2822 = FF
      when "010100000100011" =>  data <= "11111111";  -- 2823 = FF
      when "010100000100100" =>  data <= "11111111";  -- 2824 = FF
      when "010100000100101" =>  data <= "11111111";  -- 2825 = FF
      when "010100000100110" =>  data <= "11111111";  -- 2826 = FF
      when "010100000100111" =>  data <= "11111111";  -- 2827 = FF
      when "010100000101000" =>  data <= "11111111";  -- 2828 = FF
      when "010100000101001" =>  data <= "11111111";  -- 2829 = FF
      when "010100000101010" =>  data <= "11111111";  -- 282A = FF
      when "010100000101011" =>  data <= "11111111";  -- 282B = FF
      when "010100000101100" =>  data <= "11111111";  -- 282C = FF
      when "010100000101101" =>  data <= "11111111";  -- 282D = FF
      when "010100000101110" =>  data <= "11111111";  -- 282E = FF
      when "010100000101111" =>  data <= "11111111";  -- 282F = FF
      when "010100000110000" =>  data <= "11111111";  -- 2830 = FF
      when "010100000110001" =>  data <= "11111111";  -- 2831 = FF
      when "010100000110010" =>  data <= "11111111";  -- 2832 = FF
      when "010100000110011" =>  data <= "11111111";  -- 2833 = FF
      when "010100000110100" =>  data <= "11111111";  -- 2834 = FF
      when "010100000110101" =>  data <= "11111111";  -- 2835 = FF
      when "010100000110110" =>  data <= "11111111";  -- 2836 = FF
      when "010100000110111" =>  data <= "11111111";  -- 2837 = FF
      when "010100000111000" =>  data <= "11111111";  -- 2838 = FF
      when "010100000111001" =>  data <= "11111111";  -- 2839 = FF
      when "010100000111010" =>  data <= "11111111";  -- 283A = FF
      when "010100000111011" =>  data <= "11111111";  -- 283B = FF
      when "010100000111100" =>  data <= "11111111";  -- 283C = FF
      when "010100000111101" =>  data <= "11111111";  -- 283D = FF
      when "010100000111110" =>  data <= "11111111";  -- 283E = FF
      when "010100000111111" =>  data <= "11111111";  -- 283F = FF
      when "010100001000000" =>  data <= "11111111";  -- 2840 = FF
      when "010100001000001" =>  data <= "11111111";  -- 2841 = FF
      when "010100001000010" =>  data <= "11111111";  -- 2842 = FF
      when "010100001000011" =>  data <= "11111111";  -- 2843 = FF
      when "010100001000100" =>  data <= "11111111";  -- 2844 = FF
      when "010100001000101" =>  data <= "11111111";  -- 2845 = FF
      when "010100001000110" =>  data <= "11111111";  -- 2846 = FF
      when "010100001000111" =>  data <= "11111111";  -- 2847 = FF
      when "010100001001000" =>  data <= "11111111";  -- 2848 = FF
      when "010100001001001" =>  data <= "11111111";  -- 2849 = FF
      when "010100001001010" =>  data <= "11111111";  -- 284A = FF
      when "010100001001011" =>  data <= "11111111";  -- 284B = FF
      when "010100001001100" =>  data <= "11111111";  -- 284C = FF
      when "010100001001101" =>  data <= "11111111";  -- 284D = FF
      when "010100001001110" =>  data <= "11111111";  -- 284E = FF
      when "010100001001111" =>  data <= "11111111";  -- 284F = FF
      when "010100001010000" =>  data <= "11111111";  -- 2850 = FF
      when "010100001010001" =>  data <= "11111111";  -- 2851 = FF
      when "010100001010010" =>  data <= "11111111";  -- 2852 = FF
      when "010100001010011" =>  data <= "11111111";  -- 2853 = FF
      when "010100001010100" =>  data <= "11111111";  -- 2854 = FF
      when "010100001010101" =>  data <= "11111111";  -- 2855 = FF
      when "010100001010110" =>  data <= "11111111";  -- 2856 = FF
      when "010100001010111" =>  data <= "11111111";  -- 2857 = FF
      when "010100001011000" =>  data <= "11111111";  -- 2858 = FF
      when "010100001011001" =>  data <= "11111111";  -- 2859 = FF
      when "010100001011010" =>  data <= "11111111";  -- 285A = FF
      when "010100001011011" =>  data <= "11111111";  -- 285B = FF
      when "010100001011100" =>  data <= "11111111";  -- 285C = FF
      when "010100001011101" =>  data <= "11111111";  -- 285D = FF
      when "010100001011110" =>  data <= "11111111";  -- 285E = FF
      when "010100001011111" =>  data <= "11111111";  -- 285F = FF
      when "010100001100000" =>  data <= "11111111";  -- 2860 = FF
      when "010100001100001" =>  data <= "11111111";  -- 2861 = FF
      when "010100001100010" =>  data <= "11111111";  -- 2862 = FF
      when "010100001100011" =>  data <= "11111111";  -- 2863 = FF
      when "010100001100100" =>  data <= "11111111";  -- 2864 = FF
      when "010100001100101" =>  data <= "11111111";  -- 2865 = FF
      when "010100001100110" =>  data <= "11111111";  -- 2866 = FF
      when "010100001100111" =>  data <= "11111111";  -- 2867 = FF
      when "010100001101000" =>  data <= "11111111";  -- 2868 = FF
      when "010100001101001" =>  data <= "11111111";  -- 2869 = FF
      when "010100001101010" =>  data <= "11111111";  -- 286A = FF
      when "010100001101011" =>  data <= "11111111";  -- 286B = FF
      when "010100001101100" =>  data <= "11111111";  -- 286C = FF
      when "010100001101101" =>  data <= "11111111";  -- 286D = FF
      when "010100001101110" =>  data <= "11111111";  -- 286E = FF
      when "010100001101111" =>  data <= "11111111";  -- 286F = FF
      when "010100001110000" =>  data <= "11111111";  -- 2870 = FF
      when "010100001110001" =>  data <= "11111111";  -- 2871 = FF
      when "010100001110010" =>  data <= "11111111";  -- 2872 = FF
      when "010100001110011" =>  data <= "11111111";  -- 2873 = FF
      when "010100001110100" =>  data <= "11111111";  -- 2874 = FF
      when "010100001110101" =>  data <= "11111111";  -- 2875 = FF
      when "010100001110110" =>  data <= "11111111";  -- 2876 = FF
      when "010100001110111" =>  data <= "11111111";  -- 2877 = FF
      when "010100001111000" =>  data <= "11111111";  -- 2878 = FF
      when "010100001111001" =>  data <= "11111111";  -- 2879 = FF
      when "010100001111010" =>  data <= "11111111";  -- 287A = FF
      when "010100001111011" =>  data <= "11111111";  -- 287B = FF
      when "010100001111100" =>  data <= "11111111";  -- 287C = FF
      when "010100001111101" =>  data <= "11111111";  -- 287D = FF
      when "010100001111110" =>  data <= "11111111";  -- 287E = FF
      when "010100001111111" =>  data <= "11111111";  -- 287F = FF
      when "010100010000000" =>  data <= "11111111";  -- 2880 = FF
      when "010100010000001" =>  data <= "11111111";  -- 2881 = FF
      when "010100010000010" =>  data <= "11111111";  -- 2882 = FF
      when "010100010000011" =>  data <= "11111111";  -- 2883 = FF
      when "010100010000100" =>  data <= "11111111";  -- 2884 = FF
      when "010100010000101" =>  data <= "11111111";  -- 2885 = FF
      when "010100010000110" =>  data <= "11111111";  -- 2886 = FF
      when "010100010000111" =>  data <= "11111111";  -- 2887 = FF
      when "010100010001000" =>  data <= "11111111";  -- 2888 = FF
      when "010100010001001" =>  data <= "11111111";  -- 2889 = FF
      when "010100010001010" =>  data <= "11111111";  -- 288A = FF
      when "010100010001011" =>  data <= "11111111";  -- 288B = FF
      when "010100010001100" =>  data <= "11111111";  -- 288C = FF
      when "010100010001101" =>  data <= "11111111";  -- 288D = FF
      when "010100010001110" =>  data <= "11111111";  -- 288E = FF
      when "010100010001111" =>  data <= "11111111";  -- 288F = FF
      when "010100010010000" =>  data <= "11111111";  -- 2890 = FF
      when "010100010010001" =>  data <= "11111111";  -- 2891 = FF
      when "010100010010010" =>  data <= "11111111";  -- 2892 = FF
      when "010100010010011" =>  data <= "11111111";  -- 2893 = FF
      when "010100010010100" =>  data <= "11111111";  -- 2894 = FF
      when "010100010010101" =>  data <= "11111111";  -- 2895 = FF
      when "010100010010110" =>  data <= "11111111";  -- 2896 = FF
      when "010100010010111" =>  data <= "11111111";  -- 2897 = FF
      when "010100010011000" =>  data <= "11111111";  -- 2898 = FF
      when "010100010011001" =>  data <= "11111111";  -- 2899 = FF
      when "010100010011010" =>  data <= "11111111";  -- 289A = FF
      when "010100010011011" =>  data <= "11111111";  -- 289B = FF
      when "010100010011100" =>  data <= "11111111";  -- 289C = FF
      when "010100010011101" =>  data <= "11111111";  -- 289D = FF
      when "010100010011110" =>  data <= "11111111";  -- 289E = FF
      when "010100010011111" =>  data <= "11111111";  -- 289F = FF
      when "010100010100000" =>  data <= "11111111";  -- 28A0 = FF
      when "010100010100001" =>  data <= "11111111";  -- 28A1 = FF
      when "010100010100010" =>  data <= "11111111";  -- 28A2 = FF
      when "010100010100011" =>  data <= "11111111";  -- 28A3 = FF
      when "010100010100100" =>  data <= "11111111";  -- 28A4 = FF
      when "010100010100101" =>  data <= "11111111";  -- 28A5 = FF
      when "010100010100110" =>  data <= "11111111";  -- 28A6 = FF
      when "010100010100111" =>  data <= "11111111";  -- 28A7 = FF
      when "010100010101000" =>  data <= "11111111";  -- 28A8 = FF
      when "010100010101001" =>  data <= "11111111";  -- 28A9 = FF
      when "010100010101010" =>  data <= "11111111";  -- 28AA = FF
      when "010100010101011" =>  data <= "11111111";  -- 28AB = FF
      when "010100010101100" =>  data <= "11111111";  -- 28AC = FF
      when "010100010101101" =>  data <= "11111111";  -- 28AD = FF
      when "010100010101110" =>  data <= "11111111";  -- 28AE = FF
      when "010100010101111" =>  data <= "11111111";  -- 28AF = FF
      when "010100010110000" =>  data <= "11111111";  -- 28B0 = FF
      when "010100010110001" =>  data <= "11111111";  -- 28B1 = FF
      when "010100010110010" =>  data <= "11111111";  -- 28B2 = FF
      when "010100010110011" =>  data <= "11111111";  -- 28B3 = FF
      when "010100010110100" =>  data <= "11111111";  -- 28B4 = FF
      when "010100010110101" =>  data <= "11111111";  -- 28B5 = FF
      when "010100010110110" =>  data <= "11111111";  -- 28B6 = FF
      when "010100010110111" =>  data <= "11111111";  -- 28B7 = FF
      when "010100010111000" =>  data <= "11111111";  -- 28B8 = FF
      when "010100010111001" =>  data <= "11111111";  -- 28B9 = FF
      when "010100010111010" =>  data <= "11111111";  -- 28BA = FF
      when "010100010111011" =>  data <= "11111111";  -- 28BB = FF
      when "010100010111100" =>  data <= "11111111";  -- 28BC = FF
      when "010100010111101" =>  data <= "11111111";  -- 28BD = FF
      when "010100010111110" =>  data <= "11111111";  -- 28BE = FF
      when "010100010111111" =>  data <= "11111111";  -- 28BF = FF
      when "010100011000000" =>  data <= "11111111";  -- 28C0 = FF
      when "010100011000001" =>  data <= "11111111";  -- 28C1 = FF
      when "010100011000010" =>  data <= "11111111";  -- 28C2 = FF
      when "010100011000011" =>  data <= "11111111";  -- 28C3 = FF
      when "010100011000100" =>  data <= "11111111";  -- 28C4 = FF
      when "010100011000101" =>  data <= "11111111";  -- 28C5 = FF
      when "010100011000110" =>  data <= "11111111";  -- 28C6 = FF
      when "010100011000111" =>  data <= "11111111";  -- 28C7 = FF
      when "010100011001000" =>  data <= "11111111";  -- 28C8 = FF
      when "010100011001001" =>  data <= "11111111";  -- 28C9 = FF
      when "010100011001010" =>  data <= "11111111";  -- 28CA = FF
      when "010100011001011" =>  data <= "11111111";  -- 28CB = FF
      when "010100011001100" =>  data <= "11111111";  -- 28CC = FF
      when "010100011001101" =>  data <= "11111111";  -- 28CD = FF
      when "010100011001110" =>  data <= "11111111";  -- 28CE = FF
      when "010100011001111" =>  data <= "11111111";  -- 28CF = FF
      when "010100011010000" =>  data <= "11111111";  -- 28D0 = FF
      when "010100011010001" =>  data <= "11111111";  -- 28D1 = FF
      when "010100011010010" =>  data <= "11111111";  -- 28D2 = FF
      when "010100011010011" =>  data <= "11111111";  -- 28D3 = FF
      when "010100011010100" =>  data <= "11111111";  -- 28D4 = FF
      when "010100011010101" =>  data <= "11111111";  -- 28D5 = FF
      when "010100011010110" =>  data <= "11111111";  -- 28D6 = FF
      when "010100011010111" =>  data <= "11111111";  -- 28D7 = FF
      when "010100011011000" =>  data <= "11111111";  -- 28D8 = FF
      when "010100011011001" =>  data <= "11111111";  -- 28D9 = FF
      when "010100011011010" =>  data <= "11111111";  -- 28DA = FF
      when "010100011011011" =>  data <= "11111111";  -- 28DB = FF
      when "010100011011100" =>  data <= "11111111";  -- 28DC = FF
      when "010100011011101" =>  data <= "11111111";  -- 28DD = FF
      when "010100011011110" =>  data <= "11111111";  -- 28DE = FF
      when "010100011011111" =>  data <= "11111111";  -- 28DF = FF
      when "010100011100000" =>  data <= "11111111";  -- 28E0 = FF
      when "010100011100001" =>  data <= "11111111";  -- 28E1 = FF
      when "010100011100010" =>  data <= "11111111";  -- 28E2 = FF
      when "010100011100011" =>  data <= "11111111";  -- 28E3 = FF
      when "010100011100100" =>  data <= "11111111";  -- 28E4 = FF
      when "010100011100101" =>  data <= "11111111";  -- 28E5 = FF
      when "010100011100110" =>  data <= "11111111";  -- 28E6 = FF
      when "010100011100111" =>  data <= "11111111";  -- 28E7 = FF
      when "010100011101000" =>  data <= "11111111";  -- 28E8 = FF
      when "010100011101001" =>  data <= "11111111";  -- 28E9 = FF
      when "010100011101010" =>  data <= "11111111";  -- 28EA = FF
      when "010100011101011" =>  data <= "11111111";  -- 28EB = FF
      when "010100011101100" =>  data <= "11111111";  -- 28EC = FF
      when "010100011101101" =>  data <= "11111111";  -- 28ED = FF
      when "010100011101110" =>  data <= "11111111";  -- 28EE = FF
      when "010100011101111" =>  data <= "11111111";  -- 28EF = FF
      when "010100011110000" =>  data <= "11111111";  -- 28F0 = FF
      when "010100011110001" =>  data <= "11111111";  -- 28F1 = FF
      when "010100011110010" =>  data <= "11111111";  -- 28F2 = FF
      when "010100011110011" =>  data <= "11111111";  -- 28F3 = FF
      when "010100011110100" =>  data <= "11111111";  -- 28F4 = FF
      when "010100011110101" =>  data <= "11111111";  -- 28F5 = FF
      when "010100011110110" =>  data <= "11111111";  -- 28F6 = FF
      when "010100011110111" =>  data <= "11111111";  -- 28F7 = FF
      when "010100011111000" =>  data <= "11111111";  -- 28F8 = FF
      when "010100011111001" =>  data <= "11111111";  -- 28F9 = FF
      when "010100011111010" =>  data <= "11111111";  -- 28FA = FF
      when "010100011111011" =>  data <= "11111111";  -- 28FB = FF
      when "010100011111100" =>  data <= "11111111";  -- 28FC = FF
      when "010100011111101" =>  data <= "11111111";  -- 28FD = FF
      when "010100011111110" =>  data <= "11111111";  -- 28FE = FF
      when "010100011111111" =>  data <= "11111111";  -- 28FF = FF
      when "010100100000000" =>  data <= "11111111";  -- 2900 = FF
      when "010100100000001" =>  data <= "11111111";  -- 2901 = FF
      when "010100100000010" =>  data <= "11111111";  -- 2902 = FF
      when "010100100000011" =>  data <= "11111111";  -- 2903 = FF
      when "010100100000100" =>  data <= "11111111";  -- 2904 = FF
      when "010100100000101" =>  data <= "11111111";  -- 2905 = FF
      when "010100100000110" =>  data <= "11111111";  -- 2906 = FF
      when "010100100000111" =>  data <= "11111111";  -- 2907 = FF
      when "010100100001000" =>  data <= "11111111";  -- 2908 = FF
      when "010100100001001" =>  data <= "11111111";  -- 2909 = FF
      when "010100100001010" =>  data <= "11111111";  -- 290A = FF
      when "010100100001011" =>  data <= "11111111";  -- 290B = FF
      when "010100100001100" =>  data <= "11111111";  -- 290C = FF
      when "010100100001101" =>  data <= "11111111";  -- 290D = FF
      when "010100100001110" =>  data <= "11111111";  -- 290E = FF
      when "010100100001111" =>  data <= "11111111";  -- 290F = FF
      when "010100100010000" =>  data <= "11111111";  -- 2910 = FF
      when "010100100010001" =>  data <= "11111111";  -- 2911 = FF
      when "010100100010010" =>  data <= "11111111";  -- 2912 = FF
      when "010100100010011" =>  data <= "11111111";  -- 2913 = FF
      when "010100100010100" =>  data <= "11111111";  -- 2914 = FF
      when "010100100010101" =>  data <= "11111111";  -- 2915 = FF
      when "010100100010110" =>  data <= "11111111";  -- 2916 = FF
      when "010100100010111" =>  data <= "11111111";  -- 2917 = FF
      when "010100100011000" =>  data <= "11111111";  -- 2918 = FF
      when "010100100011001" =>  data <= "11111111";  -- 2919 = FF
      when "010100100011010" =>  data <= "11111111";  -- 291A = FF
      when "010100100011011" =>  data <= "11111111";  -- 291B = FF
      when "010100100011100" =>  data <= "11111111";  -- 291C = FF
      when "010100100011101" =>  data <= "11111111";  -- 291D = FF
      when "010100100011110" =>  data <= "11111111";  -- 291E = FF
      when "010100100011111" =>  data <= "11111111";  -- 291F = FF
      when "010100100100000" =>  data <= "11111111";  -- 2920 = FF
      when "010100100100001" =>  data <= "11111111";  -- 2921 = FF
      when "010100100100010" =>  data <= "11111111";  -- 2922 = FF
      when "010100100100011" =>  data <= "11111111";  -- 2923 = FF
      when "010100100100100" =>  data <= "11111111";  -- 2924 = FF
      when "010100100100101" =>  data <= "11111111";  -- 2925 = FF
      when "010100100100110" =>  data <= "11111111";  -- 2926 = FF
      when "010100100100111" =>  data <= "11111111";  -- 2927 = FF
      when "010100100101000" =>  data <= "11111111";  -- 2928 = FF
      when "010100100101001" =>  data <= "11111111";  -- 2929 = FF
      when "010100100101010" =>  data <= "11111111";  -- 292A = FF
      when "010100100101011" =>  data <= "11111111";  -- 292B = FF
      when "010100100101100" =>  data <= "11111111";  -- 292C = FF
      when "010100100101101" =>  data <= "11111111";  -- 292D = FF
      when "010100100101110" =>  data <= "11111111";  -- 292E = FF
      when "010100100101111" =>  data <= "11111111";  -- 292F = FF
      when "010100100110000" =>  data <= "11111111";  -- 2930 = FF
      when "010100100110001" =>  data <= "11111111";  -- 2931 = FF
      when "010100100110010" =>  data <= "11111111";  -- 2932 = FF
      when "010100100110011" =>  data <= "11111111";  -- 2933 = FF
      when "010100100110100" =>  data <= "11111111";  -- 2934 = FF
      when "010100100110101" =>  data <= "11111111";  -- 2935 = FF
      when "010100100110110" =>  data <= "11111111";  -- 2936 = FF
      when "010100100110111" =>  data <= "11111111";  -- 2937 = FF
      when "010100100111000" =>  data <= "11111111";  -- 2938 = FF
      when "010100100111001" =>  data <= "11111111";  -- 2939 = FF
      when "010100100111010" =>  data <= "11111111";  -- 293A = FF
      when "010100100111011" =>  data <= "11111111";  -- 293B = FF
      when "010100100111100" =>  data <= "11111111";  -- 293C = FF
      when "010100100111101" =>  data <= "11111111";  -- 293D = FF
      when "010100100111110" =>  data <= "11111111";  -- 293E = FF
      when "010100100111111" =>  data <= "11111111";  -- 293F = FF
      when "010100101000000" =>  data <= "11111111";  -- 2940 = FF
      when "010100101000001" =>  data <= "11111111";  -- 2941 = FF
      when "010100101000010" =>  data <= "11111111";  -- 2942 = FF
      when "010100101000011" =>  data <= "11111111";  -- 2943 = FF
      when "010100101000100" =>  data <= "11111111";  -- 2944 = FF
      when "010100101000101" =>  data <= "11111111";  -- 2945 = FF
      when "010100101000110" =>  data <= "11111111";  -- 2946 = FF
      when "010100101000111" =>  data <= "11111111";  -- 2947 = FF
      when "010100101001000" =>  data <= "11111111";  -- 2948 = FF
      when "010100101001001" =>  data <= "11111111";  -- 2949 = FF
      when "010100101001010" =>  data <= "11111111";  -- 294A = FF
      when "010100101001011" =>  data <= "11111111";  -- 294B = FF
      when "010100101001100" =>  data <= "11111111";  -- 294C = FF
      when "010100101001101" =>  data <= "11111111";  -- 294D = FF
      when "010100101001110" =>  data <= "11111111";  -- 294E = FF
      when "010100101001111" =>  data <= "11111111";  -- 294F = FF
      when "010100101010000" =>  data <= "11111111";  -- 2950 = FF
      when "010100101010001" =>  data <= "11111111";  -- 2951 = FF
      when "010100101010010" =>  data <= "11111111";  -- 2952 = FF
      when "010100101010011" =>  data <= "11111111";  -- 2953 = FF
      when "010100101010100" =>  data <= "11111111";  -- 2954 = FF
      when "010100101010101" =>  data <= "11111111";  -- 2955 = FF
      when "010100101010110" =>  data <= "11111111";  -- 2956 = FF
      when "010100101010111" =>  data <= "11111111";  -- 2957 = FF
      when "010100101011000" =>  data <= "11111111";  -- 2958 = FF
      when "010100101011001" =>  data <= "11111111";  -- 2959 = FF
      when "010100101011010" =>  data <= "11111111";  -- 295A = FF
      when "010100101011011" =>  data <= "11111111";  -- 295B = FF
      when "010100101011100" =>  data <= "11111111";  -- 295C = FF
      when "010100101011101" =>  data <= "11111111";  -- 295D = FF
      when "010100101011110" =>  data <= "11111111";  -- 295E = FF
      when "010100101011111" =>  data <= "11111111";  -- 295F = FF
      when "010100101100000" =>  data <= "11111111";  -- 2960 = FF
      when "010100101100001" =>  data <= "11111111";  -- 2961 = FF
      when "010100101100010" =>  data <= "11111111";  -- 2962 = FF
      when "010100101100011" =>  data <= "11111111";  -- 2963 = FF
      when "010100101100100" =>  data <= "11111111";  -- 2964 = FF
      when "010100101100101" =>  data <= "11111111";  -- 2965 = FF
      when "010100101100110" =>  data <= "11111111";  -- 2966 = FF
      when "010100101100111" =>  data <= "11111111";  -- 2967 = FF
      when "010100101101000" =>  data <= "11111111";  -- 2968 = FF
      when "010100101101001" =>  data <= "11111111";  -- 2969 = FF
      when "010100101101010" =>  data <= "11111111";  -- 296A = FF
      when "010100101101011" =>  data <= "11111111";  -- 296B = FF
      when "010100101101100" =>  data <= "11111111";  -- 296C = FF
      when "010100101101101" =>  data <= "11111111";  -- 296D = FF
      when "010100101101110" =>  data <= "11111111";  -- 296E = FF
      when "010100101101111" =>  data <= "11111111";  -- 296F = FF
      when "010100101110000" =>  data <= "11111111";  -- 2970 = FF
      when "010100101110001" =>  data <= "11111111";  -- 2971 = FF
      when "010100101110010" =>  data <= "11111111";  -- 2972 = FF
      when "010100101110011" =>  data <= "11111111";  -- 2973 = FF
      when "010100101110100" =>  data <= "11111111";  -- 2974 = FF
      when "010100101110101" =>  data <= "11111111";  -- 2975 = FF
      when "010100101110110" =>  data <= "11111111";  -- 2976 = FF
      when "010100101110111" =>  data <= "11111111";  -- 2977 = FF
      when "010100101111000" =>  data <= "11111111";  -- 2978 = FF
      when "010100101111001" =>  data <= "11111111";  -- 2979 = FF
      when "010100101111010" =>  data <= "11111111";  -- 297A = FF
      when "010100101111011" =>  data <= "11111111";  -- 297B = FF
      when "010100101111100" =>  data <= "11111111";  -- 297C = FF
      when "010100101111101" =>  data <= "11111111";  -- 297D = FF
      when "010100101111110" =>  data <= "11111111";  -- 297E = FF
      when "010100101111111" =>  data <= "11111111";  -- 297F = FF
      when "010100110000000" =>  data <= "11111111";  -- 2980 = FF
      when "010100110000001" =>  data <= "11111111";  -- 2981 = FF
      when "010100110000010" =>  data <= "11111111";  -- 2982 = FF
      when "010100110000011" =>  data <= "11111111";  -- 2983 = FF
      when "010100110000100" =>  data <= "11111111";  -- 2984 = FF
      when "010100110000101" =>  data <= "11111111";  -- 2985 = FF
      when "010100110000110" =>  data <= "11111111";  -- 2986 = FF
      when "010100110000111" =>  data <= "11111111";  -- 2987 = FF
      when "010100110001000" =>  data <= "11111111";  -- 2988 = FF
      when "010100110001001" =>  data <= "11111111";  -- 2989 = FF
      when "010100110001010" =>  data <= "11111111";  -- 298A = FF
      when "010100110001011" =>  data <= "11111111";  -- 298B = FF
      when "010100110001100" =>  data <= "11111111";  -- 298C = FF
      when "010100110001101" =>  data <= "11111111";  -- 298D = FF
      when "010100110001110" =>  data <= "11111111";  -- 298E = FF
      when "010100110001111" =>  data <= "11111111";  -- 298F = FF
      when "010100110010000" =>  data <= "11111111";  -- 2990 = FF
      when "010100110010001" =>  data <= "11111111";  -- 2991 = FF
      when "010100110010010" =>  data <= "11111111";  -- 2992 = FF
      when "010100110010011" =>  data <= "11111111";  -- 2993 = FF
      when "010100110010100" =>  data <= "11111111";  -- 2994 = FF
      when "010100110010101" =>  data <= "11111111";  -- 2995 = FF
      when "010100110010110" =>  data <= "11111111";  -- 2996 = FF
      when "010100110010111" =>  data <= "11111111";  -- 2997 = FF
      when "010100110011000" =>  data <= "11111111";  -- 2998 = FF
      when "010100110011001" =>  data <= "11111111";  -- 2999 = FF
      when "010100110011010" =>  data <= "11111111";  -- 299A = FF
      when "010100110011011" =>  data <= "11111111";  -- 299B = FF
      when "010100110011100" =>  data <= "11111111";  -- 299C = FF
      when "010100110011101" =>  data <= "11111111";  -- 299D = FF
      when "010100110011110" =>  data <= "11111111";  -- 299E = FF
      when "010100110011111" =>  data <= "11111111";  -- 299F = FF
      when "010100110100000" =>  data <= "11111111";  -- 29A0 = FF
      when "010100110100001" =>  data <= "11111111";  -- 29A1 = FF
      when "010100110100010" =>  data <= "11111111";  -- 29A2 = FF
      when "010100110100011" =>  data <= "11111111";  -- 29A3 = FF
      when "010100110100100" =>  data <= "11111111";  -- 29A4 = FF
      when "010100110100101" =>  data <= "11111111";  -- 29A5 = FF
      when "010100110100110" =>  data <= "11111111";  -- 29A6 = FF
      when "010100110100111" =>  data <= "11111111";  -- 29A7 = FF
      when "010100110101000" =>  data <= "11111111";  -- 29A8 = FF
      when "010100110101001" =>  data <= "11111111";  -- 29A9 = FF
      when "010100110101010" =>  data <= "11111111";  -- 29AA = FF
      when "010100110101011" =>  data <= "11111111";  -- 29AB = FF
      when "010100110101100" =>  data <= "11111111";  -- 29AC = FF
      when "010100110101101" =>  data <= "11111111";  -- 29AD = FF
      when "010100110101110" =>  data <= "11111111";  -- 29AE = FF
      when "010100110101111" =>  data <= "11111111";  -- 29AF = FF
      when "010100110110000" =>  data <= "11111111";  -- 29B0 = FF
      when "010100110110001" =>  data <= "11111111";  -- 29B1 = FF
      when "010100110110010" =>  data <= "11111111";  -- 29B2 = FF
      when "010100110110011" =>  data <= "11111111";  -- 29B3 = FF
      when "010100110110100" =>  data <= "11111111";  -- 29B4 = FF
      when "010100110110101" =>  data <= "11111111";  -- 29B5 = FF
      when "010100110110110" =>  data <= "11111111";  -- 29B6 = FF
      when "010100110110111" =>  data <= "11111111";  -- 29B7 = FF
      when "010100110111000" =>  data <= "11111111";  -- 29B8 = FF
      when "010100110111001" =>  data <= "11111111";  -- 29B9 = FF
      when "010100110111010" =>  data <= "11111111";  -- 29BA = FF
      when "010100110111011" =>  data <= "11111111";  -- 29BB = FF
      when "010100110111100" =>  data <= "11111111";  -- 29BC = FF
      when "010100110111101" =>  data <= "11111111";  -- 29BD = FF
      when "010100110111110" =>  data <= "11111111";  -- 29BE = FF
      when "010100110111111" =>  data <= "11111111";  -- 29BF = FF
      when "010100111000000" =>  data <= "11111111";  -- 29C0 = FF
      when "010100111000001" =>  data <= "11111111";  -- 29C1 = FF
      when "010100111000010" =>  data <= "11111111";  -- 29C2 = FF
      when "010100111000011" =>  data <= "11111111";  -- 29C3 = FF
      when "010100111000100" =>  data <= "11111111";  -- 29C4 = FF
      when "010100111000101" =>  data <= "11111111";  -- 29C5 = FF
      when "010100111000110" =>  data <= "11111111";  -- 29C6 = FF
      when "010100111000111" =>  data <= "11111111";  -- 29C7 = FF
      when "010100111001000" =>  data <= "11111111";  -- 29C8 = FF
      when "010100111001001" =>  data <= "11111111";  -- 29C9 = FF
      when "010100111001010" =>  data <= "11111111";  -- 29CA = FF
      when "010100111001011" =>  data <= "11111111";  -- 29CB = FF
      when "010100111001100" =>  data <= "11111111";  -- 29CC = FF
      when "010100111001101" =>  data <= "11111111";  -- 29CD = FF
      when "010100111001110" =>  data <= "11111111";  -- 29CE = FF
      when "010100111001111" =>  data <= "11111111";  -- 29CF = FF
      when "010100111010000" =>  data <= "11111111";  -- 29D0 = FF
      when "010100111010001" =>  data <= "11111111";  -- 29D1 = FF
      when "010100111010010" =>  data <= "11111111";  -- 29D2 = FF
      when "010100111010011" =>  data <= "11111111";  -- 29D3 = FF
      when "010100111010100" =>  data <= "11111111";  -- 29D4 = FF
      when "010100111010101" =>  data <= "11111111";  -- 29D5 = FF
      when "010100111010110" =>  data <= "11111111";  -- 29D6 = FF
      when "010100111010111" =>  data <= "11111111";  -- 29D7 = FF
      when "010100111011000" =>  data <= "11111111";  -- 29D8 = FF
      when "010100111011001" =>  data <= "11111111";  -- 29D9 = FF
      when "010100111011010" =>  data <= "11111111";  -- 29DA = FF
      when "010100111011011" =>  data <= "11111111";  -- 29DB = FF
      when "010100111011100" =>  data <= "11111111";  -- 29DC = FF
      when "010100111011101" =>  data <= "11111111";  -- 29DD = FF
      when "010100111011110" =>  data <= "11111111";  -- 29DE = FF
      when "010100111011111" =>  data <= "11111111";  -- 29DF = FF
      when "010100111100000" =>  data <= "11111111";  -- 29E0 = FF
      when "010100111100001" =>  data <= "11111111";  -- 29E1 = FF
      when "010100111100010" =>  data <= "11111111";  -- 29E2 = FF
      when "010100111100011" =>  data <= "11111111";  -- 29E3 = FF
      when "010100111100100" =>  data <= "11111111";  -- 29E4 = FF
      when "010100111100101" =>  data <= "11111111";  -- 29E5 = FF
      when "010100111100110" =>  data <= "11111111";  -- 29E6 = FF
      when "010100111100111" =>  data <= "11111111";  -- 29E7 = FF
      when "010100111101000" =>  data <= "11111111";  -- 29E8 = FF
      when "010100111101001" =>  data <= "11111111";  -- 29E9 = FF
      when "010100111101010" =>  data <= "11111111";  -- 29EA = FF
      when "010100111101011" =>  data <= "11111111";  -- 29EB = FF
      when "010100111101100" =>  data <= "11111111";  -- 29EC = FF
      when "010100111101101" =>  data <= "11111111";  -- 29ED = FF
      when "010100111101110" =>  data <= "11111111";  -- 29EE = FF
      when "010100111101111" =>  data <= "11111111";  -- 29EF = FF
      when "010100111110000" =>  data <= "11111111";  -- 29F0 = FF
      when "010100111110001" =>  data <= "11111111";  -- 29F1 = FF
      when "010100111110010" =>  data <= "11111111";  -- 29F2 = FF
      when "010100111110011" =>  data <= "11111111";  -- 29F3 = FF
      when "010100111110100" =>  data <= "11111111";  -- 29F4 = FF
      when "010100111110101" =>  data <= "11111111";  -- 29F5 = FF
      when "010100111110110" =>  data <= "11111111";  -- 29F6 = FF
      when "010100111110111" =>  data <= "11111111";  -- 29F7 = FF
      when "010100111111000" =>  data <= "11111111";  -- 29F8 = FF
      when "010100111111001" =>  data <= "11111111";  -- 29F9 = FF
      when "010100111111010" =>  data <= "11111111";  -- 29FA = FF
      when "010100111111011" =>  data <= "11111111";  -- 29FB = FF
      when "010100111111100" =>  data <= "11111111";  -- 29FC = FF
      when "010100111111101" =>  data <= "11111111";  -- 29FD = FF
      when "010100111111110" =>  data <= "11111111";  -- 29FE = FF
      when "010100111111111" =>  data <= "11111111";  -- 29FF = FF
      when "010101000000000" =>  data <= "11111111";  -- 2A00 = FF
      when "010101000000001" =>  data <= "11111111";  -- 2A01 = FF
      when "010101000000010" =>  data <= "11111111";  -- 2A02 = FF
      when "010101000000011" =>  data <= "11111111";  -- 2A03 = FF
      when "010101000000100" =>  data <= "11111111";  -- 2A04 = FF
      when "010101000000101" =>  data <= "11111111";  -- 2A05 = FF
      when "010101000000110" =>  data <= "11111111";  -- 2A06 = FF
      when "010101000000111" =>  data <= "11111111";  -- 2A07 = FF
      when "010101000001000" =>  data <= "11111111";  -- 2A08 = FF
      when "010101000001001" =>  data <= "11111111";  -- 2A09 = FF
      when "010101000001010" =>  data <= "11111111";  -- 2A0A = FF
      when "010101000001011" =>  data <= "11111111";  -- 2A0B = FF
      when "010101000001100" =>  data <= "11111111";  -- 2A0C = FF
      when "010101000001101" =>  data <= "11111111";  -- 2A0D = FF
      when "010101000001110" =>  data <= "11111111";  -- 2A0E = FF
      when "010101000001111" =>  data <= "11111111";  -- 2A0F = FF
      when "010101000010000" =>  data <= "11111111";  -- 2A10 = FF
      when "010101000010001" =>  data <= "11111111";  -- 2A11 = FF
      when "010101000010010" =>  data <= "11111111";  -- 2A12 = FF
      when "010101000010011" =>  data <= "11111111";  -- 2A13 = FF
      when "010101000010100" =>  data <= "11111111";  -- 2A14 = FF
      when "010101000010101" =>  data <= "11111111";  -- 2A15 = FF
      when "010101000010110" =>  data <= "11111111";  -- 2A16 = FF
      when "010101000010111" =>  data <= "11111111";  -- 2A17 = FF
      when "010101000011000" =>  data <= "11111111";  -- 2A18 = FF
      when "010101000011001" =>  data <= "11111111";  -- 2A19 = FF
      when "010101000011010" =>  data <= "11111111";  -- 2A1A = FF
      when "010101000011011" =>  data <= "11111111";  -- 2A1B = FF
      when "010101000011100" =>  data <= "11111111";  -- 2A1C = FF
      when "010101000011101" =>  data <= "11111111";  -- 2A1D = FF
      when "010101000011110" =>  data <= "11111111";  -- 2A1E = FF
      when "010101000011111" =>  data <= "11111111";  -- 2A1F = FF
      when "010101000100000" =>  data <= "11111111";  -- 2A20 = FF
      when "010101000100001" =>  data <= "11111111";  -- 2A21 = FF
      when "010101000100010" =>  data <= "11111111";  -- 2A22 = FF
      when "010101000100011" =>  data <= "11111111";  -- 2A23 = FF
      when "010101000100100" =>  data <= "11111111";  -- 2A24 = FF
      when "010101000100101" =>  data <= "11111111";  -- 2A25 = FF
      when "010101000100110" =>  data <= "11111111";  -- 2A26 = FF
      when "010101000100111" =>  data <= "11111111";  -- 2A27 = FF
      when "010101000101000" =>  data <= "11111111";  -- 2A28 = FF
      when "010101000101001" =>  data <= "11111111";  -- 2A29 = FF
      when "010101000101010" =>  data <= "11111111";  -- 2A2A = FF
      when "010101000101011" =>  data <= "11111111";  -- 2A2B = FF
      when "010101000101100" =>  data <= "11111111";  -- 2A2C = FF
      when "010101000101101" =>  data <= "11111111";  -- 2A2D = FF
      when "010101000101110" =>  data <= "11111111";  -- 2A2E = FF
      when "010101000101111" =>  data <= "11111111";  -- 2A2F = FF
      when "010101000110000" =>  data <= "11111111";  -- 2A30 = FF
      when "010101000110001" =>  data <= "11111111";  -- 2A31 = FF
      when "010101000110010" =>  data <= "11111111";  -- 2A32 = FF
      when "010101000110011" =>  data <= "11111111";  -- 2A33 = FF
      when "010101000110100" =>  data <= "11111111";  -- 2A34 = FF
      when "010101000110101" =>  data <= "11111111";  -- 2A35 = FF
      when "010101000110110" =>  data <= "11111111";  -- 2A36 = FF
      when "010101000110111" =>  data <= "11111111";  -- 2A37 = FF
      when "010101000111000" =>  data <= "11111111";  -- 2A38 = FF
      when "010101000111001" =>  data <= "11111111";  -- 2A39 = FF
      when "010101000111010" =>  data <= "11111111";  -- 2A3A = FF
      when "010101000111011" =>  data <= "11111111";  -- 2A3B = FF
      when "010101000111100" =>  data <= "11111111";  -- 2A3C = FF
      when "010101000111101" =>  data <= "11111111";  -- 2A3D = FF
      when "010101000111110" =>  data <= "11111111";  -- 2A3E = FF
      when "010101000111111" =>  data <= "11111111";  -- 2A3F = FF
      when "010101001000000" =>  data <= "11111111";  -- 2A40 = FF
      when "010101001000001" =>  data <= "11111111";  -- 2A41 = FF
      when "010101001000010" =>  data <= "11111111";  -- 2A42 = FF
      when "010101001000011" =>  data <= "11111111";  -- 2A43 = FF
      when "010101001000100" =>  data <= "11111111";  -- 2A44 = FF
      when "010101001000101" =>  data <= "11111111";  -- 2A45 = FF
      when "010101001000110" =>  data <= "11111111";  -- 2A46 = FF
      when "010101001000111" =>  data <= "11111111";  -- 2A47 = FF
      when "010101001001000" =>  data <= "11111111";  -- 2A48 = FF
      when "010101001001001" =>  data <= "11111111";  -- 2A49 = FF
      when "010101001001010" =>  data <= "11111111";  -- 2A4A = FF
      when "010101001001011" =>  data <= "11111111";  -- 2A4B = FF
      when "010101001001100" =>  data <= "11111111";  -- 2A4C = FF
      when "010101001001101" =>  data <= "11111111";  -- 2A4D = FF
      when "010101001001110" =>  data <= "11111111";  -- 2A4E = FF
      when "010101001001111" =>  data <= "11111111";  -- 2A4F = FF
      when "010101001010000" =>  data <= "11111111";  -- 2A50 = FF
      when "010101001010001" =>  data <= "11111111";  -- 2A51 = FF
      when "010101001010010" =>  data <= "11111111";  -- 2A52 = FF
      when "010101001010011" =>  data <= "11111111";  -- 2A53 = FF
      when "010101001010100" =>  data <= "11111111";  -- 2A54 = FF
      when "010101001010101" =>  data <= "11111111";  -- 2A55 = FF
      when "010101001010110" =>  data <= "11111111";  -- 2A56 = FF
      when "010101001010111" =>  data <= "11111111";  -- 2A57 = FF
      when "010101001011000" =>  data <= "11111111";  -- 2A58 = FF
      when "010101001011001" =>  data <= "11111111";  -- 2A59 = FF
      when "010101001011010" =>  data <= "11111111";  -- 2A5A = FF
      when "010101001011011" =>  data <= "11111111";  -- 2A5B = FF
      when "010101001011100" =>  data <= "11111111";  -- 2A5C = FF
      when "010101001011101" =>  data <= "11111111";  -- 2A5D = FF
      when "010101001011110" =>  data <= "11111111";  -- 2A5E = FF
      when "010101001011111" =>  data <= "11111111";  -- 2A5F = FF
      when "010101001100000" =>  data <= "11111111";  -- 2A60 = FF
      when "010101001100001" =>  data <= "11111111";  -- 2A61 = FF
      when "010101001100010" =>  data <= "11111111";  -- 2A62 = FF
      when "010101001100011" =>  data <= "11111111";  -- 2A63 = FF
      when "010101001100100" =>  data <= "11111111";  -- 2A64 = FF
      when "010101001100101" =>  data <= "11111111";  -- 2A65 = FF
      when "010101001100110" =>  data <= "11111111";  -- 2A66 = FF
      when "010101001100111" =>  data <= "11111111";  -- 2A67 = FF
      when "010101001101000" =>  data <= "11111111";  -- 2A68 = FF
      when "010101001101001" =>  data <= "11111111";  -- 2A69 = FF
      when "010101001101010" =>  data <= "11111111";  -- 2A6A = FF
      when "010101001101011" =>  data <= "11111111";  -- 2A6B = FF
      when "010101001101100" =>  data <= "11111111";  -- 2A6C = FF
      when "010101001101101" =>  data <= "11111111";  -- 2A6D = FF
      when "010101001101110" =>  data <= "11111111";  -- 2A6E = FF
      when "010101001101111" =>  data <= "11111111";  -- 2A6F = FF
      when "010101001110000" =>  data <= "11111111";  -- 2A70 = FF
      when "010101001110001" =>  data <= "11111111";  -- 2A71 = FF
      when "010101001110010" =>  data <= "11111111";  -- 2A72 = FF
      when "010101001110011" =>  data <= "11111111";  -- 2A73 = FF
      when "010101001110100" =>  data <= "11111111";  -- 2A74 = FF
      when "010101001110101" =>  data <= "11111111";  -- 2A75 = FF
      when "010101001110110" =>  data <= "11111111";  -- 2A76 = FF
      when "010101001110111" =>  data <= "11111111";  -- 2A77 = FF
      when "010101001111000" =>  data <= "11111111";  -- 2A78 = FF
      when "010101001111001" =>  data <= "11111111";  -- 2A79 = FF
      when "010101001111010" =>  data <= "11111111";  -- 2A7A = FF
      when "010101001111011" =>  data <= "11111111";  -- 2A7B = FF
      when "010101001111100" =>  data <= "11111111";  -- 2A7C = FF
      when "010101001111101" =>  data <= "11111111";  -- 2A7D = FF
      when "010101001111110" =>  data <= "11111111";  -- 2A7E = FF
      when "010101001111111" =>  data <= "11111111";  -- 2A7F = FF
      when "010101010000000" =>  data <= "11111111";  -- 2A80 = FF
      when "010101010000001" =>  data <= "11111111";  -- 2A81 = FF
      when "010101010000010" =>  data <= "11111111";  -- 2A82 = FF
      when "010101010000011" =>  data <= "11111111";  -- 2A83 = FF
      when "010101010000100" =>  data <= "11111111";  -- 2A84 = FF
      when "010101010000101" =>  data <= "11111111";  -- 2A85 = FF
      when "010101010000110" =>  data <= "11111111";  -- 2A86 = FF
      when "010101010000111" =>  data <= "11111111";  -- 2A87 = FF
      when "010101010001000" =>  data <= "11111111";  -- 2A88 = FF
      when "010101010001001" =>  data <= "11111111";  -- 2A89 = FF
      when "010101010001010" =>  data <= "11111111";  -- 2A8A = FF
      when "010101010001011" =>  data <= "11111111";  -- 2A8B = FF
      when "010101010001100" =>  data <= "11111111";  -- 2A8C = FF
      when "010101010001101" =>  data <= "11111111";  -- 2A8D = FF
      when "010101010001110" =>  data <= "11111111";  -- 2A8E = FF
      when "010101010001111" =>  data <= "11111111";  -- 2A8F = FF
      when "010101010010000" =>  data <= "11111111";  -- 2A90 = FF
      when "010101010010001" =>  data <= "11111111";  -- 2A91 = FF
      when "010101010010010" =>  data <= "11111111";  -- 2A92 = FF
      when "010101010010011" =>  data <= "11111111";  -- 2A93 = FF
      when "010101010010100" =>  data <= "11111111";  -- 2A94 = FF
      when "010101010010101" =>  data <= "11111111";  -- 2A95 = FF
      when "010101010010110" =>  data <= "11111111";  -- 2A96 = FF
      when "010101010010111" =>  data <= "11111111";  -- 2A97 = FF
      when "010101010011000" =>  data <= "11111111";  -- 2A98 = FF
      when "010101010011001" =>  data <= "11111111";  -- 2A99 = FF
      when "010101010011010" =>  data <= "11111111";  -- 2A9A = FF
      when "010101010011011" =>  data <= "11111111";  -- 2A9B = FF
      when "010101010011100" =>  data <= "11111111";  -- 2A9C = FF
      when "010101010011101" =>  data <= "11111111";  -- 2A9D = FF
      when "010101010011110" =>  data <= "11111111";  -- 2A9E = FF
      when "010101010011111" =>  data <= "11111111";  -- 2A9F = FF
      when "010101010100000" =>  data <= "11111111";  -- 2AA0 = FF
      when "010101010100001" =>  data <= "11111111";  -- 2AA1 = FF
      when "010101010100010" =>  data <= "11111111";  -- 2AA2 = FF
      when "010101010100011" =>  data <= "11111111";  -- 2AA3 = FF
      when "010101010100100" =>  data <= "11111111";  -- 2AA4 = FF
      when "010101010100101" =>  data <= "11111111";  -- 2AA5 = FF
      when "010101010100110" =>  data <= "11111111";  -- 2AA6 = FF
      when "010101010100111" =>  data <= "11111111";  -- 2AA7 = FF
      when "010101010101000" =>  data <= "11111111";  -- 2AA8 = FF
      when "010101010101001" =>  data <= "11111111";  -- 2AA9 = FF
      when "010101010101010" =>  data <= "11111111";  -- 2AAA = FF
      when "010101010101011" =>  data <= "11111111";  -- 2AAB = FF
      when "010101010101100" =>  data <= "11111111";  -- 2AAC = FF
      when "010101010101101" =>  data <= "11111111";  -- 2AAD = FF
      when "010101010101110" =>  data <= "11111111";  -- 2AAE = FF
      when "010101010101111" =>  data <= "11111111";  -- 2AAF = FF
      when "010101010110000" =>  data <= "11111111";  -- 2AB0 = FF
      when "010101010110001" =>  data <= "11111111";  -- 2AB1 = FF
      when "010101010110010" =>  data <= "11111111";  -- 2AB2 = FF
      when "010101010110011" =>  data <= "11111111";  -- 2AB3 = FF
      when "010101010110100" =>  data <= "11111111";  -- 2AB4 = FF
      when "010101010110101" =>  data <= "11111111";  -- 2AB5 = FF
      when "010101010110110" =>  data <= "11111111";  -- 2AB6 = FF
      when "010101010110111" =>  data <= "11111111";  -- 2AB7 = FF
      when "010101010111000" =>  data <= "11111111";  -- 2AB8 = FF
      when "010101010111001" =>  data <= "11111111";  -- 2AB9 = FF
      when "010101010111010" =>  data <= "11111111";  -- 2ABA = FF
      when "010101010111011" =>  data <= "11111111";  -- 2ABB = FF
      when "010101010111100" =>  data <= "11111111";  -- 2ABC = FF
      when "010101010111101" =>  data <= "11111111";  -- 2ABD = FF
      when "010101010111110" =>  data <= "11111111";  -- 2ABE = FF
      when "010101010111111" =>  data <= "11111111";  -- 2ABF = FF
      when "010101011000000" =>  data <= "11111111";  -- 2AC0 = FF
      when "010101011000001" =>  data <= "11111111";  -- 2AC1 = FF
      when "010101011000010" =>  data <= "11111111";  -- 2AC2 = FF
      when "010101011000011" =>  data <= "11111111";  -- 2AC3 = FF
      when "010101011000100" =>  data <= "11111111";  -- 2AC4 = FF
      when "010101011000101" =>  data <= "11111111";  -- 2AC5 = FF
      when "010101011000110" =>  data <= "11111111";  -- 2AC6 = FF
      when "010101011000111" =>  data <= "11111111";  -- 2AC7 = FF
      when "010101011001000" =>  data <= "11111111";  -- 2AC8 = FF
      when "010101011001001" =>  data <= "11111111";  -- 2AC9 = FF
      when "010101011001010" =>  data <= "11111111";  -- 2ACA = FF
      when "010101011001011" =>  data <= "11111111";  -- 2ACB = FF
      when "010101011001100" =>  data <= "11111111";  -- 2ACC = FF
      when "010101011001101" =>  data <= "11111111";  -- 2ACD = FF
      when "010101011001110" =>  data <= "11111111";  -- 2ACE = FF
      when "010101011001111" =>  data <= "11111111";  -- 2ACF = FF
      when "010101011010000" =>  data <= "11111111";  -- 2AD0 = FF
      when "010101011010001" =>  data <= "11111111";  -- 2AD1 = FF
      when "010101011010010" =>  data <= "11111111";  -- 2AD2 = FF
      when "010101011010011" =>  data <= "11111111";  -- 2AD3 = FF
      when "010101011010100" =>  data <= "11111111";  -- 2AD4 = FF
      when "010101011010101" =>  data <= "11111111";  -- 2AD5 = FF
      when "010101011010110" =>  data <= "11111111";  -- 2AD6 = FF
      when "010101011010111" =>  data <= "11111111";  -- 2AD7 = FF
      when "010101011011000" =>  data <= "11111111";  -- 2AD8 = FF
      when "010101011011001" =>  data <= "11111111";  -- 2AD9 = FF
      when "010101011011010" =>  data <= "11111111";  -- 2ADA = FF
      when "010101011011011" =>  data <= "11111111";  -- 2ADB = FF
      when "010101011011100" =>  data <= "11111111";  -- 2ADC = FF
      when "010101011011101" =>  data <= "11111111";  -- 2ADD = FF
      when "010101011011110" =>  data <= "11111111";  -- 2ADE = FF
      when "010101011011111" =>  data <= "11111111";  -- 2ADF = FF
      when "010101011100000" =>  data <= "11111111";  -- 2AE0 = FF
      when "010101011100001" =>  data <= "11111111";  -- 2AE1 = FF
      when "010101011100010" =>  data <= "11111111";  -- 2AE2 = FF
      when "010101011100011" =>  data <= "11111111";  -- 2AE3 = FF
      when "010101011100100" =>  data <= "11111111";  -- 2AE4 = FF
      when "010101011100101" =>  data <= "11111111";  -- 2AE5 = FF
      when "010101011100110" =>  data <= "11111111";  -- 2AE6 = FF
      when "010101011100111" =>  data <= "11111111";  -- 2AE7 = FF
      when "010101011101000" =>  data <= "11111111";  -- 2AE8 = FF
      when "010101011101001" =>  data <= "11111111";  -- 2AE9 = FF
      when "010101011101010" =>  data <= "11111111";  -- 2AEA = FF
      when "010101011101011" =>  data <= "11111111";  -- 2AEB = FF
      when "010101011101100" =>  data <= "11111111";  -- 2AEC = FF
      when "010101011101101" =>  data <= "11111111";  -- 2AED = FF
      when "010101011101110" =>  data <= "11111111";  -- 2AEE = FF
      when "010101011101111" =>  data <= "11111111";  -- 2AEF = FF
      when "010101011110000" =>  data <= "11111111";  -- 2AF0 = FF
      when "010101011110001" =>  data <= "11111111";  -- 2AF1 = FF
      when "010101011110010" =>  data <= "11111111";  -- 2AF2 = FF
      when "010101011110011" =>  data <= "11111111";  -- 2AF3 = FF
      when "010101011110100" =>  data <= "11111111";  -- 2AF4 = FF
      when "010101011110101" =>  data <= "11111111";  -- 2AF5 = FF
      when "010101011110110" =>  data <= "11111111";  -- 2AF6 = FF
      when "010101011110111" =>  data <= "11111111";  -- 2AF7 = FF
      when "010101011111000" =>  data <= "11111111";  -- 2AF8 = FF
      when "010101011111001" =>  data <= "11111111";  -- 2AF9 = FF
      when "010101011111010" =>  data <= "11111111";  -- 2AFA = FF
      when "010101011111011" =>  data <= "11111111";  -- 2AFB = FF
      when "010101011111100" =>  data <= "11111111";  -- 2AFC = FF
      when "010101011111101" =>  data <= "11111111";  -- 2AFD = FF
      when "010101011111110" =>  data <= "11111111";  -- 2AFE = FF
      when "010101011111111" =>  data <= "11111111";  -- 2AFF = FF
      when "010101100000000" =>  data <= "11111111";  -- 2B00 = FF
      when "010101100000001" =>  data <= "11111111";  -- 2B01 = FF
      when "010101100000010" =>  data <= "11111111";  -- 2B02 = FF
      when "010101100000011" =>  data <= "11111111";  -- 2B03 = FF
      when "010101100000100" =>  data <= "11111111";  -- 2B04 = FF
      when "010101100000101" =>  data <= "11111111";  -- 2B05 = FF
      when "010101100000110" =>  data <= "11111111";  -- 2B06 = FF
      when "010101100000111" =>  data <= "11111111";  -- 2B07 = FF
      when "010101100001000" =>  data <= "11111111";  -- 2B08 = FF
      when "010101100001001" =>  data <= "11111111";  -- 2B09 = FF
      when "010101100001010" =>  data <= "11111111";  -- 2B0A = FF
      when "010101100001011" =>  data <= "11111111";  -- 2B0B = FF
      when "010101100001100" =>  data <= "11111111";  -- 2B0C = FF
      when "010101100001101" =>  data <= "11111111";  -- 2B0D = FF
      when "010101100001110" =>  data <= "11111111";  -- 2B0E = FF
      when "010101100001111" =>  data <= "11111111";  -- 2B0F = FF
      when "010101100010000" =>  data <= "11111111";  -- 2B10 = FF
      when "010101100010001" =>  data <= "11111111";  -- 2B11 = FF
      when "010101100010010" =>  data <= "11111111";  -- 2B12 = FF
      when "010101100010011" =>  data <= "11111111";  -- 2B13 = FF
      when "010101100010100" =>  data <= "11111111";  -- 2B14 = FF
      when "010101100010101" =>  data <= "11111111";  -- 2B15 = FF
      when "010101100010110" =>  data <= "11111111";  -- 2B16 = FF
      when "010101100010111" =>  data <= "11111111";  -- 2B17 = FF
      when "010101100011000" =>  data <= "11111111";  -- 2B18 = FF
      when "010101100011001" =>  data <= "11111111";  -- 2B19 = FF
      when "010101100011010" =>  data <= "11111111";  -- 2B1A = FF
      when "010101100011011" =>  data <= "11111111";  -- 2B1B = FF
      when "010101100011100" =>  data <= "11111111";  -- 2B1C = FF
      when "010101100011101" =>  data <= "11111111";  -- 2B1D = FF
      when "010101100011110" =>  data <= "11111111";  -- 2B1E = FF
      when "010101100011111" =>  data <= "11111111";  -- 2B1F = FF
      when "010101100100000" =>  data <= "11111111";  -- 2B20 = FF
      when "010101100100001" =>  data <= "11111111";  -- 2B21 = FF
      when "010101100100010" =>  data <= "11111111";  -- 2B22 = FF
      when "010101100100011" =>  data <= "11111111";  -- 2B23 = FF
      when "010101100100100" =>  data <= "11111111";  -- 2B24 = FF
      when "010101100100101" =>  data <= "11111111";  -- 2B25 = FF
      when "010101100100110" =>  data <= "11111111";  -- 2B26 = FF
      when "010101100100111" =>  data <= "11111111";  -- 2B27 = FF
      when "010101100101000" =>  data <= "11111111";  -- 2B28 = FF
      when "010101100101001" =>  data <= "11111111";  -- 2B29 = FF
      when "010101100101010" =>  data <= "11111111";  -- 2B2A = FF
      when "010101100101011" =>  data <= "11111111";  -- 2B2B = FF
      when "010101100101100" =>  data <= "11111111";  -- 2B2C = FF
      when "010101100101101" =>  data <= "11111111";  -- 2B2D = FF
      when "010101100101110" =>  data <= "11111111";  -- 2B2E = FF
      when "010101100101111" =>  data <= "11111111";  -- 2B2F = FF
      when "010101100110000" =>  data <= "11111111";  -- 2B30 = FF
      when "010101100110001" =>  data <= "11111111";  -- 2B31 = FF
      when "010101100110010" =>  data <= "11111111";  -- 2B32 = FF
      when "010101100110011" =>  data <= "11111111";  -- 2B33 = FF
      when "010101100110100" =>  data <= "11111111";  -- 2B34 = FF
      when "010101100110101" =>  data <= "11111111";  -- 2B35 = FF
      when "010101100110110" =>  data <= "11111111";  -- 2B36 = FF
      when "010101100110111" =>  data <= "11111111";  -- 2B37 = FF
      when "010101100111000" =>  data <= "11111111";  -- 2B38 = FF
      when "010101100111001" =>  data <= "11111111";  -- 2B39 = FF
      when "010101100111010" =>  data <= "11111111";  -- 2B3A = FF
      when "010101100111011" =>  data <= "11111111";  -- 2B3B = FF
      when "010101100111100" =>  data <= "11111111";  -- 2B3C = FF
      when "010101100111101" =>  data <= "11111111";  -- 2B3D = FF
      when "010101100111110" =>  data <= "11111111";  -- 2B3E = FF
      when "010101100111111" =>  data <= "11111111";  -- 2B3F = FF
      when "010101101000000" =>  data <= "11111111";  -- 2B40 = FF
      when "010101101000001" =>  data <= "11111111";  -- 2B41 = FF
      when "010101101000010" =>  data <= "11111111";  -- 2B42 = FF
      when "010101101000011" =>  data <= "11111111";  -- 2B43 = FF
      when "010101101000100" =>  data <= "11111111";  -- 2B44 = FF
      when "010101101000101" =>  data <= "11111111";  -- 2B45 = FF
      when "010101101000110" =>  data <= "11111111";  -- 2B46 = FF
      when "010101101000111" =>  data <= "11111111";  -- 2B47 = FF
      when "010101101001000" =>  data <= "11111111";  -- 2B48 = FF
      when "010101101001001" =>  data <= "11111111";  -- 2B49 = FF
      when "010101101001010" =>  data <= "11111111";  -- 2B4A = FF
      when "010101101001011" =>  data <= "11111111";  -- 2B4B = FF
      when "010101101001100" =>  data <= "11111111";  -- 2B4C = FF
      when "010101101001101" =>  data <= "11111111";  -- 2B4D = FF
      when "010101101001110" =>  data <= "11111111";  -- 2B4E = FF
      when "010101101001111" =>  data <= "11111111";  -- 2B4F = FF
      when "010101101010000" =>  data <= "11111111";  -- 2B50 = FF
      when "010101101010001" =>  data <= "11111111";  -- 2B51 = FF
      when "010101101010010" =>  data <= "11111111";  -- 2B52 = FF
      when "010101101010011" =>  data <= "11111111";  -- 2B53 = FF
      when "010101101010100" =>  data <= "11111111";  -- 2B54 = FF
      when "010101101010101" =>  data <= "11111111";  -- 2B55 = FF
      when "010101101010110" =>  data <= "11111111";  -- 2B56 = FF
      when "010101101010111" =>  data <= "11111111";  -- 2B57 = FF
      when "010101101011000" =>  data <= "11111111";  -- 2B58 = FF
      when "010101101011001" =>  data <= "11111111";  -- 2B59 = FF
      when "010101101011010" =>  data <= "11111111";  -- 2B5A = FF
      when "010101101011011" =>  data <= "11111111";  -- 2B5B = FF
      when "010101101011100" =>  data <= "11111111";  -- 2B5C = FF
      when "010101101011101" =>  data <= "11111111";  -- 2B5D = FF
      when "010101101011110" =>  data <= "11111111";  -- 2B5E = FF
      when "010101101011111" =>  data <= "11111111";  -- 2B5F = FF
      when "010101101100000" =>  data <= "11111111";  -- 2B60 = FF
      when "010101101100001" =>  data <= "11111111";  -- 2B61 = FF
      when "010101101100010" =>  data <= "11111111";  -- 2B62 = FF
      when "010101101100011" =>  data <= "11111111";  -- 2B63 = FF
      when "010101101100100" =>  data <= "11111111";  -- 2B64 = FF
      when "010101101100101" =>  data <= "11111111";  -- 2B65 = FF
      when "010101101100110" =>  data <= "11111111";  -- 2B66 = FF
      when "010101101100111" =>  data <= "11111111";  -- 2B67 = FF
      when "010101101101000" =>  data <= "11111111";  -- 2B68 = FF
      when "010101101101001" =>  data <= "11111111";  -- 2B69 = FF
      when "010101101101010" =>  data <= "11111111";  -- 2B6A = FF
      when "010101101101011" =>  data <= "11111111";  -- 2B6B = FF
      when "010101101101100" =>  data <= "11111111";  -- 2B6C = FF
      when "010101101101101" =>  data <= "11111111";  -- 2B6D = FF
      when "010101101101110" =>  data <= "11111111";  -- 2B6E = FF
      when "010101101101111" =>  data <= "11111111";  -- 2B6F = FF
      when "010101101110000" =>  data <= "11111111";  -- 2B70 = FF
      when "010101101110001" =>  data <= "11111111";  -- 2B71 = FF
      when "010101101110010" =>  data <= "11111111";  -- 2B72 = FF
      when "010101101110011" =>  data <= "11111111";  -- 2B73 = FF
      when "010101101110100" =>  data <= "11111111";  -- 2B74 = FF
      when "010101101110101" =>  data <= "11111111";  -- 2B75 = FF
      when "010101101110110" =>  data <= "11111111";  -- 2B76 = FF
      when "010101101110111" =>  data <= "11111111";  -- 2B77 = FF
      when "010101101111000" =>  data <= "11111111";  -- 2B78 = FF
      when "010101101111001" =>  data <= "11111111";  -- 2B79 = FF
      when "010101101111010" =>  data <= "11111111";  -- 2B7A = FF
      when "010101101111011" =>  data <= "11111111";  -- 2B7B = FF
      when "010101101111100" =>  data <= "11111111";  -- 2B7C = FF
      when "010101101111101" =>  data <= "11111111";  -- 2B7D = FF
      when "010101101111110" =>  data <= "11111111";  -- 2B7E = FF
      when "010101101111111" =>  data <= "11111111";  -- 2B7F = FF
      when "010101110000000" =>  data <= "11111111";  -- 2B80 = FF
      when "010101110000001" =>  data <= "11111111";  -- 2B81 = FF
      when "010101110000010" =>  data <= "11111111";  -- 2B82 = FF
      when "010101110000011" =>  data <= "11111111";  -- 2B83 = FF
      when "010101110000100" =>  data <= "11111111";  -- 2B84 = FF
      when "010101110000101" =>  data <= "11111111";  -- 2B85 = FF
      when "010101110000110" =>  data <= "11111111";  -- 2B86 = FF
      when "010101110000111" =>  data <= "11111111";  -- 2B87 = FF
      when "010101110001000" =>  data <= "11111111";  -- 2B88 = FF
      when "010101110001001" =>  data <= "11111111";  -- 2B89 = FF
      when "010101110001010" =>  data <= "11111111";  -- 2B8A = FF
      when "010101110001011" =>  data <= "11111111";  -- 2B8B = FF
      when "010101110001100" =>  data <= "11111111";  -- 2B8C = FF
      when "010101110001101" =>  data <= "11111111";  -- 2B8D = FF
      when "010101110001110" =>  data <= "11111111";  -- 2B8E = FF
      when "010101110001111" =>  data <= "11111111";  -- 2B8F = FF
      when "010101110010000" =>  data <= "11111111";  -- 2B90 = FF
      when "010101110010001" =>  data <= "11111111";  -- 2B91 = FF
      when "010101110010010" =>  data <= "11111111";  -- 2B92 = FF
      when "010101110010011" =>  data <= "11111111";  -- 2B93 = FF
      when "010101110010100" =>  data <= "11111111";  -- 2B94 = FF
      when "010101110010101" =>  data <= "11111111";  -- 2B95 = FF
      when "010101110010110" =>  data <= "11111111";  -- 2B96 = FF
      when "010101110010111" =>  data <= "11111111";  -- 2B97 = FF
      when "010101110011000" =>  data <= "11111111";  -- 2B98 = FF
      when "010101110011001" =>  data <= "11111111";  -- 2B99 = FF
      when "010101110011010" =>  data <= "11111111";  -- 2B9A = FF
      when "010101110011011" =>  data <= "11111111";  -- 2B9B = FF
      when "010101110011100" =>  data <= "11111111";  -- 2B9C = FF
      when "010101110011101" =>  data <= "11111111";  -- 2B9D = FF
      when "010101110011110" =>  data <= "11111111";  -- 2B9E = FF
      when "010101110011111" =>  data <= "11111111";  -- 2B9F = FF
      when "010101110100000" =>  data <= "11111111";  -- 2BA0 = FF
      when "010101110100001" =>  data <= "11111111";  -- 2BA1 = FF
      when "010101110100010" =>  data <= "11111111";  -- 2BA2 = FF
      when "010101110100011" =>  data <= "11111111";  -- 2BA3 = FF
      when "010101110100100" =>  data <= "11111111";  -- 2BA4 = FF
      when "010101110100101" =>  data <= "11111111";  -- 2BA5 = FF
      when "010101110100110" =>  data <= "11111111";  -- 2BA6 = FF
      when "010101110100111" =>  data <= "11111111";  -- 2BA7 = FF
      when "010101110101000" =>  data <= "11111111";  -- 2BA8 = FF
      when "010101110101001" =>  data <= "11111111";  -- 2BA9 = FF
      when "010101110101010" =>  data <= "11111111";  -- 2BAA = FF
      when "010101110101011" =>  data <= "11111111";  -- 2BAB = FF
      when "010101110101100" =>  data <= "11111111";  -- 2BAC = FF
      when "010101110101101" =>  data <= "11111111";  -- 2BAD = FF
      when "010101110101110" =>  data <= "11111111";  -- 2BAE = FF
      when "010101110101111" =>  data <= "11111111";  -- 2BAF = FF
      when "010101110110000" =>  data <= "11111111";  -- 2BB0 = FF
      when "010101110110001" =>  data <= "11111111";  -- 2BB1 = FF
      when "010101110110010" =>  data <= "11111111";  -- 2BB2 = FF
      when "010101110110011" =>  data <= "11111111";  -- 2BB3 = FF
      when "010101110110100" =>  data <= "11111111";  -- 2BB4 = FF
      when "010101110110101" =>  data <= "11111111";  -- 2BB5 = FF
      when "010101110110110" =>  data <= "11111111";  -- 2BB6 = FF
      when "010101110110111" =>  data <= "11111111";  -- 2BB7 = FF
      when "010101110111000" =>  data <= "11111111";  -- 2BB8 = FF
      when "010101110111001" =>  data <= "11111111";  -- 2BB9 = FF
      when "010101110111010" =>  data <= "11111111";  -- 2BBA = FF
      when "010101110111011" =>  data <= "11111111";  -- 2BBB = FF
      when "010101110111100" =>  data <= "11111111";  -- 2BBC = FF
      when "010101110111101" =>  data <= "11111111";  -- 2BBD = FF
      when "010101110111110" =>  data <= "11111111";  -- 2BBE = FF
      when "010101110111111" =>  data <= "11111111";  -- 2BBF = FF
      when "010101111000000" =>  data <= "11111111";  -- 2BC0 = FF
      when "010101111000001" =>  data <= "11111111";  -- 2BC1 = FF
      when "010101111000010" =>  data <= "11111111";  -- 2BC2 = FF
      when "010101111000011" =>  data <= "11111111";  -- 2BC3 = FF
      when "010101111000100" =>  data <= "11111111";  -- 2BC4 = FF
      when "010101111000101" =>  data <= "11111111";  -- 2BC5 = FF
      when "010101111000110" =>  data <= "11111111";  -- 2BC6 = FF
      when "010101111000111" =>  data <= "11111111";  -- 2BC7 = FF
      when "010101111001000" =>  data <= "11111111";  -- 2BC8 = FF
      when "010101111001001" =>  data <= "11111111";  -- 2BC9 = FF
      when "010101111001010" =>  data <= "11111111";  -- 2BCA = FF
      when "010101111001011" =>  data <= "11111111";  -- 2BCB = FF
      when "010101111001100" =>  data <= "11111111";  -- 2BCC = FF
      when "010101111001101" =>  data <= "11111111";  -- 2BCD = FF
      when "010101111001110" =>  data <= "11111111";  -- 2BCE = FF
      when "010101111001111" =>  data <= "11111111";  -- 2BCF = FF
      when "010101111010000" =>  data <= "11111111";  -- 2BD0 = FF
      when "010101111010001" =>  data <= "11111111";  -- 2BD1 = FF
      when "010101111010010" =>  data <= "11111111";  -- 2BD2 = FF
      when "010101111010011" =>  data <= "11111111";  -- 2BD3 = FF
      when "010101111010100" =>  data <= "11111111";  -- 2BD4 = FF
      when "010101111010101" =>  data <= "11111111";  -- 2BD5 = FF
      when "010101111010110" =>  data <= "11111111";  -- 2BD6 = FF
      when "010101111010111" =>  data <= "11111111";  -- 2BD7 = FF
      when "010101111011000" =>  data <= "11111111";  -- 2BD8 = FF
      when "010101111011001" =>  data <= "11111111";  -- 2BD9 = FF
      when "010101111011010" =>  data <= "11111111";  -- 2BDA = FF
      when "010101111011011" =>  data <= "11111111";  -- 2BDB = FF
      when "010101111011100" =>  data <= "11111111";  -- 2BDC = FF
      when "010101111011101" =>  data <= "11111111";  -- 2BDD = FF
      when "010101111011110" =>  data <= "11111111";  -- 2BDE = FF
      when "010101111011111" =>  data <= "11111111";  -- 2BDF = FF
      when "010101111100000" =>  data <= "11111111";  -- 2BE0 = FF
      when "010101111100001" =>  data <= "11111111";  -- 2BE1 = FF
      when "010101111100010" =>  data <= "11111111";  -- 2BE2 = FF
      when "010101111100011" =>  data <= "11111111";  -- 2BE3 = FF
      when "010101111100100" =>  data <= "11111111";  -- 2BE4 = FF
      when "010101111100101" =>  data <= "11111111";  -- 2BE5 = FF
      when "010101111100110" =>  data <= "11111111";  -- 2BE6 = FF
      when "010101111100111" =>  data <= "11111111";  -- 2BE7 = FF
      when "010101111101000" =>  data <= "11111111";  -- 2BE8 = FF
      when "010101111101001" =>  data <= "11111111";  -- 2BE9 = FF
      when "010101111101010" =>  data <= "11111111";  -- 2BEA = FF
      when "010101111101011" =>  data <= "11111111";  -- 2BEB = FF
      when "010101111101100" =>  data <= "11111111";  -- 2BEC = FF
      when "010101111101101" =>  data <= "11111111";  -- 2BED = FF
      when "010101111101110" =>  data <= "11111111";  -- 2BEE = FF
      when "010101111101111" =>  data <= "11111111";  -- 2BEF = FF
      when "010101111110000" =>  data <= "11111111";  -- 2BF0 = FF
      when "010101111110001" =>  data <= "11111111";  -- 2BF1 = FF
      when "010101111110010" =>  data <= "11111111";  -- 2BF2 = FF
      when "010101111110011" =>  data <= "11111111";  -- 2BF3 = FF
      when "010101111110100" =>  data <= "11111111";  -- 2BF4 = FF
      when "010101111110101" =>  data <= "11111111";  -- 2BF5 = FF
      when "010101111110110" =>  data <= "11111111";  -- 2BF6 = FF
      when "010101111110111" =>  data <= "11111111";  -- 2BF7 = FF
      when "010101111111000" =>  data <= "11111111";  -- 2BF8 = FF
      when "010101111111001" =>  data <= "11111111";  -- 2BF9 = FF
      when "010101111111010" =>  data <= "11111111";  -- 2BFA = FF
      when "010101111111011" =>  data <= "11111111";  -- 2BFB = FF
      when "010101111111100" =>  data <= "11111111";  -- 2BFC = FF
      when "010101111111101" =>  data <= "11111111";  -- 2BFD = FF
      when "010101111111110" =>  data <= "11111111";  -- 2BFE = FF
      when "010101111111111" =>  data <= "11111111";  -- 2BFF = FF
      when "010110000000000" =>  data <= "11111111";  -- 2C00 = FF
      when "010110000000001" =>  data <= "11111111";  -- 2C01 = FF
      when "010110000000010" =>  data <= "11111111";  -- 2C02 = FF
      when "010110000000011" =>  data <= "11111111";  -- 2C03 = FF
      when "010110000000100" =>  data <= "11111111";  -- 2C04 = FF
      when "010110000000101" =>  data <= "11111111";  -- 2C05 = FF
      when "010110000000110" =>  data <= "11111111";  -- 2C06 = FF
      when "010110000000111" =>  data <= "11111111";  -- 2C07 = FF
      when "010110000001000" =>  data <= "11111111";  -- 2C08 = FF
      when "010110000001001" =>  data <= "11111111";  -- 2C09 = FF
      when "010110000001010" =>  data <= "11111111";  -- 2C0A = FF
      when "010110000001011" =>  data <= "11111111";  -- 2C0B = FF
      when "010110000001100" =>  data <= "11111111";  -- 2C0C = FF
      when "010110000001101" =>  data <= "11111111";  -- 2C0D = FF
      when "010110000001110" =>  data <= "11111111";  -- 2C0E = FF
      when "010110000001111" =>  data <= "11111111";  -- 2C0F = FF
      when "010110000010000" =>  data <= "11111111";  -- 2C10 = FF
      when "010110000010001" =>  data <= "11111111";  -- 2C11 = FF
      when "010110000010010" =>  data <= "11111111";  -- 2C12 = FF
      when "010110000010011" =>  data <= "11111111";  -- 2C13 = FF
      when "010110000010100" =>  data <= "11111111";  -- 2C14 = FF
      when "010110000010101" =>  data <= "11111111";  -- 2C15 = FF
      when "010110000010110" =>  data <= "11111111";  -- 2C16 = FF
      when "010110000010111" =>  data <= "11111111";  -- 2C17 = FF
      when "010110000011000" =>  data <= "11111111";  -- 2C18 = FF
      when "010110000011001" =>  data <= "11111111";  -- 2C19 = FF
      when "010110000011010" =>  data <= "11111111";  -- 2C1A = FF
      when "010110000011011" =>  data <= "11111111";  -- 2C1B = FF
      when "010110000011100" =>  data <= "11111111";  -- 2C1C = FF
      when "010110000011101" =>  data <= "11111111";  -- 2C1D = FF
      when "010110000011110" =>  data <= "11111111";  -- 2C1E = FF
      when "010110000011111" =>  data <= "11111111";  -- 2C1F = FF
      when "010110000100000" =>  data <= "11111111";  -- 2C20 = FF
      when "010110000100001" =>  data <= "11111111";  -- 2C21 = FF
      when "010110000100010" =>  data <= "11111111";  -- 2C22 = FF
      when "010110000100011" =>  data <= "11111111";  -- 2C23 = FF
      when "010110000100100" =>  data <= "11111111";  -- 2C24 = FF
      when "010110000100101" =>  data <= "11111111";  -- 2C25 = FF
      when "010110000100110" =>  data <= "11111111";  -- 2C26 = FF
      when "010110000100111" =>  data <= "11111111";  -- 2C27 = FF
      when "010110000101000" =>  data <= "11111111";  -- 2C28 = FF
      when "010110000101001" =>  data <= "11111111";  -- 2C29 = FF
      when "010110000101010" =>  data <= "11111111";  -- 2C2A = FF
      when "010110000101011" =>  data <= "11111111";  -- 2C2B = FF
      when "010110000101100" =>  data <= "11111111";  -- 2C2C = FF
      when "010110000101101" =>  data <= "11111111";  -- 2C2D = FF
      when "010110000101110" =>  data <= "11111111";  -- 2C2E = FF
      when "010110000101111" =>  data <= "11111111";  -- 2C2F = FF
      when "010110000110000" =>  data <= "11111111";  -- 2C30 = FF
      when "010110000110001" =>  data <= "11111111";  -- 2C31 = FF
      when "010110000110010" =>  data <= "11111111";  -- 2C32 = FF
      when "010110000110011" =>  data <= "11111111";  -- 2C33 = FF
      when "010110000110100" =>  data <= "11111111";  -- 2C34 = FF
      when "010110000110101" =>  data <= "11111111";  -- 2C35 = FF
      when "010110000110110" =>  data <= "11111111";  -- 2C36 = FF
      when "010110000110111" =>  data <= "11111111";  -- 2C37 = FF
      when "010110000111000" =>  data <= "11111111";  -- 2C38 = FF
      when "010110000111001" =>  data <= "11111111";  -- 2C39 = FF
      when "010110000111010" =>  data <= "11111111";  -- 2C3A = FF
      when "010110000111011" =>  data <= "11111111";  -- 2C3B = FF
      when "010110000111100" =>  data <= "11111111";  -- 2C3C = FF
      when "010110000111101" =>  data <= "11111111";  -- 2C3D = FF
      when "010110000111110" =>  data <= "11111111";  -- 2C3E = FF
      when "010110000111111" =>  data <= "11111111";  -- 2C3F = FF
      when "010110001000000" =>  data <= "11111111";  -- 2C40 = FF
      when "010110001000001" =>  data <= "11111111";  -- 2C41 = FF
      when "010110001000010" =>  data <= "11111111";  -- 2C42 = FF
      when "010110001000011" =>  data <= "11111111";  -- 2C43 = FF
      when "010110001000100" =>  data <= "11111111";  -- 2C44 = FF
      when "010110001000101" =>  data <= "11111111";  -- 2C45 = FF
      when "010110001000110" =>  data <= "11111111";  -- 2C46 = FF
      when "010110001000111" =>  data <= "11111111";  -- 2C47 = FF
      when "010110001001000" =>  data <= "11111111";  -- 2C48 = FF
      when "010110001001001" =>  data <= "11111111";  -- 2C49 = FF
      when "010110001001010" =>  data <= "11111111";  -- 2C4A = FF
      when "010110001001011" =>  data <= "11111111";  -- 2C4B = FF
      when "010110001001100" =>  data <= "11111111";  -- 2C4C = FF
      when "010110001001101" =>  data <= "11111111";  -- 2C4D = FF
      when "010110001001110" =>  data <= "11111111";  -- 2C4E = FF
      when "010110001001111" =>  data <= "11111111";  -- 2C4F = FF
      when "010110001010000" =>  data <= "11111111";  -- 2C50 = FF
      when "010110001010001" =>  data <= "11111111";  -- 2C51 = FF
      when "010110001010010" =>  data <= "11111111";  -- 2C52 = FF
      when "010110001010011" =>  data <= "11111111";  -- 2C53 = FF
      when "010110001010100" =>  data <= "11111111";  -- 2C54 = FF
      when "010110001010101" =>  data <= "11111111";  -- 2C55 = FF
      when "010110001010110" =>  data <= "11111111";  -- 2C56 = FF
      when "010110001010111" =>  data <= "11111111";  -- 2C57 = FF
      when "010110001011000" =>  data <= "11111111";  -- 2C58 = FF
      when "010110001011001" =>  data <= "11111111";  -- 2C59 = FF
      when "010110001011010" =>  data <= "11111111";  -- 2C5A = FF
      when "010110001011011" =>  data <= "11111111";  -- 2C5B = FF
      when "010110001011100" =>  data <= "11111111";  -- 2C5C = FF
      when "010110001011101" =>  data <= "11111111";  -- 2C5D = FF
      when "010110001011110" =>  data <= "11111111";  -- 2C5E = FF
      when "010110001011111" =>  data <= "11111111";  -- 2C5F = FF
      when "010110001100000" =>  data <= "11111111";  -- 2C60 = FF
      when "010110001100001" =>  data <= "11111111";  -- 2C61 = FF
      when "010110001100010" =>  data <= "11111111";  -- 2C62 = FF
      when "010110001100011" =>  data <= "11111111";  -- 2C63 = FF
      when "010110001100100" =>  data <= "11111111";  -- 2C64 = FF
      when "010110001100101" =>  data <= "11111111";  -- 2C65 = FF
      when "010110001100110" =>  data <= "11111111";  -- 2C66 = FF
      when "010110001100111" =>  data <= "11111111";  -- 2C67 = FF
      when "010110001101000" =>  data <= "11111111";  -- 2C68 = FF
      when "010110001101001" =>  data <= "11111111";  -- 2C69 = FF
      when "010110001101010" =>  data <= "11111111";  -- 2C6A = FF
      when "010110001101011" =>  data <= "11111111";  -- 2C6B = FF
      when "010110001101100" =>  data <= "11111111";  -- 2C6C = FF
      when "010110001101101" =>  data <= "11111111";  -- 2C6D = FF
      when "010110001101110" =>  data <= "11111111";  -- 2C6E = FF
      when "010110001101111" =>  data <= "11111111";  -- 2C6F = FF
      when "010110001110000" =>  data <= "11111111";  -- 2C70 = FF
      when "010110001110001" =>  data <= "11111111";  -- 2C71 = FF
      when "010110001110010" =>  data <= "11111111";  -- 2C72 = FF
      when "010110001110011" =>  data <= "11111111";  -- 2C73 = FF
      when "010110001110100" =>  data <= "11111111";  -- 2C74 = FF
      when "010110001110101" =>  data <= "11111111";  -- 2C75 = FF
      when "010110001110110" =>  data <= "11111111";  -- 2C76 = FF
      when "010110001110111" =>  data <= "11111111";  -- 2C77 = FF
      when "010110001111000" =>  data <= "11111111";  -- 2C78 = FF
      when "010110001111001" =>  data <= "11111111";  -- 2C79 = FF
      when "010110001111010" =>  data <= "11111111";  -- 2C7A = FF
      when "010110001111011" =>  data <= "11111111";  -- 2C7B = FF
      when "010110001111100" =>  data <= "11111111";  -- 2C7C = FF
      when "010110001111101" =>  data <= "11111111";  -- 2C7D = FF
      when "010110001111110" =>  data <= "11111111";  -- 2C7E = FF
      when "010110001111111" =>  data <= "11111111";  -- 2C7F = FF
      when "010110010000000" =>  data <= "11111111";  -- 2C80 = FF
      when "010110010000001" =>  data <= "11111111";  -- 2C81 = FF
      when "010110010000010" =>  data <= "11111111";  -- 2C82 = FF
      when "010110010000011" =>  data <= "11111111";  -- 2C83 = FF
      when "010110010000100" =>  data <= "11111111";  -- 2C84 = FF
      when "010110010000101" =>  data <= "11111111";  -- 2C85 = FF
      when "010110010000110" =>  data <= "11111111";  -- 2C86 = FF
      when "010110010000111" =>  data <= "11111111";  -- 2C87 = FF
      when "010110010001000" =>  data <= "11111111";  -- 2C88 = FF
      when "010110010001001" =>  data <= "11111111";  -- 2C89 = FF
      when "010110010001010" =>  data <= "11111111";  -- 2C8A = FF
      when "010110010001011" =>  data <= "11111111";  -- 2C8B = FF
      when "010110010001100" =>  data <= "11111111";  -- 2C8C = FF
      when "010110010001101" =>  data <= "11111111";  -- 2C8D = FF
      when "010110010001110" =>  data <= "11111111";  -- 2C8E = FF
      when "010110010001111" =>  data <= "11111111";  -- 2C8F = FF
      when "010110010010000" =>  data <= "11111111";  -- 2C90 = FF
      when "010110010010001" =>  data <= "11111111";  -- 2C91 = FF
      when "010110010010010" =>  data <= "11111111";  -- 2C92 = FF
      when "010110010010011" =>  data <= "11111111";  -- 2C93 = FF
      when "010110010010100" =>  data <= "11111111";  -- 2C94 = FF
      when "010110010010101" =>  data <= "11111111";  -- 2C95 = FF
      when "010110010010110" =>  data <= "11111111";  -- 2C96 = FF
      when "010110010010111" =>  data <= "11111111";  -- 2C97 = FF
      when "010110010011000" =>  data <= "11111111";  -- 2C98 = FF
      when "010110010011001" =>  data <= "11111111";  -- 2C99 = FF
      when "010110010011010" =>  data <= "11111111";  -- 2C9A = FF
      when "010110010011011" =>  data <= "11111111";  -- 2C9B = FF
      when "010110010011100" =>  data <= "11111111";  -- 2C9C = FF
      when "010110010011101" =>  data <= "11111111";  -- 2C9D = FF
      when "010110010011110" =>  data <= "11111111";  -- 2C9E = FF
      when "010110010011111" =>  data <= "11111111";  -- 2C9F = FF
      when "010110010100000" =>  data <= "11111111";  -- 2CA0 = FF
      when "010110010100001" =>  data <= "11111111";  -- 2CA1 = FF
      when "010110010100010" =>  data <= "11111111";  -- 2CA2 = FF
      when "010110010100011" =>  data <= "11111111";  -- 2CA3 = FF
      when "010110010100100" =>  data <= "11111111";  -- 2CA4 = FF
      when "010110010100101" =>  data <= "11111111";  -- 2CA5 = FF
      when "010110010100110" =>  data <= "11111111";  -- 2CA6 = FF
      when "010110010100111" =>  data <= "11111111";  -- 2CA7 = FF
      when "010110010101000" =>  data <= "11111111";  -- 2CA8 = FF
      when "010110010101001" =>  data <= "11111111";  -- 2CA9 = FF
      when "010110010101010" =>  data <= "11111111";  -- 2CAA = FF
      when "010110010101011" =>  data <= "11111111";  -- 2CAB = FF
      when "010110010101100" =>  data <= "11111111";  -- 2CAC = FF
      when "010110010101101" =>  data <= "11111111";  -- 2CAD = FF
      when "010110010101110" =>  data <= "11111111";  -- 2CAE = FF
      when "010110010101111" =>  data <= "11111111";  -- 2CAF = FF
      when "010110010110000" =>  data <= "11111111";  -- 2CB0 = FF
      when "010110010110001" =>  data <= "11111111";  -- 2CB1 = FF
      when "010110010110010" =>  data <= "11111111";  -- 2CB2 = FF
      when "010110010110011" =>  data <= "11111111";  -- 2CB3 = FF
      when "010110010110100" =>  data <= "11111111";  -- 2CB4 = FF
      when "010110010110101" =>  data <= "11111111";  -- 2CB5 = FF
      when "010110010110110" =>  data <= "11111111";  -- 2CB6 = FF
      when "010110010110111" =>  data <= "11111111";  -- 2CB7 = FF
      when "010110010111000" =>  data <= "11111111";  -- 2CB8 = FF
      when "010110010111001" =>  data <= "11111111";  -- 2CB9 = FF
      when "010110010111010" =>  data <= "11111111";  -- 2CBA = FF
      when "010110010111011" =>  data <= "11111111";  -- 2CBB = FF
      when "010110010111100" =>  data <= "11111111";  -- 2CBC = FF
      when "010110010111101" =>  data <= "11111111";  -- 2CBD = FF
      when "010110010111110" =>  data <= "11111111";  -- 2CBE = FF
      when "010110010111111" =>  data <= "11111111";  -- 2CBF = FF
      when "010110011000000" =>  data <= "11111111";  -- 2CC0 = FF
      when "010110011000001" =>  data <= "11111111";  -- 2CC1 = FF
      when "010110011000010" =>  data <= "11111111";  -- 2CC2 = FF
      when "010110011000011" =>  data <= "11111111";  -- 2CC3 = FF
      when "010110011000100" =>  data <= "11111111";  -- 2CC4 = FF
      when "010110011000101" =>  data <= "11111111";  -- 2CC5 = FF
      when "010110011000110" =>  data <= "11111111";  -- 2CC6 = FF
      when "010110011000111" =>  data <= "11111111";  -- 2CC7 = FF
      when "010110011001000" =>  data <= "11111111";  -- 2CC8 = FF
      when "010110011001001" =>  data <= "11111111";  -- 2CC9 = FF
      when "010110011001010" =>  data <= "11111111";  -- 2CCA = FF
      when "010110011001011" =>  data <= "11111111";  -- 2CCB = FF
      when "010110011001100" =>  data <= "11111111";  -- 2CCC = FF
      when "010110011001101" =>  data <= "11111111";  -- 2CCD = FF
      when "010110011001110" =>  data <= "11111111";  -- 2CCE = FF
      when "010110011001111" =>  data <= "11111111";  -- 2CCF = FF
      when "010110011010000" =>  data <= "11111111";  -- 2CD0 = FF
      when "010110011010001" =>  data <= "11111111";  -- 2CD1 = FF
      when "010110011010010" =>  data <= "11111111";  -- 2CD2 = FF
      when "010110011010011" =>  data <= "11111111";  -- 2CD3 = FF
      when "010110011010100" =>  data <= "11111111";  -- 2CD4 = FF
      when "010110011010101" =>  data <= "11111111";  -- 2CD5 = FF
      when "010110011010110" =>  data <= "11111111";  -- 2CD6 = FF
      when "010110011010111" =>  data <= "11111111";  -- 2CD7 = FF
      when "010110011011000" =>  data <= "11111111";  -- 2CD8 = FF
      when "010110011011001" =>  data <= "11111111";  -- 2CD9 = FF
      when "010110011011010" =>  data <= "11111111";  -- 2CDA = FF
      when "010110011011011" =>  data <= "11111111";  -- 2CDB = FF
      when "010110011011100" =>  data <= "11111111";  -- 2CDC = FF
      when "010110011011101" =>  data <= "11111111";  -- 2CDD = FF
      when "010110011011110" =>  data <= "11111111";  -- 2CDE = FF
      when "010110011011111" =>  data <= "11111111";  -- 2CDF = FF
      when "010110011100000" =>  data <= "11111111";  -- 2CE0 = FF
      when "010110011100001" =>  data <= "11111111";  -- 2CE1 = FF
      when "010110011100010" =>  data <= "11111111";  -- 2CE2 = FF
      when "010110011100011" =>  data <= "11111111";  -- 2CE3 = FF
      when "010110011100100" =>  data <= "11111111";  -- 2CE4 = FF
      when "010110011100101" =>  data <= "11111111";  -- 2CE5 = FF
      when "010110011100110" =>  data <= "11111111";  -- 2CE6 = FF
      when "010110011100111" =>  data <= "11111111";  -- 2CE7 = FF
      when "010110011101000" =>  data <= "11111111";  -- 2CE8 = FF
      when "010110011101001" =>  data <= "11111111";  -- 2CE9 = FF
      when "010110011101010" =>  data <= "11111111";  -- 2CEA = FF
      when "010110011101011" =>  data <= "11111111";  -- 2CEB = FF
      when "010110011101100" =>  data <= "11111111";  -- 2CEC = FF
      when "010110011101101" =>  data <= "11111111";  -- 2CED = FF
      when "010110011101110" =>  data <= "11111111";  -- 2CEE = FF
      when "010110011101111" =>  data <= "11111111";  -- 2CEF = FF
      when "010110011110000" =>  data <= "11111111";  -- 2CF0 = FF
      when "010110011110001" =>  data <= "11111111";  -- 2CF1 = FF
      when "010110011110010" =>  data <= "11111111";  -- 2CF2 = FF
      when "010110011110011" =>  data <= "11111111";  -- 2CF3 = FF
      when "010110011110100" =>  data <= "11111111";  -- 2CF4 = FF
      when "010110011110101" =>  data <= "11111111";  -- 2CF5 = FF
      when "010110011110110" =>  data <= "11111111";  -- 2CF6 = FF
      when "010110011110111" =>  data <= "11111111";  -- 2CF7 = FF
      when "010110011111000" =>  data <= "11111111";  -- 2CF8 = FF
      when "010110011111001" =>  data <= "11111111";  -- 2CF9 = FF
      when "010110011111010" =>  data <= "11111111";  -- 2CFA = FF
      when "010110011111011" =>  data <= "11111111";  -- 2CFB = FF
      when "010110011111100" =>  data <= "11111111";  -- 2CFC = FF
      when "010110011111101" =>  data <= "11111111";  -- 2CFD = FF
      when "010110011111110" =>  data <= "11111111";  -- 2CFE = FF
      when "010110011111111" =>  data <= "11111111";  -- 2CFF = FF
      when "010110100000000" =>  data <= "11111111";  -- 2D00 = FF
      when "010110100000001" =>  data <= "11111111";  -- 2D01 = FF
      when "010110100000010" =>  data <= "11111111";  -- 2D02 = FF
      when "010110100000011" =>  data <= "11111111";  -- 2D03 = FF
      when "010110100000100" =>  data <= "11111111";  -- 2D04 = FF
      when "010110100000101" =>  data <= "11111111";  -- 2D05 = FF
      when "010110100000110" =>  data <= "11111111";  -- 2D06 = FF
      when "010110100000111" =>  data <= "11111111";  -- 2D07 = FF
      when "010110100001000" =>  data <= "11111111";  -- 2D08 = FF
      when "010110100001001" =>  data <= "11111111";  -- 2D09 = FF
      when "010110100001010" =>  data <= "11111111";  -- 2D0A = FF
      when "010110100001011" =>  data <= "11111111";  -- 2D0B = FF
      when "010110100001100" =>  data <= "11111111";  -- 2D0C = FF
      when "010110100001101" =>  data <= "11111111";  -- 2D0D = FF
      when "010110100001110" =>  data <= "11111111";  -- 2D0E = FF
      when "010110100001111" =>  data <= "11111111";  -- 2D0F = FF
      when "010110100010000" =>  data <= "11111111";  -- 2D10 = FF
      when "010110100010001" =>  data <= "11111111";  -- 2D11 = FF
      when "010110100010010" =>  data <= "11111111";  -- 2D12 = FF
      when "010110100010011" =>  data <= "11111111";  -- 2D13 = FF
      when "010110100010100" =>  data <= "11111111";  -- 2D14 = FF
      when "010110100010101" =>  data <= "11111111";  -- 2D15 = FF
      when "010110100010110" =>  data <= "11111111";  -- 2D16 = FF
      when "010110100010111" =>  data <= "11111111";  -- 2D17 = FF
      when "010110100011000" =>  data <= "11111111";  -- 2D18 = FF
      when "010110100011001" =>  data <= "11111111";  -- 2D19 = FF
      when "010110100011010" =>  data <= "11111111";  -- 2D1A = FF
      when "010110100011011" =>  data <= "11111111";  -- 2D1B = FF
      when "010110100011100" =>  data <= "11111111";  -- 2D1C = FF
      when "010110100011101" =>  data <= "11111111";  -- 2D1D = FF
      when "010110100011110" =>  data <= "11111111";  -- 2D1E = FF
      when "010110100011111" =>  data <= "11111111";  -- 2D1F = FF
      when "010110100100000" =>  data <= "11111111";  -- 2D20 = FF
      when "010110100100001" =>  data <= "11111111";  -- 2D21 = FF
      when "010110100100010" =>  data <= "11111111";  -- 2D22 = FF
      when "010110100100011" =>  data <= "11111111";  -- 2D23 = FF
      when "010110100100100" =>  data <= "11111111";  -- 2D24 = FF
      when "010110100100101" =>  data <= "11111111";  -- 2D25 = FF
      when "010110100100110" =>  data <= "11111111";  -- 2D26 = FF
      when "010110100100111" =>  data <= "11111111";  -- 2D27 = FF
      when "010110100101000" =>  data <= "11111111";  -- 2D28 = FF
      when "010110100101001" =>  data <= "11111111";  -- 2D29 = FF
      when "010110100101010" =>  data <= "11111111";  -- 2D2A = FF
      when "010110100101011" =>  data <= "11111111";  -- 2D2B = FF
      when "010110100101100" =>  data <= "11111111";  -- 2D2C = FF
      when "010110100101101" =>  data <= "11111111";  -- 2D2D = FF
      when "010110100101110" =>  data <= "11111111";  -- 2D2E = FF
      when "010110100101111" =>  data <= "11111111";  -- 2D2F = FF
      when "010110100110000" =>  data <= "11111111";  -- 2D30 = FF
      when "010110100110001" =>  data <= "11111111";  -- 2D31 = FF
      when "010110100110010" =>  data <= "11111111";  -- 2D32 = FF
      when "010110100110011" =>  data <= "11111111";  -- 2D33 = FF
      when "010110100110100" =>  data <= "11111111";  -- 2D34 = FF
      when "010110100110101" =>  data <= "11111111";  -- 2D35 = FF
      when "010110100110110" =>  data <= "11111111";  -- 2D36 = FF
      when "010110100110111" =>  data <= "11111111";  -- 2D37 = FF
      when "010110100111000" =>  data <= "11111111";  -- 2D38 = FF
      when "010110100111001" =>  data <= "11111111";  -- 2D39 = FF
      when "010110100111010" =>  data <= "11111111";  -- 2D3A = FF
      when "010110100111011" =>  data <= "11111111";  -- 2D3B = FF
      when "010110100111100" =>  data <= "11111111";  -- 2D3C = FF
      when "010110100111101" =>  data <= "11111111";  -- 2D3D = FF
      when "010110100111110" =>  data <= "11111111";  -- 2D3E = FF
      when "010110100111111" =>  data <= "11111111";  -- 2D3F = FF
      when "010110101000000" =>  data <= "11111111";  -- 2D40 = FF
      when "010110101000001" =>  data <= "11111111";  -- 2D41 = FF
      when "010110101000010" =>  data <= "11111111";  -- 2D42 = FF
      when "010110101000011" =>  data <= "11111111";  -- 2D43 = FF
      when "010110101000100" =>  data <= "11111111";  -- 2D44 = FF
      when "010110101000101" =>  data <= "11111111";  -- 2D45 = FF
      when "010110101000110" =>  data <= "11111111";  -- 2D46 = FF
      when "010110101000111" =>  data <= "11111111";  -- 2D47 = FF
      when "010110101001000" =>  data <= "11111111";  -- 2D48 = FF
      when "010110101001001" =>  data <= "11111111";  -- 2D49 = FF
      when "010110101001010" =>  data <= "11111111";  -- 2D4A = FF
      when "010110101001011" =>  data <= "11111111";  -- 2D4B = FF
      when "010110101001100" =>  data <= "11111111";  -- 2D4C = FF
      when "010110101001101" =>  data <= "11111111";  -- 2D4D = FF
      when "010110101001110" =>  data <= "11111111";  -- 2D4E = FF
      when "010110101001111" =>  data <= "11111111";  -- 2D4F = FF
      when "010110101010000" =>  data <= "11111111";  -- 2D50 = FF
      when "010110101010001" =>  data <= "11111111";  -- 2D51 = FF
      when "010110101010010" =>  data <= "11111111";  -- 2D52 = FF
      when "010110101010011" =>  data <= "11111111";  -- 2D53 = FF
      when "010110101010100" =>  data <= "11111111";  -- 2D54 = FF
      when "010110101010101" =>  data <= "11111111";  -- 2D55 = FF
      when "010110101010110" =>  data <= "11111111";  -- 2D56 = FF
      when "010110101010111" =>  data <= "11111111";  -- 2D57 = FF
      when "010110101011000" =>  data <= "11111111";  -- 2D58 = FF
      when "010110101011001" =>  data <= "11111111";  -- 2D59 = FF
      when "010110101011010" =>  data <= "11111111";  -- 2D5A = FF
      when "010110101011011" =>  data <= "11111111";  -- 2D5B = FF
      when "010110101011100" =>  data <= "11111111";  -- 2D5C = FF
      when "010110101011101" =>  data <= "11111111";  -- 2D5D = FF
      when "010110101011110" =>  data <= "11111111";  -- 2D5E = FF
      when "010110101011111" =>  data <= "11111111";  -- 2D5F = FF
      when "010110101100000" =>  data <= "11111111";  -- 2D60 = FF
      when "010110101100001" =>  data <= "11111111";  -- 2D61 = FF
      when "010110101100010" =>  data <= "11111111";  -- 2D62 = FF
      when "010110101100011" =>  data <= "11111111";  -- 2D63 = FF
      when "010110101100100" =>  data <= "11111111";  -- 2D64 = FF
      when "010110101100101" =>  data <= "11111111";  -- 2D65 = FF
      when "010110101100110" =>  data <= "11111111";  -- 2D66 = FF
      when "010110101100111" =>  data <= "11111111";  -- 2D67 = FF
      when "010110101101000" =>  data <= "11111111";  -- 2D68 = FF
      when "010110101101001" =>  data <= "11111111";  -- 2D69 = FF
      when "010110101101010" =>  data <= "11111111";  -- 2D6A = FF
      when "010110101101011" =>  data <= "11111111";  -- 2D6B = FF
      when "010110101101100" =>  data <= "11111111";  -- 2D6C = FF
      when "010110101101101" =>  data <= "11111111";  -- 2D6D = FF
      when "010110101101110" =>  data <= "11111111";  -- 2D6E = FF
      when "010110101101111" =>  data <= "11111111";  -- 2D6F = FF
      when "010110101110000" =>  data <= "11111111";  -- 2D70 = FF
      when "010110101110001" =>  data <= "11111111";  -- 2D71 = FF
      when "010110101110010" =>  data <= "11111111";  -- 2D72 = FF
      when "010110101110011" =>  data <= "11111111";  -- 2D73 = FF
      when "010110101110100" =>  data <= "11111111";  -- 2D74 = FF
      when "010110101110101" =>  data <= "11111111";  -- 2D75 = FF
      when "010110101110110" =>  data <= "11111111";  -- 2D76 = FF
      when "010110101110111" =>  data <= "11111111";  -- 2D77 = FF
      when "010110101111000" =>  data <= "11111111";  -- 2D78 = FF
      when "010110101111001" =>  data <= "11111111";  -- 2D79 = FF
      when "010110101111010" =>  data <= "11111111";  -- 2D7A = FF
      when "010110101111011" =>  data <= "11111111";  -- 2D7B = FF
      when "010110101111100" =>  data <= "11111111";  -- 2D7C = FF
      when "010110101111101" =>  data <= "11111111";  -- 2D7D = FF
      when "010110101111110" =>  data <= "11111111";  -- 2D7E = FF
      when "010110101111111" =>  data <= "11111111";  -- 2D7F = FF
      when "010110110000000" =>  data <= "11111111";  -- 2D80 = FF
      when "010110110000001" =>  data <= "11111111";  -- 2D81 = FF
      when "010110110000010" =>  data <= "11111111";  -- 2D82 = FF
      when "010110110000011" =>  data <= "11111111";  -- 2D83 = FF
      when "010110110000100" =>  data <= "11111111";  -- 2D84 = FF
      when "010110110000101" =>  data <= "11111111";  -- 2D85 = FF
      when "010110110000110" =>  data <= "11111111";  -- 2D86 = FF
      when "010110110000111" =>  data <= "11111111";  -- 2D87 = FF
      when "010110110001000" =>  data <= "11111111";  -- 2D88 = FF
      when "010110110001001" =>  data <= "11111111";  -- 2D89 = FF
      when "010110110001010" =>  data <= "11111111";  -- 2D8A = FF
      when "010110110001011" =>  data <= "11111111";  -- 2D8B = FF
      when "010110110001100" =>  data <= "11111111";  -- 2D8C = FF
      when "010110110001101" =>  data <= "11111111";  -- 2D8D = FF
      when "010110110001110" =>  data <= "11111111";  -- 2D8E = FF
      when "010110110001111" =>  data <= "11111111";  -- 2D8F = FF
      when "010110110010000" =>  data <= "11111111";  -- 2D90 = FF
      when "010110110010001" =>  data <= "11111111";  -- 2D91 = FF
      when "010110110010010" =>  data <= "11111111";  -- 2D92 = FF
      when "010110110010011" =>  data <= "11111111";  -- 2D93 = FF
      when "010110110010100" =>  data <= "11111111";  -- 2D94 = FF
      when "010110110010101" =>  data <= "11111111";  -- 2D95 = FF
      when "010110110010110" =>  data <= "11111111";  -- 2D96 = FF
      when "010110110010111" =>  data <= "11111111";  -- 2D97 = FF
      when "010110110011000" =>  data <= "11111111";  -- 2D98 = FF
      when "010110110011001" =>  data <= "11111111";  -- 2D99 = FF
      when "010110110011010" =>  data <= "11111111";  -- 2D9A = FF
      when "010110110011011" =>  data <= "11111111";  -- 2D9B = FF
      when "010110110011100" =>  data <= "11111111";  -- 2D9C = FF
      when "010110110011101" =>  data <= "11111111";  -- 2D9D = FF
      when "010110110011110" =>  data <= "11111111";  -- 2D9E = FF
      when "010110110011111" =>  data <= "11111111";  -- 2D9F = FF
      when "010110110100000" =>  data <= "11111111";  -- 2DA0 = FF
      when "010110110100001" =>  data <= "11111111";  -- 2DA1 = FF
      when "010110110100010" =>  data <= "11111111";  -- 2DA2 = FF
      when "010110110100011" =>  data <= "11111111";  -- 2DA3 = FF
      when "010110110100100" =>  data <= "11111111";  -- 2DA4 = FF
      when "010110110100101" =>  data <= "11111111";  -- 2DA5 = FF
      when "010110110100110" =>  data <= "11111111";  -- 2DA6 = FF
      when "010110110100111" =>  data <= "11111111";  -- 2DA7 = FF
      when "010110110101000" =>  data <= "11111111";  -- 2DA8 = FF
      when "010110110101001" =>  data <= "11111111";  -- 2DA9 = FF
      when "010110110101010" =>  data <= "11111111";  -- 2DAA = FF
      when "010110110101011" =>  data <= "11111111";  -- 2DAB = FF
      when "010110110101100" =>  data <= "11111111";  -- 2DAC = FF
      when "010110110101101" =>  data <= "11111111";  -- 2DAD = FF
      when "010110110101110" =>  data <= "11111111";  -- 2DAE = FF
      when "010110110101111" =>  data <= "11111111";  -- 2DAF = FF
      when "010110110110000" =>  data <= "11111111";  -- 2DB0 = FF
      when "010110110110001" =>  data <= "11111111";  -- 2DB1 = FF
      when "010110110110010" =>  data <= "11111111";  -- 2DB2 = FF
      when "010110110110011" =>  data <= "11111111";  -- 2DB3 = FF
      when "010110110110100" =>  data <= "11111111";  -- 2DB4 = FF
      when "010110110110101" =>  data <= "11111111";  -- 2DB5 = FF
      when "010110110110110" =>  data <= "11111111";  -- 2DB6 = FF
      when "010110110110111" =>  data <= "11111111";  -- 2DB7 = FF
      when "010110110111000" =>  data <= "11111111";  -- 2DB8 = FF
      when "010110110111001" =>  data <= "11111111";  -- 2DB9 = FF
      when "010110110111010" =>  data <= "11111111";  -- 2DBA = FF
      when "010110110111011" =>  data <= "11111111";  -- 2DBB = FF
      when "010110110111100" =>  data <= "11111111";  -- 2DBC = FF
      when "010110110111101" =>  data <= "11111111";  -- 2DBD = FF
      when "010110110111110" =>  data <= "11111111";  -- 2DBE = FF
      when "010110110111111" =>  data <= "11111111";  -- 2DBF = FF
      when "010110111000000" =>  data <= "11111111";  -- 2DC0 = FF
      when "010110111000001" =>  data <= "11111111";  -- 2DC1 = FF
      when "010110111000010" =>  data <= "11111111";  -- 2DC2 = FF
      when "010110111000011" =>  data <= "11111111";  -- 2DC3 = FF
      when "010110111000100" =>  data <= "11111111";  -- 2DC4 = FF
      when "010110111000101" =>  data <= "11111111";  -- 2DC5 = FF
      when "010110111000110" =>  data <= "11111111";  -- 2DC6 = FF
      when "010110111000111" =>  data <= "11111111";  -- 2DC7 = FF
      when "010110111001000" =>  data <= "11111111";  -- 2DC8 = FF
      when "010110111001001" =>  data <= "11111111";  -- 2DC9 = FF
      when "010110111001010" =>  data <= "11111111";  -- 2DCA = FF
      when "010110111001011" =>  data <= "11111111";  -- 2DCB = FF
      when "010110111001100" =>  data <= "11111111";  -- 2DCC = FF
      when "010110111001101" =>  data <= "11111111";  -- 2DCD = FF
      when "010110111001110" =>  data <= "11111111";  -- 2DCE = FF
      when "010110111001111" =>  data <= "11111111";  -- 2DCF = FF
      when "010110111010000" =>  data <= "11111111";  -- 2DD0 = FF
      when "010110111010001" =>  data <= "11111111";  -- 2DD1 = FF
      when "010110111010010" =>  data <= "11111111";  -- 2DD2 = FF
      when "010110111010011" =>  data <= "11111111";  -- 2DD3 = FF
      when "010110111010100" =>  data <= "11111111";  -- 2DD4 = FF
      when "010110111010101" =>  data <= "11111111";  -- 2DD5 = FF
      when "010110111010110" =>  data <= "11111111";  -- 2DD6 = FF
      when "010110111010111" =>  data <= "11111111";  -- 2DD7 = FF
      when "010110111011000" =>  data <= "11111111";  -- 2DD8 = FF
      when "010110111011001" =>  data <= "11111111";  -- 2DD9 = FF
      when "010110111011010" =>  data <= "11111111";  -- 2DDA = FF
      when "010110111011011" =>  data <= "11111111";  -- 2DDB = FF
      when "010110111011100" =>  data <= "11111111";  -- 2DDC = FF
      when "010110111011101" =>  data <= "11111111";  -- 2DDD = FF
      when "010110111011110" =>  data <= "11111111";  -- 2DDE = FF
      when "010110111011111" =>  data <= "11111111";  -- 2DDF = FF
      when "010110111100000" =>  data <= "11111111";  -- 2DE0 = FF
      when "010110111100001" =>  data <= "11111111";  -- 2DE1 = FF
      when "010110111100010" =>  data <= "11111111";  -- 2DE2 = FF
      when "010110111100011" =>  data <= "11111111";  -- 2DE3 = FF
      when "010110111100100" =>  data <= "11111111";  -- 2DE4 = FF
      when "010110111100101" =>  data <= "11111111";  -- 2DE5 = FF
      when "010110111100110" =>  data <= "11111111";  -- 2DE6 = FF
      when "010110111100111" =>  data <= "11111111";  -- 2DE7 = FF
      when "010110111101000" =>  data <= "11111111";  -- 2DE8 = FF
      when "010110111101001" =>  data <= "11111111";  -- 2DE9 = FF
      when "010110111101010" =>  data <= "11111111";  -- 2DEA = FF
      when "010110111101011" =>  data <= "11111111";  -- 2DEB = FF
      when "010110111101100" =>  data <= "11111111";  -- 2DEC = FF
      when "010110111101101" =>  data <= "11111111";  -- 2DED = FF
      when "010110111101110" =>  data <= "11111111";  -- 2DEE = FF
      when "010110111101111" =>  data <= "11111111";  -- 2DEF = FF
      when "010110111110000" =>  data <= "11111111";  -- 2DF0 = FF
      when "010110111110001" =>  data <= "11111111";  -- 2DF1 = FF
      when "010110111110010" =>  data <= "11111111";  -- 2DF2 = FF
      when "010110111110011" =>  data <= "11111111";  -- 2DF3 = FF
      when "010110111110100" =>  data <= "11111111";  -- 2DF4 = FF
      when "010110111110101" =>  data <= "11111111";  -- 2DF5 = FF
      when "010110111110110" =>  data <= "11111111";  -- 2DF6 = FF
      when "010110111110111" =>  data <= "11111111";  -- 2DF7 = FF
      when "010110111111000" =>  data <= "11111111";  -- 2DF8 = FF
      when "010110111111001" =>  data <= "11111111";  -- 2DF9 = FF
      when "010110111111010" =>  data <= "11111111";  -- 2DFA = FF
      when "010110111111011" =>  data <= "11111111";  -- 2DFB = FF
      when "010110111111100" =>  data <= "11111111";  -- 2DFC = FF
      when "010110111111101" =>  data <= "11111111";  -- 2DFD = FF
      when "010110111111110" =>  data <= "11111111";  -- 2DFE = FF
      when "010110111111111" =>  data <= "11111111";  -- 2DFF = FF
      when "010111000000000" =>  data <= "11111111";  -- 2E00 = FF
      when "010111000000001" =>  data <= "11111111";  -- 2E01 = FF
      when "010111000000010" =>  data <= "11111111";  -- 2E02 = FF
      when "010111000000011" =>  data <= "11111111";  -- 2E03 = FF
      when "010111000000100" =>  data <= "11111111";  -- 2E04 = FF
      when "010111000000101" =>  data <= "11111111";  -- 2E05 = FF
      when "010111000000110" =>  data <= "11111111";  -- 2E06 = FF
      when "010111000000111" =>  data <= "11111111";  -- 2E07 = FF
      when "010111000001000" =>  data <= "11111111";  -- 2E08 = FF
      when "010111000001001" =>  data <= "11111111";  -- 2E09 = FF
      when "010111000001010" =>  data <= "11111111";  -- 2E0A = FF
      when "010111000001011" =>  data <= "11111111";  -- 2E0B = FF
      when "010111000001100" =>  data <= "11111111";  -- 2E0C = FF
      when "010111000001101" =>  data <= "11111111";  -- 2E0D = FF
      when "010111000001110" =>  data <= "11111111";  -- 2E0E = FF
      when "010111000001111" =>  data <= "11111111";  -- 2E0F = FF
      when "010111000010000" =>  data <= "11111111";  -- 2E10 = FF
      when "010111000010001" =>  data <= "11111111";  -- 2E11 = FF
      when "010111000010010" =>  data <= "11111111";  -- 2E12 = FF
      when "010111000010011" =>  data <= "11111111";  -- 2E13 = FF
      when "010111000010100" =>  data <= "11111111";  -- 2E14 = FF
      when "010111000010101" =>  data <= "11111111";  -- 2E15 = FF
      when "010111000010110" =>  data <= "11111111";  -- 2E16 = FF
      when "010111000010111" =>  data <= "11111111";  -- 2E17 = FF
      when "010111000011000" =>  data <= "11111111";  -- 2E18 = FF
      when "010111000011001" =>  data <= "11111111";  -- 2E19 = FF
      when "010111000011010" =>  data <= "11111111";  -- 2E1A = FF
      when "010111000011011" =>  data <= "11111111";  -- 2E1B = FF
      when "010111000011100" =>  data <= "11111111";  -- 2E1C = FF
      when "010111000011101" =>  data <= "11111111";  -- 2E1D = FF
      when "010111000011110" =>  data <= "11111111";  -- 2E1E = FF
      when "010111000011111" =>  data <= "11111111";  -- 2E1F = FF
      when "010111000100000" =>  data <= "11111111";  -- 2E20 = FF
      when "010111000100001" =>  data <= "11111111";  -- 2E21 = FF
      when "010111000100010" =>  data <= "11111111";  -- 2E22 = FF
      when "010111000100011" =>  data <= "11111111";  -- 2E23 = FF
      when "010111000100100" =>  data <= "11111111";  -- 2E24 = FF
      when "010111000100101" =>  data <= "11111111";  -- 2E25 = FF
      when "010111000100110" =>  data <= "11111111";  -- 2E26 = FF
      when "010111000100111" =>  data <= "11111111";  -- 2E27 = FF
      when "010111000101000" =>  data <= "11111111";  -- 2E28 = FF
      when "010111000101001" =>  data <= "11111111";  -- 2E29 = FF
      when "010111000101010" =>  data <= "11111111";  -- 2E2A = FF
      when "010111000101011" =>  data <= "11111111";  -- 2E2B = FF
      when "010111000101100" =>  data <= "11111111";  -- 2E2C = FF
      when "010111000101101" =>  data <= "11111111";  -- 2E2D = FF
      when "010111000101110" =>  data <= "11111111";  -- 2E2E = FF
      when "010111000101111" =>  data <= "11111111";  -- 2E2F = FF
      when "010111000110000" =>  data <= "11111111";  -- 2E30 = FF
      when "010111000110001" =>  data <= "11111111";  -- 2E31 = FF
      when "010111000110010" =>  data <= "11111111";  -- 2E32 = FF
      when "010111000110011" =>  data <= "11111111";  -- 2E33 = FF
      when "010111000110100" =>  data <= "11111111";  -- 2E34 = FF
      when "010111000110101" =>  data <= "11111111";  -- 2E35 = FF
      when "010111000110110" =>  data <= "11111111";  -- 2E36 = FF
      when "010111000110111" =>  data <= "11111111";  -- 2E37 = FF
      when "010111000111000" =>  data <= "11111111";  -- 2E38 = FF
      when "010111000111001" =>  data <= "11111111";  -- 2E39 = FF
      when "010111000111010" =>  data <= "11111111";  -- 2E3A = FF
      when "010111000111011" =>  data <= "11111111";  -- 2E3B = FF
      when "010111000111100" =>  data <= "11111111";  -- 2E3C = FF
      when "010111000111101" =>  data <= "11111111";  -- 2E3D = FF
      when "010111000111110" =>  data <= "11111111";  -- 2E3E = FF
      when "010111000111111" =>  data <= "11111111";  -- 2E3F = FF
      when "010111001000000" =>  data <= "11111111";  -- 2E40 = FF
      when "010111001000001" =>  data <= "11111111";  -- 2E41 = FF
      when "010111001000010" =>  data <= "11111111";  -- 2E42 = FF
      when "010111001000011" =>  data <= "11111111";  -- 2E43 = FF
      when "010111001000100" =>  data <= "11111111";  -- 2E44 = FF
      when "010111001000101" =>  data <= "11111111";  -- 2E45 = FF
      when "010111001000110" =>  data <= "11111111";  -- 2E46 = FF
      when "010111001000111" =>  data <= "11111111";  -- 2E47 = FF
      when "010111001001000" =>  data <= "11111111";  -- 2E48 = FF
      when "010111001001001" =>  data <= "11111111";  -- 2E49 = FF
      when "010111001001010" =>  data <= "11111111";  -- 2E4A = FF
      when "010111001001011" =>  data <= "11111111";  -- 2E4B = FF
      when "010111001001100" =>  data <= "11111111";  -- 2E4C = FF
      when "010111001001101" =>  data <= "11111111";  -- 2E4D = FF
      when "010111001001110" =>  data <= "11111111";  -- 2E4E = FF
      when "010111001001111" =>  data <= "11111111";  -- 2E4F = FF
      when "010111001010000" =>  data <= "11111111";  -- 2E50 = FF
      when "010111001010001" =>  data <= "11111111";  -- 2E51 = FF
      when "010111001010010" =>  data <= "11111111";  -- 2E52 = FF
      when "010111001010011" =>  data <= "11111111";  -- 2E53 = FF
      when "010111001010100" =>  data <= "11111111";  -- 2E54 = FF
      when "010111001010101" =>  data <= "11111111";  -- 2E55 = FF
      when "010111001010110" =>  data <= "11111111";  -- 2E56 = FF
      when "010111001010111" =>  data <= "11111111";  -- 2E57 = FF
      when "010111001011000" =>  data <= "11111111";  -- 2E58 = FF
      when "010111001011001" =>  data <= "11111111";  -- 2E59 = FF
      when "010111001011010" =>  data <= "11111111";  -- 2E5A = FF
      when "010111001011011" =>  data <= "11111111";  -- 2E5B = FF
      when "010111001011100" =>  data <= "11111111";  -- 2E5C = FF
      when "010111001011101" =>  data <= "11111111";  -- 2E5D = FF
      when "010111001011110" =>  data <= "11111111";  -- 2E5E = FF
      when "010111001011111" =>  data <= "11111111";  -- 2E5F = FF
      when "010111001100000" =>  data <= "11111111";  -- 2E60 = FF
      when "010111001100001" =>  data <= "11111111";  -- 2E61 = FF
      when "010111001100010" =>  data <= "11111111";  -- 2E62 = FF
      when "010111001100011" =>  data <= "11111111";  -- 2E63 = FF
      when "010111001100100" =>  data <= "11111111";  -- 2E64 = FF
      when "010111001100101" =>  data <= "11111111";  -- 2E65 = FF
      when "010111001100110" =>  data <= "11111111";  -- 2E66 = FF
      when "010111001100111" =>  data <= "11111111";  -- 2E67 = FF
      when "010111001101000" =>  data <= "11111111";  -- 2E68 = FF
      when "010111001101001" =>  data <= "11111111";  -- 2E69 = FF
      when "010111001101010" =>  data <= "11111111";  -- 2E6A = FF
      when "010111001101011" =>  data <= "11111111";  -- 2E6B = FF
      when "010111001101100" =>  data <= "11111111";  -- 2E6C = FF
      when "010111001101101" =>  data <= "11111111";  -- 2E6D = FF
      when "010111001101110" =>  data <= "11111111";  -- 2E6E = FF
      when "010111001101111" =>  data <= "11111111";  -- 2E6F = FF
      when "010111001110000" =>  data <= "11111111";  -- 2E70 = FF
      when "010111001110001" =>  data <= "11111111";  -- 2E71 = FF
      when "010111001110010" =>  data <= "11111111";  -- 2E72 = FF
      when "010111001110011" =>  data <= "11111111";  -- 2E73 = FF
      when "010111001110100" =>  data <= "11111111";  -- 2E74 = FF
      when "010111001110101" =>  data <= "11111111";  -- 2E75 = FF
      when "010111001110110" =>  data <= "11111111";  -- 2E76 = FF
      when "010111001110111" =>  data <= "11111111";  -- 2E77 = FF
      when "010111001111000" =>  data <= "11111111";  -- 2E78 = FF
      when "010111001111001" =>  data <= "11111111";  -- 2E79 = FF
      when "010111001111010" =>  data <= "11111111";  -- 2E7A = FF
      when "010111001111011" =>  data <= "11111111";  -- 2E7B = FF
      when "010111001111100" =>  data <= "11111111";  -- 2E7C = FF
      when "010111001111101" =>  data <= "11111111";  -- 2E7D = FF
      when "010111001111110" =>  data <= "11111111";  -- 2E7E = FF
      when "010111001111111" =>  data <= "11111111";  -- 2E7F = FF
      when "010111010000000" =>  data <= "11111111";  -- 2E80 = FF
      when "010111010000001" =>  data <= "11111111";  -- 2E81 = FF
      when "010111010000010" =>  data <= "11111111";  -- 2E82 = FF
      when "010111010000011" =>  data <= "11111111";  -- 2E83 = FF
      when "010111010000100" =>  data <= "11111111";  -- 2E84 = FF
      when "010111010000101" =>  data <= "11111111";  -- 2E85 = FF
      when "010111010000110" =>  data <= "11111111";  -- 2E86 = FF
      when "010111010000111" =>  data <= "11111111";  -- 2E87 = FF
      when "010111010001000" =>  data <= "11111111";  -- 2E88 = FF
      when "010111010001001" =>  data <= "11111111";  -- 2E89 = FF
      when "010111010001010" =>  data <= "11111111";  -- 2E8A = FF
      when "010111010001011" =>  data <= "11111111";  -- 2E8B = FF
      when "010111010001100" =>  data <= "11111111";  -- 2E8C = FF
      when "010111010001101" =>  data <= "11111111";  -- 2E8D = FF
      when "010111010001110" =>  data <= "11111111";  -- 2E8E = FF
      when "010111010001111" =>  data <= "11111111";  -- 2E8F = FF
      when "010111010010000" =>  data <= "11111111";  -- 2E90 = FF
      when "010111010010001" =>  data <= "11111111";  -- 2E91 = FF
      when "010111010010010" =>  data <= "11111111";  -- 2E92 = FF
      when "010111010010011" =>  data <= "11111111";  -- 2E93 = FF
      when "010111010010100" =>  data <= "11111111";  -- 2E94 = FF
      when "010111010010101" =>  data <= "11111111";  -- 2E95 = FF
      when "010111010010110" =>  data <= "11111111";  -- 2E96 = FF
      when "010111010010111" =>  data <= "11111111";  -- 2E97 = FF
      when "010111010011000" =>  data <= "11111111";  -- 2E98 = FF
      when "010111010011001" =>  data <= "11111111";  -- 2E99 = FF
      when "010111010011010" =>  data <= "11111111";  -- 2E9A = FF
      when "010111010011011" =>  data <= "11111111";  -- 2E9B = FF
      when "010111010011100" =>  data <= "11111111";  -- 2E9C = FF
      when "010111010011101" =>  data <= "11111111";  -- 2E9D = FF
      when "010111010011110" =>  data <= "11111111";  -- 2E9E = FF
      when "010111010011111" =>  data <= "11111111";  -- 2E9F = FF
      when "010111010100000" =>  data <= "11111111";  -- 2EA0 = FF
      when "010111010100001" =>  data <= "11111111";  -- 2EA1 = FF
      when "010111010100010" =>  data <= "11111111";  -- 2EA2 = FF
      when "010111010100011" =>  data <= "11111111";  -- 2EA3 = FF
      when "010111010100100" =>  data <= "11111111";  -- 2EA4 = FF
      when "010111010100101" =>  data <= "11111111";  -- 2EA5 = FF
      when "010111010100110" =>  data <= "11111111";  -- 2EA6 = FF
      when "010111010100111" =>  data <= "11111111";  -- 2EA7 = FF
      when "010111010101000" =>  data <= "11111111";  -- 2EA8 = FF
      when "010111010101001" =>  data <= "11111111";  -- 2EA9 = FF
      when "010111010101010" =>  data <= "11111111";  -- 2EAA = FF
      when "010111010101011" =>  data <= "11111111";  -- 2EAB = FF
      when "010111010101100" =>  data <= "11111111";  -- 2EAC = FF
      when "010111010101101" =>  data <= "11111111";  -- 2EAD = FF
      when "010111010101110" =>  data <= "11111111";  -- 2EAE = FF
      when "010111010101111" =>  data <= "11111111";  -- 2EAF = FF
      when "010111010110000" =>  data <= "11111111";  -- 2EB0 = FF
      when "010111010110001" =>  data <= "11111111";  -- 2EB1 = FF
      when "010111010110010" =>  data <= "11111111";  -- 2EB2 = FF
      when "010111010110011" =>  data <= "11111111";  -- 2EB3 = FF
      when "010111010110100" =>  data <= "11111111";  -- 2EB4 = FF
      when "010111010110101" =>  data <= "11111111";  -- 2EB5 = FF
      when "010111010110110" =>  data <= "11111111";  -- 2EB6 = FF
      when "010111010110111" =>  data <= "11111111";  -- 2EB7 = FF
      when "010111010111000" =>  data <= "11111111";  -- 2EB8 = FF
      when "010111010111001" =>  data <= "11111111";  -- 2EB9 = FF
      when "010111010111010" =>  data <= "11111111";  -- 2EBA = FF
      when "010111010111011" =>  data <= "11111111";  -- 2EBB = FF
      when "010111010111100" =>  data <= "11111111";  -- 2EBC = FF
      when "010111010111101" =>  data <= "11111111";  -- 2EBD = FF
      when "010111010111110" =>  data <= "11111111";  -- 2EBE = FF
      when "010111010111111" =>  data <= "11111111";  -- 2EBF = FF
      when "010111011000000" =>  data <= "11111111";  -- 2EC0 = FF
      when "010111011000001" =>  data <= "11111111";  -- 2EC1 = FF
      when "010111011000010" =>  data <= "11111111";  -- 2EC2 = FF
      when "010111011000011" =>  data <= "11111111";  -- 2EC3 = FF
      when "010111011000100" =>  data <= "11111111";  -- 2EC4 = FF
      when "010111011000101" =>  data <= "11111111";  -- 2EC5 = FF
      when "010111011000110" =>  data <= "11111111";  -- 2EC6 = FF
      when "010111011000111" =>  data <= "11111111";  -- 2EC7 = FF
      when "010111011001000" =>  data <= "11111111";  -- 2EC8 = FF
      when "010111011001001" =>  data <= "11111111";  -- 2EC9 = FF
      when "010111011001010" =>  data <= "11111111";  -- 2ECA = FF
      when "010111011001011" =>  data <= "11111111";  -- 2ECB = FF
      when "010111011001100" =>  data <= "11111111";  -- 2ECC = FF
      when "010111011001101" =>  data <= "11111111";  -- 2ECD = FF
      when "010111011001110" =>  data <= "11111111";  -- 2ECE = FF
      when "010111011001111" =>  data <= "11111111";  -- 2ECF = FF
      when "010111011010000" =>  data <= "11111111";  -- 2ED0 = FF
      when "010111011010001" =>  data <= "11111111";  -- 2ED1 = FF
      when "010111011010010" =>  data <= "11111111";  -- 2ED2 = FF
      when "010111011010011" =>  data <= "11111111";  -- 2ED3 = FF
      when "010111011010100" =>  data <= "11111111";  -- 2ED4 = FF
      when "010111011010101" =>  data <= "11111111";  -- 2ED5 = FF
      when "010111011010110" =>  data <= "11111111";  -- 2ED6 = FF
      when "010111011010111" =>  data <= "11111111";  -- 2ED7 = FF
      when "010111011011000" =>  data <= "11111111";  -- 2ED8 = FF
      when "010111011011001" =>  data <= "11111111";  -- 2ED9 = FF
      when "010111011011010" =>  data <= "11111111";  -- 2EDA = FF
      when "010111011011011" =>  data <= "11111111";  -- 2EDB = FF
      when "010111011011100" =>  data <= "11111111";  -- 2EDC = FF
      when "010111011011101" =>  data <= "11111111";  -- 2EDD = FF
      when "010111011011110" =>  data <= "11111111";  -- 2EDE = FF
      when "010111011011111" =>  data <= "11111111";  -- 2EDF = FF
      when "010111011100000" =>  data <= "11111111";  -- 2EE0 = FF
      when "010111011100001" =>  data <= "11111111";  -- 2EE1 = FF
      when "010111011100010" =>  data <= "11111111";  -- 2EE2 = FF
      when "010111011100011" =>  data <= "11111111";  -- 2EE3 = FF
      when "010111011100100" =>  data <= "11111111";  -- 2EE4 = FF
      when "010111011100101" =>  data <= "11111111";  -- 2EE5 = FF
      when "010111011100110" =>  data <= "11111111";  -- 2EE6 = FF
      when "010111011100111" =>  data <= "11111111";  -- 2EE7 = FF
      when "010111011101000" =>  data <= "11111111";  -- 2EE8 = FF
      when "010111011101001" =>  data <= "11111111";  -- 2EE9 = FF
      when "010111011101010" =>  data <= "11111111";  -- 2EEA = FF
      when "010111011101011" =>  data <= "11111111";  -- 2EEB = FF
      when "010111011101100" =>  data <= "11111111";  -- 2EEC = FF
      when "010111011101101" =>  data <= "11111111";  -- 2EED = FF
      when "010111011101110" =>  data <= "11111111";  -- 2EEE = FF
      when "010111011101111" =>  data <= "11111111";  -- 2EEF = FF
      when "010111011110000" =>  data <= "11111111";  -- 2EF0 = FF
      when "010111011110001" =>  data <= "11111111";  -- 2EF1 = FF
      when "010111011110010" =>  data <= "11111111";  -- 2EF2 = FF
      when "010111011110011" =>  data <= "11111111";  -- 2EF3 = FF
      when "010111011110100" =>  data <= "11111111";  -- 2EF4 = FF
      when "010111011110101" =>  data <= "11111111";  -- 2EF5 = FF
      when "010111011110110" =>  data <= "11111111";  -- 2EF6 = FF
      when "010111011110111" =>  data <= "11111111";  -- 2EF7 = FF
      when "010111011111000" =>  data <= "11111111";  -- 2EF8 = FF
      when "010111011111001" =>  data <= "11111111";  -- 2EF9 = FF
      when "010111011111010" =>  data <= "11111111";  -- 2EFA = FF
      when "010111011111011" =>  data <= "11111111";  -- 2EFB = FF
      when "010111011111100" =>  data <= "11111111";  -- 2EFC = FF
      when "010111011111101" =>  data <= "11111111";  -- 2EFD = FF
      when "010111011111110" =>  data <= "11111111";  -- 2EFE = FF
      when "010111011111111" =>  data <= "11111111";  -- 2EFF = FF
      when "010111100000000" =>  data <= "11111111";  -- 2F00 = FF
      when "010111100000001" =>  data <= "11111111";  -- 2F01 = FF
      when "010111100000010" =>  data <= "11111111";  -- 2F02 = FF
      when "010111100000011" =>  data <= "11111111";  -- 2F03 = FF
      when "010111100000100" =>  data <= "11111111";  -- 2F04 = FF
      when "010111100000101" =>  data <= "11111111";  -- 2F05 = FF
      when "010111100000110" =>  data <= "11111111";  -- 2F06 = FF
      when "010111100000111" =>  data <= "11111111";  -- 2F07 = FF
      when "010111100001000" =>  data <= "11111111";  -- 2F08 = FF
      when "010111100001001" =>  data <= "11111111";  -- 2F09 = FF
      when "010111100001010" =>  data <= "11111111";  -- 2F0A = FF
      when "010111100001011" =>  data <= "11111111";  -- 2F0B = FF
      when "010111100001100" =>  data <= "11111111";  -- 2F0C = FF
      when "010111100001101" =>  data <= "11111111";  -- 2F0D = FF
      when "010111100001110" =>  data <= "11111111";  -- 2F0E = FF
      when "010111100001111" =>  data <= "11111111";  -- 2F0F = FF
      when "010111100010000" =>  data <= "11111111";  -- 2F10 = FF
      when "010111100010001" =>  data <= "11111111";  -- 2F11 = FF
      when "010111100010010" =>  data <= "11111111";  -- 2F12 = FF
      when "010111100010011" =>  data <= "11111111";  -- 2F13 = FF
      when "010111100010100" =>  data <= "11111111";  -- 2F14 = FF
      when "010111100010101" =>  data <= "11111111";  -- 2F15 = FF
      when "010111100010110" =>  data <= "11111111";  -- 2F16 = FF
      when "010111100010111" =>  data <= "11111111";  -- 2F17 = FF
      when "010111100011000" =>  data <= "11111111";  -- 2F18 = FF
      when "010111100011001" =>  data <= "11111111";  -- 2F19 = FF
      when "010111100011010" =>  data <= "11111111";  -- 2F1A = FF
      when "010111100011011" =>  data <= "11111111";  -- 2F1B = FF
      when "010111100011100" =>  data <= "11111111";  -- 2F1C = FF
      when "010111100011101" =>  data <= "11111111";  -- 2F1D = FF
      when "010111100011110" =>  data <= "11111111";  -- 2F1E = FF
      when "010111100011111" =>  data <= "11111111";  -- 2F1F = FF
      when "010111100100000" =>  data <= "11111111";  -- 2F20 = FF
      when "010111100100001" =>  data <= "11111111";  -- 2F21 = FF
      when "010111100100010" =>  data <= "11111111";  -- 2F22 = FF
      when "010111100100011" =>  data <= "11111111";  -- 2F23 = FF
      when "010111100100100" =>  data <= "11111111";  -- 2F24 = FF
      when "010111100100101" =>  data <= "11111111";  -- 2F25 = FF
      when "010111100100110" =>  data <= "11111111";  -- 2F26 = FF
      when "010111100100111" =>  data <= "11111111";  -- 2F27 = FF
      when "010111100101000" =>  data <= "11111111";  -- 2F28 = FF
      when "010111100101001" =>  data <= "11111111";  -- 2F29 = FF
      when "010111100101010" =>  data <= "11111111";  -- 2F2A = FF
      when "010111100101011" =>  data <= "11111111";  -- 2F2B = FF
      when "010111100101100" =>  data <= "11111111";  -- 2F2C = FF
      when "010111100101101" =>  data <= "11111111";  -- 2F2D = FF
      when "010111100101110" =>  data <= "11111111";  -- 2F2E = FF
      when "010111100101111" =>  data <= "11111111";  -- 2F2F = FF
      when "010111100110000" =>  data <= "11111111";  -- 2F30 = FF
      when "010111100110001" =>  data <= "11111111";  -- 2F31 = FF
      when "010111100110010" =>  data <= "11111111";  -- 2F32 = FF
      when "010111100110011" =>  data <= "11111111";  -- 2F33 = FF
      when "010111100110100" =>  data <= "11111111";  -- 2F34 = FF
      when "010111100110101" =>  data <= "11111111";  -- 2F35 = FF
      when "010111100110110" =>  data <= "11111111";  -- 2F36 = FF
      when "010111100110111" =>  data <= "11111111";  -- 2F37 = FF
      when "010111100111000" =>  data <= "11111111";  -- 2F38 = FF
      when "010111100111001" =>  data <= "11111111";  -- 2F39 = FF
      when "010111100111010" =>  data <= "11111111";  -- 2F3A = FF
      when "010111100111011" =>  data <= "11111111";  -- 2F3B = FF
      when "010111100111100" =>  data <= "11111111";  -- 2F3C = FF
      when "010111100111101" =>  data <= "11111111";  -- 2F3D = FF
      when "010111100111110" =>  data <= "11111111";  -- 2F3E = FF
      when "010111100111111" =>  data <= "11111111";  -- 2F3F = FF
      when "010111101000000" =>  data <= "11111111";  -- 2F40 = FF
      when "010111101000001" =>  data <= "11111111";  -- 2F41 = FF
      when "010111101000010" =>  data <= "11111111";  -- 2F42 = FF
      when "010111101000011" =>  data <= "11111111";  -- 2F43 = FF
      when "010111101000100" =>  data <= "11111111";  -- 2F44 = FF
      when "010111101000101" =>  data <= "11111111";  -- 2F45 = FF
      when "010111101000110" =>  data <= "11111111";  -- 2F46 = FF
      when "010111101000111" =>  data <= "11111111";  -- 2F47 = FF
      when "010111101001000" =>  data <= "11111111";  -- 2F48 = FF
      when "010111101001001" =>  data <= "11111111";  -- 2F49 = FF
      when "010111101001010" =>  data <= "11111111";  -- 2F4A = FF
      when "010111101001011" =>  data <= "11111111";  -- 2F4B = FF
      when "010111101001100" =>  data <= "11111111";  -- 2F4C = FF
      when "010111101001101" =>  data <= "11111111";  -- 2F4D = FF
      when "010111101001110" =>  data <= "11111111";  -- 2F4E = FF
      when "010111101001111" =>  data <= "11111111";  -- 2F4F = FF
      when "010111101010000" =>  data <= "11111111";  -- 2F50 = FF
      when "010111101010001" =>  data <= "11111111";  -- 2F51 = FF
      when "010111101010010" =>  data <= "11111111";  -- 2F52 = FF
      when "010111101010011" =>  data <= "11111111";  -- 2F53 = FF
      when "010111101010100" =>  data <= "11111111";  -- 2F54 = FF
      when "010111101010101" =>  data <= "11111111";  -- 2F55 = FF
      when "010111101010110" =>  data <= "11111111";  -- 2F56 = FF
      when "010111101010111" =>  data <= "11111111";  -- 2F57 = FF
      when "010111101011000" =>  data <= "11111111";  -- 2F58 = FF
      when "010111101011001" =>  data <= "11111111";  -- 2F59 = FF
      when "010111101011010" =>  data <= "11111111";  -- 2F5A = FF
      when "010111101011011" =>  data <= "11111111";  -- 2F5B = FF
      when "010111101011100" =>  data <= "11111111";  -- 2F5C = FF
      when "010111101011101" =>  data <= "11111111";  -- 2F5D = FF
      when "010111101011110" =>  data <= "11111111";  -- 2F5E = FF
      when "010111101011111" =>  data <= "11111111";  -- 2F5F = FF
      when "010111101100000" =>  data <= "11111111";  -- 2F60 = FF
      when "010111101100001" =>  data <= "11111111";  -- 2F61 = FF
      when "010111101100010" =>  data <= "11111111";  -- 2F62 = FF
      when "010111101100011" =>  data <= "11111111";  -- 2F63 = FF
      when "010111101100100" =>  data <= "11111111";  -- 2F64 = FF
      when "010111101100101" =>  data <= "11111111";  -- 2F65 = FF
      when "010111101100110" =>  data <= "11111111";  -- 2F66 = FF
      when "010111101100111" =>  data <= "11111111";  -- 2F67 = FF
      when "010111101101000" =>  data <= "11111111";  -- 2F68 = FF
      when "010111101101001" =>  data <= "11111111";  -- 2F69 = FF
      when "010111101101010" =>  data <= "11111111";  -- 2F6A = FF
      when "010111101101011" =>  data <= "11111111";  -- 2F6B = FF
      when "010111101101100" =>  data <= "11111111";  -- 2F6C = FF
      when "010111101101101" =>  data <= "11111111";  -- 2F6D = FF
      when "010111101101110" =>  data <= "11111111";  -- 2F6E = FF
      when "010111101101111" =>  data <= "11111111";  -- 2F6F = FF
      when "010111101110000" =>  data <= "11111111";  -- 2F70 = FF
      when "010111101110001" =>  data <= "11111111";  -- 2F71 = FF
      when "010111101110010" =>  data <= "11111111";  -- 2F72 = FF
      when "010111101110011" =>  data <= "11111111";  -- 2F73 = FF
      when "010111101110100" =>  data <= "11111111";  -- 2F74 = FF
      when "010111101110101" =>  data <= "11111111";  -- 2F75 = FF
      when "010111101110110" =>  data <= "11111111";  -- 2F76 = FF
      when "010111101110111" =>  data <= "11111111";  -- 2F77 = FF
      when "010111101111000" =>  data <= "11111111";  -- 2F78 = FF
      when "010111101111001" =>  data <= "11111111";  -- 2F79 = FF
      when "010111101111010" =>  data <= "11111111";  -- 2F7A = FF
      when "010111101111011" =>  data <= "11111111";  -- 2F7B = FF
      when "010111101111100" =>  data <= "11111111";  -- 2F7C = FF
      when "010111101111101" =>  data <= "11111111";  -- 2F7D = FF
      when "010111101111110" =>  data <= "11111111";  -- 2F7E = FF
      when "010111101111111" =>  data <= "11111111";  -- 2F7F = FF
      when "010111110000000" =>  data <= "11111111";  -- 2F80 = FF
      when "010111110000001" =>  data <= "11111111";  -- 2F81 = FF
      when "010111110000010" =>  data <= "11111111";  -- 2F82 = FF
      when "010111110000011" =>  data <= "11111111";  -- 2F83 = FF
      when "010111110000100" =>  data <= "11111111";  -- 2F84 = FF
      when "010111110000101" =>  data <= "11111111";  -- 2F85 = FF
      when "010111110000110" =>  data <= "11111111";  -- 2F86 = FF
      when "010111110000111" =>  data <= "11111111";  -- 2F87 = FF
      when "010111110001000" =>  data <= "11111111";  -- 2F88 = FF
      when "010111110001001" =>  data <= "11111111";  -- 2F89 = FF
      when "010111110001010" =>  data <= "11111111";  -- 2F8A = FF
      when "010111110001011" =>  data <= "11111111";  -- 2F8B = FF
      when "010111110001100" =>  data <= "11111111";  -- 2F8C = FF
      when "010111110001101" =>  data <= "11111111";  -- 2F8D = FF
      when "010111110001110" =>  data <= "11111111";  -- 2F8E = FF
      when "010111110001111" =>  data <= "11111111";  -- 2F8F = FF
      when "010111110010000" =>  data <= "11111111";  -- 2F90 = FF
      when "010111110010001" =>  data <= "11111111";  -- 2F91 = FF
      when "010111110010010" =>  data <= "11111111";  -- 2F92 = FF
      when "010111110010011" =>  data <= "11111111";  -- 2F93 = FF
      when "010111110010100" =>  data <= "11111111";  -- 2F94 = FF
      when "010111110010101" =>  data <= "11111111";  -- 2F95 = FF
      when "010111110010110" =>  data <= "11111111";  -- 2F96 = FF
      when "010111110010111" =>  data <= "11111111";  -- 2F97 = FF
      when "010111110011000" =>  data <= "11111111";  -- 2F98 = FF
      when "010111110011001" =>  data <= "11111111";  -- 2F99 = FF
      when "010111110011010" =>  data <= "11111111";  -- 2F9A = FF
      when "010111110011011" =>  data <= "11111111";  -- 2F9B = FF
      when "010111110011100" =>  data <= "11111111";  -- 2F9C = FF
      when "010111110011101" =>  data <= "11111111";  -- 2F9D = FF
      when "010111110011110" =>  data <= "11111111";  -- 2F9E = FF
      when "010111110011111" =>  data <= "11111111";  -- 2F9F = FF
      when "010111110100000" =>  data <= "11111111";  -- 2FA0 = FF
      when "010111110100001" =>  data <= "11111111";  -- 2FA1 = FF
      when "010111110100010" =>  data <= "11111111";  -- 2FA2 = FF
      when "010111110100011" =>  data <= "11111111";  -- 2FA3 = FF
      when "010111110100100" =>  data <= "11111111";  -- 2FA4 = FF
      when "010111110100101" =>  data <= "11111111";  -- 2FA5 = FF
      when "010111110100110" =>  data <= "11111111";  -- 2FA6 = FF
      when "010111110100111" =>  data <= "11111111";  -- 2FA7 = FF
      when "010111110101000" =>  data <= "11111111";  -- 2FA8 = FF
      when "010111110101001" =>  data <= "11111111";  -- 2FA9 = FF
      when "010111110101010" =>  data <= "11111111";  -- 2FAA = FF
      when "010111110101011" =>  data <= "11111111";  -- 2FAB = FF
      when "010111110101100" =>  data <= "11111111";  -- 2FAC = FF
      when "010111110101101" =>  data <= "11111111";  -- 2FAD = FF
      when "010111110101110" =>  data <= "11111111";  -- 2FAE = FF
      when "010111110101111" =>  data <= "11111111";  -- 2FAF = FF
      when "010111110110000" =>  data <= "11111111";  -- 2FB0 = FF
      when "010111110110001" =>  data <= "11111111";  -- 2FB1 = FF
      when "010111110110010" =>  data <= "11111111";  -- 2FB2 = FF
      when "010111110110011" =>  data <= "11111111";  -- 2FB3 = FF
      when "010111110110100" =>  data <= "11111111";  -- 2FB4 = FF
      when "010111110110101" =>  data <= "11111111";  -- 2FB5 = FF
      when "010111110110110" =>  data <= "11111111";  -- 2FB6 = FF
      when "010111110110111" =>  data <= "11111111";  -- 2FB7 = FF
      when "010111110111000" =>  data <= "11111111";  -- 2FB8 = FF
      when "010111110111001" =>  data <= "11111111";  -- 2FB9 = FF
      when "010111110111010" =>  data <= "11111111";  -- 2FBA = FF
      when "010111110111011" =>  data <= "11111111";  -- 2FBB = FF
      when "010111110111100" =>  data <= "11111111";  -- 2FBC = FF
      when "010111110111101" =>  data <= "11111111";  -- 2FBD = FF
      when "010111110111110" =>  data <= "11111111";  -- 2FBE = FF
      when "010111110111111" =>  data <= "11111111";  -- 2FBF = FF
      when "010111111000000" =>  data <= "11111111";  -- 2FC0 = FF
      when "010111111000001" =>  data <= "11111111";  -- 2FC1 = FF
      when "010111111000010" =>  data <= "11111111";  -- 2FC2 = FF
      when "010111111000011" =>  data <= "11111111";  -- 2FC3 = FF
      when "010111111000100" =>  data <= "11111111";  -- 2FC4 = FF
      when "010111111000101" =>  data <= "11111111";  -- 2FC5 = FF
      when "010111111000110" =>  data <= "11111111";  -- 2FC6 = FF
      when "010111111000111" =>  data <= "11111111";  -- 2FC7 = FF
      when "010111111001000" =>  data <= "11111111";  -- 2FC8 = FF
      when "010111111001001" =>  data <= "11111111";  -- 2FC9 = FF
      when "010111111001010" =>  data <= "11111111";  -- 2FCA = FF
      when "010111111001011" =>  data <= "11111111";  -- 2FCB = FF
      when "010111111001100" =>  data <= "11111111";  -- 2FCC = FF
      when "010111111001101" =>  data <= "11111111";  -- 2FCD = FF
      when "010111111001110" =>  data <= "11111111";  -- 2FCE = FF
      when "010111111001111" =>  data <= "11111111";  -- 2FCF = FF
      when "010111111010000" =>  data <= "11111111";  -- 2FD0 = FF
      when "010111111010001" =>  data <= "11111111";  -- 2FD1 = FF
      when "010111111010010" =>  data <= "11111111";  -- 2FD2 = FF
      when "010111111010011" =>  data <= "11111111";  -- 2FD3 = FF
      when "010111111010100" =>  data <= "11111111";  -- 2FD4 = FF
      when "010111111010101" =>  data <= "11111111";  -- 2FD5 = FF
      when "010111111010110" =>  data <= "11111111";  -- 2FD6 = FF
      when "010111111010111" =>  data <= "11111111";  -- 2FD7 = FF
      when "010111111011000" =>  data <= "11111111";  -- 2FD8 = FF
      when "010111111011001" =>  data <= "11111111";  -- 2FD9 = FF
      when "010111111011010" =>  data <= "11111111";  -- 2FDA = FF
      when "010111111011011" =>  data <= "11111111";  -- 2FDB = FF
      when "010111111011100" =>  data <= "11111111";  -- 2FDC = FF
      when "010111111011101" =>  data <= "11111111";  -- 2FDD = FF
      when "010111111011110" =>  data <= "11111111";  -- 2FDE = FF
      when "010111111011111" =>  data <= "11111111";  -- 2FDF = FF
      when "010111111100000" =>  data <= "11111111";  -- 2FE0 = FF
      when "010111111100001" =>  data <= "11111111";  -- 2FE1 = FF
      when "010111111100010" =>  data <= "11111111";  -- 2FE2 = FF
      when "010111111100011" =>  data <= "11111111";  -- 2FE3 = FF
      when "010111111100100" =>  data <= "11111111";  -- 2FE4 = FF
      when "010111111100101" =>  data <= "11111111";  -- 2FE5 = FF
      when "010111111100110" =>  data <= "11111111";  -- 2FE6 = FF
      when "010111111100111" =>  data <= "11111111";  -- 2FE7 = FF
      when "010111111101000" =>  data <= "11111111";  -- 2FE8 = FF
      when "010111111101001" =>  data <= "11111111";  -- 2FE9 = FF
      when "010111111101010" =>  data <= "11111111";  -- 2FEA = FF
      when "010111111101011" =>  data <= "11111111";  -- 2FEB = FF
      when "010111111101100" =>  data <= "11111111";  -- 2FEC = FF
      when "010111111101101" =>  data <= "11111111";  -- 2FED = FF
      when "010111111101110" =>  data <= "11111111";  -- 2FEE = FF
      when "010111111101111" =>  data <= "11111111";  -- 2FEF = FF
      when "010111111110000" =>  data <= "11111111";  -- 2FF0 = FF
      when "010111111110001" =>  data <= "11111111";  -- 2FF1 = FF
      when "010111111110010" =>  data <= "11111111";  -- 2FF2 = FF
      when "010111111110011" =>  data <= "11111111";  -- 2FF3 = FF
      when "010111111110100" =>  data <= "11111111";  -- 2FF4 = FF
      when "010111111110101" =>  data <= "11111111";  -- 2FF5 = FF
      when "010111111110110" =>  data <= "11111111";  -- 2FF6 = FF
      when "010111111110111" =>  data <= "11111111";  -- 2FF7 = FF
      when "010111111111000" =>  data <= "11111111";  -- 2FF8 = FF
      when "010111111111001" =>  data <= "11111111";  -- 2FF9 = FF
      when "010111111111010" =>  data <= "11111111";  -- 2FFA = FF
      when "010111111111011" =>  data <= "11111111";  -- 2FFB = FF
      when "010111111111100" =>  data <= "11111111";  -- 2FFC = FF
      when "010111111111101" =>  data <= "11111111";  -- 2FFD = FF
      when "010111111111110" =>  data <= "11111111";  -- 2FFE = FF
      when "010111111111111" =>  data <= "11111111";  -- 2FFF = FF
      when "011000000000000" =>  data <= "11000111";  -- 3000 = C7
      when "011000000000001" =>  data <= "10110111";  -- 3001 = B7
      when "011000000000010" =>  data <= "11011101";  -- 3002 = DD
      when "011000000000011" =>  data <= "10110110";  -- 3003 = B6
      when "011000000000100" =>  data <= "00011000";  -- 3004 = 18
      when "011000000000101" =>  data <= "10111101";  -- 3005 = BD
      when "011000000000110" =>  data <= "10000010";  -- 3006 = 82
      when "011000000000111" =>  data <= "10111000";  -- 3007 = B8
      when "011000000001000" =>  data <= "10100011";  -- 3008 = A3
      when "011000000001001" =>  data <= "10111011";  -- 3009 = BB
      when "011000000001010" =>  data <= "10111101";  -- 300A = BD
      when "011000000001011" =>  data <= "10111011";  -- 300B = BB
      when "011000000001100" =>  data <= "00100000";  -- 300C = 20
      when "011000000001101" =>  data <= "11000001";  -- 300D = C1
      when "011000000001110" =>  data <= "00000001";  -- 300E = 1
      when "011000000001111" =>  data <= "10111100";  -- 300F = BC
      when "011000000010000" =>  data <= "00101111";  -- 3010 = 2F
      when "011000000010001" =>  data <= "10111001";  -- 3011 = B9
      when "011000000010010" =>  data <= "00101111";  -- 3012 = 2F
      when "011000000010011" =>  data <= "10111000";  -- 3013 = B8
      when "011000000010100" =>  data <= "00000111";  -- 3014 = 7
      when "011000000010101" =>  data <= "10111000";  -- 3015 = B8
      when "011000000010110" =>  data <= "10110010";  -- 3016 = B2
      when "011000000010111" =>  data <= "10111000";  -- 3017 = B8
      when "011000000011000" =>  data <= "10110110";  -- 3018 = B6
      when "011000000011001" =>  data <= "10110111";  -- 3019 = B7
      when "011000000011010" =>  data <= "00010010";  -- 301A = 12
      when "011000000011011" =>  data <= "10111000";  -- 301B = B8
      when "011000000011100" =>  data <= "01011100";  -- 301C = 5C
      when "011000000011101" =>  data <= "10111000";  -- 301D = B8
      when "011000000011110" =>  data <= "11000101";  -- 301E = C5
      when "011000000011111" =>  data <= "10111000";  -- 301F = B8
      when "011000000100000" =>  data <= "11000101";  -- 3020 = C5
      when "011000000100001" =>  data <= "10110111";  -- 3021 = B7
      when "011000000100010" =>  data <= "11010101";  -- 3022 = D5
      when "011000000100011" =>  data <= "10111000";  -- 3023 = B8
      when "011000000100100" =>  data <= "01100010";  -- 3024 = 62
      when "011000000100101" =>  data <= "11001001";  -- 3025 = C9
      when "011000000100110" =>  data <= "11010100";  -- 3026 = D4
      when "011000000100111" =>  data <= "11111111";  -- 3027 = FF
      when "011000000101000" =>  data <= "11010111";  -- 3028 = D7
      when "011000000101001" =>  data <= "11111111";  -- 3029 = FF
      when "011000000101010" =>  data <= "11011010";  -- 302A = DA
      when "011000000101011" =>  data <= "11111111";  -- 302B = FF
      when "011000000101100" =>  data <= "11011011";  -- 302C = DB
      when "011000000101101" =>  data <= "11000100";  -- 302D = C4
      when "011000000101110" =>  data <= "01011001";  -- 302E = 59
      when "011000000101111" =>  data <= "11001001";  -- 302F = C9
      when "011000000110000" =>  data <= "10000111";  -- 3030 = 87
      when "011000000110001" =>  data <= "10111010";  -- 3031 = BA
      when "011000000110010" =>  data <= "10100111";  -- 3032 = A7
      when "011000000110011" =>  data <= "10111010";  -- 3033 = BA
      when "011000000110100" =>  data <= "11101101";  -- 3034 = ED
      when "011000000110101" =>  data <= "10110111";  -- 3035 = B7
      when "011000000110110" =>  data <= "00101111";  -- 3036 = 2F
      when "011000000110111" =>  data <= "10110110";  -- 3037 = B6
      when "011000000111000" =>  data <= "11101101";  -- 3038 = ED
      when "011000000111001" =>  data <= "10110101";  -- 3039 = B5
      when "011000000111010" =>  data <= "10001101";  -- 303A = 8D
      when "011000000111011" =>  data <= "10111010";  -- 303B = BA
      when "011000000111100" =>  data <= "11011101";  -- 303C = DD
      when "011000000111101" =>  data <= "11111111";  -- 303D = FF
      when "011000000111110" =>  data <= "10111111";  -- 303E = BF
      when "011000000111111" =>  data <= "11111111";  -- 303F = FF
      when "011000001000000" =>  data <= "11000010";  -- 3040 = C2
      when "011000001000001" =>  data <= "11111111";  -- 3041 = FF
      when "011000001000010" =>  data <= "01111001";  -- 3042 = 79
      when "011000001000011" =>  data <= "10111011";  -- 3043 = BB
      when "011000001000100" =>  data <= "11010001";  -- 3044 = D1
      when "011000001000101" =>  data <= "10110101";  -- 3045 = B5
      when "011000001000110" =>  data <= "10101011";  -- 3046 = AB
      when "011000001000111" =>  data <= "10110111";  -- 3047 = B7
      when "011000001001000" =>  data <= "10010010";  -- 3048 = 92
      when "011000001001001" =>  data <= "11111111";  -- 3049 = FF
      when "011000001001010" =>  data <= "10010101";  -- 304A = 95
      when "011000001001011" =>  data <= "11111111";  -- 304B = FF
      when "011000001001100" =>  data <= "10011000";  -- 304C = 98
      when "011000001001101" =>  data <= "11111111";  -- 304D = FF
      when "011000001001110" =>  data <= "10011011";  -- 304E = 9B
      when "011000001001111" =>  data <= "11111111";  -- 304F = FF
      when "011000001010000" =>  data <= "10011110";  -- 3050 = 9E
      when "011000001010001" =>  data <= "11111111";  -- 3051 = FF
      when "011000001010010" =>  data <= "10100001";  -- 3052 = A1
      when "011000001010011" =>  data <= "11111111";  -- 3053 = FF
      when "011000001010100" =>  data <= "10100100";  -- 3054 = A4
      when "011000001010101" =>  data <= "11111111";  -- 3055 = FF
      when "011000001010110" =>  data <= "10100111";  -- 3056 = A7
      when "011000001010111" =>  data <= "11111111";  -- 3057 = FF
      when "011000001011000" =>  data <= "10101010";  -- 3058 = AA
      when "011000001011001" =>  data <= "11111111";  -- 3059 = FF
      when "011000001011010" =>  data <= "10101101";  -- 305A = AD
      when "011000001011011" =>  data <= "11111111";  -- 305B = FF
      when "011000001011100" =>  data <= "10110000";  -- 305C = B0
      when "011000001011101" =>  data <= "11111111";  -- 305D = FF
      when "011000001011110" =>  data <= "10110011";  -- 305E = B3
      when "011000001011111" =>  data <= "11111111";  -- 305F = FF
      when "011000001100000" =>  data <= "10110110";  -- 3060 = B6
      when "011000001100001" =>  data <= "11111111";  -- 3061 = FF
      when "011000001100010" =>  data <= "10111001";  -- 3062 = B9
      when "011000001100011" =>  data <= "11111111";  -- 3063 = FF
      when "011000001100100" =>  data <= "10110011";  -- 3064 = B3
      when "011000001100101" =>  data <= "11111111";  -- 3065 = FF
      when "011000001100110" =>  data <= "01101111";  -- 3066 = 6F
      when "011000001100111" =>  data <= "11001101";  -- 3067 = CD
      when "011000001101000" =>  data <= "00000010";  -- 3068 = 2
      when "011000001101001" =>  data <= "11001110";  -- 3069 = CE
      when "011000001101010" =>  data <= "10001110";  -- 306A = 8E
      when "011000001101011" =>  data <= "11001101";  -- 306B = CD
      when "011000001101100" =>  data <= "00000000";  -- 306C = 0
      when "011000001101101" =>  data <= "00000000";  -- 306D = 0
      when "011000001101110" =>  data <= "10101000";  -- 306E = A8
      when "011000001101111" =>  data <= "11000100";  -- 306F = C4
      when "011000001110000" =>  data <= "11001001";  -- 3070 = C9
      when "011000001110001" =>  data <= "11000100";  -- 3071 = C4
      when "011000001110010" =>  data <= "00001000";  -- 3072 = 8
      when "011000001110011" =>  data <= "11010001";  -- 3073 = D1
      when "011000001110100" =>  data <= "00101001";  -- 3074 = 29
      when "011000001110101" =>  data <= "11010010";  -- 3075 = D2
      when "011000001110110" =>  data <= "00100000";  -- 3076 = 20
      when "011000001110111" =>  data <= "11001011";  -- 3077 = CB
      when "011000001111000" =>  data <= "10000100";  -- 3078 = 84
      when "011000001111001" =>  data <= "11010001";  -- 3079 = D1
      when "011000001111010" =>  data <= "10000010";  -- 307A = 82
      when "011000001111011" =>  data <= "11010010";  -- 307B = D2
      when "011000001111100" =>  data <= "10001001";  -- 307C = 89
      when "011000001111101" =>  data <= "11010010";  -- 307D = D2
      when "011000001111110" =>  data <= "11010010";  -- 307E = D2
      when "011000001111111" =>  data <= "11010010";  -- 307F = D2
      when "011000010000000" =>  data <= "00101100";  -- 3080 = 2C
      when "011000010000001" =>  data <= "11010011";  -- 3081 = D3
      when "011000010000010" =>  data <= "01000011";  -- 3082 = 43
      when "011000010000011" =>  data <= "11001001";  -- 3083 = C9
      when "011000010000100" =>  data <= "10110010";  -- 3084 = B2
      when "011000010000101" =>  data <= "11001000";  -- 3085 = C8
      when "011000010000110" =>  data <= "10001110";  -- 3086 = 8E
      when "011000010000111" =>  data <= "11000101";  -- 3087 = C5
      when "011000010001000" =>  data <= "11100011";  -- 3088 = E3
      when "011000010001001" =>  data <= "11001000";  -- 3089 = C8
      when "011000010001010" =>  data <= "11000001";  -- 308A = C1
      when "011000010001011" =>  data <= "11001000";  -- 308B = C8
      when "011000010001100" =>  data <= "00100010";  -- 308C = 22
      when "011000010001101" =>  data <= "11001000";  -- 308D = C8
      when "011000010001110" =>  data <= "00110110";  -- 308E = 36
      when "011000010001111" =>  data <= "11001000";  -- 308F = C8
      when "011000010010000" =>  data <= "01100010";  -- 3090 = 62
      when "011000010010001" =>  data <= "11001000";  -- 3091 = C8
      when "011000010010010" =>  data <= "01101101";  -- 3092 = 6D
      when "011000010010011" =>  data <= "11001000";  -- 3093 = C8
      when "011000010010100" =>  data <= "01111001";  -- 3094 = 79
      when "011000010010101" =>  data <= "10011111";  -- 3095 = 9F
      when "011000010010110" =>  data <= "11001001";  -- 3096 = C9
      when "011000010010111" =>  data <= "01111001";  -- 3097 = 79
      when "011000010011000" =>  data <= "10001000";  -- 3098 = 88
      when "011000010011001" =>  data <= "11001001";  -- 3099 = C9
      when "011000010011010" =>  data <= "01111011";  -- 309A = 7B
      when "011000010011011" =>  data <= "01100000";  -- 309B = 60
      when "011000010011100" =>  data <= "11001011";  -- 309C = CB
      when "011000010011101" =>  data <= "01111011";  -- 309D = 7B
      when "011000010011110" =>  data <= "01000111";  -- 309E = 47
      when "011000010011111" =>  data <= "11001100";  -- 309F = CC
      when "011000010100000" =>  data <= "01111111";  -- 30A0 = 7F
      when "011000010100001" =>  data <= "00010001";  -- 30A1 = 11
      when "011000010100010" =>  data <= "11010001";  -- 30A2 = D1
      when "011000010100011" =>  data <= "01010000";  -- 30A3 = 50
      when "011000010100100" =>  data <= "10001000";  -- 30A4 = 88
      when "011000010100101" =>  data <= "11000000";  -- 30A5 = C0
      when "011000010100110" =>  data <= "01000110";  -- 30A6 = 46
      when "011000010100111" =>  data <= "10000101";  -- 30A7 = 85
      when "011000010101000" =>  data <= "11000000";  -- 30A8 = C0
      when "011000010101001" =>  data <= "01111101";  -- 30A9 = 7D
      when "011000010101010" =>  data <= "01001010";  -- 30AA = 4A
      when "011000010101011" =>  data <= "11010001";  -- 30AB = D1
      when "011000010101100" =>  data <= "01011010";  -- 30AC = 5A
      when "011000010101101" =>  data <= "11001011";  -- 30AD = CB
      when "011000010101110" =>  data <= "10111110";  -- 30AE = BE
      when "011000010101111" =>  data <= "01100100";  -- 30AF = 64
      when "011000010110000" =>  data <= "10110101";  -- 30B0 = B5
      when "011000010110001" =>  data <= "11000000";  -- 30B1 = C0
      when "011000010110010" =>  data <= "01000101";  -- 30B2 = 45
      when "011000010110011" =>  data <= "01001110";  -- 30B3 = 4E
      when "011000010110100" =>  data <= "11000100";  -- 30B4 = C4
      when "011000010110101" =>  data <= "01000110";  -- 30B5 = 46
      when "011000010110110" =>  data <= "01001111";  -- 30B6 = 4F
      when "011000010110111" =>  data <= "11010010";  -- 30B7 = D2
      when "011000010111000" =>  data <= "01001110";  -- 30B8 = 4E
      when "011000010111001" =>  data <= "01000101";  -- 30B9 = 45
      when "011000010111010" =>  data <= "01011000";  -- 30BA = 58
      when "011000010111011" =>  data <= "11010100";  -- 30BB = D4
      when "011000010111100" =>  data <= "01000100";  -- 30BC = 44
      when "011000010111101" =>  data <= "01000001";  -- 30BD = 41
      when "011000010111110" =>  data <= "01010100";  -- 30BE = 54
      when "011000010111111" =>  data <= "11000001";  -- 30BF = C1
      when "011000011000000" =>  data <= "01001001";  -- 30C0 = 49
      when "011000011000001" =>  data <= "01001110";  -- 30C1 = 4E
      when "011000011000010" =>  data <= "01010000";  -- 30C2 = 50
      when "011000011000011" =>  data <= "01010101";  -- 30C3 = 55
      when "011000011000100" =>  data <= "01010100";  -- 30C4 = 54
      when "011000011000101" =>  data <= "10100011";  -- 30C5 = A3
      when "011000011000110" =>  data <= "01001001";  -- 30C6 = 49
      when "011000011000111" =>  data <= "01001110";  -- 30C7 = 4E
      when "011000011001000" =>  data <= "01010000";  -- 30C8 = 50
      when "011000011001001" =>  data <= "01010101";  -- 30C9 = 55
      when "011000011001010" =>  data <= "11010100";  -- 30CA = D4
      when "011000011001011" =>  data <= "01000100";  -- 30CB = 44
      when "011000011001100" =>  data <= "01001001";  -- 30CC = 49
      when "011000011001101" =>  data <= "11001101";  -- 30CD = CD
      when "011000011001110" =>  data <= "01010010";  -- 30CE = 52
      when "011000011001111" =>  data <= "01000101";  -- 30CF = 45
      when "011000011010000" =>  data <= "01000001";  -- 30D0 = 41
      when "011000011010001" =>  data <= "11000100";  -- 30D1 = C4
      when "011000011010010" =>  data <= "01001100";  -- 30D2 = 4C
      when "011000011010011" =>  data <= "01000101";  -- 30D3 = 45
      when "011000011010100" =>  data <= "11010100";  -- 30D4 = D4
      when "011000011010101" =>  data <= "01000111";  -- 30D5 = 47
      when "011000011010110" =>  data <= "01001111";  -- 30D6 = 4F
      when "011000011010111" =>  data <= "01010100";  -- 30D7 = 54
      when "011000011011000" =>  data <= "11001111";  -- 30D8 = CF
      when "011000011011001" =>  data <= "01010010";  -- 30D9 = 52
      when "011000011011010" =>  data <= "01010101";  -- 30DA = 55
      when "011000011011011" =>  data <= "11001110";  -- 30DB = CE
      when "011000011011100" =>  data <= "01001001";  -- 30DC = 49
      when "011000011011101" =>  data <= "11000110";  -- 30DD = C6
      when "011000011011110" =>  data <= "01010010";  -- 30DE = 52
      when "011000011011111" =>  data <= "01000101";  -- 30DF = 45
      when "011000011100000" =>  data <= "01010011";  -- 30E0 = 53
      when "011000011100001" =>  data <= "01010100";  -- 30E1 = 54
      when "011000011100010" =>  data <= "01001111";  -- 30E2 = 4F
      when "011000011100011" =>  data <= "01010010";  -- 30E3 = 52
      when "011000011100100" =>  data <= "11000101";  -- 30E4 = C5
      when "011000011100101" =>  data <= "01000111";  -- 30E5 = 47
      when "011000011100110" =>  data <= "01001111";  -- 30E6 = 4F
      when "011000011100111" =>  data <= "01010011";  -- 30E7 = 53
      when "011000011101000" =>  data <= "01010101";  -- 30E8 = 55
      when "011000011101001" =>  data <= "11000010";  -- 30E9 = C2
      when "011000011101010" =>  data <= "01010010";  -- 30EA = 52
      when "011000011101011" =>  data <= "01000101";  -- 30EB = 45
      when "011000011101100" =>  data <= "01010100";  -- 30EC = 54
      when "011000011101101" =>  data <= "01010101";  -- 30ED = 55
      when "011000011101110" =>  data <= "01010010";  -- 30EE = 52
      when "011000011101111" =>  data <= "11001110";  -- 30EF = CE
      when "011000011110000" =>  data <= "01010010";  -- 30F0 = 52
      when "011000011110001" =>  data <= "01000101";  -- 30F1 = 45
      when "011000011110010" =>  data <= "11001101";  -- 30F2 = CD
      when "011000011110011" =>  data <= "01010011";  -- 30F3 = 53
      when "011000011110100" =>  data <= "01010100";  -- 30F4 = 54
      when "011000011110101" =>  data <= "01001111";  -- 30F5 = 4F
      when "011000011110110" =>  data <= "11010000";  -- 30F6 = D0
      when "011000011110111" =>  data <= "01001111";  -- 30F7 = 4F
      when "011000011111000" =>  data <= "11001110";  -- 30F8 = CE
      when "011000011111001" =>  data <= "01010111";  -- 30F9 = 57
      when "011000011111010" =>  data <= "01000001";  -- 30FA = 41
      when "011000011111011" =>  data <= "01001001";  -- 30FB = 49
      when "011000011111100" =>  data <= "11010100";  -- 30FC = D4
      when "011000011111101" =>  data <= "01001100";  -- 30FD = 4C
      when "011000011111110" =>  data <= "01001111";  -- 30FE = 4F
      when "011000011111111" =>  data <= "01000001";  -- 30FF = 41
      when "011000100000000" =>  data <= "11000100";  -- 3100 = C4
      when "011000100000001" =>  data <= "01010011";  -- 3101 = 53
      when "011000100000010" =>  data <= "01000001";  -- 3102 = 41
      when "011000100000011" =>  data <= "01010110";  -- 3103 = 56
      when "011000100000100" =>  data <= "11000101";  -- 3104 = C5
      when "011000100000101" =>  data <= "01010110";  -- 3105 = 56
      when "011000100000110" =>  data <= "01000101";  -- 3106 = 45
      when "011000100000111" =>  data <= "01010010";  -- 3107 = 52
      when "011000100001000" =>  data <= "01001001";  -- 3108 = 49
      when "011000100001001" =>  data <= "01000110";  -- 3109 = 46
      when "011000100001010" =>  data <= "11011001";  -- 310A = D9
      when "011000100001011" =>  data <= "01000100";  -- 310B = 44
      when "011000100001100" =>  data <= "01000101";  -- 310C = 45
      when "011000100001101" =>  data <= "11000110";  -- 310D = C6
      when "011000100001110" =>  data <= "01010000";  -- 310E = 50
      when "011000100001111" =>  data <= "01001111";  -- 310F = 4F
      when "011000100010000" =>  data <= "01001011";  -- 3110 = 4B
      when "011000100010001" =>  data <= "11000101";  -- 3111 = C5
      when "011000100010010" =>  data <= "01010000";  -- 3112 = 50
      when "011000100010011" =>  data <= "01010010";  -- 3113 = 52
      when "011000100010100" =>  data <= "01001001";  -- 3114 = 49
      when "011000100010101" =>  data <= "01001110";  -- 3115 = 4E
      when "011000100010110" =>  data <= "01010100";  -- 3116 = 54
      when "011000100010111" =>  data <= "10100011";  -- 3117 = A3
      when "011000100011000" =>  data <= "01010000";  -- 3118 = 50
      when "011000100011001" =>  data <= "01010010";  -- 3119 = 52
      when "011000100011010" =>  data <= "01001001";  -- 311A = 49
      when "011000100011011" =>  data <= "01001110";  -- 311B = 4E
      when "011000100011100" =>  data <= "11010100";  -- 311C = D4
      when "011000100011101" =>  data <= "01000011";  -- 311D = 43
      when "011000100011110" =>  data <= "01001111";  -- 311E = 4F
      when "011000100011111" =>  data <= "01001110";  -- 311F = 4E
      when "011000100100000" =>  data <= "11010100";  -- 3120 = D4
      when "011000100100001" =>  data <= "01001100";  -- 3121 = 4C
      when "011000100100010" =>  data <= "01001001";  -- 3122 = 49
      when "011000100100011" =>  data <= "01010011";  -- 3123 = 53
      when "011000100100100" =>  data <= "11010100";  -- 3124 = D4
      when "011000100100101" =>  data <= "01000011";  -- 3125 = 43
      when "011000100100110" =>  data <= "01001100";  -- 3126 = 4C
      when "011000100100111" =>  data <= "11010010";  -- 3127 = D2
      when "011000100101000" =>  data <= "01000011";  -- 3128 = 43
      when "011000100101001" =>  data <= "01001101";  -- 3129 = 4D
      when "011000100101010" =>  data <= "11000100";  -- 312A = C4
      when "011000100101011" =>  data <= "01010011";  -- 312B = 53
      when "011000100101100" =>  data <= "01011001";  -- 312C = 59
      when "011000100101101" =>  data <= "11010011";  -- 312D = D3
      when "011000100101110" =>  data <= "01001111";  -- 312E = 4F
      when "011000100101111" =>  data <= "01010000";  -- 312F = 50
      when "011000100110000" =>  data <= "01000101";  -- 3130 = 45
      when "011000100110001" =>  data <= "11001110";  -- 3131 = CE
      when "011000100110010" =>  data <= "01000011";  -- 3132 = 43
      when "011000100110011" =>  data <= "01001100";  -- 3133 = 4C
      when "011000100110100" =>  data <= "01001111";  -- 3134 = 4F
      when "011000100110101" =>  data <= "01010011";  -- 3135 = 53
      when "011000100110110" =>  data <= "11000101";  -- 3136 = C5
      when "011000100110111" =>  data <= "01000111";  -- 3137 = 47
      when "011000100111000" =>  data <= "01000101";  -- 3138 = 45
      when "011000100111001" =>  data <= "11010100";  -- 3139 = D4
      when "011000100111010" =>  data <= "01001110";  -- 313A = 4E
      when "011000100111011" =>  data <= "01000101";  -- 313B = 45
      when "011000100111100" =>  data <= "11010111";  -- 313C = D7
      when "011000100111101" =>  data <= "01010100";  -- 313D = 54
      when "011000100111110" =>  data <= "01000001";  -- 313E = 41
      when "011000100111111" =>  data <= "01000010";  -- 313F = 42
      when "011000101000000" =>  data <= "10101000";  -- 3140 = A8
      when "011000101000001" =>  data <= "01010100";  -- 3141 = 54
      when "011000101000010" =>  data <= "11001111";  -- 3142 = CF
      when "011000101000011" =>  data <= "01000110";  -- 3143 = 46
      when "011000101000100" =>  data <= "11001110";  -- 3144 = CE
      when "011000101000101" =>  data <= "01010011";  -- 3145 = 53
      when "011000101000110" =>  data <= "01010000";  -- 3146 = 50
      when "011000101000111" =>  data <= "01000011";  -- 3147 = 43
      when "011000101001000" =>  data <= "10101000";  -- 3148 = A8
      when "011000101001001" =>  data <= "01010100";  -- 3149 = 54
      when "011000101001010" =>  data <= "01001000";  -- 314A = 48
      when "011000101001011" =>  data <= "01000101";  -- 314B = 45
      when "011000101001100" =>  data <= "11001110";  -- 314C = CE
      when "011000101001101" =>  data <= "01001110";  -- 314D = 4E
      when "011000101001110" =>  data <= "01001111";  -- 314E = 4F
      when "011000101001111" =>  data <= "11010100";  -- 314F = D4
      when "011000101010000" =>  data <= "01010011";  -- 3150 = 53
      when "011000101010001" =>  data <= "01010100";  -- 3151 = 54
      when "011000101010010" =>  data <= "01000101";  -- 3152 = 45
      when "011000101010011" =>  data <= "11010000";  -- 3153 = D0
      when "011000101010100" =>  data <= "10101011";  -- 3154 = AB
      when "011000101010101" =>  data <= "10101101";  -- 3155 = AD
      when "011000101010110" =>  data <= "10101010";  -- 3156 = AA
      when "011000101010111" =>  data <= "10101111";  -- 3157 = AF
      when "011000101011000" =>  data <= "11011110";  -- 3158 = DE
      when "011000101011001" =>  data <= "01000001";  -- 3159 = 41
      when "011000101011010" =>  data <= "01001110";  -- 315A = 4E
      when "011000101011011" =>  data <= "11000100";  -- 315B = C4
      when "011000101011100" =>  data <= "01001111";  -- 315C = 4F
      when "011000101011101" =>  data <= "11010010";  -- 315D = D2
      when "011000101011110" =>  data <= "10111110";  -- 315E = BE
      when "011000101011111" =>  data <= "10111101";  -- 315F = BD
      when "011000101100000" =>  data <= "10111100";  -- 3160 = BC
      when "011000101100001" =>  data <= "01010011";  -- 3161 = 53
      when "011000101100010" =>  data <= "01000111";  -- 3162 = 47
      when "011000101100011" =>  data <= "11001110";  -- 3163 = CE
      when "011000101100100" =>  data <= "01001001";  -- 3164 = 49
      when "011000101100101" =>  data <= "01001110";  -- 3165 = 4E
      when "011000101100110" =>  data <= "11010100";  -- 3166 = D4
      when "011000101100111" =>  data <= "01000001";  -- 3167 = 41
      when "011000101101000" =>  data <= "01000010";  -- 3168 = 42
      when "011000101101001" =>  data <= "11010011";  -- 3169 = D3
      when "011000101101010" =>  data <= "01010101";  -- 316A = 55
      when "011000101101011" =>  data <= "01010011";  -- 316B = 53
      when "011000101101100" =>  data <= "11010010";  -- 316C = D2
      when "011000101101101" =>  data <= "01000110";  -- 316D = 46
      when "011000101101110" =>  data <= "01010010";  -- 316E = 52
      when "011000101101111" =>  data <= "11000101";  -- 316F = C5
      when "011000101110000" =>  data <= "01010000";  -- 3170 = 50
      when "011000101110001" =>  data <= "01001111";  -- 3171 = 4F
      when "011000101110010" =>  data <= "11010011";  -- 3172 = D3
      when "011000101110011" =>  data <= "01010011";  -- 3173 = 53
      when "011000101110100" =>  data <= "01010001";  -- 3174 = 51
      when "011000101110101" =>  data <= "11010010";  -- 3175 = D2
      when "011000101110110" =>  data <= "01010010";  -- 3176 = 52
      when "011000101110111" =>  data <= "01001110";  -- 3177 = 4E
      when "011000101111000" =>  data <= "11000100";  -- 3178 = C4
      when "011000101111001" =>  data <= "01001100";  -- 3179 = 4C
      when "011000101111010" =>  data <= "01001111";  -- 317A = 4F
      when "011000101111011" =>  data <= "11000111";  -- 317B = C7
      when "011000101111100" =>  data <= "01000101";  -- 317C = 45
      when "011000101111101" =>  data <= "01011000";  -- 317D = 58
      when "011000101111110" =>  data <= "11010000";  -- 317E = D0
      when "011000101111111" =>  data <= "01000011";  -- 317F = 43
      when "011000110000000" =>  data <= "01001111";  -- 3180 = 4F
      when "011000110000001" =>  data <= "11010011";  -- 3181 = D3
      when "011000110000010" =>  data <= "01010011";  -- 3182 = 53
      when "011000110000011" =>  data <= "01001001";  -- 3183 = 49
      when "011000110000100" =>  data <= "11001110";  -- 3184 = CE
      when "011000110000101" =>  data <= "01010100";  -- 3185 = 54
      when "011000110000110" =>  data <= "01000001";  -- 3186 = 41
      when "011000110000111" =>  data <= "11001110";  -- 3187 = CE
      when "011000110001000" =>  data <= "01000001";  -- 3188 = 41
      when "011000110001001" =>  data <= "01010100";  -- 3189 = 54
      when "011000110001010" =>  data <= "11001110";  -- 318A = CE
      when "011000110001011" =>  data <= "01010000";  -- 318B = 50
      when "011000110001100" =>  data <= "01000101";  -- 318C = 45
      when "011000110001101" =>  data <= "01000101";  -- 318D = 45
      when "011000110001110" =>  data <= "11001011";  -- 318E = CB
      when "011000110001111" =>  data <= "01001100";  -- 318F = 4C
      when "011000110010000" =>  data <= "01000101";  -- 3190 = 45
      when "011000110010001" =>  data <= "11001110";  -- 3191 = CE
      when "011000110010010" =>  data <= "01010011";  -- 3192 = 53
      when "011000110010011" =>  data <= "01010100";  -- 3193 = 54
      when "011000110010100" =>  data <= "01010010";  -- 3194 = 52
      when "011000110010101" =>  data <= "10100100";  -- 3195 = A4
      when "011000110010110" =>  data <= "01010110";  -- 3196 = 56
      when "011000110010111" =>  data <= "01000001";  -- 3197 = 41
      when "011000110011000" =>  data <= "11001100";  -- 3198 = CC
      when "011000110011001" =>  data <= "01000001";  -- 3199 = 41
      when "011000110011010" =>  data <= "01010011";  -- 319A = 53
      when "011000110011011" =>  data <= "11000011";  -- 319B = C3
      when "011000110011100" =>  data <= "01000011";  -- 319C = 43
      when "011000110011101" =>  data <= "01001000";  -- 319D = 48
      when "011000110011110" =>  data <= "01010010";  -- 319E = 52
      when "011000110011111" =>  data <= "10100100";  -- 319F = A4
      when "011000110100000" =>  data <= "01001100";  -- 31A0 = 4C
      when "011000110100001" =>  data <= "01000101";  -- 31A1 = 45
      when "011000110100010" =>  data <= "01000110";  -- 31A2 = 46
      when "011000110100011" =>  data <= "01010100";  -- 31A3 = 54
      when "011000110100100" =>  data <= "10100100";  -- 31A4 = A4
      when "011000110100101" =>  data <= "01010010";  -- 31A5 = 52
      when "011000110100110" =>  data <= "01001001";  -- 31A6 = 49
      when "011000110100111" =>  data <= "01000111";  -- 31A7 = 47
      when "011000110101000" =>  data <= "01001000";  -- 31A8 = 48
      when "011000110101001" =>  data <= "01010100";  -- 31A9 = 54
      when "011000110101010" =>  data <= "10100100";  -- 31AA = A4
      when "011000110101011" =>  data <= "01001101";  -- 31AB = 4D
      when "011000110101100" =>  data <= "01001001";  -- 31AC = 49
      when "011000110101101" =>  data <= "01000100";  -- 31AD = 44
      when "011000110101110" =>  data <= "10100100";  -- 31AE = A4
      when "011000110101111" =>  data <= "01000111";  -- 31AF = 47
      when "011000110110000" =>  data <= "11001111";  -- 31B0 = CF
      when "011000110110001" =>  data <= "01000011";  -- 31B1 = 43
      when "011000110110010" =>  data <= "01001111";  -- 31B2 = 4F
      when "011000110110011" =>  data <= "01001110";  -- 31B3 = 4E
      when "011000110110100" =>  data <= "01000011";  -- 31B4 = 43
      when "011000110110101" =>  data <= "01000001";  -- 31B5 = 41
      when "011000110110110" =>  data <= "11010100";  -- 31B6 = D4
      when "011000110110111" =>  data <= "01000100";  -- 31B7 = 44
      when "011000110111000" =>  data <= "01001111";  -- 31B8 = 4F
      when "011000110111001" =>  data <= "01010000";  -- 31B9 = 50
      when "011000110111010" =>  data <= "01000101";  -- 31BA = 45
      when "011000110111011" =>  data <= "11001110";  -- 31BB = CE
      when "011000110111100" =>  data <= "01000100";  -- 31BC = 44
      when "011000110111101" =>  data <= "01000011";  -- 31BD = 43
      when "011000110111110" =>  data <= "01001100";  -- 31BE = 4C
      when "011000110111111" =>  data <= "01001111";  -- 31BF = 4F
      when "011000111000000" =>  data <= "01010011";  -- 31C0 = 53
      when "011000111000001" =>  data <= "11000101";  -- 31C1 = C5
      when "011000111000010" =>  data <= "01010010";  -- 31C2 = 52
      when "011000111000011" =>  data <= "01000101";  -- 31C3 = 45
      when "011000111000100" =>  data <= "01000011";  -- 31C4 = 43
      when "011000111000101" =>  data <= "01001111";  -- 31C5 = 4F
      when "011000111000110" =>  data <= "01010010";  -- 31C6 = 52
      when "011000111000111" =>  data <= "11000100";  -- 31C7 = C4
      when "011000111001000" =>  data <= "01001000";  -- 31C8 = 48
      when "011000111001001" =>  data <= "01000101";  -- 31C9 = 45
      when "011000111001010" =>  data <= "01000001";  -- 31CA = 41
      when "011000111001011" =>  data <= "01000100";  -- 31CB = 44
      when "011000111001100" =>  data <= "01000101";  -- 31CC = 45
      when "011000111001101" =>  data <= "11010010";  -- 31CD = D2
      when "011000111001110" =>  data <= "01000011";  -- 31CE = 43
      when "011000111001111" =>  data <= "01001111";  -- 31CF = 4F
      when "011000111010000" =>  data <= "01001100";  -- 31D0 = 4C
      when "011000111010001" =>  data <= "01001100";  -- 31D1 = 4C
      when "011000111010010" =>  data <= "01000101";  -- 31D2 = 45
      when "011000111010011" =>  data <= "01000011";  -- 31D3 = 43
      when "011000111010100" =>  data <= "11010100";  -- 31D4 = D4
      when "011000111010101" =>  data <= "01000010";  -- 31D5 = 42
      when "011000111010110" =>  data <= "01000001";  -- 31D6 = 41
      when "011000111010111" =>  data <= "01000011";  -- 31D7 = 43
      when "011000111011000" =>  data <= "01001011";  -- 31D8 = 4B
      when "011000111011001" =>  data <= "01010101";  -- 31D9 = 55
      when "011000111011010" =>  data <= "11010000";  -- 31DA = D0
      when "011000111011011" =>  data <= "01000011";  -- 31DB = 43
      when "011000111011100" =>  data <= "01001111";  -- 31DC = 4F
      when "011000111011101" =>  data <= "01010000";  -- 31DD = 50
      when "011000111011110" =>  data <= "11011001";  -- 31DE = D9
      when "011000111011111" =>  data <= "01000001";  -- 31DF = 41
      when "011000111100000" =>  data <= "01010000";  -- 31E0 = 50
      when "011000111100001" =>  data <= "01010000";  -- 31E1 = 50
      when "011000111100010" =>  data <= "01000101";  -- 31E2 = 45
      when "011000111100011" =>  data <= "01001110";  -- 31E3 = 4E
      when "011000111100100" =>  data <= "11000100";  -- 31E4 = C4
      when "011000111100101" =>  data <= "01000100";  -- 31E5 = 44
      when "011000111100110" =>  data <= "01010011";  -- 31E6 = 53
      when "011000111100111" =>  data <= "01000001";  -- 31E7 = 41
      when "011000111101000" =>  data <= "01010110";  -- 31E8 = 56
      when "011000111101001" =>  data <= "11000101";  -- 31E9 = C5
      when "011000111101010" =>  data <= "01000100";  -- 31EA = 44
      when "011000111101011" =>  data <= "01001100";  -- 31EB = 4C
      when "011000111101100" =>  data <= "01001111";  -- 31EC = 4F
      when "011000111101101" =>  data <= "01000001";  -- 31ED = 41
      when "011000111101110" =>  data <= "11000100";  -- 31EE = C4
      when "011000111101111" =>  data <= "01000011";  -- 31EF = 43
      when "011000111110000" =>  data <= "01000001";  -- 31F0 = 41
      when "011000111110001" =>  data <= "01010100";  -- 31F1 = 54
      when "011000111110010" =>  data <= "01000001";  -- 31F2 = 41
      when "011000111110011" =>  data <= "01001100";  -- 31F3 = 4C
      when "011000111110100" =>  data <= "01001111";  -- 31F4 = 4F
      when "011000111110101" =>  data <= "11000111";  -- 31F5 = C7
      when "011000111110110" =>  data <= "01010010";  -- 31F6 = 52
      when "011000111110111" =>  data <= "01000101";  -- 31F7 = 45
      when "011000111111000" =>  data <= "01001110";  -- 31F8 = 4E
      when "011000111111001" =>  data <= "01000001";  -- 31F9 = 41
      when "011000111111010" =>  data <= "01001101";  -- 31FA = 4D
      when "011000111111011" =>  data <= "11000101";  -- 31FB = C5
      when "011000111111100" =>  data <= "01010011";  -- 31FC = 53
      when "011000111111101" =>  data <= "01000011";  -- 31FD = 43
      when "011000111111110" =>  data <= "01010010";  -- 31FE = 52
      when "011000111111111" =>  data <= "01000001";  -- 31FF = 41
      when "011001000000000" =>  data <= "01010100";  -- 3200 = 54
      when "011001000000001" =>  data <= "01000011";  -- 3201 = 43
      when "011001000000010" =>  data <= "11001000";  -- 3202 = C8
      when "011001000000011" =>  data <= "01000100";  -- 3203 = 44
      when "011001000000100" =>  data <= "01001001";  -- 3204 = 49
      when "011001000000101" =>  data <= "01010010";  -- 3205 = 52
      when "011001000000110" =>  data <= "01000101";  -- 3206 = 45
      when "011001000000111" =>  data <= "01000011";  -- 3207 = 43
      when "011001000001000" =>  data <= "01010100";  -- 3208 = 54
      when "011001000001001" =>  data <= "01001111";  -- 3209 = 4F
      when "011001000001010" =>  data <= "01010010";  -- 320A = 52
      when "011001000001011" =>  data <= "11011001";  -- 320B = D9
      when "011001000001100" =>  data <= "00000000";  -- 320C = 0
      when "011001000001101" =>  data <= "01001110";  -- 320D = 4E
      when "011001000001110" =>  data <= "01000101";  -- 320E = 45
      when "011001000001111" =>  data <= "01011000";  -- 320F = 58
      when "011001000010000" =>  data <= "01010100";  -- 3210 = 54
      when "011001000010001" =>  data <= "00100000";  -- 3211 = 20
      when "011001000010010" =>  data <= "01010111";  -- 3212 = 57
      when "011001000010011" =>  data <= "01001001";  -- 3213 = 49
      when "011001000010100" =>  data <= "01010100";  -- 3214 = 54
      when "011001000010101" =>  data <= "01001000";  -- 3215 = 48
      when "011001000010110" =>  data <= "01001111";  -- 3216 = 4F
      when "011001000010111" =>  data <= "01010101";  -- 3217 = 55
      when "011001000011000" =>  data <= "01010100";  -- 3218 = 54
      when "011001000011001" =>  data <= "00100000";  -- 3219 = 20
      when "011001000011010" =>  data <= "01000110";  -- 321A = 46
      when "011001000011011" =>  data <= "01001111";  -- 321B = 4F
      when "011001000011100" =>  data <= "11010010";  -- 321C = D2
      when "011001000011101" =>  data <= "01010011";  -- 321D = 53
      when "011001000011110" =>  data <= "01011001";  -- 321E = 59
      when "011001000011111" =>  data <= "01001110";  -- 321F = 4E
      when "011001000100000" =>  data <= "01010100";  -- 3220 = 54
      when "011001000100001" =>  data <= "01000001";  -- 3221 = 41
      when "011001000100010" =>  data <= "11011000";  -- 3222 = D8
      when "011001000100011" =>  data <= "01010010";  -- 3223 = 52
      when "011001000100100" =>  data <= "01000101";  -- 3224 = 45
      when "011001000100101" =>  data <= "01010100";  -- 3225 = 54
      when "011001000100110" =>  data <= "01010101";  -- 3226 = 55
      when "011001000100111" =>  data <= "01010010";  -- 3227 = 52
      when "011001000101000" =>  data <= "01001110";  -- 3228 = 4E
      when "011001000101001" =>  data <= "00100000";  -- 3229 = 20
      when "011001000101010" =>  data <= "01010111";  -- 322A = 57
      when "011001000101011" =>  data <= "01001001";  -- 322B = 49
      when "011001000101100" =>  data <= "01010100";  -- 322C = 54
      when "011001000101101" =>  data <= "01001000";  -- 322D = 48
      when "011001000101110" =>  data <= "01001111";  -- 322E = 4F
      when "011001000101111" =>  data <= "01010101";  -- 322F = 55
      when "011001000110000" =>  data <= "01010100";  -- 3230 = 54
      when "011001000110001" =>  data <= "00100000";  -- 3231 = 20
      when "011001000110010" =>  data <= "01000111";  -- 3232 = 47
      when "011001000110011" =>  data <= "01001111";  -- 3233 = 4F
      when "011001000110100" =>  data <= "01010011";  -- 3234 = 53
      when "011001000110101" =>  data <= "01010101";  -- 3235 = 55
      when "011001000110110" =>  data <= "11000010";  -- 3236 = C2
      when "011001000110111" =>  data <= "01001111";  -- 3237 = 4F
      when "011001000111000" =>  data <= "01010101";  -- 3238 = 55
      when "011001000111001" =>  data <= "01010100";  -- 3239 = 54
      when "011001000111010" =>  data <= "00100000";  -- 323A = 20
      when "011001000111011" =>  data <= "01001111";  -- 323B = 4F
      when "011001000111100" =>  data <= "01000110";  -- 323C = 46
      when "011001000111101" =>  data <= "00100000";  -- 323D = 20
      when "011001000111110" =>  data <= "01000100";  -- 323E = 44
      when "011001000111111" =>  data <= "01000001";  -- 323F = 41
      when "011001001000000" =>  data <= "01010100";  -- 3240 = 54
      when "011001001000001" =>  data <= "11000001";  -- 3241 = C1
      when "011001001000010" =>  data <= "01001001";  -- 3242 = 49
      when "011001001000011" =>  data <= "01001100";  -- 3243 = 4C
      when "011001001000100" =>  data <= "01001100";  -- 3244 = 4C
      when "011001001000101" =>  data <= "01000101";  -- 3245 = 45
      when "011001001000110" =>  data <= "01000111";  -- 3246 = 47
      when "011001001000111" =>  data <= "01000001";  -- 3247 = 41
      when "011001001001000" =>  data <= "01001100";  -- 3248 = 4C
      when "011001001001001" =>  data <= "00100000";  -- 3249 = 20
      when "011001001001010" =>  data <= "01010001";  -- 324A = 51
      when "011001001001011" =>  data <= "01010101";  -- 324B = 55
      when "011001001001100" =>  data <= "01000001";  -- 324C = 41
      when "011001001001101" =>  data <= "01001110";  -- 324D = 4E
      when "011001001001110" =>  data <= "01010100";  -- 324E = 54
      when "011001001001111" =>  data <= "01001001";  -- 324F = 49
      when "011001001010000" =>  data <= "01010100";  -- 3250 = 54
      when "011001001010001" =>  data <= "11011001";  -- 3251 = D9
      when "011001001010010" =>  data <= "01001111";  -- 3252 = 4F
      when "011001001010011" =>  data <= "01010110";  -- 3253 = 56
      when "011001001010100" =>  data <= "01000101";  -- 3254 = 45
      when "011001001010101" =>  data <= "01010010";  -- 3255 = 52
      when "011001001010110" =>  data <= "01000110";  -- 3256 = 46
      when "011001001010111" =>  data <= "01001100";  -- 3257 = 4C
      when "011001001011000" =>  data <= "01001111";  -- 3258 = 4F
      when "011001001011001" =>  data <= "11010111";  -- 3259 = D7
      when "011001001011010" =>  data <= "01001111";  -- 325A = 4F
      when "011001001011011" =>  data <= "01010101";  -- 325B = 55
      when "011001001011100" =>  data <= "01010100";  -- 325C = 54
      when "011001001011101" =>  data <= "00100000";  -- 325D = 20
      when "011001001011110" =>  data <= "01001111";  -- 325E = 4F
      when "011001001011111" =>  data <= "01000110";  -- 325F = 46
      when "011001001100000" =>  data <= "00100000";  -- 3260 = 20
      when "011001001100001" =>  data <= "01001101";  -- 3261 = 4D
      when "011001001100010" =>  data <= "01000101";  -- 3262 = 45
      when "011001001100011" =>  data <= "01001101";  -- 3263 = 4D
      when "011001001100100" =>  data <= "01001111";  -- 3264 = 4F
      when "011001001100101" =>  data <= "01010010";  -- 3265 = 52
      when "011001001100110" =>  data <= "11011001";  -- 3266 = D9
      when "011001001100111" =>  data <= "01010101";  -- 3267 = 55
      when "011001001101000" =>  data <= "01001110";  -- 3268 = 4E
      when "011001001101001" =>  data <= "01000100";  -- 3269 = 44
      when "011001001101010" =>  data <= "01000101";  -- 326A = 45
      when "011001001101011" =>  data <= "01000110";  -- 326B = 46
      when "011001001101100" =>  data <= "00100111";  -- 326C = 27
      when "011001001101101" =>  data <= "01000100";  -- 326D = 44
      when "011001001101110" =>  data <= "00100000";  -- 326E = 20
      when "011001001101111" =>  data <= "01010011";  -- 326F = 53
      when "011001001110000" =>  data <= "01010100";  -- 3270 = 54
      when "011001001110001" =>  data <= "01000001";  -- 3271 = 41
      when "011001001110010" =>  data <= "01010100";  -- 3272 = 54
      when "011001001110011" =>  data <= "01000101";  -- 3273 = 45
      when "011001001110100" =>  data <= "01001101";  -- 3274 = 4D
      when "011001001110101" =>  data <= "01000101";  -- 3275 = 45
      when "011001001110110" =>  data <= "01001110";  -- 3276 = 4E
      when "011001001110111" =>  data <= "11010100";  -- 3277 = D4
      when "011001001111000" =>  data <= "01000010";  -- 3278 = 42
      when "011001001111001" =>  data <= "01000001";  -- 3279 = 41
      when "011001001111010" =>  data <= "01000100";  -- 327A = 44
      when "011001001111011" =>  data <= "00100000";  -- 327B = 20
      when "011001001111100" =>  data <= "01010011";  -- 327C = 53
      when "011001001111101" =>  data <= "01010101";  -- 327D = 55
      when "011001001111110" =>  data <= "01000010";  -- 327E = 42
      when "011001001111111" =>  data <= "01010011";  -- 327F = 53
      when "011001010000000" =>  data <= "01000011";  -- 3280 = 43
      when "011001010000001" =>  data <= "01010010";  -- 3281 = 52
      when "011001010000010" =>  data <= "01001001";  -- 3282 = 49
      when "011001010000011" =>  data <= "01010000";  -- 3283 = 50
      when "011001010000100" =>  data <= "11010100";  -- 3284 = D4
      when "011001010000101" =>  data <= "01010010";  -- 3285 = 52
      when "011001010000110" =>  data <= "01000101";  -- 3286 = 45
      when "011001010000111" =>  data <= "01000100";  -- 3287 = 44
      when "011001010001000" =>  data <= "01001001";  -- 3288 = 49
      when "011001010001001" =>  data <= "01001101";  -- 3289 = 4D
      when "011001010001010" =>  data <= "00100111";  -- 328A = 27
      when "011001010001011" =>  data <= "01000100";  -- 328B = 44
      when "011001010001100" =>  data <= "00100000";  -- 328C = 20
      when "011001010001101" =>  data <= "01000001";  -- 328D = 41
      when "011001010001110" =>  data <= "01010010";  -- 328E = 52
      when "011001010001111" =>  data <= "01010010";  -- 328F = 52
      when "011001010010000" =>  data <= "01000001";  -- 3290 = 41
      when "011001010010001" =>  data <= "11011001";  -- 3291 = D9
      when "011001010010010" =>  data <= "01000100";  -- 3292 = 44
      when "011001010010011" =>  data <= "01001001";  -- 3293 = 49
      when "011001010010100" =>  data <= "01010110";  -- 3294 = 56
      when "011001010010101" =>  data <= "01001001";  -- 3295 = 49
      when "011001010010110" =>  data <= "01010011";  -- 3296 = 53
      when "011001010010111" =>  data <= "01001001";  -- 3297 = 49
      when "011001010011000" =>  data <= "01001111";  -- 3298 = 4F
      when "011001010011001" =>  data <= "01001110";  -- 3299 = 4E
      when "011001010011010" =>  data <= "00100000";  -- 329A = 20
      when "011001010011011" =>  data <= "01000010";  -- 329B = 42
      when "011001010011100" =>  data <= "01011001";  -- 329C = 59
      when "011001010011101" =>  data <= "00100000";  -- 329D = 20
      when "011001010011110" =>  data <= "01011010";  -- 329E = 5A
      when "011001010011111" =>  data <= "01000101";  -- 329F = 45
      when "011001010100000" =>  data <= "01010010";  -- 32A0 = 52
      when "011001010100001" =>  data <= "11001111";  -- 32A1 = CF
      when "011001010100010" =>  data <= "01001001";  -- 32A2 = 49
      when "011001010100011" =>  data <= "01001100";  -- 32A3 = 4C
      when "011001010100100" =>  data <= "01001100";  -- 32A4 = 4C
      when "011001010100101" =>  data <= "01000101";  -- 32A5 = 45
      when "011001010100110" =>  data <= "01000111";  -- 32A6 = 47
      when "011001010100111" =>  data <= "01000001";  -- 32A7 = 41
      when "011001010101000" =>  data <= "01001100";  -- 32A8 = 4C
      when "011001010101001" =>  data <= "00100000";  -- 32A9 = 20
      when "011001010101010" =>  data <= "01000100";  -- 32AA = 44
      when "011001010101011" =>  data <= "01001001";  -- 32AB = 49
      when "011001010101100" =>  data <= "01010010";  -- 32AC = 52
      when "011001010101101" =>  data <= "01000101";  -- 32AD = 45
      when "011001010101110" =>  data <= "01000011";  -- 32AE = 43
      when "011001010101111" =>  data <= "11010100";  -- 32AF = D4
      when "011001010110000" =>  data <= "01010100";  -- 32B0 = 54
      when "011001010110001" =>  data <= "01011001";  -- 32B1 = 59
      when "011001010110010" =>  data <= "01010000";  -- 32B2 = 50
      when "011001010110011" =>  data <= "01000101";  -- 32B3 = 45
      when "011001010110100" =>  data <= "00100000";  -- 32B4 = 20
      when "011001010110101" =>  data <= "01001101";  -- 32B5 = 4D
      when "011001010110110" =>  data <= "01001001";  -- 32B6 = 49
      when "011001010110111" =>  data <= "01010011";  -- 32B7 = 53
      when "011001010111000" =>  data <= "01001101";  -- 32B8 = 4D
      when "011001010111001" =>  data <= "01000001";  -- 32B9 = 41
      when "011001010111010" =>  data <= "01010100";  -- 32BA = 54
      when "011001010111011" =>  data <= "01000011";  -- 32BB = 43
      when "011001010111100" =>  data <= "11001000";  -- 32BC = C8
      when "011001010111101" =>  data <= "01010011";  -- 32BD = 53
      when "011001010111110" =>  data <= "01010100";  -- 32BE = 54
      when "011001010111111" =>  data <= "01010010";  -- 32BF = 52
      when "011001011000000" =>  data <= "01001001";  -- 32C0 = 49
      when "011001011000001" =>  data <= "01001110";  -- 32C1 = 4E
      when "011001011000010" =>  data <= "01000111";  -- 32C2 = 47
      when "011001011000011" =>  data <= "00100000";  -- 32C3 = 20
      when "011001011000100" =>  data <= "01010100";  -- 32C4 = 54
      when "011001011000101" =>  data <= "01001111";  -- 32C5 = 4F
      when "011001011000110" =>  data <= "01001111";  -- 32C6 = 4F
      when "011001011000111" =>  data <= "00100000";  -- 32C7 = 20
      when "011001011001000" =>  data <= "01001100";  -- 32C8 = 4C
      when "011001011001001" =>  data <= "01001111";  -- 32C9 = 4F
      when "011001011001010" =>  data <= "01001110";  -- 32CA = 4E
      when "011001011001011" =>  data <= "11000111";  -- 32CB = C7
      when "011001011001100" =>  data <= "01000110";  -- 32CC = 46
      when "011001011001101" =>  data <= "01001001";  -- 32CD = 49
      when "011001011001110" =>  data <= "01001100";  -- 32CE = 4C
      when "011001011001111" =>  data <= "01000101";  -- 32CF = 45
      when "011001011010000" =>  data <= "00100000";  -- 32D0 = 20
      when "011001011010001" =>  data <= "01000100";  -- 32D1 = 44
      when "011001011010010" =>  data <= "01000001";  -- 32D2 = 41
      when "011001011010011" =>  data <= "01010100";  -- 32D3 = 54
      when "011001011010100" =>  data <= "11000001";  -- 32D4 = C1
      when "011001011010101" =>  data <= "01000110";  -- 32D5 = 46
      when "011001011010110" =>  data <= "01001111";  -- 32D6 = 4F
      when "011001011010111" =>  data <= "01010010";  -- 32D7 = 52
      when "011001011011000" =>  data <= "01001101";  -- 32D8 = 4D
      when "011001011011001" =>  data <= "01010101";  -- 32D9 = 55
      when "011001011011010" =>  data <= "01001100";  -- 32DA = 4C
      when "011001011011011" =>  data <= "01000001";  -- 32DB = 41
      when "011001011011100" =>  data <= "00100000";  -- 32DC = 20
      when "011001011011101" =>  data <= "01010100";  -- 32DD = 54
      when "011001011011110" =>  data <= "01001111";  -- 32DE = 4F
      when "011001011011111" =>  data <= "01001111";  -- 32DF = 4F
      when "011001011100000" =>  data <= "00100000";  -- 32E0 = 20
      when "011001011100001" =>  data <= "01000011";  -- 32E1 = 43
      when "011001011100010" =>  data <= "01001111";  -- 32E2 = 4F
      when "011001011100011" =>  data <= "01001101";  -- 32E3 = 4D
      when "011001011100100" =>  data <= "01010000";  -- 32E4 = 50
      when "011001011100101" =>  data <= "01001100";  -- 32E5 = 4C
      when "011001011100110" =>  data <= "01000101";  -- 32E6 = 45
      when "011001011100111" =>  data <= "11011000";  -- 32E7 = D8
      when "011001011101000" =>  data <= "01000011";  -- 32E8 = 43
      when "011001011101001" =>  data <= "01000001";  -- 32E9 = 41
      when "011001011101010" =>  data <= "01001110";  -- 32EA = 4E
      when "011001011101011" =>  data <= "00100111";  -- 32EB = 27
      when "011001011101100" =>  data <= "01010100";  -- 32EC = 54
      when "011001011101101" =>  data <= "00100000";  -- 32ED = 20
      when "011001011101110" =>  data <= "01000011";  -- 32EE = 43
      when "011001011101111" =>  data <= "01001111";  -- 32EF = 4F
      when "011001011110000" =>  data <= "01001110";  -- 32F0 = 4E
      when "011001011110001" =>  data <= "01010100";  -- 32F1 = 54
      when "011001011110010" =>  data <= "01001001";  -- 32F2 = 49
      when "011001011110011" =>  data <= "01001110";  -- 32F3 = 4E
      when "011001011110100" =>  data <= "01010101";  -- 32F4 = 55
      when "011001011110101" =>  data <= "11000101";  -- 32F5 = C5
      when "011001011110110" =>  data <= "01010101";  -- 32F6 = 55
      when "011001011110111" =>  data <= "01001110";  -- 32F7 = 4E
      when "011001011111000" =>  data <= "01000100";  -- 32F8 = 44
      when "011001011111001" =>  data <= "01000101";  -- 32F9 = 45
      when "011001011111010" =>  data <= "01000110";  -- 32FA = 46
      when "011001011111011" =>  data <= "00100111";  -- 32FB = 27
      when "011001011111100" =>  data <= "01000100";  -- 32FC = 44
      when "011001011111101" =>  data <= "00100000";  -- 32FD = 20
      when "011001011111110" =>  data <= "01000110";  -- 32FE = 46
      when "011001011111111" =>  data <= "01010101";  -- 32FF = 55
      when "011001100000000" =>  data <= "01001110";  -- 3300 = 4E
      when "011001100000001" =>  data <= "01000011";  -- 3301 = 43
      when "011001100000010" =>  data <= "01010100";  -- 3302 = 54
      when "011001100000011" =>  data <= "01001001";  -- 3303 = 49
      when "011001100000100" =>  data <= "01001111";  -- 3304 = 4F
      when "011001100000101" =>  data <= "11001110";  -- 3305 = CE
      when "011001100000110" =>  data <= "00100000";  -- 3306 = 20
      when "011001100000111" =>  data <= "01000101";  -- 3307 = 45
      when "011001100001000" =>  data <= "01010010";  -- 3308 = 52
      when "011001100001001" =>  data <= "01010010";  -- 3309 = 52
      when "011001100001010" =>  data <= "01001111";  -- 330A = 4F
      when "011001100001011" =>  data <= "01010010";  -- 330B = 52
      when "011001100001100" =>  data <= "00000000";  -- 330C = 0
      when "011001100001101" =>  data <= "00100000";  -- 330D = 20
      when "011001100001110" =>  data <= "01001001";  -- 330E = 49
      when "011001100001111" =>  data <= "01001110";  -- 330F = 4E
      when "011001100010000" =>  data <= "00100000";  -- 3310 = 20
      when "011001100010001" =>  data <= "00000000";  -- 3311 = 0
      when "011001100010010" =>  data <= "00001101";  -- 3312 = D
      when "011001100010011" =>  data <= "01010010";  -- 3313 = 52
      when "011001100010100" =>  data <= "01000101";  -- 3314 = 45
      when "011001100010101" =>  data <= "01000001";  -- 3315 = 41
      when "011001100010110" =>  data <= "01000100";  -- 3316 = 44
      when "011001100010111" =>  data <= "01011001";  -- 3317 = 59
      when "011001100011000" =>  data <= "00101110";  -- 3318 = 2E
      when "011001100011001" =>  data <= "00001101";  -- 3319 = D
      when "011001100011010" =>  data <= "00000000";  -- 331A = 0
      when "011001100011011" =>  data <= "00001101";  -- 331B = D
      when "011001100011100" =>  data <= "01000010";  -- 331C = 42
      when "011001100011101" =>  data <= "01010010";  -- 331D = 52
      when "011001100011110" =>  data <= "01000101";  -- 331E = 45
      when "011001100011111" =>  data <= "01000001";  -- 331F = 41
      when "011001100100000" =>  data <= "01001011";  -- 3320 = 4B
      when "011001100100001" =>  data <= "00000000";  -- 3321 = 0
      when "011001100100010" =>  data <= "10111010";  -- 3322 = BA
      when "011001100100011" =>  data <= "11101000";  -- 3323 = E8
      when "011001100100100" =>  data <= "11101000";  -- 3324 = E8
      when "011001100100101" =>  data <= "11101000";  -- 3325 = E8
      when "011001100100110" =>  data <= "11101000";  -- 3326 = E8
      when "011001100100111" =>  data <= "10111101";  -- 3327 = BD
      when "011001100101000" =>  data <= "00000001";  -- 3328 = 1
      when "011001100101001" =>  data <= "00000001";  -- 3329 = 1
      when "011001100101010" =>  data <= "11001001";  -- 332A = C9
      when "011001100101011" =>  data <= "10000001";  -- 332B = 81
      when "011001100101100" =>  data <= "11010000";  -- 332C = D0
      when "011001100101101" =>  data <= "00100001";  -- 332D = 21
      when "011001100101110" =>  data <= "10100101";  -- 332E = A5
      when "011001100101111" =>  data <= "01000111";  -- 332F = 47
      when "011001100110000" =>  data <= "11010000";  -- 3330 = D0
      when "011001100110001" =>  data <= "00001010";  -- 3331 = A
      when "011001100110010" =>  data <= "10111101";  -- 3332 = BD
      when "011001100110011" =>  data <= "00000010";  -- 3333 = 2
      when "011001100110100" =>  data <= "00000001";  -- 3334 = 1
      when "011001100110101" =>  data <= "10000101";  -- 3335 = 85
      when "011001100110110" =>  data <= "01000110";  -- 3336 = 46
      when "011001100110111" =>  data <= "10111101";  -- 3337 = BD
      when "011001100111000" =>  data <= "00000011";  -- 3338 = 3
      when "011001100111001" =>  data <= "00000001";  -- 3339 = 1
      when "011001100111010" =>  data <= "10000101";  -- 333A = 85
      when "011001100111011" =>  data <= "01000111";  -- 333B = 47
      when "011001100111100" =>  data <= "11011101";  -- 333C = DD
      when "011001100111101" =>  data <= "00000011";  -- 333D = 3
      when "011001100111110" =>  data <= "00000001";  -- 333E = 1
      when "011001100111111" =>  data <= "11010000";  -- 333F = D0
      when "011001101000000" =>  data <= "00000111";  -- 3340 = 7
      when "011001101000001" =>  data <= "10100101";  -- 3341 = A5
      when "011001101000010" =>  data <= "01000110";  -- 3342 = 46
      when "011001101000011" =>  data <= "11011101";  -- 3343 = DD
      when "011001101000100" =>  data <= "00000010";  -- 3344 = 2
      when "011001101000101" =>  data <= "00000001";  -- 3345 = 1
      when "011001101000110" =>  data <= "11110000";  -- 3346 = F0
      when "011001101000111" =>  data <= "00000111";  -- 3347 = 7
      when "011001101001000" =>  data <= "10001010";  -- 3348 = 8A
      when "011001101001001" =>  data <= "00011000";  -- 3349 = 18
      when "011001101001010" =>  data <= "01101001";  -- 334A = 69
      when "011001101001011" =>  data <= "00010010";  -- 334B = 12
      when "011001101001100" =>  data <= "10101010";  -- 334C = AA
      when "011001101001101" =>  data <= "11010000";  -- 334D = D0
      when "011001101001110" =>  data <= "11011000";  -- 334E = D8
      when "011001101001111" =>  data <= "01100000";  -- 334F = 60
      when "011001101010000" =>  data <= "00100000";  -- 3350 = 20
      when "011001101010001" =>  data <= "10100000";  -- 3351 = A0
      when "011001101010010" =>  data <= "10110011";  -- 3352 = B3
      when "011001101010011" =>  data <= "10000101";  -- 3353 = 85
      when "011001101010100" =>  data <= "00101110";  -- 3354 = 2E
      when "011001101010101" =>  data <= "10000100";  -- 3355 = 84
      when "011001101010110" =>  data <= "00101111";  -- 3356 = 2F
      when "011001101010111" =>  data <= "00111000";  -- 3357 = 38
      when "011001101011000" =>  data <= "10100101";  -- 3358 = A5
      when "011001101011001" =>  data <= "01010111";  -- 3359 = 57
      when "011001101011010" =>  data <= "11100101";  -- 335A = E5
      when "011001101011011" =>  data <= "01011100";  -- 335B = 5C
      when "011001101011100" =>  data <= "10000101";  -- 335C = 85
      when "011001101011101" =>  data <= "00011111";  -- 335D = 1F
      when "011001101011110" =>  data <= "10101000";  -- 335E = A8
      when "011001101011111" =>  data <= "10100101";  -- 335F = A5
      when "011001101100000" =>  data <= "01011000";  -- 3360 = 58
      when "011001101100001" =>  data <= "11100101";  -- 3361 = E5
      when "011001101100010" =>  data <= "01011101";  -- 3362 = 5D
      when "011001101100011" =>  data <= "10101010";  -- 3363 = AA
      when "011001101100100" =>  data <= "11101000";  -- 3364 = E8
      when "011001101100101" =>  data <= "10011000";  -- 3365 = 98
      when "011001101100110" =>  data <= "11110000";  -- 3366 = F0
      when "011001101100111" =>  data <= "00100011";  -- 3367 = 23
      when "011001101101000" =>  data <= "10100101";  -- 3368 = A5
      when "011001101101001" =>  data <= "01010111";  -- 3369 = 57
      when "011001101101010" =>  data <= "00111000";  -- 336A = 38
      when "011001101101011" =>  data <= "11100101";  -- 336B = E5
      when "011001101101100" =>  data <= "00011111";  -- 336C = 1F
      when "011001101101101" =>  data <= "10000101";  -- 336D = 85
      when "011001101101110" =>  data <= "01010111";  -- 336E = 57
      when "011001101101111" =>  data <= "10110000";  -- 336F = B0
      when "011001101110000" =>  data <= "00000011";  -- 3370 = 3
      when "011001101110001" =>  data <= "11000110";  -- 3371 = C6
      when "011001101110010" =>  data <= "01011000";  -- 3372 = 58
      when "011001101110011" =>  data <= "00111000";  -- 3373 = 38
      when "011001101110100" =>  data <= "10100101";  -- 3374 = A5
      when "011001101110101" =>  data <= "01010101";  -- 3375 = 55
      when "011001101110110" =>  data <= "11100101";  -- 3376 = E5
      when "011001101110111" =>  data <= "00011111";  -- 3377 = 1F
      when "011001101111000" =>  data <= "10000101";  -- 3378 = 85
      when "011001101111001" =>  data <= "01010101";  -- 3379 = 55
      when "011001101111010" =>  data <= "10110000";  -- 337A = B0
      when "011001101111011" =>  data <= "00001000";  -- 337B = 8
      when "011001101111100" =>  data <= "11000110";  -- 337C = C6
      when "011001101111101" =>  data <= "01010110";  -- 337D = 56
      when "011001101111110" =>  data <= "10010000";  -- 337E = 90
      when "011001101111111" =>  data <= "00000100";  -- 337F = 4
      when "011001110000000" =>  data <= "10110001";  -- 3380 = B1
      when "011001110000001" =>  data <= "01010111";  -- 3381 = 57
      when "011001110000010" =>  data <= "10010001";  -- 3382 = 91
      when "011001110000011" =>  data <= "01010101";  -- 3383 = 55
      when "011001110000100" =>  data <= "10001000";  -- 3384 = 88
      when "011001110000101" =>  data <= "11010000";  -- 3385 = D0
      when "011001110000110" =>  data <= "11111001";  -- 3386 = F9
      when "011001110000111" =>  data <= "10110001";  -- 3387 = B1
      when "011001110001000" =>  data <= "01010111";  -- 3388 = 57
      when "011001110001001" =>  data <= "10010001";  -- 3389 = 91
      when "011001110001010" =>  data <= "01010101";  -- 338A = 55
      when "011001110001011" =>  data <= "11000110";  -- 338B = C6
      when "011001110001100" =>  data <= "01011000";  -- 338C = 58
      when "011001110001101" =>  data <= "11000110";  -- 338D = C6
      when "011001110001110" =>  data <= "01010110";  -- 338E = 56
      when "011001110001111" =>  data <= "11001010";  -- 338F = CA
      when "011001110010000" =>  data <= "11010000";  -- 3390 = D0
      when "011001110010001" =>  data <= "11110010";  -- 3391 = F2
      when "011001110010010" =>  data <= "01100000";  -- 3392 = 60
      when "011001110010011" =>  data <= "00001010";  -- 3393 = A
      when "011001110010100" =>  data <= "01101001";  -- 3394 = 69
      when "011001110010101" =>  data <= "00111110";  -- 3395 = 3E
      when "011001110010110" =>  data <= "10110000";  -- 3396 = B0
      when "011001110010111" =>  data <= "00110101";  -- 3397 = 35
      when "011001110011000" =>  data <= "10000101";  -- 3398 = 85
      when "011001110011001" =>  data <= "00011111";  -- 3399 = 1F
      when "011001110011010" =>  data <= "10111010";  -- 339A = BA
      when "011001110011011" =>  data <= "11100100";  -- 339B = E4
      when "011001110011100" =>  data <= "00011111";  -- 339C = 1F
      when "011001110011101" =>  data <= "10010000";  -- 339D = 90
      when "011001110011110" =>  data <= "00101110";  -- 339E = 2E
      when "011001110011111" =>  data <= "01100000";  -- 339F = 60
      when "011001110100000" =>  data <= "11000100";  -- 33A0 = C4
      when "011001110100001" =>  data <= "00110001";  -- 33A1 = 31
      when "011001110100010" =>  data <= "10010000";  -- 33A2 = 90
      when "011001110100011" =>  data <= "00101000";  -- 33A3 = 28
      when "011001110100100" =>  data <= "11010000";  -- 33A4 = D0
      when "011001110100101" =>  data <= "00000100";  -- 33A5 = 4
      when "011001110100110" =>  data <= "11000101";  -- 33A6 = C5
      when "011001110100111" =>  data <= "00110000";  -- 33A7 = 30
      when "011001110101000" =>  data <= "10010000";  -- 33A8 = 90
      when "011001110101001" =>  data <= "00100010";  -- 33A9 = 22
      when "011001110101010" =>  data <= "01001000";  -- 33AA = 48
      when "011001110101011" =>  data <= "10100010";  -- 33AB = A2
      when "011001110101100" =>  data <= "00001001";  -- 33AC = 9
      when "011001110101101" =>  data <= "10011000";  -- 33AD = 98
      when "011001110101110" =>  data <= "01001000";  -- 33AE = 48
      when "011001110101111" =>  data <= "10110101";  -- 33AF = B5
      when "011001110110000" =>  data <= "01010100";  -- 33B0 = 54
      when "011001110110001" =>  data <= "11001010";  -- 33B1 = CA
      when "011001110110010" =>  data <= "00010000";  -- 33B2 = 10
      when "011001110110011" =>  data <= "11111010";  -- 33B3 = FA
      when "011001110110100" =>  data <= "00100000";  -- 33B4 = 20
      when "011001110110101" =>  data <= "01101010";  -- 33B5 = 6A
      when "011001110110110" =>  data <= "11000110";  -- 33B6 = C6
      when "011001110110111" =>  data <= "10100010";  -- 33B7 = A2
      when "011001110111000" =>  data <= "11110111";  -- 33B8 = F7
      when "011001110111001" =>  data <= "01101000";  -- 33B9 = 68
      when "011001110111010" =>  data <= "10010101";  -- 33BA = 95
      when "011001110111011" =>  data <= "01011110";  -- 33BB = 5E
      when "011001110111100" =>  data <= "11101000";  -- 33BC = E8
      when "011001110111101" =>  data <= "00110000";  -- 33BD = 30
      when "011001110111110" =>  data <= "11111010";  -- 33BE = FA
      when "011001110111111" =>  data <= "01101000";  -- 33BF = 68
      when "011001111000000" =>  data <= "10101000";  -- 33C0 = A8
      when "011001111000001" =>  data <= "01101000";  -- 33C1 = 68
      when "011001111000010" =>  data <= "11000100";  -- 33C2 = C4
      when "011001111000011" =>  data <= "00110001";  -- 33C3 = 31
      when "011001111000100" =>  data <= "10010000";  -- 33C4 = 90
      when "011001111000101" =>  data <= "00000110";  -- 33C5 = 6
      when "011001111000110" =>  data <= "11010000";  -- 33C6 = D0
      when "011001111000111" =>  data <= "00000101";  -- 33C7 = 5
      when "011001111001000" =>  data <= "11000101";  -- 33C8 = C5
      when "011001111001001" =>  data <= "00110000";  -- 33C9 = 30
      when "011001111001010" =>  data <= "10110000";  -- 33CA = B0
      when "011001111001011" =>  data <= "00000001";  -- 33CB = 1
      when "011001111001100" =>  data <= "01100000";  -- 33CC = 60
      when "011001111001101" =>  data <= "10100010";  -- 33CD = A2
      when "011001111001110" =>  data <= "01001101";  -- 33CE = 4D
      when "011001111001111" =>  data <= "10100101";  -- 33CF = A5
      when "011001111010000" =>  data <= "00010000";  -- 33D0 = 10
      when "011001111010001" =>  data <= "11110000";  -- 33D1 = F0
      when "011001111010010" =>  data <= "00000111";  -- 33D2 = 7
      when "011001111010011" =>  data <= "00100000";  -- 33D3 = 20
      when "011001111010100" =>  data <= "11001100";  -- 33D4 = CC
      when "011001111010101" =>  data <= "11111111";  -- 33D5 = FF
      when "011001111010110" =>  data <= "10101001";  -- 33D6 = A9
      when "011001111010111" =>  data <= "00000000";  -- 33D7 = 0
      when "011001111011000" =>  data <= "10000101";  -- 33D8 = 85
      when "011001111011001" =>  data <= "00010000";  -- 33D9 = 10
      when "011001111011010" =>  data <= "00100000";  -- 33DA = 20
      when "011001111011011" =>  data <= "11011111";  -- 33DB = DF
      when "011001111011100" =>  data <= "10111010";  -- 33DC = BA
      when "011001111011101" =>  data <= "00100000";  -- 33DD = 20
      when "011001111011110" =>  data <= "01000100";  -- 33DE = 44
      when "011001111011111" =>  data <= "10111011";  -- 33DF = BB
      when "011001111100000" =>  data <= "10111101";  -- 33E0 = BD
      when "011001111100001" =>  data <= "00001101";  -- 33E1 = D
      when "011001111100010" =>  data <= "10110010";  -- 33E2 = B2
      when "011001111100011" =>  data <= "01001000";  -- 33E3 = 48
      when "011001111100100" =>  data <= "00101001";  -- 33E4 = 29
      when "011001111100101" =>  data <= "01111111";  -- 33E5 = 7F
      when "011001111100110" =>  data <= "00100000";  -- 33E6 = 20
      when "011001111100111" =>  data <= "01000110";  -- 33E7 = 46
      when "011001111101000" =>  data <= "10111011";  -- 33E8 = BB
      when "011001111101001" =>  data <= "11101000";  -- 33E9 = E8
      when "011001111101010" =>  data <= "01101000";  -- 33EA = 68
      when "011001111101011" =>  data <= "00010000";  -- 33EB = 10
      when "011001111101100" =>  data <= "11110011";  -- 33EC = F3
      when "011001111101101" =>  data <= "00100000";  -- 33ED = 20
      when "011001111101110" =>  data <= "00001110";  -- 33EE = E
      when "011001111101111" =>  data <= "10110110";  -- 33EF = B6
      when "011001111110000" =>  data <= "10101001";  -- 33F0 = A9
      when "011001111110001" =>  data <= "00000110";  -- 33F1 = 6
      when "011001111110010" =>  data <= "10100000";  -- 33F2 = A0
      when "011001111110011" =>  data <= "10110011";  -- 33F3 = B3
      when "011001111110100" =>  data <= "00100000";  -- 33F4 = 20
      when "011001111110101" =>  data <= "00011101";  -- 33F5 = 1D
      when "011001111110110" =>  data <= "10111011";  -- 33F6 = BB
      when "011001111110111" =>  data <= "10100100";  -- 33F7 = A4
      when "011001111111000" =>  data <= "00110111";  -- 33F8 = 37
      when "011001111111001" =>  data <= "11001000";  -- 33F9 = C8
      when "011001111111010" =>  data <= "11110000";  -- 33FA = F0
      when "011001111111011" =>  data <= "00000011";  -- 33FB = 3
      when "011001111111100" =>  data <= "00100000";  -- 33FC = 20
      when "011001111111101" =>  data <= "01111000";  -- 33FD = 78
      when "011001111111110" =>  data <= "11001111";  -- 33FE = CF
      when "011001111111111" =>  data <= "10101001";  -- 33FF = A9
      when "011010000000000" =>  data <= "00010010";  -- 3400 = 12
      when "011010000000001" =>  data <= "10100000";  -- 3401 = A0
      when "011010000000010" =>  data <= "10110011";  -- 3402 = B3
      when "011010000000011" =>  data <= "00100000";  -- 3403 = 20
      when "011010000000100" =>  data <= "00011101";  -- 3404 = 1D
      when "011010000000101" =>  data <= "10111011";  -- 3405 = BB
      when "011010000000110" =>  data <= "00100000";  -- 3406 = 20
      when "011010000000111" =>  data <= "11100010";  -- 3407 = E2
      when "011010000001000" =>  data <= "10110100";  -- 3408 = B4
      when "011010000001001" =>  data <= "10000110";  -- 3409 = 86
      when "011010000001010" =>  data <= "01110111";  -- 340A = 77
      when "011010000001011" =>  data <= "10000100";  -- 340B = 84
      when "011010000001100" =>  data <= "01111000";  -- 340C = 78
      when "011010000001101" =>  data <= "00100000";  -- 340D = 20
      when "011010000001110" =>  data <= "01110000";  -- 340E = 70
      when "011010000001111" =>  data <= "00000000";  -- 340F = 0
      when "011010000010000" =>  data <= "10101010";  -- 3410 = AA
      when "011010000010001" =>  data <= "11110000";  -- 3411 = F0
      when "011010000010010" =>  data <= "11110011";  -- 3412 = F3
      when "011010000010011" =>  data <= "10100010";  -- 3413 = A2
      when "011010000010100" =>  data <= "11111111";  -- 3414 = FF
      when "011010000010101" =>  data <= "10000110";  -- 3415 = 86
      when "011010000010110" =>  data <= "00110111";  -- 3416 = 37
      when "011010000010111" =>  data <= "10010000";  -- 3417 = 90
      when "011010000011000" =>  data <= "00000110";  -- 3418 = 6
      when "011010000011001" =>  data <= "00100000";  -- 3419 = 20
      when "011010000011010" =>  data <= "11111011";  -- 341A = FB
      when "011010000011011" =>  data <= "10110100";  -- 341B = B4
      when "011010000011100" =>  data <= "01001100";  -- 341C = 4C
      when "011010000011101" =>  data <= "01111100";  -- 341D = 7C
      when "011010000011110" =>  data <= "10110111";  -- 341E = B7
      when "011010000011111" =>  data <= "00100000";  -- 341F = 20
      when "011010000100000" =>  data <= "11110110";  -- 3420 = F6
      when "011010000100001" =>  data <= "10111000";  -- 3421 = B8
      when "011010000100010" =>  data <= "00100000";  -- 3422 = 20
      when "011010000100011" =>  data <= "11111011";  -- 3423 = FB
      when "011010000100100" =>  data <= "10110100";  -- 3424 = B4
      when "011010000100101" =>  data <= "10000100";  -- 3425 = 84
      when "011010000100110" =>  data <= "00000101";  -- 3426 = 5
      when "011010000100111" =>  data <= "00100000";  -- 3427 = 20
      when "011010000101000" =>  data <= "10100011";  -- 3428 = A3
      when "011010000101001" =>  data <= "10110101";  -- 3429 = B5
      when "011010000101010" =>  data <= "10010000";  -- 342A = 90
      when "011010000101011" =>  data <= "01000100";  -- 342B = 44
      when "011010000101100" =>  data <= "10100000";  -- 342C = A0
      when "011010000101101" =>  data <= "00000001";  -- 342D = 1
      when "011010000101110" =>  data <= "10110001";  -- 342E = B1
      when "011010000101111" =>  data <= "01011100";  -- 342F = 5C
      when "011010000110000" =>  data <= "10000101";  -- 3430 = 85
      when "011010000110001" =>  data <= "00100000";  -- 3431 = 20
      when "011010000110010" =>  data <= "10100101";  -- 3432 = A5
      when "011010000110011" =>  data <= "00101010";  -- 3433 = 2A
      when "011010000110100" =>  data <= "10000101";  -- 3434 = 85
      when "011010000110101" =>  data <= "00011111";  -- 3435 = 1F
      when "011010000110110" =>  data <= "10100101";  -- 3436 = A5
      when "011010000110111" =>  data <= "01011101";  -- 3437 = 5D
      when "011010000111000" =>  data <= "10000101";  -- 3438 = 85
      when "011010000111001" =>  data <= "00100010";  -- 3439 = 22
      when "011010000111010" =>  data <= "10100101";  -- 343A = A5
      when "011010000111011" =>  data <= "01011100";  -- 343B = 5C
      when "011010000111100" =>  data <= "10001000";  -- 343C = 88
      when "011010000111101" =>  data <= "11110001";  -- 343D = F1
      when "011010000111110" =>  data <= "01011100";  -- 343E = 5C
      when "011010000111111" =>  data <= "00011000";  -- 343F = 18
      when "011010001000000" =>  data <= "01100101";  -- 3440 = 65
      when "011010001000001" =>  data <= "00101010";  -- 3441 = 2A
      when "011010001000010" =>  data <= "10000101";  -- 3442 = 85
      when "011010001000011" =>  data <= "00101010";  -- 3443 = 2A
      when "011010001000100" =>  data <= "10000101";  -- 3444 = 85
      when "011010001000101" =>  data <= "00100001";  -- 3445 = 21
      when "011010001000110" =>  data <= "10100101";  -- 3446 = A5
      when "011010001000111" =>  data <= "00101011";  -- 3447 = 2B
      when "011010001001000" =>  data <= "01101001";  -- 3448 = 69
      when "011010001001001" =>  data <= "11111111";  -- 3449 = FF
      when "011010001001010" =>  data <= "10000101";  -- 344A = 85
      when "011010001001011" =>  data <= "00101011";  -- 344B = 2B
      when "011010001001100" =>  data <= "11100101";  -- 344C = E5
      when "011010001001101" =>  data <= "01011101";  -- 344D = 5D
      when "011010001001110" =>  data <= "10101010";  -- 344E = AA
      when "011010001001111" =>  data <= "00111000";  -- 344F = 38
      when "011010001010000" =>  data <= "10100101";  -- 3450 = A5
      when "011010001010001" =>  data <= "01011100";  -- 3451 = 5C
      when "011010001010010" =>  data <= "11100101";  -- 3452 = E5
      when "011010001010011" =>  data <= "00101010";  -- 3453 = 2A
      when "011010001010100" =>  data <= "10101000";  -- 3454 = A8
      when "011010001010101" =>  data <= "10110000";  -- 3455 = B0
      when "011010001010110" =>  data <= "00000011";  -- 3456 = 3
      when "011010001010111" =>  data <= "11101000";  -- 3457 = E8
      when "011010001011000" =>  data <= "11000110";  -- 3458 = C6
      when "011010001011001" =>  data <= "00100010";  -- 3459 = 22
      when "011010001011010" =>  data <= "00011000";  -- 345A = 18
      when "011010001011011" =>  data <= "01100101";  -- 345B = 65
      when "011010001011100" =>  data <= "00011111";  -- 345C = 1F
      when "011010001011101" =>  data <= "10010000";  -- 345D = 90
      when "011010001011110" =>  data <= "00000011";  -- 345E = 3
      when "011010001011111" =>  data <= "11000110";  -- 345F = C6
      when "011010001100000" =>  data <= "00100000";  -- 3460 = 20
      when "011010001100001" =>  data <= "00011000";  -- 3461 = 18
      when "011010001100010" =>  data <= "10110001";  -- 3462 = B1
      when "011010001100011" =>  data <= "00011111";  -- 3463 = 1F
      when "011010001100100" =>  data <= "10010001";  -- 3464 = 91
      when "011010001100101" =>  data <= "00100001";  -- 3465 = 21
      when "011010001100110" =>  data <= "11001000";  -- 3466 = C8
      when "011010001100111" =>  data <= "11010000";  -- 3467 = D0
      when "011010001101000" =>  data <= "11111001";  -- 3468 = F9
      when "011010001101001" =>  data <= "11100110";  -- 3469 = E6
      when "011010001101010" =>  data <= "00100000";  -- 346A = 20
      when "011010001101011" =>  data <= "11100110";  -- 346B = E6
      when "011010001101100" =>  data <= "00100010";  -- 346C = 22
      when "011010001101101" =>  data <= "11001010";  -- 346D = CA
      when "011010001101110" =>  data <= "11010000";  -- 346E = D0
      when "011010001101111" =>  data <= "11110010";  -- 346F = F2
      when "011010001110000" =>  data <= "00100000";  -- 3470 = 20
      when "011010001110001" =>  data <= "11101001";  -- 3471 = E9
      when "011010001110010" =>  data <= "10110101";  -- 3472 = B5
      when "011010001110011" =>  data <= "00100000";  -- 3473 = 20
      when "011010001110100" =>  data <= "10110110";  -- 3474 = B6
      when "011010001110101" =>  data <= "10110100";  -- 3475 = B4
      when "011010001110110" =>  data <= "10101101";  -- 3476 = AD
      when "011010001110111" =>  data <= "00000000";  -- 3477 = 0
      when "011010001111000" =>  data <= "00000010";  -- 3478 = 2
      when "011010001111001" =>  data <= "11110000";  -- 3479 = F0
      when "011010001111010" =>  data <= "10001011";  -- 347A = 8B
      when "011010001111011" =>  data <= "00011000";  -- 347B = 18
      when "011010001111100" =>  data <= "10100101";  -- 347C = A5
      when "011010001111101" =>  data <= "00101010";  -- 347D = 2A
      when "011010001111110" =>  data <= "10000101";  -- 347E = 85
      when "011010001111111" =>  data <= "01010111";  -- 347F = 57
      when "011010010000000" =>  data <= "01100101";  -- 3480 = 65
      when "011010010000001" =>  data <= "00000101";  -- 3481 = 5
      when "011010010000010" =>  data <= "10000101";  -- 3482 = 85
      when "011010010000011" =>  data <= "01010101";  -- 3483 = 55
      when "011010010000100" =>  data <= "10100100";  -- 3484 = A4
      when "011010010000101" =>  data <= "00101011";  -- 3485 = 2B
      when "011010010000110" =>  data <= "10000100";  -- 3486 = 84
      when "011010010000111" =>  data <= "01011000";  -- 3487 = 58
      when "011010010001000" =>  data <= "10010000";  -- 3488 = 90
      when "011010010001001" =>  data <= "00000001";  -- 3489 = 1
      when "011010010001010" =>  data <= "11001000";  -- 348A = C8
      when "011010010001011" =>  data <= "10000100";  -- 348B = 84
      when "011010010001100" =>  data <= "01010110";  -- 348C = 56
      when "011010010001101" =>  data <= "00100000";  -- 348D = 20
      when "011010010001110" =>  data <= "01010000";  -- 348E = 50
      when "011010010001111" =>  data <= "10110011";  -- 348F = B3
      when "011010010010000" =>  data <= "10100101";  -- 3490 = A5
      when "011010010010001" =>  data <= "00010001";  -- 3491 = 11
      when "011010010010010" =>  data <= "10100100";  -- 3492 = A4
      when "011010010010011" =>  data <= "00010010";  -- 3493 = 12
      when "011010010010100" =>  data <= "10001101";  -- 3494 = 8D
      when "011010010010101" =>  data <= "11111110";  -- 3495 = FE
      when "011010010010110" =>  data <= "00000001";  -- 3496 = 1
      when "011010010010111" =>  data <= "10001100";  -- 3497 = 8C
      when "011010010011000" =>  data <= "11111111";  -- 3498 = FF
      when "011010010011001" =>  data <= "00000001";  -- 3499 = 1
      when "011010010011010" =>  data <= "10100101";  -- 349A = A5
      when "011010010011011" =>  data <= "00101110";  -- 349B = 2E
      when "011010010011100" =>  data <= "10100100";  -- 349C = A4
      when "011010010011101" =>  data <= "00101111";  -- 349D = 2F
      when "011010010011110" =>  data <= "10000101";  -- 349E = 85
      when "011010010011111" =>  data <= "00101010";  -- 349F = 2A
      when "011010010100000" =>  data <= "10000100";  -- 34A0 = 84
      when "011010010100001" =>  data <= "00101011";  -- 34A1 = 2B
      when "011010010100010" =>  data <= "10100100";  -- 34A2 = A4
      when "011010010100011" =>  data <= "00000101";  -- 34A3 = 5
      when "011010010100100" =>  data <= "10001000";  -- 34A4 = 88
      when "011010010100101" =>  data <= "10111001";  -- 34A5 = B9
      when "011010010100110" =>  data <= "11111100";  -- 34A6 = FC
      when "011010010100111" =>  data <= "00000001";  -- 34A7 = 1
      when "011010010101000" =>  data <= "10010001";  -- 34A8 = 91
      when "011010010101001" =>  data <= "01011100";  -- 34A9 = 5C
      when "011010010101010" =>  data <= "10001000";  -- 34AA = 88
      when "011010010101011" =>  data <= "00010000";  -- 34AB = 10
      when "011010010101100" =>  data <= "11111000";  -- 34AC = F8
      when "011010010101101" =>  data <= "00100000";  -- 34AD = 20
      when "011010010101110" =>  data <= "11101001";  -- 34AE = E9
      when "011010010101111" =>  data <= "10110101";  -- 34AF = B5
      when "011010010110000" =>  data <= "00100000";  -- 34B0 = 20
      when "011010010110001" =>  data <= "10110110";  -- 34B1 = B6
      when "011010010110010" =>  data <= "10110100";  -- 34B2 = B4
      when "011010010110011" =>  data <= "01001100";  -- 34B3 = 4C
      when "011010010110100" =>  data <= "00000110";  -- 34B4 = 6
      when "011010010110101" =>  data <= "10110100";  -- 34B5 = B4
      when "011010010110110" =>  data <= "10100101";  -- 34B6 = A5
      when "011010010110111" =>  data <= "00101000";  -- 34B7 = 28
      when "011010010111000" =>  data <= "10100100";  -- 34B8 = A4
      when "011010010111001" =>  data <= "00101001";  -- 34B9 = 29
      when "011010010111010" =>  data <= "10000101";  -- 34BA = 85
      when "011010010111011" =>  data <= "00011111";  -- 34BB = 1F
      when "011010010111100" =>  data <= "10000100";  -- 34BC = 84
      when "011010010111101" =>  data <= "00100000";  -- 34BD = 20
      when "011010010111110" =>  data <= "00011000";  -- 34BE = 18
      when "011010010111111" =>  data <= "10100000";  -- 34BF = A0
      when "011010011000000" =>  data <= "00000001";  -- 34C0 = 1
      when "011010011000001" =>  data <= "10110001";  -- 34C1 = B1
      when "011010011000010" =>  data <= "00011111";  -- 34C2 = 1F
      when "011010011000011" =>  data <= "11110000";  -- 34C3 = F0
      when "011010011000100" =>  data <= "00011100";  -- 34C4 = 1C
      when "011010011000101" =>  data <= "10100000";  -- 34C5 = A0
      when "011010011000110" =>  data <= "00000100";  -- 34C6 = 4
      when "011010011000111" =>  data <= "11001000";  -- 34C7 = C8
      when "011010011001000" =>  data <= "10110001";  -- 34C8 = B1
      when "011010011001001" =>  data <= "00011111";  -- 34C9 = 1F
      when "011010011001010" =>  data <= "11010000";  -- 34CA = D0
      when "011010011001011" =>  data <= "11111011";  -- 34CB = FB
      when "011010011001100" =>  data <= "11001000";  -- 34CC = C8
      when "011010011001101" =>  data <= "10011000";  -- 34CD = 98
      when "011010011001110" =>  data <= "01100101";  -- 34CE = 65
      when "011010011001111" =>  data <= "00011111";  -- 34CF = 1F
      when "011010011010000" =>  data <= "10101010";  -- 34D0 = AA
      when "011010011010001" =>  data <= "10100000";  -- 34D1 = A0
      when "011010011010010" =>  data <= "00000000";  -- 34D2 = 0
      when "011010011010011" =>  data <= "10010001";  -- 34D3 = 91
      when "011010011010100" =>  data <= "00011111";  -- 34D4 = 1F
      when "011010011010101" =>  data <= "10011000";  -- 34D5 = 98
      when "011010011010110" =>  data <= "01100101";  -- 34D6 = 65
      when "011010011010111" =>  data <= "00100000";  -- 34D7 = 20
      when "011010011011000" =>  data <= "11001000";  -- 34D8 = C8
      when "011010011011001" =>  data <= "10010001";  -- 34D9 = 91
      when "011010011011010" =>  data <= "00011111";  -- 34DA = 1F
      when "011010011011011" =>  data <= "10000110";  -- 34DB = 86
      when "011010011011100" =>  data <= "00011111";  -- 34DC = 1F
      when "011010011011101" =>  data <= "10000101";  -- 34DD = 85
      when "011010011011110" =>  data <= "00100000";  -- 34DE = 20
      when "011010011011111" =>  data <= "10010000";  -- 34DF = 90
      when "011010011100000" =>  data <= "11011110";  -- 34E0 = DE
      when "011010011100001" =>  data <= "01100000";  -- 34E1 = 60
      when "011010011100010" =>  data <= "10100010";  -- 34E2 = A2
      when "011010011100011" =>  data <= "00000000";  -- 34E3 = 0
      when "011010011100100" =>  data <= "00100000";  -- 34E4 = 20
      when "011010011100101" =>  data <= "11001111";  -- 34E5 = CF
      when "011010011100110" =>  data <= "11111111";  -- 34E6 = FF
      when "011010011100111" =>  data <= "11001001";  -- 34E7 = C9
      when "011010011101000" =>  data <= "00001101";  -- 34E8 = D
      when "011010011101001" =>  data <= "11110000";  -- 34E9 = F0
      when "011010011101010" =>  data <= "00001101";  -- 34EA = D
      when "011010011101011" =>  data <= "10011101";  -- 34EB = 9D
      when "011010011101100" =>  data <= "00000000";  -- 34EC = 0
      when "011010011101101" =>  data <= "00000010";  -- 34ED = 2
      when "011010011101110" =>  data <= "11101000";  -- 34EE = E8
      when "011010011101111" =>  data <= "11100000";  -- 34EF = E0
      when "011010011110000" =>  data <= "01010001";  -- 34F0 = 51
      when "011010011110001" =>  data <= "11010000";  -- 34F1 = D0
      when "011010011110010" =>  data <= "11110001";  -- 34F2 = F1
      when "011010011110011" =>  data <= "10100010";  -- 34F3 = A2
      when "011010011110100" =>  data <= "10110000";  -- 34F4 = B0
      when "011010011110101" =>  data <= "01001100";  -- 34F5 = 4C
      when "011010011110110" =>  data <= "11001111";  -- 34F6 = CF
      when "011010011110111" =>  data <= "10110011";  -- 34F7 = B3
      when "011010011111000" =>  data <= "01001100";  -- 34F8 = 4C
      when "011010011111001" =>  data <= "11010010";  -- 34F9 = D2
      when "011010011111010" =>  data <= "10111010";  -- 34FA = BA
      when "011010011111011" =>  data <= "10100110";  -- 34FB = A6
      when "011010011111100" =>  data <= "01110111";  -- 34FC = 77
      when "011010011111101" =>  data <= "10100000";  -- 34FD = A0
      when "011010011111110" =>  data <= "00000100";  -- 34FE = 4
      when "011010011111111" =>  data <= "10000100";  -- 34FF = 84
      when "011010100000000" =>  data <= "00001001";  -- 3500 = 9
      when "011010100000001" =>  data <= "10111101";  -- 3501 = BD
      when "011010100000010" =>  data <= "00000000";  -- 3502 = 0
      when "011010100000011" =>  data <= "00000010";  -- 3503 = 2
      when "011010100000100" =>  data <= "00010000";  -- 3504 = 10
      when "011010100000101" =>  data <= "00000111";  -- 3505 = 7
      when "011010100000110" =>  data <= "11001001";  -- 3506 = C9
      when "011010100000111" =>  data <= "11111111";  -- 3507 = FF
      when "011010100001000" =>  data <= "11110000";  -- 3508 = F0
      when "011010100001001" =>  data <= "01001010";  -- 3509 = 4A
      when "011010100001010" =>  data <= "11101000";  -- 350A = E8
      when "011010100001011" =>  data <= "11010000";  -- 350B = D0
      when "011010100001100" =>  data <= "11110100";  -- 350C = F4
      when "011010100001101" =>  data <= "11001001";  -- 350D = C9
      when "011010100001110" =>  data <= "00100000";  -- 350E = 20
      when "011010100001111" =>  data <= "11110000";  -- 350F = F0
      when "011010100010000" =>  data <= "01000011";  -- 3510 = 43
      when "011010100010001" =>  data <= "10000101";  -- 3511 = 85
      when "011010100010010" =>  data <= "00000100";  -- 3512 = 4
      when "011010100010011" =>  data <= "11001001";  -- 3513 = C9
      when "011010100010100" =>  data <= "00100010";  -- 3514 = 22
      when "011010100010101" =>  data <= "11110000";  -- 3515 = F0
      when "011010100010110" =>  data <= "01100010";  -- 3516 = 62
      when "011010100010111" =>  data <= "00100100";  -- 3517 = 24
      when "011010100011000" =>  data <= "00001001";  -- 3518 = 9
      when "011010100011001" =>  data <= "01110000";  -- 3519 = 70
      when "011010100011010" =>  data <= "00111001";  -- 351A = 39
      when "011010100011011" =>  data <= "11001001";  -- 351B = C9
      when "011010100011100" =>  data <= "00111111";  -- 351C = 3F
      when "011010100011101" =>  data <= "11010000";  -- 351D = D0
      when "011010100011110" =>  data <= "00000100";  -- 351E = 4
      when "011010100011111" =>  data <= "10101001";  -- 351F = A9
      when "011010100100000" =>  data <= "10011001";  -- 3520 = 99
      when "011010100100001" =>  data <= "11010000";  -- 3521 = D0
      when "011010100100010" =>  data <= "00110001";  -- 3522 = 31
      when "011010100100011" =>  data <= "11001001";  -- 3523 = C9
      when "011010100100100" =>  data <= "00110000";  -- 3524 = 30
      when "011010100100101" =>  data <= "10010000";  -- 3525 = 90
      when "011010100100110" =>  data <= "00000100";  -- 3526 = 4
      when "011010100100111" =>  data <= "11001001";  -- 3527 = C9
      when "011010100101000" =>  data <= "00111100";  -- 3528 = 3C
      when "011010100101001" =>  data <= "10010000";  -- 3529 = 90
      when "011010100101010" =>  data <= "00101001";  -- 352A = 29
      when "011010100101011" =>  data <= "10000100";  -- 352B = 84
      when "011010100101100" =>  data <= "01101110";  -- 352C = 6E
      when "011010100101101" =>  data <= "10100000";  -- 352D = A0
      when "011010100101110" =>  data <= "00000000";  -- 352E = 0
      when "011010100101111" =>  data <= "10000100";  -- 352F = 84
      when "011010100110000" =>  data <= "00000101";  -- 3530 = 5
      when "011010100110001" =>  data <= "10000110";  -- 3531 = 86
      when "011010100110010" =>  data <= "01110111";  -- 3532 = 77
      when "011010100110011" =>  data <= "10101001";  -- 3533 = A9
      when "011010100110100" =>  data <= "10110000";  -- 3534 = B0
      when "011010100110101" =>  data <= "10000101";  -- 3535 = 85
      when "011010100110110" =>  data <= "00100000";  -- 3536 = 20
      when "011010100110111" =>  data <= "10101001";  -- 3537 = A9
      when "011010100111000" =>  data <= "10110010";  -- 3538 = B2
      when "011010100111001" =>  data <= "10000101";  -- 3539 = 85
      when "011010100111010" =>  data <= "00011111";  -- 353A = 1F
      when "011010100111011" =>  data <= "11010000";  -- 353B = D0
      when "011010100111100" =>  data <= "00000111";  -- 353C = 7
      when "011010100111101" =>  data <= "11101000";  -- 353D = E8
      when "011010100111110" =>  data <= "11100110";  -- 353E = E6
      when "011010100111111" =>  data <= "00011111";  -- 353F = 1F
      when "011010101000000" =>  data <= "11010000";  -- 3540 = D0
      when "011010101000001" =>  data <= "00000010";  -- 3541 = 2
      when "011010101000010" =>  data <= "11100110";  -- 3542 = E6
      when "011010101000011" =>  data <= "00100000";  -- 3543 = 20
      when "011010101000100" =>  data <= "10111101";  -- 3544 = BD
      when "011010101000101" =>  data <= "00000000";  -- 3545 = 0
      when "011010101000110" =>  data <= "00000010";  -- 3546 = 2
      when "011010101000111" =>  data <= "00111000";  -- 3547 = 38
      when "011010101001000" =>  data <= "11110001";  -- 3548 = F1
      when "011010101001001" =>  data <= "00011111";  -- 3549 = 1F
      when "011010101001010" =>  data <= "11110000";  -- 354A = F0
      when "011010101001011" =>  data <= "11110001";  -- 354B = F1
      when "011010101001100" =>  data <= "11001001";  -- 354C = C9
      when "011010101001101" =>  data <= "10000000";  -- 354D = 80
      when "011010101001110" =>  data <= "11010000";  -- 354E = D0
      when "011010101001111" =>  data <= "00110000";  -- 354F = 30
      when "011010101010000" =>  data <= "00000101";  -- 3550 = 5
      when "011010101010001" =>  data <= "00000101";  -- 3551 = 5
      when "011010101010010" =>  data <= "10100100";  -- 3552 = A4
      when "011010101010011" =>  data <= "01101110";  -- 3553 = 6E
      when "011010101010100" =>  data <= "11101000";  -- 3554 = E8
      when "011010101010101" =>  data <= "11001000";  -- 3555 = C8
      when "011010101010110" =>  data <= "10011001";  -- 3556 = 99
      when "011010101010111" =>  data <= "11111011";  -- 3557 = FB
      when "011010101011000" =>  data <= "00000001";  -- 3558 = 1
      when "011010101011001" =>  data <= "10111001";  -- 3559 = B9
      when "011010101011010" =>  data <= "11111011";  -- 355A = FB
      when "011010101011011" =>  data <= "00000001";  -- 355B = 1
      when "011010101011100" =>  data <= "11110000";  -- 355C = F0
      when "011010101011101" =>  data <= "00111011";  -- 355D = 3B
      when "011010101011110" =>  data <= "00111000";  -- 355E = 38
      when "011010101011111" =>  data <= "11101001";  -- 355F = E9
      when "011010101100000" =>  data <= "00111010";  -- 3560 = 3A
      when "011010101100001" =>  data <= "11110000";  -- 3561 = F0
      when "011010101100010" =>  data <= "00000100";  -- 3562 = 4
      when "011010101100011" =>  data <= "11001001";  -- 3563 = C9
      when "011010101100100" =>  data <= "01001001";  -- 3564 = 49
      when "011010101100101" =>  data <= "11010000";  -- 3565 = D0
      when "011010101100110" =>  data <= "00000010";  -- 3566 = 2
      when "011010101100111" =>  data <= "10000101";  -- 3567 = 85
      when "011010101101000" =>  data <= "00001001";  -- 3568 = 9
      when "011010101101001" =>  data <= "00111000";  -- 3569 = 38
      when "011010101101010" =>  data <= "11101001";  -- 356A = E9
      when "011010101101011" =>  data <= "01010101";  -- 356B = 55
      when "011010101101100" =>  data <= "11010000";  -- 356C = D0
      when "011010101101101" =>  data <= "10010011";  -- 356D = 93
      when "011010101101110" =>  data <= "10000101";  -- 356E = 85
      when "011010101101111" =>  data <= "00000100";  -- 356F = 4
      when "011010101110000" =>  data <= "10111101";  -- 3570 = BD
      when "011010101110001" =>  data <= "00000000";  -- 3571 = 0
      when "011010101110010" =>  data <= "00000010";  -- 3572 = 2
      when "011010101110011" =>  data <= "11110000";  -- 3573 = F0
      when "011010101110100" =>  data <= "11011111";  -- 3574 = DF
      when "011010101110101" =>  data <= "11000101";  -- 3575 = C5
      when "011010101110110" =>  data <= "00000100";  -- 3576 = 4
      when "011010101110111" =>  data <= "11110000";  -- 3577 = F0
      when "011010101111000" =>  data <= "11011011";  -- 3578 = DB
      when "011010101111001" =>  data <= "11001000";  -- 3579 = C8
      when "011010101111010" =>  data <= "10011001";  -- 357A = 99
      when "011010101111011" =>  data <= "11111011";  -- 357B = FB
      when "011010101111100" =>  data <= "00000001";  -- 357C = 1
      when "011010101111101" =>  data <= "11101000";  -- 357D = E8
      when "011010101111110" =>  data <= "11010000";  -- 357E = D0
      when "011010101111111" =>  data <= "11110000";  -- 357F = F0
      when "011010110000000" =>  data <= "10100110";  -- 3580 = A6
      when "011010110000001" =>  data <= "01110111";  -- 3581 = 77
      when "011010110000010" =>  data <= "11100110";  -- 3582 = E6
      when "011010110000011" =>  data <= "00000101";  -- 3583 = 5
      when "011010110000100" =>  data <= "10110001";  -- 3584 = B1
      when "011010110000101" =>  data <= "00011111";  -- 3585 = 1F
      when "011010110000110" =>  data <= "00001000";  -- 3586 = 8
      when "011010110000111" =>  data <= "11100110";  -- 3587 = E6
      when "011010110001000" =>  data <= "00011111";  -- 3588 = 1F
      when "011010110001001" =>  data <= "11010000";  -- 3589 = D0
      when "011010110001010" =>  data <= "00000010";  -- 358A = 2
      when "011010110001011" =>  data <= "11100110";  -- 358B = E6
      when "011010110001100" =>  data <= "00100000";  -- 358C = 20
      when "011010110001101" =>  data <= "00101000";  -- 358D = 28
      when "011010110001110" =>  data <= "00010000";  -- 358E = 10
      when "011010110001111" =>  data <= "11110100";  -- 358F = F4
      when "011010110010000" =>  data <= "10110001";  -- 3590 = B1
      when "011010110010001" =>  data <= "00011111";  -- 3591 = 1F
      when "011010110010010" =>  data <= "11010000";  -- 3592 = D0
      when "011010110010011" =>  data <= "10110000";  -- 3593 = B0
      when "011010110010100" =>  data <= "10111101";  -- 3594 = BD
      when "011010110010101" =>  data <= "00000000";  -- 3595 = 0
      when "011010110010110" =>  data <= "00000010";  -- 3596 = 2
      when "011010110010111" =>  data <= "00010000";  -- 3597 = 10
      when "011010110011000" =>  data <= "10111001";  -- 3598 = B9
      when "011010110011001" =>  data <= "10011001";  -- 3599 = 99
      when "011010110011010" =>  data <= "11111101";  -- 359A = FD
      when "011010110011011" =>  data <= "00000001";  -- 359B = 1
      when "011010110011100" =>  data <= "11000110";  -- 359C = C6
      when "011010110011101" =>  data <= "01111000";  -- 359D = 78
      when "011010110011110" =>  data <= "10101001";  -- 359E = A9
      when "011010110011111" =>  data <= "11111111";  -- 359F = FF
      when "011010110100000" =>  data <= "10000101";  -- 35A0 = 85
      when "011010110100001" =>  data <= "01110111";  -- 35A1 = 77
      when "011010110100010" =>  data <= "01100000";  -- 35A2 = 60
      when "011010110100011" =>  data <= "10100101";  -- 35A3 = A5
      when "011010110100100" =>  data <= "00101000";  -- 35A4 = 28
      when "011010110100101" =>  data <= "10100110";  -- 35A5 = A6
      when "011010110100110" =>  data <= "00101001";  -- 35A6 = 29
      when "011010110100111" =>  data <= "10100000";  -- 35A7 = A0
      when "011010110101000" =>  data <= "00000001";  -- 35A8 = 1
      when "011010110101001" =>  data <= "10000101";  -- 35A9 = 85
      when "011010110101010" =>  data <= "01011100";  -- 35AA = 5C
      when "011010110101011" =>  data <= "10000110";  -- 35AB = 86
      when "011010110101100" =>  data <= "01011101";  -- 35AC = 5D
      when "011010110101101" =>  data <= "10110001";  -- 35AD = B1
      when "011010110101110" =>  data <= "01011100";  -- 35AE = 5C
      when "011010110101111" =>  data <= "11110000";  -- 35AF = F0
      when "011010110110000" =>  data <= "00011111";  -- 35B0 = 1F
      when "011010110110001" =>  data <= "11001000";  -- 35B1 = C8
      when "011010110110010" =>  data <= "11001000";  -- 35B2 = C8
      when "011010110110011" =>  data <= "10100101";  -- 35B3 = A5
      when "011010110110100" =>  data <= "00010010";  -- 35B4 = 12
      when "011010110110101" =>  data <= "11010001";  -- 35B5 = D1
      when "011010110110110" =>  data <= "01011100";  -- 35B6 = 5C
      when "011010110110111" =>  data <= "10010000";  -- 35B7 = 90
      when "011010110111000" =>  data <= "00011000";  -- 35B8 = 18
      when "011010110111001" =>  data <= "11110000";  -- 35B9 = F0
      when "011010110111010" =>  data <= "00000011";  -- 35BA = 3
      when "011010110111011" =>  data <= "10001000";  -- 35BB = 88
      when "011010110111100" =>  data <= "11010000";  -- 35BC = D0
      when "011010110111101" =>  data <= "00001001";  -- 35BD = 9
      when "011010110111110" =>  data <= "10100101";  -- 35BE = A5
      when "011010110111111" =>  data <= "00010001";  -- 35BF = 11
      when "011010111000000" =>  data <= "10001000";  -- 35C0 = 88
      when "011010111000001" =>  data <= "11010001";  -- 35C1 = D1
      when "011010111000010" =>  data <= "01011100";  -- 35C2 = 5C
      when "011010111000011" =>  data <= "10010000";  -- 35C3 = 90
      when "011010111000100" =>  data <= "00001100";  -- 35C4 = C
      when "011010111000101" =>  data <= "11110000";  -- 35C5 = F0
      when "011010111000110" =>  data <= "00001010";  -- 35C6 = A
      when "011010111000111" =>  data <= "10001000";  -- 35C7 = 88
      when "011010111001000" =>  data <= "10110001";  -- 35C8 = B1
      when "011010111001001" =>  data <= "01011100";  -- 35C9 = 5C
      when "011010111001010" =>  data <= "10101010";  -- 35CA = AA
      when "011010111001011" =>  data <= "10001000";  -- 35CB = 88
      when "011010111001100" =>  data <= "10110001";  -- 35CC = B1
      when "011010111001101" =>  data <= "01011100";  -- 35CD = 5C
      when "011010111001110" =>  data <= "10110000";  -- 35CE = B0
      when "011010111001111" =>  data <= "11010111";  -- 35CF = D7
      when "011010111010000" =>  data <= "00011000";  -- 35D0 = 18
      when "011010111010001" =>  data <= "01100000";  -- 35D1 = 60
      when "011010111010010" =>  data <= "11010000";  -- 35D2 = D0
      when "011010111010011" =>  data <= "11111101";  -- 35D3 = FD
      when "011010111010100" =>  data <= "10101001";  -- 35D4 = A9
      when "011010111010101" =>  data <= "00000000";  -- 35D5 = 0
      when "011010111010110" =>  data <= "10101000";  -- 35D6 = A8
      when "011010111010111" =>  data <= "10010001";  -- 35D7 = 91
      when "011010111011000" =>  data <= "00101000";  -- 35D8 = 28
      when "011010111011001" =>  data <= "11001000";  -- 35D9 = C8
      when "011010111011010" =>  data <= "10010001";  -- 35DA = 91
      when "011010111011011" =>  data <= "00101000";  -- 35DB = 28
      when "011010111011100" =>  data <= "10100101";  -- 35DC = A5
      when "011010111011101" =>  data <= "00101000";  -- 35DD = 28
      when "011010111011110" =>  data <= "00011000";  -- 35DE = 18
      when "011010111011111" =>  data <= "01101001";  -- 35DF = 69
      when "011010111100000" =>  data <= "00000010";  -- 35E0 = 2
      when "011010111100001" =>  data <= "10000101";  -- 35E1 = 85
      when "011010111100010" =>  data <= "00101010";  -- 35E2 = 2A
      when "011010111100011" =>  data <= "10100101";  -- 35E3 = A5
      when "011010111100100" =>  data <= "00101001";  -- 35E4 = 29
      when "011010111100101" =>  data <= "01101001";  -- 35E5 = 69
      when "011010111100110" =>  data <= "00000000";  -- 35E6 = 0
      when "011010111100111" =>  data <= "10000101";  -- 35E7 = 85
      when "011010111101000" =>  data <= "00101011";  -- 35E8 = 2B
      when "011010111101001" =>  data <= "00100000";  -- 35E9 = 20
      when "011010111101010" =>  data <= "00100010";  -- 35EA = 22
      when "011010111101011" =>  data <= "10110110";  -- 35EB = B6
      when "011010111101100" =>  data <= "10101001";  -- 35EC = A9
      when "011010111101101" =>  data <= "00000000";  -- 35ED = 0
      when "011010111101110" =>  data <= "11010000";  -- 35EE = D0
      when "011010111101111" =>  data <= "00110001";  -- 35EF = 31
      when "011010111110000" =>  data <= "10100101";  -- 35F0 = A5
      when "011010111110001" =>  data <= "00110100";  -- 35F1 = 34
      when "011010111110010" =>  data <= "10100100";  -- 35F2 = A4
      when "011010111110011" =>  data <= "00110101";  -- 35F3 = 35
      when "011010111110100" =>  data <= "10000101";  -- 35F4 = 85
      when "011010111110101" =>  data <= "00110000";  -- 35F5 = 30
      when "011010111110110" =>  data <= "10000100";  -- 35F6 = 84
      when "011010111110111" =>  data <= "00110001";  -- 35F7 = 31
      when "011010111111000" =>  data <= "10101001";  -- 35F8 = A9
      when "011010111111001" =>  data <= "00000000";  -- 35F9 = 0
      when "011010111111010" =>  data <= "10000101";  -- 35FA = 85
      when "011010111111011" =>  data <= "00001101";  -- 35FB = D
      when "011010111111100" =>  data <= "00100000";  -- 35FC = 20
      when "011010111111101" =>  data <= "11100111";  -- 35FD = E7
      when "011010111111110" =>  data <= "11111111";  -- 35FE = FF
      when "011010111111111" =>  data <= "10100101";  -- 35FF = A5
      when "011011000000000" =>  data <= "00101010";  -- 3600 = 2A
      when "011011000000001" =>  data <= "10100100";  -- 3601 = A4
      when "011011000000010" =>  data <= "00101011";  -- 3602 = 2B
      when "011011000000011" =>  data <= "10000101";  -- 3603 = 85
      when "011011000000100" =>  data <= "00101100";  -- 3604 = 2C
      when "011011000000101" =>  data <= "10000100";  -- 3605 = 84
      when "011011000000110" =>  data <= "00101101";  -- 3606 = 2D
      when "011011000000111" =>  data <= "10000101";  -- 3607 = 85
      when "011011000001000" =>  data <= "00101110";  -- 3608 = 2E
      when "011011000001001" =>  data <= "10000100";  -- 3609 = 84
      when "011011000001010" =>  data <= "00101111";  -- 360A = 2F
      when "011011000001011" =>  data <= "00100000";  -- 360B = 20
      when "011011000001100" =>  data <= "10110111";  -- 360C = B7
      when "011011000001101" =>  data <= "10110111";  -- 360D = B7
      when "011011000001110" =>  data <= "10100010";  -- 360E = A2
      when "011011000001111" =>  data <= "00010110";  -- 360F = 16
      when "011011000010000" =>  data <= "10000110";  -- 3610 = 86
      when "011011000010001" =>  data <= "00010011";  -- 3611 = 13
      when "011011000010010" =>  data <= "01101000";  -- 3612 = 68
      when "011011000010011" =>  data <= "10101000";  -- 3613 = A8
      when "011011000010100" =>  data <= "01101000";  -- 3614 = 68
      when "011011000010101" =>  data <= "10100010";  -- 3615 = A2
      when "011011000010110" =>  data <= "11111010";  -- 3616 = FA
      when "011011000010111" =>  data <= "10011010";  -- 3617 = 9A
      when "011011000011000" =>  data <= "01001000";  -- 3618 = 48
      when "011011000011001" =>  data <= "10011000";  -- 3619 = 98
      when "011011000011010" =>  data <= "01001000";  -- 361A = 48
      when "011011000011011" =>  data <= "10101001";  -- 361B = A9
      when "011011000011100" =>  data <= "00000000";  -- 361C = 0
      when "011011000011101" =>  data <= "10000101";  -- 361D = 85
      when "011011000011110" =>  data <= "00111011";  -- 361E = 3B
      when "011011000011111" =>  data <= "10000101";  -- 361F = 85
      when "011011000100000" =>  data <= "00001010";  -- 3620 = A
      when "011011000100001" =>  data <= "01100000";  -- 3621 = 60
      when "011011000100010" =>  data <= "00011000";  -- 3622 = 18
      when "011011000100011" =>  data <= "10100101";  -- 3623 = A5
      when "011011000100100" =>  data <= "00101000";  -- 3624 = 28
      when "011011000100101" =>  data <= "01101001";  -- 3625 = 69
      when "011011000100110" =>  data <= "11111111";  -- 3626 = FF
      when "011011000100111" =>  data <= "10000101";  -- 3627 = 85
      when "011011000101000" =>  data <= "01110111";  -- 3628 = 77
      when "011011000101001" =>  data <= "10100101";  -- 3629 = A5
      when "011011000101010" =>  data <= "00101001";  -- 362A = 29
      when "011011000101011" =>  data <= "01101001";  -- 362B = 69
      when "011011000101100" =>  data <= "11111111";  -- 362C = FF
      when "011011000101101" =>  data <= "10000101";  -- 362D = 85
      when "011011000101110" =>  data <= "01111000";  -- 362E = 78
      when "011011000101111" =>  data <= "01100000";  -- 362F = 60
      when "011011000110000" =>  data <= "10010000";  -- 3630 = 90
      when "011011000110001" =>  data <= "00000110";  -- 3631 = 6
      when "011011000110010" =>  data <= "11110000";  -- 3632 = F0
      when "011011000110011" =>  data <= "00000100";  -- 3633 = 4
      when "011011000110100" =>  data <= "11001001";  -- 3634 = C9
      when "011011000110101" =>  data <= "10101011";  -- 3635 = AB
      when "011011000110110" =>  data <= "11010000";  -- 3636 = D0
      when "011011000110111" =>  data <= "11101001";  -- 3637 = E9
      when "011011000111000" =>  data <= "00100000";  -- 3638 = 20
      when "011011000111001" =>  data <= "11110110";  -- 3639 = F6
      when "011011000111010" =>  data <= "10111000";  -- 363A = B8
      when "011011000111011" =>  data <= "00100000";  -- 363B = 20
      when "011011000111100" =>  data <= "10100011";  -- 363C = A3
      when "011011000111101" =>  data <= "10110101";  -- 363D = B5
      when "011011000111110" =>  data <= "00100000";  -- 363E = 20
      when "011011000111111" =>  data <= "01110110";  -- 363F = 76
      when "011011001000000" =>  data <= "00000000";  -- 3640 = 0
      when "011011001000001" =>  data <= "11110000";  -- 3641 = F0
      when "011011001000010" =>  data <= "00001100";  -- 3642 = C
      when "011011001000011" =>  data <= "11001001";  -- 3643 = C9
      when "011011001000100" =>  data <= "10101011";  -- 3644 = AB
      when "011011001000101" =>  data <= "11010000";  -- 3645 = D0
      when "011011001000110" =>  data <= "10001010";  -- 3646 = 8A
      when "011011001000111" =>  data <= "00100000";  -- 3647 = 20
      when "011011001001000" =>  data <= "01110000";  -- 3648 = 70
      when "011011001001001" =>  data <= "00000000";  -- 3649 = 0
      when "011011001001010" =>  data <= "00100000";  -- 364A = 20
      when "011011001001011" =>  data <= "11110110";  -- 364B = F6
      when "011011001001100" =>  data <= "10111000";  -- 364C = B8
      when "011011001001101" =>  data <= "11010000";  -- 364D = D0
      when "011011001001110" =>  data <= "10000010";  -- 364E = 82
      when "011011001001111" =>  data <= "01101000";  -- 364F = 68
      when "011011001010000" =>  data <= "01101000";  -- 3650 = 68
      when "011011001010001" =>  data <= "10100101";  -- 3651 = A5
      when "011011001010010" =>  data <= "00010001";  -- 3652 = 11
      when "011011001010011" =>  data <= "00000101";  -- 3653 = 5
      when "011011001010100" =>  data <= "00010010";  -- 3654 = 12
      when "011011001010101" =>  data <= "11010000";  -- 3655 = D0
      when "011011001010110" =>  data <= "00000110";  -- 3656 = 6
      when "011011001010111" =>  data <= "10101001";  -- 3657 = A9
      when "011011001011000" =>  data <= "11111111";  -- 3658 = FF
      when "011011001011001" =>  data <= "10000101";  -- 3659 = 85
      when "011011001011010" =>  data <= "00010001";  -- 365A = 11
      when "011011001011011" =>  data <= "10000101";  -- 365B = 85
      when "011011001011100" =>  data <= "00010010";  -- 365C = 12
      when "011011001011101" =>  data <= "10100000";  -- 365D = A0
      when "011011001011110" =>  data <= "00000001";  -- 365E = 1
      when "011011001011111" =>  data <= "10000100";  -- 365F = 84
      when "011011001100000" =>  data <= "00001001";  -- 3660 = 9
      when "011011001100001" =>  data <= "10110001";  -- 3661 = B1
      when "011011001100010" =>  data <= "01011100";  -- 3662 = 5C
      when "011011001100011" =>  data <= "11110000";  -- 3663 = F0
      when "011011001100100" =>  data <= "01000011";  -- 3664 = 43
      when "011011001100101" =>  data <= "00100000";  -- 3665 = 20
      when "011011001100110" =>  data <= "11100001";  -- 3666 = E1
      when "011011001100111" =>  data <= "11111111";  -- 3667 = FF
      when "011011001101000" =>  data <= "00100000";  -- 3668 = 20
      when "011011001101001" =>  data <= "11011111";  -- 3669 = DF
      when "011011001101010" =>  data <= "10111010";  -- 366A = BA
      when "011011001101011" =>  data <= "11001000";  -- 366B = C8
      when "011011001101100" =>  data <= "10110001";  -- 366C = B1
      when "011011001101101" =>  data <= "01011100";  -- 366D = 5C
      when "011011001101110" =>  data <= "10101010";  -- 366E = AA
      when "011011001101111" =>  data <= "11001000";  -- 366F = C8
      when "011011001110000" =>  data <= "10110001";  -- 3670 = B1
      when "011011001110001" =>  data <= "01011100";  -- 3671 = 5C
      when "011011001110010" =>  data <= "11000101";  -- 3672 = C5
      when "011011001110011" =>  data <= "00010010";  -- 3673 = 12
      when "011011001110100" =>  data <= "11010000";  -- 3674 = D0
      when "011011001110101" =>  data <= "00000100";  -- 3675 = 4
      when "011011001110110" =>  data <= "11100100";  -- 3676 = E4
      when "011011001110111" =>  data <= "00010001";  -- 3677 = 11
      when "011011001111000" =>  data <= "11110000";  -- 3678 = F0
      when "011011001111001" =>  data <= "00000010";  -- 3679 = 2
      when "011011001111010" =>  data <= "10110000";  -- 367A = B0
      when "011011001111011" =>  data <= "00101100";  -- 367B = 2C
      when "011011001111100" =>  data <= "10000100";  -- 367C = 84
      when "011011001111101" =>  data <= "01000110";  -- 367D = 46
      when "011011001111110" =>  data <= "00100000";  -- 367E = 20
      when "011011001111111" =>  data <= "10000011";  -- 367F = 83
      when "011011010000000" =>  data <= "11001111";  -- 3680 = CF
      when "011011010000001" =>  data <= "10101001";  -- 3681 = A9
      when "011011010000010" =>  data <= "00100000";  -- 3682 = 20
      when "011011010000011" =>  data <= "10100100";  -- 3683 = A4
      when "011011010000100" =>  data <= "01000110";  -- 3684 = 46
      when "011011010000101" =>  data <= "00101001";  -- 3685 = 29
      when "011011010000110" =>  data <= "01111111";  -- 3686 = 7F
      when "011011010000111" =>  data <= "00100000";  -- 3687 = 20
      when "011011010001000" =>  data <= "01000110";  -- 3688 = 46
      when "011011010001001" =>  data <= "10111011";  -- 3689 = BB
      when "011011010001010" =>  data <= "11001001";  -- 368A = C9
      when "011011010001011" =>  data <= "00100010";  -- 368B = 22
      when "011011010001100" =>  data <= "11010000";  -- 368C = D0
      when "011011010001101" =>  data <= "00000110";  -- 368D = 6
      when "011011010001110" =>  data <= "10100101";  -- 368E = A5
      when "011011010001111" =>  data <= "00001001";  -- 368F = 9
      when "011011010010000" =>  data <= "01001001";  -- 3690 = 49
      when "011011010010001" =>  data <= "11111111";  -- 3691 = FF
      when "011011010010010" =>  data <= "10000101";  -- 3692 = 85
      when "011011010010011" =>  data <= "00001001";  -- 3693 = 9
      when "011011010010100" =>  data <= "11001000";  -- 3694 = C8
      when "011011010010101" =>  data <= "11110000";  -- 3695 = F0
      when "011011010010110" =>  data <= "00010001";  -- 3696 = 11
      when "011011010010111" =>  data <= "10110001";  -- 3697 = B1
      when "011011010011000" =>  data <= "01011100";  -- 3698 = 5C
      when "011011010011001" =>  data <= "11010000";  -- 3699 = D0
      when "011011010011010" =>  data <= "00010000";  -- 369A = 10
      when "011011010011011" =>  data <= "10101000";  -- 369B = A8
      when "011011010011100" =>  data <= "10110001";  -- 369C = B1
      when "011011010011101" =>  data <= "01011100";  -- 369D = 5C
      when "011011010011110" =>  data <= "10101010";  -- 369E = AA
      when "011011010011111" =>  data <= "11001000";  -- 369F = C8
      when "011011010100000" =>  data <= "10110001";  -- 36A0 = B1
      when "011011010100001" =>  data <= "01011100";  -- 36A1 = 5C
      when "011011010100010" =>  data <= "10000110";  -- 36A2 = 86
      when "011011010100011" =>  data <= "01011100";  -- 36A3 = 5C
      when "011011010100100" =>  data <= "10000101";  -- 36A4 = 85
      when "011011010100101" =>  data <= "01011101";  -- 36A5 = 5D
      when "011011010100110" =>  data <= "11010000";  -- 36A6 = D0
      when "011011010100111" =>  data <= "10110101";  -- 36A7 = B5
      when "011011010101000" =>  data <= "01001100";  -- 36A8 = 4C
      when "011011010101001" =>  data <= "11111111";  -- 36A9 = FF
      when "011011010101010" =>  data <= "10110011";  -- 36AA = B3
      when "011011010101011" =>  data <= "00010000";  -- 36AB = 10
      when "011011010101100" =>  data <= "11011010";  -- 36AC = DA
      when "011011010101101" =>  data <= "11001001";  -- 36AD = C9
      when "011011010101110" =>  data <= "11111111";  -- 36AE = FF
      when "011011010101111" =>  data <= "11110000";  -- 36AF = F0
      when "011011010110000" =>  data <= "11010110";  -- 36B0 = D6
      when "011011010110001" =>  data <= "00100100";  -- 36B1 = 24
      when "011011010110010" =>  data <= "00001001";  -- 36B2 = 9
      when "011011010110011" =>  data <= "00110000";  -- 36B3 = 30
      when "011011010110100" =>  data <= "11010010";  -- 36B4 = D2
      when "011011010110101" =>  data <= "10101010";  -- 36B5 = AA
      when "011011010110110" =>  data <= "10000100";  -- 36B6 = 84
      when "011011010110111" =>  data <= "01000110";  -- 36B7 = 46
      when "011011010111000" =>  data <= "10100000";  -- 36B8 = A0
      when "011011010111001" =>  data <= "10110000";  -- 36B9 = B0
      when "011011010111010" =>  data <= "10000100";  -- 36BA = 84
      when "011011010111011" =>  data <= "00100000";  -- 36BB = 20
      when "011011010111100" =>  data <= "10100000";  -- 36BC = A0
      when "011011010111101" =>  data <= "10110010";  -- 36BD = B2
      when "011011010111110" =>  data <= "10000100";  -- 36BE = 84
      when "011011010111111" =>  data <= "00011111";  -- 36BF = 1F
      when "011011011000000" =>  data <= "10100000";  -- 36C0 = A0
      when "011011011000001" =>  data <= "00000000";  -- 36C1 = 0
      when "011011011000010" =>  data <= "00001010";  -- 36C2 = A
      when "011011011000011" =>  data <= "11110000";  -- 36C3 = F0
      when "011011011000100" =>  data <= "00010000";  -- 36C4 = 10
      when "011011011000101" =>  data <= "11001010";  -- 36C5 = CA
      when "011011011000110" =>  data <= "00010000";  -- 36C6 = 10
      when "011011011000111" =>  data <= "00001100";  -- 36C7 = C
      when "011011011001000" =>  data <= "11100110";  -- 36C8 = E6
      when "011011011001001" =>  data <= "00011111";  -- 36C9 = 1F
      when "011011011001010" =>  data <= "11010000";  -- 36CA = D0
      when "011011011001011" =>  data <= "00000010";  -- 36CB = 2
      when "011011011001100" =>  data <= "11100110";  -- 36CC = E6
      when "011011011001101" =>  data <= "00100000";  -- 36CD = 20
      when "011011011001110" =>  data <= "10110001";  -- 36CE = B1
      when "011011011001111" =>  data <= "00011111";  -- 36CF = 1F
      when "011011011010000" =>  data <= "00010000";  -- 36D0 = 10
      when "011011011010001" =>  data <= "11110110";  -- 36D1 = F6
      when "011011011010010" =>  data <= "00110000";  -- 36D2 = 30
      when "011011011010011" =>  data <= "11110001";  -- 36D3 = F1
      when "011011011010100" =>  data <= "11001000";  -- 36D4 = C8
      when "011011011010101" =>  data <= "10110001";  -- 36D5 = B1
      when "011011011010110" =>  data <= "00011111";  -- 36D6 = 1F
      when "011011011010111" =>  data <= "00110000";  -- 36D7 = 30
      when "011011011011000" =>  data <= "10101010";  -- 36D8 = AA
      when "011011011011001" =>  data <= "00100000";  -- 36D9 = 20
      when "011011011011010" =>  data <= "01000110";  -- 36DA = 46
      when "011011011011011" =>  data <= "10111011";  -- 36DB = BB
      when "011011011011100" =>  data <= "11010000";  -- 36DC = D0
      when "011011011011101" =>  data <= "11110110";  -- 36DD = F6
      when "011011011011110" =>  data <= "10101001";  -- 36DE = A9
      when "011011011011111" =>  data <= "10000000";  -- 36DF = 80
      when "011011011100000" =>  data <= "10000101";  -- 36E0 = 85
      when "011011011100001" =>  data <= "00001010";  -- 36E1 = A
      when "011011011100010" =>  data <= "00100000";  -- 36E2 = 20
      when "011011011100011" =>  data <= "00110000";  -- 36E3 = 30
      when "011011011100100" =>  data <= "10111001";  -- 36E4 = B9
      when "011011011100101" =>  data <= "00100000";  -- 36E5 = 20
      when "011011011100110" =>  data <= "00100010";  -- 36E6 = 22
      when "011011011100111" =>  data <= "10110011";  -- 36E7 = B3
      when "011011011101000" =>  data <= "11010000";  -- 36E8 = D0
      when "011011011101001" =>  data <= "00000101";  -- 36E9 = 5
      when "011011011101010" =>  data <= "10001010";  -- 36EA = 8A
      when "011011011101011" =>  data <= "01101001";  -- 36EB = 69
      when "011011011101100" =>  data <= "00001111";  -- 36EC = F
      when "011011011101101" =>  data <= "10101010";  -- 36ED = AA
      when "011011011101110" =>  data <= "10011010";  -- 36EE = 9A
      when "011011011101111" =>  data <= "01101000";  -- 36EF = 68
      when "011011011110000" =>  data <= "01101000";  -- 36F0 = 68
      when "011011011110001" =>  data <= "10101001";  -- 36F1 = A9
      when "011011011110010" =>  data <= "00001001";  -- 36F2 = 9
      when "011011011110011" =>  data <= "00100000";  -- 36F3 = 20
      when "011011011110100" =>  data <= "10010011";  -- 36F4 = 93
      when "011011011110101" =>  data <= "10110011";  -- 36F5 = B3
      when "011011011110110" =>  data <= "00100000";  -- 36F6 = 20
      when "011011011110111" =>  data <= "10010001";  -- 36F7 = 91
      when "011011011111000" =>  data <= "10111000";  -- 36F8 = B8
      when "011011011111001" =>  data <= "00011000";  -- 36F9 = 18
      when "011011011111010" =>  data <= "10011000";  -- 36FA = 98
      when "011011011111011" =>  data <= "01100101";  -- 36FB = 65
      when "011011011111100" =>  data <= "01110111";  -- 36FC = 77
      when "011011011111101" =>  data <= "01001000";  -- 36FD = 48
      when "011011011111110" =>  data <= "10100101";  -- 36FE = A5
      when "011011011111111" =>  data <= "01111000";  -- 36FF = 78
      when "011011100000000" =>  data <= "01101001";  -- 3700 = 69
      when "011011100000001" =>  data <= "00000000";  -- 3701 = 0
      when "011011100000010" =>  data <= "01001000";  -- 3702 = 48
      when "011011100000011" =>  data <= "10100101";  -- 3703 = A5
      when "011011100000100" =>  data <= "00110111";  -- 3704 = 37
      when "011011100000101" =>  data <= "01001000";  -- 3705 = 48
      when "011011100000110" =>  data <= "10100101";  -- 3706 = A5
      when "011011100000111" =>  data <= "00110110";  -- 3707 = 36
      when "011011100001000" =>  data <= "01001000";  -- 3708 = 48
      when "011011100001001" =>  data <= "10101001";  -- 3709 = A9
      when "011011100001010" =>  data <= "10100100";  -- 370A = A4
      when "011011100001011" =>  data <= "00100000";  -- 370B = 20
      when "011011100001100" =>  data <= "11110111";  -- 370C = F7
      when "011011100001101" =>  data <= "10111110";  -- 370D = BE
      when "011011100001110" =>  data <= "00100000";  -- 370E = 20
      when "011011100001111" =>  data <= "10000111";  -- 370F = 87
      when "011011100010000" =>  data <= "10111101";  -- 3710 = BD
      when "011011100010001" =>  data <= "00100000";  -- 3711 = 20
      when "011011100010010" =>  data <= "10000100";  -- 3712 = 84
      when "011011100010011" =>  data <= "10111101";  -- 3713 = BD
      when "011011100010100" =>  data <= "10100101";  -- 3714 = A5
      when "011011100010101" =>  data <= "01100011";  -- 3715 = 63
      when "011011100010110" =>  data <= "00001001";  -- 3716 = 9
      when "011011100010111" =>  data <= "01111111";  -- 3717 = 7F
      when "011011100011000" =>  data <= "00100101";  -- 3718 = 25
      when "011011100011001" =>  data <= "01011111";  -- 3719 = 5F
      when "011011100011010" =>  data <= "10000101";  -- 371A = 85
      when "011011100011011" =>  data <= "01011111";  -- 371B = 5F
      when "011011100011100" =>  data <= "10101001";  -- 371C = A9
      when "011011100011101" =>  data <= "00100111";  -- 371D = 27
      when "011011100011110" =>  data <= "10100000";  -- 371E = A0
      when "011011100011111" =>  data <= "10110111";  -- 371F = B7
      when "011011100100000" =>  data <= "10000101";  -- 3720 = 85
      when "011011100100001" =>  data <= "00011111";  -- 3721 = 1F
      when "011011100100010" =>  data <= "10000100";  -- 3722 = 84
      when "011011100100011" =>  data <= "00100000";  -- 3723 = 20
      when "011011100100100" =>  data <= "01001100";  -- 3724 = 4C
      when "011011100100101" =>  data <= "01000001";  -- 3725 = 41
      when "011011100100110" =>  data <= "10111110";  -- 3726 = BE
      when "011011100100111" =>  data <= "10101001";  -- 3727 = A9
      when "011011100101000" =>  data <= "11110010";  -- 3728 = F2
      when "011011100101001" =>  data <= "10100000";  -- 3729 = A0
      when "011011100101010" =>  data <= "11001010";  -- 372A = CA
      when "011011100101011" =>  data <= "00100000";  -- 372B = 20
      when "011011100101100" =>  data <= "11011000";  -- 372C = D8
      when "011011100101101" =>  data <= "11001100";  -- 372D = CC
      when "011011100101110" =>  data <= "00100000";  -- 372E = 20
      when "011011100101111" =>  data <= "01110110";  -- 372F = 76
      when "011011100110000" =>  data <= "00000000";  -- 3730 = 0
      when "011011100110001" =>  data <= "11001001";  -- 3731 = C9
      when "011011100110010" =>  data <= "10101001";  -- 3732 = A9
      when "011011100110011" =>  data <= "11010000";  -- 3733 = D0
      when "011011100110100" =>  data <= "00000110";  -- 3734 = 6
      when "011011100110101" =>  data <= "00100000";  -- 3735 = 20
      when "011011100110110" =>  data <= "01110000";  -- 3736 = 70
      when "011011100110111" =>  data <= "00000000";  -- 3737 = 0
      when "011011100111000" =>  data <= "00100000";  -- 3738 = 20
      when "011011100111001" =>  data <= "10000100";  -- 3739 = 84
      when "011011100111010" =>  data <= "10111101";  -- 373A = BD
      when "011011100111011" =>  data <= "00100000";  -- 373B = 20
      when "011011100111100" =>  data <= "01100001";  -- 373C = 61
      when "011011100111101" =>  data <= "11001101";  -- 373D = CD
      when "011011100111110" =>  data <= "00100000";  -- 373E = 20
      when "011011100111111" =>  data <= "00110010";  -- 373F = 32
      when "011011101000000" =>  data <= "10111110";  -- 3740 = BE
      when "011011101000001" =>  data <= "10100101";  -- 3741 = A5
      when "011011101000010" =>  data <= "01000111";  -- 3742 = 47
      when "011011101000011" =>  data <= "01001000";  -- 3743 = 48
      when "011011101000100" =>  data <= "10100101";  -- 3744 = A5
      when "011011101000101" =>  data <= "01000110";  -- 3745 = 46
      when "011011101000110" =>  data <= "01001000";  -- 3746 = 48
      when "011011101000111" =>  data <= "10101001";  -- 3747 = A9
      when "011011101001000" =>  data <= "10000001";  -- 3748 = 81
      when "011011101001001" =>  data <= "01001000";  -- 3749 = 48
      when "011011101001010" =>  data <= "00100000";  -- 374A = 20
      when "011011101001011" =>  data <= "11100001";  -- 374B = E1
      when "011011101001100" =>  data <= "11111111";  -- 374C = FF
      when "011011101001101" =>  data <= "10100101";  -- 374D = A5
      when "011011101001110" =>  data <= "01110111";  -- 374E = 77
      when "011011101001111" =>  data <= "10100100";  -- 374F = A4
      when "011011101010000" =>  data <= "01111000";  -- 3750 = 78
      when "011011101010001" =>  data <= "11000000";  -- 3751 = C0
      when "011011101010010" =>  data <= "00000010";  -- 3752 = 2
      when "011011101010011" =>  data <= "11110000";  -- 3753 = F0
      when "011011101010100" =>  data <= "00000100";  -- 3754 = 4
      when "011011101010101" =>  data <= "10000101";  -- 3755 = 85
      when "011011101010110" =>  data <= "00111010";  -- 3756 = 3A
      when "011011101010111" =>  data <= "10000100";  -- 3757 = 84
      when "011011101011000" =>  data <= "00111011";  -- 3758 = 3B
      when "011011101011001" =>  data <= "10100000";  -- 3759 = A0
      when "011011101011010" =>  data <= "00000000";  -- 375A = 0
      when "011011101011011" =>  data <= "10110001";  -- 375B = B1
      when "011011101011100" =>  data <= "01110111";  -- 375C = 77
      when "011011101011101" =>  data <= "11010000";  -- 375D = D0
      when "011011101011110" =>  data <= "01000110";  -- 375E = 46
      when "011011101011111" =>  data <= "10100000";  -- 375F = A0
      when "011011101100000" =>  data <= "00000010";  -- 3760 = 2
      when "011011101100001" =>  data <= "10110001";  -- 3761 = B1
      when "011011101100010" =>  data <= "01110111";  -- 3762 = 77
      when "011011101100011" =>  data <= "00011000";  -- 3763 = 18
      when "011011101100100" =>  data <= "11010000";  -- 3764 = D0
      when "011011101100101" =>  data <= "00000011";  -- 3765 = 3
      when "011011101100110" =>  data <= "01001100";  -- 3766 = 4C
      when "011011101100111" =>  data <= "11100010";  -- 3767 = E2
      when "011011101101000" =>  data <= "10110111";  -- 3768 = B7
      when "011011101101001" =>  data <= "11001000";  -- 3769 = C8
      when "011011101101010" =>  data <= "10110001";  -- 376A = B1
      when "011011101101011" =>  data <= "01110111";  -- 376B = 77
      when "011011101101100" =>  data <= "10000101";  -- 376C = 85
      when "011011101101101" =>  data <= "00110110";  -- 376D = 36
      when "011011101101110" =>  data <= "11001000";  -- 376E = C8
      when "011011101101111" =>  data <= "10110001";  -- 376F = B1
      when "011011101110000" =>  data <= "01110111";  -- 3770 = 77
      when "011011101110001" =>  data <= "10000101";  -- 3771 = 85
      when "011011101110010" =>  data <= "00110111";  -- 3772 = 37
      when "011011101110011" =>  data <= "10011000";  -- 3773 = 98
      when "011011101110100" =>  data <= "01100101";  -- 3774 = 65
      when "011011101110101" =>  data <= "01110111";  -- 3775 = 77
      when "011011101110110" =>  data <= "10000101";  -- 3776 = 85
      when "011011101110111" =>  data <= "01110111";  -- 3777 = 77
      when "011011101111000" =>  data <= "10010000";  -- 3778 = 90
      when "011011101111001" =>  data <= "00000010";  -- 3779 = 2
      when "011011101111010" =>  data <= "11100110";  -- 377A = E6
      when "011011101111011" =>  data <= "01111000";  -- 377B = 78
      when "011011101111100" =>  data <= "00100000";  -- 377C = 20
      when "011011101111101" =>  data <= "00100001";  -- 377D = 21
      when "011011101111110" =>  data <= "10111111";  -- 377E = BF
      when "011011101111111" =>  data <= "00100000";  -- 377F = 20
      when "011011110000000" =>  data <= "10000101";  -- 3780 = 85
      when "011011110000001" =>  data <= "10110111";  -- 3781 = B7
      when "011011110000010" =>  data <= "01001100";  -- 3782 = 4C
      when "011011110000011" =>  data <= "01001010";  -- 3783 = 4A
      when "011011110000100" =>  data <= "10110111";  -- 3784 = B7
      when "011011110000101" =>  data <= "11110000";  -- 3785 = F0
      when "011011110000110" =>  data <= "00111110";  -- 3786 = 3E
      when "011011110000111" =>  data <= "11101001";  -- 3787 = E9
      when "011011110001000" =>  data <= "10000000";  -- 3788 = 80
      when "011011110001001" =>  data <= "10010000";  -- 3789 = 90
      when "011011110001010" =>  data <= "00010111";  -- 378A = 17
      when "011011110001011" =>  data <= "11001001";  -- 378B = C9
      when "011011110001100" =>  data <= "00100011";  -- 378C = 23
      when "011011110001101" =>  data <= "10010000";  -- 378D = 90
      when "011011110001110" =>  data <= "00000110";  -- 378E = 6
      when "011011110001111" =>  data <= "11001001";  -- 378F = C9
      when "011011110010000" =>  data <= "01001011";  -- 3790 = 4B
      when "011011110010001" =>  data <= "10010000";  -- 3791 = 90
      when "011011110010010" =>  data <= "00010110";  -- 3792 = 16
      when "011011110010011" =>  data <= "11101001";  -- 3793 = E9
      when "011011110010100" =>  data <= "00101000";  -- 3794 = 28
      when "011011110010101" =>  data <= "00001010";  -- 3795 = A
      when "011011110010110" =>  data <= "10101000";  -- 3796 = A8
      when "011011110010111" =>  data <= "10111001";  -- 3797 = B9
      when "011011110011000" =>  data <= "00000001";  -- 3798 = 1
      when "011011110011001" =>  data <= "10110000";  -- 3799 = B0
      when "011011110011010" =>  data <= "01001000";  -- 379A = 48
      when "011011110011011" =>  data <= "10111001";  -- 379B = B9
      when "011011110011100" =>  data <= "00000000";  -- 379C = 0
      when "011011110011101" =>  data <= "10110000";  -- 379D = B0
      when "011011110011110" =>  data <= "01001000";  -- 379E = 48
      when "011011110011111" =>  data <= "01001100";  -- 379F = 4C
      when "011011110100000" =>  data <= "01110000";  -- 37A0 = 70
      when "011011110100001" =>  data <= "00000000";  -- 37A1 = 0
      when "011011110100010" =>  data <= "01001100";  -- 37A2 = 4C
      when "011011110100011" =>  data <= "00110000";  -- 37A3 = 30
      when "011011110100100" =>  data <= "10111001";  -- 37A4 = B9
      when "011011110100101" =>  data <= "11001001";  -- 37A5 = C9
      when "011011110100110" =>  data <= "00111010";  -- 37A6 = 3A
      when "011011110100111" =>  data <= "11110000";  -- 37A7 = F0
      when "011011110101000" =>  data <= "11010011";  -- 37A8 = D3
      when "011011110101001" =>  data <= "01001100";  -- 37A9 = 4C
      when "011011110101010" =>  data <= "00000000";  -- 37AA = 0
      when "011011110101011" =>  data <= "10111111";  -- 37AB = BF
      when "011011110101100" =>  data <= "00100000";  -- 37AC = 20
      when "011011110101101" =>  data <= "01110110";  -- 37AD = 76
      when "011011110101110" =>  data <= "00000000";  -- 37AE = 0
      when "011011110101111" =>  data <= "10101001";  -- 37AF = A9
      when "011011110110000" =>  data <= "10100100";  -- 37B0 = A4
      when "011011110110001" =>  data <= "00100000";  -- 37B1 = 20
      when "011011110110010" =>  data <= "11110111";  -- 37B2 = F7
      when "011011110110011" =>  data <= "10111110";  -- 37B3 = BE
      when "011011110110100" =>  data <= "01001100";  -- 37B4 = 4C
      when "011011110110101" =>  data <= "00110000";  -- 37B5 = 30
      when "011011110110110" =>  data <= "10111000";  -- 37B6 = B8
      when "011011110110111" =>  data <= "00111000";  -- 37B7 = 38
      when "011011110111000" =>  data <= "10100101";  -- 37B8 = A5
      when "011011110111001" =>  data <= "00101000";  -- 37B9 = 28
      when "011011110111010" =>  data <= "11101001";  -- 37BA = E9
      when "011011110111011" =>  data <= "00000001";  -- 37BB = 1
      when "011011110111100" =>  data <= "10100100";  -- 37BC = A4
      when "011011110111101" =>  data <= "00101001";  -- 37BD = 29
      when "011011110111110" =>  data <= "10110000";  -- 37BE = B0
      when "011011110111111" =>  data <= "00000001";  -- 37BF = 1
      when "011011111000000" =>  data <= "10001000";  -- 37C0 = 88
      when "011011111000001" =>  data <= "10000101";  -- 37C1 = 85
      when "011011111000010" =>  data <= "00111110";  -- 37C2 = 3E
      when "011011111000011" =>  data <= "10000100";  -- 37C3 = 84
      when "011011111000100" =>  data <= "00111111";  -- 37C4 = 3F
      when "011011111000101" =>  data <= "01100000";  -- 37C5 = 60
      when "011011111000110" =>  data <= "10110000";  -- 37C6 = B0
      when "011011111000111" =>  data <= "00000001";  -- 37C7 = 1
      when "011011111001000" =>  data <= "00011000";  -- 37C8 = 18
      when "011011111001001" =>  data <= "11010000";  -- 37C9 = D0
      when "011011111001010" =>  data <= "00111100";  -- 37CA = 3C
      when "011011111001011" =>  data <= "10100101";  -- 37CB = A5
      when "011011111001100" =>  data <= "01110111";  -- 37CC = 77
      when "011011111001101" =>  data <= "10100100";  -- 37CD = A4
      when "011011111001110" =>  data <= "01111000";  -- 37CE = 78
      when "011011111001111" =>  data <= "10100110";  -- 37CF = A6
      when "011011111010000" =>  data <= "00110111";  -- 37D0 = 37
      when "011011111010001" =>  data <= "11101000";  -- 37D1 = E8
      when "011011111010010" =>  data <= "11110000";  -- 37D2 = F0
      when "011011111010011" =>  data <= "00001100";  -- 37D3 = C
      when "011011111010100" =>  data <= "10000101";  -- 37D4 = 85
      when "011011111010101" =>  data <= "00111010";  -- 37D5 = 3A
      when "011011111010110" =>  data <= "10000100";  -- 37D6 = 84
      when "011011111010111" =>  data <= "00111011";  -- 37D7 = 3B
      when "011011111011000" =>  data <= "10100101";  -- 37D8 = A5
      when "011011111011001" =>  data <= "00110110";  -- 37D9 = 36
      when "011011111011010" =>  data <= "10100100";  -- 37DA = A4
      when "011011111011011" =>  data <= "00110111";  -- 37DB = 37
      when "011011111011100" =>  data <= "10000101";  -- 37DC = 85
      when "011011111011101" =>  data <= "00111000";  -- 37DD = 38
      when "011011111011110" =>  data <= "10000100";  -- 37DE = 84
      when "011011111011111" =>  data <= "00111001";  -- 37DF = 39
      when "011011111100000" =>  data <= "01101000";  -- 37E0 = 68
      when "011011111100001" =>  data <= "01101000";  -- 37E1 = 68
      when "011011111100010" =>  data <= "10101001";  -- 37E2 = A9
      when "011011111100011" =>  data <= "00011011";  -- 37E3 = 1B
      when "011011111100100" =>  data <= "10100000";  -- 37E4 = A0
      when "011011111100101" =>  data <= "10110011";  -- 37E5 = B3
      when "011011111100110" =>  data <= "10010000";  -- 37E6 = 90
      when "011011111100111" =>  data <= "00000011";  -- 37E7 = 3
      when "011011111101000" =>  data <= "01001100";  -- 37E8 = 4C
      when "011011111101001" =>  data <= "11110100";  -- 37E9 = F4
      when "011011111101010" =>  data <= "10110011";  -- 37EA = B3
      when "011011111101011" =>  data <= "01001100";  -- 37EB = 4C
      when "011011111101100" =>  data <= "11111111";  -- 37EC = FF
      when "011011111101101" =>  data <= "10110011";  -- 37ED = B3
      when "011011111101110" =>  data <= "11010000";  -- 37EE = D0
      when "011011111101111" =>  data <= "00010111";  -- 37EF = 17
      when "011011111110000" =>  data <= "10100010";  -- 37F0 = A2
      when "011011111110001" =>  data <= "11011011";  -- 37F1 = DB
      when "011011111110010" =>  data <= "10100100";  -- 37F2 = A4
      when "011011111110011" =>  data <= "00111011";  -- 37F3 = 3B
      when "011011111110100" =>  data <= "11010000";  -- 37F4 = D0
      when "011011111110101" =>  data <= "00000011";  -- 37F5 = 3
      when "011011111110110" =>  data <= "01001100";  -- 37F6 = 4C
      when "011011111110111" =>  data <= "11001111";  -- 37F7 = CF
      when "011011111111000" =>  data <= "10110011";  -- 37F8 = B3
      when "011011111111001" =>  data <= "10100101";  -- 37F9 = A5
      when "011011111111010" =>  data <= "00111010";  -- 37FA = 3A
      when "011011111111011" =>  data <= "10000101";  -- 37FB = 85
      when "011011111111100" =>  data <= "01110111";  -- 37FC = 77
      when "011011111111101" =>  data <= "10000100";  -- 37FD = 84
      when "011011111111110" =>  data <= "01111000";  -- 37FE = 78
      when "011011111111111" =>  data <= "10100101";  -- 37FF = A5
      when "011100000000000" =>  data <= "00111000";  -- 3800 = 38
      when "011100000000001" =>  data <= "10100100";  -- 3801 = A4
      when "011100000000010" =>  data <= "00111001";  -- 3802 = 39
      when "011100000000011" =>  data <= "10000101";  -- 3803 = 85
      when "011100000000100" =>  data <= "00110110";  -- 3804 = 36
      when "011100000000101" =>  data <= "10000100";  -- 3805 = 84
      when "011100000000110" =>  data <= "00110111";  -- 3806 = 37
      when "011100000000111" =>  data <= "01100000";  -- 3807 = 60
      when "011100000001000" =>  data <= "11010000";  -- 3808 = D0
      when "011100000001001" =>  data <= "00000011";  -- 3809 = 3
      when "011100000001010" =>  data <= "01001100";  -- 380A = 4C
      when "011100000001011" =>  data <= "11101001";  -- 380B = E9
      when "011100000001100" =>  data <= "10110101";  -- 380C = B5
      when "011100000001101" =>  data <= "00100000";  -- 380D = 20
      when "011100000001110" =>  data <= "11110000";  -- 380E = F0
      when "011100000001111" =>  data <= "10110101";  -- 380F = B5
      when "011100000010000" =>  data <= "01001100";  -- 3810 = 4C
      when "011100000010001" =>  data <= "00100111";  -- 3811 = 27
      when "011100000010010" =>  data <= "10111000";  -- 3812 = B8
      when "011100000010011" =>  data <= "10101001";  -- 3813 = A9
      when "011100000010100" =>  data <= "00000011";  -- 3814 = 3
      when "011100000010101" =>  data <= "00100000";  -- 3815 = 20
      when "011100000010110" =>  data <= "10010011";  -- 3816 = 93
      when "011100000010111" =>  data <= "10110011";  -- 3817 = B3
      when "011100000011000" =>  data <= "10100101";  -- 3818 = A5
      when "011100000011001" =>  data <= "01111000";  -- 3819 = 78
      when "011100000011010" =>  data <= "01001000";  -- 381A = 48
      when "011100000011011" =>  data <= "10100101";  -- 381B = A5
      when "011100000011100" =>  data <= "01110111";  -- 381C = 77
      when "011100000011101" =>  data <= "01001000";  -- 381D = 48
      when "011100000011110" =>  data <= "10100101";  -- 381E = A5
      when "011100000011111" =>  data <= "00110111";  -- 381F = 37
      when "011100000100000" =>  data <= "01001000";  -- 3820 = 48
      when "011100000100001" =>  data <= "10100101";  -- 3821 = A5
      when "011100000100010" =>  data <= "00110110";  -- 3822 = 36
      when "011100000100011" =>  data <= "01001000";  -- 3823 = 48
      when "011100000100100" =>  data <= "10101001";  -- 3824 = A9
      when "011100000100101" =>  data <= "10001101";  -- 3825 = 8D
      when "011100000100110" =>  data <= "01001000";  -- 3826 = 48
      when "011100000100111" =>  data <= "00100000";  -- 3827 = 20
      when "011100000101000" =>  data <= "01110110";  -- 3828 = 76
      when "011100000101001" =>  data <= "00000000";  -- 3829 = 0
      when "011100000101010" =>  data <= "00100000";  -- 382A = 20
      when "011100000101011" =>  data <= "00110000";  -- 382B = 30
      when "011100000101100" =>  data <= "10111000";  -- 382C = B8
      when "011100000101101" =>  data <= "01001100";  -- 382D = 4C
      when "011100000101110" =>  data <= "01001010";  -- 382E = 4A
      when "011100000101111" =>  data <= "10110111";  -- 382F = B7
      when "011100000110000" =>  data <= "00100000";  -- 3830 = 20
      when "011100000110001" =>  data <= "11110110";  -- 3831 = F6
      when "011100000110010" =>  data <= "10111000";  -- 3832 = B8
      when "011100000110011" =>  data <= "00100000";  -- 3833 = 20
      when "011100000110100" =>  data <= "10010100";  -- 3834 = 94
      when "011100000110101" =>  data <= "10111000";  -- 3835 = B8
      when "011100000110110" =>  data <= "10100101";  -- 3836 = A5
      when "011100000110111" =>  data <= "00110111";  -- 3837 = 37
      when "011100000111000" =>  data <= "11000101";  -- 3838 = C5
      when "011100000111001" =>  data <= "00010010";  -- 3839 = 12
      when "011100000111010" =>  data <= "10110000";  -- 383A = B0
      when "011100000111011" =>  data <= "00001011";  -- 383B = B
      when "011100000111100" =>  data <= "10011000";  -- 383C = 98
      when "011100000111101" =>  data <= "00111000";  -- 383D = 38
      when "011100000111110" =>  data <= "01100101";  -- 383E = 65
      when "011100000111111" =>  data <= "01110111";  -- 383F = 77
      when "011100001000000" =>  data <= "10100110";  -- 3840 = A6
      when "011100001000001" =>  data <= "01111000";  -- 3841 = 78
      when "011100001000010" =>  data <= "10010000";  -- 3842 = 90
      when "011100001000011" =>  data <= "00000111";  -- 3843 = 7
      when "011100001000100" =>  data <= "11101000";  -- 3844 = E8
      when "011100001000101" =>  data <= "10110000";  -- 3845 = B0
      when "011100001000110" =>  data <= "00000100";  -- 3846 = 4
      when "011100001000111" =>  data <= "10100101";  -- 3847 = A5
      when "011100001001000" =>  data <= "00101000";  -- 3848 = 28
      when "011100001001001" =>  data <= "10100110";  -- 3849 = A6
      when "011100001001010" =>  data <= "00101001";  -- 384A = 29
      when "011100001001011" =>  data <= "00100000";  -- 384B = 20
      when "011100001001100" =>  data <= "10100111";  -- 384C = A7
      when "011100001001101" =>  data <= "10110101";  -- 384D = B5
      when "011100001001110" =>  data <= "10010000";  -- 384E = 90
      when "011100001001111" =>  data <= "00011110";  -- 384F = 1E
      when "011100001010000" =>  data <= "10100101";  -- 3850 = A5
      when "011100001010001" =>  data <= "01011100";  -- 3851 = 5C
      when "011100001010010" =>  data <= "11101001";  -- 3852 = E9
      when "011100001010011" =>  data <= "00000001";  -- 3853 = 1
      when "011100001010100" =>  data <= "10000101";  -- 3854 = 85
      when "011100001010101" =>  data <= "01110111";  -- 3855 = 77
      when "011100001010110" =>  data <= "10100101";  -- 3856 = A5
      when "011100001010111" =>  data <= "01011101";  -- 3857 = 5D
      when "011100001011000" =>  data <= "11101001";  -- 3858 = E9
      when "011100001011001" =>  data <= "00000000";  -- 3859 = 0
      when "011100001011010" =>  data <= "10000101";  -- 385A = 85
      when "011100001011011" =>  data <= "01111000";  -- 385B = 78
      when "011100001011100" =>  data <= "01100000";  -- 385C = 60
      when "011100001011101" =>  data <= "11010000";  -- 385D = D0
      when "011100001011110" =>  data <= "11111101";  -- 385E = FD
      when "011100001011111" =>  data <= "10101001";  -- 385F = A9
      when "011100001100000" =>  data <= "11111111";  -- 3860 = FF
      when "011100001100001" =>  data <= "10000101";  -- 3861 = 85
      when "011100001100010" =>  data <= "01000111";  -- 3862 = 47
      when "011100001100011" =>  data <= "00100000";  -- 3863 = 20
      when "011100001100100" =>  data <= "00100010";  -- 3864 = 22
      when "011100001100101" =>  data <= "10110011";  -- 3865 = B3
      when "011100001100110" =>  data <= "10011010";  -- 3866 = 9A
      when "011100001100111" =>  data <= "11001001";  -- 3867 = C9
      when "011100001101000" =>  data <= "10001101";  -- 3868 = 8D
      when "011100001101001" =>  data <= "11110000";  -- 3869 = F0
      when "011100001101010" =>  data <= "00001011";  -- 386A = B
      when "011100001101011" =>  data <= "10100010";  -- 386B = A2
      when "011100001101100" =>  data <= "00010110";  -- 386C = 16
      when "011100001101101" =>  data <= "00101100";  -- 386D = 2C
      when "011100001101110" =>  data <= "10100010";  -- 386E = A2
      when "011100001101111" =>  data <= "01011010";  -- 386F = 5A
      when "011100001110000" =>  data <= "01001100";  -- 3870 = 4C
      when "011100001110001" =>  data <= "11001111";  -- 3871 = CF
      when "011100001110010" =>  data <= "10110011";  -- 3872 = B3
      when "011100001110011" =>  data <= "01001100";  -- 3873 = 4C
      when "011100001110100" =>  data <= "00000000";  -- 3874 = 0
      when "011100001110101" =>  data <= "10111111";  -- 3875 = BF
      when "011100001110110" =>  data <= "01101000";  -- 3876 = 68
      when "011100001110111" =>  data <= "01101000";  -- 3877 = 68
      when "011100001111000" =>  data <= "10000101";  -- 3878 = 85
      when "011100001111001" =>  data <= "00110110";  -- 3879 = 36
      when "011100001111010" =>  data <= "01101000";  -- 387A = 68
      when "011100001111011" =>  data <= "10000101";  -- 387B = 85
      when "011100001111100" =>  data <= "00110111";  -- 387C = 37
      when "011100001111101" =>  data <= "01101000";  -- 387D = 68
      when "011100001111110" =>  data <= "10000101";  -- 387E = 85
      when "011100001111111" =>  data <= "01110111";  -- 387F = 77
      when "011100010000000" =>  data <= "01101000";  -- 3880 = 68
      when "011100010000001" =>  data <= "10000101";  -- 3881 = 85
      when "011100010000010" =>  data <= "01111000";  -- 3882 = 78
      when "011100010000011" =>  data <= "00100000";  -- 3883 = 20
      when "011100010000100" =>  data <= "10010001";  -- 3884 = 91
      when "011100010000101" =>  data <= "10111000";  -- 3885 = B8
      when "011100010000110" =>  data <= "10011000";  -- 3886 = 98
      when "011100010000111" =>  data <= "00011000";  -- 3887 = 18
      when "011100010001000" =>  data <= "01100101";  -- 3888 = 65
      when "011100010001001" =>  data <= "01110111";  -- 3889 = 77
      when "011100010001010" =>  data <= "10000101";  -- 388A = 85
      when "011100010001011" =>  data <= "01110111";  -- 388B = 77
      when "011100010001100" =>  data <= "10010000";  -- 388C = 90
      when "011100010001101" =>  data <= "00000010";  -- 388D = 2
      when "011100010001110" =>  data <= "11100110";  -- 388E = E6
      when "011100010001111" =>  data <= "01111000";  -- 388F = 78
      when "011100010010000" =>  data <= "01100000";  -- 3890 = 60
      when "011100010010001" =>  data <= "10100010";  -- 3891 = A2
      when "011100010010010" =>  data <= "00111010";  -- 3892 = 3A
      when "011100010010011" =>  data <= "00101100";  -- 3893 = 2C
      when "011100010010100" =>  data <= "10100010";  -- 3894 = A2
      when "011100010010101" =>  data <= "00000000";  -- 3895 = 0
      when "011100010010110" =>  data <= "10000110";  -- 3896 = 86
      when "011100010010111" =>  data <= "00000011";  -- 3897 = 3
      when "011100010011000" =>  data <= "10100000";  -- 3898 = A0
      when "011100010011001" =>  data <= "00000000";  -- 3899 = 0
      when "011100010011010" =>  data <= "10000100";  -- 389A = 84
      when "011100010011011" =>  data <= "00000100";  -- 389B = 4
      when "011100010011100" =>  data <= "10100101";  -- 389C = A5
      when "011100010011101" =>  data <= "00000100";  -- 389D = 4
      when "011100010011110" =>  data <= "10100110";  -- 389E = A6
      when "011100010011111" =>  data <= "00000011";  -- 389F = 3
      when "011100010100000" =>  data <= "10000101";  -- 38A0 = 85
      when "011100010100001" =>  data <= "00000011";  -- 38A1 = 3
      when "011100010100010" =>  data <= "10000110";  -- 38A2 = 86
      when "011100010100011" =>  data <= "00000100";  -- 38A3 = 4
      when "011100010100100" =>  data <= "10110001";  -- 38A4 = B1
      when "011100010100101" =>  data <= "01110111";  -- 38A5 = 77
      when "011100010100110" =>  data <= "11110000";  -- 38A6 = F0
      when "011100010100111" =>  data <= "11101000";  -- 38A7 = E8
      when "011100010101000" =>  data <= "11000101";  -- 38A8 = C5
      when "011100010101001" =>  data <= "00000100";  -- 38A9 = 4
      when "011100010101010" =>  data <= "11110000";  -- 38AA = F0
      when "011100010101011" =>  data <= "11100100";  -- 38AB = E4
      when "011100010101100" =>  data <= "11001000";  -- 38AC = C8
      when "011100010101101" =>  data <= "11001001";  -- 38AD = C9
      when "011100010101110" =>  data <= "00100010";  -- 38AE = 22
      when "011100010101111" =>  data <= "11010000";  -- 38AF = D0
      when "011100010110000" =>  data <= "11110011";  -- 38B0 = F3
      when "011100010110001" =>  data <= "11110000";  -- 38B1 = F0
      when "011100010110010" =>  data <= "11101001";  -- 38B2 = E9
      when "011100010110011" =>  data <= "00100000";  -- 38B3 = 20
      when "011100010110100" =>  data <= "10011000";  -- 38B4 = 98
      when "011100010110101" =>  data <= "10111101";  -- 38B5 = BD
      when "011100010110110" =>  data <= "00100000";  -- 38B6 = 20
      when "011100010110111" =>  data <= "01110110";  -- 38B7 = 76
      when "011100010111000" =>  data <= "00000000";  -- 38B8 = 0
      when "011100010111001" =>  data <= "11001001";  -- 38B9 = C9
      when "011100010111010" =>  data <= "10001001";  -- 38BA = 89
      when "011100010111011" =>  data <= "11110000";  -- 38BB = F0
      when "011100010111100" =>  data <= "00000101";  -- 38BC = 5
      when "011100010111101" =>  data <= "10101001";  -- 38BD = A9
      when "011100010111110" =>  data <= "10100111";  -- 38BE = A7
      when "011100010111111" =>  data <= "00100000";  -- 38BF = 20
      when "011100011000000" =>  data <= "11110111";  -- 38C0 = F7
      when "011100011000001" =>  data <= "10111110";  -- 38C1 = BE
      when "011100011000010" =>  data <= "10100101";  -- 38C2 = A5
      when "011100011000011" =>  data <= "01011110";  -- 38C3 = 5E
      when "011100011000100" =>  data <= "11010000";  -- 38C4 = D0
      when "011100011000101" =>  data <= "00000101";  -- 38C5 = 5
      when "011100011000110" =>  data <= "00100000";  -- 38C6 = 20
      when "011100011000111" =>  data <= "10010100";  -- 38C7 = 94
      when "011100011001000" =>  data <= "10111000";  -- 38C8 = B8
      when "011100011001001" =>  data <= "11110000";  -- 38C9 = F0
      when "011100011001010" =>  data <= "10111011";  -- 38CA = BB
      when "011100011001011" =>  data <= "00100000";  -- 38CB = 20
      when "011100011001100" =>  data <= "01110110";  -- 38CC = 76
      when "011100011001101" =>  data <= "00000000";  -- 38CD = 0
      when "011100011001110" =>  data <= "10110000";  -- 38CE = B0
      when "011100011001111" =>  data <= "00000011";  -- 38CF = 3
      when "011100011010000" =>  data <= "01001100";  -- 38D0 = 4C
      when "011100011010001" =>  data <= "00110000";  -- 38D1 = 30
      when "011100011010010" =>  data <= "10111000";  -- 38D2 = B8
      when "011100011010011" =>  data <= "01001100";  -- 38D3 = 4C
      when "011100011010100" =>  data <= "10000101";  -- 38D4 = 85
      when "011100011010101" =>  data <= "10110111";  -- 38D5 = B7
      when "011100011010110" =>  data <= "00100000";  -- 38D6 = 20
      when "011100011010111" =>  data <= "11010100";  -- 38D7 = D4
      when "011100011011000" =>  data <= "11001000";  -- 38D8 = C8
      when "011100011011001" =>  data <= "01001000";  -- 38D9 = 48
      when "011100011011010" =>  data <= "11001001";  -- 38DA = C9
      when "011100011011011" =>  data <= "10001101";  -- 38DB = 8D
      when "011100011011100" =>  data <= "11110000";  -- 38DC = F0
      when "011100011011101" =>  data <= "00000100";  -- 38DD = 4
      when "011100011011110" =>  data <= "11001001";  -- 38DE = C9
      when "011100011011111" =>  data <= "10001001";  -- 38DF = 89
      when "011100011100000" =>  data <= "11010000";  -- 38E0 = D0
      when "011100011100001" =>  data <= "10010001";  -- 38E1 = 91
      when "011100011100010" =>  data <= "11000110";  -- 38E2 = C6
      when "011100011100011" =>  data <= "01100010";  -- 38E3 = 62
      when "011100011100100" =>  data <= "11010000";  -- 38E4 = D0
      when "011100011100101" =>  data <= "00000100";  -- 38E5 = 4
      when "011100011100110" =>  data <= "01101000";  -- 38E6 = 68
      when "011100011100111" =>  data <= "01001100";  -- 38E7 = 4C
      when "011100011101000" =>  data <= "10000111";  -- 38E8 = 87
      when "011100011101001" =>  data <= "10110111";  -- 38E9 = B7
      when "011100011101010" =>  data <= "00100000";  -- 38EA = 20
      when "011100011101011" =>  data <= "01110000";  -- 38EB = 70
      when "011100011101100" =>  data <= "00000000";  -- 38EC = 0
      when "011100011101101" =>  data <= "00100000";  -- 38ED = 20
      when "011100011101110" =>  data <= "11110110";  -- 38EE = F6
      when "011100011101111" =>  data <= "10111000";  -- 38EF = B8
      when "011100011110000" =>  data <= "11001001";  -- 38F0 = C9
      when "011100011110001" =>  data <= "00101100";  -- 38F1 = 2C
      when "011100011110010" =>  data <= "11110000";  -- 38F2 = F0
      when "011100011110011" =>  data <= "11101110";  -- 38F3 = EE
      when "011100011110100" =>  data <= "01101000";  -- 38F4 = 68
      when "011100011110101" =>  data <= "01100000";  -- 38F5 = 60
      when "011100011110110" =>  data <= "10100010";  -- 38F6 = A2
      when "011100011110111" =>  data <= "00000000";  -- 38F7 = 0
      when "011100011111000" =>  data <= "10000110";  -- 38F8 = 86
      when "011100011111001" =>  data <= "00010001";  -- 38F9 = 11
      when "011100011111010" =>  data <= "10000110";  -- 38FA = 86
      when "011100011111011" =>  data <= "00010010";  -- 38FB = 12
      when "011100011111100" =>  data <= "10110000";  -- 38FC = B0
      when "011100011111101" =>  data <= "11110111";  -- 38FD = F7
      when "011100011111110" =>  data <= "11101001";  -- 38FE = E9
      when "011100011111111" =>  data <= "00101111";  -- 38FF = 2F
      when "011100100000000" =>  data <= "10000101";  -- 3900 = 85
      when "011100100000001" =>  data <= "00000011";  -- 3901 = 3
      when "011100100000010" =>  data <= "10100101";  -- 3902 = A5
      when "011100100000011" =>  data <= "00010010";  -- 3903 = 12
      when "011100100000100" =>  data <= "10000101";  -- 3904 = 85
      when "011100100000101" =>  data <= "00011111";  -- 3905 = 1F
      when "011100100000110" =>  data <= "11001001";  -- 3906 = C9
      when "011100100000111" =>  data <= "00011001";  -- 3907 = 19
      when "011100100001000" =>  data <= "10110000";  -- 3908 = B0
      when "011100100001001" =>  data <= "11010100";  -- 3909 = D4
      when "011100100001010" =>  data <= "10100101";  -- 390A = A5
      when "011100100001011" =>  data <= "00010001";  -- 390B = 11
      when "011100100001100" =>  data <= "00001010";  -- 390C = A
      when "011100100001101" =>  data <= "00100110";  -- 390D = 26
      when "011100100001110" =>  data <= "00011111";  -- 390E = 1F
      when "011100100001111" =>  data <= "00001010";  -- 390F = A
      when "011100100010000" =>  data <= "00100110";  -- 3910 = 26
      when "011100100010001" =>  data <= "00011111";  -- 3911 = 1F
      when "011100100010010" =>  data <= "01100101";  -- 3912 = 65
      when "011100100010011" =>  data <= "00010001";  -- 3913 = 11
      when "011100100010100" =>  data <= "10000101";  -- 3914 = 85
      when "011100100010101" =>  data <= "00010001";  -- 3915 = 11
      when "011100100010110" =>  data <= "10100101";  -- 3916 = A5
      when "011100100010111" =>  data <= "00011111";  -- 3917 = 1F
      when "011100100011000" =>  data <= "01100101";  -- 3918 = 65
      when "011100100011001" =>  data <= "00010010";  -- 3919 = 12
      when "011100100011010" =>  data <= "10000101";  -- 391A = 85
      when "011100100011011" =>  data <= "00010010";  -- 391B = 12
      when "011100100011100" =>  data <= "00000110";  -- 391C = 6
      when "011100100011101" =>  data <= "00010001";  -- 391D = 11
      when "011100100011110" =>  data <= "00100110";  -- 391E = 26
      when "011100100011111" =>  data <= "00010010";  -- 391F = 12
      when "011100100100000" =>  data <= "10100101";  -- 3920 = A5
      when "011100100100001" =>  data <= "00010001";  -- 3921 = 11
      when "011100100100010" =>  data <= "01100101";  -- 3922 = 65
      when "011100100100011" =>  data <= "00000011";  -- 3923 = 3
      when "011100100100100" =>  data <= "10000101";  -- 3924 = 85
      when "011100100100101" =>  data <= "00010001";  -- 3925 = 11
      when "011100100100110" =>  data <= "10010000";  -- 3926 = 90
      when "011100100100111" =>  data <= "00000010";  -- 3927 = 2
      when "011100100101000" =>  data <= "11100110";  -- 3928 = E6
      when "011100100101001" =>  data <= "00010010";  -- 3929 = 12
      when "011100100101010" =>  data <= "00100000";  -- 392A = 20
      when "011100100101011" =>  data <= "01110000";  -- 392B = 70
      when "011100100101100" =>  data <= "00000000";  -- 392C = 0
      when "011100100101101" =>  data <= "01001100";  -- 392D = 4C
      when "011100100101110" =>  data <= "11111100";  -- 392E = FC
      when "011100100101111" =>  data <= "10111000";  -- 392F = B8
      when "011100100110000" =>  data <= "00100000";  -- 3930 = 20
      when "011100100110001" =>  data <= "00101011";  -- 3931 = 2B
      when "011100100110010" =>  data <= "11000001";  -- 3932 = C1
      when "011100100110011" =>  data <= "10000101";  -- 3933 = 85
      when "011100100110100" =>  data <= "01000110";  -- 3934 = 46
      when "011100100110101" =>  data <= "10000100";  -- 3935 = 84
      when "011100100110110" =>  data <= "01000111";  -- 3936 = 47
      when "011100100110111" =>  data <= "10101001";  -- 3937 = A9
      when "011100100111000" =>  data <= "10110010";  -- 3938 = B2
      when "011100100111001" =>  data <= "00100000";  -- 3939 = 20
      when "011100100111010" =>  data <= "11110111";  -- 393A = F7
      when "011100100111011" =>  data <= "10111110";  -- 393B = BE
      when "011100100111100" =>  data <= "10100101";  -- 393C = A5
      when "011100100111101" =>  data <= "00001000";  -- 393D = 8
      when "011100100111110" =>  data <= "01001000";  -- 393E = 48
      when "011100100111111" =>  data <= "10100101";  -- 393F = A5
      when "011100101000000" =>  data <= "00000111";  -- 3940 = 7
      when "011100101000001" =>  data <= "01001000";  -- 3941 = 48
      when "011100101000010" =>  data <= "00100000";  -- 3942 = 20
      when "011100101000011" =>  data <= "10011000";  -- 3943 = 98
      when "011100101000100" =>  data <= "10111101";  -- 3944 = BD
      when "011100101000101" =>  data <= "01101000";  -- 3945 = 68
      when "011100101000110" =>  data <= "00101010";  -- 3946 = 2A
      when "011100101000111" =>  data <= "00100000";  -- 3947 = 20
      when "011100101001000" =>  data <= "10001010";  -- 3948 = 8A
      when "011100101001001" =>  data <= "10111101";  -- 3949 = BD
      when "011100101001010" =>  data <= "11010000";  -- 394A = D0
      when "011100101001011" =>  data <= "00011000";  -- 394B = 18
      when "011100101001100" =>  data <= "01101000";  -- 394C = 68
      when "011100101001101" =>  data <= "00010000";  -- 394D = 10
      when "011100101001110" =>  data <= "00010010";  -- 394E = 12
      when "011100101001111" =>  data <= "00100000";  -- 394F = 20
      when "011100101010000" =>  data <= "01010001";  -- 3950 = 51
      when "011100101010001" =>  data <= "11001101";  -- 3951 = CD
      when "011100101010010" =>  data <= "00100000";  -- 3952 = 20
      when "011100101010011" =>  data <= "11101010";  -- 3953 = EA
      when "011100101010100" =>  data <= "11000010";  -- 3954 = C2
      when "011100101010101" =>  data <= "10100000";  -- 3955 = A0
      when "011100101010110" =>  data <= "00000000";  -- 3956 = 0
      when "011100101010111" =>  data <= "10100101";  -- 3957 = A5
      when "011100101011000" =>  data <= "01100001";  -- 3958 = 61
      when "011100101011001" =>  data <= "10010001";  -- 3959 = 91
      when "011100101011010" =>  data <= "01000110";  -- 395A = 46
      when "011100101011011" =>  data <= "11001000";  -- 395B = C8
      when "011100101011100" =>  data <= "10100101";  -- 395C = A5
      when "011100101011101" =>  data <= "01100010";  -- 395D = 62
      when "011100101011110" =>  data <= "10010001";  -- 395E = 91
      when "011100101011111" =>  data <= "01000110";  -- 395F = 46
      when "011100101100000" =>  data <= "01100000";  -- 3960 = 60
      when "011100101100001" =>  data <= "01001100";  -- 3961 = 4C
      when "011100101100010" =>  data <= "00000110";  -- 3962 = 6
      when "011100101100011" =>  data <= "11001101";  -- 3963 = CD
      when "011100101100100" =>  data <= "01101000";  -- 3964 = 68
      when "011100101100101" =>  data <= "10100100";  -- 3965 = A4
      when "011100101100110" =>  data <= "01000111";  -- 3966 = 47
      when "011100101100111" =>  data <= "11000000";  -- 3967 = C0
      when "011100101101000" =>  data <= "11010000";  -- 3968 = D0
      when "011100101101001" =>  data <= "11010000";  -- 3969 = D0
      when "011100101101010" =>  data <= "01001111";  -- 396A = 4F
      when "011100101101011" =>  data <= "00100000";  -- 396B = 20
      when "011100101101100" =>  data <= "10111000";  -- 396C = B8
      when "011100101101101" =>  data <= "11000111";  -- 396D = C7
      when "011100101101110" =>  data <= "11001001";  -- 396E = C9
      when "011100101101111" =>  data <= "00000110";  -- 396F = 6
      when "011100101110000" =>  data <= "11010000";  -- 3970 = D0
      when "011100101110001" =>  data <= "01000000";  -- 3971 = 40
      when "011100101110010" =>  data <= "10100000";  -- 3972 = A0
      when "011100101110011" =>  data <= "00000000";  -- 3973 = 0
      when "011100101110100" =>  data <= "10000100";  -- 3974 = 84
      when "011100101110101" =>  data <= "01011110";  -- 3975 = 5E
      when "011100101110110" =>  data <= "10000100";  -- 3976 = 84
      when "011100101110111" =>  data <= "01100011";  -- 3977 = 63
      when "011100101111000" =>  data <= "10000100";  -- 3978 = 84
      when "011100101111001" =>  data <= "01101110";  -- 3979 = 6E
      when "011100101111010" =>  data <= "00100000";  -- 397A = 20
      when "011100101111011" =>  data <= "10101011";  -- 397B = AB
      when "011100101111100" =>  data <= "10111001";  -- 397C = B9
      when "011100101111101" =>  data <= "00100000";  -- 397D = 20
      when "011100101111110" =>  data <= "00011000";  -- 397E = 18
      when "011100101111111" =>  data <= "11001100";  -- 397F = CC
      when "011100110000000" =>  data <= "11100110";  -- 3980 = E6
      when "011100110000001" =>  data <= "01101110";  -- 3981 = 6E
      when "011100110000010" =>  data <= "10100100";  -- 3982 = A4
      when "011100110000011" =>  data <= "01101110";  -- 3983 = 6E
      when "011100110000100" =>  data <= "00100000";  -- 3984 = 20
      when "011100110000101" =>  data <= "10101011";  -- 3985 = AB
      when "011100110000110" =>  data <= "10111001";  -- 3986 = B9
      when "011100110000111" =>  data <= "00100000";  -- 3987 = 20
      when "011100110001000" =>  data <= "01000010";  -- 3988 = 42
      when "011100110001001" =>  data <= "11001101";  -- 3989 = CD
      when "011100110001010" =>  data <= "10101010";  -- 398A = AA
      when "011100110001011" =>  data <= "11110000";  -- 398B = F0
      when "011100110001100" =>  data <= "00000101";  -- 398C = 5
      when "011100110001101" =>  data <= "11101000";  -- 398D = E8
      when "011100110001110" =>  data <= "10001010";  -- 398E = 8A
      when "011100110001111" =>  data <= "00100000";  -- 398F = 20
      when "011100110010000" =>  data <= "00100011";  -- 3990 = 23
      when "011100110010001" =>  data <= "11001100";  -- 3991 = CC
      when "011100110010010" =>  data <= "10100100";  -- 3992 = A4
      when "011100110010011" =>  data <= "01101110";  -- 3993 = 6E
      when "011100110010100" =>  data <= "11001000";  -- 3994 = C8
      when "011100110010101" =>  data <= "11000000";  -- 3995 = C0
      when "011100110010110" =>  data <= "00000110";  -- 3996 = 6
      when "011100110010111" =>  data <= "11010000";  -- 3997 = D0
      when "011100110011000" =>  data <= "11011111";  -- 3998 = DF
      when "011100110011001" =>  data <= "00100000";  -- 3999 = 20
      when "011100110011010" =>  data <= "00011000";  -- 399A = 18
      when "011100110011011" =>  data <= "11001100";  -- 399B = CC
      when "011100110011100" =>  data <= "00100000";  -- 399C = 20
      when "011100110011101" =>  data <= "11010001";  -- 399D = D1
      when "011100110011110" =>  data <= "11001101";  -- 399E = CD
      when "011100110011111" =>  data <= "10100010";  -- 399F = A2
      when "011100110100000" =>  data <= "00000010";  -- 39A0 = 2
      when "011100110100001" =>  data <= "01111000";  -- 39A1 = 78
      when "011100110100010" =>  data <= "10110101";  -- 39A2 = B5
      when "011100110100011" =>  data <= "01100000";  -- 39A3 = 60
      when "011100110100100" =>  data <= "10010101";  -- 39A4 = 95
      when "011100110100101" =>  data <= "10001101";  -- 39A5 = 8D
      when "011100110100110" =>  data <= "11001010";  -- 39A6 = CA
      when "011100110100111" =>  data <= "00010000";  -- 39A7 = 10
      when "011100110101000" =>  data <= "11111001";  -- 39A8 = F9
      when "011100110101001" =>  data <= "01011000";  -- 39A9 = 58
      when "011100110101010" =>  data <= "01100000";  -- 39AA = 60
      when "011100110101011" =>  data <= "10110001";  -- 39AB = B1
      when "011100110101100" =>  data <= "00011111";  -- 39AC = 1F
      when "011100110101101" =>  data <= "00100000";  -- 39AD = 20
      when "011100110101110" =>  data <= "01111101";  -- 39AE = 7D
      when "011100110101111" =>  data <= "00000000";  -- 39AF = 0
      when "011100110110000" =>  data <= "10010000";  -- 39B0 = 90
      when "011100110110001" =>  data <= "00000011";  -- 39B1 = 3
      when "011100110110010" =>  data <= "01001100";  -- 39B2 = 4C
      when "011100110110011" =>  data <= "01110011";  -- 39B3 = 73
      when "011100110110100" =>  data <= "11000011";  -- 39B4 = C3
      when "011100110110101" =>  data <= "11101001";  -- 39B5 = E9
      when "011100110110110" =>  data <= "00101111";  -- 39B6 = 2F
      when "011100110110111" =>  data <= "01001100";  -- 39B7 = 4C
      when "011100110111000" =>  data <= "10110100";  -- 39B8 = B4
      when "011100110111001" =>  data <= "11001110";  -- 39B9 = CE
      when "011100110111010" =>  data <= "10100000";  -- 39BA = A0
      when "011100110111011" =>  data <= "00000010";  -- 39BB = 2
      when "011100110111100" =>  data <= "10110001";  -- 39BC = B1
      when "011100110111101" =>  data <= "01100001";  -- 39BD = 61
      when "011100110111110" =>  data <= "11000101";  -- 39BE = C5
      when "011100110111111" =>  data <= "00001111";  -- 39BF = F
      when "011100111000000" =>  data <= "11010000";  -- 39C0 = D0
      when "011100111000001" =>  data <= "00010010";  -- 39C1 = 12
      when "011100111000010" =>  data <= "01001000";  -- 39C2 = 48
      when "011100111000011" =>  data <= "10001000";  -- 39C3 = 88
      when "011100111000100" =>  data <= "10100101";  -- 39C4 = A5
      when "011100111000101" =>  data <= "00001101";  -- 39C5 = D
      when "011100111000110" =>  data <= "11110000";  -- 39C6 = F0
      when "011100111000111" =>  data <= "00001010";  -- 39C7 = A
      when "011100111001000" =>  data <= "10110001";  -- 39C8 = B1
      when "011100111001001" =>  data <= "01100001";  -- 39C9 = 61
      when "011100111001010" =>  data <= "11000101";  -- 39CA = C5
      when "011100111001011" =>  data <= "00001110";  -- 39CB = E
      when "011100111001100" =>  data <= "11010000";  -- 39CC = D0
      when "011100111001101" =>  data <= "00000100";  -- 39CD = 4
      when "011100111001110" =>  data <= "01101000";  -- 39CE = 68
      when "011100111001111" =>  data <= "01001100";  -- 39CF = 4C
      when "011100111010000" =>  data <= "11110110";  -- 39D0 = F6
      when "011100111010001" =>  data <= "10111001";  -- 39D1 = B9
      when "011100111010010" =>  data <= "01101000";  -- 39D2 = 68
      when "011100111010011" =>  data <= "11001000";  -- 39D3 = C8
      when "011100111010100" =>  data <= "11000101";  -- 39D4 = C5
      when "011100111010101" =>  data <= "00110001";  -- 39D5 = 31
      when "011100111010110" =>  data <= "10010000";  -- 39D6 = 90
      when "011100111010111" =>  data <= "00010111";  -- 39D7 = 17
      when "011100111011000" =>  data <= "11010000";  -- 39D8 = D0
      when "011100111011001" =>  data <= "00000111";  -- 39D9 = 7
      when "011100111011010" =>  data <= "10001000";  -- 39DA = 88
      when "011100111011011" =>  data <= "10110001";  -- 39DB = B1
      when "011100111011100" =>  data <= "01100001";  -- 39DC = 61
      when "011100111011101" =>  data <= "11000101";  -- 39DD = C5
      when "011100111011110" =>  data <= "00110000";  -- 39DE = 30
      when "011100111011111" =>  data <= "10010000";  -- 39DF = 90
      when "011100111100000" =>  data <= "00001110";  -- 39E0 = E
      when "011100111100001" =>  data <= "10100100";  -- 39E1 = A4
      when "011100111100010" =>  data <= "01100010";  -- 39E2 = 62
      when "011100111100011" =>  data <= "11000100";  -- 39E3 = C4
      when "011100111100100" =>  data <= "00101011";  -- 39E4 = 2B
      when "011100111100101" =>  data <= "10010000";  -- 39E5 = 90
      when "011100111100110" =>  data <= "00001000";  -- 39E6 = 8
      when "011100111100111" =>  data <= "11010000";  -- 39E7 = D0
      when "011100111101000" =>  data <= "00001101";  -- 39E8 = D
      when "011100111101001" =>  data <= "10100101";  -- 39E9 = A5
      when "011100111101010" =>  data <= "01100001";  -- 39EA = 61
      when "011100111101011" =>  data <= "11000101";  -- 39EB = C5
      when "011100111101100" =>  data <= "00101010";  -- 39EC = 2A
      when "011100111101101" =>  data <= "10110000";  -- 39ED = B0
      when "011100111101110" =>  data <= "00000111";  -- 39EE = 7
      when "011100111101111" =>  data <= "10100101";  -- 39EF = A5
      when "011100111110000" =>  data <= "01100001";  -- 39F0 = 61
      when "011100111110001" =>  data <= "10100100";  -- 39F1 = A4
      when "011100111110010" =>  data <= "01100010";  -- 39F2 = 62
      when "011100111110011" =>  data <= "01001100";  -- 39F3 = 4C
      when "011100111110100" =>  data <= "00010011";  -- 39F4 = 13
      when "011100111110101" =>  data <= "10111010";  -- 39F5 = BA
      when "011100111110110" =>  data <= "10100000";  -- 39F6 = A0
      when "011100111110111" =>  data <= "00000000";  -- 39F7 = 0
      when "011100111111000" =>  data <= "10110001";  -- 39F8 = B1
      when "011100111111001" =>  data <= "01100001";  -- 39F9 = 61
      when "011100111111010" =>  data <= "00100000";  -- 39FA = 20
      when "011100111111011" =>  data <= "10011110";  -- 39FB = 9E
      when "011100111111100" =>  data <= "11000101";  -- 39FC = C5
      when "011100111111101" =>  data <= "10100101";  -- 39FD = A5
      when "011100111111110" =>  data <= "01001101";  -- 39FE = 4D
      when "011100111111111" =>  data <= "10100100";  -- 39FF = A4
      when "011101000000000" =>  data <= "01001110";  -- 3A00 = 4E
      when "011101000000001" =>  data <= "10000101";  -- 3A01 = 85
      when "011101000000010" =>  data <= "01101100";  -- 3A02 = 6C
      when "011101000000011" =>  data <= "10000100";  -- 3A03 = 84
      when "011101000000100" =>  data <= "01101101";  -- 3A04 = 6D
      when "011101000000101" =>  data <= "00100000";  -- 3A05 = 20
      when "011101000000110" =>  data <= "10001100";  -- 3A06 = 8C
      when "011101000000111" =>  data <= "11000111";  -- 3A07 = C7
      when "011101000001000" =>  data <= "10100101";  -- 3A08 = A5
      when "011101000001001" =>  data <= "01101100";  -- 3A09 = 6C
      when "011101000001010" =>  data <= "10100100";  -- 3A0A = A4
      when "011101000001011" =>  data <= "01101101";  -- 3A0B = 6D
      when "011101000001100" =>  data <= "00100000";  -- 3A0C = 20
      when "011101000001101" =>  data <= "00010001";  -- 3A0D = 11
      when "011101000001110" =>  data <= "11001000";  -- 3A0E = C8
      when "011101000001111" =>  data <= "10101001";  -- 3A0F = A9
      when "011101000010000" =>  data <= "01011110";  -- 3A10 = 5E
      when "011101000010001" =>  data <= "10100000";  -- 3A11 = A0
      when "011101000010010" =>  data <= "00000000";  -- 3A12 = 0
      when "011101000010011" =>  data <= "10000101";  -- 3A13 = 85
      when "011101000010100" =>  data <= "01001101";  -- 3A14 = 4D
      when "011101000010101" =>  data <= "10000100";  -- 3A15 = 84
      when "011101000010110" =>  data <= "01001110";  -- 3A16 = 4E
      when "011101000010111" =>  data <= "10000101";  -- 3A17 = 85
      when "011101000011000" =>  data <= "00011111";  -- 3A18 = 1F
      when "011101000011001" =>  data <= "10000100";  -- 3A19 = 84
      when "011101000011010" =>  data <= "00100000";  -- 3A1A = 20
      when "011101000011011" =>  data <= "00100000";  -- 3A1B = 20
      when "011101000011100" =>  data <= "00010001";  -- 3A1C = 11
      when "011101000011101" =>  data <= "11001000";  -- 3A1D = C8
      when "011101000011110" =>  data <= "00100000";  -- 3A1E = 20
      when "011101000011111" =>  data <= "01001110";  -- 3A1F = 4E
      when "011101000100000" =>  data <= "10111010";  -- 3A20 = BA
      when "011101000100001" =>  data <= "10010000";  -- 3A21 = 90
      when "011101000100010" =>  data <= "00001011";  -- 3A22 = B
      when "011101000100011" =>  data <= "10100000";  -- 3A23 = A0
      when "011101000100100" =>  data <= "00000000";  -- 3A24 = 0
      when "011101000100101" =>  data <= "10100101";  -- 3A25 = A5
      when "011101000100110" =>  data <= "01000110";  -- 3A26 = 46
      when "011101000100111" =>  data <= "10010001";  -- 3A27 = 91
      when "011101000101000" =>  data <= "00011111";  -- 3A28 = 1F
      when "011101000101001" =>  data <= "11001000";  -- 3A29 = C8
      when "011101000101010" =>  data <= "10100101";  -- 3A2A = A5
      when "011101000101011" =>  data <= "01000111";  -- 3A2B = 47
      when "011101000101100" =>  data <= "10010001";  -- 3A2C = 91
      when "011101000101101" =>  data <= "00011111";  -- 3A2D = 1F
      when "011101000101110" =>  data <= "10100101";  -- 3A2E = A5
      when "011101000101111" =>  data <= "01000110";  -- 3A2F = 46
      when "011101000110000" =>  data <= "10000101";  -- 3A30 = 85
      when "011101000110001" =>  data <= "00011111";  -- 3A31 = 1F
      when "011101000110010" =>  data <= "10100101";  -- 3A32 = A5
      when "011101000110011" =>  data <= "01000111";  -- 3A33 = 47
      when "011101000110100" =>  data <= "10000101";  -- 3A34 = 85
      when "011101000110101" =>  data <= "00100000";  -- 3A35 = 20
      when "011101000110110" =>  data <= "00100000";  -- 3A36 = 20
      when "011101000110111" =>  data <= "01001110";  -- 3A37 = 4E
      when "011101000111000" =>  data <= "10111010";  -- 3A38 = BA
      when "011101000111001" =>  data <= "10010000";  -- 3A39 = 90
      when "011101000111010" =>  data <= "00001001";  -- 3A3A = 9
      when "011101000111011" =>  data <= "10001000";  -- 3A3B = 88
      when "011101000111100" =>  data <= "10101001";  -- 3A3C = A9
      when "011101000111101" =>  data <= "11111111";  -- 3A3D = FF
      when "011101000111110" =>  data <= "10010001";  -- 3A3E = 91
      when "011101000111111" =>  data <= "00011111";  -- 3A3F = 1F
      when "011101001000000" =>  data <= "10001000";  -- 3A40 = 88
      when "011101001000001" =>  data <= "10001010";  -- 3A41 = 8A
      when "011101001000010" =>  data <= "10010001";  -- 3A42 = 91
      when "011101001000011" =>  data <= "00011111";  -- 3A43 = 1F
      when "011101001000100" =>  data <= "10100000";  -- 3A44 = A0
      when "011101001000101" =>  data <= "00000010";  -- 3A45 = 2
      when "011101001000110" =>  data <= "10110001";  -- 3A46 = B1
      when "011101001000111" =>  data <= "01001101";  -- 3A47 = 4D
      when "011101001001000" =>  data <= "10010001";  -- 3A48 = 91
      when "011101001001001" =>  data <= "01000110";  -- 3A49 = 46
      when "011101001001010" =>  data <= "10001000";  -- 3A4A = 88
      when "011101001001011" =>  data <= "00010000";  -- 3A4B = 10
      when "011101001001100" =>  data <= "11111001";  -- 3A4C = F9
      when "011101001001101" =>  data <= "01100000";  -- 3A4D = 60
      when "011101001001110" =>  data <= "10100000";  -- 3A4E = A0
      when "011101001001111" =>  data <= "00000000";  -- 3A4F = 0
      when "011101001010000" =>  data <= "10110001";  -- 3A50 = B1
      when "011101001010001" =>  data <= "00011111";  -- 3A51 = 1F
      when "011101001010010" =>  data <= "01001000";  -- 3A52 = 48
      when "011101001010011" =>  data <= "11110000";  -- 3A53 = F0
      when "011101001010100" =>  data <= "00110000";  -- 3A54 = 30
      when "011101001010101" =>  data <= "11001000";  -- 3A55 = C8
      when "011101001010110" =>  data <= "10110001";  -- 3A56 = B1
      when "011101001010111" =>  data <= "00011111";  -- 3A57 = 1F
      when "011101001011000" =>  data <= "10101010";  -- 3A58 = AA
      when "011101001011001" =>  data <= "11001000";  -- 3A59 = C8
      when "011101001011010" =>  data <= "10110001";  -- 3A5A = B1
      when "011101001011011" =>  data <= "00011111";  -- 3A5B = 1F
      when "011101001011100" =>  data <= "00110000";  -- 3A5C = 30
      when "011101001011101" =>  data <= "00100111";  -- 3A5D = 27
      when "011101001011110" =>  data <= "11001001";  -- 3A5E = C9
      when "011101001011111" =>  data <= "10110000";  -- 3A5F = B0
      when "011101001100000" =>  data <= "10110000";  -- 3A60 = B0
      when "011101001100001" =>  data <= "00100011";  -- 3A61 = 23
      when "011101001100010" =>  data <= "11000101";  -- 3A62 = C5
      when "011101001100011" =>  data <= "00110001";  -- 3A63 = 31
      when "011101001100100" =>  data <= "10010000";  -- 3A64 = 90
      when "011101001100101" =>  data <= "00011111";  -- 3A65 = 1F
      when "011101001100110" =>  data <= "11010000";  -- 3A66 = D0
      when "011101001100111" =>  data <= "00000100";  -- 3A67 = 4
      when "011101001101000" =>  data <= "11100100";  -- 3A68 = E4
      when "011101001101001" =>  data <= "00110000";  -- 3A69 = 30
      when "011101001101010" =>  data <= "10010000";  -- 3A6A = 90
      when "011101001101011" =>  data <= "00011001";  -- 3A6B = 19
      when "011101001101100" =>  data <= "01001100";  -- 3A6C = 4C
      when "011101001101101" =>  data <= "00010000";  -- 3A6D = 10
      when "011101001101110" =>  data <= "10111111";  -- 3A6E = BF
      when "011101001101111" =>  data <= "11101010";  -- 3A6F = EA
      when "011101001110000" =>  data <= "11100100";  -- 3A70 = E4
      when "011101001110001" =>  data <= "00001110";  -- 3A71 = E
      when "011101001110010" =>  data <= "11110000";  -- 3A72 = F0
      when "011101001110011" =>  data <= "00010001";  -- 3A73 = 11
      when "011101001110100" =>  data <= "10000110";  -- 3A74 = 86
      when "011101001110101" =>  data <= "00011111";  -- 3A75 = 1F
      when "011101001110110" =>  data <= "10000101";  -- 3A76 = 85
      when "011101001110111" =>  data <= "00100000";  -- 3A77 = 20
      when "011101001111000" =>  data <= "01101000";  -- 3A78 = 68
      when "011101001111001" =>  data <= "10101010";  -- 3A79 = AA
      when "011101001111010" =>  data <= "00011000";  -- 3A7A = 18
      when "011101001111011" =>  data <= "01100101";  -- 3A7B = 65
      when "011101001111100" =>  data <= "00011111";  -- 3A7C = 1F
      when "011101001111101" =>  data <= "10000101";  -- 3A7D = 85
      when "011101001111110" =>  data <= "00011111";  -- 3A7E = 1F
      when "011101001111111" =>  data <= "10010000";  -- 3A7F = 90
      when "011101010000000" =>  data <= "00000010";  -- 3A80 = 2
      when "011101010000001" =>  data <= "11100110";  -- 3A81 = E6
      when "011101010000010" =>  data <= "00100000";  -- 3A82 = 20
      when "011101010000011" =>  data <= "00111000";  -- 3A83 = 38
      when "011101010000100" =>  data <= "01100000";  -- 3A84 = 60
      when "011101010000101" =>  data <= "01101000";  -- 3A85 = 68
      when "011101010000110" =>  data <= "00011000";  -- 3A86 = 18
      when "011101010000111" =>  data <= "01100000";  -- 3A87 = 60
      when "011101010001000" =>  data <= "00100000";  -- 3A88 = 20
      when "011101010001001" =>  data <= "10001110";  -- 3A89 = 8E
      when "011101010001010" =>  data <= "10111010";  -- 3A8A = BA
      when "011101010001011" =>  data <= "01001100";  -- 3A8B = 4C
      when "011101010001100" =>  data <= "10110100";  -- 3A8C = B4
      when "011101010001101" =>  data <= "10111011";  -- 3A8D = BB
      when "011101010001110" =>  data <= "00100000";  -- 3A8E = 20
      when "011101010001111" =>  data <= "11010100";  -- 3A8F = D4
      when "011101010010000" =>  data <= "11001000";  -- 3A90 = C8
      when "011101010010001" =>  data <= "11110000";  -- 3A91 = F0
      when "011101010010010" =>  data <= "00000101";  -- 3A92 = 5
      when "011101010010011" =>  data <= "10101001";  -- 3A93 = A9
      when "011101010010100" =>  data <= "00101100";  -- 3A94 = 2C
      when "011101010010101" =>  data <= "00100000";  -- 3A95 = 20
      when "011101010010110" =>  data <= "11110111";  -- 3A96 = F7
      when "011101010010111" =>  data <= "10111110";  -- 3A97 = BE
      when "011101010011000" =>  data <= "00001000";  -- 3A98 = 8
      when "011101010011001" =>  data <= "00100000";  -- 3A99 = 20
      when "011101010011010" =>  data <= "11001001";  -- 3A9A = C9
      when "011101010011011" =>  data <= "11111111";  -- 3A9B = FF
      when "011101010011100" =>  data <= "10000110";  -- 3A9C = 86
      when "011101010011101" =>  data <= "00010000";  -- 3A9D = 10
      when "011101010011110" =>  data <= "00101000";  -- 3A9E = 28
      when "011101010011111" =>  data <= "01001100";  -- 3A9F = 4C
      when "011101010100000" =>  data <= "10101000";  -- 3AA0 = A8
      when "011101010100001" =>  data <= "10111010";  -- 3AA1 = BA
      when "011101010100010" =>  data <= "00100000";  -- 3AA2 = 20
      when "011101010100011" =>  data <= "00100000";  -- 3AA3 = 20
      when "011101010100100" =>  data <= "10111011";  -- 3AA4 = BB
      when "011101010100101" =>  data <= "00100000";  -- 3AA5 = 20
      when "011101010100110" =>  data <= "01110110";  -- 3AA6 = 76
      when "011101010100111" =>  data <= "00000000";  -- 3AA7 = 0
      when "011101010101000" =>  data <= "11110000";  -- 3AA8 = F0
      when "011101010101001" =>  data <= "00110101";  -- 3AA9 = 35
      when "011101010101010" =>  data <= "11110000";  -- 3AAA = F0
      when "011101010101011" =>  data <= "01000011";  -- 3AAB = 43
      when "011101010101100" =>  data <= "11001001";  -- 3AAC = C9
      when "011101010101101" =>  data <= "10100011";  -- 3AAD = A3
      when "011101010101110" =>  data <= "11110000";  -- 3AAE = F0
      when "011101010101111" =>  data <= "01001101";  -- 3AAF = 4D
      when "011101010110000" =>  data <= "11001001";  -- 3AB0 = C9
      when "011101010110001" =>  data <= "10100110";  -- 3AB1 = A6
      when "011101010110010" =>  data <= "00011000";  -- 3AB2 = 18
      when "011101010110011" =>  data <= "11110000";  -- 3AB3 = F0
      when "011101010110100" =>  data <= "01001000";  -- 3AB4 = 48
      when "011101010110101" =>  data <= "11001001";  -- 3AB5 = C9
      when "011101010110110" =>  data <= "00101100";  -- 3AB6 = 2C
      when "011101010110111" =>  data <= "11110000";  -- 3AB7 = F0
      when "011101010111000" =>  data <= "00110111";  -- 3AB8 = 37
      when "011101010111001" =>  data <= "11001001";  -- 3AB9 = C9
      when "011101010111010" =>  data <= "00111011";  -- 3ABA = 3B
      when "011101010111011" =>  data <= "11110000";  -- 3ABB = F0
      when "011101010111100" =>  data <= "01010101";  -- 3ABC = 55
      when "011101010111101" =>  data <= "00100000";  -- 3ABD = 20
      when "011101010111110" =>  data <= "10011000";  -- 3ABE = 98
      when "011101010111111" =>  data <= "10111101";  -- 3ABF = BD
      when "011101011000000" =>  data <= "00100100";  -- 3AC0 = 24
      when "011101011000001" =>  data <= "00000111";  -- 3AC1 = 7
      when "011101011000010" =>  data <= "00110000";  -- 3AC2 = 30
      when "011101011000011" =>  data <= "11011110";  -- 3AC3 = DE
      when "011101011000100" =>  data <= "00100000";  -- 3AC4 = 20
      when "011101011000101" =>  data <= "10010011";  -- 3AC5 = 93
      when "011101011000110" =>  data <= "11001111";  -- 3AC6 = CF
      when "011101011000111" =>  data <= "00100000";  -- 3AC7 = 20
      when "011101011001000" =>  data <= "10110000";  -- 3AC8 = B0
      when "011101011001001" =>  data <= "11000101";  -- 3AC9 = C5
      when "011101011001010" =>  data <= "00100000";  -- 3ACA = 20
      when "011101011001011" =>  data <= "00100000";  -- 3ACB = 20
      when "011101011001100" =>  data <= "10111011";  -- 3ACC = BB
      when "011101011001101" =>  data <= "00100000";  -- 3ACD = 20
      when "011101011001110" =>  data <= "00111010";  -- 3ACE = 3A
      when "011101011001111" =>  data <= "10111011";  -- 3ACF = BB
      when "011101011010000" =>  data <= "11010000";  -- 3AD0 = D0
      when "011101011010001" =>  data <= "11010011";  -- 3AD1 = D3
      when "011101011010010" =>  data <= "10101001";  -- 3AD2 = A9
      when "011101011010011" =>  data <= "00000000";  -- 3AD3 = 0
      when "011101011010100" =>  data <= "10011101";  -- 3AD4 = 9D
      when "011101011010101" =>  data <= "00000000";  -- 3AD5 = 0
      when "011101011010110" =>  data <= "00000010";  -- 3AD6 = 2
      when "011101011010111" =>  data <= "10100010";  -- 3AD7 = A2
      when "011101011011000" =>  data <= "11111111";  -- 3AD8 = FF
      when "011101011011001" =>  data <= "10100000";  -- 3AD9 = A0
      when "011101011011010" =>  data <= "00000001";  -- 3ADA = 1
      when "011101011011011" =>  data <= "10100101";  -- 3ADB = A5
      when "011101011011100" =>  data <= "00010000";  -- 3ADC = 10
      when "011101011011101" =>  data <= "11010000";  -- 3ADD = D0
      when "011101011011110" =>  data <= "00010000";  -- 3ADE = 10
      when "011101011011111" =>  data <= "10101001";  -- 3ADF = A9
      when "011101011100000" =>  data <= "00001101";  -- 3AE0 = D
      when "011101011100001" =>  data <= "00100000";  -- 3AE1 = 20
      when "011101011100010" =>  data <= "01000110";  -- 3AE2 = 46
      when "011101011100011" =>  data <= "10111011";  -- 3AE3 = BB
      when "011101011100100" =>  data <= "10100101";  -- 3AE4 = A5
      when "011101011100101" =>  data <= "00010000";  -- 3AE5 = 10
      when "011101011100110" =>  data <= "00010000";  -- 3AE6 = 10
      when "011101011100111" =>  data <= "00000101";  -- 3AE7 = 5
      when "011101011101000" =>  data <= "10101001";  -- 3AE8 = A9
      when "011101011101001" =>  data <= "00001010";  -- 3AE9 = A
      when "011101011101010" =>  data <= "00100000";  -- 3AEA = 20
      when "011101011101011" =>  data <= "01000110";  -- 3AEB = 46
      when "011101011101100" =>  data <= "10111011";  -- 3AEC = BB
      when "011101011101101" =>  data <= "01001001";  -- 3AED = 49
      when "011101011101110" =>  data <= "11111111";  -- 3AEE = FF
      when "011101011101111" =>  data <= "01100000";  -- 3AEF = 60
      when "011101011110000" =>  data <= "10100101";  -- 3AF0 = A5
      when "011101011110001" =>  data <= "11000110";  -- 3AF1 = C6
      when "011101011110010" =>  data <= "00111000";  -- 3AF2 = 38
      when "011101011110011" =>  data <= "11101001";  -- 3AF3 = E9
      when "011101011110100" =>  data <= "00001010";  -- 3AF4 = A
      when "011101011110101" =>  data <= "10110000";  -- 3AF5 = B0
      when "011101011110110" =>  data <= "11111100";  -- 3AF6 = FC
      when "011101011110111" =>  data <= "01001001";  -- 3AF7 = 49
      when "011101011111000" =>  data <= "11111111";  -- 3AF8 = FF
      when "011101011111001" =>  data <= "01101001";  -- 3AF9 = 69
      when "011101011111010" =>  data <= "00000001";  -- 3AFA = 1
      when "011101011111011" =>  data <= "11010000";  -- 3AFB = D0
      when "011101011111100" =>  data <= "00010000";  -- 3AFC = 10
      when "011101011111101" =>  data <= "00001000";  -- 3AFD = 8
      when "011101011111110" =>  data <= "00100000";  -- 3AFE = 20
      when "011101011111111" =>  data <= "11010001";  -- 3AFF = D1
      when "011101100000000" =>  data <= "11001000";  -- 3B00 = C8
      when "011101100000001" =>  data <= "11001001";  -- 3B01 = C9
      when "011101100000010" =>  data <= "00101001";  -- 3B02 = 29
      when "011101100000011" =>  data <= "11010000";  -- 3B03 = D0
      when "011101100000100" =>  data <= "01011001";  -- 3B04 = 59
      when "011101100000101" =>  data <= "00101000";  -- 3B05 = 28
      when "011101100000110" =>  data <= "10010000";  -- 3B06 = 90
      when "011101100000111" =>  data <= "00000110";  -- 3B07 = 6
      when "011101100001000" =>  data <= "10001010";  -- 3B08 = 8A
      when "011101100001001" =>  data <= "11100101";  -- 3B09 = E5
      when "011101100001010" =>  data <= "11000110";  -- 3B0A = C6
      when "011101100001011" =>  data <= "10010000";  -- 3B0B = 90
      when "011101100001100" =>  data <= "00000101";  -- 3B0C = 5
      when "011101100001101" =>  data <= "10101010";  -- 3B0D = AA
      when "011101100001110" =>  data <= "11101000";  -- 3B0E = E8
      when "011101100001111" =>  data <= "11001010";  -- 3B0F = CA
      when "011101100010000" =>  data <= "11010000";  -- 3B10 = D0
      when "011101100010001" =>  data <= "00000110";  -- 3B11 = 6
      when "011101100010010" =>  data <= "00100000";  -- 3B12 = 20
      when "011101100010011" =>  data <= "01110000";  -- 3B13 = 70
      when "011101100010100" =>  data <= "00000000";  -- 3B14 = 0
      when "011101100010101" =>  data <= "01001100";  -- 3B15 = 4C
      when "011101100010110" =>  data <= "10101010";  -- 3B16 = AA
      when "011101100010111" =>  data <= "10111010";  -- 3B17 = BA
      when "011101100011000" =>  data <= "00100000";  -- 3B18 = 20
      when "011101100011001" =>  data <= "00111010";  -- 3B19 = 3A
      when "011101100011010" =>  data <= "10111011";  -- 3B1A = BB
      when "011101100011011" =>  data <= "11010000";  -- 3B1B = D0
      when "011101100011100" =>  data <= "11110010";  -- 3B1C = F2
      when "011101100011101" =>  data <= "00100000";  -- 3B1D = 20
      when "011101100011110" =>  data <= "10110000";  -- 3B1E = B0
      when "011101100011111" =>  data <= "11000101";  -- 3B1F = C5
      when "011101100100000" =>  data <= "00100000";  -- 3B20 = 20
      when "011101100100001" =>  data <= "10111000";  -- 3B21 = B8
      when "011101100100010" =>  data <= "11000111";  -- 3B22 = C7
      when "011101100100011" =>  data <= "10101010";  -- 3B23 = AA
      when "011101100100100" =>  data <= "10100000";  -- 3B24 = A0
      when "011101100100101" =>  data <= "00000000";  -- 3B25 = 0
      when "011101100100110" =>  data <= "11101000";  -- 3B26 = E8
      when "011101100100111" =>  data <= "11001010";  -- 3B27 = CA
      when "011101100101000" =>  data <= "11110000";  -- 3B28 = F0
      when "011101100101001" =>  data <= "11000101";  -- 3B29 = C5
      when "011101100101010" =>  data <= "10110001";  -- 3B2A = B1
      when "011101100101011" =>  data <= "00011111";  -- 3B2B = 1F
      when "011101100101100" =>  data <= "00100000";  -- 3B2C = 20
      when "011101100101101" =>  data <= "01000110";  -- 3B2D = 46
      when "011101100101110" =>  data <= "10111011";  -- 3B2E = BB
      when "011101100101111" =>  data <= "11001000";  -- 3B2F = C8
      when "011101100110000" =>  data <= "11001001";  -- 3B30 = C9
      when "011101100110001" =>  data <= "00001101";  -- 3B31 = D
      when "011101100110010" =>  data <= "11010000";  -- 3B32 = D0
      when "011101100110011" =>  data <= "11110011";  -- 3B33 = F3
      when "011101100110100" =>  data <= "00100000";  -- 3B34 = 20
      when "011101100110101" =>  data <= "11101101";  -- 3B35 = ED
      when "011101100110110" =>  data <= "10111010";  -- 3B36 = BA
      when "011101100110111" =>  data <= "01001100";  -- 3B37 = 4C
      when "011101100111000" =>  data <= "00100111";  -- 3B38 = 27
      when "011101100111001" =>  data <= "10111011";  -- 3B39 = BB
      when "011101100111010" =>  data <= "10100101";  -- 3B3A = A5
      when "011101100111011" =>  data <= "00010000";  -- 3B3B = 10
      when "011101100111100" =>  data <= "11110000";  -- 3B3C = F0
      when "011101100111101" =>  data <= "00000011";  -- 3B3D = 3
      when "011101100111110" =>  data <= "10101001";  -- 3B3E = A9
      when "011101100111111" =>  data <= "00100000";  -- 3B3F = 20
      when "011101101000000" =>  data <= "00101100";  -- 3B40 = 2C
      when "011101101000001" =>  data <= "10101001";  -- 3B41 = A9
      when "011101101000010" =>  data <= "00011101";  -- 3B42 = 1D
      when "011101101000011" =>  data <= "00101100";  -- 3B43 = 2C
      when "011101101000100" =>  data <= "10101001";  -- 3B44 = A9
      when "011101101000101" =>  data <= "00111111";  -- 3B45 = 3F
      when "011101101000110" =>  data <= "00100000";  -- 3B46 = 20
      when "011101101000111" =>  data <= "11010010";  -- 3B47 = D2
      when "011101101001000" =>  data <= "11111111";  -- 3B48 = FF
      when "011101101001001" =>  data <= "00101001";  -- 3B49 = 29
      when "011101101001010" =>  data <= "11111111";  -- 3B4A = FF
      when "011101101001011" =>  data <= "01100000";  -- 3B4B = 60
      when "011101101001100" =>  data <= "10100101";  -- 3B4C = A5
      when "011101101001101" =>  data <= "00001011";  -- 3B4D = B
      when "011101101001110" =>  data <= "11110000";  -- 3B4E = F0
      when "011101101001111" =>  data <= "00010001";  -- 3B4F = 11
      when "011101101010000" =>  data <= "00110000";  -- 3B50 = 30
      when "011101101010001" =>  data <= "00000100";  -- 3B51 = 4
      when "011101101010010" =>  data <= "10100000";  -- 3B52 = A0
      when "011101101010011" =>  data <= "11111111";  -- 3B53 = FF
      when "011101101010100" =>  data <= "11010000";  -- 3B54 = D0
      when "011101101010101" =>  data <= "00000100";  -- 3B55 = 4
      when "011101101010110" =>  data <= "10100101";  -- 3B56 = A5
      when "011101101010111" =>  data <= "00111100";  -- 3B57 = 3C
      when "011101101011000" =>  data <= "10100100";  -- 3B58 = A4
      when "011101101011001" =>  data <= "00111101";  -- 3B59 = 3D
      when "011101101011010" =>  data <= "10000101";  -- 3B5A = 85
      when "011101101011011" =>  data <= "00110110";  -- 3B5B = 36
      when "011101101011100" =>  data <= "10000100";  -- 3B5C = 84
      when "011101101011101" =>  data <= "00110111";  -- 3B5D = 37
      when "011101101011110" =>  data <= "01001100";  -- 3B5E = 4C
      when "011101101011111" =>  data <= "00000000";  -- 3B5F = 0
      when "011101101100000" =>  data <= "10111111";  -- 3B60 = BF
      when "011101101100001" =>  data <= "10100101";  -- 3B61 = A5
      when "011101101100010" =>  data <= "00010000";  -- 3B62 = 10
      when "011101101100011" =>  data <= "11110000";  -- 3B63 = F0
      when "011101101100100" =>  data <= "00000101";  -- 3B64 = 5
      when "011101101100101" =>  data <= "10100010";  -- 3B65 = A2
      when "011101101100110" =>  data <= "10111111";  -- 3B66 = BF
      when "011101101100111" =>  data <= "01001100";  -- 3B67 = 4C
      when "011101101101000" =>  data <= "11001111";  -- 3B68 = CF
      when "011101101101001" =>  data <= "10110011";  -- 3B69 = B3
      when "011101101101010" =>  data <= "10101001";  -- 3B6A = A9
      when "011101101101011" =>  data <= "00000111";  -- 3B6B = 7
      when "011101101101100" =>  data <= "10100000";  -- 3B6C = A0
      when "011101101101101" =>  data <= "10111101";  -- 3B6D = BD
      when "011101101101110" =>  data <= "00100000";  -- 3B6E = 20
      when "011101101101111" =>  data <= "00011101";  -- 3B6F = 1D
      when "011101101110000" =>  data <= "10111011";  -- 3B70 = BB
      when "011101101110001" =>  data <= "10100101";  -- 3B71 = A5
      when "011101101110010" =>  data <= "00111010";  -- 3B72 = 3A
      when "011101101110011" =>  data <= "10100100";  -- 3B73 = A4
      when "011101101110100" =>  data <= "00111011";  -- 3B74 = 3B
      when "011101101110101" =>  data <= "10000101";  -- 3B75 = 85
      when "011101101110110" =>  data <= "01110111";  -- 3B76 = 77
      when "011101101110111" =>  data <= "10000100";  -- 3B77 = 84
      when "011101101111000" =>  data <= "01111000";  -- 3B78 = 78
      when "011101101111001" =>  data <= "01100000";  -- 3B79 = 60
      when "011101101111010" =>  data <= "00100000";  -- 3B7A = 20
      when "011101101111011" =>  data <= "11001111";  -- 3B7B = CF
      when "011101101111100" =>  data <= "11000100";  -- 3B7C = C4
      when "011101101111101" =>  data <= "11001001";  -- 3B7D = C9
      when "011101101111110" =>  data <= "00100011";  -- 3B7E = 23
      when "011101101111111" =>  data <= "11010000";  -- 3B7F = D0
      when "011101110000000" =>  data <= "00010000";  -- 3B80 = 10
      when "011101110000001" =>  data <= "00100000";  -- 3B81 = 20
      when "011101110000010" =>  data <= "01110000";  -- 3B82 = 70
      when "011101110000011" =>  data <= "00000000";  -- 3B83 = 0
      when "011101110000100" =>  data <= "00100000";  -- 3B84 = 20
      when "011101110000101" =>  data <= "11010100";  -- 3B85 = D4
      when "011101110000110" =>  data <= "11001000";  -- 3B86 = C8
      when "011101110000111" =>  data <= "10101001";  -- 3B87 = A9
      when "011101110001000" =>  data <= "00101100";  -- 3B88 = 2C
      when "011101110001001" =>  data <= "00100000";  -- 3B89 = 20
      when "011101110001010" =>  data <= "11110111";  -- 3B8A = F7
      when "011101110001011" =>  data <= "10111110";  -- 3B8B = BE
      when "011101110001100" =>  data <= "00100000";  -- 3B8C = 20
      when "011101110001101" =>  data <= "11000110";  -- 3B8D = C6
      when "011101110001110" =>  data <= "11111111";  -- 3B8E = FF
      when "011101110001111" =>  data <= "10000110";  -- 3B8F = 86
      when "011101110010000" =>  data <= "00010000";  -- 3B90 = 10
      when "011101110010001" =>  data <= "10100010";  -- 3B91 = A2
      when "011101110010010" =>  data <= "00000001";  -- 3B92 = 1
      when "011101110010011" =>  data <= "10100000";  -- 3B93 = A0
      when "011101110010100" =>  data <= "00000010";  -- 3B94 = 2
      when "011101110010101" =>  data <= "10101001";  -- 3B95 = A9
      when "011101110010110" =>  data <= "00000000";  -- 3B96 = 0
      when "011101110010111" =>  data <= "10001101";  -- 3B97 = 8D
      when "011101110011000" =>  data <= "00000001";  -- 3B98 = 1
      when "011101110011001" =>  data <= "00000010";  -- 3B99 = 2
      when "011101110011010" =>  data <= "10101001";  -- 3B9A = A9
      when "011101110011011" =>  data <= "01000000";  -- 3B9B = 40
      when "011101110011100" =>  data <= "00100000";  -- 3B9C = 20
      when "011101110011101" =>  data <= "00001011";  -- 3B9D = B
      when "011101110011110" =>  data <= "10111100";  -- 3B9E = BC
      when "011101110011111" =>  data <= "10100110";  -- 3B9F = A6
      when "011101110100000" =>  data <= "00010000";  -- 3BA0 = 10
      when "011101110100001" =>  data <= "11010000";  -- 3BA1 = D0
      when "011101110100010" =>  data <= "00010011";  -- 3BA2 = 13
      when "011101110100011" =>  data <= "01100000";  -- 3BA3 = 60
      when "011101110100100" =>  data <= "00100000";  -- 3BA4 = 20
      when "011101110100101" =>  data <= "11010100";  -- 3BA5 = D4
      when "011101110100110" =>  data <= "11001000";  -- 3BA6 = C8
      when "011101110100111" =>  data <= "10101001";  -- 3BA7 = A9
      when "011101110101000" =>  data <= "00101100";  -- 3BA8 = 2C
      when "011101110101001" =>  data <= "00100000";  -- 3BA9 = 20
      when "011101110101010" =>  data <= "11110111";  -- 3BAA = F7
      when "011101110101011" =>  data <= "10111110";  -- 3BAB = BE
      when "011101110101100" =>  data <= "00100000";  -- 3BAC = 20
      when "011101110101101" =>  data <= "11000110";  -- 3BAD = C6
      when "011101110101110" =>  data <= "11111111";  -- 3BAE = FF
      when "011101110101111" =>  data <= "10000110";  -- 3BAF = 86
      when "011101110110000" =>  data <= "00010000";  -- 3BB0 = 10
      when "011101110110001" =>  data <= "00100000";  -- 3BB1 = 20
      when "011101110110010" =>  data <= "11001101";  -- 3BB2 = CD
      when "011101110110011" =>  data <= "10111011";  -- 3BB3 = BB
      when "011101110110100" =>  data <= "10100101";  -- 3BB4 = A5
      when "011101110110101" =>  data <= "00010000";  -- 3BB5 = 10
      when "011101110110110" =>  data <= "00100000";  -- 3BB6 = 20
      when "011101110110111" =>  data <= "11001100";  -- 3BB7 = CC
      when "011101110111000" =>  data <= "11111111";  -- 3BB8 = FF
      when "011101110111001" =>  data <= "10100010";  -- 3BB9 = A2
      when "011101110111010" =>  data <= "00000000";  -- 3BBA = 0
      when "011101110111011" =>  data <= "10000110";  -- 3BBB = 86
      when "011101110111100" =>  data <= "00010000";  -- 3BBC = 10
      when "011101110111101" =>  data <= "01100000";  -- 3BBD = 60
      when "011101110111110" =>  data <= "11001001";  -- 3BBE = C9
      when "011101110111111" =>  data <= "00100010";  -- 3BBF = 22
      when "011101111000000" =>  data <= "11010000";  -- 3BC0 = D0
      when "011101111000001" =>  data <= "00001011";  -- 3BC1 = B
      when "011101111000010" =>  data <= "00100000";  -- 3BC2 = 20
      when "011101111000011" =>  data <= "10110101";  -- 3BC3 = B5
      when "011101111000100" =>  data <= "10111110";  -- 3BC4 = BE
      when "011101111000101" =>  data <= "10101001";  -- 3BC5 = A9
      when "011101111000110" =>  data <= "00111011";  -- 3BC6 = 3B
      when "011101111000111" =>  data <= "00100000";  -- 3BC7 = 20
      when "011101111001000" =>  data <= "11110111";  -- 3BC8 = F7
      when "011101111001001" =>  data <= "10111110";  -- 3BC9 = BE
      when "011101111001010" =>  data <= "00100000";  -- 3BCA = 20
      when "011101111001011" =>  data <= "00100000";  -- 3BCB = 20
      when "011101111001100" =>  data <= "10111011";  -- 3BCC = BB
      when "011101111001101" =>  data <= "00100000";  -- 3BCD = 20
      when "011101111001110" =>  data <= "11001111";  -- 3BCE = CF
      when "011101111001111" =>  data <= "11000100";  -- 3BCF = C4
      when "011101111010000" =>  data <= "10101001";  -- 3BD0 = A9
      when "011101111010001" =>  data <= "00101100";  -- 3BD1 = 2C
      when "011101111010010" =>  data <= "10001101";  -- 3BD2 = 8D
      when "011101111010011" =>  data <= "11111111";  -- 3BD3 = FF
      when "011101111010100" =>  data <= "00000001";  -- 3BD4 = 1
      when "011101111010101" =>  data <= "00100000";  -- 3BD5 = 20
      when "011101111010110" =>  data <= "11110101";  -- 3BD6 = F5
      when "011101111010111" =>  data <= "10111011";  -- 3BD7 = BB
      when "011101111011000" =>  data <= "10100101";  -- 3BD8 = A5
      when "011101111011001" =>  data <= "00010000";  -- 3BD9 = 10
      when "011101111011010" =>  data <= "11110000";  -- 3BDA = F0
      when "011101111011011" =>  data <= "00001100";  -- 3BDB = C
      when "011101111011100" =>  data <= "10100101";  -- 3BDC = A5
      when "011101111011101" =>  data <= "10010110";  -- 3BDD = 96
      when "011101111011110" =>  data <= "00101001";  -- 3BDE = 29
      when "011101111011111" =>  data <= "00000011";  -- 3BDF = 3
      when "011101111100000" =>  data <= "11110000";  -- 3BE0 = F0
      when "011101111100001" =>  data <= "00000110";  -- 3BE1 = 6
      when "011101111100010" =>  data <= "00100000";  -- 3BE2 = 20
      when "011101111100011" =>  data <= "10110100";  -- 3BE3 = B4
      when "011101111100100" =>  data <= "10111011";  -- 3BE4 = BB
      when "011101111100101" =>  data <= "01001100";  -- 3BE5 = 4C
      when "011101111100110" =>  data <= "10000011";  -- 3BE6 = 83
      when "011101111100111" =>  data <= "10111000";  -- 3BE7 = B8
      when "011101111101000" =>  data <= "10101101";  -- 3BE8 = AD
      when "011101111101001" =>  data <= "00000000";  -- 3BE9 = 0
      when "011101111101010" =>  data <= "00000010";  -- 3BEA = 2
      when "011101111101011" =>  data <= "11010000";  -- 3BEB = D0
      when "011101111101100" =>  data <= "00011100";  -- 3BEC = 1C
      when "011101111101101" =>  data <= "01001100";  -- 3BED = 4C
      when "011101111101110" =>  data <= "00101110";  -- 3BEE = 2E
      when "011101111101111" =>  data <= "10111111";  -- 3BEF = BF
      when "011101111110000" =>  data <= "11101010";  -- 3BF0 = EA
      when "011101111110001" =>  data <= "00011000";  -- 3BF1 = 18
      when "011101111110010" =>  data <= "01001100";  -- 3BF2 = 4C
      when "011101111110011" =>  data <= "11011000";  -- 3BF3 = D8
      when "011101111110100" =>  data <= "10110111";  -- 3BF4 = B7
      when "011101111110101" =>  data <= "10100101";  -- 3BF5 = A5
      when "011101111110110" =>  data <= "00010000";  -- 3BF6 = 10
      when "011101111110111" =>  data <= "11010000";  -- 3BF7 = D0
      when "011101111111000" =>  data <= "00000110";  -- 3BF8 = 6
      when "011101111111001" =>  data <= "00100000";  -- 3BF9 = 20
      when "011101111111010" =>  data <= "01000100";  -- 3BFA = 44
      when "011101111111011" =>  data <= "10111011";  -- 3BFB = BB
      when "011101111111100" =>  data <= "00100000";  -- 3BFC = 20
      when "011101111111101" =>  data <= "00111010";  -- 3BFD = 3A
      when "011101111111110" =>  data <= "10111011";  -- 3BFE = BB
      when "011101111111111" =>  data <= "01001100";  -- 3BFF = 4C
      when "011110000000000" =>  data <= "11100010";  -- 3C00 = E2
      when "011110000000001" =>  data <= "10110100";  -- 3C01 = B4
      when "011110000000010" =>  data <= "10100110";  -- 3C02 = A6
      when "011110000000011" =>  data <= "00111110";  -- 3C03 = 3E
      when "011110000000100" =>  data <= "10100100";  -- 3C04 = A4
      when "011110000000101" =>  data <= "00111111";  -- 3C05 = 3F
      when "011110000000110" =>  data <= "10101001";  -- 3C06 = A9
      when "011110000000111" =>  data <= "10011000";  -- 3C07 = 98
      when "011110000001000" =>  data <= "00101100";  -- 3C08 = 2C
      when "011110000001001" =>  data <= "10101001";  -- 3C09 = A9
      when "011110000001010" =>  data <= "00000000";  -- 3C0A = 0
      when "011110000001011" =>  data <= "10000101";  -- 3C0B = 85
      when "011110000001100" =>  data <= "00001011";  -- 3C0C = B
      when "011110000001101" =>  data <= "10000110";  -- 3C0D = 86
      when "011110000001110" =>  data <= "01000000";  -- 3C0E = 40
      when "011110000001111" =>  data <= "10000100";  -- 3C0F = 84
      when "011110000010000" =>  data <= "01000001";  -- 3C10 = 41
      when "011110000010001" =>  data <= "00100000";  -- 3C11 = 20
      when "011110000010010" =>  data <= "00101011";  -- 3C12 = 2B
      when "011110000010011" =>  data <= "11000001";  -- 3C13 = C1
      when "011110000010100" =>  data <= "10000101";  -- 3C14 = 85
      when "011110000010101" =>  data <= "01000110";  -- 3C15 = 46
      when "011110000010110" =>  data <= "10000100";  -- 3C16 = 84
      when "011110000010111" =>  data <= "01000111";  -- 3C17 = 47
      when "011110000011000" =>  data <= "10100101";  -- 3C18 = A5
      when "011110000011001" =>  data <= "01110111";  -- 3C19 = 77
      when "011110000011010" =>  data <= "10100100";  -- 3C1A = A4
      when "011110000011011" =>  data <= "01111000";  -- 3C1B = 78
      when "011110000011100" =>  data <= "10000101";  -- 3C1C = 85
      when "011110000011101" =>  data <= "01001000";  -- 3C1D = 48
      when "011110000011110" =>  data <= "10000100";  -- 3C1E = 84
      when "011110000011111" =>  data <= "01001001";  -- 3C1F = 49
      when "011110000100000" =>  data <= "10100110";  -- 3C20 = A6
      when "011110000100001" =>  data <= "01000000";  -- 3C21 = 40
      when "011110000100010" =>  data <= "10100100";  -- 3C22 = A4
      when "011110000100011" =>  data <= "01000001";  -- 3C23 = 41
      when "011110000100100" =>  data <= "10000110";  -- 3C24 = 86
      when "011110000100101" =>  data <= "01110111";  -- 3C25 = 77
      when "011110000100110" =>  data <= "10000100";  -- 3C26 = 84
      when "011110000100111" =>  data <= "01111000";  -- 3C27 = 78
      when "011110000101000" =>  data <= "00100000";  -- 3C28 = 20
      when "011110000101001" =>  data <= "01110110";  -- 3C29 = 76
      when "011110000101010" =>  data <= "00000000";  -- 3C2A = 0
      when "011110000101011" =>  data <= "11010000";  -- 3C2B = D0
      when "011110000101100" =>  data <= "00100000";  -- 3C2C = 20
      when "011110000101101" =>  data <= "00100100";  -- 3C2D = 24
      when "011110000101110" =>  data <= "00001011";  -- 3C2E = B
      when "011110000101111" =>  data <= "01010000";  -- 3C2F = 50
      when "011110000110000" =>  data <= "00001100";  -- 3C30 = C
      when "011110000110001" =>  data <= "00100000";  -- 3C31 = 20
      when "011110000110010" =>  data <= "11100100";  -- 3C32 = E4
      when "011110000110011" =>  data <= "11111111";  -- 3C33 = FF
      when "011110000110100" =>  data <= "10001101";  -- 3C34 = 8D
      when "011110000110101" =>  data <= "00000000";  -- 3C35 = 0
      when "011110000110110" =>  data <= "00000010";  -- 3C36 = 2
      when "011110000110111" =>  data <= "10100010";  -- 3C37 = A2
      when "011110000111000" =>  data <= "11111111";  -- 3C38 = FF
      when "011110000111001" =>  data <= "10100000";  -- 3C39 = A0
      when "011110000111010" =>  data <= "00000001";  -- 3C3A = 1
      when "011110000111011" =>  data <= "11010000";  -- 3C3B = D0
      when "011110000111100" =>  data <= "00001100";  -- 3C3C = C
      when "011110000111101" =>  data <= "00110000";  -- 3C3D = 30
      when "011110000111110" =>  data <= "01110101";  -- 3C3E = 75
      when "011110000111111" =>  data <= "10100101";  -- 3C3F = A5
      when "011110001000000" =>  data <= "00010000";  -- 3C40 = 10
      when "011110001000001" =>  data <= "11010000";  -- 3C41 = D0
      when "011110001000010" =>  data <= "00000011";  -- 3C42 = 3
      when "011110001000011" =>  data <= "00100000";  -- 3C43 = 20
      when "011110001000100" =>  data <= "01000100";  -- 3C44 = 44
      when "011110001000101" =>  data <= "10111011";  -- 3C45 = BB
      when "011110001000110" =>  data <= "00100000";  -- 3C46 = 20
      when "011110001000111" =>  data <= "11110101";  -- 3C47 = F5
      when "011110001001000" =>  data <= "10111011";  -- 3C48 = BB
      when "011110001001001" =>  data <= "10000110";  -- 3C49 = 86
      when "011110001001010" =>  data <= "01110111";  -- 3C4A = 77
      when "011110001001011" =>  data <= "10000100";  -- 3C4B = 84
      when "011110001001100" =>  data <= "01111000";  -- 3C4C = 78
      when "011110001001101" =>  data <= "00100000";  -- 3C4D = 20
      when "011110001001110" =>  data <= "01110000";  -- 3C4E = 70
      when "011110001001111" =>  data <= "00000000";  -- 3C4F = 0
      when "011110001010000" =>  data <= "00100100";  -- 3C50 = 24
      when "011110001010001" =>  data <= "00000111";  -- 3C51 = 7
      when "011110001010010" =>  data <= "00010000";  -- 3C52 = 10
      when "011110001010011" =>  data <= "00110001";  -- 3C53 = 31
      when "011110001010100" =>  data <= "00100100";  -- 3C54 = 24
      when "011110001010101" =>  data <= "00001011";  -- 3C55 = B
      when "011110001010110" =>  data <= "01010000";  -- 3C56 = 50
      when "011110001010111" =>  data <= "00001001";  -- 3C57 = 9
      when "011110001011000" =>  data <= "11101000";  -- 3C58 = E8
      when "011110001011001" =>  data <= "10000110";  -- 3C59 = 86
      when "011110001011010" =>  data <= "01110111";  -- 3C5A = 77
      when "011110001011011" =>  data <= "10101001";  -- 3C5B = A9
      when "011110001011100" =>  data <= "00000000";  -- 3C5C = 0
      when "011110001011101" =>  data <= "10000101";  -- 3C5D = 85
      when "011110001011110" =>  data <= "00000011";  -- 3C5E = 3
      when "011110001011111" =>  data <= "11110000";  -- 3C5F = F0
      when "011110001100000" =>  data <= "00001100";  -- 3C60 = C
      when "011110001100001" =>  data <= "10000101";  -- 3C61 = 85
      when "011110001100010" =>  data <= "00000011";  -- 3C62 = 3
      when "011110001100011" =>  data <= "11001001";  -- 3C63 = C9
      when "011110001100100" =>  data <= "00100010";  -- 3C64 = 22
      when "011110001100101" =>  data <= "11110000";  -- 3C65 = F0
      when "011110001100110" =>  data <= "00000111";  -- 3C66 = 7
      when "011110001100111" =>  data <= "10101001";  -- 3C67 = A9
      when "011110001101000" =>  data <= "00111010";  -- 3C68 = 3A
      when "011110001101001" =>  data <= "10000101";  -- 3C69 = 85
      when "011110001101010" =>  data <= "00000011";  -- 3C6A = 3
      when "011110001101011" =>  data <= "10101001";  -- 3C6B = A9
      when "011110001101100" =>  data <= "00101100";  -- 3C6C = 2C
      when "011110001101101" =>  data <= "00011000";  -- 3C6D = 18
      when "011110001101110" =>  data <= "10000101";  -- 3C6E = 85
      when "011110001101111" =>  data <= "00000100";  -- 3C6F = 4
      when "011110001110000" =>  data <= "10100101";  -- 3C70 = A5
      when "011110001110001" =>  data <= "01110111";  -- 3C71 = 77
      when "011110001110010" =>  data <= "10100100";  -- 3C72 = A4
      when "011110001110011" =>  data <= "01111000";  -- 3C73 = 78
      when "011110001110100" =>  data <= "01101001";  -- 3C74 = 69
      when "011110001110101" =>  data <= "00000000";  -- 3C75 = 0
      when "011110001110110" =>  data <= "10010000";  -- 3C76 = 90
      when "011110001110111" =>  data <= "00000001";  -- 3C77 = 1
      when "011110001111000" =>  data <= "11001000";  -- 3C78 = C8
      when "011110001111001" =>  data <= "00100000";  -- 3C79 = 20
      when "011110001111010" =>  data <= "10110110";  -- 3C7A = B6
      when "011110001111011" =>  data <= "11000101";  -- 3C7B = C5
      when "011110001111100" =>  data <= "00100000";  -- 3C7C = 20
      when "011110001111101" =>  data <= "00011000";  -- 3C7D = 18
      when "011110001111110" =>  data <= "11001001";  -- 3C7E = C9
      when "011110001111111" =>  data <= "00100000";  -- 3C7F = 20
      when "011110010000000" =>  data <= "01100101";  -- 3C80 = 65
      when "011110010000001" =>  data <= "10111001";  -- 3C81 = B9
      when "011110010000010" =>  data <= "01001100";  -- 3C82 = 4C
      when "011110010000011" =>  data <= "10001101";  -- 3C83 = 8D
      when "011110010000100" =>  data <= "10111100";  -- 3C84 = BC
      when "011110010000101" =>  data <= "00100000";  -- 3C85 = 20
      when "011110010000110" =>  data <= "00101001";  -- 3C86 = 29
      when "011110010000111" =>  data <= "11001110";  -- 3C87 = CE
      when "011110010001000" =>  data <= "10100101";  -- 3C88 = A5
      when "011110010001001" =>  data <= "00001000";  -- 3C89 = 8
      when "011110010001010" =>  data <= "00100000";  -- 3C8A = 20
      when "011110010001011" =>  data <= "01001101";  -- 3C8B = 4D
      when "011110010001100" =>  data <= "10111001";  -- 3C8C = B9
      when "011110010001101" =>  data <= "00100000";  -- 3C8D = 20
      when "011110010001110" =>  data <= "01110110";  -- 3C8E = 76
      when "011110010001111" =>  data <= "00000000";  -- 3C8F = 0
      when "011110010010000" =>  data <= "11110000";  -- 3C90 = F0
      when "011110010010001" =>  data <= "00000111";  -- 3C91 = 7
      when "011110010010010" =>  data <= "11001001";  -- 3C92 = C9
      when "011110010010011" =>  data <= "00101100";  -- 3C93 = 2C
      when "011110010010100" =>  data <= "11110000";  -- 3C94 = F0
      when "011110010010101" =>  data <= "00000011";  -- 3C95 = 3
      when "011110010010110" =>  data <= "01001100";  -- 3C96 = 4C
      when "011110010010111" =>  data <= "01001100";  -- 3C97 = 4C
      when "011110010011000" =>  data <= "10111011";  -- 3C98 = BB
      when "011110010011001" =>  data <= "10100101";  -- 3C99 = A5
      when "011110010011010" =>  data <= "01110111";  -- 3C9A = 77
      when "011110010011011" =>  data <= "10100100";  -- 3C9B = A4
      when "011110010011100" =>  data <= "01111000";  -- 3C9C = 78
      when "011110010011101" =>  data <= "10000101";  -- 3C9D = 85
      when "011110010011110" =>  data <= "01000000";  -- 3C9E = 40
      when "011110010011111" =>  data <= "10000100";  -- 3C9F = 84
      when "011110010100000" =>  data <= "01000001";  -- 3CA0 = 41
      when "011110010100001" =>  data <= "10100101";  -- 3CA1 = A5
      when "011110010100010" =>  data <= "01001000";  -- 3CA2 = 48
      when "011110010100011" =>  data <= "10100100";  -- 3CA3 = A4
      when "011110010100100" =>  data <= "01001001";  -- 3CA4 = 49
      when "011110010100101" =>  data <= "10000101";  -- 3CA5 = 85
      when "011110010100110" =>  data <= "01110111";  -- 3CA6 = 77
      when "011110010100111" =>  data <= "10000100";  -- 3CA7 = 84
      when "011110010101000" =>  data <= "01111000";  -- 3CA8 = 78
      when "011110010101001" =>  data <= "00100000";  -- 3CA9 = 20
      when "011110010101010" =>  data <= "01110110";  -- 3CAA = 76
      when "011110010101011" =>  data <= "00000000";  -- 3CAB = 0
      when "011110010101100" =>  data <= "11110000";  -- 3CAC = F0
      when "011110010101101" =>  data <= "00101100";  -- 3CAD = 2C
      when "011110010101110" =>  data <= "00100000";  -- 3CAE = 20
      when "011110010101111" =>  data <= "11110101";  -- 3CAF = F5
      when "011110010110000" =>  data <= "10111110";  -- 3CB0 = BE
      when "011110010110001" =>  data <= "01001100";  -- 3CB1 = 4C
      when "011110010110010" =>  data <= "00010001";  -- 3CB2 = 11
      when "011110010110011" =>  data <= "10111100";  -- 3CB3 = BC
      when "011110010110100" =>  data <= "00100000";  -- 3CB4 = 20
      when "011110010110101" =>  data <= "10010001";  -- 3CB5 = 91
      when "011110010110110" =>  data <= "10111000";  -- 3CB6 = B8
      when "011110010110111" =>  data <= "11001000";  -- 3CB7 = C8
      when "011110010111000" =>  data <= "10101010";  -- 3CB8 = AA
      when "011110010111001" =>  data <= "11010000";  -- 3CB9 = D0
      when "011110010111010" =>  data <= "00010010";  -- 3CBA = 12
      when "011110010111011" =>  data <= "10100010";  -- 3CBB = A2
      when "011110010111100" =>  data <= "00101010";  -- 3CBC = 2A
      when "011110010111101" =>  data <= "11001000";  -- 3CBD = C8
      when "011110010111110" =>  data <= "10110001";  -- 3CBE = B1
      when "011110010111111" =>  data <= "01110111";  -- 3CBF = 77
      when "011110011000000" =>  data <= "11110000";  -- 3CC0 = F0
      when "011110011000001" =>  data <= "01101011";  -- 3CC1 = 6B
      when "011110011000010" =>  data <= "11001000";  -- 3CC2 = C8
      when "011110011000011" =>  data <= "10110001";  -- 3CC3 = B1
      when "011110011000100" =>  data <= "01110111";  -- 3CC4 = 77
      when "011110011000101" =>  data <= "10000101";  -- 3CC5 = 85
      when "011110011000110" =>  data <= "00111100";  -- 3CC6 = 3C
      when "011110011000111" =>  data <= "11001000";  -- 3CC7 = C8
      when "011110011001000" =>  data <= "10110001";  -- 3CC8 = B1
      when "011110011001001" =>  data <= "01110111";  -- 3CC9 = 77
      when "011110011001010" =>  data <= "11001000";  -- 3CCA = C8
      when "011110011001011" =>  data <= "10000101";  -- 3CCB = 85
      when "011110011001100" =>  data <= "00111101";  -- 3CCC = 3D
      when "011110011001101" =>  data <= "10110001";  -- 3CCD = B1
      when "011110011001110" =>  data <= "01110111";  -- 3CCE = 77
      when "011110011001111" =>  data <= "10101010";  -- 3CCF = AA
      when "011110011010000" =>  data <= "00100000";  -- 3CD0 = 20
      when "011110011010001" =>  data <= "10000110";  -- 3CD1 = 86
      when "011110011010010" =>  data <= "10111000";  -- 3CD2 = B8
      when "011110011010011" =>  data <= "11100000";  -- 3CD3 = E0
      when "011110011010100" =>  data <= "10000011";  -- 3CD4 = 83
      when "011110011010101" =>  data <= "11010000";  -- 3CD5 = D0
      when "011110011010110" =>  data <= "11011101";  -- 3CD6 = DD
      when "011110011010111" =>  data <= "01001100";  -- 3CD7 = 4C
      when "011110011011000" =>  data <= "01001101";  -- 3CD8 = 4D
      when "011110011011001" =>  data <= "10111100";  -- 3CD9 = BC
      when "011110011011010" =>  data <= "10100101";  -- 3CDA = A5
      when "011110011011011" =>  data <= "01000000";  -- 3CDB = 40
      when "011110011011100" =>  data <= "10100100";  -- 3CDC = A4
      when "011110011011101" =>  data <= "01000001";  -- 3CDD = 41
      when "011110011011110" =>  data <= "10100110";  -- 3CDE = A6
      when "011110011011111" =>  data <= "00001011";  -- 3CDF = B
      when "011110011100000" =>  data <= "00010000";  -- 3CE0 = 10
      when "011110011100001" =>  data <= "00000011";  -- 3CE1 = 3
      when "011110011100010" =>  data <= "01001100";  -- 3CE2 = 4C
      when "011110011100011" =>  data <= "11000001";  -- 3CE3 = C1
      when "011110011100100" =>  data <= "10110111";  -- 3CE4 = B7
      when "011110011100101" =>  data <= "10100000";  -- 3CE5 = A0
      when "011110011100110" =>  data <= "00000000";  -- 3CE6 = 0
      when "011110011100111" =>  data <= "10110001";  -- 3CE7 = B1
      when "011110011101000" =>  data <= "01000000";  -- 3CE8 = 40
      when "011110011101001" =>  data <= "11110000";  -- 3CE9 = F0
      when "011110011101010" =>  data <= "00001011";  -- 3CEA = B
      when "011110011101011" =>  data <= "10100101";  -- 3CEB = A5
      when "011110011101100" =>  data <= "00010000";  -- 3CEC = 10
      when "011110011101101" =>  data <= "11010000";  -- 3CED = D0
      when "011110011101110" =>  data <= "00000111";  -- 3CEE = 7
      when "011110011101111" =>  data <= "10101001";  -- 3CEF = A9
      when "011110011110000" =>  data <= "11110111";  -- 3CF0 = F7
      when "011110011110001" =>  data <= "10100000";  -- 3CF1 = A0
      when "011110011110010" =>  data <= "10111100";  -- 3CF2 = BC
      when "011110011110011" =>  data <= "01001100";  -- 3CF3 = 4C
      when "011110011110100" =>  data <= "00011101";  -- 3CF4 = 1D
      when "011110011110101" =>  data <= "10111011";  -- 3CF5 = BB
      when "011110011110110" =>  data <= "01100000";  -- 3CF6 = 60
      when "011110011110111" =>  data <= "00111111";  -- 3CF7 = 3F
      when "011110011111000" =>  data <= "01000101";  -- 3CF8 = 45
      when "011110011111001" =>  data <= "01011000";  -- 3CF9 = 58
      when "011110011111010" =>  data <= "01010100";  -- 3CFA = 54
      when "011110011111011" =>  data <= "01010010";  -- 3CFB = 52
      when "011110011111100" =>  data <= "01000001";  -- 3CFC = 41
      when "011110011111101" =>  data <= "00100000";  -- 3CFD = 20
      when "011110011111110" =>  data <= "01001001";  -- 3CFE = 49
      when "011110011111111" =>  data <= "01000111";  -- 3CFF = 47
      when "011110100000000" =>  data <= "01001110";  -- 3D00 = 4E
      when "011110100000001" =>  data <= "01001111";  -- 3D01 = 4F
      when "011110100000010" =>  data <= "01010010";  -- 3D02 = 52
      when "011110100000011" =>  data <= "01000101";  -- 3D03 = 45
      when "011110100000100" =>  data <= "01000100";  -- 3D04 = 44
      when "011110100000101" =>  data <= "00001101";  -- 3D05 = D
      when "011110100000110" =>  data <= "00000000";  -- 3D06 = 0
      when "011110100000111" =>  data <= "00111111";  -- 3D07 = 3F
      when "011110100001000" =>  data <= "01010010";  -- 3D08 = 52
      when "011110100001001" =>  data <= "01000101";  -- 3D09 = 45
      when "011110100001010" =>  data <= "01000100";  -- 3D0A = 44
      when "011110100001011" =>  data <= "01001111";  -- 3D0B = 4F
      when "011110100001100" =>  data <= "00100000";  -- 3D0C = 20
      when "011110100001101" =>  data <= "01000110";  -- 3D0D = 46
      when "011110100001110" =>  data <= "01010010";  -- 3D0E = 52
      when "011110100001111" =>  data <= "01001111";  -- 3D0F = 4F
      when "011110100010000" =>  data <= "01001101";  -- 3D10 = 4D
      when "011110100010001" =>  data <= "00100000";  -- 3D11 = 20
      when "011110100010010" =>  data <= "01010011";  -- 3D12 = 53
      when "011110100010011" =>  data <= "01010100";  -- 3D13 = 54
      when "011110100010100" =>  data <= "01000001";  -- 3D14 = 41
      when "011110100010101" =>  data <= "01010010";  -- 3D15 = 52
      when "011110100010110" =>  data <= "01010100";  -- 3D16 = 54
      when "011110100010111" =>  data <= "00001101";  -- 3D17 = D
      when "011110100011000" =>  data <= "00000000";  -- 3D18 = 0
      when "011110100011001" =>  data <= "11010000";  -- 3D19 = D0
      when "011110100011010" =>  data <= "00000100";  -- 3D1A = 4
      when "011110100011011" =>  data <= "10100000";  -- 3D1B = A0
      when "011110100011100" =>  data <= "00000000";  -- 3D1C = 0
      when "011110100011101" =>  data <= "11110000";  -- 3D1D = F0
      when "011110100011110" =>  data <= "00000011";  -- 3D1E = 3
      when "011110100011111" =>  data <= "00100000";  -- 3D1F = 20
      when "011110100100000" =>  data <= "00101011";  -- 3D20 = 2B
      when "011110100100001" =>  data <= "11000001";  -- 3D21 = C1
      when "011110100100010" =>  data <= "10000101";  -- 3D22 = 85
      when "011110100100011" =>  data <= "01000110";  -- 3D23 = 46
      when "011110100100100" =>  data <= "10000100";  -- 3D24 = 84
      when "011110100100101" =>  data <= "01000111";  -- 3D25 = 47
      when "011110100100110" =>  data <= "00100000";  -- 3D26 = 20
      when "011110100100111" =>  data <= "00100010";  -- 3D27 = 22
      when "011110100101000" =>  data <= "10110011";  -- 3D28 = B3
      when "011110100101001" =>  data <= "11110000";  -- 3D29 = F0
      when "011110100101010" =>  data <= "00000100";  -- 3D2A = 4
      when "011110100101011" =>  data <= "10100010";  -- 3D2B = A2
      when "011110100101100" =>  data <= "00000000";  -- 3D2C = 0
      when "011110100101101" =>  data <= "11110000";  -- 3D2D = F0
      when "011110100101110" =>  data <= "01100110";  -- 3D2E = 66
      when "011110100101111" =>  data <= "10011010";  -- 3D2F = 9A
      when "011110100110000" =>  data <= "10001010";  -- 3D30 = 8A
      when "011110100110001" =>  data <= "00011000";  -- 3D31 = 18
      when "011110100110010" =>  data <= "01101001";  -- 3D32 = 69
      when "011110100110011" =>  data <= "00000100";  -- 3D33 = 4
      when "011110100110100" =>  data <= "01001000";  -- 3D34 = 48
      when "011110100110101" =>  data <= "01101001";  -- 3D35 = 69
      when "011110100110110" =>  data <= "00000110";  -- 3D36 = 6
      when "011110100110111" =>  data <= "10000101";  -- 3D37 = 85
      when "011110100111000" =>  data <= "00100001";  -- 3D38 = 21
      when "011110100111001" =>  data <= "01101000";  -- 3D39 = 68
      when "011110100111010" =>  data <= "10100000";  -- 3D3A = A0
      when "011110100111011" =>  data <= "00000001";  -- 3D3B = 1
      when "011110100111100" =>  data <= "00100000";  -- 3D3C = 20
      when "011110100111101" =>  data <= "11011000";  -- 3D3D = D8
      when "011110100111110" =>  data <= "11001100";  -- 3D3E = CC
      when "011110100111111" =>  data <= "10111010";  -- 3D3F = BA
      when "011110101000000" =>  data <= "10111101";  -- 3D40 = BD
      when "011110101000001" =>  data <= "00001001";  -- 3D41 = 9
      when "011110101000010" =>  data <= "00000001";  -- 3D42 = 1
      when "011110101000011" =>  data <= "10000101";  -- 3D43 = 85
      when "011110101000100" =>  data <= "01100011";  -- 3D44 = 63
      when "011110101000101" =>  data <= "10100101";  -- 3D45 = A5
      when "011110101000110" =>  data <= "01000110";  -- 3D46 = 46
      when "011110101000111" =>  data <= "10100100";  -- 3D47 = A4
      when "011110101001000" =>  data <= "01000111";  -- 3D48 = 47
      when "011110101001001" =>  data <= "00100000";  -- 3D49 = 20
      when "011110101001010" =>  data <= "10011101";  -- 3D4A = 9D
      when "011110101001011" =>  data <= "11001001";  -- 3D4B = C9
      when "011110101001100" =>  data <= "00100000";  -- 3D4C = 20
      when "011110101001101" =>  data <= "00000110";  -- 3D4D = 6
      when "011110101001110" =>  data <= "11001101";  -- 3D4E = CD
      when "011110101001111" =>  data <= "10100000";  -- 3D4F = A0
      when "011110101010000" =>  data <= "00000001";  -- 3D50 = 1
      when "011110101010001" =>  data <= "00100000";  -- 3D51 = 20
      when "011110101010010" =>  data <= "10010011";  -- 3D52 = 93
      when "011110101010011" =>  data <= "11001101";  -- 3D53 = CD
      when "011110101010100" =>  data <= "10111010";  -- 3D54 = BA
      when "011110101010101" =>  data <= "00111000";  -- 3D55 = 38
      when "011110101010110" =>  data <= "11111101";  -- 3D56 = FD
      when "011110101010111" =>  data <= "00001001";  -- 3D57 = 9
      when "011110101011000" =>  data <= "00000001";  -- 3D58 = 1
      when "011110101011001" =>  data <= "11110000";  -- 3D59 = F0
      when "011110101011010" =>  data <= "00010111";  -- 3D5A = 17
      when "011110101011011" =>  data <= "10111101";  -- 3D5B = BD
      when "011110101011100" =>  data <= "00001111";  -- 3D5C = F
      when "011110101011101" =>  data <= "00000001";  -- 3D5D = 1
      when "011110101011110" =>  data <= "10000101";  -- 3D5E = 85
      when "011110101011111" =>  data <= "00110110";  -- 3D5F = 36
      when "011110101100000" =>  data <= "10111101";  -- 3D60 = BD
      when "011110101100001" =>  data <= "00010000";  -- 3D61 = 10
      when "011110101100010" =>  data <= "00000001";  -- 3D62 = 1
      when "011110101100011" =>  data <= "10000101";  -- 3D63 = 85
      when "011110101100100" =>  data <= "00110111";  -- 3D64 = 37
      when "011110101100101" =>  data <= "10111101";  -- 3D65 = BD
      when "011110101100110" =>  data <= "00010010";  -- 3D66 = 12
      when "011110101100111" =>  data <= "00000001";  -- 3D67 = 1
      when "011110101101000" =>  data <= "10000101";  -- 3D68 = 85
      when "011110101101001" =>  data <= "01110111";  -- 3D69 = 77
      when "011110101101010" =>  data <= "10111101";  -- 3D6A = BD
      when "011110101101011" =>  data <= "00010001";  -- 3D6B = 11
      when "011110101101100" =>  data <= "00000001";  -- 3D6C = 1
      when "011110101101101" =>  data <= "10000101";  -- 3D6D = 85
      when "011110101101110" =>  data <= "01111000";  -- 3D6E = 78
      when "011110101101111" =>  data <= "01001100";  -- 3D6F = 4C
      when "011110101110000" =>  data <= "01001010";  -- 3D70 = 4A
      when "011110101110001" =>  data <= "10110111";  -- 3D71 = B7
      when "011110101110010" =>  data <= "10001010";  -- 3D72 = 8A
      when "011110101110011" =>  data <= "01101001";  -- 3D73 = 69
      when "011110101110100" =>  data <= "00010001";  -- 3D74 = 11
      when "011110101110101" =>  data <= "10101010";  -- 3D75 = AA
      when "011110101110110" =>  data <= "10011010";  -- 3D76 = 9A
      when "011110101110111" =>  data <= "00100000";  -- 3D77 = 20
      when "011110101111000" =>  data <= "01110110";  -- 3D78 = 76
      when "011110101111001" =>  data <= "00000000";  -- 3D79 = 0
      when "011110101111010" =>  data <= "11001001";  -- 3D7A = C9
      when "011110101111011" =>  data <= "00101100";  -- 3D7B = 2C
      when "011110101111100" =>  data <= "11010000";  -- 3D7C = D0
      when "011110101111101" =>  data <= "11110001";  -- 3D7D = F1
      when "011110101111110" =>  data <= "00100000";  -- 3D7E = 20
      when "011110101111111" =>  data <= "01110000";  -- 3D7F = 70
      when "011110110000000" =>  data <= "00000000";  -- 3D80 = 0
      when "011110110000001" =>  data <= "00100000";  -- 3D81 = 20
      when "011110110000010" =>  data <= "00011111";  -- 3D82 = 1F
      when "011110110000011" =>  data <= "10111101";  -- 3D83 = BD
      when "011110110000100" =>  data <= "00100000";  -- 3D84 = 20
      when "011110110000101" =>  data <= "10011000";  -- 3D85 = 98
      when "011110110000110" =>  data <= "10111101";  -- 3D86 = BD
      when "011110110000111" =>  data <= "00011000";  -- 3D87 = 18
      when "011110110001000" =>  data <= "00100100";  -- 3D88 = 24
      when "011110110001001" =>  data <= "00111000";  -- 3D89 = 38
      when "011110110001010" =>  data <= "00100100";  -- 3D8A = 24
      when "011110110001011" =>  data <= "00000111";  -- 3D8B = 7
      when "011110110001100" =>  data <= "00110000";  -- 3D8C = 30
      when "011110110001101" =>  data <= "00000011";  -- 3D8D = 3
      when "011110110001110" =>  data <= "10110000";  -- 3D8E = B0
      when "011110110001111" =>  data <= "00000011";  -- 3D8F = 3
      when "011110110010000" =>  data <= "01100000";  -- 3D90 = 60
      when "011110110010001" =>  data <= "10110000";  -- 3D91 = B0
      when "011110110010010" =>  data <= "11111101";  -- 3D92 = FD
      when "011110110010011" =>  data <= "10100010";  -- 3D93 = A2
      when "011110110010100" =>  data <= "10100011";  -- 3D94 = A3
      when "011110110010101" =>  data <= "01001100";  -- 3D95 = 4C
      when "011110110010110" =>  data <= "11001111";  -- 3D96 = CF
      when "011110110010111" =>  data <= "10110011";  -- 3D97 = B3
      when "011110110011000" =>  data <= "10100110";  -- 3D98 = A6
      when "011110110011001" =>  data <= "01110111";  -- 3D99 = 77
      when "011110110011010" =>  data <= "11010000";  -- 3D9A = D0
      when "011110110011011" =>  data <= "00000010";  -- 3D9B = 2
      when "011110110011100" =>  data <= "11000110";  -- 3D9C = C6
      when "011110110011101" =>  data <= "01111000";  -- 3D9D = 78
      when "011110110011110" =>  data <= "11000110";  -- 3D9E = C6
      when "011110110011111" =>  data <= "01110111";  -- 3D9F = 77
      when "011110110100000" =>  data <= "10100010";  -- 3DA0 = A2
      when "011110110100001" =>  data <= "00000000";  -- 3DA1 = 0
      when "011110110100010" =>  data <= "00100100";  -- 3DA2 = 24
      when "011110110100011" =>  data <= "01001000";  -- 3DA3 = 48
      when "011110110100100" =>  data <= "10001010";  -- 3DA4 = 8A
      when "011110110100101" =>  data <= "01001000";  -- 3DA5 = 48
      when "011110110100110" =>  data <= "10101001";  -- 3DA6 = A9
      when "011110110100111" =>  data <= "00000001";  -- 3DA7 = 1
      when "011110110101000" =>  data <= "00100000";  -- 3DA8 = 20
      when "011110110101001" =>  data <= "10010011";  -- 3DA9 = 93
      when "011110110101010" =>  data <= "10110011";  -- 3DAA = B3
      when "011110110101011" =>  data <= "00100000";  -- 3DAB = 20
      when "011110110101100" =>  data <= "10000001";  -- 3DAC = 81
      when "011110110101101" =>  data <= "10111110";  -- 3DAD = BE
      when "011110110101110" =>  data <= "10101001";  -- 3DAE = A9
      when "011110110101111" =>  data <= "00000000";  -- 3DAF = 0
      when "011110110110000" =>  data <= "10000101";  -- 3DB0 = 85
      when "011110110110001" =>  data <= "01001010";  -- 3DB1 = 4A
      when "011110110110010" =>  data <= "00100000";  -- 3DB2 = 20
      when "011110110110011" =>  data <= "01110110";  -- 3DB3 = 76
      when "011110110110100" =>  data <= "00000000";  -- 3DB4 = 0
      when "011110110110101" =>  data <= "00111000";  -- 3DB5 = 38
      when "011110110110110" =>  data <= "11101001";  -- 3DB6 = E9
      when "011110110110111" =>  data <= "10110001";  -- 3DB7 = B1
      when "011110110111000" =>  data <= "10010000";  -- 3DB8 = 90
      when "011110110111001" =>  data <= "00010111";  -- 3DB9 = 17
      when "011110110111010" =>  data <= "11001001";  -- 3DBA = C9
      when "011110110111011" =>  data <= "00000011";  -- 3DBB = 3
      when "011110110111100" =>  data <= "10110000";  -- 3DBC = B0
      when "011110110111101" =>  data <= "00010011";  -- 3DBD = 13
      when "011110110111110" =>  data <= "11001001";  -- 3DBE = C9
      when "011110110111111" =>  data <= "00000001";  -- 3DBF = 1
      when "011110111000000" =>  data <= "00101010";  -- 3DC0 = 2A
      when "011110111000001" =>  data <= "01001001";  -- 3DC1 = 49
      when "011110111000010" =>  data <= "00000001";  -- 3DC2 = 1
      when "011110111000011" =>  data <= "01000101";  -- 3DC3 = 45
      when "011110111000100" =>  data <= "01001010";  -- 3DC4 = 4A
      when "011110111000101" =>  data <= "11000101";  -- 3DC5 = C5
      when "011110111000110" =>  data <= "01001010";  -- 3DC6 = 4A
      when "011110111000111" =>  data <= "10010000";  -- 3DC7 = 90
      when "011110111001000" =>  data <= "01100001";  -- 3DC8 = 61
      when "011110111001001" =>  data <= "10000101";  -- 3DC9 = 85
      when "011110111001010" =>  data <= "01001010";  -- 3DCA = 4A
      when "011110111001011" =>  data <= "00100000";  -- 3DCB = 20
      when "011110111001100" =>  data <= "01110000";  -- 3DCC = 70
      when "011110111001101" =>  data <= "00000000";  -- 3DCD = 0
      when "011110111001110" =>  data <= "01001100";  -- 3DCE = 4C
      when "011110111001111" =>  data <= "10110101";  -- 3DCF = B5
      when "011110111010000" =>  data <= "10111101";  -- 3DD0 = BD
      when "011110111010001" =>  data <= "10100110";  -- 3DD1 = A6
      when "011110111010010" =>  data <= "01001010";  -- 3DD2 = 4A
      when "011110111010011" =>  data <= "11010000";  -- 3DD3 = D0
      when "011110111010100" =>  data <= "00101100";  -- 3DD4 = 2C
      when "011110111010101" =>  data <= "10110000";  -- 3DD5 = B0
      when "011110111010110" =>  data <= "01111111";  -- 3DD6 = 7F
      when "011110111010111" =>  data <= "01101001";  -- 3DD7 = 69
      when "011110111011000" =>  data <= "00000111";  -- 3DD8 = 7
      when "011110111011001" =>  data <= "10010000";  -- 3DD9 = 90
      when "011110111011010" =>  data <= "01111011";  -- 3DDA = 7B
      when "011110111011011" =>  data <= "01100101";  -- 3DDB = 65
      when "011110111011100" =>  data <= "00000111";  -- 3DDC = 7
      when "011110111011101" =>  data <= "11010000";  -- 3DDD = D0
      when "011110111011110" =>  data <= "00000011";  -- 3DDE = 3
      when "011110111011111" =>  data <= "01001100";  -- 3DDF = 4C
      when "011110111100000" =>  data <= "01001111";  -- 3DE0 = 4F
      when "011110111100001" =>  data <= "11000111";  -- 3DE1 = C7
      when "011110111100010" =>  data <= "01101001";  -- 3DE2 = 69
      when "011110111100011" =>  data <= "11111111";  -- 3DE3 = FF
      when "011110111100100" =>  data <= "10000101";  -- 3DE4 = 85
      when "011110111100101" =>  data <= "00011111";  -- 3DE5 = 1F
      when "011110111100110" =>  data <= "00001010";  -- 3DE6 = A
      when "011110111100111" =>  data <= "01100101";  -- 3DE7 = 65
      when "011110111101000" =>  data <= "00011111";  -- 3DE8 = 1F
      when "011110111101001" =>  data <= "10101000";  -- 3DE9 = A8
      when "011110111101010" =>  data <= "01101000";  -- 3DEA = 68
      when "011110111101011" =>  data <= "11011001";  -- 3DEB = D9
      when "011110111101100" =>  data <= "10010100";  -- 3DEC = 94
      when "011110111101101" =>  data <= "10110000";  -- 3DED = B0
      when "011110111101110" =>  data <= "10110000";  -- 3DEE = B0
      when "011110111101111" =>  data <= "01101011";  -- 3DEF = 6B
      when "011110111110000" =>  data <= "00100000";  -- 3DF0 = 20
      when "011110111110001" =>  data <= "10000111";  -- 3DF1 = 87
      when "011110111110010" =>  data <= "10111101";  -- 3DF2 = BD
      when "011110111110011" =>  data <= "01001000";  -- 3DF3 = 48
      when "011110111110100" =>  data <= "00100000";  -- 3DF4 = 20
      when "011110111110101" =>  data <= "00011010";  -- 3DF5 = 1A
      when "011110111110110" =>  data <= "10111110";  -- 3DF6 = BE
      when "011110111110111" =>  data <= "01101000";  -- 3DF7 = 68
      when "011110111111000" =>  data <= "10100100";  -- 3DF8 = A4
      when "011110111111001" =>  data <= "01001000";  -- 3DF9 = 48
      when "011110111111010" =>  data <= "00010000";  -- 3DFA = 10
      when "011110111111011" =>  data <= "00010111";  -- 3DFB = 17
      when "011110111111100" =>  data <= "10101010";  -- 3DFC = AA
      when "011110111111101" =>  data <= "11110000";  -- 3DFD = F0
      when "011110111111110" =>  data <= "01011010";  -- 3DFE = 5A
      when "011110111111111" =>  data <= "11010000";  -- 3DFF = D0
      when "011111000000000" =>  data <= "01100011";  -- 3E00 = 63
      when "011111000000001" =>  data <= "01000110";  -- 3E01 = 46
      when "011111000000010" =>  data <= "00000111";  -- 3E02 = 7
      when "011111000000011" =>  data <= "10001010";  -- 3E03 = 8A
      when "011111000000100" =>  data <= "00101010";  -- 3E04 = 2A
      when "011111000000101" =>  data <= "10100110";  -- 3E05 = A6
      when "011111000000110" =>  data <= "01110111";  -- 3E06 = 77
      when "011111000000111" =>  data <= "11010000";  -- 3E07 = D0
      when "011111000001000" =>  data <= "00000010";  -- 3E08 = 2
      when "011111000001001" =>  data <= "11000110";  -- 3E09 = C6
      when "011111000001010" =>  data <= "01111000";  -- 3E0A = 78
      when "011111000001011" =>  data <= "11000110";  -- 3E0B = C6
      when "011111000001100" =>  data <= "01110111";  -- 3E0C = 77
      when "011111000001101" =>  data <= "10100000";  -- 3E0D = A0
      when "011111000001110" =>  data <= "00011011";  -- 3E0E = 1B
      when "011111000001111" =>  data <= "10000101";  -- 3E0F = 85
      when "011111000010000" =>  data <= "01001010";  -- 3E10 = 4A
      when "011111000010001" =>  data <= "11010000";  -- 3E11 = D0
      when "011111000010010" =>  data <= "11010111";  -- 3E12 = D7
      when "011111000010011" =>  data <= "11011001";  -- 3E13 = D9
      when "011111000010100" =>  data <= "10010100";  -- 3E14 = 94
      when "011111000010101" =>  data <= "10110000";  -- 3E15 = B0
      when "011111000010110" =>  data <= "10110000";  -- 3E16 = B0
      when "011111000010111" =>  data <= "01001100";  -- 3E17 = 4C
      when "011111000011000" =>  data <= "10010000";  -- 3E18 = 90
      when "011111000011001" =>  data <= "11011001";  -- 3E19 = D9
      when "011111000011010" =>  data <= "10111001";  -- 3E1A = B9
      when "011111000011011" =>  data <= "10010110";  -- 3E1B = 96
      when "011111000011100" =>  data <= "10110000";  -- 3E1C = B0
      when "011111000011101" =>  data <= "01001000";  -- 3E1D = 48
      when "011111000011110" =>  data <= "10111001";  -- 3E1E = B9
      when "011111000011111" =>  data <= "10010101";  -- 3E1F = 95
      when "011111000100000" =>  data <= "10110000";  -- 3E20 = B0
      when "011111000100001" =>  data <= "01001000";  -- 3E21 = 48
      when "011111000100010" =>  data <= "00100000";  -- 3E22 = 20
      when "011111000100011" =>  data <= "00101101";  -- 3E23 = 2D
      when "011111000100100" =>  data <= "10111110";  -- 3E24 = BE
      when "011111000100101" =>  data <= "10100101";  -- 3E25 = A5
      when "011111000100110" =>  data <= "01001010";  -- 3E26 = 4A
      when "011111000100111" =>  data <= "01001100";  -- 3E27 = 4C
      when "011111000101000" =>  data <= "10100011";  -- 3E28 = A3
      when "011111000101001" =>  data <= "10111101";  -- 3E29 = BD
      when "011111000101010" =>  data <= "01001100";  -- 3E2A = 4C
      when "011111000101011" =>  data <= "00000000";  -- 3E2B = 0
      when "011111000101100" =>  data <= "10111111";  -- 3E2C = BF
      when "011111000101101" =>  data <= "10100101";  -- 3E2D = A5
      when "011111000101110" =>  data <= "01100011";  -- 3E2E = 63
      when "011111000101111" =>  data <= "10111110";  -- 3E2F = BE
      when "011111000110000" =>  data <= "10010100";  -- 3E30 = 94
      when "011111000110001" =>  data <= "10110000";  -- 3E31 = B0
      when "011111000110010" =>  data <= "10101000";  -- 3E32 = A8
      when "011111000110011" =>  data <= "01101000";  -- 3E33 = 68
      when "011111000110100" =>  data <= "10000101";  -- 3E34 = 85
      when "011111000110101" =>  data <= "00011111";  -- 3E35 = 1F
      when "011111000110110" =>  data <= "01101000";  -- 3E36 = 68
      when "011111000110111" =>  data <= "10000101";  -- 3E37 = 85
      when "011111000111000" =>  data <= "00100000";  -- 3E38 = 20
      when "011111000111001" =>  data <= "10011000";  -- 3E39 = 98
      when "011111000111010" =>  data <= "01001000";  -- 3E3A = 48
      when "011111000111011" =>  data <= "11100110";  -- 3E3B = E6
      when "011111000111100" =>  data <= "00011111";  -- 3E3C = 1F
      when "011111000111101" =>  data <= "11010000";  -- 3E3D = D0
      when "011111000111110" =>  data <= "00000010";  -- 3E3E = 2
      when "011111000111111" =>  data <= "11100110";  -- 3E3F = E6
      when "011111001000000" =>  data <= "00100000";  -- 3E40 = 20
      when "011111001000001" =>  data <= "00100000";  -- 3E41 = 20
      when "011111001000010" =>  data <= "01010001";  -- 3E42 = 51
      when "011111001000011" =>  data <= "11001101";  -- 3E43 = CD
      when "011111001000100" =>  data <= "10100101";  -- 3E44 = A5
      when "011111001000101" =>  data <= "01100010";  -- 3E45 = 62
      when "011111001000110" =>  data <= "01001000";  -- 3E46 = 48
      when "011111001000111" =>  data <= "10100101";  -- 3E47 = A5
      when "011111001001000" =>  data <= "01100001";  -- 3E48 = 61
      when "011111001001001" =>  data <= "01001000";  -- 3E49 = 48
      when "011111001001010" =>  data <= "10100101";  -- 3E4A = A5
      when "011111001001011" =>  data <= "01100000";  -- 3E4B = 60
      when "011111001001100" =>  data <= "01001000";  -- 3E4C = 48
      when "011111001001101" =>  data <= "10100101";  -- 3E4D = A5
      when "011111001001110" =>  data <= "01011111";  -- 3E4E = 5F
      when "011111001001111" =>  data <= "01001000";  -- 3E4F = 48
      when "011111001010000" =>  data <= "10100101";  -- 3E50 = A5
      when "011111001010001" =>  data <= "01011110";  -- 3E51 = 5E
      when "011111001010010" =>  data <= "01001000";  -- 3E52 = 48
      when "011111001010011" =>  data <= "01101100";  -- 3E53 = 6C
      when "011111001010100" =>  data <= "00011111";  -- 3E54 = 1F
      when "011111001010101" =>  data <= "00000000";  -- 3E55 = 0
      when "011111001010110" =>  data <= "10100000";  -- 3E56 = A0
      when "011111001010111" =>  data <= "11111111";  -- 3E57 = FF
      when "011111001011000" =>  data <= "01101000";  -- 3E58 = 68
      when "011111001011001" =>  data <= "11110000";  -- 3E59 = F0
      when "011111001011010" =>  data <= "00100011";  -- 3E5A = 23
      when "011111001011011" =>  data <= "11001001";  -- 3E5B = C9
      when "011111001011100" =>  data <= "01100100";  -- 3E5C = 64
      when "011111001011101" =>  data <= "11110000";  -- 3E5D = F0
      when "011111001011110" =>  data <= "00000011";  -- 3E5E = 3
      when "011111001011111" =>  data <= "00100000";  -- 3E5F = 20
      when "011111001100000" =>  data <= "10000111";  -- 3E60 = 87
      when "011111001100001" =>  data <= "10111101";  -- 3E61 = BD
      when "011111001100010" =>  data <= "10000100";  -- 3E62 = 84
      when "011111001100011" =>  data <= "01001000";  -- 3E63 = 48
      when "011111001100100" =>  data <= "01101000";  -- 3E64 = 68
      when "011111001100101" =>  data <= "01001010";  -- 3E65 = 4A
      when "011111001100110" =>  data <= "10000101";  -- 3E66 = 85
      when "011111001100111" =>  data <= "00001100";  -- 3E67 = C
      when "011111001101000" =>  data <= "01101000";  -- 3E68 = 68
      when "011111001101001" =>  data <= "10000101";  -- 3E69 = 85
      when "011111001101010" =>  data <= "01100110";  -- 3E6A = 66
      when "011111001101011" =>  data <= "01101000";  -- 3E6B = 68
      when "011111001101100" =>  data <= "10000101";  -- 3E6C = 85
      when "011111001101101" =>  data <= "01100111";  -- 3E6D = 67
      when "011111001101110" =>  data <= "01101000";  -- 3E6E = 68
      when "011111001101111" =>  data <= "10000101";  -- 3E6F = 85
      when "011111001110000" =>  data <= "01101000";  -- 3E70 = 68
      when "011111001110001" =>  data <= "01101000";  -- 3E71 = 68
      when "011111001110010" =>  data <= "10000101";  -- 3E72 = 85
      when "011111001110011" =>  data <= "01101001";  -- 3E73 = 69
      when "011111001110100" =>  data <= "01101000";  -- 3E74 = 68
      when "011111001110101" =>  data <= "10000101";  -- 3E75 = 85
      when "011111001110110" =>  data <= "01101010";  -- 3E76 = 6A
      when "011111001110111" =>  data <= "01101000";  -- 3E77 = 68
      when "011111001111000" =>  data <= "10000101";  -- 3E78 = 85
      when "011111001111001" =>  data <= "01101011";  -- 3E79 = 6B
      when "011111001111010" =>  data <= "01000101";  -- 3E7A = 45
      when "011111001111011" =>  data <= "01100011";  -- 3E7B = 63
      when "011111001111100" =>  data <= "10000101";  -- 3E7C = 85
      when "011111001111101" =>  data <= "01101100";  -- 3E7D = 6C
      when "011111001111110" =>  data <= "10100101";  -- 3E7E = A5
      when "011111001111111" =>  data <= "01011110";  -- 3E7F = 5E
      when "011111010000000" =>  data <= "01100000";  -- 3E80 = 60
      when "011111010000001" =>  data <= "10101001";  -- 3E81 = A9
      when "011111010000010" =>  data <= "00000000";  -- 3E82 = 0
      when "011111010000011" =>  data <= "10000101";  -- 3E83 = 85
      when "011111010000100" =>  data <= "00000111";  -- 3E84 = 7
      when "011111010000101" =>  data <= "00100000";  -- 3E85 = 20
      when "011111010000110" =>  data <= "01110000";  -- 3E86 = 70
      when "011111010000111" =>  data <= "00000000";  -- 3E87 = 0
      when "011111010001000" =>  data <= "10110000";  -- 3E88 = B0
      when "011111010001001" =>  data <= "00000011";  -- 3E89 = 3
      when "011111010001010" =>  data <= "01001100";  -- 3E8A = 4C
      when "011111010001011" =>  data <= "00101001";  -- 3E8B = 29
      when "011111010001100" =>  data <= "11001110";  -- 3E8C = CE
      when "011111010001101" =>  data <= "00100000";  -- 3E8D = 20
      when "011111010001110" =>  data <= "10110110";  -- 3E8E = B6
      when "011111010001111" =>  data <= "11000001";  -- 3E8F = C1
      when "011111010010000" =>  data <= "10110000";  -- 3E90 = B0
      when "011111010010001" =>  data <= "01111011";  -- 3E91 = 7B
      when "011111010010010" =>  data <= "11001001";  -- 3E92 = C9
      when "011111010010011" =>  data <= "11111111";  -- 3E93 = FF
      when "011111010010100" =>  data <= "11010000";  -- 3E94 = D0
      when "011111010010101" =>  data <= "00001111";  -- 3E95 = F
      when "011111010010110" =>  data <= "10101001";  -- 3E96 = A9
      when "011111010010111" =>  data <= "10100000";  -- 3E97 = A0
      when "011111010011000" =>  data <= "10100000";  -- 3E98 = A0
      when "011111010011001" =>  data <= "10111110";  -- 3E99 = BE
      when "011111010011010" =>  data <= "00100000";  -- 3E9A = 20
      when "011111010011011" =>  data <= "11011000";  -- 3E9B = D8
      when "011111010011100" =>  data <= "11001100";  -- 3E9C = CC
      when "011111010011101" =>  data <= "01001100";  -- 3E9D = 4C
      when "011111010011110" =>  data <= "01110000";  -- 3E9E = 70
      when "011111010011111" =>  data <= "00000000";  -- 3E9F = 0
      when "011111010100000" =>  data <= "10000010";  -- 3EA0 = 82
      when "011111010100001" =>  data <= "01001001";  -- 3EA1 = 49
      when "011111010100010" =>  data <= "00001111";  -- 3EA2 = F
      when "011111010100011" =>  data <= "11011010";  -- 3EA3 = DA
      when "011111010100100" =>  data <= "10100001";  -- 3EA4 = A1
      when "011111010100101" =>  data <= "11001001";  -- 3EA5 = C9
      when "011111010100110" =>  data <= "00101110";  -- 3EA6 = 2E
      when "011111010100111" =>  data <= "11110000";  -- 3EA7 = F0
      when "011111010101000" =>  data <= "11100001";  -- 3EA8 = E1
      when "011111010101001" =>  data <= "11001001";  -- 3EA9 = C9
      when "011111010101010" =>  data <= "10101011";  -- 3EAA = AB
      when "011111010101011" =>  data <= "11110000";  -- 3EAB = F0
      when "011111010101100" =>  data <= "01011000";  -- 3EAC = 58
      when "011111010101101" =>  data <= "11001001";  -- 3EAD = C9
      when "011111010101110" =>  data <= "10101010";  -- 3EAE = AA
      when "011111010101111" =>  data <= "11110000";  -- 3EAF = F0
      when "011111010110000" =>  data <= "11010100";  -- 3EB0 = D4
      when "011111010110001" =>  data <= "11001001";  -- 3EB1 = C9
      when "011111010110010" =>  data <= "00100010";  -- 3EB2 = 22
      when "011111010110011" =>  data <= "11010000";  -- 3EB3 = D0
      when "011111010110100" =>  data <= "00001111";  -- 3EB4 = F
      when "011111010110101" =>  data <= "10100101";  -- 3EB5 = A5
      when "011111010110110" =>  data <= "01110111";  -- 3EB6 = 77
      when "011111010110111" =>  data <= "10100100";  -- 3EB7 = A4
      when "011111010111000" =>  data <= "01111000";  -- 3EB8 = 78
      when "011111010111001" =>  data <= "01101001";  -- 3EB9 = 69
      when "011111010111010" =>  data <= "00000000";  -- 3EBA = 0
      when "011111010111011" =>  data <= "10010000";  -- 3EBB = 90
      when "011111010111100" =>  data <= "00000001";  -- 3EBC = 1
      when "011111010111101" =>  data <= "11001000";  -- 3EBD = C8
      when "011111010111110" =>  data <= "00100000";  -- 3EBE = 20
      when "011111010111111" =>  data <= "10110000";  -- 3EBF = B0
      when "011111011000000" =>  data <= "11000101";  -- 3EC0 = C5
      when "011111011000001" =>  data <= "01001100";  -- 3EC1 = 4C
      when "011111011000010" =>  data <= "00011000";  -- 3EC2 = 18
      when "011111011000011" =>  data <= "11001001";  -- 3EC3 = C9
      when "011111011000100" =>  data <= "11001001";  -- 3EC4 = C9
      when "011111011000101" =>  data <= "10101000";  -- 3EC5 = A8
      when "011111011000110" =>  data <= "11010000";  -- 3EC6 = D0
      when "011111011000111" =>  data <= "00010011";  -- 3EC7 = 13
      when "011111011001000" =>  data <= "10100000";  -- 3EC8 = A0
      when "011111011001001" =>  data <= "00011000";  -- 3EC9 = 18
      when "011111011001010" =>  data <= "11010000";  -- 3ECA = D0
      when "011111011001011" =>  data <= "00111011";  -- 3ECB = 3B
      when "011111011001100" =>  data <= "00100000";  -- 3ECC = 20
      when "011111011001101" =>  data <= "11101010";  -- 3ECD = EA
      when "011111011001110" =>  data <= "11000010";  -- 3ECE = C2
      when "011111011001111" =>  data <= "10100101";  -- 3ECF = A5
      when "011111011010000" =>  data <= "01100010";  -- 3ED0 = 62
      when "011111011010001" =>  data <= "01001001";  -- 3ED1 = 49
      when "011111011010010" =>  data <= "11111111";  -- 3ED2 = FF
      when "011111011010011" =>  data <= "10101000";  -- 3ED3 = A8
      when "011111011010100" =>  data <= "10100101";  -- 3ED4 = A5
      when "011111011010101" =>  data <= "01100001";  -- 3ED5 = 61
      when "011111011010110" =>  data <= "01001001";  -- 3ED6 = 49
      when "011111011010111" =>  data <= "11111111";  -- 3ED7 = FF
      when "011111011011000" =>  data <= "01001100";  -- 3ED8 = 4C
      when "011111011011001" =>  data <= "10111100";  -- 3ED9 = BC
      when "011111011011010" =>  data <= "11000100";  -- 3EDA = C4
      when "011111011011011" =>  data <= "11001001";  -- 3EDB = C9
      when "011111011011100" =>  data <= "10100101";  -- 3EDC = A5
      when "011111011011101" =>  data <= "11010000";  -- 3EDD = D0
      when "011111011011110" =>  data <= "00000011";  -- 3EDE = 3
      when "011111011011111" =>  data <= "01001100";  -- 3EDF = 4C
      when "011111011100000" =>  data <= "00011101";  -- 3EE0 = 1D
      when "011111011100001" =>  data <= "11000101";  -- 3EE1 = C5
      when "011111011100010" =>  data <= "11001001";  -- 3EE2 = C9
      when "011111011100011" =>  data <= "10110100";  -- 3EE3 = B4
      when "011111011100100" =>  data <= "10010000";  -- 3EE4 = 90
      when "011111011100101" =>  data <= "00000011";  -- 3EE5 = 3
      when "011111011100110" =>  data <= "01001100";  -- 3EE6 = 4C
      when "011111011100111" =>  data <= "01000111";  -- 3EE7 = 47
      when "011111011101000" =>  data <= "11000000";  -- 3EE8 = C0
      when "011111011101001" =>  data <= "00100000";  -- 3EE9 = 20
      when "011111011101010" =>  data <= "11110010";  -- 3EEA = F2
      when "011111011101011" =>  data <= "10111110";  -- 3EEB = BE
      when "011111011101100" =>  data <= "00100000";  -- 3EEC = 20
      when "011111011101101" =>  data <= "10011000";  -- 3EED = 98
      when "011111011101110" =>  data <= "10111101";  -- 3EEE = BD
      when "011111011101111" =>  data <= "10101001";  -- 3EEF = A9
      when "011111011110000" =>  data <= "00101001";  -- 3EF0 = 29
      when "011111011110001" =>  data <= "00101100";  -- 3EF1 = 2C
      when "011111011110010" =>  data <= "10101001";  -- 3EF2 = A9
      when "011111011110011" =>  data <= "00101000";  -- 3EF3 = 28
      when "011111011110100" =>  data <= "00101100";  -- 3EF4 = 2C
      when "011111011110101" =>  data <= "10101001";  -- 3EF5 = A9
      when "011111011110110" =>  data <= "00101100";  -- 3EF6 = 2C
      when "011111011110111" =>  data <= "10100000";  -- 3EF7 = A0
      when "011111011111000" =>  data <= "00000000";  -- 3EF8 = 0
      when "011111011111001" =>  data <= "11010001";  -- 3EF9 = D1
      when "011111011111010" =>  data <= "01110111";  -- 3EFA = 77
      when "011111011111011" =>  data <= "11010000";  -- 3EFB = D0
      when "011111011111100" =>  data <= "00000011";  -- 3EFC = 3
      when "011111011111101" =>  data <= "01001100";  -- 3EFD = 4C
      when "011111011111110" =>  data <= "01110000";  -- 3EFE = 70
      when "011111011111111" =>  data <= "00000000";  -- 3EFF = 0
      when "011111100000000" =>  data <= "10100010";  -- 3F00 = A2
      when "011111100000001" =>  data <= "00010000";  -- 3F01 = 10
      when "011111100000010" =>  data <= "01001100";  -- 3F02 = 4C
      when "011111100000011" =>  data <= "11001111";  -- 3F03 = CF
      when "011111100000100" =>  data <= "10110011";  -- 3F04 = B3
      when "011111100000101" =>  data <= "10100000";  -- 3F05 = A0
      when "011111100000110" =>  data <= "00010101";  -- 3F06 = 15
      when "011111100000111" =>  data <= "01101000";  -- 3F07 = 68
      when "011111100001000" =>  data <= "01101000";  -- 3F08 = 68
      when "011111100001001" =>  data <= "01001100";  -- 3F09 = 4C
      when "011111100001010" =>  data <= "11110100";  -- 3F0A = F4
      when "011111100001011" =>  data <= "10111101";  -- 3F0B = BD
      when "011111100001100" =>  data <= "10111000";  -- 3F0C = B8
      when "011111100001101" =>  data <= "01001100";  -- 3F0D = 4C
      when "011111100001110" =>  data <= "10001100";  -- 3F0E = 8C
      when "011111100001111" =>  data <= "10111111";  -- 3F0F = BF
      when "011111100010000" =>  data <= "01001000";  -- 3F10 = 48
      when "011111100010001" =>  data <= "10100101";  -- 3F11 = A5
      when "011111100010010" =>  data <= "00001101";  -- 3F12 = D
      when "011111100010011" =>  data <= "11110000";  -- 3F13 = F0
      when "011111100010100" =>  data <= "00001000";  -- 3F14 = 8
      when "011111100010101" =>  data <= "01101000";  -- 3F15 = 68
      when "011111100010110" =>  data <= "11000101";  -- 3F16 = C5
      when "011111100010111" =>  data <= "00001111";  -- 3F17 = F
      when "011111100011000" =>  data <= "11010000";  -- 3F18 = D0
      when "011111100011001" =>  data <= "00000100";  -- 3F19 = 4
      when "011111100011010" =>  data <= "01001100";  -- 3F1A = 4C
      when "011111100011011" =>  data <= "01110000";  -- 3F1B = 70
      when "011111100011100" =>  data <= "10111010";  -- 3F1C = BA
      when "011111100011101" =>  data <= "01101000";  -- 3F1D = 68
      when "011111100011110" =>  data <= "01001100";  -- 3F1E = 4C
      when "011111100011111" =>  data <= "01110100";  -- 3F1F = 74
      when "011111100100000" =>  data <= "10111010";  -- 3F20 = BA
      when "011111100100001" =>  data <= "00100000";  -- 3F21 = 20
      when "011111100100010" =>  data <= "01110000";  -- 3F22 = 70
      when "011111100100011" =>  data <= "00000000";  -- 3F23 = 0
      when "011111100100100" =>  data <= "11001001";  -- 3F24 = C9
      when "011111100100101" =>  data <= "11111111";  -- 3F25 = FF
      when "011111100100110" =>  data <= "11010000";  -- 3F26 = D0
      when "011111100100111" =>  data <= "00000011";  -- 3F27 = 3
      when "011111100101000" =>  data <= "01001100";  -- 3F28 = 4C
      when "011111100101001" =>  data <= "00000000";  -- 3F29 = 0
      when "011111100101010" =>  data <= "10111111";  -- 3F2A = BF
      when "011111100101011" =>  data <= "01001100";  -- 3F2B = 4C
      when "011111100101100" =>  data <= "01110110";  -- 3F2C = 76
      when "011111100101101" =>  data <= "00000000";  -- 3F2D = 0
      when "011111100101110" =>  data <= "10100101";  -- 3F2E = A5
      when "011111100101111" =>  data <= "00010000";  -- 3F2F = 10
      when "011111100110000" =>  data <= "11010000";  -- 3F30 = D0
      when "011111100110001" =>  data <= "00000011";  -- 3F31 = 3
      when "011111100110010" =>  data <= "01001100";  -- 3F32 = 4C
      when "011111100110011" =>  data <= "11110001";  -- 3F33 = F1
      when "011111100110100" =>  data <= "10111011";  -- 3F34 = BB
      when "011111100110101" =>  data <= "10100101";  -- 3F35 = A5
      when "011111100110110" =>  data <= "10010110";  -- 3F36 = 96
      when "011111100110111" =>  data <= "00101001";  -- 3F37 = 29
      when "011111100111000" =>  data <= "01000000";  -- 3F38 = 40
      when "011111100111001" =>  data <= "11010000";  -- 3F39 = D0
      when "011111100111010" =>  data <= "00000011";  -- 3F3A = 3
      when "011111100111011" =>  data <= "01001100";  -- 3F3B = 4C
      when "011111100111100" =>  data <= "11010101";  -- 3F3C = D5
      when "011111100111101" =>  data <= "10111011";  -- 3F3D = BB
      when "011111100111110" =>  data <= "01001100";  -- 3F3E = 4C
      when "011111100111111" =>  data <= "00001001";  -- 3F3F = 9
      when "011111101000000" =>  data <= "10111100";  -- 3F40 = BC
      when "011111101000001" =>  data <= "10101010";  -- 3F41 = AA
      when "011111101000010" =>  data <= "10101010";  -- 3F42 = AA
      when "011111101000011" =>  data <= "10101010";  -- 3F43 = AA
      when "011111101000100" =>  data <= "10101010";  -- 3F44 = AA
      when "011111101000101" =>  data <= "10101010";  -- 3F45 = AA
      when "011111101000110" =>  data <= "10101010";  -- 3F46 = AA
      when "011111101000111" =>  data <= "10101010";  -- 3F47 = AA
      when "011111101001000" =>  data <= "10101010";  -- 3F48 = AA
      when "011111101001001" =>  data <= "10101010";  -- 3F49 = AA
      when "011111101001010" =>  data <= "10101010";  -- 3F4A = AA
      when "011111101001011" =>  data <= "10101010";  -- 3F4B = AA
      when "011111101001100" =>  data <= "10101010";  -- 3F4C = AA
      when "011111101001101" =>  data <= "10101010";  -- 3F4D = AA
      when "011111101001110" =>  data <= "10101010";  -- 3F4E = AA
      when "011111101001111" =>  data <= "10101010";  -- 3F4F = AA
      when "011111101010000" =>  data <= "10101010";  -- 3F50 = AA
      when "011111101010001" =>  data <= "10101010";  -- 3F51 = AA
      when "011111101010010" =>  data <= "10101010";  -- 3F52 = AA
      when "011111101010011" =>  data <= "10101010";  -- 3F53 = AA
      when "011111101010100" =>  data <= "10101010";  -- 3F54 = AA
      when "011111101010101" =>  data <= "10101010";  -- 3F55 = AA
      when "011111101010110" =>  data <= "10101010";  -- 3F56 = AA
      when "011111101010111" =>  data <= "10101010";  -- 3F57 = AA
      when "011111101011000" =>  data <= "10101010";  -- 3F58 = AA
      when "011111101011001" =>  data <= "10101010";  -- 3F59 = AA
      when "011111101011010" =>  data <= "10101010";  -- 3F5A = AA
      when "011111101011011" =>  data <= "10101010";  -- 3F5B = AA
      when "011111101011100" =>  data <= "10101010";  -- 3F5C = AA
      when "011111101011101" =>  data <= "10101010";  -- 3F5D = AA
      when "011111101011110" =>  data <= "10101010";  -- 3F5E = AA
      when "011111101011111" =>  data <= "10101010";  -- 3F5F = AA
      when "011111101100000" =>  data <= "10101010";  -- 3F60 = AA
      when "011111101100001" =>  data <= "10101010";  -- 3F61 = AA
      when "011111101100010" =>  data <= "10101010";  -- 3F62 = AA
      when "011111101100011" =>  data <= "10101010";  -- 3F63 = AA
      when "011111101100100" =>  data <= "10101010";  -- 3F64 = AA
      when "011111101100101" =>  data <= "10101010";  -- 3F65 = AA
      when "011111101100110" =>  data <= "10101010";  -- 3F66 = AA
      when "011111101100111" =>  data <= "10101010";  -- 3F67 = AA
      when "011111101101000" =>  data <= "10101010";  -- 3F68 = AA
      when "011111101101001" =>  data <= "10101010";  -- 3F69 = AA
      when "011111101101010" =>  data <= "10101010";  -- 3F6A = AA
      when "011111101101011" =>  data <= "10101010";  -- 3F6B = AA
      when "011111101101100" =>  data <= "10101010";  -- 3F6C = AA
      when "011111101101101" =>  data <= "10101010";  -- 3F6D = AA
      when "011111101101110" =>  data <= "10101010";  -- 3F6E = AA
      when "011111101101111" =>  data <= "10101010";  -- 3F6F = AA
      when "011111101110000" =>  data <= "10101010";  -- 3F70 = AA
      when "011111101110001" =>  data <= "10101010";  -- 3F71 = AA
      when "011111101110010" =>  data <= "10101010";  -- 3F72 = AA
      when "011111101110011" =>  data <= "10101010";  -- 3F73 = AA
      when "011111101110100" =>  data <= "10101010";  -- 3F74 = AA
      when "011111101110101" =>  data <= "10101010";  -- 3F75 = AA
      when "011111101110110" =>  data <= "10101010";  -- 3F76 = AA
      when "011111101110111" =>  data <= "10101010";  -- 3F77 = AA
      when "011111101111000" =>  data <= "10101010";  -- 3F78 = AA
      when "011111101111001" =>  data <= "10101010";  -- 3F79 = AA
      when "011111101111010" =>  data <= "10101010";  -- 3F7A = AA
      when "011111101111011" =>  data <= "10101010";  -- 3F7B = AA
      when "011111101111100" =>  data <= "10101010";  -- 3F7C = AA
      when "011111101111101" =>  data <= "10101010";  -- 3F7D = AA
      when "011111101111110" =>  data <= "10101010";  -- 3F7E = AA
      when "011111101111111" =>  data <= "10101010";  -- 3F7F = AA
      when "011111110000000" =>  data <= "10101010";  -- 3F80 = AA
      when "011111110000001" =>  data <= "10101010";  -- 3F81 = AA
      when "011111110000010" =>  data <= "10101010";  -- 3F82 = AA
      when "011111110000011" =>  data <= "10101010";  -- 3F83 = AA
      when "011111110000100" =>  data <= "10101010";  -- 3F84 = AA
      when "011111110000101" =>  data <= "10101010";  -- 3F85 = AA
      when "011111110000110" =>  data <= "10101010";  -- 3F86 = AA
      when "011111110000111" =>  data <= "10101010";  -- 3F87 = AA
      when "011111110001000" =>  data <= "10101010";  -- 3F88 = AA
      when "011111110001001" =>  data <= "10101010";  -- 3F89 = AA
      when "011111110001010" =>  data <= "10101010";  -- 3F8A = AA
      when "011111110001011" =>  data <= "10101010";  -- 3F8B = AA
      when "011111110001100" =>  data <= "00100000";  -- 3F8C = 20
      when "011111110001101" =>  data <= "00101011";  -- 3F8D = 2B
      when "011111110001110" =>  data <= "11000001";  -- 3F8E = C1
      when "011111110001111" =>  data <= "10000101";  -- 3F8F = 85
      when "011111110010000" =>  data <= "01100001";  -- 3F90 = 61
      when "011111110010001" =>  data <= "10000100";  -- 3F91 = 84
      when "011111110010010" =>  data <= "01100010";  -- 3F92 = 62
      when "011111110010011" =>  data <= "10100101";  -- 3F93 = A5
      when "011111110010100" =>  data <= "01000010";  -- 3F94 = 42
      when "011111110010101" =>  data <= "10100100";  -- 3F95 = A4
      when "011111110010110" =>  data <= "01000011";  -- 3F96 = 43
      when "011111110010111" =>  data <= "10100110";  -- 3F97 = A6
      when "011111110011000" =>  data <= "00000111";  -- 3F98 = 7
      when "011111110011001" =>  data <= "11110000";  -- 3F99 = F0
      when "011111110011010" =>  data <= "00111001";  -- 3F9A = 39
      when "011111110011011" =>  data <= "10100010";  -- 3F9B = A2
      when "011111110011100" =>  data <= "00000000";  -- 3F9C = 0
      when "011111110011101" =>  data <= "10000110";  -- 3F9D = 86
      when "011111110011110" =>  data <= "01101101";  -- 3F9E = 6D
      when "011111110011111" =>  data <= "10100110";  -- 3F9F = A6
      when "011111110100000" =>  data <= "01100010";  -- 3FA0 = 62
      when "011111110100001" =>  data <= "11100000";  -- 3FA1 = E0
      when "011111110100010" =>  data <= "10001011";  -- 3FA2 = 8B
      when "011111110100011" =>  data <= "10010000";  -- 3FA3 = 90
      when "011111110100100" =>  data <= "00101110";  -- 3FA4 = 2E
      when "011111110100101" =>  data <= "11001001";  -- 3FA5 = C9
      when "011111110100110" =>  data <= "01010100";  -- 3FA6 = 54
      when "011111110100111" =>  data <= "11010000";  -- 3FA7 = D0
      when "011111110101000" =>  data <= "00011000";  -- 3FA8 = 18
      when "011111110101001" =>  data <= "11000000";  -- 3FA9 = C0
      when "011111110101010" =>  data <= "11001001";  -- 3FAA = C9
      when "011111110101011" =>  data <= "11010000";  -- 3FAB = D0
      when "011111110101100" =>  data <= "00010100";  -- 3FAC = 14
      when "011111110101101" =>  data <= "00100000";  -- 3FAD = 20
      when "011111110101110" =>  data <= "00000011";  -- 3FAE = 3
      when "011111110101111" =>  data <= "11000000";  -- 3FAF = C0
      when "011111110110000" =>  data <= "10000100";  -- 3FB0 = 84
      when "011111110110001" =>  data <= "01011011";  -- 3FB1 = 5B
      when "011111110110010" =>  data <= "10001000";  -- 3FB2 = 88
      when "011111110110011" =>  data <= "10000100";  -- 3FB3 = 84
      when "011111110110100" =>  data <= "01101110";  -- 3FB4 = 6E
      when "011111110110101" =>  data <= "10100000";  -- 3FB5 = A0
      when "011111110110110" =>  data <= "00000110";  -- 3FB6 = 6
      when "011111110110111" =>  data <= "10000100";  -- 3FB7 = 84
      when "011111110111000" =>  data <= "01011010";  -- 3FB8 = 5A
      when "011111110111001" =>  data <= "10100000";  -- 3FB9 = A0
      when "011111110111010" =>  data <= "00100100";  -- 3FBA = 24
      when "011111110111011" =>  data <= "00100000";  -- 3FBB = 20
      when "011111110111100" =>  data <= "00011110";  -- 3FBC = 1E
      when "011111110111101" =>  data <= "11010000";  -- 3FBD = D0
      when "011111110111110" =>  data <= "01001100";  -- 3FBE = 4C
      when "011111110111111" =>  data <= "10011000";  -- 3FBF = 98
      when "011111111000000" =>  data <= "11000101";  -- 3FC0 = C5
      when "011111111000001" =>  data <= "11001001";  -- 3FC1 = C9
      when "011111111000010" =>  data <= "01000100";  -- 3FC2 = 44
      when "011111111000011" =>  data <= "11010000";  -- 3FC3 = D0
      when "011111111000100" =>  data <= "00001110";  -- 3FC4 = E
      when "011111111000101" =>  data <= "11000000";  -- 3FC5 = C0
      when "011111111000110" =>  data <= "11010011";  -- 3FC6 = D3
      when "011111111000111" =>  data <= "11010000";  -- 3FC7 = D0
      when "011111111001000" =>  data <= "00001010";  -- 3FC8 = A
      when "011111111001001" =>  data <= "00100000";  -- 3FC9 = 20
      when "011111111001010" =>  data <= "11111100";  -- 3FCA = FC
      when "011111111001011" =>  data <= "10111111";  -- 3FCB = BF
      when "011111111001100" =>  data <= "10100101";  -- 3FCC = A5
      when "011111111001101" =>  data <= "00001110";  -- 3FCD = E
      when "011111111001110" =>  data <= "10100100";  -- 3FCE = A4
      when "011111111001111" =>  data <= "00001111";  -- 3FCF = F
      when "011111111010000" =>  data <= "01001100";  -- 3FD0 = 4C
      when "011111111010001" =>  data <= "10110000";  -- 3FD1 = B0
      when "011111111010010" =>  data <= "11000101";  -- 3FD2 = C5
      when "011111111010011" =>  data <= "01100000";  -- 3FD3 = 60
      when "011111111010100" =>  data <= "10100110";  -- 3FD4 = A6
      when "011111111010101" =>  data <= "00001000";  -- 3FD5 = 8
      when "011111111010110" =>  data <= "00010000";  -- 3FD6 = 10
      when "011111111010111" =>  data <= "00001101";  -- 3FD7 = D
      when "011111111011000" =>  data <= "10100000";  -- 3FD8 = A0
      when "011111111011001" =>  data <= "00000000";  -- 3FD9 = 0
      when "011111111011010" =>  data <= "10110001";  -- 3FDA = B1
      when "011111111011011" =>  data <= "01100001";  -- 3FDB = 61
      when "011111111011100" =>  data <= "10101010";  -- 3FDC = AA
      when "011111111011101" =>  data <= "11001000";  -- 3FDD = C8
      when "011111111011110" =>  data <= "10110001";  -- 3FDE = B1
      when "011111111011111" =>  data <= "01100001";  -- 3FDF = 61
      when "011111111100000" =>  data <= "10101000";  -- 3FE0 = A8
      when "011111111100001" =>  data <= "10001010";  -- 3FE1 = 8A
      when "011111111100010" =>  data <= "01001100";  -- 3FE2 = 4C
      when "011111111100011" =>  data <= "10111100";  -- 3FE3 = BC
      when "011111111100100" =>  data <= "11000100";  -- 3FE4 = C4
      when "011111111100101" =>  data <= "10100110";  -- 3FE5 = A6
      when "011111111100110" =>  data <= "01100010";  -- 3FE6 = 62
      when "011111111100111" =>  data <= "11100000";  -- 3FE7 = E0
      when "011111111101000" =>  data <= "10001011";  -- 3FE8 = 8B
      when "011111111101001" =>  data <= "10010000";  -- 3FE9 = 90
      when "011111111101010" =>  data <= "01010101";  -- 3FEA = 55
      when "011111111101011" =>  data <= "11001001";  -- 3FEB = C9
      when "011111111101100" =>  data <= "01010100";  -- 3FEC = 54
      when "011111111101101" =>  data <= "11010000";  -- 3FED = D0
      when "011111111101110" =>  data <= "00100000";  -- 3FEE = 20
      when "011111111101111" =>  data <= "11000000";  -- 3FEF = C0
      when "011111111110000" =>  data <= "01001001";  -- 3FF0 = 49
      when "011111111110001" =>  data <= "11010000";  -- 3FF1 = D0
      when "011111111110010" =>  data <= "01001101";  -- 3FF2 = 4D
      when "011111111110011" =>  data <= "00100000";  -- 3FF3 = 20
      when "011111111110100" =>  data <= "00000011";  -- 3FF4 = 3
      when "011111111110101" =>  data <= "11000000";  -- 3FF5 = C0
      when "011111111110110" =>  data <= "10011000";  -- 3FF6 = 98
      when "011111111110111" =>  data <= "10100010";  -- 3FF7 = A2
      when "011111111111000" =>  data <= "10100000";  -- 3FF8 = A0
      when "011111111111001" =>  data <= "01001100";  -- 3FF9 = 4C
      when "011111111111010" =>  data <= "10000101";  -- 3FFA = 85
      when "011111111111011" =>  data <= "11001101";  -- 3FFB = CD
      when "011111111111100" =>  data <= "10100101";  -- 3FFC = A5
      when "011111111111101" =>  data <= "00001101";  -- 3FFD = D
      when "011111111111110" =>  data <= "11010000";  -- 3FFE = D0
      when "011111111111111" =>  data <= "11010011";  -- 3FFF = D3
      when "100000000000000" =>  data <= "01001100";  -- 4000 = 4C
      when "100000000000001" =>  data <= "10111101";  -- 4001 = BD
      when "100000000000010" =>  data <= "11111111";  -- 4002 = FF
      when "100000000000011" =>  data <= "10101001";  -- 4003 = A9
      when "100000000000100" =>  data <= "10001011";  -- 4004 = 8B
      when "100000000000101" =>  data <= "10100000";  -- 4005 = A0
      when "100000000000110" =>  data <= "00000000";  -- 4006 = 0
      when "100000000000111" =>  data <= "01111000";  -- 4007 = 78
      when "100000000001000" =>  data <= "00100000";  -- 4008 = 20
      when "100000000001001" =>  data <= "11011000";  -- 4009 = D8
      when "100000000001010" =>  data <= "11001100";  -- 400A = CC
      when "100000000001011" =>  data <= "01011000";  -- 400B = 58
      when "100000000001100" =>  data <= "10000100";  -- 400C = 84
      when "100000000001101" =>  data <= "01011111";  -- 400D = 5F
      when "100000000001110" =>  data <= "01100000";  -- 400E = 60
      when "100000000001111" =>  data <= "11001001";  -- 400F = C9
      when "100000000010000" =>  data <= "01010011";  -- 4010 = 53
      when "100000000010001" =>  data <= "11010000";  -- 4011 = D0
      when "100000000010010" =>  data <= "00001001";  -- 4012 = 9
      when "100000000010011" =>  data <= "11000000";  -- 4013 = C0
      when "100000000010100" =>  data <= "01010100";  -- 4014 = 54
      when "100000000010101" =>  data <= "11010000";  -- 4015 = D0
      when "100000000010110" =>  data <= "00000101";  -- 4016 = 5
      when "100000000010111" =>  data <= "10100101";  -- 4017 = A5
      when "100000000011000" =>  data <= "10010110";  -- 4018 = 96
      when "100000000011001" =>  data <= "01001100";  -- 4019 = 4C
      when "100000000011010" =>  data <= "01110010";  -- 401A = 72
      when "100000000011011" =>  data <= "11001101";  -- 401B = CD
      when "100000000011100" =>  data <= "11001001";  -- 401C = C9
      when "100000000011101" =>  data <= "01000100";  -- 401D = 44
      when "100000000011110" =>  data <= "11010000";  -- 401E = D0
      when "100000000011111" =>  data <= "00100000";  -- 401F = 20
      when "100000000100000" =>  data <= "11000000";  -- 4020 = C0
      when "100000000100001" =>  data <= "01010011";  -- 4021 = 53
      when "100000000100010" =>  data <= "11010000";  -- 4022 = D0
      when "100000000100011" =>  data <= "00011100";  -- 4023 = 1C
      when "100000000100100" =>  data <= "00100000";  -- 4024 = 20
      when "100000000100101" =>  data <= "11111100";  -- 4025 = FC
      when "100000000100110" =>  data <= "10111111";  -- 4026 = BF
      when "100000000100111" =>  data <= "10100000";  -- 4027 = A0
      when "100000000101000" =>  data <= "00000000";  -- 4028 = 0
      when "100000000101001" =>  data <= "10110001";  -- 4029 = B1
      when "100000000101010" =>  data <= "00001110";  -- 402A = E
      when "100000000101011" =>  data <= "00101001";  -- 402B = 29
      when "100000000101100" =>  data <= "00001111";  -- 402C = F
      when "100000000101101" =>  data <= "00001010";  -- 402D = A
      when "100000000101110" =>  data <= "10000101";  -- 402E = 85
      when "100000000101111" =>  data <= "00001001";  -- 402F = 9
      when "100000000110000" =>  data <= "00001010";  -- 4030 = A
      when "100000000110001" =>  data <= "00001010";  -- 4031 = A
      when "100000000110010" =>  data <= "01100101";  -- 4032 = 65
      when "100000000110011" =>  data <= "00001001";  -- 4033 = 9
      when "100000000110100" =>  data <= "10000101";  -- 4034 = 85
      when "100000000110101" =>  data <= "00001001";  -- 4035 = 9
      when "100000000110110" =>  data <= "11001000";  -- 4036 = C8
      when "100000000110111" =>  data <= "10110001";  -- 4037 = B1
      when "100000000111000" =>  data <= "00001110";  -- 4038 = E
      when "100000000111001" =>  data <= "00101001";  -- 4039 = 29
      when "100000000111010" =>  data <= "00001111";  -- 403A = F
      when "100000000111011" =>  data <= "01100101";  -- 403B = 65
      when "100000000111100" =>  data <= "00001001";  -- 403C = 9
      when "100000000111101" =>  data <= "01001100";  -- 403D = 4C
      when "100000000111110" =>  data <= "01110010";  -- 403E = 72
      when "100000000111111" =>  data <= "11001101";  -- 403F = CD
      when "100000001000000" =>  data <= "10100101";  -- 4040 = A5
      when "100000001000001" =>  data <= "01100001";  -- 4041 = 61
      when "100000001000010" =>  data <= "10100100";  -- 4042 = A4
      when "100000001000011" =>  data <= "01100010";  -- 4043 = 62
      when "100000001000100" =>  data <= "01001100";  -- 4044 = 4C
      when "100000001000101" =>  data <= "11011000";  -- 4045 = D8
      when "100000001000110" =>  data <= "11001100";  -- 4046 = CC
      when "100000001000111" =>  data <= "00001010";  -- 4047 = A
      when "100000001001000" =>  data <= "01001000";  -- 4048 = 48
      when "100000001001001" =>  data <= "10101010";  -- 4049 = AA
      when "100000001001010" =>  data <= "00100000";  -- 404A = 20
      when "100000001001011" =>  data <= "01110000";  -- 404B = 70
      when "100000001001100" =>  data <= "00000000";  -- 404C = 0
      when "100000001001101" =>  data <= "11100000";  -- 404D = E0
      when "100000001001110" =>  data <= "10001111";  -- 404E = 8F
      when "100000001001111" =>  data <= "10010000";  -- 404F = 90
      when "100000001010000" =>  data <= "00100000";  -- 4050 = 20
      when "100000001010001" =>  data <= "00100000";  -- 4051 = 20
      when "100000001010010" =>  data <= "11110010";  -- 4052 = F2
      when "100000001010011" =>  data <= "10111110";  -- 4053 = BE
      when "100000001010100" =>  data <= "00100000";  -- 4054 = 20
      when "100000001010101" =>  data <= "10011000";  -- 4055 = 98
      when "100000001010110" =>  data <= "10111101";  -- 4056 = BD
      when "100000001010111" =>  data <= "00100000";  -- 4057 = 20
      when "100000001011000" =>  data <= "11110101";  -- 4058 = F5
      when "100000001011001" =>  data <= "10111110";  -- 4059 = BE
      when "100000001011010" =>  data <= "00100000";  -- 405A = 20
      when "100000001011011" =>  data <= "10001001";  -- 405B = 89
      when "100000001011100" =>  data <= "10111101";  -- 405C = BD
      when "100000001011101" =>  data <= "01101000";  -- 405D = 68
      when "100000001011110" =>  data <= "10101010";  -- 405E = AA
      when "100000001011111" =>  data <= "10100101";  -- 405F = A5
      when "100000001100000" =>  data <= "01100010";  -- 4060 = 62
      when "100000001100001" =>  data <= "01001000";  -- 4061 = 48
      when "100000001100010" =>  data <= "10100101";  -- 4062 = A5
      when "100000001100011" =>  data <= "01100001";  -- 4063 = 61
      when "100000001100100" =>  data <= "01001000";  -- 4064 = 48
      when "100000001100101" =>  data <= "10001010";  -- 4065 = 8A
      when "100000001100110" =>  data <= "01001000";  -- 4066 = 48
      when "100000001100111" =>  data <= "00100000";  -- 4067 = 20
      when "100000001101000" =>  data <= "11010100";  -- 4068 = D4
      when "100000001101001" =>  data <= "11001000";  -- 4069 = C8
      when "100000001101010" =>  data <= "01101000";  -- 406A = 68
      when "100000001101011" =>  data <= "10101000";  -- 406B = A8
      when "100000001101100" =>  data <= "10001010";  -- 406C = 8A
      when "100000001101101" =>  data <= "01001000";  -- 406D = 48
      when "100000001101110" =>  data <= "01001100";  -- 406E = 4C
      when "100000001101111" =>  data <= "01110110";  -- 406F = 76
      when "100000001110000" =>  data <= "11000000";  -- 4070 = C0
      when "100000001110001" =>  data <= "00100000";  -- 4071 = 20
      when "100000001110010" =>  data <= "11101001";  -- 4072 = E9
      when "100000001110011" =>  data <= "10111110";  -- 4073 = BE
      when "100000001110100" =>  data <= "01101000";  -- 4074 = 68
      when "100000001110101" =>  data <= "10101000";  -- 4075 = A8
      when "100000001110110" =>  data <= "10111001";  -- 4076 = B9
      when "100000001110111" =>  data <= "11111110";  -- 4077 = FE
      when "100000001111000" =>  data <= "10101111";  -- 4078 = AF
      when "100000001111001" =>  data <= "10000101";  -- 4079 = 85
      when "100000001111010" =>  data <= "01010010";  -- 407A = 52
      when "100000001111011" =>  data <= "10111001";  -- 407B = B9
      when "100000001111100" =>  data <= "11111111";  -- 407C = FF
      when "100000001111101" =>  data <= "10101111";  -- 407D = AF
      when "100000001111110" =>  data <= "10000101";  -- 407E = 85
      when "100000001111111" =>  data <= "01010011";  -- 407F = 53
      when "100000010000000" =>  data <= "00100000";  -- 4080 = 20
      when "100000010000001" =>  data <= "01010001";  -- 4081 = 51
      when "100000010000010" =>  data <= "00000000";  -- 4082 = 0
      when "100000010000011" =>  data <= "01001100";  -- 4083 = 4C
      when "100000010000100" =>  data <= "10000111";  -- 4084 = 87
      when "100000010000101" =>  data <= "10111101";  -- 4085 = BD
      when "100000010000110" =>  data <= "10100000";  -- 4086 = A0
      when "100000010000111" =>  data <= "11111111";  -- 4087 = FF
      when "100000010001000" =>  data <= "00101100";  -- 4088 = 2C
      when "100000010001001" =>  data <= "10100000";  -- 4089 = A0
      when "100000010001010" =>  data <= "00000000";  -- 408A = 0
      when "100000010001011" =>  data <= "10000100";  -- 408B = 84
      when "100000010001100" =>  data <= "00000101";  -- 408C = 5
      when "100000010001101" =>  data <= "00100000";  -- 408D = 20
      when "100000010001110" =>  data <= "11101010";  -- 408E = EA
      when "100000010001111" =>  data <= "11000010";  -- 408F = C2
      when "100000010010000" =>  data <= "10100101";  -- 4090 = A5
      when "100000010010001" =>  data <= "01100001";  -- 4091 = 61
      when "100000010010010" =>  data <= "01000101";  -- 4092 = 45
      when "100000010010011" =>  data <= "00000101";  -- 4093 = 5
      when "100000010010100" =>  data <= "10000101";  -- 4094 = 85
      when "100000010010101" =>  data <= "00000011";  -- 4095 = 3
      when "100000010010110" =>  data <= "10100101";  -- 4096 = A5
      when "100000010010111" =>  data <= "01100010";  -- 4097 = 62
      when "100000010011000" =>  data <= "01000101";  -- 4098 = 45
      when "100000010011001" =>  data <= "00000101";  -- 4099 = 5
      when "100000010011010" =>  data <= "10000101";  -- 409A = 85
      when "100000010011011" =>  data <= "00000100";  -- 409B = 4
      when "100000010011100" =>  data <= "00100000";  -- 409C = 20
      when "100000010011101" =>  data <= "00110010";  -- 409D = 32
      when "100000010011110" =>  data <= "11001101";  -- 409E = CD
      when "100000010011111" =>  data <= "00100000";  -- 409F = 20
      when "100000010100000" =>  data <= "11101010";  -- 40A0 = EA
      when "100000010100001" =>  data <= "11000010";  -- 40A1 = C2
      when "100000010100010" =>  data <= "10100101";  -- 40A2 = A5
      when "100000010100011" =>  data <= "01100010";  -- 40A3 = 62
      when "100000010100100" =>  data <= "01000101";  -- 40A4 = 45
      when "100000010100101" =>  data <= "00000101";  -- 40A5 = 5
      when "100000010100110" =>  data <= "00100101";  -- 40A6 = 25
      when "100000010100111" =>  data <= "00000100";  -- 40A7 = 4
      when "100000010101000" =>  data <= "01000101";  -- 40A8 = 45
      when "100000010101001" =>  data <= "00000101";  -- 40A9 = 5
      when "100000010101010" =>  data <= "10101000";  -- 40AA = A8
      when "100000010101011" =>  data <= "10100101";  -- 40AB = A5
      when "100000010101100" =>  data <= "01100001";  -- 40AC = 61
      when "100000010101101" =>  data <= "01000101";  -- 40AD = 45
      when "100000010101110" =>  data <= "00000101";  -- 40AE = 5
      when "100000010101111" =>  data <= "00100101";  -- 40AF = 25
      when "100000010110000" =>  data <= "00000011";  -- 40B0 = 3
      when "100000010110001" =>  data <= "01000101";  -- 40B1 = 45
      when "100000010110010" =>  data <= "00000101";  -- 40B2 = 5
      when "100000010110011" =>  data <= "01001100";  -- 40B3 = 4C
      when "100000010110100" =>  data <= "10111100";  -- 40B4 = BC
      when "100000010110101" =>  data <= "11000100";  -- 40B5 = C4
      when "100000010110110" =>  data <= "00100000";  -- 40B6 = 20
      when "100000010110111" =>  data <= "10001010";  -- 40B7 = 8A
      when "100000010111000" =>  data <= "10111101";  -- 40B8 = BD
      when "100000010111001" =>  data <= "10110000";  -- 40B9 = B0
      when "100000010111010" =>  data <= "00010011";  -- 40BA = 13
      when "100000010111011" =>  data <= "10100101";  -- 40BB = A5
      when "100000010111100" =>  data <= "01101011";  -- 40BC = 6B
      when "100000010111101" =>  data <= "00001001";  -- 40BD = 9
      when "100000010111110" =>  data <= "01111111";  -- 40BE = 7F
      when "100000010111111" =>  data <= "00100101";  -- 40BF = 25
      when "100000011000000" =>  data <= "01100111";  -- 40C0 = 67
      when "100000011000001" =>  data <= "10000101";  -- 40C1 = 85
      when "100000011000010" =>  data <= "01100111";  -- 40C2 = 67
      when "100000011000011" =>  data <= "10101001";  -- 40C3 = A9
      when "100000011000100" =>  data <= "01100110";  -- 40C4 = 66
      when "100000011000101" =>  data <= "10100000";  -- 40C5 = A0
      when "100000011000110" =>  data <= "00000000";  -- 40C6 = 0
      when "100000011000111" =>  data <= "00100000";  -- 40C7 = 20
      when "100000011001000" =>  data <= "10010001";  -- 40C8 = 91
      when "100000011001001" =>  data <= "11001101";  -- 40C9 = CD
      when "100000011001010" =>  data <= "10101010";  -- 40CA = AA
      when "100000011001011" =>  data <= "01001100";  -- 40CB = 4C
      when "100000011001100" =>  data <= "00000001";  -- 40CC = 1
      when "100000011001101" =>  data <= "11000001";  -- 40CD = C1
      when "100000011001110" =>  data <= "10101001";  -- 40CE = A9
      when "100000011001111" =>  data <= "00000000";  -- 40CF = 0
      when "100000011010000" =>  data <= "10000101";  -- 40D0 = 85
      when "100000011010001" =>  data <= "00000111";  -- 40D1 = 7
      when "100000011010010" =>  data <= "11000110";  -- 40D2 = C6
      when "100000011010011" =>  data <= "01001010";  -- 40D3 = 4A
      when "100000011010100" =>  data <= "00100000";  -- 40D4 = 20
      when "100000011010101" =>  data <= "10111000";  -- 40D5 = B8
      when "100000011010110" =>  data <= "11000111";  -- 40D6 = C7
      when "100000011010111" =>  data <= "10000101";  -- 40D7 = 85
      when "100000011011000" =>  data <= "01011110";  -- 40D8 = 5E
      when "100000011011001" =>  data <= "10000110";  -- 40D9 = 86
      when "100000011011010" =>  data <= "01011111";  -- 40DA = 5F
      when "100000011011011" =>  data <= "10000100";  -- 40DB = 84
      when "100000011011100" =>  data <= "01100000";  -- 40DC = 60
      when "100000011011101" =>  data <= "10100101";  -- 40DD = A5
      when "100000011011110" =>  data <= "01101001";  -- 40DE = 69
      when "100000011011111" =>  data <= "10100100";  -- 40DF = A4
      when "100000011100000" =>  data <= "01101010";  -- 40E0 = 6A
      when "100000011100001" =>  data <= "00100000";  -- 40E1 = 20
      when "100000011100010" =>  data <= "10111100";  -- 40E2 = BC
      when "100000011100011" =>  data <= "11000111";  -- 40E3 = C7
      when "100000011100100" =>  data <= "10000110";  -- 40E4 = 86
      when "100000011100101" =>  data <= "01101001";  -- 40E5 = 69
      when "100000011100110" =>  data <= "10000100";  -- 40E6 = 84
      when "100000011100111" =>  data <= "01101010";  -- 40E7 = 6A
      when "100000011101000" =>  data <= "10101010";  -- 40E8 = AA
      when "100000011101001" =>  data <= "00111000";  -- 40E9 = 38
      when "100000011101010" =>  data <= "11100101";  -- 40EA = E5
      when "100000011101011" =>  data <= "01011110";  -- 40EB = 5E
      when "100000011101100" =>  data <= "11110000";  -- 40EC = F0
      when "100000011101101" =>  data <= "00001000";  -- 40ED = 8
      when "100000011101110" =>  data <= "10101001";  -- 40EE = A9
      when "100000011101111" =>  data <= "00000001";  -- 40EF = 1
      when "100000011110000" =>  data <= "10010000";  -- 40F0 = 90
      when "100000011110001" =>  data <= "00000100";  -- 40F1 = 4
      when "100000011110010" =>  data <= "10100110";  -- 40F2 = A6
      when "100000011110011" =>  data <= "01011110";  -- 40F3 = 5E
      when "100000011110100" =>  data <= "10101001";  -- 40F4 = A9
      when "100000011110101" =>  data <= "11111111";  -- 40F5 = FF
      when "100000011110110" =>  data <= "10000101";  -- 40F6 = 85
      when "100000011110111" =>  data <= "01100011";  -- 40F7 = 63
      when "100000011111000" =>  data <= "10100000";  -- 40F8 = A0
      when "100000011111001" =>  data <= "11111111";  -- 40F9 = FF
      when "100000011111010" =>  data <= "11101000";  -- 40FA = E8
      when "100000011111011" =>  data <= "11001000";  -- 40FB = C8
      when "100000011111100" =>  data <= "11001010";  -- 40FC = CA
      when "100000011111101" =>  data <= "11010000";  -- 40FD = D0
      when "100000011111110" =>  data <= "00000111";  -- 40FE = 7
      when "100000011111111" =>  data <= "10100110";  -- 40FF = A6
      when "100000100000000" =>  data <= "01100011";  -- 4100 = 63
      when "100000100000001" =>  data <= "00110000";  -- 4101 = 30
      when "100000100000010" =>  data <= "00001111";  -- 4102 = F
      when "100000100000011" =>  data <= "00011000";  -- 4103 = 18
      when "100000100000100" =>  data <= "10010000";  -- 4104 = 90
      when "100000100000101" =>  data <= "00001100";  -- 4105 = C
      when "100000100000110" =>  data <= "10110001";  -- 4106 = B1
      when "100000100000111" =>  data <= "01101001";  -- 4107 = 69
      when "100000100001000" =>  data <= "11010001";  -- 4108 = D1
      when "100000100001001" =>  data <= "01011111";  -- 4109 = 5F
      when "100000100001010" =>  data <= "11110000";  -- 410A = F0
      when "100000100001011" =>  data <= "11101111";  -- 410B = EF
      when "100000100001100" =>  data <= "10100010";  -- 410C = A2
      when "100000100001101" =>  data <= "11111111";  -- 410D = FF
      when "100000100001110" =>  data <= "10110000";  -- 410E = B0
      when "100000100001111" =>  data <= "00000010";  -- 410F = 2
      when "100000100010000" =>  data <= "10100010";  -- 4110 = A2
      when "100000100010001" =>  data <= "00000001";  -- 4111 = 1
      when "100000100010010" =>  data <= "11101000";  -- 4112 = E8
      when "100000100010011" =>  data <= "10001010";  -- 4113 = 8A
      when "100000100010100" =>  data <= "00101010";  -- 4114 = 2A
      when "100000100010101" =>  data <= "00100101";  -- 4115 = 25
      when "100000100010110" =>  data <= "00001100";  -- 4116 = C
      when "100000100010111" =>  data <= "11110000";  -- 4117 = F0
      when "100000100011000" =>  data <= "00000010";  -- 4118 = 2
      when "100000100011001" =>  data <= "10101001";  -- 4119 = A9
      when "100000100011010" =>  data <= "11111111";  -- 411A = FF
      when "100000100011011" =>  data <= "01001100";  -- 411B = 4C
      when "100000100011100" =>  data <= "01110010";  -- 411C = 72
      when "100000100011101" =>  data <= "11001101";  -- 411D = CD
      when "100000100011110" =>  data <= "00100000";  -- 411E = 20
      when "100000100011111" =>  data <= "11110101";  -- 411F = F5
      when "100000100100000" =>  data <= "10111110";  -- 4120 = BE
      when "100000100100001" =>  data <= "10101010";  -- 4121 = AA
      when "100000100100010" =>  data <= "00100000";  -- 4122 = 20
      when "100000100100011" =>  data <= "00110000";  -- 4123 = 30
      when "100000100100100" =>  data <= "11000001";  -- 4124 = C1
      when "100000100100101" =>  data <= "00100000";  -- 4125 = 20
      when "100000100100110" =>  data <= "01110110";  -- 4126 = 76
      when "100000100100111" =>  data <= "00000000";  -- 4127 = 0
      when "100000100101000" =>  data <= "11010000";  -- 4128 = D0
      when "100000100101001" =>  data <= "11110100";  -- 4129 = F4
      when "100000100101010" =>  data <= "01100000";  -- 412A = 60
      when "100000100101011" =>  data <= "10100010";  -- 412B = A2
      when "100000100101100" =>  data <= "00000000";  -- 412C = 0
      when "100000100101101" =>  data <= "00100000";  -- 412D = 20
      when "100000100101110" =>  data <= "01110110";  -- 412E = 76
      when "100000100101111" =>  data <= "00000000";  -- 412F = 0
      when "100000100110000" =>  data <= "10000110";  -- 4130 = 86
      when "100000100110001" =>  data <= "00000110";  -- 4131 = 6
      when "100000100110010" =>  data <= "10000101";  -- 4132 = 85
      when "100000100110011" =>  data <= "01000010";  -- 4133 = 42
      when "100000100110100" =>  data <= "00100000";  -- 4134 = 20
      when "100000100110101" =>  data <= "01110110";  -- 4135 = 76
      when "100000100110110" =>  data <= "00000000";  -- 4136 = 0
      when "100000100110111" =>  data <= "00100000";  -- 4137 = 20
      when "100000100111000" =>  data <= "10110110";  -- 4138 = B6
      when "100000100111001" =>  data <= "11000001";  -- 4139 = C1
      when "100000100111010" =>  data <= "10110000";  -- 413A = B0
      when "100000100111011" =>  data <= "00000011";  -- 413B = 3
      when "100000100111100" =>  data <= "01001100";  -- 413C = 4C
      when "100000100111101" =>  data <= "00000000";  -- 413D = 0
      when "100000100111110" =>  data <= "10111111";  -- 413E = BF
      when "100000100111111" =>  data <= "10100010";  -- 413F = A2
      when "100000101000000" =>  data <= "00000000";  -- 4140 = 0
      when "100000101000001" =>  data <= "10000110";  -- 4141 = 86
      when "100000101000010" =>  data <= "00000111";  -- 4142 = 7
      when "100000101000011" =>  data <= "10000110";  -- 4143 = 86
      when "100000101000100" =>  data <= "00001000";  -- 4144 = 8
      when "100000101000101" =>  data <= "00100000";  -- 4145 = 20
      when "100000101000110" =>  data <= "01110000";  -- 4146 = 70
      when "100000101000111" =>  data <= "00000000";  -- 4147 = 0
      when "100000101001000" =>  data <= "10010000";  -- 4148 = 90
      when "100000101001001" =>  data <= "00000101";  -- 4149 = 5
      when "100000101001010" =>  data <= "00100000";  -- 414A = 20
      when "100000101001011" =>  data <= "10110110";  -- 414B = B6
      when "100000101001100" =>  data <= "11000001";  -- 414C = C1
      when "100000101001101" =>  data <= "10010000";  -- 414D = 90
      when "100000101001110" =>  data <= "00001011";  -- 414E = B
      when "100000101001111" =>  data <= "10101010";  -- 414F = AA
      when "100000101010000" =>  data <= "00100000";  -- 4150 = 20
      when "100000101010001" =>  data <= "01110000";  -- 4151 = 70
      when "100000101010010" =>  data <= "00000000";  -- 4152 = 0
      when "100000101010011" =>  data <= "10010000";  -- 4153 = 90
      when "100000101010100" =>  data <= "11111011";  -- 4154 = FB
      when "100000101010101" =>  data <= "00100000";  -- 4155 = 20
      when "100000101010110" =>  data <= "10110110";  -- 4156 = B6
      when "100000101010111" =>  data <= "11000001";  -- 4157 = C1
      when "100000101011000" =>  data <= "10110000";  -- 4158 = B0
      when "100000101011001" =>  data <= "11110110";  -- 4159 = F6
      when "100000101011010" =>  data <= "11001001";  -- 415A = C9
      when "100000101011011" =>  data <= "00100100";  -- 415B = 24
      when "100000101011100" =>  data <= "11010000";  -- 415C = D0
      when "100000101011101" =>  data <= "00000110";  -- 415D = 6
      when "100000101011110" =>  data <= "10101001";  -- 415E = A9
      when "100000101011111" =>  data <= "11111111";  -- 415F = FF
      when "100000101100000" =>  data <= "10000101";  -- 4160 = 85
      when "100000101100001" =>  data <= "00000111";  -- 4161 = 7
      when "100000101100010" =>  data <= "11010000";  -- 4162 = D0
      when "100000101100011" =>  data <= "00010000";  -- 4163 = 10
      when "100000101100100" =>  data <= "11001001";  -- 4164 = C9
      when "100000101100101" =>  data <= "00100101";  -- 4165 = 25
      when "100000101100110" =>  data <= "11010000";  -- 4166 = D0
      when "100000101100111" =>  data <= "00010011";  -- 4167 = 13
      when "100000101101000" =>  data <= "10100101";  -- 4168 = A5
      when "100000101101001" =>  data <= "00001010";  -- 4169 = A
      when "100000101101010" =>  data <= "11010000";  -- 416A = D0
      when "100000101101011" =>  data <= "11010000";  -- 416B = D0
      when "100000101101100" =>  data <= "10101001";  -- 416C = A9
      when "100000101101101" =>  data <= "10000000";  -- 416D = 80
      when "100000101101110" =>  data <= "10000101";  -- 416E = 85
      when "100000101101111" =>  data <= "00001000";  -- 416F = 8
      when "100000101110000" =>  data <= "00000101";  -- 4170 = 5
      when "100000101110001" =>  data <= "01000010";  -- 4171 = 42
      when "100000101110010" =>  data <= "10000101";  -- 4172 = 85
      when "100000101110011" =>  data <= "01000010";  -- 4173 = 42
      when "100000101110100" =>  data <= "10001010";  -- 4174 = 8A
      when "100000101110101" =>  data <= "00001001";  -- 4175 = 9
      when "100000101110110" =>  data <= "10000000";  -- 4176 = 80
      when "100000101110111" =>  data <= "10101010";  -- 4177 = AA
      when "100000101111000" =>  data <= "00100000";  -- 4178 = 20
      when "100000101111001" =>  data <= "01110000";  -- 4179 = 70
      when "100000101111010" =>  data <= "00000000";  -- 417A = 0
      when "100000101111011" =>  data <= "10000110";  -- 417B = 86
      when "100000101111100" =>  data <= "01000011";  -- 417C = 43
      when "100000101111101" =>  data <= "00111000";  -- 417D = 38
      when "100000101111110" =>  data <= "00000101";  -- 417E = 5
      when "100000101111111" =>  data <= "00001010";  -- 417F = A
      when "100000110000000" =>  data <= "11101001";  -- 4180 = E9
      when "100000110000001" =>  data <= "00101000";  -- 4181 = 28
      when "100000110000010" =>  data <= "11010000";  -- 4182 = D0
      when "100000110000011" =>  data <= "00000011";  -- 4183 = 3
      when "100000110000100" =>  data <= "01001100";  -- 4184 = 4C
      when "100000110000101" =>  data <= "11111100";  -- 4185 = FC
      when "100000110000110" =>  data <= "11000010";  -- 4186 = C2
      when "100000110000111" =>  data <= "10100000";  -- 4187 = A0
      when "100000110001000" =>  data <= "00000000";  -- 4188 = 0
      when "100000110001001" =>  data <= "10000100";  -- 4189 = 84
      when "100000110001010" =>  data <= "00001010";  -- 418A = A
      when "100000110001011" =>  data <= "10100101";  -- 418B = A5
      when "100000110001100" =>  data <= "00101010";  -- 418C = 2A
      when "100000110001101" =>  data <= "10100110";  -- 418D = A6
      when "100000110001110" =>  data <= "00101011";  -- 418E = 2B
      when "100000110001111" =>  data <= "10000110";  -- 418F = 86
      when "100000110010000" =>  data <= "01011101";  -- 4190 = 5D
      when "100000110010001" =>  data <= "10000101";  -- 4191 = 85
      when "100000110010010" =>  data <= "01011100";  -- 4192 = 5C
      when "100000110010011" =>  data <= "11100100";  -- 4193 = E4
      when "100000110010100" =>  data <= "00101101";  -- 4194 = 2D
      when "100000110010101" =>  data <= "11010000";  -- 4195 = D0
      when "100000110010110" =>  data <= "00000100";  -- 4196 = 4
      when "100000110010111" =>  data <= "11000101";  -- 4197 = C5
      when "100000110011000" =>  data <= "00101100";  -- 4198 = 2C
      when "100000110011001" =>  data <= "11110000";  -- 4199 = F0
      when "100000110011010" =>  data <= "00100101";  -- 419A = 25
      when "100000110011011" =>  data <= "10100101";  -- 419B = A5
      when "100000110011100" =>  data <= "01000010";  -- 419C = 42
      when "100000110011101" =>  data <= "11010001";  -- 419D = D1
      when "100000110011110" =>  data <= "01011100";  -- 419E = 5C
      when "100000110011111" =>  data <= "11010000";  -- 419F = D0
      when "100000110100000" =>  data <= "00001011";  -- 41A0 = B
      when "100000110100001" =>  data <= "10100101";  -- 41A1 = A5
      when "100000110100010" =>  data <= "01000011";  -- 41A2 = 43
      when "100000110100011" =>  data <= "11001000";  -- 41A3 = C8
      when "100000110100100" =>  data <= "11010001";  -- 41A4 = D1
      when "100000110100101" =>  data <= "01011100";  -- 41A5 = 5C
      when "100000110100110" =>  data <= "11010000";  -- 41A6 = D0
      when "100000110100111" =>  data <= "00000011";  -- 41A7 = 3
      when "100000110101000" =>  data <= "01001100";  -- 41A8 = 4C
      when "100000110101001" =>  data <= "10111001";  -- 41A9 = B9
      when "100000110101010" =>  data <= "11000010";  -- 41AA = C2
      when "100000110101011" =>  data <= "10001000";  -- 41AB = 88
      when "100000110101100" =>  data <= "00011000";  -- 41AC = 18
      when "100000110101101" =>  data <= "10100101";  -- 41AD = A5
      when "100000110101110" =>  data <= "01011100";  -- 41AE = 5C
      when "100000110101111" =>  data <= "01101001";  -- 41AF = 69
      when "100000110110000" =>  data <= "00000111";  -- 41B0 = 7
      when "100000110110001" =>  data <= "10010000";  -- 41B1 = 90
      when "100000110110010" =>  data <= "11011110";  -- 41B2 = DE
      when "100000110110011" =>  data <= "11101000";  -- 41B3 = E8
      when "100000110110100" =>  data <= "11010000";  -- 41B4 = D0
      when "100000110110101" =>  data <= "11011001";  -- 41B5 = D9
      when "100000110110110" =>  data <= "11001001";  -- 41B6 = C9
      when "100000110110111" =>  data <= "01000001";  -- 41B7 = 41
      when "100000110111000" =>  data <= "10010000";  -- 41B8 = 90
      when "100000110111001" =>  data <= "00000101";  -- 41B9 = 5
      when "100000110111010" =>  data <= "11101001";  -- 41BA = E9
      when "100000110111011" =>  data <= "01011011";  -- 41BB = 5B
      when "100000110111100" =>  data <= "00111000";  -- 41BC = 38
      when "100000110111101" =>  data <= "11101001";  -- 41BD = E9
      when "100000110111110" =>  data <= "10100101";  -- 41BE = A5
      when "100000110111111" =>  data <= "01100000";  -- 41BF = 60
      when "100000111000000" =>  data <= "01101000";  -- 41C0 = 68
      when "100000111000001" =>  data <= "01001000";  -- 41C1 = 48
      when "100000111000010" =>  data <= "11001001";  -- 41C2 = C9
      when "100000111000011" =>  data <= "10001110";  -- 41C3 = 8E
      when "100000111000100" =>  data <= "11010000";  -- 41C4 = D0
      when "100000111000101" =>  data <= "00000101";  -- 41C5 = 5
      when "100000111000110" =>  data <= "10101001";  -- 41C6 = A9
      when "100000111000111" =>  data <= "11001001";  -- 41C7 = C9
      when "100000111001000" =>  data <= "10100000";  -- 41C8 = A0
      when "100000111001001" =>  data <= "11010000";  -- 41C9 = D0
      when "100000111001010" =>  data <= "01100000";  -- 41CA = 60
      when "100000111001011" =>  data <= "10100101";  -- 41CB = A5
      when "100000111001100" =>  data <= "01000010";  -- 41CC = 42
      when "100000111001101" =>  data <= "10100100";  -- 41CD = A4
      when "100000111001110" =>  data <= "01000011";  -- 41CE = 43
      when "100000111001111" =>  data <= "11001001";  -- 41CF = C9
      when "100000111010000" =>  data <= "01010100";  -- 41D0 = 54
      when "100000111010001" =>  data <= "11010000";  -- 41D1 = D0
      when "100000111010010" =>  data <= "00001011";  -- 41D2 = B
      when "100000111010011" =>  data <= "11000000";  -- 41D3 = C0
      when "100000111010100" =>  data <= "11001001";  -- 41D4 = C9
      when "100000111010101" =>  data <= "11110000";  -- 41D5 = F0
      when "100000111010110" =>  data <= "11101111";  -- 41D6 = EF
      when "100000111010111" =>  data <= "11000000";  -- 41D7 = C0
      when "100000111011000" =>  data <= "01001001";  -- 41D8 = 49
      when "100000111011001" =>  data <= "11010000";  -- 41D9 = D0
      when "100000111011010" =>  data <= "00000011";  -- 41DA = 3
      when "100000111011011" =>  data <= "01001100";  -- 41DB = 4C
      when "100000111011100" =>  data <= "00000000";  -- 41DC = 0
      when "100000111011101" =>  data <= "10111111";  -- 41DD = BF
      when "100000111011110" =>  data <= "11001001";  -- 41DE = C9
      when "100000111011111" =>  data <= "01010011";  -- 41DF = 53
      when "100000111100000" =>  data <= "11010000";  -- 41E0 = D0
      when "100000111100001" =>  data <= "00000100";  -- 41E1 = 4
      when "100000111100010" =>  data <= "11000000";  -- 41E2 = C0
      when "100000111100011" =>  data <= "01010100";  -- 41E3 = 54
      when "100000111100100" =>  data <= "11110000";  -- 41E4 = F0
      when "100000111100101" =>  data <= "11110101";  -- 41E5 = F5
      when "100000111100110" =>  data <= "11001001";  -- 41E6 = C9
      when "100000111100111" =>  data <= "01000100";  -- 41E7 = 44
      when "100000111101000" =>  data <= "11010000";  -- 41E8 = D0
      when "100000111101001" =>  data <= "00001000";  -- 41E9 = 8
      when "100000111101010" =>  data <= "11000000";  -- 41EA = C0
      when "100000111101011" =>  data <= "01010011";  -- 41EB = 53
      when "100000111101100" =>  data <= "11110000";  -- 41EC = F0
      when "100000111101101" =>  data <= "11101101";  -- 41ED = ED
      when "100000111101110" =>  data <= "11000000";  -- 41EE = C0
      when "100000111101111" =>  data <= "11010011";  -- 41EF = D3
      when "100000111110000" =>  data <= "11110000";  -- 41F0 = F0
      when "100000111110001" =>  data <= "11101001";  -- 41F1 = E9
      when "100000111110010" =>  data <= "10100101";  -- 41F2 = A5
      when "100000111110011" =>  data <= "00101100";  -- 41F3 = 2C
      when "100000111110100" =>  data <= "10100100";  -- 41F4 = A4
      when "100000111110101" =>  data <= "00101101";  -- 41F5 = 2D
      when "100000111110110" =>  data <= "10000101";  -- 41F6 = 85
      when "100000111110111" =>  data <= "01011100";  -- 41F7 = 5C
      when "100000111111000" =>  data <= "10000100";  -- 41F8 = 84
      when "100000111111001" =>  data <= "01011101";  -- 41F9 = 5D
      when "100000111111010" =>  data <= "10100101";  -- 41FA = A5
      when "100000111111011" =>  data <= "00101110";  -- 41FB = 2E
      when "100000111111100" =>  data <= "10100100";  -- 41FC = A4
      when "100000111111101" =>  data <= "00101111";  -- 41FD = 2F
      when "100000111111110" =>  data <= "10000101";  -- 41FE = 85
      when "100000111111111" =>  data <= "01010111";  -- 41FF = 57
      when "100001000000000" =>  data <= "10000100";  -- 4200 = 84
      when "100001000000001" =>  data <= "01011000";  -- 4201 = 58
      when "100001000000010" =>  data <= "00011000";  -- 4202 = 18
      when "100001000000011" =>  data <= "01101001";  -- 4203 = 69
      when "100001000000100" =>  data <= "00000111";  -- 4204 = 7
      when "100001000000101" =>  data <= "10010000";  -- 4205 = 90
      when "100001000000110" =>  data <= "00000001";  -- 4206 = 1
      when "100001000000111" =>  data <= "11001000";  -- 4207 = C8
      when "100001000001000" =>  data <= "10000101";  -- 4208 = 85
      when "100001000001001" =>  data <= "01010101";  -- 4209 = 55
      when "100001000001010" =>  data <= "10000100";  -- 420A = 84
      when "100001000001011" =>  data <= "01010110";  -- 420B = 56
      when "100001000001100" =>  data <= "00100000";  -- 420C = 20
      when "100001000001101" =>  data <= "01010000";  -- 420D = 50
      when "100001000001110" =>  data <= "10110011";  -- 420E = B3
      when "100001000001111" =>  data <= "10100101";  -- 420F = A5
      when "100001000010000" =>  data <= "01010101";  -- 4210 = 55
      when "100001000010001" =>  data <= "10100100";  -- 4211 = A4
      when "100001000010010" =>  data <= "01010110";  -- 4212 = 56
      when "100001000010011" =>  data <= "11001000";  -- 4213 = C8
      when "100001000010100" =>  data <= "10000101";  -- 4214 = 85
      when "100001000010101" =>  data <= "00101100";  -- 4215 = 2C
      when "100001000010110" =>  data <= "10000100";  -- 4216 = 84
      when "100001000010111" =>  data <= "00101101";  -- 4217 = 2D
      when "100001000011000" =>  data <= "10000101";  -- 4218 = 85
      when "100001000011001" =>  data <= "01010101";  -- 4219 = 55
      when "100001000011010" =>  data <= "10000100";  -- 421A = 84
      when "100001000011011" =>  data <= "01010110";  -- 421B = 56
      when "100001000011100" =>  data <= "10100101";  -- 421C = A5
      when "100001000011101" =>  data <= "01010101";  -- 421D = 55
      when "100001000011110" =>  data <= "10100110";  -- 421E = A6
      when "100001000011111" =>  data <= "01010110";  -- 421F = 56
      when "100001000100000" =>  data <= "11100100";  -- 4220 = E4
      when "100001000100001" =>  data <= "00101111";  -- 4221 = 2F
      when "100001000100010" =>  data <= "11010000";  -- 4222 = D0
      when "100001000100011" =>  data <= "00000100";  -- 4223 = 4
      when "100001000100100" =>  data <= "11000101";  -- 4224 = C5
      when "100001000100101" =>  data <= "00101110";  -- 4225 = 2E
      when "100001000100110" =>  data <= "11110000";  -- 4226 = F0
      when "100001000100111" =>  data <= "01110101";  -- 4227 = 75
      when "100001000101000" =>  data <= "10000101";  -- 4228 = 85
      when "100001000101001" =>  data <= "00011111";  -- 4229 = 1F
      when "100001000101010" =>  data <= "10000110";  -- 422A = 86
      when "100001000101011" =>  data <= "00100000";  -- 422B = 20
      when "100001000101100" =>  data <= "10100000";  -- 422C = A0
      when "100001000101101" =>  data <= "00000000";  -- 422D = 0
      when "100001000101110" =>  data <= "10110001";  -- 422E = B1
      when "100001000101111" =>  data <= "00011111";  -- 422F = 1F
      when "100001000110000" =>  data <= "10101010";  -- 4230 = AA
      when "100001000110001" =>  data <= "11001000";  -- 4231 = C8
      when "100001000110010" =>  data <= "10110001";  -- 4232 = B1
      when "100001000110011" =>  data <= "00011111";  -- 4233 = 1F
      when "100001000110100" =>  data <= "00001000";  -- 4234 = 8
      when "100001000110101" =>  data <= "11001000";  -- 4235 = C8
      when "100001000110110" =>  data <= "10110001";  -- 4236 = B1
      when "100001000110111" =>  data <= "00011111";  -- 4237 = 1F
      when "100001000111000" =>  data <= "01100101";  -- 4238 = 65
      when "100001000111001" =>  data <= "01010101";  -- 4239 = 55
      when "100001000111010" =>  data <= "10000101";  -- 423A = 85
      when "100001000111011" =>  data <= "01010101";  -- 423B = 55
      when "100001000111100" =>  data <= "11001000";  -- 423C = C8
      when "100001000111101" =>  data <= "10110001";  -- 423D = B1
      when "100001000111110" =>  data <= "00011111";  -- 423E = 1F
      when "100001000111111" =>  data <= "01100101";  -- 423F = 65
      when "100001001000000" =>  data <= "01010110";  -- 4240 = 56
      when "100001001000001" =>  data <= "10000101";  -- 4241 = 85
      when "100001001000010" =>  data <= "01010110";  -- 4242 = 56
      when "100001001000011" =>  data <= "00101000";  -- 4243 = 28
      when "100001001000100" =>  data <= "00010000";  -- 4244 = 10
      when "100001001000101" =>  data <= "11010110";  -- 4245 = D6
      when "100001001000110" =>  data <= "10001010";  -- 4246 = 8A
      when "100001001000111" =>  data <= "00110000";  -- 4247 = 30
      when "100001001001000" =>  data <= "11010011";  -- 4248 = D3
      when "100001001001001" =>  data <= "11001000";  -- 4249 = C8
      when "100001001001010" =>  data <= "10110001";  -- 424A = B1
      when "100001001001011" =>  data <= "00011111";  -- 424B = 1F
      when "100001001001100" =>  data <= "10100000";  -- 424C = A0
      when "100001001001101" =>  data <= "00000000";  -- 424D = 0
      when "100001001001110" =>  data <= "00001010";  -- 424E = A
      when "100001001001111" =>  data <= "01101001";  -- 424F = 69
      when "100001001010000" =>  data <= "00000101";  -- 4250 = 5
      when "100001001010001" =>  data <= "01100101";  -- 4251 = 65
      when "100001001010010" =>  data <= "00011111";  -- 4252 = 1F
      when "100001001010011" =>  data <= "10000101";  -- 4253 = 85
      when "100001001010100" =>  data <= "00011111";  -- 4254 = 1F
      when "100001001010101" =>  data <= "10010000";  -- 4255 = 90
      when "100001001010110" =>  data <= "00000010";  -- 4256 = 2
      when "100001001010111" =>  data <= "11100110";  -- 4257 = E6
      when "100001001011000" =>  data <= "00100000";  -- 4258 = 20
      when "100001001011001" =>  data <= "10100110";  -- 4259 = A6
      when "100001001011010" =>  data <= "00100000";  -- 425A = 20
      when "100001001011011" =>  data <= "11100100";  -- 425B = E4
      when "100001001011100" =>  data <= "01010110";  -- 425C = 56
      when "100001001011101" =>  data <= "11010000";  -- 425D = D0
      when "100001001011110" =>  data <= "00000100";  -- 425E = 4
      when "100001001011111" =>  data <= "11000101";  -- 425F = C5
      when "100001001100000" =>  data <= "01010101";  -- 4260 = 55
      when "100001001100001" =>  data <= "11110000";  -- 4261 = F0
      when "100001001100010" =>  data <= "10111101";  -- 4262 = BD
      when "100001001100011" =>  data <= "10100000";  -- 4263 = A0
      when "100001001100100" =>  data <= "00000000";  -- 4264 = 0
      when "100001001100101" =>  data <= "10110001";  -- 4265 = B1
      when "100001001100110" =>  data <= "00011111";  -- 4266 = 1F
      when "100001001100111" =>  data <= "11110000";  -- 4267 = F0
      when "100001001101000" =>  data <= "00100111";  -- 4268 = 27
      when "100001001101001" =>  data <= "11001000";  -- 4269 = C8
      when "100001001101010" =>  data <= "00011000";  -- 426A = 18
      when "100001001101011" =>  data <= "01110001";  -- 426B = 71
      when "100001001101100" =>  data <= "00011111";  -- 426C = 1F
      when "100001001101101" =>  data <= "10000101";  -- 426D = 85
      when "100001001101110" =>  data <= "01010111";  -- 426E = 57
      when "100001001101111" =>  data <= "10101010";  -- 426F = AA
      when "100001001110000" =>  data <= "11001000";  -- 4270 = C8
      when "100001001110001" =>  data <= "10110001";  -- 4271 = B1
      when "100001001110010" =>  data <= "00011111";  -- 4272 = 1F
      when "100001001110011" =>  data <= "01101001";  -- 4273 = 69
      when "100001001110100" =>  data <= "00000000";  -- 4274 = 0
      when "100001001110101" =>  data <= "10000101";  -- 4275 = 85
      when "100001001110110" =>  data <= "01011000";  -- 4276 = 58
      when "100001001110111" =>  data <= "11000101";  -- 4277 = C5
      when "100001001111000" =>  data <= "00110001";  -- 4278 = 31
      when "100001001111001" =>  data <= "10010000";  -- 4279 = 90
      when "100001001111010" =>  data <= "00010101";  -- 427A = 15
      when "100001001111011" =>  data <= "11010000";  -- 427B = D0
      when "100001001111100" =>  data <= "00000100";  -- 427C = 4
      when "100001001111101" =>  data <= "11100100";  -- 427D = E4
      when "100001001111110" =>  data <= "00110000";  -- 427E = 30
      when "100001001111111" =>  data <= "10010000";  -- 427F = 90
      when "100001010000000" =>  data <= "00001111";  -- 4280 = F
      when "100001010000001" =>  data <= "10100000";  -- 4281 = A0
      when "100001010000010" =>  data <= "00000000";  -- 4282 = 0
      when "100001010000011" =>  data <= "10110001";  -- 4283 = B1
      when "100001010000100" =>  data <= "01010111";  -- 4284 = 57
      when "100001010000101" =>  data <= "01101001";  -- 4285 = 69
      when "100001010000110" =>  data <= "00000110";  -- 4286 = 6
      when "100001010000111" =>  data <= "10010001";  -- 4287 = 91
      when "100001010001000" =>  data <= "01010111";  -- 4288 = 57
      when "100001010001001" =>  data <= "11001000";  -- 4289 = C8
      when "100001010001010" =>  data <= "10110001";  -- 428A = B1
      when "100001010001011" =>  data <= "01010111";  -- 428B = 57
      when "100001010001100" =>  data <= "01101001";  -- 428C = 69
      when "100001010001101" =>  data <= "00000000";  -- 428D = 0
      when "100001010001110" =>  data <= "10010001";  -- 428E = 91
      when "100001010001111" =>  data <= "01010111";  -- 428F = 57
      when "100001010010000" =>  data <= "10101001";  -- 4290 = A9
      when "100001010010001" =>  data <= "00000011";  -- 4291 = 3
      when "100001010010010" =>  data <= "00011000";  -- 4292 = 18
      when "100001010010011" =>  data <= "01100101";  -- 4293 = 65
      when "100001010010100" =>  data <= "00011111";  -- 4294 = 1F
      when "100001010010101" =>  data <= "10000101";  -- 4295 = 85
      when "100001010010110" =>  data <= "00011111";  -- 4296 = 1F
      when "100001010010111" =>  data <= "10010000";  -- 4297 = 90
      when "100001010011000" =>  data <= "11000000";  -- 4298 = C0
      when "100001010011001" =>  data <= "11100110";  -- 4299 = E6
      when "100001010011010" =>  data <= "00100000";  -- 429A = 20
      when "100001010011011" =>  data <= "11010000";  -- 429B = D0
      when "100001010011100" =>  data <= "10111100";  -- 429C = BC
      when "100001010011101" =>  data <= "10100000";  -- 429D = A0
      when "100001010011110" =>  data <= "00000000";  -- 429E = 0
      when "100001010011111" =>  data <= "10100101";  -- 429F = A5
      when "100001010100000" =>  data <= "01000010";  -- 42A0 = 42
      when "100001010100001" =>  data <= "10010001";  -- 42A1 = 91
      when "100001010100010" =>  data <= "01011100";  -- 42A2 = 5C
      when "100001010100011" =>  data <= "11001000";  -- 42A3 = C8
      when "100001010100100" =>  data <= "10100101";  -- 42A4 = A5
      when "100001010100101" =>  data <= "01000011";  -- 42A5 = 43
      when "100001010100110" =>  data <= "10010001";  -- 42A6 = 91
      when "100001010100111" =>  data <= "01011100";  -- 42A7 = 5C
      when "100001010101000" =>  data <= "10101001";  -- 42A8 = A9
      when "100001010101001" =>  data <= "00000000";  -- 42A9 = 0
      when "100001010101010" =>  data <= "11001000";  -- 42AA = C8
      when "100001010101011" =>  data <= "10010001";  -- 42AB = 91
      when "100001010101100" =>  data <= "01011100";  -- 42AC = 5C
      when "100001010101101" =>  data <= "11001000";  -- 42AD = C8
      when "100001010101110" =>  data <= "10010001";  -- 42AE = 91
      when "100001010101111" =>  data <= "01011100";  -- 42AF = 5C
      when "100001010110000" =>  data <= "11001000";  -- 42B0 = C8
      when "100001010110001" =>  data <= "10010001";  -- 42B1 = 91
      when "100001010110010" =>  data <= "01011100";  -- 42B2 = 5C
      when "100001010110011" =>  data <= "11001000";  -- 42B3 = C8
      when "100001010110100" =>  data <= "10010001";  -- 42B4 = 91
      when "100001010110101" =>  data <= "01011100";  -- 42B5 = 5C
      when "100001010110110" =>  data <= "11001000";  -- 42B6 = C8
      when "100001010110111" =>  data <= "10010001";  -- 42B7 = 91
      when "100001010111000" =>  data <= "01011100";  -- 42B8 = 5C
      when "100001010111001" =>  data <= "10100101";  -- 42B9 = A5
      when "100001010111010" =>  data <= "01011100";  -- 42BA = 5C
      when "100001010111011" =>  data <= "00011000";  -- 42BB = 18
      when "100001010111100" =>  data <= "01101001";  -- 42BC = 69
      when "100001010111101" =>  data <= "00000010";  -- 42BD = 2
      when "100001010111110" =>  data <= "10100100";  -- 42BE = A4
      when "100001010111111" =>  data <= "01011101";  -- 42BF = 5D
      when "100001011000000" =>  data <= "10010000";  -- 42C0 = 90
      when "100001011000001" =>  data <= "00000001";  -- 42C1 = 1
      when "100001011000010" =>  data <= "11001000";  -- 42C2 = C8
      when "100001011000011" =>  data <= "10000101";  -- 42C3 = 85
      when "100001011000100" =>  data <= "01000100";  -- 42C4 = 44
      when "100001011000101" =>  data <= "10000100";  -- 42C5 = 84
      when "100001011000110" =>  data <= "01000101";  -- 42C6 = 45
      when "100001011000111" =>  data <= "01100000";  -- 42C7 = 60
      when "100001011001000" =>  data <= "10100101";  -- 42C8 = A5
      when "100001011001001" =>  data <= "00000101";  -- 42C9 = 5
      when "100001011001010" =>  data <= "00001010";  -- 42CA = A
      when "100001011001011" =>  data <= "01101001";  -- 42CB = 69
      when "100001011001100" =>  data <= "00000101";  -- 42CC = 5
      when "100001011001101" =>  data <= "01100101";  -- 42CD = 65
      when "100001011001110" =>  data <= "01011100";  -- 42CE = 5C
      when "100001011001111" =>  data <= "10100100";  -- 42CF = A4
      when "100001011010000" =>  data <= "01011101";  -- 42D0 = 5D
      when "100001011010001" =>  data <= "10010000";  -- 42D1 = 90
      when "100001011010010" =>  data <= "00000001";  -- 42D2 = 1
      when "100001011010011" =>  data <= "11001000";  -- 42D3 = C8
      when "100001011010100" =>  data <= "10000101";  -- 42D4 = 85
      when "100001011010101" =>  data <= "01010101";  -- 42D5 = 55
      when "100001011010110" =>  data <= "10000100";  -- 42D6 = 84
      when "100001011010111" =>  data <= "01010110";  -- 42D7 = 56
      when "100001011011000" =>  data <= "01100000";  -- 42D8 = 60
      when "100001011011001" =>  data <= "10010000";  -- 42D9 = 90
      when "100001011011010" =>  data <= "10000000";  -- 42DA = 80
      when "100001011011011" =>  data <= "00000000";  -- 42DB = 0
      when "100001011011100" =>  data <= "00000000";  -- 42DC = 0
      when "100001011011101" =>  data <= "00100000";  -- 42DD = 20
      when "100001011011110" =>  data <= "01110000";  -- 42DE = 70
      when "100001011011111" =>  data <= "00000000";  -- 42DF = 0
      when "100001011100000" =>  data <= "00100000";  -- 42E0 = 20
      when "100001011100001" =>  data <= "10011000";  -- 42E1 = 98
      when "100001011100010" =>  data <= "10111101";  -- 42E2 = BD
      when "100001011100011" =>  data <= "00100000";  -- 42E3 = 20
      when "100001011100100" =>  data <= "10000111";  -- 42E4 = 87
      when "100001011100101" =>  data <= "10111101";  -- 42E5 = BD
      when "100001011100110" =>  data <= "10100101";  -- 42E6 = A5
      when "100001011100111" =>  data <= "01100011";  -- 42E7 = 63
      when "100001011101000" =>  data <= "00110000";  -- 42E8 = 30
      when "100001011101001" =>  data <= "00001101";  -- 42E9 = D
      when "100001011101010" =>  data <= "10100101";  -- 42EA = A5
      when "100001011101011" =>  data <= "01011110";  -- 42EB = 5E
      when "100001011101100" =>  data <= "11001001";  -- 42EC = C9
      when "100001011101101" =>  data <= "10010000";  -- 42ED = 90
      when "100001011101110" =>  data <= "10010000";  -- 42EE = 90
      when "100001011101111" =>  data <= "00001001";  -- 42EF = 9
      when "100001011110000" =>  data <= "10101001";  -- 42F0 = A9
      when "100001011110001" =>  data <= "11011001";  -- 42F1 = D9
      when "100001011110010" =>  data <= "10100000";  -- 42F2 = A0
      when "100001011110011" =>  data <= "11000010";  -- 42F3 = C2
      when "100001011110100" =>  data <= "00100000";  -- 42F4 = 20
      when "100001011110101" =>  data <= "10010001";  -- 42F5 = 91
      when "100001011110110" =>  data <= "11001101";  -- 42F6 = CD
      when "100001011110111" =>  data <= "11010000";  -- 42F7 = D0
      when "100001011111000" =>  data <= "01111010";  -- 42F8 = 7A
      when "100001011111001" =>  data <= "01001100";  -- 42F9 = 4C
      when "100001011111010" =>  data <= "11010001";  -- 42FA = D1
      when "100001011111011" =>  data <= "11001101";  -- 42FB = CD
      when "100001011111100" =>  data <= "10100101";  -- 42FC = A5
      when "100001011111101" =>  data <= "00000110";  -- 42FD = 6
      when "100001011111110" =>  data <= "00000101";  -- 42FE = 5
      when "100001011111111" =>  data <= "00001000";  -- 42FF = 8
      when "100001100000000" =>  data <= "01001000";  -- 4300 = 48
      when "100001100000001" =>  data <= "10100101";  -- 4301 = A5
      when "100001100000010" =>  data <= "00000111";  -- 4302 = 7
      when "100001100000011" =>  data <= "01001000";  -- 4303 = 48
      when "100001100000100" =>  data <= "10100000";  -- 4304 = A0
      when "100001100000101" =>  data <= "00000000";  -- 4305 = 0
      when "100001100000110" =>  data <= "10011000";  -- 4306 = 98
      when "100001100000111" =>  data <= "01001000";  -- 4307 = 48
      when "100001100001000" =>  data <= "10100101";  -- 4308 = A5
      when "100001100001001" =>  data <= "01000011";  -- 4309 = 43
      when "100001100001010" =>  data <= "01001000";  -- 430A = 48
      when "100001100001011" =>  data <= "10100101";  -- 430B = A5
      when "100001100001100" =>  data <= "01000010";  -- 430C = 42
      when "100001100001101" =>  data <= "01001000";  -- 430D = 48
      when "100001100001110" =>  data <= "00100000";  -- 430E = 20
      when "100001100001111" =>  data <= "11011101";  -- 430F = DD
      when "100001100010000" =>  data <= "11000010";  -- 4310 = C2
      when "100001100010001" =>  data <= "01101000";  -- 4311 = 68
      when "100001100010010" =>  data <= "10000101";  -- 4312 = 85
      when "100001100010011" =>  data <= "01000010";  -- 4313 = 42
      when "100001100010100" =>  data <= "01101000";  -- 4314 = 68
      when "100001100010101" =>  data <= "10000101";  -- 4315 = 85
      when "100001100010110" =>  data <= "01000011";  -- 4316 = 43
      when "100001100010111" =>  data <= "01101000";  -- 4317 = 68
      when "100001100011000" =>  data <= "10101000";  -- 4318 = A8
      when "100001100011001" =>  data <= "10111010";  -- 4319 = BA
      when "100001100011010" =>  data <= "10111101";  -- 431A = BD
      when "100001100011011" =>  data <= "00000010";  -- 431B = 2
      when "100001100011100" =>  data <= "00000001";  -- 431C = 1
      when "100001100011101" =>  data <= "01001000";  -- 431D = 48
      when "100001100011110" =>  data <= "10111101";  -- 431E = BD
      when "100001100011111" =>  data <= "00000001";  -- 431F = 1
      when "100001100100000" =>  data <= "00000001";  -- 4320 = 1
      when "100001100100001" =>  data <= "01001000";  -- 4321 = 48
      when "100001100100010" =>  data <= "10100101";  -- 4322 = A5
      when "100001100100011" =>  data <= "01100001";  -- 4323 = 61
      when "100001100100100" =>  data <= "10011101";  -- 4324 = 9D
      when "100001100100101" =>  data <= "00000010";  -- 4325 = 2
      when "100001100100110" =>  data <= "00000001";  -- 4326 = 1
      when "100001100100111" =>  data <= "10100101";  -- 4327 = A5
      when "100001100101000" =>  data <= "01100010";  -- 4328 = 62
      when "100001100101001" =>  data <= "10011101";  -- 4329 = 9D
      when "100001100101010" =>  data <= "00000001";  -- 432A = 1
      when "100001100101011" =>  data <= "00000001";  -- 432B = 1
      when "100001100101100" =>  data <= "11001000";  -- 432C = C8
      when "100001100101101" =>  data <= "00100000";  -- 432D = 20
      when "100001100101110" =>  data <= "01110110";  -- 432E = 76
      when "100001100101111" =>  data <= "00000000";  -- 432F = 0
      when "100001100110000" =>  data <= "11001001";  -- 4330 = C9
      when "100001100110001" =>  data <= "00101100";  -- 4331 = 2C
      when "100001100110010" =>  data <= "11110000";  -- 4332 = F0
      when "100001100110011" =>  data <= "11010010";  -- 4333 = D2
      when "100001100110100" =>  data <= "10000100";  -- 4334 = 84
      when "100001100110101" =>  data <= "00000101";  -- 4335 = 5
      when "100001100110110" =>  data <= "00100000";  -- 4336 = 20
      when "100001100110111" =>  data <= "11101111";  -- 4337 = EF
      when "100001100111000" =>  data <= "10111110";  -- 4338 = BE
      when "100001100111001" =>  data <= "01101000";  -- 4339 = 68
      when "100001100111010" =>  data <= "10000101";  -- 433A = 85
      when "100001100111011" =>  data <= "00000111";  -- 433B = 7
      when "100001100111100" =>  data <= "01101000";  -- 433C = 68
      when "100001100111101" =>  data <= "10000101";  -- 433D = 85
      when "100001100111110" =>  data <= "00001000";  -- 433E = 8
      when "100001100111111" =>  data <= "00101001";  -- 433F = 29
      when "100001101000000" =>  data <= "01111111";  -- 4340 = 7F
      when "100001101000001" =>  data <= "10000101";  -- 4341 = 85
      when "100001101000010" =>  data <= "00000110";  -- 4342 = 6
      when "100001101000011" =>  data <= "10100110";  -- 4343 = A6
      when "100001101000100" =>  data <= "00101100";  -- 4344 = 2C
      when "100001101000101" =>  data <= "10100101";  -- 4345 = A5
      when "100001101000110" =>  data <= "00101101";  -- 4346 = 2D
      when "100001101000111" =>  data <= "10000110";  -- 4347 = 86
      when "100001101001000" =>  data <= "01011100";  -- 4348 = 5C
      when "100001101001001" =>  data <= "10000101";  -- 4349 = 85
      when "100001101001010" =>  data <= "01011101";  -- 434A = 5D
      when "100001101001011" =>  data <= "11000101";  -- 434B = C5
      when "100001101001100" =>  data <= "00101111";  -- 434C = 2F
      when "100001101001101" =>  data <= "11010000";  -- 434D = D0
      when "100001101001110" =>  data <= "00000100";  -- 434E = 4
      when "100001101001111" =>  data <= "11100100";  -- 434F = E4
      when "100001101010000" =>  data <= "00101110";  -- 4350 = 2E
      when "100001101010001" =>  data <= "11110000";  -- 4351 = F0
      when "100001101010010" =>  data <= "00111001";  -- 4352 = 39
      when "100001101010011" =>  data <= "10100000";  -- 4353 = A0
      when "100001101010100" =>  data <= "00000000";  -- 4354 = 0
      when "100001101010101" =>  data <= "10110001";  -- 4355 = B1
      when "100001101010110" =>  data <= "01011100";  -- 4356 = 5C
      when "100001101010111" =>  data <= "11001000";  -- 4357 = C8
      when "100001101011000" =>  data <= "11000101";  -- 4358 = C5
      when "100001101011001" =>  data <= "01000010";  -- 4359 = 42
      when "100001101011010" =>  data <= "11010000";  -- 435A = D0
      when "100001101011011" =>  data <= "00000110";  -- 435B = 6
      when "100001101011100" =>  data <= "10100101";  -- 435C = A5
      when "100001101011101" =>  data <= "01000011";  -- 435D = 43
      when "100001101011110" =>  data <= "11010001";  -- 435E = D1
      when "100001101011111" =>  data <= "01011100";  -- 435F = 5C
      when "100001101100000" =>  data <= "11110000";  -- 4360 = F0
      when "100001101100001" =>  data <= "00010110";  -- 4361 = 16
      when "100001101100010" =>  data <= "11001000";  -- 4362 = C8
      when "100001101100011" =>  data <= "10110001";  -- 4363 = B1
      when "100001101100100" =>  data <= "01011100";  -- 4364 = 5C
      when "100001101100101" =>  data <= "00011000";  -- 4365 = 18
      when "100001101100110" =>  data <= "01100101";  -- 4366 = 65
      when "100001101100111" =>  data <= "01011100";  -- 4367 = 5C
      when "100001101101000" =>  data <= "10101010";  -- 4368 = AA
      when "100001101101001" =>  data <= "11001000";  -- 4369 = C8
      when "100001101101010" =>  data <= "10110001";  -- 436A = B1
      when "100001101101011" =>  data <= "01011100";  -- 436B = 5C
      when "100001101101100" =>  data <= "01100101";  -- 436C = 65
      when "100001101101101" =>  data <= "01011101";  -- 436D = 5D
      when "100001101101110" =>  data <= "10010000";  -- 436E = 90
      when "100001101101111" =>  data <= "11010111";  -- 436F = D7
      when "100001101110000" =>  data <= "10100010";  -- 4370 = A2
      when "100001101110001" =>  data <= "01101011";  -- 4371 = 6B
      when "100001101110010" =>  data <= "00101100";  -- 4372 = 2C
      when "100001101110011" =>  data <= "10100010";  -- 4373 = A2
      when "100001101110100" =>  data <= "00110101";  -- 4374 = 35
      when "100001101110101" =>  data <= "01001100";  -- 4375 = 4C
      when "100001101110110" =>  data <= "11001111";  -- 4376 = CF
      when "100001101110111" =>  data <= "10110011";  -- 4377 = B3
      when "100001101111000" =>  data <= "10100010";  -- 4378 = A2
      when "100001101111001" =>  data <= "01111000";  -- 4379 = 78
      when "100001101111010" =>  data <= "10100101";  -- 437A = A5
      when "100001101111011" =>  data <= "00000110";  -- 437B = 6
      when "100001101111100" =>  data <= "11010000";  -- 437C = D0
      when "100001101111101" =>  data <= "11110111";  -- 437D = F7
      when "100001101111110" =>  data <= "00100000";  -- 437E = 20
      when "100001101111111" =>  data <= "11001000";  -- 437F = C8
      when "100001110000000" =>  data <= "11000010";  -- 4380 = C2
      when "100001110000001" =>  data <= "10100101";  -- 4381 = A5
      when "100001110000010" =>  data <= "00000101";  -- 4382 = 5
      when "100001110000011" =>  data <= "10100000";  -- 4383 = A0
      when "100001110000100" =>  data <= "00000100";  -- 4384 = 4
      when "100001110000101" =>  data <= "11010001";  -- 4385 = D1
      when "100001110000110" =>  data <= "01011100";  -- 4386 = 5C
      when "100001110000111" =>  data <= "11010000";  -- 4387 = D0
      when "100001110001000" =>  data <= "11100111";  -- 4388 = E7
      when "100001110001001" =>  data <= "01001100";  -- 4389 = 4C
      when "100001110001010" =>  data <= "00010101";  -- 438A = 15
      when "100001110001011" =>  data <= "11000100";  -- 438B = C4
      when "100001110001100" =>  data <= "00100000";  -- 438C = 20
      when "100001110001101" =>  data <= "11001000";  -- 438D = C8
      when "100001110001110" =>  data <= "11000010";  -- 438E = C2
      when "100001110001111" =>  data <= "00100000";  -- 438F = 20
      when "100001110010000" =>  data <= "10100000";  -- 4390 = A0
      when "100001110010001" =>  data <= "10110011";  -- 4391 = B3
      when "100001110010010" =>  data <= "10100000";  -- 4392 = A0
      when "100001110010011" =>  data <= "00000000";  -- 4393 = 0
      when "100001110010100" =>  data <= "10000100";  -- 4394 = 84
      when "100001110010101" =>  data <= "01101111";  -- 4395 = 6F
      when "100001110010110" =>  data <= "10100010";  -- 4396 = A2
      when "100001110010111" =>  data <= "00000101";  -- 4397 = 5
      when "100001110011000" =>  data <= "10100101";  -- 4398 = A5
      when "100001110011001" =>  data <= "01000010";  -- 4399 = 42
      when "100001110011010" =>  data <= "10010001";  -- 439A = 91
      when "100001110011011" =>  data <= "01011100";  -- 439B = 5C
      when "100001110011100" =>  data <= "00010000";  -- 439C = 10
      when "100001110011101" =>  data <= "00000001";  -- 439D = 1
      when "100001110011110" =>  data <= "11001010";  -- 439E = CA
      when "100001110011111" =>  data <= "11001000";  -- 439F = C8
      when "100001110100000" =>  data <= "10100101";  -- 43A0 = A5
      when "100001110100001" =>  data <= "01000011";  -- 43A1 = 43
      when "100001110100010" =>  data <= "10010001";  -- 43A2 = 91
      when "100001110100011" =>  data <= "01011100";  -- 43A3 = 5C
      when "100001110100100" =>  data <= "00010000";  -- 43A4 = 10
      when "100001110100101" =>  data <= "00000010";  -- 43A5 = 2
      when "100001110100110" =>  data <= "11001010";  -- 43A6 = CA
      when "100001110100111" =>  data <= "11001010";  -- 43A7 = CA
      when "100001110101000" =>  data <= "10000110";  -- 43A8 = 86
      when "100001110101001" =>  data <= "01101110";  -- 43A9 = 6E
      when "100001110101010" =>  data <= "10100101";  -- 43AA = A5
      when "100001110101011" =>  data <= "00000101";  -- 43AB = 5
      when "100001110101100" =>  data <= "11001000";  -- 43AC = C8
      when "100001110101101" =>  data <= "11001000";  -- 43AD = C8
      when "100001110101110" =>  data <= "11001000";  -- 43AE = C8
      when "100001110101111" =>  data <= "10010001";  -- 43AF = 91
      when "100001110110000" =>  data <= "01011100";  -- 43B0 = 5C
      when "100001110110001" =>  data <= "10100010";  -- 43B1 = A2
      when "100001110110010" =>  data <= "00001011";  -- 43B2 = B
      when "100001110110011" =>  data <= "10101001";  -- 43B3 = A9
      when "100001110110100" =>  data <= "00000000";  -- 43B4 = 0
      when "100001110110101" =>  data <= "00100100";  -- 43B5 = 24
      when "100001110110110" =>  data <= "00000110";  -- 43B6 = 6
      when "100001110110111" =>  data <= "01010000";  -- 43B7 = 50
      when "100001110111000" =>  data <= "00001000";  -- 43B8 = 8
      when "100001110111001" =>  data <= "01101000";  -- 43B9 = 68
      when "100001110111010" =>  data <= "00011000";  -- 43BA = 18
      when "100001110111011" =>  data <= "01101001";  -- 43BB = 69
      when "100001110111100" =>  data <= "00000001";  -- 43BC = 1
      when "100001110111101" =>  data <= "10101010";  -- 43BD = AA
      when "100001110111110" =>  data <= "01101000";  -- 43BE = 68
      when "100001110111111" =>  data <= "01101001";  -- 43BF = 69
      when "100001111000000" =>  data <= "00000000";  -- 43C0 = 0
      when "100001111000001" =>  data <= "11001000";  -- 43C1 = C8
      when "100001111000010" =>  data <= "10010001";  -- 43C2 = 91
      when "100001111000011" =>  data <= "01011100";  -- 43C3 = 5C
      when "100001111000100" =>  data <= "11001000";  -- 43C4 = C8
      when "100001111000101" =>  data <= "10001010";  -- 43C5 = 8A
      when "100001111000110" =>  data <= "10010001";  -- 43C6 = 91
      when "100001111000111" =>  data <= "01011100";  -- 43C7 = 5C
      when "100001111001000" =>  data <= "00100000";  -- 43C8 = 20
      when "100001111001001" =>  data <= "01110111";  -- 43C9 = 77
      when "100001111001010" =>  data <= "11000100";  -- 43CA = C4
      when "100001111001011" =>  data <= "10000110";  -- 43CB = 86
      when "100001111001100" =>  data <= "01101110";  -- 43CC = 6E
      when "100001111001101" =>  data <= "10000101";  -- 43CD = 85
      when "100001111001110" =>  data <= "01101111";  -- 43CE = 6F
      when "100001111001111" =>  data <= "10100100";  -- 43CF = A4
      when "100001111010000" =>  data <= "00011111";  -- 43D0 = 1F
      when "100001111010001" =>  data <= "11000110";  -- 43D1 = C6
      when "100001111010010" =>  data <= "00000101";  -- 43D2 = 5
      when "100001111010011" =>  data <= "11010000";  -- 43D3 = D0
      when "100001111010100" =>  data <= "11011100";  -- 43D4 = DC
      when "100001111010101" =>  data <= "01100101";  -- 43D5 = 65
      when "100001111010110" =>  data <= "01010110";  -- 43D6 = 56
      when "100001111010111" =>  data <= "10110000";  -- 43D7 = B0
      when "100001111011000" =>  data <= "01011101";  -- 43D8 = 5D
      when "100001111011001" =>  data <= "10000101";  -- 43D9 = 85
      when "100001111011010" =>  data <= "01010110";  -- 43DA = 56
      when "100001111011011" =>  data <= "10101000";  -- 43DB = A8
      when "100001111011100" =>  data <= "10001010";  -- 43DC = 8A
      when "100001111011101" =>  data <= "01100101";  -- 43DD = 65
      when "100001111011110" =>  data <= "01010101";  -- 43DE = 55
      when "100001111011111" =>  data <= "10010000";  -- 43DF = 90
      when "100001111100000" =>  data <= "00000011";  -- 43E0 = 3
      when "100001111100001" =>  data <= "11001000";  -- 43E1 = C8
      when "100001111100010" =>  data <= "11110000";  -- 43E2 = F0
      when "100001111100011" =>  data <= "01010010";  -- 43E3 = 52
      when "100001111100100" =>  data <= "00100000";  -- 43E4 = 20
      when "100001111100101" =>  data <= "10100000";  -- 43E5 = A0
      when "100001111100110" =>  data <= "10110011";  -- 43E6 = B3
      when "100001111100111" =>  data <= "10000101";  -- 43E7 = 85
      when "100001111101000" =>  data <= "00101110";  -- 43E8 = 2E
      when "100001111101001" =>  data <= "10000100";  -- 43E9 = 84
      when "100001111101010" =>  data <= "00101111";  -- 43EA = 2F
      when "100001111101011" =>  data <= "10101001";  -- 43EB = A9
      when "100001111101100" =>  data <= "00000000";  -- 43EC = 0
      when "100001111101101" =>  data <= "11100110";  -- 43ED = E6
      when "100001111101110" =>  data <= "01101111";  -- 43EE = 6F
      when "100001111101111" =>  data <= "10100100";  -- 43EF = A4
      when "100001111110000" =>  data <= "01101110";  -- 43F0 = 6E
      when "100001111110001" =>  data <= "11110000";  -- 43F1 = F0
      when "100001111110010" =>  data <= "00000101";  -- 43F2 = 5
      when "100001111110011" =>  data <= "10001000";  -- 43F3 = 88
      when "100001111110100" =>  data <= "10010001";  -- 43F4 = 91
      when "100001111110101" =>  data <= "01010101";  -- 43F5 = 55
      when "100001111110110" =>  data <= "11010000";  -- 43F6 = D0
      when "100001111110111" =>  data <= "11111011";  -- 43F7 = FB
      when "100001111111000" =>  data <= "11000110";  -- 43F8 = C6
      when "100001111111001" =>  data <= "01010110";  -- 43F9 = 56
      when "100001111111010" =>  data <= "11000110";  -- 43FA = C6
      when "100001111111011" =>  data <= "01101111";  -- 43FB = 6F
      when "100001111111100" =>  data <= "11010000";  -- 43FC = D0
      when "100001111111101" =>  data <= "11110101";  -- 43FD = F5
      when "100001111111110" =>  data <= "11100110";  -- 43FE = E6
      when "100001111111111" =>  data <= "01010110";  -- 43FF = 56
      when "100010000000000" =>  data <= "00111000";  -- 4400 = 38
      when "100010000000001" =>  data <= "10100101";  -- 4401 = A5
      when "100010000000010" =>  data <= "00101110";  -- 4402 = 2E
      when "100010000000011" =>  data <= "11100101";  -- 4403 = E5
      when "100010000000100" =>  data <= "01011100";  -- 4404 = 5C
      when "100010000000101" =>  data <= "10100000";  -- 4405 = A0
      when "100010000000110" =>  data <= "00000010";  -- 4406 = 2
      when "100010000000111" =>  data <= "10010001";  -- 4407 = 91
      when "100010000001000" =>  data <= "01011100";  -- 4408 = 5C
      when "100010000001001" =>  data <= "10100101";  -- 4409 = A5
      when "100010000001010" =>  data <= "00101111";  -- 440A = 2F
      when "100010000001011" =>  data <= "11001000";  -- 440B = C8
      when "100010000001100" =>  data <= "11100101";  -- 440C = E5
      when "100010000001101" =>  data <= "01011101";  -- 440D = 5D
      when "100010000001110" =>  data <= "10010001";  -- 440E = 91
      when "100010000001111" =>  data <= "01011100";  -- 440F = 5C
      when "100010000010000" =>  data <= "10100101";  -- 4410 = A5
      when "100010000010001" =>  data <= "00000110";  -- 4411 = 6
      when "100010000010010" =>  data <= "11010000";  -- 4412 = D0
      when "100010000010011" =>  data <= "01100010";  -- 4413 = 62
      when "100010000010100" =>  data <= "11001000";  -- 4414 = C8
      when "100010000010101" =>  data <= "10110001";  -- 4415 = B1
      when "100010000010110" =>  data <= "01011100";  -- 4416 = 5C
      when "100010000010111" =>  data <= "10000101";  -- 4417 = 85
      when "100010000011000" =>  data <= "00000101";  -- 4418 = 5
      when "100010000011001" =>  data <= "10101001";  -- 4419 = A9
      when "100010000011010" =>  data <= "00000000";  -- 441A = 0
      when "100010000011011" =>  data <= "10000101";  -- 441B = 85
      when "100010000011100" =>  data <= "01101110";  -- 441C = 6E
      when "100010000011101" =>  data <= "10000101";  -- 441D = 85
      when "100010000011110" =>  data <= "01101111";  -- 441E = 6F
      when "100010000011111" =>  data <= "11001000";  -- 441F = C8
      when "100010000100000" =>  data <= "01101000";  -- 4420 = 68
      when "100010000100001" =>  data <= "10101010";  -- 4421 = AA
      when "100010000100010" =>  data <= "10000101";  -- 4422 = 85
      when "100010000100011" =>  data <= "01100001";  -- 4423 = 61
      when "100010000100100" =>  data <= "01101000";  -- 4424 = 68
      when "100010000100101" =>  data <= "10000101";  -- 4425 = 85
      when "100010000100110" =>  data <= "01100010";  -- 4426 = 62
      when "100010000100111" =>  data <= "11010001";  -- 4427 = D1
      when "100010000101000" =>  data <= "01011100";  -- 4428 = 5C
      when "100010000101001" =>  data <= "10010000";  -- 4429 = 90
      when "100010000101010" =>  data <= "00001110";  -- 442A = E
      when "100010000101011" =>  data <= "11010000";  -- 442B = D0
      when "100010000101100" =>  data <= "00000110";  -- 442C = 6
      when "100010000101101" =>  data <= "11001000";  -- 442D = C8
      when "100010000101110" =>  data <= "10001010";  -- 442E = 8A
      when "100010000101111" =>  data <= "11010001";  -- 442F = D1
      when "100010000110000" =>  data <= "01011100";  -- 4430 = 5C
      when "100010000110001" =>  data <= "10010000";  -- 4431 = 90
      when "100010000110010" =>  data <= "00000111";  -- 4432 = 7
      when "100010000110011" =>  data <= "01001100";  -- 4433 = 4C
      when "100010000110100" =>  data <= "01110000";  -- 4434 = 70
      when "100010000110101" =>  data <= "11000011";  -- 4435 = C3
      when "100010000110110" =>  data <= "01001100";  -- 4436 = 4C
      when "100010000110111" =>  data <= "11001101";  -- 4437 = CD
      when "100010000111000" =>  data <= "10110011";  -- 4438 = B3
      when "100010000111001" =>  data <= "11001000";  -- 4439 = C8
      when "100010000111010" =>  data <= "10100101";  -- 443A = A5
      when "100010000111011" =>  data <= "01101111";  -- 443B = 6F
      when "100010000111100" =>  data <= "00000101";  -- 443C = 5
      when "100010000111101" =>  data <= "01101110";  -- 443D = 6E
      when "100010000111110" =>  data <= "00011000";  -- 443E = 18
      when "100010000111111" =>  data <= "11110000";  -- 443F = F0
      when "100010001000000" =>  data <= "00001010";  -- 4440 = A
      when "100010001000001" =>  data <= "00100000";  -- 4441 = 20
      when "100010001000010" =>  data <= "01110111";  -- 4442 = 77
      when "100010001000011" =>  data <= "11000100";  -- 4443 = C4
      when "100010001000100" =>  data <= "10001010";  -- 4444 = 8A
      when "100010001000101" =>  data <= "01100101";  -- 4445 = 65
      when "100010001000110" =>  data <= "01100001";  -- 4446 = 61
      when "100010001000111" =>  data <= "10101010";  -- 4447 = AA
      when "100010001001000" =>  data <= "10011000";  -- 4448 = 98
      when "100010001001001" =>  data <= "10100100";  -- 4449 = A4
      when "100010001001010" =>  data <= "00011111";  -- 444A = 1F
      when "100010001001011" =>  data <= "01100101";  -- 444B = 65
      when "100010001001100" =>  data <= "01100010";  -- 444C = 62
      when "100010001001101" =>  data <= "10000110";  -- 444D = 86
      when "100010001001110" =>  data <= "01101110";  -- 444E = 6E
      when "100010001001111" =>  data <= "11000110";  -- 444F = C6
      when "100010001010000" =>  data <= "00000101";  -- 4450 = 5
      when "100010001010001" =>  data <= "11010000";  -- 4451 = D0
      when "100010001010010" =>  data <= "11001010";  -- 4452 = CA
      when "100010001010011" =>  data <= "10000101";  -- 4453 = 85
      when "100010001010100" =>  data <= "01101111";  -- 4454 = 6F
      when "100010001010101" =>  data <= "10100010";  -- 4455 = A2
      when "100010001010110" =>  data <= "00000101";  -- 4456 = 5
      when "100010001010111" =>  data <= "10100101";  -- 4457 = A5
      when "100010001011000" =>  data <= "01000010";  -- 4458 = 42
      when "100010001011001" =>  data <= "00010000";  -- 4459 = 10
      when "100010001011010" =>  data <= "00000001";  -- 445A = 1
      when "100010001011011" =>  data <= "11001010";  -- 445B = CA
      when "100010001011100" =>  data <= "10100101";  -- 445C = A5
      when "100010001011101" =>  data <= "01000011";  -- 445D = 43
      when "100010001011110" =>  data <= "00010000";  -- 445E = 10
      when "100010001011111" =>  data <= "00000010";  -- 445F = 2
      when "100010001100000" =>  data <= "11001010";  -- 4460 = CA
      when "100010001100001" =>  data <= "11001010";  -- 4461 = CA
      when "100010001100010" =>  data <= "10000110";  -- 4462 = 86
      when "100010001100011" =>  data <= "00100101";  -- 4463 = 25
      when "100010001100100" =>  data <= "10101001";  -- 4464 = A9
      when "100010001100101" =>  data <= "00000000";  -- 4465 = 0
      when "100010001100110" =>  data <= "00100000";  -- 4466 = 20
      when "100010001100111" =>  data <= "10000000";  -- 4467 = 80
      when "100010001101000" =>  data <= "11000100";  -- 4468 = C4
      when "100010001101001" =>  data <= "10001010";  -- 4469 = 8A
      when "100010001101010" =>  data <= "01100101";  -- 446A = 65
      when "100010001101011" =>  data <= "01010101";  -- 446B = 55
      when "100010001101100" =>  data <= "10000101";  -- 446C = 85
      when "100010001101101" =>  data <= "01000100";  -- 446D = 44
      when "100010001101110" =>  data <= "10011000";  -- 446E = 98
      when "100010001101111" =>  data <= "01100101";  -- 446F = 65
      when "100010001110000" =>  data <= "01010110";  -- 4470 = 56
      when "100010001110001" =>  data <= "10000101";  -- 4471 = 85
      when "100010001110010" =>  data <= "01000101";  -- 4472 = 45
      when "100010001110011" =>  data <= "10101000";  -- 4473 = A8
      when "100010001110100" =>  data <= "10100101";  -- 4474 = A5
      when "100010001110101" =>  data <= "01000100";  -- 4475 = 44
      when "100010001110110" =>  data <= "01100000";  -- 4476 = 60
      when "100010001110111" =>  data <= "10000100";  -- 4477 = 84
      when "100010001111000" =>  data <= "00011111";  -- 4478 = 1F
      when "100010001111001" =>  data <= "10110001";  -- 4479 = B1
      when "100010001111010" =>  data <= "01011100";  -- 447A = 5C
      when "100010001111011" =>  data <= "10000101";  -- 447B = 85
      when "100010001111100" =>  data <= "00100101";  -- 447C = 25
      when "100010001111101" =>  data <= "10001000";  -- 447D = 88
      when "100010001111110" =>  data <= "10110001";  -- 447E = B1
      when "100010001111111" =>  data <= "01011100";  -- 447F = 5C
      when "100010010000000" =>  data <= "10000101";  -- 4480 = 85
      when "100010010000001" =>  data <= "00100110";  -- 4481 = 26
      when "100010010000010" =>  data <= "10101001";  -- 4482 = A9
      when "100010010000011" =>  data <= "00010000";  -- 4483 = 10
      when "100010010000100" =>  data <= "10000101";  -- 4484 = 85
      when "100010010000101" =>  data <= "01011010";  -- 4485 = 5A
      when "100010010000110" =>  data <= "10100010";  -- 4486 = A2
      when "100010010000111" =>  data <= "00000000";  -- 4487 = 0
      when "100010010001000" =>  data <= "10100000";  -- 4488 = A0
      when "100010010001001" =>  data <= "00000000";  -- 4489 = 0
      when "100010010001010" =>  data <= "10001010";  -- 448A = 8A
      when "100010010001011" =>  data <= "00001010";  -- 448B = A
      when "100010010001100" =>  data <= "10101010";  -- 448C = AA
      when "100010010001101" =>  data <= "10011000";  -- 448D = 98
      when "100010010001110" =>  data <= "00101010";  -- 448E = 2A
      when "100010010001111" =>  data <= "10101000";  -- 448F = A8
      when "100010010010000" =>  data <= "10110000";  -- 4490 = B0
      when "100010010010001" =>  data <= "10100100";  -- 4491 = A4
      when "100010010010010" =>  data <= "00000110";  -- 4492 = 6
      when "100010010010011" =>  data <= "01101110";  -- 4493 = 6E
      when "100010010010100" =>  data <= "00100110";  -- 4494 = 26
      when "100010010010101" =>  data <= "01101111";  -- 4495 = 6F
      when "100010010010110" =>  data <= "10010000";  -- 4496 = 90
      when "100010010010111" =>  data <= "00001011";  -- 4497 = B
      when "100010010011000" =>  data <= "00011000";  -- 4498 = 18
      when "100010010011001" =>  data <= "10001010";  -- 4499 = 8A
      when "100010010011010" =>  data <= "01100101";  -- 449A = 65
      when "100010010011011" =>  data <= "00100101";  -- 449B = 25
      when "100010010011100" =>  data <= "10101010";  -- 449C = AA
      when "100010010011101" =>  data <= "10011000";  -- 449D = 98
      when "100010010011110" =>  data <= "01100101";  -- 449E = 65
      when "100010010011111" =>  data <= "00100110";  -- 449F = 26
      when "100010010100000" =>  data <= "10101000";  -- 44A0 = A8
      when "100010010100001" =>  data <= "10110000";  -- 44A1 = B0
      when "100010010100010" =>  data <= "10010011";  -- 44A2 = 93
      when "100010010100011" =>  data <= "11000110";  -- 44A3 = C6
      when "100010010100100" =>  data <= "01011010";  -- 44A4 = 5A
      when "100010010100101" =>  data <= "11010000";  -- 44A5 = D0
      when "100010010100110" =>  data <= "11100011";  -- 44A6 = E3
      when "100010010100111" =>  data <= "01100000";  -- 44A7 = 60
      when "100010010101000" =>  data <= "10100101";  -- 44A8 = A5
      when "100010010101001" =>  data <= "00000111";  -- 44A9 = 7
      when "100010010101010" =>  data <= "11110000";  -- 44AA = F0
      when "100010010101011" =>  data <= "00000011";  -- 44AB = 3
      when "100010010101100" =>  data <= "00100000";  -- 44AC = 20
      when "100010010101101" =>  data <= "10111000";  -- 44AD = B8
      when "100010010101110" =>  data <= "11000111";  -- 44AE = C7
      when "100010010101111" =>  data <= "00100000";  -- 44AF = 20
      when "100010010110000" =>  data <= "01101010";  -- 44B0 = 6A
      when "100010010110001" =>  data <= "11000110";  -- 44B1 = C6
      when "100010010110010" =>  data <= "00111000";  -- 44B2 = 38
      when "100010010110011" =>  data <= "10100101";  -- 44B3 = A5
      when "100010010110100" =>  data <= "00110000";  -- 44B4 = 30
      when "100010010110101" =>  data <= "11100101";  -- 44B5 = E5
      when "100010010110110" =>  data <= "00101110";  -- 44B6 = 2E
      when "100010010110111" =>  data <= "10101000";  -- 44B7 = A8
      when "100010010111000" =>  data <= "10100101";  -- 44B8 = A5
      when "100010010111001" =>  data <= "00110001";  -- 44B9 = 31
      when "100010010111010" =>  data <= "11100101";  -- 44BA = E5
      when "100010010111011" =>  data <= "00101111";  -- 44BB = 2F
      when "100010010111100" =>  data <= "10100010";  -- 44BC = A2
      when "100010010111101" =>  data <= "00000000";  -- 44BD = 0
      when "100010010111110" =>  data <= "10000110";  -- 44BE = 86
      when "100010010111111" =>  data <= "00000111";  -- 44BF = 7
      when "100010011000000" =>  data <= "10000101";  -- 44C0 = 85
      when "100010011000001" =>  data <= "01011111";  -- 44C1 = 5F
      when "100010011000010" =>  data <= "10000100";  -- 44C2 = 84
      when "100010011000011" =>  data <= "01100000";  -- 44C3 = 60
      when "100010011000100" =>  data <= "10100010";  -- 44C4 = A2
      when "100010011000101" =>  data <= "10010000";  -- 44C5 = 90
      when "100010011000110" =>  data <= "01001100";  -- 44C6 = 4C
      when "100010011000111" =>  data <= "01111010";  -- 44C7 = 7A
      when "100010011001000" =>  data <= "11001101";  -- 44C8 = CD
      when "100010011001001" =>  data <= "10100100";  -- 44C9 = A4
      when "100010011001010" =>  data <= "11000110";  -- 44CA = C6
      when "100010011001011" =>  data <= "10101001";  -- 44CB = A9
      when "100010011001100" =>  data <= "00000000";  -- 44CC = 0
      when "100010011001101" =>  data <= "11110000";  -- 44CD = F0
      when "100010011001110" =>  data <= "11101101";  -- 44CE = ED
      when "100010011001111" =>  data <= "10100110";  -- 44CF = A6
      when "100010011010000" =>  data <= "00110111";  -- 44D0 = 37
      when "100010011010001" =>  data <= "11101000";  -- 44D1 = E8
      when "100010011010010" =>  data <= "11010000";  -- 44D2 = D0
      when "100010011010011" =>  data <= "10100010";  -- 44D3 = A2
      when "100010011010100" =>  data <= "10100010";  -- 44D4 = A2
      when "100010011010101" =>  data <= "10010101";  -- 44D5 = 95
      when "100010011010110" =>  data <= "00101100";  -- 44D6 = 2C
      when "100010011010111" =>  data <= "10100010";  -- 44D7 = A2
      when "100010011011000" =>  data <= "11101001";  -- 44D8 = E9
      when "100010011011001" =>  data <= "01001100";  -- 44D9 = 4C
      when "100010011011010" =>  data <= "11001111";  -- 44DA = CF
      when "100010011011011" =>  data <= "10110011";  -- 44DB = B3
      when "100010011011100" =>  data <= "00100000";  -- 44DC = 20
      when "100010011011101" =>  data <= "00001010";  -- 44DD = A
      when "100010011011110" =>  data <= "11000101";  -- 44DE = C5
      when "100010011011111" =>  data <= "00100000";  -- 44DF = 20
      when "100010011100000" =>  data <= "11001111";  -- 44E0 = CF
      when "100010011100001" =>  data <= "11000100";  -- 44E1 = C4
      when "100010011100010" =>  data <= "00100000";  -- 44E2 = 20
      when "100010011100011" =>  data <= "11110010";  -- 44E3 = F2
      when "100010011100100" =>  data <= "10111110";  -- 44E4 = BE
      when "100010011100101" =>  data <= "10101001";  -- 44E5 = A9
      when "100010011100110" =>  data <= "10000000";  -- 44E6 = 80
      when "100010011100111" =>  data <= "10000101";  -- 44E7 = 85
      when "100010011101000" =>  data <= "00001010";  -- 44E8 = A
      when "100010011101001" =>  data <= "00100000";  -- 44E9 = 20
      when "100010011101010" =>  data <= "00101011";  -- 44EA = 2B
      when "100010011101011" =>  data <= "11000001";  -- 44EB = C1
      when "100010011101100" =>  data <= "00100000";  -- 44EC = 20
      when "100010011101101" =>  data <= "10000111";  -- 44ED = 87
      when "100010011101110" =>  data <= "10111101";  -- 44EE = BD
      when "100010011101111" =>  data <= "00100000";  -- 44EF = 20
      when "100010011110000" =>  data <= "11101111";  -- 44F0 = EF
      when "100010011110001" =>  data <= "10111110";  -- 44F1 = BE
      when "100010011110010" =>  data <= "10101001";  -- 44F2 = A9
      when "100010011110011" =>  data <= "10110010";  -- 44F3 = B2
      when "100010011110100" =>  data <= "00100000";  -- 44F4 = 20
      when "100010011110101" =>  data <= "11110111";  -- 44F5 = F7
      when "100010011110110" =>  data <= "10111110";  -- 44F6 = BE
      when "100010011110111" =>  data <= "01001000";  -- 44F7 = 48
      when "100010011111000" =>  data <= "10100101";  -- 44F8 = A5
      when "100010011111001" =>  data <= "01000101";  -- 44F9 = 45
      when "100010011111010" =>  data <= "01001000";  -- 44FA = 48
      when "100010011111011" =>  data <= "10100101";  -- 44FB = A5
      when "100010011111100" =>  data <= "01000100";  -- 44FC = 44
      when "100010011111101" =>  data <= "01001000";  -- 44FD = 48
      when "100010011111110" =>  data <= "10100101";  -- 44FE = A5
      when "100010011111111" =>  data <= "01111000";  -- 44FF = 78
      when "100010100000000" =>  data <= "01001000";  -- 4500 = 48
      when "100010100000001" =>  data <= "10100101";  -- 4501 = A5
      when "100010100000010" =>  data <= "01110111";  -- 4502 = 77
      when "100010100000011" =>  data <= "01001000";  -- 4503 = 48
      when "100010100000100" =>  data <= "00100000";  -- 4504 = 20
      when "100010100000101" =>  data <= "10000011";  -- 4505 = 83
      when "100010100000110" =>  data <= "10111000";  -- 4506 = B8
      when "100010100000111" =>  data <= "01001100";  -- 4507 = 4C
      when "100010100001000" =>  data <= "01111000";  -- 4508 = 78
      when "100010100001001" =>  data <= "11000101";  -- 4509 = C5
      when "100010100001010" =>  data <= "10101001";  -- 450A = A9
      when "100010100001011" =>  data <= "10100101";  -- 450B = A5
      when "100010100001100" =>  data <= "00100000";  -- 450C = 20
      when "100010100001101" =>  data <= "11110111";  -- 450D = F7
      when "100010100001110" =>  data <= "10111110";  -- 450E = BE
      when "100010100001111" =>  data <= "00001001";  -- 450F = 9
      when "100010100010000" =>  data <= "10000000";  -- 4510 = 80
      when "100010100010001" =>  data <= "10000101";  -- 4511 = 85
      when "100010100010010" =>  data <= "00001010";  -- 4512 = A
      when "100010100010011" =>  data <= "00100000";  -- 4513 = 20
      when "100010100010100" =>  data <= "00110010";  -- 4514 = 32
      when "100010100010101" =>  data <= "11000001";  -- 4515 = C1
      when "100010100010110" =>  data <= "10000101";  -- 4516 = 85
      when "100010100010111" =>  data <= "01001011";  -- 4517 = 4B
      when "100010100011000" =>  data <= "10000100";  -- 4518 = 84
      when "100010100011001" =>  data <= "01001100";  -- 4519 = 4C
      when "100010100011010" =>  data <= "01001100";  -- 451A = 4C
      when "100010100011011" =>  data <= "10000111";  -- 451B = 87
      when "100010100011100" =>  data <= "10111101";  -- 451C = BD
      when "100010100011101" =>  data <= "00100000";  -- 451D = 20
      when "100010100011110" =>  data <= "00001010";  -- 451E = A
      when "100010100011111" =>  data <= "11000101";  -- 451F = C5
      when "100010100100000" =>  data <= "10100101";  -- 4520 = A5
      when "100010100100001" =>  data <= "01001100";  -- 4521 = 4C
      when "100010100100010" =>  data <= "01001000";  -- 4522 = 48
      when "100010100100011" =>  data <= "10100101";  -- 4523 = A5
      when "100010100100100" =>  data <= "01001011";  -- 4524 = 4B
      when "100010100100101" =>  data <= "01001000";  -- 4525 = 48
      when "100010100100110" =>  data <= "00100000";  -- 4526 = 20
      when "100010100100111" =>  data <= "11101001";  -- 4527 = E9
      when "100010100101000" =>  data <= "10111110";  -- 4528 = BE
      when "100010100101001" =>  data <= "00100000";  -- 4529 = 20
      when "100010100101010" =>  data <= "10000111";  -- 452A = 87
      when "100010100101011" =>  data <= "10111101";  -- 452B = BD
      when "100010100101100" =>  data <= "01101000";  -- 452C = 68
      when "100010100101101" =>  data <= "10000101";  -- 452D = 85
      when "100010100101110" =>  data <= "01001011";  -- 452E = 4B
      when "100010100101111" =>  data <= "01101000";  -- 452F = 68
      when "100010100110000" =>  data <= "10000101";  -- 4530 = 85
      when "100010100110001" =>  data <= "01001100";  -- 4531 = 4C
      when "100010100110010" =>  data <= "10100000";  -- 4532 = A0
      when "100010100110011" =>  data <= "00000010";  -- 4533 = 2
      when "100010100110100" =>  data <= "10110001";  -- 4534 = B1
      when "100010100110101" =>  data <= "01001011";  -- 4535 = 4B
      when "100010100110110" =>  data <= "10000101";  -- 4536 = 85
      when "100010100110111" =>  data <= "01000100";  -- 4537 = 44
      when "100010100111000" =>  data <= "10101010";  -- 4538 = AA
      when "100010100111001" =>  data <= "11001000";  -- 4539 = C8
      when "100010100111010" =>  data <= "10110001";  -- 453A = B1
      when "100010100111011" =>  data <= "01001011";  -- 453B = 4B
      when "100010100111100" =>  data <= "11110000";  -- 453C = F0
      when "100010100111101" =>  data <= "10011001";  -- 453D = 99
      when "100010100111110" =>  data <= "10000101";  -- 453E = 85
      when "100010100111111" =>  data <= "01000101";  -- 453F = 45
      when "100010101000000" =>  data <= "11001000";  -- 4540 = C8
      when "100010101000001" =>  data <= "10110001";  -- 4541 = B1
      when "100010101000010" =>  data <= "01000100";  -- 4542 = 44
      when "100010101000011" =>  data <= "01001000";  -- 4543 = 48
      when "100010101000100" =>  data <= "10001000";  -- 4544 = 88
      when "100010101000101" =>  data <= "00010000";  -- 4545 = 10
      when "100010101000110" =>  data <= "11111010";  -- 4546 = FA
      when "100010101000111" =>  data <= "10100100";  -- 4547 = A4
      when "100010101001000" =>  data <= "01000101";  -- 4548 = 45
      when "100010101001001" =>  data <= "00100000";  -- 4549 = 20
      when "100010101001010" =>  data <= "00001010";  -- 454A = A
      when "100010101001011" =>  data <= "11001101";  -- 454B = CD
      when "100010101001100" =>  data <= "10100101";  -- 454C = A5
      when "100010101001101" =>  data <= "01111000";  -- 454D = 78
      when "100010101001110" =>  data <= "01001000";  -- 454E = 48
      when "100010101001111" =>  data <= "10100101";  -- 454F = A5
      when "100010101010000" =>  data <= "01110111";  -- 4550 = 77
      when "100010101010001" =>  data <= "01001000";  -- 4551 = 48
      when "100010101010010" =>  data <= "10110001";  -- 4552 = B1
      when "100010101010011" =>  data <= "01001011";  -- 4553 = 4B
      when "100010101010100" =>  data <= "10000101";  -- 4554 = 85
      when "100010101010101" =>  data <= "01110111";  -- 4555 = 77
      when "100010101010110" =>  data <= "11001000";  -- 4556 = C8
      when "100010101010111" =>  data <= "10110001";  -- 4557 = B1
      when "100010101011000" =>  data <= "01001011";  -- 4558 = 4B
      when "100010101011001" =>  data <= "10000101";  -- 4559 = 85
      when "100010101011010" =>  data <= "01111000";  -- 455A = 78
      when "100010101011011" =>  data <= "10100101";  -- 455B = A5
      when "100010101011100" =>  data <= "01000101";  -- 455C = 45
      when "100010101011101" =>  data <= "01001000";  -- 455D = 48
      when "100010101011110" =>  data <= "10100101";  -- 455E = A5
      when "100010101011111" =>  data <= "01000100";  -- 455F = 44
      when "100010101100000" =>  data <= "01001000";  -- 4560 = 48
      when "100010101100001" =>  data <= "00100000";  -- 4561 = 20
      when "100010101100010" =>  data <= "10000100";  -- 4562 = 84
      when "100010101100011" =>  data <= "10111101";  -- 4563 = BD
      when "100010101100100" =>  data <= "01101000";  -- 4564 = 68
      when "100010101100101" =>  data <= "10000101";  -- 4565 = 85
      when "100010101100110" =>  data <= "01001011";  -- 4566 = 4B
      when "100010101100111" =>  data <= "01101000";  -- 4567 = 68
      when "100010101101000" =>  data <= "10000101";  -- 4568 = 85
      when "100010101101001" =>  data <= "01001100";  -- 4569 = 4C
      when "100010101101010" =>  data <= "00100000";  -- 456A = 20
      when "100010101101011" =>  data <= "01110110";  -- 456B = 76
      when "100010101101100" =>  data <= "00000000";  -- 456C = 0
      when "100010101101101" =>  data <= "11110000";  -- 456D = F0
      when "100010101101110" =>  data <= "00000011";  -- 456E = 3
      when "100010101101111" =>  data <= "01001100";  -- 456F = 4C
      when "100010101110000" =>  data <= "00000000";  -- 4570 = 0
      when "100010101110001" =>  data <= "10111111";  -- 4571 = BF
      when "100010101110010" =>  data <= "01101000";  -- 4572 = 68
      when "100010101110011" =>  data <= "10000101";  -- 4573 = 85
      when "100010101110100" =>  data <= "01110111";  -- 4574 = 77
      when "100010101110101" =>  data <= "01101000";  -- 4575 = 68
      when "100010101110110" =>  data <= "10000101";  -- 4576 = 85
      when "100010101110111" =>  data <= "01111000";  -- 4577 = 78
      when "100010101111000" =>  data <= "10100000";  -- 4578 = A0
      when "100010101111001" =>  data <= "00000000";  -- 4579 = 0
      when "100010101111010" =>  data <= "01101000";  -- 457A = 68
      when "100010101111011" =>  data <= "10010001";  -- 457B = 91
      when "100010101111100" =>  data <= "01001011";  -- 457C = 4B
      when "100010101111101" =>  data <= "01101000";  -- 457D = 68
      when "100010101111110" =>  data <= "11001000";  -- 457E = C8
      when "100010101111111" =>  data <= "10010001";  -- 457F = 91
      when "100010110000000" =>  data <= "01001011";  -- 4580 = 4B
      when "100010110000001" =>  data <= "01101000";  -- 4581 = 68
      when "100010110000010" =>  data <= "11001000";  -- 4582 = C8
      when "100010110000011" =>  data <= "10010001";  -- 4583 = 91
      when "100010110000100" =>  data <= "01001011";  -- 4584 = 4B
      when "100010110000101" =>  data <= "01101000";  -- 4585 = 68
      when "100010110000110" =>  data <= "11001000";  -- 4586 = C8
      when "100010110000111" =>  data <= "10010001";  -- 4587 = 91
      when "100010110001000" =>  data <= "01001011";  -- 4588 = 4B
      when "100010110001001" =>  data <= "01101000";  -- 4589 = 68
      when "100010110001010" =>  data <= "11001000";  -- 458A = C8
      when "100010110001011" =>  data <= "10010001";  -- 458B = 91
      when "100010110001100" =>  data <= "01001011";  -- 458C = 4B
      when "100010110001101" =>  data <= "01100000";  -- 458D = 60
      when "100010110001110" =>  data <= "00100000";  -- 458E = 20
      when "100010110001111" =>  data <= "10000111";  -- 458F = 87
      when "100010110010000" =>  data <= "10111101";  -- 4590 = BD
      when "100010110010001" =>  data <= "10100000";  -- 4591 = A0
      when "100010110010010" =>  data <= "00000000";  -- 4592 = 0
      when "100010110010011" =>  data <= "00100000";  -- 4593 = 20
      when "100010110010100" =>  data <= "10010101";  -- 4594 = 95
      when "100010110010101" =>  data <= "11001111";  -- 4595 = CF
      when "100010110010110" =>  data <= "01101000";  -- 4596 = 68
      when "100010110010111" =>  data <= "01101000";  -- 4597 = 68
      when "100010110011000" =>  data <= "10101001";  -- 4598 = A9
      when "100010110011001" =>  data <= "11111111";  -- 4599 = FF
      when "100010110011010" =>  data <= "10100000";  -- 459A = A0
      when "100010110011011" =>  data <= "00000000";  -- 459B = 0
      when "100010110011100" =>  data <= "11110000";  -- 459C = F0
      when "100010110011101" =>  data <= "00010010";  -- 459D = 12
      when "100010110011110" =>  data <= "10100110";  -- 459E = A6
      when "100010110011111" =>  data <= "01100001";  -- 459F = 61
      when "100010110100000" =>  data <= "10100100";  -- 45A0 = A4
      when "100010110100001" =>  data <= "01100010";  -- 45A1 = 62
      when "100010110100010" =>  data <= "10000110";  -- 45A2 = 86
      when "100010110100011" =>  data <= "01001101";  -- 45A3 = 4D
      when "100010110100100" =>  data <= "10000100";  -- 45A4 = 84
      when "100010110100101" =>  data <= "01001110";  -- 45A5 = 4E
      when "100010110100110" =>  data <= "00100000";  -- 45A6 = 20
      when "100010110100111" =>  data <= "00011101";  -- 45A7 = 1D
      when "100010110101000" =>  data <= "11000110";  -- 45A8 = C6
      when "100010110101001" =>  data <= "10000110";  -- 45A9 = 86
      when "100010110101010" =>  data <= "01011111";  -- 45AA = 5F
      when "100010110101011" =>  data <= "10000100";  -- 45AB = 84
      when "100010110101100" =>  data <= "01100000";  -- 45AC = 60
      when "100010110101101" =>  data <= "10000101";  -- 45AD = 85
      when "100010110101110" =>  data <= "01011110";  -- 45AE = 5E
      when "100010110101111" =>  data <= "01100000";  -- 45AF = 60
      when "100010110110000" =>  data <= "10100010";  -- 45B0 = A2
      when "100010110110001" =>  data <= "00100010";  -- 45B1 = 22
      when "100010110110010" =>  data <= "10000110";  -- 45B2 = 86
      when "100010110110011" =>  data <= "00000011";  -- 45B3 = 3
      when "100010110110100" =>  data <= "10000110";  -- 45B4 = 86
      when "100010110110101" =>  data <= "00000100";  -- 45B5 = 4
      when "100010110110110" =>  data <= "10000101";  -- 45B6 = 85
      when "100010110110111" =>  data <= "01101100";  -- 45B7 = 6C
      when "100010110111000" =>  data <= "10000100";  -- 45B8 = 84
      when "100010110111001" =>  data <= "01101101";  -- 45B9 = 6D
      when "100010110111010" =>  data <= "10000101";  -- 45BA = 85
      when "100010110111011" =>  data <= "01011111";  -- 45BB = 5F
      when "100010110111100" =>  data <= "10000100";  -- 45BC = 84
      when "100010110111101" =>  data <= "01100000";  -- 45BD = 60
      when "100010110111110" =>  data <= "10100000";  -- 45BE = A0
      when "100010110111111" =>  data <= "11111111";  -- 45BF = FF
      when "100010111000000" =>  data <= "11001000";  -- 45C0 = C8
      when "100010111000001" =>  data <= "10110001";  -- 45C1 = B1
      when "100010111000010" =>  data <= "01101100";  -- 45C2 = 6C
      when "100010111000011" =>  data <= "11110000";  -- 45C3 = F0
      when "100010111000100" =>  data <= "00001100";  -- 45C4 = C
      when "100010111000101" =>  data <= "11000101";  -- 45C5 = C5
      when "100010111000110" =>  data <= "00000011";  -- 45C6 = 3
      when "100010111000111" =>  data <= "11110000";  -- 45C7 = F0
      when "100010111001000" =>  data <= "00000100";  -- 45C8 = 4
      when "100010111001001" =>  data <= "11000101";  -- 45C9 = C5
      when "100010111001010" =>  data <= "00000100";  -- 45CA = 4
      when "100010111001011" =>  data <= "11010000";  -- 45CB = D0
      when "100010111001100" =>  data <= "11110011";  -- 45CC = F3
      when "100010111001101" =>  data <= "11001001";  -- 45CD = C9
      when "100010111001110" =>  data <= "00100010";  -- 45CE = 22
      when "100010111001111" =>  data <= "11110000";  -- 45CF = F0
      when "100010111010000" =>  data <= "00000001";  -- 45D0 = 1
      when "100010111010001" =>  data <= "00011000";  -- 45D1 = 18
      when "100010111010010" =>  data <= "10000100";  -- 45D2 = 84
      when "100010111010011" =>  data <= "01011110";  -- 45D3 = 5E
      when "100010111010100" =>  data <= "10011000";  -- 45D4 = 98
      when "100010111010101" =>  data <= "01100101";  -- 45D5 = 65
      when "100010111010110" =>  data <= "01101100";  -- 45D6 = 6C
      when "100010111010111" =>  data <= "10000101";  -- 45D7 = 85
      when "100010111011000" =>  data <= "01101110";  -- 45D8 = 6E
      when "100010111011001" =>  data <= "10100110";  -- 45D9 = A6
      when "100010111011010" =>  data <= "01101101";  -- 45DA = 6D
      when "100010111011011" =>  data <= "10010000";  -- 45DB = 90
      when "100010111011100" =>  data <= "00000001";  -- 45DC = 1
      when "100010111011101" =>  data <= "11101000";  -- 45DD = E8
      when "100010111011110" =>  data <= "10000110";  -- 45DE = 86
      when "100010111011111" =>  data <= "01101111";  -- 45DF = 6F
      when "100010111100000" =>  data <= "10100101";  -- 45E0 = A5
      when "100010111100001" =>  data <= "01101101";  -- 45E1 = 6D
      when "100010111100010" =>  data <= "11110000";  -- 45E2 = F0
      when "100010111100011" =>  data <= "00000100";  -- 45E3 = 4
      when "100010111100100" =>  data <= "11001001";  -- 45E4 = C9
      when "100010111100101" =>  data <= "00000010";  -- 45E5 = 2
      when "100010111100110" =>  data <= "11010000";  -- 45E6 = D0
      when "100010111100111" =>  data <= "00001011";  -- 45E7 = B
      when "100010111101000" =>  data <= "10011000";  -- 45E8 = 98
      when "100010111101001" =>  data <= "00100000";  -- 45E9 = 20
      when "100010111101010" =>  data <= "10011110";  -- 45EA = 9E
      when "100010111101011" =>  data <= "11000101";  -- 45EB = C5
      when "100010111101100" =>  data <= "10100110";  -- 45EC = A6
      when "100010111101101" =>  data <= "01101100";  -- 45ED = 6C
      when "100010111101110" =>  data <= "10100100";  -- 45EE = A4
      when "100010111101111" =>  data <= "01101101";  -- 45EF = 6D
      when "100010111110000" =>  data <= "00100000";  -- 45F0 = 20
      when "100010111110001" =>  data <= "10011010";  -- 45F1 = 9A
      when "100010111110010" =>  data <= "11000111";  -- 45F2 = C7
      when "100010111110011" =>  data <= "10100110";  -- 45F3 = A6
      when "100010111110100" =>  data <= "00010011";  -- 45F4 = 13
      when "100010111110101" =>  data <= "11100000";  -- 45F5 = E0
      when "100010111110110" =>  data <= "00011111";  -- 45F6 = 1F
      when "100010111110111" =>  data <= "11010000";  -- 45F7 = D0
      when "100010111111000" =>  data <= "00000101";  -- 45F8 = 5
      when "100010111111001" =>  data <= "10100010";  -- 45F9 = A2
      when "100010111111010" =>  data <= "11001000";  -- 45FA = C8
      when "100010111111011" =>  data <= "01001100";  -- 45FB = 4C
      when "100010111111100" =>  data <= "11001111";  -- 45FC = CF
      when "100010111111101" =>  data <= "10110011";  -- 45FD = B3
      when "100010111111110" =>  data <= "10100101";  -- 45FE = A5
      when "100010111111111" =>  data <= "01011110";  -- 45FF = 5E
      when "100011000000000" =>  data <= "10010101";  -- 4600 = 95
      when "100011000000001" =>  data <= "00000000";  -- 4601 = 0
      when "100011000000010" =>  data <= "10100101";  -- 4602 = A5
      when "100011000000011" =>  data <= "01011111";  -- 4603 = 5F
      when "100011000000100" =>  data <= "10010101";  -- 4604 = 95
      when "100011000000101" =>  data <= "00000001";  -- 4605 = 1
      when "100011000000110" =>  data <= "10100101";  -- 4606 = A5
      when "100011000000111" =>  data <= "01100000";  -- 4607 = 60
      when "100011000001000" =>  data <= "10010101";  -- 4608 = 95
      when "100011000001001" =>  data <= "00000010";  -- 4609 = 2
      when "100011000001010" =>  data <= "10100000";  -- 460A = A0
      when "100011000001011" =>  data <= "00000000";  -- 460B = 0
      when "100011000001100" =>  data <= "10000110";  -- 460C = 86
      when "100011000001101" =>  data <= "01100001";  -- 460D = 61
      when "100011000001110" =>  data <= "10000100";  -- 460E = 84
      when "100011000001111" =>  data <= "01100010";  -- 460F = 62
      when "100011000010000" =>  data <= "10000100";  -- 4610 = 84
      when "100011000010001" =>  data <= "01101101";  -- 4611 = 6D
      when "100011000010010" =>  data <= "10001000";  -- 4612 = 88
      when "100011000010011" =>  data <= "10000100";  -- 4613 = 84
      when "100011000010100" =>  data <= "00000111";  -- 4614 = 7
      when "100011000010101" =>  data <= "10000110";  -- 4615 = 86
      when "100011000010110" =>  data <= "00010100";  -- 4616 = 14
      when "100011000010111" =>  data <= "11101000";  -- 4617 = E8
      when "100011000011000" =>  data <= "11101000";  -- 4618 = E8
      when "100011000011001" =>  data <= "11101000";  -- 4619 = E8
      when "100011000011010" =>  data <= "10000110";  -- 461A = 86
      when "100011000011011" =>  data <= "00010011";  -- 461B = 13
      when "100011000011100" =>  data <= "01100000";  -- 461C = 60
      when "100011000011101" =>  data <= "01000110";  -- 461D = 46
      when "100011000011110" =>  data <= "00001001";  -- 461E = 9
      when "100011000011111" =>  data <= "10101010";  -- 461F = AA
      when "100011000100000" =>  data <= "11110000";  -- 4620 = F0
      when "100011000100001" =>  data <= "00111000";  -- 4621 = 38
      when "100011000100010" =>  data <= "01001000";  -- 4622 = 48
      when "100011000100011" =>  data <= "10100101";  -- 4623 = A5
      when "100011000100100" =>  data <= "00110000";  -- 4624 = 30
      when "100011000100101" =>  data <= "00111000";  -- 4625 = 38
      when "100011000100110" =>  data <= "11101001";  -- 4626 = E9
      when "100011000100111" =>  data <= "00000010";  -- 4627 = 2
      when "100011000101000" =>  data <= "10100100";  -- 4628 = A4
      when "100011000101001" =>  data <= "00110001";  -- 4629 = 31
      when "100011000101010" =>  data <= "10110000";  -- 462A = B0
      when "100011000101011" =>  data <= "00000001";  -- 462B = 1
      when "100011000101100" =>  data <= "10001000";  -- 462C = 88
      when "100011000101101" =>  data <= "10000101";  -- 462D = 85
      when "100011000101110" =>  data <= "00011111";  -- 462E = 1F
      when "100011000101111" =>  data <= "10000100";  -- 462F = 84
      when "100011000110000" =>  data <= "00100000";  -- 4630 = 20
      when "100011000110001" =>  data <= "10001010";  -- 4631 = 8A
      when "100011000110010" =>  data <= "01001001";  -- 4632 = 49
      when "100011000110011" =>  data <= "11111111";  -- 4633 = FF
      when "100011000110100" =>  data <= "00111000";  -- 4634 = 38
      when "100011000110101" =>  data <= "01100101";  -- 4635 = 65
      when "100011000110110" =>  data <= "00011111";  -- 4636 = 1F
      when "100011000110111" =>  data <= "10110000";  -- 4637 = B0
      when "100011000111000" =>  data <= "00000001";  -- 4638 = 1
      when "100011000111001" =>  data <= "10001000";  -- 4639 = 88
      when "100011000111010" =>  data <= "11000100";  -- 463A = C4
      when "100011000111011" =>  data <= "00101111";  -- 463B = 2F
      when "100011000111100" =>  data <= "10010000";  -- 463C = 90
      when "100011000111101" =>  data <= "00011101";  -- 463D = 1D
      when "100011000111110" =>  data <= "11010000";  -- 463E = D0
      when "100011000111111" =>  data <= "00000100";  -- 463F = 4
      when "100011001000000" =>  data <= "11000101";  -- 4640 = C5
      when "100011001000001" =>  data <= "00101110";  -- 4641 = 2E
      when "100011001000010" =>  data <= "10010000";  -- 4642 = 90
      when "100011001000011" =>  data <= "00010111";  -- 4643 = 17
      when "100011001000100" =>  data <= "10000101";  -- 4644 = 85
      when "100011001000101" =>  data <= "00110010";  -- 4645 = 32
      when "100011001000110" =>  data <= "10000100";  -- 4646 = 84
      when "100011001000111" =>  data <= "00110011";  -- 4647 = 33
      when "100011001001000" =>  data <= "10100000";  -- 4648 = A0
      when "100011001001001" =>  data <= "00000001";  -- 4649 = 1
      when "100011001001010" =>  data <= "10101001";  -- 464A = A9
      when "100011001001011" =>  data <= "11111111";  -- 464B = FF
      when "100011001001100" =>  data <= "10010001";  -- 464C = 91
      when "100011001001101" =>  data <= "00011111";  -- 464D = 1F
      when "100011001001110" =>  data <= "10001000";  -- 464E = 88
      when "100011001001111" =>  data <= "01101000";  -- 464F = 68
      when "100011001010000" =>  data <= "10010001";  -- 4650 = 91
      when "100011001010001" =>  data <= "00011111";  -- 4651 = 1F
      when "100011001010010" =>  data <= "10100110";  -- 4652 = A6
      when "100011001010011" =>  data <= "00110010";  -- 4653 = 32
      when "100011001010100" =>  data <= "10100100";  -- 4654 = A4
      when "100011001010101" =>  data <= "00110011";  -- 4655 = 33
      when "100011001010110" =>  data <= "10000110";  -- 4656 = 86
      when "100011001010111" =>  data <= "00110000";  -- 4657 = 30
      when "100011001011000" =>  data <= "10000100";  -- 4658 = 84
      when "100011001011001" =>  data <= "00110001";  -- 4659 = 31
      when "100011001011010" =>  data <= "01100000";  -- 465A = 60
      when "100011001011011" =>  data <= "10100010";  -- 465B = A2
      when "100011001011100" =>  data <= "01001101";  -- 465C = 4D
      when "100011001011101" =>  data <= "10100101";  -- 465D = A5
      when "100011001011110" =>  data <= "00001001";  -- 465E = 9
      when "100011001011111" =>  data <= "00110000";  -- 465F = 30
      when "100011001100000" =>  data <= "10011010";  -- 4660 = 9A
      when "100011001100001" =>  data <= "00100000";  -- 4661 = 20
      when "100011001100010" =>  data <= "01101010";  -- 4662 = 6A
      when "100011001100011" =>  data <= "11000110";  -- 4663 = C6
      when "100011001100100" =>  data <= "00111000";  -- 4664 = 38
      when "100011001100101" =>  data <= "01100110";  -- 4665 = 66
      when "100011001100110" =>  data <= "00001001";  -- 4666 = 9
      when "100011001100111" =>  data <= "01101000";  -- 4667 = 68
      when "100011001101000" =>  data <= "11010000";  -- 4668 = D0
      when "100011001101001" =>  data <= "10110101";  -- 4669 = B5
      when "100011001101010" =>  data <= "10100000";  -- 466A = A0
      when "100011001101011" =>  data <= "00000000";  -- 466B = 0
      when "100011001101100" =>  data <= "10000100";  -- 466C = 84
      when "100011001101101" =>  data <= "01010101";  -- 466D = 55
      when "100011001101110" =>  data <= "10100101";  -- 466E = A5
      when "100011001101111" =>  data <= "00110100";  -- 466F = 34
      when "100011001110000" =>  data <= "10100100";  -- 4670 = A4
      when "100011001110001" =>  data <= "00110101";  -- 4671 = 35
      when "100011001110010" =>  data <= "10000101";  -- 4672 = 85
      when "100011001110011" =>  data <= "01011100";  -- 4673 = 5C
      when "100011001110100" =>  data <= "10000101";  -- 4674 = 85
      when "100011001110101" =>  data <= "01001011";  -- 4675 = 4B
      when "100011001110110" =>  data <= "10000101";  -- 4676 = 85
      when "100011001110111" =>  data <= "00110010";  -- 4677 = 32
      when "100011001111000" =>  data <= "10000100";  -- 4678 = 84
      when "100011001111001" =>  data <= "01011101";  -- 4679 = 5D
      when "100011001111010" =>  data <= "10000100";  -- 467A = 84
      when "100011001111011" =>  data <= "01001100";  -- 467B = 4C
      when "100011001111100" =>  data <= "10000100";  -- 467C = 84
      when "100011001111101" =>  data <= "00110011";  -- 467D = 33
      when "100011001111110" =>  data <= "11000100";  -- 467E = C4
      when "100011001111111" =>  data <= "00110001";  -- 467F = 31
      when "100011010000000" =>  data <= "10010000";  -- 4680 = 90
      when "100011010000001" =>  data <= "01111110";  -- 4681 = 7E
      when "100011010000010" =>  data <= "11010000";  -- 4682 = D0
      when "100011010000011" =>  data <= "00000110";  -- 4683 = 6
      when "100011010000100" =>  data <= "11000101";  -- 4684 = C5
      when "100011010000101" =>  data <= "00110000";  -- 4685 = 30
      when "100011010000110" =>  data <= "11110000";  -- 4686 = F0
      when "100011010000111" =>  data <= "01111000";  -- 4687 = 78
      when "100011010001000" =>  data <= "10010000";  -- 4688 = 90
      when "100011010001001" =>  data <= "01110110";  -- 4689 = 76
      when "100011010001010" =>  data <= "10100110";  -- 468A = A6
      when "100011010001011" =>  data <= "01010101";  -- 468B = 55
      when "100011010001100" =>  data <= "00110000";  -- 468C = 30
      when "100011010001101" =>  data <= "00000101";  -- 468D = 5
      when "100011010001110" =>  data <= "10101001";  -- 468E = A9
      when "100011010001111" =>  data <= "00000010";  -- 468F = 2
      when "100011010010000" =>  data <= "00100000";  -- 4690 = 20
      when "100011010010001" =>  data <= "00110101";  -- 4691 = 35
      when "100011010010010" =>  data <= "11000111";  -- 4692 = C7
      when "100011010010011" =>  data <= "00100000";  -- 4693 = 20
      when "100011010010100" =>  data <= "00100100";  -- 4694 = 24
      when "100011010010101" =>  data <= "11000111";  -- 4695 = C7
      when "100011010010110" =>  data <= "10100000";  -- 4696 = A0
      when "100011010010111" =>  data <= "00000001";  -- 4697 = 1
      when "100011010011000" =>  data <= "10110001";  -- 4698 = B1
      when "100011010011001" =>  data <= "01001011";  -- 4699 = 4B
      when "100011010011010" =>  data <= "11001001";  -- 469A = C9
      when "100011010011011" =>  data <= "11111111";  -- 469B = FF
      when "100011010011100" =>  data <= "11010000";  -- 469C = D0
      when "100011010011101" =>  data <= "00001011";  -- 469D = B
      when "100011010011110" =>  data <= "10001000";  -- 469E = 88
      when "100011010011111" =>  data <= "10110001";  -- 469F = B1
      when "100011010100000" =>  data <= "01001011";  -- 46A0 = 4B
      when "100011010100001" =>  data <= "00100000";  -- 46A1 = 20
      when "100011010100010" =>  data <= "00100110";  -- 46A2 = 26
      when "100011010100011" =>  data <= "11000111";  -- 46A3 = C7
      when "100011010100100" =>  data <= "00111000";  -- 46A4 = 38
      when "100011010100101" =>  data <= "01100110";  -- 46A5 = 66
      when "100011010100110" =>  data <= "01010101";  -- 46A6 = 55
      when "100011010100111" =>  data <= "11010000";  -- 46A7 = D0
      when "100011010101000" =>  data <= "11010101";  -- 46A8 = D5
      when "100011010101001" =>  data <= "00100000";  -- 46A9 = 20
      when "100011010101010" =>  data <= "01000100";  -- 46AA = 44
      when "100011010101011" =>  data <= "11000111";  -- 46AB = C7
      when "100011010101100" =>  data <= "10100110";  -- 46AC = A6
      when "100011010101101" =>  data <= "01010101";  -- 46AD = 55
      when "100011010101110" =>  data <= "00010000";  -- 46AE = 10
      when "100011010101111" =>  data <= "01010011";  -- 46AF = 53
      when "100011010110000" =>  data <= "01000110";  -- 46B0 = 46
      when "100011010110001" =>  data <= "01010101";  -- 46B1 = 55
      when "100011010110010" =>  data <= "10100000";  -- 46B2 = A0
      when "100011010110011" =>  data <= "00000000";  -- 46B3 = 0
      when "100011010110100" =>  data <= "10110001";  -- 46B4 = B1
      when "100011010110101" =>  data <= "01001011";  -- 46B5 = 4B
      when "100011010110110" =>  data <= "10010001";  -- 46B6 = 91
      when "100011010110111" =>  data <= "01011100";  -- 46B7 = 5C
      when "100011010111000" =>  data <= "11001000";  -- 46B8 = C8
      when "100011010111001" =>  data <= "10110001";  -- 46B9 = B1
      when "100011010111010" =>  data <= "01001011";  -- 46BA = 4B
      when "100011010111011" =>  data <= "10010001";  -- 46BB = 91
      when "100011010111100" =>  data <= "01011100";  -- 46BC = 5C
      when "100011010111101" =>  data <= "10001000";  -- 46BD = 88
      when "100011010111110" =>  data <= "10110001";  -- 46BE = B1
      when "100011010111111" =>  data <= "00011111";  -- 46BF = 1F
      when "100011011000000" =>  data <= "10101010";  -- 46C0 = AA
      when "100011011000001" =>  data <= "00100000";  -- 46C1 = 20
      when "100011011000010" =>  data <= "00110101";  -- 46C2 = 35
      when "100011011000011" =>  data <= "11000111";  -- 46C3 = C7
      when "100011011000100" =>  data <= "10000101";  -- 46C4 = 85
      when "100011011000101" =>  data <= "00110010";  -- 46C5 = 32
      when "100011011000110" =>  data <= "10000100";  -- 46C6 = 84
      when "100011011000111" =>  data <= "00110011";  -- 46C7 = 33
      when "100011011001000" =>  data <= "10001010";  -- 46C8 = 8A
      when "100011011001001" =>  data <= "00100000";  -- 46C9 = 20
      when "100011011001010" =>  data <= "00100110";  -- 46CA = 26
      when "100011011001011" =>  data <= "11000111";  -- 46CB = C7
      when "100011011001100" =>  data <= "10001010";  -- 46CC = 8A
      when "100011011001101" =>  data <= "10101000";  -- 46CD = A8
      when "100011011001110" =>  data <= "10001000";  -- 46CE = 88
      when "100011011001111" =>  data <= "10110001";  -- 46CF = B1
      when "100011011010000" =>  data <= "01001011";  -- 46D0 = 4B
      when "100011011010001" =>  data <= "10010001";  -- 46D1 = 91
      when "100011011010010" =>  data <= "01011100";  -- 46D2 = 5C
      when "100011011010011" =>  data <= "11001010";  -- 46D3 = CA
      when "100011011010100" =>  data <= "11010000";  -- 46D4 = D0
      when "100011011010101" =>  data <= "11111000";  -- 46D5 = F8
      when "100011011010110" =>  data <= "10100000";  -- 46D6 = A0
      when "100011011010111" =>  data <= "00000010";  -- 46D7 = 2
      when "100011011011000" =>  data <= "10111001";  -- 46D8 = B9
      when "100011011011001" =>  data <= "01011011";  -- 46D9 = 5B
      when "100011011011010" =>  data <= "00000000";  -- 46DA = 0
      when "100011011011011" =>  data <= "10010001";  -- 46DB = 91
      when "100011011011100" =>  data <= "00011111";  -- 46DC = 1F
      when "100011011011101" =>  data <= "10001000";  -- 46DD = 88
      when "100011011011110" =>  data <= "11010000";  -- 46DE = D0
      when "100011011011111" =>  data <= "11111000";  -- 46DF = F8
      when "100011011100000" =>  data <= "10100101";  -- 46E0 = A5
      when "100011011100001" =>  data <= "01001011";  -- 46E1 = 4B
      when "100011011100010" =>  data <= "10100100";  -- 46E2 = A4
      when "100011011100011" =>  data <= "01001100";  -- 46E3 = 4C
      when "100011011100100" =>  data <= "11000100";  -- 46E4 = C4
      when "100011011100101" =>  data <= "00110001";  -- 46E5 = 31
      when "100011011100110" =>  data <= "10010000";  -- 46E6 = 90
      when "100011011100111" =>  data <= "00011000";  -- 46E7 = 18
      when "100011011101000" =>  data <= "11010000";  -- 46E8 = D0
      when "100011011101001" =>  data <= "00000110";  -- 46E9 = 6
      when "100011011101010" =>  data <= "11000101";  -- 46EA = C5
      when "100011011101011" =>  data <= "00110000";  -- 46EB = 30
      when "100011011101100" =>  data <= "11110000";  -- 46EC = F0
      when "100011011101101" =>  data <= "00010010";  -- 46ED = 12
      when "100011011101110" =>  data <= "10010000";  -- 46EE = 90
      when "100011011101111" =>  data <= "00010000";  -- 46EF = 10
      when "100011011110000" =>  data <= "00100000";  -- 46F0 = 20
      when "100011011110001" =>  data <= "00011111";  -- 46F1 = 1F
      when "100011011110010" =>  data <= "11000111";  -- 46F2 = C7
      when "100011011110011" =>  data <= "10100000";  -- 46F3 = A0
      when "100011011110100" =>  data <= "00000001";  -- 46F4 = 1
      when "100011011110101" =>  data <= "10110001";  -- 46F5 = B1
      when "100011011110110" =>  data <= "01001011";  -- 46F6 = 4B
      when "100011011110111" =>  data <= "11001001";  -- 46F7 = C9
      when "100011011111000" =>  data <= "11111111";  -- 46F8 = FF
      when "100011011111001" =>  data <= "11110000";  -- 46F9 = F0
      when "100011011111010" =>  data <= "10100011";  -- 46FA = A3
      when "100011011111011" =>  data <= "00100000";  -- 46FB = 20
      when "100011011111100" =>  data <= "01000100";  -- 46FC = 44
      when "100011011111101" =>  data <= "11000111";  -- 46FD = C7
      when "100011011111110" =>  data <= "00110000";  -- 46FE = 30
      when "100011011111111" =>  data <= "10110010";  -- 46FF = B2
      when "100011100000000" =>  data <= "01001100";  -- 4700 = 4C
      when "100011100000001" =>  data <= "00010110";  -- 4701 = 16
      when "100011100000010" =>  data <= "11000111";  -- 4702 = C7
      when "100011100000011" =>  data <= "10100000";  -- 4703 = A0
      when "100011100000100" =>  data <= "00000000";  -- 4704 = 0
      when "100011100000101" =>  data <= "10110001";  -- 4705 = B1
      when "100011100000110" =>  data <= "00011111";  -- 4706 = 1F
      when "100011100000111" =>  data <= "10101010";  -- 4707 = AA
      when "100011100001000" =>  data <= "00100000";  -- 4708 = 20
      when "100011100001001" =>  data <= "00110101";  -- 4709 = 35
      when "100011100001010" =>  data <= "11000111";  -- 470A = C7
      when "100011100001011" =>  data <= "10000101";  -- 470B = 85
      when "100011100001100" =>  data <= "00110010";  -- 470C = 32
      when "100011100001101" =>  data <= "10000100";  -- 470D = 84
      when "100011100001110" =>  data <= "00110011";  -- 470E = 33
      when "100011100001111" =>  data <= "10001010";  -- 470F = 8A
      when "100011100010000" =>  data <= "00100000";  -- 4710 = 20
      when "100011100010001" =>  data <= "00100110";  -- 4711 = 26
      when "100011100010010" =>  data <= "11000111";  -- 4712 = C7
      when "100011100010011" =>  data <= "01001100";  -- 4713 = 4C
      when "100011100010100" =>  data <= "01111110";  -- 4714 = 7E
      when "100011100010101" =>  data <= "11000110";  -- 4715 = C6
      when "100011100010110" =>  data <= "10100101";  -- 4716 = A5
      when "100011100010111" =>  data <= "00110010";  -- 4717 = 32
      when "100011100011000" =>  data <= "10100100";  -- 4718 = A4
      when "100011100011001" =>  data <= "00110011";  -- 4719 = 33
      when "100011100011010" =>  data <= "10000101";  -- 471A = 85
      when "100011100011011" =>  data <= "00110000";  -- 471B = 30
      when "100011100011100" =>  data <= "10000100";  -- 471C = 84
      when "100011100011101" =>  data <= "00110001";  -- 471D = 31
      when "100011100011110" =>  data <= "01100000";  -- 471E = 60
      when "100011100011111" =>  data <= "10101001";  -- 471F = A9
      when "100011100100000" =>  data <= "00000010";  -- 4720 = 2
      when "100011100100001" =>  data <= "00100000";  -- 4721 = 20
      when "100011100100010" =>  data <= "00110101";  -- 4722 = 35
      when "100011100100011" =>  data <= "11000111";  -- 4723 = C7
      when "100011100100100" =>  data <= "10101001";  -- 4724 = A9
      when "100011100100101" =>  data <= "00000010";  -- 4725 = 2
      when "100011100100110" =>  data <= "01001001";  -- 4726 = 49
      when "100011100100111" =>  data <= "11111111";  -- 4727 = FF
      when "100011100101000" =>  data <= "00111000";  -- 4728 = 38
      when "100011100101001" =>  data <= "01100101";  -- 4729 = 65
      when "100011100101010" =>  data <= "01001011";  -- 472A = 4B
      when "100011100101011" =>  data <= "10100100";  -- 472B = A4
      when "100011100101100" =>  data <= "01001100";  -- 472C = 4C
      when "100011100101101" =>  data <= "10110000";  -- 472D = B0
      when "100011100101110" =>  data <= "00000001";  -- 472E = 1
      when "100011100101111" =>  data <= "10001000";  -- 472F = 88
      when "100011100110000" =>  data <= "10000101";  -- 4730 = 85
      when "100011100110001" =>  data <= "01001011";  -- 4731 = 4B
      when "100011100110010" =>  data <= "10000100";  -- 4732 = 84
      when "100011100110011" =>  data <= "01001100";  -- 4733 = 4C
      when "100011100110100" =>  data <= "01100000";  -- 4734 = 60
      when "100011100110101" =>  data <= "01001001";  -- 4735 = 49
      when "100011100110110" =>  data <= "11111111";  -- 4736 = FF
      when "100011100110111" =>  data <= "00111000";  -- 4737 = 38
      when "100011100111000" =>  data <= "01100101";  -- 4738 = 65
      when "100011100111001" =>  data <= "01011100";  -- 4739 = 5C
      when "100011100111010" =>  data <= "10100100";  -- 473A = A4
      when "100011100111011" =>  data <= "01011101";  -- 473B = 5D
      when "100011100111100" =>  data <= "10110000";  -- 473C = B0
      when "100011100111101" =>  data <= "00000001";  -- 473D = 1
      when "100011100111110" =>  data <= "10001000";  -- 473E = 88
      when "100011100111111" =>  data <= "10000101";  -- 473F = 85
      when "100011101000000" =>  data <= "01011100";  -- 4740 = 5C
      when "100011101000001" =>  data <= "10000100";  -- 4741 = 84
      when "100011101000010" =>  data <= "01011101";  -- 4742 = 5D
      when "100011101000011" =>  data <= "01100000";  -- 4743 = 60
      when "100011101000100" =>  data <= "10100000";  -- 4744 = A0
      when "100011101000101" =>  data <= "00000001";  -- 4745 = 1
      when "100011101000110" =>  data <= "10110001";  -- 4746 = B1
      when "100011101000111" =>  data <= "01001011";  -- 4747 = 4B
      when "100011101001000" =>  data <= "10011001";  -- 4748 = 99
      when "100011101001001" =>  data <= "00011111";  -- 4749 = 1F
      when "100011101001010" =>  data <= "00000000";  -- 474A = 0
      when "100011101001011" =>  data <= "10001000";  -- 474B = 88
      when "100011101001100" =>  data <= "00010000";  -- 474C = 10
      when "100011101001101" =>  data <= "11111000";  -- 474D = F8
      when "100011101001110" =>  data <= "01100000";  -- 474E = 60
      when "100011101001111" =>  data <= "10100101";  -- 474F = A5
      when "100011101010000" =>  data <= "01100010";  -- 4750 = 62
      when "100011101010001" =>  data <= "01001000";  -- 4751 = 48
      when "100011101010010" =>  data <= "10100101";  -- 4752 = A5
      when "100011101010011" =>  data <= "01100001";  -- 4753 = 61
      when "100011101010100" =>  data <= "01001000";  -- 4754 = 48
      when "100011101010101" =>  data <= "00100000";  -- 4755 = 20
      when "100011101010110" =>  data <= "10000001";  -- 4756 = 81
      when "100011101010111" =>  data <= "10111110";  -- 4757 = BE
      when "100011101011000" =>  data <= "00100000";  -- 4758 = 20
      when "100011101011001" =>  data <= "10001001";  -- 4759 = 89
      when "100011101011010" =>  data <= "10111101";  -- 475A = BD
      when "100011101011011" =>  data <= "01101000";  -- 475B = 68
      when "100011101011100" =>  data <= "10000101";  -- 475C = 85
      when "100011101011101" =>  data <= "01101100";  -- 475D = 6C
      when "100011101011110" =>  data <= "01101000";  -- 475E = 68
      when "100011101011111" =>  data <= "10000101";  -- 475F = 85
      when "100011101100000" =>  data <= "01101101";  -- 4760 = 6D
      when "100011101100001" =>  data <= "10100000";  -- 4761 = A0
      when "100011101100010" =>  data <= "00000000";  -- 4762 = 0
      when "100011101100011" =>  data <= "10110001";  -- 4763 = B1
      when "100011101100100" =>  data <= "01101100";  -- 4764 = 6C
      when "100011101100101" =>  data <= "00011000";  -- 4765 = 18
      when "100011101100110" =>  data <= "01110001";  -- 4766 = 71
      when "100011101100111" =>  data <= "01100001";  -- 4767 = 61
      when "100011101101000" =>  data <= "10010000";  -- 4768 = 90
      when "100011101101001" =>  data <= "00000101";  -- 4769 = 5
      when "100011101101010" =>  data <= "10100010";  -- 476A = A2
      when "100011101101011" =>  data <= "10110000";  -- 476B = B0
      when "100011101101100" =>  data <= "01001100";  -- 476C = 4C
      when "100011101101101" =>  data <= "11001111";  -- 476D = CF
      when "100011101101110" =>  data <= "10110011";  -- 476E = B3
      when "100011101101111" =>  data <= "00100000";  -- 476F = 20
      when "100011101110000" =>  data <= "10011110";  -- 4770 = 9E
      when "100011101110001" =>  data <= "11000101";  -- 4771 = C5
      when "100011101110010" =>  data <= "00100000";  -- 4772 = 20
      when "100011101110011" =>  data <= "10001100";  -- 4773 = 8C
      when "100011101110100" =>  data <= "11000111";  -- 4774 = C7
      when "100011101110101" =>  data <= "10100101";  -- 4775 = A5
      when "100011101110110" =>  data <= "01001101";  -- 4776 = 4D
      when "100011101110111" =>  data <= "10100100";  -- 4777 = A4
      when "100011101111000" =>  data <= "01001110";  -- 4778 = 4E
      when "100011101111001" =>  data <= "00100000";  -- 4779 = 20
      when "100011101111010" =>  data <= "10111100";  -- 477A = BC
      when "100011101111011" =>  data <= "11000111";  -- 477B = C7
      when "100011101111100" =>  data <= "00100000";  -- 477C = 20
      when "100011101111101" =>  data <= "10011110";  -- 477D = 9E
      when "100011101111110" =>  data <= "11000111";  -- 477E = C7
      when "100011101111111" =>  data <= "10100101";  -- 477F = A5
      when "100011110000000" =>  data <= "01101100";  -- 4780 = 6C
      when "100011110000001" =>  data <= "10100100";  -- 4781 = A4
      when "100011110000010" =>  data <= "01101101";  -- 4782 = 6D
      when "100011110000011" =>  data <= "00100000";  -- 4783 = 20
      when "100011110000100" =>  data <= "10111100";  -- 4784 = BC
      when "100011110000101" =>  data <= "11000111";  -- 4785 = C7
      when "100011110000110" =>  data <= "00100000";  -- 4786 = 20
      when "100011110000111" =>  data <= "11110011";  -- 4787 = F3
      when "100011110001000" =>  data <= "11000101";  -- 4788 = C5
      when "100011110001001" =>  data <= "01001100";  -- 4789 = 4C
      when "100011110001010" =>  data <= "10110010";  -- 478A = B2
      when "100011110001011" =>  data <= "10111101";  -- 478B = BD
      when "100011110001100" =>  data <= "10100000";  -- 478C = A0
      when "100011110001101" =>  data <= "00000000";  -- 478D = 0
      when "100011110001110" =>  data <= "10110001";  -- 478E = B1
      when "100011110001111" =>  data <= "01101100";  -- 478F = 6C
      when "100011110010000" =>  data <= "01001000";  -- 4790 = 48
      when "100011110010001" =>  data <= "11001000";  -- 4791 = C8
      when "100011110010010" =>  data <= "10110001";  -- 4792 = B1
      when "100011110010011" =>  data <= "01101100";  -- 4793 = 6C
      when "100011110010100" =>  data <= "10101010";  -- 4794 = AA
      when "100011110010101" =>  data <= "11001000";  -- 4795 = C8
      when "100011110010110" =>  data <= "10110001";  -- 4796 = B1
      when "100011110010111" =>  data <= "01101100";  -- 4797 = 6C
      when "100011110011000" =>  data <= "10101000";  -- 4798 = A8
      when "100011110011001" =>  data <= "01101000";  -- 4799 = 68
      when "100011110011010" =>  data <= "10000110";  -- 479A = 86
      when "100011110011011" =>  data <= "00011111";  -- 479B = 1F
      when "100011110011100" =>  data <= "10000100";  -- 479C = 84
      when "100011110011101" =>  data <= "00100000";  -- 479D = 20
      when "100011110011110" =>  data <= "10101000";  -- 479E = A8
      when "100011110011111" =>  data <= "11110000";  -- 479F = F0
      when "100011110100000" =>  data <= "00001010";  -- 47A0 = A
      when "100011110100001" =>  data <= "01001000";  -- 47A1 = 48
      when "100011110100010" =>  data <= "10001000";  -- 47A2 = 88
      when "100011110100011" =>  data <= "10110001";  -- 47A3 = B1
      when "100011110100100" =>  data <= "00011111";  -- 47A4 = 1F
      when "100011110100101" =>  data <= "10010001";  -- 47A5 = 91
      when "100011110100110" =>  data <= "00110010";  -- 47A6 = 32
      when "100011110100111" =>  data <= "10011000";  -- 47A7 = 98
      when "100011110101000" =>  data <= "11010000";  -- 47A8 = D0
      when "100011110101001" =>  data <= "11111000";  -- 47A9 = F8
      when "100011110101010" =>  data <= "01101000";  -- 47AA = 68
      when "100011110101011" =>  data <= "00011000";  -- 47AB = 18
      when "100011110101100" =>  data <= "01100101";  -- 47AC = 65
      when "100011110101101" =>  data <= "00110010";  -- 47AD = 32
      when "100011110101110" =>  data <= "10000101";  -- 47AE = 85
      when "100011110101111" =>  data <= "00110010";  -- 47AF = 32
      when "100011110110000" =>  data <= "10010000";  -- 47B0 = 90
      when "100011110110001" =>  data <= "00000010";  -- 47B1 = 2
      when "100011110110010" =>  data <= "11100110";  -- 47B2 = E6
      when "100011110110011" =>  data <= "00110011";  -- 47B3 = 33
      when "100011110110100" =>  data <= "01100000";  -- 47B4 = 60
      when "100011110110101" =>  data <= "00100000";  -- 47B5 = 20
      when "100011110110110" =>  data <= "10001001";  -- 47B6 = 89
      when "100011110110111" =>  data <= "10111101";  -- 47B7 = BD
      when "100011110111000" =>  data <= "10100101";  -- 47B8 = A5
      when "100011110111001" =>  data <= "01100001";  -- 47B9 = 61
      when "100011110111010" =>  data <= "10100100";  -- 47BA = A4
      when "100011110111011" =>  data <= "01100010";  -- 47BB = 62
      when "100011110111100" =>  data <= "10000101";  -- 47BC = 85
      when "100011110111101" =>  data <= "00011111";  -- 47BD = 1F
      when "100011110111110" =>  data <= "10000100";  -- 47BE = 84
      when "100011110111111" =>  data <= "00100000";  -- 47BF = 20
      when "100011111000000" =>  data <= "00100000";  -- 47C0 = 20
      when "100011111000001" =>  data <= "00010001";  -- 47C1 = 11
      when "100011111000010" =>  data <= "11001000";  -- 47C2 = C8
      when "100011111000011" =>  data <= "11010000";  -- 47C3 = D0
      when "100011111000100" =>  data <= "00111001";  -- 47C4 = 39
      when "100011111000101" =>  data <= "00100000";  -- 47C5 = 20
      when "100011111000110" =>  data <= "01001110";  -- 47C6 = 4E
      when "100011111000111" =>  data <= "10111010";  -- 47C7 = BA
      when "100011111001000" =>  data <= "10010000";  -- 47C8 = 90
      when "100011111001001" =>  data <= "00110100";  -- 47C9 = 34
      when "100011111001010" =>  data <= "10001000";  -- 47CA = 88
      when "100011111001011" =>  data <= "10101001";  -- 47CB = A9
      when "100011111001100" =>  data <= "11111111";  -- 47CC = FF
      when "100011111001101" =>  data <= "10010001";  -- 47CD = 91
      when "100011111001110" =>  data <= "00011111";  -- 47CE = 1F
      when "100011111001111" =>  data <= "10001000";  -- 47CF = 88
      when "100011111010000" =>  data <= "10001010";  -- 47D0 = 8A
      when "100011111010001" =>  data <= "10010001";  -- 47D1 = 91
      when "100011111010010" =>  data <= "00011111";  -- 47D2 = 1F
      when "100011111010011" =>  data <= "01001000";  -- 47D3 = 48
      when "100011111010100" =>  data <= "01001001";  -- 47D4 = 49
      when "100011111010101" =>  data <= "11111111";  -- 47D5 = FF
      when "100011111010110" =>  data <= "00111000";  -- 47D6 = 38
      when "100011111010111" =>  data <= "01100101";  -- 47D7 = 65
      when "100011111011000" =>  data <= "00011111";  -- 47D8 = 1F
      when "100011111011001" =>  data <= "10100100";  -- 47D9 = A4
      when "100011111011010" =>  data <= "00100000";  -- 47DA = 20
      when "100011111011011" =>  data <= "10110000";  -- 47DB = B0
      when "100011111011100" =>  data <= "00000001";  -- 47DC = 1
      when "100011111011101" =>  data <= "10001000";  -- 47DD = 88
      when "100011111011110" =>  data <= "10000101";  -- 47DE = 85
      when "100011111011111" =>  data <= "00011111";  -- 47DF = 1F
      when "100011111100000" =>  data <= "10000100";  -- 47E0 = 84
      when "100011111100001" =>  data <= "00100000";  -- 47E1 = 20
      when "100011111100010" =>  data <= "10101010";  -- 47E2 = AA
      when "100011111100011" =>  data <= "01101000";  -- 47E3 = 68
      when "100011111100100" =>  data <= "11000100";  -- 47E4 = C4
      when "100011111100101" =>  data <= "00110001";  -- 47E5 = 31
      when "100011111100110" =>  data <= "11010000";  -- 47E6 = D0
      when "100011111100111" =>  data <= "00111001";  -- 47E7 = 39
      when "100011111101000" =>  data <= "11100100";  -- 47E8 = E4
      when "100011111101001" =>  data <= "00110000";  -- 47E9 = 30
      when "100011111101010" =>  data <= "11010000";  -- 47EA = D0
      when "100011111101011" =>  data <= "00110101";  -- 47EB = 35
      when "100011111101100" =>  data <= "01001000";  -- 47EC = 48
      when "100011111101101" =>  data <= "00111000";  -- 47ED = 38
      when "100011111101110" =>  data <= "01100101";  -- 47EE = 65
      when "100011111101111" =>  data <= "00110000";  -- 47EF = 30
      when "100011111110000" =>  data <= "10000101";  -- 47F0 = 85
      when "100011111110001" =>  data <= "00110000";  -- 47F1 = 30
      when "100011111110010" =>  data <= "10010000";  -- 47F2 = 90
      when "100011111110011" =>  data <= "00000010";  -- 47F3 = 2
      when "100011111110100" =>  data <= "11100110";  -- 47F4 = E6
      when "100011111110101" =>  data <= "00110001";  -- 47F5 = 31
      when "100011111110110" =>  data <= "11100110";  -- 47F6 = E6
      when "100011111110111" =>  data <= "00110000";  -- 47F7 = 30
      when "100011111111000" =>  data <= "11010000";  -- 47F8 = D0
      when "100011111111001" =>  data <= "00000010";  -- 47F9 = 2
      when "100011111111010" =>  data <= "11100110";  -- 47FA = E6
      when "100011111111011" =>  data <= "00110001";  -- 47FB = 31
      when "100011111111100" =>  data <= "01101000";  -- 47FC = 68
      when "100011111111101" =>  data <= "01100000";  -- 47FD = 60
      when "100011111111110" =>  data <= "10100000";  -- 47FE = A0
      when "100011111111111" =>  data <= "00000000";  -- 47FF = 0
      when "100100000000000" =>  data <= "10110001";  -- 4800 = B1
      when "100100000000001" =>  data <= "00011111";  -- 4801 = 1F
      when "100100000000010" =>  data <= "01001000";  -- 4802 = 48
      when "100100000000011" =>  data <= "11001000";  -- 4803 = C8
      when "100100000000100" =>  data <= "10110001";  -- 4804 = B1
      when "100100000000101" =>  data <= "00011111";  -- 4805 = 1F
      when "100100000000110" =>  data <= "10101010";  -- 4806 = AA
      when "100100000000111" =>  data <= "11001000";  -- 4807 = C8
      when "100100000001000" =>  data <= "10110001";  -- 4808 = B1
      when "100100000001001" =>  data <= "00011111";  -- 4809 = 1F
      when "100100000001010" =>  data <= "10101000";  -- 480A = A8
      when "100100000001011" =>  data <= "10000110";  -- 480B = 86
      when "100100000001100" =>  data <= "00011111";  -- 480C = 1F
      when "100100000001101" =>  data <= "10000100";  -- 480D = 84
      when "100100000001110" =>  data <= "00100000";  -- 480E = 20
      when "100100000001111" =>  data <= "01101000";  -- 480F = 68
      when "100100000010000" =>  data <= "01100000";  -- 4810 = 60
      when "100100000010001" =>  data <= "11000100";  -- 4811 = C4
      when "100100000010010" =>  data <= "00010101";  -- 4812 = 15
      when "100100000010011" =>  data <= "11010000";  -- 4813 = D0
      when "100100000010100" =>  data <= "00001100";  -- 4814 = C
      when "100100000010101" =>  data <= "11000101";  -- 4815 = C5
      when "100100000010110" =>  data <= "00010100";  -- 4816 = 14
      when "100100000010111" =>  data <= "11010000";  -- 4817 = D0
      when "100100000011000" =>  data <= "00001000";  -- 4818 = 8
      when "100100000011001" =>  data <= "10000101";  -- 4819 = 85
      when "100100000011010" =>  data <= "00010011";  -- 481A = 13
      when "100100000011011" =>  data <= "11101001";  -- 481B = E9
      when "100100000011100" =>  data <= "00000011";  -- 481C = 3
      when "100100000011101" =>  data <= "10000101";  -- 481D = 85
      when "100100000011110" =>  data <= "00010100";  -- 481E = 14
      when "100100000011111" =>  data <= "10100000";  -- 481F = A0
      when "100100000100000" =>  data <= "00000000";  -- 4820 = 0
      when "100100000100001" =>  data <= "01100000";  -- 4821 = 60
      when "100100000100010" =>  data <= "00100000";  -- 4822 = 20
      when "100100000100011" =>  data <= "11010111";  -- 4823 = D7
      when "100100000100100" =>  data <= "11001000";  -- 4824 = C8
      when "100100000100101" =>  data <= "10001010";  -- 4825 = 8A
      when "100100000100110" =>  data <= "01001000";  -- 4826 = 48
      when "100100000100111" =>  data <= "10101001";  -- 4827 = A9
      when "100100000101000" =>  data <= "00000001";  -- 4828 = 1
      when "100100000101001" =>  data <= "00100000";  -- 4829 = 20
      when "100100000101010" =>  data <= "10100110";  -- 482A = A6
      when "100100000101011" =>  data <= "11000101";  -- 482B = C5
      when "100100000101100" =>  data <= "01101000";  -- 482C = 68
      when "100100000101101" =>  data <= "10100000";  -- 482D = A0
      when "100100000101110" =>  data <= "00000000";  -- 482E = 0
      when "100100000101111" =>  data <= "10010001";  -- 482F = 91
      when "100100000110000" =>  data <= "01011111";  -- 4830 = 5F
      when "100100000110001" =>  data <= "01101000";  -- 4831 = 68
      when "100100000110010" =>  data <= "01101000";  -- 4832 = 68
      when "100100000110011" =>  data <= "01001100";  -- 4833 = 4C
      when "100100000110100" =>  data <= "11110011";  -- 4834 = F3
      when "100100000110101" =>  data <= "11000101";  -- 4835 = C5
      when "100100000110110" =>  data <= "00100000";  -- 4836 = 20
      when "100100000110111" =>  data <= "10010111";  -- 4837 = 97
      when "100100000111000" =>  data <= "11001000";  -- 4838 = C8
      when "100100000111001" =>  data <= "11010001";  -- 4839 = D1
      when "100100000111010" =>  data <= "01001101";  -- 483A = 4D
      when "100100000111011" =>  data <= "10011000";  -- 483B = 98
      when "100100000111100" =>  data <= "10010000";  -- 483C = 90
      when "100100000111101" =>  data <= "00000100";  -- 483D = 4
      when "100100000111110" =>  data <= "10110001";  -- 483E = B1
      when "100100000111111" =>  data <= "01001101";  -- 483F = 4D
      when "100100001000000" =>  data <= "10101010";  -- 4840 = AA
      when "100100001000001" =>  data <= "10011000";  -- 4841 = 98
      when "100100001000010" =>  data <= "01001000";  -- 4842 = 48
      when "100100001000011" =>  data <= "10001010";  -- 4843 = 8A
      when "100100001000100" =>  data <= "01001000";  -- 4844 = 48
      when "100100001000101" =>  data <= "00100000";  -- 4845 = 20
      when "100100001000110" =>  data <= "10100110";  -- 4846 = A6
      when "100100001000111" =>  data <= "11000101";  -- 4847 = C5
      when "100100001001000" =>  data <= "10100101";  -- 4848 = A5
      when "100100001001001" =>  data <= "01001101";  -- 4849 = 4D
      when "100100001001010" =>  data <= "10100100";  -- 484A = A4
      when "100100001001011" =>  data <= "01001110";  -- 484B = 4E
      when "100100001001100" =>  data <= "00100000";  -- 484C = 20
      when "100100001001101" =>  data <= "10111100";  -- 484D = BC
      when "100100001001110" =>  data <= "11000111";  -- 484E = C7
      when "100100001001111" =>  data <= "01101000";  -- 484F = 68
      when "100100001010000" =>  data <= "10101000";  -- 4850 = A8
      when "100100001010001" =>  data <= "01101000";  -- 4851 = 68
      when "100100001010010" =>  data <= "00011000";  -- 4852 = 18
      when "100100001010011" =>  data <= "01100101";  -- 4853 = 65
      when "100100001010100" =>  data <= "00011111";  -- 4854 = 1F
      when "100100001010101" =>  data <= "10000101";  -- 4855 = 85
      when "100100001010110" =>  data <= "00011111";  -- 4856 = 1F
      when "100100001010111" =>  data <= "10010000";  -- 4857 = 90
      when "100100001011000" =>  data <= "00000010";  -- 4858 = 2
      when "100100001011001" =>  data <= "11100110";  -- 4859 = E6
      when "100100001011010" =>  data <= "00100000";  -- 485A = 20
      when "100100001011011" =>  data <= "10011000";  -- 485B = 98
      when "100100001011100" =>  data <= "00100000";  -- 485C = 20
      when "100100001011101" =>  data <= "10011110";  -- 485D = 9E
      when "100100001011110" =>  data <= "11000111";  -- 485E = C7
      when "100100001011111" =>  data <= "01001100";  -- 485F = 4C
      when "100100001100000" =>  data <= "11110011";  -- 4860 = F3
      when "100100001100001" =>  data <= "11000101";  -- 4861 = C5
      when "100100001100010" =>  data <= "00100000";  -- 4862 = 20
      when "100100001100011" =>  data <= "10010111";  -- 4863 = 97
      when "100100001100100" =>  data <= "11001000";  -- 4864 = C8
      when "100100001100101" =>  data <= "00011000";  -- 4865 = 18
      when "100100001100110" =>  data <= "11110001";  -- 4866 = F1
      when "100100001100111" =>  data <= "01001101";  -- 4867 = 4D
      when "100100001101000" =>  data <= "01001001";  -- 4868 = 49
      when "100100001101001" =>  data <= "11111111";  -- 4869 = FF
      when "100100001101010" =>  data <= "01001100";  -- 486A = 4C
      when "100100001101011" =>  data <= "00111100";  -- 486B = 3C
      when "100100001101100" =>  data <= "11001000";  -- 486C = C8
      when "100100001101101" =>  data <= "10101001";  -- 486D = A9
      when "100100001101110" =>  data <= "11111111";  -- 486E = FF
      when "100100001101111" =>  data <= "10000101";  -- 486F = 85
      when "100100001110000" =>  data <= "01100010";  -- 4870 = 62
      when "100100001110001" =>  data <= "00100000";  -- 4871 = 20
      when "100100001110010" =>  data <= "01110110";  -- 4872 = 76
      when "100100001110011" =>  data <= "00000000";  -- 4873 = 0
      when "100100001110100" =>  data <= "11001001";  -- 4874 = C9
      when "100100001110101" =>  data <= "00101001";  -- 4875 = 29
      when "100100001110110" =>  data <= "11110000";  -- 4876 = F0
      when "100100001110111" =>  data <= "00000110";  -- 4877 = 6
      when "100100001111000" =>  data <= "00100000";  -- 4878 = 20
      when "100100001111001" =>  data <= "11110101";  -- 4879 = F5
      when "100100001111010" =>  data <= "10111110";  -- 487A = BE
      when "100100001111011" =>  data <= "00100000";  -- 487B = 20
      when "100100001111100" =>  data <= "11010100";  -- 487C = D4
      when "100100001111101" =>  data <= "11001000";  -- 487D = C8
      when "100100001111110" =>  data <= "00100000";  -- 487E = 20
      when "100100001111111" =>  data <= "10010111";  -- 487F = 97
      when "100100010000000" =>  data <= "11001000";  -- 4880 = C8
      when "100100010000001" =>  data <= "11110000";  -- 4881 = F0
      when "100100010000010" =>  data <= "01001011";  -- 4882 = 4B
      when "100100010000011" =>  data <= "11001010";  -- 4883 = CA
      when "100100010000100" =>  data <= "10001010";  -- 4884 = 8A
      when "100100010000101" =>  data <= "01001000";  -- 4885 = 48
      when "100100010000110" =>  data <= "00011000";  -- 4886 = 18
      when "100100010000111" =>  data <= "10100010";  -- 4887 = A2
      when "100100010001000" =>  data <= "00000000";  -- 4888 = 0
      when "100100010001001" =>  data <= "11110001";  -- 4889 = F1
      when "100100010001010" =>  data <= "01001101";  -- 488A = 4D
      when "100100010001011" =>  data <= "10110000";  -- 488B = B0
      when "100100010001100" =>  data <= "10110110";  -- 488C = B6
      when "100100010001101" =>  data <= "01001001";  -- 488D = 49
      when "100100010001110" =>  data <= "11111111";  -- 488E = FF
      when "100100010001111" =>  data <= "11000101";  -- 488F = C5
      when "100100010010000" =>  data <= "01100010";  -- 4890 = 62
      when "100100010010001" =>  data <= "10010000";  -- 4891 = 90
      when "100100010010010" =>  data <= "10110001";  -- 4892 = B1
      when "100100010010011" =>  data <= "10100101";  -- 4893 = A5
      when "100100010010100" =>  data <= "01100010";  -- 4894 = 62
      when "100100010010101" =>  data <= "10110000";  -- 4895 = B0
      when "100100010010110" =>  data <= "10101101";  -- 4896 = AD
      when "100100010010111" =>  data <= "00100000";  -- 4897 = 20
      when "100100010011000" =>  data <= "11101111";  -- 4898 = EF
      when "100100010011001" =>  data <= "10111110";  -- 4899 = BE
      when "100100010011010" =>  data <= "01101000";  -- 489A = 68
      when "100100010011011" =>  data <= "10101000";  -- 489B = A8
      when "100100010011100" =>  data <= "01101000";  -- 489C = 68
      when "100100010011101" =>  data <= "10000101";  -- 489D = 85
      when "100100010011110" =>  data <= "01010010";  -- 489E = 52
      when "100100010011111" =>  data <= "01101000";  -- 489F = 68
      when "100100010100000" =>  data <= "01101000";  -- 48A0 = 68
      when "100100010100001" =>  data <= "01101000";  -- 48A1 = 68
      when "100100010100010" =>  data <= "10101010";  -- 48A2 = AA
      when "100100010100011" =>  data <= "01101000";  -- 48A3 = 68
      when "100100010100100" =>  data <= "10000101";  -- 48A4 = 85
      when "100100010100101" =>  data <= "01001101";  -- 48A5 = 4D
      when "100100010100110" =>  data <= "01101000";  -- 48A6 = 68
      when "100100010100111" =>  data <= "10000101";  -- 48A7 = 85
      when "100100010101000" =>  data <= "01001110";  -- 48A8 = 4E
      when "100100010101001" =>  data <= "10100101";  -- 48A9 = A5
      when "100100010101010" =>  data <= "01010010";  -- 48AA = 52
      when "100100010101011" =>  data <= "01001000";  -- 48AB = 48
      when "100100010101100" =>  data <= "10011000";  -- 48AC = 98
      when "100100010101101" =>  data <= "01001000";  -- 48AD = 48
      when "100100010101110" =>  data <= "10100000";  -- 48AE = A0
      when "100100010101111" =>  data <= "00000000";  -- 48AF = 0
      when "100100010110000" =>  data <= "10001010";  -- 48B0 = 8A
      when "100100010110001" =>  data <= "01100000";  -- 48B1 = 60
      when "100100010110010" =>  data <= "00100000";  -- 48B2 = 20
      when "100100010110011" =>  data <= "10111000";  -- 48B3 = B8
      when "100100010110100" =>  data <= "11001000";  -- 48B4 = C8
      when "100100010110101" =>  data <= "01001100";  -- 48B5 = 4C
      when "100100010110110" =>  data <= "11001011";  -- 48B6 = CB
      when "100100010110111" =>  data <= "11000100";  -- 48B7 = C4
      when "100100010111000" =>  data <= "00100000";  -- 48B8 = 20
      when "100100010111001" =>  data <= "10110101";  -- 48B9 = B5
      when "100100010111010" =>  data <= "11000111";  -- 48BA = C7
      when "100100010111011" =>  data <= "10100010";  -- 48BB = A2
      when "100100010111100" =>  data <= "00000000";  -- 48BC = 0
      when "100100010111101" =>  data <= "10000110";  -- 48BD = 86
      when "100100010111110" =>  data <= "00000111";  -- 48BE = 7
      when "100100010111111" =>  data <= "10101000";  -- 48BF = A8
      when "100100011000000" =>  data <= "01100000";  -- 48C0 = 60
      when "100100011000001" =>  data <= "00100000";  -- 48C1 = 20
      when "100100011000010" =>  data <= "10111000";  -- 48C2 = B8
      when "100100011000011" =>  data <= "11001000";  -- 48C3 = C8
      when "100100011000100" =>  data <= "11110000";  -- 48C4 = F0
      when "100100011000101" =>  data <= "00001000";  -- 48C5 = 8
      when "100100011000110" =>  data <= "10100000";  -- 48C6 = A0
      when "100100011000111" =>  data <= "00000000";  -- 48C7 = 0
      when "100100011001000" =>  data <= "10110001";  -- 48C8 = B1
      when "100100011001001" =>  data <= "00011111";  -- 48C9 = 1F
      when "100100011001010" =>  data <= "10101000";  -- 48CA = A8
      when "100100011001011" =>  data <= "01001100";  -- 48CB = 4C
      when "100100011001100" =>  data <= "11001011";  -- 48CC = CB
      when "100100011001101" =>  data <= "11000100";  -- 48CD = C4
      when "100100011001110" =>  data <= "01001100";  -- 48CE = 4C
      when "100100011001111" =>  data <= "01110011";  -- 48CF = 73
      when "100100011010000" =>  data <= "11000011";  -- 48D0 = C3
      when "100100011010001" =>  data <= "00100000";  -- 48D1 = 20
      when "100100011010010" =>  data <= "01110000";  -- 48D2 = 70
      when "100100011010011" =>  data <= "00000000";  -- 48D3 = 0
      when "100100011010100" =>  data <= "00100000";  -- 48D4 = 20
      when "100100011010101" =>  data <= "10000100";  -- 48D5 = 84
      when "100100011010110" =>  data <= "10111101";  -- 48D6 = BD
      when "100100011010111" =>  data <= "00100000";  -- 48D7 = 20
      when "100100011011000" =>  data <= "11100011";  -- 48D8 = E3
      when "100100011011001" =>  data <= "11000010";  -- 48D9 = C2
      when "100100011011010" =>  data <= "10100110";  -- 48DA = A6
      when "100100011011011" =>  data <= "01100001";  -- 48DB = 61
      when "100100011011100" =>  data <= "11010000";  -- 48DC = D0
      when "100100011011101" =>  data <= "11110000";  -- 48DD = F0
      when "100100011011110" =>  data <= "10100110";  -- 48DE = A6
      when "100100011011111" =>  data <= "01100010";  -- 48DF = 62
      when "100100011100000" =>  data <= "01001100";  -- 48E0 = 4C
      when "100100011100001" =>  data <= "01110110";  -- 48E1 = 76
      when "100100011100010" =>  data <= "00000000";  -- 48E2 = 0
      when "100100011100011" =>  data <= "00100000";  -- 48E3 = 20
      when "100100011100100" =>  data <= "10111000";  -- 48E4 = B8
      when "100100011100101" =>  data <= "11001000";  -- 48E5 = C8
      when "100100011100110" =>  data <= "11010000";  -- 48E6 = D0
      when "100100011100111" =>  data <= "00000011";  -- 48E7 = 3
      when "100100011101000" =>  data <= "01001100";  -- 48E8 = 4C
      when "100100011101001" =>  data <= "00101101";  -- 48E9 = 2D
      when "100100011101010" =>  data <= "11001010";  -- 48EA = CA
      when "100100011101011" =>  data <= "10100110";  -- 48EB = A6
      when "100100011101100" =>  data <= "01110111";  -- 48EC = 77
      when "100100011101101" =>  data <= "10100100";  -- 48ED = A4
      when "100100011101110" =>  data <= "01111000";  -- 48EE = 78
      when "100100011101111" =>  data <= "10000110";  -- 48EF = 86
      when "100100011110000" =>  data <= "01101110";  -- 48F0 = 6E
      when "100100011110001" =>  data <= "10000100";  -- 48F1 = 84
      when "100100011110010" =>  data <= "01101111";  -- 48F2 = 6F
      when "100100011110011" =>  data <= "10100110";  -- 48F3 = A6
      when "100100011110100" =>  data <= "00011111";  -- 48F4 = 1F
      when "100100011110101" =>  data <= "10000110";  -- 48F5 = 86
      when "100100011110110" =>  data <= "01110111";  -- 48F6 = 77
      when "100100011110111" =>  data <= "00011000";  -- 48F7 = 18
      when "100100011111000" =>  data <= "01100101";  -- 48F8 = 65
      when "100100011111001" =>  data <= "00011111";  -- 48F9 = 1F
      when "100100011111010" =>  data <= "10000101";  -- 48FA = 85
      when "100100011111011" =>  data <= "00100001";  -- 48FB = 21
      when "100100011111100" =>  data <= "10100110";  -- 48FC = A6
      when "100100011111101" =>  data <= "00100000";  -- 48FD = 20
      when "100100011111110" =>  data <= "10000110";  -- 48FE = 86
      when "100100011111111" =>  data <= "01111000";  -- 48FF = 78
      when "100100100000000" =>  data <= "10010000";  -- 4900 = 90
      when "100100100000001" =>  data <= "00000001";  -- 4901 = 1
      when "100100100000010" =>  data <= "11101000";  -- 4902 = E8
      when "100100100000011" =>  data <= "10000110";  -- 4903 = 86
      when "100100100000100" =>  data <= "00100010";  -- 4904 = 22
      when "100100100000101" =>  data <= "10100000";  -- 4905 = A0
      when "100100100000110" =>  data <= "00000000";  -- 4906 = 0
      when "100100100000111" =>  data <= "10110001";  -- 4907 = B1
      when "100100100001000" =>  data <= "00100001";  -- 4908 = 21
      when "100100100001001" =>  data <= "01001000";  -- 4909 = 48
      when "100100100001010" =>  data <= "10011000";  -- 490A = 98
      when "100100100001011" =>  data <= "10010001";  -- 490B = 91
      when "100100100001100" =>  data <= "00100001";  -- 490C = 21
      when "100100100001101" =>  data <= "00100000";  -- 490D = 20
      when "100100100001110" =>  data <= "01110110";  -- 490E = 76
      when "100100100001111" =>  data <= "00000000";  -- 490F = 0
      when "100100100010000" =>  data <= "00100000";  -- 4910 = 20
      when "100100100010001" =>  data <= "00101001";  -- 4911 = 29
      when "100100100010010" =>  data <= "11001110";  -- 4912 = CE
      when "100100100010011" =>  data <= "01101000";  -- 4913 = 68
      when "100100100010100" =>  data <= "10100000";  -- 4914 = A0
      when "100100100010101" =>  data <= "00000000";  -- 4915 = 0
      when "100100100010110" =>  data <= "10010001";  -- 4916 = 91
      when "100100100010111" =>  data <= "00100001";  -- 4917 = 21
      when "100100100011000" =>  data <= "10100110";  -- 4918 = A6
      when "100100100011001" =>  data <= "01101110";  -- 4919 = 6E
      when "100100100011010" =>  data <= "10100100";  -- 491A = A4
      when "100100100011011" =>  data <= "01101111";  -- 491B = 6F
      when "100100100011100" =>  data <= "10000110";  -- 491C = 86
      when "100100100011101" =>  data <= "01110111";  -- 491D = 77
      when "100100100011110" =>  data <= "10000100";  -- 491E = 84
      when "100100100011111" =>  data <= "01111000";  -- 491F = 78
      when "100100100100000" =>  data <= "01100000";  -- 4920 = 60
      when "100100100100001" =>  data <= "00100000";  -- 4921 = 20
      when "100100100100010" =>  data <= "10000100";  -- 4922 = 84
      when "100100100100011" =>  data <= "10111101";  -- 4923 = BD
      when "100100100100100" =>  data <= "00100000";  -- 4924 = 20
      when "100100100100101" =>  data <= "00101101";  -- 4925 = 2D
      when "100100100100110" =>  data <= "11001001";  -- 4926 = C9
      when "100100100100111" =>  data <= "00100000";  -- 4927 = 20
      when "100100100101000" =>  data <= "11110101";  -- 4928 = F5
      when "100100100101001" =>  data <= "10111110";  -- 4929 = BE
      when "100100100101010" =>  data <= "01001100";  -- 492A = 4C
      when "100100100101011" =>  data <= "11010100";  -- 492B = D4
      when "100100100101100" =>  data <= "11001000";  -- 492C = C8
      when "100100100101101" =>  data <= "10100101";  -- 492D = A5
      when "100100100101110" =>  data <= "01100011";  -- 492E = 63
      when "100100100101111" =>  data <= "00110000";  -- 492F = 30
      when "100100100110000" =>  data <= "10011101";  -- 4930 = 9D
      when "100100100110001" =>  data <= "10100101";  -- 4931 = A5
      when "100100100110010" =>  data <= "01011110";  -- 4932 = 5E
      when "100100100110011" =>  data <= "11001001";  -- 4933 = C9
      when "100100100110100" =>  data <= "10010001";  -- 4934 = 91
      when "100100100110101" =>  data <= "10110000";  -- 4935 = B0
      when "100100100110110" =>  data <= "10010111";  -- 4936 = 97
      when "100100100110111" =>  data <= "00100000";  -- 4937 = 20
      when "100100100111000" =>  data <= "11010001";  -- 4938 = D1
      when "100100100111001" =>  data <= "11001101";  -- 4939 = CD
      when "100100100111010" =>  data <= "10100101";  -- 493A = A5
      when "100100100111011" =>  data <= "01100001";  -- 493B = 61
      when "100100100111100" =>  data <= "10100100";  -- 493C = A4
      when "100100100111101" =>  data <= "01100010";  -- 493D = 62
      when "100100100111110" =>  data <= "10000100";  -- 493E = 84
      when "100100100111111" =>  data <= "00010001";  -- 493F = 11
      when "100100101000000" =>  data <= "10000101";  -- 4940 = 85
      when "100100101000001" =>  data <= "00010010";  -- 4941 = 12
      when "100100101000010" =>  data <= "01100000";  -- 4942 = 60
      when "100100101000011" =>  data <= "10100101";  -- 4943 = A5
      when "100100101000100" =>  data <= "00010010";  -- 4944 = 12
      when "100100101000101" =>  data <= "01001000";  -- 4945 = 48
      when "100100101000110" =>  data <= "10100101";  -- 4946 = A5
      when "100100101000111" =>  data <= "00010001";  -- 4947 = 11
      when "100100101001000" =>  data <= "01001000";  -- 4948 = 48
      when "100100101001001" =>  data <= "00100000";  -- 4949 = 20
      when "100100101001010" =>  data <= "00101101";  -- 494A = 2D
      when "100100101001011" =>  data <= "11001001";  -- 494B = C9
      when "100100101001100" =>  data <= "10100000";  -- 494C = A0
      when "100100101001101" =>  data <= "00000000";  -- 494D = 0
      when "100100101001110" =>  data <= "10110001";  -- 494E = B1
      when "100100101001111" =>  data <= "00010001";  -- 494F = 11
      when "100100101010000" =>  data <= "10101000";  -- 4950 = A8
      when "100100101010001" =>  data <= "01101000";  -- 4951 = 68
      when "100100101010010" =>  data <= "10000101";  -- 4952 = 85
      when "100100101010011" =>  data <= "00010001";  -- 4953 = 11
      when "100100101010100" =>  data <= "01101000";  -- 4954 = 68
      when "100100101010101" =>  data <= "10000101";  -- 4955 = 85
      when "100100101010110" =>  data <= "00010010";  -- 4956 = 12
      when "100100101010111" =>  data <= "01001100";  -- 4957 = 4C
      when "100100101011000" =>  data <= "11001011";  -- 4958 = CB
      when "100100101011001" =>  data <= "11000100";  -- 4959 = C4
      when "100100101011010" =>  data <= "00100000";  -- 495A = 20
      when "100100101011011" =>  data <= "00100001";  -- 495B = 21
      when "100100101011100" =>  data <= "11001001";  -- 495C = C9
      when "100100101011101" =>  data <= "10001010";  -- 495D = 8A
      when "100100101011110" =>  data <= "10100000";  -- 495E = A0
      when "100100101011111" =>  data <= "00000000";  -- 495F = 0
      when "100100101100000" =>  data <= "10010001";  -- 4960 = 91
      when "100100101100001" =>  data <= "00010001";  -- 4961 = 11
      when "100100101100010" =>  data <= "01100000";  -- 4962 = 60
      when "100100101100011" =>  data <= "00100000";  -- 4963 = 20
      when "100100101100100" =>  data <= "00100001";  -- 4964 = 21
      when "100100101100101" =>  data <= "11001001";  -- 4965 = C9
      when "100100101100110" =>  data <= "10000110";  -- 4966 = 86
      when "100100101100111" =>  data <= "01000110";  -- 4967 = 46
      when "100100101101000" =>  data <= "10100010";  -- 4968 = A2
      when "100100101101001" =>  data <= "00000000";  -- 4969 = 0
      when "100100101101010" =>  data <= "00100000";  -- 496A = 20
      when "100100101101011" =>  data <= "01110110";  -- 496B = 76
      when "100100101101100" =>  data <= "00000000";  -- 496C = 0
      when "100100101101101" =>  data <= "11110000";  -- 496D = F0
      when "100100101101110" =>  data <= "00000011";  -- 496E = 3
      when "100100101101111" =>  data <= "00100000";  -- 496F = 20
      when "100100101110000" =>  data <= "00100111";  -- 4970 = 27
      when "100100101110001" =>  data <= "11001001";  -- 4971 = C9
      when "100100101110010" =>  data <= "10000110";  -- 4972 = 86
      when "100100101110011" =>  data <= "01000111";  -- 4973 = 47
      when "100100101110100" =>  data <= "10100000";  -- 4974 = A0
      when "100100101110101" =>  data <= "00000000";  -- 4975 = 0
      when "100100101110110" =>  data <= "10110001";  -- 4976 = B1
      when "100100101110111" =>  data <= "00010001";  -- 4977 = 11
      when "100100101111000" =>  data <= "01000101";  -- 4978 = 45
      when "100100101111001" =>  data <= "01000111";  -- 4979 = 47
      when "100100101111010" =>  data <= "00100101";  -- 497A = 25
      when "100100101111011" =>  data <= "01000110";  -- 497B = 46
      when "100100101111100" =>  data <= "11110000";  -- 497C = F0
      when "100100101111101" =>  data <= "11111000";  -- 497D = F8
      when "100100101111110" =>  data <= "01100000";  -- 497E = 60
      when "100100101111111" =>  data <= "10101001";  -- 497F = A9
      when "100100110000000" =>  data <= "11000111";  -- 4980 = C7
      when "100100110000001" =>  data <= "10100000";  -- 4981 = A0
      when "100100110000010" =>  data <= "11010000";  -- 4982 = D0
      when "100100110000011" =>  data <= "01001100";  -- 4983 = 4C
      when "100100110000100" =>  data <= "10011101";  -- 4984 = 9D
      when "100100110000101" =>  data <= "11001001";  -- 4985 = C9
      when "100100110000110" =>  data <= "00100000";  -- 4986 = 20
      when "100100110000111" =>  data <= "11000010";  -- 4987 = C2
      when "100100110001000" =>  data <= "11001011";  -- 4988 = CB
      when "100100110001001" =>  data <= "10100101";  -- 4989 = A5
      when "100100110001010" =>  data <= "01100011";  -- 498A = 63
      when "100100110001011" =>  data <= "01001001";  -- 498B = 49
      when "100100110001100" =>  data <= "11111111";  -- 498C = FF
      when "100100110001101" =>  data <= "10000101";  -- 498D = 85
      when "100100110001110" =>  data <= "01100011";  -- 498E = 63
      when "100100110001111" =>  data <= "01000101";  -- 498F = 45
      when "100100110010000" =>  data <= "01101011";  -- 4990 = 6B
      when "100100110010001" =>  data <= "10000101";  -- 4991 = 85
      when "100100110010010" =>  data <= "01101100";  -- 4992 = 6C
      when "100100110010011" =>  data <= "10100101";  -- 4993 = A5
      when "100100110010100" =>  data <= "01011110";  -- 4994 = 5E
      when "100100110010101" =>  data <= "01001100";  -- 4995 = 4C
      when "100100110010110" =>  data <= "10100000";  -- 4996 = A0
      when "100100110010111" =>  data <= "11001001";  -- 4997 = C9
      when "100100110011000" =>  data <= "00100000";  -- 4998 = 20
      when "100100110011001" =>  data <= "11001111";  -- 4999 = CF
      when "100100110011010" =>  data <= "11001010";  -- 499A = CA
      when "100100110011011" =>  data <= "10010000";  -- 499B = 90
      when "100100110011100" =>  data <= "00111100";  -- 499C = 3C
      when "100100110011101" =>  data <= "00100000";  -- 499D = 20
      when "100100110011110" =>  data <= "11000010";  -- 499E = C2
      when "100100110011111" =>  data <= "11001011";  -- 499F = CB
      when "100100110100000" =>  data <= "11010000";  -- 49A0 = D0
      when "100100110100001" =>  data <= "00000011";  -- 49A1 = 3
      when "100100110100010" =>  data <= "01001100";  -- 49A2 = 4C
      when "100100110100011" =>  data <= "00110010";  -- 49A3 = 32
      when "100100110100100" =>  data <= "11001101";  -- 49A4 = CD
      when "100100110100101" =>  data <= "10100110";  -- 49A5 = A6
      when "100100110100110" =>  data <= "01101101";  -- 49A6 = 6D
      when "100100110100111" =>  data <= "10000110";  -- 49A7 = 86
      when "100100110101000" =>  data <= "01010011";  -- 49A8 = 53
      when "100100110101001" =>  data <= "10100010";  -- 49A9 = A2
      when "100100110101010" =>  data <= "01100110";  -- 49AA = 66
      when "100100110101011" =>  data <= "10100101";  -- 49AB = A5
      when "100100110101100" =>  data <= "01100110";  -- 49AC = 66
      when "100100110101101" =>  data <= "10101000";  -- 49AD = A8
      when "100100110101110" =>  data <= "11110000";  -- 49AE = F0
      when "100100110101111" =>  data <= "11001110";  -- 49AF = CE
      when "100100110110000" =>  data <= "00111000";  -- 49B0 = 38
      when "100100110110001" =>  data <= "11100101";  -- 49B1 = E5
      when "100100110110010" =>  data <= "01011110";  -- 49B2 = 5E
      when "100100110110011" =>  data <= "11110000";  -- 49B3 = F0
      when "100100110110100" =>  data <= "00100100";  -- 49B4 = 24
      when "100100110110101" =>  data <= "10010000";  -- 49B5 = 90
      when "100100110110110" =>  data <= "00010010";  -- 49B6 = 12
      when "100100110110111" =>  data <= "10000100";  -- 49B7 = 84
      when "100100110111000" =>  data <= "01011110";  -- 49B8 = 5E
      when "100100110111001" =>  data <= "10100100";  -- 49B9 = A4
      when "100100110111010" =>  data <= "01101011";  -- 49BA = 6B
      when "100100110111011" =>  data <= "10000100";  -- 49BB = 84
      when "100100110111100" =>  data <= "01100011";  -- 49BC = 63
      when "100100110111101" =>  data <= "01001001";  -- 49BD = 49
      when "100100110111110" =>  data <= "11111111";  -- 49BE = FF
      when "100100110111111" =>  data <= "01101001";  -- 49BF = 69
      when "100100111000000" =>  data <= "00000000";  -- 49C0 = 0
      when "100100111000001" =>  data <= "10100000";  -- 49C1 = A0
      when "100100111000010" =>  data <= "00000000";  -- 49C2 = 0
      when "100100111000011" =>  data <= "10000100";  -- 49C3 = 84
      when "100100111000100" =>  data <= "01010011";  -- 49C4 = 53
      when "100100111000101" =>  data <= "10100010";  -- 49C5 = A2
      when "100100111000110" =>  data <= "01011110";  -- 49C6 = 5E
      when "100100111000111" =>  data <= "11010000";  -- 49C7 = D0
      when "100100111001000" =>  data <= "00000100";  -- 49C8 = 4
      when "100100111001001" =>  data <= "10100000";  -- 49C9 = A0
      when "100100111001010" =>  data <= "00000000";  -- 49CA = 0
      when "100100111001011" =>  data <= "10000100";  -- 49CB = 84
      when "100100111001100" =>  data <= "01101101";  -- 49CC = 6D
      when "100100111001101" =>  data <= "11001001";  -- 49CD = C9
      when "100100111001110" =>  data <= "11111001";  -- 49CE = F9
      when "100100111001111" =>  data <= "00110000";  -- 49CF = 30
      when "100100111010000" =>  data <= "11000111";  -- 49D0 = C7
      when "100100111010001" =>  data <= "10101000";  -- 49D1 = A8
      when "100100111010010" =>  data <= "10100101";  -- 49D2 = A5
      when "100100111010011" =>  data <= "01101101";  -- 49D3 = 6D
      when "100100111010100" =>  data <= "01010110";  -- 49D4 = 56
      when "100100111010101" =>  data <= "00000001";  -- 49D5 = 1
      when "100100111010110" =>  data <= "00100000";  -- 49D6 = 20
      when "100100111010111" =>  data <= "11100110";  -- 49D7 = E6
      when "100100111011000" =>  data <= "11001010";  -- 49D8 = CA
      when "100100111011001" =>  data <= "00100100";  -- 49D9 = 24
      when "100100111011010" =>  data <= "01101100";  -- 49DA = 6C
      when "100100111011011" =>  data <= "00010000";  -- 49DB = 10
      when "100100111011100" =>  data <= "01010111";  -- 49DC = 57
      when "100100111011101" =>  data <= "10100000";  -- 49DD = A0
      when "100100111011110" =>  data <= "01011110";  -- 49DE = 5E
      when "100100111011111" =>  data <= "11100000";  -- 49DF = E0
      when "100100111100000" =>  data <= "01100110";  -- 49E0 = 66
      when "100100111100001" =>  data <= "11110000";  -- 49E1 = F0
      when "100100111100010" =>  data <= "00000010";  -- 49E2 = 2
      when "100100111100011" =>  data <= "10100000";  -- 49E3 = A0
      when "100100111100100" =>  data <= "01100110";  -- 49E4 = 66
      when "100100111100101" =>  data <= "00111000";  -- 49E5 = 38
      when "100100111100110" =>  data <= "01001001";  -- 49E6 = 49
      when "100100111100111" =>  data <= "11111111";  -- 49E7 = FF
      when "100100111101000" =>  data <= "01100101";  -- 49E8 = 65
      when "100100111101001" =>  data <= "01010011";  -- 49E9 = 53
      when "100100111101010" =>  data <= "10000101";  -- 49EA = 85
      when "100100111101011" =>  data <= "01101101";  -- 49EB = 6D
      when "100100111101100" =>  data <= "10111001";  -- 49EC = B9
      when "100100111101101" =>  data <= "00000100";  -- 49ED = 4
      when "100100111101110" =>  data <= "00000000";  -- 49EE = 0
      when "100100111101111" =>  data <= "11110101";  -- 49EF = F5
      when "100100111110000" =>  data <= "00000100";  -- 49F0 = 4
      when "100100111110001" =>  data <= "10000101";  -- 49F1 = 85
      when "100100111110010" =>  data <= "01100010";  -- 49F2 = 62
      when "100100111110011" =>  data <= "10111001";  -- 49F3 = B9
      when "100100111110100" =>  data <= "00000011";  -- 49F4 = 3
      when "100100111110101" =>  data <= "00000000";  -- 49F5 = 0
      when "100100111110110" =>  data <= "11110101";  -- 49F6 = F5
      when "100100111110111" =>  data <= "00000011";  -- 49F7 = 3
      when "100100111111000" =>  data <= "10000101";  -- 49F8 = 85
      when "100100111111001" =>  data <= "01100001";  -- 49F9 = 61
      when "100100111111010" =>  data <= "10111001";  -- 49FA = B9
      when "100100111111011" =>  data <= "00000010";  -- 49FB = 2
      when "100100111111100" =>  data <= "00000000";  -- 49FC = 0
      when "100100111111101" =>  data <= "11110101";  -- 49FD = F5
      when "100100111111110" =>  data <= "00000010";  -- 49FE = 2
      when "100100111111111" =>  data <= "10000101";  -- 49FF = 85
      when "100101000000000" =>  data <= "01100000";  -- 4A00 = 60
      when "100101000000001" =>  data <= "10111001";  -- 4A01 = B9
      when "100101000000010" =>  data <= "00000001";  -- 4A02 = 1
      when "100101000000011" =>  data <= "00000000";  -- 4A03 = 0
      when "100101000000100" =>  data <= "11110101";  -- 4A04 = F5
      when "100101000000101" =>  data <= "00000001";  -- 4A05 = 1
      when "100101000000110" =>  data <= "10000101";  -- 4A06 = 85
      when "100101000000111" =>  data <= "01011111";  -- 4A07 = 5F
      when "100101000001000" =>  data <= "10110000";  -- 4A08 = B0
      when "100101000001001" =>  data <= "00000011";  -- 4A09 = 3
      when "100101000001010" =>  data <= "00100000";  -- 4A0A = 20
      when "100101000001011" =>  data <= "01111101";  -- 4A0B = 7D
      when "100101000001100" =>  data <= "11001010";  -- 4A0C = CA
      when "100101000001101" =>  data <= "10100000";  -- 4A0D = A0
      when "100101000001110" =>  data <= "00000000";  -- 4A0E = 0
      when "100101000001111" =>  data <= "10011000";  -- 4A0F = 98
      when "100101000010000" =>  data <= "00011000";  -- 4A10 = 18
      when "100101000010001" =>  data <= "10100110";  -- 4A11 = A6
      when "100101000010010" =>  data <= "01011111";  -- 4A12 = 5F
      when "100101000010011" =>  data <= "11010000";  -- 4A13 = D0
      when "100101000010100" =>  data <= "01001010";  -- 4A14 = 4A
      when "100101000010101" =>  data <= "10100110";  -- 4A15 = A6
      when "100101000010110" =>  data <= "01100000";  -- 4A16 = 60
      when "100101000010111" =>  data <= "10000110";  -- 4A17 = 86
      when "100101000011000" =>  data <= "01011111";  -- 4A18 = 5F
      when "100101000011001" =>  data <= "10100110";  -- 4A19 = A6
      when "100101000011010" =>  data <= "01100001";  -- 4A1A = 61
      when "100101000011011" =>  data <= "10000110";  -- 4A1B = 86
      when "100101000011100" =>  data <= "01100000";  -- 4A1C = 60
      when "100101000011101" =>  data <= "10100110";  -- 4A1D = A6
      when "100101000011110" =>  data <= "01100010";  -- 4A1E = 62
      when "100101000011111" =>  data <= "10000110";  -- 4A1F = 86
      when "100101000100000" =>  data <= "01100001";  -- 4A20 = 61
      when "100101000100001" =>  data <= "10100110";  -- 4A21 = A6
      when "100101000100010" =>  data <= "01101101";  -- 4A22 = 6D
      when "100101000100011" =>  data <= "10000110";  -- 4A23 = 86
      when "100101000100100" =>  data <= "01100010";  -- 4A24 = 62
      when "100101000100101" =>  data <= "10000100";  -- 4A25 = 84
      when "100101000100110" =>  data <= "01101101";  -- 4A26 = 6D
      when "100101000100111" =>  data <= "01101001";  -- 4A27 = 69
      when "100101000101000" =>  data <= "00001000";  -- 4A28 = 8
      when "100101000101001" =>  data <= "11001001";  -- 4A29 = C9
      when "100101000101010" =>  data <= "00100000";  -- 4A2A = 20
      when "100101000101011" =>  data <= "11010000";  -- 4A2B = D0
      when "100101000101100" =>  data <= "11100100";  -- 4A2C = E4
      when "100101000101101" =>  data <= "10101001";  -- 4A2D = A9
      when "100101000101110" =>  data <= "00000000";  -- 4A2E = 0
      when "100101000101111" =>  data <= "10000101";  -- 4A2F = 85
      when "100101000110000" =>  data <= "01011110";  -- 4A30 = 5E
      when "100101000110001" =>  data <= "10000101";  -- 4A31 = 85
      when "100101000110010" =>  data <= "01100011";  -- 4A32 = 63
      when "100101000110011" =>  data <= "01100000";  -- 4A33 = 60
      when "100101000110100" =>  data <= "01100101";  -- 4A34 = 65
      when "100101000110101" =>  data <= "01010011";  -- 4A35 = 53
      when "100101000110110" =>  data <= "10000101";  -- 4A36 = 85
      when "100101000110111" =>  data <= "01101101";  -- 4A37 = 6D
      when "100101000111000" =>  data <= "10100101";  -- 4A38 = A5
      when "100101000111001" =>  data <= "01100010";  -- 4A39 = 62
      when "100101000111010" =>  data <= "01100101";  -- 4A3A = 65
      when "100101000111011" =>  data <= "01101010";  -- 4A3B = 6A
      when "100101000111100" =>  data <= "10000101";  -- 4A3C = 85
      when "100101000111101" =>  data <= "01100010";  -- 4A3D = 62
      when "100101000111110" =>  data <= "10100101";  -- 4A3E = A5
      when "100101000111111" =>  data <= "01100001";  -- 4A3F = 61
      when "100101001000000" =>  data <= "01100101";  -- 4A40 = 65
      when "100101001000001" =>  data <= "01101001";  -- 4A41 = 69
      when "100101001000010" =>  data <= "10000101";  -- 4A42 = 85
      when "100101001000011" =>  data <= "01100001";  -- 4A43 = 61
      when "100101001000100" =>  data <= "10100101";  -- 4A44 = A5
      when "100101001000101" =>  data <= "01100000";  -- 4A45 = 60
      when "100101001000110" =>  data <= "01100101";  -- 4A46 = 65
      when "100101001000111" =>  data <= "01101000";  -- 4A47 = 68
      when "100101001001000" =>  data <= "10000101";  -- 4A48 = 85
      when "100101001001001" =>  data <= "01100000";  -- 4A49 = 60
      when "100101001001010" =>  data <= "10100101";  -- 4A4A = A5
      when "100101001001011" =>  data <= "01011111";  -- 4A4B = 5F
      when "100101001001100" =>  data <= "01100101";  -- 4A4C = 65
      when "100101001001101" =>  data <= "01100111";  -- 4A4D = 67
      when "100101001001110" =>  data <= "10000101";  -- 4A4E = 85
      when "100101001001111" =>  data <= "01011111";  -- 4A4F = 5F
      when "100101001010000" =>  data <= "01001100";  -- 4A50 = 4C
      when "100101001010001" =>  data <= "01101100";  -- 4A51 = 6C
      when "100101001010010" =>  data <= "11001010";  -- 4A52 = CA
      when "100101001010011" =>  data <= "01101001";  -- 4A53 = 69
      when "100101001010100" =>  data <= "00000001";  -- 4A54 = 1
      when "100101001010101" =>  data <= "00000110";  -- 4A55 = 6
      when "100101001010110" =>  data <= "01101101";  -- 4A56 = 6D
      when "100101001010111" =>  data <= "00100110";  -- 4A57 = 26
      when "100101001011000" =>  data <= "01100010";  -- 4A58 = 62
      when "100101001011001" =>  data <= "00100110";  -- 4A59 = 26
      when "100101001011010" =>  data <= "01100001";  -- 4A5A = 61
      when "100101001011011" =>  data <= "00100110";  -- 4A5B = 26
      when "100101001011100" =>  data <= "01100000";  -- 4A5C = 60
      when "100101001011101" =>  data <= "00100110";  -- 4A5D = 26
      when "100101001011110" =>  data <= "01011111";  -- 4A5E = 5F
      when "100101001011111" =>  data <= "00010000";  -- 4A5F = 10
      when "100101001100000" =>  data <= "11110010";  -- 4A60 = F2
      when "100101001100001" =>  data <= "00111000";  -- 4A61 = 38
      when "100101001100010" =>  data <= "11100101";  -- 4A62 = E5
      when "100101001100011" =>  data <= "01011110";  -- 4A63 = 5E
      when "100101001100100" =>  data <= "10110000";  -- 4A64 = B0
      when "100101001100101" =>  data <= "11000111";  -- 4A65 = C7
      when "100101001100110" =>  data <= "01001001";  -- 4A66 = 49
      when "100101001100111" =>  data <= "11111111";  -- 4A67 = FF
      when "100101001101000" =>  data <= "01101001";  -- 4A68 = 69
      when "100101001101001" =>  data <= "00000001";  -- 4A69 = 1
      when "100101001101010" =>  data <= "10000101";  -- 4A6A = 85
      when "100101001101011" =>  data <= "01011110";  -- 4A6B = 5E
      when "100101001101100" =>  data <= "10010000";  -- 4A6C = 90
      when "100101001101101" =>  data <= "00001110";  -- 4A6D = E
      when "100101001101110" =>  data <= "11100110";  -- 4A6E = E6
      when "100101001101111" =>  data <= "01011110";  -- 4A6F = 5E
      when "100101001110000" =>  data <= "11110000";  -- 4A70 = F0
      when "100101001110001" =>  data <= "01000010";  -- 4A71 = 42
      when "100101001110010" =>  data <= "01100110";  -- 4A72 = 66
      when "100101001110011" =>  data <= "01011111";  -- 4A73 = 5F
      when "100101001110100" =>  data <= "01100110";  -- 4A74 = 66
      when "100101001110101" =>  data <= "01100000";  -- 4A75 = 60
      when "100101001110110" =>  data <= "01100110";  -- 4A76 = 66
      when "100101001110111" =>  data <= "01100001";  -- 4A77 = 61
      when "100101001111000" =>  data <= "01100110";  -- 4A78 = 66
      when "100101001111001" =>  data <= "01100010";  -- 4A79 = 62
      when "100101001111010" =>  data <= "01100110";  -- 4A7A = 66
      when "100101001111011" =>  data <= "01101101";  -- 4A7B = 6D
      when "100101001111100" =>  data <= "01100000";  -- 4A7C = 60
      when "100101001111101" =>  data <= "10100101";  -- 4A7D = A5
      when "100101001111110" =>  data <= "01100011";  -- 4A7E = 63
      when "100101001111111" =>  data <= "01001001";  -- 4A7F = 49
      when "100101010000000" =>  data <= "11111111";  -- 4A80 = FF
      when "100101010000001" =>  data <= "10000101";  -- 4A81 = 85
      when "100101010000010" =>  data <= "01100011";  -- 4A82 = 63
      when "100101010000011" =>  data <= "10100101";  -- 4A83 = A5
      when "100101010000100" =>  data <= "01011111";  -- 4A84 = 5F
      when "100101010000101" =>  data <= "01001001";  -- 4A85 = 49
      when "100101010000110" =>  data <= "11111111";  -- 4A86 = FF
      when "100101010000111" =>  data <= "10000101";  -- 4A87 = 85
      when "100101010001000" =>  data <= "01011111";  -- 4A88 = 5F
      when "100101010001001" =>  data <= "10100101";  -- 4A89 = A5
      when "100101010001010" =>  data <= "01100000";  -- 4A8A = 60
      when "100101010001011" =>  data <= "01001001";  -- 4A8B = 49
      when "100101010001100" =>  data <= "11111111";  -- 4A8C = FF
      when "100101010001101" =>  data <= "10000101";  -- 4A8D = 85
      when "100101010001110" =>  data <= "01100000";  -- 4A8E = 60
      when "100101010001111" =>  data <= "10100101";  -- 4A8F = A5
      when "100101010010000" =>  data <= "01100001";  -- 4A90 = 61
      when "100101010010001" =>  data <= "01001001";  -- 4A91 = 49
      when "100101010010010" =>  data <= "11111111";  -- 4A92 = FF
      when "100101010010011" =>  data <= "10000101";  -- 4A93 = 85
      when "100101010010100" =>  data <= "01100001";  -- 4A94 = 61
      when "100101010010101" =>  data <= "10100101";  -- 4A95 = A5
      when "100101010010110" =>  data <= "01100010";  -- 4A96 = 62
      when "100101010010111" =>  data <= "01001001";  -- 4A97 = 49
      when "100101010011000" =>  data <= "11111111";  -- 4A98 = FF
      when "100101010011001" =>  data <= "10000101";  -- 4A99 = 85
      when "100101010011010" =>  data <= "01100010";  -- 4A9A = 62
      when "100101010011011" =>  data <= "10100101";  -- 4A9B = A5
      when "100101010011100" =>  data <= "01101101";  -- 4A9C = 6D
      when "100101010011101" =>  data <= "01001001";  -- 4A9D = 49
      when "100101010011110" =>  data <= "11111111";  -- 4A9E = FF
      when "100101010011111" =>  data <= "10000101";  -- 4A9F = 85
      when "100101010100000" =>  data <= "01101101";  -- 4AA0 = 6D
      when "100101010100001" =>  data <= "11100110";  -- 4AA1 = E6
      when "100101010100010" =>  data <= "01101101";  -- 4AA2 = 6D
      when "100101010100011" =>  data <= "11010000";  -- 4AA3 = D0
      when "100101010100100" =>  data <= "00001110";  -- 4AA4 = E
      when "100101010100101" =>  data <= "11100110";  -- 4AA5 = E6
      when "100101010100110" =>  data <= "01100010";  -- 4AA6 = 62
      when "100101010100111" =>  data <= "11010000";  -- 4AA7 = D0
      when "100101010101000" =>  data <= "00001010";  -- 4AA8 = A
      when "100101010101001" =>  data <= "11100110";  -- 4AA9 = E6
      when "100101010101010" =>  data <= "01100001";  -- 4AAA = 61
      when "100101010101011" =>  data <= "11010000";  -- 4AAB = D0
      when "100101010101100" =>  data <= "00000110";  -- 4AAC = 6
      when "100101010101101" =>  data <= "11100110";  -- 4AAD = E6
      when "100101010101110" =>  data <= "01100000";  -- 4AAE = 60
      when "100101010101111" =>  data <= "11010000";  -- 4AAF = D0
      when "100101010110000" =>  data <= "00000010";  -- 4AB0 = 2
      when "100101010110001" =>  data <= "11100110";  -- 4AB1 = E6
      when "100101010110010" =>  data <= "01011111";  -- 4AB2 = 5F
      when "100101010110011" =>  data <= "01100000";  -- 4AB3 = 60
      when "100101010110100" =>  data <= "10100010";  -- 4AB4 = A2
      when "100101010110101" =>  data <= "01000101";  -- 4AB5 = 45
      when "100101010110110" =>  data <= "01001100";  -- 4AB6 = 4C
      when "100101010110111" =>  data <= "11001111";  -- 4AB7 = CF
      when "100101010111000" =>  data <= "10110011";  -- 4AB8 = B3
      when "100101010111001" =>  data <= "10100010";  -- 4AB9 = A2
      when "100101010111010" =>  data <= "00100010";  -- 4ABA = 22
      when "100101010111011" =>  data <= "10110100";  -- 4ABB = B4
      when "100101010111100" =>  data <= "00000100";  -- 4ABC = 4
      when "100101010111101" =>  data <= "10000100";  -- 4ABD = 84
      when "100101010111110" =>  data <= "01101101";  -- 4ABE = 6D
      when "100101010111111" =>  data <= "10110100";  -- 4ABF = B4
      when "100101011000000" =>  data <= "00000011";  -- 4AC0 = 3
      when "100101011000001" =>  data <= "10010100";  -- 4AC1 = 94
      when "100101011000010" =>  data <= "00000100";  -- 4AC2 = 4
      when "100101011000011" =>  data <= "10110100";  -- 4AC3 = B4
      when "100101011000100" =>  data <= "00000010";  -- 4AC4 = 2
      when "100101011000101" =>  data <= "10010100";  -- 4AC5 = 94
      when "100101011000110" =>  data <= "00000011";  -- 4AC6 = 3
      when "100101011000111" =>  data <= "10110100";  -- 4AC7 = B4
      when "100101011001000" =>  data <= "00000001";  -- 4AC8 = 1
      when "100101011001001" =>  data <= "10010100";  -- 4AC9 = 94
      when "100101011001010" =>  data <= "00000010";  -- 4ACA = 2
      when "100101011001011" =>  data <= "10100100";  -- 4ACB = A4
      when "100101011001100" =>  data <= "01100101";  -- 4ACC = 65
      when "100101011001101" =>  data <= "10010100";  -- 4ACD = 94
      when "100101011001110" =>  data <= "00000001";  -- 4ACE = 1
      when "100101011001111" =>  data <= "01101001";  -- 4ACF = 69
      when "100101011010000" =>  data <= "00001000";  -- 4AD0 = 8
      when "100101011010001" =>  data <= "00110000";  -- 4AD1 = 30
      when "100101011010010" =>  data <= "11101000";  -- 4AD2 = E8
      when "100101011010011" =>  data <= "11110000";  -- 4AD3 = F0
      when "100101011010100" =>  data <= "11100110";  -- 4AD4 = E6
      when "100101011010101" =>  data <= "11101001";  -- 4AD5 = E9
      when "100101011010110" =>  data <= "00001000";  -- 4AD6 = 8
      when "100101011010111" =>  data <= "10101000";  -- 4AD7 = A8
      when "100101011011000" =>  data <= "10100101";  -- 4AD8 = A5
      when "100101011011001" =>  data <= "01101101";  -- 4AD9 = 6D
      when "100101011011010" =>  data <= "10110000";  -- 4ADA = B0
      when "100101011011011" =>  data <= "00010100";  -- 4ADB = 14
      when "100101011011100" =>  data <= "00010110";  -- 4ADC = 16
      when "100101011011101" =>  data <= "00000001";  -- 4ADD = 1
      when "100101011011110" =>  data <= "10010000";  -- 4ADE = 90
      when "100101011011111" =>  data <= "00000010";  -- 4ADF = 2
      when "100101011100000" =>  data <= "11110110";  -- 4AE0 = F6
      when "100101011100001" =>  data <= "00000001";  -- 4AE1 = 1
      when "100101011100010" =>  data <= "01110110";  -- 4AE2 = 76
      when "100101011100011" =>  data <= "00000001";  -- 4AE3 = 1
      when "100101011100100" =>  data <= "01110110";  -- 4AE4 = 76
      when "100101011100101" =>  data <= "00000001";  -- 4AE5 = 1
      when "100101011100110" =>  data <= "01110110";  -- 4AE6 = 76
      when "100101011100111" =>  data <= "00000010";  -- 4AE7 = 2
      when "100101011101000" =>  data <= "01110110";  -- 4AE8 = 76
      when "100101011101001" =>  data <= "00000011";  -- 4AE9 = 3
      when "100101011101010" =>  data <= "01110110";  -- 4AEA = 76
      when "100101011101011" =>  data <= "00000100";  -- 4AEB = 4
      when "100101011101100" =>  data <= "01101010";  -- 4AEC = 6A
      when "100101011101101" =>  data <= "11001000";  -- 4AED = C8
      when "100101011101110" =>  data <= "11010000";  -- 4AEE = D0
      when "100101011101111" =>  data <= "11101100";  -- 4AEF = EC
      when "100101011110000" =>  data <= "00011000";  -- 4AF0 = 18
      when "100101011110001" =>  data <= "01100000";  -- 4AF1 = 60
      when "100101011110010" =>  data <= "10000001";  -- 4AF2 = 81
      when "100101011110011" =>  data <= "00000000";  -- 4AF3 = 0
      when "100101011110100" =>  data <= "00000000";  -- 4AF4 = 0
      when "100101011110101" =>  data <= "00000000";  -- 4AF5 = 0
      when "100101011110110" =>  data <= "00000000";  -- 4AF6 = 0
      when "100101011110111" =>  data <= "00000011";  -- 4AF7 = 3
      when "100101011111000" =>  data <= "01111111";  -- 4AF8 = 7F
      when "100101011111001" =>  data <= "01011110";  -- 4AF9 = 5E
      when "100101011111010" =>  data <= "01010110";  -- 4AFA = 56
      when "100101011111011" =>  data <= "11001011";  -- 4AFB = CB
      when "100101011111100" =>  data <= "01111001";  -- 4AFC = 79
      when "100101011111101" =>  data <= "10000000";  -- 4AFD = 80
      when "100101011111110" =>  data <= "00010011";  -- 4AFE = 13
      when "100101011111111" =>  data <= "10011011";  -- 4AFF = 9B
      when "100101100000000" =>  data <= "00001011";  -- 4B00 = B
      when "100101100000001" =>  data <= "01100100";  -- 4B01 = 64
      when "100101100000010" =>  data <= "10000000";  -- 4B02 = 80
      when "100101100000011" =>  data <= "01110110";  -- 4B03 = 76
      when "100101100000100" =>  data <= "00111000";  -- 4B04 = 38
      when "100101100000101" =>  data <= "10010011";  -- 4B05 = 93
      when "100101100000110" =>  data <= "00010110";  -- 4B06 = 16
      when "100101100000111" =>  data <= "10000010";  -- 4B07 = 82
      when "100101100001000" =>  data <= "00111000";  -- 4B08 = 38
      when "100101100001001" =>  data <= "10101010";  -- 4B09 = AA
      when "100101100001010" =>  data <= "00111011";  -- 4B0A = 3B
      when "100101100001011" =>  data <= "00100000";  -- 4B0B = 20
      when "100101100001100" =>  data <= "10000000";  -- 4B0C = 80
      when "100101100001101" =>  data <= "00110101";  -- 4B0D = 35
      when "100101100001110" =>  data <= "00000100";  -- 4B0E = 4
      when "100101100001111" =>  data <= "11110011";  -- 4B0F = F3
      when "100101100010000" =>  data <= "00110100";  -- 4B10 = 34
      when "100101100010001" =>  data <= "10000001";  -- 4B11 = 81
      when "100101100010010" =>  data <= "00110101";  -- 4B12 = 35
      when "100101100010011" =>  data <= "00000100";  -- 4B13 = 4
      when "100101100010100" =>  data <= "11110011";  -- 4B14 = F3
      when "100101100010101" =>  data <= "00110100";  -- 4B15 = 34
      when "100101100010110" =>  data <= "10000000";  -- 4B16 = 80
      when "100101100010111" =>  data <= "10000000";  -- 4B17 = 80
      when "100101100011000" =>  data <= "00000000";  -- 4B18 = 0
      when "100101100011001" =>  data <= "00000000";  -- 4B19 = 0
      when "100101100011010" =>  data <= "00000000";  -- 4B1A = 0
      when "100101100011011" =>  data <= "10000000";  -- 4B1B = 80
      when "100101100011100" =>  data <= "00110001";  -- 4B1C = 31
      when "100101100011101" =>  data <= "01110010";  -- 4B1D = 72
      when "100101100011110" =>  data <= "00010111";  -- 4B1E = 17
      when "100101100011111" =>  data <= "11111000";  -- 4B1F = F8
      when "100101100100000" =>  data <= "00100000";  -- 4B20 = 20
      when "100101100100001" =>  data <= "01100001";  -- 4B21 = 61
      when "100101100100010" =>  data <= "11001101";  -- 4B22 = CD
      when "100101100100011" =>  data <= "11110000";  -- 4B23 = F0
      when "100101100100100" =>  data <= "00000010";  -- 4B24 = 2
      when "100101100100101" =>  data <= "00010000";  -- 4B25 = 10
      when "100101100100110" =>  data <= "00000011";  -- 4B26 = 3
      when "100101100100111" =>  data <= "01001100";  -- 4B27 = 4C
      when "100101100101000" =>  data <= "01110011";  -- 4B28 = 73
      when "100101100101001" =>  data <= "11000011";  -- 4B29 = C3
      when "100101100101010" =>  data <= "10100101";  -- 4B2A = A5
      when "100101100101011" =>  data <= "01011110";  -- 4B2B = 5E
      when "100101100101100" =>  data <= "11101001";  -- 4B2C = E9
      when "100101100101101" =>  data <= "01111111";  -- 4B2D = 7F
      when "100101100101110" =>  data <= "01001000";  -- 4B2E = 48
      when "100101100101111" =>  data <= "10101001";  -- 4B2F = A9
      when "100101100110000" =>  data <= "10000000";  -- 4B30 = 80
      when "100101100110001" =>  data <= "10000101";  -- 4B31 = 85
      when "100101100110010" =>  data <= "01011110";  -- 4B32 = 5E
      when "100101100110011" =>  data <= "10101001";  -- 4B33 = A9
      when "100101100110100" =>  data <= "00001100";  -- 4B34 = C
      when "100101100110101" =>  data <= "10100000";  -- 4B35 = A0
      when "100101100110110" =>  data <= "11001011";  -- 4B36 = CB
      when "100101100110111" =>  data <= "00100000";  -- 4B37 = 20
      when "100101100111000" =>  data <= "10011101";  -- 4B38 = 9D
      when "100101100111001" =>  data <= "11001001";  -- 4B39 = C9
      when "100101100111010" =>  data <= "10101001";  -- 4B3A = A9
      when "100101100111011" =>  data <= "00010001";  -- 4B3B = 11
      when "100101100111100" =>  data <= "10100000";  -- 4B3C = A0
      when "100101100111101" =>  data <= "11001011";  -- 4B3D = CB
      when "100101100111110" =>  data <= "00100000";  -- 4B3E = 20
      when "100101100111111" =>  data <= "01000101";  -- 4B3F = 45
      when "100101101000000" =>  data <= "11001100";  -- 4B40 = CC
      when "100101101000001" =>  data <= "10101001";  -- 4B41 = A9
      when "100101101000010" =>  data <= "11110010";  -- 4B42 = F2
      when "100101101000011" =>  data <= "10100000";  -- 4B43 = A0
      when "100101101000100" =>  data <= "11001010";  -- 4B44 = CA
      when "100101101000101" =>  data <= "00100000";  -- 4B45 = 20
      when "100101101000110" =>  data <= "10000110";  -- 4B46 = 86
      when "100101101000111" =>  data <= "11001001";  -- 4B47 = C9
      when "100101101001000" =>  data <= "10101001";  -- 4B48 = A9
      when "100101101001001" =>  data <= "11110111";  -- 4B49 = F7
      when "100101101001010" =>  data <= "10100000";  -- 4B4A = A0
      when "100101101001011" =>  data <= "11001010";  -- 4B4B = CA
      when "100101101001100" =>  data <= "00100000";  -- 4B4C = 20
      when "100101101001101" =>  data <= "11010111";  -- 4B4D = D7
      when "100101101001110" =>  data <= "11010001";  -- 4B4E = D1
      when "100101101001111" =>  data <= "10101001";  -- 4B4F = A9
      when "100101101010000" =>  data <= "00010110";  -- 4B50 = 16
      when "100101101010001" =>  data <= "10100000";  -- 4B51 = A0
      when "100101101010010" =>  data <= "11001011";  -- 4B52 = CB
      when "100101101010011" =>  data <= "00100000";  -- 4B53 = 20
      when "100101101010100" =>  data <= "10011101";  -- 4B54 = 9D
      when "100101101010101" =>  data <= "11001001";  -- 4B55 = C9
      when "100101101010110" =>  data <= "01101000";  -- 4B56 = 68
      when "100101101010111" =>  data <= "00100000";  -- 4B57 = 20
      when "100101101011000" =>  data <= "10110100";  -- 4B58 = B4
      when "100101101011001" =>  data <= "11001110";  -- 4B59 = CE
      when "100101101011010" =>  data <= "10101001";  -- 4B5A = A9
      when "100101101011011" =>  data <= "00011011";  -- 4B5B = 1B
      when "100101101011100" =>  data <= "10100000";  -- 4B5C = A0
      when "100101101011101" =>  data <= "11001011";  -- 4B5D = CB
      when "100101101011110" =>  data <= "00100000";  -- 4B5E = 20
      when "100101101011111" =>  data <= "11000010";  -- 4B5F = C2
      when "100101101100000" =>  data <= "11001011";  -- 4B60 = CB
      when "100101101100001" =>  data <= "11010000";  -- 4B61 = D0
      when "100101101100010" =>  data <= "00000011";  -- 4B62 = 3
      when "100101101100011" =>  data <= "01001100";  -- 4B63 = 4C
      when "100101101100100" =>  data <= "11000001";  -- 4B64 = C1
      when "100101101100101" =>  data <= "11001011";  -- 4B65 = CB
      when "100101101100110" =>  data <= "00100000";  -- 4B66 = 20
      when "100101101100111" =>  data <= "11101101";  -- 4B67 = ED
      when "100101101101000" =>  data <= "11001011";  -- 4B68 = CB
      when "100101101101001" =>  data <= "10101001";  -- 4B69 = A9
      when "100101101101010" =>  data <= "00000000";  -- 4B6A = 0
      when "100101101101011" =>  data <= "10000101";  -- 4B6B = 85
      when "100101101101100" =>  data <= "00100011";  -- 4B6C = 23
      when "100101101101101" =>  data <= "10000101";  -- 4B6D = 85
      when "100101101101110" =>  data <= "00100100";  -- 4B6E = 24
      when "100101101101111" =>  data <= "10000101";  -- 4B6F = 85
      when "100101101110000" =>  data <= "00100101";  -- 4B70 = 25
      when "100101101110001" =>  data <= "10000101";  -- 4B71 = 85
      when "100101101110010" =>  data <= "00100110";  -- 4B72 = 26
      when "100101101110011" =>  data <= "10100101";  -- 4B73 = A5
      when "100101101110100" =>  data <= "01101101";  -- 4B74 = 6D
      when "100101101110101" =>  data <= "00100000";  -- 4B75 = 20
      when "100101101110110" =>  data <= "10001111";  -- 4B76 = 8F
      when "100101101110111" =>  data <= "11001011";  -- 4B77 = CB
      when "100101101111000" =>  data <= "10100101";  -- 4B78 = A5
      when "100101101111001" =>  data <= "01100010";  -- 4B79 = 62
      when "100101101111010" =>  data <= "00100000";  -- 4B7A = 20
      when "100101101111011" =>  data <= "10001111";  -- 4B7B = 8F
      when "100101101111100" =>  data <= "11001011";  -- 4B7C = CB
      when "100101101111101" =>  data <= "10100101";  -- 4B7D = A5
      when "100101101111110" =>  data <= "01100001";  -- 4B7E = 61
      when "100101101111111" =>  data <= "00100000";  -- 4B7F = 20
      when "100101110000000" =>  data <= "10001111";  -- 4B80 = 8F
      when "100101110000001" =>  data <= "11001011";  -- 4B81 = CB
      when "100101110000010" =>  data <= "10100101";  -- 4B82 = A5
      when "100101110000011" =>  data <= "01100000";  -- 4B83 = 60
      when "100101110000100" =>  data <= "00100000";  -- 4B84 = 20
      when "100101110000101" =>  data <= "10001111";  -- 4B85 = 8F
      when "100101110000110" =>  data <= "11001011";  -- 4B86 = CB
      when "100101110000111" =>  data <= "10100101";  -- 4B87 = A5
      when "100101110001000" =>  data <= "01011111";  -- 4B88 = 5F
      when "100101110001001" =>  data <= "00100000";  -- 4B89 = 20
      when "100101110001010" =>  data <= "10010100";  -- 4B8A = 94
      when "100101110001011" =>  data <= "11001011";  -- 4B8B = CB
      when "100101110001100" =>  data <= "01001100";  -- 4B8C = 4C
      when "100101110001101" =>  data <= "11000101";  -- 4B8D = C5
      when "100101110001110" =>  data <= "11001100";  -- 4B8E = CC
      when "100101110001111" =>  data <= "11010000";  -- 4B8F = D0
      when "100101110010000" =>  data <= "00000011";  -- 4B90 = 3
      when "100101110010001" =>  data <= "01001100";  -- 4B91 = 4C
      when "100101110010010" =>  data <= "10111001";  -- 4B92 = B9
      when "100101110010011" =>  data <= "11001010";  -- 4B93 = CA
      when "100101110010100" =>  data <= "01001010";  -- 4B94 = 4A
      when "100101110010101" =>  data <= "00001001";  -- 4B95 = 9
      when "100101110010110" =>  data <= "10000000";  -- 4B96 = 80
      when "100101110010111" =>  data <= "10101000";  -- 4B97 = A8
      when "100101110011000" =>  data <= "10010000";  -- 4B98 = 90
      when "100101110011001" =>  data <= "00011001";  -- 4B99 = 19
      when "100101110011010" =>  data <= "00011000";  -- 4B9A = 18
      when "100101110011011" =>  data <= "10100101";  -- 4B9B = A5
      when "100101110011100" =>  data <= "00100110";  -- 4B9C = 26
      when "100101110011101" =>  data <= "01100101";  -- 4B9D = 65
      when "100101110011110" =>  data <= "01101010";  -- 4B9E = 6A
      when "100101110011111" =>  data <= "10000101";  -- 4B9F = 85
      when "100101110100000" =>  data <= "00100110";  -- 4BA0 = 26
      when "100101110100001" =>  data <= "10100101";  -- 4BA1 = A5
      when "100101110100010" =>  data <= "00100101";  -- 4BA2 = 25
      when "100101110100011" =>  data <= "01100101";  -- 4BA3 = 65
      when "100101110100100" =>  data <= "01101001";  -- 4BA4 = 69
      when "100101110100101" =>  data <= "10000101";  -- 4BA5 = 85
      when "100101110100110" =>  data <= "00100101";  -- 4BA6 = 25
      when "100101110100111" =>  data <= "10100101";  -- 4BA7 = A5
      when "100101110101000" =>  data <= "00100100";  -- 4BA8 = 24
      when "100101110101001" =>  data <= "01100101";  -- 4BA9 = 65
      when "100101110101010" =>  data <= "01101000";  -- 4BAA = 68
      when "100101110101011" =>  data <= "10000101";  -- 4BAB = 85
      when "100101110101100" =>  data <= "00100100";  -- 4BAC = 24
      when "100101110101101" =>  data <= "10100101";  -- 4BAD = A5
      when "100101110101110" =>  data <= "00100011";  -- 4BAE = 23
      when "100101110101111" =>  data <= "01100101";  -- 4BAF = 65
      when "100101110110000" =>  data <= "01100111";  -- 4BB0 = 67
      when "100101110110001" =>  data <= "10000101";  -- 4BB1 = 85
      when "100101110110010" =>  data <= "00100011";  -- 4BB2 = 23
      when "100101110110011" =>  data <= "01100110";  -- 4BB3 = 66
      when "100101110110100" =>  data <= "00100011";  -- 4BB4 = 23
      when "100101110110101" =>  data <= "01100110";  -- 4BB5 = 66
      when "100101110110110" =>  data <= "00100100";  -- 4BB6 = 24
      when "100101110110111" =>  data <= "01100110";  -- 4BB7 = 66
      when "100101110111000" =>  data <= "00100101";  -- 4BB8 = 25
      when "100101110111001" =>  data <= "01100110";  -- 4BB9 = 66
      when "100101110111010" =>  data <= "00100110";  -- 4BBA = 26
      when "100101110111011" =>  data <= "01100110";  -- 4BBB = 66
      when "100101110111100" =>  data <= "01101101";  -- 4BBC = 6D
      when "100101110111101" =>  data <= "10011000";  -- 4BBD = 98
      when "100101110111110" =>  data <= "01001010";  -- 4BBE = 4A
      when "100101110111111" =>  data <= "11010000";  -- 4BBF = D0
      when "100101111000000" =>  data <= "11010110";  -- 4BC0 = D6
      when "100101111000001" =>  data <= "01100000";  -- 4BC1 = 60
      when "100101111000010" =>  data <= "10000101";  -- 4BC2 = 85
      when "100101111000011" =>  data <= "00011111";  -- 4BC3 = 1F
      when "100101111000100" =>  data <= "10000100";  -- 4BC4 = 84
      when "100101111000101" =>  data <= "00100000";  -- 4BC5 = 20
      when "100101111000110" =>  data <= "10100000";  -- 4BC6 = A0
      when "100101111000111" =>  data <= "00000100";  -- 4BC7 = 4
      when "100101111001000" =>  data <= "10110001";  -- 4BC8 = B1
      when "100101111001001" =>  data <= "00011111";  -- 4BC9 = 1F
      when "100101111001010" =>  data <= "10000101";  -- 4BCA = 85
      when "100101111001011" =>  data <= "01101010";  -- 4BCB = 6A
      when "100101111001100" =>  data <= "10001000";  -- 4BCC = 88
      when "100101111001101" =>  data <= "10110001";  -- 4BCD = B1
      when "100101111001110" =>  data <= "00011111";  -- 4BCE = 1F
      when "100101111001111" =>  data <= "10000101";  -- 4BCF = 85
      when "100101111010000" =>  data <= "01101001";  -- 4BD0 = 69
      when "100101111010001" =>  data <= "10001000";  -- 4BD1 = 88
      when "100101111010010" =>  data <= "10110001";  -- 4BD2 = B1
      when "100101111010011" =>  data <= "00011111";  -- 4BD3 = 1F
      when "100101111010100" =>  data <= "10000101";  -- 4BD4 = 85
      when "100101111010101" =>  data <= "01101000";  -- 4BD5 = 68
      when "100101111010110" =>  data <= "10001000";  -- 4BD6 = 88
      when "100101111010111" =>  data <= "10110001";  -- 4BD7 = B1
      when "100101111011000" =>  data <= "00011111";  -- 4BD8 = 1F
      when "100101111011001" =>  data <= "10000101";  -- 4BD9 = 85
      when "100101111011010" =>  data <= "01101011";  -- 4BDA = 6B
      when "100101111011011" =>  data <= "01000101";  -- 4BDB = 45
      when "100101111011100" =>  data <= "01100011";  -- 4BDC = 63
      when "100101111011101" =>  data <= "10000101";  -- 4BDD = 85
      when "100101111011110" =>  data <= "01101100";  -- 4BDE = 6C
      when "100101111011111" =>  data <= "10100101";  -- 4BDF = A5
      when "100101111100000" =>  data <= "01101011";  -- 4BE0 = 6B
      when "100101111100001" =>  data <= "00001001";  -- 4BE1 = 9
      when "100101111100010" =>  data <= "10000000";  -- 4BE2 = 80
      when "100101111100011" =>  data <= "10000101";  -- 4BE3 = 85
      when "100101111100100" =>  data <= "01100111";  -- 4BE4 = 67
      when "100101111100101" =>  data <= "10001000";  -- 4BE5 = 88
      when "100101111100110" =>  data <= "10110001";  -- 4BE6 = B1
      when "100101111100111" =>  data <= "00011111";  -- 4BE7 = 1F
      when "100101111101000" =>  data <= "10000101";  -- 4BE8 = 85
      when "100101111101001" =>  data <= "01100110";  -- 4BE9 = 66
      when "100101111101010" =>  data <= "10100101";  -- 4BEA = A5
      when "100101111101011" =>  data <= "01011110";  -- 4BEB = 5E
      when "100101111101100" =>  data <= "01100000";  -- 4BEC = 60
      when "100101111101101" =>  data <= "10100101";  -- 4BED = A5
      when "100101111101110" =>  data <= "01100110";  -- 4BEE = 66
      when "100101111101111" =>  data <= "11110000";  -- 4BEF = F0
      when "100101111110000" =>  data <= "00011111";  -- 4BF0 = 1F
      when "100101111110001" =>  data <= "00011000";  -- 4BF1 = 18
      when "100101111110010" =>  data <= "01100101";  -- 4BF2 = 65
      when "100101111110011" =>  data <= "01011110";  -- 4BF3 = 5E
      when "100101111110100" =>  data <= "10010000";  -- 4BF4 = 90
      when "100101111110101" =>  data <= "00000100";  -- 4BF5 = 4
      when "100101111110110" =>  data <= "00110000";  -- 4BF6 = 30
      when "100101111110111" =>  data <= "00011101";  -- 4BF7 = 1D
      when "100101111111000" =>  data <= "00011000";  -- 4BF8 = 18
      when "100101111111001" =>  data <= "00101100";  -- 4BF9 = 2C
      when "100101111111010" =>  data <= "00010000";  -- 4BFA = 10
      when "100101111111011" =>  data <= "00010100";  -- 4BFB = 14
      when "100101111111100" =>  data <= "01101001";  -- 4BFC = 69
      when "100101111111101" =>  data <= "10000000";  -- 4BFD = 80
      when "100101111111110" =>  data <= "10000101";  -- 4BFE = 85
      when "100101111111111" =>  data <= "01011110";  -- 4BFF = 5E
      when "100110000000000" =>  data <= "11010000";  -- 4C00 = D0
      when "100110000000001" =>  data <= "00000011";  -- 4C01 = 3
      when "100110000000010" =>  data <= "01001100";  -- 4C02 = 4C
      when "100110000000011" =>  data <= "00110001";  -- 4C03 = 31
      when "100110000000100" =>  data <= "11001010";  -- 4C04 = CA
      when "100110000000101" =>  data <= "10100101";  -- 4C05 = A5
      when "100110000000110" =>  data <= "01101100";  -- 4C06 = 6C
      when "100110000000111" =>  data <= "10000101";  -- 4C07 = 85
      when "100110000001000" =>  data <= "01100011";  -- 4C08 = 63
      when "100110000001001" =>  data <= "01100000";  -- 4C09 = 60
      when "100110000001010" =>  data <= "10100101";  -- 4C0A = A5
      when "100110000001011" =>  data <= "01100011";  -- 4C0B = 63
      when "100110000001100" =>  data <= "01001001";  -- 4C0C = 49
      when "100110000001101" =>  data <= "11111111";  -- 4C0D = FF
      when "100110000001110" =>  data <= "00110000";  -- 4C0E = 30
      when "100110000001111" =>  data <= "00000101";  -- 4C0F = 5
      when "100110000010000" =>  data <= "01101000";  -- 4C10 = 68
      when "100110000010001" =>  data <= "01101000";  -- 4C11 = 68
      when "100110000010010" =>  data <= "01001100";  -- 4C12 = 4C
      when "100110000010011" =>  data <= "00101101";  -- 4C13 = 2D
      when "100110000010100" =>  data <= "11001010";  -- 4C14 = CA
      when "100110000010101" =>  data <= "01001100";  -- 4C15 = 4C
      when "100110000010110" =>  data <= "10110100";  -- 4C16 = B4
      when "100110000010111" =>  data <= "11001010";  -- 4C17 = CA
      when "100110000011000" =>  data <= "00100000";  -- 4C18 = 20
      when "100110000011001" =>  data <= "01000010";  -- 4C19 = 42
      when "100110000011010" =>  data <= "11001101";  -- 4C1A = CD
      when "100110000011011" =>  data <= "10101010";  -- 4C1B = AA
      when "100110000011100" =>  data <= "11110000";  -- 4C1C = F0
      when "100110000011101" =>  data <= "00010000";  -- 4C1D = 10
      when "100110000011110" =>  data <= "00011000";  -- 4C1E = 18
      when "100110000011111" =>  data <= "01101001";  -- 4C1F = 69
      when "100110000100000" =>  data <= "00000010";  -- 4C20 = 2
      when "100110000100001" =>  data <= "10110000";  -- 4C21 = B0
      when "100110000100010" =>  data <= "11110010";  -- 4C22 = F2
      when "100110000100011" =>  data <= "10100010";  -- 4C23 = A2
      when "100110000100100" =>  data <= "00000000";  -- 4C24 = 0
      when "100110000100101" =>  data <= "10000110";  -- 4C25 = 86
      when "100110000100110" =>  data <= "01101100";  -- 4C26 = 6C
      when "100110000100111" =>  data <= "00100000";  -- 4C27 = 20
      when "100110000101000" =>  data <= "10101101";  -- 4C28 = AD
      when "100110000101001" =>  data <= "11001001";  -- 4C29 = C9
      when "100110000101010" =>  data <= "11100110";  -- 4C2A = E6
      when "100110000101011" =>  data <= "01011110";  -- 4C2B = 5E
      when "100110000101100" =>  data <= "11110000";  -- 4C2C = F0
      when "100110000101101" =>  data <= "11100111";  -- 4C2D = E7
      when "100110000101110" =>  data <= "01100000";  -- 4C2E = 60
      when "100110000101111" =>  data <= "10000100";  -- 4C2F = 84
      when "100110000110000" =>  data <= "00100000";  -- 4C30 = 20
      when "100110000110001" =>  data <= "00000000";  -- 4C31 = 0
      when "100110000110010" =>  data <= "00000000";  -- 4C32 = 0
      when "100110000110011" =>  data <= "00000000";  -- 4C33 = 0
      when "100110000110100" =>  data <= "00100000";  -- 4C34 = 20
      when "100110000110101" =>  data <= "01000010";  -- 4C35 = 42
      when "100110000110110" =>  data <= "11001101";  -- 4C36 = CD
      when "100110000110111" =>  data <= "10101001";  -- 4C37 = A9
      when "100110000111000" =>  data <= "00101111";  -- 4C38 = 2F
      when "100110000111001" =>  data <= "10100000";  -- 4C39 = A0
      when "100110000111010" =>  data <= "11001100";  -- 4C3A = CC
      when "100110000111011" =>  data <= "10100010";  -- 4C3B = A2
      when "100110000111100" =>  data <= "00000000";  -- 4C3C = 0
      when "100110000111101" =>  data <= "10000110";  -- 4C3D = 86
      when "100110000111110" =>  data <= "01101100";  -- 4C3E = 6C
      when "100110000111111" =>  data <= "00100000";  -- 4C3F = 20
      when "100110001000000" =>  data <= "11011000";  -- 4C40 = D8
      when "100110001000001" =>  data <= "11001100";  -- 4C41 = CC
      when "100110001000010" =>  data <= "01001100";  -- 4C42 = 4C
      when "100110001000011" =>  data <= "01001000";  -- 4C43 = 48
      when "100110001000100" =>  data <= "11001100";  -- 4C44 = CC
      when "100110001000101" =>  data <= "00100000";  -- 4C45 = 20
      when "100110001000110" =>  data <= "11000010";  -- 4C46 = C2
      when "100110001000111" =>  data <= "11001011";  -- 4C47 = CB
      when "100110001001000" =>  data <= "11110000";  -- 4C48 = F0
      when "100110001001001" =>  data <= "01110110";  -- 4C49 = 76
      when "100110001001010" =>  data <= "00100000";  -- 4C4A = 20
      when "100110001001011" =>  data <= "01010001";  -- 4C4B = 51
      when "100110001001100" =>  data <= "11001101";  -- 4C4C = CD
      when "100110001001101" =>  data <= "10101001";  -- 4C4D = A9
      when "100110001001110" =>  data <= "00000000";  -- 4C4E = 0
      when "100110001001111" =>  data <= "00111000";  -- 4C4F = 38
      when "100110001010000" =>  data <= "11100101";  -- 4C50 = E5
      when "100110001010001" =>  data <= "01011110";  -- 4C51 = 5E
      when "100110001010010" =>  data <= "10000101";  -- 4C52 = 85
      when "100110001010011" =>  data <= "01011110";  -- 4C53 = 5E
      when "100110001010100" =>  data <= "00100000";  -- 4C54 = 20
      when "100110001010101" =>  data <= "11101101";  -- 4C55 = ED
      when "100110001010110" =>  data <= "11001011";  -- 4C56 = CB
      when "100110001010111" =>  data <= "11100110";  -- 4C57 = E6
      when "100110001011000" =>  data <= "01011110";  -- 4C58 = 5E
      when "100110001011001" =>  data <= "11110000";  -- 4C59 = F0
      when "100110001011010" =>  data <= "10111010";  -- 4C5A = BA
      when "100110001011011" =>  data <= "10100010";  -- 4C5B = A2
      when "100110001011100" =>  data <= "11111100";  -- 4C5C = FC
      when "100110001011101" =>  data <= "10101001";  -- 4C5D = A9
      when "100110001011110" =>  data <= "00000001";  -- 4C5E = 1
      when "100110001011111" =>  data <= "10100100";  -- 4C5F = A4
      when "100110001100000" =>  data <= "01100111";  -- 4C60 = 67
      when "100110001100001" =>  data <= "11000100";  -- 4C61 = C4
      when "100110001100010" =>  data <= "01011111";  -- 4C62 = 5F
      when "100110001100011" =>  data <= "11010000";  -- 4C63 = D0
      when "100110001100100" =>  data <= "00010000";  -- 4C64 = 10
      when "100110001100101" =>  data <= "10100100";  -- 4C65 = A4
      when "100110001100110" =>  data <= "01101000";  -- 4C66 = 68
      when "100110001100111" =>  data <= "11000100";  -- 4C67 = C4
      when "100110001101000" =>  data <= "01100000";  -- 4C68 = 60
      when "100110001101001" =>  data <= "11010000";  -- 4C69 = D0
      when "100110001101010" =>  data <= "00001010";  -- 4C6A = A
      when "100110001101011" =>  data <= "10100100";  -- 4C6B = A4
      when "100110001101100" =>  data <= "01101001";  -- 4C6C = 69
      when "100110001101101" =>  data <= "11000100";  -- 4C6D = C4
      when "100110001101110" =>  data <= "01100001";  -- 4C6E = 61
      when "100110001101111" =>  data <= "11010000";  -- 4C6F = D0
      when "100110001110000" =>  data <= "00000100";  -- 4C70 = 4
      when "100110001110001" =>  data <= "10100100";  -- 4C71 = A4
      when "100110001110010" =>  data <= "01101010";  -- 4C72 = 6A
      when "100110001110011" =>  data <= "11000100";  -- 4C73 = C4
      when "100110001110100" =>  data <= "01100010";  -- 4C74 = 62
      when "100110001110101" =>  data <= "00001000";  -- 4C75 = 8
      when "100110001110110" =>  data <= "00101010";  -- 4C76 = 2A
      when "100110001110111" =>  data <= "10010000";  -- 4C77 = 90
      when "100110001111000" =>  data <= "00001001";  -- 4C78 = 9
      when "100110001111001" =>  data <= "11101000";  -- 4C79 = E8
      when "100110001111010" =>  data <= "10010101";  -- 4C7A = 95
      when "100110001111011" =>  data <= "00100110";  -- 4C7B = 26
      when "100110001111100" =>  data <= "11110000";  -- 4C7C = F0
      when "100110001111101" =>  data <= "00110010";  -- 4C7D = 32
      when "100110001111110" =>  data <= "00010000";  -- 4C7E = 10
      when "100110001111111" =>  data <= "00110100";  -- 4C7F = 34
      when "100110010000000" =>  data <= "10101001";  -- 4C80 = A9
      when "100110010000001" =>  data <= "00000001";  -- 4C81 = 1
      when "100110010000010" =>  data <= "00101000";  -- 4C82 = 28
      when "100110010000011" =>  data <= "10110000";  -- 4C83 = B0
      when "100110010000100" =>  data <= "00001110";  -- 4C84 = E
      when "100110010000101" =>  data <= "00000110";  -- 4C85 = 6
      when "100110010000110" =>  data <= "01101010";  -- 4C86 = 6A
      when "100110010000111" =>  data <= "00100110";  -- 4C87 = 26
      when "100110010001000" =>  data <= "01101001";  -- 4C88 = 69
      when "100110010001001" =>  data <= "00100110";  -- 4C89 = 26
      when "100110010001010" =>  data <= "01101000";  -- 4C8A = 68
      when "100110010001011" =>  data <= "00100110";  -- 4C8B = 26
      when "100110010001100" =>  data <= "01100111";  -- 4C8C = 67
      when "100110010001101" =>  data <= "10110000";  -- 4C8D = B0
      when "100110010001110" =>  data <= "11100110";  -- 4C8E = E6
      when "100110010001111" =>  data <= "00110000";  -- 4C8F = 30
      when "100110010010000" =>  data <= "11001110";  -- 4C90 = CE
      when "100110010010001" =>  data <= "00010000";  -- 4C91 = 10
      when "100110010010010" =>  data <= "11100010";  -- 4C92 = E2
      when "100110010010011" =>  data <= "10101000";  -- 4C93 = A8
      when "100110010010100" =>  data <= "10100101";  -- 4C94 = A5
      when "100110010010101" =>  data <= "01101010";  -- 4C95 = 6A
      when "100110010010110" =>  data <= "11100101";  -- 4C96 = E5
      when "100110010010111" =>  data <= "01100010";  -- 4C97 = 62
      when "100110010011000" =>  data <= "10000101";  -- 4C98 = 85
      when "100110010011001" =>  data <= "01101010";  -- 4C99 = 6A
      when "100110010011010" =>  data <= "10100101";  -- 4C9A = A5
      when "100110010011011" =>  data <= "01101001";  -- 4C9B = 69
      when "100110010011100" =>  data <= "11100101";  -- 4C9C = E5
      when "100110010011101" =>  data <= "01100001";  -- 4C9D = 61
      when "100110010011110" =>  data <= "10000101";  -- 4C9E = 85
      when "100110010011111" =>  data <= "01101001";  -- 4C9F = 69
      when "100110010100000" =>  data <= "10100101";  -- 4CA0 = A5
      when "100110010100001" =>  data <= "01101000";  -- 4CA1 = 68
      when "100110010100010" =>  data <= "11100101";  -- 4CA2 = E5
      when "100110010100011" =>  data <= "01100000";  -- 4CA3 = 60
      when "100110010100100" =>  data <= "10000101";  -- 4CA4 = 85
      when "100110010100101" =>  data <= "01101000";  -- 4CA5 = 68
      when "100110010100110" =>  data <= "10100101";  -- 4CA6 = A5
      when "100110010100111" =>  data <= "01100111";  -- 4CA7 = 67
      when "100110010101000" =>  data <= "11100101";  -- 4CA8 = E5
      when "100110010101001" =>  data <= "01011111";  -- 4CA9 = 5F
      when "100110010101010" =>  data <= "10000101";  -- 4CAA = 85
      when "100110010101011" =>  data <= "01100111";  -- 4CAB = 67
      when "100110010101100" =>  data <= "10011000";  -- 4CAC = 98
      when "100110010101101" =>  data <= "01001100";  -- 4CAD = 4C
      when "100110010101110" =>  data <= "10000101";  -- 4CAE = 85
      when "100110010101111" =>  data <= "11001100";  -- 4CAF = CC
      when "100110010110000" =>  data <= "10101001";  -- 4CB0 = A9
      when "100110010110001" =>  data <= "01000000";  -- 4CB1 = 40
      when "100110010110010" =>  data <= "11010000";  -- 4CB2 = D0
      when "100110010110011" =>  data <= "11001110";  -- 4CB3 = CE
      when "100110010110100" =>  data <= "00001010";  -- 4CB4 = A
      when "100110010110101" =>  data <= "00001010";  -- 4CB5 = A
      when "100110010110110" =>  data <= "00001010";  -- 4CB6 = A
      when "100110010110111" =>  data <= "00001010";  -- 4CB7 = A
      when "100110010111000" =>  data <= "00001010";  -- 4CB8 = A
      when "100110010111001" =>  data <= "00001010";  -- 4CB9 = A
      when "100110010111010" =>  data <= "10000101";  -- 4CBA = 85
      when "100110010111011" =>  data <= "01101101";  -- 4CBB = 6D
      when "100110010111100" =>  data <= "00101000";  -- 4CBC = 28
      when "100110010111101" =>  data <= "01001100";  -- 4CBD = 4C
      when "100110010111110" =>  data <= "11000101";  -- 4CBE = C5
      when "100110010111111" =>  data <= "11001100";  -- 4CBF = CC
      when "100110011000000" =>  data <= "10100010";  -- 4CC0 = A2
      when "100110011000001" =>  data <= "10000101";  -- 4CC1 = 85
      when "100110011000010" =>  data <= "01001100";  -- 4CC2 = 4C
      when "100110011000011" =>  data <= "11001111";  -- 4CC3 = CF
      when "100110011000100" =>  data <= "10110011";  -- 4CC4 = B3
      when "100110011000101" =>  data <= "10100101";  -- 4CC5 = A5
      when "100110011000110" =>  data <= "00100011";  -- 4CC6 = 23
      when "100110011000111" =>  data <= "10000101";  -- 4CC7 = 85
      when "100110011001000" =>  data <= "01011111";  -- 4CC8 = 5F
      when "100110011001001" =>  data <= "10100101";  -- 4CC9 = A5
      when "100110011001010" =>  data <= "00100100";  -- 4CCA = 24
      when "100110011001011" =>  data <= "10000101";  -- 4CCB = 85
      when "100110011001100" =>  data <= "01100000";  -- 4CCC = 60
      when "100110011001101" =>  data <= "10100101";  -- 4CCD = A5
      when "100110011001110" =>  data <= "00100101";  -- 4CCE = 25
      when "100110011001111" =>  data <= "10000101";  -- 4CCF = 85
      when "100110011010000" =>  data <= "01100001";  -- 4CD0 = 61
      when "100110011010001" =>  data <= "10100101";  -- 4CD1 = A5
      when "100110011010010" =>  data <= "00100110";  -- 4CD2 = 26
      when "100110011010011" =>  data <= "10000101";  -- 4CD3 = 85
      when "100110011010100" =>  data <= "01100010";  -- 4CD4 = 62
      when "100110011010101" =>  data <= "01001100";  -- 4CD5 = 4C
      when "100110011010110" =>  data <= "00001101";  -- 4CD6 = D
      when "100110011010111" =>  data <= "11001010";  -- 4CD7 = CA
      when "100110011011000" =>  data <= "10000101";  -- 4CD8 = 85
      when "100110011011001" =>  data <= "00011111";  -- 4CD9 = 1F
      when "100110011011010" =>  data <= "10000100";  -- 4CDA = 84
      when "100110011011011" =>  data <= "00100000";  -- 4CDB = 20
      when "100110011011100" =>  data <= "10100000";  -- 4CDC = A0
      when "100110011011101" =>  data <= "00000100";  -- 4CDD = 4
      when "100110011011110" =>  data <= "10110001";  -- 4CDE = B1
      when "100110011011111" =>  data <= "00011111";  -- 4CDF = 1F
      when "100110011100000" =>  data <= "10000101";  -- 4CE0 = 85
      when "100110011100001" =>  data <= "01100010";  -- 4CE1 = 62
      when "100110011100010" =>  data <= "10001000";  -- 4CE2 = 88
      when "100110011100011" =>  data <= "10110001";  -- 4CE3 = B1
      when "100110011100100" =>  data <= "00011111";  -- 4CE4 = 1F
      when "100110011100101" =>  data <= "10000101";  -- 4CE5 = 85
      when "100110011100110" =>  data <= "01100001";  -- 4CE6 = 61
      when "100110011100111" =>  data <= "10001000";  -- 4CE7 = 88
      when "100110011101000" =>  data <= "10110001";  -- 4CE8 = B1
      when "100110011101001" =>  data <= "00011111";  -- 4CE9 = 1F
      when "100110011101010" =>  data <= "10000101";  -- 4CEA = 85
      when "100110011101011" =>  data <= "01100000";  -- 4CEB = 60
      when "100110011101100" =>  data <= "10001000";  -- 4CEC = 88
      when "100110011101101" =>  data <= "10110001";  -- 4CED = B1
      when "100110011101110" =>  data <= "00011111";  -- 4CEE = 1F
      when "100110011101111" =>  data <= "10000101";  -- 4CEF = 85
      when "100110011110000" =>  data <= "01100011";  -- 4CF0 = 63
      when "100110011110001" =>  data <= "00001001";  -- 4CF1 = 9
      when "100110011110010" =>  data <= "10000000";  -- 4CF2 = 80
      when "100110011110011" =>  data <= "10000101";  -- 4CF3 = 85
      when "100110011110100" =>  data <= "01011111";  -- 4CF4 = 5F
      when "100110011110101" =>  data <= "10001000";  -- 4CF5 = 88
      when "100110011110110" =>  data <= "10110001";  -- 4CF6 = B1
      when "100110011110111" =>  data <= "00011111";  -- 4CF7 = 1F
      when "100110011111000" =>  data <= "10000101";  -- 4CF8 = 85
      when "100110011111001" =>  data <= "01011110";  -- 4CF9 = 5E
      when "100110011111010" =>  data <= "10000100";  -- 4CFA = 84
      when "100110011111011" =>  data <= "01101101";  -- 4CFB = 6D
      when "100110011111100" =>  data <= "01100000";  -- 4CFC = 60
      when "100110011111101" =>  data <= "10100010";  -- 4CFD = A2
      when "100110011111110" =>  data <= "01011001";  -- 4CFE = 59
      when "100110011111111" =>  data <= "00101100";  -- 4CFF = 2C
      when "100110100000000" =>  data <= "10100010";  -- 4D00 = A2
      when "100110100000001" =>  data <= "01010100";  -- 4D01 = 54
      when "100110100000010" =>  data <= "10100000";  -- 4D02 = A0
      when "100110100000011" =>  data <= "00000000";  -- 4D03 = 0
      when "100110100000100" =>  data <= "11110000";  -- 4D04 = F0
      when "100110100000101" =>  data <= "00000100";  -- 4D05 = 4
      when "100110100000110" =>  data <= "10100110";  -- 4D06 = A6
      when "100110100000111" =>  data <= "01000110";  -- 4D07 = 46
      when "100110100001000" =>  data <= "10100100";  -- 4D08 = A4
      when "100110100001001" =>  data <= "01000111";  -- 4D09 = 47
      when "100110100001010" =>  data <= "00100000";  -- 4D0A = 20
      when "100110100001011" =>  data <= "01010001";  -- 4D0B = 51
      when "100110100001100" =>  data <= "11001101";  -- 4D0C = CD
      when "100110100001101" =>  data <= "10000110";  -- 4D0D = 86
      when "100110100001110" =>  data <= "00011111";  -- 4D0E = 1F
      when "100110100001111" =>  data <= "10000100";  -- 4D0F = 84
      when "100110100010000" =>  data <= "00100000";  -- 4D10 = 20
      when "100110100010001" =>  data <= "10100000";  -- 4D11 = A0
      when "100110100010010" =>  data <= "00000100";  -- 4D12 = 4
      when "100110100010011" =>  data <= "10100101";  -- 4D13 = A5
      when "100110100010100" =>  data <= "01100010";  -- 4D14 = 62
      when "100110100010101" =>  data <= "10010001";  -- 4D15 = 91
      when "100110100010110" =>  data <= "00011111";  -- 4D16 = 1F
      when "100110100010111" =>  data <= "10001000";  -- 4D17 = 88
      when "100110100011000" =>  data <= "10100101";  -- 4D18 = A5
      when "100110100011001" =>  data <= "01100001";  -- 4D19 = 61
      when "100110100011010" =>  data <= "10010001";  -- 4D1A = 91
      when "100110100011011" =>  data <= "00011111";  -- 4D1B = 1F
      when "100110100011100" =>  data <= "10001000";  -- 4D1C = 88
      when "100110100011101" =>  data <= "10100101";  -- 4D1D = A5
      when "100110100011110" =>  data <= "01100000";  -- 4D1E = 60
      when "100110100011111" =>  data <= "10010001";  -- 4D1F = 91
      when "100110100100000" =>  data <= "00011111";  -- 4D20 = 1F
      when "100110100100001" =>  data <= "10001000";  -- 4D21 = 88
      when "100110100100010" =>  data <= "10100101";  -- 4D22 = A5
      when "100110100100011" =>  data <= "01100011";  -- 4D23 = 63
      when "100110100100100" =>  data <= "00001001";  -- 4D24 = 9
      when "100110100100101" =>  data <= "01111111";  -- 4D25 = 7F
      when "100110100100110" =>  data <= "00100101";  -- 4D26 = 25
      when "100110100100111" =>  data <= "01011111";  -- 4D27 = 5F
      when "100110100101000" =>  data <= "10010001";  -- 4D28 = 91
      when "100110100101001" =>  data <= "00011111";  -- 4D29 = 1F
      when "100110100101010" =>  data <= "10001000";  -- 4D2A = 88
      when "100110100101011" =>  data <= "10100101";  -- 4D2B = A5
      when "100110100101100" =>  data <= "01011110";  -- 4D2C = 5E
      when "100110100101101" =>  data <= "10010001";  -- 4D2D = 91
      when "100110100101110" =>  data <= "00011111";  -- 4D2E = 1F
      when "100110100101111" =>  data <= "10000100";  -- 4D2F = 84
      when "100110100110000" =>  data <= "01101101";  -- 4D30 = 6D
      when "100110100110001" =>  data <= "01100000";  -- 4D31 = 60
      when "100110100110010" =>  data <= "10100101";  -- 4D32 = A5
      when "100110100110011" =>  data <= "01101011";  -- 4D33 = 6B
      when "100110100110100" =>  data <= "10000101";  -- 4D34 = 85
      when "100110100110101" =>  data <= "01100011";  -- 4D35 = 63
      when "100110100110110" =>  data <= "10100010";  -- 4D36 = A2
      when "100110100110111" =>  data <= "00000101";  -- 4D37 = 5
      when "100110100111000" =>  data <= "10110101";  -- 4D38 = B5
      when "100110100111001" =>  data <= "01100101";  -- 4D39 = 65
      when "100110100111010" =>  data <= "10010101";  -- 4D3A = 95
      when "100110100111011" =>  data <= "01011101";  -- 4D3B = 5D
      when "100110100111100" =>  data <= "11001010";  -- 4D3C = CA
      when "100110100111101" =>  data <= "11010000";  -- 4D3D = D0
      when "100110100111110" =>  data <= "11111001";  -- 4D3E = F9
      when "100110100111111" =>  data <= "10000110";  -- 4D3F = 86
      when "100110101000000" =>  data <= "01101101";  -- 4D40 = 6D
      when "100110101000001" =>  data <= "01100000";  -- 4D41 = 60
      when "100110101000010" =>  data <= "00100000";  -- 4D42 = 20
      when "100110101000011" =>  data <= "01010001";  -- 4D43 = 51
      when "100110101000100" =>  data <= "11001101";  -- 4D44 = CD
      when "100110101000101" =>  data <= "10100010";  -- 4D45 = A2
      when "100110101000110" =>  data <= "00000110";  -- 4D46 = 6
      when "100110101000111" =>  data <= "10110101";  -- 4D47 = B5
      when "100110101001000" =>  data <= "01011101";  -- 4D48 = 5D
      when "100110101001001" =>  data <= "10010101";  -- 4D49 = 95
      when "100110101001010" =>  data <= "01100101";  -- 4D4A = 65
      when "100110101001011" =>  data <= "11001010";  -- 4D4B = CA
      when "100110101001100" =>  data <= "11010000";  -- 4D4C = D0
      when "100110101001101" =>  data <= "11111001";  -- 4D4D = F9
      when "100110101001110" =>  data <= "10000110";  -- 4D4E = 86
      when "100110101001111" =>  data <= "01101101";  -- 4D4F = 6D
      when "100110101010000" =>  data <= "01100000";  -- 4D50 = 60
      when "100110101010001" =>  data <= "10100101";  -- 4D51 = A5
      when "100110101010010" =>  data <= "01011110";  -- 4D52 = 5E
      when "100110101010011" =>  data <= "11110000";  -- 4D53 = F0
      when "100110101010100" =>  data <= "11111011";  -- 4D54 = FB
      when "100110101010101" =>  data <= "00000110";  -- 4D55 = 6
      when "100110101010110" =>  data <= "01101101";  -- 4D56 = 6D
      when "100110101010111" =>  data <= "10010000";  -- 4D57 = 90
      when "100110101011000" =>  data <= "11110111";  -- 4D58 = F7
      when "100110101011001" =>  data <= "00100000";  -- 4D59 = 20
      when "100110101011010" =>  data <= "10100101";  -- 4D5A = A5
      when "100110101011011" =>  data <= "11001010";  -- 4D5B = CA
      when "100110101011100" =>  data <= "11010000";  -- 4D5C = D0
      when "100110101011101" =>  data <= "11110010";  -- 4D5D = F2
      when "100110101011110" =>  data <= "01001100";  -- 4D5E = 4C
      when "100110101011111" =>  data <= "01101110";  -- 4D5F = 6E
      when "100110101100000" =>  data <= "11001010";  -- 4D60 = CA
      when "100110101100001" =>  data <= "10100101";  -- 4D61 = A5
      when "100110101100010" =>  data <= "01011110";  -- 4D62 = 5E
      when "100110101100011" =>  data <= "11110000";  -- 4D63 = F0
      when "100110101100100" =>  data <= "00001001";  -- 4D64 = 9
      when "100110101100101" =>  data <= "10100101";  -- 4D65 = A5
      when "100110101100110" =>  data <= "01100011";  -- 4D66 = 63
      when "100110101100111" =>  data <= "00101010";  -- 4D67 = 2A
      when "100110101101000" =>  data <= "10101001";  -- 4D68 = A9
      when "100110101101001" =>  data <= "11111111";  -- 4D69 = FF
      when "100110101101010" =>  data <= "10110000";  -- 4D6A = B0
      when "100110101101011" =>  data <= "00000010";  -- 4D6B = 2
      when "100110101101100" =>  data <= "10101001";  -- 4D6C = A9
      when "100110101101101" =>  data <= "00000001";  -- 4D6D = 1
      when "100110101101110" =>  data <= "01100000";  -- 4D6E = 60
      when "100110101101111" =>  data <= "00100000";  -- 4D6F = 20
      when "100110101110000" =>  data <= "01100001";  -- 4D70 = 61
      when "100110101110001" =>  data <= "11001101";  -- 4D71 = CD
      when "100110101110010" =>  data <= "10000101";  -- 4D72 = 85
      when "100110101110011" =>  data <= "01011111";  -- 4D73 = 5F
      when "100110101110100" =>  data <= "10101001";  -- 4D74 = A9
      when "100110101110101" =>  data <= "00000000";  -- 4D75 = 0
      when "100110101110110" =>  data <= "10000101";  -- 4D76 = 85
      when "100110101110111" =>  data <= "01100000";  -- 4D77 = 60
      when "100110101111000" =>  data <= "10100010";  -- 4D78 = A2
      when "100110101111001" =>  data <= "10001000";  -- 4D79 = 88
      when "100110101111010" =>  data <= "10100101";  -- 4D7A = A5
      when "100110101111011" =>  data <= "01011111";  -- 4D7B = 5F
      when "100110101111100" =>  data <= "01001001";  -- 4D7C = 49
      when "100110101111101" =>  data <= "11111111";  -- 4D7D = FF
      when "100110101111110" =>  data <= "00101010";  -- 4D7E = 2A
      when "100110101111111" =>  data <= "10101001";  -- 4D7F = A9
      when "100110110000000" =>  data <= "00000000";  -- 4D80 = 0
      when "100110110000001" =>  data <= "10000101";  -- 4D81 = 85
      when "100110110000010" =>  data <= "01100010";  -- 4D82 = 62
      when "100110110000011" =>  data <= "10000101";  -- 4D83 = 85
      when "100110110000100" =>  data <= "01100001";  -- 4D84 = 61
      when "100110110000101" =>  data <= "10000110";  -- 4D85 = 86
      when "100110110000110" =>  data <= "01011110";  -- 4D86 = 5E
      when "100110110000111" =>  data <= "10000101";  -- 4D87 = 85
      when "100110110001000" =>  data <= "01101101";  -- 4D88 = 6D
      when "100110110001001" =>  data <= "10000101";  -- 4D89 = 85
      when "100110110001010" =>  data <= "01100011";  -- 4D8A = 63
      when "100110110001011" =>  data <= "01001100";  -- 4D8B = 4C
      when "100110110001100" =>  data <= "00001000";  -- 4D8C = 8
      when "100110110001101" =>  data <= "11001010";  -- 4D8D = CA
      when "100110110001110" =>  data <= "01000110";  -- 4D8E = 46
      when "100110110001111" =>  data <= "01100011";  -- 4D8F = 63
      when "100110110010000" =>  data <= "01100000";  -- 4D90 = 60
      when "100110110010001" =>  data <= "10000101";  -- 4D91 = 85
      when "100110110010010" =>  data <= "00100001";  -- 4D92 = 21
      when "100110110010011" =>  data <= "10000100";  -- 4D93 = 84
      when "100110110010100" =>  data <= "00100010";  -- 4D94 = 22
      when "100110110010101" =>  data <= "10100000";  -- 4D95 = A0
      when "100110110010110" =>  data <= "00000000";  -- 4D96 = 0
      when "100110110010111" =>  data <= "10110001";  -- 4D97 = B1
      when "100110110011000" =>  data <= "00100001";  -- 4D98 = 21
      when "100110110011001" =>  data <= "11001000";  -- 4D99 = C8
      when "100110110011010" =>  data <= "10101010";  -- 4D9A = AA
      when "100110110011011" =>  data <= "11110000";  -- 4D9B = F0
      when "100110110011100" =>  data <= "11000100";  -- 4D9C = C4
      when "100110110011101" =>  data <= "10110001";  -- 4D9D = B1
      when "100110110011110" =>  data <= "00100001";  -- 4D9E = 21
      when "100110110011111" =>  data <= "01000101";  -- 4D9F = 45
      when "100110110100000" =>  data <= "01100011";  -- 4DA0 = 63
      when "100110110100001" =>  data <= "00110000";  -- 4DA1 = 30
      when "100110110100010" =>  data <= "11000010";  -- 4DA2 = C2
      when "100110110100011" =>  data <= "11100100";  -- 4DA3 = E4
      when "100110110100100" =>  data <= "01011110";  -- 4DA4 = 5E
      when "100110110100101" =>  data <= "11010000";  -- 4DA5 = D0
      when "100110110100110" =>  data <= "00100001";  -- 4DA6 = 21
      when "100110110100111" =>  data <= "10110001";  -- 4DA7 = B1
      when "100110110101000" =>  data <= "00100001";  -- 4DA8 = 21
      when "100110110101001" =>  data <= "00001001";  -- 4DA9 = 9
      when "100110110101010" =>  data <= "10000000";  -- 4DAA = 80
      when "100110110101011" =>  data <= "11000101";  -- 4DAB = C5
      when "100110110101100" =>  data <= "01011111";  -- 4DAC = 5F
      when "100110110101101" =>  data <= "11010000";  -- 4DAD = D0
      when "100110110101110" =>  data <= "00011001";  -- 4DAE = 19
      when "100110110101111" =>  data <= "11001000";  -- 4DAF = C8
      when "100110110110000" =>  data <= "10110001";  -- 4DB0 = B1
      when "100110110110001" =>  data <= "00100001";  -- 4DB1 = 21
      when "100110110110010" =>  data <= "11000101";  -- 4DB2 = C5
      when "100110110110011" =>  data <= "01100000";  -- 4DB3 = 60
      when "100110110110100" =>  data <= "11010000";  -- 4DB4 = D0
      when "100110110110101" =>  data <= "00010010";  -- 4DB5 = 12
      when "100110110110110" =>  data <= "11001000";  -- 4DB6 = C8
      when "100110110110111" =>  data <= "10110001";  -- 4DB7 = B1
      when "100110110111000" =>  data <= "00100001";  -- 4DB8 = 21
      when "100110110111001" =>  data <= "11000101";  -- 4DB9 = C5
      when "100110110111010" =>  data <= "01100001";  -- 4DBA = 61
      when "100110110111011" =>  data <= "11010000";  -- 4DBB = D0
      when "100110110111100" =>  data <= "00001011";  -- 4DBC = B
      when "100110110111101" =>  data <= "11001000";  -- 4DBD = C8
      when "100110110111110" =>  data <= "10101001";  -- 4DBE = A9
      when "100110110111111" =>  data <= "01111111";  -- 4DBF = 7F
      when "100110111000000" =>  data <= "11000101";  -- 4DC0 = C5
      when "100110111000001" =>  data <= "01101101";  -- 4DC1 = 6D
      when "100110111000010" =>  data <= "10110001";  -- 4DC2 = B1
      when "100110111000011" =>  data <= "00100001";  -- 4DC3 = 21
      when "100110111000100" =>  data <= "11100101";  -- 4DC4 = E5
      when "100110111000101" =>  data <= "01100010";  -- 4DC5 = 62
      when "100110111000110" =>  data <= "11110000";  -- 4DC6 = F0
      when "100110111000111" =>  data <= "00101000";  -- 4DC7 = 28
      when "100110111001000" =>  data <= "10100101";  -- 4DC8 = A5
      when "100110111001001" =>  data <= "01100011";  -- 4DC9 = 63
      when "100110111001010" =>  data <= "10010000";  -- 4DCA = 90
      when "100110111001011" =>  data <= "00000010";  -- 4DCB = 2
      when "100110111001100" =>  data <= "01001001";  -- 4DCC = 49
      when "100110111001101" =>  data <= "11111111";  -- 4DCD = FF
      when "100110111001110" =>  data <= "01001100";  -- 4DCE = 4C
      when "100110111001111" =>  data <= "01100111";  -- 4DCF = 67
      when "100110111010000" =>  data <= "11001101";  -- 4DD0 = CD
      when "100110111010001" =>  data <= "10100101";  -- 4DD1 = A5
      when "100110111010010" =>  data <= "01011110";  -- 4DD2 = 5E
      when "100110111010011" =>  data <= "11110000";  -- 4DD3 = F0
      when "100110111010100" =>  data <= "01001010";  -- 4DD4 = 4A
      when "100110111010101" =>  data <= "00111000";  -- 4DD5 = 38
      when "100110111010110" =>  data <= "11101001";  -- 4DD6 = E9
      when "100110111010111" =>  data <= "10100000";  -- 4DD7 = A0
      when "100110111011000" =>  data <= "00100100";  -- 4DD8 = 24
      when "100110111011001" =>  data <= "01100011";  -- 4DD9 = 63
      when "100110111011010" =>  data <= "00010000";  -- 4DDA = 10
      when "100110111011011" =>  data <= "00001001";  -- 4DDB = 9
      when "100110111011100" =>  data <= "10101010";  -- 4DDC = AA
      when "100110111011101" =>  data <= "10101001";  -- 4DDD = A9
      when "100110111011110" =>  data <= "11111111";  -- 4DDE = FF
      when "100110111011111" =>  data <= "10000101";  -- 4DDF = 85
      when "100110111100000" =>  data <= "01100101";  -- 4DE0 = 65
      when "100110111100001" =>  data <= "00100000";  -- 4DE1 = 20
      when "100110111100010" =>  data <= "10000011";  -- 4DE2 = 83
      when "100110111100011" =>  data <= "11001010";  -- 4DE3 = CA
      when "100110111100100" =>  data <= "10001010";  -- 4DE4 = 8A
      when "100110111100101" =>  data <= "10100010";  -- 4DE5 = A2
      when "100110111100110" =>  data <= "01011110";  -- 4DE6 = 5E
      when "100110111100111" =>  data <= "11001001";  -- 4DE7 = C9
      when "100110111101000" =>  data <= "11111001";  -- 4DE8 = F9
      when "100110111101001" =>  data <= "00010000";  -- 4DE9 = 10
      when "100110111101010" =>  data <= "00000110";  -- 4DEA = 6
      when "100110111101011" =>  data <= "00100000";  -- 4DEB = 20
      when "100110111101100" =>  data <= "11001111";  -- 4DEC = CF
      when "100110111101101" =>  data <= "11001010";  -- 4DED = CA
      when "100110111101110" =>  data <= "10000100";  -- 4DEE = 84
      when "100110111101111" =>  data <= "01100101";  -- 4DEF = 65
      when "100110111110000" =>  data <= "01100000";  -- 4DF0 = 60
      when "100110111110001" =>  data <= "10101000";  -- 4DF1 = A8
      when "100110111110010" =>  data <= "10100101";  -- 4DF2 = A5
      when "100110111110011" =>  data <= "01100011";  -- 4DF3 = 63
      when "100110111110100" =>  data <= "00101001";  -- 4DF4 = 29
      when "100110111110101" =>  data <= "10000000";  -- 4DF5 = 80
      when "100110111110110" =>  data <= "01000110";  -- 4DF6 = 46
      when "100110111110111" =>  data <= "01011111";  -- 4DF7 = 5F
      when "100110111111000" =>  data <= "00000101";  -- 4DF8 = 5
      when "100110111111001" =>  data <= "01011111";  -- 4DF9 = 5F
      when "100110111111010" =>  data <= "10000101";  -- 4DFA = 85
      when "100110111111011" =>  data <= "01011111";  -- 4DFB = 5F
      when "100110111111100" =>  data <= "00100000";  -- 4DFC = 20
      when "100110111111101" =>  data <= "11100110";  -- 4DFD = E6
      when "100110111111110" =>  data <= "11001010";  -- 4DFE = CA
      when "100110111111111" =>  data <= "10000100";  -- 4DFF = 84
      when "100111000000000" =>  data <= "01100101";  -- 4E00 = 65
      when "100111000000001" =>  data <= "01100000";  -- 4E01 = 60
      when "100111000000010" =>  data <= "10100101";  -- 4E02 = A5
      when "100111000000011" =>  data <= "01011110";  -- 4E03 = 5E
      when "100111000000100" =>  data <= "11001001";  -- 4E04 = C9
      when "100111000000101" =>  data <= "10100000";  -- 4E05 = A0
      when "100111000000110" =>  data <= "10110000";  -- 4E06 = B0
      when "100111000000111" =>  data <= "00100000";  -- 4E07 = 20
      when "100111000001000" =>  data <= "00100000";  -- 4E08 = 20
      when "100111000001001" =>  data <= "11010001";  -- 4E09 = D1
      when "100111000001010" =>  data <= "11001101";  -- 4E0A = CD
      when "100111000001011" =>  data <= "10000100";  -- 4E0B = 84
      when "100111000001100" =>  data <= "01101101";  -- 4E0C = 6D
      when "100111000001101" =>  data <= "10100101";  -- 4E0D = A5
      when "100111000001110" =>  data <= "01100011";  -- 4E0E = 63
      when "100111000001111" =>  data <= "10000100";  -- 4E0F = 84
      when "100111000010000" =>  data <= "01100011";  -- 4E10 = 63
      when "100111000010001" =>  data <= "01001001";  -- 4E11 = 49
      when "100111000010010" =>  data <= "10000000";  -- 4E12 = 80
      when "100111000010011" =>  data <= "00101010";  -- 4E13 = 2A
      when "100111000010100" =>  data <= "10101001";  -- 4E14 = A9
      when "100111000010101" =>  data <= "10100000";  -- 4E15 = A0
      when "100111000010110" =>  data <= "10000101";  -- 4E16 = 85
      when "100111000010111" =>  data <= "01011110";  -- 4E17 = 5E
      when "100111000011000" =>  data <= "10100101";  -- 4E18 = A5
      when "100111000011001" =>  data <= "01100010";  -- 4E19 = 62
      when "100111000011010" =>  data <= "10000101";  -- 4E1A = 85
      when "100111000011011" =>  data <= "00000011";  -- 4E1B = 3
      when "100111000011100" =>  data <= "01001100";  -- 4E1C = 4C
      when "100111000011101" =>  data <= "00001000";  -- 4E1D = 8
      when "100111000011110" =>  data <= "11001010";  -- 4E1E = CA
      when "100111000011111" =>  data <= "10000101";  -- 4E1F = 85
      when "100111000100000" =>  data <= "01011111";  -- 4E20 = 5F
      when "100111000100001" =>  data <= "10000101";  -- 4E21 = 85
      when "100111000100010" =>  data <= "01100000";  -- 4E22 = 60
      when "100111000100011" =>  data <= "10000101";  -- 4E23 = 85
      when "100111000100100" =>  data <= "01100001";  -- 4E24 = 61
      when "100111000100101" =>  data <= "10000101";  -- 4E25 = 85
      when "100111000100110" =>  data <= "01100010";  -- 4E26 = 62
      when "100111000100111" =>  data <= "10101000";  -- 4E27 = A8
      when "100111000101000" =>  data <= "01100000";  -- 4E28 = 60
      when "100111000101001" =>  data <= "10100000";  -- 4E29 = A0
      when "100111000101010" =>  data <= "00000000";  -- 4E2A = 0
      when "100111000101011" =>  data <= "10100010";  -- 4E2B = A2
      when "100111000101100" =>  data <= "00001010";  -- 4E2C = A
      when "100111000101101" =>  data <= "10010100";  -- 4E2D = 94
      when "100111000101110" =>  data <= "01011010";  -- 4E2E = 5A
      when "100111000101111" =>  data <= "11001010";  -- 4E2F = CA
      when "100111000110000" =>  data <= "00010000";  -- 4E30 = 10
      when "100111000110001" =>  data <= "11111011";  -- 4E31 = FB
      when "100111000110010" =>  data <= "10010000";  -- 4E32 = 90
      when "100111000110011" =>  data <= "00001111";  -- 4E33 = F
      when "100111000110100" =>  data <= "11001001";  -- 4E34 = C9
      when "100111000110101" =>  data <= "00101101";  -- 4E35 = 2D
      when "100111000110110" =>  data <= "11010000";  -- 4E36 = D0
      when "100111000110111" =>  data <= "00000100";  -- 4E37 = 4
      when "100111000111000" =>  data <= "10000110";  -- 4E38 = 86
      when "100111000111001" =>  data <= "01100100";  -- 4E39 = 64
      when "100111000111010" =>  data <= "11110000";  -- 4E3A = F0
      when "100111000111011" =>  data <= "00000100";  -- 4E3B = 4
      when "100111000111100" =>  data <= "11001001";  -- 4E3C = C9
      when "100111000111101" =>  data <= "00101011";  -- 4E3D = 2B
      when "100111000111110" =>  data <= "11010000";  -- 4E3E = D0
      when "100111000111111" =>  data <= "00000101";  -- 4E3F = 5
      when "100111001000000" =>  data <= "00100000";  -- 4E40 = 20
      when "100111001000001" =>  data <= "01110000";  -- 4E41 = 70
      when "100111001000010" =>  data <= "00000000";  -- 4E42 = 0
      when "100111001000011" =>  data <= "10010000";  -- 4E43 = 90
      when "100111001000100" =>  data <= "01011011";  -- 4E44 = 5B
      when "100111001000101" =>  data <= "11001001";  -- 4E45 = C9
      when "100111001000110" =>  data <= "00101110";  -- 4E46 = 2E
      when "100111001000111" =>  data <= "11110000";  -- 4E47 = F0
      when "100111001001000" =>  data <= "00101110";  -- 4E48 = 2E
      when "100111001001001" =>  data <= "11001001";  -- 4E49 = C9
      when "100111001001010" =>  data <= "01000101";  -- 4E4A = 45
      when "100111001001011" =>  data <= "11010000";  -- 4E4B = D0
      when "100111001001100" =>  data <= "00110000";  -- 4E4C = 30
      when "100111001001101" =>  data <= "00100000";  -- 4E4D = 20
      when "100111001001110" =>  data <= "01110000";  -- 4E4E = 70
      when "100111001001111" =>  data <= "00000000";  -- 4E4F = 0
      when "100111001010000" =>  data <= "10010000";  -- 4E50 = 90
      when "100111001010001" =>  data <= "00010111";  -- 4E51 = 17
      when "100111001010010" =>  data <= "11001001";  -- 4E52 = C9
      when "100111001010011" =>  data <= "10101011";  -- 4E53 = AB
      when "100111001010100" =>  data <= "11110000";  -- 4E54 = F0
      when "100111001010101" =>  data <= "00001110";  -- 4E55 = E
      when "100111001010110" =>  data <= "11001001";  -- 4E56 = C9
      when "100111001010111" =>  data <= "00101101";  -- 4E57 = 2D
      when "100111001011000" =>  data <= "11110000";  -- 4E58 = F0
      when "100111001011001" =>  data <= "00001010";  -- 4E59 = A
      when "100111001011010" =>  data <= "11001001";  -- 4E5A = C9
      when "100111001011011" =>  data <= "10101010";  -- 4E5B = AA
      when "100111001011100" =>  data <= "11110000";  -- 4E5C = F0
      when "100111001011101" =>  data <= "00001000";  -- 4E5D = 8
      when "100111001011110" =>  data <= "11001001";  -- 4E5E = C9
      when "100111001011111" =>  data <= "00101011";  -- 4E5F = 2B
      when "100111001100000" =>  data <= "11110000";  -- 4E60 = F0
      when "100111001100001" =>  data <= "00000100";  -- 4E61 = 4
      when "100111001100010" =>  data <= "11010000";  -- 4E62 = D0
      when "100111001100011" =>  data <= "00000111";  -- 4E63 = 7
      when "100111001100100" =>  data <= "01100110";  -- 4E64 = 66
      when "100111001100101" =>  data <= "01011101";  -- 4E65 = 5D
      when "100111001100110" =>  data <= "00100000";  -- 4E66 = 20
      when "100111001100111" =>  data <= "01110000";  -- 4E67 = 70
      when "100111001101000" =>  data <= "00000000";  -- 4E68 = 0
      when "100111001101001" =>  data <= "10010000";  -- 4E69 = 90
      when "100111001101010" =>  data <= "01011100";  -- 4E6A = 5C
      when "100111001101011" =>  data <= "00100100";  -- 4E6B = 24
      when "100111001101100" =>  data <= "01011101";  -- 4E6C = 5D
      when "100111001101101" =>  data <= "00010000";  -- 4E6D = 10
      when "100111001101110" =>  data <= "00001110";  -- 4E6E = E
      when "100111001101111" =>  data <= "10101001";  -- 4E6F = A9
      when "100111001110000" =>  data <= "00000000";  -- 4E70 = 0
      when "100111001110001" =>  data <= "00111000";  -- 4E71 = 38
      when "100111001110010" =>  data <= "11100101";  -- 4E72 = E5
      when "100111001110011" =>  data <= "01011011";  -- 4E73 = 5B
      when "100111001110100" =>  data <= "01001100";  -- 4E74 = 4C
      when "100111001110101" =>  data <= "01111111";  -- 4E75 = 7F
      when "100111001110110" =>  data <= "11001110";  -- 4E76 = CE
      when "100111001110111" =>  data <= "01100110";  -- 4E77 = 66
      when "100111001111000" =>  data <= "01011100";  -- 4E78 = 5C
      when "100111001111001" =>  data <= "00100100";  -- 4E79 = 24
      when "100111001111010" =>  data <= "01011100";  -- 4E7A = 5C
      when "100111001111011" =>  data <= "01010000";  -- 4E7B = 50
      when "100111001111100" =>  data <= "11000011";  -- 4E7C = C3
      when "100111001111101" =>  data <= "10100101";  -- 4E7D = A5
      when "100111001111110" =>  data <= "01011011";  -- 4E7E = 5B
      when "100111001111111" =>  data <= "00111000";  -- 4E7F = 38
      when "100111010000000" =>  data <= "11100101";  -- 4E80 = E5
      when "100111010000001" =>  data <= "01011010";  -- 4E81 = 5A
      when "100111010000010" =>  data <= "10000101";  -- 4E82 = 85
      when "100111010000011" =>  data <= "01011011";  -- 4E83 = 5B
      when "100111010000100" =>  data <= "11110000";  -- 4E84 = F0
      when "100111010000101" =>  data <= "00010010";  -- 4E85 = 12
      when "100111010000110" =>  data <= "00010000";  -- 4E86 = 10
      when "100111010000111" =>  data <= "00001001";  -- 4E87 = 9
      when "100111010001000" =>  data <= "00100000";  -- 4E88 = 20
      when "100111010001001" =>  data <= "00110100";  -- 4E89 = 34
      when "100111010001010" =>  data <= "11001100";  -- 4E8A = CC
      when "100111010001011" =>  data <= "11100110";  -- 4E8B = E6
      when "100111010001100" =>  data <= "01011011";  -- 4E8C = 5B
      when "100111010001101" =>  data <= "11010000";  -- 4E8D = D0
      when "100111010001110" =>  data <= "11111001";  -- 4E8E = F9
      when "100111010001111" =>  data <= "11110000";  -- 4E8F = F0
      when "100111010010000" =>  data <= "00000111";  -- 4E90 = 7
      when "100111010010001" =>  data <= "00100000";  -- 4E91 = 20
      when "100111010010010" =>  data <= "00011000";  -- 4E92 = 18
      when "100111010010011" =>  data <= "11001100";  -- 4E93 = CC
      when "100111010010100" =>  data <= "11000110";  -- 4E94 = C6
      when "100111010010101" =>  data <= "01011011";  -- 4E95 = 5B
      when "100111010010110" =>  data <= "11010000";  -- 4E96 = D0
      when "100111010010111" =>  data <= "11111001";  -- 4E97 = F9
      when "100111010011000" =>  data <= "10100101";  -- 4E98 = A5
      when "100111010011001" =>  data <= "01100100";  -- 4E99 = 64
      when "100111010011010" =>  data <= "00110000";  -- 4E9A = 30
      when "100111010011011" =>  data <= "00000001";  -- 4E9B = 1
      when "100111010011100" =>  data <= "01100000";  -- 4E9C = 60
      when "100111010011101" =>  data <= "01001100";  -- 4E9D = 4C
      when "100111010011110" =>  data <= "01001011";  -- 4E9E = 4B
      when "100111010011111" =>  data <= "11010001";  -- 4E9F = D1
      when "100111010100000" =>  data <= "01001000";  -- 4EA0 = 48
      when "100111010100001" =>  data <= "00100100";  -- 4EA1 = 24
      when "100111010100010" =>  data <= "01011100";  -- 4EA2 = 5C
      when "100111010100011" =>  data <= "00010000";  -- 4EA3 = 10
      when "100111010100100" =>  data <= "00000010";  -- 4EA4 = 2
      when "100111010100101" =>  data <= "11100110";  -- 4EA5 = E6
      when "100111010100110" =>  data <= "01011010";  -- 4EA6 = 5A
      when "100111010100111" =>  data <= "00100000";  -- 4EA7 = 20
      when "100111010101000" =>  data <= "00011000";  -- 4EA8 = 18
      when "100111010101001" =>  data <= "11001100";  -- 4EA9 = CC
      when "100111010101010" =>  data <= "01101000";  -- 4EAA = 68
      when "100111010101011" =>  data <= "00111000";  -- 4EAB = 38
      when "100111010101100" =>  data <= "11101001";  -- 4EAC = E9
      when "100111010101101" =>  data <= "00110000";  -- 4EAD = 30
      when "100111010101110" =>  data <= "00100000";  -- 4EAE = 20
      when "100111010101111" =>  data <= "10110100";  -- 4EAF = B4
      when "100111010110000" =>  data <= "11001110";  -- 4EB0 = CE
      when "100111010110001" =>  data <= "01001100";  -- 4EB1 = 4C
      when "100111010110010" =>  data <= "01000000";  -- 4EB2 = 40
      when "100111010110011" =>  data <= "11001110";  -- 4EB3 = CE
      when "100111010110100" =>  data <= "01001000";  -- 4EB4 = 48
      when "100111010110101" =>  data <= "00100000";  -- 4EB5 = 20
      when "100111010110110" =>  data <= "01000010";  -- 4EB6 = 42
      when "100111010110111" =>  data <= "11001101";  -- 4EB7 = CD
      when "100111010111000" =>  data <= "01101000";  -- 4EB8 = 68
      when "100111010111001" =>  data <= "00100000";  -- 4EB9 = 20
      when "100111010111010" =>  data <= "01110010";  -- 4EBA = 72
      when "100111010111011" =>  data <= "11001101";  -- 4EBB = CD
      when "100111010111100" =>  data <= "10100101";  -- 4EBC = A5
      when "100111010111101" =>  data <= "01101011";  -- 4EBD = 6B
      when "100111010111110" =>  data <= "01000101";  -- 4EBE = 45
      when "100111010111111" =>  data <= "01100011";  -- 4EBF = 63
      when "100111011000000" =>  data <= "10000101";  -- 4EC0 = 85
      when "100111011000001" =>  data <= "01101100";  -- 4EC1 = 6C
      when "100111011000010" =>  data <= "10100110";  -- 4EC2 = A6
      when "100111011000011" =>  data <= "01011110";  -- 4EC3 = 5E
      when "100111011000100" =>  data <= "01001100";  -- 4EC4 = 4C
      when "100111011000101" =>  data <= "10100000";  -- 4EC5 = A0
      when "100111011000110" =>  data <= "11001001";  -- 4EC6 = C9
      when "100111011000111" =>  data <= "10100101";  -- 4EC7 = A5
      when "100111011001000" =>  data <= "01011011";  -- 4EC8 = 5B
      when "100111011001001" =>  data <= "11001001";  -- 4EC9 = C9
      when "100111011001010" =>  data <= "00001010";  -- 4ECA = A
      when "100111011001011" =>  data <= "10010000";  -- 4ECB = 90
      when "100111011001100" =>  data <= "00001001";  -- 4ECC = 9
      when "100111011001101" =>  data <= "10101001";  -- 4ECD = A9
      when "100111011001110" =>  data <= "01100100";  -- 4ECE = 64
      when "100111011001111" =>  data <= "00100100";  -- 4ECF = 24
      when "100111011010000" =>  data <= "01011101";  -- 4ED0 = 5D
      when "100111011010001" =>  data <= "00110000";  -- 4ED1 = 30
      when "100111011010010" =>  data <= "00010001";  -- 4ED2 = 11
      when "100111011010011" =>  data <= "01001100";  -- 4ED3 = 4C
      when "100111011010100" =>  data <= "10110100";  -- 4ED4 = B4
      when "100111011010101" =>  data <= "11001010";  -- 4ED5 = CA
      when "100111011010110" =>  data <= "00001010";  -- 4ED6 = A
      when "100111011010111" =>  data <= "00001010";  -- 4ED7 = A
      when "100111011011000" =>  data <= "00011000";  -- 4ED8 = 18
      when "100111011011001" =>  data <= "01100101";  -- 4ED9 = 65
      when "100111011011010" =>  data <= "01011011";  -- 4EDA = 5B
      when "100111011011011" =>  data <= "00001010";  -- 4EDB = A
      when "100111011011100" =>  data <= "00011000";  -- 4EDC = 18
      when "100111011011101" =>  data <= "10100000";  -- 4EDD = A0
      when "100111011011110" =>  data <= "00000000";  -- 4EDE = 0
      when "100111011011111" =>  data <= "01110001";  -- 4EDF = 71
      when "100111011100000" =>  data <= "01110111";  -- 4EE0 = 77
      when "100111011100001" =>  data <= "00111000";  -- 4EE1 = 38
      when "100111011100010" =>  data <= "11101001";  -- 4EE2 = E9
      when "100111011100011" =>  data <= "00110000";  -- 4EE3 = 30
      when "100111011100100" =>  data <= "10000101";  -- 4EE4 = 85
      when "100111011100101" =>  data <= "01011011";  -- 4EE5 = 5B
      when "100111011100110" =>  data <= "01001100";  -- 4EE6 = 4C
      when "100111011100111" =>  data <= "01100110";  -- 4EE7 = 66
      when "100111011101000" =>  data <= "11001110";  -- 4EE8 = CE
      when "100111011101001" =>  data <= "10011011";  -- 4EE9 = 9B
      when "100111011101010" =>  data <= "00111110";  -- 4EEA = 3E
      when "100111011101011" =>  data <= "10111100";  -- 4EEB = BC
      when "100111011101100" =>  data <= "00011111";  -- 4EEC = 1F
      when "100111011101101" =>  data <= "11111101";  -- 4EED = FD
      when "100111011101110" =>  data <= "10011110";  -- 4EEE = 9E
      when "100111011101111" =>  data <= "01101110";  -- 4EEF = 6E
      when "100111011110000" =>  data <= "01101011";  -- 4EF0 = 6B
      when "100111011110001" =>  data <= "00100111";  -- 4EF1 = 27
      when "100111011110010" =>  data <= "11111101";  -- 4EF2 = FD
      when "100111011110011" =>  data <= "10011110";  -- 4EF3 = 9E
      when "100111011110100" =>  data <= "01101110";  -- 4EF4 = 6E
      when "100111011110101" =>  data <= "01101011";  -- 4EF5 = 6B
      when "100111011110110" =>  data <= "00101000";  -- 4EF6 = 28
      when "100111011110111" =>  data <= "00000000";  -- 4EF7 = 0
      when "100111011111000" =>  data <= "11111001";  -- 4EF8 = F9
      when "100111011111001" =>  data <= "10101010";  -- 4EF9 = AA
      when "100111011111010" =>  data <= "10101010";  -- 4EFA = AA
      when "100111011111011" =>  data <= "10101010";  -- 4EFB = AA
      when "100111011111100" =>  data <= "10101010";  -- 4EFC = AA
      when "100111011111101" =>  data <= "10101010";  -- 4EFD = AA
      when "100111011111110" =>  data <= "10101010";  -- 4EFE = AA
      when "100111011111111" =>  data <= "10101010";  -- 4EFF = AA
      when "100111100000000" =>  data <= "10101010";  -- 4F00 = AA
      when "100111100000001" =>  data <= "10101010";  -- 4F01 = AA
      when "100111100000010" =>  data <= "10101010";  -- 4F02 = AA
      when "100111100000011" =>  data <= "10101010";  -- 4F03 = AA
      when "100111100000100" =>  data <= "10101010";  -- 4F04 = AA
      when "100111100000101" =>  data <= "10101010";  -- 4F05 = AA
      when "100111100000110" =>  data <= "10101010";  -- 4F06 = AA
      when "100111100000111" =>  data <= "10101010";  -- 4F07 = AA
      when "100111100001000" =>  data <= "10101010";  -- 4F08 = AA
      when "100111100001001" =>  data <= "10101010";  -- 4F09 = AA
      when "100111100001010" =>  data <= "10101010";  -- 4F0A = AA
      when "100111100001011" =>  data <= "10101010";  -- 4F0B = AA
      when "100111100001100" =>  data <= "10101010";  -- 4F0C = AA
      when "100111100001101" =>  data <= "10101010";  -- 4F0D = AA
      when "100111100001110" =>  data <= "10101010";  -- 4F0E = AA
      when "100111100001111" =>  data <= "10101010";  -- 4F0F = AA
      when "100111100010000" =>  data <= "10101010";  -- 4F10 = AA
      when "100111100010001" =>  data <= "10101010";  -- 4F11 = AA
      when "100111100010010" =>  data <= "10101010";  -- 4F12 = AA
      when "100111100010011" =>  data <= "10101010";  -- 4F13 = AA
      when "100111100010100" =>  data <= "10101010";  -- 4F14 = AA
      when "100111100010101" =>  data <= "10101010";  -- 4F15 = AA
      when "100111100010110" =>  data <= "10101010";  -- 4F16 = AA
      when "100111100010111" =>  data <= "10101010";  -- 4F17 = AA
      when "100111100011000" =>  data <= "10101010";  -- 4F18 = AA
      when "100111100011001" =>  data <= "10101010";  -- 4F19 = AA
      when "100111100011010" =>  data <= "10101010";  -- 4F1A = AA
      when "100111100011011" =>  data <= "10101010";  -- 4F1B = AA
      when "100111100011100" =>  data <= "10101010";  -- 4F1C = AA
      when "100111100011101" =>  data <= "10101010";  -- 4F1D = AA
      when "100111100011110" =>  data <= "10101010";  -- 4F1E = AA
      when "100111100011111" =>  data <= "10101010";  -- 4F1F = AA
      when "100111100100000" =>  data <= "10101010";  -- 4F20 = AA
      when "100111100100001" =>  data <= "10101010";  -- 4F21 = AA
      when "100111100100010" =>  data <= "10101010";  -- 4F22 = AA
      when "100111100100011" =>  data <= "10101010";  -- 4F23 = AA
      when "100111100100100" =>  data <= "10101010";  -- 4F24 = AA
      when "100111100100101" =>  data <= "10101010";  -- 4F25 = AA
      when "100111100100110" =>  data <= "10101010";  -- 4F26 = AA
      when "100111100100111" =>  data <= "10101010";  -- 4F27 = AA
      when "100111100101000" =>  data <= "10101010";  -- 4F28 = AA
      when "100111100101001" =>  data <= "10101010";  -- 4F29 = AA
      when "100111100101010" =>  data <= "10101010";  -- 4F2A = AA
      when "100111100101011" =>  data <= "10101010";  -- 4F2B = AA
      when "100111100101100" =>  data <= "10101010";  -- 4F2C = AA
      when "100111100101101" =>  data <= "10101010";  -- 4F2D = AA
      when "100111100101110" =>  data <= "10101010";  -- 4F2E = AA
      when "100111100101111" =>  data <= "10101010";  -- 4F2F = AA
      when "100111100110000" =>  data <= "10101010";  -- 4F30 = AA
      when "100111100110001" =>  data <= "10101010";  -- 4F31 = AA
      when "100111100110010" =>  data <= "10101010";  -- 4F32 = AA
      when "100111100110011" =>  data <= "10101010";  -- 4F33 = AA
      when "100111100110100" =>  data <= "10101010";  -- 4F34 = AA
      when "100111100110101" =>  data <= "10101010";  -- 4F35 = AA
      when "100111100110110" =>  data <= "10101010";  -- 4F36 = AA
      when "100111100110111" =>  data <= "10101010";  -- 4F37 = AA
      when "100111100111000" =>  data <= "10101010";  -- 4F38 = AA
      when "100111100111001" =>  data <= "10101010";  -- 4F39 = AA
      when "100111100111010" =>  data <= "10101010";  -- 4F3A = AA
      when "100111100111011" =>  data <= "10101010";  -- 4F3B = AA
      when "100111100111100" =>  data <= "10101010";  -- 4F3C = AA
      when "100111100111101" =>  data <= "10101010";  -- 4F3D = AA
      when "100111100111110" =>  data <= "10101010";  -- 4F3E = AA
      when "100111100111111" =>  data <= "10101010";  -- 4F3F = AA
      when "100111101000000" =>  data <= "10101010";  -- 4F40 = AA
      when "100111101000001" =>  data <= "10101010";  -- 4F41 = AA
      when "100111101000010" =>  data <= "10101010";  -- 4F42 = AA
      when "100111101000011" =>  data <= "10101010";  -- 4F43 = AA
      when "100111101000100" =>  data <= "10101010";  -- 4F44 = AA
      when "100111101000101" =>  data <= "10101010";  -- 4F45 = AA
      when "100111101000110" =>  data <= "10101010";  -- 4F46 = AA
      when "100111101000111" =>  data <= "10101010";  -- 4F47 = AA
      when "100111101001000" =>  data <= "10101010";  -- 4F48 = AA
      when "100111101001001" =>  data <= "10101010";  -- 4F49 = AA
      when "100111101001010" =>  data <= "10101010";  -- 4F4A = AA
      when "100111101001011" =>  data <= "10101010";  -- 4F4B = AA
      when "100111101001100" =>  data <= "10101010";  -- 4F4C = AA
      when "100111101001101" =>  data <= "10101010";  -- 4F4D = AA
      when "100111101001110" =>  data <= "10101010";  -- 4F4E = AA
      when "100111101001111" =>  data <= "10101010";  -- 4F4F = AA
      when "100111101010000" =>  data <= "10101010";  -- 4F50 = AA
      when "100111101010001" =>  data <= "10101010";  -- 4F51 = AA
      when "100111101010010" =>  data <= "10101010";  -- 4F52 = AA
      when "100111101010011" =>  data <= "10101010";  -- 4F53 = AA
      when "100111101010100" =>  data <= "10101010";  -- 4F54 = AA
      when "100111101010101" =>  data <= "10101010";  -- 4F55 = AA
      when "100111101010110" =>  data <= "10101010";  -- 4F56 = AA
      when "100111101010111" =>  data <= "10101010";  -- 4F57 = AA
      when "100111101011000" =>  data <= "10101010";  -- 4F58 = AA
      when "100111101011001" =>  data <= "10101010";  -- 4F59 = AA
      when "100111101011010" =>  data <= "10101010";  -- 4F5A = AA
      when "100111101011011" =>  data <= "10101010";  -- 4F5B = AA
      when "100111101011100" =>  data <= "10101010";  -- 4F5C = AA
      when "100111101011101" =>  data <= "10101010";  -- 4F5D = AA
      when "100111101011110" =>  data <= "10101010";  -- 4F5E = AA
      when "100111101011111" =>  data <= "10101010";  -- 4F5F = AA
      when "100111101100000" =>  data <= "10101010";  -- 4F60 = AA
      when "100111101100001" =>  data <= "10101010";  -- 4F61 = AA
      when "100111101100010" =>  data <= "10101010";  -- 4F62 = AA
      when "100111101100011" =>  data <= "10101010";  -- 4F63 = AA
      when "100111101100100" =>  data <= "10101010";  -- 4F64 = AA
      when "100111101100101" =>  data <= "10101010";  -- 4F65 = AA
      when "100111101100110" =>  data <= "10101010";  -- 4F66 = AA
      when "100111101100111" =>  data <= "10101010";  -- 4F67 = AA
      when "100111101101000" =>  data <= "10101010";  -- 4F68 = AA
      when "100111101101001" =>  data <= "10101010";  -- 4F69 = AA
      when "100111101101010" =>  data <= "10101010";  -- 4F6A = AA
      when "100111101101011" =>  data <= "10101010";  -- 4F6B = AA
      when "100111101101100" =>  data <= "10101010";  -- 4F6C = AA
      when "100111101101101" =>  data <= "10101010";  -- 4F6D = AA
      when "100111101101110" =>  data <= "10101010";  -- 4F6E = AA
      when "100111101101111" =>  data <= "10101010";  -- 4F6F = AA
      when "100111101110000" =>  data <= "10101010";  -- 4F70 = AA
      when "100111101110001" =>  data <= "10101010";  -- 4F71 = AA
      when "100111101110010" =>  data <= "10101010";  -- 4F72 = AA
      when "100111101110011" =>  data <= "10101010";  -- 4F73 = AA
      when "100111101110100" =>  data <= "10101010";  -- 4F74 = AA
      when "100111101110101" =>  data <= "10101010";  -- 4F75 = AA
      when "100111101110110" =>  data <= "10101010";  -- 4F76 = AA
      when "100111101110111" =>  data <= "10101010";  -- 4F77 = AA
      when "100111101111000" =>  data <= "10101001";  -- 4F78 = A9
      when "100111101111001" =>  data <= "00001101";  -- 4F79 = D
      when "100111101111010" =>  data <= "10100000";  -- 4F7A = A0
      when "100111101111011" =>  data <= "10110011";  -- 4F7B = B3
      when "100111101111100" =>  data <= "00100000";  -- 4F7C = 20
      when "100111101111101" =>  data <= "10010000";  -- 4F7D = 90
      when "100111101111110" =>  data <= "11001111";  -- 4F7E = CF
      when "100111101111111" =>  data <= "10100101";  -- 4F7F = A5
      when "100111110000000" =>  data <= "00110111";  -- 4F80 = 37
      when "100111110000001" =>  data <= "10100110";  -- 4F81 = A6
      when "100111110000010" =>  data <= "00110110";  -- 4F82 = 36
      when "100111110000011" =>  data <= "10000101";  -- 4F83 = 85
      when "100111110000100" =>  data <= "01011111";  -- 4F84 = 5F
      when "100111110000101" =>  data <= "10000110";  -- 4F85 = 86
      when "100111110000110" =>  data <= "01100000";  -- 4F86 = 60
      when "100111110000111" =>  data <= "10100010";  -- 4F87 = A2
      when "100111110001000" =>  data <= "10010000";  -- 4F88 = 90
      when "100111110001001" =>  data <= "00111000";  -- 4F89 = 38
      when "100111110001010" =>  data <= "00100000";  -- 4F8A = 20
      when "100111110001011" =>  data <= "01111111";  -- 4F8B = 7F
      when "100111110001100" =>  data <= "11001101";  -- 4F8C = CD
      when "100111110001101" =>  data <= "00100000";  -- 4F8D = 20
      when "100111110001110" =>  data <= "10010011";  -- 4F8E = 93
      when "100111110001111" =>  data <= "11001111";  -- 4F8F = CF
      when "100111110010000" =>  data <= "01001100";  -- 4F90 = 4C
      when "100111110010001" =>  data <= "00011101";  -- 4F91 = 1D
      when "100111110010010" =>  data <= "10111011";  -- 4F92 = BB
      when "100111110010011" =>  data <= "10100000";  -- 4F93 = A0
      when "100111110010100" =>  data <= "00000001";  -- 4F94 = 1
      when "100111110010101" =>  data <= "10101001";  -- 4F95 = A9
      when "100111110010110" =>  data <= "00100000";  -- 4F96 = 20
      when "100111110010111" =>  data <= "00100100";  -- 4F97 = 24
      when "100111110011000" =>  data <= "01100011";  -- 4F98 = 63
      when "100111110011001" =>  data <= "00010000";  -- 4F99 = 10
      when "100111110011010" =>  data <= "00000010";  -- 4F9A = 2
      when "100111110011011" =>  data <= "10101001";  -- 4F9B = A9
      when "100111110011100" =>  data <= "00101101";  -- 4F9C = 2D
      when "100111110011101" =>  data <= "10011001";  -- 4F9D = 99
      when "100111110011110" =>  data <= "11111111";  -- 4F9E = FF
      when "100111110011111" =>  data <= "00000000";  -- 4F9F = 0
      when "100111110100000" =>  data <= "10000101";  -- 4FA0 = 85
      when "100111110100001" =>  data <= "01100011";  -- 4FA1 = 63
      when "100111110100010" =>  data <= "10000100";  -- 4FA2 = 84
      when "100111110100011" =>  data <= "01101110";  -- 4FA3 = 6E
      when "100111110100100" =>  data <= "11001000";  -- 4FA4 = C8
      when "100111110100101" =>  data <= "10101001";  -- 4FA5 = A9
      when "100111110100110" =>  data <= "00110000";  -- 4FA6 = 30
      when "100111110100111" =>  data <= "10100110";  -- 4FA7 = A6
      when "100111110101000" =>  data <= "01011110";  -- 4FA8 = 5E
      when "100111110101001" =>  data <= "11010000";  -- 4FA9 = D0
      when "100111110101010" =>  data <= "00000011";  -- 4FAA = 3
      when "100111110101011" =>  data <= "01001100";  -- 4FAB = 4C
      when "100111110101100" =>  data <= "10111010";  -- 4FAC = BA
      when "100111110101101" =>  data <= "11010000";  -- 4FAD = D0
      when "100111110101110" =>  data <= "10101001";  -- 4FAE = A9
      when "100111110101111" =>  data <= "00000000";  -- 4FAF = 0
      when "100111110110000" =>  data <= "11100000";  -- 4FB0 = E0
      when "100111110110001" =>  data <= "10000000";  -- 4FB1 = 80
      when "100111110110010" =>  data <= "11110000";  -- 4FB2 = F0
      when "100111110110011" =>  data <= "00000010";  -- 4FB3 = 2
      when "100111110110100" =>  data <= "10110000";  -- 4FB4 = B0
      when "100111110110101" =>  data <= "00001001";  -- 4FB5 = 9
      when "100111110110110" =>  data <= "10101001";  -- 4FB6 = A9
      when "100111110110111" =>  data <= "11110011";  -- 4FB7 = F3
      when "100111110111000" =>  data <= "10100000";  -- 4FB8 = A0
      when "100111110111001" =>  data <= "11001110";  -- 4FB9 = CE
      when "100111110111010" =>  data <= "00100000";  -- 4FBA = 20
      when "100111110111011" =>  data <= "01011110";  -- 4FBB = 5E
      when "100111110111100" =>  data <= "11001011";  -- 4FBC = CB
      when "100111110111101" =>  data <= "10101001";  -- 4FBD = A9
      when "100111110111110" =>  data <= "11110111";  -- 4FBE = F7
      when "100111110111111" =>  data <= "10000101";  -- 4FBF = 85
      when "100111111000000" =>  data <= "01011010";  -- 4FC0 = 5A
      when "100111111000001" =>  data <= "10101001";  -- 4FC1 = A9
      when "100111111000010" =>  data <= "11101110";  -- 4FC2 = EE
      when "100111111000011" =>  data <= "10100000";  -- 4FC3 = A0
      when "100111111000100" =>  data <= "11001110";  -- 4FC4 = CE
      when "100111111000101" =>  data <= "00100000";  -- 4FC5 = 20
      when "100111111000110" =>  data <= "10010001";  -- 4FC6 = 91
      when "100111111000111" =>  data <= "11001101";  -- 4FC7 = CD
      when "100111111001000" =>  data <= "11110000";  -- 4FC8 = F0
      when "100111111001001" =>  data <= "00011110";  -- 4FC9 = 1E
      when "100111111001010" =>  data <= "00010000";  -- 4FCA = 10
      when "100111111001011" =>  data <= "00010010";  -- 4FCB = 12
      when "100111111001100" =>  data <= "10101001";  -- 4FCC = A9
      when "100111111001101" =>  data <= "11101001";  -- 4FCD = E9
      when "100111111001110" =>  data <= "10100000";  -- 4FCE = A0
      when "100111111001111" =>  data <= "11001110";  -- 4FCF = CE
      when "100111111010000" =>  data <= "00100000";  -- 4FD0 = 20
      when "100111111010001" =>  data <= "10010001";  -- 4FD1 = 91
      when "100111111010010" =>  data <= "11001101";  -- 4FD2 = CD
      when "100111111010011" =>  data <= "11110000";  -- 4FD3 = F0
      when "100111111010100" =>  data <= "00000010";  -- 4FD4 = 2
      when "100111111010101" =>  data <= "00010000";  -- 4FD5 = 10
      when "100111111010110" =>  data <= "00001110";  -- 4FD6 = E
      when "100111111010111" =>  data <= "00100000";  -- 4FD7 = 20
      when "100111111011000" =>  data <= "00011000";  -- 4FD8 = 18
      when "100111111011001" =>  data <= "11001100";  -- 4FD9 = CC
      when "100111111011010" =>  data <= "11000110";  -- 4FDA = C6
      when "100111111011011" =>  data <= "01011010";  -- 4FDB = 5A
      when "100111111011100" =>  data <= "11010000";  -- 4FDC = D0
      when "100111111011101" =>  data <= "11101110";  -- 4FDD = EE
      when "100111111011110" =>  data <= "00100000";  -- 4FDE = 20
      when "100111111011111" =>  data <= "00110100";  -- 4FDF = 34
      when "100111111100000" =>  data <= "11001100";  -- 4FE0 = CC
      when "100111111100001" =>  data <= "11100110";  -- 4FE1 = E6
      when "100111111100010" =>  data <= "01011010";  -- 4FE2 = 5A
      when "100111111100011" =>  data <= "11010000";  -- 4FE3 = D0
      when "100111111100100" =>  data <= "11011100";  -- 4FE4 = DC
      when "100111111100101" =>  data <= "00100000";  -- 4FE5 = 20
      when "100111111100110" =>  data <= "01111111";  -- 4FE6 = 7F
      when "100111111100111" =>  data <= "11001001";  -- 4FE7 = C9
      when "100111111101000" =>  data <= "00100000";  -- 4FE8 = 20
      when "100111111101001" =>  data <= "11010001";  -- 4FE9 = D1
      when "100111111101010" =>  data <= "11001101";  -- 4FEA = CD
      when "100111111101011" =>  data <= "10100010";  -- 4FEB = A2
      when "100111111101100" =>  data <= "00000001";  -- 4FEC = 1
      when "100111111101101" =>  data <= "10100101";  -- 4FED = A5
      when "100111111101110" =>  data <= "01011010";  -- 4FEE = 5A
      when "100111111101111" =>  data <= "00011000";  -- 4FEF = 18
      when "100111111110000" =>  data <= "01101001";  -- 4FF0 = 69
      when "100111111110001" =>  data <= "00001010";  -- 4FF1 = A
      when "100111111110010" =>  data <= "00110000";  -- 4FF2 = 30
      when "100111111110011" =>  data <= "00001001";  -- 4FF3 = 9
      when "100111111110100" =>  data <= "11001001";  -- 4FF4 = C9
      when "100111111110101" =>  data <= "00001011";  -- 4FF5 = B
      when "100111111110110" =>  data <= "10110000";  -- 4FF6 = B0
      when "100111111110111" =>  data <= "00000110";  -- 4FF7 = 6
      when "100111111111000" =>  data <= "01101001";  -- 4FF8 = 69
      when "100111111111001" =>  data <= "11111111";  -- 4FF9 = FF
      when "100111111111010" =>  data <= "10101010";  -- 4FFA = AA
      when "100111111111011" =>  data <= "10101001";  -- 4FFB = A9
      when "100111111111100" =>  data <= "00000010";  -- 4FFC = 2
      when "100111111111101" =>  data <= "00111000";  -- 4FFD = 38
      when "100111111111110" =>  data <= "11101001";  -- 4FFE = E9
      when "100111111111111" =>  data <= "00000010";  -- 4FFF = 2
      when "101000000000000" =>  data <= "10000101";  -- 5000 = 85
      when "101000000000001" =>  data <= "01011011";  -- 5001 = 5B
      when "101000000000010" =>  data <= "10000110";  -- 5002 = 86
      when "101000000000011" =>  data <= "01011010";  -- 5003 = 5A
      when "101000000000100" =>  data <= "10001010";  -- 5004 = 8A
      when "101000000000101" =>  data <= "11110000";  -- 5005 = F0
      when "101000000000110" =>  data <= "00000010";  -- 5006 = 2
      when "101000000000111" =>  data <= "00010000";  -- 5007 = 10
      when "101000000001000" =>  data <= "00010011";  -- 5008 = 13
      when "101000000001001" =>  data <= "10100100";  -- 5009 = A4
      when "101000000001010" =>  data <= "01101110";  -- 500A = 6E
      when "101000000001011" =>  data <= "10101001";  -- 500B = A9
      when "101000000001100" =>  data <= "00101110";  -- 500C = 2E
      when "101000000001101" =>  data <= "11001000";  -- 500D = C8
      when "101000000001110" =>  data <= "10011001";  -- 500E = 99
      when "101000000001111" =>  data <= "11111111";  -- 500F = FF
      when "101000000010000" =>  data <= "00000000";  -- 5010 = 0
      when "101000000010001" =>  data <= "10001010";  -- 5011 = 8A
      when "101000000010010" =>  data <= "11110000";  -- 5012 = F0
      when "101000000010011" =>  data <= "00000110";  -- 5013 = 6
      when "101000000010100" =>  data <= "10101001";  -- 5014 = A9
      when "101000000010101" =>  data <= "00110000";  -- 5015 = 30
      when "101000000010110" =>  data <= "11001000";  -- 5016 = C8
      when "101000000010111" =>  data <= "10011001";  -- 5017 = 99
      when "101000000011000" =>  data <= "11111111";  -- 5018 = FF
      when "101000000011001" =>  data <= "00000000";  -- 5019 = 0
      when "101000000011010" =>  data <= "10000100";  -- 501A = 84
      when "101000000011011" =>  data <= "01101110";  -- 501B = 6E
      when "101000000011100" =>  data <= "10100000";  -- 501C = A0
      when "101000000011101" =>  data <= "00000000";  -- 501D = 0
      when "101000000011110" =>  data <= "10100010";  -- 501E = A2
      when "101000000011111" =>  data <= "10000000";  -- 501F = 80
      when "101000000100000" =>  data <= "10100101";  -- 5020 = A5
      when "101000000100001" =>  data <= "01100010";  -- 5021 = 62
      when "101000000100010" =>  data <= "00011000";  -- 5022 = 18
      when "101000000100011" =>  data <= "01111001";  -- 5023 = 79
      when "101000000100100" =>  data <= "11001111";  -- 5024 = CF
      when "101000000100101" =>  data <= "11010000";  -- 5025 = D0
      when "101000000100110" =>  data <= "10000101";  -- 5026 = 85
      when "101000000100111" =>  data <= "01100010";  -- 5027 = 62
      when "101000000101000" =>  data <= "10100101";  -- 5028 = A5
      when "101000000101001" =>  data <= "01100001";  -- 5029 = 61
      when "101000000101010" =>  data <= "01111001";  -- 502A = 79
      when "101000000101011" =>  data <= "11001110";  -- 502B = CE
      when "101000000101100" =>  data <= "11010000";  -- 502C = D0
      when "101000000101101" =>  data <= "10000101";  -- 502D = 85
      when "101000000101110" =>  data <= "01100001";  -- 502E = 61
      when "101000000101111" =>  data <= "10100101";  -- 502F = A5
      when "101000000110000" =>  data <= "01100000";  -- 5030 = 60
      when "101000000110001" =>  data <= "01111001";  -- 5031 = 79
      when "101000000110010" =>  data <= "11001101";  -- 5032 = CD
      when "101000000110011" =>  data <= "11010000";  -- 5033 = D0
      when "101000000110100" =>  data <= "10000101";  -- 5034 = 85
      when "101000000110101" =>  data <= "01100000";  -- 5035 = 60
      when "101000000110110" =>  data <= "10100101";  -- 5036 = A5
      when "101000000110111" =>  data <= "01011111";  -- 5037 = 5F
      when "101000000111000" =>  data <= "01111001";  -- 5038 = 79
      when "101000000111001" =>  data <= "11001100";  -- 5039 = CC
      when "101000000111010" =>  data <= "11010000";  -- 503A = D0
      when "101000000111011" =>  data <= "10000101";  -- 503B = 85
      when "101000000111100" =>  data <= "01011111";  -- 503C = 5F
      when "101000000111101" =>  data <= "11101000";  -- 503D = E8
      when "101000000111110" =>  data <= "10110000";  -- 503E = B0
      when "101000000111111" =>  data <= "00000100";  -- 503F = 4
      when "101000001000000" =>  data <= "00010000";  -- 5040 = 10
      when "101000001000001" =>  data <= "11011110";  -- 5041 = DE
      when "101000001000010" =>  data <= "00110000";  -- 5042 = 30
      when "101000001000011" =>  data <= "00000010";  -- 5043 = 2
      when "101000001000100" =>  data <= "00110000";  -- 5044 = 30
      when "101000001000101" =>  data <= "11011010";  -- 5045 = DA
      when "101000001000110" =>  data <= "10001010";  -- 5046 = 8A
      when "101000001000111" =>  data <= "10010000";  -- 5047 = 90
      when "101000001001000" =>  data <= "00000100";  -- 5048 = 4
      when "101000001001001" =>  data <= "01001001";  -- 5049 = 49
      when "101000001001010" =>  data <= "11111111";  -- 504A = FF
      when "101000001001011" =>  data <= "01101001";  -- 504B = 69
      when "101000001001100" =>  data <= "00001010";  -- 504C = A
      when "101000001001101" =>  data <= "01101001";  -- 504D = 69
      when "101000001001110" =>  data <= "00101111";  -- 504E = 2F
      when "101000001001111" =>  data <= "11001000";  -- 504F = C8
      when "101000001010000" =>  data <= "11001000";  -- 5050 = C8
      when "101000001010001" =>  data <= "11001000";  -- 5051 = C8
      when "101000001010010" =>  data <= "11001000";  -- 5052 = C8
      when "101000001010011" =>  data <= "10000100";  -- 5053 = 84
      when "101000001010100" =>  data <= "01000100";  -- 5054 = 44
      when "101000001010101" =>  data <= "10100100";  -- 5055 = A4
      when "101000001010110" =>  data <= "01101110";  -- 5056 = 6E
      when "101000001010111" =>  data <= "11001000";  -- 5057 = C8
      when "101000001011000" =>  data <= "10101010";  -- 5058 = AA
      when "101000001011001" =>  data <= "00101001";  -- 5059 = 29
      when "101000001011010" =>  data <= "01111111";  -- 505A = 7F
      when "101000001011011" =>  data <= "10011001";  -- 505B = 99
      when "101000001011100" =>  data <= "11111111";  -- 505C = FF
      when "101000001011101" =>  data <= "00000000";  -- 505D = 0
      when "101000001011110" =>  data <= "11000110";  -- 505E = C6
      when "101000001011111" =>  data <= "01011010";  -- 505F = 5A
      when "101000001100000" =>  data <= "11010000";  -- 5060 = D0
      when "101000001100001" =>  data <= "00000110";  -- 5061 = 6
      when "101000001100010" =>  data <= "10101001";  -- 5062 = A9
      when "101000001100011" =>  data <= "00101110";  -- 5063 = 2E
      when "101000001100100" =>  data <= "11001000";  -- 5064 = C8
      when "101000001100101" =>  data <= "10011001";  -- 5065 = 99
      when "101000001100110" =>  data <= "11111111";  -- 5066 = FF
      when "101000001100111" =>  data <= "00000000";  -- 5067 = 0
      when "101000001101000" =>  data <= "10000100";  -- 5068 = 84
      when "101000001101001" =>  data <= "01101110";  -- 5069 = 6E
      when "101000001101010" =>  data <= "10100100";  -- 506A = A4
      when "101000001101011" =>  data <= "01000100";  -- 506B = 44
      when "101000001101100" =>  data <= "10001010";  -- 506C = 8A
      when "101000001101101" =>  data <= "01001001";  -- 506D = 49
      when "101000001101110" =>  data <= "11111111";  -- 506E = FF
      when "101000001101111" =>  data <= "00101001";  -- 506F = 29
      when "101000001110000" =>  data <= "10000000";  -- 5070 = 80
      when "101000001110001" =>  data <= "10101010";  -- 5071 = AA
      when "101000001110010" =>  data <= "11000000";  -- 5072 = C0
      when "101000001110011" =>  data <= "00100100";  -- 5073 = 24
      when "101000001110100" =>  data <= "11110000";  -- 5074 = F0
      when "101000001110101" =>  data <= "00000100";  -- 5075 = 4
      when "101000001110110" =>  data <= "11000000";  -- 5076 = C0
      when "101000001110111" =>  data <= "00111100";  -- 5077 = 3C
      when "101000001111000" =>  data <= "11010000";  -- 5078 = D0
      when "101000001111001" =>  data <= "10100110";  -- 5079 = A6
      when "101000001111010" =>  data <= "10100100";  -- 507A = A4
      when "101000001111011" =>  data <= "01101110";  -- 507B = 6E
      when "101000001111100" =>  data <= "10111001";  -- 507C = B9
      when "101000001111101" =>  data <= "11111111";  -- 507D = FF
      when "101000001111110" =>  data <= "00000000";  -- 507E = 0
      when "101000001111111" =>  data <= "10001000";  -- 507F = 88
      when "101000010000000" =>  data <= "11001001";  -- 5080 = C9
      when "101000010000001" =>  data <= "00110000";  -- 5081 = 30
      when "101000010000010" =>  data <= "11110000";  -- 5082 = F0
      when "101000010000011" =>  data <= "11111000";  -- 5083 = F8
      when "101000010000100" =>  data <= "11001001";  -- 5084 = C9
      when "101000010000101" =>  data <= "00101110";  -- 5085 = 2E
      when "101000010000110" =>  data <= "11110000";  -- 5086 = F0
      when "101000010000111" =>  data <= "00000001";  -- 5087 = 1
      when "101000010001000" =>  data <= "11001000";  -- 5088 = C8
      when "101000010001001" =>  data <= "10101001";  -- 5089 = A9
      when "101000010001010" =>  data <= "00101011";  -- 508A = 2B
      when "101000010001011" =>  data <= "10100110";  -- 508B = A6
      when "101000010001100" =>  data <= "01011011";  -- 508C = 5B
      when "101000010001101" =>  data <= "11110000";  -- 508D = F0
      when "101000010001110" =>  data <= "00101110";  -- 508E = 2E
      when "101000010001111" =>  data <= "00010000";  -- 508F = 10
      when "101000010010000" =>  data <= "00001000";  -- 5090 = 8
      when "101000010010001" =>  data <= "10101001";  -- 5091 = A9
      when "101000010010010" =>  data <= "00000000";  -- 5092 = 0
      when "101000010010011" =>  data <= "00111000";  -- 5093 = 38
      when "101000010010100" =>  data <= "11100101";  -- 5094 = E5
      when "101000010010101" =>  data <= "01011011";  -- 5095 = 5B
      when "101000010010110" =>  data <= "10101010";  -- 5096 = AA
      when "101000010010111" =>  data <= "10101001";  -- 5097 = A9
      when "101000010011000" =>  data <= "00101101";  -- 5098 = 2D
      when "101000010011001" =>  data <= "10011001";  -- 5099 = 99
      when "101000010011010" =>  data <= "00000001";  -- 509A = 1
      when "101000010011011" =>  data <= "00000001";  -- 509B = 1
      when "101000010011100" =>  data <= "10101001";  -- 509C = A9
      when "101000010011101" =>  data <= "01000101";  -- 509D = 45
      when "101000010011110" =>  data <= "10011001";  -- 509E = 99
      when "101000010011111" =>  data <= "00000000";  -- 509F = 0
      when "101000010100000" =>  data <= "00000001";  -- 50A0 = 1
      when "101000010100001" =>  data <= "10001010";  -- 50A1 = 8A
      when "101000010100010" =>  data <= "10100010";  -- 50A2 = A2
      when "101000010100011" =>  data <= "00101111";  -- 50A3 = 2F
      when "101000010100100" =>  data <= "00111000";  -- 50A4 = 38
      when "101000010100101" =>  data <= "11101000";  -- 50A5 = E8
      when "101000010100110" =>  data <= "11101001";  -- 50A6 = E9
      when "101000010100111" =>  data <= "00001010";  -- 50A7 = A
      when "101000010101000" =>  data <= "10110000";  -- 50A8 = B0
      when "101000010101001" =>  data <= "11111011";  -- 50A9 = FB
      when "101000010101010" =>  data <= "01101001";  -- 50AA = 69
      when "101000010101011" =>  data <= "00111010";  -- 50AB = 3A
      when "101000010101100" =>  data <= "10011001";  -- 50AC = 99
      when "101000010101101" =>  data <= "00000011";  -- 50AD = 3
      when "101000010101110" =>  data <= "00000001";  -- 50AE = 1
      when "101000010101111" =>  data <= "10001010";  -- 50AF = 8A
      when "101000010110000" =>  data <= "10011001";  -- 50B0 = 99
      when "101000010110001" =>  data <= "00000010";  -- 50B1 = 2
      when "101000010110010" =>  data <= "00000001";  -- 50B2 = 1
      when "101000010110011" =>  data <= "10101001";  -- 50B3 = A9
      when "101000010110100" =>  data <= "00000000";  -- 50B4 = 0
      when "101000010110101" =>  data <= "10011001";  -- 50B5 = 99
      when "101000010110110" =>  data <= "00000100";  -- 50B6 = 4
      when "101000010110111" =>  data <= "00000001";  -- 50B7 = 1
      when "101000010111000" =>  data <= "11110000";  -- 50B8 = F0
      when "101000010111001" =>  data <= "00001000";  -- 50B9 = 8
      when "101000010111010" =>  data <= "10011001";  -- 50BA = 99
      when "101000010111011" =>  data <= "11111111";  -- 50BB = FF
      when "101000010111100" =>  data <= "00000000";  -- 50BC = 0
      when "101000010111101" =>  data <= "10101001";  -- 50BD = A9
      when "101000010111110" =>  data <= "00000000";  -- 50BE = 0
      when "101000010111111" =>  data <= "10011001";  -- 50BF = 99
      when "101000011000000" =>  data <= "00000000";  -- 50C0 = 0
      when "101000011000001" =>  data <= "00000001";  -- 50C1 = 1
      when "101000011000010" =>  data <= "10101001";  -- 50C2 = A9
      when "101000011000011" =>  data <= "00000000";  -- 50C3 = 0
      when "101000011000100" =>  data <= "10100000";  -- 50C4 = A0
      when "101000011000101" =>  data <= "00000001";  -- 50C5 = 1
      when "101000011000110" =>  data <= "01100000";  -- 50C6 = 60
      when "101000011000111" =>  data <= "10000000";  -- 50C7 = 80
      when "101000011001000" =>  data <= "00000000";  -- 50C8 = 0
      when "101000011001001" =>  data <= "00000000";  -- 50C9 = 0
      when "101000011001010" =>  data <= "00000000";  -- 50CA = 0
      when "101000011001011" =>  data <= "00000000";  -- 50CB = 0
      when "101000011001100" =>  data <= "11111010";  -- 50CC = FA
      when "101000011001101" =>  data <= "00001010";  -- 50CD = A
      when "101000011001110" =>  data <= "00011111";  -- 50CE = 1F
      when "101000011001111" =>  data <= "00000000";  -- 50CF = 0
      when "101000011010000" =>  data <= "00000000";  -- 50D0 = 0
      when "101000011010001" =>  data <= "10011000";  -- 50D1 = 98
      when "101000011010010" =>  data <= "10010110";  -- 50D2 = 96
      when "101000011010011" =>  data <= "10000000";  -- 50D3 = 80
      when "101000011010100" =>  data <= "11111111";  -- 50D4 = FF
      when "101000011010101" =>  data <= "11110000";  -- 50D5 = F0
      when "101000011010110" =>  data <= "10111101";  -- 50D6 = BD
      when "101000011010111" =>  data <= "11000000";  -- 50D7 = C0
      when "101000011011000" =>  data <= "00000000";  -- 50D8 = 0
      when "101000011011001" =>  data <= "00000001";  -- 50D9 = 1
      when "101000011011010" =>  data <= "10000110";  -- 50DA = 86
      when "101000011011011" =>  data <= "10100000";  -- 50DB = A0
      when "101000011011100" =>  data <= "11111111";  -- 50DC = FF
      when "101000011011101" =>  data <= "11111111";  -- 50DD = FF
      when "101000011011110" =>  data <= "11011000";  -- 50DE = D8
      when "101000011011111" =>  data <= "11110000";  -- 50DF = F0
      when "101000011100000" =>  data <= "00000000";  -- 50E0 = 0
      when "101000011100001" =>  data <= "00000000";  -- 50E1 = 0
      when "101000011100010" =>  data <= "00000011";  -- 50E2 = 3
      when "101000011100011" =>  data <= "11101000";  -- 50E3 = E8
      when "101000011100100" =>  data <= "11111111";  -- 50E4 = FF
      when "101000011100101" =>  data <= "11111111";  -- 50E5 = FF
      when "101000011100110" =>  data <= "11111111";  -- 50E6 = FF
      when "101000011100111" =>  data <= "10011100";  -- 50E7 = 9C
      when "101000011101000" =>  data <= "00000000";  -- 50E8 = 0
      when "101000011101001" =>  data <= "00000000";  -- 50E9 = 0
      when "101000011101010" =>  data <= "00000000";  -- 50EA = 0
      when "101000011101011" =>  data <= "00001010";  -- 50EB = A
      when "101000011101100" =>  data <= "11111111";  -- 50EC = FF
      when "101000011101101" =>  data <= "11111111";  -- 50ED = FF
      when "101000011101110" =>  data <= "11111111";  -- 50EE = FF
      when "101000011101111" =>  data <= "11111111";  -- 50EF = FF
      when "101000011110000" =>  data <= "11111111";  -- 50F0 = FF
      when "101000011110001" =>  data <= "11011111";  -- 50F1 = DF
      when "101000011110010" =>  data <= "00001010";  -- 50F2 = A
      when "101000011110011" =>  data <= "10000000";  -- 50F3 = 80
      when "101000011110100" =>  data <= "00000000";  -- 50F4 = 0
      when "101000011110101" =>  data <= "00000011";  -- 50F5 = 3
      when "101000011110110" =>  data <= "01001011";  -- 50F6 = 4B
      when "101000011110111" =>  data <= "11000000";  -- 50F7 = C0
      when "101000011111000" =>  data <= "11111111";  -- 50F8 = FF
      when "101000011111001" =>  data <= "11111111";  -- 50F9 = FF
      when "101000011111010" =>  data <= "01110011";  -- 50FA = 73
      when "101000011111011" =>  data <= "01100000";  -- 50FB = 60
      when "101000011111100" =>  data <= "00000000";  -- 50FC = 0
      when "101000011111101" =>  data <= "00000000";  -- 50FD = 0
      when "101000011111110" =>  data <= "00001110";  -- 50FE = E
      when "101000011111111" =>  data <= "00010000";  -- 50FF = 10
      when "101000100000000" =>  data <= "11111111";  -- 5100 = FF
      when "101000100000001" =>  data <= "11111111";  -- 5101 = FF
      when "101000100000010" =>  data <= "11111101";  -- 5102 = FD
      when "101000100000011" =>  data <= "10101000";  -- 5103 = A8
      when "101000100000100" =>  data <= "00000000";  -- 5104 = 0
      when "101000100000101" =>  data <= "00000000";  -- 5105 = 0
      when "101000100000110" =>  data <= "00000000";  -- 5106 = 0
      when "101000100000111" =>  data <= "00111100";  -- 5107 = 3C
      when "101000100001000" =>  data <= "00100000";  -- 5108 = 20
      when "101000100001001" =>  data <= "01000010";  -- 5109 = 42
      when "101000100001010" =>  data <= "11001101";  -- 510A = CD
      when "101000100001011" =>  data <= "10101001";  -- 510B = A9
      when "101000100001100" =>  data <= "11000111";  -- 510C = C7
      when "101000100001101" =>  data <= "10100000";  -- 510D = A0
      when "101000100001110" =>  data <= "11010000";  -- 510E = D0
      when "101000100001111" =>  data <= "00100000";  -- 510F = 20
      when "101000100010000" =>  data <= "11011000";  -- 5110 = D8
      when "101000100010001" =>  data <= "11001100";  -- 5111 = CC
      when "101000100010010" =>  data <= "11110000";  -- 5112 = F0
      when "101000100010011" =>  data <= "01110000";  -- 5113 = 70
      when "101000100010100" =>  data <= "10100101";  -- 5114 = A5
      when "101000100010101" =>  data <= "01100110";  -- 5115 = 66
      when "101000100010110" =>  data <= "11010000";  -- 5116 = D0
      when "101000100010111" =>  data <= "00000011";  -- 5117 = 3
      when "101000100011000" =>  data <= "01001100";  -- 5118 = 4C
      when "101000100011001" =>  data <= "00101111";  -- 5119 = 2F
      when "101000100011010" =>  data <= "11001010";  -- 511A = CA
      when "101000100011011" =>  data <= "10100010";  -- 511B = A2
      when "101000100011100" =>  data <= "01001011";  -- 511C = 4B
      when "101000100011101" =>  data <= "10100000";  -- 511D = A0
      when "101000100011110" =>  data <= "00000000";  -- 511E = 0
      when "101000100011111" =>  data <= "00100000";  -- 511F = 20
      when "101000100100000" =>  data <= "00001010";  -- 5120 = A
      when "101000100100001" =>  data <= "11001101";  -- 5121 = CD
      when "101000100100010" =>  data <= "10100101";  -- 5122 = A5
      when "101000100100011" =>  data <= "01101011";  -- 5123 = 6B
      when "101000100100100" =>  data <= "00010000";  -- 5124 = 10
      when "101000100100101" =>  data <= "00001111";  -- 5125 = F
      when "101000100100110" =>  data <= "00100000";  -- 5126 = 20
      when "101000100100111" =>  data <= "00000010";  -- 5127 = 2
      when "101000100101000" =>  data <= "11001110";  -- 5128 = CE
      when "101000100101001" =>  data <= "10101001";  -- 5129 = A9
      when "101000100101010" =>  data <= "01001011";  -- 512A = 4B
      when "101000100101011" =>  data <= "10100000";  -- 512B = A0
      when "101000100101100" =>  data <= "00000000";  -- 512C = 0
      when "101000100101101" =>  data <= "00100000";  -- 512D = 20
      when "101000100101110" =>  data <= "10010001";  -- 512E = 91
      when "101000100101111" =>  data <= "11001101";  -- 512F = CD
      when "101000100110000" =>  data <= "11010000";  -- 5130 = D0
      when "101000100110001" =>  data <= "00000011";  -- 5131 = 3
      when "101000100110010" =>  data <= "10011000";  -- 5132 = 98
      when "101000100110011" =>  data <= "10100100";  -- 5133 = A4
      when "101000100110100" =>  data <= "00000011";  -- 5134 = 3
      when "101000100110101" =>  data <= "00100000";  -- 5135 = 20
      when "101000100110110" =>  data <= "00110100";  -- 5136 = 34
      when "101000100110111" =>  data <= "11001101";  -- 5137 = CD
      when "101000100111000" =>  data <= "10011000";  -- 5138 = 98
      when "101000100111001" =>  data <= "01001000";  -- 5139 = 48
      when "101000100111010" =>  data <= "00100000";  -- 513A = 20
      when "101000100111011" =>  data <= "00100000";  -- 513B = 20
      when "101000100111100" =>  data <= "11001011";  -- 513C = CB
      when "101000100111101" =>  data <= "10101001";  -- 513D = A9
      when "101000100111110" =>  data <= "01001011";  -- 513E = 4B
      when "101000100111111" =>  data <= "10100000";  -- 513F = A0
      when "101000101000000" =>  data <= "00000000";  -- 5140 = 0
      when "101000101000001" =>  data <= "00100000";  -- 5141 = 20
      when "101000101000010" =>  data <= "01011110";  -- 5142 = 5E
      when "101000101000011" =>  data <= "11001011";  -- 5143 = CB
      when "101000101000100" =>  data <= "00100000";  -- 5144 = 20
      when "101000101000101" =>  data <= "10000100";  -- 5145 = 84
      when "101000101000110" =>  data <= "11010001";  -- 5146 = D1
      when "101000101000111" =>  data <= "01101000";  -- 5147 = 68
      when "101000101001000" =>  data <= "01001010";  -- 5148 = 4A
      when "101000101001001" =>  data <= "10010000";  -- 5149 = 90
      when "101000101001010" =>  data <= "00001010";  -- 514A = A
      when "101000101001011" =>  data <= "10100101";  -- 514B = A5
      when "101000101001100" =>  data <= "01011110";  -- 514C = 5E
      when "101000101001101" =>  data <= "11110000";  -- 514D = F0
      when "101000101001110" =>  data <= "00000110";  -- 514E = 6
      when "101000101001111" =>  data <= "10100101";  -- 514F = A5
      when "101000101010000" =>  data <= "01100011";  -- 5150 = 63
      when "101000101010001" =>  data <= "01001001";  -- 5151 = 49
      when "101000101010010" =>  data <= "11111111";  -- 5152 = FF
      when "101000101010011" =>  data <= "10000101";  -- 5153 = 85
      when "101000101010100" =>  data <= "01100011";  -- 5154 = 63
      when "101000101010101" =>  data <= "01100000";  -- 5155 = 60
      when "101000101010110" =>  data <= "10000001";  -- 5156 = 81
      when "101000101010111" =>  data <= "00111000";  -- 5157 = 38
      when "101000101011000" =>  data <= "10101010";  -- 5158 = AA
      when "101000101011001" =>  data <= "00111011";  -- 5159 = 3B
      when "101000101011010" =>  data <= "00101001";  -- 515A = 29
      when "101000101011011" =>  data <= "00000111";  -- 515B = 7
      when "101000101011100" =>  data <= "01110001";  -- 515C = 71
      when "101000101011101" =>  data <= "00110100";  -- 515D = 34
      when "101000101011110" =>  data <= "01011000";  -- 515E = 58
      when "101000101011111" =>  data <= "00111110";  -- 515F = 3E
      when "101000101100000" =>  data <= "01010110";  -- 5160 = 56
      when "101000101100001" =>  data <= "01110100";  -- 5161 = 74
      when "101000101100010" =>  data <= "00010110";  -- 5162 = 16
      when "101000101100011" =>  data <= "01111110";  -- 5163 = 7E
      when "101000101100100" =>  data <= "10110011";  -- 5164 = B3
      when "101000101100101" =>  data <= "00011011";  -- 5165 = 1B
      when "101000101100110" =>  data <= "01110111";  -- 5166 = 77
      when "101000101100111" =>  data <= "00101111";  -- 5167 = 2F
      when "101000101101000" =>  data <= "11101110";  -- 5168 = EE
      when "101000101101001" =>  data <= "11100011";  -- 5169 = E3
      when "101000101101010" =>  data <= "10000101";  -- 516A = 85
      when "101000101101011" =>  data <= "01111010";  -- 516B = 7A
      when "101000101101100" =>  data <= "00011101";  -- 516C = 1D
      when "101000101101101" =>  data <= "10000100";  -- 516D = 84
      when "101000101101110" =>  data <= "00011100";  -- 516E = 1C
      when "101000101101111" =>  data <= "00101010";  -- 516F = 2A
      when "101000101110000" =>  data <= "01111100";  -- 5170 = 7C
      when "101000101110001" =>  data <= "01100011";  -- 5171 = 63
      when "101000101110010" =>  data <= "01011001";  -- 5172 = 59
      when "101000101110011" =>  data <= "01011000";  -- 5173 = 58
      when "101000101110100" =>  data <= "00001010";  -- 5174 = A
      when "101000101110101" =>  data <= "01111110";  -- 5175 = 7E
      when "101000101110110" =>  data <= "01110101";  -- 5176 = 75
      when "101000101110111" =>  data <= "11111101";  -- 5177 = FD
      when "101000101111000" =>  data <= "11100111";  -- 5178 = E7
      when "101000101111001" =>  data <= "11000110";  -- 5179 = C6
      when "101000101111010" =>  data <= "10000000";  -- 517A = 80
      when "101000101111011" =>  data <= "00110001";  -- 517B = 31
      when "101000101111100" =>  data <= "01110010";  -- 517C = 72
      when "101000101111101" =>  data <= "00011000";  -- 517D = 18
      when "101000101111110" =>  data <= "00010000";  -- 517E = 10
      when "101000101111111" =>  data <= "10000001";  -- 517F = 81
      when "101000110000000" =>  data <= "00000000";  -- 5180 = 0
      when "101000110000001" =>  data <= "00000000";  -- 5181 = 0
      when "101000110000010" =>  data <= "00000000";  -- 5182 = 0
      when "101000110000011" =>  data <= "00000000";  -- 5183 = 0
      when "101000110000100" =>  data <= "10101001";  -- 5184 = A9
      when "101000110000101" =>  data <= "01010110";  -- 5185 = 56
      when "101000110000110" =>  data <= "10100000";  -- 5186 = A0
      when "101000110000111" =>  data <= "11010001";  -- 5187 = D1
      when "101000110001000" =>  data <= "00100000";  -- 5188 = 20
      when "101000110001001" =>  data <= "01011110";  -- 5189 = 5E
      when "101000110001010" =>  data <= "11001011";  -- 518A = CB
      when "101000110001011" =>  data <= "10100101";  -- 518B = A5
      when "101000110001100" =>  data <= "01101101";  -- 518C = 6D
      when "101000110001101" =>  data <= "01101001";  -- 518D = 69
      when "101000110001110" =>  data <= "01010000";  -- 518E = 50
      when "101000110001111" =>  data <= "10010000";  -- 518F = 90
      when "101000110010000" =>  data <= "00000011";  -- 5190 = 3
      when "101000110010001" =>  data <= "00100000";  -- 5191 = 20
      when "101000110010010" =>  data <= "01011001";  -- 5192 = 59
      when "101000110010011" =>  data <= "11001101";  -- 5193 = CD
      when "101000110010100" =>  data <= "10000101";  -- 5194 = 85
      when "101000110010101" =>  data <= "01010011";  -- 5195 = 53
      when "101000110010110" =>  data <= "00100000";  -- 5196 = 20
      when "101000110010111" =>  data <= "01000101";  -- 5197 = 45
      when "101000110011000" =>  data <= "11001101";  -- 5198 = CD
      when "101000110011001" =>  data <= "10100101";  -- 5199 = A5
      when "101000110011010" =>  data <= "01011110";  -- 519A = 5E
      when "101000110011011" =>  data <= "11001001";  -- 519B = C9
      when "101000110011100" =>  data <= "10001000";  -- 519C = 88
      when "101000110011101" =>  data <= "10010000";  -- 519D = 90
      when "101000110011110" =>  data <= "00000011";  -- 519E = 3
      when "101000110011111" =>  data <= "00100000";  -- 519F = 20
      when "101000110100000" =>  data <= "00001010";  -- 51A0 = A
      when "101000110100001" =>  data <= "11001100";  -- 51A1 = CC
      when "101000110100010" =>  data <= "00100000";  -- 51A2 = 20
      when "101000110100011" =>  data <= "00000010";  -- 51A3 = 2
      when "101000110100100" =>  data <= "11001110";  -- 51A4 = CE
      when "101000110100101" =>  data <= "10100101";  -- 51A5 = A5
      when "101000110100110" =>  data <= "00000011";  -- 51A6 = 3
      when "101000110100111" =>  data <= "00011000";  -- 51A7 = 18
      when "101000110101000" =>  data <= "01101001";  -- 51A8 = 69
      when "101000110101001" =>  data <= "10000001";  -- 51A9 = 81
      when "101000110101010" =>  data <= "11110000";  -- 51AA = F0
      when "101000110101011" =>  data <= "11110011";  -- 51AB = F3
      when "101000110101100" =>  data <= "00111000";  -- 51AC = 38
      when "101000110101101" =>  data <= "11101001";  -- 51AD = E9
      when "101000110101110" =>  data <= "00000001";  -- 51AE = 1
      when "101000110101111" =>  data <= "01001000";  -- 51AF = 48
      when "101000110110000" =>  data <= "10100010";  -- 51B0 = A2
      when "101000110110001" =>  data <= "00000101";  -- 51B1 = 5
      when "101000110110010" =>  data <= "10110101";  -- 51B2 = B5
      when "101000110110011" =>  data <= "01100110";  -- 51B3 = 66
      when "101000110110100" =>  data <= "10110100";  -- 51B4 = B4
      when "101000110110101" =>  data <= "01011110";  -- 51B5 = 5E
      when "101000110110110" =>  data <= "10010101";  -- 51B6 = 95
      when "101000110110111" =>  data <= "01011110";  -- 51B7 = 5E
      when "101000110111000" =>  data <= "10010100";  -- 51B8 = 94
      when "101000110111001" =>  data <= "01100110";  -- 51B9 = 66
      when "101000110111010" =>  data <= "11001010";  -- 51BA = CA
      when "101000110111011" =>  data <= "00010000";  -- 51BB = 10
      when "101000110111100" =>  data <= "11110101";  -- 51BC = F5
      when "101000110111101" =>  data <= "10100101";  -- 51BD = A5
      when "101000110111110" =>  data <= "01010011";  -- 51BE = 53
      when "101000110111111" =>  data <= "10000101";  -- 51BF = 85
      when "101000111000000" =>  data <= "01101101";  -- 51C0 = 6D
      when "101000111000001" =>  data <= "00100000";  -- 51C1 = 20
      when "101000111000010" =>  data <= "10001001";  -- 51C2 = 89
      when "101000111000011" =>  data <= "11001001";  -- 51C3 = C9
      when "101000111000100" =>  data <= "00100000";  -- 51C4 = 20
      when "101000111000101" =>  data <= "01001011";  -- 51C5 = 4B
      when "101000111000110" =>  data <= "11010001";  -- 51C6 = D1
      when "101000111000111" =>  data <= "10101001";  -- 51C7 = A9
      when "101000111001000" =>  data <= "01011011";  -- 51C8 = 5B
      when "101000111001001" =>  data <= "10100000";  -- 51C9 = A0
      when "101000111001010" =>  data <= "11010001";  -- 51CA = D1
      when "101000111001011" =>  data <= "00100000";  -- 51CB = 20
      when "101000111001100" =>  data <= "11101101";  -- 51CC = ED
      when "101000111001101" =>  data <= "11010001";  -- 51CD = D1
      when "101000111001110" =>  data <= "10101001";  -- 51CE = A9
      when "101000111001111" =>  data <= "00000000";  -- 51CF = 0
      when "101000111010000" =>  data <= "10000101";  -- 51D0 = 85
      when "101000111010001" =>  data <= "01101100";  -- 51D1 = 6C
      when "101000111010010" =>  data <= "01101000";  -- 51D2 = 68
      when "101000111010011" =>  data <= "00100000";  -- 51D3 = 20
      when "101000111010100" =>  data <= "11101111";  -- 51D4 = EF
      when "101000111010101" =>  data <= "11001011";  -- 51D5 = CB
      when "101000111010110" =>  data <= "01100000";  -- 51D6 = 60
      when "101000111010111" =>  data <= "10000101";  -- 51D7 = 85
      when "101000111011000" =>  data <= "01101110";  -- 51D8 = 6E
      when "101000111011001" =>  data <= "10000100";  -- 51D9 = 84
      when "101000111011010" =>  data <= "01101111";  -- 51DA = 6F
      when "101000111011011" =>  data <= "00100000";  -- 51DB = 20
      when "101000111011100" =>  data <= "00000000";  -- 51DC = 0
      when "101000111011101" =>  data <= "11001101";  -- 51DD = CD
      when "101000111011110" =>  data <= "10101001";  -- 51DE = A9
      when "101000111011111" =>  data <= "01010100";  -- 51DF = 54
      when "101000111100000" =>  data <= "00100000";  -- 51E0 = 20
      when "101000111100001" =>  data <= "01011110";  -- 51E1 = 5E
      when "101000111100010" =>  data <= "11001011";  -- 51E2 = CB
      when "101000111100011" =>  data <= "00100000";  -- 51E3 = 20
      when "101000111100100" =>  data <= "11110001";  -- 51E4 = F1
      when "101000111100101" =>  data <= "11010001";  -- 51E5 = D1
      when "101000111100110" =>  data <= "10101001";  -- 51E6 = A9
      when "101000111100111" =>  data <= "01010100";  -- 51E7 = 54
      when "101000111101000" =>  data <= "10100000";  -- 51E8 = A0
      when "101000111101001" =>  data <= "00000000";  -- 51E9 = 0
      when "101000111101010" =>  data <= "01001100";  -- 51EA = 4C
      when "101000111101011" =>  data <= "01011110";  -- 51EB = 5E
      when "101000111101100" =>  data <= "11001011";  -- 51EC = CB
      when "101000111101101" =>  data <= "10000101";  -- 51ED = 85
      when "101000111101110" =>  data <= "01101110";  -- 51EE = 6E
      when "101000111101111" =>  data <= "10000100";  -- 51EF = 84
      when "101000111110000" =>  data <= "01101111";  -- 51F0 = 6F
      when "101000111110001" =>  data <= "00100000";  -- 51F1 = 20
      when "101000111110010" =>  data <= "11111101";  -- 51F2 = FD
      when "101000111110011" =>  data <= "11001100";  -- 51F3 = CC
      when "101000111110100" =>  data <= "10110001";  -- 51F4 = B1
      when "101000111110101" =>  data <= "01101110";  -- 51F5 = 6E
      when "101000111110110" =>  data <= "10000101";  -- 51F6 = 85
      when "101000111110111" =>  data <= "01100100";  -- 51F7 = 64
      when "101000111111000" =>  data <= "10100100";  -- 51F8 = A4
      when "101000111111001" =>  data <= "01101110";  -- 51F9 = 6E
      when "101000111111010" =>  data <= "11001000";  -- 51FA = C8
      when "101000111111011" =>  data <= "10011000";  -- 51FB = 98
      when "101000111111100" =>  data <= "11010000";  -- 51FC = D0
      when "101000111111101" =>  data <= "00000010";  -- 51FD = 2
      when "101000111111110" =>  data <= "11100110";  -- 51FE = E6
      when "101000111111111" =>  data <= "01101111";  -- 51FF = 6F
      when "101001000000000" =>  data <= "10000101";  -- 5200 = 85
      when "101001000000001" =>  data <= "01101110";  -- 5201 = 6E
      when "101001000000010" =>  data <= "10100100";  -- 5202 = A4
      when "101001000000011" =>  data <= "01101111";  -- 5203 = 6F
      when "101001000000100" =>  data <= "00100000";  -- 5204 = 20
      when "101001000000101" =>  data <= "01011110";  -- 5205 = 5E
      when "101001000000110" =>  data <= "11001011";  -- 5206 = CB
      when "101001000000111" =>  data <= "10100101";  -- 5207 = A5
      when "101001000001000" =>  data <= "01101110";  -- 5208 = 6E
      when "101001000001001" =>  data <= "10100100";  -- 5209 = A4
      when "101001000001010" =>  data <= "01101111";  -- 520A = 6F
      when "101001000001011" =>  data <= "00011000";  -- 520B = 18
      when "101001000001100" =>  data <= "01101001";  -- 520C = 69
      when "101001000001101" =>  data <= "00000101";  -- 520D = 5
      when "101001000001110" =>  data <= "10010000";  -- 520E = 90
      when "101001000001111" =>  data <= "00000001";  -- 520F = 1
      when "101001000010000" =>  data <= "11001000";  -- 5210 = C8
      when "101001000010001" =>  data <= "10000101";  -- 5211 = 85
      when "101001000010010" =>  data <= "01101110";  -- 5212 = 6E
      when "101001000010011" =>  data <= "10000100";  -- 5213 = 84
      when "101001000010100" =>  data <= "01101111";  -- 5214 = 6F
      when "101001000010101" =>  data <= "00100000";  -- 5215 = 20
      when "101001000010110" =>  data <= "10011101";  -- 5216 = 9D
      when "101001000010111" =>  data <= "11001001";  -- 5217 = C9
      when "101001000011000" =>  data <= "10101001";  -- 5218 = A9
      when "101001000011001" =>  data <= "01011001";  -- 5219 = 59
      when "101001000011010" =>  data <= "10100000";  -- 521A = A0
      when "101001000011011" =>  data <= "00000000";  -- 521B = 0
      when "101001000011100" =>  data <= "11000110";  -- 521C = C6
      when "101001000011101" =>  data <= "01100100";  -- 521D = 64
      when "101001000011110" =>  data <= "11010000";  -- 521E = D0
      when "101001000011111" =>  data <= "11100100";  -- 521F = E4
      when "101001000100000" =>  data <= "01100000";  -- 5220 = 60
      when "101001000100001" =>  data <= "10011000";  -- 5221 = 98
      when "101001000100010" =>  data <= "00110101";  -- 5222 = 35
      when "101001000100011" =>  data <= "01000100";  -- 5223 = 44
      when "101001000100100" =>  data <= "01111010";  -- 5224 = 7A
      when "101001000100101" =>  data <= "01101000";  -- 5225 = 68
      when "101001000100110" =>  data <= "00101000";  -- 5226 = 28
      when "101001000100111" =>  data <= "10110001";  -- 5227 = B1
      when "101001000101000" =>  data <= "01000110";  -- 5228 = 46
      when "101001000101001" =>  data <= "00100000";  -- 5229 = 20
      when "101001000101010" =>  data <= "01100001";  -- 522A = 61
      when "101001000101011" =>  data <= "11001101";  -- 522B = CD
      when "101001000101100" =>  data <= "00110000";  -- 522C = 30
      when "101001000101101" =>  data <= "00101110";  -- 522D = 2E
      when "101001000101110" =>  data <= "11010000";  -- 522E = D0
      when "101001000101111" =>  data <= "00010111";  -- 522F = 17
      when "101001000110000" =>  data <= "10101101";  -- 5230 = AD
      when "101001000110001" =>  data <= "01000100";  -- 5231 = 44
      when "101001000110010" =>  data <= "11101000";  -- 5232 = E8
      when "101001000110011" =>  data <= "10000101";  -- 5233 = 85
      when "101001000110100" =>  data <= "01011111";  -- 5234 = 5F
      when "101001000110101" =>  data <= "10101101";  -- 5235 = AD
      when "101001000110110" =>  data <= "01001000";  -- 5236 = 48
      when "101001000110111" =>  data <= "11101000";  -- 5237 = E8
      when "101001000111000" =>  data <= "10000101";  -- 5238 = 85
      when "101001000111001" =>  data <= "01100000";  -- 5239 = 60
      when "101001000111010" =>  data <= "10101101";  -- 523A = AD
      when "101001000111011" =>  data <= "01000101";  -- 523B = 45
      when "101001000111100" =>  data <= "11101000";  -- 523C = E8
      when "101001000111101" =>  data <= "10000101";  -- 523D = 85
      when "101001000111110" =>  data <= "01100001";  -- 523E = 61
      when "101001000111111" =>  data <= "10101101";  -- 523F = AD
      when "101001001000000" =>  data <= "01001001";  -- 5240 = 49
      when "101001001000001" =>  data <= "11101000";  -- 5241 = E8
      when "101001001000010" =>  data <= "10000101";  -- 5242 = 85
      when "101001001000011" =>  data <= "01100010";  -- 5243 = 62
      when "101001001000100" =>  data <= "01001100";  -- 5244 = 4C
      when "101001001000101" =>  data <= "01101100";  -- 5245 = 6C
      when "101001001000110" =>  data <= "11010010";  -- 5246 = D2
      when "101001001000111" =>  data <= "10101001";  -- 5247 = A9
      when "101001001001000" =>  data <= "10001000";  -- 5248 = 88
      when "101001001001001" =>  data <= "10100000";  -- 5249 = A0
      when "101001001001010" =>  data <= "00000000";  -- 524A = 0
      when "101001001001011" =>  data <= "00100000";  -- 524B = 20
      when "101001001001100" =>  data <= "11011000";  -- 524C = D8
      when "101001001001101" =>  data <= "11001100";  -- 524D = CC
      when "101001001001110" =>  data <= "10101001";  -- 524E = A9
      when "101001001001111" =>  data <= "00100001";  -- 524F = 21
      when "101001001010000" =>  data <= "10100000";  -- 5250 = A0
      when "101001001010001" =>  data <= "11010010";  -- 5251 = D2
      when "101001001010010" =>  data <= "00100000";  -- 5252 = 20
      when "101001001010011" =>  data <= "01011110";  -- 5253 = 5E
      when "101001001010100" =>  data <= "11001011";  -- 5254 = CB
      when "101001001010101" =>  data <= "10101001";  -- 5255 = A9
      when "101001001010110" =>  data <= "00100101";  -- 5256 = 25
      when "101001001010111" =>  data <= "10100000";  -- 5257 = A0
      when "101001001011000" =>  data <= "11010010";  -- 5258 = D2
      when "101001001011001" =>  data <= "00100000";  -- 5259 = 20
      when "101001001011010" =>  data <= "10011101";  -- 525A = 9D
      when "101001001011011" =>  data <= "11001001";  -- 525B = C9
      when "101001001011100" =>  data <= "10100110";  -- 525C = A6
      when "101001001011101" =>  data <= "01100010";  -- 525D = 62
      when "101001001011110" =>  data <= "10100101";  -- 525E = A5
      when "101001001011111" =>  data <= "01011111";  -- 525F = 5F
      when "101001001100000" =>  data <= "10000101";  -- 5260 = 85
      when "101001001100001" =>  data <= "01100010";  -- 5261 = 62
      when "101001001100010" =>  data <= "10000110";  -- 5262 = 86
      when "101001001100011" =>  data <= "01011111";  -- 5263 = 5F
      when "101001001100100" =>  data <= "10100110";  -- 5264 = A6
      when "101001001100101" =>  data <= "01100000";  -- 5265 = 60
      when "101001001100110" =>  data <= "10100101";  -- 5266 = A5
      when "101001001100111" =>  data <= "01100001";  -- 5267 = 61
      when "101001001101000" =>  data <= "10000101";  -- 5268 = 85
      when "101001001101001" =>  data <= "01100000";  -- 5269 = 60
      when "101001001101010" =>  data <= "10000110";  -- 526A = 86
      when "101001001101011" =>  data <= "01100001";  -- 526B = 61
      when "101001001101100" =>  data <= "10101001";  -- 526C = A9
      when "101001001101101" =>  data <= "00000000";  -- 526D = 0
      when "101001001101110" =>  data <= "10000101";  -- 526E = 85
      when "101001001101111" =>  data <= "01100011";  -- 526F = 63
      when "101001001110000" =>  data <= "10100101";  -- 5270 = A5
      when "101001001110001" =>  data <= "01011110";  -- 5271 = 5E
      when "101001001110010" =>  data <= "10000101";  -- 5272 = 85
      when "101001001110011" =>  data <= "01101101";  -- 5273 = 6D
      when "101001001110100" =>  data <= "10101001";  -- 5274 = A9
      when "101001001110101" =>  data <= "10000000";  -- 5275 = 80
      when "101001001110110" =>  data <= "10000101";  -- 5276 = 85
      when "101001001110111" =>  data <= "01011110";  -- 5277 = 5E
      when "101001001111000" =>  data <= "00100000";  -- 5278 = 20
      when "101001001111001" =>  data <= "00001101";  -- 5279 = D
      when "101001001111010" =>  data <= "11001010";  -- 527A = CA
      when "101001001111011" =>  data <= "10100010";  -- 527B = A2
      when "101001001111100" =>  data <= "10001000";  -- 527C = 88
      when "101001001111101" =>  data <= "10100000";  -- 527D = A0
      when "101001001111110" =>  data <= "00000000";  -- 527E = 0
      when "101001001111111" =>  data <= "01001100";  -- 527F = 4C
      when "101001010000000" =>  data <= "00001010";  -- 5280 = A
      when "101001010000001" =>  data <= "11001101";  -- 5281 = CD
      when "101001010000010" =>  data <= "10101001";  -- 5282 = A9
      when "101001010000011" =>  data <= "11111110";  -- 5283 = FE
      when "101001010000100" =>  data <= "10100000";  -- 5284 = A0
      when "101001010000101" =>  data <= "11010010";  -- 5285 = D2
      when "101001010000110" =>  data <= "00100000";  -- 5286 = 20
      when "101001010000111" =>  data <= "10011101";  -- 5287 = 9D
      when "101001010001000" =>  data <= "11001001";  -- 5288 = C9
      when "101001010001001" =>  data <= "00100000";  -- 5289 = 20
      when "101001010001010" =>  data <= "01000010";  -- 528A = 42
      when "101001010001011" =>  data <= "11001101";  -- 528B = CD
      when "101001010001100" =>  data <= "10101001";  -- 528C = A9
      when "101001010001101" =>  data <= "00000011";  -- 528D = 3
      when "101001010001110" =>  data <= "10100000";  -- 528E = A0
      when "101001010001111" =>  data <= "11010011";  -- 528F = D3
      when "101001010010000" =>  data <= "10100110";  -- 5290 = A6
      when "101001010010001" =>  data <= "01101011";  -- 5291 = 6B
      when "101001010010010" =>  data <= "00100000";  -- 5292 = 20
      when "101001010010011" =>  data <= "00111101";  -- 5293 = 3D
      when "101001010010100" =>  data <= "11001100";  -- 5294 = CC
      when "101001010010101" =>  data <= "00100000";  -- 5295 = 20
      when "101001010010110" =>  data <= "01000010";  -- 5296 = 42
      when "101001010010111" =>  data <= "11001101";  -- 5297 = CD
      when "101001010011000" =>  data <= "00100000";  -- 5298 = 20
      when "101001010011001" =>  data <= "00000010";  -- 5299 = 2
      when "101001010011010" =>  data <= "11001110";  -- 529A = CE
      when "101001010011011" =>  data <= "10101001";  -- 529B = A9
      when "101001010011100" =>  data <= "00000000";  -- 529C = 0
      when "101001010011101" =>  data <= "10000101";  -- 529D = 85
      when "101001010011110" =>  data <= "01101100";  -- 529E = 6C
      when "101001010011111" =>  data <= "00100000";  -- 529F = 20
      when "101001010100000" =>  data <= "10001001";  -- 52A0 = 89
      when "101001010100001" =>  data <= "11001001";  -- 52A1 = C9
      when "101001010100010" =>  data <= "10101001";  -- 52A2 = A9
      when "101001010100011" =>  data <= "00001000";  -- 52A3 = 8
      when "101001010100100" =>  data <= "10100000";  -- 52A4 = A0
      when "101001010100101" =>  data <= "11010011";  -- 52A5 = D3
      when "101001010100110" =>  data <= "00100000";  -- 52A6 = 20
      when "101001010100111" =>  data <= "10000110";  -- 52A7 = 86
      when "101001010101000" =>  data <= "11001001";  -- 52A8 = C9
      when "101001010101001" =>  data <= "10100101";  -- 52A9 = A5
      when "101001010101010" =>  data <= "01100011";  -- 52AA = 63
      when "101001010101011" =>  data <= "01001000";  -- 52AB = 48
      when "101001010101100" =>  data <= "00010000";  -- 52AC = 10
      when "101001010101101" =>  data <= "00001101";  -- 52AD = D
      when "101001010101110" =>  data <= "00100000";  -- 52AE = 20
      when "101001010101111" =>  data <= "01111111";  -- 52AF = 7F
      when "101001010110000" =>  data <= "11001001";  -- 52B0 = C9
      when "101001010110001" =>  data <= "10100101";  -- 52B1 = A5
      when "101001010110010" =>  data <= "01100011";  -- 52B2 = 63
      when "101001010110011" =>  data <= "00110000";  -- 52B3 = 30
      when "101001010110100" =>  data <= "00001001";  -- 52B4 = 9
      when "101001010110101" =>  data <= "10100101";  -- 52B5 = A5
      when "101001010110110" =>  data <= "00001100";  -- 52B6 = C
      when "101001010110111" =>  data <= "01001001";  -- 52B7 = 49
      when "101001010111000" =>  data <= "11111111";  -- 52B8 = FF
      when "101001010111001" =>  data <= "10000101";  -- 52B9 = 85
      when "101001010111010" =>  data <= "00001100";  -- 52BA = C
      when "101001010111011" =>  data <= "00100000";  -- 52BB = 20
      when "101001010111100" =>  data <= "01001011";  -- 52BC = 4B
      when "101001010111101" =>  data <= "11010001";  -- 52BD = D1
      when "101001010111110" =>  data <= "10101001";  -- 52BE = A9
      when "101001010111111" =>  data <= "00001000";  -- 52BF = 8
      when "101001011000000" =>  data <= "10100000";  -- 52C0 = A0
      when "101001011000001" =>  data <= "11010011";  -- 52C1 = D3
      when "101001011000010" =>  data <= "00100000";  -- 52C2 = 20
      when "101001011000011" =>  data <= "10011101";  -- 52C3 = 9D
      when "101001011000100" =>  data <= "11001001";  -- 52C4 = C9
      when "101001011000101" =>  data <= "01101000";  -- 52C5 = 68
      when "101001011000110" =>  data <= "00010000";  -- 52C6 = 10
      when "101001011000111" =>  data <= "00000011";  -- 52C7 = 3
      when "101001011001000" =>  data <= "00100000";  -- 52C8 = 20
      when "101001011001001" =>  data <= "01001011";  -- 52C9 = 4B
      when "101001011001010" =>  data <= "11010001";  -- 52CA = D1
      when "101001011001011" =>  data <= "10101001";  -- 52CB = A9
      when "101001011001100" =>  data <= "00001101";  -- 52CC = D
      when "101001011001101" =>  data <= "10100000";  -- 52CD = A0
      when "101001011001110" =>  data <= "11010011";  -- 52CE = D3
      when "101001011001111" =>  data <= "01001100";  -- 52CF = 4C
      when "101001011010000" =>  data <= "11010111";  -- 52D0 = D7
      when "101001011010001" =>  data <= "11010001";  -- 52D1 = D1
      when "101001011010010" =>  data <= "00100000";  -- 52D2 = 20
      when "101001011010011" =>  data <= "00000000";  -- 52D3 = 0
      when "101001011010100" =>  data <= "11001101";  -- 52D4 = CD
      when "101001011010101" =>  data <= "10101001";  -- 52D5 = A9
      when "101001011010110" =>  data <= "00000000";  -- 52D6 = 0
      when "101001011010111" =>  data <= "10000101";  -- 52D7 = 85
      when "101001011011000" =>  data <= "00001100";  -- 52D8 = C
      when "101001011011001" =>  data <= "00100000";  -- 52D9 = 20
      when "101001011011010" =>  data <= "10001001";  -- 52DA = 89
      when "101001011011011" =>  data <= "11010010";  -- 52DB = D2
      when "101001011011100" =>  data <= "10100010";  -- 52DC = A2
      when "101001011011101" =>  data <= "01001011";  -- 52DD = 4B
      when "101001011011110" =>  data <= "10100000";  -- 52DE = A0
      when "101001011011111" =>  data <= "00000000";  -- 52DF = 0
      when "101001011100000" =>  data <= "00100000";  -- 52E0 = 20
      when "101001011100001" =>  data <= "01111111";  -- 52E1 = 7F
      when "101001011100010" =>  data <= "11010010";  -- 52E2 = D2
      when "101001011100011" =>  data <= "10101001";  -- 52E3 = A9
      when "101001011100100" =>  data <= "01010100";  -- 52E4 = 54
      when "101001011100101" =>  data <= "10100000";  -- 52E5 = A0
      when "101001011100110" =>  data <= "00000000";  -- 52E6 = 0
      when "101001011100111" =>  data <= "00100000";  -- 52E7 = 20
      when "101001011101000" =>  data <= "11011000";  -- 52E8 = D8
      when "101001011101001" =>  data <= "11001100";  -- 52E9 = CC
      when "101001011101010" =>  data <= "10101001";  -- 52EA = A9
      when "101001011101011" =>  data <= "00000000";  -- 52EB = 0
      when "101001011101100" =>  data <= "10000101";  -- 52EC = 85
      when "101001011101101" =>  data <= "01100011";  -- 52ED = 63
      when "101001011101110" =>  data <= "10100101";  -- 52EE = A5
      when "101001011101111" =>  data <= "00001100";  -- 52EF = C
      when "101001011110000" =>  data <= "00100000";  -- 52F0 = 20
      when "101001011110001" =>  data <= "11111010";  -- 52F1 = FA
      when "101001011110010" =>  data <= "11010010";  -- 52F2 = D2
      when "101001011110011" =>  data <= "10101001";  -- 52F3 = A9
      when "101001011110100" =>  data <= "01001011";  -- 52F4 = 4B
      when "101001011110101" =>  data <= "10100000";  -- 52F5 = A0
      when "101001011110110" =>  data <= "00000000";  -- 52F6 = 0
      when "101001011110111" =>  data <= "01001100";  -- 52F7 = 4C
      when "101001011111000" =>  data <= "01000101";  -- 52F8 = 45
      when "101001011111001" =>  data <= "11001100";  -- 52F9 = CC
      when "101001011111010" =>  data <= "01001000";  -- 52FA = 48
      when "101001011111011" =>  data <= "01001100";  -- 52FB = 4C
      when "101001011111100" =>  data <= "10111011";  -- 52FC = BB
      when "101001011111101" =>  data <= "11010010";  -- 52FD = D2
      when "101001011111110" =>  data <= "10000001";  -- 52FE = 81
      when "101001011111111" =>  data <= "01001001";  -- 52FF = 49
      when "101001100000000" =>  data <= "00001111";  -- 5300 = F
      when "101001100000001" =>  data <= "11011010";  -- 5301 = DA
      when "101001100000010" =>  data <= "10100010";  -- 5302 = A2
      when "101001100000011" =>  data <= "10000011";  -- 5303 = 83
      when "101001100000100" =>  data <= "01001001";  -- 5304 = 49
      when "101001100000101" =>  data <= "00001111";  -- 5305 = F
      when "101001100000110" =>  data <= "11011010";  -- 5306 = DA
      when "101001100000111" =>  data <= "10100010";  -- 5307 = A2
      when "101001100001000" =>  data <= "01111111";  -- 5308 = 7F
      when "101001100001001" =>  data <= "00000000";  -- 5309 = 0
      when "101001100001010" =>  data <= "00000000";  -- 530A = 0
      when "101001100001011" =>  data <= "00000000";  -- 530B = 0
      when "101001100001100" =>  data <= "00000000";  -- 530C = 0
      when "101001100001101" =>  data <= "00000101";  -- 530D = 5
      when "101001100001110" =>  data <= "10000100";  -- 530E = 84
      when "101001100001111" =>  data <= "11100110";  -- 530F = E6
      when "101001100010000" =>  data <= "00011010";  -- 5310 = 1A
      when "101001100010001" =>  data <= "00101101";  -- 5311 = 2D
      when "101001100010010" =>  data <= "00011011";  -- 5312 = 1B
      when "101001100010011" =>  data <= "10000110";  -- 5313 = 86
      when "101001100010100" =>  data <= "00101000";  -- 5314 = 28
      when "101001100010101" =>  data <= "00000111";  -- 5315 = 7
      when "101001100010110" =>  data <= "11111011";  -- 5316 = FB
      when "101001100010111" =>  data <= "11111000";  -- 5317 = F8
      when "101001100011000" =>  data <= "10000111";  -- 5318 = 87
      when "101001100011001" =>  data <= "10011001";  -- 5319 = 99
      when "101001100011010" =>  data <= "01101000";  -- 531A = 68
      when "101001100011011" =>  data <= "10001001";  -- 531B = 89
      when "101001100011100" =>  data <= "00000001";  -- 531C = 1
      when "101001100011101" =>  data <= "10000111";  -- 531D = 87
      when "101001100011110" =>  data <= "00100011";  -- 531E = 23
      when "101001100011111" =>  data <= "00110101";  -- 531F = 35
      when "101001100100000" =>  data <= "11011111";  -- 5320 = DF
      when "101001100100001" =>  data <= "11100001";  -- 5321 = E1
      when "101001100100010" =>  data <= "10000110";  -- 5322 = 86
      when "101001100100011" =>  data <= "10100101";  -- 5323 = A5
      when "101001100100100" =>  data <= "01011101";  -- 5324 = 5D
      when "101001100100101" =>  data <= "11100111";  -- 5325 = E7
      when "101001100100110" =>  data <= "00101000";  -- 5326 = 28
      when "101001100100111" =>  data <= "10000011";  -- 5327 = 83
      when "101001100101000" =>  data <= "01001001";  -- 5328 = 49
      when "101001100101001" =>  data <= "00001111";  -- 5329 = F
      when "101001100101010" =>  data <= "11011010";  -- 532A = DA
      when "101001100101011" =>  data <= "10100010";  -- 532B = A2
      when "101001100101100" =>  data <= "10100101";  -- 532C = A5
      when "101001100101101" =>  data <= "01100011";  -- 532D = 63
      when "101001100101110" =>  data <= "01001000";  -- 532E = 48
      when "101001100101111" =>  data <= "00010000";  -- 532F = 10
      when "101001100110000" =>  data <= "00000011";  -- 5330 = 3
      when "101001100110001" =>  data <= "00100000";  -- 5331 = 20
      when "101001100110010" =>  data <= "01001011";  -- 5332 = 4B
      when "101001100110011" =>  data <= "11010001";  -- 5333 = D1
      when "101001100110100" =>  data <= "10100101";  -- 5334 = A5
      when "101001100110101" =>  data <= "01011110";  -- 5335 = 5E
      when "101001100110110" =>  data <= "01001000";  -- 5336 = 48
      when "101001100110111" =>  data <= "11001001";  -- 5337 = C9
      when "101001100111000" =>  data <= "10000001";  -- 5338 = 81
      when "101001100111001" =>  data <= "10010000";  -- 5339 = 90
      when "101001100111010" =>  data <= "00000111";  -- 533A = 7
      when "101001100111011" =>  data <= "10101001";  -- 533B = A9
      when "101001100111100" =>  data <= "11110010";  -- 533C = F2
      when "101001100111101" =>  data <= "10100000";  -- 533D = A0
      when "101001100111110" =>  data <= "11001010";  -- 533E = CA
      when "101001100111111" =>  data <= "00100000";  -- 533F = 20
      when "101001101000000" =>  data <= "01000101";  -- 5340 = 45
      when "101001101000001" =>  data <= "11001100";  -- 5341 = CC
      when "101001101000010" =>  data <= "10101001";  -- 5342 = A9
      when "101001101000011" =>  data <= "01011100";  -- 5343 = 5C
      when "101001101000100" =>  data <= "10100000";  -- 5344 = A0
      when "101001101000101" =>  data <= "11010011";  -- 5345 = D3
      when "101001101000110" =>  data <= "00100000";  -- 5346 = 20
      when "101001101000111" =>  data <= "11010111";  -- 5347 = D7
      when "101001101001000" =>  data <= "11010001";  -- 5348 = D1
      when "101001101001001" =>  data <= "01101000";  -- 5349 = 68
      when "101001101001010" =>  data <= "11001001";  -- 534A = C9
      when "101001101001011" =>  data <= "10000001";  -- 534B = 81
      when "101001101001100" =>  data <= "10010000";  -- 534C = 90
      when "101001101001101" =>  data <= "00000111";  -- 534D = 7
      when "101001101001110" =>  data <= "10101001";  -- 534E = A9
      when "101001101001111" =>  data <= "11111110";  -- 534F = FE
      when "101001101010000" =>  data <= "10100000";  -- 5350 = A0
      when "101001101010001" =>  data <= "11010010";  -- 5351 = D2
      when "101001101010010" =>  data <= "00100000";  -- 5352 = 20
      when "101001101010011" =>  data <= "10000110";  -- 5353 = 86
      when "101001101010100" =>  data <= "11001001";  -- 5354 = C9
      when "101001101010101" =>  data <= "01101000";  -- 5355 = 68
      when "101001101010110" =>  data <= "00010000";  -- 5356 = 10
      when "101001101010111" =>  data <= "00000011";  -- 5357 = 3
      when "101001101011000" =>  data <= "01001100";  -- 5358 = 4C
      when "101001101011001" =>  data <= "01001011";  -- 5359 = 4B
      when "101001101011010" =>  data <= "11010001";  -- 535A = D1
      when "101001101011011" =>  data <= "01100000";  -- 535B = 60
      when "101001101011100" =>  data <= "00001011";  -- 535C = B
      when "101001101011101" =>  data <= "01110110";  -- 535D = 76
      when "101001101011110" =>  data <= "10110011";  -- 535E = B3
      when "101001101011111" =>  data <= "10000011";  -- 535F = 83
      when "101001101100000" =>  data <= "10111101";  -- 5360 = BD
      when "101001101100001" =>  data <= "11010011";  -- 5361 = D3
      when "101001101100010" =>  data <= "01111001";  -- 5362 = 79
      when "101001101100011" =>  data <= "00011110";  -- 5363 = 1E
      when "101001101100100" =>  data <= "11110100";  -- 5364 = F4
      when "101001101100101" =>  data <= "10100110";  -- 5365 = A6
      when "101001101100110" =>  data <= "11110101";  -- 5366 = F5
      when "101001101100111" =>  data <= "01111011";  -- 5367 = 7B
      when "101001101101000" =>  data <= "10000011";  -- 5368 = 83
      when "101001101101001" =>  data <= "11111100";  -- 5369 = FC
      when "101001101101010" =>  data <= "10110000";  -- 536A = B0
      when "101001101101011" =>  data <= "00010000";  -- 536B = 10
      when "101001101101100" =>  data <= "01111100";  -- 536C = 7C
      when "101001101101101" =>  data <= "00001100";  -- 536D = C
      when "101001101101110" =>  data <= "00011111";  -- 536E = 1F
      when "101001101101111" =>  data <= "01100111";  -- 536F = 67
      when "101001101110000" =>  data <= "11001010";  -- 5370 = CA
      when "101001101110001" =>  data <= "01111100";  -- 5371 = 7C
      when "101001101110010" =>  data <= "11011110";  -- 5372 = DE
      when "101001101110011" =>  data <= "01010011";  -- 5373 = 53
      when "101001101110100" =>  data <= "11001011";  -- 5374 = CB
      when "101001101110101" =>  data <= "11000001";  -- 5375 = C1
      when "101001101110110" =>  data <= "01111101";  -- 5376 = 7D
      when "101001101110111" =>  data <= "00010100";  -- 5377 = 14
      when "101001101111000" =>  data <= "01100100";  -- 5378 = 64
      when "101001101111001" =>  data <= "01110000";  -- 5379 = 70
      when "101001101111010" =>  data <= "01001100";  -- 537A = 4C
      when "101001101111011" =>  data <= "01111101";  -- 537B = 7D
      when "101001101111100" =>  data <= "10110111";  -- 537C = B7
      when "101001101111101" =>  data <= "11101010";  -- 537D = EA
      when "101001101111110" =>  data <= "01010001";  -- 537E = 51
      when "101001101111111" =>  data <= "01111010";  -- 537F = 7A
      when "101001110000000" =>  data <= "01111101";  -- 5380 = 7D
      when "101001110000001" =>  data <= "01100011";  -- 5381 = 63
      when "101001110000010" =>  data <= "00110000";  -- 5382 = 30
      when "101001110000011" =>  data <= "10001000";  -- 5383 = 88
      when "101001110000100" =>  data <= "01111110";  -- 5384 = 7E
      when "101001110000101" =>  data <= "01111110";  -- 5385 = 7E
      when "101001110000110" =>  data <= "10010010";  -- 5386 = 92
      when "101001110000111" =>  data <= "01000100";  -- 5387 = 44
      when "101001110001000" =>  data <= "10011001";  -- 5388 = 99
      when "101001110001001" =>  data <= "00111010";  -- 5389 = 3A
      when "101001110001010" =>  data <= "01111110";  -- 538A = 7E
      when "101001110001011" =>  data <= "01001100";  -- 538B = 4C
      when "101001110001100" =>  data <= "11001100";  -- 538C = CC
      when "101001110001101" =>  data <= "10010001";  -- 538D = 91
      when "101001110001110" =>  data <= "11000111";  -- 538E = C7
      when "101001110001111" =>  data <= "01111111";  -- 538F = 7F
      when "101001110010000" =>  data <= "10101010";  -- 5390 = AA
      when "101001110010001" =>  data <= "10101010";  -- 5391 = AA
      when "101001110010010" =>  data <= "10101010";  -- 5392 = AA
      when "101001110010011" =>  data <= "00010011";  -- 5393 = 13
      when "101001110010100" =>  data <= "10000001";  -- 5394 = 81
      when "101001110010101" =>  data <= "00000000";  -- 5395 = 0
      when "101001110010110" =>  data <= "00000000";  -- 5396 = 0
      when "101001110010111" =>  data <= "00000000";  -- 5397 = 0
      when "101001110011000" =>  data <= "00000000";  -- 5398 = 0
      when "101001110011001" =>  data <= "11100110";  -- 5399 = E6
      when "101001110011010" =>  data <= "01110111";  -- 539A = 77
      when "101001110011011" =>  data <= "11010000";  -- 539B = D0
      when "101001110011100" =>  data <= "00000010";  -- 539C = 2
      when "101001110011101" =>  data <= "11100110";  -- 539D = E6
      when "101001110011110" =>  data <= "01111000";  -- 539E = 78
      when "101001110011111" =>  data <= "10101101";  -- 539F = AD
      when "101001110100000" =>  data <= "01100000";  -- 53A0 = 60
      when "101001110100001" =>  data <= "11101010";  -- 53A1 = EA
      when "101001110100010" =>  data <= "11001001";  -- 53A2 = C9
      when "101001110100011" =>  data <= "00111010";  -- 53A3 = 3A
      when "101001110100100" =>  data <= "10110000";  -- 53A4 = B0
      when "101001110100101" =>  data <= "00001010";  -- 53A5 = A
      when "101001110100110" =>  data <= "11001001";  -- 53A6 = C9
      when "101001110100111" =>  data <= "00100000";  -- 53A7 = 20
      when "101001110101000" =>  data <= "11110000";  -- 53A8 = F0
      when "101001110101001" =>  data <= "11101111";  -- 53A9 = EF
      when "101001110101010" =>  data <= "00111000";  -- 53AA = 38
      when "101001110101011" =>  data <= "11101001";  -- 53AB = E9
      when "101001110101100" =>  data <= "00110000";  -- 53AC = 30
      when "101001110101101" =>  data <= "00111000";  -- 53AD = 38
      when "101001110101110" =>  data <= "11101001";  -- 53AE = E9
      when "101001110101111" =>  data <= "11010000";  -- 53AF = D0
      when "101001110110000" =>  data <= "01100000";  -- 53B0 = 60
      when "101001110110001" =>  data <= "10000000";  -- 53B1 = 80
      when "101001110110010" =>  data <= "01001111";  -- 53B2 = 4F
      when "101001110110011" =>  data <= "11000111";  -- 53B3 = C7
      when "101001110110100" =>  data <= "01010010";  -- 53B4 = 52
      when "101001110110101" =>  data <= "01011000";  -- 53B5 = 58
      when "101001110110110" =>  data <= "10100010";  -- 53B6 = A2
      when "101001110110111" =>  data <= "11111011";  -- 53B7 = FB
      when "101001110111000" =>  data <= "10011010";  -- 53B8 = 9A
      when "101001110111001" =>  data <= "10101001";  -- 53B9 = A9
      when "101001110111010" =>  data <= "01001100";  -- 53BA = 4C
      when "101001110111011" =>  data <= "10000101";  -- 53BB = 85
      when "101001110111100" =>  data <= "01010001";  -- 53BC = 51
      when "101001110111101" =>  data <= "10000101";  -- 53BD = 85
      when "101001110111110" =>  data <= "00000000";  -- 53BE = 0
      when "101001110111111" =>  data <= "10101001";  -- 53BF = A9
      when "101001111000000" =>  data <= "01110011";  -- 53C0 = 73
      when "101001111000001" =>  data <= "10100000";  -- 53C1 = A0
      when "101001111000010" =>  data <= "11000011";  -- 53C2 = C3
      when "101001111000011" =>  data <= "10000101";  -- 53C3 = 85
      when "101001111000100" =>  data <= "00000001";  -- 53C4 = 1
      when "101001111000101" =>  data <= "10000100";  -- 53C5 = 84
      when "101001111000110" =>  data <= "00000010";  -- 53C6 = 2
      when "101001111000111" =>  data <= "10100010";  -- 53C7 = A2
      when "101001111001000" =>  data <= "00011100";  -- 53C8 = 1C
      when "101001111001001" =>  data <= "10111101";  -- 53C9 = BD
      when "101001111001010" =>  data <= "10011000";  -- 53CA = 98
      when "101001111001011" =>  data <= "11010011";  -- 53CB = D3
      when "101001111001100" =>  data <= "10010101";  -- 53CC = 95
      when "101001111001101" =>  data <= "01101111";  -- 53CD = 6F
      when "101001111001110" =>  data <= "11001010";  -- 53CE = CA
      when "101001111001111" =>  data <= "11010000";  -- 53CF = D0
      when "101001111010000" =>  data <= "11111000";  -- 53D0 = F8
      when "101001111010001" =>  data <= "10101001";  -- 53D1 = A9
      when "101001111010010" =>  data <= "00000011";  -- 53D2 = 3
      when "101001111010011" =>  data <= "10000101";  -- 53D3 = 85
      when "101001111010100" =>  data <= "01010000";  -- 53D4 = 50
      when "101001111010101" =>  data <= "10001010";  -- 53D5 = 8A
      when "101001111010110" =>  data <= "10000101";  -- 53D6 = 85
      when "101001111010111" =>  data <= "01100101";  -- 53D7 = 65
      when "101001111011000" =>  data <= "10000101";  -- 53D8 = 85
      when "101001111011001" =>  data <= "00010000";  -- 53D9 = 10
      when "101001111011010" =>  data <= "10000101";  -- 53DA = 85
      when "101001111011011" =>  data <= "00010101";  -- 53DB = 15
      when "101001111011100" =>  data <= "10000101";  -- 53DC = 85
      when "101001111011101" =>  data <= "00001101";  -- 53DD = D
      when "101001111011110" =>  data <= "01001000";  -- 53DE = 48
      when "101001111011111" =>  data <= "11101000";  -- 53DF = E8
      when "101001111100000" =>  data <= "10001110";  -- 53E0 = 8E
      when "101001111100001" =>  data <= "11111101";  -- 53E1 = FD
      when "101001111100010" =>  data <= "00000001";  -- 53E2 = 1
      when "101001111100011" =>  data <= "10001110";  -- 53E3 = 8E
      when "101001111100100" =>  data <= "11111100";  -- 53E4 = FC
      when "101001111100101" =>  data <= "00000001";  -- 53E5 = 1
      when "101001111100110" =>  data <= "10100010";  -- 53E6 = A2
      when "101001111100111" =>  data <= "00010110";  -- 53E7 = 16
      when "101001111101000" =>  data <= "10000110";  -- 53E8 = 86
      when "101001111101001" =>  data <= "00010011";  -- 53E9 = 13
      when "101001111101010" =>  data <= "10100000";  -- 53EA = A0
      when "101001111101011" =>  data <= "00000100";  -- 53EB = 4
      when "101001111101100" =>  data <= "10000101";  -- 53EC = 85
      when "101001111101101" =>  data <= "00101000";  -- 53ED = 28
      when "101001111101110" =>  data <= "10000100";  -- 53EE = 84
      when "101001111101111" =>  data <= "00101001";  -- 53EF = 29
      when "101001111110000" =>  data <= "10000101";  -- 53F0 = 85
      when "101001111110001" =>  data <= "00010001";  -- 53F1 = 11
      when "101001111110010" =>  data <= "10000100";  -- 53F2 = 84
      when "101001111110011" =>  data <= "00010010";  -- 53F3 = 12
      when "101001111110100" =>  data <= "10101000";  -- 53F4 = A8
      when "101001111110101" =>  data <= "10101001";  -- 53F5 = A9
      when "101001111110110" =>  data <= "10000000";  -- 53F6 = 80
      when "101001111110111" =>  data <= "11010000";  -- 53F7 = D0
      when "101001111111000" =>  data <= "00000111";  -- 53F8 = 7
      when "101001111111001" =>  data <= "10101001";  -- 53F9 = A9
      when "101001111111010" =>  data <= "00000000";  -- 53FA = 0
      when "101001111111011" =>  data <= "10100000";  -- 53FB = A0
      when "101001111111100" =>  data <= "10110000";  -- 53FC = B0
      when "101001111111101" =>  data <= "01001100";  -- 53FD = 4C
      when "101001111111110" =>  data <= "00011011";  -- 53FE = 1B
      when "101001111111111" =>  data <= "11010100";  -- 53FF = D4
      when "101010000000000" =>  data <= "11100110";  -- 5400 = E6
      when "101010000000001" =>  data <= "00010001";  -- 5401 = 11
      when "101010000000010" =>  data <= "11010000";  -- 5402 = D0
      when "101010000000011" =>  data <= "00000100";  -- 5403 = 4
      when "101010000000100" =>  data <= "11100110";  -- 5404 = E6
      when "101010000000101" =>  data <= "00010010";  -- 5405 = 12
      when "101010000000110" =>  data <= "00110000";  -- 5406 = 30
      when "101010000000111" =>  data <= "00001111";  -- 5407 = F
      when "101010000001000" =>  data <= "10101001";  -- 5408 = A9
      when "101010000001001" =>  data <= "01010101";  -- 5409 = 55
      when "101010000001010" =>  data <= "10010001";  -- 540A = 91
      when "101010000001011" =>  data <= "00010001";  -- 540B = 11
      when "101010000001100" =>  data <= "11010001";  -- 540C = D1
      when "101010000001101" =>  data <= "00010001";  -- 540D = 11
      when "101010000001110" =>  data <= "11010000";  -- 540E = D0
      when "101010000001111" =>  data <= "00000111";  -- 540F = 7
      when "101010000010000" =>  data <= "00001010";  -- 5410 = A
      when "101010000010001" =>  data <= "10010001";  -- 5411 = 91
      when "101010000010010" =>  data <= "00010001";  -- 5412 = 11
      when "101010000010011" =>  data <= "11010001";  -- 5413 = D1
      when "101010000010100" =>  data <= "00010001";  -- 5414 = 11
      when "101010000010101" =>  data <= "11110000";  -- 5415 = F0
      when "101010000010110" =>  data <= "11101001";  -- 5416 = E9
      when "101010000010111" =>  data <= "10100101";  -- 5417 = A5
      when "101010000011000" =>  data <= "00010001";  -- 5418 = 11
      when "101010000011001" =>  data <= "10100100";  -- 5419 = A4
      when "101010000011010" =>  data <= "00010010";  -- 541A = 12
      when "101010000011011" =>  data <= "10000101";  -- 541B = 85
      when "101010000011100" =>  data <= "00110100";  -- 541C = 34
      when "101010000011101" =>  data <= "10000100";  -- 541D = 84
      when "101010000011110" =>  data <= "00110101";  -- 541E = 35
      when "101010000011111" =>  data <= "10000101";  -- 541F = 85
      when "101010000100000" =>  data <= "00110000";  -- 5420 = 30
      when "101010000100001" =>  data <= "10000100";  -- 5421 = 84
      when "101010000100010" =>  data <= "00110001";  -- 5422 = 31
      when "101010000100011" =>  data <= "10100000";  -- 5423 = A0
      when "101010000100100" =>  data <= "00000000";  -- 5424 = 0
      when "101010000100101" =>  data <= "10011000";  -- 5425 = 98
      when "101010000100110" =>  data <= "10010001";  -- 5426 = 91
      when "101010000100111" =>  data <= "00101000";  -- 5427 = 28
      when "101010000101000" =>  data <= "11100110";  -- 5428 = E6
      when "101010000101001" =>  data <= "00101000";  -- 5429 = 28
      when "101010000101010" =>  data <= "10101001";  -- 542A = A9
      when "101010000101011" =>  data <= "10100100";  -- 542B = A4
      when "101010000101100" =>  data <= "10100000";  -- 542C = A0
      when "101010000101101" =>  data <= "11011110";  -- 542D = DE
      when "101010000101110" =>  data <= "00100000";  -- 542E = 20
      when "101010000101111" =>  data <= "00011101";  -- 542F = 1D
      when "101010000110000" =>  data <= "10111011";  -- 5430 = BB
      when "101010000110001" =>  data <= "10100101";  -- 5431 = A5
      when "101010000110010" =>  data <= "00110100";  -- 5432 = 34
      when "101010000110011" =>  data <= "00111000";  -- 5433 = 38
      when "101010000110100" =>  data <= "11100101";  -- 5434 = E5
      when "101010000110101" =>  data <= "00101000";  -- 5435 = 28
      when "101010000110110" =>  data <= "10101010";  -- 5436 = AA
      when "101010000110111" =>  data <= "10100101";  -- 5437 = A5
      when "101010000111000" =>  data <= "00110101";  -- 5438 = 35
      when "101010000111001" =>  data <= "11100101";  -- 5439 = E5
      when "101010000111010" =>  data <= "00101001";  -- 543A = 29
      when "101010000111011" =>  data <= "00100000";  -- 543B = 20
      when "101010000111100" =>  data <= "10000011";  -- 543C = 83
      when "101010000111101" =>  data <= "11001111";  -- 543D = CF
      when "101010000111110" =>  data <= "10101001";  -- 543E = A9
      when "101010000111111" =>  data <= "01001011";  -- 543F = 4B
      when "101010001000000" =>  data <= "10100000";  -- 5440 = A0
      when "101010001000001" =>  data <= "11010100";  -- 5441 = D4
      when "101010001000010" =>  data <= "00100000";  -- 5442 = 20
      when "101010001000011" =>  data <= "00011101";  -- 5443 = 1D
      when "101010001000100" =>  data <= "10111011";  -- 5444 = BB
      when "101010001000101" =>  data <= "00100000";  -- 5445 = 20
      when "101010001000110" =>  data <= "11010100";  -- 5446 = D4
      when "101010001000111" =>  data <= "10110101";  -- 5447 = B5
      when "101010001001000" =>  data <= "01001100";  -- 5448 = 4C
      when "101010001001001" =>  data <= "11111111";  -- 5449 = FF
      when "101010001001010" =>  data <= "10110011";  -- 544A = B3
      when "101010001001011" =>  data <= "00100000";  -- 544B = 20
      when "101010001001100" =>  data <= "01000010";  -- 544C = 42
      when "101010001001101" =>  data <= "01011001";  -- 544D = 59
      when "101010001001110" =>  data <= "01010100";  -- 544E = 54
      when "101010001001111" =>  data <= "01000101";  -- 544F = 45
      when "101010001010000" =>  data <= "01010011";  -- 5450 = 53
      when "101010001010001" =>  data <= "00100000";  -- 5451 = 20
      when "101010001010010" =>  data <= "01000110";  -- 5452 = 46
      when "101010001010011" =>  data <= "01010010";  -- 5453 = 52
      when "101010001010100" =>  data <= "01000101";  -- 5454 = 45
      when "101010001010101" =>  data <= "01000101";  -- 5455 = 45
      when "101010001010110" =>  data <= "00001101";  -- 5456 = D
      when "101010001010111" =>  data <= "00000000";  -- 5457 = 0
      when "101010001011000" =>  data <= "00100011";  -- 5458 = 23
      when "101010001011001" =>  data <= "00100011";  -- 5459 = 23
      when "101010001011010" =>  data <= "00100011";  -- 545A = 23
      when "101010001011011" =>  data <= "00100000";  -- 545B = 20
      when "101010001011100" =>  data <= "01000011";  -- 545C = 43
      when "101010001011101" =>  data <= "01001111";  -- 545D = 4F
      when "101010001011110" =>  data <= "01001101";  -- 545E = 4D
      when "101010001011111" =>  data <= "01001101";  -- 545F = 4D
      when "101010001100000" =>  data <= "01001111";  -- 5460 = 4F
      when "101010001100001" =>  data <= "01000100";  -- 5461 = 44
      when "101010001100010" =>  data <= "01001111";  -- 5462 = 4F
      when "101010001100011" =>  data <= "01010010";  -- 5463 = 52
      when "101010001100100" =>  data <= "01000101";  -- 5464 = 45
      when "101010001100101" =>  data <= "00100000";  -- 5465 = 20
      when "101010001100110" =>  data <= "01000010";  -- 5466 = 42
      when "101010001100111" =>  data <= "01000001";  -- 5467 = 41
      when "101010001101000" =>  data <= "01010011";  -- 5468 = 53
      when "101010001101001" =>  data <= "01001001";  -- 5469 = 49
      when "101010001101010" =>  data <= "01000011";  -- 546A = 43
      when "101010001101011" =>  data <= "00100000";  -- 546B = 20
      when "101010001101100" =>  data <= "00100011";  -- 546C = 23
      when "101010001101101" =>  data <= "00100011";  -- 546D = 23
      when "101010001101110" =>  data <= "00100011";  -- 546E = 23
      when "101010001101111" =>  data <= "00001101";  -- 546F = D
      when "101010001110000" =>  data <= "00001101";  -- 5470 = D
      when "101010001110001" =>  data <= "00000000";  -- 5471 = 0
      when "101010001110010" =>  data <= "10101001";  -- 5472 = A9
      when "101010001110011" =>  data <= "01000011";  -- 5473 = 43
      when "101010001110100" =>  data <= "10000101";  -- 5474 = 85
      when "101010001110101" =>  data <= "10110101";  -- 5475 = B5
      when "101010001110110" =>  data <= "11010000";  -- 5476 = D0
      when "101010001110111" =>  data <= "00011001";  -- 5477 = 19
      when "101010001111000" =>  data <= "00100000";  -- 5478 = 20
      when "101010001111001" =>  data <= "10100110";  -- 5479 = A6
      when "101010001111010" =>  data <= "11110010";  -- 547A = F2
      when "101010001111011" =>  data <= "10101001";  -- 547B = A9
      when "101010001111100" =>  data <= "01000010";  -- 547C = 42
      when "101010001111101" =>  data <= "10000101";  -- 547D = 85
      when "101010001111110" =>  data <= "10110101";  -- 547E = B5
      when "101010001111111" =>  data <= "11011000";  -- 547F = D8
      when "101010010000000" =>  data <= "01001010";  -- 5480 = 4A
      when "101010010000001" =>  data <= "01101000";  -- 5481 = 68
      when "101010010000010" =>  data <= "10001101";  -- 5482 = 8D
      when "101010010000011" =>  data <= "00000101";  -- 5483 = 5
      when "101010010000100" =>  data <= "00000010";  -- 5484 = 2
      when "101010010000101" =>  data <= "01101000";  -- 5485 = 68
      when "101010010000110" =>  data <= "10001101";  -- 5486 = 8D
      when "101010010000111" =>  data <= "00000100";  -- 5487 = 4
      when "101010010001000" =>  data <= "00000010";  -- 5488 = 2
      when "101010010001001" =>  data <= "01101000";  -- 5489 = 68
      when "101010010001010" =>  data <= "10001101";  -- 548A = 8D
      when "101010010001011" =>  data <= "00000011";  -- 548B = 3
      when "101010010001100" =>  data <= "00000010";  -- 548C = 2
      when "101010010001101" =>  data <= "01101000";  -- 548D = 68
      when "101010010001110" =>  data <= "10001101";  -- 548E = 8D
      when "101010010001111" =>  data <= "00000010";  -- 548F = 2
      when "101010010010000" =>  data <= "00000010";  -- 5490 = 2
      when "101010010010001" =>  data <= "01101000";  -- 5491 = 68
      when "101010010010010" =>  data <= "01101001";  -- 5492 = 69
      when "101010010010011" =>  data <= "11111111";  -- 5493 = FF
      when "101010010010100" =>  data <= "10001101";  -- 5494 = 8D
      when "101010010010101" =>  data <= "00000001";  -- 5495 = 1
      when "101010010010110" =>  data <= "00000010";  -- 5496 = 2
      when "101010010010111" =>  data <= "01101000";  -- 5497 = 68
      when "101010010011000" =>  data <= "01101001";  -- 5498 = 69
      when "101010010011001" =>  data <= "11111111";  -- 5499 = FF
      when "101010010011010" =>  data <= "10001101";  -- 549A = 8D
      when "101010010011011" =>  data <= "00000000";  -- 549B = 0
      when "101010010011100" =>  data <= "00000010";  -- 549C = 2
      when "101010010011101" =>  data <= "10100101";  -- 549D = A5
      when "101010010011110" =>  data <= "10010000";  -- 549E = 90
      when "101010010011111" =>  data <= "10001101";  -- 549F = 8D
      when "101010010100000" =>  data <= "00001000";  -- 54A0 = 8
      when "101010010100001" =>  data <= "00000010";  -- 54A1 = 2
      when "101010010100010" =>  data <= "10100101";  -- 54A2 = A5
      when "101010010100011" =>  data <= "10010001";  -- 54A3 = 91
      when "101010010100100" =>  data <= "10001101";  -- 54A4 = 8D
      when "101010010100101" =>  data <= "00000111";  -- 54A5 = 7
      when "101010010100110" =>  data <= "00000010";  -- 54A6 = 2
      when "101010010100111" =>  data <= "10111010";  -- 54A7 = BA
      when "101010010101000" =>  data <= "10001110";  -- 54A8 = 8E
      when "101010010101001" =>  data <= "00000110";  -- 54A9 = 6
      when "101010010101010" =>  data <= "00000010";  -- 54AA = 2
      when "101010010101011" =>  data <= "01011000";  -- 54AB = 58
      when "101010010101100" =>  data <= "00100000";  -- 54AC = 20
      when "101010010101101" =>  data <= "00110100";  -- 54AD = 34
      when "101010010101110" =>  data <= "11010101";  -- 54AE = D5
      when "101010010101111" =>  data <= "10100110";  -- 54AF = A6
      when "101010010110000" =>  data <= "10110101";  -- 54B0 = B5
      when "101010010110001" =>  data <= "10101001";  -- 54B1 = A9
      when "101010010110010" =>  data <= "00101010";  -- 54B2 = 2A
      when "101010010110011" =>  data <= "00100000";  -- 54B3 = 20
      when "101010010110100" =>  data <= "00110001";  -- 54B4 = 31
      when "101010010110101" =>  data <= "11010111";  -- 54B5 = D7
      when "101010010110110" =>  data <= "10101001";  -- 54B6 = A9
      when "101010010110111" =>  data <= "01010010";  -- 54B7 = 52
      when "101010010111000" =>  data <= "11010000";  -- 54B8 = D0
      when "101010010111001" =>  data <= "00011010";  -- 54B9 = 1A
      when "101010010111010" =>  data <= "10101001";  -- 54BA = A9
      when "101010010111011" =>  data <= "00000010";  -- 54BB = 2
      when "101010010111100" =>  data <= "10000101";  -- 54BC = 85
      when "101010010111101" =>  data <= "01110111";  -- 54BD = 77
      when "101010010111110" =>  data <= "10101001";  -- 54BE = A9
      when "101010010111111" =>  data <= "00000000";  -- 54BF = 0
      when "101010011000000" =>  data <= "10000101";  -- 54C0 = 85
      when "101010011000001" =>  data <= "11011110";  -- 54C1 = DE
      when "101010011000010" =>  data <= "10100010";  -- 54C2 = A2
      when "101010011000011" =>  data <= "00001101";  -- 54C3 = D
      when "101010011000100" =>  data <= "10101001";  -- 54C4 = A9
      when "101010011000101" =>  data <= "00101110";  -- 54C5 = 2E
      when "101010011000110" =>  data <= "00100000";  -- 54C6 = 20
      when "101010011000111" =>  data <= "00110001";  -- 54C7 = 31
      when "101010011001000" =>  data <= "11010111";  -- 54C8 = D7
      when "101010011001001" =>  data <= "00100000";  -- 54C9 = 20
      when "101010011001010" =>  data <= "10011000";  -- 54CA = 98
      when "101010011001011" =>  data <= "11010111";  -- 54CB = D7
      when "101010011001100" =>  data <= "11001001";  -- 54CC = C9
      when "101010011001101" =>  data <= "00101110";  -- 54CD = 2E
      when "101010011001110" =>  data <= "11110000";  -- 54CE = F0
      when "101010011001111" =>  data <= "11111001";  -- 54CF = F9
      when "101010011010000" =>  data <= "11001001";  -- 54D0 = C9
      when "101010011010001" =>  data <= "00100000";  -- 54D1 = 20
      when "101010011010010" =>  data <= "11110000";  -- 54D2 = F0
      when "101010011010011" =>  data <= "11110101";  -- 54D3 = F5
      when "101010011010100" =>  data <= "10100010";  -- 54D4 = A2
      when "101010011010101" =>  data <= "00000111";  -- 54D5 = 7
      when "101010011010110" =>  data <= "11011101";  -- 54D6 = DD
      when "101010011010111" =>  data <= "01000100";  -- 54D7 = 44
      when "101010011011000" =>  data <= "11010101";  -- 54D8 = D5
      when "101010011011001" =>  data <= "11010000";  -- 54D9 = D0
      when "101010011011010" =>  data <= "00001011";  -- 54DA = B
      when "101010011011011" =>  data <= "10000110";  -- 54DB = 86
      when "101010011011100" =>  data <= "10110100";  -- 54DC = B4
      when "101010011011101" =>  data <= "10111101";  -- 54DD = BD
      when "101010011011110" =>  data <= "01001100";  -- 54DE = 4C
      when "101010011011111" =>  data <= "11010101";  -- 54DF = D5
      when "101010011100000" =>  data <= "01001000";  -- 54E0 = 48
      when "101010011100001" =>  data <= "10111101";  -- 54E1 = BD
      when "101010011100010" =>  data <= "01010100";  -- 54E2 = 54
      when "101010011100011" =>  data <= "11010101";  -- 54E3 = D5
      when "101010011100100" =>  data <= "01001000";  -- 54E4 = 48
      when "101010011100101" =>  data <= "01100000";  -- 54E5 = 60
      when "101010011100110" =>  data <= "11001010";  -- 54E6 = CA
      when "101010011100111" =>  data <= "00010000";  -- 54E7 = 10
      when "101010011101000" =>  data <= "11101101";  -- 54E8 = ED
      when "101010011101001" =>  data <= "01101100";  -- 54E9 = 6C
      when "101010011101010" =>  data <= "11111010";  -- 54EA = FA
      when "101010011101011" =>  data <= "00000011";  -- 54EB = 3
      when "101010011101100" =>  data <= "10100101";  -- 54EC = A5
      when "101010011101101" =>  data <= "11111011";  -- 54ED = FB
      when "101010011101110" =>  data <= "10001101";  -- 54EE = 8D
      when "101010011101111" =>  data <= "00000001";  -- 54EF = 1
      when "101010011110000" =>  data <= "00000010";  -- 54F0 = 2
      when "101010011110001" =>  data <= "10100101";  -- 54F1 = A5
      when "101010011110010" =>  data <= "11111100";  -- 54F2 = FC
      when "101010011110011" =>  data <= "10001101";  -- 54F3 = 8D
      when "101010011110100" =>  data <= "00000000";  -- 54F4 = 0
      when "101010011110101" =>  data <= "00000010";  -- 54F5 = 2
      when "101010011110110" =>  data <= "01100000";  -- 54F6 = 60
      when "101010011110111" =>  data <= "10000101";  -- 54F7 = 85
      when "101010011111000" =>  data <= "10110101";  -- 54F8 = B5
      when "101010011111001" =>  data <= "10100000";  -- 54F9 = A0
      when "101010011111010" =>  data <= "00000000";  -- 54FA = 0
      when "101010011111011" =>  data <= "00100000";  -- 54FB = 20
      when "101010011111100" =>  data <= "00110001";  -- 54FC = 31
      when "101010011111101" =>  data <= "11010101";  -- 54FD = D5
      when "101010011111110" =>  data <= "10110001";  -- 54FE = B1
      when "101010011111111" =>  data <= "11111011";  -- 54FF = FB
      when "101010100000000" =>  data <= "00100000";  -- 5500 = 20
      when "101010100000001" =>  data <= "00100010";  -- 5501 = 22
      when "101010100000010" =>  data <= "11010111";  -- 5502 = D7
      when "101010100000011" =>  data <= "00100000";  -- 5503 = 20
      when "101010100000100" =>  data <= "00111001";  -- 5504 = 39
      when "101010100000101" =>  data <= "11010101";  -- 5505 = D5
      when "101010100000110" =>  data <= "11000110";  -- 5506 = C6
      when "101010100000111" =>  data <= "10110101";  -- 5507 = B5
      when "101010100001000" =>  data <= "11010000";  -- 5508 = D0
      when "101010100001001" =>  data <= "11110001";  -- 5509 = F1
      when "101010100001010" =>  data <= "01100000";  -- 550A = 60
      when "101010100001011" =>  data <= "00100000";  -- 550B = 20
      when "101010100001100" =>  data <= "01100011";  -- 550C = 63
      when "101010100001101" =>  data <= "11010111";  -- 550D = D7
      when "101010100001110" =>  data <= "10010000";  -- 550E = 90
      when "101010100001111" =>  data <= "00001101";  -- 550F = D
      when "101010100010000" =>  data <= "10100010";  -- 5510 = A2
      when "101010100010001" =>  data <= "00000000";  -- 5511 = 0
      when "101010100010010" =>  data <= "10000001";  -- 5512 = 81
      when "101010100010011" =>  data <= "11111011";  -- 5513 = FB
      when "101010100010100" =>  data <= "11000001";  -- 5514 = C1
      when "101010100010101" =>  data <= "11111011";  -- 5515 = FB
      when "101010100010110" =>  data <= "11110000";  -- 5516 = F0
      when "101010100010111" =>  data <= "00000101";  -- 5517 = 5
      when "101010100011000" =>  data <= "01101000";  -- 5518 = 68
      when "101010100011001" =>  data <= "01101000";  -- 5519 = 68
      when "101010100011010" =>  data <= "01001100";  -- 551A = 4C
      when "101010100011011" =>  data <= "10100100";  -- 551B = A4
      when "101010100011100" =>  data <= "11010111";  -- 551C = D7
      when "101010100011101" =>  data <= "00100000";  -- 551D = 20
      when "101010100011110" =>  data <= "00111001";  -- 551E = 39
      when "101010100011111" =>  data <= "11010101";  -- 551F = D5
      when "101010100100000" =>  data <= "11000110";  -- 5520 = C6
      when "101010100100001" =>  data <= "10110101";  -- 5521 = B5
      when "101010100100010" =>  data <= "01100000";  -- 5522 = 60
      when "101010100100011" =>  data <= "10101001";  -- 5523 = A9
      when "101010100100100" =>  data <= "00000010";  -- 5524 = 2
      when "101010100100101" =>  data <= "10000101";  -- 5525 = 85
      when "101010100100110" =>  data <= "11111011";  -- 5526 = FB
      when "101010100100111" =>  data <= "10101001";  -- 5527 = A9
      when "101010100101000" =>  data <= "00000010";  -- 5528 = 2
      when "101010100101001" =>  data <= "10000101";  -- 5529 = 85
      when "101010100101010" =>  data <= "11111100";  -- 552A = FC
      when "101010100101011" =>  data <= "10101001";  -- 552B = A9
      when "101010100101100" =>  data <= "00000101";  -- 552C = 5
      when "101010100101101" =>  data <= "01100000";  -- 552D = 60
      when "101010100101110" =>  data <= "00100000";  -- 552E = 20
      when "101010100101111" =>  data <= "00110001";  -- 552F = 31
      when "101010100110000" =>  data <= "11010101";  -- 5530 = D5
      when "101010100110001" =>  data <= "10101001";  -- 5531 = A9
      when "101010100110010" =>  data <= "00100000";  -- 5532 = 20
      when "101010100110011" =>  data <= "00101100";  -- 5533 = 2C
      when "101010100110100" =>  data <= "10101001";  -- 5534 = A9
      when "101010100110101" =>  data <= "00001101";  -- 5535 = D
      when "101010100110110" =>  data <= "01001100";  -- 5536 = 4C
      when "101010100110111" =>  data <= "01100110";  -- 5537 = 66
      when "101010100111000" =>  data <= "11110010";  -- 5538 = F2
      when "101010100111001" =>  data <= "11100110";  -- 5539 = E6
      when "101010100111010" =>  data <= "11111011";  -- 553A = FB
      when "101010100111011" =>  data <= "11010000";  -- 553B = D0
      when "101010100111100" =>  data <= "00000110";  -- 553C = 6
      when "101010100111101" =>  data <= "11100110";  -- 553D = E6
      when "101010100111110" =>  data <= "11111100";  -- 553E = FC
      when "101010100111111" =>  data <= "11010000";  -- 553F = D0
      when "101010101000000" =>  data <= "00000010";  -- 5540 = 2
      when "101010101000001" =>  data <= "11100110";  -- 5541 = E6
      when "101010101000010" =>  data <= "11011110";  -- 5542 = DE
      when "101010101000011" =>  data <= "01100000";  -- 5543 = 60
      when "101010101000100" =>  data <= "00111010";  -- 5544 = 3A
      when "101010101000101" =>  data <= "00111011";  -- 5545 = 3B
      when "101010101000110" =>  data <= "01010010";  -- 5546 = 52
      when "101010101000111" =>  data <= "01001101";  -- 5547 = 4D
      when "101010101001000" =>  data <= "01000111";  -- 5548 = 47
      when "101010101001001" =>  data <= "01011000";  -- 5549 = 58
      when "101010101001010" =>  data <= "01001100";  -- 554A = 4C
      when "101010101001011" =>  data <= "01010011";  -- 554B = 53
      when "101010101001100" =>  data <= "11010110";  -- 554C = D6
      when "101010101001101" =>  data <= "11010101";  -- 554D = D5
      when "101010101001110" =>  data <= "11010101";  -- 554E = D5
      when "101010101001111" =>  data <= "11010101";  -- 554F = D5
      when "101010101010000" =>  data <= "11010110";  -- 5550 = D6
      when "101010101010001" =>  data <= "11010110";  -- 5551 = D6
      when "101010101010010" =>  data <= "11010110";  -- 5552 = D6
      when "101010101010011" =>  data <= "11010110";  -- 5553 = D6
      when "101010101010100" =>  data <= "00011100";  -- 5554 = 1C
      when "101010101010101" =>  data <= "11111010";  -- 5555 = FA
      when "101010101010110" =>  data <= "10000110";  -- 5556 = 86
      when "101010101010111" =>  data <= "10111011";  -- 5557 = BB
      when "101010101011000" =>  data <= "00110010";  -- 5558 = 32
      when "101010101011001" =>  data <= "01101010";  -- 5559 = 6A
      when "101010101011010" =>  data <= "01110100";  -- 555A = 74
      when "101010101011011" =>  data <= "01110100";  -- 555B = 74
      when "101010101011100" =>  data <= "00001101";  -- 555C = D
      when "101010101011101" =>  data <= "00100000";  -- 555D = 20
      when "101010101011110" =>  data <= "00100000";  -- 555E = 20
      when "101010101011111" =>  data <= "00100000";  -- 555F = 20
      when "101010101100000" =>  data <= "00100000";  -- 5560 = 20
      when "101010101100001" =>  data <= "00100000";  -- 5561 = 20
      when "101010101100010" =>  data <= "01010000";  -- 5562 = 50
      when "101010101100011" =>  data <= "01000011";  -- 5563 = 43
      when "101010101100100" =>  data <= "00100000";  -- 5564 = 20
      when "101010101100101" =>  data <= "00100000";  -- 5565 = 20
      when "101010101100110" =>  data <= "01001001";  -- 5566 = 49
      when "101010101100111" =>  data <= "01010010";  -- 5567 = 52
      when "101010101101000" =>  data <= "01010001";  -- 5568 = 51
      when "101010101101001" =>  data <= "00100000";  -- 5569 = 20
      when "101010101101010" =>  data <= "00100000";  -- 556A = 20
      when "101010101101011" =>  data <= "01010011";  -- 556B = 53
      when "101010101101100" =>  data <= "01010010";  -- 556C = 52
      when "101010101101101" =>  data <= "00100000";  -- 556D = 20
      when "101010101101110" =>  data <= "01000001";  -- 556E = 41
      when "101010101101111" =>  data <= "01000011";  -- 556F = 43
      when "101010101110000" =>  data <= "00100000";  -- 5570 = 20
      when "101010101110001" =>  data <= "01011000";  -- 5571 = 58
      when "101010101110010" =>  data <= "01010010";  -- 5572 = 52
      when "101010101110011" =>  data <= "00100000";  -- 5573 = 20
      when "101010101110100" =>  data <= "01011001";  -- 5574 = 59
      when "101010101110101" =>  data <= "01010010";  -- 5575 = 52
      when "101010101110110" =>  data <= "00100000";  -- 5576 = 20
      when "101010101110111" =>  data <= "01010011";  -- 5577 = 53
      when "101010101111000" =>  data <= "01010000";  -- 5578 = 50
      when "101010101111001" =>  data <= "10011000";  -- 5579 = 98
      when "101010101111010" =>  data <= "01001000";  -- 557A = 48
      when "101010101111011" =>  data <= "00100000";  -- 557B = 20
      when "101010101111100" =>  data <= "00110100";  -- 557C = 34
      when "101010101111101" =>  data <= "11010101";  -- 557D = D5
      when "101010101111110" =>  data <= "01101000";  -- 557E = 68
      when "101010101111111" =>  data <= "10100010";  -- 557F = A2
      when "101010110000000" =>  data <= "00101110";  -- 5580 = 2E
      when "101010110000001" =>  data <= "00100000";  -- 5581 = 20
      when "101010110000010" =>  data <= "00110001";  -- 5582 = 31
      when "101010110000011" =>  data <= "11010111";  -- 5583 = D7
      when "101010110000100" =>  data <= "01001100";  -- 5584 = 4C
      when "101010110000101" =>  data <= "00101110";  -- 5585 = 2E
      when "101010110000110" =>  data <= "11010101";  -- 5586 = D5
      when "101010110000111" =>  data <= "10100010";  -- 5587 = A2
      when "101010110001000" =>  data <= "00000000";  -- 5588 = 0
      when "101010110001001" =>  data <= "10111101";  -- 5589 = BD
      when "101010110001010" =>  data <= "01011100";  -- 558A = 5C
      when "101010110001011" =>  data <= "11010101";  -- 558B = D5
      when "101010110001100" =>  data <= "00100000";  -- 558C = 20
      when "101010110001101" =>  data <= "01100110";  -- 558D = 66
      when "101010110001110" =>  data <= "11110010";  -- 558E = F2
      when "101010110001111" =>  data <= "11101000";  -- 558F = E8
      when "101010110010000" =>  data <= "11100000";  -- 5590 = E0
      when "101010110010001" =>  data <= "00011101";  -- 5591 = 1D
      when "101010110010010" =>  data <= "11010000";  -- 5592 = D0
      when "101010110010011" =>  data <= "11110101";  -- 5593 = F5
      when "101010110010100" =>  data <= "10100000";  -- 5594 = A0
      when "101010110010101" =>  data <= "00111011";  -- 5595 = 3B
      when "101010110010110" =>  data <= "00100000";  -- 5596 = 20
      when "101010110010111" =>  data <= "01111001";  -- 5597 = 79
      when "101010110011000" =>  data <= "11010101";  -- 5598 = D5
      when "101010110011001" =>  data <= "10101101";  -- 5599 = AD
      when "101010110011010" =>  data <= "00000000";  -- 559A = 0
      when "101010110011011" =>  data <= "00000010";  -- 559B = 2
      when "101010110011100" =>  data <= "00100000";  -- 559C = 20
      when "101010110011101" =>  data <= "00100010";  -- 559D = 22
      when "101010110011110" =>  data <= "11010111";  -- 559E = D7
      when "101010110011111" =>  data <= "10101101";  -- 559F = AD
      when "101010110100000" =>  data <= "00000001";  -- 55A0 = 1
      when "101010110100001" =>  data <= "00000010";  -- 55A1 = 2
      when "101010110100010" =>  data <= "00100000";  -- 55A2 = 20
      when "101010110100011" =>  data <= "00100010";  -- 55A3 = 22
      when "101010110100100" =>  data <= "11010111";  -- 55A4 = D7
      when "101010110100101" =>  data <= "00100000";  -- 55A5 = 20
      when "101010110100110" =>  data <= "00110001";  -- 55A6 = 31
      when "101010110100111" =>  data <= "11010101";  -- 55A7 = D5
      when "101010110101000" =>  data <= "10101101";  -- 55A8 = AD
      when "101010110101001" =>  data <= "00000111";  -- 55A9 = 7
      when "101010110101010" =>  data <= "00000010";  -- 55AA = 2
      when "101010110101011" =>  data <= "00100000";  -- 55AB = 20
      when "101010110101100" =>  data <= "00100010";  -- 55AC = 22
      when "101010110101101" =>  data <= "11010111";  -- 55AD = D7
      when "101010110101110" =>  data <= "10101101";  -- 55AE = AD
      when "101010110101111" =>  data <= "00001000";  -- 55AF = 8
      when "101010110110000" =>  data <= "00000010";  -- 55B0 = 2
      when "101010110110001" =>  data <= "00100000";  -- 55B1 = 20
      when "101010110110010" =>  data <= "00100010";  -- 55B2 = 22
      when "101010110110011" =>  data <= "11010111";  -- 55B3 = D7
      when "101010110110100" =>  data <= "00100000";  -- 55B4 = 20
      when "101010110110101" =>  data <= "00100011";  -- 55B5 = 23
      when "101010110110110" =>  data <= "11010101";  -- 55B6 = D5
      when "101010110110111" =>  data <= "00100000";  -- 55B7 = 20
      when "101010110111000" =>  data <= "11110111";  -- 55B8 = F7
      when "101010110111001" =>  data <= "11010100";  -- 55B9 = D4
      when "101010110111010" =>  data <= "11110000";  -- 55BA = F0
      when "101010110111011" =>  data <= "00111001";  -- 55BB = 39
      when "101010110111100" =>  data <= "00100000";  -- 55BC = 20
      when "101010110111101" =>  data <= "10011000";  -- 55BD = 98
      when "101010110111110" =>  data <= "11010111";  -- 55BE = D7
      when "101010110111111" =>  data <= "00100000";  -- 55BF = 20
      when "101010111000000" =>  data <= "01010100";  -- 55C0 = 54
      when "101010111000001" =>  data <= "11010111";  -- 55C1 = D7
      when "101010111000010" =>  data <= "10010000";  -- 55C2 = 90
      when "101010111000011" =>  data <= "00110100";  -- 55C3 = 34
      when "101010111000100" =>  data <= "00100000";  -- 55C4 = 20
      when "101010111000101" =>  data <= "01000100";  -- 55C5 = 44
      when "101010111000110" =>  data <= "11010111";  -- 55C6 = D7
      when "101010111000111" =>  data <= "00100000";  -- 55C7 = 20
      when "101010111001000" =>  data <= "10011000";  -- 55C8 = 98
      when "101010111001001" =>  data <= "11010111";  -- 55C9 = D7
      when "101010111001010" =>  data <= "00100000";  -- 55CA = 20
      when "101010111001011" =>  data <= "01010100";  -- 55CB = 54
      when "101010111001100" =>  data <= "11010111";  -- 55CC = D7
      when "101010111001101" =>  data <= "10010000";  -- 55CD = 90
      when "101010111001110" =>  data <= "00101001";  -- 55CE = 29
      when "101010111001111" =>  data <= "00100000";  -- 55CF = 20
      when "101010111010000" =>  data <= "01000100";  -- 55D0 = 44
      when "101010111010001" =>  data <= "11010111";  -- 55D1 = D7
      when "101010111010010" =>  data <= "00100000";  -- 55D2 = 20
      when "101010111010011" =>  data <= "00110101";  -- 55D3 = 35
      when "101010111010100" =>  data <= "11110011";  -- 55D4 = F3
      when "101010111010101" =>  data <= "11110000";  -- 55D5 = F0
      when "101010111010110" =>  data <= "00011110";  -- 55D6 = 1E
      when "101010111010111" =>  data <= "10100110";  -- 55D7 = A6
      when "101010111011000" =>  data <= "11011110";  -- 55D8 = DE
      when "101010111011001" =>  data <= "11010000";  -- 55D9 = D0
      when "101010111011010" =>  data <= "00011010";  -- 55DA = 1A
      when "101010111011011" =>  data <= "00111000";  -- 55DB = 38
      when "101010111011100" =>  data <= "10100101";  -- 55DC = A5
      when "101010111011101" =>  data <= "11111101";  -- 55DD = FD
      when "101010111011110" =>  data <= "11100101";  -- 55DE = E5
      when "101010111011111" =>  data <= "11111011";  -- 55DF = FB
      when "101010111100000" =>  data <= "10100101";  -- 55E0 = A5
      when "101010111100001" =>  data <= "11111110";  -- 55E1 = FE
      when "101010111100010" =>  data <= "11100101";  -- 55E2 = E5
      when "101010111100011" =>  data <= "11111100";  -- 55E3 = FC
      when "101010111100100" =>  data <= "10010000";  -- 55E4 = 90
      when "101010111100101" =>  data <= "00001111";  -- 55E5 = F
      when "101010111100110" =>  data <= "10100000";  -- 55E6 = A0
      when "101010111100111" =>  data <= "00111010";  -- 55E7 = 3A
      when "101010111101000" =>  data <= "00100000";  -- 55E8 = 20
      when "101010111101001" =>  data <= "01111001";  -- 55E9 = 79
      when "101010111101010" =>  data <= "11010101";  -- 55EA = D5
      when "101010111101011" =>  data <= "00100000";  -- 55EB = 20
      when "101010111101100" =>  data <= "00010111";  -- 55EC = 17
      when "101010111101101" =>  data <= "11010111";  -- 55ED = D7
      when "101010111101110" =>  data <= "10101001";  -- 55EE = A9
      when "101010111101111" =>  data <= "00001000";  -- 55EF = 8
      when "101010111110000" =>  data <= "00100000";  -- 55F0 = 20
      when "101010111110001" =>  data <= "11110111";  -- 55F1 = F7
      when "101010111110010" =>  data <= "11010100";  -- 55F2 = D4
      when "101010111110011" =>  data <= "11110000";  -- 55F3 = F0
      when "101010111110100" =>  data <= "11011101";  -- 55F4 = DD
      when "101010111110101" =>  data <= "01001100";  -- 55F5 = 4C
      when "101010111110110" =>  data <= "10111010";  -- 55F6 = BA
      when "101010111110111" =>  data <= "11010100";  -- 55F7 = D4
      when "101010111111000" =>  data <= "01001100";  -- 55F8 = 4C
      when "101010111111001" =>  data <= "10100100";  -- 55F9 = A4
      when "101010111111010" =>  data <= "11010111";  -- 55FA = D7
      when "101010111111011" =>  data <= "00100000";  -- 55FB = 20
      when "101010111111100" =>  data <= "01100011";  -- 55FC = 63
      when "101010111111101" =>  data <= "11010111";  -- 55FD = D7
      when "101010111111110" =>  data <= "00100000";  -- 55FE = 20
      when "101010111111111" =>  data <= "01010100";  -- 55FF = 54
      when "101011000000000" =>  data <= "11010111";  -- 5600 = D7
      when "101011000000001" =>  data <= "10010000";  -- 5601 = 90
      when "101011000000010" =>  data <= "00000011";  -- 5602 = 3
      when "101011000000011" =>  data <= "00100000";  -- 5603 = 20
      when "101011000000100" =>  data <= "11101100";  -- 5604 = EC
      when "101011000000101" =>  data <= "11010100";  -- 5605 = D4
      when "101011000000110" =>  data <= "00100000";  -- 5606 = 20
      when "101011000000111" =>  data <= "00010101";  -- 5607 = 15
      when "101011000001000" =>  data <= "11110010";  -- 5608 = F2
      when "101011000001001" =>  data <= "00100000";  -- 5609 = 20
      when "101011000001010" =>  data <= "01010100";  -- 560A = 54
      when "101011000001011" =>  data <= "11010111";  -- 560B = D7
      when "101011000001100" =>  data <= "10010000";  -- 560C = 90
      when "101011000001101" =>  data <= "00001010";  -- 560D = A
      when "101011000001110" =>  data <= "10100101";  -- 560E = A5
      when "101011000001111" =>  data <= "11111011";  -- 560F = FB
      when "101011000010000" =>  data <= "10001101";  -- 5610 = 8D
      when "101011000010001" =>  data <= "00001000";  -- 5611 = 8
      when "101011000010010" =>  data <= "00000010";  -- 5612 = 2
      when "101011000010011" =>  data <= "10100101";  -- 5613 = A5
      when "101011000010100" =>  data <= "11111100";  -- 5614 = FC
      when "101011000010101" =>  data <= "10001101";  -- 5615 = 8D
      when "101011000010110" =>  data <= "00000111";  -- 5616 = 7
      when "101011000010111" =>  data <= "00000010";  -- 5617 = 2
      when "101011000011000" =>  data <= "00100000";  -- 5618 = 20
      when "101011000011001" =>  data <= "00100011";  -- 5619 = 23
      when "101011000011010" =>  data <= "11010101";  -- 561A = D5
      when "101011000011011" =>  data <= "11010000";  -- 561B = D0
      when "101011000011100" =>  data <= "00001010";  -- 561C = A
      when "101011000011101" =>  data <= "00100000";  -- 561D = 20
      when "101011000011110" =>  data <= "01100011";  -- 561E = 63
      when "101011000011111" =>  data <= "11010111";  -- 561F = D7
      when "101011000100000" =>  data <= "00100000";  -- 5620 = 20
      when "101011000100001" =>  data <= "01010100";  -- 5621 = 54
      when "101011000100010" =>  data <= "11010111";  -- 5622 = D7
      when "101011000100011" =>  data <= "10010000";  -- 5623 = 90
      when "101011000100100" =>  data <= "11010011";  -- 5624 = D3
      when "101011000100101" =>  data <= "10101001";  -- 5625 = A9
      when "101011000100110" =>  data <= "00001000";  -- 5626 = 8
      when "101011000100111" =>  data <= "10000101";  -- 5627 = 85
      when "101011000101000" =>  data <= "10110101";  -- 5628 = B5
      when "101011000101001" =>  data <= "00100000";  -- 5629 = 20
      when "101011000101010" =>  data <= "10011000";  -- 562A = 98
      when "101011000101011" =>  data <= "11010111";  -- 562B = D7
      when "101011000101100" =>  data <= "00100000";  -- 562C = 20
      when "101011000101101" =>  data <= "00001011";  -- 562D = B
      when "101011000101110" =>  data <= "11010101";  -- 562E = D5
      when "101011000101111" =>  data <= "11010000";  -- 562F = D0
      when "101011000110000" =>  data <= "11111000";  -- 5630 = F8
      when "101011000110001" =>  data <= "11110000";  -- 5631 = F0
      when "101011000110010" =>  data <= "11000010";  -- 5632 = C2
      when "101011000110011" =>  data <= "00100000";  -- 5633 = 20
      when "101011000110100" =>  data <= "00010101";  -- 5634 = 15
      when "101011000110101" =>  data <= "11110010";  -- 5635 = F2
      when "101011000110110" =>  data <= "11001001";  -- 5636 = C9
      when "101011000110111" =>  data <= "00001101";  -- 5637 = D
      when "101011000111000" =>  data <= "11110000";  -- 5638 = F0
      when "101011000111001" =>  data <= "00001100";  -- 5639 = C
      when "101011000111010" =>  data <= "11001001";  -- 563A = C9
      when "101011000111011" =>  data <= "00100000";  -- 563B = 20
      when "101011000111100" =>  data <= "11010000";  -- 563C = D0
      when "101011000111101" =>  data <= "10111010";  -- 563D = BA
      when "101011000111110" =>  data <= "00100000";  -- 563E = 20
      when "101011000111111" =>  data <= "01010100";  -- 563F = 54
      when "101011001000000" =>  data <= "11010111";  -- 5640 = D7
      when "101011001000001" =>  data <= "10010000";  -- 5641 = 90
      when "101011001000010" =>  data <= "00000011";  -- 5642 = 3
      when "101011001000011" =>  data <= "00100000";  -- 5643 = 20
      when "101011001000100" =>  data <= "11101100";  -- 5644 = EC
      when "101011001000101" =>  data <= "11010100";  -- 5645 = D4
      when "101011001000110" =>  data <= "10101110";  -- 5646 = AE
      when "101011001000111" =>  data <= "00000110";  -- 5647 = 6
      when "101011001001000" =>  data <= "00000010";  -- 5648 = 2
      when "101011001001001" =>  data <= "10011010";  -- 5649 = 9A
      when "101011001001010" =>  data <= "01111000";  -- 564A = 78
      when "101011001001011" =>  data <= "10101101";  -- 564B = AD
      when "101011001001100" =>  data <= "00000111";  -- 564C = 7
      when "101011001001101" =>  data <= "00000010";  -- 564D = 2
      when "101011001001110" =>  data <= "10000101";  -- 564E = 85
      when "101011001001111" =>  data <= "10010001";  -- 564F = 91
      when "101011001010000" =>  data <= "10101101";  -- 5650 = AD
      when "101011001010001" =>  data <= "00001000";  -- 5651 = 8
      when "101011001010010" =>  data <= "00000010";  -- 5652 = 2
      when "101011001010011" =>  data <= "10000101";  -- 5653 = 85
      when "101011001010100" =>  data <= "10010000";  -- 5654 = 90
      when "101011001010101" =>  data <= "10101101";  -- 5655 = AD
      when "101011001010110" =>  data <= "00000000";  -- 5656 = 0
      when "101011001010111" =>  data <= "00000010";  -- 5657 = 2
      when "101011001011000" =>  data <= "01001000";  -- 5658 = 48
      when "101011001011001" =>  data <= "10101101";  -- 5659 = AD
      when "101011001011010" =>  data <= "00000001";  -- 565A = 1
      when "101011001011011" =>  data <= "00000010";  -- 565B = 2
      when "101011001011100" =>  data <= "01001000";  -- 565C = 48
      when "101011001011101" =>  data <= "10101101";  -- 565D = AD
      when "101011001011110" =>  data <= "00000010";  -- 565E = 2
      when "101011001011111" =>  data <= "00000010";  -- 565F = 2
      when "101011001100000" =>  data <= "01001000";  -- 5660 = 48
      when "101011001100001" =>  data <= "10101101";  -- 5661 = AD
      when "101011001100010" =>  data <= "00000011";  -- 5662 = 3
      when "101011001100011" =>  data <= "00000010";  -- 5663 = 2
      when "101011001100100" =>  data <= "10101110";  -- 5664 = AE
      when "101011001100101" =>  data <= "00000100";  -- 5665 = 4
      when "101011001100110" =>  data <= "00000010";  -- 5666 = 2
      when "101011001100111" =>  data <= "10101100";  -- 5667 = AC
      when "101011001101000" =>  data <= "00000101";  -- 5668 = 5
      when "101011001101001" =>  data <= "00000010";  -- 5669 = 2
      when "101011001101010" =>  data <= "01000000";  -- 566A = 40
      when "101011001101011" =>  data <= "10101110";  -- 566B = AE
      when "101011001101100" =>  data <= "00000110";  -- 566C = 6
      when "101011001101101" =>  data <= "00000010";  -- 566D = 2
      when "101011001101110" =>  data <= "10011010";  -- 566E = 9A
      when "101011001101111" =>  data <= "01001100";  -- 566F = 4C
      when "101011001110000" =>  data <= "11111111";  -- 5670 = FF
      when "101011001110001" =>  data <= "10110011";  -- 5671 = B3
      when "101011001110010" =>  data <= "01001100";  -- 5672 = 4C
      when "101011001110011" =>  data <= "10100100";  -- 5673 = A4
      when "101011001110100" =>  data <= "11010111";  -- 5674 = D7
      when "101011001110101" =>  data <= "10100000";  -- 5675 = A0
      when "101011001110110" =>  data <= "00000001";  -- 5676 = 1
      when "101011001110111" =>  data <= "10000100";  -- 5677 = 84
      when "101011001111000" =>  data <= "11010100";  -- 5678 = D4
      when "101011001111001" =>  data <= "10001000";  -- 5679 = 88
      when "101011001111010" =>  data <= "10000100";  -- 567A = 84
      when "101011001111011" =>  data <= "11010001";  -- 567B = D1
      when "101011001111100" =>  data <= "10000100";  -- 567C = 84
      when "101011001111101" =>  data <= "10010110";  -- 567D = 96
      when "101011001111110" =>  data <= "10000100";  -- 567E = 84
      when "101011001111111" =>  data <= "10011101";  -- 567F = 9D
      when "101011010000000" =>  data <= "10101001";  -- 5680 = A9
      when "101011010000001" =>  data <= "00000010";  -- 5681 = 2
      when "101011010000010" =>  data <= "10000101";  -- 5682 = 85
      when "101011010000011" =>  data <= "11011011";  -- 5683 = DB
      when "101011010000100" =>  data <= "10101001";  -- 5684 = A9
      when "101011010000101" =>  data <= "00001001";  -- 5685 = 9
      when "101011010000110" =>  data <= "10000101";  -- 5686 = 85
      when "101011010000111" =>  data <= "11011010";  -- 5687 = DA
      when "101011010001000" =>  data <= "00100000";  -- 5688 = 20
      when "101011010001001" =>  data <= "00010101";  -- 5689 = 15
      when "101011010001010" =>  data <= "11110010";  -- 568A = F2
      when "101011010001011" =>  data <= "11001001";  -- 568B = C9
      when "101011010001100" =>  data <= "00100000";  -- 568C = 20
      when "101011010001101" =>  data <= "11110000";  -- 568D = F0
      when "101011010001110" =>  data <= "11111001";  -- 568E = F9
      when "101011010001111" =>  data <= "11001001";  -- 568F = C9
      when "101011010010000" =>  data <= "00001101";  -- 5690 = D
      when "101011010010001" =>  data <= "11110000";  -- 5691 = F0
      when "101011010010010" =>  data <= "00011010";  -- 5692 = 1A
      when "101011010010011" =>  data <= "11001001";  -- 5693 = C9
      when "101011010010100" =>  data <= "00100010";  -- 5694 = 22
      when "101011010010101" =>  data <= "11010000";  -- 5695 = D0
      when "101011010010110" =>  data <= "11011011";  -- 5696 = DB
      when "101011010010111" =>  data <= "00100000";  -- 5697 = 20
      when "101011010011000" =>  data <= "00010101";  -- 5698 = 15
      when "101011010011001" =>  data <= "11110010";  -- 5699 = F2
      when "101011010011010" =>  data <= "11001001";  -- 569A = C9
      when "101011010011011" =>  data <= "00100010";  -- 569B = 22
      when "101011010011100" =>  data <= "11110000";  -- 569C = F0
      when "101011010011101" =>  data <= "00100100";  -- 569D = 24
      when "101011010011110" =>  data <= "11001001";  -- 569E = C9
      when "101011010011111" =>  data <= "00001101";  -- 569F = D
      when "101011010100000" =>  data <= "11110000";  -- 56A0 = F0
      when "101011010100001" =>  data <= "00001011";  -- 56A1 = B
      when "101011010100010" =>  data <= "10010001";  -- 56A2 = 91
      when "101011010100011" =>  data <= "11011010";  -- 56A3 = DA
      when "101011010100100" =>  data <= "11100110";  -- 56A4 = E6
      when "101011010100101" =>  data <= "11010001";  -- 56A5 = D1
      when "101011010100110" =>  data <= "11001000";  -- 56A6 = C8
      when "101011010100111" =>  data <= "11000000";  -- 56A7 = C0
      when "101011010101000" =>  data <= "00010000";  -- 56A8 = 10
      when "101011010101001" =>  data <= "11110000";  -- 56A9 = F0
      when "101011010101010" =>  data <= "11000111";  -- 56AA = C7
      when "101011010101011" =>  data <= "11010000";  -- 56AB = D0
      when "101011010101100" =>  data <= "11101010";  -- 56AC = EA
      when "101011010101101" =>  data <= "10100101";  -- 56AD = A5
      when "101011010101110" =>  data <= "10110100";  -- 56AE = B4
      when "101011010101111" =>  data <= "11001001";  -- 56AF = C9
      when "101011010110000" =>  data <= "00000110";  -- 56B0 = 6
      when "101011010110001" =>  data <= "11010000";  -- 56B1 = D0
      when "101011010110010" =>  data <= "11100010";  -- 56B2 = E2
      when "101011010110011" =>  data <= "00100000";  -- 56B3 = 20
      when "101011010110100" =>  data <= "01010110";  -- 56B4 = 56
      when "101011010110101" =>  data <= "11110011";  -- 56B5 = F3
      when "101011010110110" =>  data <= "00100000";  -- 56B6 = 20
      when "101011010110111" =>  data <= "00101011";  -- 56B7 = 2B
      when "101011010111000" =>  data <= "11111001";  -- 56B8 = F9
      when "101011010111001" =>  data <= "10100101";  -- 56B9 = A5
      when "101011010111010" =>  data <= "10010110";  -- 56BA = 96
      when "101011010111011" =>  data <= "00101001";  -- 56BB = 29
      when "101011010111100" =>  data <= "00010000";  -- 56BC = 10
      when "101011010111101" =>  data <= "11010000";  -- 56BD = D0
      when "101011010111110" =>  data <= "11110010";  -- 56BE = F2
      when "101011010111111" =>  data <= "01001100";  -- 56BF = 4C
      when "101011011000000" =>  data <= "10111010";  -- 56C0 = BA
      when "101011011000001" =>  data <= "11010100";  -- 56C1 = D4
      when "101011011000010" =>  data <= "00100000";  -- 56C2 = 20
      when "101011011000011" =>  data <= "00010101";  -- 56C3 = 15
      when "101011011000100" =>  data <= "11110010";  -- 56C4 = F2
      when "101011011000101" =>  data <= "11001001";  -- 56C5 = C9
      when "101011011000110" =>  data <= "00001101";  -- 56C6 = D
      when "101011011000111" =>  data <= "11110000";  -- 56C7 = F0
      when "101011011001000" =>  data <= "11100100";  -- 56C8 = E4
      when "101011011001001" =>  data <= "11001001";  -- 56C9 = C9
      when "101011011001010" =>  data <= "00101100";  -- 56CA = 2C
      when "101011011001011" =>  data <= "11010000";  -- 56CB = D0
      when "101011011001100" =>  data <= "11110000";  -- 56CC = F0
      when "101011011001101" =>  data <= "00100000";  -- 56CD = 20
      when "101011011001110" =>  data <= "01100011";  -- 56CE = 63
      when "101011011001111" =>  data <= "11010111";  -- 56CF = D7
      when "101011011010000" =>  data <= "00101001";  -- 56D0 = 29
      when "101011011010001" =>  data <= "00001111";  -- 56D1 = F
      when "101011011010010" =>  data <= "11110000";  -- 56D2 = F0
      when "101011011010011" =>  data <= "11010101";  -- 56D3 = D5
      when "101011011010100" =>  data <= "11001001";  -- 56D4 = C9
      when "101011011010101" =>  data <= "00000011";  -- 56D5 = 3
      when "101011011010110" =>  data <= "11110000";  -- 56D6 = F0
      when "101011011010111" =>  data <= "11111010";  -- 56D7 = FA
      when "101011011011000" =>  data <= "10000101";  -- 56D8 = 85
      when "101011011011001" =>  data <= "11010100";  -- 56D9 = D4
      when "101011011011010" =>  data <= "00100000";  -- 56DA = 20
      when "101011011011011" =>  data <= "00010101";  -- 56DB = 15
      when "101011011011100" =>  data <= "11110010";  -- 56DC = F2
      when "101011011011101" =>  data <= "11001001";  -- 56DD = C9
      when "101011011011110" =>  data <= "00001101";  -- 56DE = D
      when "101011011011111" =>  data <= "11110000";  -- 56DF = F0
      when "101011011100000" =>  data <= "11001100";  -- 56E0 = CC
      when "101011011100001" =>  data <= "11001001";  -- 56E1 = C9
      when "101011011100010" =>  data <= "00101100";  -- 56E2 = 2C
      when "101011011100011" =>  data <= "11010000";  -- 56E3 = D0
      when "101011011100100" =>  data <= "11100110";  -- 56E4 = E6
      when "101011011100101" =>  data <= "00100000";  -- 56E5 = 20
      when "101011011100110" =>  data <= "01010100";  -- 56E6 = 54
      when "101011011100111" =>  data <= "11010111";  -- 56E7 = D7
      when "101011011101000" =>  data <= "00100000";  -- 56E8 = 20
      when "101011011101001" =>  data <= "01000100";  -- 56E9 = 44
      when "101011011101010" =>  data <= "11010111";  -- 56EA = D7
      when "101011011101011" =>  data <= "00100000";  -- 56EB = 20
      when "101011011101100" =>  data <= "00010101";  -- 56EC = 15
      when "101011011101101" =>  data <= "11110010";  -- 56ED = F2
      when "101011011101110" =>  data <= "11001001";  -- 56EE = C9
      when "101011011101111" =>  data <= "00101100";  -- 56EF = 2C
      when "101011011110000" =>  data <= "11010000";  -- 56F0 = D0
      when "101011011110001" =>  data <= "11110001";  -- 56F1 = F1
      when "101011011110010" =>  data <= "00100000";  -- 56F2 = 20
      when "101011011110011" =>  data <= "01010100";  -- 56F3 = 54
      when "101011011110100" =>  data <= "11010111";  -- 56F4 = D7
      when "101011011110101" =>  data <= "10100101";  -- 56F5 = A5
      when "101011011110110" =>  data <= "11111011";  -- 56F6 = FB
      when "101011011110111" =>  data <= "10000101";  -- 56F7 = 85
      when "101011011111000" =>  data <= "11001001";  -- 56F8 = C9
      when "101011011111001" =>  data <= "10100101";  -- 56F9 = A5
      when "101011011111010" =>  data <= "11111100";  -- 56FA = FC
      when "101011011111011" =>  data <= "10000101";  -- 56FB = 85
      when "101011011111100" =>  data <= "11001010";  -- 56FC = CA
      when "101011011111101" =>  data <= "00100000";  -- 56FD = 20
      when "101011011111110" =>  data <= "01000100";  -- 56FE = 44
      when "101011011111111" =>  data <= "11010111";  -- 56FF = D7
      when "101011100000000" =>  data <= "00100000";  -- 5700 = 20
      when "101011100000001" =>  data <= "00010101";  -- 5701 = 15
      when "101011100000010" =>  data <= "11110010";  -- 5702 = F2
      when "101011100000011" =>  data <= "11001001";  -- 5703 = C9
      when "101011100000100" =>  data <= "00100000";  -- 5704 = 20
      when "101011100000101" =>  data <= "11110000";  -- 5705 = F0
      when "101011100000110" =>  data <= "11111001";  -- 5706 = F9
      when "101011100000111" =>  data <= "11001001";  -- 5707 = C9
      when "101011100001000" =>  data <= "00001101";  -- 5708 = D
      when "101011100001001" =>  data <= "11010000";  -- 5709 = D0
      when "101011100001010" =>  data <= "11100101";  -- 570A = E5
      when "101011100001011" =>  data <= "10100101";  -- 570B = A5
      when "101011100001100" =>  data <= "10110100";  -- 570C = B4
      when "101011100001101" =>  data <= "11001001";  -- 570D = C9
      when "101011100001110" =>  data <= "00000111";  -- 570E = 7
      when "101011100001111" =>  data <= "11010000";  -- 570F = D0
      when "101011100010000" =>  data <= "11111000";  -- 5710 = F8
      when "101011100010001" =>  data <= "00100000";  -- 5711 = 20
      when "101011100010010" =>  data <= "11100011";  -- 5712 = E3
      when "101011100010011" =>  data <= "11110110";  -- 5713 = F6
      when "101011100010100" =>  data <= "01001100";  -- 5714 = 4C
      when "101011100010101" =>  data <= "10111010";  -- 5715 = BA
      when "101011100010110" =>  data <= "11010100";  -- 5716 = D4
      when "101011100010111" =>  data <= "10100010";  -- 5717 = A2
      when "101011100011000" =>  data <= "00000001";  -- 5718 = 1
      when "101011100011001" =>  data <= "10110101";  -- 5719 = B5
      when "101011100011010" =>  data <= "11111010";  -- 571A = FA
      when "101011100011011" =>  data <= "01001000";  -- 571B = 48
      when "101011100011100" =>  data <= "10110101";  -- 571C = B5
      when "101011100011101" =>  data <= "11111011";  -- 571D = FB
      when "101011100011110" =>  data <= "00100000";  -- 571E = 20
      when "101011100011111" =>  data <= "00100010";  -- 571F = 22
      when "101011100100000" =>  data <= "11010111";  -- 5720 = D7
      when "101011100100001" =>  data <= "01101000";  -- 5721 = 68
      when "101011100100010" =>  data <= "01001000";  -- 5722 = 48
      when "101011100100011" =>  data <= "01001010";  -- 5723 = 4A
      when "101011100100100" =>  data <= "01001010";  -- 5724 = 4A
      when "101011100100101" =>  data <= "01001010";  -- 5725 = 4A
      when "101011100100110" =>  data <= "01001010";  -- 5726 = 4A
      when "101011100100111" =>  data <= "00100000";  -- 5727 = 20
      when "101011100101000" =>  data <= "00111010";  -- 5728 = 3A
      when "101011100101001" =>  data <= "11010111";  -- 5729 = D7
      when "101011100101010" =>  data <= "10101010";  -- 572A = AA
      when "101011100101011" =>  data <= "01101000";  -- 572B = 68
      when "101011100101100" =>  data <= "00101001";  -- 572C = 29
      when "101011100101101" =>  data <= "00001111";  -- 572D = F
      when "101011100101110" =>  data <= "00100000";  -- 572E = 20
      when "101011100101111" =>  data <= "00111010";  -- 572F = 3A
      when "101011100110000" =>  data <= "11010111";  -- 5730 = D7
      when "101011100110001" =>  data <= "01001000";  -- 5731 = 48
      when "101011100110010" =>  data <= "10001010";  -- 5732 = 8A
      when "101011100110011" =>  data <= "00100000";  -- 5733 = 20
      when "101011100110100" =>  data <= "01100110";  -- 5734 = 66
      when "101011100110101" =>  data <= "11110010";  -- 5735 = F2
      when "101011100110110" =>  data <= "01101000";  -- 5736 = 68
      when "101011100110111" =>  data <= "01001100";  -- 5737 = 4C
      when "101011100111000" =>  data <= "01100110";  -- 5738 = 66
      when "101011100111001" =>  data <= "11110010";  -- 5739 = F2
      when "101011100111010" =>  data <= "00011000";  -- 573A = 18
      when "101011100111011" =>  data <= "01101001";  -- 573B = 69
      when "101011100111100" =>  data <= "11110110";  -- 573C = F6
      when "101011100111101" =>  data <= "10010000";  -- 573D = 90
      when "101011100111110" =>  data <= "00000010";  -- 573E = 2
      when "101011100111111" =>  data <= "01101001";  -- 573F = 69
      when "101011101000000" =>  data <= "00000110";  -- 5740 = 6
      when "101011101000001" =>  data <= "01101001";  -- 5741 = 69
      when "101011101000010" =>  data <= "00111010";  -- 5742 = 3A
      when "101011101000011" =>  data <= "01100000";  -- 5743 = 60
      when "101011101000100" =>  data <= "10100010";  -- 5744 = A2
      when "101011101000101" =>  data <= "00000010";  -- 5745 = 2
      when "101011101000110" =>  data <= "10110101";  -- 5746 = B5
      when "101011101000111" =>  data <= "11111010";  -- 5747 = FA
      when "101011101001000" =>  data <= "01001000";  -- 5748 = 48
      when "101011101001001" =>  data <= "10110101";  -- 5749 = B5
      when "101011101001010" =>  data <= "11111100";  -- 574A = FC
      when "101011101001011" =>  data <= "10010101";  -- 574B = 95
      when "101011101001100" =>  data <= "11111010";  -- 574C = FA
      when "101011101001101" =>  data <= "01101000";  -- 574D = 68
      when "101011101001110" =>  data <= "10010101";  -- 574E = 95
      when "101011101001111" =>  data <= "11111100";  -- 574F = FC
      when "101011101010000" =>  data <= "11001010";  -- 5750 = CA
      when "101011101010001" =>  data <= "11010000";  -- 5751 = D0
      when "101011101010010" =>  data <= "11110011";  -- 5752 = F3
      when "101011101010011" =>  data <= "01100000";  -- 5753 = 60
      when "101011101010100" =>  data <= "00100000";  -- 5754 = 20
      when "101011101010101" =>  data <= "01100011";  -- 5755 = 63
      when "101011101010110" =>  data <= "11010111";  -- 5756 = D7
      when "101011101010111" =>  data <= "10010000";  -- 5757 = 90
      when "101011101011000" =>  data <= "00000010";  -- 5758 = 2
      when "101011101011001" =>  data <= "10000101";  -- 5759 = 85
      when "101011101011010" =>  data <= "11111100";  -- 575A = FC
      when "101011101011011" =>  data <= "00100000";  -- 575B = 20
      when "101011101011100" =>  data <= "01100011";  -- 575C = 63
      when "101011101011101" =>  data <= "11010111";  -- 575D = D7
      when "101011101011110" =>  data <= "10010000";  -- 575E = 90
      when "101011101011111" =>  data <= "00000010";  -- 575F = 2
      when "101011101100000" =>  data <= "10000101";  -- 5760 = 85
      when "101011101100001" =>  data <= "11111011";  -- 5761 = FB
      when "101011101100010" =>  data <= "01100000";  -- 5762 = 60
      when "101011101100011" =>  data <= "10101001";  -- 5763 = A9
      when "101011101100100" =>  data <= "00000000";  -- 5764 = 0
      when "101011101100101" =>  data <= "10001101";  -- 5765 = 8D
      when "101011101100110" =>  data <= "00000000";  -- 5766 = 0
      when "101011101100111" =>  data <= "00000001";  -- 5767 = 1
      when "101011101101000" =>  data <= "00100000";  -- 5768 = 20
      when "101011101101001" =>  data <= "10011000";  -- 5769 = 98
      when "101011101101010" =>  data <= "11010111";  -- 576A = D7
      when "101011101101011" =>  data <= "11001001";  -- 576B = C9
      when "101011101101100" =>  data <= "00100000";  -- 576C = 20
      when "101011101101101" =>  data <= "11010000";  -- 576D = D0
      when "101011101101110" =>  data <= "00001001";  -- 576E = 9
      when "101011101101111" =>  data <= "00100000";  -- 576F = 20
      when "101011101110000" =>  data <= "10011000";  -- 5770 = 98
      when "101011101110001" =>  data <= "11010111";  -- 5771 = D7
      when "101011101110010" =>  data <= "11001001";  -- 5772 = C9
      when "101011101110011" =>  data <= "00100000";  -- 5773 = 20
      when "101011101110100" =>  data <= "11010000";  -- 5774 = D0
      when "101011101110101" =>  data <= "00001111";  -- 5775 = F
      when "101011101110110" =>  data <= "00011000";  -- 5776 = 18
      when "101011101110111" =>  data <= "01100000";  -- 5777 = 60
      when "101011101111000" =>  data <= "00100000";  -- 5778 = 20
      when "101011101111001" =>  data <= "10001101";  -- 5779 = 8D
      when "101011101111010" =>  data <= "11010111";  -- 577A = D7
      when "101011101111011" =>  data <= "00001010";  -- 577B = A
      when "101011101111100" =>  data <= "00001010";  -- 577C = A
      when "101011101111101" =>  data <= "00001010";  -- 577D = A
      when "101011101111110" =>  data <= "00001010";  -- 577E = A
      when "101011101111111" =>  data <= "10001101";  -- 577F = 8D
      when "101011110000000" =>  data <= "00000000";  -- 5780 = 0
      when "101011110000001" =>  data <= "00000001";  -- 5781 = 1
      when "101011110000010" =>  data <= "00100000";  -- 5782 = 20
      when "101011110000011" =>  data <= "10011000";  -- 5783 = 98
      when "101011110000100" =>  data <= "11010111";  -- 5784 = D7
      when "101011110000101" =>  data <= "00100000";  -- 5785 = 20
      when "101011110000110" =>  data <= "10001101";  -- 5786 = 8D
      when "101011110000111" =>  data <= "11010111";  -- 5787 = D7
      when "101011110001000" =>  data <= "00001101";  -- 5788 = D
      when "101011110001001" =>  data <= "00000000";  -- 5789 = 0
      when "101011110001010" =>  data <= "00000001";  -- 578A = 1
      when "101011110001011" =>  data <= "00111000";  -- 578B = 38
      when "101011110001100" =>  data <= "01100000";  -- 578C = 60
      when "101011110001101" =>  data <= "11001001";  -- 578D = C9
      when "101011110001110" =>  data <= "00111010";  -- 578E = 3A
      when "101011110001111" =>  data <= "00001000";  -- 578F = 8
      when "101011110010000" =>  data <= "00101001";  -- 5790 = 29
      when "101011110010001" =>  data <= "00001111";  -- 5791 = F
      when "101011110010010" =>  data <= "00101000";  -- 5792 = 28
      when "101011110010011" =>  data <= "10010000";  -- 5793 = 90
      when "101011110010100" =>  data <= "00000010";  -- 5794 = 2
      when "101011110010101" =>  data <= "01101001";  -- 5795 = 69
      when "101011110010110" =>  data <= "00001000";  -- 5796 = 8
      when "101011110010111" =>  data <= "01100000";  -- 5797 = 60
      when "101011110011000" =>  data <= "00100000";  -- 5798 = 20
      when "101011110011001" =>  data <= "00010101";  -- 5799 = 15
      when "101011110011010" =>  data <= "11110010";  -- 579A = F2
      when "101011110011011" =>  data <= "11001001";  -- 579B = C9
      when "101011110011100" =>  data <= "00001101";  -- 579C = D
      when "101011110011101" =>  data <= "11010000";  -- 579D = D0
      when "101011110011110" =>  data <= "11111000";  -- 579E = F8
      when "101011110011111" =>  data <= "01101000";  -- 579F = 68
      when "101011110100000" =>  data <= "01101000";  -- 57A0 = 68
      when "101011110100001" =>  data <= "01001100";  -- 57A1 = 4C
      when "101011110100010" =>  data <= "10111010";  -- 57A2 = BA
      when "101011110100011" =>  data <= "11010100";  -- 57A3 = D4
      when "101011110100100" =>  data <= "10101001";  -- 57A4 = A9
      when "101011110100101" =>  data <= "00111111";  -- 57A5 = 3F
      when "101011110100110" =>  data <= "00100000";  -- 57A6 = 20
      when "101011110100111" =>  data <= "01100110";  -- 57A7 = 66
      when "101011110101000" =>  data <= "11110010";  -- 57A8 = F2
      when "101011110101001" =>  data <= "01001100";  -- 57A9 = 4C
      when "101011110101010" =>  data <= "10111010";  -- 57AA = BA
      when "101011110101011" =>  data <= "11010100";  -- 57AB = D4
      when "101011110101100" =>  data <= "01001100";  -- 57AC = 4C
      when "101011110101101" =>  data <= "00000000";  -- 57AD = 0
      when "101011110101110" =>  data <= "10111111";  -- 57AE = BF
      when "101011110101111" =>  data <= "10101001";  -- 57AF = A9
      when "101011110110000" =>  data <= "00000001";  -- 57B0 = 1
      when "101011110110001" =>  data <= "10001101";  -- 57B1 = 8D
      when "101011110110010" =>  data <= "00111010";  -- 57B2 = 3A
      when "101011110110011" =>  data <= "00000011";  -- 57B3 = 3
      when "101011110110100" =>  data <= "00100000";  -- 57B4 = 20
      when "101011110110101" =>  data <= "01110110";  -- 57B5 = 76
      when "101011110110110" =>  data <= "00000000";  -- 57B6 = 0
      when "101011110110111" =>  data <= "10101001";  -- 57B7 = A9
      when "101011110111000" =>  data <= "00100011";  -- 57B8 = 23
      when "101011110111001" =>  data <= "00100000";  -- 57B9 = 20
      when "101011110111010" =>  data <= "11110111";  -- 57BA = F7
      when "101011110111011" =>  data <= "10111110";  -- 57BB = BE
      when "101011110111100" =>  data <= "00100000";  -- 57BC = 20
      when "101011110111101" =>  data <= "10001010";  -- 57BD = 8A
      when "101011110111110" =>  data <= "11011110";  -- 57BE = DE
      when "101011110111111" =>  data <= "11100000";  -- 57BF = E0
      when "101011111000000" =>  data <= "00000000";  -- 57C0 = 0
      when "101011111000001" =>  data <= "11110000";  -- 57C1 = F0
      when "101011111000010" =>  data <= "00111110";  -- 57C2 = 3E
      when "101011111000011" =>  data <= "10000110";  -- 57C3 = 86
      when "101011111000100" =>  data <= "11010010";  -- 57C4 = D2
      when "101011111000101" =>  data <= "00100000";  -- 57C5 = 20
      when "101011111000110" =>  data <= "11110101";  -- 57C6 = F5
      when "101011111000111" =>  data <= "10111110";  -- 57C7 = BE
      when "101011111001000" =>  data <= "11110000";  -- 57C8 = F0
      when "101011111001001" =>  data <= "11100010";  -- 57C9 = E2
      when "101011111001010" =>  data <= "10010000";  -- 57CA = 90
      when "101011111001011" =>  data <= "00001111";  -- 57CB = F
      when "101011111001100" =>  data <= "00100000";  -- 57CC = 20
      when "101011111001101" =>  data <= "11110010";  -- 57CD = F2
      when "101011111001110" =>  data <= "10111110";  -- 57CE = BE
      when "101011111001111" =>  data <= "00100000";  -- 57CF = 20
      when "101011111010000" =>  data <= "10011000";  -- 57D0 = 98
      when "101011111010001" =>  data <= "10111101";  -- 57D1 = BD
      when "101011111010010" =>  data <= "00100000";  -- 57D2 = 20
      when "101011111010011" =>  data <= "00101101";  -- 57D3 = 2D
      when "101011111010100" =>  data <= "11001001";  -- 57D4 = C9
      when "101011111010101" =>  data <= "00100000";  -- 57D5 = 20
      when "101011111010110" =>  data <= "11101111";  -- 57D6 = EF
      when "101011111010111" =>  data <= "10111110";  -- 57D7 = BE
      when "101011111011000" =>  data <= "01001100";  -- 57D8 = 4C
      when "101011111011001" =>  data <= "11100001";  -- 57D9 = E1
      when "101011111011010" =>  data <= "11010111";  -- 57DA = D7
      when "101011111011011" =>  data <= "00100000";  -- 57DB = 20
      when "101011111011100" =>  data <= "10011000";  -- 57DC = 98
      when "101011111011101" =>  data <= "10111101";  -- 57DD = BD
      when "101011111011110" =>  data <= "00100000";  -- 57DE = 20
      when "101011111011111" =>  data <= "00101101";  -- 57DF = 2D
      when "101011111100000" =>  data <= "11001001";  -- 57E0 = C9
      when "101011111100001" =>  data <= "00100000";  -- 57E1 = 20
      when "101011111100010" =>  data <= "01110110";  -- 57E2 = 76
      when "101011111100011" =>  data <= "00000000";  -- 57E3 = 0
      when "101011111100100" =>  data <= "11110000";  -- 57E4 = F0
      when "101011111100101" =>  data <= "00011000";  -- 57E5 = 18
      when "101011111100110" =>  data <= "00100000";  -- 57E6 = 20
      when "101011111100111" =>  data <= "11110101";  -- 57E7 = F5
      when "101011111101000" =>  data <= "10111110";  -- 57E8 = BE
      when "101011111101001" =>  data <= "11110000";  -- 57E9 = F0
      when "101011111101010" =>  data <= "11000001";  -- 57EA = C1
      when "101011111101011" =>  data <= "00100000";  -- 57EB = 20
      when "101011111101100" =>  data <= "10001010";  -- 57EC = 8A
      when "101011111101101" =>  data <= "11011110";  -- 57ED = DE
      when "101011111101110" =>  data <= "11100000";  -- 57EE = E0
      when "101011111101111" =>  data <= "00000000";  -- 57EF = 0
      when "101011111110000" =>  data <= "11110000";  -- 57F0 = F0
      when "101011111110001" =>  data <= "00001111";  -- 57F1 = F
      when "101011111110010" =>  data <= "11100000";  -- 57F2 = E0
      when "101011111110011" =>  data <= "11111111";  -- 57F3 = FF
      when "101011111110100" =>  data <= "11110000";  -- 57F4 = F0
      when "101011111110101" =>  data <= "00001011";  -- 57F5 = B
      when "101011111110110" =>  data <= "10001110";  -- 57F6 = 8E
      when "101011111110111" =>  data <= "00111010";  -- 57F7 = 3A
      when "101011111111000" =>  data <= "00000011";  -- 57F8 = 3
      when "101011111111001" =>  data <= "00100000";  -- 57F9 = 20
      when "101011111111010" =>  data <= "01110110";  -- 57FA = 76
      when "101011111111011" =>  data <= "00000000";  -- 57FB = 0
      when "101011111111100" =>  data <= "11010000";  -- 57FC = D0
      when "101011111111101" =>  data <= "10101110";  -- 57FD = AE
      when "101011111111110" =>  data <= "01001100";  -- 57FE = 4C
      when "101011111111111" =>  data <= "00110001";  -- 57FF = 31
      when "101100000000000" =>  data <= "11011010";  -- 5800 = DA
      when "101100000000001" =>  data <= "01001100";  -- 5801 = 4C
      when "101100000000010" =>  data <= "00100111";  -- 5802 = 27
      when "101100000000011" =>  data <= "11011110";  -- 5803 = DE
      when "101100000000100" =>  data <= "00101001";  -- 5804 = 29
      when "101100000000101" =>  data <= "11100110";  -- 5805 = E6
      when "101100000000110" =>  data <= "11110000";  -- 5806 = F0
      when "101100000000111" =>  data <= "00000011";  -- 5807 = 3
      when "101100000001000" =>  data <= "01001100";  -- 5808 = 4C
      when "101100000001001" =>  data <= "00000000";  -- 5809 = 0
      when "101100000001010" =>  data <= "10111111";  -- 580A = BF
      when "101100000001011" =>  data <= "10101101";  -- 580B = AD
      when "101100000001100" =>  data <= "00111110";  -- 580C = 3E
      when "101100000001101" =>  data <= "00000011";  -- 580D = 3
      when "101100000001110" =>  data <= "00101001";  -- 580E = 29
      when "101100000001111" =>  data <= "00000001";  -- 580F = 1
      when "101100000010000" =>  data <= "11001001";  -- 5810 = C9
      when "101100000010001" =>  data <= "00000001";  -- 5811 = 1
      when "101100000010010" =>  data <= "11010000";  -- 5812 = D0
      when "101100000010011" =>  data <= "11110100";  -- 5813 = F4
      when "101100000010100" =>  data <= "10101101";  -- 5814 = AD
      when "101100000010101" =>  data <= "00111110";  -- 5815 = 3E
      when "101100000010110" =>  data <= "00000011";  -- 5816 = 3
      when "101100000010111" =>  data <= "01100000";  -- 5817 = 60
      when "101100000011000" =>  data <= "00101001";  -- 5818 = 29
      when "101100000011001" =>  data <= "11100111";  -- 5819 = E7
      when "101100000011010" =>  data <= "11010000";  -- 581A = D0
      when "101100000011011" =>  data <= "11101100";  -- 581B = EC
      when "101100000011100" =>  data <= "01100000";  -- 581C = 60
      when "101100000011101" =>  data <= "00101001";  -- 581D = 29
      when "101100000011110" =>  data <= "11000100";  -- 581E = C4
      when "101100000011111" =>  data <= "11010000";  -- 581F = D0
      when "101100000100000" =>  data <= "11100111";  -- 5820 = E7
      when "101100000100001" =>  data <= "10101101";  -- 5821 = AD
      when "101100000100010" =>  data <= "00111110";  -- 5822 = 3E
      when "101100000100011" =>  data <= "00000011";  -- 5823 = 3
      when "101100000100100" =>  data <= "00101001";  -- 5824 = 29
      when "101100000100101" =>  data <= "00000011";  -- 5825 = 3
      when "101100000100110" =>  data <= "11001001";  -- 5826 = C9
      when "101100000100111" =>  data <= "00000011";  -- 5827 = 3
      when "101100000101000" =>  data <= "11010000";  -- 5828 = D0
      when "101100000101001" =>  data <= "11011110";  -- 5829 = DE
      when "101100000101010" =>  data <= "10101101";  -- 582A = AD
      when "101100000101011" =>  data <= "00111110";  -- 582B = 3E
      when "101100000101100" =>  data <= "00000011";  -- 582C = 3
      when "101100000101101" =>  data <= "01100000";  -- 582D = 60
      when "101100000101110" =>  data <= "00101001";  -- 582E = 29
      when "101100000101111" =>  data <= "00000101";  -- 582F = 5
      when "101100000110000" =>  data <= "11001001";  -- 5830 = C9
      when "101100000110001" =>  data <= "00000101";  -- 5831 = 5
      when "101100000110010" =>  data <= "11010000";  -- 5832 = D0
      when "101100000110011" =>  data <= "11010100";  -- 5833 = D4
      when "101100000110100" =>  data <= "10101101";  -- 5834 = AD
      when "101100000110101" =>  data <= "00111110";  -- 5835 = 3E
      when "101100000110110" =>  data <= "00000011";  -- 5836 = 3
      when "101100000110111" =>  data <= "01100000";  -- 5837 = 60
      when "101100000111000" =>  data <= "11111111";  -- 5838 = FF
      when "101100000111001" =>  data <= "00100100";  -- 5839 = 24
      when "101100000111010" =>  data <= "11010001";  -- 583A = D1
      when "101100000111011" =>  data <= "11010001";  -- 583B = D1
      when "101100000111100" =>  data <= "00111010";  -- 583C = 3A
      when "101100000111101" =>  data <= "11110001";  -- 583D = F1
      when "101100000111110" =>  data <= "00101100";  -- 583E = 2C
      when "101100000111111" =>  data <= "11100001";  -- 583F = E1
      when "101100001000000" =>  data <= "00101100";  -- 5840 = 2C
      when "101100001000001" =>  data <= "11100000";  -- 5841 = E0
      when "101100001000010" =>  data <= "11010001";  -- 5842 = D1
      when "101100001000011" =>  data <= "00111010";  -- 5843 = 3A
      when "101100001000100" =>  data <= "11110001";  -- 5844 = F1
      when "101100001000101" =>  data <= "00101100";  -- 5845 = 2C
      when "101100001000110" =>  data <= "01000001";  -- 5846 = 41
      when "101100001000111" =>  data <= "01001110";  -- 5847 = 4E
      when "101100001001000" =>  data <= "11010001";  -- 5848 = D1
      when "101100001001001" =>  data <= "00111010";  -- 5849 = 3A
      when "101100001001010" =>  data <= "11110001";  -- 584A = F1
      when "101100001001011" =>  data <= "00101100";  -- 584B = 2C
      when "101100001001100" =>  data <= "11010000";  -- 584C = D0
      when "101100001001101" =>  data <= "01010110";  -- 584D = 56
      when "101100001001110" =>  data <= "11010001";  -- 584E = D1
      when "101100001001111" =>  data <= "01000100";  -- 584F = 44
      when "101100001010000" =>  data <= "11010010";  -- 5850 = D2
      when "101100001010001" =>  data <= "00111101";  -- 5851 = 3D
      when "101100001010010" =>  data <= "11010001";  -- 5852 = D1
      when "101100001010011" =>  data <= "01000011";  -- 5853 = 43
      when "101100001010100" =>  data <= "11010010";  -- 5854 = D2
      when "101100001010101" =>  data <= "00111010";  -- 5855 = 3A
      when "101100001010110" =>  data <= "11110010";  -- 5856 = F2
      when "101100001010111" =>  data <= "00111101";  -- 5857 = 3D
      when "101100001011000" =>  data <= "11010001";  -- 5858 = D1
      when "101100001011001" =>  data <= "00111010";  -- 5859 = 3A
      when "101100001011010" =>  data <= "11110001";  -- 585A = F1
      when "101100001011011" =>  data <= "01000011";  -- 585B = 43
      when "101100001011100" =>  data <= "11010010";  -- 585C = D2
      when "101100001011101" =>  data <= "00111010";  -- 585D = 3A
      when "101100001011110" =>  data <= "11110010";  -- 585E = F2
      when "101100001011111" =>  data <= "00111101";  -- 585F = 3D
      when "101100001100000" =>  data <= "11010010";  -- 5860 = D2
      when "101100001100001" =>  data <= "00111010";  -- 5861 = 3A
      when "101100001100010" =>  data <= "11110010";  -- 5862 = F2
      when "101100001100011" =>  data <= "00101100";  -- 5863 = 2C
      when "101100001100100" =>  data <= "11010001";  -- 5864 = D1
      when "101100001100101" =>  data <= "00111010";  -- 5865 = 3A
      when "101100001100110" =>  data <= "11110001";  -- 5866 = F1
      when "101100001100111" =>  data <= "01010010";  -- 5867 = 52
      when "101100001101000" =>  data <= "11010001";  -- 5868 = D1
      when "101100001101001" =>  data <= "00111010";  -- 5869 = 3A
      when "101100001101010" =>  data <= "11110010";  -- 586A = F2
      when "101100001101011" =>  data <= "00111101";  -- 586B = 3D
      when "101100001101100" =>  data <= "11010001";  -- 586C = D1
      when "101100001101101" =>  data <= "00111010";  -- 586D = 3A
      when "101100001101110" =>  data <= "11110001";  -- 586E = F1
      when "101100001101111" =>  data <= "01010011";  -- 586F = 53
      when "101100001110000" =>  data <= "11010001";  -- 5870 = D1
      when "101100001110001" =>  data <= "00111010";  -- 5871 = 3A
      when "101100001110010" =>  data <= "11110001";  -- 5872 = F1
      when "101100001110011" =>  data <= "10100101";  -- 5873 = A5
      when "101100001110100" =>  data <= "11010010";  -- 5874 = D2
      when "101100001110101" =>  data <= "10000101";  -- 5875 = 85
      when "101100001110110" =>  data <= "10110011";  -- 5876 = B3
      when "101100001110111" =>  data <= "00100000";  -- 5877 = 20
      when "101100001111000" =>  data <= "01101000";  -- 5878 = 68
      when "101100001111001" =>  data <= "11011100";  -- 5879 = DC
      when "101100001111010" =>  data <= "00100000";  -- 587A = 20
      when "101100001111011" =>  data <= "00011000";  -- 587B = 18
      when "101100001111100" =>  data <= "11011000";  -- 587C = D8
      when "101100001111101" =>  data <= "10100000";  -- 587D = A0
      when "101100001111110" =>  data <= "00000000";  -- 587E = 0
      when "101100001111111" =>  data <= "10100010";  -- 587F = A2
      when "101100010000000" =>  data <= "00000001";  -- 5880 = 1
      when "101100010000001" =>  data <= "10101101";  -- 5881 = AD
      when "101100010000010" =>  data <= "00111110";  -- 5882 = 3E
      when "101100010000011" =>  data <= "00000011";  -- 5883 = 3
      when "101100010000100" =>  data <= "00101001";  -- 5884 = 29
      when "101100010000101" =>  data <= "00010000";  -- 5885 = 10
      when "101100010000110" =>  data <= "11110000";  -- 5886 = F0
      when "101100010000111" =>  data <= "00000001";  -- 5887 = 1
      when "101100010001000" =>  data <= "11101000";  -- 5888 = E8
      when "101100010001001" =>  data <= "10001010";  -- 5889 = 8A
      when "101100010001010" =>  data <= "00100000";  -- 588A = 20
      when "101100010001011" =>  data <= "11111010";  -- 588B = FA
      when "101100010001100" =>  data <= "11011011";  -- 588C = DB
      when "101100010001101" =>  data <= "10100101";  -- 588D = A5
      when "101100010001110" =>  data <= "10110000";  -- 588E = B0
      when "101100010001111" =>  data <= "10000101";  -- 588F = 85
      when "101100010010000" =>  data <= "10111010";  -- 5890 = BA
      when "101100010010001" =>  data <= "10101001";  -- 5891 = A9
      when "101100010010010" =>  data <= "01100000";  -- 5892 = 60
      when "101100010010011" =>  data <= "10000101";  -- 5893 = 85
      when "101100010010100" =>  data <= "11010011";  -- 5894 = D3
      when "101100010010101" =>  data <= "10101001";  -- 5895 = A9
      when "101100010010110" =>  data <= "00001110";  -- 5896 = E
      when "101100010010111" =>  data <= "10000101";  -- 5897 = 85
      when "101100010011000" =>  data <= "11010010";  -- 5898 = D2
      when "101100010011001" =>  data <= "00100000";  -- 5899 = 20
      when "101100010011010" =>  data <= "10111001";  -- 589A = B9
      when "101100010011011" =>  data <= "11110001";  -- 589B = F1
      when "101100010011100" =>  data <= "00100000";  -- 589C = 20
      when "101100010011101" =>  data <= "01100101";  -- 589D = 65
      when "101100010011110" =>  data <= "11110101";  -- 589E = F5
      when "101100010011111" =>  data <= "10101001";  -- 589F = A9
      when "101100010100000" =>  data <= "00000000";  -- 58A0 = 0
      when "101100010100001" =>  data <= "10000101";  -- 58A1 = 85
      when "101100010100010" =>  data <= "10010110";  -- 58A2 = 96
      when "101100010100011" =>  data <= "10100000";  -- 58A3 = A0
      when "101100010100100" =>  data <= "00000011";  -- 58A4 = 3
      when "101100010100101" =>  data <= "10000100";  -- 58A5 = 84
      when "101100010100110" =>  data <= "11010001";  -- 58A6 = D1
      when "101100010100111" =>  data <= "10100010";  -- 58A7 = A2
      when "101100010101000" =>  data <= "00001110";  -- 58A8 = E
      when "101100010101001" =>  data <= "00100000";  -- 58A9 = 20
      when "101100010101010" =>  data <= "10101111";  -- 58AA = AF
      when "101100010101011" =>  data <= "11110111";  -- 58AB = F7
      when "101100010101100" =>  data <= "00100000";  -- 58AC = 20
      when "101100010101101" =>  data <= "00010101";  -- 58AD = 15
      when "101100010101110" =>  data <= "11110010";  -- 58AE = F2
      when "101100010101111" =>  data <= "10000101";  -- 58AF = 85
      when "101100010110000" =>  data <= "11111101";  -- 58B0 = FD
      when "101100010110001" =>  data <= "10100100";  -- 58B1 = A4
      when "101100010110010" =>  data <= "10010110";  -- 58B2 = 96
      when "101100010110011" =>  data <= "11010000";  -- 58B3 = D0
      when "101100010110100" =>  data <= "01011101";  -- 58B4 = 5D
      when "101100010110101" =>  data <= "00100000";  -- 58B5 = 20
      when "101100010110110" =>  data <= "00010101";  -- 58B6 = 15
      when "101100010110111" =>  data <= "11110010";  -- 58B7 = F2
      when "101100010111000" =>  data <= "10000101";  -- 58B8 = 85
      when "101100010111001" =>  data <= "11111110";  -- 58B9 = FE
      when "101100010111010" =>  data <= "10100100";  -- 58BA = A4
      when "101100010111011" =>  data <= "10010110";  -- 58BB = 96
      when "101100010111100" =>  data <= "11010000";  -- 58BC = D0
      when "101100010111101" =>  data <= "01010100";  -- 58BD = 54
      when "101100010111110" =>  data <= "10100100";  -- 58BE = A4
      when "101100010111111" =>  data <= "11010001";  -- 58BF = D1
      when "101100011000000" =>  data <= "10001000";  -- 58C0 = 88
      when "101100011000001" =>  data <= "11010000";  -- 58C1 = D0
      when "101100011000010" =>  data <= "11100010";  -- 58C2 = E2
      when "101100011000011" =>  data <= "00100000";  -- 58C3 = 20
      when "101100011000100" =>  data <= "10100110";  -- 58C4 = A6
      when "101100011000101" =>  data <= "11110010";  -- 58C5 = F2
      when "101100011000110" =>  data <= "00100000";  -- 58C6 = 20
      when "101100011000111" =>  data <= "00100011";  -- 58C7 = 23
      when "101100011001000" =>  data <= "11011001";  -- 58C8 = D9
      when "101100011001001" =>  data <= "10100110";  -- 58C9 = A6
      when "101100011001010" =>  data <= "11111101";  -- 58CA = FD
      when "101100011001011" =>  data <= "10100101";  -- 58CB = A5
      when "101100011001100" =>  data <= "11111110";  -- 58CC = FE
      when "101100011001101" =>  data <= "00100000";  -- 58CD = 20
      when "101100011001110" =>  data <= "10000011";  -- 58CE = 83
      when "101100011001111" =>  data <= "11001111";  -- 58CF = CF
      when "101100011010000" =>  data <= "10101001";  -- 58D0 = A9
      when "101100011010001" =>  data <= "00100000";  -- 58D1 = 20
      when "101100011010010" =>  data <= "00100000";  -- 58D2 = 20
      when "101100011010011" =>  data <= "01100110";  -- 58D3 = 66
      when "101100011010100" =>  data <= "11110010";  -- 58D4 = F2
      when "101100011010101" =>  data <= "00100000";  -- 58D5 = 20
      when "101100011010110" =>  data <= "10100110";  -- 58D6 = A6
      when "101100011010111" =>  data <= "11110010";  -- 58D7 = F2
      when "101100011011000" =>  data <= "10100010";  -- 58D8 = A2
      when "101100011011001" =>  data <= "00001110";  -- 58D9 = E
      when "101100011011010" =>  data <= "00100000";  -- 58DA = 20
      when "101100011011011" =>  data <= "10101111";  -- 58DB = AF
      when "101100011011100" =>  data <= "11110111";  -- 58DC = F7
      when "101100011011101" =>  data <= "00100000";  -- 58DD = 20
      when "101100011011110" =>  data <= "00010101";  -- 58DE = 15
      when "101100011011111" =>  data <= "11110010";  -- 58DF = F2
      when "101100011100000" =>  data <= "01001000";  -- 58E0 = 48
      when "101100011100001" =>  data <= "00100000";  -- 58E1 = 20
      when "101100011100010" =>  data <= "10100110";  -- 58E2 = A6
      when "101100011100011" =>  data <= "11110010";  -- 58E3 = F2
      when "101100011100100" =>  data <= "01101000";  -- 58E4 = 68
      when "101100011100101" =>  data <= "10100110";  -- 58E5 = A6
      when "101100011100110" =>  data <= "10010110";  -- 58E6 = 96
      when "101100011100111" =>  data <= "11010000";  -- 58E7 = D0
      when "101100011101000" =>  data <= "00101001";  -- 58E8 = 29
      when "101100011101001" =>  data <= "11001001";  -- 58E9 = C9
      when "101100011101010" =>  data <= "00000000";  -- 58EA = 0
      when "101100011101011" =>  data <= "11110000";  -- 58EB = F0
      when "101100011101100" =>  data <= "00011000";  -- 58EC = 18
      when "101100011101101" =>  data <= "00100000";  -- 58ED = 20
      when "101100011101110" =>  data <= "00011010";  -- 58EE = 1A
      when "101100011101111" =>  data <= "11011001";  -- 58EF = D9
      when "101100011110000" =>  data <= "00100000";  -- 58F0 = 20
      when "101100011110001" =>  data <= "00110101";  -- 58F1 = 35
      when "101100011110010" =>  data <= "11110011";  -- 58F2 = F3
      when "101100011110011" =>  data <= "11110000";  -- 58F3 = F0
      when "101100011110100" =>  data <= "00011101";  -- 58F4 = 1D
      when "101100011110101" =>  data <= "00100000";  -- 58F5 = 20
      when "101100011110110" =>  data <= "00000101";  -- 58F6 = 5
      when "101100011110111" =>  data <= "11110010";  -- 58F7 = F2
      when "101100011111000" =>  data <= "11110000";  -- 58F8 = F0
      when "101100011111001" =>  data <= "11011110";  -- 58F9 = DE
      when "101100011111010" =>  data <= "11001001";  -- 58FA = C9
      when "101100011111011" =>  data <= "00100000";  -- 58FB = 20
      when "101100011111100" =>  data <= "11010000";  -- 58FC = D0
      when "101100011111101" =>  data <= "11011010";  -- 58FD = DA
      when "101100011111110" =>  data <= "00100000";  -- 58FE = 20
      when "101100011111111" =>  data <= "00000101";  -- 58FF = 5
      when "101100100000000" =>  data <= "11110010";  -- 5900 = F2
      when "101100100000001" =>  data <= "11110000";  -- 5901 = F0
      when "101100100000010" =>  data <= "11111011";  -- 5902 = FB
      when "101100100000011" =>  data <= "11010000";  -- 5903 = D0
      when "101100100000100" =>  data <= "11010011";  -- 5904 = D3
      when "101100100000101" =>  data <= "10101001";  -- 5905 = A9
      when "101100100000110" =>  data <= "00001101";  -- 5906 = D
      when "101100100000111" =>  data <= "00100000";  -- 5907 = 20
      when "101100100001000" =>  data <= "00011010";  -- 5908 = 1A
      when "101100100001001" =>  data <= "11011001";  -- 5909 = D9
      when "101100100001010" =>  data <= "00100000";  -- 590A = 20
      when "101100100001011" =>  data <= "10111001";  -- 590B = B9
      when "101100100001100" =>  data <= "11110001";  -- 590C = F1
      when "101100100001101" =>  data <= "10100000";  -- 590D = A0
      when "101100100001110" =>  data <= "00000010";  -- 590E = 2
      when "101100100001111" =>  data <= "11010000";  -- 590F = D0
      when "101100100010000" =>  data <= "10010100";  -- 5910 = 94
      when "101100100010001" =>  data <= "01101000";  -- 5911 = 68
      when "101100100010010" =>  data <= "00100000";  -- 5912 = 20
      when "101100100010011" =>  data <= "10100110";  -- 5913 = A6
      when "101100100010100" =>  data <= "11110010";  -- 5914 = F2
      when "101100100010101" =>  data <= "10101001";  -- 5915 = A9
      when "101100100010110" =>  data <= "00001110";  -- 5916 = E
      when "101100100010111" =>  data <= "01001100";  -- 5917 = 4C
      when "101100100011000" =>  data <= "11100010";  -- 5918 = E2
      when "101100100011001" =>  data <= "11110010";  -- 5919 = F2
      when "101100100011010" =>  data <= "00100000";  -- 591A = 20
      when "101100100011011" =>  data <= "00100011";  -- 591B = 23
      when "101100100011100" =>  data <= "11011001";  -- 591C = D9
      when "101100100011101" =>  data <= "00100000";  -- 591D = 20
      when "101100100011110" =>  data <= "01100110";  -- 591E = 66
      when "101100100011111" =>  data <= "11110010";  -- 591F = F2
      when "101100100100000" =>  data <= "01001100";  -- 5920 = 4C
      when "101100100100001" =>  data <= "10100110";  -- 5921 = A6
      when "101100100100010" =>  data <= "11110010";  -- 5922 = F2
      when "101100100100011" =>  data <= "10100110";  -- 5923 = A6
      when "101100100100100" =>  data <= "10111010";  -- 5924 = BA
      when "101100100100101" =>  data <= "11100000";  -- 5925 = E0
      when "101100100100110" =>  data <= "00000011";  -- 5926 = 3
      when "101100100100111" =>  data <= "11110000";  -- 5927 = F0
      when "101100100101000" =>  data <= "00000101";  -- 5928 = 5
      when "101100100101001" =>  data <= "10100110";  -- 5929 = A6
      when "101100100101010" =>  data <= "10110011";  -- 592A = B3
      when "101100100101011" =>  data <= "00100000";  -- 592B = 20
      when "101100100101100" =>  data <= "11111110";  -- 592C = FE
      when "101100100101101" =>  data <= "11110111";  -- 592D = F7
      when "101100100101110" =>  data <= "01100000";  -- 592E = 60
      when "101100100101111" =>  data <= "10100000";  -- 592F = A0
      when "101100100110000" =>  data <= "01100001";  -- 5930 = 61
      when "101100100110001" =>  data <= "11001000";  -- 5931 = C8
      when "101100100110010" =>  data <= "10011000";  -- 5932 = 98
      when "101100100110011" =>  data <= "10100110";  -- 5933 = A6
      when "101100100110100" =>  data <= "10101110";  -- 5934 = AE
      when "101100100110101" =>  data <= "11001010";  -- 5935 = CA
      when "101100100110110" =>  data <= "00110000";  -- 5936 = 30
      when "101100100110111" =>  data <= "00000111";  -- 5937 = 7
      when "101100100111000" =>  data <= "11011101";  -- 5938 = DD
      when "101100100111001" =>  data <= "01100101";  -- 5939 = 65
      when "101100100111010" =>  data <= "00000010";  -- 593A = 2
      when "101100100111011" =>  data <= "11110000";  -- 593B = F0
      when "101100100111100" =>  data <= "11110100";  -- 593C = F4
      when "101100100111101" =>  data <= "11010000";  -- 593D = D0
      when "101100100111110" =>  data <= "11110110";  -- 593E = F6
      when "101100100111111" =>  data <= "10000100";  -- 593F = 84
      when "101100101000000" =>  data <= "11010011";  -- 5940 = D3
      when "101100101000001" =>  data <= "01100000";  -- 5941 = 60
      when "101100101000010" =>  data <= "00100000";  -- 5942 = 20
      when "101100101000011" =>  data <= "01101000";  -- 5943 = 68
      when "101100101000100" =>  data <= "11011100";  -- 5944 = DC
      when "101100101000101" =>  data <= "00100000";  -- 5945 = 20
      when "101100101000110" =>  data <= "00101110";  -- 5946 = 2E
      when "101100101000111" =>  data <= "11011000";  -- 5947 = D8
      when "101100101001000" =>  data <= "00101001";  -- 5948 = 29
      when "101100101001001" =>  data <= "00100010";  -- 5949 = 22
      when "101100101001010" =>  data <= "11110000";  -- 594A = F0
      when "101100101001011" =>  data <= "00000011";  -- 594B = 3
      when "101100101001100" =>  data <= "01001100";  -- 594C = 4C
      when "101100101001101" =>  data <= "00000000";  -- 594D = 0
      when "101100101001110" =>  data <= "10111111";  -- 594E = BF
      when "101100101001111" =>  data <= "00100000";  -- 594F = 20
      when "101100101010000" =>  data <= "00101111";  -- 5950 = 2F
      when "101100101010001" =>  data <= "11011001";  -- 5951 = D9
      when "101100101010010" =>  data <= "10100000";  -- 5952 = A0
      when "101100101010011" =>  data <= "00000010";  -- 5953 = 2
      when "101100101010100" =>  data <= "10100010";  -- 5954 = A2
      when "101100101010101" =>  data <= "00000011";  -- 5955 = 3
      when "101100101010110" =>  data <= "00101100";  -- 5956 = 2C
      when "101100101010111" =>  data <= "00111110";  -- 5957 = 3E
      when "101100101011000" =>  data <= "00000011";  -- 5958 = 3
      when "101100101011001" =>  data <= "01010000";  -- 5959 = 50
      when "101100101011010" =>  data <= "00000010";  -- 595A = 2
      when "101100101011011" =>  data <= "10100010";  -- 595B = A2
      when "101100101011100" =>  data <= "00000111";  -- 595C = 7
      when "101100101011101" =>  data <= "00101100";  -- 595D = 2C
      when "101100101011110" =>  data <= "00111110";  -- 595E = 3E
      when "101100101011111" =>  data <= "00000011";  -- 595F = 3
      when "101100101100000" =>  data <= "00010000";  -- 5960 = 10
      when "101100101100001" =>  data <= "00001110";  -- 5961 = E
      when "101100101100010" =>  data <= "10101001";  -- 5962 = A9
      when "101100101100011" =>  data <= "01000000";  -- 5963 = 40
      when "101100101100100" =>  data <= "10001101";  -- 5964 = 8D
      when "101100101100101" =>  data <= "01010011";  -- 5965 = 53
      when "101100101100110" =>  data <= "00000011";  -- 5966 = 3
      when "101100101100111" =>  data <= "10001010";  -- 5967 = 8A
      when "101100101101000" =>  data <= "10100010";  -- 5968 = A2
      when "101100101101001" =>  data <= "00000001";  -- 5969 = 1
      when "101100101101010" =>  data <= "00100000";  -- 596A = 20
      when "101100101101011" =>  data <= "11111100";  -- 596B = FC
      when "101100101101100" =>  data <= "11011011";  -- 596C = DB
      when "101100101101101" =>  data <= "01001100";  -- 596D = 4C
      when "101100101101110" =>  data <= "01100011";  -- 596E = 63
      when "101100101101111" =>  data <= "11110101";  -- 596F = F5
      when "101100101110000" =>  data <= "10001010";  -- 5970 = 8A
      when "101100101110001" =>  data <= "00100000";  -- 5971 = 20
      when "101100101110010" =>  data <= "11111010";  -- 5972 = FA
      when "101100101110011" =>  data <= "11011011";  -- 5973 = DB
      when "101100101110100" =>  data <= "01001100";  -- 5974 = 4C
      when "101100101110101" =>  data <= "01100011";  -- 5975 = 63
      when "101100101110110" =>  data <= "11110101";  -- 5976 = F5
      when "101100101110111" =>  data <= "00100000";  -- 5977 = 20
      when "101100101111000" =>  data <= "01101000";  -- 5978 = 68
      when "101100101111001" =>  data <= "11011100";  -- 5979 = DC
      when "101100101111010" =>  data <= "00100000";  -- 597A = 20
      when "101100101111011" =>  data <= "00101110";  -- 597B = 2E
      when "101100101111100" =>  data <= "11011000";  -- 597C = D8
      when "101100101111101" =>  data <= "00101001";  -- 597D = 29
      when "101100101111110" =>  data <= "11100010";  -- 597E = E2
      when "101100101111111" =>  data <= "11110000";  -- 597F = F0
      when "101100110000000" =>  data <= "00000011";  -- 5980 = 3
      when "101100110000001" =>  data <= "01001100";  -- 5981 = 4C
      when "101100110000010" =>  data <= "00000000";  -- 5982 = 0
      when "101100110000011" =>  data <= "10111111";  -- 5983 = BF
      when "101100110000100" =>  data <= "00100000";  -- 5984 = 20
      when "101100110000101" =>  data <= "00101111";  -- 5985 = 2F
      when "101100110000110" =>  data <= "11011001";  -- 5986 = D9
      when "101100110000111" =>  data <= "10100000";  -- 5987 = A0
      when "101100110001000" =>  data <= "00001001";  -- 5988 = 9
      when "101100110001001" =>  data <= "10101001";  -- 5989 = A9
      when "101100110001010" =>  data <= "00000101";  -- 598A = 5
      when "101100110001011" =>  data <= "00100000";  -- 598B = 20
      when "101100110001100" =>  data <= "11111010";  -- 598C = FA
      when "101100110001101" =>  data <= "11011011";  -- 598D = DB
      when "101100110001110" =>  data <= "01001100";  -- 598E = 4C
      when "101100110001111" =>  data <= "01100011";  -- 598F = 63
      when "101100110010000" =>  data <= "11110101";  -- 5990 = F5
      when "101100110010001" =>  data <= "10100101";  -- 5991 = A5
      when "101100110010010" =>  data <= "00001101";  -- 5992 = D
      when "101100110010011" =>  data <= "11010000";  -- 5993 = D0
      when "101100110010100" =>  data <= "00010110";  -- 5994 = 16
      when "101100110010101" =>  data <= "10101001";  -- 5995 = A9
      when "101100110010110" =>  data <= "00101000";  -- 5996 = 28
      when "101100110010111" =>  data <= "10000101";  -- 5997 = 85
      when "101100110011000" =>  data <= "00001101";  -- 5998 = D
      when "101100110011001" =>  data <= "00100000";  -- 5999 = 20
      when "101100110011010" =>  data <= "00011101";  -- 599A = 1D
      when "101100110011011" =>  data <= "11000110";  -- 599B = C6
      when "101100110011100" =>  data <= "10000110";  -- 599C = 86
      when "101100110011101" =>  data <= "00001110";  -- 599D = E
      when "101100110011110" =>  data <= "10000100";  -- 599E = 84
      when "101100110011111" =>  data <= "00001111";  -- 599F = F
      when "101100110100000" =>  data <= "10101001";  -- 59A0 = A9
      when "101100110100001" =>  data <= "00000000";  -- 59A1 = 0
      when "101100110100010" =>  data <= "10100000";  -- 59A2 = A0
      when "101100110100011" =>  data <= "00101001";  -- 59A3 = 29
      when "101100110100100" =>  data <= "00100000";  -- 59A4 = 20
      when "101100110100101" =>  data <= "10011110";  -- 59A5 = 9E
      when "101100110100110" =>  data <= "11011110";  -- 59A6 = DE
      when "101100110100111" =>  data <= "10101001";  -- 59A7 = A9
      when "101100110101000" =>  data <= "00001101";  -- 59A8 = D
      when "101100110101001" =>  data <= "10010001";  -- 59A9 = 91
      when "101100110101010" =>  data <= "00001110";  -- 59AA = E
      when "101100110101011" =>  data <= "10100101";  -- 59AB = A5
      when "101100110101100" =>  data <= "11010100";  -- 59AC = D4
      when "101100110101101" =>  data <= "11010000";  -- 59AD = D0
      when "101100110101110" =>  data <= "00000100";  -- 59AE = 4
      when "101100110101111" =>  data <= "10101001";  -- 59AF = A9
      when "101100110110000" =>  data <= "00001000";  -- 59B0 = 8
      when "101100110110001" =>  data <= "10000101";  -- 59B1 = 85
      when "101100110110010" =>  data <= "11010100";  -- 59B2 = D4
      when "101100110110011" =>  data <= "00100000";  -- 59B3 = 20
      when "101100110110100" =>  data <= "11010010";  -- 59B4 = D2
      when "101100110110101" =>  data <= "11110000";  -- 59B5 = F0
      when "101100110110110" =>  data <= "10101001";  -- 59B6 = A9
      when "101100110110111" =>  data <= "01101111";  -- 59B7 = 6F
      when "101100110111000" =>  data <= "10000101";  -- 59B8 = 85
      when "101100110111001" =>  data <= "11010011";  -- 59B9 = D3
      when "101100110111010" =>  data <= "00100000";  -- 59BA = 20
      when "101100110111011" =>  data <= "10010011";  -- 59BB = 93
      when "101100110111100" =>  data <= "11110001";  -- 59BC = F1
      when "101100110111101" =>  data <= "10100000";  -- 59BD = A0
      when "101100110111110" =>  data <= "11111111";  -- 59BE = FF
      when "101100110111111" =>  data <= "11001000";  -- 59BF = C8
      when "101100111000000" =>  data <= "00100000";  -- 59C0 = 20
      when "101100111000001" =>  data <= "11000000";  -- 59C1 = C0
      when "101100111000010" =>  data <= "11110001";  -- 59C2 = F1
      when "101100111000011" =>  data <= "11001001";  -- 59C3 = C9
      when "101100111000100" =>  data <= "00001101";  -- 59C4 = D
      when "101100111000101" =>  data <= "11110000";  -- 59C5 = F0
      when "101100111000110" =>  data <= "00000100";  -- 59C6 = 4
      when "101100111000111" =>  data <= "10010001";  -- 59C7 = 91
      when "101100111001000" =>  data <= "00001110";  -- 59C8 = E
      when "101100111001001" =>  data <= "11010000";  -- 59C9 = D0
      when "101100111001010" =>  data <= "11110100";  -- 59CA = F4
      when "101100111001011" =>  data <= "10101001";  -- 59CB = A9
      when "101100111001100" =>  data <= "00000000";  -- 59CC = 0
      when "101100111001101" =>  data <= "10010001";  -- 59CD = 91
      when "101100111001110" =>  data <= "00001110";  -- 59CE = E
      when "101100111001111" =>  data <= "01001100";  -- 59CF = 4C
      when "101100111010000" =>  data <= "10101110";  -- 59D0 = AE
      when "101100111010001" =>  data <= "11110001";  -- 59D1 = F1
      when "101100111010010" =>  data <= "00100000";  -- 59D2 = 20
      when "101100111010011" =>  data <= "01101000";  -- 59D3 = 68
      when "101100111010100" =>  data <= "11011100";  -- 59D4 = DC
      when "101100111010101" =>  data <= "00100000";  -- 59D5 = 20
      when "101100111010110" =>  data <= "00000100";  -- 59D6 = 4
      when "101100111010111" =>  data <= "11011000";  -- 59D7 = D8
      when "101100111011000" =>  data <= "00101001";  -- 59D8 = 29
      when "101100111011001" =>  data <= "00010001";  -- 59D9 = 11
      when "101100111011010" =>  data <= "11001001";  -- 59DA = C9
      when "101100111011011" =>  data <= "00010001";  -- 59DB = 11
      when "101100111011100" =>  data <= "11110000";  -- 59DC = F0
      when "101100111011101" =>  data <= "00000011";  -- 59DD = 3
      when "101100111011110" =>  data <= "01001100";  -- 59DE = 4C
      when "101100111011111" =>  data <= "00000000";  -- 59DF = 0
      when "101100111100000" =>  data <= "10111111";  -- 59E0 = BF
      when "101100111100001" =>  data <= "00100000";  -- 59E1 = 20
      when "101100111100010" =>  data <= "00011011";  -- 59E2 = 1B
      when "101100111100011" =>  data <= "11011010";  -- 59E3 = DA
      when "101100111100100" =>  data <= "00100000";  -- 59E4 = 20
      when "101100111100101" =>  data <= "10011110";  -- 59E5 = 9E
      when "101100111100110" =>  data <= "11011011";  -- 59E6 = DB
      when "101100111100111" =>  data <= "10010000";  -- 59E7 = 90
      when "101100111101000" =>  data <= "00000001";  -- 59E8 = 1
      when "101100111101001" =>  data <= "01100000";  -- 59E9 = 60
      when "101100111101010" =>  data <= "10100000";  -- 59EA = A0
      when "101100111101011" =>  data <= "00001110";  -- 59EB = E
      when "101100111101100" =>  data <= "10101001";  -- 59EC = A9
      when "101100111101101" =>  data <= "00000100";  -- 59ED = 4
      when "101100111101110" =>  data <= "10101110";  -- 59EE = AE
      when "101100111101111" =>  data <= "00111111";  -- 59EF = 3F
      when "101100111110000" =>  data <= "00000011";  -- 59F0 = 3
      when "101100111110001" =>  data <= "11110000";  -- 59F1 = F0
      when "101100111110010" =>  data <= "00000010";  -- 59F2 = 2
      when "101100111110011" =>  data <= "10101001";  -- 59F3 = A9
      when "101100111110100" =>  data <= "00000110";  -- 59F4 = 6
      when "101100111110101" =>  data <= "00100000";  -- 59F5 = 20
      when "101100111110110" =>  data <= "10011000";  -- 59F6 = 98
      when "101100111110111" =>  data <= "11011010";  -- 59F7 = DA
      when "101100111111000" =>  data <= "00100000";  -- 59F8 = 20
      when "101100111111001" =>  data <= "10010001";  -- 59F9 = 91
      when "101100111111010" =>  data <= "11011001";  -- 59FA = D9
      when "101100111111011" =>  data <= "10100000";  -- 59FB = A0
      when "101100111111100" =>  data <= "00000000";  -- 59FC = 0
      when "101100111111101" =>  data <= "10110001";  -- 59FD = B1
      when "101100111111110" =>  data <= "00001110";  -- 59FE = E
      when "101100111111111" =>  data <= "11001001";  -- 59FF = C9
      when "101101000000000" =>  data <= "00110010";  -- 5A00 = 32
      when "101101000000001" =>  data <= "10110000";  -- 5A01 = B0
      when "101101000000010" =>  data <= "00000001";  -- 5A02 = 1
      when "101101000000011" =>  data <= "01100000";  -- 5A03 = 60
      when "101101000000100" =>  data <= "01001100";  -- 5A04 = 4C
      when "101101000000101" =>  data <= "11010111";  -- 5A05 = D7
      when "101101000000110" =>  data <= "11011011";  -- 5A06 = DB
      when "101101000000111" =>  data <= "00100000";  -- 5A07 = 20
      when "101101000001000" =>  data <= "01101000";  -- 5A08 = 68
      when "101101000001001" =>  data <= "11011100";  -- 5A09 = DC
      when "101101000001010" =>  data <= "00101001";  -- 5A0A = 29
      when "101101000001011" =>  data <= "11110011";  -- 5A0B = F3
      when "101101000001100" =>  data <= "11110000";  -- 5A0C = F0
      when "101101000001101" =>  data <= "00000011";  -- 5A0D = 3
      when "101101000001110" =>  data <= "01001100";  -- 5A0E = 4C
      when "101101000001111" =>  data <= "00000000";  -- 5A0F = 0
      when "101101000010000" =>  data <= "10111111";  -- 5A10 = BF
      when "101101000010001" =>  data <= "00100000";  -- 5A11 = 20
      when "101101000010010" =>  data <= "11100001";  -- 5A12 = E1
      when "101101000010011" =>  data <= "11011011";  -- 5A13 = DB
      when "101101000010100" =>  data <= "10100101";  -- 5A14 = A5
      when "101101000010101" =>  data <= "11010010";  -- 5A15 = D2
      when "101101000010110" =>  data <= "11110000";  -- 5A16 = F0
      when "101101000010111" =>  data <= "00000011";  -- 5A17 = 3
      when "101101000011000" =>  data <= "01001100";  -- 5A18 = 4C
      when "101101000011001" =>  data <= "11100010";  -- 5A19 = E2
      when "101101000011010" =>  data <= "11110010";  -- 5A1A = F2
      when "101101000011011" =>  data <= "10100101";  -- 5A1B = A5
      when "101101000011100" =>  data <= "11010100";  -- 5A1C = D4
      when "101101000011101" =>  data <= "10100110";  -- 5A1D = A6
      when "101101000011110" =>  data <= "10101110";  -- 5A1E = AE
      when "101101000011111" =>  data <= "11001010";  -- 5A1F = CA
      when "101101000100000" =>  data <= "00110000";  -- 5A20 = 30
      when "101101000100001" =>  data <= "00001110";  -- 5A21 = E
      when "101101000100010" =>  data <= "11011101";  -- 5A22 = DD
      when "101101000100011" =>  data <= "01011011";  -- 5A23 = 5B
      when "101101000100100" =>  data <= "00000010";  -- 5A24 = 2
      when "101101000100101" =>  data <= "11010000";  -- 5A25 = D0
      when "101101000100110" =>  data <= "11111000";  -- 5A26 = F8
      when "101101000100111" =>  data <= "10111101";  -- 5A27 = BD
      when "101101000101000" =>  data <= "01010001";  -- 5A28 = 51
      when "101101000101001" =>  data <= "00000010";  -- 5A29 = 2
      when "101101000101010" =>  data <= "00100000";  -- 5A2A = 20
      when "101101000101011" =>  data <= "11100111";  -- 5A2B = E7
      when "101101000101100" =>  data <= "11110010";  -- 5A2C = F2
      when "101101000101101" =>  data <= "10111000";  -- 5A2D = B8
      when "101101000101110" =>  data <= "01010000";  -- 5A2E = 50
      when "101101000101111" =>  data <= "11101011";  -- 5A2F = EB
      when "101101000110000" =>  data <= "01100000";  -- 5A30 = 60
      when "101101000110001" =>  data <= "10100101";  -- 5A31 = A5
      when "101101000110010" =>  data <= "11010010";  -- 5A32 = D2
      when "101101000110011" =>  data <= "00100000";  -- 5A33 = 20
      when "101101000110100" =>  data <= "11000001";  -- 5A34 = C1
      when "101101000110101" =>  data <= "11110010";  -- 5A35 = F2
      when "101101000110110" =>  data <= "11110000";  -- 5A36 = F0
      when "101101000110111" =>  data <= "00000101";  -- 5A37 = 5
      when "101101000111000" =>  data <= "10100000";  -- 5A38 = A0
      when "101101000111001" =>  data <= "00010111";  -- 5A39 = 17
      when "101101000111010" =>  data <= "01001100";  -- 5A3A = 4C
      when "101101000111011" =>  data <= "10101111";  -- 5A3B = AF
      when "101101000111100" =>  data <= "11110101";  -- 5A3C = F5
      when "101101000111101" =>  data <= "00100000";  -- 5A3D = 20
      when "101101000111110" =>  data <= "11001101";  -- 5A3E = CD
      when "101101000111111" =>  data <= "11110010";  -- 5A3F = F2
      when "101101001000000" =>  data <= "00100000";  -- 5A40 = 20
      when "101101001000001" =>  data <= "11100001";  -- 5A41 = E1
      when "101101001000010" =>  data <= "11011011";  -- 5A42 = DB
      when "101101001000011" =>  data <= "10101001";  -- 5A43 = A9
      when "101101001000100" =>  data <= "01010000";  -- 5A44 = 50
      when "101101001000101" =>  data <= "10001101";  -- 5A45 = 8D
      when "101101001000110" =>  data <= "01010011";  -- 5A46 = 53
      when "101101001000111" =>  data <= "00000011";  -- 5A47 = 3
      when "101101001001000" =>  data <= "10100101";  -- 5A48 = A5
      when "101101001001001" =>  data <= "11010011";  -- 5A49 = D3
      when "101101001001010" =>  data <= "10001101";  -- 5A4A = 8D
      when "101101001001011" =>  data <= "01010100";  -- 5A4B = 54
      when "101101001001100" =>  data <= "00000011";  -- 5A4C = 3
      when "101101001001101" =>  data <= "10100101";  -- 5A4D = A5
      when "101101001001110" =>  data <= "00010001";  -- 5A4E = 11
      when "101101001001111" =>  data <= "10001101";  -- 5A4F = 8D
      when "101101001010000" =>  data <= "01010101";  -- 5A50 = 55
      when "101101001010001" =>  data <= "00000011";  -- 5A51 = 3
      when "101101001010010" =>  data <= "10100101";  -- 5A52 = A5
      when "101101001010011" =>  data <= "00010010";  -- 5A53 = 12
      when "101101001010100" =>  data <= "10001101";  -- 5A54 = 8D
      when "101101001010101" =>  data <= "01010110";  -- 5A55 = 56
      when "101101001010110" =>  data <= "00000011";  -- 5A56 = 3
      when "101101001010111" =>  data <= "10101101";  -- 5A57 = AD
      when "101101001011000" =>  data <= "00111010";  -- 5A58 = 3A
      when "101101001011001" =>  data <= "00000011";  -- 5A59 = 3
      when "101101001011010" =>  data <= "10001101";  -- 5A5A = 8D
      when "101101001011011" =>  data <= "01010111";  -- 5A5B = 57
      when "101101001011100" =>  data <= "00000011";  -- 5A5C = 3
      when "101101001011101" =>  data <= "10100010";  -- 5A5D = A2
      when "101101001011110" =>  data <= "00000101";  -- 5A5E = 5
      when "101101001011111" =>  data <= "00100000";  -- 5A5F = 20
      when "101101001100000" =>  data <= "01001100";  -- 5A60 = 4C
      when "101101001100001" =>  data <= "11011100";  -- 5A61 = DC
      when "101101001100010" =>  data <= "01001100";  -- 5A62 = 4C
      when "101101001100011" =>  data <= "10011011";  -- 5A63 = 9B
      when "101101001100100" =>  data <= "11011010";  -- 5A64 = DA
      when "101101001100101" =>  data <= "00100000";  -- 5A65 = 20
      when "101101001100110" =>  data <= "01101000";  -- 5A66 = 68
      when "101101001100111" =>  data <= "11011100";  -- 5A67 = DC
      when "101101001101000" =>  data <= "00100000";  -- 5A68 = 20
      when "101101001101001" =>  data <= "00011000";  -- 5A69 = 18
      when "101101001101010" =>  data <= "11011000";  -- 5A6A = D8
      when "101101001101011" =>  data <= "00100000";  -- 5A6B = 20
      when "101101001101100" =>  data <= "00011011";  -- 5A6C = 1B
      when "101101001101101" =>  data <= "11011010";  -- 5A6D = DA
      when "101101001101110" =>  data <= "10100000";  -- 5A6E = A0
      when "101101001101111" =>  data <= "00010100";  -- 5A6F = 14
      when "101101001110000" =>  data <= "10100010";  -- 5A70 = A2
      when "101101001110001" =>  data <= "00000001";  -- 5A71 = 1
      when "101101001110010" =>  data <= "10101101";  -- 5A72 = AD
      when "101101001110011" =>  data <= "00111110";  -- 5A73 = 3E
      when "101101001110100" =>  data <= "00000011";  -- 5A74 = 3
      when "101101001110101" =>  data <= "00101001";  -- 5A75 = 29
      when "101101001110110" =>  data <= "00010000";  -- 5A76 = 10
      when "101101001110111" =>  data <= "11110000";  -- 5A77 = F0
      when "101101001111000" =>  data <= "00000001";  -- 5A78 = 1
      when "101101001111001" =>  data <= "11101000";  -- 5A79 = E8
      when "101101001111010" =>  data <= "10001010";  -- 5A7A = 8A
      when "101101001111011" =>  data <= "01001100";  -- 5A7B = 4C
      when "101101001111100" =>  data <= "10011000";  -- 5A7C = 98
      when "101101001111101" =>  data <= "11011010";  -- 5A7D = DA
      when "101101001111110" =>  data <= "00100000";  -- 5A7E = 20
      when "101101001111111" =>  data <= "01101000";  -- 5A7F = 68
      when "101101010000000" =>  data <= "11011100";  -- 5A80 = DC
      when "101101010000001" =>  data <= "00101001";  -- 5A81 = 29
      when "101101010000010" =>  data <= "00110000";  -- 5A82 = 30
      when "101101010000011" =>  data <= "11001001";  -- 5A83 = C9
      when "101101010000100" =>  data <= "00110000";  -- 5A84 = 30
      when "101101010000101" =>  data <= "11110000";  -- 5A85 = F0
      when "101101010000110" =>  data <= "00000011";  -- 5A86 = 3
      when "101101010000111" =>  data <= "01001100";  -- 5A87 = 4C
      when "101101010001000" =>  data <= "00000000";  -- 5A88 = 0
      when "101101010001001" =>  data <= "10111111";  -- 5A89 = BF
      when "101101010001010" =>  data <= "10101101";  -- 5A8A = AD
      when "101101010001011" =>  data <= "00111110";  -- 5A8B = 3E
      when "101101010001100" =>  data <= "00000011";  -- 5A8C = 3
      when "101101010001101" =>  data <= "00101001";  -- 5A8D = 29
      when "101101010001110" =>  data <= "11000111";  -- 5A8E = C7
      when "101101010001111" =>  data <= "11010000";  -- 5A8F = D0
      when "101101010010000" =>  data <= "11110110";  -- 5A90 = F6
      when "101101010010001" =>  data <= "00100000";  -- 5A91 = 20
      when "101101010010010" =>  data <= "00011011";  -- 5A92 = 1B
      when "101101010010011" =>  data <= "11011010";  -- 5A93 = DA
      when "101101010010100" =>  data <= "10100000";  -- 5A94 = A0
      when "101101010010101" =>  data <= "00010110";  -- 5A95 = 16
      when "101101010010110" =>  data <= "10101001";  -- 5A96 = A9
      when "101101010010111" =>  data <= "00000100";  -- 5A97 = 4
      when "101101010011000" =>  data <= "00100000";  -- 5A98 = 20
      when "101101010011001" =>  data <= "11111010";  -- 5A99 = FA
      when "101101010011010" =>  data <= "11011011";  -- 5A9A = DB
      when "101101010011011" =>  data <= "10101001";  -- 5A9B = A9
      when "101101010011100" =>  data <= "01101111";  -- 5A9C = 6F
      when "101101010011101" =>  data <= "10000101";  -- 5A9D = 85
      when "101101010011110" =>  data <= "11010011";  -- 5A9E = D3
      when "101101010011111" =>  data <= "00100000";  -- 5A9F = 20
      when "101101010100000" =>  data <= "11010101";  -- 5AA0 = D5
      when "101101010100001" =>  data <= "11110000";  -- 5AA1 = F0
      when "101101010100010" =>  data <= "10100101";  -- 5AA2 = A5
      when "101101010100011" =>  data <= "11010011";  -- 5AA3 = D3
      when "101101010100100" =>  data <= "01001100";  -- 5AA4 = 4C
      when "101101010100101" =>  data <= "10110100";  -- 5AA5 = B4
      when "101101010100110" =>  data <= "11110100";  -- 5AA6 = F4
      when "101101010100111" =>  data <= "00100000";  -- 5AA7 = 20
      when "101101010101000" =>  data <= "01101000";  -- 5AA8 = 68
      when "101101010101001" =>  data <= "11011100";  -- 5AA9 = DC
      when "101101010101010" =>  data <= "00101001";  -- 5AAA = 29
      when "101101010101011" =>  data <= "00110000";  -- 5AAB = 30
      when "101101010101100" =>  data <= "11001001";  -- 5AAC = C9
      when "101101010101101" =>  data <= "00110000";  -- 5AAD = 30
      when "101101010101110" =>  data <= "11010000";  -- 5AAE = D0
      when "101101010101111" =>  data <= "00000111";  -- 5AAF = 7
      when "101101010110000" =>  data <= "10101101";  -- 5AB0 = AD
      when "101101010110001" =>  data <= "00111110";  -- 5AB1 = 3E
      when "101101010110010" =>  data <= "00000011";  -- 5AB2 = 3
      when "101101010110011" =>  data <= "00101001";  -- 5AB3 = 29
      when "101101010110100" =>  data <= "11000111";  -- 5AB4 = C7
      when "101101010110101" =>  data <= "11110000";  -- 5AB5 = F0
      when "101101010110110" =>  data <= "00001001";  -- 5AB6 = 9
      when "101101010110111" =>  data <= "10101101";  -- 5AB7 = AD
      when "101101010111000" =>  data <= "00111110";  -- 5AB8 = 3E
      when "101101010111001" =>  data <= "00000011";  -- 5AB9 = 3
      when "101101010111010" =>  data <= "00100000";  -- 5ABA = 20
      when "101101010111011" =>  data <= "00011101";  -- 5ABB = 1D
      when "101101010111100" =>  data <= "11011000";  -- 5ABC = D8
      when "101101010111101" =>  data <= "10101101";  -- 5ABD = AD
      when "101101010111110" =>  data <= "00111110";  -- 5ABE = 3E
      when "101101010111111" =>  data <= "00000011";  -- 5ABF = 3
      when "101101011000000" =>  data <= "10100000";  -- 5AC0 = A0
      when "101101011000001" =>  data <= "00011010";  -- 5AC1 = 1A
      when "101101011000010" =>  data <= "10101001";  -- 5AC2 = A9
      when "101101011000011" =>  data <= "00001000";  -- 5AC3 = 8
      when "101101011000100" =>  data <= "01001100";  -- 5AC4 = 4C
      when "101101011000101" =>  data <= "10011000";  -- 5AC5 = 98
      when "101101011000110" =>  data <= "11011010";  -- 5AC6 = DA
      when "101101011000111" =>  data <= "00100000";  -- 5AC7 = 20
      when "101101011001000" =>  data <= "01101000";  -- 5AC8 = 68
      when "101101011001001" =>  data <= "11011100";  -- 5AC9 = DC
      when "101101011001010" =>  data <= "00100000";  -- 5ACA = 20
      when "101101011001011" =>  data <= "00011101";  -- 5ACB = 1D
      when "101101011001100" =>  data <= "11011000";  -- 5ACC = D8
      when "101101011001101" =>  data <= "10100000";  -- 5ACD = A0
      when "101101011001110" =>  data <= "00100010";  -- 5ACE = 22
      when "101101011001111" =>  data <= "10101001";  -- 5ACF = A9
      when "101101011010000" =>  data <= "00001100";  -- 5AD0 = C
      when "101101011010001" =>  data <= "01001100";  -- 5AD1 = 4C
      when "101101011010010" =>  data <= "10011000";  -- 5AD2 = 98
      when "101101011010011" =>  data <= "11011010";  -- 5AD3 = DA
      when "101101011010100" =>  data <= "10100101";  -- 5AD4 = A5
      when "101101011010101" =>  data <= "11010001";  -- 5AD5 = D1
      when "101101011010110" =>  data <= "10001101";  -- 5AD6 = 8D
      when "101101011010111" =>  data <= "00111010";  -- 5AD7 = 3A
      when "101101011011000" =>  data <= "00000011";  -- 5AD8 = 3
      when "101101011011001" =>  data <= "10100101";  -- 5AD9 = A5
      when "101101011011010" =>  data <= "11011010";  -- 5ADA = DA
      when "101101011011011" =>  data <= "10000101";  -- 5ADB = 85
      when "101101011011100" =>  data <= "11111101";  -- 5ADC = FD
      when "101101011011101" =>  data <= "10100101";  -- 5ADD = A5
      when "101101011011110" =>  data <= "11011011";  -- 5ADE = DB
      when "101101011011111" =>  data <= "10000101";  -- 5ADF = 85
      when "101101011100000" =>  data <= "11111110";  -- 5AE0 = FE
      when "101101011100001" =>  data <= "10011000";  -- 5AE1 = 98
      when "101101011100010" =>  data <= "01001000";  -- 5AE2 = 48
      when "101101011100011" =>  data <= "10101100";  -- 5AE3 = AC
      when "101101011100100" =>  data <= "00111010";  -- 5AE4 = 3A
      when "101101011100101" =>  data <= "00000011";  -- 5AE5 = 3
      when "101101011100110" =>  data <= "11110000";  -- 5AE6 = F0
      when "101101011100111" =>  data <= "00010000";  -- 5AE7 = 10
      when "101101011101000" =>  data <= "10100000";  -- 5AE8 = A0
      when "101101011101001" =>  data <= "00000000";  -- 5AE9 = 0
      when "101101011101010" =>  data <= "10110001";  -- 5AEA = B1
      when "101101011101011" =>  data <= "11111101";  -- 5AEB = FD
      when "101101011101100" =>  data <= "10011101";  -- 5AEC = 9D
      when "101101011101101" =>  data <= "01010011";  -- 5AED = 53
      when "101101011101110" =>  data <= "00000011";  -- 5AEE = 3
      when "101101011101111" =>  data <= "11101000";  -- 5AEF = E8
      when "101101011110000" =>  data <= "11001000";  -- 5AF0 = C8
      when "101101011110001" =>  data <= "11001100";  -- 5AF1 = CC
      when "101101011110010" =>  data <= "00111010";  -- 5AF2 = 3A
      when "101101011110011" =>  data <= "00000011";  -- 5AF3 = 3
      when "101101011110100" =>  data <= "11010000";  -- 5AF4 = D0
      when "101101011110101" =>  data <= "11110100";  -- 5AF5 = F4
      when "101101011110110" =>  data <= "11110000";  -- 5AF6 = F0
      when "101101011110111" =>  data <= "00000001";  -- 5AF7 = 1
      when "101101011111000" =>  data <= "11001010";  -- 5AF8 = CA
      when "101101011111001" =>  data <= "01101000";  -- 5AF9 = 68
      when "101101011111010" =>  data <= "10101000";  -- 5AFA = A8
      when "101101011111011" =>  data <= "00111000";  -- 5AFB = 38
      when "101101011111100" =>  data <= "01100000";  -- 5AFC = 60
      when "101101011111101" =>  data <= "10101101";  -- 5AFD = AD
      when "101101011111110" =>  data <= "00111111";  -- 5AFE = 3F
      when "101101011111111" =>  data <= "00000011";  -- 5AFF = 3
      when "101101100000000" =>  data <= "10011101";  -- 5B00 = 9D
      when "101101100000001" =>  data <= "01010011";  -- 5B01 = 53
      when "101101100000010" =>  data <= "00000011";  -- 5B02 = 3
      when "101101100000011" =>  data <= "11101000";  -- 5B03 = E8
      when "101101100000100" =>  data <= "10101101";  -- 5B04 = AD
      when "101101100000101" =>  data <= "01000000";  -- 5B05 = 40
      when "101101100000110" =>  data <= "00000011";  -- 5B06 = 3
      when "101101100000111" =>  data <= "10011101";  -- 5B07 = 9D
      when "101101100001000" =>  data <= "01010011";  -- 5B08 = 53
      when "101101100001001" =>  data <= "00000011";  -- 5B09 = 3
      when "101101100001010" =>  data <= "11101000";  -- 5B0A = E8
      when "101101100001011" =>  data <= "10001010";  -- 5B0B = 8A
      when "101101100001100" =>  data <= "01100000";  -- 5B0C = 60
      when "101101100001101" =>  data <= "00100000";  -- 5B0D = 20
      when "101101100001110" =>  data <= "01101000";  -- 5B0E = 68
      when "101101100001111" =>  data <= "11011100";  -- 5B0F = DC
      when "101101100010000" =>  data <= "00100000";  -- 5B10 = 20
      when "101101100010001" =>  data <= "00001011";  -- 5B11 = B
      when "101101100010010" =>  data <= "11011000";  -- 5B12 = D8
      when "101101100010011" =>  data <= "00101001";  -- 5B13 = 29
      when "101101100010100" =>  data <= "01100110";  -- 5B14 = 66
      when "101101100010101" =>  data <= "11110000";  -- 5B15 = F0
      when "101101100010110" =>  data <= "00000011";  -- 5B16 = 3
      when "101101100010111" =>  data <= "01001100";  -- 5B17 = 4C
      when "101101100011000" =>  data <= "00000000";  -- 5B18 = 0
      when "101101100011001" =>  data <= "10111111";  -- 5B19 = BF
      when "101101100011010" =>  data <= "10100000";  -- 5B1A = A0
      when "101101100011011" =>  data <= "00000010";  -- 5B1B = 2
      when "101101100011100" =>  data <= "10101101";  -- 5B1C = AD
      when "101101100011101" =>  data <= "00111110";  -- 5B1D = 3E
      when "101101100011110" =>  data <= "00000011";  -- 5B1E = 3
      when "101101100011111" =>  data <= "00101001";  -- 5B1F = 29
      when "101101100100000" =>  data <= "10000000";  -- 5B20 = 80
      when "101101100100001" =>  data <= "11110000";  -- 5B21 = F0
      when "101101100100010" =>  data <= "00001111";  -- 5B22 = F
      when "101101100100011" =>  data <= "10101001";  -- 5B23 = A9
      when "101101100100100" =>  data <= "01000000";  -- 5B24 = 40
      when "101101100100101" =>  data <= "10001101";  -- 5B25 = 8D
      when "101101100100110" =>  data <= "01010011";  -- 5B26 = 53
      when "101101100100111" =>  data <= "00000011";  -- 5B27 = 3
      when "101101100101000" =>  data <= "10100010";  -- 5B28 = A2
      when "101101100101001" =>  data <= "00000001";  -- 5B29 = 1
      when "101101100101010" =>  data <= "10101001";  -- 5B2A = A9
      when "101101100101011" =>  data <= "00000011";  -- 5B2B = 3
      when "101101100101100" =>  data <= "00100000";  -- 5B2C = 20
      when "101101100101101" =>  data <= "11111100";  -- 5B2D = FC
      when "101101100101110" =>  data <= "11011011";  -- 5B2E = DB
      when "101101100101111" =>  data <= "01001100";  -- 5B2F = 4C
      when "101101100110000" =>  data <= "11100000";  -- 5B30 = E0
      when "101101100110001" =>  data <= "11110110";  -- 5B31 = F6
      when "101101100110010" =>  data <= "10101001";  -- 5B32 = A9
      when "101101100110011" =>  data <= "00000011";  -- 5B33 = 3
      when "101101100110100" =>  data <= "00100000";  -- 5B34 = 20
      when "101101100110101" =>  data <= "11111010";  -- 5B35 = FA
      when "101101100110110" =>  data <= "11011011";  -- 5B36 = DB
      when "101101100110111" =>  data <= "01001100";  -- 5B37 = 4C
      when "101101100111000" =>  data <= "11100000";  -- 5B38 = E0
      when "101101100111001" =>  data <= "11110110";  -- 5B39 = F6
      when "101101100111010" =>  data <= "00100000";  -- 5B3A = 20
      when "101101100111011" =>  data <= "01101000";  -- 5B3B = 68
      when "101101100111100" =>  data <= "11011100";  -- 5B3C = DC
      when "101101100111101" =>  data <= "00100000";  -- 5B3D = 20
      when "101101100111110" =>  data <= "00001011";  -- 5B3E = B
      when "101101100111111" =>  data <= "11011000";  -- 5B3F = D8
      when "101101101000000" =>  data <= "00101001";  -- 5B40 = 29
      when "101101101000001" =>  data <= "11100110";  -- 5B41 = E6
      when "101101101000010" =>  data <= "11110000";  -- 5B42 = F0
      when "101101101000011" =>  data <= "00000011";  -- 5B43 = 3
      when "101101101000100" =>  data <= "01001100";  -- 5B44 = 4C
      when "101101101000101" =>  data <= "00000000";  -- 5B45 = 0
      when "101101101000110" =>  data <= "10111111";  -- 5B46 = BF
      when "101101101000111" =>  data <= "10100000";  -- 5B47 = A0
      when "101101101001000" =>  data <= "00000010";  -- 5B48 = 2
      when "101101101001001" =>  data <= "10101001";  -- 5B49 = A9
      when "101101101001010" =>  data <= "00000011";  -- 5B4A = 3
      when "101101101001011" =>  data <= "00100000";  -- 5B4B = 20
      when "101101101001100" =>  data <= "11111010";  -- 5B4C = FA
      when "101101101001101" =>  data <= "11011011";  -- 5B4D = DB
      when "101101101001110" =>  data <= "10101001";  -- 5B4E = A9
      when "101101101001111" =>  data <= "00000000";  -- 5B4F = 0
      when "101101101010000" =>  data <= "10000101";  -- 5B50 = 85
      when "101101101010001" =>  data <= "10011101";  -- 5B51 = 9D
      when "101101101010010" =>  data <= "01001100";  -- 5B52 = 4C
      when "101101101010011" =>  data <= "00001000";  -- 5B53 = 8
      when "101101101010100" =>  data <= "11110100";  -- 5B54 = F4
      when "101101101010101" =>  data <= "00100000";  -- 5B55 = 20
      when "101101101010110" =>  data <= "01101000";  -- 5B56 = 68
      when "101101101010111" =>  data <= "11011100";  -- 5B57 = DC
      when "101101101011000" =>  data <= "00100000";  -- 5B58 = 20
      when "101101101011001" =>  data <= "00100100";  -- 5B59 = 24
      when "101101101011010" =>  data <= "11011000";  -- 5B5A = D8
      when "101101101011011" =>  data <= "00101001";  -- 5B5B = 29
      when "101101101011100" =>  data <= "11100100";  -- 5B5C = E4
      when "101101101011101" =>  data <= "11010000";  -- 5B5D = D0
      when "101101101011110" =>  data <= "11100101";  -- 5B5E = E5
      when "101101101011111" =>  data <= "10100000";  -- 5B5F = A0
      when "101101101100000" =>  data <= "00101110";  -- 5B60 = 2E
      when "101101101100001" =>  data <= "10101001";  -- 5B61 = A9
      when "101101101100010" =>  data <= "00001000";  -- 5B62 = 8
      when "101101101100011" =>  data <= "01001100";  -- 5B63 = 4C
      when "101101101100100" =>  data <= "10011000";  -- 5B64 = 98
      when "101101101100101" =>  data <= "11011010";  -- 5B65 = DA
      when "101101101100110" =>  data <= "00100000";  -- 5B66 = 20
      when "101101101100111" =>  data <= "01101000";  -- 5B67 = 68
      when "101101101101000" =>  data <= "11011100";  -- 5B68 = DC
      when "101101101101001" =>  data <= "00100000";  -- 5B69 = 20
      when "101101101101010" =>  data <= "00000100";  -- 5B6A = 4
      when "101101101101011" =>  data <= "11011000";  -- 5B6B = D8
      when "101101101101100" =>  data <= "00100000";  -- 5B6C = 20
      when "101101101101101" =>  data <= "10011110";  -- 5B6D = 9E
      when "101101101101110" =>  data <= "11011011";  -- 5B6E = DB
      when "101101101101111" =>  data <= "10110000";  -- 5B6F = B0
      when "101101101110000" =>  data <= "00100111";  -- 5B70 = 27
      when "101101101110001" =>  data <= "10100000";  -- 5B71 = A0
      when "101101101110010" =>  data <= "00110110";  -- 5B72 = 36
      when "101101101110011" =>  data <= "10101001";  -- 5B73 = A9
      when "101101101110100" =>  data <= "00000100";  -- 5B74 = 4
      when "101101101110101" =>  data <= "00100000";  -- 5B75 = 20
      when "101101101110110" =>  data <= "10011000";  -- 5B76 = 98
      when "101101101110111" =>  data <= "11011010";  -- 5B77 = DA
      when "101101101111000" =>  data <= "00100000";  -- 5B78 = 20
      when "101101101111001" =>  data <= "10011001";  -- 5B79 = 99
      when "101101101111010" =>  data <= "11011011";  -- 5B7A = DB
      when "101101101111011" =>  data <= "11010000";  -- 5B7B = D0
      when "101101101111100" =>  data <= "00011011";  -- 5B7C = 1B
      when "101101101111101" =>  data <= "00100000";  -- 5B7D = 20
      when "101101101111110" =>  data <= "10010001";  -- 5B7E = 91
      when "101101101111111" =>  data <= "11011001";  -- 5B7F = D9
      when "101101110000000" =>  data <= "10101001";  -- 5B80 = A9
      when "101101110000001" =>  data <= "00001101";  -- 5B81 = D
      when "101101110000010" =>  data <= "00100000";  -- 5B82 = 20
      when "101101110000011" =>  data <= "00000010";  -- 5B83 = 2
      when "101101110000100" =>  data <= "11100010";  -- 5B84 = E2
      when "101101110000101" =>  data <= "10100000";  -- 5B85 = A0
      when "101101110000110" =>  data <= "00000000";  -- 5B86 = 0
      when "101101110000111" =>  data <= "10110001";  -- 5B87 = B1
      when "101101110001000" =>  data <= "00001110";  -- 5B88 = E
      when "101101110001001" =>  data <= "11001001";  -- 5B89 = C9
      when "101101110001010" =>  data <= "00000000";  -- 5B8A = 0
      when "101101110001011" =>  data <= "11110000";  -- 5B8B = F0
      when "101101110001100" =>  data <= "00000110";  -- 5B8C = 6
      when "101101110001101" =>  data <= "00100000";  -- 5B8D = 20
      when "101101110001110" =>  data <= "00000010";  -- 5B8E = 2
      when "101101110001111" =>  data <= "11100010";  -- 5B8F = E2
      when "101101110010000" =>  data <= "11001000";  -- 5B90 = C8
      when "101101110010001" =>  data <= "11010000";  -- 5B91 = D0
      when "101101110010010" =>  data <= "11110100";  -- 5B92 = F4
      when "101101110010011" =>  data <= "10101001";  -- 5B93 = A9
      when "101101110010100" =>  data <= "00001101";  -- 5B94 = D
      when "101101110010101" =>  data <= "00100000";  -- 5B95 = 20
      when "101101110010110" =>  data <= "00000010";  -- 5B96 = 2
      when "101101110010111" =>  data <= "11100010";  -- 5B97 = E2
      when "101101110011000" =>  data <= "01100000";  -- 5B98 = 60
      when "101101110011001" =>  data <= "10100101";  -- 5B99 = A5
      when "101101110011010" =>  data <= "01111000";  -- 5B9A = 78
      when "101101110011011" =>  data <= "11001001";  -- 5B9B = C9
      when "101101110011100" =>  data <= "00000010";  -- 5B9C = 2
      when "101101110011101" =>  data <= "01100000";  -- 5B9D = 60
      when "101101110011110" =>  data <= "00100000";  -- 5B9E = 20
      when "101101110011111" =>  data <= "10011001";  -- 5B9F = 99
      when "101101110100000" =>  data <= "11011011";  -- 5BA0 = DB
      when "101101110100001" =>  data <= "11010000";  -- 5BA1 = D0
      when "101101110100010" =>  data <= "00110010";  -- 5BA2 = 32
      when "101101110100011" =>  data <= "10100000";  -- 5BA3 = A0
      when "101101110100100" =>  data <= "10110110";  -- 5BA4 = B6
      when "101101110100101" =>  data <= "00100000";  -- 5BA5 = 20
      when "101101110100110" =>  data <= "10000101";  -- 5BA6 = 85
      when "101101110100111" =>  data <= "11110001";  -- 5BA7 = F1
      when "101101110101000" =>  data <= "00100000";  -- 5BA8 = 20
      when "101101110101001" =>  data <= "10100110";  -- 5BA9 = A6
      when "101101110101010" =>  data <= "11110010";  -- 5BAA = F2
      when "101101110101011" =>  data <= "00100000";  -- 5BAB = 20
      when "101101110101100" =>  data <= "00010101";  -- 5BAC = 15
      when "101101110101101" =>  data <= "11110010";  -- 5BAD = F2
      when "101101110101110" =>  data <= "11001001";  -- 5BAE = C9
      when "101101110101111" =>  data <= "01011001";  -- 5BAF = 59
      when "101101110110000" =>  data <= "11010000";  -- 5BB0 = D0
      when "101101110110001" =>  data <= "00011001";  -- 5BB1 = 19
      when "101101110110010" =>  data <= "00100000";  -- 5BB2 = 20
      when "101101110110011" =>  data <= "00010101";  -- 5BB3 = 15
      when "101101110110100" =>  data <= "11110010";  -- 5BB4 = F2
      when "101101110110101" =>  data <= "11001001";  -- 5BB5 = C9
      when "101101110110110" =>  data <= "00001101";  -- 5BB6 = D
      when "101101110110111" =>  data <= "11110000";  -- 5BB7 = F0
      when "101101110111000" =>  data <= "00011100";  -- 5BB8 = 1C
      when "101101110111001" =>  data <= "11001001";  -- 5BB9 = C9
      when "101101110111010" =>  data <= "01000101";  -- 5BBA = 45
      when "101101110111011" =>  data <= "11010000";  -- 5BBB = D0
      when "101101110111100" =>  data <= "00001110";  -- 5BBC = E
      when "101101110111101" =>  data <= "00100000";  -- 5BBD = 20
      when "101101110111110" =>  data <= "00010101";  -- 5BBE = 15
      when "101101110111111" =>  data <= "11110010";  -- 5BBF = F2
      when "101101111000000" =>  data <= "11001001";  -- 5BC0 = C9
      when "101101111000001" =>  data <= "01010011";  -- 5BC1 = 53
      when "101101111000010" =>  data <= "11010000";  -- 5BC2 = D0
      when "101101111000011" =>  data <= "00000111";  -- 5BC3 = 7
      when "101101111000100" =>  data <= "00100000";  -- 5BC4 = 20
      when "101101111000101" =>  data <= "00010101";  -- 5BC5 = 15
      when "101101111000110" =>  data <= "11110010";  -- 5BC6 = F2
      when "101101111000111" =>  data <= "11001001";  -- 5BC7 = C9
      when "101101111001000" =>  data <= "00001101";  -- 5BC8 = D
      when "101101111001001" =>  data <= "11110000";  -- 5BC9 = F0
      when "101101111001010" =>  data <= "00001010";  -- 5BCA = A
      when "101101111001011" =>  data <= "11001001";  -- 5BCB = C9
      when "101101111001100" =>  data <= "00001101";  -- 5BCC = D
      when "101101111001101" =>  data <= "00111000";  -- 5BCD = 38
      when "101101111001110" =>  data <= "11110000";  -- 5BCE = F0
      when "101101111001111" =>  data <= "00000110";  -- 5BCF = 6
      when "101101111010000" =>  data <= "00100000";  -- 5BD0 = 20
      when "101101111010001" =>  data <= "00010101";  -- 5BD1 = 15
      when "101101111010010" =>  data <= "11110010";  -- 5BD2 = F2
      when "101101111010011" =>  data <= "11010000";  -- 5BD3 = D0
      when "101101111010100" =>  data <= "11110110";  -- 5BD4 = F6
      when "101101111010101" =>  data <= "00011000";  -- 5BD5 = 18
      when "101101111010110" =>  data <= "01100000";  -- 5BD6 = 60
      when "101101111010111" =>  data <= "00100000";  -- 5BD7 = 20
      when "101101111011000" =>  data <= "10011001";  -- 5BD8 = 99
      when "101101111011001" =>  data <= "11011011";  -- 5BD9 = DB
      when "101101111011010" =>  data <= "11010000";  -- 5BDA = D0
      when "101101111011011" =>  data <= "11111010";  -- 5BDB = FA
      when "101101111011100" =>  data <= "10100000";  -- 5BDC = A0
      when "101101111011101" =>  data <= "11000101";  -- 5BDD = C5
      when "101101111011110" =>  data <= "01001100";  -- 5BDE = 4C
      when "101101111011111" =>  data <= "10000101";  -- 5BDF = 85
      when "101101111100000" =>  data <= "11110001";  -- 5BE0 = F1
      when "101101111100001" =>  data <= "10011000";  -- 5BE1 = 98
      when "101101111100010" =>  data <= "01001000";  -- 5BE2 = 48
      when "101101111100011" =>  data <= "10100101";  -- 5BE3 = A5
      when "101101111100100" =>  data <= "00001101";  -- 5BE4 = D
      when "101101111100101" =>  data <= "11110000";  -- 5BE5 = F0
      when "101101111100110" =>  data <= "00001010";  -- 5BE6 = A
      when "101101111100111" =>  data <= "10100000";  -- 5BE7 = A0
      when "101101111101000" =>  data <= "00101000";  -- 5BE8 = 28
      when "101101111101001" =>  data <= "10011000";  -- 5BE9 = 98
      when "101101111101010" =>  data <= "10010001";  -- 5BEA = 91
      when "101101111101011" =>  data <= "00001110";  -- 5BEB = E
      when "101101111101100" =>  data <= "11001000";  -- 5BEC = C8
      when "101101111101101" =>  data <= "10101001";  -- 5BED = A9
      when "101101111101110" =>  data <= "11111111";  -- 5BEE = FF
      when "101101111101111" =>  data <= "10010001";  -- 5BEF = 91
      when "101101111110000" =>  data <= "00001110";  -- 5BF0 = E
      when "101101111110001" =>  data <= "10101001";  -- 5BF1 = A9
      when "101101111110010" =>  data <= "00000000";  -- 5BF2 = 0
      when "101101111110011" =>  data <= "10000101";  -- 5BF3 = 85
      when "101101111110100" =>  data <= "10010110";  -- 5BF4 = 96
      when "101101111110101" =>  data <= "10000101";  -- 5BF5 = 85
      when "101101111110110" =>  data <= "00001101";  -- 5BF6 = D
      when "101101111110111" =>  data <= "01101000";  -- 5BF7 = 68
      when "101101111111000" =>  data <= "10101000";  -- 5BF8 = A8
      when "101101111111001" =>  data <= "01100000";  -- 5BF9 = 60
      when "101101111111010" =>  data <= "10100010";  -- 5BFA = A2
      when "101101111111011" =>  data <= "00000000";  -- 5BFB = 0
      when "101101111111100" =>  data <= "10001101";  -- 5BFC = 8D
      when "101101111111101" =>  data <= "01000001";  -- 5BFD = 41
      when "101101111111110" =>  data <= "00000011";  -- 5BFE = 3
      when "101101111111111" =>  data <= "00100000";  -- 5BFF = 20
      when "101110000000000" =>  data <= "11100001";  -- 5C00 = E1
      when "101110000000001" =>  data <= "11011011";  -- 5C01 = DB
      when "101110000000010" =>  data <= "11001110";  -- 5C02 = CE
      when "101110000000011" =>  data <= "01000001";  -- 5C03 = 41
      when "101110000000100" =>  data <= "00000011";  -- 5C04 = 3
      when "101110000000101" =>  data <= "00110000";  -- 5C05 = 30
      when "101110000000110" =>  data <= "01000101";  -- 5C06 = 45
      when "101110000000111" =>  data <= "11001000";  -- 5C07 = C8
      when "101110000001000" =>  data <= "10111001";  -- 5C08 = B9
      when "101110000001001" =>  data <= "00111000";  -- 5C09 = 38
      when "101110000001010" =>  data <= "11011000";  -- 5C0A = D8
      when "101110000001011" =>  data <= "00010000";  -- 5C0B = 10
      when "101110000001100" =>  data <= "00111001";  -- 5C0C = 39
      when "101110000001101" =>  data <= "11001001";  -- 5C0D = C9
      when "101110000001110" =>  data <= "11110001";  -- 5C0E = F1
      when "101110000001111" =>  data <= "11010000";  -- 5C0F = D0
      when "101110000010000" =>  data <= "00000011";  -- 5C10 = 3
      when "101110000010001" =>  data <= "00100000";  -- 5C11 = 20
      when "101110000010010" =>  data <= "11010100";  -- 5C12 = D4
      when "101110000010011" =>  data <= "11011010";  -- 5C13 = DA
      when "101110000010100" =>  data <= "11001001";  -- 5C14 = C9
      when "101110000010101" =>  data <= "11110010";  -- 5C15 = F2
      when "101110000010110" =>  data <= "11010000";  -- 5C16 = D0
      when "101110000010111" =>  data <= "00000011";  -- 5C17 = 3
      when "101110000011000" =>  data <= "00100000";  -- 5C18 = 20
      when "101110000011001" =>  data <= "11100001";  -- 5C19 = E1
      when "101110000011010" =>  data <= "11011010";  -- 5C1A = DA
      when "101110000011011" =>  data <= "11001001";  -- 5C1B = C9
      when "101110000011100" =>  data <= "11100000";  -- 5C1C = E0
      when "101110000011101" =>  data <= "11010000";  -- 5C1D = D0
      when "101110000011110" =>  data <= "00000101";  -- 5C1E = 5
      when "101110000011111" =>  data <= "10101101";  -- 5C1F = AD
      when "101110000100000" =>  data <= "00111101";  -- 5C20 = 3D
      when "101110000100001" =>  data <= "00000011";  -- 5C21 = 3
      when "101110000100010" =>  data <= "11010000";  -- 5C22 = D0
      when "101110000100011" =>  data <= "00100010";  -- 5C23 = 22
      when "101110000100100" =>  data <= "11001001";  -- 5C24 = C9
      when "101110000100101" =>  data <= "11010000";  -- 5C25 = D0
      when "101110000100110" =>  data <= "11010000";  -- 5C26 = D0
      when "101110000100111" =>  data <= "00000011";  -- 5C27 = 3
      when "101110000101000" =>  data <= "00100000";  -- 5C28 = 20
      when "101110000101001" =>  data <= "11111101";  -- 5C29 = FD
      when "101110000101010" =>  data <= "11011010";  -- 5C2A = DA
      when "101110000101011" =>  data <= "11001001";  -- 5C2B = C9
      when "101110000101100" =>  data <= "11100001";  -- 5C2C = E1
      when "101110000101101" =>  data <= "11010000";  -- 5C2D = D0
      when "101110000101110" =>  data <= "00000101";  -- 5C2E = 5
      when "101110000101111" =>  data <= "00100000";  -- 5C2F = 20
      when "101110000110000" =>  data <= "01010111";  -- 5C30 = 57
      when "101110000110001" =>  data <= "11011100";  -- 5C31 = DC
      when "101110000110010" =>  data <= "11010000";  -- 5C32 = D0
      when "101110000110011" =>  data <= "00010010";  -- 5C33 = 12
      when "101110000110100" =>  data <= "11001001";  -- 5C34 = C9
      when "101110000110101" =>  data <= "11010001";  -- 5C35 = D1
      when "101110000110110" =>  data <= "11010000";  -- 5C36 = D0
      when "101110000110111" =>  data <= "00000101";  -- 5C37 = 5
      when "101110000111000" =>  data <= "10101101";  -- 5C38 = AD
      when "101110000111001" =>  data <= "00111011";  -- 5C39 = 3B
      when "101110000111010" =>  data <= "00000011";  -- 5C3A = 3
      when "101110000111011" =>  data <= "00010000";  -- 5C3B = 10
      when "101110000111100" =>  data <= "00000111";  -- 5C3C = 7
      when "101110000111101" =>  data <= "11001001";  -- 5C3D = C9
      when "101110000111110" =>  data <= "11010010";  -- 5C3E = D2
      when "101110000111111" =>  data <= "11010000";  -- 5C3F = D0
      when "101110001000000" =>  data <= "11000001";  -- 5C40 = C1
      when "101110001000001" =>  data <= "10101101";  -- 5C41 = AD
      when "101110001000010" =>  data <= "00111100";  -- 5C42 = 3C
      when "101110001000011" =>  data <= "00000011";  -- 5C43 = 3
      when "101110001000100" =>  data <= "00001001";  -- 5C44 = 9
      when "101110001000101" =>  data <= "00110000";  -- 5C45 = 30
      when "101110001000110" =>  data <= "10011101";  -- 5C46 = 9D
      when "101110001000111" =>  data <= "01010011";  -- 5C47 = 53
      when "101110001001000" =>  data <= "00000011";  -- 5C48 = 3
      when "101110001001001" =>  data <= "11101000";  -- 5C49 = E8
      when "101110001001010" =>  data <= "11010000";  -- 5C4A = D0
      when "101110001001011" =>  data <= "10110110";  -- 5C4B = B6
      when "101110001001100" =>  data <= "10000110";  -- 5C4C = 86
      when "101110001001101" =>  data <= "11010001";  -- 5C4D = D1
      when "101110001001110" =>  data <= "10101001";  -- 5C4E = A9
      when "101110001001111" =>  data <= "01010011";  -- 5C4F = 53
      when "101110001010000" =>  data <= "10000101";  -- 5C50 = 85
      when "101110001010001" =>  data <= "11011010";  -- 5C51 = DA
      when "101110001010010" =>  data <= "10101001";  -- 5C52 = A9
      when "101110001010011" =>  data <= "00000011";  -- 5C53 = 3
      when "101110001010100" =>  data <= "10000101";  -- 5C54 = 85
      when "101110001010101" =>  data <= "11011011";  -- 5C55 = DB
      when "101110001010110" =>  data <= "01100000";  -- 5C56 = 60
      when "101110001010111" =>  data <= "10101101";  -- 5C57 = AD
      when "101110001011000" =>  data <= "00111101";  -- 5C58 = 3D
      when "101110001011001" =>  data <= "00000011";  -- 5C59 = 3
      when "101110001011010" =>  data <= "11110000";  -- 5C5A = F0
      when "101110001011011" =>  data <= "00000100";  -- 5C5B = 4
      when "101110001011100" =>  data <= "10101001";  -- 5C5C = A9
      when "101110001011101" =>  data <= "01001100";  -- 5C5D = 4C
      when "101110001011110" =>  data <= "11010000";  -- 5C5E = D0
      when "101110001011111" =>  data <= "00000111";  -- 5C5F = 7
      when "101110001100000" =>  data <= "10101001";  -- 5C60 = A9
      when "101110001100001" =>  data <= "01010011";  -- 5C61 = 53
      when "101110001100010" =>  data <= "10001101";  -- 5C62 = 8D
      when "101110001100011" =>  data <= "00111101";  -- 5C63 = 3D
      when "101110001100100" =>  data <= "00000011";  -- 5C64 = 3
      when "101110001100101" =>  data <= "10101001";  -- 5C65 = A9
      when "101110001100110" =>  data <= "01010111";  -- 5C66 = 57
      when "101110001100111" =>  data <= "01100000";  -- 5C67 = 60
      when "101110001101000" =>  data <= "10100010";  -- 5C68 = A2
      when "101110001101001" =>  data <= "00000000";  -- 5C69 = 0
      when "101110001101010" =>  data <= "10001110";  -- 5C6A = 8E
      when "101110001101011" =>  data <= "00111110";  -- 5C6B = 3E
      when "101110001101100" =>  data <= "00000011";  -- 5C6C = 3
      when "101110001101101" =>  data <= "10000110";  -- 5C6D = 86
      when "101110001101110" =>  data <= "11010010";  -- 5C6E = D2
      when "101110001101111" =>  data <= "10001110";  -- 5C6F = 8E
      when "101110001110000" =>  data <= "00111101";  -- 5C70 = 3D
      when "101110001110001" =>  data <= "00000011";  -- 5C71 = 3
      when "101110001110010" =>  data <= "10001110";  -- 5C72 = 8E
      when "101110001110011" =>  data <= "00111011";  -- 5C73 = 3B
      when "101110001110100" =>  data <= "00000011";  -- 5C74 = 3
      when "101110001110101" =>  data <= "10001110";  -- 5C75 = 8E
      when "101110001110110" =>  data <= "00111100";  -- 5C76 = 3C
      when "101110001110111" =>  data <= "00000011";  -- 5C77 = 3
      when "101110001111000" =>  data <= "10000110";  -- 5C78 = 86
      when "101110001111001" =>  data <= "11010001";  -- 5C79 = D1
      when "101110001111010" =>  data <= "10001110";  -- 5C7A = 8E
      when "101110001111011" =>  data <= "00111010";  -- 5C7B = 3A
      when "101110001111100" =>  data <= "00000011";  -- 5C7C = 3
      when "101110001111101" =>  data <= "10001110";  -- 5C7D = 8E
      when "101110001111110" =>  data <= "00111111";  -- 5C7E = 3F
      when "101110001111111" =>  data <= "00000011";  -- 5C7F = 3
      when "101110010000000" =>  data <= "10100010";  -- 5C80 = A2
      when "101110010000001" =>  data <= "00001000";  -- 5C81 = 8
      when "101110010000010" =>  data <= "10000110";  -- 5C82 = 86
      when "101110010000011" =>  data <= "11010100";  -- 5C83 = D4
      when "101110010000100" =>  data <= "00100000";  -- 5C84 = 20
      when "101110010000101" =>  data <= "01110110";  -- 5C85 = 76
      when "101110010000110" =>  data <= "00000000";  -- 5C86 = 0
      when "101110010000111" =>  data <= "11110000";  -- 5C87 = F0
      when "101110010001000" =>  data <= "01111010";  -- 5C88 = 7A
      when "101110010001001" =>  data <= "11001001";  -- 5C89 = C9
      when "101110010001010" =>  data <= "00100011";  -- 5C8A = 23
      when "101110010001011" =>  data <= "11110000";  -- 5C8B = F0
      when "101110010001100" =>  data <= "00110000";  -- 5C8C = 30
      when "101110010001101" =>  data <= "11001001";  -- 5C8D = C9
      when "101110010001110" =>  data <= "01010111";  -- 5C8E = 57
      when "101110010001111" =>  data <= "11110000";  -- 5C8F = F0
      when "101110010010000" =>  data <= "01000111";  -- 5C90 = 47
      when "101110010010001" =>  data <= "11001001";  -- 5C91 = C9
      when "101110010010010" =>  data <= "01001100";  -- 5C92 = 4C
      when "101110010010011" =>  data <= "11110000";  -- 5C93 = F0
      when "101110010010100" =>  data <= "01000011";  -- 5C94 = 43
      when "101110010010101" =>  data <= "11001001";  -- 5C95 = C9
      when "101110010010110" =>  data <= "01010010";  -- 5C96 = 52
      when "101110010010111" =>  data <= "11010000";  -- 5C97 = D0
      when "101110010011000" =>  data <= "00000110";  -- 5C98 = 6
      when "101110010011001" =>  data <= "00100000";  -- 5C99 = 20
      when "101110010011010" =>  data <= "01110000";  -- 5C9A = 70
      when "101110010011011" =>  data <= "00000000";  -- 5C9B = 0
      when "101110010011100" =>  data <= "01001100";  -- 5C9C = 4C
      when "101110010011101" =>  data <= "10010110";  -- 5C9D = 96
      when "101110010011110" =>  data <= "11011101";  -- 5C9E = DD
      when "101110010011111" =>  data <= "11001001";  -- 5C9F = C9
      when "101110010100000" =>  data <= "01000100";  -- 5CA0 = 44
      when "101110010100001" =>  data <= "11110000";  -- 5CA1 = F0
      when "101110010100010" =>  data <= "01110010";  -- 5CA2 = 72
      when "101110010100011" =>  data <= "11001001";  -- 5CA3 = C9
      when "101110010100100" =>  data <= "10010001";  -- 5CA4 = 91
      when "101110010100101" =>  data <= "11110000";  -- 5CA5 = F0
      when "101110010100110" =>  data <= "01100010";  -- 5CA6 = 62
      when "101110010100111" =>  data <= "11001001";  -- 5CA7 = C9
      when "101110010101000" =>  data <= "01010101";  -- 5CA8 = 55
      when "101110010101001" =>  data <= "11110000";  -- 5CA9 = F0
      when "101110010101010" =>  data <= "01100100";  -- 5CAA = 64
      when "101110010101011" =>  data <= "11001001";  -- 5CAB = C9
      when "101110010101100" =>  data <= "01001001";  -- 5CAC = 49
      when "101110010101101" =>  data <= "11010000";  -- 5CAD = D0
      when "101110010101110" =>  data <= "00000011";  -- 5CAE = 3
      when "101110010101111" =>  data <= "01001100";  -- 5CAF = 4C
      when "101110010110000" =>  data <= "00110111";  -- 5CB0 = 37
      when "101110010110001" =>  data <= "11011101";  -- 5CB1 = DD
      when "101110010110010" =>  data <= "11001001";  -- 5CB2 = C9
      when "101110010110011" =>  data <= "00100010";  -- 5CB3 = 22
      when "101110010110100" =>  data <= "11110000";  -- 5CB4 = F0
      when "101110010110101" =>  data <= "01010000";  -- 5CB5 = 50
      when "101110010110110" =>  data <= "11001001";  -- 5CB6 = C9
      when "101110010110111" =>  data <= "00101000";  -- 5CB7 = 28
      when "101110010111000" =>  data <= "11110000";  -- 5CB8 = F0
      when "101110010111001" =>  data <= "01001100";  -- 5CB9 = 4C
      when "101110010111010" =>  data <= "01001100";  -- 5CBA = 4C
      when "101110010111011" =>  data <= "00000000";  -- 5CBB = 0
      when "101110010111100" =>  data <= "10111111";  -- 5CBC = BF
      when "101110010111101" =>  data <= "10101101";  -- 5CBD = AD
      when "101110010111110" =>  data <= "00111110";  -- 5CBE = 3E
      when "101110010111111" =>  data <= "00000011";  -- 5CBF = 3
      when "101110011000000" =>  data <= "00101001";  -- 5CC0 = 29
      when "101110011000001" =>  data <= "00000100";  -- 5CC1 = 4
      when "101110011000010" =>  data <= "11010000";  -- 5CC2 = D0
      when "101110011000011" =>  data <= "11110110";  -- 5CC3 = F6
      when "101110011000100" =>  data <= "00100000";  -- 5CC4 = 20
      when "101110011000101" =>  data <= "10000111";  -- 5CC5 = 87
      when "101110011000110" =>  data <= "11011110";  -- 5CC6 = DE
      when "101110011000111" =>  data <= "11100000";  -- 5CC7 = E0
      when "101110011001000" =>  data <= "00000000";  -- 5CC8 = 0
      when "101110011001001" =>  data <= "11110000";  -- 5CC9 = F0
      when "101110011001010" =>  data <= "01101001";  -- 5CCA = 69
      when "101110011001011" =>  data <= "10000110";  -- 5CCB = 86
      when "101110011001100" =>  data <= "11010010";  -- 5CCC = D2
      when "101110011001101" =>  data <= "10101101";  -- 5CCD = AD
      when "101110011001110" =>  data <= "00111110";  -- 5CCE = 3E
      when "101110011001111" =>  data <= "00000011";  -- 5CCF = 3
      when "101110011010000" =>  data <= "00001001";  -- 5CD0 = 9
      when "101110011010001" =>  data <= "00000100";  -- 5CD1 = 4
      when "101110011010010" =>  data <= "10001101";  -- 5CD2 = 8D
      when "101110011010011" =>  data <= "00111110";  -- 5CD3 = 3E
      when "101110011010100" =>  data <= "00000011";  -- 5CD4 = 3
      when "101110011010101" =>  data <= "01001100";  -- 5CD5 = 4C
      when "101110011010110" =>  data <= "10010110";  -- 5CD6 = 96
      when "101110011010111" =>  data <= "11011101";  -- 5CD7 = DD
      when "101110011011000" =>  data <= "10101010";  -- 5CD8 = AA
      when "101110011011001" =>  data <= "10101101";  -- 5CD9 = AD
      when "101110011011010" =>  data <= "00111110";  -- 5CDA = 3E
      when "101110011011011" =>  data <= "00000011";  -- 5CDB = 3
      when "101110011011100" =>  data <= "00101001";  -- 5CDC = 29
      when "101110011011101" =>  data <= "01000000";  -- 5CDD = 40
      when "101110011011110" =>  data <= "11010000";  -- 5CDE = D0
      when "101110011011111" =>  data <= "11011010";  -- 5CDF = DA
      when "101110011100000" =>  data <= "11100000";  -- 5CE0 = E0
      when "101110011100001" =>  data <= "01010111";  -- 5CE1 = 57
      when "101110011100010" =>  data <= "11010000";  -- 5CE2 = D0
      when "101110011100011" =>  data <= "00000110";  -- 5CE3 = 6
      when "101110011100100" =>  data <= "00100000";  -- 5CE4 = 20
      when "101110011100101" =>  data <= "01110000";  -- 5CE5 = 70
      when "101110011100110" =>  data <= "00000000";  -- 5CE6 = 0
      when "101110011100111" =>  data <= "01001100";  -- 5CE7 = 4C
      when "101110011101000" =>  data <= "11111000";  -- 5CE8 = F8
      when "101110011101001" =>  data <= "11011100";  -- 5CE9 = DC
      when "101110011101010" =>  data <= "00100000";  -- 5CEA = 20
      when "101110011101011" =>  data <= "10000111";  -- 5CEB = 87
      when "101110011101100" =>  data <= "11011110";  -- 5CEC = DE
      when "101110011101101" =>  data <= "11100000";  -- 5CED = E0
      when "101110011101110" =>  data <= "00000000";  -- 5CEE = 0
      when "101110011101111" =>  data <= "11110000";  -- 5CEF = F0
      when "101110011110000" =>  data <= "01000011";  -- 5CF0 = 43
      when "101110011110001" =>  data <= "11100000";  -- 5CF1 = E0
      when "101110011110010" =>  data <= "11111111";  -- 5CF2 = FF
      when "101110011110011" =>  data <= "11110000";  -- 5CF3 = F0
      when "101110011110100" =>  data <= "00111111";  -- 5CF4 = 3F
      when "101110011110101" =>  data <= "10001110";  -- 5CF5 = 8E
      when "101110011110110" =>  data <= "00111101";  -- 5CF6 = 3D
      when "101110011110111" =>  data <= "00000011";  -- 5CF7 = 3
      when "101110011111000" =>  data <= "10101101";  -- 5CF8 = AD
      when "101110011111001" =>  data <= "00111110";  -- 5CF9 = 3E
      when "101110011111010" =>  data <= "00000011";  -- 5CFA = 3
      when "101110011111011" =>  data <= "00001001";  -- 5CFB = 9
      when "101110011111100" =>  data <= "01000000";  -- 5CFC = 40
      when "101110011111101" =>  data <= "10001101";  -- 5CFD = 8D
      when "101110011111110" =>  data <= "00111110";  -- 5CFE = 3E
      when "101110011111111" =>  data <= "00000011";  -- 5CFF = 3
      when "101110100000000" =>  data <= "01001100";  -- 5D00 = 4C
      when "101110100000001" =>  data <= "10010110";  -- 5D01 = 96
      when "101110100000010" =>  data <= "11011101";  -- 5D02 = DD
      when "101110100000011" =>  data <= "01001100";  -- 5D03 = 4C
      when "101110100000100" =>  data <= "00100011";  -- 5D04 = 23
      when "101110100000101" =>  data <= "11011110";  -- 5D05 = DE
      when "101110100000110" =>  data <= "01001100";  -- 5D06 = 4C
      when "101110100000111" =>  data <= "01100000";  -- 5D07 = 60
      when "101110100001000" =>  data <= "11011101";  -- 5D08 = DD
      when "101110100001001" =>  data <= "00100000";  -- 5D09 = 20
      when "101110100001010" =>  data <= "00101100";  -- 5D0A = 2C
      when "101110100001011" =>  data <= "11011110";  -- 5D0B = DE
      when "101110100001100" =>  data <= "01001100";  -- 5D0C = 4C
      when "101110100001101" =>  data <= "10010110";  -- 5D0D = 96
      when "101110100001110" =>  data <= "11011101";  -- 5D0E = DD
      when "101110100001111" =>  data <= "00100000";  -- 5D0F = 20
      when "101110100010000" =>  data <= "00110011";  -- 5D10 = 33
      when "101110100010001" =>  data <= "11011110";  -- 5D11 = DE
      when "101110100010010" =>  data <= "01001100";  -- 5D12 = 4C
      when "101110100010011" =>  data <= "10010110";  -- 5D13 = 96
      when "101110100010100" =>  data <= "11011101";  -- 5D14 = DD
      when "101110100010101" =>  data <= "10101101";  -- 5D15 = AD
      when "101110100010110" =>  data <= "00111110";  -- 5D16 = 3E
      when "101110100010111" =>  data <= "00000011";  -- 5D17 = 3
      when "101110100011000" =>  data <= "00101001";  -- 5D18 = 29
      when "101110100011001" =>  data <= "00010000";  -- 5D19 = 10
      when "101110100011010" =>  data <= "11010000";  -- 5D1A = D0
      when "101110100011011" =>  data <= "10011110";  -- 5D1B = 9E
      when "101110100011100" =>  data <= "00100000";  -- 5D1C = 20
      when "101110100011101" =>  data <= "10000111";  -- 5D1D = 87
      when "101110100011110" =>  data <= "11011110";  -- 5D1E = DE
      when "101110100011111" =>  data <= "11100000";  -- 5D1F = E0
      when "101110100100000" =>  data <= "00000010";  -- 5D20 = 2
      when "101110100100001" =>  data <= "10110000";  -- 5D21 = B0
      when "101110100100010" =>  data <= "00010001";  -- 5D22 = 11
      when "101110100100011" =>  data <= "10001110";  -- 5D23 = 8E
      when "101110100100100" =>  data <= "00111011";  -- 5D24 = 3B
      when "101110100100101" =>  data <= "00000011";  -- 5D25 = 3
      when "101110100100110" =>  data <= "10001110";  -- 5D26 = 8E
      when "101110100100111" =>  data <= "00111100";  -- 5D27 = 3C
      when "101110100101000" =>  data <= "00000011";  -- 5D28 = 3
      when "101110100101001" =>  data <= "10101101";  -- 5D29 = AD
      when "101110100101010" =>  data <= "00111110";  -- 5D2A = 3E
      when "101110100101011" =>  data <= "00000011";  -- 5D2B = 3
      when "101110100101100" =>  data <= "00001001";  -- 5D2C = 9
      when "101110100101101" =>  data <= "00010000";  -- 5D2D = 10
      when "101110100101110" =>  data <= "10001101";  -- 5D2E = 8D
      when "101110100101111" =>  data <= "00111110";  -- 5D2F = 3E
      when "101110100110000" =>  data <= "00000011";  -- 5D30 = 3
      when "101110100110001" =>  data <= "01001100";  -- 5D31 = 4C
      when "101110100110010" =>  data <= "10010110";  -- 5D32 = 96
      when "101110100110011" =>  data <= "11011101";  -- 5D33 = DD
      when "101110100110100" =>  data <= "01001100";  -- 5D34 = 4C
      when "101110100110101" =>  data <= "00100111";  -- 5D35 = 27
      when "101110100110110" =>  data <= "11011110";  -- 5D36 = DE
      when "101110100110111" =>  data <= "10101101";  -- 5D37 = AD
      when "101110100111000" =>  data <= "00111101";  -- 5D38 = 3D
      when "101110100111001" =>  data <= "00000011";  -- 5D39 = 3
      when "101110100111010" =>  data <= "00101001";  -- 5D3A = 29
      when "101110100111011" =>  data <= "11111111";  -- 5D3B = FF
      when "101110100111100" =>  data <= "11110000";  -- 5D3C = F0
      when "101110100111101" =>  data <= "00000011";  -- 5D3D = 3
      when "101110100111110" =>  data <= "01001100";  -- 5D3E = 4C
      when "101110100111111" =>  data <= "00000000";  -- 5D3F = 0
      when "101110101000000" =>  data <= "10111111";  -- 5D40 = BF
      when "101110101000001" =>  data <= "10100000";  -- 5D41 = A0
      when "101110101000010" =>  data <= "00000000";  -- 5D42 = 0
      when "101110101000011" =>  data <= "10100010";  -- 5D43 = A2
      when "101110101000100" =>  data <= "00000000";  -- 5D44 = 0
      when "101110101000101" =>  data <= "11100110";  -- 5D45 = E6
      when "101110101000110" =>  data <= "01110111";  -- 5D46 = 77
      when "101110101000111" =>  data <= "11010000";  -- 5D47 = D0
      when "101110101001000" =>  data <= "00000010";  -- 5D48 = 2
      when "101110101001001" =>  data <= "11100110";  -- 5D49 = E6
      when "101110101001010" =>  data <= "01111000";  -- 5D4A = 78
      when "101110101001011" =>  data <= "10110001";  -- 5D4B = B1
      when "101110101001100" =>  data <= "01110111";  -- 5D4C = 77
      when "101110101001101" =>  data <= "10011101";  -- 5D4D = 9D
      when "101110101001110" =>  data <= "00111111";  -- 5D4E = 3F
      when "101110101001111" =>  data <= "00000011";  -- 5D4F = 3
      when "101110101010000" =>  data <= "11101000";  -- 5D50 = E8
      when "101110101010001" =>  data <= "11100000";  -- 5D51 = E0
      when "101110101010010" =>  data <= "00000010";  -- 5D52 = 2
      when "101110101010011" =>  data <= "10010000";  -- 5D53 = 90
      when "101110101010100" =>  data <= "11110000";  -- 5D54 = F0
      when "101110101010101" =>  data <= "10101001";  -- 5D55 = A9
      when "101110101010110" =>  data <= "11111111";  -- 5D56 = FF
      when "101110101010111" =>  data <= "10001101";  -- 5D57 = 8D
      when "101110101011000" =>  data <= "00111101";  -- 5D58 = 3D
      when "101110101011001" =>  data <= "00000011";  -- 5D59 = 3
      when "101110101011010" =>  data <= "00100000";  -- 5D5A = 20
      when "101110101011011" =>  data <= "01110000";  -- 5D5B = 70
      when "101110101011100" =>  data <= "00000000";  -- 5D5C = 0
      when "101110101011101" =>  data <= "01001100";  -- 5D5D = 4C
      when "101110101011110" =>  data <= "10010110";  -- 5D5E = 96
      when "101110101011111" =>  data <= "11011101";  -- 5D5F = DD
      when "101110101100000" =>  data <= "10101101";  -- 5D60 = AD
      when "101110101100001" =>  data <= "00111110";  -- 5D61 = 3E
      when "101110101100010" =>  data <= "00000011";  -- 5D62 = 3
      when "101110101100011" =>  data <= "00101001";  -- 5D63 = 29
      when "101110101100100" =>  data <= "00000001";  -- 5D64 = 1
      when "101110101100101" =>  data <= "00100000";  -- 5D65 = 20
      when "101110101100110" =>  data <= "01001001";  -- 5D66 = 49
      when "101110101100111" =>  data <= "11011110";  -- 5D67 = DE
      when "101110101101000" =>  data <= "10000101";  -- 5D68 = 85
      when "101110101101001" =>  data <= "11010001";  -- 5D69 = D1
      when "101110101101010" =>  data <= "10001101";  -- 5D6A = 8D
      when "101110101101011" =>  data <= "01000001";  -- 5D6B = 41
      when "101110101101100" =>  data <= "00000011";  -- 5D6C = 3
      when "101110101101101" =>  data <= "10101001";  -- 5D6D = A9
      when "101110101101110" =>  data <= "01000010";  -- 5D6E = 42
      when "101110101101111" =>  data <= "10000101";  -- 5D6F = 85
      when "101110101110000" =>  data <= "11011010";  -- 5D70 = DA
      when "101110101110001" =>  data <= "10101001";  -- 5D71 = A9
      when "101110101110010" =>  data <= "00000011";  -- 5D72 = 3
      when "101110101110011" =>  data <= "10000101";  -- 5D73 = 85
      when "101110101110100" =>  data <= "11011011";  -- 5D74 = DB
      when "101110101110101" =>  data <= "10100000";  -- 5D75 = A0
      when "101110101110110" =>  data <= "00000000";  -- 5D76 = 0
      when "101110101110111" =>  data <= "10110001";  -- 5D77 = B1
      when "101110101111000" =>  data <= "00011111";  -- 5D78 = 1F
      when "101110101111001" =>  data <= "11000000";  -- 5D79 = C0
      when "101110101111010" =>  data <= "00000000";  -- 5D7A = 0
      when "101110101111011" =>  data <= "11010000";  -- 5D7B = D0
      when "101110101111100" =>  data <= "00001000";  -- 5D7C = 8
      when "101110101111101" =>  data <= "11001001";  -- 5D7D = C9
      when "101110101111110" =>  data <= "01000000";  -- 5D7E = 40
      when "101110101111111" =>  data <= "11010000";  -- 5D7F = D0
      when "101110110000000" =>  data <= "00000100";  -- 5D80 = 4
      when "101110110000001" =>  data <= "11100110";  -- 5D81 = E6
      when "101110110000010" =>  data <= "11011010";  -- 5D82 = DA
      when "101110110000011" =>  data <= "11000110";  -- 5D83 = C6
      when "101110110000100" =>  data <= "11010001";  -- 5D84 = D1
      when "101110110000101" =>  data <= "10011001";  -- 5D85 = 99
      when "101110110000110" =>  data <= "01000010";  -- 5D86 = 42
      when "101110110000111" =>  data <= "00000011";  -- 5D87 = 3
      when "101110110001000" =>  data <= "11001000";  -- 5D88 = C8
      when "101110110001001" =>  data <= "11001100";  -- 5D89 = CC
      when "101110110001010" =>  data <= "01000001";  -- 5D8A = 41
      when "101110110001011" =>  data <= "00000011";  -- 5D8B = 3
      when "101110110001100" =>  data <= "10010000";  -- 5D8C = 90
      when "101110110001101" =>  data <= "11101001";  -- 5D8D = E9
      when "101110110001110" =>  data <= "10101101";  -- 5D8E = AD
      when "101110110001111" =>  data <= "00111110";  -- 5D8F = 3E
      when "101110110010000" =>  data <= "00000011";  -- 5D90 = 3
      when "101110110010001" =>  data <= "00001001";  -- 5D91 = 9
      when "101110110010010" =>  data <= "00000001";  -- 5D92 = 1
      when "101110110010011" =>  data <= "10001101";  -- 5D93 = 8D
      when "101110110010100" =>  data <= "00111110";  -- 5D94 = 3E
      when "101110110010101" =>  data <= "00000011";  -- 5D95 = 3
      when "101110110010110" =>  data <= "00100000";  -- 5D96 = 20
      when "101110110010111" =>  data <= "01110110";  -- 5D97 = 76
      when "101110110011000" =>  data <= "00000000";  -- 5D98 = 0
      when "101110110011001" =>  data <= "11010000";  -- 5D99 = D0
      when "101110110011010" =>  data <= "00000011";  -- 5D9A = 3
      when "101110110011011" =>  data <= "01001100";  -- 5D9B = 4C
      when "101110110011100" =>  data <= "00000011";  -- 5D9C = 3
      when "101110110011101" =>  data <= "11011101";  -- 5D9D = DD
      when "101110110011110" =>  data <= "11001001";  -- 5D9E = C9
      when "101110110011111" =>  data <= "00101100";  -- 5D9F = 2C
      when "101110110100000" =>  data <= "11010000";  -- 5DA0 = D0
      when "101110110100001" =>  data <= "00000110";  -- 5DA1 = 6
      when "101110110100010" =>  data <= "00100000";  -- 5DA2 = 20
      when "101110110100011" =>  data <= "01110000";  -- 5DA3 = 70
      when "101110110100100" =>  data <= "00000000";  -- 5DA4 = 0
      when "101110110100101" =>  data <= "01001100";  -- 5DA5 = 4C
      when "101110110100110" =>  data <= "10001001";  -- 5DA6 = 89
      when "101110110100111" =>  data <= "11011100";  -- 5DA7 = DC
      when "101110110101000" =>  data <= "11001001";  -- 5DA8 = C9
      when "101110110101001" =>  data <= "10010001";  -- 5DA9 = 91
      when "101110110101010" =>  data <= "11010000";  -- 5DAA = D0
      when "101110110101011" =>  data <= "00000011";  -- 5DAB = 3
      when "101110110101100" =>  data <= "01001100";  -- 5DAC = 4C
      when "101110110101101" =>  data <= "00001001";  -- 5DAD = 9
      when "101110110101110" =>  data <= "11011101";  -- 5DAE = DD
      when "101110110101111" =>  data <= "11001001";  -- 5DAF = C9
      when "101110110110000" =>  data <= "10100100";  -- 5DB0 = A4
      when "101110110110001" =>  data <= "11110000";  -- 5DB1 = F0
      when "101110110110010" =>  data <= "00000011";  -- 5DB2 = 3
      when "101110110110011" =>  data <= "01001100";  -- 5DB3 = 4C
      when "101110110110100" =>  data <= "00000000";  -- 5DB4 = 0
      when "101110110110101" =>  data <= "10111111";  -- 5DB5 = BF
      when "101110110110110" =>  data <= "00100000";  -- 5DB6 = 20
      when "101110110110111" =>  data <= "01110000";  -- 5DB7 = 70
      when "101110110111000" =>  data <= "00000000";  -- 5DB8 = 0
      when "101110110111001" =>  data <= "11001001";  -- 5DB9 = C9
      when "101110110111010" =>  data <= "01000100";  -- 5DBA = 44
      when "101110110111011" =>  data <= "11110000";  -- 5DBB = F0
      when "101110110111100" =>  data <= "00010011";  -- 5DBC = 13
      when "101110110111101" =>  data <= "11001001";  -- 5DBD = C9
      when "101110110111110" =>  data <= "10010001";  -- 5DBE = 91
      when "101110110111111" =>  data <= "11110000";  -- 5DBF = F0
      when "101110111000000" =>  data <= "00101011";  -- 5DC0 = 2B
      when "101110111000001" =>  data <= "11001001";  -- 5DC1 = C9
      when "101110111000010" =>  data <= "01010101";  -- 5DC2 = 55
      when "101110111000011" =>  data <= "11110000";  -- 5DC3 = F0
      when "101110111000100" =>  data <= "00101101";  -- 5DC4 = 2D
      when "101110111000101" =>  data <= "11001001";  -- 5DC5 = C9
      when "101110111000110" =>  data <= "00100010";  -- 5DC6 = 22
      when "101110111000111" =>  data <= "11110000";  -- 5DC7 = F0
      when "101110111001000" =>  data <= "00101111";  -- 5DC8 = 2F
      when "101110111001001" =>  data <= "11001001";  -- 5DC9 = C9
      when "101110111001010" =>  data <= "00101000";  -- 5DCA = 28
      when "101110111001011" =>  data <= "11110000";  -- 5DCB = F0
      when "101110111001100" =>  data <= "00101011";  -- 5DCC = 2B
      when "101110111001101" =>  data <= "01001100";  -- 5DCD = 4C
      when "101110111001110" =>  data <= "00000000";  -- 5DCE = 0
      when "101110111001111" =>  data <= "10111111";  -- 5DCF = BF
      when "101110111010000" =>  data <= "10101101";  -- 5DD0 = AD
      when "101110111010001" =>  data <= "00111110";  -- 5DD1 = 3E
      when "101110111010010" =>  data <= "00000011";  -- 5DD2 = 3
      when "101110111010011" =>  data <= "00101001";  -- 5DD3 = 29
      when "101110111010100" =>  data <= "00100000";  -- 5DD4 = 20
      when "101110111010101" =>  data <= "11010000";  -- 5DD5 = D0
      when "101110111010110" =>  data <= "11110110";  -- 5DD6 = F6
      when "101110111010111" =>  data <= "00100000";  -- 5DD7 = 20
      when "101110111011000" =>  data <= "10000111";  -- 5DD8 = 87
      when "101110111011001" =>  data <= "11011110";  -- 5DD9 = DE
      when "101110111011010" =>  data <= "11100000";  -- 5DDA = E0
      when "101110111011011" =>  data <= "00000010";  -- 5DDB = 2
      when "101110111011100" =>  data <= "10110000";  -- 5DDC = B0
      when "101110111011101" =>  data <= "01001001";  -- 5DDD = 49
      when "101110111011110" =>  data <= "10001110";  -- 5DDE = 8E
      when "101110111011111" =>  data <= "00111100";  -- 5DDF = 3C
      when "101110111100000" =>  data <= "00000011";  -- 5DE0 = 3
      when "101110111100001" =>  data <= "10101101";  -- 5DE1 = AD
      when "101110111100010" =>  data <= "00111110";  -- 5DE2 = 3E
      when "101110111100011" =>  data <= "00000011";  -- 5DE3 = 3
      when "101110111100100" =>  data <= "00001001";  -- 5DE4 = 9
      when "101110111100101" =>  data <= "00100000";  -- 5DE5 = 20
      when "101110111100110" =>  data <= "10001101";  -- 5DE6 = 8D
      when "101110111100111" =>  data <= "00111110";  -- 5DE7 = 3E
      when "101110111101000" =>  data <= "00000011";  -- 5DE8 = 3
      when "101110111101001" =>  data <= "01001100";  -- 5DE9 = 4C
      when "101110111101010" =>  data <= "00001111";  -- 5DEA = F
      when "101110111101011" =>  data <= "11011110";  -- 5DEB = DE
      when "101110111101100" =>  data <= "00100000";  -- 5DEC = 20
      when "101110111101101" =>  data <= "00101100";  -- 5DED = 2C
      when "101110111101110" =>  data <= "11011110";  -- 5DEE = DE
      when "101110111101111" =>  data <= "01001100";  -- 5DEF = 4C
      when "101110111110000" =>  data <= "00001111";  -- 5DF0 = F
      when "101110111110001" =>  data <= "11011110";  -- 5DF1 = DE
      when "101110111110010" =>  data <= "00100000";  -- 5DF2 = 20
      when "101110111110011" =>  data <= "00110011";  -- 5DF3 = 33
      when "101110111110100" =>  data <= "11011110";  -- 5DF4 = DE
      when "101110111110101" =>  data <= "01001100";  -- 5DF5 = 4C
      when "101110111110110" =>  data <= "00001111";  -- 5DF6 = F
      when "101110111110111" =>  data <= "11011110";  -- 5DF7 = DE
      when "101110111111000" =>  data <= "10101101";  -- 5DF8 = AD
      when "101110111111001" =>  data <= "00111110";  -- 5DF9 = 3E
      when "101110111111010" =>  data <= "00000011";  -- 5DFA = 3
      when "101110111111011" =>  data <= "00101001";  -- 5DFB = 29
      when "101110111111100" =>  data <= "00000010";  -- 5DFC = 2
      when "101110111111101" =>  data <= "00100000";  -- 5DFD = 20
      when "101110111111110" =>  data <= "01001001";  -- 5DFE = 49
      when "101110111111111" =>  data <= "11011110";  -- 5DFF = DE
      when "101111000000000" =>  data <= "10001101";  -- 5E00 = 8D
      when "101111000000001" =>  data <= "00111010";  -- 5E01 = 3A
      when "101111000000010" =>  data <= "00000011";  -- 5E02 = 3
      when "101111000000011" =>  data <= "10000110";  -- 5E03 = 86
      when "101111000000100" =>  data <= "11111101";  -- 5E04 = FD
      when "101111000000101" =>  data <= "10000100";  -- 5E05 = 84
      when "101111000000110" =>  data <= "11111110";  -- 5E06 = FE
      when "101111000000111" =>  data <= "10101101";  -- 5E07 = AD
      when "101111000001000" =>  data <= "00111110";  -- 5E08 = 3E
      when "101111000001001" =>  data <= "00000011";  -- 5E09 = 3
      when "101111000001010" =>  data <= "00001001";  -- 5E0A = 9
      when "101111000001011" =>  data <= "00000010";  -- 5E0B = 2
      when "101111000001100" =>  data <= "10001101";  -- 5E0C = 8D
      when "101111000001101" =>  data <= "00111110";  -- 5E0D = 3E
      when "101111000001110" =>  data <= "00000011";  -- 5E0E = 3
      when "101111000001111" =>  data <= "00100000";  -- 5E0F = 20
      when "101111000010000" =>  data <= "01110110";  -- 5E10 = 76
      when "101111000010001" =>  data <= "00000000";  -- 5E11 = 0
      when "101111000010010" =>  data <= "11110000";  -- 5E12 = F0
      when "101111000010011" =>  data <= "00001111";  -- 5E13 = F
      when "101111000010100" =>  data <= "11001001";  -- 5E14 = C9
      when "101111000010101" =>  data <= "00101100";  -- 5E15 = 2C
      when "101111000010110" =>  data <= "11110000";  -- 5E16 = F0
      when "101111000010111" =>  data <= "10011110";  -- 5E17 = 9E
      when "101111000011000" =>  data <= "11001001";  -- 5E18 = C9
      when "101111000011001" =>  data <= "10010001";  -- 5E19 = 91
      when "101111000011010" =>  data <= "11110000";  -- 5E1A = F0
      when "101111000011011" =>  data <= "11010000";  -- 5E1B = D0
      when "101111000011100" =>  data <= "11001001";  -- 5E1C = C9
      when "101111000011101" =>  data <= "01010101";  -- 5E1D = 55
      when "101111000011110" =>  data <= "11110000";  -- 5E1E = F0
      when "101111000011111" =>  data <= "11010010";  -- 5E1F = D2
      when "101111000100000" =>  data <= "01001100";  -- 5E20 = 4C
      when "101111000100001" =>  data <= "00000000";  -- 5E21 = 0
      when "101111000100010" =>  data <= "10111111";  -- 5E22 = BF
      when "101111000100011" =>  data <= "10101101";  -- 5E23 = AD
      when "101111000100100" =>  data <= "00111110";  -- 5E24 = 3E
      when "101111000100101" =>  data <= "00000011";  -- 5E25 = 3
      when "101111000100110" =>  data <= "01100000";  -- 5E26 = 60
      when "101111000100111" =>  data <= "10100010";  -- 5E27 = A2
      when "101111000101000" =>  data <= "00110101";  -- 5E28 = 35
      when "101111000101001" =>  data <= "01001100";  -- 5E29 = 4C
      when "101111000101010" =>  data <= "11001111";  -- 5E2A = CF
      when "101111000101011" =>  data <= "10110011";  -- 5E2B = B3
      when "101111000101100" =>  data <= "00100000";  -- 5E2C = 20
      when "101111000101101" =>  data <= "01110000";  -- 5E2D = 70
      when "101111000101110" =>  data <= "00000000";  -- 5E2E = 0
      when "101111000101111" =>  data <= "11001001";  -- 5E2F = C9
      when "101111000110000" =>  data <= "01010101";  -- 5E30 = 55
      when "101111000110001" =>  data <= "11010000";  -- 5E31 = D0
      when "101111000110010" =>  data <= "11101101";  -- 5E32 = ED
      when "101111000110011" =>  data <= "00100000";  -- 5E33 = 20
      when "101111000110100" =>  data <= "10000111";  -- 5E34 = 87
      when "101111000110101" =>  data <= "11011110";  -- 5E35 = DE
      when "101111000110110" =>  data <= "11100000";  -- 5E36 = E0
      when "101111000110111" =>  data <= "00100000";  -- 5E37 = 20
      when "101111000111000" =>  data <= "10110000";  -- 5E38 = B0
      when "101111000111001" =>  data <= "11101101";  -- 5E39 = ED
      when "101111000111010" =>  data <= "11100000";  -- 5E3A = E0
      when "101111000111011" =>  data <= "00000011";  -- 5E3B = 3
      when "101111000111100" =>  data <= "10010000";  -- 5E3C = 90
      when "101111000111101" =>  data <= "11101001";  -- 5E3D = E9
      when "101111000111110" =>  data <= "10000110";  -- 5E3E = 86
      when "101111000111111" =>  data <= "11010100";  -- 5E3F = D4
      when "101111001000000" =>  data <= "10101101";  -- 5E40 = AD
      when "101111001000001" =>  data <= "00111110";  -- 5E41 = 3E
      when "101111001000010" =>  data <= "00000011";  -- 5E42 = 3
      when "101111001000011" =>  data <= "00001001";  -- 5E43 = 9
      when "101111001000100" =>  data <= "00001000";  -- 5E44 = 8
      when "101111001000101" =>  data <= "10001101";  -- 5E45 = 8D
      when "101111001000110" =>  data <= "00111110";  -- 5E46 = 3E
      when "101111001000111" =>  data <= "00000011";  -- 5E47 = 3
      when "101111001001000" =>  data <= "01100000";  -- 5E48 = 60
      when "101111001001001" =>  data <= "11010000";  -- 5E49 = D0
      when "101111001001010" =>  data <= "11010101";  -- 5E4A = D5
      when "101111001001011" =>  data <= "00100000";  -- 5E4B = 20
      when "101111001001100" =>  data <= "10011000";  -- 5E4C = 98
      when "101111001001101" =>  data <= "10111101";  -- 5E4D = BD
      when "101111001001110" =>  data <= "00100000";  -- 5E4E = 20
      when "101111001001111" =>  data <= "10110101";  -- 5E4F = B5
      when "101111001010000" =>  data <= "11000111";  -- 5E50 = C7
      when "101111001010001" =>  data <= "10101010";  -- 5E51 = AA
      when "101111001010010" =>  data <= "11001001";  -- 5E52 = C9
      when "101111001010011" =>  data <= "00000000";  -- 5E53 = 0
      when "101111001010100" =>  data <= "11110000";  -- 5E54 = F0
      when "101111001010101" =>  data <= "11010001";  -- 5E55 = D1
      when "101111001010110" =>  data <= "11001001";  -- 5E56 = C9
      when "101111001010111" =>  data <= "00010010";  -- 5E57 = 12
      when "101111001011000" =>  data <= "10110000";  -- 5E58 = B0
      when "101111001011001" =>  data <= "00011010";  -- 5E59 = 1A
      when "101111001011010" =>  data <= "10100000";  -- 5E5A = A0
      when "101111001011011" =>  data <= "00000000";  -- 5E5B = 0
      when "101111001011100" =>  data <= "10110001";  -- 5E5C = B1
      when "101111001011101" =>  data <= "00011111";  -- 5E5D = 1F
      when "101111001011110" =>  data <= "11001001";  -- 5E5E = C9
      when "101111001011111" =>  data <= "01000000";  -- 5E5F = 40
      when "101111001100000" =>  data <= "11010000";  -- 5E60 = D0
      when "101111001100001" =>  data <= "00001010";  -- 5E61 = A
      when "101111001100010" =>  data <= "10101101";  -- 5E62 = AD
      when "101111001100011" =>  data <= "00111110";  -- 5E63 = 3E
      when "101111001100100" =>  data <= "00000011";  -- 5E64 = 3
      when "101111001100101" =>  data <= "00101001";  -- 5E65 = 29
      when "101111001100110" =>  data <= "10000000";  -- 5E66 = 80
      when "101111001100111" =>  data <= "11110000";  -- 5E67 = F0
      when "101111001101000" =>  data <= "00010000";  -- 5E68 = 10
      when "101111001101001" =>  data <= "01001100";  -- 5E69 = 4C
      when "101111001101010" =>  data <= "00000000";  -- 5E6A = 0
      when "101111001101011" =>  data <= "10111111";  -- 5E6B = BF
      when "101111001101100" =>  data <= "10001010";  -- 5E6C = 8A
      when "101111001101101" =>  data <= "11001001";  -- 5E6D = C9
      when "101111001101110" =>  data <= "00010001";  -- 5E6E = 11
      when "101111001101111" =>  data <= "10110000";  -- 5E6F = B0
      when "101111001110000" =>  data <= "00000011";  -- 5E70 = 3
      when "101111001110001" =>  data <= "01001100";  -- 5E71 = 4C
      when "101111001110010" =>  data <= "10000010";  -- 5E72 = 82
      when "101111001110011" =>  data <= "11011110";  -- 5E73 = DE
      when "101111001110100" =>  data <= "10100010";  -- 5E74 = A2
      when "101111001110101" =>  data <= "10110000";  -- 5E75 = B0
      when "101111001110110" =>  data <= "01001100";  -- 5E76 = 4C
      when "101111001110111" =>  data <= "11001111";  -- 5E77 = CF
      when "101111001111000" =>  data <= "10110011";  -- 5E78 = B3
      when "101111001111001" =>  data <= "10101101";  -- 5E79 = AD
      when "101111001111010" =>  data <= "00111110";  -- 5E7A = 3E
      when "101111001111011" =>  data <= "00000011";  -- 5E7B = 3
      when "101111001111100" =>  data <= "00001001";  -- 5E7C = 9
      when "101111001111101" =>  data <= "10000000";  -- 5E7D = 80
      when "101111001111110" =>  data <= "10001101";  -- 5E7E = 8D
      when "101111001111111" =>  data <= "00111110";  -- 5E7F = 3E
      when "101111010000000" =>  data <= "00000011";  -- 5E80 = 3
      when "101111010000001" =>  data <= "10001010";  -- 5E81 = 8A
      when "101111010000010" =>  data <= "10100110";  -- 5E82 = A6
      when "101111010000011" =>  data <= "00011111";  -- 5E83 = 1F
      when "101111010000100" =>  data <= "10100100";  -- 5E84 = A4
      when "101111010000101" =>  data <= "00100000";  -- 5E85 = 20
      when "101111010000110" =>  data <= "01100000";  -- 5E86 = 60
      when "101111010000111" =>  data <= "00100000";  -- 5E87 = 20
      when "101111010001000" =>  data <= "01110000";  -- 5E88 = 70
      when "101111010001001" =>  data <= "00000000";  -- 5E89 = 0
      when "101111010001010" =>  data <= "11010000";  -- 5E8A = D0
      when "101111010001011" =>  data <= "00000011";  -- 5E8B = 3
      when "101111010001100" =>  data <= "01001100";  -- 5E8C = 4C
      when "101111010001101" =>  data <= "00000000";  -- 5E8D = 0
      when "101111010001110" =>  data <= "10111111";  -- 5E8E = BF
      when "101111010001111" =>  data <= "10010000";  -- 5E8F = 90
      when "101111010010000" =>  data <= "00001001";  -- 5E90 = 9
      when "101111010010001" =>  data <= "00100000";  -- 5E91 = 20
      when "101111010010010" =>  data <= "11110010";  -- 5E92 = F2
      when "101111010010011" =>  data <= "10111110";  -- 5E93 = BE
      when "101111010010100" =>  data <= "00100000";  -- 5E94 = 20
      when "101111010010101" =>  data <= "11010100";  -- 5E95 = D4
      when "101111010010110" =>  data <= "11001000";  -- 5E96 = C8
      when "101111010010111" =>  data <= "01001100";  -- 5E97 = 4C
      when "101111010011000" =>  data <= "11101111";  -- 5E98 = EF
      when "101111010011001" =>  data <= "10111110";  -- 5E99 = BE
      when "101111010011010" =>  data <= "01001100";  -- 5E9A = 4C
      when "101111010011011" =>  data <= "11010100";  -- 5E9B = D4
      when "101111010011100" =>  data <= "11001000";  -- 5E9C = C8
      when "101111010011101" =>  data <= "11110100";  -- 5E9D = F4
      when "101111010011110" =>  data <= "10000101";  -- 5E9E = 85
      when "101111010011111" =>  data <= "10010110";  -- 5E9F = 96
      when "101111010100000" =>  data <= "10010001";  -- 5EA0 = 91
      when "101111010100001" =>  data <= "00001110";  -- 5EA1 = E
      when "101111010100010" =>  data <= "10001000";  -- 5EA2 = 88
      when "101111010100011" =>  data <= "01100000";  -- 5EA3 = 60
      when "101111010100100" =>  data <= "00101010";  -- 5EA4 = 2A
      when "101111010100101" =>  data <= "00101010";  -- 5EA5 = 2A
      when "101111010100110" =>  data <= "00101010";  -- 5EA6 = 2A
      when "101111010100111" =>  data <= "00100000";  -- 5EA7 = 20
      when "101111010101000" =>  data <= "01000011";  -- 5EA8 = 43
      when "101111010101001" =>  data <= "01001111";  -- 5EA9 = 4F
      when "101111010101010" =>  data <= "01001101";  -- 5EAA = 4D
      when "101111010101011" =>  data <= "01001101";  -- 5EAB = 4D
      when "101111010101100" =>  data <= "01001111";  -- 5EAC = 4F
      when "101111010101101" =>  data <= "01000100";  -- 5EAD = 44
      when "101111010101110" =>  data <= "01001111";  -- 5EAE = 4F
      when "101111010101111" =>  data <= "01010010";  -- 5EAF = 52
      when "101111010110000" =>  data <= "01000101";  -- 5EB0 = 45
      when "101111010110001" =>  data <= "00100000";  -- 5EB1 = 20
      when "101111010110010" =>  data <= "01000010";  -- 5EB2 = 42
      when "101111010110011" =>  data <= "01000001";  -- 5EB3 = 41
      when "101111010110100" =>  data <= "01010011";  -- 5EB4 = 53
      when "101111010110101" =>  data <= "01001001";  -- 5EB5 = 49
      when "101111010110110" =>  data <= "01000011";  -- 5EB6 = 43
      when "101111010110111" =>  data <= "00100000";  -- 5EB7 = 20
      when "101111010111000" =>  data <= "00110100";  -- 5EB8 = 34
      when "101111010111001" =>  data <= "00101110";  -- 5EB9 = 2E
      when "101111010111010" =>  data <= "00110000";  -- 5EBA = 30
      when "101111010111011" =>  data <= "00100000";  -- 5EBB = 20
      when "101111010111100" =>  data <= "00101010";  -- 5EBC = 2A
      when "101111010111101" =>  data <= "00101010";  -- 5EBD = 2A
      when "101111010111110" =>  data <= "00101010";  -- 5EBE = 2A
      when "101111010111111" =>  data <= "00001101";  -- 5EBF = D
      when "101111011000000" =>  data <= "00001101";  -- 5EC0 = D
      when "101111011000001" =>  data <= "00000000";  -- 5EC1 = 0
      when "101111011000010" =>  data <= "10101010";  -- 5EC2 = AA
      when "101111011000011" =>  data <= "10101010";  -- 5EC3 = AA
      when "101111011000100" =>  data <= "10101010";  -- 5EC4 = AA
      when "101111011000101" =>  data <= "10101010";  -- 5EC5 = AA
      when "101111011000110" =>  data <= "10101010";  -- 5EC6 = AA
      when "101111011000111" =>  data <= "10101010";  -- 5EC7 = AA
      when "101111011001000" =>  data <= "10101010";  -- 5EC8 = AA
      when "101111011001001" =>  data <= "10101010";  -- 5EC9 = AA
      when "101111011001010" =>  data <= "10101010";  -- 5ECA = AA
      when "101111011001011" =>  data <= "10101010";  -- 5ECB = AA
      when "101111011001100" =>  data <= "10101010";  -- 5ECC = AA
      when "101111011001101" =>  data <= "10101010";  -- 5ECD = AA
      when "101111011001110" =>  data <= "10101010";  -- 5ECE = AA
      when "101111011001111" =>  data <= "10101010";  -- 5ECF = AA
      when "101111011010000" =>  data <= "10101010";  -- 5ED0 = AA
      when "101111011010001" =>  data <= "10101010";  -- 5ED1 = AA
      when "101111011010010" =>  data <= "10101010";  -- 5ED2 = AA
      when "101111011010011" =>  data <= "10101010";  -- 5ED3 = AA
      when "101111011010100" =>  data <= "10101010";  -- 5ED4 = AA
      when "101111011010101" =>  data <= "10101010";  -- 5ED5 = AA
      when "101111011010110" =>  data <= "10101010";  -- 5ED6 = AA
      when "101111011010111" =>  data <= "10101010";  -- 5ED7 = AA
      when "101111011011000" =>  data <= "10101010";  -- 5ED8 = AA
      when "101111011011001" =>  data <= "10101010";  -- 5ED9 = AA
      when "101111011011010" =>  data <= "10101010";  -- 5EDA = AA
      when "101111011011011" =>  data <= "10101010";  -- 5EDB = AA
      when "101111011011100" =>  data <= "10101010";  -- 5EDC = AA
      when "101111011011101" =>  data <= "10101010";  -- 5EDD = AA
      when "101111011011110" =>  data <= "10101010";  -- 5EDE = AA
      when "101111011011111" =>  data <= "10101010";  -- 5EDF = AA
      when "101111011100000" =>  data <= "10101010";  -- 5EE0 = AA
      when "101111011100001" =>  data <= "10101010";  -- 5EE1 = AA
      when "101111011100010" =>  data <= "10101010";  -- 5EE2 = AA
      when "101111011100011" =>  data <= "10101010";  -- 5EE3 = AA
      when "101111011100100" =>  data <= "10101010";  -- 5EE4 = AA
      when "101111011100101" =>  data <= "10101010";  -- 5EE5 = AA
      when "101111011100110" =>  data <= "10101010";  -- 5EE6 = AA
      when "101111011100111" =>  data <= "10101010";  -- 5EE7 = AA
      when "101111011101000" =>  data <= "10101010";  -- 5EE8 = AA
      when "101111011101001" =>  data <= "10101010";  -- 5EE9 = AA
      when "101111011101010" =>  data <= "10101010";  -- 5EEA = AA
      when "101111011101011" =>  data <= "10101010";  -- 5EEB = AA
      when "101111011101100" =>  data <= "10101010";  -- 5EEC = AA
      when "101111011101101" =>  data <= "10101010";  -- 5EED = AA
      when "101111011101110" =>  data <= "10101010";  -- 5EEE = AA
      when "101111011101111" =>  data <= "10101010";  -- 5EEF = AA
      when "101111011110000" =>  data <= "10101010";  -- 5EF0 = AA
      when "101111011110001" =>  data <= "10101010";  -- 5EF1 = AA
      when "101111011110010" =>  data <= "10101010";  -- 5EF2 = AA
      when "101111011110011" =>  data <= "10101010";  -- 5EF3 = AA
      when "101111011110100" =>  data <= "10101010";  -- 5EF4 = AA
      when "101111011110101" =>  data <= "10101010";  -- 5EF5 = AA
      when "101111011110110" =>  data <= "10101010";  -- 5EF6 = AA
      when "101111011110111" =>  data <= "10101010";  -- 5EF7 = AA
      when "101111011111000" =>  data <= "10101010";  -- 5EF8 = AA
      when "101111011111001" =>  data <= "10101010";  -- 5EF9 = AA
      when "101111011111010" =>  data <= "10101010";  -- 5EFA = AA
      when "101111011111011" =>  data <= "10101010";  -- 5EFB = AA
      when "101111011111100" =>  data <= "10101010";  -- 5EFC = AA
      when "101111011111101" =>  data <= "10101010";  -- 5EFD = AA
      when "101111011111110" =>  data <= "10101010";  -- 5EFE = AA
      when "101111011111111" =>  data <= "10101010";  -- 5EFF = AA
      when "101111100000000" =>  data <= "10101010";  -- 5F00 = AA
      when "101111100000001" =>  data <= "10101010";  -- 5F01 = AA
      when "101111100000010" =>  data <= "10101010";  -- 5F02 = AA
      when "101111100000011" =>  data <= "10101010";  -- 5F03 = AA
      when "101111100000100" =>  data <= "10101010";  -- 5F04 = AA
      when "101111100000101" =>  data <= "10101010";  -- 5F05 = AA
      when "101111100000110" =>  data <= "10101010";  -- 5F06 = AA
      when "101111100000111" =>  data <= "10101010";  -- 5F07 = AA
      when "101111100001000" =>  data <= "10101010";  -- 5F08 = AA
      when "101111100001001" =>  data <= "10101010";  -- 5F09 = AA
      when "101111100001010" =>  data <= "10101010";  -- 5F0A = AA
      when "101111100001011" =>  data <= "10101010";  -- 5F0B = AA
      when "101111100001100" =>  data <= "10101010";  -- 5F0C = AA
      when "101111100001101" =>  data <= "10101010";  -- 5F0D = AA
      when "101111100001110" =>  data <= "10101010";  -- 5F0E = AA
      when "101111100001111" =>  data <= "10101010";  -- 5F0F = AA
      when "101111100010000" =>  data <= "10101010";  -- 5F10 = AA
      when "101111100010001" =>  data <= "10101010";  -- 5F11 = AA
      when "101111100010010" =>  data <= "10101010";  -- 5F12 = AA
      when "101111100010011" =>  data <= "10101010";  -- 5F13 = AA
      when "101111100010100" =>  data <= "10101010";  -- 5F14 = AA
      when "101111100010101" =>  data <= "10101010";  -- 5F15 = AA
      when "101111100010110" =>  data <= "10101010";  -- 5F16 = AA
      when "101111100010111" =>  data <= "10101010";  -- 5F17 = AA
      when "101111100011000" =>  data <= "10101010";  -- 5F18 = AA
      when "101111100011001" =>  data <= "10101010";  -- 5F19 = AA
      when "101111100011010" =>  data <= "10101010";  -- 5F1A = AA
      when "101111100011011" =>  data <= "10101010";  -- 5F1B = AA
      when "101111100011100" =>  data <= "10101010";  -- 5F1C = AA
      when "101111100011101" =>  data <= "10101010";  -- 5F1D = AA
      when "101111100011110" =>  data <= "10101010";  -- 5F1E = AA
      when "101111100011111" =>  data <= "10101010";  -- 5F1F = AA
      when "101111100100000" =>  data <= "10101010";  -- 5F20 = AA
      when "101111100100001" =>  data <= "10101010";  -- 5F21 = AA
      when "101111100100010" =>  data <= "10101010";  -- 5F22 = AA
      when "101111100100011" =>  data <= "10101010";  -- 5F23 = AA
      when "101111100100100" =>  data <= "10101010";  -- 5F24 = AA
      when "101111100100101" =>  data <= "10101010";  -- 5F25 = AA
      when "101111100100110" =>  data <= "10101010";  -- 5F26 = AA
      when "101111100100111" =>  data <= "10101010";  -- 5F27 = AA
      when "101111100101000" =>  data <= "10101010";  -- 5F28 = AA
      when "101111100101001" =>  data <= "10101010";  -- 5F29 = AA
      when "101111100101010" =>  data <= "10101010";  -- 5F2A = AA
      when "101111100101011" =>  data <= "10101010";  -- 5F2B = AA
      when "101111100101100" =>  data <= "10101010";  -- 5F2C = AA
      when "101111100101101" =>  data <= "10101010";  -- 5F2D = AA
      when "101111100101110" =>  data <= "10101010";  -- 5F2E = AA
      when "101111100101111" =>  data <= "10101010";  -- 5F2F = AA
      when "101111100110000" =>  data <= "10101010";  -- 5F30 = AA
      when "101111100110001" =>  data <= "10101010";  -- 5F31 = AA
      when "101111100110010" =>  data <= "10101010";  -- 5F32 = AA
      when "101111100110011" =>  data <= "10101010";  -- 5F33 = AA
      when "101111100110100" =>  data <= "10101010";  -- 5F34 = AA
      when "101111100110101" =>  data <= "10101010";  -- 5F35 = AA
      when "101111100110110" =>  data <= "10101010";  -- 5F36 = AA
      when "101111100110111" =>  data <= "10101010";  -- 5F37 = AA
      when "101111100111000" =>  data <= "10101010";  -- 5F38 = AA
      when "101111100111001" =>  data <= "10101010";  -- 5F39 = AA
      when "101111100111010" =>  data <= "10101010";  -- 5F3A = AA
      when "101111100111011" =>  data <= "10101010";  -- 5F3B = AA
      when "101111100111100" =>  data <= "10101010";  -- 5F3C = AA
      when "101111100111101" =>  data <= "10101010";  -- 5F3D = AA
      when "101111100111110" =>  data <= "10101010";  -- 5F3E = AA
      when "101111100111111" =>  data <= "10101010";  -- 5F3F = AA
      when "101111101000000" =>  data <= "10101010";  -- 5F40 = AA
      when "101111101000001" =>  data <= "10101010";  -- 5F41 = AA
      when "101111101000010" =>  data <= "10101010";  -- 5F42 = AA
      when "101111101000011" =>  data <= "10101010";  -- 5F43 = AA
      when "101111101000100" =>  data <= "10101010";  -- 5F44 = AA
      when "101111101000101" =>  data <= "10101010";  -- 5F45 = AA
      when "101111101000110" =>  data <= "10101010";  -- 5F46 = AA
      when "101111101000111" =>  data <= "10101010";  -- 5F47 = AA
      when "101111101001000" =>  data <= "10101010";  -- 5F48 = AA
      when "101111101001001" =>  data <= "10101010";  -- 5F49 = AA
      when "101111101001010" =>  data <= "10101010";  -- 5F4A = AA
      when "101111101001011" =>  data <= "10101010";  -- 5F4B = AA
      when "101111101001100" =>  data <= "10101010";  -- 5F4C = AA
      when "101111101001101" =>  data <= "10101010";  -- 5F4D = AA
      when "101111101001110" =>  data <= "10101010";  -- 5F4E = AA
      when "101111101001111" =>  data <= "10101010";  -- 5F4F = AA
      when "101111101010000" =>  data <= "10101010";  -- 5F50 = AA
      when "101111101010001" =>  data <= "10101010";  -- 5F51 = AA
      when "101111101010010" =>  data <= "10101010";  -- 5F52 = AA
      when "101111101010011" =>  data <= "10101010";  -- 5F53 = AA
      when "101111101010100" =>  data <= "10101010";  -- 5F54 = AA
      when "101111101010101" =>  data <= "10101010";  -- 5F55 = AA
      when "101111101010110" =>  data <= "10101010";  -- 5F56 = AA
      when "101111101010111" =>  data <= "10101010";  -- 5F57 = AA
      when "101111101011000" =>  data <= "10101010";  -- 5F58 = AA
      when "101111101011001" =>  data <= "10101010";  -- 5F59 = AA
      when "101111101011010" =>  data <= "10101010";  -- 5F5A = AA
      when "101111101011011" =>  data <= "10101010";  -- 5F5B = AA
      when "101111101011100" =>  data <= "10101010";  -- 5F5C = AA
      when "101111101011101" =>  data <= "10101010";  -- 5F5D = AA
      when "101111101011110" =>  data <= "10101010";  -- 5F5E = AA
      when "101111101011111" =>  data <= "10101010";  -- 5F5F = AA
      when "101111101100000" =>  data <= "10101010";  -- 5F60 = AA
      when "101111101100001" =>  data <= "10101010";  -- 5F61 = AA
      when "101111101100010" =>  data <= "10101010";  -- 5F62 = AA
      when "101111101100011" =>  data <= "10101010";  -- 5F63 = AA
      when "101111101100100" =>  data <= "10101010";  -- 5F64 = AA
      when "101111101100101" =>  data <= "10101010";  -- 5F65 = AA
      when "101111101100110" =>  data <= "10101010";  -- 5F66 = AA
      when "101111101100111" =>  data <= "10101010";  -- 5F67 = AA
      when "101111101101000" =>  data <= "10101010";  -- 5F68 = AA
      when "101111101101001" =>  data <= "10101010";  -- 5F69 = AA
      when "101111101101010" =>  data <= "10101010";  -- 5F6A = AA
      when "101111101101011" =>  data <= "10101010";  -- 5F6B = AA
      when "101111101101100" =>  data <= "10101010";  -- 5F6C = AA
      when "101111101101101" =>  data <= "10101010";  -- 5F6D = AA
      when "101111101101110" =>  data <= "10101010";  -- 5F6E = AA
      when "101111101101111" =>  data <= "10101010";  -- 5F6F = AA
      when "101111101110000" =>  data <= "10101010";  -- 5F70 = AA
      when "101111101110001" =>  data <= "10101010";  -- 5F71 = AA
      when "101111101110010" =>  data <= "10101010";  -- 5F72 = AA
      when "101111101110011" =>  data <= "10101010";  -- 5F73 = AA
      when "101111101110100" =>  data <= "10101010";  -- 5F74 = AA
      when "101111101110101" =>  data <= "10101010";  -- 5F75 = AA
      when "101111101110110" =>  data <= "10101010";  -- 5F76 = AA
      when "101111101110111" =>  data <= "10101010";  -- 5F77 = AA
      when "101111101111000" =>  data <= "10101010";  -- 5F78 = AA
      when "101111101111001" =>  data <= "10101010";  -- 5F79 = AA
      when "101111101111010" =>  data <= "10101010";  -- 5F7A = AA
      when "101111101111011" =>  data <= "10101010";  -- 5F7B = AA
      when "101111101111100" =>  data <= "10101010";  -- 5F7C = AA
      when "101111101111101" =>  data <= "10101010";  -- 5F7D = AA
      when "101111101111110" =>  data <= "10101010";  -- 5F7E = AA
      when "101111101111111" =>  data <= "10101010";  -- 5F7F = AA
      when "101111110000000" =>  data <= "10101010";  -- 5F80 = AA
      when "101111110000001" =>  data <= "10101010";  -- 5F81 = AA
      when "101111110000010" =>  data <= "10101010";  -- 5F82 = AA
      when "101111110000011" =>  data <= "10101010";  -- 5F83 = AA
      when "101111110000100" =>  data <= "10101010";  -- 5F84 = AA
      when "101111110000101" =>  data <= "10101010";  -- 5F85 = AA
      when "101111110000110" =>  data <= "10101010";  -- 5F86 = AA
      when "101111110000111" =>  data <= "10101010";  -- 5F87 = AA
      when "101111110001000" =>  data <= "10101010";  -- 5F88 = AA
      when "101111110001001" =>  data <= "10101010";  -- 5F89 = AA
      when "101111110001010" =>  data <= "10101010";  -- 5F8A = AA
      when "101111110001011" =>  data <= "10101010";  -- 5F8B = AA
      when "101111110001100" =>  data <= "10101010";  -- 5F8C = AA
      when "101111110001101" =>  data <= "10101010";  -- 5F8D = AA
      when "101111110001110" =>  data <= "10101010";  -- 5F8E = AA
      when "101111110001111" =>  data <= "10101010";  -- 5F8F = AA
      when "101111110010000" =>  data <= "10101010";  -- 5F90 = AA
      when "101111110010001" =>  data <= "10101010";  -- 5F91 = AA
      when "101111110010010" =>  data <= "10101010";  -- 5F92 = AA
      when "101111110010011" =>  data <= "10101010";  -- 5F93 = AA
      when "101111110010100" =>  data <= "10101010";  -- 5F94 = AA
      when "101111110010101" =>  data <= "10101010";  -- 5F95 = AA
      when "101111110010110" =>  data <= "10101010";  -- 5F96 = AA
      when "101111110010111" =>  data <= "10101010";  -- 5F97 = AA
      when "101111110011000" =>  data <= "10101010";  -- 5F98 = AA
      when "101111110011001" =>  data <= "10101010";  -- 5F99 = AA
      when "101111110011010" =>  data <= "10101010";  -- 5F9A = AA
      when "101111110011011" =>  data <= "10101010";  -- 5F9B = AA
      when "101111110011100" =>  data <= "10101010";  -- 5F9C = AA
      when "101111110011101" =>  data <= "10101010";  -- 5F9D = AA
      when "101111110011110" =>  data <= "10101010";  -- 5F9E = AA
      when "101111110011111" =>  data <= "10101010";  -- 5F9F = AA
      when "101111110100000" =>  data <= "10101010";  -- 5FA0 = AA
      when "101111110100001" =>  data <= "10101010";  -- 5FA1 = AA
      when "101111110100010" =>  data <= "10101010";  -- 5FA2 = AA
      when "101111110100011" =>  data <= "10101010";  -- 5FA3 = AA
      when "101111110100100" =>  data <= "10101010";  -- 5FA4 = AA
      when "101111110100101" =>  data <= "10101010";  -- 5FA5 = AA
      when "101111110100110" =>  data <= "10101010";  -- 5FA6 = AA
      when "101111110100111" =>  data <= "10101010";  -- 5FA7 = AA
      when "101111110101000" =>  data <= "10101010";  -- 5FA8 = AA
      when "101111110101001" =>  data <= "10101010";  -- 5FA9 = AA
      when "101111110101010" =>  data <= "10101010";  -- 5FAA = AA
      when "101111110101011" =>  data <= "10101010";  -- 5FAB = AA
      when "101111110101100" =>  data <= "10101010";  -- 5FAC = AA
      when "101111110101101" =>  data <= "10101010";  -- 5FAD = AA
      when "101111110101110" =>  data <= "10101010";  -- 5FAE = AA
      when "101111110101111" =>  data <= "10101010";  -- 5FAF = AA
      when "101111110110000" =>  data <= "10101010";  -- 5FB0 = AA
      when "101111110110001" =>  data <= "10101010";  -- 5FB1 = AA
      when "101111110110010" =>  data <= "10101010";  -- 5FB2 = AA
      when "101111110110011" =>  data <= "10101010";  -- 5FB3 = AA
      when "101111110110100" =>  data <= "10101010";  -- 5FB4 = AA
      when "101111110110101" =>  data <= "10101010";  -- 5FB5 = AA
      when "101111110110110" =>  data <= "10101010";  -- 5FB6 = AA
      when "101111110110111" =>  data <= "10101010";  -- 5FB7 = AA
      when "101111110111000" =>  data <= "10101010";  -- 5FB8 = AA
      when "101111110111001" =>  data <= "10101010";  -- 5FB9 = AA
      when "101111110111010" =>  data <= "10101010";  -- 5FBA = AA
      when "101111110111011" =>  data <= "10101010";  -- 5FBB = AA
      when "101111110111100" =>  data <= "10101010";  -- 5FBC = AA
      when "101111110111101" =>  data <= "10101010";  -- 5FBD = AA
      when "101111110111110" =>  data <= "10101010";  -- 5FBE = AA
      when "101111110111111" =>  data <= "10101010";  -- 5FBF = AA
      when "101111111000000" =>  data <= "10101010";  -- 5FC0 = AA
      when "101111111000001" =>  data <= "10101010";  -- 5FC1 = AA
      when "101111111000010" =>  data <= "10101010";  -- 5FC2 = AA
      when "101111111000011" =>  data <= "10101010";  -- 5FC3 = AA
      when "101111111000100" =>  data <= "10101010";  -- 5FC4 = AA
      when "101111111000101" =>  data <= "10101010";  -- 5FC5 = AA
      when "101111111000110" =>  data <= "10101010";  -- 5FC6 = AA
      when "101111111000111" =>  data <= "10101010";  -- 5FC7 = AA
      when "101111111001000" =>  data <= "10101010";  -- 5FC8 = AA
      when "101111111001001" =>  data <= "10101010";  -- 5FC9 = AA
      when "101111111001010" =>  data <= "10101010";  -- 5FCA = AA
      when "101111111001011" =>  data <= "10101010";  -- 5FCB = AA
      when "101111111001100" =>  data <= "10101010";  -- 5FCC = AA
      when "101111111001101" =>  data <= "10101010";  -- 5FCD = AA
      when "101111111001110" =>  data <= "10101010";  -- 5FCE = AA
      when "101111111001111" =>  data <= "10101010";  -- 5FCF = AA
      when "101111111010000" =>  data <= "10101010";  -- 5FD0 = AA
      when "101111111010001" =>  data <= "10101010";  -- 5FD1 = AA
      when "101111111010010" =>  data <= "10101010";  -- 5FD2 = AA
      when "101111111010011" =>  data <= "10101010";  -- 5FD3 = AA
      when "101111111010100" =>  data <= "10101010";  -- 5FD4 = AA
      when "101111111010101" =>  data <= "10101010";  -- 5FD5 = AA
      when "101111111010110" =>  data <= "10101010";  -- 5FD6 = AA
      when "101111111010111" =>  data <= "10101010";  -- 5FD7 = AA
      when "101111111011000" =>  data <= "10101010";  -- 5FD8 = AA
      when "101111111011001" =>  data <= "10101010";  -- 5FD9 = AA
      when "101111111011010" =>  data <= "10101010";  -- 5FDA = AA
      when "101111111011011" =>  data <= "10101010";  -- 5FDB = AA
      when "101111111011100" =>  data <= "10101010";  -- 5FDC = AA
      when "101111111011101" =>  data <= "10101010";  -- 5FDD = AA
      when "101111111011110" =>  data <= "10101010";  -- 5FDE = AA
      when "101111111011111" =>  data <= "10101010";  -- 5FDF = AA
      when "101111111100000" =>  data <= "10101010";  -- 5FE0 = AA
      when "101111111100001" =>  data <= "10101010";  -- 5FE1 = AA
      when "101111111100010" =>  data <= "10101010";  -- 5FE2 = AA
      when "101111111100011" =>  data <= "10101010";  -- 5FE3 = AA
      when "101111111100100" =>  data <= "10101010";  -- 5FE4 = AA
      when "101111111100101" =>  data <= "10101010";  -- 5FE5 = AA
      when "101111111100110" =>  data <= "10101010";  -- 5FE6 = AA
      when "101111111100111" =>  data <= "10101010";  -- 5FE7 = AA
      when "101111111101000" =>  data <= "10101010";  -- 5FE8 = AA
      when "101111111101001" =>  data <= "10101010";  -- 5FE9 = AA
      when "101111111101010" =>  data <= "10101010";  -- 5FEA = AA
      when "101111111101011" =>  data <= "10101010";  -- 5FEB = AA
      when "101111111101100" =>  data <= "10101010";  -- 5FEC = AA
      when "101111111101101" =>  data <= "10101010";  -- 5FED = AA
      when "101111111101110" =>  data <= "10101010";  -- 5FEE = AA
      when "101111111101111" =>  data <= "10101010";  -- 5FEF = AA
      when "101111111110000" =>  data <= "10101010";  -- 5FF0 = AA
      when "101111111110001" =>  data <= "10101010";  -- 5FF1 = AA
      when "101111111110010" =>  data <= "10101010";  -- 5FF2 = AA
      when "101111111110011" =>  data <= "10101010";  -- 5FF3 = AA
      when "101111111110100" =>  data <= "10101010";  -- 5FF4 = AA
      when "101111111110101" =>  data <= "10101010";  -- 5FF5 = AA
      when "101111111110110" =>  data <= "10101010";  -- 5FF6 = AA
      when "101111111110111" =>  data <= "10101010";  -- 5FF7 = AA
      when "101111111111000" =>  data <= "10101010";  -- 5FF8 = AA
      when "101111111111001" =>  data <= "10101010";  -- 5FF9 = AA
      when "101111111111010" =>  data <= "10101010";  -- 5FFA = AA
      when "101111111111011" =>  data <= "10101010";  -- 5FFB = AA
      when "101111111111100" =>  data <= "10101010";  -- 5FFC = AA
      when "101111111111101" =>  data <= "10101010";  -- 5FFD = AA
      when "101111111111110" =>  data <= "10101010";  -- 5FFE = AA
      when "101111111111111" =>  data <= "10101010";  -- 5FFF = AA
      when "110000000000000" =>  data <= "01001100";  -- 6000 = 4C
      when "110000000000001" =>  data <= "00110110";  -- 6001 = 36
      when "110000000000010" =>  data <= "11100000";  -- 6002 = E0
      when "110000000000011" =>  data <= "01001100";  -- 6003 = 4C
      when "110000000000100" =>  data <= "10100111";  -- 6004 = A7
      when "110000000000101" =>  data <= "11100000";  -- 6005 = E0
      when "110000000000110" =>  data <= "01001100";  -- 6006 = 4C
      when "110000000000111" =>  data <= "00010110";  -- 6007 = 16
      when "110000000001000" =>  data <= "11100001";  -- 6008 = E1
      when "110000000001001" =>  data <= "01001100";  -- 6009 = 4C
      when "110000000001010" =>  data <= "00000010";  -- 600A = 2
      when "110000000001011" =>  data <= "11100010";  -- 600B = E2
      when "110000000001100" =>  data <= "01001100";  -- 600C = 4C
      when "110000000001101" =>  data <= "01000010";  -- 600D = 42
      when "110000000001110" =>  data <= "11100100";  -- 600E = E4
      when "110000000001111" =>  data <= "01001100";  -- 600F = 4C
      when "110000000010000" =>  data <= "01010101";  -- 6010 = 55
      when "110000000010001" =>  data <= "11100100";  -- 6011 = E4
      when "110000000010010" =>  data <= "01001100";  -- 6012 = 4C
      when "110000000010011" =>  data <= "00000000";  -- 6013 = 0
      when "110000000010100" =>  data <= "11100110";  -- 6014 = E6
      when "110000000010101" =>  data <= "01001100";  -- 6015 = 4C
      when "110000000010110" =>  data <= "01000010";  -- 6016 = 42
      when "110000000010111" =>  data <= "11100000";  -- 6017 = E0
      when "110000000011000" =>  data <= "01001100";  -- 6018 = 4C
      when "110000000011001" =>  data <= "00001111";  -- 6019 = F
      when "110000000011010" =>  data <= "11100110";  -- 601A = E6
      when "110000000011011" =>  data <= "01001100";  -- 601B = 4C
      when "110000000011100" =>  data <= "00010111";  -- 601C = 17
      when "110000000011101" =>  data <= "11100110";  -- 601D = E6
      when "110000000011110" =>  data <= "01001100";  -- 601E = 4C
      when "110000000011111" =>  data <= "00011101";  -- 601F = 1D
      when "110000000100000" =>  data <= "11100110";  -- 6020 = E6
      when "110000000100001" =>  data <= "01001100";  -- 6021 = 4C
      when "110000000100010" =>  data <= "11101010";  -- 6022 = EA
      when "110000000100011" =>  data <= "11100110";  -- 6023 = E6
      when "110000000100100" =>  data <= "01001100";  -- 6024 = 4C
      when "110000000100101" =>  data <= "11010001";  -- 6025 = D1
      when "110000000100110" =>  data <= "11100011";  -- 6026 = E3
      when "110000000100111" =>  data <= "01001100";  -- 6027 = 4C
      when "110000000101000" =>  data <= "10111111";  -- 6028 = BF
      when "110000000101001" =>  data <= "11100100";  -- 6029 = E4
      when "110000000101010" =>  data <= "01001100";  -- 602A = 4C
      when "110000000101011" =>  data <= "01010111";  -- 602B = 57
      when "110000000101100" =>  data <= "11100110";  -- 602C = E6
      when "110000000101101" =>  data <= "01001100";  -- 602D = 4C
      when "110000000101110" =>  data <= "10011000";  -- 602E = 98
      when "110000000101111" =>  data <= "11100000";  -- 602F = E0
      when "110000000110000" =>  data <= "01001100";  -- 6030 = 4C
      when "110000000110001" =>  data <= "10011000";  -- 6031 = 98
      when "110000000110010" =>  data <= "11100000";  -- 6032 = E0
      when "110000000110011" =>  data <= "01001100";  -- 6033 = 4C
      when "110000000110100" =>  data <= "10011000";  -- 6034 = 98
      when "110000000110101" =>  data <= "11100000";  -- 6035 = E0
      when "110000000110110" =>  data <= "00100000";  -- 6036 = 20
      when "110000000110111" =>  data <= "10000011";  -- 6037 = 83
      when "110000000111000" =>  data <= "11100110";  -- 6038 = E6
      when "110000000111001" =>  data <= "00100000";  -- 6039 = 20
      when "110000000111010" =>  data <= "00010111";  -- 603A = 17
      when "110000000111011" =>  data <= "11100110";  -- 603B = E6
      when "110000000111100" =>  data <= "00100000";  -- 603C = 20
      when "110000000111101" =>  data <= "01010100";  -- 603D = 54
      when "110000000111110" =>  data <= "11100110";  -- 603E = E6
      when "110000000111111" =>  data <= "00100000";  -- 603F = 20
      when "110000001000000" =>  data <= "01010100";  -- 6040 = 54
      when "110000001000001" =>  data <= "11100110";  -- 6041 = E6
      when "110000001000010" =>  data <= "10100010";  -- 6042 = A2
      when "110000001000011" =>  data <= "00011000";  -- 6043 = 18
      when "110000001000100" =>  data <= "10101001";  -- 6044 = A9
      when "110000001000101" =>  data <= "11000000";  -- 6045 = C0
      when "110000001000110" =>  data <= "10100000";  -- 6046 = A0
      when "110000001000111" =>  data <= "10000011";  -- 6047 = 83
      when "110000001001000" =>  data <= "10010100";  -- 6048 = 94
      when "110000001001001" =>  data <= "11100000";  -- 6049 = E0
      when "110000001001010" =>  data <= "00111000";  -- 604A = 38
      when "110000001001011" =>  data <= "11101001";  -- 604B = E9
      when "110000001001100" =>  data <= "00101000";  -- 604C = 28
      when "110000001001101" =>  data <= "10110000";  -- 604D = B0
      when "110000001001110" =>  data <= "00000001";  -- 604E = 1
      when "110000001001111" =>  data <= "10001000";  -- 604F = 88
      when "110000001010000" =>  data <= "11001010";  -- 6050 = CA
      when "110000001010001" =>  data <= "00010000";  -- 6051 = 10
      when "110000001010010" =>  data <= "11110101";  -- 6052 = F5
      when "110000001010011" =>  data <= "10000100";  -- 6053 = 84
      when "110000001010100" =>  data <= "11000101";  -- 6054 = C5
      when "110000001010101" =>  data <= "11101000";  -- 6055 = E8
      when "110000001010110" =>  data <= "10000110";  -- 6056 = 86
      when "110000001010111" =>  data <= "10011111";  -- 6057 = 9F
      when "110000001011000" =>  data <= "10000110";  -- 6058 = 86
      when "110000001011001" =>  data <= "11000100";  -- 6059 = C4
      when "110000001011010" =>  data <= "10101001";  -- 605A = A9
      when "110000001011011" =>  data <= "00100000";  -- 605B = 20
      when "110000001011100" =>  data <= "10011101";  -- 605C = 9D
      when "110000001011101" =>  data <= "00000000";  -- 605D = 0
      when "110000001011110" =>  data <= "10000000";  -- 605E = 80
      when "110000001011111" =>  data <= "10011101";  -- 605F = 9D
      when "110000001100000" =>  data <= "00000000";  -- 6060 = 0
      when "110000001100001" =>  data <= "10000001";  -- 6061 = 81
      when "110000001100010" =>  data <= "10011101";  -- 6062 = 9D
      when "110000001100011" =>  data <= "00000000";  -- 6063 = 0
      when "110000001100100" =>  data <= "10000010";  -- 6064 = 82
      when "110000001100101" =>  data <= "10011101";  -- 6065 = 9D
      when "110000001100110" =>  data <= "00000000";  -- 6066 = 0
      when "110000001100111" =>  data <= "10000011";  -- 6067 = 83
      when "110000001101000" =>  data <= "11101000";  -- 6068 = E8
      when "110000001101001" =>  data <= "11010000";  -- 6069 = D0
      when "110000001101010" =>  data <= "11110001";  -- 606A = F1
      when "110000001101011" =>  data <= "10100000";  -- 606B = A0
      when "110000001101100" =>  data <= "00000000";  -- 606C = 0
      when "110000001101101" =>  data <= "10000100";  -- 606D = 84
      when "110000001101110" =>  data <= "11000110";  -- 606E = C6
      when "110000001101111" =>  data <= "10000100";  -- 606F = 84
      when "110000001110000" =>  data <= "11011000";  -- 6070 = D8
      when "110000001110001" =>  data <= "10100110";  -- 6071 = A6
      when "110000001110010" =>  data <= "11011000";  -- 6072 = D8
      when "110000001110011" =>  data <= "10110101";  -- 6073 = B5
      when "110000001110100" =>  data <= "11100000";  -- 6074 = E0
      when "110000001110101" =>  data <= "00001001";  -- 6075 = 9
      when "110000001110110" =>  data <= "10000000";  -- 6076 = 80
      when "110000001110111" =>  data <= "10000101";  -- 6077 = 85
      when "110000001111000" =>  data <= "11000101";  -- 6078 = C5
      when "110000001111001" =>  data <= "10111101";  -- 6079 = BD
      when "110000001111010" =>  data <= "10011000";  -- 607A = 98
      when "110000001111011" =>  data <= "11100111";  -- 607B = E7
      when "110000001111100" =>  data <= "10000101";  -- 607C = 85
      when "110000001111101" =>  data <= "11000100";  -- 607D = C4
      when "110000001111110" =>  data <= "10101001";  -- 607E = A9
      when "110000001111111" =>  data <= "00100111";  -- 607F = 27
      when "110000010000000" =>  data <= "10000101";  -- 6080 = 85
      when "110000010000001" =>  data <= "11010101";  -- 6081 = D5
      when "110000010000010" =>  data <= "11100000";  -- 6082 = E0
      when "110000010000011" =>  data <= "00011000";  -- 6083 = 18
      when "110000010000100" =>  data <= "11110000";  -- 6084 = F0
      when "110000010000101" =>  data <= "00001000";  -- 6085 = 8
      when "110000010000110" =>  data <= "10110101";  -- 6086 = B5
      when "110000010000111" =>  data <= "11100001";  -- 6087 = E1
      when "110000010001000" =>  data <= "00110000";  -- 6088 = 30
      when "110000010001001" =>  data <= "00000100";  -- 6089 = 4
      when "110000010001010" =>  data <= "10101001";  -- 608A = A9
      when "110000010001011" =>  data <= "01001111";  -- 608B = 4F
      when "110000010001100" =>  data <= "10000101";  -- 608C = 85
      when "110000010001101" =>  data <= "11010101";  -- 608D = D5
      when "110000010001110" =>  data <= "10100101";  -- 608E = A5
      when "110000010001111" =>  data <= "11000110";  -- 608F = C6
      when "110000010010000" =>  data <= "11001001";  -- 6090 = C9
      when "110000010010001" =>  data <= "00101000";  -- 6091 = 28
      when "110000010010010" =>  data <= "10010000";  -- 6092 = 90
      when "110000010010011" =>  data <= "00000100";  -- 6093 = 4
      when "110000010010100" =>  data <= "11101001";  -- 6094 = E9
      when "110000010010101" =>  data <= "00101000";  -- 6095 = 28
      when "110000010010110" =>  data <= "10000101";  -- 6096 = 85
      when "110000010010111" =>  data <= "11000110";  -- 6097 = C6
      when "110000010011000" =>  data <= "01100000";  -- 6098 = 60
      when "110000010011001" =>  data <= "10101010";  -- 6099 = AA
      when "110000010011010" =>  data <= "10101010";  -- 609A = AA
      when "110000010011011" =>  data <= "10101010";  -- 609B = AA
      when "110000010011100" =>  data <= "10101010";  -- 609C = AA
      when "110000010011101" =>  data <= "10101010";  -- 609D = AA
      when "110000010011110" =>  data <= "10101010";  -- 609E = AA
      when "110000010011111" =>  data <= "10101010";  -- 609F = AA
      when "110000010100000" =>  data <= "10101010";  -- 60A0 = AA
      when "110000010100001" =>  data <= "10101010";  -- 60A1 = AA
      when "110000010100010" =>  data <= "10101010";  -- 60A2 = AA
      when "110000010100011" =>  data <= "10101010";  -- 60A3 = AA
      when "110000010100100" =>  data <= "10101010";  -- 60A4 = AA
      when "110000010100101" =>  data <= "10101010";  -- 60A5 = AA
      when "110000010100110" =>  data <= "10101010";  -- 60A6 = AA
      when "110000010100111" =>  data <= "10101100";  -- 60A7 = AC
      when "110000010101000" =>  data <= "01101111";  -- 60A8 = 6F
      when "110000010101001" =>  data <= "00000010";  -- 60A9 = 2
      when "110000010101010" =>  data <= "10100010";  -- 60AA = A2
      when "110000010101011" =>  data <= "00000000";  -- 60AB = 0
      when "110000010101100" =>  data <= "10111101";  -- 60AC = BD
      when "110000010101101" =>  data <= "01110000";  -- 60AD = 70
      when "110000010101110" =>  data <= "00000010";  -- 60AE = 2
      when "110000010101111" =>  data <= "10011101";  -- 60AF = 9D
      when "110000010110000" =>  data <= "01101111";  -- 60B0 = 6F
      when "110000010110001" =>  data <= "00000010";  -- 60B1 = 2
      when "110000010110010" =>  data <= "11101000";  -- 60B2 = E8
      when "110000010110011" =>  data <= "11100100";  -- 60B3 = E4
      when "110000010110100" =>  data <= "10011110";  -- 60B4 = 9E
      when "110000010110101" =>  data <= "11010000";  -- 60B5 = D0
      when "110000010110110" =>  data <= "11110101";  -- 60B6 = F5
      when "110000010110111" =>  data <= "11000110";  -- 60B7 = C6
      when "110000010111000" =>  data <= "10011110";  -- 60B8 = 9E
      when "110000010111001" =>  data <= "10011000";  -- 60B9 = 98
      when "110000010111010" =>  data <= "01011000";  -- 60BA = 58
      when "110000010111011" =>  data <= "01100000";  -- 60BB = 60
      when "110000010111100" =>  data <= "00100000";  -- 60BC = 20
      when "110000010111101" =>  data <= "00111100";  -- 60BD = 3C
      when "110000010111110" =>  data <= "11100110";  -- 60BE = E6
      when "110000010111111" =>  data <= "10100101";  -- 60BF = A5
      when "110000011000000" =>  data <= "10011110";  -- 60C0 = 9E
      when "110000011000001" =>  data <= "10000101";  -- 60C1 = 85
      when "110000011000010" =>  data <= "10100111";  -- 60C2 = A7
      when "110000011000011" =>  data <= "11110000";  -- 60C3 = F0
      when "110000011000100" =>  data <= "11111010";  -- 60C4 = FA
      when "110000011000101" =>  data <= "01111000";  -- 60C5 = 78
      when "110000011000110" =>  data <= "10100101";  -- 60C6 = A5
      when "110000011000111" =>  data <= "10101010";  -- 60C7 = AA
      when "110000011001000" =>  data <= "11110000";  -- 60C8 = F0
      when "110000011001001" =>  data <= "00001001";  -- 60C9 = 9
      when "110000011001010" =>  data <= "10100101";  -- 60CA = A5
      when "110000011001011" =>  data <= "10101001";  -- 60CB = A9
      when "110000011001100" =>  data <= "10100000";  -- 60CC = A0
      when "110000011001101" =>  data <= "00000000";  -- 60CD = 0
      when "110000011001110" =>  data <= "10000100";  -- 60CE = 84
      when "110000011001111" =>  data <= "10101010";  -- 60CF = AA
      when "110000011010000" =>  data <= "00100000";  -- 60D0 = 20
      when "110000011010001" =>  data <= "00000110";  -- 60D1 = 6
      when "110000011010010" =>  data <= "11100110";  -- 60D2 = E6
      when "110000011010011" =>  data <= "00100000";  -- 60D3 = 20
      when "110000011010100" =>  data <= "10100111";  -- 60D4 = A7
      when "110000011010101" =>  data <= "11100000";  -- 60D5 = E0
      when "110000011010110" =>  data <= "11001001";  -- 60D6 = C9
      when "110000011010111" =>  data <= "10000011";  -- 60D7 = 83
      when "110000011011000" =>  data <= "11010000";  -- 60D8 = D0
      when "110000011011001" =>  data <= "00010000";  -- 60D9 = 10
      when "110000011011010" =>  data <= "01111000";  -- 60DA = 78
      when "110000011011011" =>  data <= "10100010";  -- 60DB = A2
      when "110000011011100" =>  data <= "00001001";  -- 60DC = 9
      when "110000011011101" =>  data <= "10000110";  -- 60DD = 86
      when "110000011011110" =>  data <= "10011110";  -- 60DE = 9E
      when "110000011011111" =>  data <= "10111101";  -- 60DF = BD
      when "110000011100000" =>  data <= "10001110";  -- 60E0 = 8E
      when "110000011100001" =>  data <= "11100111";  -- 60E1 = E7
      when "110000011100010" =>  data <= "10011101";  -- 60E2 = 9D
      when "110000011100011" =>  data <= "01101110";  -- 60E3 = 6E
      when "110000011100100" =>  data <= "00000010";  -- 60E4 = 2
      when "110000011100101" =>  data <= "11001010";  -- 60E5 = CA
      when "110000011100110" =>  data <= "11010000";  -- 60E6 = D0
      when "110000011100111" =>  data <= "11110111";  -- 60E7 = F7
      when "110000011101000" =>  data <= "11110000";  -- 60E8 = F0
      when "110000011101001" =>  data <= "11010101";  -- 60E9 = D5
      when "110000011101010" =>  data <= "11001001";  -- 60EA = C9
      when "110000011101011" =>  data <= "00001101";  -- 60EB = D
      when "110000011101100" =>  data <= "11010000";  -- 60EC = D0
      when "110000011101101" =>  data <= "11001110";  -- 60ED = CE
      when "110000011101110" =>  data <= "10100100";  -- 60EE = A4
      when "110000011101111" =>  data <= "11010101";  -- 60EF = D5
      when "110000011110000" =>  data <= "10000100";  -- 60F0 = 84
      when "110000011110001" =>  data <= "10101100";  -- 60F1 = AC
      when "110000011110010" =>  data <= "10110001";  -- 60F2 = B1
      when "110000011110011" =>  data <= "11000100";  -- 60F3 = C4
      when "110000011110100" =>  data <= "11001001";  -- 60F4 = C9
      when "110000011110101" =>  data <= "00100000";  -- 60F5 = 20
      when "110000011110110" =>  data <= "11010000";  -- 60F6 = D0
      when "110000011110111" =>  data <= "00000011";  -- 60F7 = 3
      when "110000011111000" =>  data <= "10001000";  -- 60F8 = 88
      when "110000011111001" =>  data <= "11010000";  -- 60F9 = D0
      when "110000011111010" =>  data <= "11110111";  -- 60FA = F7
      when "110000011111011" =>  data <= "11001000";  -- 60FB = C8
      when "110000011111100" =>  data <= "10000100";  -- 60FC = 84
      when "110000011111101" =>  data <= "10100001";  -- 60FD = A1
      when "110000011111110" =>  data <= "10100000";  -- 60FE = A0
      when "110000011111111" =>  data <= "00000000";  -- 60FF = 0
      when "110000100000000" =>  data <= "10000100";  -- 6100 = 84
      when "110000100000001" =>  data <= "11000110";  -- 6101 = C6
      when "110000100000010" =>  data <= "10000100";  -- 6102 = 84
      when "110000100000011" =>  data <= "11001101";  -- 6103 = CD
      when "110000100000100" =>  data <= "10100101";  -- 6104 = A5
      when "110000100000101" =>  data <= "10100011";  -- 6105 = A3
      when "110000100000110" =>  data <= "00110000";  -- 6106 = 30
      when "110000100000111" =>  data <= "00010110";  -- 6107 = 16
      when "110000100001000" =>  data <= "11000101";  -- 6108 = C5
      when "110000100001001" =>  data <= "11011000";  -- 6109 = D8
      when "110000100001010" =>  data <= "11010000";  -- 610A = D0
      when "110000100001011" =>  data <= "00010010";  -- 610B = 12
      when "110000100001100" =>  data <= "10100101";  -- 610C = A5
      when "110000100001101" =>  data <= "10100100";  -- 610D = A4
      when "110000100001110" =>  data <= "10000101";  -- 610E = 85
      when "110000100001111" =>  data <= "11000110";  -- 610F = C6
      when "110000100010000" =>  data <= "11000101";  -- 6110 = C5
      when "110000100010001" =>  data <= "10100001";  -- 6111 = A1
      when "110000100010010" =>  data <= "10010000";  -- 6112 = 90
      when "110000100010011" =>  data <= "00001010";  -- 6113 = A
      when "110000100010100" =>  data <= "10110000";  -- 6114 = B0
      when "110000100010101" =>  data <= "00101011";  -- 6115 = 2B
      when "110000100010110" =>  data <= "10011000";  -- 6116 = 98
      when "110000100010111" =>  data <= "01001000";  -- 6117 = 48
      when "110000100011000" =>  data <= "10001010";  -- 6118 = 8A
      when "110000100011001" =>  data <= "01001000";  -- 6119 = 48
      when "110000100011010" =>  data <= "10100101";  -- 611A = A5
      when "110000100011011" =>  data <= "10101100";  -- 611B = AC
      when "110000100011100" =>  data <= "11110000";  -- 611C = F0
      when "110000100011101" =>  data <= "10100001";  -- 611D = A1
      when "110000100011110" =>  data <= "10100100";  -- 611E = A4
      when "110000100011111" =>  data <= "11000110";  -- 611F = C6
      when "110000100100000" =>  data <= "10110001";  -- 6120 = B1
      when "110000100100001" =>  data <= "11000100";  -- 6121 = C4
      when "110000100100010" =>  data <= "10000101";  -- 6122 = 85
      when "110000100100011" =>  data <= "11011001";  -- 6123 = D9
      when "110000100100100" =>  data <= "00101001";  -- 6124 = 29
      when "110000100100101" =>  data <= "00111111";  -- 6125 = 3F
      when "110000100100110" =>  data <= "00000110";  -- 6126 = 6
      when "110000100100111" =>  data <= "11011001";  -- 6127 = D9
      when "110000100101000" =>  data <= "00100100";  -- 6128 = 24
      when "110000100101001" =>  data <= "11011001";  -- 6129 = D9
      when "110000100101010" =>  data <= "00010000";  -- 612A = 10
      when "110000100101011" =>  data <= "00000010";  -- 612B = 2
      when "110000100101100" =>  data <= "00001001";  -- 612C = 9
      when "110000100101101" =>  data <= "10000000";  -- 612D = 80
      when "110000100101110" =>  data <= "10010000";  -- 612E = 90
      when "110000100101111" =>  data <= "00000100";  -- 612F = 4
      when "110000100110000" =>  data <= "10100110";  -- 6130 = A6
      when "110000100110001" =>  data <= "11001101";  -- 6131 = CD
      when "110000100110010" =>  data <= "11010000";  -- 6132 = D0
      when "110000100110011" =>  data <= "00000100";  -- 6133 = 4
      when "110000100110100" =>  data <= "01110000";  -- 6134 = 70
      when "110000100110101" =>  data <= "00000010";  -- 6135 = 2
      when "110000100110110" =>  data <= "00001001";  -- 6136 = 9
      when "110000100110111" =>  data <= "01000000";  -- 6137 = 40
      when "110000100111000" =>  data <= "11100110";  -- 6138 = E6
      when "110000100111001" =>  data <= "11000110";  -- 6139 = C6
      when "110000100111010" =>  data <= "00100000";  -- 613A = 20
      when "110000100111011" =>  data <= "01100111";  -- 613B = 67
      when "110000100111100" =>  data <= "11100001";  -- 613C = E1
      when "110000100111101" =>  data <= "11000100";  -- 613D = C4
      when "110000100111110" =>  data <= "10100001";  -- 613E = A1
      when "110000100111111" =>  data <= "11010000";  -- 613F = D0
      when "110000101000000" =>  data <= "00010111";  -- 6140 = 17
      when "110000101000001" =>  data <= "10101001";  -- 6141 = A9
      when "110000101000010" =>  data <= "00000000";  -- 6142 = 0
      when "110000101000011" =>  data <= "10000101";  -- 6143 = 85
      when "110000101000100" =>  data <= "10101100";  -- 6144 = AC
      when "110000101000101" =>  data <= "10101001";  -- 6145 = A9
      when "110000101000110" =>  data <= "00001101";  -- 6146 = D
      when "110000101000111" =>  data <= "10100110";  -- 6147 = A6
      when "110000101001000" =>  data <= "10101111";  -- 6148 = AF
      when "110000101001001" =>  data <= "11100000";  -- 6149 = E0
      when "110000101001010" =>  data <= "00000011";  -- 614A = 3
      when "110000101001011" =>  data <= "11110000";  -- 614B = F0
      when "110000101001100" =>  data <= "00000110";  -- 614C = 6
      when "110000101001101" =>  data <= "10100110";  -- 614D = A6
      when "110000101001110" =>  data <= "10110000";  -- 614E = B0
      when "110000101001111" =>  data <= "11100000";  -- 614F = E0
      when "110000101010000" =>  data <= "00000011";  -- 6150 = 3
      when "110000101010001" =>  data <= "11110000";  -- 6151 = F0
      when "110000101010010" =>  data <= "00000011";  -- 6152 = 3
      when "110000101010011" =>  data <= "00100000";  -- 6153 = 20
      when "110000101010100" =>  data <= "00000010";  -- 6154 = 2
      when "110000101010101" =>  data <= "11100010";  -- 6155 = E2
      when "110000101010110" =>  data <= "10101001";  -- 6156 = A9
      when "110000101010111" =>  data <= "00001101";  -- 6157 = D
      when "110000101011000" =>  data <= "10000101";  -- 6158 = 85
      when "110000101011001" =>  data <= "11011001";  -- 6159 = D9
      when "110000101011010" =>  data <= "01101000";  -- 615A = 68
      when "110000101011011" =>  data <= "10101010";  -- 615B = AA
      when "110000101011100" =>  data <= "01101000";  -- 615C = 68
      when "110000101011101" =>  data <= "10101000";  -- 615D = A8
      when "110000101011110" =>  data <= "10100101";  -- 615E = A5
      when "110000101011111" =>  data <= "11011001";  -- 615F = D9
      when "110000101100000" =>  data <= "11001001";  -- 6160 = C9
      when "110000101100001" =>  data <= "11011110";  -- 6161 = DE
      when "110000101100010" =>  data <= "11010000";  -- 6162 = D0
      when "110000101100011" =>  data <= "00000010";  -- 6163 = 2
      when "110000101100100" =>  data <= "10101001";  -- 6164 = A9
      when "110000101100101" =>  data <= "11111111";  -- 6165 = FF
      when "110000101100110" =>  data <= "01100000";  -- 6166 = 60
      when "110000101100111" =>  data <= "11001001";  -- 6167 = C9
      when "110000101101000" =>  data <= "00100010";  -- 6168 = 22
      when "110000101101001" =>  data <= "11010000";  -- 6169 = D0
      when "110000101101010" =>  data <= "00001000";  -- 616A = 8
      when "110000101101011" =>  data <= "10100101";  -- 616B = A5
      when "110000101101100" =>  data <= "11001101";  -- 616C = CD
      when "110000101101101" =>  data <= "01001001";  -- 616D = 49
      when "110000101101110" =>  data <= "00000001";  -- 616E = 1
      when "110000101101111" =>  data <= "10000101";  -- 616F = 85
      when "110000101110000" =>  data <= "11001101";  -- 6170 = CD
      when "110000101110001" =>  data <= "10101001";  -- 6171 = A9
      when "110000101110010" =>  data <= "00100010";  -- 6172 = 22
      when "110000101110011" =>  data <= "01100000";  -- 6173 = 60
      when "110000101110100" =>  data <= "00001001";  -- 6174 = 9
      when "110000101110101" =>  data <= "01000000";  -- 6175 = 40
      when "110000101110110" =>  data <= "10100110";  -- 6176 = A6
      when "110000101110111" =>  data <= "10011111";  -- 6177 = 9F
      when "110000101111000" =>  data <= "11110000";  -- 6178 = F0
      when "110000101111001" =>  data <= "00000010";  -- 6179 = 2
      when "110000101111010" =>  data <= "00001001";  -- 617A = 9
      when "110000101111011" =>  data <= "10000000";  -- 617B = 80
      when "110000101111100" =>  data <= "10100110";  -- 617C = A6
      when "110000101111101" =>  data <= "11011100";  -- 617D = DC
      when "110000101111110" =>  data <= "11110000";  -- 617E = F0
      when "110000101111111" =>  data <= "00000010";  -- 617F = 2
      when "110000110000000" =>  data <= "11000110";  -- 6180 = C6
      when "110000110000001" =>  data <= "11011100";  -- 6181 = DC
      when "110000110000010" =>  data <= "00100000";  -- 6182 = 20
      when "110000110000011" =>  data <= "00000110";  -- 6183 = 6
      when "110000110000100" =>  data <= "11100110";  -- 6184 = E6
      when "110000110000101" =>  data <= "11100110";  -- 6185 = E6
      when "110000110000110" =>  data <= "11000110";  -- 6186 = C6
      when "110000110000111" =>  data <= "10100100";  -- 6187 = A4
      when "110000110001000" =>  data <= "11010101";  -- 6188 = D5
      when "110000110001001" =>  data <= "11000100";  -- 6189 = C4
      when "110000110001010" =>  data <= "11000110";  -- 618A = C6
      when "110000110001011" =>  data <= "10110000";  -- 618B = B0
      when "110000110001100" =>  data <= "00011001";  -- 618C = 19
      when "110000110001101" =>  data <= "10100110";  -- 618D = A6
      when "110000110001110" =>  data <= "11011000";  -- 618E = D8
      when "110000110001111" =>  data <= "11000000";  -- 618F = C0
      when "110000110010000" =>  data <= "01001111";  -- 6190 = 4F
      when "110000110010001" =>  data <= "11010000";  -- 6191 = D0
      when "110000110010010" =>  data <= "00001100";  -- 6192 = C
      when "110000110010011" =>  data <= "00100000";  -- 6193 = 20
      when "110000110010100" =>  data <= "10110011";  -- 6194 = B3
      when "110000110010101" =>  data <= "11100001";  -- 6195 = E1
      when "110000110010110" =>  data <= "00100000";  -- 6196 = 20
      when "110000110010111" =>  data <= "10101001";  -- 6197 = A9
      when "110000110011000" =>  data <= "11100011";  -- 6198 = E3
      when "110000110011001" =>  data <= "10101001";  -- 6199 = A9
      when "110000110011010" =>  data <= "00000000";  -- 619A = 0
      when "110000110011011" =>  data <= "10000101";  -- 619B = 85
      when "110000110011100" =>  data <= "11000110";  -- 619C = C6
      when "110000110011101" =>  data <= "11110000";  -- 619D = F0
      when "110000110011110" =>  data <= "00000111";  -- 619E = 7
      when "110000110011111" =>  data <= "11100000";  -- 619F = E0
      when "110000110100000" =>  data <= "00011000";  -- 61A0 = 18
      when "110000110100001" =>  data <= "11010000";  -- 61A1 = D0
      when "110000110100010" =>  data <= "00011011";  -- 61A2 = 1B
      when "110000110100011" =>  data <= "00100000";  -- 61A3 = 20
      when "110000110100100" =>  data <= "11000100";  -- 61A4 = C4
      when "110000110100101" =>  data <= "11100001";  -- 61A5 = E1
      when "110000110100110" =>  data <= "01101000";  -- 61A6 = 68
      when "110000110100111" =>  data <= "10101000";  -- 61A7 = A8
      when "110000110101000" =>  data <= "10100101";  -- 61A8 = A5
      when "110000110101001" =>  data <= "11011100";  -- 61A9 = DC
      when "110000110101010" =>  data <= "11110000";  -- 61AA = F0
      when "110000110101011" =>  data <= "00000010";  -- 61AB = 2
      when "110000110101100" =>  data <= "01000110";  -- 61AC = 46
      when "110000110101101" =>  data <= "11001101";  -- 61AD = CD
      when "110000110101110" =>  data <= "01101000";  -- 61AE = 68
      when "110000110101111" =>  data <= "10101010";  -- 61AF = AA
      when "110000110110000" =>  data <= "01101000";  -- 61B0 = 68
      when "110000110110001" =>  data <= "01011000";  -- 61B1 = 58
      when "110000110110010" =>  data <= "01100000";  -- 61B2 = 60
      when "110000110110011" =>  data <= "11100000";  -- 61B3 = E0
      when "110000110110100" =>  data <= "00010111";  -- 61B4 = 17
      when "110000110110101" =>  data <= "10110000";  -- 61B5 = B0
      when "110000110110110" =>  data <= "00000110";  -- 61B6 = 6
      when "110000110110111" =>  data <= "10110101";  -- 61B7 = B5
      when "110000110111000" =>  data <= "11100010";  -- 61B8 = E2
      when "110000110111001" =>  data <= "00001001";  -- 61B9 = 9
      when "110000110111010" =>  data <= "10000000";  -- 61BA = 80
      when "110000110111011" =>  data <= "10010101";  -- 61BB = 95
      when "110000110111100" =>  data <= "11100010";  -- 61BC = E2
      when "110000110111101" =>  data <= "01100000";  -- 61BD = 60
      when "110000110111110" =>  data <= "00100000";  -- 61BE = 20
      when "110000110111111" =>  data <= "11001101";  -- 61BF = CD
      when "110000111000000" =>  data <= "11100001";  -- 61C0 = E1
      when "110000111000001" =>  data <= "01001100";  -- 61C1 = 4C
      when "110000111000010" =>  data <= "10100110";  -- 61C2 = A6
      when "110000111000011" =>  data <= "11100001";  -- 61C3 = E1
      when "110000111000100" =>  data <= "00100000";  -- 61C4 = 20
      when "110000111000101" =>  data <= "11010001";  -- 61C5 = D1
      when "110000111000110" =>  data <= "11100011";  -- 61C6 = E3
      when "110000111000111" =>  data <= "11000110";  -- 61C7 = C6
      when "110000111001000" =>  data <= "10100011";  -- 61C8 = A3
      when "110000111001001" =>  data <= "11000110";  -- 61C9 = C6
      when "110000111001010" =>  data <= "11011000";  -- 61CA = D8
      when "110000111001011" =>  data <= "10100110";  -- 61CB = A6
      when "110000111001100" =>  data <= "11011000";  -- 61CC = D8
      when "110000111001101" =>  data <= "00010110";  -- 61CD = 16
      when "110000111001110" =>  data <= "11100001";  -- 61CE = E1
      when "110000111001111" =>  data <= "01010110";  -- 61CF = 56
      when "110000111010000" =>  data <= "11100001";  -- 61D0 = E1
      when "110000111010001" =>  data <= "00100000";  -- 61D1 = 20
      when "110000111010010" =>  data <= "10110011";  -- 61D2 = B3
      when "110000111010011" =>  data <= "11100001";  -- 61D3 = E1
      when "110000111010100" =>  data <= "10100101";  -- 61D4 = A5
      when "110000111010101" =>  data <= "11000110";  -- 61D5 = C6
      when "110000111010110" =>  data <= "01001000";  -- 61D6 = 48
      when "110000111010111" =>  data <= "00100000";  -- 61D7 = 20
      when "110000111011000" =>  data <= "01110001";  -- 61D8 = 71
      when "110000111011001" =>  data <= "11100000";  -- 61D9 = E0
      when "110000111011010" =>  data <= "01101000";  -- 61DA = 68
      when "110000111011011" =>  data <= "10000101";  -- 61DB = 85
      when "110000111011100" =>  data <= "11000110";  -- 61DC = C6
      when "110000111011101" =>  data <= "01100000";  -- 61DD = 60
      when "110000111011110" =>  data <= "10100000";  -- 61DE = A0
      when "110000111011111" =>  data <= "00100111";  -- 61DF = 27
      when "110000111100000" =>  data <= "10100110";  -- 61E0 = A6
      when "110000111100001" =>  data <= "11011000";  -- 61E1 = D8
      when "110000111100010" =>  data <= "11010000";  -- 61E2 = D0
      when "110000111100011" =>  data <= "00000110";  -- 61E3 = 6
      when "110000111100100" =>  data <= "10000110";  -- 61E4 = 86
      when "110000111100101" =>  data <= "11000110";  -- 61E5 = C6
      when "110000111100110" =>  data <= "01101000";  -- 61E6 = 68
      when "110000111100111" =>  data <= "01101000";  -- 61E7 = 68
      when "110000111101000" =>  data <= "11010000";  -- 61E8 = D0
      when "110000111101001" =>  data <= "10111100";  -- 61E9 = BC
      when "110000111101010" =>  data <= "10110101";  -- 61EA = B5
      when "110000111101011" =>  data <= "11011111";  -- 61EB = DF
      when "110000111101100" =>  data <= "00110000";  -- 61EC = 30
      when "110000111101101" =>  data <= "00000101";  -- 61ED = 5
      when "110000111101110" =>  data <= "11001010";  -- 61EE = CA
      when "110000111101111" =>  data <= "10110101";  -- 61EF = B5
      when "110000111110000" =>  data <= "11011111";  -- 61F0 = DF
      when "110000111110001" =>  data <= "10100000";  -- 61F1 = A0
      when "110000111110010" =>  data <= "01001111";  -- 61F2 = 4F
      when "110000111110011" =>  data <= "11001010";  -- 61F3 = CA
      when "110000111110100" =>  data <= "10000110";  -- 61F4 = 86
      when "110000111110101" =>  data <= "11011000";  -- 61F5 = D8
      when "110000111110110" =>  data <= "10000101";  -- 61F6 = 85
      when "110000111110111" =>  data <= "11000101";  -- 61F7 = C5
      when "110000111111000" =>  data <= "10111101";  -- 61F8 = BD
      when "110000111111001" =>  data <= "10011000";  -- 61F9 = 98
      when "110000111111010" =>  data <= "11100111";  -- 61FA = E7
      when "110000111111011" =>  data <= "10000101";  -- 61FB = 85
      when "110000111111100" =>  data <= "11000100";  -- 61FC = C4
      when "110000111111101" =>  data <= "10000100";  -- 61FD = 84
      when "110000111111110" =>  data <= "11000110";  -- 61FE = C6
      when "110000111111111" =>  data <= "10000100";  -- 61FF = 84
      when "110001000000000" =>  data <= "11010101";  -- 6200 = D5
      when "110001000000001" =>  data <= "01100000";  -- 6201 = 60
      when "110001000000010" =>  data <= "01001000";  -- 6202 = 48
      when "110001000000011" =>  data <= "10000101";  -- 6203 = 85
      when "110001000000100" =>  data <= "11011001";  -- 6204 = D9
      when "110001000000101" =>  data <= "10001010";  -- 6205 = 8A
      when "110001000000110" =>  data <= "01001000";  -- 6206 = 48
      when "110001000000111" =>  data <= "10011000";  -- 6207 = 98
      when "110001000001000" =>  data <= "01001000";  -- 6208 = 48
      when "110001000001001" =>  data <= "10101001";  -- 6209 = A9
      when "110001000001010" =>  data <= "00000000";  -- 620A = 0
      when "110001000001011" =>  data <= "10000101";  -- 620B = 85
      when "110001000001100" =>  data <= "10101100";  -- 620C = AC
      when "110001000001101" =>  data <= "10100100";  -- 620D = A4
      when "110001000001110" =>  data <= "11000110";  -- 620E = C6
      when "110001000001111" =>  data <= "10100101";  -- 620F = A5
      when "110001000010000" =>  data <= "11011001";  -- 6210 = D9
      when "110001000010001" =>  data <= "00101001";  -- 6211 = 29
      when "110001000010010" =>  data <= "01111111";  -- 6212 = 7F
      when "110001000010011" =>  data <= "11001001";  -- 6213 = C9
      when "110001000010100" =>  data <= "00011011";  -- 6214 = 1B
      when "110001000010101" =>  data <= "11010000";  -- 6215 = D0
      when "110001000010110" =>  data <= "00000011";  -- 6216 = 3
      when "110001000010111" =>  data <= "01001100";  -- 6217 = 4C
      when "110001000011000" =>  data <= "11000110";  -- 6218 = C6
      when "110001000011001" =>  data <= "11100011";  -- 6219 = E3
      when "110001000011010" =>  data <= "10100101";  -- 621A = A5
      when "110001000011011" =>  data <= "11011001";  -- 621B = D9
      when "110001000011100" =>  data <= "00010000";  -- 621C = 10
      when "110001000011101" =>  data <= "00000011";  -- 621D = 3
      when "110001000011110" =>  data <= "01001100";  -- 621E = 4C
      when "110001000011111" =>  data <= "11010101";  -- 621F = D5
      when "110001000100000" =>  data <= "11100010";  -- 6220 = E2
      when "110001000100001" =>  data <= "11001001";  -- 6221 = C9
      when "110001000100010" =>  data <= "00001101";  -- 6222 = D
      when "110001000100011" =>  data <= "11010000";  -- 6223 = D0
      when "110001000100100" =>  data <= "00000011";  -- 6224 = 3
      when "110001000100101" =>  data <= "01001100";  -- 6225 = 4C
      when "110001000100110" =>  data <= "10111111";  -- 6226 = BF
      when "110001000100111" =>  data <= "11100011";  -- 6227 = E3
      when "110001000101000" =>  data <= "11001001";  -- 6228 = C9
      when "110001000101001" =>  data <= "00100000";  -- 6229 = 20
      when "110001000101010" =>  data <= "10010000";  -- 622A = 90
      when "110001000101011" =>  data <= "00001000";  -- 622B = 8
      when "110001000101100" =>  data <= "00101001";  -- 622C = 29
      when "110001000101101" =>  data <= "00111111";  -- 622D = 3F
      when "110001000101110" =>  data <= "00100000";  -- 622E = 20
      when "110001000101111" =>  data <= "01100111";  -- 622F = 67
      when "110001000110000" =>  data <= "11100001";  -- 6230 = E1
      when "110001000110001" =>  data <= "01001100";  -- 6231 = 4C
      when "110001000110010" =>  data <= "01110110";  -- 6232 = 76
      when "110001000110011" =>  data <= "11100001";  -- 6233 = E1
      when "110001000110100" =>  data <= "10100110";  -- 6234 = A6
      when "110001000110101" =>  data <= "11011100";  -- 6235 = DC
      when "110001000110110" =>  data <= "11110000";  -- 6236 = F0
      when "110001000110111" =>  data <= "00000011";  -- 6237 = 3
      when "110001000111000" =>  data <= "01001100";  -- 6238 = 4C
      when "110001000111001" =>  data <= "01111010";  -- 6239 = 7A
      when "110001000111010" =>  data <= "11100001";  -- 623A = E1
      when "110001000111011" =>  data <= "11001001";  -- 623B = C9
      when "110001000111100" =>  data <= "00010100";  -- 623C = 14
      when "110001000111101" =>  data <= "11010000";  -- 623D = D0
      when "110001000111110" =>  data <= "00011100";  -- 623E = 1C
      when "110001000111111" =>  data <= "10001000";  -- 623F = 88
      when "110001001000000" =>  data <= "10000100";  -- 6240 = 84
      when "110001001000001" =>  data <= "11000110";  -- 6241 = C6
      when "110001001000010" =>  data <= "00010000";  -- 6242 = 10
      when "110001001000011" =>  data <= "00000110";  -- 6243 = 6
      when "110001001000100" =>  data <= "00100000";  -- 6244 = 20
      when "110001001000101" =>  data <= "11011110";  -- 6245 = DE
      when "110001001000110" =>  data <= "11100001";  -- 6246 = E1
      when "110001001000111" =>  data <= "01001100";  -- 6247 = 4C
      when "110001001001000" =>  data <= "01010101";  -- 6248 = 55
      when "110001001001001" =>  data <= "11100010";  -- 6249 = E2
      when "110001001001010" =>  data <= "11001000";  -- 624A = C8
      when "110001001001011" =>  data <= "10110001";  -- 624B = B1
      when "110001001001100" =>  data <= "11000100";  -- 624C = C4
      when "110001001001101" =>  data <= "10001000";  -- 624D = 88
      when "110001001001110" =>  data <= "10010001";  -- 624E = 91
      when "110001001001111" =>  data <= "11000100";  -- 624F = C4
      when "110001001010000" =>  data <= "11001000";  -- 6250 = C8
      when "110001001010001" =>  data <= "11000100";  -- 6251 = C4
      when "110001001010010" =>  data <= "11010101";  -- 6252 = D5
      when "110001001010011" =>  data <= "11010000";  -- 6253 = D0
      when "110001001010100" =>  data <= "11110101";  -- 6254 = F5
      when "110001001010101" =>  data <= "10101001";  -- 6255 = A9
      when "110001001010110" =>  data <= "00100000";  -- 6256 = 20
      when "110001001010111" =>  data <= "10010001";  -- 6257 = 91
      when "110001001011000" =>  data <= "11000100";  -- 6258 = C4
      when "110001001011001" =>  data <= "11010000";  -- 6259 = D0
      when "110001001011010" =>  data <= "00101001";  -- 625A = 29
      when "110001001011011" =>  data <= "10100110";  -- 625B = A6
      when "110001001011100" =>  data <= "11001101";  -- 625C = CD
      when "110001001011101" =>  data <= "11110000";  -- 625D = F0
      when "110001001011110" =>  data <= "00000011";  -- 625E = 3
      when "110001001011111" =>  data <= "01001100";  -- 625F = 4C
      when "110001001100000" =>  data <= "01111010";  -- 6260 = 7A
      when "110001001100001" =>  data <= "11100001";  -- 6261 = E1
      when "110001001100010" =>  data <= "11001001";  -- 6262 = C9
      when "110001001100011" =>  data <= "00010010";  -- 6263 = 12
      when "110001001100100" =>  data <= "11010000";  -- 6264 = D0
      when "110001001100101" =>  data <= "00000100";  -- 6265 = 4
      when "110001001100110" =>  data <= "10000101";  -- 6266 = 85
      when "110001001100111" =>  data <= "10011111";  -- 6267 = 9F
      when "110001001101000" =>  data <= "11110000";  -- 6268 = F0
      when "110001001101001" =>  data <= "00011010";  -- 6269 = 1A
      when "110001001101010" =>  data <= "11001001";  -- 626A = C9
      when "110001001101011" =>  data <= "00010011";  -- 626B = 13
      when "110001001101100" =>  data <= "11010000";  -- 626C = D0
      when "110001001101101" =>  data <= "00000011";  -- 626D = 3
      when "110001001101110" =>  data <= "00100000";  -- 626E = 20
      when "110001001101111" =>  data <= "01101011";  -- 626F = 6B
      when "110001001110000" =>  data <= "11100000";  -- 6270 = E0
      when "110001001110001" =>  data <= "11001001";  -- 6271 = C9
      when "110001001110010" =>  data <= "00011101";  -- 6272 = 1D
      when "110001001110011" =>  data <= "11010000";  -- 6273 = D0
      when "110001001110100" =>  data <= "00010010";  -- 6274 = 12
      when "110001001110101" =>  data <= "11001000";  -- 6275 = C8
      when "110001001110110" =>  data <= "10000100";  -- 6276 = 84
      when "110001001110111" =>  data <= "11000110";  -- 6277 = C6
      when "110001001111000" =>  data <= "10001000";  -- 6278 = 88
      when "110001001111001" =>  data <= "11000100";  -- 6279 = C4
      when "110001001111010" =>  data <= "11010101";  -- 627A = D5
      when "110001001111011" =>  data <= "10010000";  -- 627B = 90
      when "110001001111100" =>  data <= "00000111";  -- 627C = 7
      when "110001001111101" =>  data <= "00100000";  -- 627D = 20
      when "110001001111110" =>  data <= "10101001";  -- 627E = A9
      when "110001001111111" =>  data <= "11100011";  -- 627F = E3
      when "110001010000000" =>  data <= "10100000";  -- 6280 = A0
      when "110001010000001" =>  data <= "00000000";  -- 6281 = 0
      when "110001010000010" =>  data <= "10000100";  -- 6282 = 84
      when "110001010000011" =>  data <= "11000110";  -- 6283 = C6
      when "110001010000100" =>  data <= "01001100";  -- 6284 = 4C
      when "110001010000101" =>  data <= "10100110";  -- 6285 = A6
      when "110001010000110" =>  data <= "11100001";  -- 6286 = E1
      when "110001010000111" =>  data <= "11001001";  -- 6287 = C9
      when "110001010001000" =>  data <= "00010001";  -- 6288 = 11
      when "110001010001001" =>  data <= "11010000";  -- 6289 = D0
      when "110001010001010" =>  data <= "00010001";  -- 628A = 11
      when "110001010001011" =>  data <= "00011000";  -- 628B = 18
      when "110001010001100" =>  data <= "10011000";  -- 628C = 98
      when "110001010001101" =>  data <= "01101001";  -- 628D = 69
      when "110001010001110" =>  data <= "00101000";  -- 628E = 28
      when "110001010001111" =>  data <= "10101000";  -- 628F = A8
      when "110001010010000" =>  data <= "11000101";  -- 6290 = C5
      when "110001010010001" =>  data <= "11010101";  -- 6291 = D5
      when "110001010010010" =>  data <= "10010000";  -- 6292 = 90
      when "110001010010011" =>  data <= "11101110";  -- 6293 = EE
      when "110001010010100" =>  data <= "11110000";  -- 6294 = F0
      when "110001010010101" =>  data <= "11101100";  -- 6295 = EC
      when "110001010010110" =>  data <= "00100000";  -- 6296 = 20
      when "110001010010111" =>  data <= "10101001";  -- 6297 = A9
      when "110001010011000" =>  data <= "11100011";  -- 6298 = E3
      when "110001010011001" =>  data <= "01001100";  -- 6299 = 4C
      when "110001010011010" =>  data <= "10100110";  -- 629A = A6
      when "110001010011011" =>  data <= "11100001";  -- 629B = E1
      when "110001010011100" =>  data <= "11001001";  -- 629C = C9
      when "110001010011101" =>  data <= "00010000";  -- 629D = 10
      when "110001010011110" =>  data <= "11010000";  -- 629E = D0
      when "110001010011111" =>  data <= "00001100";  -- 629F = C
      when "110001010100000" =>  data <= "10101001";  -- 62A0 = A9
      when "110001010100001" =>  data <= "00100000";  -- 62A1 = 20
      when "110001010100010" =>  data <= "10001000";  -- 62A2 = 88
      when "110001010100011" =>  data <= "11001000";  -- 62A3 = C8
      when "110001010100100" =>  data <= "10010001";  -- 62A4 = 91
      when "110001010100101" =>  data <= "11000100";  -- 62A5 = C4
      when "110001010100110" =>  data <= "11000100";  -- 62A6 = C4
      when "110001010100111" =>  data <= "11010101";  -- 62A7 = D5
      when "110001010101000" =>  data <= "10010000";  -- 62A8 = 90
      when "110001010101001" =>  data <= "11111001";  -- 62A9 = F9
      when "110001010101010" =>  data <= "10110000";  -- 62AA = B0
      when "110001010101011" =>  data <= "11101101";  -- 62AB = ED
      when "110001010101100" =>  data <= "11001001";  -- 62AC = C9
      when "110001010101101" =>  data <= "00001110";  -- 62AD = E
      when "110001010101110" =>  data <= "11010000";  -- 62AE = D0
      when "110001010101111" =>  data <= "00000101";  -- 62AF = 5
      when "110001010110000" =>  data <= "00100000";  -- 62B0 = 20
      when "110001010110001" =>  data <= "00001111";  -- 62B1 = F
      when "110001010110010" =>  data <= "11100110";  -- 62B2 = E6
      when "110001010110011" =>  data <= "00110000";  -- 62B3 = 30
      when "110001010110100" =>  data <= "11100100";  -- 62B4 = E4
      when "110001010110101" =>  data <= "11001001";  -- 62B5 = C9
      when "110001010110110" =>  data <= "00000111";  -- 62B6 = 7
      when "110001010110111" =>  data <= "11010000";  -- 62B7 = D0
      when "110001010111000" =>  data <= "00000101";  -- 62B8 = 5
      when "110001010111001" =>  data <= "00100000";  -- 62B9 = 20
      when "110001010111010" =>  data <= "01010111";  -- 62BA = 57
      when "110001010111011" =>  data <= "11100110";  -- 62BB = E6
      when "110001010111100" =>  data <= "11110000";  -- 62BC = F0
      when "110001010111101" =>  data <= "11011011";  -- 62BD = DB
      when "110001010111110" =>  data <= "11001001";  -- 62BE = C9
      when "110001010111111" =>  data <= "00001001";  -- 62BF = 9
      when "110001011000000" =>  data <= "11010000";  -- 62C0 = D0
      when "110001011000001" =>  data <= "11010111";  -- 62C1 = D7
      when "110001011000010" =>  data <= "11000100";  -- 62C2 = C4
      when "110001011000011" =>  data <= "11010101";  -- 62C3 = D5
      when "110001011000100" =>  data <= "10010000";  -- 62C4 = 90
      when "110001011000101" =>  data <= "00000111";  -- 62C5 = 7
      when "110001011000110" =>  data <= "10100100";  -- 62C6 = A4
      when "110001011000111" =>  data <= "11010101";  -- 62C7 = D5
      when "110001011001000" =>  data <= "10000100";  -- 62C8 = 84
      when "110001011001001" =>  data <= "11000110";  -- 62C9 = C6
      when "110001011001010" =>  data <= "01001100";  -- 62CA = 4C
      when "110001011001011" =>  data <= "10100110";  -- 62CB = A6
      when "110001011001100" =>  data <= "11100001";  -- 62CC = E1
      when "110001011001101" =>  data <= "11001000";  -- 62CD = C8
      when "110001011001110" =>  data <= "00100000";  -- 62CE = 20
      when "110001011001111" =>  data <= "10001000";  -- 62CF = 88
      when "110001011010000" =>  data <= "11100101";  -- 62D0 = E5
      when "110001011010001" =>  data <= "11110000";  -- 62D1 = F0
      when "110001011010010" =>  data <= "11101111";  -- 62D2 = EF
      when "110001011010011" =>  data <= "11010000";  -- 62D3 = D0
      when "110001011010100" =>  data <= "11110011";  -- 62D4 = F3
      when "110001011010101" =>  data <= "00101001";  -- 62D5 = 29
      when "110001011010110" =>  data <= "01111111";  -- 62D6 = 7F
      when "110001011010111" =>  data <= "11001001";  -- 62D7 = C9
      when "110001011011000" =>  data <= "01111111";  -- 62D8 = 7F
      when "110001011011001" =>  data <= "11010000";  -- 62D9 = D0
      when "110001011011010" =>  data <= "00000010";  -- 62DA = 2
      when "110001011011011" =>  data <= "10101001";  -- 62DB = A9
      when "110001011011100" =>  data <= "01011110";  -- 62DC = 5E
      when "110001011011101" =>  data <= "11001001";  -- 62DD = C9
      when "110001011011110" =>  data <= "00100000";  -- 62DE = 20
      when "110001011011111" =>  data <= "10010000";  -- 62DF = 90
      when "110001011100000" =>  data <= "00000011";  -- 62E0 = 3
      when "110001011100001" =>  data <= "01001100";  -- 62E1 = 4C
      when "110001011100010" =>  data <= "01110100";  -- 62E2 = 74
      when "110001011100011" =>  data <= "11100001";  -- 62E3 = E1
      when "110001011100100" =>  data <= "11001001";  -- 62E4 = C9
      when "110001011100101" =>  data <= "00001101";  -- 62E5 = D
      when "110001011100110" =>  data <= "11010000";  -- 62E6 = D0
      when "110001011100111" =>  data <= "00000011";  -- 62E7 = 3
      when "110001011101000" =>  data <= "01001100";  -- 62E8 = 4C
      when "110001011101001" =>  data <= "10111111";  -- 62E9 = BF
      when "110001011101010" =>  data <= "11100011";  -- 62EA = E3
      when "110001011101011" =>  data <= "10100110";  -- 62EB = A6
      when "110001011101100" =>  data <= "11001101";  -- 62EC = CD
      when "110001011101101" =>  data <= "11010000";  -- 62ED = D0
      when "110001011101110" =>  data <= "00110000";  -- 62EE = 30
      when "110001011101111" =>  data <= "11001001";  -- 62EF = C9
      when "110001011110000" =>  data <= "00010100";  -- 62F0 = 14
      when "110001011110001" =>  data <= "11010000";  -- 62F1 = D0
      when "110001011110010" =>  data <= "00101000";  -- 62F2 = 28
      when "110001011110011" =>  data <= "10100100";  -- 62F3 = A4
      when "110001011110100" =>  data <= "11010101";  -- 62F4 = D5
      when "110001011110101" =>  data <= "10110001";  -- 62F5 = B1
      when "110001011110110" =>  data <= "11000100";  -- 62F6 = C4
      when "110001011110111" =>  data <= "11001001";  -- 62F7 = C9
      when "110001011111000" =>  data <= "00100000";  -- 62F8 = 20
      when "110001011111001" =>  data <= "11010000";  -- 62F9 = D0
      when "110001011111010" =>  data <= "00000100";  -- 62FA = 4
      when "110001011111011" =>  data <= "11000100";  -- 62FB = C4
      when "110001011111100" =>  data <= "11000110";  -- 62FC = C6
      when "110001011111101" =>  data <= "11010000";  -- 62FD = D0
      when "110001011111110" =>  data <= "00000111";  -- 62FE = 7
      when "110001011111111" =>  data <= "11000000";  -- 62FF = C0
      when "110001100000000" =>  data <= "01001111";  -- 6300 = 4F
      when "110001100000001" =>  data <= "11110000";  -- 6301 = F0
      when "110001100000010" =>  data <= "10000001";  -- 6302 = 81
      when "110001100000011" =>  data <= "00100000";  -- 6303 = 20
      when "110001100000100" =>  data <= "11101010";  -- 6304 = EA
      when "110001100000101" =>  data <= "11100110";  -- 6305 = E6
      when "110001100000110" =>  data <= "10100100";  -- 6306 = A4
      when "110001100000111" =>  data <= "11010101";  -- 6307 = D5
      when "110001100001000" =>  data <= "10001000";  -- 6308 = 88
      when "110001100001001" =>  data <= "10110001";  -- 6309 = B1
      when "110001100001010" =>  data <= "11000100";  -- 630A = C4
      when "110001100001011" =>  data <= "11001000";  -- 630B = C8
      when "110001100001100" =>  data <= "10010001";  -- 630C = 91
      when "110001100001101" =>  data <= "11000100";  -- 630D = C4
      when "110001100001110" =>  data <= "10001000";  -- 630E = 88
      when "110001100001111" =>  data <= "11000100";  -- 630F = C4
      when "110001100010000" =>  data <= "11000110";  -- 6310 = C6
      when "110001100010001" =>  data <= "11010000";  -- 6311 = D0
      when "110001100010010" =>  data <= "11110101";  -- 6312 = F5
      when "110001100010011" =>  data <= "10101001";  -- 6313 = A9
      when "110001100010100" =>  data <= "00100000";  -- 6314 = 20
      when "110001100010101" =>  data <= "10010001";  -- 6315 = 91
      when "110001100010110" =>  data <= "11000100";  -- 6316 = C4
      when "110001100010111" =>  data <= "11100110";  -- 6317 = E6
      when "110001100011000" =>  data <= "11011100";  -- 6318 = DC
      when "110001100011001" =>  data <= "11010000";  -- 6319 = D0
      when "110001100011010" =>  data <= "01011000";  -- 631A = 58
      when "110001100011011" =>  data <= "10100110";  -- 631B = A6
      when "110001100011100" =>  data <= "11011100";  -- 631C = DC
      when "110001100011101" =>  data <= "11110000";  -- 631D = F0
      when "110001100011110" =>  data <= "00000101";  -- 631E = 5
      when "110001100011111" =>  data <= "00001001";  -- 631F = 9
      when "110001100100000" =>  data <= "01000000";  -- 6320 = 40
      when "110001100100001" =>  data <= "01001100";  -- 6321 = 4C
      when "110001100100010" =>  data <= "01111010";  -- 6322 = 7A
      when "110001100100011" =>  data <= "11100001";  -- 6323 = E1
      when "110001100100100" =>  data <= "11001001";  -- 6324 = C9
      when "110001100100101" =>  data <= "00010001";  -- 6325 = 11
      when "110001100100110" =>  data <= "11010000";  -- 6326 = D0
      when "110001100100111" =>  data <= "00101011";  -- 6327 = 2B
      when "110001100101000" =>  data <= "10100101";  -- 6328 = A5
      when "110001100101001" =>  data <= "11000110";  -- 6329 = C6
      when "110001100101010" =>  data <= "11001001";  -- 632A = C9
      when "110001100101011" =>  data <= "00101000";  -- 632B = 28
      when "110001100101100" =>  data <= "10010000";  -- 632C = 90
      when "110001100101101" =>  data <= "00000110";  -- 632D = 6
      when "110001100101110" =>  data <= "11101001";  -- 632E = E9
      when "110001100101111" =>  data <= "00101000";  -- 632F = 28
      when "110001100110000" =>  data <= "10000101";  -- 6330 = 85
      when "110001100110001" =>  data <= "11000110";  -- 6331 = C6
      when "110001100110010" =>  data <= "10110000";  -- 6332 = B0
      when "110001100110011" =>  data <= "00111111";  -- 6333 = 3F
      when "110001100110100" =>  data <= "10100110";  -- 6334 = A6
      when "110001100110101" =>  data <= "11011000";  -- 6335 = D8
      when "110001100110110" =>  data <= "11110000";  -- 6336 = F0
      when "110001100110111" =>  data <= "00111011";  -- 6337 = 3B
      when "110001100111000" =>  data <= "10110101";  -- 6338 = B5
      when "110001100111001" =>  data <= "11011111";  -- 6339 = DF
      when "110001100111010" =>  data <= "00010000";  -- 633A = 10
      when "110001100111011" =>  data <= "00000111";  -- 633B = 7
      when "110001100111100" =>  data <= "11000110";  -- 633C = C6
      when "110001100111101" =>  data <= "11011000";  -- 633D = D8
      when "110001100111110" =>  data <= "00100000";  -- 633E = 20
      when "110001100111111" =>  data <= "01110001";  -- 633F = 71
      when "110001101000000" =>  data <= "11100000";  -- 6340 = E0
      when "110001101000001" =>  data <= "10010000";  -- 6341 = 90
      when "110001101000010" =>  data <= "00110000";  -- 6342 = 30
      when "110001101000011" =>  data <= "11001010";  -- 6343 = CA
      when "110001101000100" =>  data <= "11001010";  -- 6344 = CA
      when "110001101000101" =>  data <= "10000110";  -- 6345 = 86
      when "110001101000110" =>  data <= "11011000";  -- 6346 = D8
      when "110001101000111" =>  data <= "00100000";  -- 6347 = 20
      when "110001101001000" =>  data <= "01110001";  -- 6348 = 71
      when "110001101001001" =>  data <= "11100000";  -- 6349 = E0
      when "110001101001010" =>  data <= "10100101";  -- 634A = A5
      when "110001101001011" =>  data <= "11000110";  -- 634B = C6
      when "110001101001100" =>  data <= "00011000";  -- 634C = 18
      when "110001101001101" =>  data <= "01101001";  -- 634D = 69
      when "110001101001110" =>  data <= "00101000";  -- 634E = 28
      when "110001101001111" =>  data <= "10000101";  -- 634F = 85
      when "110001101010000" =>  data <= "11000110";  -- 6350 = C6
      when "110001101010001" =>  data <= "11010000";  -- 6351 = D0
      when "110001101010010" =>  data <= "00100000";  -- 6352 = 20
      when "110001101010011" =>  data <= "11001001";  -- 6353 = C9
      when "110001101010100" =>  data <= "00010010";  -- 6354 = 12
      when "110001101010101" =>  data <= "11010000";  -- 6355 = D0
      when "110001101010110" =>  data <= "00000110";  -- 6356 = 6
      when "110001101010111" =>  data <= "10101001";  -- 6357 = A9
      when "110001101011000" =>  data <= "00000000";  -- 6358 = 0
      when "110001101011001" =>  data <= "10000101";  -- 6359 = 85
      when "110001101011010" =>  data <= "10011111";  -- 635A = 9F
      when "110001101011011" =>  data <= "11110000";  -- 635B = F0
      when "110001101011100" =>  data <= "00010110";  -- 635C = 16
      when "110001101011101" =>  data <= "11001001";  -- 635D = C9
      when "110001101011110" =>  data <= "00011101";  -- 635E = 1D
      when "110001101011111" =>  data <= "11010000";  -- 635F = D0
      when "110001101100000" =>  data <= "00001011";  -- 6360 = B
      when "110001101100001" =>  data <= "10001000";  -- 6361 = 88
      when "110001101100010" =>  data <= "10000100";  -- 6362 = 84
      when "110001101100011" =>  data <= "11000110";  -- 6363 = C6
      when "110001101100100" =>  data <= "00010000";  -- 6364 = 10
      when "110001101100101" =>  data <= "00001101";  -- 6365 = D
      when "110001101100110" =>  data <= "00100000";  -- 6366 = 20
      when "110001101100111" =>  data <= "11011110";  -- 6367 = DE
      when "110001101101000" =>  data <= "11100001";  -- 6368 = E1
      when "110001101101001" =>  data <= "01001100";  -- 6369 = 4C
      when "110001101101010" =>  data <= "10100110";  -- 636A = A6
      when "110001101101011" =>  data <= "11100001";  -- 636B = E1
      when "110001101101100" =>  data <= "11001001";  -- 636C = C9
      when "110001101101101" =>  data <= "00010011";  -- 636D = 13
      when "110001101101110" =>  data <= "11010000";  -- 636E = D0
      when "110001101101111" =>  data <= "00000110";  -- 636F = 6
      when "110001101110000" =>  data <= "00100000";  -- 6370 = 20
      when "110001101110001" =>  data <= "01000010";  -- 6371 = 42
      when "110001101110010" =>  data <= "11100000";  -- 6372 = E0
      when "110001101110011" =>  data <= "01001100";  -- 6373 = 4C
      when "110001101110100" =>  data <= "10100110";  -- 6374 = A6
      when "110001101110101" =>  data <= "11100001";  -- 6375 = E1
      when "110001101110110" =>  data <= "11001001";  -- 6376 = C9
      when "110001101110111" =>  data <= "00010110";  -- 6377 = 16
      when "110001101111000" =>  data <= "11010000";  -- 6378 = D0
      when "110001101111001" =>  data <= "00001101";  -- 6379 = D
      when "110001101111010" =>  data <= "10101001";  -- 637A = A9
      when "110001101111011" =>  data <= "00100000";  -- 637B = 20
      when "110001101111100" =>  data <= "10100000";  -- 637C = A0
      when "110001101111101" =>  data <= "00000000";  -- 637D = 0
      when "110001101111110" =>  data <= "11000100";  -- 637E = C4
      when "110001101111111" =>  data <= "11000110";  -- 637F = C6
      when "110001110000000" =>  data <= "10110000";  -- 6380 = B0
      when "110001110000001" =>  data <= "11110001";  -- 6381 = F1
      when "110001110000010" =>  data <= "10010001";  -- 6382 = 91
      when "110001110000011" =>  data <= "11000100";  -- 6383 = C4
      when "110001110000100" =>  data <= "11001000";  -- 6384 = C8
      when "110001110000101" =>  data <= "11010000";  -- 6385 = D0
      when "110001110000110" =>  data <= "11110111";  -- 6386 = F7
      when "110001110000111" =>  data <= "11001001";  -- 6387 = C9
      when "110001110001000" =>  data <= "00001110";  -- 6388 = E
      when "110001110001001" =>  data <= "11010000";  -- 6389 = D0
      when "110001110001010" =>  data <= "00000101";  -- 638A = 5
      when "110001110001011" =>  data <= "00100000";  -- 638B = 20
      when "110001110001100" =>  data <= "00010111";  -- 638C = 17
      when "110001110001101" =>  data <= "11100110";  -- 638D = E6
      when "110001110001110" =>  data <= "00110000";  -- 638E = 30
      when "110001110001111" =>  data <= "11100011";  -- 638F = E3
      when "110001110010000" =>  data <= "11001001";  -- 6390 = C9
      when "110001110010001" =>  data <= "00000111";  -- 6391 = 7
      when "110001110010010" =>  data <= "11010000";  -- 6392 = D0
      when "110001110010011" =>  data <= "00000101";  -- 6393 = 5
      when "110001110010100" =>  data <= "00100000";  -- 6394 = 20
      when "110001110010101" =>  data <= "01010100";  -- 6395 = 54
      when "110001110010110" =>  data <= "11100110";  -- 6396 = E6
      when "110001110010111" =>  data <= "11110000";  -- 6397 = F0
      when "110001110011000" =>  data <= "11011010";  -- 6398 = DA
      when "110001110011001" =>  data <= "11001001";  -- 6399 = C9
      when "110001110011010" =>  data <= "00001001";  -- 639A = 9
      when "110001110011011" =>  data <= "11010000";  -- 639B = D0
      when "110001110011100" =>  data <= "11010110";  -- 639C = D6
      when "110001110011101" =>  data <= "00100000";  -- 639D = 20
      when "110001110011110" =>  data <= "10001000";  -- 639E = 88
      when "110001110011111" =>  data <= "11100101";  -- 639F = E5
      when "110001110100000" =>  data <= "01001101";  -- 63A0 = 4D
      when "110001110100001" =>  data <= "11101111";  -- 63A1 = EF
      when "110001110100010" =>  data <= "00000011";  -- 63A2 = 3
      when "110001110100011" =>  data <= "10011101";  -- 63A3 = 9D
      when "110001110100100" =>  data <= "11110000";  -- 63A4 = F0
      when "110001110100101" =>  data <= "00000011";  -- 63A5 = 3
      when "110001110100110" =>  data <= "01001100";  -- 63A6 = 4C
      when "110001110100111" =>  data <= "10100110";  -- 63A7 = A6
      when "110001110101000" =>  data <= "11100001";  -- 63A8 = E1
      when "110001110101001" =>  data <= "00111000";  -- 63A9 = 38
      when "110001110101010" =>  data <= "01000110";  -- 63AA = 46
      when "110001110101011" =>  data <= "10100011";  -- 63AB = A3
      when "110001110101100" =>  data <= "10100110";  -- 63AC = A6
      when "110001110101101" =>  data <= "11011000";  -- 63AD = D8
      when "110001110101110" =>  data <= "11101000";  -- 63AE = E8
      when "110001110101111" =>  data <= "11100000";  -- 63AF = E0
      when "110001110110000" =>  data <= "00011001";  -- 63B0 = 19
      when "110001110110001" =>  data <= "11010000";  -- 63B1 = D0
      when "110001110110010" =>  data <= "00000011";  -- 63B2 = 3
      when "110001110110011" =>  data <= "00100000";  -- 63B3 = 20
      when "110001110110100" =>  data <= "11010001";  -- 63B4 = D1
      when "110001110110101" =>  data <= "11100011";  -- 63B5 = E3
      when "110001110110110" =>  data <= "10110101";  -- 63B6 = B5
      when "110001110110111" =>  data <= "11100000";  -- 63B7 = E0
      when "110001110111000" =>  data <= "00010000";  -- 63B8 = 10
      when "110001110111001" =>  data <= "11110100";  -- 63B9 = F4
      when "110001110111010" =>  data <= "10000110";  -- 63BA = 86
      when "110001110111011" =>  data <= "11011000";  -- 63BB = D8
      when "110001110111100" =>  data <= "01001100";  -- 63BC = 4C
      when "110001110111101" =>  data <= "01110001";  -- 63BD = 71
      when "110001110111110" =>  data <= "11100000";  -- 63BE = E0
      when "110001110111111" =>  data <= "00100000";  -- 63BF = 20
      when "110001111000000" =>  data <= "10101001";  -- 63C0 = A9
      when "110001111000001" =>  data <= "11100011";  -- 63C1 = E3
      when "110001111000010" =>  data <= "10101001";  -- 63C2 = A9
      when "110001111000011" =>  data <= "00000000";  -- 63C3 = 0
      when "110001111000100" =>  data <= "10000101";  -- 63C4 = 85
      when "110001111000101" =>  data <= "11000110";  -- 63C5 = C6
      when "110001111000110" =>  data <= "10101001";  -- 63C6 = A9
      when "110001111000111" =>  data <= "00000000";  -- 63C7 = 0
      when "110001111001000" =>  data <= "10000101";  -- 63C8 = 85
      when "110001111001001" =>  data <= "11011100";  -- 63C9 = DC
      when "110001111001010" =>  data <= "10000101";  -- 63CA = 85
      when "110001111001011" =>  data <= "10011111";  -- 63CB = 9F
      when "110001111001100" =>  data <= "10000101";  -- 63CC = 85
      when "110001111001101" =>  data <= "11001101";  -- 63CD = CD
      when "110001111001110" =>  data <= "01001100";  -- 63CE = 4C
      when "110001111001111" =>  data <= "10100110";  -- 63CF = A6
      when "110001111010000" =>  data <= "11100001";  -- 63D0 = E1
      when "110001111010001" =>  data <= "10100010";  -- 63D1 = A2
      when "110001111010010" =>  data <= "00011001";  -- 63D2 = 19
      when "110001111010011" =>  data <= "10000110";  -- 63D3 = 86
      when "110001111010100" =>  data <= "11011000";  -- 63D4 = D8
      when "110001111010101" =>  data <= "10100010";  -- 63D5 = A2
      when "110001111010110" =>  data <= "11111111";  -- 63D6 = FF
      when "110001111010111" =>  data <= "11101000";  -- 63D7 = E8
      when "110001111011000" =>  data <= "10111101";  -- 63D8 = BD
      when "110001111011001" =>  data <= "10011000";  -- 63D9 = 98
      when "110001111011010" =>  data <= "11100111";  -- 63DA = E7
      when "110001111011011" =>  data <= "10000101";  -- 63DB = 85
      when "110001111011100" =>  data <= "11000100";  -- 63DC = C4
      when "110001111011101" =>  data <= "10110101";  -- 63DD = B5
      when "110001111011110" =>  data <= "11100000";  -- 63DE = E0
      when "110001111011111" =>  data <= "00001001";  -- 63DF = 9
      when "110001111100000" =>  data <= "10000000";  -- 63E0 = 80
      when "110001111100001" =>  data <= "10000101";  -- 63E1 = 85
      when "110001111100010" =>  data <= "11000101";  -- 63E2 = C5
      when "110001111100011" =>  data <= "11100000";  -- 63E3 = E0
      when "110001111100100" =>  data <= "00011000";  -- 63E4 = 18
      when "110001111100101" =>  data <= "10110000";  -- 63E5 = B0
      when "110001111100110" =>  data <= "00011101";  -- 63E6 = 1D
      when "110001111100111" =>  data <= "10110100";  -- 63E7 = B4
      when "110001111101000" =>  data <= "11100001";  -- 63E8 = E1
      when "110001111101001" =>  data <= "00110000";  -- 63E9 = 30
      when "110001111101010" =>  data <= "00000010";  -- 63EA = 2
      when "110001111101011" =>  data <= "00101001";  -- 63EB = 29
      when "110001111101100" =>  data <= "01111111";  -- 63EC = 7F
      when "110001111101101" =>  data <= "10010101";  -- 63ED = 95
      when "110001111101110" =>  data <= "11100000";  -- 63EE = E0
      when "110001111101111" =>  data <= "10011000";  -- 63EF = 98
      when "110001111110000" =>  data <= "00001001";  -- 63F0 = 9
      when "110001111110001" =>  data <= "10000000";  -- 63F1 = 80
      when "110001111110010" =>  data <= "10000101";  -- 63F2 = 85
      when "110001111110011" =>  data <= "11001000";  -- 63F3 = C8
      when "110001111110100" =>  data <= "10111101";  -- 63F4 = BD
      when "110001111110101" =>  data <= "10011001";  -- 63F5 = 99
      when "110001111110110" =>  data <= "11100111";  -- 63F6 = E7
      when "110001111110111" =>  data <= "10000101";  -- 63F7 = 85
      when "110001111111000" =>  data <= "11000111";  -- 63F8 = C7
      when "110001111111001" =>  data <= "10100000";  -- 63F9 = A0
      when "110001111111010" =>  data <= "00100111";  -- 63FA = 27
      when "110001111111011" =>  data <= "10110001";  -- 63FB = B1
      when "110001111111100" =>  data <= "11000111";  -- 63FC = C7
      when "110001111111101" =>  data <= "10010001";  -- 63FD = 91
      when "110001111111110" =>  data <= "11000100";  -- 63FE = C4
      when "110001111111111" =>  data <= "10001000";  -- 63FF = 88
      when "110010000000000" =>  data <= "00010000";  -- 6400 = 10
      when "110010000000001" =>  data <= "11111001";  -- 6401 = F9
      when "110010000000010" =>  data <= "00110000";  -- 6402 = 30
      when "110010000000011" =>  data <= "11010011";  -- 6403 = D3
      when "110010000000100" =>  data <= "10010101";  -- 6404 = 95
      when "110010000000101" =>  data <= "11100000";  -- 6405 = E0
      when "110010000000110" =>  data <= "10100000";  -- 6406 = A0
      when "110010000000111" =>  data <= "00100111";  -- 6407 = 27
      when "110010000001000" =>  data <= "10101001";  -- 6408 = A9
      when "110010000001001" =>  data <= "00100000";  -- 6409 = 20
      when "110010000001010" =>  data <= "10010001";  -- 640A = 91
      when "110010000001011" =>  data <= "11000100";  -- 640B = C4
      when "110010000001100" =>  data <= "10001000";  -- 640C = 88
      when "110010000001101" =>  data <= "00010000";  -- 640D = 10
      when "110010000001110" =>  data <= "11111011";  -- 640E = FB
      when "110010000001111" =>  data <= "11000110";  -- 640F = C6
      when "110010000010000" =>  data <= "11011000";  -- 6410 = D8
      when "110010000010001" =>  data <= "10100101";  -- 6411 = A5
      when "110010000010010" =>  data <= "11100000";  -- 6412 = E0
      when "110010000010011" =>  data <= "00010000";  -- 6413 = 10
      when "110010000010100" =>  data <= "11000000";  -- 6414 = C0
      when "110010000010101" =>  data <= "10101101";  -- 6415 = AD
      when "110010000010110" =>  data <= "00010010";  -- 6416 = 12
      when "110010000010111" =>  data <= "11101000";  -- 6417 = E8
      when "110010000011000" =>  data <= "11001001";  -- 6418 = C9
      when "110010000011001" =>  data <= "11111110";  -- 6419 = FE
      when "110010000011010" =>  data <= "11010000";  -- 641A = D0
      when "110010000011011" =>  data <= "00001011";  -- 641B = B
      when "110010000011100" =>  data <= "10100000";  -- 641C = A0
      when "110010000011101" =>  data <= "00000000";  -- 641D = 0
      when "110010000011110" =>  data <= "11101010";  -- 641E = EA
      when "110010000011111" =>  data <= "11001010";  -- 641F = CA
      when "110010000100000" =>  data <= "11010000";  -- 6420 = D0
      when "110010000100001" =>  data <= "11111100";  -- 6421 = FC
      when "110010000100010" =>  data <= "10001000";  -- 6422 = 88
      when "110010000100011" =>  data <= "11010000";  -- 6423 = D0
      when "110010000100100" =>  data <= "11111001";  -- 6424 = F9
      when "110010000100101" =>  data <= "10000100";  -- 6425 = 84
      when "110010000100110" =>  data <= "10011110";  -- 6426 = 9E
      when "110010000100111" =>  data <= "10100110";  -- 6427 = A6
      when "110010000101000" =>  data <= "11011000";  -- 6428 = D8
      when "110010000101001" =>  data <= "01100000";  -- 6429 = 60
      when "110010000101010" =>  data <= "10101010";  -- 642A = AA
      when "110010000101011" =>  data <= "10101010";  -- 642B = AA
      when "110010000101100" =>  data <= "10101010";  -- 642C = AA
      when "110010000101101" =>  data <= "10101010";  -- 642D = AA
      when "110010000101110" =>  data <= "00100000";  -- 642E = 20
      when "110010000101111" =>  data <= "11101010";  -- 642F = EA
      when "110010000110000" =>  data <= "11111111";  -- 6430 = FF
      when "110010000110001" =>  data <= "11101110";  -- 6431 = EE
      when "110010000110010" =>  data <= "11101101";  -- 6432 = ED
      when "110010000110011" =>  data <= "00000011";  -- 6433 = 3
      when "110010000110100" =>  data <= "10101101";  -- 6434 = AD
      when "110010000110101" =>  data <= "11101101";  -- 6435 = ED
      when "110010000110110" =>  data <= "00000011";  -- 6436 = 3
      when "110010000110111" =>  data <= "11001001";  -- 6437 = C9
      when "110010000111000" =>  data <= "00000110";  -- 6438 = 6
      when "110010000111001" =>  data <= "11010000";  -- 6439 = D0
      when "110010000111010" =>  data <= "00011101";  -- 643A = 1D
      when "110010000111011" =>  data <= "10101001";  -- 643B = A9
      when "110010000111100" =>  data <= "00000000";  -- 643C = 0
      when "110010000111101" =>  data <= "10001101";  -- 643D = 8D
      when "110010000111110" =>  data <= "11101101";  -- 643E = ED
      when "110010000111111" =>  data <= "00000011";  -- 643F = 3
      when "110010001000000" =>  data <= "11110000";  -- 6440 = F0
      when "110010001000001" =>  data <= "11101100";  -- 6441 = EC
      when "110010001000010" =>  data <= "01001000";  -- 6442 = 48
      when "110010001000011" =>  data <= "10001010";  -- 6443 = 8A
      when "110010001000100" =>  data <= "01001000";  -- 6444 = 48
      when "110010001000101" =>  data <= "10011000";  -- 6445 = 98
      when "110010001000110" =>  data <= "01001000";  -- 6446 = 48
      when "110010001000111" =>  data <= "10111010";  -- 6447 = BA
      when "110010001001000" =>  data <= "10111101";  -- 6448 = BD
      when "110010001001001" =>  data <= "00000100";  -- 6449 = 4
      when "110010001001010" =>  data <= "00000001";  -- 644A = 1
      when "110010001001011" =>  data <= "00101001";  -- 644B = 29
      when "110010001001100" =>  data <= "00010000";  -- 644C = 10
      when "110010001001101" =>  data <= "11110000";  -- 644D = F0
      when "110010001001110" =>  data <= "00000011";  -- 644E = 3
      when "110010001001111" =>  data <= "01101100";  -- 644F = 6C
      when "110010001010000" =>  data <= "10010010";  -- 6450 = 92
      when "110010001010001" =>  data <= "00000000";  -- 6451 = 0
      when "110010001010010" =>  data <= "01101100";  -- 6452 = 6C
      when "110010001010011" =>  data <= "10010000";  -- 6453 = 90
      when "110010001010100" =>  data <= "00000000";  -- 6454 = 0
      when "110010001010101" =>  data <= "01001100";  -- 6455 = 4C
      when "110010001010110" =>  data <= "00101110";  -- 6456 = 2E
      when "110010001010111" =>  data <= "11100100";  -- 6457 = E4
      when "110010001011000" =>  data <= "10100101";  -- 6458 = A5
      when "110010001011001" =>  data <= "10100111";  -- 6459 = A7
      when "110010001011010" =>  data <= "11010000";  -- 645A = D0
      when "110010001011011" =>  data <= "00011111";  -- 645B = 1F
      when "110010001011100" =>  data <= "11000110";  -- 645C = C6
      when "110010001011101" =>  data <= "10101000";  -- 645D = A8
      when "110010001011110" =>  data <= "11010000";  -- 645E = D0
      when "110010001011111" =>  data <= "00011011";  -- 645F = 1B
      when "110010001100000" =>  data <= "10101001";  -- 6460 = A9
      when "110010001100001" =>  data <= "00010100";  -- 6461 = 14
      when "110010001100010" =>  data <= "00101100";  -- 6462 = 2C
      when "110010001100011" =>  data <= "11101110";  -- 6463 = EE
      when "110010001100100" =>  data <= "00000011";  -- 6464 = 3
      when "110010001100101" =>  data <= "00010000";  -- 6465 = 10
      when "110010001100110" =>  data <= "00000010";  -- 6466 = 2
      when "110010001100111" =>  data <= "10101001";  -- 6467 = A9
      when "110010001101000" =>  data <= "00000010";  -- 6468 = 2
      when "110010001101001" =>  data <= "10000101";  -- 6469 = 85
      when "110010001101010" =>  data <= "10101000";  -- 646A = A8
      when "110010001101011" =>  data <= "10100100";  -- 646B = A4
      when "110010001101100" =>  data <= "11000110";  -- 646C = C6
      when "110010001101101" =>  data <= "01000110";  -- 646D = 46
      when "110010001101110" =>  data <= "10101010";  -- 646E = AA
      when "110010001101111" =>  data <= "10110001";  -- 646F = B1
      when "110010001110000" =>  data <= "11000100";  -- 6470 = C4
      when "110010001110001" =>  data <= "10110000";  -- 6471 = B0
      when "110010001110010" =>  data <= "00000100";  -- 6472 = 4
      when "110010001110011" =>  data <= "11100110";  -- 6473 = E6
      when "110010001110100" =>  data <= "10101010";  -- 6474 = AA
      when "110010001110101" =>  data <= "10000101";  -- 6475 = 85
      when "110010001110110" =>  data <= "10101001";  -- 6476 = A9
      when "110010001110111" =>  data <= "01001001";  -- 6477 = 49
      when "110010001111000" =>  data <= "10000000";  -- 6478 = 80
      when "110010001111001" =>  data <= "10010001";  -- 6479 = 91
      when "110010001111010" =>  data <= "11000100";  -- 647A = C4
      when "110010001111011" =>  data <= "10100000";  -- 647B = A0
      when "110010001111100" =>  data <= "00000000";  -- 647C = 0
      when "110010001111101" =>  data <= "10101101";  -- 647D = AD
      when "110010001111110" =>  data <= "00010000";  -- 647E = 10
      when "110010001111111" =>  data <= "11101000";  -- 647F = E8
      when "110010010000000" =>  data <= "00101001";  -- 6480 = 29
      when "110010010000001" =>  data <= "11110000";  -- 6481 = F0
      when "110010010000010" =>  data <= "10001101";  -- 6482 = 8D
      when "110010010000011" =>  data <= "00010000";  -- 6483 = 10
      when "110010010000100" =>  data <= "11101000";  -- 6484 = E8
      when "110010010000101" =>  data <= "10101101";  -- 6485 = AD
      when "110010010000110" =>  data <= "00010000";  -- 6486 = 10
      when "110010010000111" =>  data <= "11101000";  -- 6487 = E8
      when "110010010001000" =>  data <= "00001010";  -- 6488 = A
      when "110010010001001" =>  data <= "00001010";  -- 6489 = A
      when "110010010001010" =>  data <= "00001010";  -- 648A = A
      when "110010010001011" =>  data <= "00010000";  -- 648B = 10
      when "110010010001100" =>  data <= "00001001";  -- 648C = 9
      when "110010010001101" =>  data <= "10000100";  -- 648D = 84
      when "110010010001110" =>  data <= "11111001";  -- 648E = F9
      when "110010010001111" =>  data <= "10101101";  -- 648F = AD
      when "110010010010000" =>  data <= "00010011";  -- 6490 = 13
      when "110010010010001" =>  data <= "11101000";  -- 6491 = E8
      when "110010010010010" =>  data <= "00001001";  -- 6492 = 9
      when "110010010010011" =>  data <= "00001000";  -- 6493 = 8
      when "110010010010100" =>  data <= "11010000";  -- 6494 = D0
      when "110010010010101" =>  data <= "00001001";  -- 6495 = 9
      when "110010010010110" =>  data <= "10100101";  -- 6496 = A5
      when "110010010010111" =>  data <= "11111001";  -- 6497 = F9
      when "110010010011000" =>  data <= "11010000";  -- 6498 = D0
      when "110010010011001" =>  data <= "00001000";  -- 6499 = 8
      when "110010010011010" =>  data <= "10101101";  -- 649A = AD
      when "110010010011011" =>  data <= "00010011";  -- 649B = 13
      when "110010010011100" =>  data <= "11101000";  -- 649C = E8
      when "110010010011101" =>  data <= "00101001";  -- 649D = 29
      when "110010010011110" =>  data <= "11110111";  -- 649E = F7
      when "110010010011111" =>  data <= "10001101";  -- 649F = 8D
      when "110010010100000" =>  data <= "00010011";  -- 64A0 = 13
      when "110010010100001" =>  data <= "11101000";  -- 64A1 = E8
      when "110010010100010" =>  data <= "10010000";  -- 64A2 = 90
      when "110010010100011" =>  data <= "00001001";  -- 64A3 = 9
      when "110010010100100" =>  data <= "10000100";  -- 64A4 = 84
      when "110010010100101" =>  data <= "11111010";  -- 64A5 = FA
      when "110010010100110" =>  data <= "10101101";  -- 64A6 = AD
      when "110010010100111" =>  data <= "01000000";  -- 64A7 = 40
      when "110010010101000" =>  data <= "11101000";  -- 64A8 = E8
      when "110010010101001" =>  data <= "00001001";  -- 64A9 = 9
      when "110010010101010" =>  data <= "00010000";  -- 64AA = 10
      when "110010010101011" =>  data <= "11010000";  -- 64AB = D0
      when "110010010101100" =>  data <= "00001001";  -- 64AC = 9
      when "110010010101101" =>  data <= "10100101";  -- 64AD = A5
      when "110010010101110" =>  data <= "11111010";  -- 64AE = FA
      when "110010010101111" =>  data <= "11010000";  -- 64AF = D0
      when "110010010110000" =>  data <= "00001000";  -- 64B0 = 8
      when "110010010110001" =>  data <= "10101101";  -- 64B1 = AD
      when "110010010110010" =>  data <= "01000000";  -- 64B2 = 40
      when "110010010110011" =>  data <= "11101000";  -- 64B3 = E8
      when "110010010110100" =>  data <= "00101001";  -- 64B4 = 29
      when "110010010110101" =>  data <= "11101111";  -- 64B5 = EF
      when "110010010110110" =>  data <= "10001101";  -- 64B6 = 8D
      when "110010010110111" =>  data <= "01000000";  -- 64B7 = 40
      when "110010010111000" =>  data <= "11101000";  -- 64B8 = E8
      when "110010010111001" =>  data <= "00100000";  -- 64B9 = 20
      when "110010010111010" =>  data <= "10111111";  -- 64BA = BF
      when "110010010111011" =>  data <= "11100100";  -- 64BB = E4
      when "110010010111100" =>  data <= "01001100";  -- 64BC = 4C
      when "110010010111101" =>  data <= "00000000";  -- 64BD = 0
      when "110010010111110" =>  data <= "11100110";  -- 64BE = E6
      when "110010010111111" =>  data <= "10100000";  -- 64BF = A0
      when "110010011000000" =>  data <= "11111111";  -- 64C0 = FF
      when "110010011000001" =>  data <= "10000100";  -- 64C1 = 84
      when "110010011000010" =>  data <= "10100110";  -- 64C2 = A6
      when "110010011000011" =>  data <= "11001000";  -- 64C3 = C8
      when "110010011000100" =>  data <= "10000100";  -- 64C4 = 84
      when "110010011000101" =>  data <= "10011000";  -- 64C5 = 98
      when "110010011000110" =>  data <= "10101101";  -- 64C6 = AD
      when "110010011000111" =>  data <= "11101110";  -- 64C7 = EE
      when "110010011001000" =>  data <= "00000011";  -- 64C8 = 3
      when "110010011001001" =>  data <= "00101001";  -- 64C9 = 29
      when "110010011001010" =>  data <= "01111111";  -- 64CA = 7F
      when "110010011001011" =>  data <= "10001101";  -- 64CB = 8D
      when "110010011001100" =>  data <= "11101110";  -- 64CC = EE
      when "110010011001101" =>  data <= "00000011";  -- 64CD = 3
      when "110010011001110" =>  data <= "10100010";  -- 64CE = A2
      when "110010011001111" =>  data <= "01010000";  -- 64CF = 50
      when "110010011010000" =>  data <= "10100000";  -- 64D0 = A0
      when "110010011010001" =>  data <= "00001000";  -- 64D1 = 8
      when "110010011010010" =>  data <= "10101101";  -- 64D2 = AD
      when "110010011010011" =>  data <= "00010010";  -- 64D3 = 12
      when "110010011010100" =>  data <= "11101000";  -- 64D4 = E8
      when "110010011010101" =>  data <= "11001101";  -- 64D5 = CD
      when "110010011010110" =>  data <= "00010010";  -- 64D6 = 12
      when "110010011010111" =>  data <= "11101000";  -- 64D7 = E8
      when "110010011011000" =>  data <= "11010000";  -- 64D8 = D0
      when "110010011011001" =>  data <= "11110110";  -- 64D9 = F6
      when "110010011011010" =>  data <= "11001001";  -- 64DA = C9
      when "110010011011011" =>  data <= "11111111";  -- 64DB = FF
      when "110010011011100" =>  data <= "11010000";  -- 64DC = D0
      when "110010011011101" =>  data <= "00001001";  -- 64DD = 9
      when "110010011011110" =>  data <= "10001010";  -- 64DE = 8A
      when "110010011011111" =>  data <= "00111000";  -- 64DF = 38
      when "110010011100000" =>  data <= "11101001";  -- 64E0 = E9
      when "110010011100001" =>  data <= "00001000";  -- 64E1 = 8
      when "110010011100010" =>  data <= "10101010";  -- 64E2 = AA
      when "110010011100011" =>  data <= "11010000";  -- 64E3 = D0
      when "110010011100100" =>  data <= "00101100";  -- 64E4 = 2C
      when "110010011100101" =>  data <= "11110000";  -- 64E5 = F0
      when "110010011100110" =>  data <= "00101111";  -- 64E6 = 2F
      when "110010011100111" =>  data <= "01001010";  -- 64E7 = 4A
      when "110010011101000" =>  data <= "10110000";  -- 64E8 = B0
      when "110010011101001" =>  data <= "00100001";  -- 64E9 = 21
      when "110010011101010" =>  data <= "01001000";  -- 64EA = 48
      when "110010011101011" =>  data <= "10111101";  -- 64EB = BD
      when "110010011101100" =>  data <= "00111110";  -- 64EC = 3E
      when "110010011101101" =>  data <= "11100111";  -- 64ED = E7
      when "110010011101110" =>  data <= "11010000";  -- 64EE = D0
      when "110010011101111" =>  data <= "00000110";  -- 64EF = 6
      when "110010011110000" =>  data <= "10101001";  -- 64F0 = A9
      when "110010011110001" =>  data <= "00000001";  -- 64F1 = 1
      when "110010011110010" =>  data <= "10000101";  -- 64F2 = 85
      when "110010011110011" =>  data <= "10011000";  -- 64F3 = 98
      when "110010011110100" =>  data <= "11010000";  -- 64F4 = D0
      when "110010011110101" =>  data <= "00010100";  -- 64F5 = 14
      when "110010011110110" =>  data <= "11001001";  -- 64F6 = C9
      when "110010011110111" =>  data <= "00010000";  -- 64F7 = 10
      when "110010011111000" =>  data <= "11010000";  -- 64F8 = D0
      when "110010011111001" =>  data <= "00001010";  -- 64F9 = A
      when "110010011111010" =>  data <= "10101101";  -- 64FA = AD
      when "110010011111011" =>  data <= "11101110";  -- 64FB = EE
      when "110010011111100" =>  data <= "00000011";  -- 64FC = 3
      when "110010011111101" =>  data <= "00001001";  -- 64FD = 9
      when "110010011111110" =>  data <= "10000000";  -- 64FE = 80
      when "110010011111111" =>  data <= "10001101";  -- 64FF = 8D
      when "110010100000000" =>  data <= "11101110";  -- 6500 = EE
      when "110010100000001" =>  data <= "00000011";  -- 6501 = 3
      when "110010100000010" =>  data <= "00110000";  -- 6502 = 30
      when "110010100000011" =>  data <= "00000110";  -- 6503 = 6
      when "110010100000100" =>  data <= "11001001";  -- 6504 = C9
      when "110010100000101" =>  data <= "11111111";  -- 6505 = FF
      when "110010100000110" =>  data <= "11110000";  -- 6506 = F0
      when "110010100000111" =>  data <= "00000010";  -- 6507 = 2
      when "110010100001000" =>  data <= "10000101";  -- 6508 = 85
      when "110010100001001" =>  data <= "10100110";  -- 6509 = A6
      when "110010100001010" =>  data <= "01101000";  -- 650A = 68
      when "110010100001011" =>  data <= "11001010";  -- 650B = CA
      when "110010100001100" =>  data <= "11110000";  -- 650C = F0
      when "110010100001101" =>  data <= "00001000";  -- 650D = 8
      when "110010100001110" =>  data <= "10001000";  -- 650E = 88
      when "110010100001111" =>  data <= "11010000";  -- 650F = D0
      when "110010100010000" =>  data <= "11010110";  -- 6510 = D6
      when "110010100010001" =>  data <= "11101110";  -- 6511 = EE
      when "110010100010010" =>  data <= "00010000";  -- 6512 = 10
      when "110010100010011" =>  data <= "11101000";  -- 6513 = E8
      when "110010100010100" =>  data <= "11010000";  -- 6514 = D0
      when "110010100010101" =>  data <= "10111010";  -- 6515 = BA
      when "110010100010110" =>  data <= "10100101";  -- 6516 = A5
      when "110010100010111" =>  data <= "10100110";  -- 6517 = A6
      when "110010100011000" =>  data <= "11000101";  -- 6518 = C5
      when "110010100011001" =>  data <= "10010111";  -- 6519 = 97
      when "110010100011010" =>  data <= "11110000";  -- 651A = F0
      when "110010100011011" =>  data <= "00000111";  -- 651B = 7
      when "110010100011100" =>  data <= "10100010";  -- 651C = A2
      when "110010100011101" =>  data <= "00010000";  -- 651D = 10
      when "110010100011110" =>  data <= "10001110";  -- 651E = 8E
      when "110010100011111" =>  data <= "11101001";  -- 651F = E9
      when "110010100100000" =>  data <= "00000011";  -- 6520 = 3
      when "110010100100001" =>  data <= "11010000";  -- 6521 = D0
      when "110010100100010" =>  data <= "00110011";  -- 6522 = 33
      when "110010100100011" =>  data <= "00101100";  -- 6523 = 2C
      when "110010100100100" =>  data <= "11101110";  -- 6524 = EE
      when "110010100100101" =>  data <= "00000011";  -- 6525 = 3
      when "110010100100110" =>  data <= "00110000";  -- 6526 = 30
      when "110010100100111" =>  data <= "00100000";  -- 6527 = 20
      when "110010100101000" =>  data <= "01110000";  -- 6528 = 70
      when "110010100101001" =>  data <= "01011101";  -- 6529 = 5D
      when "110010100101010" =>  data <= "11001001";  -- 652A = C9
      when "110010100101011" =>  data <= "11111111";  -- 652B = FF
      when "110010100101100" =>  data <= "11110000";  -- 652C = F0
      when "110010100101101" =>  data <= "01011001";  -- 652D = 59
      when "110010100101110" =>  data <= "11001001";  -- 652E = C9
      when "110010100101111" =>  data <= "00010100";  -- 652F = 14
      when "110010100110000" =>  data <= "11110000";  -- 6530 = F0
      when "110010100110001" =>  data <= "00001100";  -- 6531 = C
      when "110010100110010" =>  data <= "11001001";  -- 6532 = C9
      when "110010100110011" =>  data <= "00100000";  -- 6533 = 20
      when "110010100110100" =>  data <= "11110000";  -- 6534 = F0
      when "110010100110101" =>  data <= "00001000";  -- 6535 = 8
      when "110010100110110" =>  data <= "11001001";  -- 6536 = C9
      when "110010100110111" =>  data <= "00011101";  -- 6537 = 1D
      when "110010100111000" =>  data <= "11110000";  -- 6538 = F0
      when "110010100111001" =>  data <= "00000100";  -- 6539 = 4
      when "110010100111010" =>  data <= "11001001";  -- 653A = C9
      when "110010100111011" =>  data <= "00010001";  -- 653B = 11
      when "110010100111100" =>  data <= "11010000";  -- 653C = D0
      when "110010100111101" =>  data <= "01001001";  -- 653D = 49
      when "110010100111110" =>  data <= "10101110";  -- 653E = AE
      when "110010100111111" =>  data <= "11101001";  -- 653F = E9
      when "110010101000000" =>  data <= "00000011";  -- 6540 = 3
      when "110010101000001" =>  data <= "11110000";  -- 6541 = F0
      when "110010101000010" =>  data <= "00000101";  -- 6542 = 5
      when "110010101000011" =>  data <= "11001110";  -- 6543 = CE
      when "110010101000100" =>  data <= "11101001";  -- 6544 = E9
      when "110010101000101" =>  data <= "00000011";  -- 6545 = 3
      when "110010101000110" =>  data <= "11010000";  -- 6546 = D0
      when "110010101000111" =>  data <= "00111111";  -- 6547 = 3F
      when "110010101001000" =>  data <= "11001110";  -- 6548 = CE
      when "110010101001001" =>  data <= "11101010";  -- 6549 = EA
      when "110010101001010" =>  data <= "00000011";  -- 654A = 3
      when "110010101001011" =>  data <= "11010000";  -- 654B = D0
      when "110010101001100" =>  data <= "00111010";  -- 654C = 3A
      when "110010101001101" =>  data <= "10100010";  -- 654D = A2
      when "110010101001110" =>  data <= "00000100";  -- 654E = 4
      when "110010101001111" =>  data <= "10001110";  -- 654F = 8E
      when "110010101010000" =>  data <= "11101010";  -- 6550 = EA
      when "110010101010001" =>  data <= "00000011";  -- 6551 = 3
      when "110010101010010" =>  data <= "10100110";  -- 6552 = A6
      when "110010101010011" =>  data <= "10011110";  -- 6553 = 9E
      when "110010101010100" =>  data <= "11010000";  -- 6554 = D0
      when "110010101010101" =>  data <= "00110001";  -- 6555 = 31
      when "110010101010110" =>  data <= "10000101";  -- 6556 = 85
      when "110010101010111" =>  data <= "10010111";  -- 6557 = 97
      when "110010101011000" =>  data <= "11001001";  -- 6558 = C9
      when "110010101011001" =>  data <= "11111111";  -- 6559 = FF
      when "110010101011010" =>  data <= "11110000";  -- 655A = F0
      when "110010101011011" =>  data <= "00101011";  -- 655B = 2B
      when "110010101011100" =>  data <= "11101010";  -- 655C = EA
      when "110010101011101" =>  data <= "11101010";  -- 655D = EA
      when "110010101011110" =>  data <= "11101010";  -- 655E = EA
      when "110010101011111" =>  data <= "11101010";  -- 655F = EA
      when "110010101100000" =>  data <= "11101010";  -- 6560 = EA
      when "110010101100001" =>  data <= "11101010";  -- 6561 = EA
      when "110010101100010" =>  data <= "11101010";  -- 6562 = EA
      when "110010101100011" =>  data <= "01000110";  -- 6563 = 46
      when "110010101100100" =>  data <= "10011000";  -- 6564 = 98
      when "110010101100101" =>  data <= "10010000";  -- 6565 = 90
      when "110010101100110" =>  data <= "00010011";  -- 6566 = 13
      when "110010101100111" =>  data <= "11101010";  -- 6567 = EA
      when "110010101101000" =>  data <= "11101010";  -- 6568 = EA
      when "110010101101001" =>  data <= "11101010";  -- 6569 = EA
      when "110010101101010" =>  data <= "11101010";  -- 656A = EA
      when "110010101101011" =>  data <= "11101010";  -- 656B = EA
      when "110010101101100" =>  data <= "11101010";  -- 656C = EA
      when "110010101101101" =>  data <= "11101010";  -- 656D = EA
      when "110010101101110" =>  data <= "11101010";  -- 656E = EA
      when "110010101101111" =>  data <= "11101010";  -- 656F = EA
      when "110010101110000" =>  data <= "11101010";  -- 6570 = EA
      when "110010101110001" =>  data <= "11101010";  -- 6571 = EA
      when "110010101110010" =>  data <= "11101010";  -- 6572 = EA
      when "110010101110011" =>  data <= "11101010";  -- 6573 = EA
      when "110010101110100" =>  data <= "11101010";  -- 6574 = EA
      when "110010101110101" =>  data <= "11101010";  -- 6575 = EA
      when "110010101110110" =>  data <= "11101010";  -- 6576 = EA
      when "110010101110111" =>  data <= "11101010";  -- 6577 = EA
      when "110010101111000" =>  data <= "00001001";  -- 6578 = 9
      when "110010101111001" =>  data <= "10000000";  -- 6579 = 80
      when "110010101111010" =>  data <= "10100110";  -- 657A = A6
      when "110010101111011" =>  data <= "10011110";  -- 657B = 9E
      when "110010101111100" =>  data <= "11101100";  -- 657C = EC
      when "110010101111101" =>  data <= "11101011";  -- 657D = EB
      when "110010101111110" =>  data <= "00000011";  -- 657E = 3
      when "110010101111111" =>  data <= "10110000";  -- 657F = B0
      when "110010110000000" =>  data <= "00000110";  -- 6580 = 6
      when "110010110000001" =>  data <= "10011101";  -- 6581 = 9D
      when "110010110000010" =>  data <= "01101111";  -- 6582 = 6F
      when "110010110000011" =>  data <= "00000010";  -- 6583 = 2
      when "110010110000100" =>  data <= "11101000";  -- 6584 = E8
      when "110010110000101" =>  data <= "10000110";  -- 6585 = 86
      when "110010110000110" =>  data <= "10011110";  -- 6586 = 9E
      when "110010110000111" =>  data <= "01100000";  -- 6587 = 60
      when "110010110001000" =>  data <= "10011000";  -- 6588 = 98
      when "110010110001001" =>  data <= "00101001";  -- 6589 = 29
      when "110010110001010" =>  data <= "00000111";  -- 658A = 7
      when "110010110001011" =>  data <= "10101010";  -- 658B = AA
      when "110010110001100" =>  data <= "10111101";  -- 658C = BD
      when "110010110001101" =>  data <= "11011100";  -- 658D = DC
      when "110010110001110" =>  data <= "11100111";  -- 658E = E7
      when "110010110001111" =>  data <= "10001101";  -- 658F = 8D
      when "110010110010000" =>  data <= "11101111";  -- 6590 = EF
      when "110010110010001" =>  data <= "00000011";  -- 6591 = 3
      when "110010110010010" =>  data <= "10011000";  -- 6592 = 98
      when "110010110010011" =>  data <= "01001010";  -- 6593 = 4A
      when "110010110010100" =>  data <= "01001010";  -- 6594 = 4A
      when "110010110010101" =>  data <= "01001010";  -- 6595 = 4A
      when "110010110010110" =>  data <= "10101010";  -- 6596 = AA
      when "110010110010111" =>  data <= "10111101";  -- 6597 = BD
      when "110010110011000" =>  data <= "11110000";  -- 6598 = F0
      when "110010110011001" =>  data <= "00000011";  -- 6599 = 3
      when "110010110011010" =>  data <= "00101100";  -- 659A = 2C
      when "110010110011011" =>  data <= "11101111";  -- 659B = EF
      when "110010110011100" =>  data <= "00000011";  -- 659C = 3
      when "110010110011101" =>  data <= "01100000";  -- 659D = 60
      when "110010110011110" =>  data <= "10101010";  -- 659E = AA
      when "110010110011111" =>  data <= "10101010";  -- 659F = AA
      when "110010110100000" =>  data <= "10101010";  -- 65A0 = AA
      when "110010110100001" =>  data <= "10101010";  -- 65A1 = AA
      when "110010110100010" =>  data <= "10101010";  -- 65A2 = AA
      when "110010110100011" =>  data <= "10101010";  -- 65A3 = AA
      when "110010110100100" =>  data <= "10101010";  -- 65A4 = AA
      when "110010110100101" =>  data <= "10101010";  -- 65A5 = AA
      when "110010110100110" =>  data <= "10101010";  -- 65A6 = AA
      when "110010110100111" =>  data <= "10101010";  -- 65A7 = AA
      when "110010110101000" =>  data <= "10101010";  -- 65A8 = AA
      when "110010110101001" =>  data <= "10101010";  -- 65A9 = AA
      when "110010110101010" =>  data <= "10101010";  -- 65AA = AA
      when "110010110101011" =>  data <= "10101010";  -- 65AB = AA
      when "110010110101100" =>  data <= "10101010";  -- 65AC = AA
      when "110010110101101" =>  data <= "10101010";  -- 65AD = AA
      when "110010110101110" =>  data <= "10101010";  -- 65AE = AA
      when "110010110101111" =>  data <= "10101010";  -- 65AF = AA
      when "110010110110000" =>  data <= "10101010";  -- 65B0 = AA
      when "110010110110001" =>  data <= "10101010";  -- 65B1 = AA
      when "110010110110010" =>  data <= "10101010";  -- 65B2 = AA
      when "110010110110011" =>  data <= "10101010";  -- 65B3 = AA
      when "110010110110100" =>  data <= "10101010";  -- 65B4 = AA
      when "110010110110101" =>  data <= "10101010";  -- 65B5 = AA
      when "110010110110110" =>  data <= "10101010";  -- 65B6 = AA
      when "110010110110111" =>  data <= "10101010";  -- 65B7 = AA
      when "110010110111000" =>  data <= "10101010";  -- 65B8 = AA
      when "110010110111001" =>  data <= "10101010";  -- 65B9 = AA
      when "110010110111010" =>  data <= "10101010";  -- 65BA = AA
      when "110010110111011" =>  data <= "10101010";  -- 65BB = AA
      when "110010110111100" =>  data <= "10101010";  -- 65BC = AA
      when "110010110111101" =>  data <= "10101010";  -- 65BD = AA
      when "110010110111110" =>  data <= "10101010";  -- 65BE = AA
      when "110010110111111" =>  data <= "10101010";  -- 65BF = AA
      when "110010111000000" =>  data <= "10101010";  -- 65C0 = AA
      when "110010111000001" =>  data <= "10101010";  -- 65C1 = AA
      when "110010111000010" =>  data <= "10101010";  -- 65C2 = AA
      when "110010111000011" =>  data <= "10101010";  -- 65C3 = AA
      when "110010111000100" =>  data <= "10101010";  -- 65C4 = AA
      when "110010111000101" =>  data <= "10101010";  -- 65C5 = AA
      when "110010111000110" =>  data <= "10101010";  -- 65C6 = AA
      when "110010111000111" =>  data <= "10101010";  -- 65C7 = AA
      when "110010111001000" =>  data <= "10101010";  -- 65C8 = AA
      when "110010111001001" =>  data <= "10101010";  -- 65C9 = AA
      when "110010111001010" =>  data <= "10101010";  -- 65CA = AA
      when "110010111001011" =>  data <= "10101010";  -- 65CB = AA
      when "110010111001100" =>  data <= "10101010";  -- 65CC = AA
      when "110010111001101" =>  data <= "10101010";  -- 65CD = AA
      when "110010111001110" =>  data <= "10101010";  -- 65CE = AA
      when "110010111001111" =>  data <= "10101010";  -- 65CF = AA
      when "110010111010000" =>  data <= "10101010";  -- 65D0 = AA
      when "110010111010001" =>  data <= "10101010";  -- 65D1 = AA
      when "110010111010010" =>  data <= "10101010";  -- 65D2 = AA
      when "110010111010011" =>  data <= "10101010";  -- 65D3 = AA
      when "110010111010100" =>  data <= "10101010";  -- 65D4 = AA
      when "110010111010101" =>  data <= "10101010";  -- 65D5 = AA
      when "110010111010110" =>  data <= "10101010";  -- 65D6 = AA
      when "110010111010111" =>  data <= "10101010";  -- 65D7 = AA
      when "110010111011000" =>  data <= "10101010";  -- 65D8 = AA
      when "110010111011001" =>  data <= "10101010";  -- 65D9 = AA
      when "110010111011010" =>  data <= "10101010";  -- 65DA = AA
      when "110010111011011" =>  data <= "10101010";  -- 65DB = AA
      when "110010111011100" =>  data <= "10101010";  -- 65DC = AA
      when "110010111011101" =>  data <= "10101010";  -- 65DD = AA
      when "110010111011110" =>  data <= "10101010";  -- 65DE = AA
      when "110010111011111" =>  data <= "10101010";  -- 65DF = AA
      when "110010111100000" =>  data <= "10101010";  -- 65E0 = AA
      when "110010111100001" =>  data <= "10101010";  -- 65E1 = AA
      when "110010111100010" =>  data <= "10101010";  -- 65E2 = AA
      when "110010111100011" =>  data <= "10101010";  -- 65E3 = AA
      when "110010111100100" =>  data <= "10101010";  -- 65E4 = AA
      when "110010111100101" =>  data <= "10101010";  -- 65E5 = AA
      when "110010111100110" =>  data <= "10101010";  -- 65E6 = AA
      when "110010111100111" =>  data <= "10101010";  -- 65E7 = AA
      when "110010111101000" =>  data <= "10101010";  -- 65E8 = AA
      when "110010111101001" =>  data <= "10101010";  -- 65E9 = AA
      when "110010111101010" =>  data <= "10101010";  -- 65EA = AA
      when "110010111101011" =>  data <= "10101010";  -- 65EB = AA
      when "110010111101100" =>  data <= "10101010";  -- 65EC = AA
      when "110010111101101" =>  data <= "10101010";  -- 65ED = AA
      when "110010111101110" =>  data <= "10101010";  -- 65EE = AA
      when "110010111101111" =>  data <= "10101010";  -- 65EF = AA
      when "110010111110000" =>  data <= "10101010";  -- 65F0 = AA
      when "110010111110001" =>  data <= "10101010";  -- 65F1 = AA
      when "110010111110010" =>  data <= "10101010";  -- 65F2 = AA
      when "110010111110011" =>  data <= "10101010";  -- 65F3 = AA
      when "110010111110100" =>  data <= "10101010";  -- 65F4 = AA
      when "110010111110101" =>  data <= "10101010";  -- 65F5 = AA
      when "110010111110110" =>  data <= "10101010";  -- 65F6 = AA
      when "110010111110111" =>  data <= "10101010";  -- 65F7 = AA
      when "110010111111000" =>  data <= "10101010";  -- 65F8 = AA
      when "110010111111001" =>  data <= "10101010";  -- 65F9 = AA
      when "110010111111010" =>  data <= "10101010";  -- 65FA = AA
      when "110010111111011" =>  data <= "10101010";  -- 65FB = AA
      when "110010111111100" =>  data <= "10101010";  -- 65FC = AA
      when "110010111111101" =>  data <= "10101010";  -- 65FD = AA
      when "110010111111110" =>  data <= "10101010";  -- 65FE = AA
      when "110010111111111" =>  data <= "10101010";  -- 65FF = AA
      when "110011000000000" =>  data <= "01101000";  -- 6600 = 68
      when "110011000000001" =>  data <= "10101000";  -- 6601 = A8
      when "110011000000010" =>  data <= "01101000";  -- 6602 = 68
      when "110011000000011" =>  data <= "10101010";  -- 6603 = AA
      when "110011000000100" =>  data <= "01101000";  -- 6604 = 68
      when "110011000000101" =>  data <= "01000000";  -- 6605 = 40
      when "110011000000110" =>  data <= "10100100";  -- 6606 = A4
      when "110011000000111" =>  data <= "11000110";  -- 6607 = C6
      when "110011000001000" =>  data <= "10010001";  -- 6608 = 91
      when "110011000001001" =>  data <= "11000100";  -- 6609 = C4
      when "110011000001010" =>  data <= "10101001";  -- 660A = A9
      when "110011000001011" =>  data <= "00000010";  -- 660B = 2
      when "110011000001100" =>  data <= "10000101";  -- 660C = 85
      when "110011000001101" =>  data <= "10101000";  -- 660D = A8
      when "110011000001110" =>  data <= "01100000";  -- 660E = 60
      when "110011000001111" =>  data <= "10101001";  -- 660F = A9
      when "110011000010000" =>  data <= "10110001";  -- 6610 = B1
      when "110011000010001" =>  data <= "10100010";  -- 6611 = A2
      when "110011000010010" =>  data <= "11100111";  -- 6612 = E7
      when "110011000010011" =>  data <= "10100000";  -- 6613 = A0
      when "110011000010100" =>  data <= "00001110";  -- 6614 = E
      when "110011000010101" =>  data <= "11010000";  -- 6615 = D0
      when "110011000010110" =>  data <= "00000110";  -- 6616 = 6
      when "110011000010111" =>  data <= "10101001";  -- 6617 = A9
      when "110011000011000" =>  data <= "11000011";  -- 6618 = C3
      when "110011000011001" =>  data <= "10100010";  -- 6619 = A2
      when "110011000011010" =>  data <= "11100111";  -- 661A = E7
      when "110011000011011" =>  data <= "10100000";  -- 661B = A0
      when "110011000011100" =>  data <= "00001100";  -- 661C = C
      when "110011000011101" =>  data <= "10000101";  -- 661D = 85
      when "110011000011110" =>  data <= "11000111";  -- 661E = C7
      when "110011000011111" =>  data <= "10000110";  -- 661F = 86
      when "110011000100000" =>  data <= "11001000";  -- 6620 = C8
      when "110011000100001" =>  data <= "10101101";  -- 6621 = AD
      when "110011000100010" =>  data <= "01001100";  -- 6622 = 4C
      when "110011000100011" =>  data <= "11101000";  -- 6623 = E8
      when "110011000100100" =>  data <= "00101001";  -- 6624 = 29
      when "110011000100101" =>  data <= "11110000";  -- 6625 = F0
      when "110011000100110" =>  data <= "10000101";  -- 6626 = 85
      when "110011000100111" =>  data <= "11010001";  -- 6627 = D1
      when "110011000101000" =>  data <= "10011000";  -- 6628 = 98
      when "110011000101001" =>  data <= "00000101";  -- 6629 = 5
      when "110011000101010" =>  data <= "11010001";  -- 662A = D1
      when "110011000101011" =>  data <= "10001101";  -- 662B = 8D
      when "110011000101100" =>  data <= "01001100";  -- 662C = 4C
      when "110011000101101" =>  data <= "11101000";  -- 662D = E8
      when "110011000101110" =>  data <= "10100000";  -- 662E = A0
      when "110011000101111" =>  data <= "00010001";  -- 662F = 11
      when "110011000110000" =>  data <= "10110001";  -- 6630 = B1
      when "110011000110001" =>  data <= "11000111";  -- 6631 = C7
      when "110011000110010" =>  data <= "10001100";  -- 6632 = 8C
      when "110011000110011" =>  data <= "10000000";  -- 6633 = 80
      when "110011000110100" =>  data <= "11101000";  -- 6634 = E8
      when "110011000110101" =>  data <= "10001101";  -- 6635 = 8D
      when "110011000110110" =>  data <= "10000001";  -- 6636 = 81
      when "110011000110111" =>  data <= "11101000";  -- 6637 = E8
      when "110011000111000" =>  data <= "10001000";  -- 6638 = 88
      when "110011000111001" =>  data <= "00010000";  -- 6639 = 10
      when "110011000111010" =>  data <= "11110101";  -- 663A = F5
      when "110011000111011" =>  data <= "01100000";  -- 663B = 60
      when "110011000111100" =>  data <= "00100000";  -- 663C = 20
      when "110011000111101" =>  data <= "00000010";  -- 663D = 2
      when "110011000111110" =>  data <= "11100010";  -- 663E = E2
      when "110011000111111" =>  data <= "10101010";  -- 663F = AA
      when "110011001000000" =>  data <= "10100101";  -- 6640 = A5
      when "110011001000001" =>  data <= "11010101";  -- 6641 = D5
      when "110011001000010" =>  data <= "00111000";  -- 6642 = 38
      when "110011001000011" =>  data <= "11100101";  -- 6643 = E5
      when "110011001000100" =>  data <= "11000110";  -- 6644 = C6
      when "110011001000101" =>  data <= "11001001";  -- 6645 = C9
      when "110011001000110" =>  data <= "00000101";  -- 6646 = 5
      when "110011001000111" =>  data <= "11010000";  -- 6647 = D0
      when "110011001001000" =>  data <= "00111001";  -- 6648 = 39
      when "110011001001001" =>  data <= "10001010";  -- 6649 = 8A
      when "110011001001010" =>  data <= "11001001";  -- 664A = C9
      when "110011001001011" =>  data <= "00011101";  -- 664B = 1D
      when "110011001001100" =>  data <= "11110000";  -- 664C = F0
      when "110011001001101" =>  data <= "00000110";  -- 664D = 6
      when "110011001001110" =>  data <= "00101001";  -- 664E = 29
      when "110011001001111" =>  data <= "01111111";  -- 664F = 7F
      when "110011001010000" =>  data <= "11001001";  -- 6650 = C9
      when "110011001010001" =>  data <= "00100000";  -- 6651 = 20
      when "110011001010010" =>  data <= "10010000";  -- 6652 = 90
      when "110011001010011" =>  data <= "00101110";  -- 6653 = 2E
      when "110011001010100" =>  data <= "00100000";  -- 6654 = 20
      when "110011001010101" =>  data <= "01010111";  -- 6655 = 57
      when "110011001010110" =>  data <= "11100110";  -- 6656 = E6
      when "110011001010111" =>  data <= "10101100";  -- 6657 = AC
      when "110011001011000" =>  data <= "11101100";  -- 6658 = EC
      when "110011001011001" =>  data <= "00000011";  -- 6659 = 3
      when "110011001011010" =>  data <= "11110000";  -- 665A = F0
      when "110011001011011" =>  data <= "00100110";  -- 665B = 26
      when "110011001011100" =>  data <= "10101001";  -- 665C = A9
      when "110011001011101" =>  data <= "00010000";  -- 665D = 10
      when "110011001011110" =>  data <= "10001101";  -- 665E = 8D
      when "110011001011111" =>  data <= "01001011";  -- 665F = 4B
      when "110011001100000" =>  data <= "11101000";  -- 6660 = E8
      when "110011001100001" =>  data <= "10101001";  -- 6661 = A9
      when "110011001100010" =>  data <= "00001111";  -- 6662 = F
      when "110011001100011" =>  data <= "10001101";  -- 6663 = 8D
      when "110011001100100" =>  data <= "01001010";  -- 6664 = 4A
      when "110011001100101" =>  data <= "11101000";  -- 6665 = E8
      when "110011001100110" =>  data <= "10100010";  -- 6666 = A2
      when "110011001100111" =>  data <= "00000111";  -- 6667 = 7
      when "110011001101000" =>  data <= "10111101";  -- 6668 = BD
      when "110011001101001" =>  data <= "11010100";  -- 6669 = D4
      when "110011001101010" =>  data <= "11100111";  -- 666A = E7
      when "110011001101011" =>  data <= "10001101";  -- 666B = 8D
      when "110011001101100" =>  data <= "01001000";  -- 666C = 48
      when "110011001101101" =>  data <= "11101000";  -- 666D = E8
      when "110011001101110" =>  data <= "10101101";  -- 666E = AD
      when "110011001101111" =>  data <= "11101100";  -- 666F = EC
      when "110011001110000" =>  data <= "00000011";  -- 6670 = 3
      when "110011001110001" =>  data <= "10001000";  -- 6671 = 88
      when "110011001110010" =>  data <= "11010000";  -- 6672 = D0
      when "110011001110011" =>  data <= "11111101";  -- 6673 = FD
      when "110011001110100" =>  data <= "00111000";  -- 6674 = 38
      when "110011001110101" =>  data <= "11101001";  -- 6675 = E9
      when "110011001110110" =>  data <= "00000001";  -- 6676 = 1
      when "110011001110111" =>  data <= "11010000";  -- 6677 = D0
      when "110011001111000" =>  data <= "11111000";  -- 6678 = F8
      when "110011001111001" =>  data <= "11001010";  -- 6679 = CA
      when "110011001111010" =>  data <= "11010000";  -- 667A = D0
      when "110011001111011" =>  data <= "11101100";  -- 667B = EC
      when "110011001111100" =>  data <= "10001110";  -- 667C = 8E
      when "110011001111101" =>  data <= "01001010";  -- 667D = 4A
      when "110011001111110" =>  data <= "11101000";  -- 667E = E8
      when "110011001111111" =>  data <= "10001110";  -- 667F = 8E
      when "110011010000000" =>  data <= "01001011";  -- 6680 = 4B
      when "110011010000001" =>  data <= "11101000";  -- 6681 = E8
      when "110011010000010" =>  data <= "01100000";  -- 6682 = 60
      when "110011010000011" =>  data <= "10101001";  -- 6683 = A9
      when "110011010000100" =>  data <= "01111111";  -- 6684 = 7F
      when "110011010000101" =>  data <= "10001101";  -- 6685 = 8D
      when "110011010000110" =>  data <= "01001110";  -- 6686 = 4E
      when "110011010000111" =>  data <= "11101000";  -- 6687 = E8
      when "110011010001000" =>  data <= "10100010";  -- 6688 = A2
      when "110011010001001" =>  data <= "01101101";  -- 6689 = 6D
      when "110011010001010" =>  data <= "10101001";  -- 668A = A9
      when "110011010001011" =>  data <= "00000000";  -- 668B = 0
      when "110011010001100" =>  data <= "10010101";  -- 668C = 95
      when "110011010001101" =>  data <= "10001101";  -- 668D = 8D
      when "110011010001110" =>  data <= "11001010";  -- 668E = CA
      when "110011010001111" =>  data <= "00010000";  -- 668F = 10
      when "110011010010000" =>  data <= "11111011";  -- 6690 = FB
      when "110011010010001" =>  data <= "10100010";  -- 6691 = A2
      when "110011010010010" =>  data <= "00001010";  -- 6692 = A
      when "110011010010011" =>  data <= "10011101";  -- 6693 = 9D
      when "110011010010100" =>  data <= "11110000";  -- 6694 = F0
      when "110011010010101" =>  data <= "00000011";  -- 6695 = 3
      when "110011010010110" =>  data <= "11001010";  -- 6696 = CA
      when "110011010010111" =>  data <= "00010000";  -- 6697 = 10
      when "110011010011000" =>  data <= "11111010";  -- 6698 = FA
      when "110011010011001" =>  data <= "10001101";  -- 6699 = 8D
      when "110011010011010" =>  data <= "11101110";  -- 669A = EE
      when "110011010011011" =>  data <= "00000011";  -- 669B = 3
      when "110011010011100" =>  data <= "10101001";  -- 669C = A9
      when "110011010011101" =>  data <= "01010101";  -- 669D = 55
      when "110011010011110" =>  data <= "10000101";  -- 669E = 85
      when "110011010011111" =>  data <= "10010000";  -- 669F = 90
      when "110011010100000" =>  data <= "10101001";  -- 66A0 = A9
      when "110011010100001" =>  data <= "11100100";  -- 66A1 = E4
      when "110011010100010" =>  data <= "10000101";  -- 66A2 = 85
      when "110011010100011" =>  data <= "10010001";  -- 66A3 = 91
      when "110011010100100" =>  data <= "10101001";  -- 66A4 = A9
      when "110011010100101" =>  data <= "00000011";  -- 66A5 = 3
      when "110011010100110" =>  data <= "10000101";  -- 66A6 = 85
      when "110011010100111" =>  data <= "10110000";  -- 66A7 = B0
      when "110011010101000" =>  data <= "10101001";  -- 66A8 = A9
      when "110011010101001" =>  data <= "00001111";  -- 66A9 = F
      when "110011010101010" =>  data <= "10001101";  -- 66AA = 8D
      when "110011010101011" =>  data <= "00010000";  -- 66AB = 10
      when "110011010101100" =>  data <= "11101000";  -- 66AC = E8
      when "110011010101101" =>  data <= "00001010";  -- 66AD = A
      when "110011010101110" =>  data <= "10001101";  -- 66AE = 8D
      when "110011010101111" =>  data <= "01000000";  -- 66AF = 40
      when "110011010110000" =>  data <= "11101000";  -- 66B0 = E8
      when "110011010110001" =>  data <= "10001101";  -- 66B1 = 8D
      when "110011010110010" =>  data <= "01000010";  -- 66B2 = 42
      when "110011010110011" =>  data <= "11101000";  -- 66B3 = E8
      when "110011010110100" =>  data <= "10001110";  -- 66B4 = 8E
      when "110011010110101" =>  data <= "00100010";  -- 66B5 = 22
      when "110011010110110" =>  data <= "11101000";  -- 66B6 = E8
      when "110011010110111" =>  data <= "10001110";  -- 66B7 = 8E
      when "110011010111000" =>  data <= "01000101";  -- 66B8 = 45
      when "110011010111001" =>  data <= "11101000";  -- 66B9 = E8
      when "110011010111010" =>  data <= "10101001";  -- 66BA = A9
      when "110011010111011" =>  data <= "00111101";  -- 66BB = 3D
      when "110011010111100" =>  data <= "10001101";  -- 66BC = 8D
      when "110011010111101" =>  data <= "00010011";  -- 66BD = 13
      when "110011010111110" =>  data <= "11101000";  -- 66BE = E8
      when "110011010111111" =>  data <= "00101100";  -- 66BF = 2C
      when "110011011000000" =>  data <= "00010010";  -- 66C0 = 12
      when "110011011000001" =>  data <= "11101000";  -- 66C1 = E8
      when "110011011000010" =>  data <= "10101001";  -- 66C2 = A9
      when "110011011000011" =>  data <= "00111100";  -- 66C3 = 3C
      when "110011011000100" =>  data <= "10001101";  -- 66C4 = 8D
      when "110011011000101" =>  data <= "00100001";  -- 66C5 = 21
      when "110011011000110" =>  data <= "11101000";  -- 66C6 = E8
      when "110011011000111" =>  data <= "10001101";  -- 66C7 = 8D
      when "110011011001000" =>  data <= "00100011";  -- 66C8 = 23
      when "110011011001001" =>  data <= "11101000";  -- 66C9 = E8
      when "110011011001010" =>  data <= "10001101";  -- 66CA = 8D
      when "110011011001011" =>  data <= "00010001";  -- 66CB = 11
      when "110011011001100" =>  data <= "11101000";  -- 66CC = E8
      when "110011011001101" =>  data <= "10001110";  -- 66CD = 8E
      when "110011011001110" =>  data <= "00100010";  -- 66CE = 22
      when "110011011001111" =>  data <= "11101000";  -- 66CF = E8
      when "110011011010000" =>  data <= "10101001";  -- 66D0 = A9
      when "110011011010001" =>  data <= "00001100";  -- 66D1 = C
      when "110011011010010" =>  data <= "10001101";  -- 66D2 = 8D
      when "110011011010011" =>  data <= "01001100";  -- 66D3 = 4C
      when "110011011010100" =>  data <= "11101000";  -- 66D4 = E8
      when "110011011010101" =>  data <= "10000101";  -- 66D5 = 85
      when "110011011010110" =>  data <= "10101000";  -- 66D6 = A8
      when "110011011010111" =>  data <= "10000101";  -- 66D7 = 85
      when "110011011011000" =>  data <= "10100111";  -- 66D8 = A7
      when "110011011011001" =>  data <= "10101001";  -- 66D9 = A9
      when "110011011011010" =>  data <= "00001001";  -- 66DA = 9
      when "110011011011011" =>  data <= "10001101";  -- 66DB = 8D
      when "110011011011100" =>  data <= "11101011";  -- 66DC = EB
      when "110011011011101" =>  data <= "00000011";  -- 66DD = 3
      when "110011011011110" =>  data <= "10101001";  -- 66DE = A9
      when "110011011011111" =>  data <= "00010000";  -- 66DF = 10
      when "110011011100000" =>  data <= "10001101";  -- 66E0 = 8D
      when "110011011100001" =>  data <= "11101100";  -- 66E1 = EC
      when "110011011100010" =>  data <= "00000011";  -- 66E2 = 3
      when "110011011100011" =>  data <= "10001101";  -- 66E3 = 8D
      when "110011011100100" =>  data <= "11101001";  -- 66E4 = E9
      when "110011011100101" =>  data <= "00000011";  -- 66E5 = 3
      when "110011011100110" =>  data <= "10001101";  -- 66E6 = 8D
      when "110011011100111" =>  data <= "11101010";  -- 66E7 = EA
      when "110011011101000" =>  data <= "00000011";  -- 66E8 = 3
      when "110011011101001" =>  data <= "01100000";  -- 66E9 = 60
      when "110011011101010" =>  data <= "10100110";  -- 66EA = A6
      when "110011011101011" =>  data <= "11011000";  -- 66EB = D8
      when "110011011101100" =>  data <= "11101000";  -- 66EC = E8
      when "110011011101101" =>  data <= "11100000";  -- 66ED = E0
      when "110011011101110" =>  data <= "00011000";  -- 66EE = 18
      when "110011011101111" =>  data <= "11110000";  -- 66EF = F0
      when "110011011110000" =>  data <= "00110011";  -- 66F0 = 33
      when "110011011110001" =>  data <= "10010000";  -- 66F1 = 90
      when "110011011110010" =>  data <= "00000011";  -- 66F2 = 3
      when "110011011110011" =>  data <= "01001100";  -- 66F3 = 4C
      when "110011011110100" =>  data <= "11000100";  -- 66F4 = C4
      when "110011011110101" =>  data <= "11100001";  -- 66F5 = E1
      when "110011011110110" =>  data <= "10100010";  -- 66F6 = A2
      when "110011011110111" =>  data <= "00010111";  -- 66F7 = 17
      when "110011011111000" =>  data <= "10110101";  -- 66F8 = B5
      when "110011011111001" =>  data <= "11100001";  -- 66F9 = E1
      when "110011011111010" =>  data <= "00001001";  -- 66FA = 9
      when "110011011111011" =>  data <= "10000000";  -- 66FB = 80
      when "110011011111100" =>  data <= "10000101";  -- 66FC = 85
      when "110011011111101" =>  data <= "11001000";  -- 66FD = C8
      when "110011011111110" =>  data <= "10110100";  -- 66FE = B4
      when "110011011111111" =>  data <= "11100000";  -- 66FF = E0
      when "110011100000000" =>  data <= "00110000";  -- 6700 = 30
      when "110011100000001" =>  data <= "00000010";  -- 6701 = 2
      when "110011100000010" =>  data <= "00101001";  -- 6702 = 29
      when "110011100000011" =>  data <= "01111111";  -- 6703 = 7F
      when "110011100000100" =>  data <= "10010101";  -- 6704 = 95
      when "110011100000101" =>  data <= "11100001";  -- 6705 = E1
      when "110011100000110" =>  data <= "10011000";  -- 6706 = 98
      when "110011100000111" =>  data <= "00001001";  -- 6707 = 9
      when "110011100001000" =>  data <= "10000000";  -- 6708 = 80
      when "110011100001001" =>  data <= "10000101";  -- 6709 = 85
      when "110011100001010" =>  data <= "11000101";  -- 670A = C5
      when "110011100001011" =>  data <= "10100000";  -- 670B = A0
      when "110011100001100" =>  data <= "00100111";  -- 670C = 27
      when "110011100001101" =>  data <= "10111101";  -- 670D = BD
      when "110011100001110" =>  data <= "10011001";  -- 670E = 99
      when "110011100001111" =>  data <= "11100111";  -- 670F = E7
      when "110011100010000" =>  data <= "10000101";  -- 6710 = 85
      when "110011100010001" =>  data <= "11000111";  -- 6711 = C7
      when "110011100010010" =>  data <= "10111101";  -- 6712 = BD
      when "110011100010011" =>  data <= "10011000";  -- 6713 = 98
      when "110011100010100" =>  data <= "11100111";  -- 6714 = E7
      when "110011100010101" =>  data <= "10000101";  -- 6715 = 85
      when "110011100010110" =>  data <= "11000100";  -- 6716 = C4
      when "110011100010111" =>  data <= "10110001";  -- 6717 = B1
      when "110011100011000" =>  data <= "11000100";  -- 6718 = C4
      when "110011100011001" =>  data <= "10010001";  -- 6719 = 91
      when "110011100011010" =>  data <= "11000111";  -- 671A = C7
      when "110011100011011" =>  data <= "10001000";  -- 671B = 88
      when "110011100011100" =>  data <= "00010000";  -- 671C = 10
      when "110011100011101" =>  data <= "11111001";  -- 671D = F9
      when "110011100011110" =>  data <= "11001010";  -- 671E = CA
      when "110011100011111" =>  data <= "11100100";  -- 671F = E4
      when "110011100100000" =>  data <= "11011000";  -- 6720 = D8
      when "110011100100001" =>  data <= "11010000";  -- 6721 = D0
      when "110011100100010" =>  data <= "11010101";  -- 6722 = D5
      when "110011100100011" =>  data <= "11101000";  -- 6723 = E8
      when "110011100100100" =>  data <= "10110101";  -- 6724 = B5
      when "110011100100101" =>  data <= "11100000";  -- 6725 = E0
      when "110011100100110" =>  data <= "00001001";  -- 6726 = 9
      when "110011100100111" =>  data <= "10000000";  -- 6727 = 80
      when "110011100101000" =>  data <= "10000101";  -- 6728 = 85
      when "110011100101001" =>  data <= "11000101";  -- 6729 = C5
      when "110011100101010" =>  data <= "00101001";  -- 672A = 29
      when "110011100101011" =>  data <= "01111111";  -- 672B = 7F
      when "110011100101100" =>  data <= "10010101";  -- 672C = 95
      when "110011100101101" =>  data <= "11100000";  -- 672D = E0
      when "110011100101110" =>  data <= "10111101";  -- 672E = BD
      when "110011100101111" =>  data <= "10011000";  -- 672F = 98
      when "110011100110000" =>  data <= "11100111";  -- 6730 = E7
      when "110011100110001" =>  data <= "10000101";  -- 6731 = 85
      when "110011100110010" =>  data <= "11000100";  -- 6732 = C4
      when "110011100110011" =>  data <= "10100000";  -- 6733 = A0
      when "110011100110100" =>  data <= "00100111";  -- 6734 = 27
      when "110011100110101" =>  data <= "10101001";  -- 6735 = A9
      when "110011100110110" =>  data <= "00100000";  -- 6736 = 20
      when "110011100110111" =>  data <= "10010001";  -- 6737 = 91
      when "110011100111000" =>  data <= "11000100";  -- 6738 = C4
      when "110011100111001" =>  data <= "10001000";  -- 6739 = 88
      when "110011100111010" =>  data <= "00010000";  -- 673A = 10
      when "110011100111011" =>  data <= "11111011";  -- 673B = FB
      when "110011100111100" =>  data <= "01001100";  -- 673C = 4C
      when "110011100111101" =>  data <= "01110001";  -- 673D = 71
      when "110011100111110" =>  data <= "11100000";  -- 673E = E0
      when "110011100111111" =>  data <= "00111101";  -- 673F = 3D
      when "110011101000000" =>  data <= "00101110";  -- 6740 = 2E
      when "110011101000001" =>  data <= "00010000";  -- 6741 = 10
      when "110011101000010" =>  data <= "00000011";  -- 6742 = 3
      when "110011101000011" =>  data <= "00111100";  -- 6743 = 3C
      when "110011101000100" =>  data <= "00100000";  -- 6744 = 20
      when "110011101000101" =>  data <= "01011011";  -- 6745 = 5B
      when "110011101000110" =>  data <= "00010010";  -- 6746 = 12
      when "110011101000111" =>  data <= "00101101";  -- 6747 = 2D
      when "110011101001000" =>  data <= "00110000";  -- 6748 = 30
      when "110011101001001" =>  data <= "00000000";  -- 6749 = 0
      when "110011101001010" =>  data <= "00111110";  -- 674A = 3E
      when "110011101001011" =>  data <= "11111111";  -- 674B = FF
      when "110011101001100" =>  data <= "01011101";  -- 674C = 5D
      when "110011101001101" =>  data <= "01000000";  -- 674D = 40
      when "110011101001110" =>  data <= "00000000";  -- 674E = 0
      when "110011101001111" =>  data <= "00101011";  -- 674F = 2B
      when "110011101010000" =>  data <= "00110010";  -- 6750 = 32
      when "110011101010001" =>  data <= "11111111";  -- 6751 = FF
      when "110011101010010" =>  data <= "00111111";  -- 6752 = 3F
      when "110011101010011" =>  data <= "00101100";  -- 6753 = 2C
      when "110011101010100" =>  data <= "01001110";  -- 6754 = 4E
      when "110011101010101" =>  data <= "01010110";  -- 6755 = 56
      when "110011101010110" =>  data <= "01011000";  -- 6756 = 58
      when "110011101010111" =>  data <= "00110011";  -- 6757 = 33
      when "110011101011000" =>  data <= "00110001";  -- 6758 = 31
      when "110011101011001" =>  data <= "00001101";  -- 6759 = D
      when "110011101011010" =>  data <= "00111011";  -- 675A = 3B
      when "110011101011011" =>  data <= "01001101";  -- 675B = 4D
      when "110011101011100" =>  data <= "01000010";  -- 675C = 42
      when "110011101011101" =>  data <= "01000011";  -- 675D = 43
      when "110011101011110" =>  data <= "01011010";  -- 675E = 5A
      when "110011101011111" =>  data <= "00101010";  -- 675F = 2A
      when "110011101100000" =>  data <= "00110101";  -- 6760 = 35
      when "110011101100001" =>  data <= "11111111";  -- 6761 = FF
      when "110011101100010" =>  data <= "00111010";  -- 6762 = 3A
      when "110011101100011" =>  data <= "01001011";  -- 6763 = 4B
      when "110011101100100" =>  data <= "01001000";  -- 6764 = 48
      when "110011101100101" =>  data <= "01000110";  -- 6765 = 46
      when "110011101100110" =>  data <= "01010011";  -- 6766 = 53
      when "110011101100111" =>  data <= "00110110";  -- 6767 = 36
      when "110011101101000" =>  data <= "00110100";  -- 6768 = 34
      when "110011101101001" =>  data <= "11111111";  -- 6769 = FF
      when "110011101101010" =>  data <= "01001100";  -- 676A = 4C
      when "110011101101011" =>  data <= "01001010";  -- 676B = 4A
      when "110011101101100" =>  data <= "01000111";  -- 676C = 47
      when "110011101101101" =>  data <= "01000100";  -- 676D = 44
      when "110011101101110" =>  data <= "01000001";  -- 676E = 41
      when "110011101101111" =>  data <= "00101111";  -- 676F = 2F
      when "110011101110000" =>  data <= "00111000";  -- 6770 = 38
      when "110011101110001" =>  data <= "11111111";  -- 6771 = FF
      when "110011101110010" =>  data <= "01010000";  -- 6772 = 50
      when "110011101110011" =>  data <= "01001001";  -- 6773 = 49
      when "110011101110100" =>  data <= "01011001";  -- 6774 = 59
      when "110011101110101" =>  data <= "01010010";  -- 6775 = 52
      when "110011101110110" =>  data <= "01010111";  -- 6776 = 57
      when "110011101110111" =>  data <= "00111001";  -- 6777 = 39
      when "110011101111000" =>  data <= "00110111";  -- 6778 = 37
      when "110011101111001" =>  data <= "01011110";  -- 6779 = 5E
      when "110011101111010" =>  data <= "01001111";  -- 677A = 4F
      when "110011101111011" =>  data <= "01010101";  -- 677B = 55
      when "110011101111100" =>  data <= "01010100";  -- 677C = 54
      when "110011101111101" =>  data <= "01000101";  -- 677D = 45
      when "110011101111110" =>  data <= "01010001";  -- 677E = 51
      when "110011101111111" =>  data <= "00010100";  -- 677F = 14
      when "110011110000000" =>  data <= "00010001";  -- 6780 = 11
      when "110011110000001" =>  data <= "00001001";  -- 6781 = 9
      when "110011110000010" =>  data <= "00101001";  -- 6782 = 29
      when "110011110000011" =>  data <= "01011100";  -- 6783 = 5C
      when "110011110000100" =>  data <= "00100111";  -- 6784 = 27
      when "110011110000101" =>  data <= "00100100";  -- 6785 = 24
      when "110011110000110" =>  data <= "00100010";  -- 6786 = 22
      when "110011110000111" =>  data <= "00011101";  -- 6787 = 1D
      when "110011110001000" =>  data <= "00010011";  -- 6788 = 13
      when "110011110001001" =>  data <= "01011111";  -- 6789 = 5F
      when "110011110001010" =>  data <= "00101000";  -- 678A = 28
      when "110011110001011" =>  data <= "00100110";  -- 678B = 26
      when "110011110001100" =>  data <= "00100101";  -- 678C = 25
      when "110011110001101" =>  data <= "00100011";  -- 678D = 23
      when "110011110001110" =>  data <= "00100001";  -- 678E = 21
      when "110011110001111" =>  data <= "01000100";  -- 678F = 44
      when "110011110010000" =>  data <= "11001100";  -- 6790 = CC
      when "110011110010001" =>  data <= "00100010";  -- 6791 = 22
      when "110011110010010" =>  data <= "00101010";  -- 6792 = 2A
      when "110011110010011" =>  data <= "00001101";  -- 6793 = D
      when "110011110010100" =>  data <= "01010010";  -- 6794 = 52
      when "110011110010101" =>  data <= "01010101";  -- 6795 = 55
      when "110011110010110" =>  data <= "01001110";  -- 6796 = 4E
      when "110011110010111" =>  data <= "00001101";  -- 6797 = D
      when "110011110011000" =>  data <= "00000000";  -- 6798 = 0
      when "110011110011001" =>  data <= "00101000";  -- 6799 = 28
      when "110011110011010" =>  data <= "01010000";  -- 679A = 50
      when "110011110011011" =>  data <= "01111000";  -- 679B = 78
      when "110011110011100" =>  data <= "10100000";  -- 679C = A0
      when "110011110011101" =>  data <= "11001000";  -- 679D = C8
      when "110011110011110" =>  data <= "11110000";  -- 679E = F0
      when "110011110011111" =>  data <= "00011000";  -- 679F = 18
      when "110011110100000" =>  data <= "01000000";  -- 67A0 = 40
      when "110011110100001" =>  data <= "01101000";  -- 67A1 = 68
      when "110011110100010" =>  data <= "10010000";  -- 67A2 = 90
      when "110011110100011" =>  data <= "10111000";  -- 67A3 = B8
      when "110011110100100" =>  data <= "11100000";  -- 67A4 = E0
      when "110011110100101" =>  data <= "00001000";  -- 67A5 = 8
      when "110011110100110" =>  data <= "00110000";  -- 67A6 = 30
      when "110011110100111" =>  data <= "01011000";  -- 67A7 = 58
      when "110011110101000" =>  data <= "10000000";  -- 67A8 = 80
      when "110011110101001" =>  data <= "10101000";  -- 67A9 = A8
      when "110011110101010" =>  data <= "11010000";  -- 67AA = D0
      when "110011110101011" =>  data <= "11111000";  -- 67AB = F8
      when "110011110101100" =>  data <= "00100000";  -- 67AC = 20
      when "110011110101101" =>  data <= "01001000";  -- 67AD = 48
      when "110011110101110" =>  data <= "01110000";  -- 67AE = 70
      when "110011110101111" =>  data <= "10011000";  -- 67AF = 98
      when "110011110110000" =>  data <= "11000000";  -- 67B0 = C0
      when "110011110110001" =>  data <= "00111101";  -- 67B1 = 3D
      when "110011110110010" =>  data <= "00101000";  -- 67B2 = 28
      when "110011110110011" =>  data <= "00110001";  -- 67B3 = 31
      when "110011110110100" =>  data <= "00000011";  -- 67B4 = 3
      when "110011110110101" =>  data <= "00100010";  -- 67B5 = 22
      when "110011110110110" =>  data <= "00000000";  -- 67B6 = 0
      when "110011110110111" =>  data <= "00011001";  -- 67B7 = 19
      when "110011110111000" =>  data <= "00011101";  -- 67B8 = 1D
      when "110011110111001" =>  data <= "00000000";  -- 67B9 = 0
      when "110011110111010" =>  data <= "00001001";  -- 67BA = 9
      when "110011110111011" =>  data <= "00000000";  -- 67BB = 0
      when "110011110111100" =>  data <= "00000000";  -- 67BC = 0
      when "110011110111101" =>  data <= "00010000";  -- 67BD = 10
      when "110011110111110" =>  data <= "00000000";  -- 67BE = 0
      when "110011110111111" =>  data <= "00000000";  -- 67BF = 0
      when "110011111000000" =>  data <= "00000000";  -- 67C0 = 0
      when "110011111000001" =>  data <= "00000000";  -- 67C1 = 0
      when "110011111000010" =>  data <= "00000000";  -- 67C2 = 0
      when "110011111000011" =>  data <= "00111101";  -- 67C3 = 3D
      when "110011111000100" =>  data <= "00101000";  -- 67C4 = 28
      when "110011111000101" =>  data <= "00110001";  -- 67C5 = 31
      when "110011111000110" =>  data <= "00000011";  -- 67C6 = 3
      when "110011111000111" =>  data <= "00101010";  -- 67C7 = 2A
      when "110011111001000" =>  data <= "00000000";  -- 67C8 = 0
      when "110011111001001" =>  data <= "00011001";  -- 67C9 = 19
      when "110011111001010" =>  data <= "00100010";  -- 67CA = 22
      when "110011111001011" =>  data <= "00000000";  -- 67CB = 0
      when "110011111001100" =>  data <= "00000111";  -- 67CC = 7
      when "110011111001101" =>  data <= "00000000";  -- 67CD = 0
      when "110011111001110" =>  data <= "00000000";  -- 67CE = 0
      when "110011111001111" =>  data <= "00010000";  -- 67CF = 10
      when "110011111010000" =>  data <= "00000000";  -- 67D0 = 0
      when "110011111010001" =>  data <= "00000000";  -- 67D1 = 0
      when "110011111010010" =>  data <= "00000000";  -- 67D2 = 0
      when "110011111010011" =>  data <= "00000000";  -- 67D3 = 0
      when "110011111010100" =>  data <= "00000000";  -- 67D4 = 0
      when "110011111010101" =>  data <= "00001110";  -- 67D5 = E
      when "110011111010110" =>  data <= "00011110";  -- 67D6 = 1E
      when "110011111010111" =>  data <= "00111110";  -- 67D7 = 3E
      when "110011111011000" =>  data <= "01111110";  -- 67D8 = 7E
      when "110011111011001" =>  data <= "00111110";  -- 67D9 = 3E
      when "110011111011010" =>  data <= "00011110";  -- 67DA = 1E
      when "110011111011011" =>  data <= "00001110";  -- 67DB = E
      when "110011111011100" =>  data <= "10000000";  -- 67DC = 80
      when "110011111011101" =>  data <= "01000000";  -- 67DD = 40
      when "110011111011110" =>  data <= "00100000";  -- 67DE = 20
      when "110011111011111" =>  data <= "00010000";  -- 67DF = 10
      when "110011111100000" =>  data <= "00001000";  -- 67E0 = 8
      when "110011111100001" =>  data <= "00000100";  -- 67E1 = 4
      when "110011111100010" =>  data <= "00000010";  -- 67E2 = 2
      when "110011111100011" =>  data <= "00000001";  -- 67E3 = 1
      when "110011111100100" =>  data <= "00101001";  -- 67E4 = 29
      when "110011111100101" =>  data <= "10101010";  -- 67E5 = AA
      when "110011111100110" =>  data <= "10101010";  -- 67E6 = AA
      when "110011111100111" =>  data <= "10101010";  -- 67E7 = AA
      when "110011111101000" =>  data <= "10101010";  -- 67E8 = AA
      when "110011111101001" =>  data <= "10101010";  -- 67E9 = AA
      when "110011111101010" =>  data <= "10101010";  -- 67EA = AA
      when "110011111101011" =>  data <= "10101010";  -- 67EB = AA
      when "110011111101100" =>  data <= "10101010";  -- 67EC = AA
      when "110011111101101" =>  data <= "10101010";  -- 67ED = AA
      when "110011111101110" =>  data <= "10101010";  -- 67EE = AA
      when "110011111101111" =>  data <= "10101010";  -- 67EF = AA
      when "110011111110000" =>  data <= "10101010";  -- 67F0 = AA
      when "110011111110001" =>  data <= "10101010";  -- 67F1 = AA
      when "110011111110010" =>  data <= "10101010";  -- 67F2 = AA
      when "110011111110011" =>  data <= "10101010";  -- 67F3 = AA
      when "110011111110100" =>  data <= "10101010";  -- 67F4 = AA
      when "110011111110101" =>  data <= "10101010";  -- 67F5 = AA
      when "110011111110110" =>  data <= "10101010";  -- 67F6 = AA
      when "110011111110111" =>  data <= "10101010";  -- 67F7 = AA
      when "110011111111000" =>  data <= "10101010";  -- 67F8 = AA
      when "110011111111001" =>  data <= "10101010";  -- 67F9 = AA
      when "110011111111010" =>  data <= "10101010";  -- 67FA = AA
      when "110011111111011" =>  data <= "10101010";  -- 67FB = AA
      when "110011111111100" =>  data <= "10101010";  -- 67FC = AA
      when "110011111111101" =>  data <= "10101010";  -- 67FD = AA
      when "110011111111110" =>  data <= "10101010";  -- 67FE = AA
      when "110011111111111" =>  data <= "10101010";  -- 67FF = AA
      when "110100000000000" =>  data <= "11111111";  -- 6800 = FF
      when "110100000000001" =>  data <= "11111111";  -- 6801 = FF
      when "110100000000010" =>  data <= "11111111";  -- 6802 = FF
      when "110100000000011" =>  data <= "11111111";  -- 6803 = FF
      when "110100000000100" =>  data <= "11111111";  -- 6804 = FF
      when "110100000000101" =>  data <= "11111111";  -- 6805 = FF
      when "110100000000110" =>  data <= "11111111";  -- 6806 = FF
      when "110100000000111" =>  data <= "11111111";  -- 6807 = FF
      when "110100000001000" =>  data <= "11111111";  -- 6808 = FF
      when "110100000001001" =>  data <= "11111111";  -- 6809 = FF
      when "110100000001010" =>  data <= "11111111";  -- 680A = FF
      when "110100000001011" =>  data <= "11111111";  -- 680B = FF
      when "110100000001100" =>  data <= "11111111";  -- 680C = FF
      when "110100000001101" =>  data <= "11111111";  -- 680D = FF
      when "110100000001110" =>  data <= "11111111";  -- 680E = FF
      when "110100000001111" =>  data <= "11111111";  -- 680F = FF
      when "110100000010000" =>  data <= "11111111";  -- 6810 = FF
      when "110100000010001" =>  data <= "11111111";  -- 6811 = FF
      when "110100000010010" =>  data <= "11111111";  -- 6812 = FF
      when "110100000010011" =>  data <= "11111111";  -- 6813 = FF
      when "110100000010100" =>  data <= "11111111";  -- 6814 = FF
      when "110100000010101" =>  data <= "11111111";  -- 6815 = FF
      when "110100000010110" =>  data <= "11111111";  -- 6816 = FF
      when "110100000010111" =>  data <= "11111111";  -- 6817 = FF
      when "110100000011000" =>  data <= "11111111";  -- 6818 = FF
      when "110100000011001" =>  data <= "11111111";  -- 6819 = FF
      when "110100000011010" =>  data <= "11111111";  -- 681A = FF
      when "110100000011011" =>  data <= "11111111";  -- 681B = FF
      when "110100000011100" =>  data <= "11111111";  -- 681C = FF
      when "110100000011101" =>  data <= "11111111";  -- 681D = FF
      when "110100000011110" =>  data <= "11111111";  -- 681E = FF
      when "110100000011111" =>  data <= "11111111";  -- 681F = FF
      when "110100000100000" =>  data <= "11111111";  -- 6820 = FF
      when "110100000100001" =>  data <= "11111111";  -- 6821 = FF
      when "110100000100010" =>  data <= "11111111";  -- 6822 = FF
      when "110100000100011" =>  data <= "11111111";  -- 6823 = FF
      when "110100000100100" =>  data <= "11111111";  -- 6824 = FF
      when "110100000100101" =>  data <= "11111111";  -- 6825 = FF
      when "110100000100110" =>  data <= "11111111";  -- 6826 = FF
      when "110100000100111" =>  data <= "11111111";  -- 6827 = FF
      when "110100000101000" =>  data <= "11111111";  -- 6828 = FF
      when "110100000101001" =>  data <= "11111111";  -- 6829 = FF
      when "110100000101010" =>  data <= "11111111";  -- 682A = FF
      when "110100000101011" =>  data <= "11111111";  -- 682B = FF
      when "110100000101100" =>  data <= "11111111";  -- 682C = FF
      when "110100000101101" =>  data <= "11111111";  -- 682D = FF
      when "110100000101110" =>  data <= "11111111";  -- 682E = FF
      when "110100000101111" =>  data <= "11111111";  -- 682F = FF
      when "110100000110000" =>  data <= "11111111";  -- 6830 = FF
      when "110100000110001" =>  data <= "11111111";  -- 6831 = FF
      when "110100000110010" =>  data <= "11111111";  -- 6832 = FF
      when "110100000110011" =>  data <= "11111111";  -- 6833 = FF
      when "110100000110100" =>  data <= "11111111";  -- 6834 = FF
      when "110100000110101" =>  data <= "11111111";  -- 6835 = FF
      when "110100000110110" =>  data <= "11111111";  -- 6836 = FF
      when "110100000110111" =>  data <= "11111111";  -- 6837 = FF
      when "110100000111000" =>  data <= "11111111";  -- 6838 = FF
      when "110100000111001" =>  data <= "11111111";  -- 6839 = FF
      when "110100000111010" =>  data <= "11111111";  -- 683A = FF
      when "110100000111011" =>  data <= "11111111";  -- 683B = FF
      when "110100000111100" =>  data <= "11111111";  -- 683C = FF
      when "110100000111101" =>  data <= "11111111";  -- 683D = FF
      when "110100000111110" =>  data <= "11111111";  -- 683E = FF
      when "110100000111111" =>  data <= "11111111";  -- 683F = FF
      when "110100001000000" =>  data <= "11111111";  -- 6840 = FF
      when "110100001000001" =>  data <= "11111111";  -- 6841 = FF
      when "110100001000010" =>  data <= "11111111";  -- 6842 = FF
      when "110100001000011" =>  data <= "11111111";  -- 6843 = FF
      when "110100001000100" =>  data <= "11111111";  -- 6844 = FF
      when "110100001000101" =>  data <= "11111111";  -- 6845 = FF
      when "110100001000110" =>  data <= "11111111";  -- 6846 = FF
      when "110100001000111" =>  data <= "11111111";  -- 6847 = FF
      when "110100001001000" =>  data <= "11111111";  -- 6848 = FF
      when "110100001001001" =>  data <= "11111111";  -- 6849 = FF
      when "110100001001010" =>  data <= "11111111";  -- 684A = FF
      when "110100001001011" =>  data <= "11111111";  -- 684B = FF
      when "110100001001100" =>  data <= "11111111";  -- 684C = FF
      when "110100001001101" =>  data <= "11111111";  -- 684D = FF
      when "110100001001110" =>  data <= "11111111";  -- 684E = FF
      when "110100001001111" =>  data <= "11111111";  -- 684F = FF
      when "110100001010000" =>  data <= "11111111";  -- 6850 = FF
      when "110100001010001" =>  data <= "11111111";  -- 6851 = FF
      when "110100001010010" =>  data <= "11111111";  -- 6852 = FF
      when "110100001010011" =>  data <= "11111111";  -- 6853 = FF
      when "110100001010100" =>  data <= "11111111";  -- 6854 = FF
      when "110100001010101" =>  data <= "11111111";  -- 6855 = FF
      when "110100001010110" =>  data <= "11111111";  -- 6856 = FF
      when "110100001010111" =>  data <= "11111111";  -- 6857 = FF
      when "110100001011000" =>  data <= "11111111";  -- 6858 = FF
      when "110100001011001" =>  data <= "11111111";  -- 6859 = FF
      when "110100001011010" =>  data <= "11111111";  -- 685A = FF
      when "110100001011011" =>  data <= "11111111";  -- 685B = FF
      when "110100001011100" =>  data <= "11111111";  -- 685C = FF
      when "110100001011101" =>  data <= "11111111";  -- 685D = FF
      when "110100001011110" =>  data <= "11111111";  -- 685E = FF
      when "110100001011111" =>  data <= "11111111";  -- 685F = FF
      when "110100001100000" =>  data <= "11111111";  -- 6860 = FF
      when "110100001100001" =>  data <= "11111111";  -- 6861 = FF
      when "110100001100010" =>  data <= "11111111";  -- 6862 = FF
      when "110100001100011" =>  data <= "11111111";  -- 6863 = FF
      when "110100001100100" =>  data <= "11111111";  -- 6864 = FF
      when "110100001100101" =>  data <= "11111111";  -- 6865 = FF
      when "110100001100110" =>  data <= "11111111";  -- 6866 = FF
      when "110100001100111" =>  data <= "11111111";  -- 6867 = FF
      when "110100001101000" =>  data <= "11111111";  -- 6868 = FF
      when "110100001101001" =>  data <= "11111111";  -- 6869 = FF
      when "110100001101010" =>  data <= "11111111";  -- 686A = FF
      when "110100001101011" =>  data <= "11111111";  -- 686B = FF
      when "110100001101100" =>  data <= "11111111";  -- 686C = FF
      when "110100001101101" =>  data <= "11111111";  -- 686D = FF
      when "110100001101110" =>  data <= "11111111";  -- 686E = FF
      when "110100001101111" =>  data <= "11111111";  -- 686F = FF
      when "110100001110000" =>  data <= "11111111";  -- 6870 = FF
      when "110100001110001" =>  data <= "11111111";  -- 6871 = FF
      when "110100001110010" =>  data <= "11111111";  -- 6872 = FF
      when "110100001110011" =>  data <= "11111111";  -- 6873 = FF
      when "110100001110100" =>  data <= "11111111";  -- 6874 = FF
      when "110100001110101" =>  data <= "11111111";  -- 6875 = FF
      when "110100001110110" =>  data <= "11111111";  -- 6876 = FF
      when "110100001110111" =>  data <= "11111111";  -- 6877 = FF
      when "110100001111000" =>  data <= "11111111";  -- 6878 = FF
      when "110100001111001" =>  data <= "11111111";  -- 6879 = FF
      when "110100001111010" =>  data <= "11111111";  -- 687A = FF
      when "110100001111011" =>  data <= "11111111";  -- 687B = FF
      when "110100001111100" =>  data <= "11111111";  -- 687C = FF
      when "110100001111101" =>  data <= "11111111";  -- 687D = FF
      when "110100001111110" =>  data <= "11111111";  -- 687E = FF
      when "110100001111111" =>  data <= "11111111";  -- 687F = FF
      when "110100010000000" =>  data <= "11111111";  -- 6880 = FF
      when "110100010000001" =>  data <= "11111111";  -- 6881 = FF
      when "110100010000010" =>  data <= "11111111";  -- 6882 = FF
      when "110100010000011" =>  data <= "11111111";  -- 6883 = FF
      when "110100010000100" =>  data <= "11111111";  -- 6884 = FF
      when "110100010000101" =>  data <= "11111111";  -- 6885 = FF
      when "110100010000110" =>  data <= "11111111";  -- 6886 = FF
      when "110100010000111" =>  data <= "11111111";  -- 6887 = FF
      when "110100010001000" =>  data <= "11111111";  -- 6888 = FF
      when "110100010001001" =>  data <= "11111111";  -- 6889 = FF
      when "110100010001010" =>  data <= "11111111";  -- 688A = FF
      when "110100010001011" =>  data <= "11111111";  -- 688B = FF
      when "110100010001100" =>  data <= "11111111";  -- 688C = FF
      when "110100010001101" =>  data <= "11111111";  -- 688D = FF
      when "110100010001110" =>  data <= "11111111";  -- 688E = FF
      when "110100010001111" =>  data <= "11111111";  -- 688F = FF
      when "110100010010000" =>  data <= "11111111";  -- 6890 = FF
      when "110100010010001" =>  data <= "11111111";  -- 6891 = FF
      when "110100010010010" =>  data <= "11111111";  -- 6892 = FF
      when "110100010010011" =>  data <= "11111111";  -- 6893 = FF
      when "110100010010100" =>  data <= "11111111";  -- 6894 = FF
      when "110100010010101" =>  data <= "11111111";  -- 6895 = FF
      when "110100010010110" =>  data <= "11111111";  -- 6896 = FF
      when "110100010010111" =>  data <= "11111111";  -- 6897 = FF
      when "110100010011000" =>  data <= "11111111";  -- 6898 = FF
      when "110100010011001" =>  data <= "11111111";  -- 6899 = FF
      when "110100010011010" =>  data <= "11111111";  -- 689A = FF
      when "110100010011011" =>  data <= "11111111";  -- 689B = FF
      when "110100010011100" =>  data <= "11111111";  -- 689C = FF
      when "110100010011101" =>  data <= "11111111";  -- 689D = FF
      when "110100010011110" =>  data <= "11111111";  -- 689E = FF
      when "110100010011111" =>  data <= "11111111";  -- 689F = FF
      when "110100010100000" =>  data <= "11111111";  -- 68A0 = FF
      when "110100010100001" =>  data <= "11111111";  -- 68A1 = FF
      when "110100010100010" =>  data <= "11111111";  -- 68A2 = FF
      when "110100010100011" =>  data <= "11111111";  -- 68A3 = FF
      when "110100010100100" =>  data <= "11111111";  -- 68A4 = FF
      when "110100010100101" =>  data <= "11111111";  -- 68A5 = FF
      when "110100010100110" =>  data <= "11111111";  -- 68A6 = FF
      when "110100010100111" =>  data <= "11111111";  -- 68A7 = FF
      when "110100010101000" =>  data <= "11111111";  -- 68A8 = FF
      when "110100010101001" =>  data <= "11111111";  -- 68A9 = FF
      when "110100010101010" =>  data <= "11111111";  -- 68AA = FF
      when "110100010101011" =>  data <= "11111111";  -- 68AB = FF
      when "110100010101100" =>  data <= "11111111";  -- 68AC = FF
      when "110100010101101" =>  data <= "11111111";  -- 68AD = FF
      when "110100010101110" =>  data <= "11111111";  -- 68AE = FF
      when "110100010101111" =>  data <= "11111111";  -- 68AF = FF
      when "110100010110000" =>  data <= "11111111";  -- 68B0 = FF
      when "110100010110001" =>  data <= "11111111";  -- 68B1 = FF
      when "110100010110010" =>  data <= "11111111";  -- 68B2 = FF
      when "110100010110011" =>  data <= "11111111";  -- 68B3 = FF
      when "110100010110100" =>  data <= "11111111";  -- 68B4 = FF
      when "110100010110101" =>  data <= "11111111";  -- 68B5 = FF
      when "110100010110110" =>  data <= "11111111";  -- 68B6 = FF
      when "110100010110111" =>  data <= "11111111";  -- 68B7 = FF
      when "110100010111000" =>  data <= "11111111";  -- 68B8 = FF
      when "110100010111001" =>  data <= "11111111";  -- 68B9 = FF
      when "110100010111010" =>  data <= "11111111";  -- 68BA = FF
      when "110100010111011" =>  data <= "11111111";  -- 68BB = FF
      when "110100010111100" =>  data <= "11111111";  -- 68BC = FF
      when "110100010111101" =>  data <= "11111111";  -- 68BD = FF
      when "110100010111110" =>  data <= "11111111";  -- 68BE = FF
      when "110100010111111" =>  data <= "11111111";  -- 68BF = FF
      when "110100011000000" =>  data <= "11111111";  -- 68C0 = FF
      when "110100011000001" =>  data <= "11111111";  -- 68C1 = FF
      when "110100011000010" =>  data <= "11111111";  -- 68C2 = FF
      when "110100011000011" =>  data <= "11111111";  -- 68C3 = FF
      when "110100011000100" =>  data <= "11111111";  -- 68C4 = FF
      when "110100011000101" =>  data <= "11111111";  -- 68C5 = FF
      when "110100011000110" =>  data <= "11111111";  -- 68C6 = FF
      when "110100011000111" =>  data <= "11111111";  -- 68C7 = FF
      when "110100011001000" =>  data <= "11111111";  -- 68C8 = FF
      when "110100011001001" =>  data <= "11111111";  -- 68C9 = FF
      when "110100011001010" =>  data <= "11111111";  -- 68CA = FF
      when "110100011001011" =>  data <= "11111111";  -- 68CB = FF
      when "110100011001100" =>  data <= "11111111";  -- 68CC = FF
      when "110100011001101" =>  data <= "11111111";  -- 68CD = FF
      when "110100011001110" =>  data <= "11111111";  -- 68CE = FF
      when "110100011001111" =>  data <= "11111111";  -- 68CF = FF
      when "110100011010000" =>  data <= "11111111";  -- 68D0 = FF
      when "110100011010001" =>  data <= "11111111";  -- 68D1 = FF
      when "110100011010010" =>  data <= "11111111";  -- 68D2 = FF
      when "110100011010011" =>  data <= "11111111";  -- 68D3 = FF
      when "110100011010100" =>  data <= "11111111";  -- 68D4 = FF
      when "110100011010101" =>  data <= "11111111";  -- 68D5 = FF
      when "110100011010110" =>  data <= "11111111";  -- 68D6 = FF
      when "110100011010111" =>  data <= "11111111";  -- 68D7 = FF
      when "110100011011000" =>  data <= "11111111";  -- 68D8 = FF
      when "110100011011001" =>  data <= "11111111";  -- 68D9 = FF
      when "110100011011010" =>  data <= "11111111";  -- 68DA = FF
      when "110100011011011" =>  data <= "11111111";  -- 68DB = FF
      when "110100011011100" =>  data <= "11111111";  -- 68DC = FF
      when "110100011011101" =>  data <= "11111111";  -- 68DD = FF
      when "110100011011110" =>  data <= "11111111";  -- 68DE = FF
      when "110100011011111" =>  data <= "11111111";  -- 68DF = FF
      when "110100011100000" =>  data <= "11111111";  -- 68E0 = FF
      when "110100011100001" =>  data <= "11111111";  -- 68E1 = FF
      when "110100011100010" =>  data <= "11111111";  -- 68E2 = FF
      when "110100011100011" =>  data <= "11111111";  -- 68E3 = FF
      when "110100011100100" =>  data <= "11111111";  -- 68E4 = FF
      when "110100011100101" =>  data <= "11111111";  -- 68E5 = FF
      when "110100011100110" =>  data <= "11111111";  -- 68E6 = FF
      when "110100011100111" =>  data <= "11111111";  -- 68E7 = FF
      when "110100011101000" =>  data <= "11111111";  -- 68E8 = FF
      when "110100011101001" =>  data <= "11111111";  -- 68E9 = FF
      when "110100011101010" =>  data <= "11111111";  -- 68EA = FF
      when "110100011101011" =>  data <= "11111111";  -- 68EB = FF
      when "110100011101100" =>  data <= "11111111";  -- 68EC = FF
      when "110100011101101" =>  data <= "11111111";  -- 68ED = FF
      when "110100011101110" =>  data <= "11111111";  -- 68EE = FF
      when "110100011101111" =>  data <= "11111111";  -- 68EF = FF
      when "110100011110000" =>  data <= "11111111";  -- 68F0 = FF
      when "110100011110001" =>  data <= "11111111";  -- 68F1 = FF
      when "110100011110010" =>  data <= "11111111";  -- 68F2 = FF
      when "110100011110011" =>  data <= "11111111";  -- 68F3 = FF
      when "110100011110100" =>  data <= "11111111";  -- 68F4 = FF
      when "110100011110101" =>  data <= "11111111";  -- 68F5 = FF
      when "110100011110110" =>  data <= "11111111";  -- 68F6 = FF
      when "110100011110111" =>  data <= "11111111";  -- 68F7 = FF
      when "110100011111000" =>  data <= "11111111";  -- 68F8 = FF
      when "110100011111001" =>  data <= "11111111";  -- 68F9 = FF
      when "110100011111010" =>  data <= "11111111";  -- 68FA = FF
      when "110100011111011" =>  data <= "11111111";  -- 68FB = FF
      when "110100011111100" =>  data <= "11111111";  -- 68FC = FF
      when "110100011111101" =>  data <= "11111111";  -- 68FD = FF
      when "110100011111110" =>  data <= "11111111";  -- 68FE = FF
      when "110100011111111" =>  data <= "11111111";  -- 68FF = FF
      when "110100100000000" =>  data <= "11111111";  -- 6900 = FF
      when "110100100000001" =>  data <= "11111111";  -- 6901 = FF
      when "110100100000010" =>  data <= "11111111";  -- 6902 = FF
      when "110100100000011" =>  data <= "11111111";  -- 6903 = FF
      when "110100100000100" =>  data <= "11111111";  -- 6904 = FF
      when "110100100000101" =>  data <= "11111111";  -- 6905 = FF
      when "110100100000110" =>  data <= "11111111";  -- 6906 = FF
      when "110100100000111" =>  data <= "11111111";  -- 6907 = FF
      when "110100100001000" =>  data <= "11111111";  -- 6908 = FF
      when "110100100001001" =>  data <= "11111111";  -- 6909 = FF
      when "110100100001010" =>  data <= "11111111";  -- 690A = FF
      when "110100100001011" =>  data <= "11111111";  -- 690B = FF
      when "110100100001100" =>  data <= "11111111";  -- 690C = FF
      when "110100100001101" =>  data <= "11111111";  -- 690D = FF
      when "110100100001110" =>  data <= "11111111";  -- 690E = FF
      when "110100100001111" =>  data <= "11111111";  -- 690F = FF
      when "110100100010000" =>  data <= "11111111";  -- 6910 = FF
      when "110100100010001" =>  data <= "11111111";  -- 6911 = FF
      when "110100100010010" =>  data <= "11111111";  -- 6912 = FF
      when "110100100010011" =>  data <= "11111111";  -- 6913 = FF
      when "110100100010100" =>  data <= "11111111";  -- 6914 = FF
      when "110100100010101" =>  data <= "11111111";  -- 6915 = FF
      when "110100100010110" =>  data <= "11111111";  -- 6916 = FF
      when "110100100010111" =>  data <= "11111111";  -- 6917 = FF
      when "110100100011000" =>  data <= "11111111";  -- 6918 = FF
      when "110100100011001" =>  data <= "11111111";  -- 6919 = FF
      when "110100100011010" =>  data <= "11111111";  -- 691A = FF
      when "110100100011011" =>  data <= "11111111";  -- 691B = FF
      when "110100100011100" =>  data <= "11111111";  -- 691C = FF
      when "110100100011101" =>  data <= "11111111";  -- 691D = FF
      when "110100100011110" =>  data <= "11111111";  -- 691E = FF
      when "110100100011111" =>  data <= "11111111";  -- 691F = FF
      when "110100100100000" =>  data <= "11111111";  -- 6920 = FF
      when "110100100100001" =>  data <= "11111111";  -- 6921 = FF
      when "110100100100010" =>  data <= "11111111";  -- 6922 = FF
      when "110100100100011" =>  data <= "11111111";  -- 6923 = FF
      when "110100100100100" =>  data <= "11111111";  -- 6924 = FF
      when "110100100100101" =>  data <= "11111111";  -- 6925 = FF
      when "110100100100110" =>  data <= "11111111";  -- 6926 = FF
      when "110100100100111" =>  data <= "11111111";  -- 6927 = FF
      when "110100100101000" =>  data <= "11111111";  -- 6928 = FF
      when "110100100101001" =>  data <= "11111111";  -- 6929 = FF
      when "110100100101010" =>  data <= "11111111";  -- 692A = FF
      when "110100100101011" =>  data <= "11111111";  -- 692B = FF
      when "110100100101100" =>  data <= "11111111";  -- 692C = FF
      when "110100100101101" =>  data <= "11111111";  -- 692D = FF
      when "110100100101110" =>  data <= "11111111";  -- 692E = FF
      when "110100100101111" =>  data <= "11111111";  -- 692F = FF
      when "110100100110000" =>  data <= "11111111";  -- 6930 = FF
      when "110100100110001" =>  data <= "11111111";  -- 6931 = FF
      when "110100100110010" =>  data <= "11111111";  -- 6932 = FF
      when "110100100110011" =>  data <= "11111111";  -- 6933 = FF
      when "110100100110100" =>  data <= "11111111";  -- 6934 = FF
      when "110100100110101" =>  data <= "11111111";  -- 6935 = FF
      when "110100100110110" =>  data <= "11111111";  -- 6936 = FF
      when "110100100110111" =>  data <= "11111111";  -- 6937 = FF
      when "110100100111000" =>  data <= "11111111";  -- 6938 = FF
      when "110100100111001" =>  data <= "11111111";  -- 6939 = FF
      when "110100100111010" =>  data <= "11111111";  -- 693A = FF
      when "110100100111011" =>  data <= "11111111";  -- 693B = FF
      when "110100100111100" =>  data <= "11111111";  -- 693C = FF
      when "110100100111101" =>  data <= "11111111";  -- 693D = FF
      when "110100100111110" =>  data <= "11111111";  -- 693E = FF
      when "110100100111111" =>  data <= "11111111";  -- 693F = FF
      when "110100101000000" =>  data <= "11111111";  -- 6940 = FF
      when "110100101000001" =>  data <= "11111111";  -- 6941 = FF
      when "110100101000010" =>  data <= "11111111";  -- 6942 = FF
      when "110100101000011" =>  data <= "11111111";  -- 6943 = FF
      when "110100101000100" =>  data <= "11111111";  -- 6944 = FF
      when "110100101000101" =>  data <= "11111111";  -- 6945 = FF
      when "110100101000110" =>  data <= "11111111";  -- 6946 = FF
      when "110100101000111" =>  data <= "11111111";  -- 6947 = FF
      when "110100101001000" =>  data <= "11111111";  -- 6948 = FF
      when "110100101001001" =>  data <= "11111111";  -- 6949 = FF
      when "110100101001010" =>  data <= "11111111";  -- 694A = FF
      when "110100101001011" =>  data <= "11111111";  -- 694B = FF
      when "110100101001100" =>  data <= "11111111";  -- 694C = FF
      when "110100101001101" =>  data <= "11111111";  -- 694D = FF
      when "110100101001110" =>  data <= "11111111";  -- 694E = FF
      when "110100101001111" =>  data <= "11111111";  -- 694F = FF
      when "110100101010000" =>  data <= "11111111";  -- 6950 = FF
      when "110100101010001" =>  data <= "11111111";  -- 6951 = FF
      when "110100101010010" =>  data <= "11111111";  -- 6952 = FF
      when "110100101010011" =>  data <= "11111111";  -- 6953 = FF
      when "110100101010100" =>  data <= "11111111";  -- 6954 = FF
      when "110100101010101" =>  data <= "11111111";  -- 6955 = FF
      when "110100101010110" =>  data <= "11111111";  -- 6956 = FF
      when "110100101010111" =>  data <= "11111111";  -- 6957 = FF
      when "110100101011000" =>  data <= "11111111";  -- 6958 = FF
      when "110100101011001" =>  data <= "11111111";  -- 6959 = FF
      when "110100101011010" =>  data <= "11111111";  -- 695A = FF
      when "110100101011011" =>  data <= "11111111";  -- 695B = FF
      when "110100101011100" =>  data <= "11111111";  -- 695C = FF
      when "110100101011101" =>  data <= "11111111";  -- 695D = FF
      when "110100101011110" =>  data <= "11111111";  -- 695E = FF
      when "110100101011111" =>  data <= "11111111";  -- 695F = FF
      when "110100101100000" =>  data <= "11111111";  -- 6960 = FF
      when "110100101100001" =>  data <= "11111111";  -- 6961 = FF
      when "110100101100010" =>  data <= "11111111";  -- 6962 = FF
      when "110100101100011" =>  data <= "11111111";  -- 6963 = FF
      when "110100101100100" =>  data <= "11111111";  -- 6964 = FF
      when "110100101100101" =>  data <= "11111111";  -- 6965 = FF
      when "110100101100110" =>  data <= "11111111";  -- 6966 = FF
      when "110100101100111" =>  data <= "11111111";  -- 6967 = FF
      when "110100101101000" =>  data <= "11111111";  -- 6968 = FF
      when "110100101101001" =>  data <= "11111111";  -- 6969 = FF
      when "110100101101010" =>  data <= "11111111";  -- 696A = FF
      when "110100101101011" =>  data <= "11111111";  -- 696B = FF
      when "110100101101100" =>  data <= "11111111";  -- 696C = FF
      when "110100101101101" =>  data <= "11111111";  -- 696D = FF
      when "110100101101110" =>  data <= "11111111";  -- 696E = FF
      when "110100101101111" =>  data <= "11111111";  -- 696F = FF
      when "110100101110000" =>  data <= "11111111";  -- 6970 = FF
      when "110100101110001" =>  data <= "11111111";  -- 6971 = FF
      when "110100101110010" =>  data <= "11111111";  -- 6972 = FF
      when "110100101110011" =>  data <= "11111111";  -- 6973 = FF
      when "110100101110100" =>  data <= "11111111";  -- 6974 = FF
      when "110100101110101" =>  data <= "11111111";  -- 6975 = FF
      when "110100101110110" =>  data <= "11111111";  -- 6976 = FF
      when "110100101110111" =>  data <= "11111111";  -- 6977 = FF
      when "110100101111000" =>  data <= "11111111";  -- 6978 = FF
      when "110100101111001" =>  data <= "11111111";  -- 6979 = FF
      when "110100101111010" =>  data <= "11111111";  -- 697A = FF
      when "110100101111011" =>  data <= "11111111";  -- 697B = FF
      when "110100101111100" =>  data <= "11111111";  -- 697C = FF
      when "110100101111101" =>  data <= "11111111";  -- 697D = FF
      when "110100101111110" =>  data <= "11111111";  -- 697E = FF
      when "110100101111111" =>  data <= "11111111";  -- 697F = FF
      when "110100110000000" =>  data <= "11111111";  -- 6980 = FF
      when "110100110000001" =>  data <= "11111111";  -- 6981 = FF
      when "110100110000010" =>  data <= "11111111";  -- 6982 = FF
      when "110100110000011" =>  data <= "11111111";  -- 6983 = FF
      when "110100110000100" =>  data <= "11111111";  -- 6984 = FF
      when "110100110000101" =>  data <= "11111111";  -- 6985 = FF
      when "110100110000110" =>  data <= "11111111";  -- 6986 = FF
      when "110100110000111" =>  data <= "11111111";  -- 6987 = FF
      when "110100110001000" =>  data <= "11111111";  -- 6988 = FF
      when "110100110001001" =>  data <= "11111111";  -- 6989 = FF
      when "110100110001010" =>  data <= "11111111";  -- 698A = FF
      when "110100110001011" =>  data <= "11111111";  -- 698B = FF
      when "110100110001100" =>  data <= "11111111";  -- 698C = FF
      when "110100110001101" =>  data <= "11111111";  -- 698D = FF
      when "110100110001110" =>  data <= "11111111";  -- 698E = FF
      when "110100110001111" =>  data <= "11111111";  -- 698F = FF
      when "110100110010000" =>  data <= "11111111";  -- 6990 = FF
      when "110100110010001" =>  data <= "11111111";  -- 6991 = FF
      when "110100110010010" =>  data <= "11111111";  -- 6992 = FF
      when "110100110010011" =>  data <= "11111111";  -- 6993 = FF
      when "110100110010100" =>  data <= "11111111";  -- 6994 = FF
      when "110100110010101" =>  data <= "11111111";  -- 6995 = FF
      when "110100110010110" =>  data <= "11111111";  -- 6996 = FF
      when "110100110010111" =>  data <= "11111111";  -- 6997 = FF
      when "110100110011000" =>  data <= "11111111";  -- 6998 = FF
      when "110100110011001" =>  data <= "11111111";  -- 6999 = FF
      when "110100110011010" =>  data <= "11111111";  -- 699A = FF
      when "110100110011011" =>  data <= "11111111";  -- 699B = FF
      when "110100110011100" =>  data <= "11111111";  -- 699C = FF
      when "110100110011101" =>  data <= "11111111";  -- 699D = FF
      when "110100110011110" =>  data <= "11111111";  -- 699E = FF
      when "110100110011111" =>  data <= "11111111";  -- 699F = FF
      when "110100110100000" =>  data <= "11111111";  -- 69A0 = FF
      when "110100110100001" =>  data <= "11111111";  -- 69A1 = FF
      when "110100110100010" =>  data <= "11111111";  -- 69A2 = FF
      when "110100110100011" =>  data <= "11111111";  -- 69A3 = FF
      when "110100110100100" =>  data <= "11111111";  -- 69A4 = FF
      when "110100110100101" =>  data <= "11111111";  -- 69A5 = FF
      when "110100110100110" =>  data <= "11111111";  -- 69A6 = FF
      when "110100110100111" =>  data <= "11111111";  -- 69A7 = FF
      when "110100110101000" =>  data <= "11111111";  -- 69A8 = FF
      when "110100110101001" =>  data <= "11111111";  -- 69A9 = FF
      when "110100110101010" =>  data <= "11111111";  -- 69AA = FF
      when "110100110101011" =>  data <= "11111111";  -- 69AB = FF
      when "110100110101100" =>  data <= "11111111";  -- 69AC = FF
      when "110100110101101" =>  data <= "11111111";  -- 69AD = FF
      when "110100110101110" =>  data <= "11111111";  -- 69AE = FF
      when "110100110101111" =>  data <= "11111111";  -- 69AF = FF
      when "110100110110000" =>  data <= "11111111";  -- 69B0 = FF
      when "110100110110001" =>  data <= "11111111";  -- 69B1 = FF
      when "110100110110010" =>  data <= "11111111";  -- 69B2 = FF
      when "110100110110011" =>  data <= "11111111";  -- 69B3 = FF
      when "110100110110100" =>  data <= "11111111";  -- 69B4 = FF
      when "110100110110101" =>  data <= "11111111";  -- 69B5 = FF
      when "110100110110110" =>  data <= "11111111";  -- 69B6 = FF
      when "110100110110111" =>  data <= "11111111";  -- 69B7 = FF
      when "110100110111000" =>  data <= "11111111";  -- 69B8 = FF
      when "110100110111001" =>  data <= "11111111";  -- 69B9 = FF
      when "110100110111010" =>  data <= "11111111";  -- 69BA = FF
      when "110100110111011" =>  data <= "11111111";  -- 69BB = FF
      when "110100110111100" =>  data <= "11111111";  -- 69BC = FF
      when "110100110111101" =>  data <= "11111111";  -- 69BD = FF
      when "110100110111110" =>  data <= "11111111";  -- 69BE = FF
      when "110100110111111" =>  data <= "11111111";  -- 69BF = FF
      when "110100111000000" =>  data <= "11111111";  -- 69C0 = FF
      when "110100111000001" =>  data <= "11111111";  -- 69C1 = FF
      when "110100111000010" =>  data <= "11111111";  -- 69C2 = FF
      when "110100111000011" =>  data <= "11111111";  -- 69C3 = FF
      when "110100111000100" =>  data <= "11111111";  -- 69C4 = FF
      when "110100111000101" =>  data <= "11111111";  -- 69C5 = FF
      when "110100111000110" =>  data <= "11111111";  -- 69C6 = FF
      when "110100111000111" =>  data <= "11111111";  -- 69C7 = FF
      when "110100111001000" =>  data <= "11111111";  -- 69C8 = FF
      when "110100111001001" =>  data <= "11111111";  -- 69C9 = FF
      when "110100111001010" =>  data <= "11111111";  -- 69CA = FF
      when "110100111001011" =>  data <= "11111111";  -- 69CB = FF
      when "110100111001100" =>  data <= "11111111";  -- 69CC = FF
      when "110100111001101" =>  data <= "11111111";  -- 69CD = FF
      when "110100111001110" =>  data <= "11111111";  -- 69CE = FF
      when "110100111001111" =>  data <= "11111111";  -- 69CF = FF
      when "110100111010000" =>  data <= "11111111";  -- 69D0 = FF
      when "110100111010001" =>  data <= "11111111";  -- 69D1 = FF
      when "110100111010010" =>  data <= "11111111";  -- 69D2 = FF
      when "110100111010011" =>  data <= "11111111";  -- 69D3 = FF
      when "110100111010100" =>  data <= "11111111";  -- 69D4 = FF
      when "110100111010101" =>  data <= "11111111";  -- 69D5 = FF
      when "110100111010110" =>  data <= "11111111";  -- 69D6 = FF
      when "110100111010111" =>  data <= "11111111";  -- 69D7 = FF
      when "110100111011000" =>  data <= "11111111";  -- 69D8 = FF
      when "110100111011001" =>  data <= "11111111";  -- 69D9 = FF
      when "110100111011010" =>  data <= "11111111";  -- 69DA = FF
      when "110100111011011" =>  data <= "11111111";  -- 69DB = FF
      when "110100111011100" =>  data <= "11111111";  -- 69DC = FF
      when "110100111011101" =>  data <= "11111111";  -- 69DD = FF
      when "110100111011110" =>  data <= "11111111";  -- 69DE = FF
      when "110100111011111" =>  data <= "11111111";  -- 69DF = FF
      when "110100111100000" =>  data <= "11111111";  -- 69E0 = FF
      when "110100111100001" =>  data <= "11111111";  -- 69E1 = FF
      when "110100111100010" =>  data <= "11111111";  -- 69E2 = FF
      when "110100111100011" =>  data <= "11111111";  -- 69E3 = FF
      when "110100111100100" =>  data <= "11111111";  -- 69E4 = FF
      when "110100111100101" =>  data <= "11111111";  -- 69E5 = FF
      when "110100111100110" =>  data <= "11111111";  -- 69E6 = FF
      when "110100111100111" =>  data <= "11111111";  -- 69E7 = FF
      when "110100111101000" =>  data <= "11111111";  -- 69E8 = FF
      when "110100111101001" =>  data <= "11111111";  -- 69E9 = FF
      when "110100111101010" =>  data <= "11111111";  -- 69EA = FF
      when "110100111101011" =>  data <= "11111111";  -- 69EB = FF
      when "110100111101100" =>  data <= "11111111";  -- 69EC = FF
      when "110100111101101" =>  data <= "11111111";  -- 69ED = FF
      when "110100111101110" =>  data <= "11111111";  -- 69EE = FF
      when "110100111101111" =>  data <= "11111111";  -- 69EF = FF
      when "110100111110000" =>  data <= "11111111";  -- 69F0 = FF
      when "110100111110001" =>  data <= "11111111";  -- 69F1 = FF
      when "110100111110010" =>  data <= "11111111";  -- 69F2 = FF
      when "110100111110011" =>  data <= "11111111";  -- 69F3 = FF
      when "110100111110100" =>  data <= "11111111";  -- 69F4 = FF
      when "110100111110101" =>  data <= "11111111";  -- 69F5 = FF
      when "110100111110110" =>  data <= "11111111";  -- 69F6 = FF
      when "110100111110111" =>  data <= "11111111";  -- 69F7 = FF
      when "110100111111000" =>  data <= "11111111";  -- 69F8 = FF
      when "110100111111001" =>  data <= "11111111";  -- 69F9 = FF
      when "110100111111010" =>  data <= "11111111";  -- 69FA = FF
      when "110100111111011" =>  data <= "11111111";  -- 69FB = FF
      when "110100111111100" =>  data <= "11111111";  -- 69FC = FF
      when "110100111111101" =>  data <= "11111111";  -- 69FD = FF
      when "110100111111110" =>  data <= "11111111";  -- 69FE = FF
      when "110100111111111" =>  data <= "11111111";  -- 69FF = FF
      when "110101000000000" =>  data <= "11111111";  -- 6A00 = FF
      when "110101000000001" =>  data <= "11111111";  -- 6A01 = FF
      when "110101000000010" =>  data <= "11111111";  -- 6A02 = FF
      when "110101000000011" =>  data <= "11111111";  -- 6A03 = FF
      when "110101000000100" =>  data <= "11111111";  -- 6A04 = FF
      when "110101000000101" =>  data <= "11111111";  -- 6A05 = FF
      when "110101000000110" =>  data <= "11111111";  -- 6A06 = FF
      when "110101000000111" =>  data <= "11111111";  -- 6A07 = FF
      when "110101000001000" =>  data <= "11111111";  -- 6A08 = FF
      when "110101000001001" =>  data <= "11111111";  -- 6A09 = FF
      when "110101000001010" =>  data <= "11111111";  -- 6A0A = FF
      when "110101000001011" =>  data <= "11111111";  -- 6A0B = FF
      when "110101000001100" =>  data <= "11111111";  -- 6A0C = FF
      when "110101000001101" =>  data <= "11111111";  -- 6A0D = FF
      when "110101000001110" =>  data <= "11111111";  -- 6A0E = FF
      when "110101000001111" =>  data <= "11111111";  -- 6A0F = FF
      when "110101000010000" =>  data <= "11111111";  -- 6A10 = FF
      when "110101000010001" =>  data <= "11111111";  -- 6A11 = FF
      when "110101000010010" =>  data <= "11111111";  -- 6A12 = FF
      when "110101000010011" =>  data <= "11111111";  -- 6A13 = FF
      when "110101000010100" =>  data <= "11111111";  -- 6A14 = FF
      when "110101000010101" =>  data <= "11111111";  -- 6A15 = FF
      when "110101000010110" =>  data <= "11111111";  -- 6A16 = FF
      when "110101000010111" =>  data <= "11111111";  -- 6A17 = FF
      when "110101000011000" =>  data <= "11111111";  -- 6A18 = FF
      when "110101000011001" =>  data <= "11111111";  -- 6A19 = FF
      when "110101000011010" =>  data <= "11111111";  -- 6A1A = FF
      when "110101000011011" =>  data <= "11111111";  -- 6A1B = FF
      when "110101000011100" =>  data <= "11111111";  -- 6A1C = FF
      when "110101000011101" =>  data <= "11111111";  -- 6A1D = FF
      when "110101000011110" =>  data <= "11111111";  -- 6A1E = FF
      when "110101000011111" =>  data <= "11111111";  -- 6A1F = FF
      when "110101000100000" =>  data <= "11111111";  -- 6A20 = FF
      when "110101000100001" =>  data <= "11111111";  -- 6A21 = FF
      when "110101000100010" =>  data <= "11111111";  -- 6A22 = FF
      when "110101000100011" =>  data <= "11111111";  -- 6A23 = FF
      when "110101000100100" =>  data <= "11111111";  -- 6A24 = FF
      when "110101000100101" =>  data <= "11111111";  -- 6A25 = FF
      when "110101000100110" =>  data <= "11111111";  -- 6A26 = FF
      when "110101000100111" =>  data <= "11111111";  -- 6A27 = FF
      when "110101000101000" =>  data <= "11111111";  -- 6A28 = FF
      when "110101000101001" =>  data <= "11111111";  -- 6A29 = FF
      when "110101000101010" =>  data <= "11111111";  -- 6A2A = FF
      when "110101000101011" =>  data <= "11111111";  -- 6A2B = FF
      when "110101000101100" =>  data <= "11111111";  -- 6A2C = FF
      when "110101000101101" =>  data <= "11111111";  -- 6A2D = FF
      when "110101000101110" =>  data <= "11111111";  -- 6A2E = FF
      when "110101000101111" =>  data <= "11111111";  -- 6A2F = FF
      when "110101000110000" =>  data <= "11111111";  -- 6A30 = FF
      when "110101000110001" =>  data <= "11111111";  -- 6A31 = FF
      when "110101000110010" =>  data <= "11111111";  -- 6A32 = FF
      when "110101000110011" =>  data <= "11111111";  -- 6A33 = FF
      when "110101000110100" =>  data <= "11111111";  -- 6A34 = FF
      when "110101000110101" =>  data <= "11111111";  -- 6A35 = FF
      when "110101000110110" =>  data <= "11111111";  -- 6A36 = FF
      when "110101000110111" =>  data <= "11111111";  -- 6A37 = FF
      when "110101000111000" =>  data <= "11111111";  -- 6A38 = FF
      when "110101000111001" =>  data <= "11111111";  -- 6A39 = FF
      when "110101000111010" =>  data <= "11111111";  -- 6A3A = FF
      when "110101000111011" =>  data <= "11111111";  -- 6A3B = FF
      when "110101000111100" =>  data <= "11111111";  -- 6A3C = FF
      when "110101000111101" =>  data <= "11111111";  -- 6A3D = FF
      when "110101000111110" =>  data <= "11111111";  -- 6A3E = FF
      when "110101000111111" =>  data <= "11111111";  -- 6A3F = FF
      when "110101001000000" =>  data <= "11111111";  -- 6A40 = FF
      when "110101001000001" =>  data <= "11111111";  -- 6A41 = FF
      when "110101001000010" =>  data <= "11111111";  -- 6A42 = FF
      when "110101001000011" =>  data <= "11111111";  -- 6A43 = FF
      when "110101001000100" =>  data <= "11111111";  -- 6A44 = FF
      when "110101001000101" =>  data <= "11111111";  -- 6A45 = FF
      when "110101001000110" =>  data <= "11111111";  -- 6A46 = FF
      when "110101001000111" =>  data <= "11111111";  -- 6A47 = FF
      when "110101001001000" =>  data <= "11111111";  -- 6A48 = FF
      when "110101001001001" =>  data <= "11111111";  -- 6A49 = FF
      when "110101001001010" =>  data <= "11111111";  -- 6A4A = FF
      when "110101001001011" =>  data <= "11111111";  -- 6A4B = FF
      when "110101001001100" =>  data <= "11111111";  -- 6A4C = FF
      when "110101001001101" =>  data <= "11111111";  -- 6A4D = FF
      when "110101001001110" =>  data <= "11111111";  -- 6A4E = FF
      when "110101001001111" =>  data <= "11111111";  -- 6A4F = FF
      when "110101001010000" =>  data <= "11111111";  -- 6A50 = FF
      when "110101001010001" =>  data <= "11111111";  -- 6A51 = FF
      when "110101001010010" =>  data <= "11111111";  -- 6A52 = FF
      when "110101001010011" =>  data <= "11111111";  -- 6A53 = FF
      when "110101001010100" =>  data <= "11111111";  -- 6A54 = FF
      when "110101001010101" =>  data <= "11111111";  -- 6A55 = FF
      when "110101001010110" =>  data <= "11111111";  -- 6A56 = FF
      when "110101001010111" =>  data <= "11111111";  -- 6A57 = FF
      when "110101001011000" =>  data <= "11111111";  -- 6A58 = FF
      when "110101001011001" =>  data <= "11111111";  -- 6A59 = FF
      when "110101001011010" =>  data <= "11111111";  -- 6A5A = FF
      when "110101001011011" =>  data <= "11111111";  -- 6A5B = FF
      when "110101001011100" =>  data <= "11111111";  -- 6A5C = FF
      when "110101001011101" =>  data <= "11111111";  -- 6A5D = FF
      when "110101001011110" =>  data <= "11111111";  -- 6A5E = FF
      when "110101001011111" =>  data <= "11111111";  -- 6A5F = FF
      when "110101001100000" =>  data <= "11111111";  -- 6A60 = FF
      when "110101001100001" =>  data <= "11111111";  -- 6A61 = FF
      when "110101001100010" =>  data <= "11111111";  -- 6A62 = FF
      when "110101001100011" =>  data <= "11111111";  -- 6A63 = FF
      when "110101001100100" =>  data <= "11111111";  -- 6A64 = FF
      when "110101001100101" =>  data <= "11111111";  -- 6A65 = FF
      when "110101001100110" =>  data <= "11111111";  -- 6A66 = FF
      when "110101001100111" =>  data <= "11111111";  -- 6A67 = FF
      when "110101001101000" =>  data <= "11111111";  -- 6A68 = FF
      when "110101001101001" =>  data <= "11111111";  -- 6A69 = FF
      when "110101001101010" =>  data <= "11111111";  -- 6A6A = FF
      when "110101001101011" =>  data <= "11111111";  -- 6A6B = FF
      when "110101001101100" =>  data <= "11111111";  -- 6A6C = FF
      when "110101001101101" =>  data <= "11111111";  -- 6A6D = FF
      when "110101001101110" =>  data <= "11111111";  -- 6A6E = FF
      when "110101001101111" =>  data <= "11111111";  -- 6A6F = FF
      when "110101001110000" =>  data <= "11111111";  -- 6A70 = FF
      when "110101001110001" =>  data <= "11111111";  -- 6A71 = FF
      when "110101001110010" =>  data <= "11111111";  -- 6A72 = FF
      when "110101001110011" =>  data <= "11111111";  -- 6A73 = FF
      when "110101001110100" =>  data <= "11111111";  -- 6A74 = FF
      when "110101001110101" =>  data <= "11111111";  -- 6A75 = FF
      when "110101001110110" =>  data <= "11111111";  -- 6A76 = FF
      when "110101001110111" =>  data <= "11111111";  -- 6A77 = FF
      when "110101001111000" =>  data <= "11111111";  -- 6A78 = FF
      when "110101001111001" =>  data <= "11111111";  -- 6A79 = FF
      when "110101001111010" =>  data <= "11111111";  -- 6A7A = FF
      when "110101001111011" =>  data <= "11111111";  -- 6A7B = FF
      when "110101001111100" =>  data <= "11111111";  -- 6A7C = FF
      when "110101001111101" =>  data <= "11111111";  -- 6A7D = FF
      when "110101001111110" =>  data <= "11111111";  -- 6A7E = FF
      when "110101001111111" =>  data <= "11111111";  -- 6A7F = FF
      when "110101010000000" =>  data <= "11111111";  -- 6A80 = FF
      when "110101010000001" =>  data <= "11111111";  -- 6A81 = FF
      when "110101010000010" =>  data <= "11111111";  -- 6A82 = FF
      when "110101010000011" =>  data <= "11111111";  -- 6A83 = FF
      when "110101010000100" =>  data <= "11111111";  -- 6A84 = FF
      when "110101010000101" =>  data <= "11111111";  -- 6A85 = FF
      when "110101010000110" =>  data <= "11111111";  -- 6A86 = FF
      when "110101010000111" =>  data <= "11111111";  -- 6A87 = FF
      when "110101010001000" =>  data <= "11111111";  -- 6A88 = FF
      when "110101010001001" =>  data <= "11111111";  -- 6A89 = FF
      when "110101010001010" =>  data <= "11111111";  -- 6A8A = FF
      when "110101010001011" =>  data <= "11111111";  -- 6A8B = FF
      when "110101010001100" =>  data <= "11111111";  -- 6A8C = FF
      when "110101010001101" =>  data <= "11111111";  -- 6A8D = FF
      when "110101010001110" =>  data <= "11111111";  -- 6A8E = FF
      when "110101010001111" =>  data <= "11111111";  -- 6A8F = FF
      when "110101010010000" =>  data <= "11111111";  -- 6A90 = FF
      when "110101010010001" =>  data <= "11111111";  -- 6A91 = FF
      when "110101010010010" =>  data <= "11111111";  -- 6A92 = FF
      when "110101010010011" =>  data <= "11111111";  -- 6A93 = FF
      when "110101010010100" =>  data <= "11111111";  -- 6A94 = FF
      when "110101010010101" =>  data <= "11111111";  -- 6A95 = FF
      when "110101010010110" =>  data <= "11111111";  -- 6A96 = FF
      when "110101010010111" =>  data <= "11111111";  -- 6A97 = FF
      when "110101010011000" =>  data <= "11111111";  -- 6A98 = FF
      when "110101010011001" =>  data <= "11111111";  -- 6A99 = FF
      when "110101010011010" =>  data <= "11111111";  -- 6A9A = FF
      when "110101010011011" =>  data <= "11111111";  -- 6A9B = FF
      when "110101010011100" =>  data <= "11111111";  -- 6A9C = FF
      when "110101010011101" =>  data <= "11111111";  -- 6A9D = FF
      when "110101010011110" =>  data <= "11111111";  -- 6A9E = FF
      when "110101010011111" =>  data <= "11111111";  -- 6A9F = FF
      when "110101010100000" =>  data <= "11111111";  -- 6AA0 = FF
      when "110101010100001" =>  data <= "11111111";  -- 6AA1 = FF
      when "110101010100010" =>  data <= "11111111";  -- 6AA2 = FF
      when "110101010100011" =>  data <= "11111111";  -- 6AA3 = FF
      when "110101010100100" =>  data <= "11111111";  -- 6AA4 = FF
      when "110101010100101" =>  data <= "11111111";  -- 6AA5 = FF
      when "110101010100110" =>  data <= "11111111";  -- 6AA6 = FF
      when "110101010100111" =>  data <= "11111111";  -- 6AA7 = FF
      when "110101010101000" =>  data <= "11111111";  -- 6AA8 = FF
      when "110101010101001" =>  data <= "11111111";  -- 6AA9 = FF
      when "110101010101010" =>  data <= "11111111";  -- 6AAA = FF
      when "110101010101011" =>  data <= "11111111";  -- 6AAB = FF
      when "110101010101100" =>  data <= "11111111";  -- 6AAC = FF
      when "110101010101101" =>  data <= "11111111";  -- 6AAD = FF
      when "110101010101110" =>  data <= "11111111";  -- 6AAE = FF
      when "110101010101111" =>  data <= "11111111";  -- 6AAF = FF
      when "110101010110000" =>  data <= "11111111";  -- 6AB0 = FF
      when "110101010110001" =>  data <= "11111111";  -- 6AB1 = FF
      when "110101010110010" =>  data <= "11111111";  -- 6AB2 = FF
      when "110101010110011" =>  data <= "11111111";  -- 6AB3 = FF
      when "110101010110100" =>  data <= "11111111";  -- 6AB4 = FF
      when "110101010110101" =>  data <= "11111111";  -- 6AB5 = FF
      when "110101010110110" =>  data <= "11111111";  -- 6AB6 = FF
      when "110101010110111" =>  data <= "11111111";  -- 6AB7 = FF
      when "110101010111000" =>  data <= "11111111";  -- 6AB8 = FF
      when "110101010111001" =>  data <= "11111111";  -- 6AB9 = FF
      when "110101010111010" =>  data <= "11111111";  -- 6ABA = FF
      when "110101010111011" =>  data <= "11111111";  -- 6ABB = FF
      when "110101010111100" =>  data <= "11111111";  -- 6ABC = FF
      when "110101010111101" =>  data <= "11111111";  -- 6ABD = FF
      when "110101010111110" =>  data <= "11111111";  -- 6ABE = FF
      when "110101010111111" =>  data <= "11111111";  -- 6ABF = FF
      when "110101011000000" =>  data <= "11111111";  -- 6AC0 = FF
      when "110101011000001" =>  data <= "11111111";  -- 6AC1 = FF
      when "110101011000010" =>  data <= "11111111";  -- 6AC2 = FF
      when "110101011000011" =>  data <= "11111111";  -- 6AC3 = FF
      when "110101011000100" =>  data <= "11111111";  -- 6AC4 = FF
      when "110101011000101" =>  data <= "11111111";  -- 6AC5 = FF
      when "110101011000110" =>  data <= "11111111";  -- 6AC6 = FF
      when "110101011000111" =>  data <= "11111111";  -- 6AC7 = FF
      when "110101011001000" =>  data <= "11111111";  -- 6AC8 = FF
      when "110101011001001" =>  data <= "11111111";  -- 6AC9 = FF
      when "110101011001010" =>  data <= "11111111";  -- 6ACA = FF
      when "110101011001011" =>  data <= "11111111";  -- 6ACB = FF
      when "110101011001100" =>  data <= "11111111";  -- 6ACC = FF
      when "110101011001101" =>  data <= "11111111";  -- 6ACD = FF
      when "110101011001110" =>  data <= "11111111";  -- 6ACE = FF
      when "110101011001111" =>  data <= "11111111";  -- 6ACF = FF
      when "110101011010000" =>  data <= "11111111";  -- 6AD0 = FF
      when "110101011010001" =>  data <= "11111111";  -- 6AD1 = FF
      when "110101011010010" =>  data <= "11111111";  -- 6AD2 = FF
      when "110101011010011" =>  data <= "11111111";  -- 6AD3 = FF
      when "110101011010100" =>  data <= "11111111";  -- 6AD4 = FF
      when "110101011010101" =>  data <= "11111111";  -- 6AD5 = FF
      when "110101011010110" =>  data <= "11111111";  -- 6AD6 = FF
      when "110101011010111" =>  data <= "11111111";  -- 6AD7 = FF
      when "110101011011000" =>  data <= "11111111";  -- 6AD8 = FF
      when "110101011011001" =>  data <= "11111111";  -- 6AD9 = FF
      when "110101011011010" =>  data <= "11111111";  -- 6ADA = FF
      when "110101011011011" =>  data <= "11111111";  -- 6ADB = FF
      when "110101011011100" =>  data <= "11111111";  -- 6ADC = FF
      when "110101011011101" =>  data <= "11111111";  -- 6ADD = FF
      when "110101011011110" =>  data <= "11111111";  -- 6ADE = FF
      when "110101011011111" =>  data <= "11111111";  -- 6ADF = FF
      when "110101011100000" =>  data <= "11111111";  -- 6AE0 = FF
      when "110101011100001" =>  data <= "11111111";  -- 6AE1 = FF
      when "110101011100010" =>  data <= "11111111";  -- 6AE2 = FF
      when "110101011100011" =>  data <= "11111111";  -- 6AE3 = FF
      when "110101011100100" =>  data <= "11111111";  -- 6AE4 = FF
      when "110101011100101" =>  data <= "11111111";  -- 6AE5 = FF
      when "110101011100110" =>  data <= "11111111";  -- 6AE6 = FF
      when "110101011100111" =>  data <= "11111111";  -- 6AE7 = FF
      when "110101011101000" =>  data <= "11111111";  -- 6AE8 = FF
      when "110101011101001" =>  data <= "11111111";  -- 6AE9 = FF
      when "110101011101010" =>  data <= "11111111";  -- 6AEA = FF
      when "110101011101011" =>  data <= "11111111";  -- 6AEB = FF
      when "110101011101100" =>  data <= "11111111";  -- 6AEC = FF
      when "110101011101101" =>  data <= "11111111";  -- 6AED = FF
      when "110101011101110" =>  data <= "11111111";  -- 6AEE = FF
      when "110101011101111" =>  data <= "11111111";  -- 6AEF = FF
      when "110101011110000" =>  data <= "11111111";  -- 6AF0 = FF
      when "110101011110001" =>  data <= "11111111";  -- 6AF1 = FF
      when "110101011110010" =>  data <= "11111111";  -- 6AF2 = FF
      when "110101011110011" =>  data <= "11111111";  -- 6AF3 = FF
      when "110101011110100" =>  data <= "11111111";  -- 6AF4 = FF
      when "110101011110101" =>  data <= "11111111";  -- 6AF5 = FF
      when "110101011110110" =>  data <= "11111111";  -- 6AF6 = FF
      when "110101011110111" =>  data <= "11111111";  -- 6AF7 = FF
      when "110101011111000" =>  data <= "11111111";  -- 6AF8 = FF
      when "110101011111001" =>  data <= "11111111";  -- 6AF9 = FF
      when "110101011111010" =>  data <= "11111111";  -- 6AFA = FF
      when "110101011111011" =>  data <= "11111111";  -- 6AFB = FF
      when "110101011111100" =>  data <= "11111111";  -- 6AFC = FF
      when "110101011111101" =>  data <= "11111111";  -- 6AFD = FF
      when "110101011111110" =>  data <= "11111111";  -- 6AFE = FF
      when "110101011111111" =>  data <= "11111111";  -- 6AFF = FF
      when "110101100000000" =>  data <= "11111111";  -- 6B00 = FF
      when "110101100000001" =>  data <= "11111111";  -- 6B01 = FF
      when "110101100000010" =>  data <= "11111111";  -- 6B02 = FF
      when "110101100000011" =>  data <= "11111111";  -- 6B03 = FF
      when "110101100000100" =>  data <= "11111111";  -- 6B04 = FF
      when "110101100000101" =>  data <= "11111111";  -- 6B05 = FF
      when "110101100000110" =>  data <= "11111111";  -- 6B06 = FF
      when "110101100000111" =>  data <= "11111111";  -- 6B07 = FF
      when "110101100001000" =>  data <= "11111111";  -- 6B08 = FF
      when "110101100001001" =>  data <= "11111111";  -- 6B09 = FF
      when "110101100001010" =>  data <= "11111111";  -- 6B0A = FF
      when "110101100001011" =>  data <= "11111111";  -- 6B0B = FF
      when "110101100001100" =>  data <= "11111111";  -- 6B0C = FF
      when "110101100001101" =>  data <= "11111111";  -- 6B0D = FF
      when "110101100001110" =>  data <= "11111111";  -- 6B0E = FF
      when "110101100001111" =>  data <= "11111111";  -- 6B0F = FF
      when "110101100010000" =>  data <= "11111111";  -- 6B10 = FF
      when "110101100010001" =>  data <= "11111111";  -- 6B11 = FF
      when "110101100010010" =>  data <= "11111111";  -- 6B12 = FF
      when "110101100010011" =>  data <= "11111111";  -- 6B13 = FF
      when "110101100010100" =>  data <= "11111111";  -- 6B14 = FF
      when "110101100010101" =>  data <= "11111111";  -- 6B15 = FF
      when "110101100010110" =>  data <= "11111111";  -- 6B16 = FF
      when "110101100010111" =>  data <= "11111111";  -- 6B17 = FF
      when "110101100011000" =>  data <= "11111111";  -- 6B18 = FF
      when "110101100011001" =>  data <= "11111111";  -- 6B19 = FF
      when "110101100011010" =>  data <= "11111111";  -- 6B1A = FF
      when "110101100011011" =>  data <= "11111111";  -- 6B1B = FF
      when "110101100011100" =>  data <= "11111111";  -- 6B1C = FF
      when "110101100011101" =>  data <= "11111111";  -- 6B1D = FF
      when "110101100011110" =>  data <= "11111111";  -- 6B1E = FF
      when "110101100011111" =>  data <= "11111111";  -- 6B1F = FF
      when "110101100100000" =>  data <= "11111111";  -- 6B20 = FF
      when "110101100100001" =>  data <= "11111111";  -- 6B21 = FF
      when "110101100100010" =>  data <= "11111111";  -- 6B22 = FF
      when "110101100100011" =>  data <= "11111111";  -- 6B23 = FF
      when "110101100100100" =>  data <= "11111111";  -- 6B24 = FF
      when "110101100100101" =>  data <= "11111111";  -- 6B25 = FF
      when "110101100100110" =>  data <= "11111111";  -- 6B26 = FF
      when "110101100100111" =>  data <= "11111111";  -- 6B27 = FF
      when "110101100101000" =>  data <= "11111111";  -- 6B28 = FF
      when "110101100101001" =>  data <= "11111111";  -- 6B29 = FF
      when "110101100101010" =>  data <= "11111111";  -- 6B2A = FF
      when "110101100101011" =>  data <= "11111111";  -- 6B2B = FF
      when "110101100101100" =>  data <= "11111111";  -- 6B2C = FF
      when "110101100101101" =>  data <= "11111111";  -- 6B2D = FF
      when "110101100101110" =>  data <= "11111111";  -- 6B2E = FF
      when "110101100101111" =>  data <= "11111111";  -- 6B2F = FF
      when "110101100110000" =>  data <= "11111111";  -- 6B30 = FF
      when "110101100110001" =>  data <= "11111111";  -- 6B31 = FF
      when "110101100110010" =>  data <= "11111111";  -- 6B32 = FF
      when "110101100110011" =>  data <= "11111111";  -- 6B33 = FF
      when "110101100110100" =>  data <= "11111111";  -- 6B34 = FF
      when "110101100110101" =>  data <= "11111111";  -- 6B35 = FF
      when "110101100110110" =>  data <= "11111111";  -- 6B36 = FF
      when "110101100110111" =>  data <= "11111111";  -- 6B37 = FF
      when "110101100111000" =>  data <= "11111111";  -- 6B38 = FF
      when "110101100111001" =>  data <= "11111111";  -- 6B39 = FF
      when "110101100111010" =>  data <= "11111111";  -- 6B3A = FF
      when "110101100111011" =>  data <= "11111111";  -- 6B3B = FF
      when "110101100111100" =>  data <= "11111111";  -- 6B3C = FF
      when "110101100111101" =>  data <= "11111111";  -- 6B3D = FF
      when "110101100111110" =>  data <= "11111111";  -- 6B3E = FF
      when "110101100111111" =>  data <= "11111111";  -- 6B3F = FF
      when "110101101000000" =>  data <= "11111111";  -- 6B40 = FF
      when "110101101000001" =>  data <= "11111111";  -- 6B41 = FF
      when "110101101000010" =>  data <= "11111111";  -- 6B42 = FF
      when "110101101000011" =>  data <= "11111111";  -- 6B43 = FF
      when "110101101000100" =>  data <= "11111111";  -- 6B44 = FF
      when "110101101000101" =>  data <= "11111111";  -- 6B45 = FF
      when "110101101000110" =>  data <= "11111111";  -- 6B46 = FF
      when "110101101000111" =>  data <= "11111111";  -- 6B47 = FF
      when "110101101001000" =>  data <= "11111111";  -- 6B48 = FF
      when "110101101001001" =>  data <= "11111111";  -- 6B49 = FF
      when "110101101001010" =>  data <= "11111111";  -- 6B4A = FF
      when "110101101001011" =>  data <= "11111111";  -- 6B4B = FF
      when "110101101001100" =>  data <= "11111111";  -- 6B4C = FF
      when "110101101001101" =>  data <= "11111111";  -- 6B4D = FF
      when "110101101001110" =>  data <= "11111111";  -- 6B4E = FF
      when "110101101001111" =>  data <= "11111111";  -- 6B4F = FF
      when "110101101010000" =>  data <= "11111111";  -- 6B50 = FF
      when "110101101010001" =>  data <= "11111111";  -- 6B51 = FF
      when "110101101010010" =>  data <= "11111111";  -- 6B52 = FF
      when "110101101010011" =>  data <= "11111111";  -- 6B53 = FF
      when "110101101010100" =>  data <= "11111111";  -- 6B54 = FF
      when "110101101010101" =>  data <= "11111111";  -- 6B55 = FF
      when "110101101010110" =>  data <= "11111111";  -- 6B56 = FF
      when "110101101010111" =>  data <= "11111111";  -- 6B57 = FF
      when "110101101011000" =>  data <= "11111111";  -- 6B58 = FF
      when "110101101011001" =>  data <= "11111111";  -- 6B59 = FF
      when "110101101011010" =>  data <= "11111111";  -- 6B5A = FF
      when "110101101011011" =>  data <= "11111111";  -- 6B5B = FF
      when "110101101011100" =>  data <= "11111111";  -- 6B5C = FF
      when "110101101011101" =>  data <= "11111111";  -- 6B5D = FF
      when "110101101011110" =>  data <= "11111111";  -- 6B5E = FF
      when "110101101011111" =>  data <= "11111111";  -- 6B5F = FF
      when "110101101100000" =>  data <= "11111111";  -- 6B60 = FF
      when "110101101100001" =>  data <= "11111111";  -- 6B61 = FF
      when "110101101100010" =>  data <= "11111111";  -- 6B62 = FF
      when "110101101100011" =>  data <= "11111111";  -- 6B63 = FF
      when "110101101100100" =>  data <= "11111111";  -- 6B64 = FF
      when "110101101100101" =>  data <= "11111111";  -- 6B65 = FF
      when "110101101100110" =>  data <= "11111111";  -- 6B66 = FF
      when "110101101100111" =>  data <= "11111111";  -- 6B67 = FF
      when "110101101101000" =>  data <= "11111111";  -- 6B68 = FF
      when "110101101101001" =>  data <= "11111111";  -- 6B69 = FF
      when "110101101101010" =>  data <= "11111111";  -- 6B6A = FF
      when "110101101101011" =>  data <= "11111111";  -- 6B6B = FF
      when "110101101101100" =>  data <= "11111111";  -- 6B6C = FF
      when "110101101101101" =>  data <= "11111111";  -- 6B6D = FF
      when "110101101101110" =>  data <= "11111111";  -- 6B6E = FF
      when "110101101101111" =>  data <= "11111111";  -- 6B6F = FF
      when "110101101110000" =>  data <= "11111111";  -- 6B70 = FF
      when "110101101110001" =>  data <= "11111111";  -- 6B71 = FF
      when "110101101110010" =>  data <= "11111111";  -- 6B72 = FF
      when "110101101110011" =>  data <= "11111111";  -- 6B73 = FF
      when "110101101110100" =>  data <= "11111111";  -- 6B74 = FF
      when "110101101110101" =>  data <= "11111111";  -- 6B75 = FF
      when "110101101110110" =>  data <= "11111111";  -- 6B76 = FF
      when "110101101110111" =>  data <= "11111111";  -- 6B77 = FF
      when "110101101111000" =>  data <= "11111111";  -- 6B78 = FF
      when "110101101111001" =>  data <= "11111111";  -- 6B79 = FF
      when "110101101111010" =>  data <= "11111111";  -- 6B7A = FF
      when "110101101111011" =>  data <= "11111111";  -- 6B7B = FF
      when "110101101111100" =>  data <= "11111111";  -- 6B7C = FF
      when "110101101111101" =>  data <= "11111111";  -- 6B7D = FF
      when "110101101111110" =>  data <= "11111111";  -- 6B7E = FF
      when "110101101111111" =>  data <= "11111111";  -- 6B7F = FF
      when "110101110000000" =>  data <= "11111111";  -- 6B80 = FF
      when "110101110000001" =>  data <= "11111111";  -- 6B81 = FF
      when "110101110000010" =>  data <= "11111111";  -- 6B82 = FF
      when "110101110000011" =>  data <= "11111111";  -- 6B83 = FF
      when "110101110000100" =>  data <= "11111111";  -- 6B84 = FF
      when "110101110000101" =>  data <= "11111111";  -- 6B85 = FF
      when "110101110000110" =>  data <= "11111111";  -- 6B86 = FF
      when "110101110000111" =>  data <= "11111111";  -- 6B87 = FF
      when "110101110001000" =>  data <= "11111111";  -- 6B88 = FF
      when "110101110001001" =>  data <= "11111111";  -- 6B89 = FF
      when "110101110001010" =>  data <= "11111111";  -- 6B8A = FF
      when "110101110001011" =>  data <= "11111111";  -- 6B8B = FF
      when "110101110001100" =>  data <= "11111111";  -- 6B8C = FF
      when "110101110001101" =>  data <= "11111111";  -- 6B8D = FF
      when "110101110001110" =>  data <= "11111111";  -- 6B8E = FF
      when "110101110001111" =>  data <= "11111111";  -- 6B8F = FF
      when "110101110010000" =>  data <= "11111111";  -- 6B90 = FF
      when "110101110010001" =>  data <= "11111111";  -- 6B91 = FF
      when "110101110010010" =>  data <= "11111111";  -- 6B92 = FF
      when "110101110010011" =>  data <= "11111111";  -- 6B93 = FF
      when "110101110010100" =>  data <= "11111111";  -- 6B94 = FF
      when "110101110010101" =>  data <= "11111111";  -- 6B95 = FF
      when "110101110010110" =>  data <= "11111111";  -- 6B96 = FF
      when "110101110010111" =>  data <= "11111111";  -- 6B97 = FF
      when "110101110011000" =>  data <= "11111111";  -- 6B98 = FF
      when "110101110011001" =>  data <= "11111111";  -- 6B99 = FF
      when "110101110011010" =>  data <= "11111111";  -- 6B9A = FF
      when "110101110011011" =>  data <= "11111111";  -- 6B9B = FF
      when "110101110011100" =>  data <= "11111111";  -- 6B9C = FF
      when "110101110011101" =>  data <= "11111111";  -- 6B9D = FF
      when "110101110011110" =>  data <= "11111111";  -- 6B9E = FF
      when "110101110011111" =>  data <= "11111111";  -- 6B9F = FF
      when "110101110100000" =>  data <= "11111111";  -- 6BA0 = FF
      when "110101110100001" =>  data <= "11111111";  -- 6BA1 = FF
      when "110101110100010" =>  data <= "11111111";  -- 6BA2 = FF
      when "110101110100011" =>  data <= "11111111";  -- 6BA3 = FF
      when "110101110100100" =>  data <= "11111111";  -- 6BA4 = FF
      when "110101110100101" =>  data <= "11111111";  -- 6BA5 = FF
      when "110101110100110" =>  data <= "11111111";  -- 6BA6 = FF
      when "110101110100111" =>  data <= "11111111";  -- 6BA7 = FF
      when "110101110101000" =>  data <= "11111111";  -- 6BA8 = FF
      when "110101110101001" =>  data <= "11111111";  -- 6BA9 = FF
      when "110101110101010" =>  data <= "11111111";  -- 6BAA = FF
      when "110101110101011" =>  data <= "11111111";  -- 6BAB = FF
      when "110101110101100" =>  data <= "11111111";  -- 6BAC = FF
      when "110101110101101" =>  data <= "11111111";  -- 6BAD = FF
      when "110101110101110" =>  data <= "11111111";  -- 6BAE = FF
      when "110101110101111" =>  data <= "11111111";  -- 6BAF = FF
      when "110101110110000" =>  data <= "11111111";  -- 6BB0 = FF
      when "110101110110001" =>  data <= "11111111";  -- 6BB1 = FF
      when "110101110110010" =>  data <= "11111111";  -- 6BB2 = FF
      when "110101110110011" =>  data <= "11111111";  -- 6BB3 = FF
      when "110101110110100" =>  data <= "11111111";  -- 6BB4 = FF
      when "110101110110101" =>  data <= "11111111";  -- 6BB5 = FF
      when "110101110110110" =>  data <= "11111111";  -- 6BB6 = FF
      when "110101110110111" =>  data <= "11111111";  -- 6BB7 = FF
      when "110101110111000" =>  data <= "11111111";  -- 6BB8 = FF
      when "110101110111001" =>  data <= "11111111";  -- 6BB9 = FF
      when "110101110111010" =>  data <= "11111111";  -- 6BBA = FF
      when "110101110111011" =>  data <= "11111111";  -- 6BBB = FF
      when "110101110111100" =>  data <= "11111111";  -- 6BBC = FF
      when "110101110111101" =>  data <= "11111111";  -- 6BBD = FF
      when "110101110111110" =>  data <= "11111111";  -- 6BBE = FF
      when "110101110111111" =>  data <= "11111111";  -- 6BBF = FF
      when "110101111000000" =>  data <= "11111111";  -- 6BC0 = FF
      when "110101111000001" =>  data <= "11111111";  -- 6BC1 = FF
      when "110101111000010" =>  data <= "11111111";  -- 6BC2 = FF
      when "110101111000011" =>  data <= "11111111";  -- 6BC3 = FF
      when "110101111000100" =>  data <= "11111111";  -- 6BC4 = FF
      when "110101111000101" =>  data <= "11111111";  -- 6BC5 = FF
      when "110101111000110" =>  data <= "11111111";  -- 6BC6 = FF
      when "110101111000111" =>  data <= "11111111";  -- 6BC7 = FF
      when "110101111001000" =>  data <= "11111111";  -- 6BC8 = FF
      when "110101111001001" =>  data <= "11111111";  -- 6BC9 = FF
      when "110101111001010" =>  data <= "11111111";  -- 6BCA = FF
      when "110101111001011" =>  data <= "11111111";  -- 6BCB = FF
      when "110101111001100" =>  data <= "11111111";  -- 6BCC = FF
      when "110101111001101" =>  data <= "11111111";  -- 6BCD = FF
      when "110101111001110" =>  data <= "11111111";  -- 6BCE = FF
      when "110101111001111" =>  data <= "11111111";  -- 6BCF = FF
      when "110101111010000" =>  data <= "11111111";  -- 6BD0 = FF
      when "110101111010001" =>  data <= "11111111";  -- 6BD1 = FF
      when "110101111010010" =>  data <= "11111111";  -- 6BD2 = FF
      when "110101111010011" =>  data <= "11111111";  -- 6BD3 = FF
      when "110101111010100" =>  data <= "11111111";  -- 6BD4 = FF
      when "110101111010101" =>  data <= "11111111";  -- 6BD5 = FF
      when "110101111010110" =>  data <= "11111111";  -- 6BD6 = FF
      when "110101111010111" =>  data <= "11111111";  -- 6BD7 = FF
      when "110101111011000" =>  data <= "11111111";  -- 6BD8 = FF
      when "110101111011001" =>  data <= "11111111";  -- 6BD9 = FF
      when "110101111011010" =>  data <= "11111111";  -- 6BDA = FF
      when "110101111011011" =>  data <= "11111111";  -- 6BDB = FF
      when "110101111011100" =>  data <= "11111111";  -- 6BDC = FF
      when "110101111011101" =>  data <= "11111111";  -- 6BDD = FF
      when "110101111011110" =>  data <= "11111111";  -- 6BDE = FF
      when "110101111011111" =>  data <= "11111111";  -- 6BDF = FF
      when "110101111100000" =>  data <= "11111111";  -- 6BE0 = FF
      when "110101111100001" =>  data <= "11111111";  -- 6BE1 = FF
      when "110101111100010" =>  data <= "11111111";  -- 6BE2 = FF
      when "110101111100011" =>  data <= "11111111";  -- 6BE3 = FF
      when "110101111100100" =>  data <= "11111111";  -- 6BE4 = FF
      when "110101111100101" =>  data <= "11111111";  -- 6BE5 = FF
      when "110101111100110" =>  data <= "11111111";  -- 6BE6 = FF
      when "110101111100111" =>  data <= "11111111";  -- 6BE7 = FF
      when "110101111101000" =>  data <= "11111111";  -- 6BE8 = FF
      when "110101111101001" =>  data <= "11111111";  -- 6BE9 = FF
      when "110101111101010" =>  data <= "11111111";  -- 6BEA = FF
      when "110101111101011" =>  data <= "11111111";  -- 6BEB = FF
      when "110101111101100" =>  data <= "11111111";  -- 6BEC = FF
      when "110101111101101" =>  data <= "11111111";  -- 6BED = FF
      when "110101111101110" =>  data <= "11111111";  -- 6BEE = FF
      when "110101111101111" =>  data <= "11111111";  -- 6BEF = FF
      when "110101111110000" =>  data <= "11111111";  -- 6BF0 = FF
      when "110101111110001" =>  data <= "11111111";  -- 6BF1 = FF
      when "110101111110010" =>  data <= "11111111";  -- 6BF2 = FF
      when "110101111110011" =>  data <= "11111111";  -- 6BF3 = FF
      when "110101111110100" =>  data <= "11111111";  -- 6BF4 = FF
      when "110101111110101" =>  data <= "11111111";  -- 6BF5 = FF
      when "110101111110110" =>  data <= "11111111";  -- 6BF6 = FF
      when "110101111110111" =>  data <= "11111111";  -- 6BF7 = FF
      when "110101111111000" =>  data <= "11111111";  -- 6BF8 = FF
      when "110101111111001" =>  data <= "11111111";  -- 6BF9 = FF
      when "110101111111010" =>  data <= "11111111";  -- 6BFA = FF
      when "110101111111011" =>  data <= "11111111";  -- 6BFB = FF
      when "110101111111100" =>  data <= "11111111";  -- 6BFC = FF
      when "110101111111101" =>  data <= "11111111";  -- 6BFD = FF
      when "110101111111110" =>  data <= "11111111";  -- 6BFE = FF
      when "110101111111111" =>  data <= "11111111";  -- 6BFF = FF
      when "110110000000000" =>  data <= "11111111";  -- 6C00 = FF
      when "110110000000001" =>  data <= "11111111";  -- 6C01 = FF
      when "110110000000010" =>  data <= "11111111";  -- 6C02 = FF
      when "110110000000011" =>  data <= "11111111";  -- 6C03 = FF
      when "110110000000100" =>  data <= "11111111";  -- 6C04 = FF
      when "110110000000101" =>  data <= "11111111";  -- 6C05 = FF
      when "110110000000110" =>  data <= "11111111";  -- 6C06 = FF
      when "110110000000111" =>  data <= "11111111";  -- 6C07 = FF
      when "110110000001000" =>  data <= "11111111";  -- 6C08 = FF
      when "110110000001001" =>  data <= "11111111";  -- 6C09 = FF
      when "110110000001010" =>  data <= "11111111";  -- 6C0A = FF
      when "110110000001011" =>  data <= "11111111";  -- 6C0B = FF
      when "110110000001100" =>  data <= "11111111";  -- 6C0C = FF
      when "110110000001101" =>  data <= "11111111";  -- 6C0D = FF
      when "110110000001110" =>  data <= "11111111";  -- 6C0E = FF
      when "110110000001111" =>  data <= "11111111";  -- 6C0F = FF
      when "110110000010000" =>  data <= "11111111";  -- 6C10 = FF
      when "110110000010001" =>  data <= "11111111";  -- 6C11 = FF
      when "110110000010010" =>  data <= "11111111";  -- 6C12 = FF
      when "110110000010011" =>  data <= "11111111";  -- 6C13 = FF
      when "110110000010100" =>  data <= "11111111";  -- 6C14 = FF
      when "110110000010101" =>  data <= "11111111";  -- 6C15 = FF
      when "110110000010110" =>  data <= "11111111";  -- 6C16 = FF
      when "110110000010111" =>  data <= "11111111";  -- 6C17 = FF
      when "110110000011000" =>  data <= "11111111";  -- 6C18 = FF
      when "110110000011001" =>  data <= "11111111";  -- 6C19 = FF
      when "110110000011010" =>  data <= "11111111";  -- 6C1A = FF
      when "110110000011011" =>  data <= "11111111";  -- 6C1B = FF
      when "110110000011100" =>  data <= "11111111";  -- 6C1C = FF
      when "110110000011101" =>  data <= "11111111";  -- 6C1D = FF
      when "110110000011110" =>  data <= "11111111";  -- 6C1E = FF
      when "110110000011111" =>  data <= "11111111";  -- 6C1F = FF
      when "110110000100000" =>  data <= "11111111";  -- 6C20 = FF
      when "110110000100001" =>  data <= "11111111";  -- 6C21 = FF
      when "110110000100010" =>  data <= "11111111";  -- 6C22 = FF
      when "110110000100011" =>  data <= "11111111";  -- 6C23 = FF
      when "110110000100100" =>  data <= "11111111";  -- 6C24 = FF
      when "110110000100101" =>  data <= "11111111";  -- 6C25 = FF
      when "110110000100110" =>  data <= "11111111";  -- 6C26 = FF
      when "110110000100111" =>  data <= "11111111";  -- 6C27 = FF
      when "110110000101000" =>  data <= "11111111";  -- 6C28 = FF
      when "110110000101001" =>  data <= "11111111";  -- 6C29 = FF
      when "110110000101010" =>  data <= "11111111";  -- 6C2A = FF
      when "110110000101011" =>  data <= "11111111";  -- 6C2B = FF
      when "110110000101100" =>  data <= "11111111";  -- 6C2C = FF
      when "110110000101101" =>  data <= "11111111";  -- 6C2D = FF
      when "110110000101110" =>  data <= "11111111";  -- 6C2E = FF
      when "110110000101111" =>  data <= "11111111";  -- 6C2F = FF
      when "110110000110000" =>  data <= "11111111";  -- 6C30 = FF
      when "110110000110001" =>  data <= "11111111";  -- 6C31 = FF
      when "110110000110010" =>  data <= "11111111";  -- 6C32 = FF
      when "110110000110011" =>  data <= "11111111";  -- 6C33 = FF
      when "110110000110100" =>  data <= "11111111";  -- 6C34 = FF
      when "110110000110101" =>  data <= "11111111";  -- 6C35 = FF
      when "110110000110110" =>  data <= "11111111";  -- 6C36 = FF
      when "110110000110111" =>  data <= "11111111";  -- 6C37 = FF
      when "110110000111000" =>  data <= "11111111";  -- 6C38 = FF
      when "110110000111001" =>  data <= "11111111";  -- 6C39 = FF
      when "110110000111010" =>  data <= "11111111";  -- 6C3A = FF
      when "110110000111011" =>  data <= "11111111";  -- 6C3B = FF
      when "110110000111100" =>  data <= "11111111";  -- 6C3C = FF
      when "110110000111101" =>  data <= "11111111";  -- 6C3D = FF
      when "110110000111110" =>  data <= "11111111";  -- 6C3E = FF
      when "110110000111111" =>  data <= "11111111";  -- 6C3F = FF
      when "110110001000000" =>  data <= "11111111";  -- 6C40 = FF
      when "110110001000001" =>  data <= "11111111";  -- 6C41 = FF
      when "110110001000010" =>  data <= "11111111";  -- 6C42 = FF
      when "110110001000011" =>  data <= "11111111";  -- 6C43 = FF
      when "110110001000100" =>  data <= "11111111";  -- 6C44 = FF
      when "110110001000101" =>  data <= "11111111";  -- 6C45 = FF
      when "110110001000110" =>  data <= "11111111";  -- 6C46 = FF
      when "110110001000111" =>  data <= "11111111";  -- 6C47 = FF
      when "110110001001000" =>  data <= "11111111";  -- 6C48 = FF
      when "110110001001001" =>  data <= "11111111";  -- 6C49 = FF
      when "110110001001010" =>  data <= "11111111";  -- 6C4A = FF
      when "110110001001011" =>  data <= "11111111";  -- 6C4B = FF
      when "110110001001100" =>  data <= "11111111";  -- 6C4C = FF
      when "110110001001101" =>  data <= "11111111";  -- 6C4D = FF
      when "110110001001110" =>  data <= "11111111";  -- 6C4E = FF
      when "110110001001111" =>  data <= "11111111";  -- 6C4F = FF
      when "110110001010000" =>  data <= "11111111";  -- 6C50 = FF
      when "110110001010001" =>  data <= "11111111";  -- 6C51 = FF
      when "110110001010010" =>  data <= "11111111";  -- 6C52 = FF
      when "110110001010011" =>  data <= "11111111";  -- 6C53 = FF
      when "110110001010100" =>  data <= "11111111";  -- 6C54 = FF
      when "110110001010101" =>  data <= "11111111";  -- 6C55 = FF
      when "110110001010110" =>  data <= "11111111";  -- 6C56 = FF
      when "110110001010111" =>  data <= "11111111";  -- 6C57 = FF
      when "110110001011000" =>  data <= "11111111";  -- 6C58 = FF
      when "110110001011001" =>  data <= "11111111";  -- 6C59 = FF
      when "110110001011010" =>  data <= "11111111";  -- 6C5A = FF
      when "110110001011011" =>  data <= "11111111";  -- 6C5B = FF
      when "110110001011100" =>  data <= "11111111";  -- 6C5C = FF
      when "110110001011101" =>  data <= "11111111";  -- 6C5D = FF
      when "110110001011110" =>  data <= "11111111";  -- 6C5E = FF
      when "110110001011111" =>  data <= "11111111";  -- 6C5F = FF
      when "110110001100000" =>  data <= "11111111";  -- 6C60 = FF
      when "110110001100001" =>  data <= "11111111";  -- 6C61 = FF
      when "110110001100010" =>  data <= "11111111";  -- 6C62 = FF
      when "110110001100011" =>  data <= "11111111";  -- 6C63 = FF
      when "110110001100100" =>  data <= "11111111";  -- 6C64 = FF
      when "110110001100101" =>  data <= "11111111";  -- 6C65 = FF
      when "110110001100110" =>  data <= "11111111";  -- 6C66 = FF
      when "110110001100111" =>  data <= "11111111";  -- 6C67 = FF
      when "110110001101000" =>  data <= "11111111";  -- 6C68 = FF
      when "110110001101001" =>  data <= "11111111";  -- 6C69 = FF
      when "110110001101010" =>  data <= "11111111";  -- 6C6A = FF
      when "110110001101011" =>  data <= "11111111";  -- 6C6B = FF
      when "110110001101100" =>  data <= "11111111";  -- 6C6C = FF
      when "110110001101101" =>  data <= "11111111";  -- 6C6D = FF
      when "110110001101110" =>  data <= "11111111";  -- 6C6E = FF
      when "110110001101111" =>  data <= "11111111";  -- 6C6F = FF
      when "110110001110000" =>  data <= "11111111";  -- 6C70 = FF
      when "110110001110001" =>  data <= "11111111";  -- 6C71 = FF
      when "110110001110010" =>  data <= "11111111";  -- 6C72 = FF
      when "110110001110011" =>  data <= "11111111";  -- 6C73 = FF
      when "110110001110100" =>  data <= "11111111";  -- 6C74 = FF
      when "110110001110101" =>  data <= "11111111";  -- 6C75 = FF
      when "110110001110110" =>  data <= "11111111";  -- 6C76 = FF
      when "110110001110111" =>  data <= "11111111";  -- 6C77 = FF
      when "110110001111000" =>  data <= "11111111";  -- 6C78 = FF
      when "110110001111001" =>  data <= "11111111";  -- 6C79 = FF
      when "110110001111010" =>  data <= "11111111";  -- 6C7A = FF
      when "110110001111011" =>  data <= "11111111";  -- 6C7B = FF
      when "110110001111100" =>  data <= "11111111";  -- 6C7C = FF
      when "110110001111101" =>  data <= "11111111";  -- 6C7D = FF
      when "110110001111110" =>  data <= "11111111";  -- 6C7E = FF
      when "110110001111111" =>  data <= "11111111";  -- 6C7F = FF
      when "110110010000000" =>  data <= "11111111";  -- 6C80 = FF
      when "110110010000001" =>  data <= "11111111";  -- 6C81 = FF
      when "110110010000010" =>  data <= "11111111";  -- 6C82 = FF
      when "110110010000011" =>  data <= "11111111";  -- 6C83 = FF
      when "110110010000100" =>  data <= "11111111";  -- 6C84 = FF
      when "110110010000101" =>  data <= "11111111";  -- 6C85 = FF
      when "110110010000110" =>  data <= "11111111";  -- 6C86 = FF
      when "110110010000111" =>  data <= "11111111";  -- 6C87 = FF
      when "110110010001000" =>  data <= "11111111";  -- 6C88 = FF
      when "110110010001001" =>  data <= "11111111";  -- 6C89 = FF
      when "110110010001010" =>  data <= "11111111";  -- 6C8A = FF
      when "110110010001011" =>  data <= "11111111";  -- 6C8B = FF
      when "110110010001100" =>  data <= "11111111";  -- 6C8C = FF
      when "110110010001101" =>  data <= "11111111";  -- 6C8D = FF
      when "110110010001110" =>  data <= "11111111";  -- 6C8E = FF
      when "110110010001111" =>  data <= "11111111";  -- 6C8F = FF
      when "110110010010000" =>  data <= "11111111";  -- 6C90 = FF
      when "110110010010001" =>  data <= "11111111";  -- 6C91 = FF
      when "110110010010010" =>  data <= "11111111";  -- 6C92 = FF
      when "110110010010011" =>  data <= "11111111";  -- 6C93 = FF
      when "110110010010100" =>  data <= "11111111";  -- 6C94 = FF
      when "110110010010101" =>  data <= "11111111";  -- 6C95 = FF
      when "110110010010110" =>  data <= "11111111";  -- 6C96 = FF
      when "110110010010111" =>  data <= "11111111";  -- 6C97 = FF
      when "110110010011000" =>  data <= "11111111";  -- 6C98 = FF
      when "110110010011001" =>  data <= "11111111";  -- 6C99 = FF
      when "110110010011010" =>  data <= "11111111";  -- 6C9A = FF
      when "110110010011011" =>  data <= "11111111";  -- 6C9B = FF
      when "110110010011100" =>  data <= "11111111";  -- 6C9C = FF
      when "110110010011101" =>  data <= "11111111";  -- 6C9D = FF
      when "110110010011110" =>  data <= "11111111";  -- 6C9E = FF
      when "110110010011111" =>  data <= "11111111";  -- 6C9F = FF
      when "110110010100000" =>  data <= "11111111";  -- 6CA0 = FF
      when "110110010100001" =>  data <= "11111111";  -- 6CA1 = FF
      when "110110010100010" =>  data <= "11111111";  -- 6CA2 = FF
      when "110110010100011" =>  data <= "11111111";  -- 6CA3 = FF
      when "110110010100100" =>  data <= "11111111";  -- 6CA4 = FF
      when "110110010100101" =>  data <= "11111111";  -- 6CA5 = FF
      when "110110010100110" =>  data <= "11111111";  -- 6CA6 = FF
      when "110110010100111" =>  data <= "11111111";  -- 6CA7 = FF
      when "110110010101000" =>  data <= "11111111";  -- 6CA8 = FF
      when "110110010101001" =>  data <= "11111111";  -- 6CA9 = FF
      when "110110010101010" =>  data <= "11111111";  -- 6CAA = FF
      when "110110010101011" =>  data <= "11111111";  -- 6CAB = FF
      when "110110010101100" =>  data <= "11111111";  -- 6CAC = FF
      when "110110010101101" =>  data <= "11111111";  -- 6CAD = FF
      when "110110010101110" =>  data <= "11111111";  -- 6CAE = FF
      when "110110010101111" =>  data <= "11111111";  -- 6CAF = FF
      when "110110010110000" =>  data <= "11111111";  -- 6CB0 = FF
      when "110110010110001" =>  data <= "11111111";  -- 6CB1 = FF
      when "110110010110010" =>  data <= "11111111";  -- 6CB2 = FF
      when "110110010110011" =>  data <= "11111111";  -- 6CB3 = FF
      when "110110010110100" =>  data <= "11111111";  -- 6CB4 = FF
      when "110110010110101" =>  data <= "11111111";  -- 6CB5 = FF
      when "110110010110110" =>  data <= "11111111";  -- 6CB6 = FF
      when "110110010110111" =>  data <= "11111111";  -- 6CB7 = FF
      when "110110010111000" =>  data <= "11111111";  -- 6CB8 = FF
      when "110110010111001" =>  data <= "11111111";  -- 6CB9 = FF
      when "110110010111010" =>  data <= "11111111";  -- 6CBA = FF
      when "110110010111011" =>  data <= "11111111";  -- 6CBB = FF
      when "110110010111100" =>  data <= "11111111";  -- 6CBC = FF
      when "110110010111101" =>  data <= "11111111";  -- 6CBD = FF
      when "110110010111110" =>  data <= "11111111";  -- 6CBE = FF
      when "110110010111111" =>  data <= "11111111";  -- 6CBF = FF
      when "110110011000000" =>  data <= "11111111";  -- 6CC0 = FF
      when "110110011000001" =>  data <= "11111111";  -- 6CC1 = FF
      when "110110011000010" =>  data <= "11111111";  -- 6CC2 = FF
      when "110110011000011" =>  data <= "11111111";  -- 6CC3 = FF
      when "110110011000100" =>  data <= "11111111";  -- 6CC4 = FF
      when "110110011000101" =>  data <= "11111111";  -- 6CC5 = FF
      when "110110011000110" =>  data <= "11111111";  -- 6CC6 = FF
      when "110110011000111" =>  data <= "11111111";  -- 6CC7 = FF
      when "110110011001000" =>  data <= "11111111";  -- 6CC8 = FF
      when "110110011001001" =>  data <= "11111111";  -- 6CC9 = FF
      when "110110011001010" =>  data <= "11111111";  -- 6CCA = FF
      when "110110011001011" =>  data <= "11111111";  -- 6CCB = FF
      when "110110011001100" =>  data <= "11111111";  -- 6CCC = FF
      when "110110011001101" =>  data <= "11111111";  -- 6CCD = FF
      when "110110011001110" =>  data <= "11111111";  -- 6CCE = FF
      when "110110011001111" =>  data <= "11111111";  -- 6CCF = FF
      when "110110011010000" =>  data <= "11111111";  -- 6CD0 = FF
      when "110110011010001" =>  data <= "11111111";  -- 6CD1 = FF
      when "110110011010010" =>  data <= "11111111";  -- 6CD2 = FF
      when "110110011010011" =>  data <= "11111111";  -- 6CD3 = FF
      when "110110011010100" =>  data <= "11111111";  -- 6CD4 = FF
      when "110110011010101" =>  data <= "11111111";  -- 6CD5 = FF
      when "110110011010110" =>  data <= "11111111";  -- 6CD6 = FF
      when "110110011010111" =>  data <= "11111111";  -- 6CD7 = FF
      when "110110011011000" =>  data <= "11111111";  -- 6CD8 = FF
      when "110110011011001" =>  data <= "11111111";  -- 6CD9 = FF
      when "110110011011010" =>  data <= "11111111";  -- 6CDA = FF
      when "110110011011011" =>  data <= "11111111";  -- 6CDB = FF
      when "110110011011100" =>  data <= "11111111";  -- 6CDC = FF
      when "110110011011101" =>  data <= "11111111";  -- 6CDD = FF
      when "110110011011110" =>  data <= "11111111";  -- 6CDE = FF
      when "110110011011111" =>  data <= "11111111";  -- 6CDF = FF
      when "110110011100000" =>  data <= "11111111";  -- 6CE0 = FF
      when "110110011100001" =>  data <= "11111111";  -- 6CE1 = FF
      when "110110011100010" =>  data <= "11111111";  -- 6CE2 = FF
      when "110110011100011" =>  data <= "11111111";  -- 6CE3 = FF
      when "110110011100100" =>  data <= "11111111";  -- 6CE4 = FF
      when "110110011100101" =>  data <= "11111111";  -- 6CE5 = FF
      when "110110011100110" =>  data <= "11111111";  -- 6CE6 = FF
      when "110110011100111" =>  data <= "11111111";  -- 6CE7 = FF
      when "110110011101000" =>  data <= "11111111";  -- 6CE8 = FF
      when "110110011101001" =>  data <= "11111111";  -- 6CE9 = FF
      when "110110011101010" =>  data <= "11111111";  -- 6CEA = FF
      when "110110011101011" =>  data <= "11111111";  -- 6CEB = FF
      when "110110011101100" =>  data <= "11111111";  -- 6CEC = FF
      when "110110011101101" =>  data <= "11111111";  -- 6CED = FF
      when "110110011101110" =>  data <= "11111111";  -- 6CEE = FF
      when "110110011101111" =>  data <= "11111111";  -- 6CEF = FF
      when "110110011110000" =>  data <= "11111111";  -- 6CF0 = FF
      when "110110011110001" =>  data <= "11111111";  -- 6CF1 = FF
      when "110110011110010" =>  data <= "11111111";  -- 6CF2 = FF
      when "110110011110011" =>  data <= "11111111";  -- 6CF3 = FF
      when "110110011110100" =>  data <= "11111111";  -- 6CF4 = FF
      when "110110011110101" =>  data <= "11111111";  -- 6CF5 = FF
      when "110110011110110" =>  data <= "11111111";  -- 6CF6 = FF
      when "110110011110111" =>  data <= "11111111";  -- 6CF7 = FF
      when "110110011111000" =>  data <= "11111111";  -- 6CF8 = FF
      when "110110011111001" =>  data <= "11111111";  -- 6CF9 = FF
      when "110110011111010" =>  data <= "11111111";  -- 6CFA = FF
      when "110110011111011" =>  data <= "11111111";  -- 6CFB = FF
      when "110110011111100" =>  data <= "11111111";  -- 6CFC = FF
      when "110110011111101" =>  data <= "11111111";  -- 6CFD = FF
      when "110110011111110" =>  data <= "11111111";  -- 6CFE = FF
      when "110110011111111" =>  data <= "11111111";  -- 6CFF = FF
      when "110110100000000" =>  data <= "11111111";  -- 6D00 = FF
      when "110110100000001" =>  data <= "11111111";  -- 6D01 = FF
      when "110110100000010" =>  data <= "11111111";  -- 6D02 = FF
      when "110110100000011" =>  data <= "11111111";  -- 6D03 = FF
      when "110110100000100" =>  data <= "11111111";  -- 6D04 = FF
      when "110110100000101" =>  data <= "11111111";  -- 6D05 = FF
      when "110110100000110" =>  data <= "11111111";  -- 6D06 = FF
      when "110110100000111" =>  data <= "11111111";  -- 6D07 = FF
      when "110110100001000" =>  data <= "11111111";  -- 6D08 = FF
      when "110110100001001" =>  data <= "11111111";  -- 6D09 = FF
      when "110110100001010" =>  data <= "11111111";  -- 6D0A = FF
      when "110110100001011" =>  data <= "11111111";  -- 6D0B = FF
      when "110110100001100" =>  data <= "11111111";  -- 6D0C = FF
      when "110110100001101" =>  data <= "11111111";  -- 6D0D = FF
      when "110110100001110" =>  data <= "11111111";  -- 6D0E = FF
      when "110110100001111" =>  data <= "11111111";  -- 6D0F = FF
      when "110110100010000" =>  data <= "11111111";  -- 6D10 = FF
      when "110110100010001" =>  data <= "11111111";  -- 6D11 = FF
      when "110110100010010" =>  data <= "11111111";  -- 6D12 = FF
      when "110110100010011" =>  data <= "11111111";  -- 6D13 = FF
      when "110110100010100" =>  data <= "11111111";  -- 6D14 = FF
      when "110110100010101" =>  data <= "11111111";  -- 6D15 = FF
      when "110110100010110" =>  data <= "11111111";  -- 6D16 = FF
      when "110110100010111" =>  data <= "11111111";  -- 6D17 = FF
      when "110110100011000" =>  data <= "11111111";  -- 6D18 = FF
      when "110110100011001" =>  data <= "11111111";  -- 6D19 = FF
      when "110110100011010" =>  data <= "11111111";  -- 6D1A = FF
      when "110110100011011" =>  data <= "11111111";  -- 6D1B = FF
      when "110110100011100" =>  data <= "11111111";  -- 6D1C = FF
      when "110110100011101" =>  data <= "11111111";  -- 6D1D = FF
      when "110110100011110" =>  data <= "11111111";  -- 6D1E = FF
      when "110110100011111" =>  data <= "11111111";  -- 6D1F = FF
      when "110110100100000" =>  data <= "11111111";  -- 6D20 = FF
      when "110110100100001" =>  data <= "11111111";  -- 6D21 = FF
      when "110110100100010" =>  data <= "11111111";  -- 6D22 = FF
      when "110110100100011" =>  data <= "11111111";  -- 6D23 = FF
      when "110110100100100" =>  data <= "11111111";  -- 6D24 = FF
      when "110110100100101" =>  data <= "11111111";  -- 6D25 = FF
      when "110110100100110" =>  data <= "11111111";  -- 6D26 = FF
      when "110110100100111" =>  data <= "11111111";  -- 6D27 = FF
      when "110110100101000" =>  data <= "11111111";  -- 6D28 = FF
      when "110110100101001" =>  data <= "11111111";  -- 6D29 = FF
      when "110110100101010" =>  data <= "11111111";  -- 6D2A = FF
      when "110110100101011" =>  data <= "11111111";  -- 6D2B = FF
      when "110110100101100" =>  data <= "11111111";  -- 6D2C = FF
      when "110110100101101" =>  data <= "11111111";  -- 6D2D = FF
      when "110110100101110" =>  data <= "11111111";  -- 6D2E = FF
      when "110110100101111" =>  data <= "11111111";  -- 6D2F = FF
      when "110110100110000" =>  data <= "11111111";  -- 6D30 = FF
      when "110110100110001" =>  data <= "11111111";  -- 6D31 = FF
      when "110110100110010" =>  data <= "11111111";  -- 6D32 = FF
      when "110110100110011" =>  data <= "11111111";  -- 6D33 = FF
      when "110110100110100" =>  data <= "11111111";  -- 6D34 = FF
      when "110110100110101" =>  data <= "11111111";  -- 6D35 = FF
      when "110110100110110" =>  data <= "11111111";  -- 6D36 = FF
      when "110110100110111" =>  data <= "11111111";  -- 6D37 = FF
      when "110110100111000" =>  data <= "11111111";  -- 6D38 = FF
      when "110110100111001" =>  data <= "11111111";  -- 6D39 = FF
      when "110110100111010" =>  data <= "11111111";  -- 6D3A = FF
      when "110110100111011" =>  data <= "11111111";  -- 6D3B = FF
      when "110110100111100" =>  data <= "11111111";  -- 6D3C = FF
      when "110110100111101" =>  data <= "11111111";  -- 6D3D = FF
      when "110110100111110" =>  data <= "11111111";  -- 6D3E = FF
      when "110110100111111" =>  data <= "11111111";  -- 6D3F = FF
      when "110110101000000" =>  data <= "11111111";  -- 6D40 = FF
      when "110110101000001" =>  data <= "11111111";  -- 6D41 = FF
      when "110110101000010" =>  data <= "11111111";  -- 6D42 = FF
      when "110110101000011" =>  data <= "11111111";  -- 6D43 = FF
      when "110110101000100" =>  data <= "11111111";  -- 6D44 = FF
      when "110110101000101" =>  data <= "11111111";  -- 6D45 = FF
      when "110110101000110" =>  data <= "11111111";  -- 6D46 = FF
      when "110110101000111" =>  data <= "11111111";  -- 6D47 = FF
      when "110110101001000" =>  data <= "11111111";  -- 6D48 = FF
      when "110110101001001" =>  data <= "11111111";  -- 6D49 = FF
      when "110110101001010" =>  data <= "11111111";  -- 6D4A = FF
      when "110110101001011" =>  data <= "11111111";  -- 6D4B = FF
      when "110110101001100" =>  data <= "11111111";  -- 6D4C = FF
      when "110110101001101" =>  data <= "11111111";  -- 6D4D = FF
      when "110110101001110" =>  data <= "11111111";  -- 6D4E = FF
      when "110110101001111" =>  data <= "11111111";  -- 6D4F = FF
      when "110110101010000" =>  data <= "11111111";  -- 6D50 = FF
      when "110110101010001" =>  data <= "11111111";  -- 6D51 = FF
      when "110110101010010" =>  data <= "11111111";  -- 6D52 = FF
      when "110110101010011" =>  data <= "11111111";  -- 6D53 = FF
      when "110110101010100" =>  data <= "11111111";  -- 6D54 = FF
      when "110110101010101" =>  data <= "11111111";  -- 6D55 = FF
      when "110110101010110" =>  data <= "11111111";  -- 6D56 = FF
      when "110110101010111" =>  data <= "11111111";  -- 6D57 = FF
      when "110110101011000" =>  data <= "11111111";  -- 6D58 = FF
      when "110110101011001" =>  data <= "11111111";  -- 6D59 = FF
      when "110110101011010" =>  data <= "11111111";  -- 6D5A = FF
      when "110110101011011" =>  data <= "11111111";  -- 6D5B = FF
      when "110110101011100" =>  data <= "11111111";  -- 6D5C = FF
      when "110110101011101" =>  data <= "11111111";  -- 6D5D = FF
      when "110110101011110" =>  data <= "11111111";  -- 6D5E = FF
      when "110110101011111" =>  data <= "11111111";  -- 6D5F = FF
      when "110110101100000" =>  data <= "11111111";  -- 6D60 = FF
      when "110110101100001" =>  data <= "11111111";  -- 6D61 = FF
      when "110110101100010" =>  data <= "11111111";  -- 6D62 = FF
      when "110110101100011" =>  data <= "11111111";  -- 6D63 = FF
      when "110110101100100" =>  data <= "11111111";  -- 6D64 = FF
      when "110110101100101" =>  data <= "11111111";  -- 6D65 = FF
      when "110110101100110" =>  data <= "11111111";  -- 6D66 = FF
      when "110110101100111" =>  data <= "11111111";  -- 6D67 = FF
      when "110110101101000" =>  data <= "11111111";  -- 6D68 = FF
      when "110110101101001" =>  data <= "11111111";  -- 6D69 = FF
      when "110110101101010" =>  data <= "11111111";  -- 6D6A = FF
      when "110110101101011" =>  data <= "11111111";  -- 6D6B = FF
      when "110110101101100" =>  data <= "11111111";  -- 6D6C = FF
      when "110110101101101" =>  data <= "11111111";  -- 6D6D = FF
      when "110110101101110" =>  data <= "11111111";  -- 6D6E = FF
      when "110110101101111" =>  data <= "11111111";  -- 6D6F = FF
      when "110110101110000" =>  data <= "11111111";  -- 6D70 = FF
      when "110110101110001" =>  data <= "11111111";  -- 6D71 = FF
      when "110110101110010" =>  data <= "11111111";  -- 6D72 = FF
      when "110110101110011" =>  data <= "11111111";  -- 6D73 = FF
      when "110110101110100" =>  data <= "11111111";  -- 6D74 = FF
      when "110110101110101" =>  data <= "11111111";  -- 6D75 = FF
      when "110110101110110" =>  data <= "11111111";  -- 6D76 = FF
      when "110110101110111" =>  data <= "11111111";  -- 6D77 = FF
      when "110110101111000" =>  data <= "11111111";  -- 6D78 = FF
      when "110110101111001" =>  data <= "11111111";  -- 6D79 = FF
      when "110110101111010" =>  data <= "11111111";  -- 6D7A = FF
      when "110110101111011" =>  data <= "11111111";  -- 6D7B = FF
      when "110110101111100" =>  data <= "11111111";  -- 6D7C = FF
      when "110110101111101" =>  data <= "11111111";  -- 6D7D = FF
      when "110110101111110" =>  data <= "11111111";  -- 6D7E = FF
      when "110110101111111" =>  data <= "11111111";  -- 6D7F = FF
      when "110110110000000" =>  data <= "11111111";  -- 6D80 = FF
      when "110110110000001" =>  data <= "11111111";  -- 6D81 = FF
      when "110110110000010" =>  data <= "11111111";  -- 6D82 = FF
      when "110110110000011" =>  data <= "11111111";  -- 6D83 = FF
      when "110110110000100" =>  data <= "11111111";  -- 6D84 = FF
      when "110110110000101" =>  data <= "11111111";  -- 6D85 = FF
      when "110110110000110" =>  data <= "11111111";  -- 6D86 = FF
      when "110110110000111" =>  data <= "11111111";  -- 6D87 = FF
      when "110110110001000" =>  data <= "11111111";  -- 6D88 = FF
      when "110110110001001" =>  data <= "11111111";  -- 6D89 = FF
      when "110110110001010" =>  data <= "11111111";  -- 6D8A = FF
      when "110110110001011" =>  data <= "11111111";  -- 6D8B = FF
      when "110110110001100" =>  data <= "11111111";  -- 6D8C = FF
      when "110110110001101" =>  data <= "11111111";  -- 6D8D = FF
      when "110110110001110" =>  data <= "11111111";  -- 6D8E = FF
      when "110110110001111" =>  data <= "11111111";  -- 6D8F = FF
      when "110110110010000" =>  data <= "11111111";  -- 6D90 = FF
      when "110110110010001" =>  data <= "11111111";  -- 6D91 = FF
      when "110110110010010" =>  data <= "11111111";  -- 6D92 = FF
      when "110110110010011" =>  data <= "11111111";  -- 6D93 = FF
      when "110110110010100" =>  data <= "11111111";  -- 6D94 = FF
      when "110110110010101" =>  data <= "11111111";  -- 6D95 = FF
      when "110110110010110" =>  data <= "11111111";  -- 6D96 = FF
      when "110110110010111" =>  data <= "11111111";  -- 6D97 = FF
      when "110110110011000" =>  data <= "11111111";  -- 6D98 = FF
      when "110110110011001" =>  data <= "11111111";  -- 6D99 = FF
      when "110110110011010" =>  data <= "11111111";  -- 6D9A = FF
      when "110110110011011" =>  data <= "11111111";  -- 6D9B = FF
      when "110110110011100" =>  data <= "11111111";  -- 6D9C = FF
      when "110110110011101" =>  data <= "11111111";  -- 6D9D = FF
      when "110110110011110" =>  data <= "11111111";  -- 6D9E = FF
      when "110110110011111" =>  data <= "11111111";  -- 6D9F = FF
      when "110110110100000" =>  data <= "11111111";  -- 6DA0 = FF
      when "110110110100001" =>  data <= "11111111";  -- 6DA1 = FF
      when "110110110100010" =>  data <= "11111111";  -- 6DA2 = FF
      when "110110110100011" =>  data <= "11111111";  -- 6DA3 = FF
      when "110110110100100" =>  data <= "11111111";  -- 6DA4 = FF
      when "110110110100101" =>  data <= "11111111";  -- 6DA5 = FF
      when "110110110100110" =>  data <= "11111111";  -- 6DA6 = FF
      when "110110110100111" =>  data <= "11111111";  -- 6DA7 = FF
      when "110110110101000" =>  data <= "11111111";  -- 6DA8 = FF
      when "110110110101001" =>  data <= "11111111";  -- 6DA9 = FF
      when "110110110101010" =>  data <= "11111111";  -- 6DAA = FF
      when "110110110101011" =>  data <= "11111111";  -- 6DAB = FF
      when "110110110101100" =>  data <= "11111111";  -- 6DAC = FF
      when "110110110101101" =>  data <= "11111111";  -- 6DAD = FF
      when "110110110101110" =>  data <= "11111111";  -- 6DAE = FF
      when "110110110101111" =>  data <= "11111111";  -- 6DAF = FF
      when "110110110110000" =>  data <= "11111111";  -- 6DB0 = FF
      when "110110110110001" =>  data <= "11111111";  -- 6DB1 = FF
      when "110110110110010" =>  data <= "11111111";  -- 6DB2 = FF
      when "110110110110011" =>  data <= "11111111";  -- 6DB3 = FF
      when "110110110110100" =>  data <= "11111111";  -- 6DB4 = FF
      when "110110110110101" =>  data <= "11111111";  -- 6DB5 = FF
      when "110110110110110" =>  data <= "11111111";  -- 6DB6 = FF
      when "110110110110111" =>  data <= "11111111";  -- 6DB7 = FF
      when "110110110111000" =>  data <= "11111111";  -- 6DB8 = FF
      when "110110110111001" =>  data <= "11111111";  -- 6DB9 = FF
      when "110110110111010" =>  data <= "11111111";  -- 6DBA = FF
      when "110110110111011" =>  data <= "11111111";  -- 6DBB = FF
      when "110110110111100" =>  data <= "11111111";  -- 6DBC = FF
      when "110110110111101" =>  data <= "11111111";  -- 6DBD = FF
      when "110110110111110" =>  data <= "11111111";  -- 6DBE = FF
      when "110110110111111" =>  data <= "11111111";  -- 6DBF = FF
      when "110110111000000" =>  data <= "11111111";  -- 6DC0 = FF
      when "110110111000001" =>  data <= "11111111";  -- 6DC1 = FF
      when "110110111000010" =>  data <= "11111111";  -- 6DC2 = FF
      when "110110111000011" =>  data <= "11111111";  -- 6DC3 = FF
      when "110110111000100" =>  data <= "11111111";  -- 6DC4 = FF
      when "110110111000101" =>  data <= "11111111";  -- 6DC5 = FF
      when "110110111000110" =>  data <= "11111111";  -- 6DC6 = FF
      when "110110111000111" =>  data <= "11111111";  -- 6DC7 = FF
      when "110110111001000" =>  data <= "11111111";  -- 6DC8 = FF
      when "110110111001001" =>  data <= "11111111";  -- 6DC9 = FF
      when "110110111001010" =>  data <= "11111111";  -- 6DCA = FF
      when "110110111001011" =>  data <= "11111111";  -- 6DCB = FF
      when "110110111001100" =>  data <= "11111111";  -- 6DCC = FF
      when "110110111001101" =>  data <= "11111111";  -- 6DCD = FF
      when "110110111001110" =>  data <= "11111111";  -- 6DCE = FF
      when "110110111001111" =>  data <= "11111111";  -- 6DCF = FF
      when "110110111010000" =>  data <= "11111111";  -- 6DD0 = FF
      when "110110111010001" =>  data <= "11111111";  -- 6DD1 = FF
      when "110110111010010" =>  data <= "11111111";  -- 6DD2 = FF
      when "110110111010011" =>  data <= "11111111";  -- 6DD3 = FF
      when "110110111010100" =>  data <= "11111111";  -- 6DD4 = FF
      when "110110111010101" =>  data <= "11111111";  -- 6DD5 = FF
      when "110110111010110" =>  data <= "11111111";  -- 6DD6 = FF
      when "110110111010111" =>  data <= "11111111";  -- 6DD7 = FF
      when "110110111011000" =>  data <= "11111111";  -- 6DD8 = FF
      when "110110111011001" =>  data <= "11111111";  -- 6DD9 = FF
      when "110110111011010" =>  data <= "11111111";  -- 6DDA = FF
      when "110110111011011" =>  data <= "11111111";  -- 6DDB = FF
      when "110110111011100" =>  data <= "11111111";  -- 6DDC = FF
      when "110110111011101" =>  data <= "11111111";  -- 6DDD = FF
      when "110110111011110" =>  data <= "11111111";  -- 6DDE = FF
      when "110110111011111" =>  data <= "11111111";  -- 6DDF = FF
      when "110110111100000" =>  data <= "11111111";  -- 6DE0 = FF
      when "110110111100001" =>  data <= "11111111";  -- 6DE1 = FF
      when "110110111100010" =>  data <= "11111111";  -- 6DE2 = FF
      when "110110111100011" =>  data <= "11111111";  -- 6DE3 = FF
      when "110110111100100" =>  data <= "11111111";  -- 6DE4 = FF
      when "110110111100101" =>  data <= "11111111";  -- 6DE5 = FF
      when "110110111100110" =>  data <= "11111111";  -- 6DE6 = FF
      when "110110111100111" =>  data <= "11111111";  -- 6DE7 = FF
      when "110110111101000" =>  data <= "11111111";  -- 6DE8 = FF
      when "110110111101001" =>  data <= "11111111";  -- 6DE9 = FF
      when "110110111101010" =>  data <= "11111111";  -- 6DEA = FF
      when "110110111101011" =>  data <= "11111111";  -- 6DEB = FF
      when "110110111101100" =>  data <= "11111111";  -- 6DEC = FF
      when "110110111101101" =>  data <= "11111111";  -- 6DED = FF
      when "110110111101110" =>  data <= "11111111";  -- 6DEE = FF
      when "110110111101111" =>  data <= "11111111";  -- 6DEF = FF
      when "110110111110000" =>  data <= "11111111";  -- 6DF0 = FF
      when "110110111110001" =>  data <= "11111111";  -- 6DF1 = FF
      when "110110111110010" =>  data <= "11111111";  -- 6DF2 = FF
      when "110110111110011" =>  data <= "11111111";  -- 6DF3 = FF
      when "110110111110100" =>  data <= "11111111";  -- 6DF4 = FF
      when "110110111110101" =>  data <= "11111111";  -- 6DF5 = FF
      when "110110111110110" =>  data <= "11111111";  -- 6DF6 = FF
      when "110110111110111" =>  data <= "11111111";  -- 6DF7 = FF
      when "110110111111000" =>  data <= "11111111";  -- 6DF8 = FF
      when "110110111111001" =>  data <= "11111111";  -- 6DF9 = FF
      when "110110111111010" =>  data <= "11111111";  -- 6DFA = FF
      when "110110111111011" =>  data <= "11111111";  -- 6DFB = FF
      when "110110111111100" =>  data <= "11111111";  -- 6DFC = FF
      when "110110111111101" =>  data <= "11111111";  -- 6DFD = FF
      when "110110111111110" =>  data <= "11111111";  -- 6DFE = FF
      when "110110111111111" =>  data <= "11111111";  -- 6DFF = FF
      when "110111000000000" =>  data <= "11111111";  -- 6E00 = FF
      when "110111000000001" =>  data <= "11111111";  -- 6E01 = FF
      when "110111000000010" =>  data <= "11111111";  -- 6E02 = FF
      when "110111000000011" =>  data <= "11111111";  -- 6E03 = FF
      when "110111000000100" =>  data <= "11111111";  -- 6E04 = FF
      when "110111000000101" =>  data <= "11111111";  -- 6E05 = FF
      when "110111000000110" =>  data <= "11111111";  -- 6E06 = FF
      when "110111000000111" =>  data <= "11111111";  -- 6E07 = FF
      when "110111000001000" =>  data <= "11111111";  -- 6E08 = FF
      when "110111000001001" =>  data <= "11111111";  -- 6E09 = FF
      when "110111000001010" =>  data <= "11111111";  -- 6E0A = FF
      when "110111000001011" =>  data <= "11111111";  -- 6E0B = FF
      when "110111000001100" =>  data <= "11111111";  -- 6E0C = FF
      when "110111000001101" =>  data <= "11111111";  -- 6E0D = FF
      when "110111000001110" =>  data <= "11111111";  -- 6E0E = FF
      when "110111000001111" =>  data <= "11111111";  -- 6E0F = FF
      when "110111000010000" =>  data <= "11111111";  -- 6E10 = FF
      when "110111000010001" =>  data <= "11111111";  -- 6E11 = FF
      when "110111000010010" =>  data <= "11111111";  -- 6E12 = FF
      when "110111000010011" =>  data <= "11111111";  -- 6E13 = FF
      when "110111000010100" =>  data <= "11111111";  -- 6E14 = FF
      when "110111000010101" =>  data <= "11111111";  -- 6E15 = FF
      when "110111000010110" =>  data <= "11111111";  -- 6E16 = FF
      when "110111000010111" =>  data <= "11111111";  -- 6E17 = FF
      when "110111000011000" =>  data <= "11111111";  -- 6E18 = FF
      when "110111000011001" =>  data <= "11111111";  -- 6E19 = FF
      when "110111000011010" =>  data <= "11111111";  -- 6E1A = FF
      when "110111000011011" =>  data <= "11111111";  -- 6E1B = FF
      when "110111000011100" =>  data <= "11111111";  -- 6E1C = FF
      when "110111000011101" =>  data <= "11111111";  -- 6E1D = FF
      when "110111000011110" =>  data <= "11111111";  -- 6E1E = FF
      when "110111000011111" =>  data <= "11111111";  -- 6E1F = FF
      when "110111000100000" =>  data <= "11111111";  -- 6E20 = FF
      when "110111000100001" =>  data <= "11111111";  -- 6E21 = FF
      when "110111000100010" =>  data <= "11111111";  -- 6E22 = FF
      when "110111000100011" =>  data <= "11111111";  -- 6E23 = FF
      when "110111000100100" =>  data <= "11111111";  -- 6E24 = FF
      when "110111000100101" =>  data <= "11111111";  -- 6E25 = FF
      when "110111000100110" =>  data <= "11111111";  -- 6E26 = FF
      when "110111000100111" =>  data <= "11111111";  -- 6E27 = FF
      when "110111000101000" =>  data <= "11111111";  -- 6E28 = FF
      when "110111000101001" =>  data <= "11111111";  -- 6E29 = FF
      when "110111000101010" =>  data <= "11111111";  -- 6E2A = FF
      when "110111000101011" =>  data <= "11111111";  -- 6E2B = FF
      when "110111000101100" =>  data <= "11111111";  -- 6E2C = FF
      when "110111000101101" =>  data <= "11111111";  -- 6E2D = FF
      when "110111000101110" =>  data <= "11111111";  -- 6E2E = FF
      when "110111000101111" =>  data <= "11111111";  -- 6E2F = FF
      when "110111000110000" =>  data <= "11111111";  -- 6E30 = FF
      when "110111000110001" =>  data <= "11111111";  -- 6E31 = FF
      when "110111000110010" =>  data <= "11111111";  -- 6E32 = FF
      when "110111000110011" =>  data <= "11111111";  -- 6E33 = FF
      when "110111000110100" =>  data <= "11111111";  -- 6E34 = FF
      when "110111000110101" =>  data <= "11111111";  -- 6E35 = FF
      when "110111000110110" =>  data <= "11111111";  -- 6E36 = FF
      when "110111000110111" =>  data <= "11111111";  -- 6E37 = FF
      when "110111000111000" =>  data <= "11111111";  -- 6E38 = FF
      when "110111000111001" =>  data <= "11111111";  -- 6E39 = FF
      when "110111000111010" =>  data <= "11111111";  -- 6E3A = FF
      when "110111000111011" =>  data <= "11111111";  -- 6E3B = FF
      when "110111000111100" =>  data <= "11111111";  -- 6E3C = FF
      when "110111000111101" =>  data <= "11111111";  -- 6E3D = FF
      when "110111000111110" =>  data <= "11111111";  -- 6E3E = FF
      when "110111000111111" =>  data <= "11111111";  -- 6E3F = FF
      when "110111001000000" =>  data <= "11111111";  -- 6E40 = FF
      when "110111001000001" =>  data <= "11111111";  -- 6E41 = FF
      when "110111001000010" =>  data <= "11111111";  -- 6E42 = FF
      when "110111001000011" =>  data <= "11111111";  -- 6E43 = FF
      when "110111001000100" =>  data <= "11111111";  -- 6E44 = FF
      when "110111001000101" =>  data <= "11111111";  -- 6E45 = FF
      when "110111001000110" =>  data <= "11111111";  -- 6E46 = FF
      when "110111001000111" =>  data <= "11111111";  -- 6E47 = FF
      when "110111001001000" =>  data <= "11111111";  -- 6E48 = FF
      when "110111001001001" =>  data <= "11111111";  -- 6E49 = FF
      when "110111001001010" =>  data <= "11111111";  -- 6E4A = FF
      when "110111001001011" =>  data <= "11111111";  -- 6E4B = FF
      when "110111001001100" =>  data <= "11111111";  -- 6E4C = FF
      when "110111001001101" =>  data <= "11111111";  -- 6E4D = FF
      when "110111001001110" =>  data <= "11111111";  -- 6E4E = FF
      when "110111001001111" =>  data <= "11111111";  -- 6E4F = FF
      when "110111001010000" =>  data <= "11111111";  -- 6E50 = FF
      when "110111001010001" =>  data <= "11111111";  -- 6E51 = FF
      when "110111001010010" =>  data <= "11111111";  -- 6E52 = FF
      when "110111001010011" =>  data <= "11111111";  -- 6E53 = FF
      when "110111001010100" =>  data <= "11111111";  -- 6E54 = FF
      when "110111001010101" =>  data <= "11111111";  -- 6E55 = FF
      when "110111001010110" =>  data <= "11111111";  -- 6E56 = FF
      when "110111001010111" =>  data <= "11111111";  -- 6E57 = FF
      when "110111001011000" =>  data <= "11111111";  -- 6E58 = FF
      when "110111001011001" =>  data <= "11111111";  -- 6E59 = FF
      when "110111001011010" =>  data <= "11111111";  -- 6E5A = FF
      when "110111001011011" =>  data <= "11111111";  -- 6E5B = FF
      when "110111001011100" =>  data <= "11111111";  -- 6E5C = FF
      when "110111001011101" =>  data <= "11111111";  -- 6E5D = FF
      when "110111001011110" =>  data <= "11111111";  -- 6E5E = FF
      when "110111001011111" =>  data <= "11111111";  -- 6E5F = FF
      when "110111001100000" =>  data <= "11111111";  -- 6E60 = FF
      when "110111001100001" =>  data <= "11111111";  -- 6E61 = FF
      when "110111001100010" =>  data <= "11111111";  -- 6E62 = FF
      when "110111001100011" =>  data <= "11111111";  -- 6E63 = FF
      when "110111001100100" =>  data <= "11111111";  -- 6E64 = FF
      when "110111001100101" =>  data <= "11111111";  -- 6E65 = FF
      when "110111001100110" =>  data <= "11111111";  -- 6E66 = FF
      when "110111001100111" =>  data <= "11111111";  -- 6E67 = FF
      when "110111001101000" =>  data <= "11111111";  -- 6E68 = FF
      when "110111001101001" =>  data <= "11111111";  -- 6E69 = FF
      when "110111001101010" =>  data <= "11111111";  -- 6E6A = FF
      when "110111001101011" =>  data <= "11111111";  -- 6E6B = FF
      when "110111001101100" =>  data <= "11111111";  -- 6E6C = FF
      when "110111001101101" =>  data <= "11111111";  -- 6E6D = FF
      when "110111001101110" =>  data <= "11111111";  -- 6E6E = FF
      when "110111001101111" =>  data <= "11111111";  -- 6E6F = FF
      when "110111001110000" =>  data <= "11111111";  -- 6E70 = FF
      when "110111001110001" =>  data <= "11111111";  -- 6E71 = FF
      when "110111001110010" =>  data <= "11111111";  -- 6E72 = FF
      when "110111001110011" =>  data <= "11111111";  -- 6E73 = FF
      when "110111001110100" =>  data <= "11111111";  -- 6E74 = FF
      when "110111001110101" =>  data <= "11111111";  -- 6E75 = FF
      when "110111001110110" =>  data <= "11111111";  -- 6E76 = FF
      when "110111001110111" =>  data <= "11111111";  -- 6E77 = FF
      when "110111001111000" =>  data <= "11111111";  -- 6E78 = FF
      when "110111001111001" =>  data <= "11111111";  -- 6E79 = FF
      when "110111001111010" =>  data <= "11111111";  -- 6E7A = FF
      when "110111001111011" =>  data <= "11111111";  -- 6E7B = FF
      when "110111001111100" =>  data <= "11111111";  -- 6E7C = FF
      when "110111001111101" =>  data <= "11111111";  -- 6E7D = FF
      when "110111001111110" =>  data <= "11111111";  -- 6E7E = FF
      when "110111001111111" =>  data <= "11111111";  -- 6E7F = FF
      when "110111010000000" =>  data <= "11111111";  -- 6E80 = FF
      when "110111010000001" =>  data <= "11111111";  -- 6E81 = FF
      when "110111010000010" =>  data <= "11111111";  -- 6E82 = FF
      when "110111010000011" =>  data <= "11111111";  -- 6E83 = FF
      when "110111010000100" =>  data <= "11111111";  -- 6E84 = FF
      when "110111010000101" =>  data <= "11111111";  -- 6E85 = FF
      when "110111010000110" =>  data <= "11111111";  -- 6E86 = FF
      when "110111010000111" =>  data <= "11111111";  -- 6E87 = FF
      when "110111010001000" =>  data <= "11111111";  -- 6E88 = FF
      when "110111010001001" =>  data <= "11111111";  -- 6E89 = FF
      when "110111010001010" =>  data <= "11111111";  -- 6E8A = FF
      when "110111010001011" =>  data <= "11111111";  -- 6E8B = FF
      when "110111010001100" =>  data <= "11111111";  -- 6E8C = FF
      when "110111010001101" =>  data <= "11111111";  -- 6E8D = FF
      when "110111010001110" =>  data <= "11111111";  -- 6E8E = FF
      when "110111010001111" =>  data <= "11111111";  -- 6E8F = FF
      when "110111010010000" =>  data <= "11111111";  -- 6E90 = FF
      when "110111010010001" =>  data <= "11111111";  -- 6E91 = FF
      when "110111010010010" =>  data <= "11111111";  -- 6E92 = FF
      when "110111010010011" =>  data <= "11111111";  -- 6E93 = FF
      when "110111010010100" =>  data <= "11111111";  -- 6E94 = FF
      when "110111010010101" =>  data <= "11111111";  -- 6E95 = FF
      when "110111010010110" =>  data <= "11111111";  -- 6E96 = FF
      when "110111010010111" =>  data <= "11111111";  -- 6E97 = FF
      when "110111010011000" =>  data <= "11111111";  -- 6E98 = FF
      when "110111010011001" =>  data <= "11111111";  -- 6E99 = FF
      when "110111010011010" =>  data <= "11111111";  -- 6E9A = FF
      when "110111010011011" =>  data <= "11111111";  -- 6E9B = FF
      when "110111010011100" =>  data <= "11111111";  -- 6E9C = FF
      when "110111010011101" =>  data <= "11111111";  -- 6E9D = FF
      when "110111010011110" =>  data <= "11111111";  -- 6E9E = FF
      when "110111010011111" =>  data <= "11111111";  -- 6E9F = FF
      when "110111010100000" =>  data <= "11111111";  -- 6EA0 = FF
      when "110111010100001" =>  data <= "11111111";  -- 6EA1 = FF
      when "110111010100010" =>  data <= "11111111";  -- 6EA2 = FF
      when "110111010100011" =>  data <= "11111111";  -- 6EA3 = FF
      when "110111010100100" =>  data <= "11111111";  -- 6EA4 = FF
      when "110111010100101" =>  data <= "11111111";  -- 6EA5 = FF
      when "110111010100110" =>  data <= "11111111";  -- 6EA6 = FF
      when "110111010100111" =>  data <= "11111111";  -- 6EA7 = FF
      when "110111010101000" =>  data <= "11111111";  -- 6EA8 = FF
      when "110111010101001" =>  data <= "11111111";  -- 6EA9 = FF
      when "110111010101010" =>  data <= "11111111";  -- 6EAA = FF
      when "110111010101011" =>  data <= "11111111";  -- 6EAB = FF
      when "110111010101100" =>  data <= "11111111";  -- 6EAC = FF
      when "110111010101101" =>  data <= "11111111";  -- 6EAD = FF
      when "110111010101110" =>  data <= "11111111";  -- 6EAE = FF
      when "110111010101111" =>  data <= "11111111";  -- 6EAF = FF
      when "110111010110000" =>  data <= "11111111";  -- 6EB0 = FF
      when "110111010110001" =>  data <= "11111111";  -- 6EB1 = FF
      when "110111010110010" =>  data <= "11111111";  -- 6EB2 = FF
      when "110111010110011" =>  data <= "11111111";  -- 6EB3 = FF
      when "110111010110100" =>  data <= "11111111";  -- 6EB4 = FF
      when "110111010110101" =>  data <= "11111111";  -- 6EB5 = FF
      when "110111010110110" =>  data <= "11111111";  -- 6EB6 = FF
      when "110111010110111" =>  data <= "11111111";  -- 6EB7 = FF
      when "110111010111000" =>  data <= "11111111";  -- 6EB8 = FF
      when "110111010111001" =>  data <= "11111111";  -- 6EB9 = FF
      when "110111010111010" =>  data <= "11111111";  -- 6EBA = FF
      when "110111010111011" =>  data <= "11111111";  -- 6EBB = FF
      when "110111010111100" =>  data <= "11111111";  -- 6EBC = FF
      when "110111010111101" =>  data <= "11111111";  -- 6EBD = FF
      when "110111010111110" =>  data <= "11111111";  -- 6EBE = FF
      when "110111010111111" =>  data <= "11111111";  -- 6EBF = FF
      when "110111011000000" =>  data <= "11111111";  -- 6EC0 = FF
      when "110111011000001" =>  data <= "11111111";  -- 6EC1 = FF
      when "110111011000010" =>  data <= "11111111";  -- 6EC2 = FF
      when "110111011000011" =>  data <= "11111111";  -- 6EC3 = FF
      when "110111011000100" =>  data <= "11111111";  -- 6EC4 = FF
      when "110111011000101" =>  data <= "11111111";  -- 6EC5 = FF
      when "110111011000110" =>  data <= "11111111";  -- 6EC6 = FF
      when "110111011000111" =>  data <= "11111111";  -- 6EC7 = FF
      when "110111011001000" =>  data <= "11111111";  -- 6EC8 = FF
      when "110111011001001" =>  data <= "11111111";  -- 6EC9 = FF
      when "110111011001010" =>  data <= "11111111";  -- 6ECA = FF
      when "110111011001011" =>  data <= "11111111";  -- 6ECB = FF
      when "110111011001100" =>  data <= "11111111";  -- 6ECC = FF
      when "110111011001101" =>  data <= "11111111";  -- 6ECD = FF
      when "110111011001110" =>  data <= "11111111";  -- 6ECE = FF
      when "110111011001111" =>  data <= "11111111";  -- 6ECF = FF
      when "110111011010000" =>  data <= "11111111";  -- 6ED0 = FF
      when "110111011010001" =>  data <= "11111111";  -- 6ED1 = FF
      when "110111011010010" =>  data <= "11111111";  -- 6ED2 = FF
      when "110111011010011" =>  data <= "11111111";  -- 6ED3 = FF
      when "110111011010100" =>  data <= "11111111";  -- 6ED4 = FF
      when "110111011010101" =>  data <= "11111111";  -- 6ED5 = FF
      when "110111011010110" =>  data <= "11111111";  -- 6ED6 = FF
      when "110111011010111" =>  data <= "11111111";  -- 6ED7 = FF
      when "110111011011000" =>  data <= "11111111";  -- 6ED8 = FF
      when "110111011011001" =>  data <= "11111111";  -- 6ED9 = FF
      when "110111011011010" =>  data <= "11111111";  -- 6EDA = FF
      when "110111011011011" =>  data <= "11111111";  -- 6EDB = FF
      when "110111011011100" =>  data <= "11111111";  -- 6EDC = FF
      when "110111011011101" =>  data <= "11111111";  -- 6EDD = FF
      when "110111011011110" =>  data <= "11111111";  -- 6EDE = FF
      when "110111011011111" =>  data <= "11111111";  -- 6EDF = FF
      when "110111011100000" =>  data <= "11111111";  -- 6EE0 = FF
      when "110111011100001" =>  data <= "11111111";  -- 6EE1 = FF
      when "110111011100010" =>  data <= "11111111";  -- 6EE2 = FF
      when "110111011100011" =>  data <= "11111111";  -- 6EE3 = FF
      when "110111011100100" =>  data <= "11111111";  -- 6EE4 = FF
      when "110111011100101" =>  data <= "11111111";  -- 6EE5 = FF
      when "110111011100110" =>  data <= "11111111";  -- 6EE6 = FF
      when "110111011100111" =>  data <= "11111111";  -- 6EE7 = FF
      when "110111011101000" =>  data <= "11111111";  -- 6EE8 = FF
      when "110111011101001" =>  data <= "11111111";  -- 6EE9 = FF
      when "110111011101010" =>  data <= "11111111";  -- 6EEA = FF
      when "110111011101011" =>  data <= "11111111";  -- 6EEB = FF
      when "110111011101100" =>  data <= "11111111";  -- 6EEC = FF
      when "110111011101101" =>  data <= "11111111";  -- 6EED = FF
      when "110111011101110" =>  data <= "11111111";  -- 6EEE = FF
      when "110111011101111" =>  data <= "11111111";  -- 6EEF = FF
      when "110111011110000" =>  data <= "11111111";  -- 6EF0 = FF
      when "110111011110001" =>  data <= "11111111";  -- 6EF1 = FF
      when "110111011110010" =>  data <= "11111111";  -- 6EF2 = FF
      when "110111011110011" =>  data <= "11111111";  -- 6EF3 = FF
      when "110111011110100" =>  data <= "11111111";  -- 6EF4 = FF
      when "110111011110101" =>  data <= "11111111";  -- 6EF5 = FF
      when "110111011110110" =>  data <= "11111111";  -- 6EF6 = FF
      when "110111011110111" =>  data <= "11111111";  -- 6EF7 = FF
      when "110111011111000" =>  data <= "11111111";  -- 6EF8 = FF
      when "110111011111001" =>  data <= "11111111";  -- 6EF9 = FF
      when "110111011111010" =>  data <= "11111111";  -- 6EFA = FF
      when "110111011111011" =>  data <= "11111111";  -- 6EFB = FF
      when "110111011111100" =>  data <= "11111111";  -- 6EFC = FF
      when "110111011111101" =>  data <= "11111111";  -- 6EFD = FF
      when "110111011111110" =>  data <= "11111111";  -- 6EFE = FF
      when "110111011111111" =>  data <= "11111111";  -- 6EFF = FF
      when "110111100000000" =>  data <= "11111111";  -- 6F00 = FF
      when "110111100000001" =>  data <= "11111111";  -- 6F01 = FF
      when "110111100000010" =>  data <= "11111111";  -- 6F02 = FF
      when "110111100000011" =>  data <= "11111111";  -- 6F03 = FF
      when "110111100000100" =>  data <= "11111111";  -- 6F04 = FF
      when "110111100000101" =>  data <= "11111111";  -- 6F05 = FF
      when "110111100000110" =>  data <= "11111111";  -- 6F06 = FF
      when "110111100000111" =>  data <= "11111111";  -- 6F07 = FF
      when "110111100001000" =>  data <= "11111111";  -- 6F08 = FF
      when "110111100001001" =>  data <= "11111111";  -- 6F09 = FF
      when "110111100001010" =>  data <= "11111111";  -- 6F0A = FF
      when "110111100001011" =>  data <= "11111111";  -- 6F0B = FF
      when "110111100001100" =>  data <= "11111111";  -- 6F0C = FF
      when "110111100001101" =>  data <= "11111111";  -- 6F0D = FF
      when "110111100001110" =>  data <= "11111111";  -- 6F0E = FF
      when "110111100001111" =>  data <= "11111111";  -- 6F0F = FF
      when "110111100010000" =>  data <= "11111111";  -- 6F10 = FF
      when "110111100010001" =>  data <= "11111111";  -- 6F11 = FF
      when "110111100010010" =>  data <= "11111111";  -- 6F12 = FF
      when "110111100010011" =>  data <= "11111111";  -- 6F13 = FF
      when "110111100010100" =>  data <= "11111111";  -- 6F14 = FF
      when "110111100010101" =>  data <= "11111111";  -- 6F15 = FF
      when "110111100010110" =>  data <= "11111111";  -- 6F16 = FF
      when "110111100010111" =>  data <= "11111111";  -- 6F17 = FF
      when "110111100011000" =>  data <= "11111111";  -- 6F18 = FF
      when "110111100011001" =>  data <= "11111111";  -- 6F19 = FF
      when "110111100011010" =>  data <= "11111111";  -- 6F1A = FF
      when "110111100011011" =>  data <= "11111111";  -- 6F1B = FF
      when "110111100011100" =>  data <= "11111111";  -- 6F1C = FF
      when "110111100011101" =>  data <= "11111111";  -- 6F1D = FF
      when "110111100011110" =>  data <= "11111111";  -- 6F1E = FF
      when "110111100011111" =>  data <= "11111111";  -- 6F1F = FF
      when "110111100100000" =>  data <= "11111111";  -- 6F20 = FF
      when "110111100100001" =>  data <= "11111111";  -- 6F21 = FF
      when "110111100100010" =>  data <= "11111111";  -- 6F22 = FF
      when "110111100100011" =>  data <= "11111111";  -- 6F23 = FF
      when "110111100100100" =>  data <= "11111111";  -- 6F24 = FF
      when "110111100100101" =>  data <= "11111111";  -- 6F25 = FF
      when "110111100100110" =>  data <= "11111111";  -- 6F26 = FF
      when "110111100100111" =>  data <= "11111111";  -- 6F27 = FF
      when "110111100101000" =>  data <= "11111111";  -- 6F28 = FF
      when "110111100101001" =>  data <= "11111111";  -- 6F29 = FF
      when "110111100101010" =>  data <= "11111111";  -- 6F2A = FF
      when "110111100101011" =>  data <= "11111111";  -- 6F2B = FF
      when "110111100101100" =>  data <= "11111111";  -- 6F2C = FF
      when "110111100101101" =>  data <= "11111111";  -- 6F2D = FF
      when "110111100101110" =>  data <= "11111111";  -- 6F2E = FF
      when "110111100101111" =>  data <= "11111111";  -- 6F2F = FF
      when "110111100110000" =>  data <= "11111111";  -- 6F30 = FF
      when "110111100110001" =>  data <= "11111111";  -- 6F31 = FF
      when "110111100110010" =>  data <= "11111111";  -- 6F32 = FF
      when "110111100110011" =>  data <= "11111111";  -- 6F33 = FF
      when "110111100110100" =>  data <= "11111111";  -- 6F34 = FF
      when "110111100110101" =>  data <= "11111111";  -- 6F35 = FF
      when "110111100110110" =>  data <= "11111111";  -- 6F36 = FF
      when "110111100110111" =>  data <= "11111111";  -- 6F37 = FF
      when "110111100111000" =>  data <= "11111111";  -- 6F38 = FF
      when "110111100111001" =>  data <= "11111111";  -- 6F39 = FF
      when "110111100111010" =>  data <= "11111111";  -- 6F3A = FF
      when "110111100111011" =>  data <= "11111111";  -- 6F3B = FF
      when "110111100111100" =>  data <= "11111111";  -- 6F3C = FF
      when "110111100111101" =>  data <= "11111111";  -- 6F3D = FF
      when "110111100111110" =>  data <= "11111111";  -- 6F3E = FF
      when "110111100111111" =>  data <= "11111111";  -- 6F3F = FF
      when "110111101000000" =>  data <= "11111111";  -- 6F40 = FF
      when "110111101000001" =>  data <= "11111111";  -- 6F41 = FF
      when "110111101000010" =>  data <= "11111111";  -- 6F42 = FF
      when "110111101000011" =>  data <= "11111111";  -- 6F43 = FF
      when "110111101000100" =>  data <= "11111111";  -- 6F44 = FF
      when "110111101000101" =>  data <= "11111111";  -- 6F45 = FF
      when "110111101000110" =>  data <= "11111111";  -- 6F46 = FF
      when "110111101000111" =>  data <= "11111111";  -- 6F47 = FF
      when "110111101001000" =>  data <= "11111111";  -- 6F48 = FF
      when "110111101001001" =>  data <= "11111111";  -- 6F49 = FF
      when "110111101001010" =>  data <= "11111111";  -- 6F4A = FF
      when "110111101001011" =>  data <= "11111111";  -- 6F4B = FF
      when "110111101001100" =>  data <= "11111111";  -- 6F4C = FF
      when "110111101001101" =>  data <= "11111111";  -- 6F4D = FF
      when "110111101001110" =>  data <= "11111111";  -- 6F4E = FF
      when "110111101001111" =>  data <= "11111111";  -- 6F4F = FF
      when "110111101010000" =>  data <= "11111111";  -- 6F50 = FF
      when "110111101010001" =>  data <= "11111111";  -- 6F51 = FF
      when "110111101010010" =>  data <= "11111111";  -- 6F52 = FF
      when "110111101010011" =>  data <= "11111111";  -- 6F53 = FF
      when "110111101010100" =>  data <= "11111111";  -- 6F54 = FF
      when "110111101010101" =>  data <= "11111111";  -- 6F55 = FF
      when "110111101010110" =>  data <= "11111111";  -- 6F56 = FF
      when "110111101010111" =>  data <= "11111111";  -- 6F57 = FF
      when "110111101011000" =>  data <= "11111111";  -- 6F58 = FF
      when "110111101011001" =>  data <= "11111111";  -- 6F59 = FF
      when "110111101011010" =>  data <= "11111111";  -- 6F5A = FF
      when "110111101011011" =>  data <= "11111111";  -- 6F5B = FF
      when "110111101011100" =>  data <= "11111111";  -- 6F5C = FF
      when "110111101011101" =>  data <= "11111111";  -- 6F5D = FF
      when "110111101011110" =>  data <= "11111111";  -- 6F5E = FF
      when "110111101011111" =>  data <= "11111111";  -- 6F5F = FF
      when "110111101100000" =>  data <= "11111111";  -- 6F60 = FF
      when "110111101100001" =>  data <= "11111111";  -- 6F61 = FF
      when "110111101100010" =>  data <= "11111111";  -- 6F62 = FF
      when "110111101100011" =>  data <= "11111111";  -- 6F63 = FF
      when "110111101100100" =>  data <= "11111111";  -- 6F64 = FF
      when "110111101100101" =>  data <= "11111111";  -- 6F65 = FF
      when "110111101100110" =>  data <= "11111111";  -- 6F66 = FF
      when "110111101100111" =>  data <= "11111111";  -- 6F67 = FF
      when "110111101101000" =>  data <= "11111111";  -- 6F68 = FF
      when "110111101101001" =>  data <= "11111111";  -- 6F69 = FF
      when "110111101101010" =>  data <= "11111111";  -- 6F6A = FF
      when "110111101101011" =>  data <= "11111111";  -- 6F6B = FF
      when "110111101101100" =>  data <= "11111111";  -- 6F6C = FF
      when "110111101101101" =>  data <= "11111111";  -- 6F6D = FF
      when "110111101101110" =>  data <= "11111111";  -- 6F6E = FF
      when "110111101101111" =>  data <= "11111111";  -- 6F6F = FF
      when "110111101110000" =>  data <= "11111111";  -- 6F70 = FF
      when "110111101110001" =>  data <= "11111111";  -- 6F71 = FF
      when "110111101110010" =>  data <= "11111111";  -- 6F72 = FF
      when "110111101110011" =>  data <= "11111111";  -- 6F73 = FF
      when "110111101110100" =>  data <= "11111111";  -- 6F74 = FF
      when "110111101110101" =>  data <= "11111111";  -- 6F75 = FF
      when "110111101110110" =>  data <= "11111111";  -- 6F76 = FF
      when "110111101110111" =>  data <= "11111111";  -- 6F77 = FF
      when "110111101111000" =>  data <= "11111111";  -- 6F78 = FF
      when "110111101111001" =>  data <= "11111111";  -- 6F79 = FF
      when "110111101111010" =>  data <= "11111111";  -- 6F7A = FF
      when "110111101111011" =>  data <= "11111111";  -- 6F7B = FF
      when "110111101111100" =>  data <= "11111111";  -- 6F7C = FF
      when "110111101111101" =>  data <= "11111111";  -- 6F7D = FF
      when "110111101111110" =>  data <= "11111111";  -- 6F7E = FF
      when "110111101111111" =>  data <= "11111111";  -- 6F7F = FF
      when "110111110000000" =>  data <= "11111111";  -- 6F80 = FF
      when "110111110000001" =>  data <= "11111111";  -- 6F81 = FF
      when "110111110000010" =>  data <= "11111111";  -- 6F82 = FF
      when "110111110000011" =>  data <= "11111111";  -- 6F83 = FF
      when "110111110000100" =>  data <= "11111111";  -- 6F84 = FF
      when "110111110000101" =>  data <= "11111111";  -- 6F85 = FF
      when "110111110000110" =>  data <= "11111111";  -- 6F86 = FF
      when "110111110000111" =>  data <= "11111111";  -- 6F87 = FF
      when "110111110001000" =>  data <= "11111111";  -- 6F88 = FF
      when "110111110001001" =>  data <= "11111111";  -- 6F89 = FF
      when "110111110001010" =>  data <= "11111111";  -- 6F8A = FF
      when "110111110001011" =>  data <= "11111111";  -- 6F8B = FF
      when "110111110001100" =>  data <= "11111111";  -- 6F8C = FF
      when "110111110001101" =>  data <= "11111111";  -- 6F8D = FF
      when "110111110001110" =>  data <= "11111111";  -- 6F8E = FF
      when "110111110001111" =>  data <= "11111111";  -- 6F8F = FF
      when "110111110010000" =>  data <= "11111111";  -- 6F90 = FF
      when "110111110010001" =>  data <= "11111111";  -- 6F91 = FF
      when "110111110010010" =>  data <= "11111111";  -- 6F92 = FF
      when "110111110010011" =>  data <= "11111111";  -- 6F93 = FF
      when "110111110010100" =>  data <= "11111111";  -- 6F94 = FF
      when "110111110010101" =>  data <= "11111111";  -- 6F95 = FF
      when "110111110010110" =>  data <= "11111111";  -- 6F96 = FF
      when "110111110010111" =>  data <= "11111111";  -- 6F97 = FF
      when "110111110011000" =>  data <= "11111111";  -- 6F98 = FF
      when "110111110011001" =>  data <= "11111111";  -- 6F99 = FF
      when "110111110011010" =>  data <= "11111111";  -- 6F9A = FF
      when "110111110011011" =>  data <= "11111111";  -- 6F9B = FF
      when "110111110011100" =>  data <= "11111111";  -- 6F9C = FF
      when "110111110011101" =>  data <= "11111111";  -- 6F9D = FF
      when "110111110011110" =>  data <= "11111111";  -- 6F9E = FF
      when "110111110011111" =>  data <= "11111111";  -- 6F9F = FF
      when "110111110100000" =>  data <= "11111111";  -- 6FA0 = FF
      when "110111110100001" =>  data <= "11111111";  -- 6FA1 = FF
      when "110111110100010" =>  data <= "11111111";  -- 6FA2 = FF
      when "110111110100011" =>  data <= "11111111";  -- 6FA3 = FF
      when "110111110100100" =>  data <= "11111111";  -- 6FA4 = FF
      when "110111110100101" =>  data <= "11111111";  -- 6FA5 = FF
      when "110111110100110" =>  data <= "11111111";  -- 6FA6 = FF
      when "110111110100111" =>  data <= "11111111";  -- 6FA7 = FF
      when "110111110101000" =>  data <= "11111111";  -- 6FA8 = FF
      when "110111110101001" =>  data <= "11111111";  -- 6FA9 = FF
      when "110111110101010" =>  data <= "11111111";  -- 6FAA = FF
      when "110111110101011" =>  data <= "11111111";  -- 6FAB = FF
      when "110111110101100" =>  data <= "11111111";  -- 6FAC = FF
      when "110111110101101" =>  data <= "11111111";  -- 6FAD = FF
      when "110111110101110" =>  data <= "11111111";  -- 6FAE = FF
      when "110111110101111" =>  data <= "11111111";  -- 6FAF = FF
      when "110111110110000" =>  data <= "11111111";  -- 6FB0 = FF
      when "110111110110001" =>  data <= "11111111";  -- 6FB1 = FF
      when "110111110110010" =>  data <= "11111111";  -- 6FB2 = FF
      when "110111110110011" =>  data <= "11111111";  -- 6FB3 = FF
      when "110111110110100" =>  data <= "11111111";  -- 6FB4 = FF
      when "110111110110101" =>  data <= "11111111";  -- 6FB5 = FF
      when "110111110110110" =>  data <= "11111111";  -- 6FB6 = FF
      when "110111110110111" =>  data <= "11111111";  -- 6FB7 = FF
      when "110111110111000" =>  data <= "11111111";  -- 6FB8 = FF
      when "110111110111001" =>  data <= "11111111";  -- 6FB9 = FF
      when "110111110111010" =>  data <= "11111111";  -- 6FBA = FF
      when "110111110111011" =>  data <= "11111111";  -- 6FBB = FF
      when "110111110111100" =>  data <= "11111111";  -- 6FBC = FF
      when "110111110111101" =>  data <= "11111111";  -- 6FBD = FF
      when "110111110111110" =>  data <= "11111111";  -- 6FBE = FF
      when "110111110111111" =>  data <= "11111111";  -- 6FBF = FF
      when "110111111000000" =>  data <= "11111111";  -- 6FC0 = FF
      when "110111111000001" =>  data <= "11111111";  -- 6FC1 = FF
      when "110111111000010" =>  data <= "11111111";  -- 6FC2 = FF
      when "110111111000011" =>  data <= "11111111";  -- 6FC3 = FF
      when "110111111000100" =>  data <= "11111111";  -- 6FC4 = FF
      when "110111111000101" =>  data <= "11111111";  -- 6FC5 = FF
      when "110111111000110" =>  data <= "11111111";  -- 6FC6 = FF
      when "110111111000111" =>  data <= "11111111";  -- 6FC7 = FF
      when "110111111001000" =>  data <= "11111111";  -- 6FC8 = FF
      when "110111111001001" =>  data <= "11111111";  -- 6FC9 = FF
      when "110111111001010" =>  data <= "11111111";  -- 6FCA = FF
      when "110111111001011" =>  data <= "11111111";  -- 6FCB = FF
      when "110111111001100" =>  data <= "11111111";  -- 6FCC = FF
      when "110111111001101" =>  data <= "11111111";  -- 6FCD = FF
      when "110111111001110" =>  data <= "11111111";  -- 6FCE = FF
      when "110111111001111" =>  data <= "11111111";  -- 6FCF = FF
      when "110111111010000" =>  data <= "11111111";  -- 6FD0 = FF
      when "110111111010001" =>  data <= "11111111";  -- 6FD1 = FF
      when "110111111010010" =>  data <= "11111111";  -- 6FD2 = FF
      when "110111111010011" =>  data <= "11111111";  -- 6FD3 = FF
      when "110111111010100" =>  data <= "11111111";  -- 6FD4 = FF
      when "110111111010101" =>  data <= "11111111";  -- 6FD5 = FF
      when "110111111010110" =>  data <= "11111111";  -- 6FD6 = FF
      when "110111111010111" =>  data <= "11111111";  -- 6FD7 = FF
      when "110111111011000" =>  data <= "11111111";  -- 6FD8 = FF
      when "110111111011001" =>  data <= "11111111";  -- 6FD9 = FF
      when "110111111011010" =>  data <= "11111111";  -- 6FDA = FF
      when "110111111011011" =>  data <= "11111111";  -- 6FDB = FF
      when "110111111011100" =>  data <= "11111111";  -- 6FDC = FF
      when "110111111011101" =>  data <= "11111111";  -- 6FDD = FF
      when "110111111011110" =>  data <= "11111111";  -- 6FDE = FF
      when "110111111011111" =>  data <= "11111111";  -- 6FDF = FF
      when "110111111100000" =>  data <= "11111111";  -- 6FE0 = FF
      when "110111111100001" =>  data <= "11111111";  -- 6FE1 = FF
      when "110111111100010" =>  data <= "11111111";  -- 6FE2 = FF
      when "110111111100011" =>  data <= "11111111";  -- 6FE3 = FF
      when "110111111100100" =>  data <= "11111111";  -- 6FE4 = FF
      when "110111111100101" =>  data <= "11111111";  -- 6FE5 = FF
      when "110111111100110" =>  data <= "11111111";  -- 6FE6 = FF
      when "110111111100111" =>  data <= "11111111";  -- 6FE7 = FF
      when "110111111101000" =>  data <= "11111111";  -- 6FE8 = FF
      when "110111111101001" =>  data <= "11111111";  -- 6FE9 = FF
      when "110111111101010" =>  data <= "11111111";  -- 6FEA = FF
      when "110111111101011" =>  data <= "11111111";  -- 6FEB = FF
      when "110111111101100" =>  data <= "11111111";  -- 6FEC = FF
      when "110111111101101" =>  data <= "11111111";  -- 6FED = FF
      when "110111111101110" =>  data <= "11111111";  -- 6FEE = FF
      when "110111111101111" =>  data <= "11111111";  -- 6FEF = FF
      when "110111111110000" =>  data <= "11111111";  -- 6FF0 = FF
      when "110111111110001" =>  data <= "11111111";  -- 6FF1 = FF
      when "110111111110010" =>  data <= "11111111";  -- 6FF2 = FF
      when "110111111110011" =>  data <= "11111111";  -- 6FF3 = FF
      when "110111111110100" =>  data <= "11111111";  -- 6FF4 = FF
      when "110111111110101" =>  data <= "11111111";  -- 6FF5 = FF
      when "110111111110110" =>  data <= "11111111";  -- 6FF6 = FF
      when "110111111110111" =>  data <= "11111111";  -- 6FF7 = FF
      when "110111111111000" =>  data <= "11111111";  -- 6FF8 = FF
      when "110111111111001" =>  data <= "11111111";  -- 6FF9 = FF
      when "110111111111010" =>  data <= "11111111";  -- 6FFA = FF
      when "110111111111011" =>  data <= "11111111";  -- 6FFB = FF
      when "110111111111100" =>  data <= "11111111";  -- 6FFC = FF
      when "110111111111101" =>  data <= "11111111";  -- 6FFD = FF
      when "110111111111110" =>  data <= "11111111";  -- 6FFE = FF
      when "110111111111111" =>  data <= "11111111";  -- 6FFF = FF
      when "111000000000000" =>  data <= "01010100";  -- 7000 = 54
      when "111000000000001" =>  data <= "01001111";  -- 7001 = 4F
      when "111000000000010" =>  data <= "01001111";  -- 7002 = 4F
      when "111000000000011" =>  data <= "00100000";  -- 7003 = 20
      when "111000000000100" =>  data <= "01001101";  -- 7004 = 4D
      when "111000000000101" =>  data <= "01000001";  -- 7005 = 41
      when "111000000000110" =>  data <= "01001110";  -- 7006 = 4E
      when "111000000000111" =>  data <= "01011001";  -- 7007 = 59
      when "111000000001000" =>  data <= "00100000";  -- 7008 = 20
      when "111000000001001" =>  data <= "01000110";  -- 7009 = 46
      when "111000000001010" =>  data <= "01001001";  -- 700A = 49
      when "111000000001011" =>  data <= "01001100";  -- 700B = 4C
      when "111000000001100" =>  data <= "01000101";  -- 700C = 45
      when "111000000001101" =>  data <= "11010011";  -- 700D = D3
      when "111000000001110" =>  data <= "01000110";  -- 700E = 46
      when "111000000001111" =>  data <= "01001001";  -- 700F = 49
      when "111000000010000" =>  data <= "01001100";  -- 7010 = 4C
      when "111000000010001" =>  data <= "01000101";  -- 7011 = 45
      when "111000000010010" =>  data <= "00100000";  -- 7012 = 20
      when "111000000010011" =>  data <= "01001111";  -- 7013 = 4F
      when "111000000010100" =>  data <= "01010000";  -- 7014 = 50
      when "111000000010101" =>  data <= "01000101";  -- 7015 = 45
      when "111000000010110" =>  data <= "11001110";  -- 7016 = CE
      when "111000000010111" =>  data <= "01000110";  -- 7017 = 46
      when "111000000011000" =>  data <= "01001001";  -- 7018 = 49
      when "111000000011001" =>  data <= "01001100";  -- 7019 = 4C
      when "111000000011010" =>  data <= "01000101";  -- 701A = 45
      when "111000000011011" =>  data <= "00100000";  -- 701B = 20
      when "111000000011100" =>  data <= "01001110";  -- 701C = 4E
      when "111000000011101" =>  data <= "01001111";  -- 701D = 4F
      when "111000000011110" =>  data <= "01010100";  -- 701E = 54
      when "111000000011111" =>  data <= "00100000";  -- 701F = 20
      when "111000000100000" =>  data <= "01001111";  -- 7020 = 4F
      when "111000000100001" =>  data <= "01010000";  -- 7021 = 50
      when "111000000100010" =>  data <= "01000101";  -- 7022 = 45
      when "111000000100011" =>  data <= "11001110";  -- 7023 = CE
      when "111000000100100" =>  data <= "01000110";  -- 7024 = 46
      when "111000000100101" =>  data <= "01001001";  -- 7025 = 49
      when "111000000100110" =>  data <= "01001100";  -- 7026 = 4C
      when "111000000100111" =>  data <= "01000101";  -- 7027 = 45
      when "111000000101000" =>  data <= "00100000";  -- 7028 = 20
      when "111000000101001" =>  data <= "01001110";  -- 7029 = 4E
      when "111000000101010" =>  data <= "01001111";  -- 702A = 4F
      when "111000000101011" =>  data <= "01010100";  -- 702B = 54
      when "111000000101100" =>  data <= "00100000";  -- 702C = 20
      when "111000000101101" =>  data <= "01000110";  -- 702D = 46
      when "111000000101110" =>  data <= "01001111";  -- 702E = 4F
      when "111000000101111" =>  data <= "01010101";  -- 702F = 55
      when "111000000110000" =>  data <= "01001110";  -- 7030 = 4E
      when "111000000110001" =>  data <= "11000100";  -- 7031 = C4
      when "111000000110010" =>  data <= "00001101";  -- 7032 = D
      when "111000000110011" =>  data <= "01010011";  -- 7033 = 53
      when "111000000110100" =>  data <= "01000101";  -- 7034 = 45
      when "111000000110101" =>  data <= "01000001";  -- 7035 = 41
      when "111000000110110" =>  data <= "01010010";  -- 7036 = 52
      when "111000000110111" =>  data <= "01000011";  -- 7037 = 43
      when "111000000111000" =>  data <= "01001000";  -- 7038 = 48
      when "111000000111001" =>  data <= "01001001";  -- 7039 = 49
      when "111000000111010" =>  data <= "01001110";  -- 703A = 4E
      when "111000000111011" =>  data <= "01000111";  -- 703B = 47
      when "111000000111100" =>  data <= "10100000";  -- 703C = A0
      when "111000000111101" =>  data <= "01000110";  -- 703D = 46
      when "111000000111110" =>  data <= "01001111";  -- 703E = 4F
      when "111000000111111" =>  data <= "01010010";  -- 703F = 52
      when "111000001000000" =>  data <= "10100000";  -- 7040 = A0
      when "111000001000001" =>  data <= "00001101";  -- 7041 = D
      when "111000001000010" =>  data <= "01010000";  -- 7042 = 50
      when "111000001000011" =>  data <= "01010010";  -- 7043 = 52
      when "111000001000100" =>  data <= "01000101";  -- 7044 = 45
      when "111000001000101" =>  data <= "01010011";  -- 7045 = 53
      when "111000001000110" =>  data <= "01010011";  -- 7046 = 53
      when "111000001000111" =>  data <= "00100000";  -- 7047 = 20
      when "111000001001000" =>  data <= "01010000";  -- 7048 = 50
      when "111000001001001" =>  data <= "01001100";  -- 7049 = 4C
      when "111000001001010" =>  data <= "01000001";  -- 704A = 41
      when "111000001001011" =>  data <= "01011001";  -- 704B = 59
      when "111000001001100" =>  data <= "10100000";  -- 704C = A0
      when "111000001001101" =>  data <= "00100110";  -- 704D = 26
      when "111000001001110" =>  data <= "00100000";  -- 704E = 20
      when "111000001001111" =>  data <= "01010010";  -- 704F = 52
      when "111000001010000" =>  data <= "01000101";  -- 7050 = 45
      when "111000001010001" =>  data <= "01000011";  -- 7051 = 43
      when "111000001010010" =>  data <= "01001111";  -- 7052 = 4F
      when "111000001010011" =>  data <= "01010010";  -- 7053 = 52
      when "111000001010100" =>  data <= "01000100";  -- 7054 = 44
      when "111000001010101" =>  data <= "10100000";  -- 7055 = A0
      when "111000001010110" =>  data <= "01001111";  -- 7056 = 4F
      when "111000001010111" =>  data <= "01001110";  -- 7057 = 4E
      when "111000001011000" =>  data <= "00100000";  -- 7058 = 20
      when "111000001011001" =>  data <= "01010100";  -- 7059 = 54
      when "111000001011010" =>  data <= "01000001";  -- 705A = 41
      when "111000001011011" =>  data <= "01010000";  -- 705B = 50
      when "111000001011100" =>  data <= "01000101";  -- 705C = 45
      when "111000001011101" =>  data <= "00100000";  -- 705D = 20
      when "111000001011110" =>  data <= "10100011";  -- 705E = A3
      when "111000001011111" =>  data <= "00001101";  -- 705F = D
      when "111000001100000" =>  data <= "01001100";  -- 7060 = 4C
      when "111000001100001" =>  data <= "01001111";  -- 7061 = 4F
      when "111000001100010" =>  data <= "01000001";  -- 7062 = 41
      when "111000001100011" =>  data <= "11000100";  -- 7063 = C4
      when "111000001100100" =>  data <= "00001101";  -- 7064 = D
      when "111000001100101" =>  data <= "01010111";  -- 7065 = 57
      when "111000001100110" =>  data <= "01010010";  -- 7066 = 52
      when "111000001100111" =>  data <= "01001001";  -- 7067 = 49
      when "111000001101000" =>  data <= "01010100";  -- 7068 = 54
      when "111000001101001" =>  data <= "01001001";  -- 7069 = 49
      when "111000001101010" =>  data <= "01001110";  -- 706A = 4E
      when "111000001101011" =>  data <= "01000111";  -- 706B = 47
      when "111000001101100" =>  data <= "10100000";  -- 706C = A0
      when "111000001101101" =>  data <= "00001101";  -- 706D = D
      when "111000001101110" =>  data <= "01010110";  -- 706E = 56
      when "111000001101111" =>  data <= "01000101";  -- 706F = 45
      when "111000001110000" =>  data <= "01010010";  -- 7070 = 52
      when "111000001110001" =>  data <= "01001001";  -- 7071 = 49
      when "111000001110010" =>  data <= "01000110";  -- 7072 = 46
      when "111000001110011" =>  data <= "11011001";  -- 7073 = D9
      when "111000001110100" =>  data <= "01000100";  -- 7074 = 44
      when "111000001110101" =>  data <= "01000101";  -- 7075 = 45
      when "111000001110110" =>  data <= "01010110";  -- 7076 = 56
      when "111000001110111" =>  data <= "01001001";  -- 7077 = 49
      when "111000001111000" =>  data <= "01000011";  -- 7078 = 43
      when "111000001111001" =>  data <= "01000101";  -- 7079 = 45
      when "111000001111010" =>  data <= "00100000";  -- 707A = 20
      when "111000001111011" =>  data <= "01001110";  -- 707B = 4E
      when "111000001111100" =>  data <= "01001111";  -- 707C = 4F
      when "111000001111101" =>  data <= "01010100";  -- 707D = 54
      when "111000001111110" =>  data <= "00100000";  -- 707E = 20
      when "111000001111111" =>  data <= "01010000";  -- 707F = 50
      when "111000010000000" =>  data <= "01010010";  -- 7080 = 52
      when "111000010000001" =>  data <= "01000101";  -- 7081 = 45
      when "111000010000010" =>  data <= "01010011";  -- 7082 = 53
      when "111000010000011" =>  data <= "01000101";  -- 7083 = 45
      when "111000010000100" =>  data <= "01001110";  -- 7084 = 4E
      when "111000010000101" =>  data <= "11010100";  -- 7085 = D4
      when "111000010000110" =>  data <= "01001110";  -- 7086 = 4E
      when "111000010000111" =>  data <= "01001111";  -- 7087 = 4F
      when "111000010001000" =>  data <= "01010100";  -- 7088 = 54
      when "111000010001001" =>  data <= "00100000";  -- 7089 = 20
      when "111000010001010" =>  data <= "01001001";  -- 708A = 49
      when "111000010001011" =>  data <= "01001110";  -- 708B = 4E
      when "111000010001100" =>  data <= "01010000";  -- 708C = 50
      when "111000010001101" =>  data <= "01010101";  -- 708D = 55
      when "111000010001110" =>  data <= "01010100";  -- 708E = 54
      when "111000010001111" =>  data <= "00100000";  -- 708F = 20
      when "111000010010000" =>  data <= "01000110";  -- 7090 = 46
      when "111000010010001" =>  data <= "01001001";  -- 7091 = 49
      when "111000010010010" =>  data <= "01001100";  -- 7092 = 4C
      when "111000010010011" =>  data <= "11000101";  -- 7093 = C5
      when "111000010010100" =>  data <= "01001110";  -- 7094 = 4E
      when "111000010010101" =>  data <= "01001111";  -- 7095 = 4F
      when "111000010010110" =>  data <= "01010100";  -- 7096 = 54
      when "111000010010111" =>  data <= "00100000";  -- 7097 = 20
      when "111000010011000" =>  data <= "01001111";  -- 7098 = 4F
      when "111000010011001" =>  data <= "01010101";  -- 7099 = 55
      when "111000010011010" =>  data <= "01010100";  -- 709A = 54
      when "111000010011011" =>  data <= "01010000";  -- 709B = 50
      when "111000010011100" =>  data <= "01010101";  -- 709C = 55
      when "111000010011101" =>  data <= "01010100";  -- 709D = 54
      when "111000010011110" =>  data <= "00100000";  -- 709E = 20
      when "111000010011111" =>  data <= "01000110";  -- 709F = 46
      when "111000010100000" =>  data <= "01001001";  -- 70A0 = 49
      when "111000010100001" =>  data <= "01001100";  -- 70A1 = 4C
      when "111000010100010" =>  data <= "11000101";  -- 70A2 = C5
      when "111000010100011" =>  data <= "00001101";  -- 70A3 = D
      when "111000010100100" =>  data <= "01000110";  -- 70A4 = 46
      when "111000010100101" =>  data <= "01001111";  -- 70A5 = 4F
      when "111000010100110" =>  data <= "01010101";  -- 70A6 = 55
      when "111000010100111" =>  data <= "01001110";  -- 70A7 = 4E
      when "111000010101000" =>  data <= "01000100";  -- 70A8 = 44
      when "111000010101001" =>  data <= "10100000";  -- 70A9 = A0
      when "111000010101010" =>  data <= "00001101";  -- 70AA = D
      when "111000010101011" =>  data <= "01001111";  -- 70AB = 4F
      when "111000010101100" =>  data <= "01001011";  -- 70AC = 4B
      when "111000010101101" =>  data <= "10001101";  -- 70AD = 8D
      when "111000010101110" =>  data <= "00001101";  -- 70AE = D
      when "111000010101111" =>  data <= "01010010";  -- 70AF = 52
      when "111000010110000" =>  data <= "01000101";  -- 70B0 = 45
      when "111000010110001" =>  data <= "01000001";  -- 70B1 = 41
      when "111000010110010" =>  data <= "01000100";  -- 70B2 = 44
      when "111000010110011" =>  data <= "01011001";  -- 70B3 = 59
      when "111000010110100" =>  data <= "00101110";  -- 70B4 = 2E
      when "111000010110101" =>  data <= "10001101";  -- 70B5 = 8D
      when "111000010110110" =>  data <= "00001101";  -- 70B6 = D
      when "111000010110111" =>  data <= "01000001";  -- 70B7 = 41
      when "111000010111000" =>  data <= "01010010";  -- 70B8 = 52
      when "111000010111001" =>  data <= "01000101";  -- 70B9 = 45
      when "111000010111010" =>  data <= "00100000";  -- 70BA = 20
      when "111000010111011" =>  data <= "01011001";  -- 70BB = 59
      when "111000010111100" =>  data <= "01001111";  -- 70BC = 4F
      when "111000010111101" =>  data <= "01010101";  -- 70BD = 55
      when "111000010111110" =>  data <= "00100000";  -- 70BE = 20
      when "111000010111111" =>  data <= "01010011";  -- 70BF = 53
      when "111000011000000" =>  data <= "01010101";  -- 70C0 = 55
      when "111000011000001" =>  data <= "01010010";  -- 70C1 = 52
      when "111000011000010" =>  data <= "01000101";  -- 70C2 = 45
      when "111000011000011" =>  data <= "00100000";  -- 70C3 = 20
      when "111000011000100" =>  data <= "10111111";  -- 70C4 = BF
      when "111000011000101" =>  data <= "00001101";  -- 70C5 = D
      when "111000011000110" =>  data <= "00111111";  -- 70C6 = 3F
      when "111000011000111" =>  data <= "00100000";  -- 70C7 = 20
      when "111000011001000" =>  data <= "01000010";  -- 70C8 = 42
      when "111000011001001" =>  data <= "01000001";  -- 70C9 = 41
      when "111000011001010" =>  data <= "01000100";  -- 70CA = 44
      when "111000011001011" =>  data <= "00100000";  -- 70CB = 20
      when "111000011001100" =>  data <= "01000100";  -- 70CC = 44
      when "111000011001101" =>  data <= "01001001";  -- 70CD = 49
      when "111000011001110" =>  data <= "01010011";  -- 70CE = 53
      when "111000011001111" =>  data <= "01001011";  -- 70CF = 4B
      when "111000011010000" =>  data <= "00100000";  -- 70D0 = 20
      when "111000011010001" =>  data <= "10001101";  -- 70D1 = 8D
      when "111000011010010" =>  data <= "10101001";  -- 70D2 = A9
      when "111000011010011" =>  data <= "01000000";  -- 70D3 = 40
      when "111000011010100" =>  data <= "00101100";  -- 70D4 = 2C
      when "111000011010101" =>  data <= "10101001";  -- 70D5 = A9
      when "111000011010110" =>  data <= "00100000";  -- 70D6 = 20
      when "111000011010111" =>  data <= "01001000";  -- 70D7 = 48
      when "111000011011000" =>  data <= "10101101";  -- 70D8 = AD
      when "111000011011001" =>  data <= "01000000";  -- 70D9 = 40
      when "111000011011010" =>  data <= "11101000";  -- 70DA = E8
      when "111000011011011" =>  data <= "00001001";  -- 70DB = 9
      when "111000011011100" =>  data <= "00000010";  -- 70DC = 2
      when "111000011011101" =>  data <= "10001101";  -- 70DD = 8D
      when "111000011011110" =>  data <= "01000000";  -- 70DE = 40
      when "111000011011111" =>  data <= "11101000";  -- 70DF = E8
      when "111000011100000" =>  data <= "10101001";  -- 70E0 = A9
      when "111000011100001" =>  data <= "00111100";  -- 70E1 = 3C
      when "111000011100010" =>  data <= "10001101";  -- 70E2 = 8D
      when "111000011100011" =>  data <= "00100001";  -- 70E3 = 21
      when "111000011100100" =>  data <= "11101000";  -- 70E4 = E8
      when "111000011100101" =>  data <= "00100100";  -- 70E5 = 24
      when "111000011100110" =>  data <= "10100000";  -- 70E6 = A0
      when "111000011100111" =>  data <= "11110000";  -- 70E7 = F0
      when "111000011101000" =>  data <= "00010001";  -- 70E8 = 11
      when "111000011101001" =>  data <= "10101001";  -- 70E9 = A9
      when "111000011101010" =>  data <= "00110100";  -- 70EA = 34
      when "111000011101011" =>  data <= "10001101";  -- 70EB = 8D
      when "111000011101100" =>  data <= "00010001";  -- 70EC = 11
      when "111000011101101" =>  data <= "11101000";  -- 70ED = E8
      when "111000011101110" =>  data <= "00100000";  -- 70EE = 20
      when "111000011101111" =>  data <= "00001001";  -- 70EF = 9
      when "111000011110000" =>  data <= "11110001";  -- 70F0 = F1
      when "111000011110001" =>  data <= "10101001";  -- 70F1 = A9
      when "111000011110010" =>  data <= "00000000";  -- 70F2 = 0
      when "111000011110011" =>  data <= "10000101";  -- 70F3 = 85
      when "111000011110100" =>  data <= "10100000";  -- 70F4 = A0
      when "111000011110101" =>  data <= "10101001";  -- 70F5 = A9
      when "111000011110110" =>  data <= "00111100";  -- 70F6 = 3C
      when "111000011110111" =>  data <= "10001101";  -- 70F7 = 8D
      when "111000011111000" =>  data <= "00010001";  -- 70F8 = 11
      when "111000011111001" =>  data <= "11101000";  -- 70F9 = E8
      when "111000011111010" =>  data <= "01101000";  -- 70FA = 68
      when "111000011111011" =>  data <= "00000101";  -- 70FB = 5
      when "111000011111100" =>  data <= "11010100";  -- 70FC = D4
      when "111000011111101" =>  data <= "10000101";  -- 70FD = 85
      when "111000011111110" =>  data <= "10100101";  -- 70FE = A5
      when "111000011111111" =>  data <= "10101101";  -- 70FF = AD
      when "111000100000000" =>  data <= "01000000";  -- 7100 = 40
      when "111000100000001" =>  data <= "11101000";  -- 7101 = E8
      when "111000100000010" =>  data <= "00010000";  -- 7102 = 10
      when "111000100000011" =>  data <= "11111011";  -- 7103 = FB
      when "111000100000100" =>  data <= "00101001";  -- 7104 = 29
      when "111000100000101" =>  data <= "11111011";  -- 7105 = FB
      when "111000100000110" =>  data <= "10001101";  -- 7106 = 8D
      when "111000100000111" =>  data <= "01000000";  -- 7107 = 40
      when "111000100001000" =>  data <= "11101000";  -- 7108 = E8
      when "111000100001001" =>  data <= "10101001";  -- 7109 = A9
      when "111000100001010" =>  data <= "00111100";  -- 710A = 3C
      when "111000100001011" =>  data <= "10001101";  -- 710B = 8D
      when "111000100001100" =>  data <= "00100011";  -- 710C = 23
      when "111000100001101" =>  data <= "11101000";  -- 710D = E8
      when "111000100001110" =>  data <= "10101101";  -- 710E = AD
      when "111000100001111" =>  data <= "01000000";  -- 710F = 40
      when "111000100010000" =>  data <= "11101000";  -- 7110 = E8
      when "111000100010001" =>  data <= "00101001";  -- 7111 = 29
      when "111000100010010" =>  data <= "01000001";  -- 7112 = 41
      when "111000100010011" =>  data <= "11001001";  -- 7113 = C9
      when "111000100010100" =>  data <= "01000001";  -- 7114 = 41
      when "111000100010101" =>  data <= "11110000";  -- 7115 = F0
      when "111000100010110" =>  data <= "01010101";  -- 7116 = 55
      when "111000100010111" =>  data <= "10100101";  -- 7117 = A5
      when "111000100011000" =>  data <= "10100101";  -- 7118 = A5
      when "111000100011001" =>  data <= "01001001";  -- 7119 = 49
      when "111000100011010" =>  data <= "11111111";  -- 711A = FF
      when "111000100011011" =>  data <= "10001101";  -- 711B = 8D
      when "111000100011100" =>  data <= "00100010";  -- 711C = 22
      when "111000100011101" =>  data <= "11101000";  -- 711D = E8
      when "111000100011110" =>  data <= "00101100";  -- 711E = 2C
      when "111000100011111" =>  data <= "01000000";  -- 711F = 40
      when "111000100100000" =>  data <= "11101000";  -- 7120 = E8
      when "111000100100001" =>  data <= "01010000";  -- 7121 = 50
      when "111000100100010" =>  data <= "11111011";  -- 7122 = FB
      when "111000100100011" =>  data <= "10101001";  -- 7123 = A9
      when "111000100100100" =>  data <= "00110100";  -- 7124 = 34
      when "111000100100101" =>  data <= "10001101";  -- 7125 = 8D
      when "111000100100110" =>  data <= "00100011";  -- 7126 = 23
      when "111000100100111" =>  data <= "11101000";  -- 7127 = E8
      when "111000100101000" =>  data <= "10101001";  -- 7128 = A9
      when "111000100101001" =>  data <= "11111111";  -- 7129 = FF
      when "111000100101010" =>  data <= "10001101";  -- 712A = 8D
      when "111000100101011" =>  data <= "01000101";  -- 712B = 45
      when "111000100101100" =>  data <= "11101000";  -- 712C = E8
      when "111000100101101" =>  data <= "10101101";  -- 712D = AD
      when "111000100101110" =>  data <= "01000000";  -- 712E = 40
      when "111000100101111" =>  data <= "11101000";  -- 712F = E8
      when "111000100110000" =>  data <= "00101100";  -- 7130 = 2C
      when "111000100110001" =>  data <= "01001101";  -- 7131 = 4D
      when "111000100110010" =>  data <= "11101000";  -- 7132 = E8
      when "111000100110011" =>  data <= "01110000";  -- 7133 = 70
      when "111000100110100" =>  data <= "00011100";  -- 7134 = 1C
      when "111000100110101" =>  data <= "01001010";  -- 7135 = 4A
      when "111000100110110" =>  data <= "10010000";  -- 7136 = 90
      when "111000100110111" =>  data <= "11110101";  -- 7137 = F5
      when "111000100111000" =>  data <= "10101001";  -- 7138 = A9
      when "111000100111001" =>  data <= "00111100";  -- 7139 = 3C
      when "111000100111010" =>  data <= "10001101";  -- 713A = 8D
      when "111000100111011" =>  data <= "00100011";  -- 713B = 23
      when "111000100111100" =>  data <= "11101000";  -- 713C = E8
      when "111000100111101" =>  data <= "10101001";  -- 713D = A9
      when "111000100111110" =>  data <= "11111111";  -- 713E = FF
      when "111000100111111" =>  data <= "10001101";  -- 713F = 8D
      when "111000101000000" =>  data <= "00100010";  -- 7140 = 22
      when "111000101000001" =>  data <= "11101000";  -- 7141 = E8
      when "111000101000010" =>  data <= "01100000";  -- 7142 = 60
      when "111000101000011" =>  data <= "10000101";  -- 7143 = 85
      when "111000101000100" =>  data <= "10100101";  -- 7144 = A5
      when "111000101000101" =>  data <= "00100000";  -- 7145 = 20
      when "111000101000110" =>  data <= "00001001";  -- 7146 = 9
      when "111000101000111" =>  data <= "11110001";  -- 7147 = F1
      when "111000101001000" =>  data <= "10101101";  -- 7148 = AD
      when "111000101001001" =>  data <= "01000000";  -- 7149 = 40
      when "111000101001010" =>  data <= "11101000";  -- 714A = E8
      when "111000101001011" =>  data <= "00001001";  -- 714B = 9
      when "111000101001100" =>  data <= "00000100";  -- 714C = 4
      when "111000101001101" =>  data <= "10001101";  -- 714D = 8D
      when "111000101001110" =>  data <= "01000000";  -- 714E = 40
      when "111000101001111" =>  data <= "11101000";  -- 714F = E8
      when "111000101010000" =>  data <= "01100000";  -- 7150 = 60
      when "111000101010001" =>  data <= "10101101";  -- 7151 = AD
      when "111000101010010" =>  data <= "11111100";  -- 7152 = FC
      when "111000101010011" =>  data <= "00000011";  -- 7153 = 3
      when "111000101010100" =>  data <= "00010000";  -- 7154 = 10
      when "111000101010101" =>  data <= "00001111";  -- 7155 = F
      when "111000101010110" =>  data <= "00100000";  -- 7156 = 20
      when "111000101010111" =>  data <= "01000011";  -- 7157 = 43
      when "111000101011000" =>  data <= "11110011";  -- 7158 = F3
      when "111000101011001" =>  data <= "11010000";  -- 7159 = D0
      when "111000101011010" =>  data <= "11001101";  -- 715A = CD
      when "111000101011011" =>  data <= "10101101";  -- 715B = AD
      when "111000101011100" =>  data <= "11111100";  -- 715C = FC
      when "111000101011101" =>  data <= "00000011";  -- 715D = 3
      when "111000101011110" =>  data <= "00010000";  -- 715E = 10
      when "111000101011111" =>  data <= "00010000";  -- 715F = 10
      when "111000101100000" =>  data <= "00100000";  -- 7160 = 20
      when "111000101100001" =>  data <= "01000011";  -- 7161 = 43
      when "111000101100010" =>  data <= "11110011";  -- 7162 = F3
      when "111000101100011" =>  data <= "11010000";  -- 7163 = D0
      when "111000101100100" =>  data <= "01101000";  -- 7164 = 68
      when "111000101100101" =>  data <= "10101001";  -- 7165 = A9
      when "111000101100110" =>  data <= "00000001";  -- 7166 = 1
      when "111000101100111" =>  data <= "00100000";  -- 7167 = 20
      when "111000101101000" =>  data <= "11000100";  -- 7168 = C4
      when "111000101101001" =>  data <= "11111011";  -- 7169 = FB
      when "111000101101010" =>  data <= "11010000";  -- 716A = D0
      when "111000101101011" =>  data <= "11001100";  -- 716B = CC
      when "111000101101100" =>  data <= "10101001";  -- 716C = A9
      when "111000101101101" =>  data <= "10000000";  -- 716D = 80
      when "111000101101110" =>  data <= "00110000";  -- 716E = 30
      when "111000101101111" =>  data <= "11110111";  -- 716F = F7
      when "111000101110000" =>  data <= "10101001";  -- 7170 = A9
      when "111000101110001" =>  data <= "00000010";  -- 7171 = 2
      when "111000101110010" =>  data <= "00100000";  -- 7172 = 20
      when "111000101110011" =>  data <= "11000100";  -- 7173 = C4
      when "111000101110100" =>  data <= "11111011";  -- 7174 = FB
      when "111000101110101" =>  data <= "10101101";  -- 7175 = AD
      when "111000101110110" =>  data <= "01000000";  -- 7176 = 40
      when "111000101110111" =>  data <= "11101000";  -- 7177 = E8
      when "111000101111000" =>  data <= "00101001";  -- 7178 = 29
      when "111000101111001" =>  data <= "11111101";  -- 7179 = FD
      when "111000101111010" =>  data <= "10001101";  -- 717A = 8D
      when "111000101111011" =>  data <= "01000000";  -- 717B = 40
      when "111000101111100" =>  data <= "11101000";  -- 717C = E8
      when "111000101111101" =>  data <= "10101001";  -- 717D = A9
      when "111000101111110" =>  data <= "00110100";  -- 717E = 34
      when "111000101111111" =>  data <= "10001101";  -- 717F = 8D
      when "111000110000000" =>  data <= "00100001";  -- 7180 = 21
      when "111000110000001" =>  data <= "11101000";  -- 7181 = E8
      when "111000110000010" =>  data <= "10101001";  -- 7182 = A9
      when "111000110000011" =>  data <= "00001101";  -- 7183 = D
      when "111000110000100" =>  data <= "01100000";  -- 7184 = 60
      when "111000110000101" =>  data <= "10111001";  -- 7185 = B9
      when "111000110000110" =>  data <= "00000000";  -- 7186 = 0
      when "111000110000111" =>  data <= "11110000";  -- 7187 = F0
      when "111000110001000" =>  data <= "00001000";  -- 7188 = 8
      when "111000110001001" =>  data <= "00101001";  -- 7189 = 29
      when "111000110001010" =>  data <= "01111111";  -- 718A = 7F
      when "111000110001011" =>  data <= "00100000";  -- 718B = 20
      when "111000110001100" =>  data <= "00000010";  -- 718C = 2
      when "111000110001101" =>  data <= "11100010";  -- 718D = E2
      when "111000110001110" =>  data <= "11001000";  -- 718E = C8
      when "111000110001111" =>  data <= "00101000";  -- 718F = 28
      when "111000110010000" =>  data <= "00010000";  -- 7190 = 10
      when "111000110010001" =>  data <= "11110011";  -- 7191 = F3
      when "111000110010010" =>  data <= "01100000";  -- 7192 = 60
      when "111000110010011" =>  data <= "10000101";  -- 7193 = 85
      when "111000110010100" =>  data <= "10100101";  -- 7194 = A5
      when "111000110010101" =>  data <= "00100000";  -- 7195 = 20
      when "111000110010110" =>  data <= "00001001";  -- 7196 = 9
      when "111000110010111" =>  data <= "11110001";  -- 7197 = F1
      when "111000110011000" =>  data <= "00100000";  -- 7198 = 20
      when "111000110011001" =>  data <= "01110101";  -- 7199 = 75
      when "111000110011010" =>  data <= "11110001";  -- 719A = F1
      when "111000110011011" =>  data <= "01001100";  -- 719B = 4C
      when "111000110011100" =>  data <= "01001000";  -- 719C = 48
      when "111000110011101" =>  data <= "11110001";  -- 719D = F1
      when "111000110011110" =>  data <= "00100100";  -- 719E = 24
      when "111000110011111" =>  data <= "10100000";  -- 719F = A0
      when "111000110100000" =>  data <= "00110000";  -- 71A0 = 30
      when "111000110100001" =>  data <= "00000100";  -- 71A1 = 4
      when "111000110100010" =>  data <= "11000110";  -- 71A2 = C6
      when "111000110100011" =>  data <= "10100000";  -- 71A3 = A0
      when "111000110100100" =>  data <= "11010000";  -- 71A4 = D0
      when "111000110100101" =>  data <= "00000101";  -- 71A5 = 5
      when "111000110100110" =>  data <= "01001000";  -- 71A6 = 48
      when "111000110100111" =>  data <= "00100000";  -- 71A7 = 20
      when "111000110101000" =>  data <= "00001001";  -- 71A8 = 9
      when "111000110101001" =>  data <= "11110001";  -- 71A9 = F1
      when "111000110101010" =>  data <= "01101000";  -- 71AA = 68
      when "111000110101011" =>  data <= "10000101";  -- 71AB = 85
      when "111000110101100" =>  data <= "10100101";  -- 71AC = A5
      when "111000110101101" =>  data <= "01100000";  -- 71AD = 60
      when "111000110101110" =>  data <= "10101101";  -- 71AE = AD
      when "111000110101111" =>  data <= "01000000";  -- 71AF = 40
      when "111000110110000" =>  data <= "11101000";  -- 71B0 = E8
      when "111000110110001" =>  data <= "00101001";  -- 71B1 = 29
      when "111000110110010" =>  data <= "11111011";  -- 71B2 = FB
      when "111000110110011" =>  data <= "10001101";  -- 71B3 = 8D
      when "111000110110100" =>  data <= "01000000";  -- 71B4 = 40
      when "111000110110101" =>  data <= "11101000";  -- 71B5 = E8
      when "111000110110110" =>  data <= "10101001";  -- 71B6 = A9
      when "111000110110111" =>  data <= "01011111";  -- 71B7 = 5F
      when "111000110111000" =>  data <= "00101100";  -- 71B8 = 2C
      when "111000110111001" =>  data <= "10101001";  -- 71B9 = A9
      when "111000110111010" =>  data <= "00111111";  -- 71BA = 3F
      when "111000110111011" =>  data <= "00100000";  -- 71BB = 20
      when "111000110111100" =>  data <= "11010111";  -- 71BC = D7
      when "111000110111101" =>  data <= "11110000";  -- 71BD = F0
      when "111000110111110" =>  data <= "11010000";  -- 71BE = D0
      when "111000110111111" =>  data <= "10001000";  -- 71BF = 88
      when "111000111000000" =>  data <= "10101001";  -- 71C0 = A9
      when "111000111000001" =>  data <= "00110100";  -- 71C1 = 34
      when "111000111000010" =>  data <= "10001101";  -- 71C2 = 8D
      when "111000111000011" =>  data <= "00100001";  -- 71C3 = 21
      when "111000111000100" =>  data <= "11101000";  -- 71C4 = E8
      when "111000111000101" =>  data <= "10101101";  -- 71C5 = AD
      when "111000111000110" =>  data <= "01000000";  -- 71C6 = 40
      when "111000111000111" =>  data <= "11101000";  -- 71C7 = E8
      when "111000111001000" =>  data <= "00001001";  -- 71C8 = 9
      when "111000111001001" =>  data <= "00000010";  -- 71C9 = 2
      when "111000111001010" =>  data <= "10001101";  -- 71CA = 8D
      when "111000111001011" =>  data <= "01000000";  -- 71CB = 40
      when "111000111001100" =>  data <= "11101000";  -- 71CC = E8
      when "111000111001101" =>  data <= "10101001";  -- 71CD = A9
      when "111000111001110" =>  data <= "11111111";  -- 71CE = FF
      when "111000111001111" =>  data <= "10001101";  -- 71CF = 8D
      when "111000111010000" =>  data <= "01000101";  -- 71D0 = 45
      when "111000111010001" =>  data <= "11101000";  -- 71D1 = E8
      when "111000111010010" =>  data <= "00101100";  -- 71D2 = 2C
      when "111000111010011" =>  data <= "01001101";  -- 71D3 = 4D
      when "111000111010100" =>  data <= "11101000";  -- 71D4 = E8
      when "111000111010101" =>  data <= "01110000";  -- 71D5 = 70
      when "111000111010110" =>  data <= "10000100";  -- 71D6 = 84
      when "111000111010111" =>  data <= "00101100";  -- 71D7 = 2C
      when "111000111011000" =>  data <= "01000000";  -- 71D8 = 40
      when "111000111011001" =>  data <= "11101000";  -- 71D9 = E8
      when "111000111011010" =>  data <= "00110000";  -- 71DA = 30
      when "111000111011011" =>  data <= "11110110";  -- 71DB = F6
      when "111000111011100" =>  data <= "10101101";  -- 71DC = AD
      when "111000111011101" =>  data <= "01000000";  -- 71DD = 40
      when "111000111011110" =>  data <= "11101000";  -- 71DE = E8
      when "111000111011111" =>  data <= "00101001";  -- 71DF = 29
      when "111000111100000" =>  data <= "11111101";  -- 71E0 = FD
      when "111000111100001" =>  data <= "10001101";  -- 71E1 = 8D
      when "111000111100010" =>  data <= "01000000";  -- 71E2 = 40
      when "111000111100011" =>  data <= "11101000";  -- 71E3 = E8
      when "111000111100100" =>  data <= "00101100";  -- 71E4 = 2C
      when "111000111100101" =>  data <= "00010000";  -- 71E5 = 10
      when "111000111100110" =>  data <= "11101000";  -- 71E6 = E8
      when "111000111100111" =>  data <= "01110000";  -- 71E7 = 70
      when "111000111101000" =>  data <= "00000101";  -- 71E8 = 5
      when "111000111101001" =>  data <= "10101001";  -- 71E9 = A9
      when "111000111101010" =>  data <= "01000000";  -- 71EA = 40
      when "111000111101011" =>  data <= "00100000";  -- 71EB = 20
      when "111000111101100" =>  data <= "11000100";  -- 71EC = C4
      when "111000111101101" =>  data <= "11111011";  -- 71ED = FB
      when "111000111101110" =>  data <= "10101101";  -- 71EE = AD
      when "111000111101111" =>  data <= "00100000";  -- 71EF = 20
      when "111000111110000" =>  data <= "11101000";  -- 71F0 = E8
      when "111000111110001" =>  data <= "01001001";  -- 71F1 = 49
      when "111000111110010" =>  data <= "11111111";  -- 71F2 = FF
      when "111000111110011" =>  data <= "01001000";  -- 71F3 = 48
      when "111000111110100" =>  data <= "10101001";  -- 71F4 = A9
      when "111000111110101" =>  data <= "00111100";  -- 71F5 = 3C
      when "111000111110110" =>  data <= "10001101";  -- 71F6 = 8D
      when "111000111110111" =>  data <= "00100001";  -- 71F7 = 21
      when "111000111111000" =>  data <= "11101000";  -- 71F8 = E8
      when "111000111111001" =>  data <= "00101100";  -- 71F9 = 2C
      when "111000111111010" =>  data <= "01000000";  -- 71FA = 40
      when "111000111111011" =>  data <= "11101000";  -- 71FB = E8
      when "111000111111100" =>  data <= "00010000";  -- 71FC = 10
      when "111000111111101" =>  data <= "11111011";  -- 71FD = FB
      when "111000111111110" =>  data <= "10101001";  -- 71FE = A9
      when "111000111111111" =>  data <= "00110100";  -- 71FF = 34
      when "111001000000000" =>  data <= "10001101";  -- 7200 = 8D
      when "111001000000001" =>  data <= "00100001";  -- 7201 = 21
      when "111001000000010" =>  data <= "11101000";  -- 7202 = E8
      when "111001000000011" =>  data <= "01101000";  -- 7203 = 68
      when "111001000000100" =>  data <= "01100000";  -- 7204 = 60
      when "111001000000101" =>  data <= "10101001";  -- 7205 = A9
      when "111001000000110" =>  data <= "00000000";  -- 7206 = 0
      when "111001000000111" =>  data <= "10000101";  -- 7207 = 85
      when "111001000001000" =>  data <= "10010110";  -- 7208 = 96
      when "111001000001001" =>  data <= "10100101";  -- 7209 = A5
      when "111001000001010" =>  data <= "10101111";  -- 720A = AF
      when "111001000001011" =>  data <= "11010000";  -- 720B = D0
      when "111001000001100" =>  data <= "00010111";  -- 720C = 17
      when "111001000001101" =>  data <= "10100101";  -- 720D = A5
      when "111001000001110" =>  data <= "10011110";  -- 720E = 9E
      when "111001000001111" =>  data <= "11110000";  -- 720F = F0
      when "111001000010000" =>  data <= "01010001";  -- 7210 = 51
      when "111001000010001" =>  data <= "01111000";  -- 7211 = 78
      when "111001000010010" =>  data <= "01001100";  -- 7212 = 4C
      when "111001000010011" =>  data <= "10100111";  -- 7213 = A7
      when "111001000010100" =>  data <= "11100000";  -- 7214 = E0
      when "111001000010101" =>  data <= "10100101";  -- 7215 = A5
      when "111001000010110" =>  data <= "10101111";  -- 7216 = AF
      when "111001000010111" =>  data <= "11010000";  -- 7217 = D0
      when "111001000011000" =>  data <= "00001011";  -- 7218 = B
      when "111001000011001" =>  data <= "10100101";  -- 7219 = A5
      when "111001000011010" =>  data <= "11000110";  -- 721A = C6
      when "111001000011011" =>  data <= "10000101";  -- 721B = 85
      when "111001000011100" =>  data <= "10100100";  -- 721C = A4
      when "111001000011101" =>  data <= "10100101";  -- 721D = A5
      when "111001000011110" =>  data <= "11011000";  -- 721E = D8
      when "111001000011111" =>  data <= "10000101";  -- 721F = 85
      when "111001000100000" =>  data <= "10100011";  -- 7220 = A3
      when "111001000100001" =>  data <= "01001100";  -- 7221 = 4C
      when "111001000100010" =>  data <= "00010110";  -- 7222 = 16
      when "111001000100011" =>  data <= "11100001";  -- 7223 = E1
      when "111001000100100" =>  data <= "11001001";  -- 7224 = C9
      when "111001000100101" =>  data <= "00000011";  -- 7225 = 3
      when "111001000100110" =>  data <= "11010000";  -- 7226 = D0
      when "111001000100111" =>  data <= "00001001";  -- 7227 = 9
      when "111001000101000" =>  data <= "10000101";  -- 7228 = 85
      when "111001000101001" =>  data <= "10101100";  -- 7229 = AC
      when "111001000101010" =>  data <= "10100101";  -- 722A = A5
      when "111001000101011" =>  data <= "11010101";  -- 722B = D5
      when "111001000101100" =>  data <= "10000101";  -- 722C = 85
      when "111001000101101" =>  data <= "10100001";  -- 722D = A1
      when "111001000101110" =>  data <= "01001100";  -- 722E = 4C
      when "111001000101111" =>  data <= "00010110";  -- 722F = 16
      when "111001000110000" =>  data <= "11100001";  -- 7230 = E1
      when "111001000110001" =>  data <= "10110000";  -- 7231 = B0
      when "111001000110010" =>  data <= "00101001";  -- 7232 = 29
      when "111001000110011" =>  data <= "10000110";  -- 7233 = 86
      when "111001000110100" =>  data <= "10101101";  -- 7234 = AD
      when "111001000110101" =>  data <= "00100000";  -- 7235 = 20
      when "111001000110110" =>  data <= "01001001";  -- 7236 = 49
      when "111001000110111" =>  data <= "11110010";  -- 7237 = F2
      when "111001000111000" =>  data <= "01001000";  -- 7238 = 48
      when "111001000111001" =>  data <= "00100000";  -- 7239 = 20
      when "111001000111010" =>  data <= "01001001";  -- 723A = 49
      when "111001000111011" =>  data <= "11110010";  -- 723B = F2
      when "111001000111100" =>  data <= "11010000";  -- 723C = D0
      when "111001000111101" =>  data <= "00000101";  -- 723D = 5
      when "111001000111110" =>  data <= "10101001";  -- 723E = A9
      when "111001000111111" =>  data <= "01000000";  -- 723F = 40
      when "111001001000000" =>  data <= "00100000";  -- 7240 = 20
      when "111001001000001" =>  data <= "11000100";  -- 7241 = C4
      when "111001001000010" =>  data <= "11111011";  -- 7242 = FB
      when "111001001000011" =>  data <= "11010110";  -- 7243 = D6
      when "111001001000100" =>  data <= "10111010";  -- 7244 = BA
      when "111001001000101" =>  data <= "10100110";  -- 7245 = A6
      when "111001001000110" =>  data <= "10101101";  -- 7246 = AD
      when "111001001000111" =>  data <= "01101000";  -- 7247 = 68
      when "111001001001000" =>  data <= "01100000";  -- 7248 = 60
      when "111001001001001" =>  data <= "00100000";  -- 7249 = 20
      when "111001001001010" =>  data <= "01001011";  -- 724A = 4B
      when "111001001001011" =>  data <= "11111000";  -- 724B = F8
      when "111001001001100" =>  data <= "11010000";  -- 724C = D0
      when "111001001001101" =>  data <= "00001011";  -- 724D = B
      when "111001001001110" =>  data <= "00100000";  -- 724E = 20
      when "111001001001111" =>  data <= "10011010";  -- 724F = 9A
      when "111001001010000" =>  data <= "11111000";  -- 7250 = F8
      when "111001001010001" =>  data <= "10100110";  -- 7251 = A6
      when "111001001010010" =>  data <= "11010100";  -- 7252 = D4
      when "111001001010011" =>  data <= "10101001";  -- 7253 = A9
      when "111001001010100" =>  data <= "00000000";  -- 7254 = 0
      when "111001001010101" =>  data <= "10010101";  -- 7255 = 95
      when "111001001010110" =>  data <= "10111010";  -- 7256 = BA
      when "111001001010111" =>  data <= "11110000";  -- 7257 = F0
      when "111001001011000" =>  data <= "11110000";  -- 7258 = F0
      when "111001001011001" =>  data <= "10110001";  -- 7259 = B1
      when "111001001011010" =>  data <= "11010110";  -- 725A = D6
      when "111001001011011" =>  data <= "01100000";  -- 725B = 60
      when "111001001011100" =>  data <= "10100101";  -- 725C = A5
      when "111001001011101" =>  data <= "10010110";  -- 725D = 96
      when "111001001011110" =>  data <= "11110000";  -- 725E = F0
      when "111001001011111" =>  data <= "00000011";  -- 725F = 3
      when "111001001100000" =>  data <= "10101001";  -- 7260 = A9
      when "111001001100001" =>  data <= "00001101";  -- 7261 = D
      when "111001001100010" =>  data <= "01100000";  -- 7262 = 60
      when "111001001100011" =>  data <= "01001100";  -- 7263 = 4C
      when "111001001100100" =>  data <= "11000000";  -- 7264 = C0
      when "111001001100101" =>  data <= "11110001";  -- 7265 = F1
      when "111001001100110" =>  data <= "01001000";  -- 7266 = 48
      when "111001001100111" =>  data <= "10100101";  -- 7267 = A5
      when "111001001101000" =>  data <= "10110000";  -- 7268 = B0
      when "111001001101001" =>  data <= "11001001";  -- 7269 = C9
      when "111001001101010" =>  data <= "00000011";  -- 726A = 3
      when "111001001101011" =>  data <= "11010000";  -- 726B = D0
      when "111001001101100" =>  data <= "00000100";  -- 726C = 4
      when "111001001101101" =>  data <= "01101000";  -- 726D = 68
      when "111001001101110" =>  data <= "01001100";  -- 726E = 4C
      when "111001001101111" =>  data <= "00000010";  -- 726F = 2
      when "111001001110000" =>  data <= "11100010";  -- 7270 = E2
      when "111001001110001" =>  data <= "00110000";  -- 7271 = 30
      when "111001001110010" =>  data <= "00000100";  -- 7272 = 4
      when "111001001110011" =>  data <= "01101000";  -- 7273 = 68
      when "111001001110100" =>  data <= "01001100";  -- 7274 = 4C
      when "111001001110101" =>  data <= "10011110";  -- 7275 = 9E
      when "111001001110110" =>  data <= "11110001";  -- 7276 = F1
      when "111001001110111" =>  data <= "01101000";  -- 7277 = 68
      when "111001001111000" =>  data <= "10000101";  -- 7278 = 85
      when "111001001111001" =>  data <= "10110100";  -- 7279 = B4
      when "111001001111010" =>  data <= "11001001";  -- 727A = C9
      when "111001001111011" =>  data <= "00001010";  -- 727B = A
      when "111001001111100" =>  data <= "11110000";  -- 727C = F0
      when "111001001111101" =>  data <= "11100100";  -- 727D = E4
      when "111001001111110" =>  data <= "01001000";  -- 727E = 48
      when "111001001111111" =>  data <= "10001010";  -- 727F = 8A
      when "111001010000000" =>  data <= "01001000";  -- 7280 = 48
      when "111001010000001" =>  data <= "10011000";  -- 7281 = 98
      when "111001010000010" =>  data <= "01001000";  -- 7282 = 48
      when "111001010000011" =>  data <= "00100000";  -- 7283 = 20
      when "111001010000100" =>  data <= "01001011";  -- 7284 = 4B
      when "111001010000101" =>  data <= "11111000";  -- 7285 = F8
      when "111001010000110" =>  data <= "11010000";  -- 7286 = D0
      when "111001010000111" =>  data <= "00010000";  -- 7287 = 10
      when "111001010001000" =>  data <= "00100000";  -- 7288 = 20
      when "111001010001001" =>  data <= "11001011";  -- 7289 = CB
      when "111001010001010" =>  data <= "11111000";  -- 728A = F8
      when "111001010001011" =>  data <= "10100110";  -- 728B = A6
      when "111001010001100" =>  data <= "11010100";  -- 728C = D4
      when "111001010001101" =>  data <= "10101001";  -- 728D = A9
      when "111001010001110" =>  data <= "00000001";  -- 728E = 1
      when "111001010001111" =>  data <= "10010101";  -- 728F = 95
      when "111001010010000" =>  data <= "10111010";  -- 7290 = BA
      when "111001010010001" =>  data <= "10100000";  -- 7291 = A0
      when "111001010010010" =>  data <= "00000000";  -- 7292 = 0
      when "111001010010011" =>  data <= "10101001";  -- 7293 = A9
      when "111001010010100" =>  data <= "00000010";  -- 7294 = 2
      when "111001010010101" =>  data <= "10010001";  -- 7295 = 91
      when "111001010010110" =>  data <= "11010110";  -- 7296 = D6
      when "111001010010111" =>  data <= "11001000";  -- 7297 = C8
      when "111001010011000" =>  data <= "10100101";  -- 7298 = A5
      when "111001010011001" =>  data <= "10110100";  -- 7299 = B4
      when "111001010011010" =>  data <= "10010001";  -- 729A = 91
      when "111001010011011" =>  data <= "11010110";  -- 729B = D6
      when "111001010011100" =>  data <= "01101000";  -- 729C = 68
      when "111001010011101" =>  data <= "10101000";  -- 729D = A8
      when "111001010011110" =>  data <= "01101000";  -- 729E = 68
      when "111001010011111" =>  data <= "10101010";  -- 729F = AA
      when "111001010100000" =>  data <= "01101000";  -- 72A0 = 68
      when "111001010100001" =>  data <= "01100000";  -- 72A1 = 60
      when "111001010100010" =>  data <= "10101001";  -- 72A2 = A9
      when "111001010100011" =>  data <= "00000000";  -- 72A3 = 0
      when "111001010100100" =>  data <= "10000101";  -- 72A4 = 85
      when "111001010100101" =>  data <= "10101110";  -- 72A5 = AE
      when "111001010100110" =>  data <= "10100101";  -- 72A6 = A5
      when "111001010100111" =>  data <= "10110000";  -- 72A7 = B0
      when "111001010101000" =>  data <= "11001001";  -- 72A8 = C9
      when "111001010101001" =>  data <= "00000100";  -- 72A9 = 4
      when "111001010101010" =>  data <= "10010000";  -- 72AA = 90
      when "111001010101011" =>  data <= "00000011";  -- 72AB = 3
      when "111001010101100" =>  data <= "00100000";  -- 72AC = 20
      when "111001010101101" =>  data <= "10111001";  -- 72AD = B9
      when "111001010101110" =>  data <= "11110001";  -- 72AE = F1
      when "111001010101111" =>  data <= "10100101";  -- 72AF = A5
      when "111001010110000" =>  data <= "10101111";  -- 72B0 = AF
      when "111001010110001" =>  data <= "11001001";  -- 72B1 = C9
      when "111001010110010" =>  data <= "00000100";  -- 72B2 = 4
      when "111001010110011" =>  data <= "10010000";  -- 72B3 = 90
      when "111001010110100" =>  data <= "00000011";  -- 72B4 = 3
      when "111001010110101" =>  data <= "00100000";  -- 72B5 = 20
      when "111001010110110" =>  data <= "10101110";  -- 72B6 = AE
      when "111001010110111" =>  data <= "11110001";  -- 72B7 = F1
      when "111001010111000" =>  data <= "10101001";  -- 72B8 = A9
      when "111001010111001" =>  data <= "00000011";  -- 72B9 = 3
      when "111001010111010" =>  data <= "10000101";  -- 72BA = 85
      when "111001010111011" =>  data <= "10110000";  -- 72BB = B0
      when "111001010111100" =>  data <= "10101001";  -- 72BC = A9
      when "111001010111101" =>  data <= "00000000";  -- 72BD = 0
      when "111001010111110" =>  data <= "10000101";  -- 72BE = 85
      when "111001010111111" =>  data <= "10101111";  -- 72BF = AF
      when "111001011000000" =>  data <= "01100000";  -- 72C0 = 60
      when "111001011000001" =>  data <= "10100110";  -- 72C1 = A6
      when "111001011000010" =>  data <= "10101110";  -- 72C2 = AE
      when "111001011000011" =>  data <= "11001010";  -- 72C3 = CA
      when "111001011000100" =>  data <= "00110000";  -- 72C4 = 30
      when "111001011000101" =>  data <= "00010110";  -- 72C5 = 16
      when "111001011000110" =>  data <= "11011101";  -- 72C6 = DD
      when "111001011000111" =>  data <= "01010001";  -- 72C7 = 51
      when "111001011001000" =>  data <= "00000010";  -- 72C8 = 2
      when "111001011001001" =>  data <= "11110000";  -- 72C9 = F0
      when "111001011001010" =>  data <= "00010001";  -- 72CA = 11
      when "111001011001011" =>  data <= "11010000";  -- 72CB = D0
      when "111001011001100" =>  data <= "11110110";  -- 72CC = F6
      when "111001011001101" =>  data <= "10111101";  -- 72CD = BD
      when "111001011001110" =>  data <= "01010001";  -- 72CE = 51
      when "111001011001111" =>  data <= "00000010";  -- 72CF = 2
      when "111001011010000" =>  data <= "10000101";  -- 72D0 = 85
      when "111001011010001" =>  data <= "11010010";  -- 72D1 = D2
      when "111001011010010" =>  data <= "10111101";  -- 72D2 = BD
      when "111001011010011" =>  data <= "01011011";  -- 72D3 = 5B
      when "111001011010100" =>  data <= "00000010";  -- 72D4 = 2
      when "111001011010101" =>  data <= "10000101";  -- 72D5 = 85
      when "111001011010110" =>  data <= "11010100";  -- 72D6 = D4
      when "111001011010111" =>  data <= "10111101";  -- 72D7 = BD
      when "111001011011000" =>  data <= "01100101";  -- 72D8 = 65
      when "111001011011001" =>  data <= "00000010";  -- 72D9 = 2
      when "111001011011010" =>  data <= "10000101";  -- 72DA = 85
      when "111001011011011" =>  data <= "11010011";  -- 72DB = D3
      when "111001011011100" =>  data <= "01100000";  -- 72DC = 60
      when "111001011011101" =>  data <= "00100000";  -- 72DD = 20
      when "111001011011110" =>  data <= "00001101";  -- 72DE = D
      when "111001011011111" =>  data <= "11110101";  -- 72DF = F5
      when "111001011100000" =>  data <= "10100101";  -- 72E0 = A5
      when "111001011100001" =>  data <= "11010010";  -- 72E1 = D2
      when "111001011100010" =>  data <= "00100000";  -- 72E2 = 20
      when "111001011100011" =>  data <= "11000001";  -- 72E3 = C1
      when "111001011100100" =>  data <= "11110010";  -- 72E4 = F2
      when "111001011100101" =>  data <= "11010000";  -- 72E5 = D0
      when "111001011100110" =>  data <= "01001101";  -- 72E6 = 4D
      when "111001011100111" =>  data <= "00100000";  -- 72E7 = 20
      when "111001011101000" =>  data <= "11001101";  -- 72E8 = CD
      when "111001011101001" =>  data <= "11110010";  -- 72E9 = F2
      when "111001011101010" =>  data <= "10001010";  -- 72EA = 8A
      when "111001011101011" =>  data <= "01001000";  -- 72EB = 48
      when "111001011101100" =>  data <= "10100101";  -- 72EC = A5
      when "111001011101101" =>  data <= "11010100";  -- 72ED = D4
      when "111001011101110" =>  data <= "11110000";  -- 72EE = F0
      when "111001011101111" =>  data <= "00101000";  -- 72EF = 28
      when "111001011110000" =>  data <= "11001001";  -- 72F0 = C9
      when "111001011110001" =>  data <= "00000011";  -- 72F1 = 3
      when "111001011110010" =>  data <= "11110000";  -- 72F2 = F0
      when "111001011110011" =>  data <= "00100100";  -- 72F3 = 24
      when "111001011110100" =>  data <= "10110000";  -- 72F4 = B0
      when "111001011110101" =>  data <= "00011111";  -- 72F5 = 1F
      when "111001011110110" =>  data <= "10100101";  -- 72F6 = A5
      when "111001011110111" =>  data <= "11010011";  -- 72F7 = D3
      when "111001011111000" =>  data <= "00101001";  -- 72F8 = 29
      when "111001011111001" =>  data <= "00001111";  -- 72F9 = F
      when "111001011111010" =>  data <= "11110000";  -- 72FA = F0
      when "111001011111011" =>  data <= "00011100";  -- 72FB = 1C
      when "111001011111100" =>  data <= "00100000";  -- 72FC = 20
      when "111001011111101" =>  data <= "10010101";  -- 72FD = 95
      when "111001011111110" =>  data <= "11110110";  -- 72FE = F6
      when "111001011111111" =>  data <= "10101001";  -- 72FF = A9
      when "111001100000000" =>  data <= "00000000";  -- 7300 = 0
      when "111001100000001" =>  data <= "00100000";  -- 7301 = 20
      when "111001100000010" =>  data <= "01111000";  -- 7302 = 78
      when "111001100000011" =>  data <= "11110010";  -- 7303 = F2
      when "111001100000100" =>  data <= "00100000";  -- 7304 = 20
      when "111001100000101" =>  data <= "11001011";  -- 7305 = CB
      when "111001100000110" =>  data <= "11111000";  -- 7306 = F8
      when "111001100000111" =>  data <= "10100101";  -- 7307 = A5
      when "111001100001000" =>  data <= "11010011";  -- 7308 = D3
      when "111001100001001" =>  data <= "11001001";  -- 7309 = C9
      when "111001100001010" =>  data <= "01100010";  -- 730A = 62
      when "111001100001011" =>  data <= "11010000";  -- 730B = D0
      when "111001100001100" =>  data <= "00001011";  -- 730C = B
      when "111001100001101" =>  data <= "10101001";  -- 730D = A9
      when "111001100001110" =>  data <= "00000101";  -- 730E = 5
      when "111001100001111" =>  data <= "00100000";  -- 730F = 20
      when "111001100010000" =>  data <= "00011001";  -- 7310 = 19
      when "111001100010001" =>  data <= "11110110";  -- 7311 = F6
      when "111001100010010" =>  data <= "01001100";  -- 7312 = 4C
      when "111001100010011" =>  data <= "00011000";  -- 7313 = 18
      when "111001100010100" =>  data <= "11110011";  -- 7314 = F3
      when "111001100010101" =>  data <= "00100000";  -- 7315 = 20
      when "111001100010110" =>  data <= "00101111";  -- 7316 = 2F
      when "111001100010111" =>  data <= "11110111";  -- 7317 = F7
      when "111001100011000" =>  data <= "01101000";  -- 7318 = 68
      when "111001100011001" =>  data <= "10101010";  -- 7319 = AA
      when "111001100011010" =>  data <= "11000110";  -- 731A = C6
      when "111001100011011" =>  data <= "10101110";  -- 731B = AE
      when "111001100011100" =>  data <= "11100100";  -- 731C = E4
      when "111001100011101" =>  data <= "10101110";  -- 731D = AE
      when "111001100011110" =>  data <= "11110000";  -- 731E = F0
      when "111001100011111" =>  data <= "00010100";  -- 731F = 14
      when "111001100100000" =>  data <= "10100100";  -- 7320 = A4
      when "111001100100001" =>  data <= "10101110";  -- 7321 = AE
      when "111001100100010" =>  data <= "10111001";  -- 7322 = B9
      when "111001100100011" =>  data <= "01010001";  -- 7323 = 51
      when "111001100100100" =>  data <= "00000010";  -- 7324 = 2
      when "111001100100101" =>  data <= "10011101";  -- 7325 = 9D
      when "111001100100110" =>  data <= "01010001";  -- 7326 = 51
      when "111001100100111" =>  data <= "00000010";  -- 7327 = 2
      when "111001100101000" =>  data <= "10111001";  -- 7328 = B9
      when "111001100101001" =>  data <= "01011011";  -- 7329 = 5B
      when "111001100101010" =>  data <= "00000010";  -- 732A = 2
      when "111001100101011" =>  data <= "10011101";  -- 732B = 9D
      when "111001100101100" =>  data <= "01011011";  -- 732C = 5B
      when "111001100101101" =>  data <= "00000010";  -- 732D = 2
      when "111001100101110" =>  data <= "10111001";  -- 732E = B9
      when "111001100101111" =>  data <= "01100101";  -- 732F = 65
      when "111001100110000" =>  data <= "00000010";  -- 7330 = 2
      when "111001100110001" =>  data <= "10011101";  -- 7331 = 9D
      when "111001100110010" =>  data <= "01100101";  -- 7332 = 65
      when "111001100110011" =>  data <= "00000010";  -- 7333 = 2
      when "111001100110100" =>  data <= "01100000";  -- 7334 = 60
      when "111001100110101" =>  data <= "10100101";  -- 7335 = A5
      when "111001100110110" =>  data <= "10011011";  -- 7336 = 9B
      when "111001100110111" =>  data <= "11001001";  -- 7337 = C9
      when "111001100111000" =>  data <= "11101111";  -- 7338 = EF
      when "111001100111001" =>  data <= "11010000";  -- 7339 = D0
      when "111001100111010" =>  data <= "00000111";  -- 733A = 7
      when "111001100111011" =>  data <= "00001000";  -- 733B = 8
      when "111001100111100" =>  data <= "00100000";  -- 733C = 20
      when "111001100111101" =>  data <= "10100110";  -- 733D = A6
      when "111001100111110" =>  data <= "11110010";  -- 733E = F2
      when "111001100111111" =>  data <= "10000101";  -- 733F = 85
      when "111001101000000" =>  data <= "10011110";  -- 7340 = 9E
      when "111001101000001" =>  data <= "00101000";  -- 7341 = 28
      when "111001101000010" =>  data <= "01100000";  -- 7342 = 60
      when "111001101000011" =>  data <= "00100000";  -- 7343 = 20
      when "111001101000100" =>  data <= "00110101";  -- 7344 = 35
      when "111001101000101" =>  data <= "11110011";  -- 7345 = F3
      when "111001101000110" =>  data <= "01001100";  -- 7346 = 4C
      when "111001101000111" =>  data <= "11000110";  -- 7347 = C6
      when "111001101001000" =>  data <= "10110111";  -- 7348 = B7
      when "111001101001001" =>  data <= "00100000";  -- 7349 = 20
      when "111001101001010" =>  data <= "01010001";  -- 734A = 51
      when "111001101001011" =>  data <= "11110011";  -- 734B = F3
      when "111001101001100" =>  data <= "11010000";  -- 734C = D0
      when "111001101001101" =>  data <= "11110100";  -- 734D = F4
      when "111001101001110" =>  data <= "01001100";  -- 734E = 4C
      when "111001101001111" =>  data <= "10000101";  -- 734F = 85
      when "111001101010000" =>  data <= "11110001";  -- 7350 = F1
      when "111001101010001" =>  data <= "10100101";  -- 7351 = A5
      when "111001101010010" =>  data <= "01111000";  -- 7352 = 78
      when "111001101010011" =>  data <= "11001001";  -- 7353 = C9
      when "111001101010100" =>  data <= "00000010";  -- 7354 = 2
      when "111001101010101" =>  data <= "01100000";  -- 7355 = 60
      when "111001101010110" =>  data <= "10100101";  -- 7356 = A5
      when "111001101010111" =>  data <= "11010100";  -- 7357 = D4
      when "111001101011000" =>  data <= "11010000";  -- 7358 = D0
      when "111001101011001" =>  data <= "00000011";  -- 7359 = 3
      when "111001101011010" =>  data <= "01001100";  -- 735A = 4C
      when "111001101011011" =>  data <= "00000000";  -- 735B = 0
      when "111001101011100" =>  data <= "10111111";  -- 735C = BF
      when "111001101011101" =>  data <= "11001001";  -- 735D = C9
      when "111001101011110" =>  data <= "00000011";  -- 735E = 3
      when "111001101011111" =>  data <= "11110000";  -- 735F = F0
      when "111001101100000" =>  data <= "11111001";  -- 7360 = F9
      when "111001101100001" =>  data <= "10010000";  -- 7361 = 90
      when "111001101100010" =>  data <= "01110001";  -- 7362 = 71
      when "111001101100011" =>  data <= "10101001";  -- 7363 = A9
      when "111001101100100" =>  data <= "01100000";  -- 7364 = 60
      when "111001101100101" =>  data <= "10000101";  -- 7365 = 85
      when "111001101100110" =>  data <= "11010011";  -- 7366 = D3
      when "111001101100111" =>  data <= "10100100";  -- 7367 = A4
      when "111001101101000" =>  data <= "11010001";  -- 7368 = D1
      when "111001101101001" =>  data <= "11010000";  -- 7369 = D0
      when "111001101101010" =>  data <= "00000011";  -- 736A = 3
      when "111001101101011" =>  data <= "01001100";  -- 736B = 4C
      when "111001101101100" =>  data <= "00000000";  -- 736C = 0
      when "111001101101101" =>  data <= "10111111";  -- 736D = BF
      when "111001101101110" =>  data <= "00100000";  -- 736E = 20
      when "111001101101111" =>  data <= "01001001";  -- 736F = 49
      when "111001101110000" =>  data <= "11110100";  -- 7370 = F4
      when "111001101110001" =>  data <= "00100000";  -- 7371 = 20
      when "111001101110010" =>  data <= "10100101";  -- 7372 = A5
      when "111001101110011" =>  data <= "11110100";  -- 7373 = F4
      when "111001101110100" =>  data <= "00100000";  -- 7374 = 20
      when "111001101110101" =>  data <= "11010010";  -- 7375 = D2
      when "111001101110110" =>  data <= "11110000";  -- 7376 = F0
      when "111001101110111" =>  data <= "10100101";  -- 7377 = A5
      when "111001101111000" =>  data <= "11010011";  -- 7378 = D3
      when "111001101111001" =>  data <= "00100000";  -- 7379 = 20
      when "111001101111010" =>  data <= "10010011";  -- 737A = 93
      when "111001101111011" =>  data <= "11110001";  -- 737B = F1
      when "111001101111100" =>  data <= "00100000";  -- 737C = 20
      when "111001101111101" =>  data <= "11000000";  -- 737D = C0
      when "111001101111110" =>  data <= "11110001";  -- 737E = F1
      when "111001101111111" =>  data <= "10000101";  -- 737F = 85
      when "111001110000000" =>  data <= "11111011";  -- 7380 = FB
      when "111001110000001" =>  data <= "10100101";  -- 7381 = A5
      when "111001110000010" =>  data <= "10010110";  -- 7382 = 96
      when "111001110000011" =>  data <= "01001010";  -- 7383 = 4A
      when "111001110000100" =>  data <= "01001010";  -- 7384 = 4A
      when "111001110000101" =>  data <= "10110000";  -- 7385 = B0
      when "111001110000110" =>  data <= "00111010";  -- 7386 = 3A
      when "111001110000111" =>  data <= "00100000";  -- 7387 = 20
      when "111001110001000" =>  data <= "11000000";  -- 7388 = C0
      when "111001110001001" =>  data <= "11110001";  -- 7389 = F1
      when "111001110001010" =>  data <= "10000101";  -- 738A = 85
      when "111001110001011" =>  data <= "11111100";  -- 738B = FC
      when "111001110001100" =>  data <= "00100000";  -- 738C = 20
      when "111001110001101" =>  data <= "01101101";  -- 738D = 6D
      when "111001110001110" =>  data <= "11110100";  -- 738E = F4
      when "111001110001111" =>  data <= "10101001";  -- 738F = A9
      when "111001110010000" =>  data <= "11111101";  -- 7390 = FD
      when "111001110010001" =>  data <= "00100101";  -- 7391 = 25
      when "111001110010010" =>  data <= "10010110";  -- 7392 = 96
      when "111001110010011" =>  data <= "10000101";  -- 7393 = 85
      when "111001110010100" =>  data <= "10010110";  -- 7394 = 96
      when "111001110010101" =>  data <= "00100000";  -- 7395 = 20
      when "111001110010110" =>  data <= "01000011";  -- 7396 = 43
      when "111001110010111" =>  data <= "11110011";  -- 7397 = F3
      when "111001110011000" =>  data <= "00100000";  -- 7398 = 20
      when "111001110011001" =>  data <= "11000000";  -- 7399 = C0
      when "111001110011010" =>  data <= "11110001";  -- 739A = F1
      when "111001110011011" =>  data <= "10101010";  -- 739B = AA
      when "111001110011100" =>  data <= "10100101";  -- 739C = A5
      when "111001110011101" =>  data <= "10010110";  -- 739D = 96
      when "111001110011110" =>  data <= "01001010";  -- 739E = 4A
      when "111001110011111" =>  data <= "01001010";  -- 739F = 4A
      when "111001110100000" =>  data <= "10110000";  -- 73A0 = B0
      when "111001110100001" =>  data <= "11101101";  -- 73A1 = ED
      when "111001110100010" =>  data <= "10001010";  -- 73A2 = 8A
      when "111001110100011" =>  data <= "10100100";  -- 73A3 = A4
      when "111001110100100" =>  data <= "10011101";  -- 73A4 = 9D
      when "111001110100101" =>  data <= "11110000";  -- 73A5 = F0
      when "111001110100110" =>  data <= "00001100";  -- 73A6 = C
      when "111001110100111" =>  data <= "10001000";  -- 73A7 = 88
      when "111001110101000" =>  data <= "11010001";  -- 73A8 = D1
      when "111001110101001" =>  data <= "11111011";  -- 73A9 = FB
      when "111001110101010" =>  data <= "11110000";  -- 73AA = F0
      when "111001110101011" =>  data <= "00001001";  -- 73AB = 9
      when "111001110101100" =>  data <= "10101001";  -- 73AC = A9
      when "111001110101101" =>  data <= "00010000";  -- 73AD = 10
      when "111001110101110" =>  data <= "00000101";  -- 73AE = 5
      when "111001110101111" =>  data <= "10010110";  -- 73AF = 96
      when "111001110110000" =>  data <= "10000101";  -- 73B0 = 85
      when "111001110110001" =>  data <= "10010110";  -- 73B1 = 96
      when "111001110110010" =>  data <= "00101100";  -- 73B2 = 2C
      when "111001110110011" =>  data <= "10010001";  -- 73B3 = 91
      when "111001110110100" =>  data <= "11111011";  -- 73B4 = FB
      when "111001110110101" =>  data <= "11100110";  -- 73B5 = E6
      when "111001110110110" =>  data <= "11111011";  -- 73B6 = FB
      when "111001110110111" =>  data <= "11010000";  -- 73B7 = D0
      when "111001110111000" =>  data <= "00000010";  -- 73B8 = 2
      when "111001110111001" =>  data <= "11100110";  -- 73B9 = E6
      when "111001110111010" =>  data <= "11111100";  -- 73BA = FC
      when "111001110111011" =>  data <= "00100100";  -- 73BB = 24
      when "111001110111100" =>  data <= "10010110";  -- 73BC = 96
      when "111001110111101" =>  data <= "01110000";  -- 73BD = 70
      when "111001110111110" =>  data <= "00000111";  -- 73BE = 7
      when "111001110111111" =>  data <= "01010000";  -- 73BF = 50
      when "111001111000000" =>  data <= "11001110";  -- 73C0 = CE
      when "111001111000001" =>  data <= "10100000";  -- 73C1 = A0
      when "111001111000010" =>  data <= "00100100";  -- 73C2 = 24
      when "111001111000011" =>  data <= "01001100";  -- 73C3 = 4C
      when "111001111000100" =>  data <= "10101111";  -- 73C4 = AF
      when "111001111000101" =>  data <= "11110101";  -- 73C5 = F5
      when "111001111000110" =>  data <= "10100101";  -- 73C6 = A5
      when "111001111000111" =>  data <= "11111011";  -- 73C7 = FB
      when "111001111001000" =>  data <= "10000101";  -- 73C8 = 85
      when "111001111001001" =>  data <= "11001001";  -- 73C9 = C9
      when "111001111001010" =>  data <= "10100101";  -- 73CA = A5
      when "111001111001011" =>  data <= "11111100";  -- 73CB = FC
      when "111001111001100" =>  data <= "10000101";  -- 73CC = 85
      when "111001111001101" =>  data <= "11001010";  -- 73CD = CA
      when "111001111001110" =>  data <= "00100000";  -- 73CE = 20
      when "111001111001111" =>  data <= "10101110";  -- 73CF = AE
      when "111001111010000" =>  data <= "11110001";  -- 73D0 = F1
      when "111001111010001" =>  data <= "01001100";  -- 73D1 = 4C
      when "111001111010010" =>  data <= "00101111";  -- 73D2 = 2F
      when "111001111010011" =>  data <= "11110111";  -- 73D3 = F7
      when "111001111010100" =>  data <= "00100000";  -- 73D4 = 20
      when "111001111010101" =>  data <= "10010101";  -- 73D5 = 95
      when "111001111010110" =>  data <= "11110110";  -- 73D6 = F6
      when "111001111010111" =>  data <= "00100000";  -- 73D7 = 20
      when "111001111011000" =>  data <= "01010111";  -- 73D8 = 57
      when "111001111011001" =>  data <= "11111000";  -- 73D9 = F8
      when "111001111011010" =>  data <= "00100000";  -- 73DA = 20
      when "111001111011011" =>  data <= "01001001";  -- 73DB = 49
      when "111001111011100" =>  data <= "11110100";  -- 73DC = F4
      when "111001111011101" =>  data <= "10100101";  -- 73DD = A5
      when "111001111011110" =>  data <= "11010001";  -- 73DE = D1
      when "111001111011111" =>  data <= "11110000";  -- 73DF = F0
      when "111001111100000" =>  data <= "00001000";  -- 73E0 = 8
      when "111001111100001" =>  data <= "00100000";  -- 73E1 = 20
      when "111001111100010" =>  data <= "11010011";  -- 73E2 = D3
      when "111001111100011" =>  data <= "11110100";  -- 73E3 = F4
      when "111001111100100" =>  data <= "11010000";  -- 73E4 = D0
      when "111001111100101" =>  data <= "00001000";  -- 73E5 = 8
      when "111001111100110" =>  data <= "01001100";  -- 73E6 = 4C
      when "111001111100111" =>  data <= "10101101";  -- 73E7 = AD
      when "111001111101000" =>  data <= "11110101";  -- 73E8 = F5
      when "111001111101001" =>  data <= "00100000";  -- 73E9 = 20
      when "111001111101010" =>  data <= "11100101";  -- 73EA = E5
      when "111001111101011" =>  data <= "11110101";  -- 73EB = F5
      when "111001111101100" =>  data <= "11110000";  -- 73EC = F0
      when "111001111101101" =>  data <= "11111000";  -- 73ED = F8
      when "111001111101110" =>  data <= "11100000";  -- 73EE = E0
      when "111001111101111" =>  data <= "00000001";  -- 73EF = 1
      when "111001111110000" =>  data <= "11010000";  -- 73F0 = D0
      when "111001111110001" =>  data <= "11101011";  -- 73F1 = EB
      when "111001111110010" =>  data <= "10100101";  -- 73F2 = A5
      when "111001111110011" =>  data <= "10010110";  -- 73F3 = 96
      when "111001111110100" =>  data <= "00101001";  -- 73F4 = 29
      when "111001111110101" =>  data <= "00010000";  -- 73F5 = 10
      when "111001111110110" =>  data <= "11010000";  -- 73F6 = D0
      when "111001111110111" =>  data <= "01110100";  -- 73F7 = 74
      when "111001111111000" =>  data <= "00100000";  -- 73F8 = 20
      when "111001111111001" =>  data <= "01111011";  -- 73F9 = 7B
      when "111001111111010" =>  data <= "11110110";  -- 73FA = F6
      when "111001111111011" =>  data <= "00100000";  -- 73FB = 20
      when "111001111111100" =>  data <= "01101101";  -- 73FC = 6D
      when "111001111111101" =>  data <= "11110100";  -- 73FD = F4
      when "111001111111110" =>  data <= "01001100";  -- 73FE = 4C
      when "111001111111111" =>  data <= "10100011";  -- 73FF = A3
      when "111010000000000" =>  data <= "11111000";  -- 7400 = F8
      when "111010000000001" =>  data <= "10101001";  -- 7401 = A9
      when "111010000000010" =>  data <= "00000000";  -- 7402 = 0
      when "111010000000011" =>  data <= "10000101";  -- 7403 = 85
      when "111010000000100" =>  data <= "10011101";  -- 7404 = 9D
      when "111010000000101" =>  data <= "00100000";  -- 7405 = 20
      when "111010000000110" =>  data <= "01111101";  -- 7406 = 7D
      when "111010000000111" =>  data <= "11110100";  -- 7407 = F4
      when "111010000001000" =>  data <= "00100000";  -- 7408 = 20
      when "111010000001001" =>  data <= "11001100";  -- 7409 = CC
      when "111010000001010" =>  data <= "11110110";  -- 740A = F6
      when "111010000001011" =>  data <= "10101001";  -- 740B = A9
      when "111010000001100" =>  data <= "11111111";  -- 740C = FF
      when "111010000001101" =>  data <= "11000101";  -- 740D = C5
      when "111010000001110" =>  data <= "10011011";  -- 740E = 9B
      when "111010000001111" =>  data <= "11010000";  -- 740F = D0
      when "111010000010000" =>  data <= "11111100";  -- 7410 = FC
      when "111010000010001" =>  data <= "11000101";  -- 7411 = C5
      when "111010000010010" =>  data <= "10011011";  -- 7412 = 9B
      when "111010000010011" =>  data <= "11010000";  -- 7413 = D0
      when "111010000010100" =>  data <= "11111000";  -- 7414 = F8
      when "111010000010101" =>  data <= "00100000";  -- 7415 = 20
      when "111010000010110" =>  data <= "01010110";  -- 7416 = 56
      when "111010000010111" =>  data <= "11110011";  -- 7417 = F3
      when "111010000011000" =>  data <= "10100101";  -- 7418 = A5
      when "111010000011001" =>  data <= "10011101";  -- 7419 = 9D
      when "111010000011010" =>  data <= "11010000";  -- 741A = D0
      when "111010000011011" =>  data <= "01010000";  -- 741B = 50
      when "111010000011100" =>  data <= "00100000";  -- 741C = 20
      when "111010000011101" =>  data <= "00101011";  -- 741D = 2B
      when "111010000011110" =>  data <= "11111001";  -- 741E = F9
      when "111010000011111" =>  data <= "10100101";  -- 741F = A5
      when "111010000100000" =>  data <= "10010110";  -- 7420 = 96
      when "111010000100001" =>  data <= "00101001";  -- 7421 = 29
      when "111010000100010" =>  data <= "00010000";  -- 7422 = 10
      when "111010000100011" =>  data <= "11110000";  -- 7423 = F0
      when "111010000100100" =>  data <= "00001001";  -- 7424 = 9
      when "111010000100101" =>  data <= "10100000";  -- 7425 = A0
      when "111010000100110" =>  data <= "00000000";  -- 7426 = 0
      when "111010000100111" =>  data <= "10000100";  -- 7427 = 84
      when "111010000101000" =>  data <= "10011110";  -- 7428 = 9E
      when "111010000101001" =>  data <= "10100000";  -- 7429 = A0
      when "111010000101010" =>  data <= "01100000";  -- 742A = 60
      when "111010000101011" =>  data <= "01001100";  -- 742B = 4C
      when "111010000101100" =>  data <= "10101111";  -- 742C = AF
      when "111010000101101" =>  data <= "11110101";  -- 742D = F5
      when "111010000101110" =>  data <= "10100000";  -- 742E = A0
      when "111010000101111" =>  data <= "10101110";  -- 742F = AE
      when "111010000110000" =>  data <= "00100000";  -- 7430 = 20
      when "111010000110001" =>  data <= "01001001";  -- 7431 = 49
      when "111010000110010" =>  data <= "11110011";  -- 7432 = F3
      when "111010000110011" =>  data <= "00100000";  -- 7433 = 20
      when "111010000110100" =>  data <= "01010001";  -- 7434 = 51
      when "111010000110101" =>  data <= "11110011";  -- 7435 = F3
      when "111010000110110" =>  data <= "11010000";  -- 7436 = D0
      when "111010000110111" =>  data <= "00001011";  -- 7437 = B
      when "111010000111000" =>  data <= "10100101";  -- 7438 = A5
      when "111010000111001" =>  data <= "11001010";  -- 7439 = CA
      when "111010000111010" =>  data <= "10000101";  -- 743A = 85
      when "111010000111011" =>  data <= "00101011";  -- 743B = 2B
      when "111010000111100" =>  data <= "10100101";  -- 743C = A5
      when "111010000111101" =>  data <= "11001001";  -- 743D = C9
      when "111010000111110" =>  data <= "10000101";  -- 743E = 85
      when "111010000111111" =>  data <= "00101010";  -- 743F = 2A
      when "111010001000000" =>  data <= "01001100";  -- 7440 = 4C
      when "111010001000001" =>  data <= "10101101";  -- 7441 = AD
      when "111010001000010" =>  data <= "10110100";  -- 7442 = B4
      when "111010001000011" =>  data <= "00100000";  -- 7443 = 20
      when "111010001000100" =>  data <= "00100010";  -- 7444 = 22
      when "111010001000101" =>  data <= "10110110";  -- 7445 = B6
      when "111010001000110" =>  data <= "01001100";  -- 7446 = 4C
      when "111010001000111" =>  data <= "00001011";  -- 7447 = B
      when "111010001001000" =>  data <= "10110110";  -- 7448 = B6
      when "111010001001001" =>  data <= "00100000";  -- 7449 = 20
      when "111010001001010" =>  data <= "01010001";  -- 744A = 51
      when "111010001001011" =>  data <= "11110011";  -- 744B = F3
      when "111010001001100" =>  data <= "11010000";  -- 744C = D0
      when "111010001001101" =>  data <= "00011110";  -- 744D = 1E
      when "111010001001110" =>  data <= "10100000";  -- 744E = A0
      when "111010001001111" =>  data <= "00110010";  -- 744F = 32
      when "111010001010000" =>  data <= "00100000";  -- 7450 = 20
      when "111010001010001" =>  data <= "10000101";  -- 7451 = 85
      when "111010001010010" =>  data <= "11110001";  -- 7452 = F1
      when "111010001010011" =>  data <= "10100101";  -- 7453 = A5
      when "111010001010100" =>  data <= "11010001";  -- 7454 = D1
      when "111010001010101" =>  data <= "11110000";  -- 7455 = F0
      when "111010001010110" =>  data <= "00010101";  -- 7456 = 15
      when "111010001010111" =>  data <= "10100000";  -- 7457 = A0
      when "111010001011000" =>  data <= "00111101";  -- 7458 = 3D
      when "111010001011001" =>  data <= "00100000";  -- 7459 = 20
      when "111010001011010" =>  data <= "10000101";  -- 745A = 85
      when "111010001011011" =>  data <= "11110001";  -- 745B = F1
      when "111010001011100" =>  data <= "10100100";  -- 745C = A4
      when "111010001011101" =>  data <= "11010001";  -- 745D = D1
      when "111010001011110" =>  data <= "11110000";  -- 745E = F0
      when "111010001011111" =>  data <= "00001100";  -- 745F = C
      when "111010001100000" =>  data <= "10100000";  -- 7460 = A0
      when "111010001100001" =>  data <= "00000000";  -- 7461 = 0
      when "111010001100010" =>  data <= "10110001";  -- 7462 = B1
      when "111010001100011" =>  data <= "11011010";  -- 7463 = DA
      when "111010001100100" =>  data <= "00100000";  -- 7464 = 20
      when "111010001100101" =>  data <= "01100110";  -- 7465 = 66
      when "111010001100110" =>  data <= "11110010";  -- 7466 = F2
      when "111010001100111" =>  data <= "11001000";  -- 7467 = C8
      when "111010001101000" =>  data <= "11000100";  -- 7468 = C4
      when "111010001101001" =>  data <= "11010001";  -- 7469 = D1
      when "111010001101010" =>  data <= "11010000";  -- 746A = D0
      when "111010001101011" =>  data <= "11110110";  -- 746B = F6
      when "111010001101100" =>  data <= "01100000";  -- 746C = 60
      when "111010001101101" =>  data <= "10100000";  -- 746D = A0
      when "111010001101110" =>  data <= "01011111";  -- 746E = 5F
      when "111010001101111" =>  data <= "10100101";  -- 746F = A5
      when "111010001110000" =>  data <= "10011101";  -- 7470 = 9D
      when "111010001110001" =>  data <= "11110000";  -- 7471 = F0
      when "111010001110010" =>  data <= "00000010";  -- 7472 = 2
      when "111010001110011" =>  data <= "10100000";  -- 7473 = A0
      when "111010001110100" =>  data <= "01101101";  -- 7474 = 6D
      when "111010001110101" =>  data <= "00100000";  -- 7475 = 20
      when "111010001110110" =>  data <= "01001001";  -- 7476 = 49
      when "111010001110111" =>  data <= "11110011";  -- 7477 = F3
      when "111010001111000" =>  data <= "10100000";  -- 7478 = A0
      when "111010001111001" =>  data <= "00111001";  -- 7479 = 39
      when "111010001111010" =>  data <= "01001100";  -- 747A = 4C
      when "111010001111011" =>  data <= "01001001";  -- 747B = 49
      when "111010001111100" =>  data <= "11110011";  -- 747C = F3
      when "111010001111101" =>  data <= "10100010";  -- 747D = A2
      when "111010001111110" =>  data <= "00000000";  -- 747E = 0
      when "111010001111111" =>  data <= "10000110";  -- 747F = 86
      when "111010010000000" =>  data <= "10010110";  -- 7480 = 96
      when "111010010000001" =>  data <= "10000110";  -- 7481 = 86
      when "111010010000010" =>  data <= "11010001";  -- 7482 = D1
      when "111010010000011" =>  data <= "10000110";  -- 7483 = 86
      when "111010010000100" =>  data <= "11010011";  -- 7484 = D3
      when "111010010000101" =>  data <= "11101000";  -- 7485 = E8
      when "111010010000110" =>  data <= "10000110";  -- 7486 = 86
      when "111010010000111" =>  data <= "11010100";  -- 7487 = D4
      when "111010010001000" =>  data <= "00100000";  -- 7488 = 20
      when "111010010001001" =>  data <= "01001101";  -- 7489 = 4D
      when "111010010001010" =>  data <= "11110101";  -- 748A = F5
      when "111010010001011" =>  data <= "00100000";  -- 748B = 20
      when "111010010001100" =>  data <= "00111100";  -- 748C = 3C
      when "111010010001101" =>  data <= "11110101";  -- 748D = F5
      when "111010010001110" =>  data <= "00100000";  -- 748E = 20
      when "111010010001111" =>  data <= "01001101";  -- 748F = 4D
      when "111010010010000" =>  data <= "11110101";  -- 7490 = F5
      when "111010010010001" =>  data <= "00100000";  -- 7491 = 20
      when "111010010010010" =>  data <= "10011111";  -- 7492 = 9F
      when "111010010010011" =>  data <= "11110100";  -- 7493 = F4
      when "111010010010100" =>  data <= "10000110";  -- 7494 = 86
      when "111010010010101" =>  data <= "11010100";  -- 7495 = D4
      when "111010010010110" =>  data <= "00100000";  -- 7496 = 20
      when "111010010010111" =>  data <= "01001101";  -- 7497 = 4D
      when "111010010011000" =>  data <= "11110101";  -- 7498 = F5
      when "111010010011001" =>  data <= "00100000";  -- 7499 = 20
      when "111010010011010" =>  data <= "10011111";  -- 749A = 9F
      when "111010010011011" =>  data <= "11110100";  -- 749B = F4
      when "111010010011100" =>  data <= "10000110";  -- 749C = 86
      when "111010010011101" =>  data <= "11010011";  -- 749D = D3
      when "111010010011110" =>  data <= "01100000";  -- 749E = 60
      when "111010010011111" =>  data <= "00100000";  -- 749F = 20
      when "111010010100000" =>  data <= "01010101";  -- 74A0 = 55
      when "111010010100001" =>  data <= "11110101";  -- 74A1 = F5
      when "111010010100010" =>  data <= "01001100";  -- 74A2 = 4C
      when "111010010100011" =>  data <= "11010100";  -- 74A3 = D4
      when "111010010100100" =>  data <= "11001000";  -- 74A4 = C8
      when "111010010100101" =>  data <= "10100101";  -- 74A5 = A5
      when "111010010100110" =>  data <= "11010011";  -- 74A6 = D3
      when "111010010100111" =>  data <= "00110000";  -- 74A7 = 30
      when "111010010101000" =>  data <= "11110101";  -- 74A8 = F5
      when "111010010101001" =>  data <= "10100100";  -- 74A9 = A4
      when "111010010101010" =>  data <= "11010001";  -- 74AA = D1
      when "111010010101011" =>  data <= "11110000";  -- 74AB = F0
      when "111010010101100" =>  data <= "11110001";  -- 74AC = F1
      when "111010010101101" =>  data <= "00100000";  -- 74AD = 20
      when "111010010101110" =>  data <= "11010101";  -- 74AE = D5
      when "111010010101111" =>  data <= "11110000";  -- 74AF = F0
      when "111010010110000" =>  data <= "10100101";  -- 74B0 = A5
      when "111010010110001" =>  data <= "11010011";  -- 74B1 = D3
      when "111010010110010" =>  data <= "00001001";  -- 74B2 = 9
      when "111010010110011" =>  data <= "11110000";  -- 74B3 = F0
      when "111010010110100" =>  data <= "00100000";  -- 74B4 = 20
      when "111010010110101" =>  data <= "01000011";  -- 74B5 = 43
      when "111010010110110" =>  data <= "11110001";  -- 74B6 = F1
      when "111010010110111" =>  data <= "10100101";  -- 74B7 = A5
      when "111010010111000" =>  data <= "10010110";  -- 74B8 = 96
      when "111010010111001" =>  data <= "00010000";  -- 74B9 = 10
      when "111010010111010" =>  data <= "00000101";  -- 74BA = 5
      when "111010010111011" =>  data <= "10100000";  -- 74BB = A0
      when "111010010111100" =>  data <= "01110100";  -- 74BC = 74
      when "111010010111101" =>  data <= "01001100";  -- 74BD = 4C
      when "111010010111110" =>  data <= "10101111";  -- 74BE = AF
      when "111010010111111" =>  data <= "11110101";  -- 74BF = F5
      when "111010011000000" =>  data <= "10100101";  -- 74C0 = A5
      when "111010011000001" =>  data <= "11010001";  -- 74C1 = D1
      when "111010011000010" =>  data <= "11110000";  -- 74C2 = F0
      when "111010011000011" =>  data <= "00001100";  -- 74C3 = C
      when "111010011000100" =>  data <= "10100000";  -- 74C4 = A0
      when "111010011000101" =>  data <= "00000000";  -- 74C5 = 0
      when "111010011000110" =>  data <= "10110001";  -- 74C6 = B1
      when "111010011000111" =>  data <= "11011010";  -- 74C7 = DA
      when "111010011001000" =>  data <= "00100000";  -- 74C8 = 20
      when "111010011001001" =>  data <= "10011110";  -- 74C9 = 9E
      when "111010011001010" =>  data <= "11110001";  -- 74CA = F1
      when "111010011001011" =>  data <= "11001000";  -- 74CB = C8
      when "111010011001100" =>  data <= "11000100";  -- 74CC = C4
      when "111010011001101" =>  data <= "11010001";  -- 74CD = D1
      when "111010011001110" =>  data <= "11010000";  -- 74CE = D0
      when "111010011001111" =>  data <= "11110110";  -- 74CF = F6
      when "111010011010000" =>  data <= "01001100";  -- 74D0 = 4C
      when "111010011010001" =>  data <= "10111001";  -- 74D1 = B9
      when "111010011010010" =>  data <= "11110001";  -- 74D2 = F1
      when "111010011010011" =>  data <= "00100000";  -- 74D3 = 20
      when "111010011010100" =>  data <= "11100101";  -- 74D4 = E5
      when "111010011010101" =>  data <= "11110101";  -- 74D5 = F5
      when "111010011010110" =>  data <= "11110000";  -- 74D6 = F0
      when "111010011010111" =>  data <= "00011101";  -- 74D7 = 1D
      when "111010011011000" =>  data <= "10100000";  -- 74D8 = A0
      when "111010011011001" =>  data <= "00000101";  -- 74D9 = 5
      when "111010011011010" =>  data <= "10000100";  -- 74DA = 84
      when "111010011011011" =>  data <= "10110101";  -- 74DB = B5
      when "111010011011100" =>  data <= "10100000";  -- 74DC = A0
      when "111010011011101" =>  data <= "00000000";  -- 74DD = 0
      when "111010011011110" =>  data <= "10000100";  -- 74DE = 84
      when "111010011011111" =>  data <= "10110100";  -- 74DF = B4
      when "111010011100000" =>  data <= "11000100";  -- 74E0 = C4
      when "111010011100001" =>  data <= "11010001";  -- 74E1 = D1
      when "111010011100010" =>  data <= "11110000";  -- 74E2 = F0
      when "111010011100011" =>  data <= "00010000";  -- 74E3 = 10
      when "111010011100100" =>  data <= "10110001";  -- 74E4 = B1
      when "111010011100101" =>  data <= "11011010";  -- 74E5 = DA
      when "111010011100110" =>  data <= "10100100";  -- 74E6 = A4
      when "111010011100111" =>  data <= "10110101";  -- 74E7 = B5
      when "111010011101000" =>  data <= "11010001";  -- 74E8 = D1
      when "111010011101001" =>  data <= "11010110";  -- 74E9 = D6
      when "111010011101010" =>  data <= "11010000";  -- 74EA = D0
      when "111010011101011" =>  data <= "11100111";  -- 74EB = E7
      when "111010011101100" =>  data <= "11100110";  -- 74EC = E6
      when "111010011101101" =>  data <= "10110100";  -- 74ED = B4
      when "111010011101110" =>  data <= "11100110";  -- 74EE = E6
      when "111010011101111" =>  data <= "10110101";  -- 74EF = B5
      when "111010011110000" =>  data <= "10100100";  -- 74F0 = A4
      when "111010011110001" =>  data <= "10110100";  -- 74F1 = B4
      when "111010011110010" =>  data <= "11010000";  -- 74F2 = D0
      when "111010011110011" =>  data <= "11101100";  -- 74F3 = EC
      when "111010011110100" =>  data <= "10011000";  -- 74F4 = 98
      when "111010011110101" =>  data <= "01100000";  -- 74F5 = 60
      when "111010011110110" =>  data <= "10101001";  -- 74F6 = A9
      when "111010011110111" =>  data <= "00000001";  -- 74F7 = 1
      when "111010011111000" =>  data <= "10000101";  -- 74F8 = 85
      when "111010011111001" =>  data <= "10011101";  -- 74F9 = 9D
      when "111010011111010" =>  data <= "00100000";  -- 74FA = 20
      when "111010011111011" =>  data <= "00000101";  -- 74FB = 5
      when "111010011111100" =>  data <= "11110100";  -- 74FC = F4
      when "111010011111101" =>  data <= "10100101";  -- 74FD = A5
      when "111010011111110" =>  data <= "10010110";  -- 74FE = 96
      when "111010011111111" =>  data <= "00101001";  -- 74FF = 29
      when "111010100000000" =>  data <= "00010000";  -- 7500 = 10
      when "111010100000001" =>  data <= "11110000";  -- 7501 = F0
      when "111010100000010" =>  data <= "00000101";  -- 7502 = 5
      when "111010100000011" =>  data <= "10100000";  -- 7503 = A0
      when "111010100000100" =>  data <= "01101110";  -- 7504 = 6E
      when "111010100000101" =>  data <= "01001100";  -- 7505 = 4C
      when "111010100000110" =>  data <= "10101111";  -- 7506 = AF
      when "111010100000111" =>  data <= "11110101";  -- 7507 = F5
      when "111010100001000" =>  data <= "10100000";  -- 7508 = A0
      when "111010100001001" =>  data <= "10101010";  -- 7509 = AA
      when "111010100001010" =>  data <= "01001100";  -- 750A = 4C
      when "111010100001011" =>  data <= "10000101";  -- 750B = 85
      when "111010100001100" =>  data <= "11110001";  -- 750C = F1
      when "111010100001101" =>  data <= "10100010";  -- 750D = A2
      when "111010100001110" =>  data <= "00000000";  -- 750E = 0
      when "111010100001111" =>  data <= "10000110";  -- 750F = 86
      when "111010100010000" =>  data <= "11010011";  -- 7510 = D3
      when "111010100010001" =>  data <= "10000110";  -- 7511 = 86
      when "111010100010010" =>  data <= "10010110";  -- 7512 = 96
      when "111010100010011" =>  data <= "10000110";  -- 7513 = 86
      when "111010100010100" =>  data <= "11010001";  -- 7514 = D1
      when "111010100010101" =>  data <= "11101000";  -- 7515 = E8
      when "111010100010110" =>  data <= "10000110";  -- 7516 = 86
      when "111010100010111" =>  data <= "11010100";  -- 7517 = D4
      when "111010100011000" =>  data <= "00100000";  -- 7518 = 20
      when "111010100011001" =>  data <= "01011000";  -- 7519 = 58
      when "111010100011010" =>  data <= "11110101";  -- 751A = F5
      when "111010100011011" =>  data <= "00100000";  -- 751B = 20
      when "111010100011100" =>  data <= "11010100";  -- 751C = D4
      when "111010100011101" =>  data <= "11001000";  -- 751D = C8
      when "111010100011110" =>  data <= "10000110";  -- 751E = 86
      when "111010100011111" =>  data <= "11010010";  -- 751F = D2
      when "111010100100000" =>  data <= "00100000";  -- 7520 = 20
      when "111010100100001" =>  data <= "01001101";  -- 7521 = 4D
      when "111010100100010" =>  data <= "11110101";  -- 7522 = F5
      when "111010100100011" =>  data <= "00100000";  -- 7523 = 20
      when "111010100100100" =>  data <= "10011111";  -- 7524 = 9F
      when "111010100100101" =>  data <= "11110100";  -- 7525 = F4
      when "111010100100110" =>  data <= "10000110";  -- 7526 = 86
      when "111010100100111" =>  data <= "11010100";  -- 7527 = D4
      when "111010100101000" =>  data <= "11100000";  -- 7528 = E0
      when "111010100101001" =>  data <= "00000011";  -- 7529 = 3
      when "111010100101010" =>  data <= "10010000";  -- 752A = 90
      when "111010100101011" =>  data <= "00000010";  -- 752B = 2
      when "111010100101100" =>  data <= "11000110";  -- 752C = C6
      when "111010100101101" =>  data <= "11010011";  -- 752D = D3
      when "111010100101110" =>  data <= "00100000";  -- 752E = 20
      when "111010100101111" =>  data <= "01001101";  -- 752F = 4D
      when "111010100110000" =>  data <= "11110101";  -- 7530 = F5
      when "111010100110001" =>  data <= "00100000";  -- 7531 = 20
      when "111010100110010" =>  data <= "10011111";  -- 7532 = 9F
      when "111010100110011" =>  data <= "11110100";  -- 7533 = F4
      when "111010100110100" =>  data <= "10000110";  -- 7534 = 86
      when "111010100110101" =>  data <= "11010011";  -- 7535 = D3
      when "111010100110110" =>  data <= "00100000";  -- 7536 = 20
      when "111010100110111" =>  data <= "01001101";  -- 7537 = 4D
      when "111010100111000" =>  data <= "11110101";  -- 7538 = F5
      when "111010100111001" =>  data <= "00100000";  -- 7539 = 20
      when "111010100111010" =>  data <= "01010101";  -- 753A = 55
      when "111010100111011" =>  data <= "11110101";  -- 753B = F5
      when "111010100111100" =>  data <= "00100000";  -- 753C = 20
      when "111010100111101" =>  data <= "10011000";  -- 753D = 98
      when "111010100111110" =>  data <= "10111101";  -- 753E = BD
      when "111010100111111" =>  data <= "00100000";  -- 753F = 20
      when "111010101000000" =>  data <= "10110101";  -- 7540 = B5
      when "111010101000001" =>  data <= "11000111";  -- 7541 = C7
      when "111010101000010" =>  data <= "10000101";  -- 7542 = 85
      when "111010101000011" =>  data <= "11010001";  -- 7543 = D1
      when "111010101000100" =>  data <= "10100101";  -- 7544 = A5
      when "111010101000101" =>  data <= "00011111";  -- 7545 = 1F
      when "111010101000110" =>  data <= "10000101";  -- 7546 = 85
      when "111010101000111" =>  data <= "11011010";  -- 7547 = DA
      when "111010101001000" =>  data <= "10100101";  -- 7548 = A5
      when "111010101001001" =>  data <= "00100000";  -- 7549 = 20
      when "111010101001010" =>  data <= "10000101";  -- 754A = 85
      when "111010101001011" =>  data <= "11011011";  -- 754B = DB
      when "111010101001100" =>  data <= "01100000";  -- 754C = 60
      when "111010101001101" =>  data <= "00100000";  -- 754D = 20
      when "111010101001110" =>  data <= "01110110";  -- 754E = 76
      when "111010101001111" =>  data <= "00000000";  -- 754F = 0
      when "111010101010000" =>  data <= "11010000";  -- 7550 = D0
      when "111010101010001" =>  data <= "00000010";  -- 7551 = 2
      when "111010101010010" =>  data <= "01101000";  -- 7552 = 68
      when "111010101010011" =>  data <= "01101000";  -- 7553 = 68
      when "111010101010100" =>  data <= "01100000";  -- 7554 = 60
      when "111010101010101" =>  data <= "00100000";  -- 7555 = 20
      when "111010101010110" =>  data <= "11110101";  -- 7556 = F5
      when "111010101010111" =>  data <= "10111110";  -- 7557 = BE
      when "111010101011000" =>  data <= "00100000";  -- 7558 = 20
      when "111010101011001" =>  data <= "01110110";  -- 7559 = 76
      when "111010101011010" =>  data <= "00000000";  -- 755A = 0
      when "111010101011011" =>  data <= "11010000";  -- 755B = D0
      when "111010101011100" =>  data <= "11110111";  -- 755C = F7
      when "111010101011101" =>  data <= "01001100";  -- 755D = 4C
      when "111010101011110" =>  data <= "00000000";  -- 755E = 0
      when "111010101011111" =>  data <= "10111111";  -- 755F = BF
      when "111010101100000" =>  data <= "00100000";  -- 7560 = 20
      when "111010101100001" =>  data <= "00001101";  -- 7561 = D
      when "111010101100010" =>  data <= "11110101";  -- 7562 = F5
      when "111010101100011" =>  data <= "10100101";  -- 7563 = A5
      when "111010101100100" =>  data <= "11010010";  -- 7564 = D2
      when "111010101100101" =>  data <= "11110000";  -- 7565 = F0
      when "111010101100110" =>  data <= "11110110";  -- 7566 = F6
      when "111010101100111" =>  data <= "10100000";  -- 7567 = A0
      when "111010101101000" =>  data <= "00001110";  -- 7568 = E
      when "111010101101001" =>  data <= "00100000";  -- 7569 = 20
      when "111010101101010" =>  data <= "11000001";  -- 756A = C1
      when "111010101101011" =>  data <= "11110010";  -- 756B = F2
      when "111010101101100" =>  data <= "11110000";  -- 756C = F0
      when "111010101101101" =>  data <= "01000001";  -- 756D = 41
      when "111010101101110" =>  data <= "10100110";  -- 756E = A6
      when "111010101101111" =>  data <= "10101110";  -- 756F = AE
      when "111010101110000" =>  data <= "10100000";  -- 7570 = A0
      when "111010101110001" =>  data <= "00000000";  -- 7571 = 0
      when "111010101110010" =>  data <= "10000100";  -- 7572 = 84
      when "111010101110011" =>  data <= "10010110";  -- 7573 = 96
      when "111010101110100" =>  data <= "11100000";  -- 7574 = E0
      when "111010101110101" =>  data <= "00001010";  -- 7575 = A
      when "111010101110110" =>  data <= "11110000";  -- 7576 = F0
      when "111010101110111" =>  data <= "00110111";  -- 7577 = 37
      when "111010101111000" =>  data <= "11100110";  -- 7578 = E6
      when "111010101111001" =>  data <= "10101110";  -- 7579 = AE
      when "111010101111010" =>  data <= "10100101";  -- 757A = A5
      when "111010101111011" =>  data <= "11010010";  -- 757B = D2
      when "111010101111100" =>  data <= "10011101";  -- 757C = 9D
      when "111010101111101" =>  data <= "01010001";  -- 757D = 51
      when "111010101111110" =>  data <= "00000010";  -- 757E = 2
      when "111010101111111" =>  data <= "10100101";  -- 757F = A5
      when "111010110000000" =>  data <= "11010011";  -- 7580 = D3
      when "111010110000001" =>  data <= "00001001";  -- 7581 = 9
      when "111010110000010" =>  data <= "01100000";  -- 7582 = 60
      when "111010110000011" =>  data <= "10000101";  -- 7583 = 85
      when "111010110000100" =>  data <= "11010011";  -- 7584 = D3
      when "111010110000101" =>  data <= "10011101";  -- 7585 = 9D
      when "111010110000110" =>  data <= "01100101";  -- 7586 = 65
      when "111010110000111" =>  data <= "00000010";  -- 7587 = 2
      when "111010110001000" =>  data <= "10100101";  -- 7588 = A5
      when "111010110001001" =>  data <= "11010100";  -- 7589 = D4
      when "111010110001010" =>  data <= "10011101";  -- 758A = 9D
      when "111010110001011" =>  data <= "01011011";  -- 758B = 5B
      when "111010110001100" =>  data <= "00000010";  -- 758C = 2
      when "111010110001101" =>  data <= "11110000";  -- 758D = F0
      when "111010110001110" =>  data <= "01010101";  -- 758E = 55
      when "111010110001111" =>  data <= "11001001";  -- 758F = C9
      when "111010110010000" =>  data <= "00000011";  -- 7590 = 3
      when "111010110010001" =>  data <= "11110000";  -- 7591 = F0
      when "111010110010010" =>  data <= "01010001";  -- 7592 = 51
      when "111010110010011" =>  data <= "10010000";  -- 7593 = 90
      when "111010110010100" =>  data <= "00000011";  -- 7594 = 3
      when "111010110010101" =>  data <= "01001100";  -- 7595 = 4C
      when "111010110010110" =>  data <= "10100101";  -- 7596 = A5
      when "111010110010111" =>  data <= "11110100";  -- 7597 = F4
      when "111010110011000" =>  data <= "10100101";  -- 7598 = A5
      when "111010110011001" =>  data <= "11010011";  -- 7599 = D3
      when "111010110011010" =>  data <= "00101001";  -- 759A = 29
      when "111010110011011" =>  data <= "00001111";  -- 759B = F
      when "111010110011100" =>  data <= "11010000";  -- 759C = D0
      when "111010110011101" =>  data <= "00101011";  -- 759D = 2B
      when "111010110011110" =>  data <= "00100000";  -- 759E = 20
      when "111010110011111" =>  data <= "01010111";  -- 759F = 57
      when "111010110100000" =>  data <= "11111000";  -- 75A0 = F8
      when "111010110100001" =>  data <= "00100000";  -- 75A1 = 20
      when "111010110100010" =>  data <= "01001001";  -- 75A2 = 49
      when "111010110100011" =>  data <= "11110100";  -- 75A3 = F4
      when "111010110100100" =>  data <= "10100101";  -- 75A4 = A5
      when "111010110100101" =>  data <= "11010001";  -- 75A5 = D1
      when "111010110100110" =>  data <= "11110000";  -- 75A6 = F0
      when "111010110100111" =>  data <= "00011010";  -- 75A7 = 1A
      when "111010110101000" =>  data <= "00100000";  -- 75A8 = 20
      when "111010110101001" =>  data <= "11010011";  -- 75A9 = D3
      when "111010110101010" =>  data <= "11110100";  -- 75AA = F4
      when "111010110101011" =>  data <= "11010000";  -- 75AB = D0
      when "111010110101100" =>  data <= "00100100";  -- 75AC = 24
      when "111010110101101" =>  data <= "10100000";  -- 75AD = A0
      when "111010110101110" =>  data <= "00100100";  -- 75AE = 24
      when "111010110101111" =>  data <= "00100000";  -- 75AF = 20
      when "111010110110000" =>  data <= "10100010";  -- 75B0 = A2
      when "111010110110001" =>  data <= "11110010";  -- 75B1 = F2
      when "111010110110010" =>  data <= "10101001";  -- 75B2 = A9
      when "111010110110011" =>  data <= "00001101";  -- 75B3 = D
      when "111010110110100" =>  data <= "00100000";  -- 75B4 = 20
      when "111010110110101" =>  data <= "01100110";  -- 75B5 = 66
      when "111010110110110" =>  data <= "11110010";  -- 75B6 = F2
      when "111010110110111" =>  data <= "10101001";  -- 75B7 = A9
      when "111010110111000" =>  data <= "00111111";  -- 75B8 = 3F
      when "111010110111001" =>  data <= "00100000";  -- 75B9 = 20
      when "111010110111010" =>  data <= "01100110";  -- 75BA = 66
      when "111010110111011" =>  data <= "11110010";  -- 75BB = F2
      when "111010110111100" =>  data <= "00100000";  -- 75BC = 20
      when "111010110111101" =>  data <= "10000101";  -- 75BD = 85
      when "111010110111110" =>  data <= "11110001";  -- 75BE = F1
      when "111010110111111" =>  data <= "01001100";  -- 75BF = 4C
      when "111010111000000" =>  data <= "11101101";  -- 75C0 = ED
      when "111010111000001" =>  data <= "10110011";  -- 75C1 = B3
      when "111010111000010" =>  data <= "00100000";  -- 75C2 = 20
      when "111010111000011" =>  data <= "11100101";  -- 75C3 = E5
      when "111010111000100" =>  data <= "11110101";  -- 75C4 = F5
      when "111010111000101" =>  data <= "11110000";  -- 75C5 = F0
      when "111010111000110" =>  data <= "11100110";  -- 75C6 = E6
      when "111010111000111" =>  data <= "11010000";  -- 75C7 = D0
      when "111010111001000" =>  data <= "00001000";  -- 75C8 = 8
      when "111010111001001" =>  data <= "00100000";  -- 75C9 = 20
      when "111010111001010" =>  data <= "10001100";  -- 75CA = 8C
      when "111010111001011" =>  data <= "11111000";  -- 75CB = F8
      when "111010111001100" =>  data <= "10101001";  -- 75CC = A9
      when "111010111001101" =>  data <= "00000100";  -- 75CD = 4
      when "111010111001110" =>  data <= "00100000";  -- 75CE = 20
      when "111010111001111" =>  data <= "00011001";  -- 75CF = 19
      when "111010111010000" =>  data <= "11110110";  -- 75D0 = F6
      when "111010111010001" =>  data <= "10100110";  -- 75D1 = A6
      when "111010111010010" =>  data <= "11010100";  -- 75D2 = D4
      when "111010111010011" =>  data <= "10101001";  -- 75D3 = A9
      when "111010111010100" =>  data <= "10111111";  -- 75D4 = BF
      when "111010111010101" =>  data <= "10100100";  -- 75D5 = A4
      when "111010111010110" =>  data <= "11010011";  -- 75D6 = D3
      when "111010111010111" =>  data <= "11000000";  -- 75D7 = C0
      when "111010111011000" =>  data <= "01100000";  -- 75D8 = 60
      when "111010111011001" =>  data <= "11110000";  -- 75D9 = F0
      when "111010111011010" =>  data <= "00000111";  -- 75DA = 7
      when "111010111011011" =>  data <= "10100000";  -- 75DB = A0
      when "111010111011100" =>  data <= "00000000";  -- 75DC = 0
      when "111010111011101" =>  data <= "10101001";  -- 75DD = A9
      when "111010111011110" =>  data <= "00000010";  -- 75DE = 2
      when "111010111011111" =>  data <= "10010001";  -- 75DF = 91
      when "111010111100000" =>  data <= "11010110";  -- 75E0 = D6
      when "111010111100001" =>  data <= "10011000";  -- 75E1 = 98
      when "111010111100010" =>  data <= "10010101";  -- 75E2 = 95
      when "111010111100011" =>  data <= "10111010";  -- 75E3 = BA
      when "111010111100100" =>  data <= "01100000";  -- 75E4 = 60
      when "111010111100101" =>  data <= "10100101";  -- 75E5 = A5
      when "111010111100110" =>  data <= "10011101";  -- 75E6 = 9D
      when "111010111100111" =>  data <= "01001000";  -- 75E7 = 48
      when "111010111101000" =>  data <= "00100000";  -- 75E8 = 20
      when "111010111101001" =>  data <= "10011010";  -- 75E9 = 9A
      when "111010111101010" =>  data <= "11111000";  -- 75EA = F8
      when "111010111101011" =>  data <= "10100000";  -- 75EB = A0
      when "111010111101100" =>  data <= "00000000";  -- 75EC = 0
      when "111010111101101" =>  data <= "10110001";  -- 75ED = B1
      when "111010111101110" =>  data <= "11010110";  -- 75EE = D6
      when "111010111101111" =>  data <= "11001001";  -- 75EF = C9
      when "111010111110000" =>  data <= "00000101";  -- 75F0 = 5
      when "111010111110001" =>  data <= "11110000";  -- 75F1 = F0
      when "111010111110010" =>  data <= "00100001";  -- 75F2 = 21
      when "111010111110011" =>  data <= "11001001";  -- 75F3 = C9
      when "111010111110100" =>  data <= "00000001";  -- 75F4 = 1
      when "111010111110101" =>  data <= "11110000";  -- 75F5 = F0
      when "111010111110110" =>  data <= "00000100";  -- 75F6 = 4
      when "111010111110111" =>  data <= "11001001";  -- 75F7 = C9
      when "111010111111000" =>  data <= "00000100";  -- 75F8 = 4
      when "111010111111001" =>  data <= "11010000";  -- 75F9 = D0
      when "111010111111010" =>  data <= "11101101";  -- 75FA = ED
      when "111010111111011" =>  data <= "10101010";  -- 75FB = AA
      when "111010111111100" =>  data <= "00100000";  -- 75FC = 20
      when "111010111111101" =>  data <= "01010001";  -- 75FD = 51
      when "111010111111110" =>  data <= "11110011";  -- 75FE = F3
      when "111010111111111" =>  data <= "11010000";  -- 75FF = D0
      when "111011000000000" =>  data <= "00010001";  -- 7600 = 11
      when "111011000000001" =>  data <= "10100000";  -- 7601 = A0
      when "111011000000010" =>  data <= "10100011";  -- 7602 = A3
      when "111011000000011" =>  data <= "00100000";  -- 7603 = 20
      when "111011000000100" =>  data <= "10000101";  -- 7604 = 85
      when "111011000000101" =>  data <= "11110001";  -- 7605 = F1
      when "111011000000110" =>  data <= "10100000";  -- 7606 = A0
      when "111011000000111" =>  data <= "00000101";  -- 7607 = 5
      when "111011000001000" =>  data <= "10110001";  -- 7608 = B1
      when "111011000001001" =>  data <= "11010110";  -- 7609 = D6
      when "111011000001010" =>  data <= "00100000";  -- 760A = 20
      when "111011000001011" =>  data <= "11010010";  -- 760B = D2
      when "111011000001100" =>  data <= "11111111";  -- 760C = FF
      when "111011000001101" =>  data <= "11001000";  -- 760D = C8
      when "111011000001110" =>  data <= "11000000";  -- 760E = C0
      when "111011000001111" =>  data <= "00010101";  -- 760F = 15
      when "111011000010000" =>  data <= "11010000";  -- 7610 = D0
      when "111011000010001" =>  data <= "11110110";  -- 7611 = F6
      when "111011000010010" =>  data <= "10100000";  -- 7612 = A0
      when "111011000010011" =>  data <= "00000001";  -- 7613 = 1
      when "111011000010100" =>  data <= "01101000";  -- 7614 = 68
      when "111011000010101" =>  data <= "10000101";  -- 7615 = 85
      when "111011000010110" =>  data <= "10011101";  -- 7616 = 9D
      when "111011000010111" =>  data <= "10011000";  -- 7617 = 98
      when "111011000011000" =>  data <= "01100000";  -- 7618 = 60
      when "111011000011001" =>  data <= "10000101";  -- 7619 = 85
      when "111011000011010" =>  data <= "10110100";  -- 761A = B4
      when "111011000011011" =>  data <= "00100000";  -- 761B = 20
      when "111011000011100" =>  data <= "10010101";  -- 761C = 95
      when "111011000011101" =>  data <= "11110110";  -- 761D = F6
      when "111011000011110" =>  data <= "10100101";  -- 761E = A5
      when "111011000011111" =>  data <= "11111100";  -- 761F = FC
      when "111011000100000" =>  data <= "01001000";  -- 7620 = 48
      when "111011000100001" =>  data <= "10100101";  -- 7621 = A5
      when "111011000100010" =>  data <= "11111011";  -- 7622 = FB
      when "111011000100011" =>  data <= "01001000";  -- 7623 = 48
      when "111011000100100" =>  data <= "10100101";  -- 7624 = A5
      when "111011000100101" =>  data <= "11001010";  -- 7625 = CA
      when "111011000100110" =>  data <= "01001000";  -- 7626 = 48
      when "111011000100111" =>  data <= "10100101";  -- 7627 = A5
      when "111011000101000" =>  data <= "11001001";  -- 7628 = C9
      when "111011000101001" =>  data <= "01001000";  -- 7629 = 48
      when "111011000101010" =>  data <= "10100000";  -- 762A = A0
      when "111011000101011" =>  data <= "10111111";  -- 762B = BF
      when "111011000101100" =>  data <= "10101001";  -- 762C = A9
      when "111011000101101" =>  data <= "00100000";  -- 762D = 20
      when "111011000101110" =>  data <= "10010001";  -- 762E = 91
      when "111011000101111" =>  data <= "11010110";  -- 762F = D6
      when "111011000110000" =>  data <= "10001000";  -- 7630 = 88
      when "111011000110001" =>  data <= "11010000";  -- 7631 = D0
      when "111011000110010" =>  data <= "11111011";  -- 7632 = FB
      when "111011000110011" =>  data <= "10100101";  -- 7633 = A5
      when "111011000110100" =>  data <= "10110100";  -- 7634 = B4
      when "111011000110101" =>  data <= "10010001";  -- 7635 = 91
      when "111011000110110" =>  data <= "11010110";  -- 7636 = D6
      when "111011000110111" =>  data <= "11001000";  -- 7637 = C8
      when "111011000111000" =>  data <= "10100101";  -- 7638 = A5
      when "111011000111001" =>  data <= "11111011";  -- 7639 = FB
      when "111011000111010" =>  data <= "10010001";  -- 763A = 91
      when "111011000111011" =>  data <= "11010110";  -- 763B = D6
      when "111011000111100" =>  data <= "11001000";  -- 763C = C8
      when "111011000111101" =>  data <= "10100101";  -- 763D = A5
      when "111011000111110" =>  data <= "11111100";  -- 763E = FC
      when "111011000111111" =>  data <= "10010001";  -- 763F = 91
      when "111011001000000" =>  data <= "11010110";  -- 7640 = D6
      when "111011001000001" =>  data <= "11001000";  -- 7641 = C8
      when "111011001000010" =>  data <= "10100101";  -- 7642 = A5
      when "111011001000011" =>  data <= "11001001";  -- 7643 = C9
      when "111011001000100" =>  data <= "10010001";  -- 7644 = 91
      when "111011001000101" =>  data <= "11010110";  -- 7645 = D6
      when "111011001000110" =>  data <= "11001000";  -- 7646 = C8
      when "111011001000111" =>  data <= "10100101";  -- 7647 = A5
      when "111011001001000" =>  data <= "11001010";  -- 7648 = CA
      when "111011001001001" =>  data <= "10010001";  -- 7649 = 91
      when "111011001001010" =>  data <= "11010110";  -- 764A = D6
      when "111011001001011" =>  data <= "11001000";  -- 764B = C8
      when "111011001001100" =>  data <= "10000100";  -- 764C = 84
      when "111011001001101" =>  data <= "10110101";  -- 764D = B5
      when "111011001001110" =>  data <= "10100000";  -- 764E = A0
      when "111011001001111" =>  data <= "00000000";  -- 764F = 0
      when "111011001010000" =>  data <= "10000100";  -- 7650 = 84
      when "111011001010001" =>  data <= "10110100";  -- 7651 = B4
      when "111011001010010" =>  data <= "10100100";  -- 7652 = A4
      when "111011001010011" =>  data <= "10110100";  -- 7653 = B4
      when "111011001010100" =>  data <= "11000100";  -- 7654 = C4
      when "111011001010101" =>  data <= "11010001";  -- 7655 = D1
      when "111011001010110" =>  data <= "11110000";  -- 7656 = F0
      when "111011001010111" =>  data <= "00001100";  -- 7657 = C
      when "111011001011000" =>  data <= "10110001";  -- 7658 = B1
      when "111011001011001" =>  data <= "11011010";  -- 7659 = DA
      when "111011001011010" =>  data <= "10100100";  -- 765A = A4
      when "111011001011011" =>  data <= "10110101";  -- 765B = B5
      when "111011001011100" =>  data <= "10010001";  -- 765C = 91
      when "111011001011101" =>  data <= "11010110";  -- 765D = D6
      when "111011001011110" =>  data <= "11100110";  -- 765E = E6
      when "111011001011111" =>  data <= "10110100";  -- 765F = B4
      when "111011001100000" =>  data <= "11100110";  -- 7660 = E6
      when "111011001100001" =>  data <= "10110101";  -- 7661 = B5
      when "111011001100010" =>  data <= "11010000";  -- 7662 = D0
      when "111011001100011" =>  data <= "11101110";  -- 7663 = EE
      when "111011001100100" =>  data <= "00100000";  -- 7664 = 20
      when "111011001100101" =>  data <= "10101011";  -- 7665 = AB
      when "111011001100110" =>  data <= "11110110";  -- 7666 = F6
      when "111011001100111" =>  data <= "10101001";  -- 7667 = A9
      when "111011001101000" =>  data <= "01101001";  -- 7668 = 69
      when "111011001101001" =>  data <= "10000101";  -- 7669 = 85
      when "111011001101010" =>  data <= "11000011";  -- 766A = C3
      when "111011001101011" =>  data <= "00100000";  -- 766B = 20
      when "111011001101100" =>  data <= "11010101";  -- 766C = D5
      when "111011001101101" =>  data <= "11111000";  -- 766D = F8
      when "111011001101110" =>  data <= "01101000";  -- 766E = 68
      when "111011001101111" =>  data <= "10000101";  -- 766F = 85
      when "111011001110000" =>  data <= "11001001";  -- 7670 = C9
      when "111011001110001" =>  data <= "01101000";  -- 7671 = 68
      when "111011001110010" =>  data <= "10000101";  -- 7672 = 85
      when "111011001110011" =>  data <= "11001010";  -- 7673 = CA
      when "111011001110100" =>  data <= "01101000";  -- 7674 = 68
      when "111011001110101" =>  data <= "10000101";  -- 7675 = 85
      when "111011001110110" =>  data <= "11111011";  -- 7676 = FB
      when "111011001110111" =>  data <= "01101000";  -- 7677 = 68
      when "111011001111000" =>  data <= "10000101";  -- 7678 = 85
      when "111011001111001" =>  data <= "11111100";  -- 7679 = FC
      when "111011001111010" =>  data <= "01100000";  -- 767A = 60
      when "111011001111011" =>  data <= "00100000";  -- 767B = 20
      when "111011001111100" =>  data <= "00101011";  -- 767C = 2B
      when "111011001111101" =>  data <= "11111001";  -- 767D = F9
      when "111011001111110" =>  data <= "10100010";  -- 767E = A2
      when "111011001111111" =>  data <= "00000000";  -- 767F = 0
      when "111011010000000" =>  data <= "10100000";  -- 7680 = A0
      when "111011010000001" =>  data <= "00000001";  -- 7681 = 1
      when "111011010000010" =>  data <= "10110001";  -- 7682 = B1
      when "111011010000011" =>  data <= "11010110";  -- 7683 = D6
      when "111011010000100" =>  data <= "10010101";  -- 7684 = 95
      when "111011010000101" =>  data <= "11000111";  -- 7685 = C7
      when "111011010000110" =>  data <= "11101000";  -- 7686 = E8
      when "111011010000111" =>  data <= "11001000";  -- 7687 = C8
      when "111011010001000" =>  data <= "11100000";  -- 7688 = E0
      when "111011010001001" =>  data <= "00000100";  -- 7689 = 4
      when "111011010001010" =>  data <= "11010000";  -- 768A = D0
      when "111011010001011" =>  data <= "11110110";  -- 768B = F6
      when "111011010001100" =>  data <= "10100101";  -- 768C = A5
      when "111011010001101" =>  data <= "11000111";  -- 768D = C7
      when "111011010001110" =>  data <= "10000101";  -- 768E = 85
      when "111011010001111" =>  data <= "11111011";  -- 768F = FB
      when "111011010010000" =>  data <= "10100101";  -- 7690 = A5
      when "111011010010001" =>  data <= "11001000";  -- 7691 = C8
      when "111011010010010" =>  data <= "10000101";  -- 7692 = 85
      when "111011010010011" =>  data <= "11111100";  -- 7693 = FC
      when "111011010010100" =>  data <= "01100000";  -- 7694 = 60
      when "111011010010101" =>  data <= "10101001";  -- 7695 = A9
      when "111011010010110" =>  data <= "01111010";  -- 7696 = 7A
      when "111011010010111" =>  data <= "10000101";  -- 7697 = 85
      when "111011010011000" =>  data <= "11010110";  -- 7698 = D6
      when "111011010011001" =>  data <= "10101001";  -- 7699 = A9
      when "111011010011010" =>  data <= "00000010";  -- 769A = 2
      when "111011010011011" =>  data <= "10000101";  -- 769B = 85
      when "111011010011100" =>  data <= "11010111";  -- 769C = D7
      when "111011010011101" =>  data <= "10100101";  -- 769D = A5
      when "111011010011110" =>  data <= "11010100";  -- 769E = D4
      when "111011010011111" =>  data <= "01001010";  -- 769F = 4A
      when "111011010100000" =>  data <= "10110000";  -- 76A0 = B0
      when "111011010100001" =>  data <= "00001000";  -- 76A1 = 8
      when "111011010100010" =>  data <= "10101001";  -- 76A2 = A9
      when "111011010100011" =>  data <= "00111010";  -- 76A3 = 3A
      when "111011010100100" =>  data <= "10000101";  -- 76A4 = 85
      when "111011010100101" =>  data <= "11010110";  -- 76A5 = D6
      when "111011010100110" =>  data <= "10101001";  -- 76A6 = A9
      when "111011010100111" =>  data <= "00000011";  -- 76A7 = 3
      when "111011010101000" =>  data <= "10000101";  -- 76A8 = 85
      when "111011010101001" =>  data <= "11010111";  -- 76A9 = D7
      when "111011010101010" =>  data <= "01100000";  -- 76AA = 60
      when "111011010101011" =>  data <= "00100000";  -- 76AB = 20
      when "111011010101100" =>  data <= "00101011";  -- 76AC = 2B
      when "111011010101101" =>  data <= "11111001";  -- 76AD = F9
      when "111011010101110" =>  data <= "00100000";  -- 76AE = 20
      when "111011010101111" =>  data <= "10010101";  -- 76AF = 95
      when "111011010110000" =>  data <= "11110110";  -- 76B0 = F6
      when "111011010110001" =>  data <= "10100101";  -- 76B1 = A5
      when "111011010110010" =>  data <= "11010110";  -- 76B2 = D6
      when "111011010110011" =>  data <= "10000101";  -- 76B3 = 85
      when "111011010110100" =>  data <= "11111011";  -- 76B4 = FB
      when "111011010110101" =>  data <= "00011000";  -- 76B5 = 18
      when "111011010110110" =>  data <= "01101001";  -- 76B6 = 69
      when "111011010110111" =>  data <= "11000000";  -- 76B7 = C0
      when "111011010111000" =>  data <= "10000101";  -- 76B8 = 85
      when "111011010111001" =>  data <= "11001001";  -- 76B9 = C9
      when "111011010111010" =>  data <= "10100101";  -- 76BA = A5
      when "111011010111011" =>  data <= "11010111";  -- 76BB = D7
      when "111011010111100" =>  data <= "10000101";  -- 76BC = 85
      when "111011010111101" =>  data <= "11111100";  -- 76BD = FC
      when "111011010111110" =>  data <= "01101001";  -- 76BE = 69
      when "111011010111111" =>  data <= "00000000";  -- 76BF = 0
      when "111011011000000" =>  data <= "10000101";  -- 76C0 = 85
      when "111011011000001" =>  data <= "11001010";  -- 76C1 = CA
      when "111011011000010" =>  data <= "01100000";  -- 76C2 = 60
      when "111011011000011" =>  data <= "00100000";  -- 76C3 = 20
      when "111011011000100" =>  data <= "10000100";  -- 76C4 = 84
      when "111011011000101" =>  data <= "10111101";  -- 76C5 = BD
      when "111011011000110" =>  data <= "00100000";  -- 76C6 = 20
      when "111011011000111" =>  data <= "00101101";  -- 76C7 = 2D
      when "111011011001000" =>  data <= "11001001";  -- 76C8 = C9
      when "111011011001001" =>  data <= "01101100";  -- 76C9 = 6C
      when "111011011001010" =>  data <= "00010001";  -- 76CA = 11
      when "111011011001011" =>  data <= "00000000";  -- 76CB = 0
      when "111011011001100" =>  data <= "10100101";  -- 76CC = A5
      when "111011011001101" =>  data <= "00101010";  -- 76CD = 2A
      when "111011011001110" =>  data <= "10000101";  -- 76CE = 85
      when "111011011001111" =>  data <= "11001001";  -- 76CF = C9
      when "111011011010000" =>  data <= "10100101";  -- 76D0 = A5
      when "111011011010001" =>  data <= "00101011";  -- 76D1 = 2B
      when "111011011010010" =>  data <= "10000101";  -- 76D2 = 85
      when "111011011010011" =>  data <= "11001010";  -- 76D3 = CA
      when "111011011010100" =>  data <= "10100101";  -- 76D4 = A5
      when "111011011010101" =>  data <= "00101001";  -- 76D5 = 29
      when "111011011010110" =>  data <= "10000101";  -- 76D6 = 85
      when "111011011010111" =>  data <= "11111100";  -- 76D7 = FC
      when "111011011011000" =>  data <= "10100101";  -- 76D8 = A5
      when "111011011011001" =>  data <= "00101000";  -- 76D9 = 28
      when "111011011011010" =>  data <= "10000101";  -- 76DA = 85
      when "111011011011011" =>  data <= "11111011";  -- 76DB = FB
      when "111011011011100" =>  data <= "01100000";  -- 76DC = 60
      when "111011011011101" =>  data <= "00100000";  -- 76DD = 20
      when "111011011011110" =>  data <= "01111101";  -- 76DE = 7D
      when "111011011011111" =>  data <= "11110100";  -- 76DF = F4
      when "111011011100000" =>  data <= "00100000";  -- 76E0 = 20
      when "111011011100001" =>  data <= "11001100";  -- 76E1 = CC
      when "111011011100010" =>  data <= "11110110";  -- 76E2 = F6
      when "111011011100011" =>  data <= "10100101";  -- 76E3 = A5
      when "111011011100100" =>  data <= "11010100";  -- 76E4 = D4
      when "111011011100101" =>  data <= "11010000";  -- 76E5 = D0
      when "111011011100110" =>  data <= "00000101";  -- 76E6 = 5
      when "111011011100111" =>  data <= "10100000";  -- 76E7 = A0
      when "111011011101000" =>  data <= "01110100";  -- 76E8 = 74
      when "111011011101001" =>  data <= "01001100";  -- 76E9 = 4C
      when "111011011101010" =>  data <= "10101111";  -- 76EA = AF
      when "111011011101011" =>  data <= "11110101";  -- 76EB = F5
      when "111011011101100" =>  data <= "11001001";  -- 76EC = C9
      when "111011011101101" =>  data <= "00000011";  -- 76ED = 3
      when "111011011101110" =>  data <= "11110000";  -- 76EE = F0
      when "111011011101111" =>  data <= "11110111";  -- 76EF = F7
      when "111011011110000" =>  data <= "10010000";  -- 76F0 = 90
      when "111011011110001" =>  data <= "01010000";  -- 76F1 = 50
      when "111011011110010" =>  data <= "10101001";  -- 76F2 = A9
      when "111011011110011" =>  data <= "01100001";  -- 76F3 = 61
      when "111011011110100" =>  data <= "10000101";  -- 76F4 = 85
      when "111011011110101" =>  data <= "11010011";  -- 76F5 = D3
      when "111011011110110" =>  data <= "10100100";  -- 76F6 = A4
      when "111011011110111" =>  data <= "11010001";  -- 76F7 = D1
      when "111011011111000" =>  data <= "11010000";  -- 76F8 = D0
      when "111011011111001" =>  data <= "00000011";  -- 76F9 = 3
      when "111011011111010" =>  data <= "01001100";  -- 76FA = 4C
      when "111011011111011" =>  data <= "00000000";  -- 76FB = 0
      when "111011011111100" =>  data <= "10111111";  -- 76FC = BF
      when "111011011111101" =>  data <= "00100000";  -- 76FD = 20
      when "111011011111110" =>  data <= "10100101";  -- 76FE = A5
      when "111011011111111" =>  data <= "11110100";  -- 76FF = F4
      when "111011100000000" =>  data <= "00100000";  -- 7700 = 20
      when "111011100000001" =>  data <= "11010101";  -- 7701 = D5
      when "111011100000010" =>  data <= "11110000";  -- 7702 = F0
      when "111011100000011" =>  data <= "10100101";  -- 7703 = A5
      when "111011100000100" =>  data <= "11010011";  -- 7704 = D3
      when "111011100000101" =>  data <= "00100000";  -- 7705 = 20
      when "111011100000110" =>  data <= "01000011";  -- 7706 = 43
      when "111011100000111" =>  data <= "11110001";  -- 7707 = F1
      when "111011100001000" =>  data <= "10100000";  -- 7708 = A0
      when "111011100001001" =>  data <= "00000000";  -- 7709 = 0
      when "111011100001010" =>  data <= "00100000";  -- 770A = 20
      when "111011100001011" =>  data <= "10111011";  -- 770B = BB
      when "111011100001100" =>  data <= "11111011";  -- 770C = FB
      when "111011100001101" =>  data <= "10100101";  -- 770D = A5
      when "111011100001110" =>  data <= "11000111";  -- 770E = C7
      when "111011100001111" =>  data <= "00100000";  -- 770F = 20
      when "111011100010000" =>  data <= "10011110";  -- 7710 = 9E
      when "111011100010001" =>  data <= "11110001";  -- 7711 = F1
      when "111011100010010" =>  data <= "10100101";  -- 7712 = A5
      when "111011100010011" =>  data <= "11001000";  -- 7713 = C8
      when "111011100010100" =>  data <= "00100000";  -- 7714 = 20
      when "111011100010101" =>  data <= "10011110";  -- 7715 = 9E
      when "111011100010110" =>  data <= "11110001";  -- 7716 = F1
      when "111011100010111" =>  data <= "00100000";  -- 7717 = 20
      when "111011100011000" =>  data <= "00001011";  -- 7718 = B
      when "111011100011001" =>  data <= "11111101";  -- 7719 = FD
      when "111011100011010" =>  data <= "11110000";  -- 771A = F0
      when "111011100011011" =>  data <= "00010000";  -- 771B = 10
      when "111011100011100" =>  data <= "10110001";  -- 771C = B1
      when "111011100011101" =>  data <= "11000111";  -- 771D = C7
      when "111011100011110" =>  data <= "00100000";  -- 771E = 20
      when "111011100011111" =>  data <= "10011110";  -- 771F = 9E
      when "111011100100000" =>  data <= "11110001";  -- 7720 = F1
      when "111011100100001" =>  data <= "00100000";  -- 7721 = 20
      when "111011100100010" =>  data <= "01000011";  -- 7722 = 43
      when "111011100100011" =>  data <= "11110011";  -- 7723 = F3
      when "111011100100100" =>  data <= "11100110";  -- 7724 = E6
      when "111011100100101" =>  data <= "11000111";  -- 7725 = C7
      when "111011100100110" =>  data <= "11010000";  -- 7726 = D0
      when "111011100100111" =>  data <= "11101111";  -- 7727 = EF
      when "111011100101000" =>  data <= "11100110";  -- 7728 = E6
      when "111011100101001" =>  data <= "11001000";  -- 7729 = C8
      when "111011100101010" =>  data <= "11010000";  -- 772A = D0
      when "111011100101011" =>  data <= "11101011";  -- 772B = EB
      when "111011100101100" =>  data <= "00100000";  -- 772C = 20
      when "111011100101101" =>  data <= "10111001";  -- 772D = B9
      when "111011100101110" =>  data <= "11110001";  -- 772E = F1
      when "111011100101111" =>  data <= "00100100";  -- 772F = 24
      when "111011100110000" =>  data <= "11010011";  -- 7730 = D3
      when "111011100110001" =>  data <= "00110000";  -- 7731 = 30
      when "111011100110010" =>  data <= "01111000";  -- 7732 = 78
      when "111011100110011" =>  data <= "00100000";  -- 7733 = 20
      when "111011100110100" =>  data <= "11010101";  -- 7734 = D5
      when "111011100110101" =>  data <= "11110000";  -- 7735 = F0
      when "111011100110110" =>  data <= "10100101";  -- 7736 = A5
      when "111011100110111" =>  data <= "11010011";  -- 7737 = D3
      when "111011100111000" =>  data <= "00101001";  -- 7738 = 29
      when "111011100111001" =>  data <= "11101111";  -- 7739 = EF
      when "111011100111010" =>  data <= "00001001";  -- 773A = 9
      when "111011100111011" =>  data <= "11100000";  -- 773B = E0
      when "111011100111100" =>  data <= "00100000";  -- 773C = 20
      when "111011100111101" =>  data <= "01000011";  -- 773D = 43
      when "111011100111110" =>  data <= "11110001";  -- 773E = F1
      when "111011100111111" =>  data <= "01001100";  -- 773F = 4C
      when "111011101000000" =>  data <= "10111001";  -- 7740 = B9
      when "111011101000001" =>  data <= "11110001";  -- 7741 = F1
      when "111011101000010" =>  data <= "00100000";  -- 7742 = 20
      when "111011101000011" =>  data <= "10010101";  -- 7743 = 95
      when "111011101000100" =>  data <= "11110110";  -- 7744 = F6
      when "111011101000101" =>  data <= "00100000";  -- 7745 = 20
      when "111011101000110" =>  data <= "10001100";  -- 7746 = 8C
      when "111011101000111" =>  data <= "11111000";  -- 7747 = F8
      when "111011101001000" =>  data <= "00100000";  -- 7748 = 20
      when "111011101001001" =>  data <= "01010001";  -- 7749 = 51
      when "111011101001010" =>  data <= "11110011";  -- 774A = F3
      when "111011101001011" =>  data <= "11010000";  -- 774B = D0
      when "111011101001100" =>  data <= "00001000";  -- 774C = 8
      when "111011101001101" =>  data <= "10100000";  -- 774D = A0
      when "111011101001110" =>  data <= "01100100";  -- 774E = 64
      when "111011101001111" =>  data <= "00100000";  -- 774F = 20
      when "111011101010000" =>  data <= "10000101";  -- 7750 = 85
      when "111011101010001" =>  data <= "11110001";  -- 7751 = F1
      when "111011101010010" =>  data <= "00100000";  -- 7752 = 20
      when "111011101010011" =>  data <= "01011100";  -- 7753 = 5C
      when "111011101010100" =>  data <= "11110100";  -- 7754 = F4
      when "111011101010101" =>  data <= "10101001";  -- 7755 = A9
      when "111011101010110" =>  data <= "00000001";  -- 7756 = 1
      when "111011101010111" =>  data <= "00100000";  -- 7757 = 20
      when "111011101011000" =>  data <= "00011001";  -- 7758 = 19
      when "111011101011001" =>  data <= "11110110";  -- 7759 = F6
      when "111011101011010" =>  data <= "00100000";  -- 775A = 20
      when "111011101011011" =>  data <= "11001110";  -- 775B = CE
      when "111011101011100" =>  data <= "11111000";  -- 775C = F8
      when "111011101011101" =>  data <= "10100101";  -- 775D = A5
      when "111011101011110" =>  data <= "11010011";  -- 775E = D3
      when "111011101011111" =>  data <= "00101001";  -- 775F = 29
      when "111011101100000" =>  data <= "00000010";  -- 7760 = 2
      when "111011101100001" =>  data <= "11110000";  -- 7761 = F0
      when "111011101100010" =>  data <= "01001000";  -- 7762 = 48
      when "111011101100011" =>  data <= "10101001";  -- 7763 = A9
      when "111011101100100" =>  data <= "00000101";  -- 7764 = 5
      when "111011101100101" =>  data <= "01001100";  -- 7765 = 4C
      when "111011101100110" =>  data <= "00011001";  -- 7766 = 19
      when "111011101100111" =>  data <= "11110110";  -- 7767 = F6
      when "111011101101000" =>  data <= "11100110";  -- 7768 = E6
      when "111011101101001" =>  data <= "10011001";  -- 7769 = 99
      when "111011101101010" =>  data <= "10100101";  -- 776A = A5
      when "111011101101011" =>  data <= "10011001";  -- 776B = 99
      when "111011101101100" =>  data <= "11010000";  -- 776C = D0
      when "111011101101101" =>  data <= "00000010";  -- 776D = 2
      when "111011101101110" =>  data <= "11100110";  -- 776E = E6
      when "111011101101111" =>  data <= "10011010";  -- 776F = 9A
      when "111011101110000" =>  data <= "11001001";  -- 7770 = C9
      when "111011101110001" =>  data <= "01101111";  -- 7771 = 6F
      when "111011101110010" =>  data <= "11010000";  -- 7772 = D0
      when "111011101110011" =>  data <= "00000110";  -- 7773 = 6
      when "111011101110100" =>  data <= "10100101";  -- 7774 = A5
      when "111011101110101" =>  data <= "10011010";  -- 7775 = 9A
      when "111011101110110" =>  data <= "11001001";  -- 7776 = C9
      when "111011101110111" =>  data <= "00000010";  -- 7777 = 2
      when "111011101111000" =>  data <= "11110000";  -- 7778 = F0
      when "111011101111001" =>  data <= "00100001";  -- 7779 = 21
      when "111011101111010" =>  data <= "11100110";  -- 777A = E6
      when "111011101111011" =>  data <= "10001111";  -- 777B = 8F
      when "111011101111100" =>  data <= "11010000";  -- 777C = D0
      when "111011101111101" =>  data <= "00000110";  -- 777D = 6
      when "111011101111110" =>  data <= "11100110";  -- 777E = E6
      when "111011101111111" =>  data <= "10001110";  -- 777F = 8E
      when "111011110000000" =>  data <= "11010000";  -- 7780 = D0
      when "111011110000001" =>  data <= "00000010";  -- 7781 = 2
      when "111011110000010" =>  data <= "11100110";  -- 7782 = E6
      when "111011110000011" =>  data <= "10001101";  -- 7783 = 8D
      when "111011110000100" =>  data <= "10100010";  -- 7784 = A2
      when "111011110000101" =>  data <= "00000000";  -- 7785 = 0
      when "111011110000110" =>  data <= "10110101";  -- 7786 = B5
      when "111011110000111" =>  data <= "10001101";  -- 7787 = 8D
      when "111011110001000" =>  data <= "11011101";  -- 7788 = DD
      when "111011110001001" =>  data <= "10101100";  -- 7789 = AC
      when "111011110001010" =>  data <= "11110111";  -- 778A = F7
      when "111011110001011" =>  data <= "10010000";  -- 778B = 90
      when "111011110001100" =>  data <= "00010100";  -- 778C = 14
      when "111011110001101" =>  data <= "11101000";  -- 778D = E8
      when "111011110001110" =>  data <= "11100000";  -- 778E = E0
      when "111011110001111" =>  data <= "00000011";  -- 778F = 3
      when "111011110010000" =>  data <= "11010000";  -- 7790 = D0
      when "111011110010001" =>  data <= "11110100";  -- 7791 = F4
      when "111011110010010" =>  data <= "10101001";  -- 7792 = A9
      when "111011110010011" =>  data <= "00000000";  -- 7793 = 0
      when "111011110010100" =>  data <= "10010101";  -- 7794 = 95
      when "111011110010101" =>  data <= "10001100";  -- 7795 = 8C
      when "111011110010110" =>  data <= "11001010";  -- 7796 = CA
      when "111011110010111" =>  data <= "11010000";  -- 7797 = D0
      when "111011110011000" =>  data <= "11111011";  -- 7798 = FB
      when "111011110011001" =>  data <= "11110000";  -- 7799 = F0
      when "111011110011010" =>  data <= "00000110";  -- 779A = 6
      when "111011110011011" =>  data <= "10101001";  -- 779B = A9
      when "111011110011100" =>  data <= "00000000";  -- 779C = 0
      when "111011110011101" =>  data <= "10000101";  -- 779D = 85
      when "111011110011110" =>  data <= "10011001";  -- 779E = 99
      when "111011110011111" =>  data <= "10000101";  -- 779F = 85
      when "111011110100000" =>  data <= "10011010";  -- 77A0 = 9A
      when "111011110100001" =>  data <= "10101101";  -- 77A1 = AD
      when "111011110100010" =>  data <= "00010010";  -- 77A2 = 12
      when "111011110100011" =>  data <= "11101000";  -- 77A3 = E8
      when "111011110100100" =>  data <= "11001101";  -- 77A4 = CD
      when "111011110100101" =>  data <= "00010010";  -- 77A5 = 12
      when "111011110100110" =>  data <= "11101000";  -- 77A6 = E8
      when "111011110100111" =>  data <= "11010000";  -- 77A7 = D0
      when "111011110101000" =>  data <= "11111000";  -- 77A8 = F8
      when "111011110101001" =>  data <= "10000101";  -- 77A9 = 85
      when "111011110101010" =>  data <= "10011011";  -- 77AA = 9B
      when "111011110101011" =>  data <= "01100000";  -- 77AB = 60
      when "111011110101100" =>  data <= "01001111";  -- 77AC = 4F
      when "111011110101101" =>  data <= "00011010";  -- 77AD = 1A
      when "111011110101110" =>  data <= "00000001";  -- 77AE = 1
      when "111011110101111" =>  data <= "01001000";  -- 77AF = 48
      when "111011110110000" =>  data <= "10001010";  -- 77B0 = 8A
      when "111011110110001" =>  data <= "01001000";  -- 77B1 = 48
      when "111011110110010" =>  data <= "10011000";  -- 77B2 = 98
      when "111011110110011" =>  data <= "01001000";  -- 77B3 = 48
      when "111011110110100" =>  data <= "10101001";  -- 77B4 = A9
      when "111011110110101" =>  data <= "00000000";  -- 77B5 = 0
      when "111011110110110" =>  data <= "10000101";  -- 77B6 = 85
      when "111011110110111" =>  data <= "10010110";  -- 77B7 = 96
      when "111011110111000" =>  data <= "10001010";  -- 77B8 = 8A
      when "111011110111001" =>  data <= "00100000";  -- 77B9 = 20
      when "111011110111010" =>  data <= "11000001";  -- 77BA = C1
      when "111011110111011" =>  data <= "11110010";  -- 77BB = F2
      when "111011110111100" =>  data <= "11110000";  -- 77BC = F0
      when "111011110111101" =>  data <= "00000101";  -- 77BD = 5
      when "111011110111110" =>  data <= "10100000";  -- 77BE = A0
      when "111011110111111" =>  data <= "00010111";  -- 77BF = 17
      when "111011111000000" =>  data <= "01001100";  -- 77C0 = 4C
      when "111011111000001" =>  data <= "10101111";  -- 77C1 = AF
      when "111011111000010" =>  data <= "11110101";  -- 77C2 = F5
      when "111011111000011" =>  data <= "00100000";  -- 77C3 = 20
      when "111011111000100" =>  data <= "11001101";  -- 77C4 = CD
      when "111011111000101" =>  data <= "11110010";  -- 77C5 = F2
      when "111011111000110" =>  data <= "10100101";  -- 77C6 = A5
      when "111011111000111" =>  data <= "11010100";  -- 77C7 = D4
      when "111011111001000" =>  data <= "11110000";  -- 77C8 = F0
      when "111011111001001" =>  data <= "00010000";  -- 77C9 = 10
      when "111011111001010" =>  data <= "11001001";  -- 77CA = C9
      when "111011111001011" =>  data <= "00000011";  -- 77CB = 3
      when "111011111001100" =>  data <= "11110000";  -- 77CC = F0
      when "111011111001101" =>  data <= "00001100";  -- 77CD = C
      when "111011111001110" =>  data <= "10110000";  -- 77CE = B0
      when "111011111001111" =>  data <= "00001111";  -- 77CF = F
      when "111011111010000" =>  data <= "10100110";  -- 77D0 = A6
      when "111011111010001" =>  data <= "11010011";  -- 77D1 = D3
      when "111011111010010" =>  data <= "11100000";  -- 77D2 = E0
      when "111011111010011" =>  data <= "01100000";  -- 77D3 = 60
      when "111011111010100" =>  data <= "11110000";  -- 77D4 = F0
      when "111011111010101" =>  data <= "00000100";  -- 77D5 = 4
      when "111011111010110" =>  data <= "10100000";  -- 77D6 = A0
      when "111011111010111" =>  data <= "10000110";  -- 77D7 = 86
      when "111011111011000" =>  data <= "11010000";  -- 77D8 = D0
      when "111011111011001" =>  data <= "11100110";  -- 77D9 = E6
      when "111011111011010" =>  data <= "10000101";  -- 77DA = 85
      when "111011111011011" =>  data <= "10101111";  -- 77DB = AF
      when "111011111011100" =>  data <= "01001100";  -- 77DC = 4C
      when "111011111011101" =>  data <= "10011100";  -- 77DD = 9C
      when "111011111011110" =>  data <= "11110010";  -- 77DE = F2
      when "111011111011111" =>  data <= "01001000";  -- 77DF = 48
      when "111011111100000" =>  data <= "00100000";  -- 77E0 = 20
      when "111011111100001" =>  data <= "11100001";  -- 77E1 = E1
      when "111011111100010" =>  data <= "11011011";  -- 77E2 = DB
      when "111011111100011" =>  data <= "00100000";  -- 77E3 = 20
      when "111011111100100" =>  data <= "11010010";  -- 77E4 = D2
      when "111011111100101" =>  data <= "11110000";  -- 77E5 = F0
      when "111011111100110" =>  data <= "10100101";  -- 77E6 = A5
      when "111011111100111" =>  data <= "11010011";  -- 77E7 = D3
      when "111011111101000" =>  data <= "00010000";  -- 77E8 = 10
      when "111011111101001" =>  data <= "00000110";  -- 77E9 = 6
      when "111011111101010" =>  data <= "00100000";  -- 77EA = 20
      when "111011111101011" =>  data <= "10011000";  -- 77EB = 98
      when "111011111101100" =>  data <= "11110001";  -- 77EC = F1
      when "111011111101101" =>  data <= "01001100";  -- 77ED = 4C
      when "111011111101110" =>  data <= "11110011";  -- 77EE = F3
      when "111011111101111" =>  data <= "11110111";  -- 77EF = F7
      when "111011111110000" =>  data <= "00100000";  -- 77F0 = 20
      when "111011111110001" =>  data <= "10010011";  -- 77F1 = 93
      when "111011111110010" =>  data <= "11110001";  -- 77F2 = F1
      when "111011111110011" =>  data <= "10100101";  -- 77F3 = A5
      when "111011111110100" =>  data <= "10010110";  -- 77F4 = 96
      when "111011111110101" =>  data <= "00010000";  -- 77F5 = 10
      when "111011111110110" =>  data <= "00000011";  -- 77F6 = 3
      when "111011111110111" =>  data <= "01001100";  -- 77F7 = 4C
      when "111011111111000" =>  data <= "10111011";  -- 77F8 = BB
      when "111011111111001" =>  data <= "11110100";  -- 77F9 = F4
      when "111011111111010" =>  data <= "01101000";  -- 77FA = 68
      when "111011111111011" =>  data <= "01001100";  -- 77FB = 4C
      when "111011111111100" =>  data <= "11011010";  -- 77FC = DA
      when "111011111111101" =>  data <= "11110111";  -- 77FD = F7
      when "111011111111110" =>  data <= "01001000";  -- 77FE = 48
      when "111011111111111" =>  data <= "10001010";  -- 77FF = 8A
      when "111100000000000" =>  data <= "01001000";  -- 7800 = 48
      when "111100000000001" =>  data <= "10011000";  -- 7801 = 98
      when "111100000000010" =>  data <= "01001000";  -- 7802 = 48
      when "111100000000011" =>  data <= "10101001";  -- 7803 = A9
      when "111100000000100" =>  data <= "00000000";  -- 7804 = 0
      when "111100000000101" =>  data <= "10000101";  -- 7805 = 85
      when "111100000000110" =>  data <= "10010110";  -- 7806 = 96
      when "111100000000111" =>  data <= "10001010";  -- 7807 = 8A
      when "111100000001000" =>  data <= "00100000";  -- 7808 = 20
      when "111100000001001" =>  data <= "11000001";  -- 7809 = C1
      when "111100000001010" =>  data <= "11110010";  -- 780A = F2
      when "111100000001011" =>  data <= "11010000";  -- 780B = D0
      when "111100000001100" =>  data <= "10110001";  -- 780C = B1
      when "111100000001101" =>  data <= "00100000";  -- 780D = 20
      when "111100000001110" =>  data <= "11001101";  -- 780E = CD
      when "111100000001111" =>  data <= "11110010";  -- 780F = F2
      when "111100000010000" =>  data <= "10100101";  -- 7810 = A5
      when "111100000010001" =>  data <= "11010100";  -- 7811 = D4
      when "111100000010010" =>  data <= "11010000";  -- 7812 = D0
      when "111100000010011" =>  data <= "00000100";  -- 7813 = 4
      when "111100000010100" =>  data <= "10100000";  -- 7814 = A0
      when "111100000010101" =>  data <= "10010100";  -- 7815 = 94
      when "111100000010110" =>  data <= "11010000";  -- 7816 = D0
      when "111100000010111" =>  data <= "10101000";  -- 7817 = A8
      when "111100000011000" =>  data <= "11001001";  -- 7818 = C9
      when "111100000011001" =>  data <= "00000011";  -- 7819 = 3
      when "111100000011010" =>  data <= "11110000";  -- 781A = F0
      when "111100000011011" =>  data <= "00001100";  -- 781B = C
      when "111100000011100" =>  data <= "10110000";  -- 781C = B0
      when "111100000011101" =>  data <= "00001111";  -- 781D = F
      when "111100000011110" =>  data <= "10100110";  -- 781E = A6
      when "111100000011111" =>  data <= "11010011";  -- 781F = D3
      when "111100000100000" =>  data <= "11100000";  -- 7820 = E0
      when "111100000100001" =>  data <= "01100000";  -- 7821 = 60
      when "111100000100010" =>  data <= "11010000";  -- 7822 = D0
      when "111100000100011" =>  data <= "00000100";  -- 7823 = 4
      when "111100000100100" =>  data <= "10100000";  -- 7824 = A0
      when "111100000100101" =>  data <= "10010100";  -- 7825 = 94
      when "111100000100110" =>  data <= "11010000";  -- 7826 = D0
      when "111100000100111" =>  data <= "10011000";  -- 7827 = 98
      when "111100000101000" =>  data <= "10000101";  -- 7828 = 85
      when "111100000101001" =>  data <= "10110000";  -- 7829 = B0
      when "111100000101010" =>  data <= "01001100";  -- 782A = 4C
      when "111100000101011" =>  data <= "10011100";  -- 782B = 9C
      when "111100000101100" =>  data <= "11110010";  -- 782C = F2
      when "111100000101101" =>  data <= "01001000";  -- 782D = 48
      when "111100000101110" =>  data <= "00100000";  -- 782E = 20
      when "111100000101111" =>  data <= "11100001";  -- 782F = E1
      when "111100000110000" =>  data <= "11011011";  -- 7830 = DB
      when "111100000110001" =>  data <= "00100000";  -- 7831 = 20
      when "111100000110010" =>  data <= "11010101";  -- 7832 = D5
      when "111100000110011" =>  data <= "11110000";  -- 7833 = F0
      when "111100000110100" =>  data <= "10100101";  -- 7834 = A5
      when "111100000110101" =>  data <= "11010011";  -- 7835 = D3
      when "111100000110110" =>  data <= "00010000";  -- 7836 = 10
      when "111100000110111" =>  data <= "00000101";  -- 7837 = 5
      when "111100000111000" =>  data <= "00100000";  -- 7838 = 20
      when "111100000111001" =>  data <= "01001000";  -- 7839 = 48
      when "111100000111010" =>  data <= "11110001";  -- 783A = F1
      when "111100000111011" =>  data <= "11010000";  -- 783B = D0
      when "111100000111100" =>  data <= "00000011";  -- 783C = 3
      when "111100000111101" =>  data <= "00100000";  -- 783D = 20
      when "111100000111110" =>  data <= "01000011";  -- 783E = 43
      when "111100000111111" =>  data <= "11110001";  -- 783F = F1
      when "111100001000000" =>  data <= "10100101";  -- 7840 = A5
      when "111100001000001" =>  data <= "10010110";  -- 7841 = 96
      when "111100001000010" =>  data <= "00010000";  -- 7842 = 10
      when "111100001000011" =>  data <= "00000011";  -- 7843 = 3
      when "111100001000100" =>  data <= "01001100";  -- 7844 = 4C
      when "111100001000101" =>  data <= "10111011";  -- 7845 = BB
      when "111100001000110" =>  data <= "11110100";  -- 7846 = F4
      when "111100001000111" =>  data <= "01101000";  -- 7847 = 68
      when "111100001001000" =>  data <= "01001100";  -- 7848 = 4C
      when "111100001001001" =>  data <= "00101000";  -- 7849 = 28
      when "111100001001010" =>  data <= "11111000";  -- 784A = F8
      when "111100001001011" =>  data <= "00100000";  -- 784B = 20
      when "111100001001100" =>  data <= "10010101";  -- 784C = 95
      when "111100001001101" =>  data <= "11110110";  -- 784D = F6
      when "111100001001110" =>  data <= "10100110";  -- 784E = A6
      when "111100001001111" =>  data <= "11010100";  -- 784F = D4
      when "111100001010000" =>  data <= "11110110";  -- 7850 = F6
      when "111100001010001" =>  data <= "10111010";  -- 7851 = BA
      when "111100001010010" =>  data <= "10110100";  -- 7852 = B4
      when "111100001010011" =>  data <= "10111010";  -- 7853 = BA
      when "111100001010100" =>  data <= "11000000";  -- 7854 = C0
      when "111100001010101" =>  data <= "11000000";  -- 7855 = C0
      when "111100001010110" =>  data <= "01100000";  -- 7856 = 60
      when "111100001010111" =>  data <= "00100000";  -- 7857 = 20
      when "111100001011000" =>  data <= "01111010";  -- 7858 = 7A
      when "111100001011001" =>  data <= "11111000";  -- 7859 = F8
      when "111100001011010" =>  data <= "11110000";  -- 785A = F0
      when "111100001011011" =>  data <= "00101111";  -- 785B = 2F
      when "111100001011100" =>  data <= "10100000";  -- 785C = A0
      when "111100001011101" =>  data <= "01000001";  -- 785D = 41
      when "111100001011110" =>  data <= "00100000";  -- 785E = 20
      when "111100001011111" =>  data <= "10000101";  -- 785F = 85
      when "111100001100000" =>  data <= "11110001";  -- 7860 = F1
      when "111100001100001" =>  data <= "10100000";  -- 7861 = A0
      when "111100001100010" =>  data <= "01010110";  -- 7862 = 56
      when "111100001100011" =>  data <= "00100000";  -- 7863 = 20
      when "111100001100100" =>  data <= "10000101";  -- 7864 = 85
      when "111100001100101" =>  data <= "11110001";  -- 7865 = F1
      when "111100001100110" =>  data <= "10100101";  -- 7866 = A5
      when "111100001100111" =>  data <= "11010100";  -- 7867 = D4
      when "111100001101000" =>  data <= "00001001";  -- 7868 = 9
      when "111100001101001" =>  data <= "00110000";  -- 7869 = 30
      when "111100001101010" =>  data <= "00100000";  -- 786A = 20
      when "111100001101011" =>  data <= "00000010";  -- 786B = 2
      when "111100001101100" =>  data <= "11100010";  -- 786C = E2
      when "111100001101101" =>  data <= "00100000";  -- 786D = 20
      when "111100001101110" =>  data <= "00110101";  -- 786E = 35
      when "111100001101111" =>  data <= "11111001";  -- 786F = F9
      when "111100001110000" =>  data <= "00100000";  -- 7870 = 20
      when "111100001110001" =>  data <= "01111010";  -- 7871 = 7A
      when "111100001110010" =>  data <= "11111000";  -- 7872 = F8
      when "111100001110011" =>  data <= "11010000";  -- 7873 = D0
      when "111100001110100" =>  data <= "11111000";  -- 7874 = F8
      when "111100001110101" =>  data <= "10100000";  -- 7875 = A0
      when "111100001110110" =>  data <= "10101010";  -- 7876 = AA
      when "111100001110111" =>  data <= "01001100";  -- 7877 = 4C
      when "111100001111000" =>  data <= "10000101";  -- 7878 = 85
      when "111100001111001" =>  data <= "11110001";  -- 7879 = F1
      when "111100001111010" =>  data <= "10101001";  -- 787A = A9
      when "111100001111011" =>  data <= "00010000";  -- 787B = 10
      when "111100001111100" =>  data <= "10100110";  -- 787C = A6
      when "111100001111101" =>  data <= "11010100";  -- 787D = D4
      when "111100001111110" =>  data <= "11001010";  -- 787E = CA
      when "111100001111111" =>  data <= "11110000";  -- 787F = F0
      when "111100010000000" =>  data <= "00000010";  -- 7880 = 2
      when "111100010000001" =>  data <= "10101001";  -- 7881 = A9
      when "111100010000010" =>  data <= "00100000";  -- 7882 = 20
      when "111100010000011" =>  data <= "00101100";  -- 7883 = 2C
      when "111100010000100" =>  data <= "00010000";  -- 7884 = 10
      when "111100010000101" =>  data <= "11101000";  -- 7885 = E8
      when "111100010000110" =>  data <= "11010000";  -- 7886 = D0
      when "111100010000111" =>  data <= "00000011";  -- 7887 = 3
      when "111100010001000" =>  data <= "00101100";  -- 7888 = 2C
      when "111100010001001" =>  data <= "00010000";  -- 7889 = 10
      when "111100010001010" =>  data <= "11101000";  -- 788A = E8
      when "111100010001011" =>  data <= "01100000";  -- 788B = 60
      when "111100010001100" =>  data <= "00100000";  -- 788C = 20
      when "111100010001101" =>  data <= "01111010";  -- 788D = 7A
      when "111100010001110" =>  data <= "11111000";  -- 788E = F8
      when "111100010001111" =>  data <= "11110000";  -- 788F = F0
      when "111100010010000" =>  data <= "11111010";  -- 7890 = FA
      when "111100010010001" =>  data <= "10100000";  -- 7891 = A0
      when "111100010010010" =>  data <= "01000001";  -- 7892 = 41
      when "111100010010011" =>  data <= "00100000";  -- 7893 = 20
      when "111100010010100" =>  data <= "10000101";  -- 7894 = 85
      when "111100010010101" =>  data <= "11110001";  -- 7895 = F1
      when "111100010010110" =>  data <= "10100000";  -- 7896 = A0
      when "111100010010111" =>  data <= "01001101";  -- 7897 = 4D
      when "111100010011000" =>  data <= "11010000";  -- 7898 = D0
      when "111100010011001" =>  data <= "11000100";  -- 7899 = C4
      when "111100010011010" =>  data <= "10101001";  -- 789A = A9
      when "111100010011011" =>  data <= "00000000";  -- 789B = 0
      when "111100010011100" =>  data <= "10000101";  -- 789C = 85
      when "111100010011101" =>  data <= "10010110";  -- 789D = 96
      when "111100010011110" =>  data <= "10000101";  -- 789E = 85
      when "111100010011111" =>  data <= "10011101";  -- 789F = 9D
      when "111100010100000" =>  data <= "00100000";  -- 78A0 = 20
      when "111100010100001" =>  data <= "10101011";  -- 78A1 = AB
      when "111100010100010" =>  data <= "11110110";  -- 78A2 = F6
      when "111100010100011" =>  data <= "00100000";  -- 78A3 = 20
      when "111100010100100" =>  data <= "00101011";  -- 78A4 = 2B
      when "111100010100101" =>  data <= "11111001";  -- 78A5 = F9
      when "111100010100110" =>  data <= "00100000";  -- 78A6 = 20
      when "111100010100111" =>  data <= "01010111";  -- 78A7 = 57
      when "111100010101000" =>  data <= "11111000";  -- 78A8 = F8
      when "111100010101001" =>  data <= "01111000";  -- 78A9 = 78
      when "111100010101010" =>  data <= "10101001";  -- 78AA = A9
      when "111100010101011" =>  data <= "00000000";  -- 78AB = 0
      when "111100010101100" =>  data <= "10000101";  -- 78AC = 85
      when "111100010101101" =>  data <= "11000010";  -- 78AD = C2
      when "111100010101110" =>  data <= "10000101";  -- 78AE = 85
      when "111100010101111" =>  data <= "11001110";  -- 78AF = CE
      when "111100010110000" =>  data <= "10000101";  -- 78B0 = 85
      when "111100010110001" =>  data <= "11001011";  -- 78B1 = CB
      when "111100010110010" =>  data <= "10000101";  -- 78B2 = 85
      when "111100010110011" =>  data <= "11000000";  -- 78B3 = C0
      when "111100010110100" =>  data <= "10000101";  -- 78B4 = 85
      when "111100010110101" =>  data <= "11000001";  -- 78B5 = C1
      when "111100010110110" =>  data <= "10000101";  -- 78B6 = 85
      when "111100010110111" =>  data <= "10110010";  -- 78B7 = B2
      when "111100010111000" =>  data <= "10100110";  -- 78B8 = A6
      when "111100010111001" =>  data <= "11010100";  -- 78B9 = D4
      when "111100010111010" =>  data <= "11001010";  -- 78BA = CA
      when "111100010111011" =>  data <= "11110000";  -- 78BB = F0
      when "111100010111100" =>  data <= "00000111";  -- 78BC = 7
      when "111100010111101" =>  data <= "10101001";  -- 78BD = A9
      when "111100010111110" =>  data <= "10010000";  -- 78BE = 90
      when "111100010111111" =>  data <= "10001101";  -- 78BF = 8D
      when "111100011000000" =>  data <= "01001110";  -- 78C0 = 4E
      when "111100011000001" =>  data <= "11101000";  -- 78C1 = E8
      when "111100011000010" =>  data <= "11010000";  -- 78C2 = D0
      when "111100011000011" =>  data <= "00000011";  -- 78C3 = 3
      when "111100011000100" =>  data <= "11101110";  -- 78C4 = EE
      when "111100011000101" =>  data <= "00010001";  -- 78C5 = 11
      when "111100011000110" =>  data <= "11101000";  -- 78C6 = E8
      when "111100011000111" =>  data <= "10100010";  -- 78C7 = A2
      when "111100011001000" =>  data <= "00001110";  -- 78C8 = E
      when "111100011001001" =>  data <= "11010000";  -- 78C9 = D0
      when "111100011001010" =>  data <= "00010101";  -- 78CA = 15
      when "111100011001011" =>  data <= "00100000";  -- 78CB = 20
      when "111100011001100" =>  data <= "10101011";  -- 78CC = AB
      when "111100011001101" =>  data <= "11110110";  -- 78CD = F6
      when "111100011001110" =>  data <= "00100000";  -- 78CE = 20
      when "111100011001111" =>  data <= "00101011";  -- 78CF = 2B
      when "111100011010000" =>  data <= "11111001";  -- 78D0 = F9
      when "111100011010001" =>  data <= "10101001";  -- 78D1 = A9
      when "111100011010010" =>  data <= "00010100";  -- 78D2 = 14
      when "111100011010011" =>  data <= "10000101";  -- 78D3 = 85
      when "111100011010100" =>  data <= "11000011";  -- 78D4 = C3
      when "111100011010101" =>  data <= "00100000";  -- 78D5 = 20
      when "111100011010110" =>  data <= "10001100";  -- 78D6 = 8C
      when "111100011010111" =>  data <= "11111000";  -- 78D7 = F8
      when "111100011011000" =>  data <= "01111000";  -- 78D8 = 78
      when "111100011011001" =>  data <= "10101001";  -- 78D9 = A9
      when "111100011011010" =>  data <= "10100000";  -- 78DA = A0
      when "111100011011011" =>  data <= "10001101";  -- 78DB = 8D
      when "111100011011100" =>  data <= "01001110";  -- 78DC = 4E
      when "111100011011101" =>  data <= "11101000";  -- 78DD = E8
      when "111100011011110" =>  data <= "10100010";  -- 78DE = A2
      when "111100011011111" =>  data <= "00001000";  -- 78DF = 8
      when "111100011100000" =>  data <= "00100000";  -- 78E0 = 20
      when "111100011100001" =>  data <= "11100000";  -- 78E1 = E0
      when "111100011100010" =>  data <= "11111100";  -- 78E2 = FC
      when "111100011100011" =>  data <= "10101001";  -- 78E3 = A9
      when "111100011100100" =>  data <= "00000010";  -- 78E4 = 2
      when "111100011100101" =>  data <= "10000101";  -- 78E5 = 85
      when "111100011100110" =>  data <= "11011110";  -- 78E6 = DE
      when "111100011100111" =>  data <= "00100000";  -- 78E7 = 20
      when "111100011101000" =>  data <= "11001001";  -- 78E8 = C9
      when "111100011101001" =>  data <= "11111011";  -- 78E9 = FB
      when "111100011101010" =>  data <= "11001110";  -- 78EA = CE
      when "111100011101011" =>  data <= "00010011";  -- 78EB = 13
      when "111100011101100" =>  data <= "11101000";  -- 78EC = E8
      when "111100011101101" =>  data <= "10100110";  -- 78ED = A6
      when "111100011101110" =>  data <= "11010100";  -- 78EE = D4
      when "111100011101111" =>  data <= "11001010";  -- 78EF = CA
      when "111100011110000" =>  data <= "11010000";  -- 78F0 = D0
      when "111100011110001" =>  data <= "00001001";  -- 78F1 = 9
      when "111100011110010" =>  data <= "10101001";  -- 78F2 = A9
      when "111100011110011" =>  data <= "00110100";  -- 78F3 = 34
      when "111100011110100" =>  data <= "10001101";  -- 78F4 = 8D
      when "111100011110101" =>  data <= "00010011";  -- 78F5 = 13
      when "111100011110110" =>  data <= "11101000";  -- 78F6 = E8
      when "111100011110111" =>  data <= "10000101";  -- 78F7 = 85
      when "111100011111000" =>  data <= "11111001";  -- 78F8 = F9
      when "111100011111001" =>  data <= "11010000";  -- 78F9 = D0
      when "111100011111010" =>  data <= "00001010";  -- 78FA = A
      when "111100011111011" =>  data <= "10101101";  -- 78FB = AD
      when "111100011111100" =>  data <= "01000000";  -- 78FC = 40
      when "111100011111101" =>  data <= "11101000";  -- 78FD = E8
      when "111100011111110" =>  data <= "10000110";  -- 78FE = 86
      when "111100011111111" =>  data <= "11111010";  -- 78FF = FA
      when "111100100000000" =>  data <= "00101001";  -- 7900 = 29
      when "111100100000001" =>  data <= "11101111";  -- 7901 = EF
      when "111100100000010" =>  data <= "10001101";  -- 7902 = 8D
      when "111100100000011" =>  data <= "01000000";  -- 7903 = 40
      when "111100100000100" =>  data <= "11101000";  -- 7904 = E8
      when "111100100000101" =>  data <= "10100010";  -- 7905 = A2
      when "111100100000110" =>  data <= "11111111";  -- 7906 = FF
      when "111100100000111" =>  data <= "10100000";  -- 7907 = A0
      when "111100100001000" =>  data <= "11111111";  -- 7908 = FF
      when "111100100001001" =>  data <= "10001000";  -- 7909 = 88
      when "111100100001010" =>  data <= "11010000";  -- 790A = D0
      when "111100100001011" =>  data <= "11111101";  -- 790B = FD
      when "111100100001100" =>  data <= "11001010";  -- 790C = CA
      when "111100100001101" =>  data <= "11010000";  -- 790D = D0
      when "111100100001110" =>  data <= "11111000";  -- 790E = F8
      when "111100100001111" =>  data <= "10001101";  -- 790F = 8D
      when "111100100010000" =>  data <= "01001001";  -- 7910 = 49
      when "111100100010001" =>  data <= "11101000";  -- 7911 = E8
      when "111100100010010" =>  data <= "01011000";  -- 7912 = 58
      when "111100100010011" =>  data <= "10101001";  -- 7913 = A9
      when "111100100010100" =>  data <= "11100100";  -- 7914 = E4
      when "111100100010101" =>  data <= "11000101";  -- 7915 = C5
      when "111100100010110" =>  data <= "10010001";  -- 7916 = 91
      when "111100100010111" =>  data <= "11110000";  -- 7917 = F0
      when "111100100011000" =>  data <= "00010001";  -- 7918 = 11
      when "111100100011001" =>  data <= "00100000";  -- 7919 = 20
      when "111100100011010" =>  data <= "00110101";  -- 791A = 35
      when "111100100011011" =>  data <= "11111001";  -- 791B = F9
      when "111100100011100" =>  data <= "00101100";  -- 791C = 2C
      when "111100100011101" =>  data <= "00010011";  -- 791D = 13
      when "111100100011110" =>  data <= "11101000";  -- 791E = E8
      when "111100100011111" =>  data <= "00010000";  -- 791F = 10
      when "111100100100000" =>  data <= "11110010";  -- 7920 = F2
      when "111100100100001" =>  data <= "00101100";  -- 7921 = 2C
      when "111100100100010" =>  data <= "00010010";  -- 7922 = 12
      when "111100100100011" =>  data <= "11101000";  -- 7923 = E8
      when "111100100100100" =>  data <= "00100000";  -- 7924 = 20
      when "111100100100101" =>  data <= "01101000";  -- 7925 = 68
      when "111100100100110" =>  data <= "11110111";  -- 7926 = F7
      when "111100100100111" =>  data <= "01001100";  -- 7927 = 4C
      when "111100100101000" =>  data <= "00010011";  -- 7928 = 13
      when "111100100101001" =>  data <= "11111001";  -- 7929 = F9
      when "111100100101010" =>  data <= "01100000";  -- 792A = 60
      when "111100100101011" =>  data <= "00100000";  -- 792B = 20
      when "111100100101100" =>  data <= "00110101";  -- 792C = 35
      when "111100100101101" =>  data <= "11111001";  -- 792D = F9
      when "111100100101110" =>  data <= "10101001";  -- 792E = A9
      when "111100100101111" =>  data <= "11100100";  -- 792F = E4
      when "111100100110000" =>  data <= "11000101";  -- 7930 = C5
      when "111100100110001" =>  data <= "10010001";  -- 7931 = 91
      when "111100100110010" =>  data <= "11010000";  -- 7932 = D0
      when "111100100110011" =>  data <= "11110111";  -- 7933 = F7
      when "111100100110100" =>  data <= "01100000";  -- 7934 = 60
      when "111100100110101" =>  data <= "00100000";  -- 7935 = 20
      when "111100100110110" =>  data <= "00110101";  -- 7936 = 35
      when "111100100110111" =>  data <= "11110011";  -- 7937 = F3
      when "111100100111000" =>  data <= "11010000";  -- 7938 = D0
      when "111100100111001" =>  data <= "00001000";  -- 7939 = 8
      when "111100100111010" =>  data <= "00100000";  -- 793A = 20
      when "111100100111011" =>  data <= "11000000";  -- 793B = C0
      when "111100100111100" =>  data <= "11111100";  -- 793C = FC
      when "111100100111101" =>  data <= "00100000";  -- 793D = 20
      when "111100100111110" =>  data <= "10111000";  -- 793E = B8
      when "111100100111111" =>  data <= "11110010";  -- 793F = F2
      when "111100101000000" =>  data <= "10000101";  -- 7940 = 85
      when "111100101000001" =>  data <= "00010000";  -- 7941 = 10
      when "111100101000010" =>  data <= "01001100";  -- 7942 = 4C
      when "111100101000011" =>  data <= "11000110";  -- 7943 = C6
      when "111100101000100" =>  data <= "10110111";  -- 7944 = B7
      when "111100101000101" =>  data <= "10000110";  -- 7945 = 86
      when "111100101000110" =>  data <= "11001100";  -- 7946 = CC
      when "111100101000111" =>  data <= "10100101";  -- 7947 = A5
      when "111100101001000" =>  data <= "11001011";  -- 7948 = CB
      when "111100101001001" =>  data <= "00001010";  -- 7949 = A
      when "111100101001010" =>  data <= "00001010";  -- 794A = A
      when "111100101001011" =>  data <= "00011000";  -- 794B = 18
      when "111100101001100" =>  data <= "01100101";  -- 794C = 65
      when "111100101001101" =>  data <= "11001011";  -- 794D = CB
      when "111100101001110" =>  data <= "00011000";  -- 794E = 18
      when "111100101001111" =>  data <= "01100101";  -- 794F = 65
      when "111100101010000" =>  data <= "11001100";  -- 7950 = CC
      when "111100101010001" =>  data <= "10000101";  -- 7951 = 85
      when "111100101010010" =>  data <= "11001100";  -- 7952 = CC
      when "111100101010011" =>  data <= "10101001";  -- 7953 = A9
      when "111100101010100" =>  data <= "00000000";  -- 7954 = 0
      when "111100101010101" =>  data <= "00100100";  -- 7955 = 24
      when "111100101010110" =>  data <= "11001011";  -- 7956 = CB
      when "111100101010111" =>  data <= "00110000";  -- 7957 = 30
      when "111100101011000" =>  data <= "00000001";  -- 7958 = 1
      when "111100101011001" =>  data <= "00101010";  -- 7959 = 2A
      when "111100101011010" =>  data <= "00000110";  -- 795A = 6
      when "111100101011011" =>  data <= "11001100";  -- 795B = CC
      when "111100101011100" =>  data <= "00101010";  -- 795C = 2A
      when "111100101011101" =>  data <= "00000110";  -- 795D = 6
      when "111100101011110" =>  data <= "11001100";  -- 795E = CC
      when "111100101011111" =>  data <= "00101010";  -- 795F = 2A
      when "111100101100000" =>  data <= "10101010";  -- 7960 = AA
      when "111100101100001" =>  data <= "10101101";  -- 7961 = AD
      when "111100101100010" =>  data <= "01001000";  -- 7962 = 48
      when "111100101100011" =>  data <= "11101000";  -- 7963 = E8
      when "111100101100100" =>  data <= "11001001";  -- 7964 = C9
      when "111100101100101" =>  data <= "00010101";  -- 7965 = 15
      when "111100101100110" =>  data <= "10010000";  -- 7966 = 90
      when "111100101100111" =>  data <= "11111001";  -- 7967 = F9
      when "111100101101000" =>  data <= "01100101";  -- 7968 = 65
      when "111100101101001" =>  data <= "11001100";  -- 7969 = CC
      when "111100101101010" =>  data <= "10001101";  -- 796A = 8D
      when "111100101101011" =>  data <= "01000100";  -- 796B = 44
      when "111100101101100" =>  data <= "11101000";  -- 796C = E8
      when "111100101101101" =>  data <= "10001010";  -- 796D = 8A
      when "111100101101110" =>  data <= "01101101";  -- 796E = 6D
      when "111100101101111" =>  data <= "01001001";  -- 796F = 49
      when "111100101110000" =>  data <= "11101000";  -- 7970 = E8
      when "111100101110001" =>  data <= "10001101";  -- 7971 = 8D
      when "111100101110010" =>  data <= "01000101";  -- 7972 = 45
      when "111100101110011" =>  data <= "11101000";  -- 7973 = E8
      when "111100101110100" =>  data <= "01011000";  -- 7974 = 58
      when "111100101110101" =>  data <= "01100000";  -- 7975 = 60
      when "111100101110110" =>  data <= "10101110";  -- 7976 = AE
      when "111100101110111" =>  data <= "01001001";  -- 7977 = 49
      when "111100101111000" =>  data <= "11101000";  -- 7978 = E8
      when "111100101111001" =>  data <= "10100000";  -- 7979 = A0
      when "111100101111010" =>  data <= "11111111";  -- 797A = FF
      when "111100101111011" =>  data <= "10011000";  -- 797B = 98
      when "111100101111100" =>  data <= "11101101";  -- 797C = ED
      when "111100101111101" =>  data <= "01001000";  -- 797D = 48
      when "111100101111110" =>  data <= "11101000";  -- 797E = E8
      when "111100101111111" =>  data <= "11101100";  -- 797F = EC
      when "111100110000000" =>  data <= "01001001";  -- 7980 = 49
      when "111100110000001" =>  data <= "11101000";  -- 7981 = E8
      when "111100110000010" =>  data <= "11010000";  -- 7982 = D0
      when "111100110000011" =>  data <= "11110010";  -- 7983 = F2
      when "111100110000100" =>  data <= "10000110";  -- 7984 = 86
      when "111100110000101" =>  data <= "11001100";  -- 7985 = CC
      when "111100110000110" =>  data <= "10101010";  -- 7986 = AA
      when "111100110000111" =>  data <= "10001100";  -- 7987 = 8C
      when "111100110001000" =>  data <= "01001000";  -- 7988 = 48
      when "111100110001001" =>  data <= "11101000";  -- 7989 = E8
      when "111100110001010" =>  data <= "10001100";  -- 798A = 8C
      when "111100110001011" =>  data <= "01001001";  -- 798B = 49
      when "111100110001100" =>  data <= "11101000";  -- 798C = E8
      when "111100110001101" =>  data <= "10011000";  -- 798D = 98
      when "111100110001110" =>  data <= "11100101";  -- 798E = E5
      when "111100110001111" =>  data <= "11001100";  -- 798F = CC
      when "111100110010000" =>  data <= "10000110";  -- 7990 = 86
      when "111100110010001" =>  data <= "11001100";  -- 7991 = CC
      when "111100110010010" =>  data <= "01001010";  -- 7992 = 4A
      when "111100110010011" =>  data <= "01100110";  -- 7993 = 66
      when "111100110010100" =>  data <= "11001100";  -- 7994 = CC
      when "111100110010101" =>  data <= "01001010";  -- 7995 = 4A
      when "111100110010110" =>  data <= "01100110";  -- 7996 = 66
      when "111100110010111" =>  data <= "11001100";  -- 7997 = CC
      when "111100110011000" =>  data <= "10100101";  -- 7998 = A5
      when "111100110011001" =>  data <= "11001011";  -- 7999 = CB
      when "111100110011010" =>  data <= "00011000";  -- 799A = 18
      when "111100110011011" =>  data <= "01101001";  -- 799B = 69
      when "111100110011100" =>  data <= "00111100";  -- 799C = 3C
      when "111100110011101" =>  data <= "00101100";  -- 799D = 2C
      when "111100110011110" =>  data <= "01000000";  -- 799E = 40
      when "111100110011111" =>  data <= "11101000";  -- 799F = E8
      when "111100110100000" =>  data <= "00101100";  -- 79A0 = 2C
      when "111100110100001" =>  data <= "00010000";  -- 79A1 = 10
      when "111100110100010" =>  data <= "11101000";  -- 79A2 = E8
      when "111100110100011" =>  data <= "11000101";  -- 79A3 = C5
      when "111100110100100" =>  data <= "11001100";  -- 79A4 = CC
      when "111100110100101" =>  data <= "10110000";  -- 79A5 = B0
      when "111100110100110" =>  data <= "01001010";  -- 79A6 = 4A
      when "111100110100111" =>  data <= "10100110";  -- 79A7 = A6
      when "111100110101000" =>  data <= "10110010";  -- 79A8 = B2
      when "111100110101001" =>  data <= "11110000";  -- 79A9 = F0
      when "111100110101010" =>  data <= "00000011";  -- 79AA = 3
      when "111100110101011" =>  data <= "01001100";  -- 79AB = 4C
      when "111100110101100" =>  data <= "10011100";  -- 79AC = 9C
      when "111100110101101" =>  data <= "11111010";  -- 79AD = FA
      when "111100110101110" =>  data <= "10100110";  -- 79AE = A6
      when "111100110101111" =>  data <= "10110111";  -- 79AF = B7
      when "111100110110000" =>  data <= "00110000";  -- 79B0 = 30
      when "111100110110001" =>  data <= "00011011";  -- 79B1 = 1B
      when "111100110110010" =>  data <= "10100010";  -- 79B2 = A2
      when "111100110110011" =>  data <= "00000000";  -- 79B3 = 0
      when "111100110110100" =>  data <= "01101001";  -- 79B4 = 69
      when "111100110110101" =>  data <= "00110000";  -- 79B5 = 30
      when "111100110110110" =>  data <= "01100101";  -- 79B6 = 65
      when "111100110110111" =>  data <= "11001011";  -- 79B7 = CB
      when "111100110111000" =>  data <= "11000101";  -- 79B8 = C5
      when "111100110111001" =>  data <= "11001100";  -- 79B9 = CC
      when "111100110111010" =>  data <= "10110000";  -- 79BA = B0
      when "111100110111011" =>  data <= "00011100";  -- 79BB = 1C
      when "111100110111100" =>  data <= "11101000";  -- 79BC = E8
      when "111100110111101" =>  data <= "01101001";  -- 79BD = 69
      when "111100110111110" =>  data <= "00100110";  -- 79BE = 26
      when "111100110111111" =>  data <= "01100101";  -- 79BF = 65
      when "111100111000000" =>  data <= "11001011";  -- 79C0 = CB
      when "111100111000001" =>  data <= "11000101";  -- 79C1 = C5
      when "111100111000010" =>  data <= "11001100";  -- 79C2 = CC
      when "111100111000011" =>  data <= "10110000";  -- 79C3 = B0
      when "111100111000100" =>  data <= "00010111";  -- 79C4 = 17
      when "111100111000101" =>  data <= "01101001";  -- 79C5 = 69
      when "111100111000110" =>  data <= "00101100";  -- 79C6 = 2C
      when "111100111000111" =>  data <= "01100101";  -- 79C7 = 65
      when "111100111001000" =>  data <= "11001011";  -- 79C8 = CB
      when "111100111001001" =>  data <= "11000101";  -- 79C9 = C5
      when "111100111001010" =>  data <= "11001100";  -- 79CA = CC
      when "111100111001011" =>  data <= "10010000";  -- 79CB = 90
      when "111100111001100" =>  data <= "00000011";  -- 79CC = 3
      when "111100111001101" =>  data <= "01001100";  -- 79CD = 4C
      when "111100111001110" =>  data <= "01001100";  -- 79CE = 4C
      when "111100111001111" =>  data <= "11111010";  -- 79CF = FA
      when "111100111010000" =>  data <= "10100101";  -- 79D0 = A5
      when "111100111010001" =>  data <= "11001110";  -- 79D1 = CE
      when "111100111010010" =>  data <= "11110000";  -- 79D2 = F0
      when "111100111010011" =>  data <= "00011101";  -- 79D3 = 1D
      when "111100111010100" =>  data <= "10000101";  -- 79D4 = 85
      when "111100111010101" =>  data <= "10111110";  -- 79D5 = BE
      when "111100111010110" =>  data <= "11010000";  -- 79D6 = D0
      when "111100111010111" =>  data <= "00011001";  -- 79D7 = 19
      when "111100111011000" =>  data <= "11100110";  -- 79D8 = E6
      when "111100111011001" =>  data <= "10111111";  -- 79D9 = BF
      when "111100111011010" =>  data <= "10110000";  -- 79DA = B0
      when "111100111011011" =>  data <= "00000010";  -- 79DB = 2
      when "111100111011100" =>  data <= "11000110";  -- 79DC = C6
      when "111100111011101" =>  data <= "10111111";  -- 79DD = BF
      when "111100111011110" =>  data <= "00111000";  -- 79DE = 38
      when "111100111011111" =>  data <= "11101001";  -- 79DF = E9
      when "111100111100000" =>  data <= "00010011";  -- 79E0 = 13
      when "111100111100001" =>  data <= "11100101";  -- 79E1 = E5
      when "111100111100010" =>  data <= "11001100";  -- 79E2 = CC
      when "111100111100011" =>  data <= "01100101";  -- 79E3 = 65
      when "111100111100100" =>  data <= "10011100";  -- 79E4 = 9C
      when "111100111100101" =>  data <= "10000101";  -- 79E5 = 85
      when "111100111100110" =>  data <= "10011100";  -- 79E6 = 9C
      when "111100111100111" =>  data <= "10100101";  -- 79E7 = A5
      when "111100111101000" =>  data <= "10111001";  -- 79E8 = B9
      when "111100111101001" =>  data <= "01001001";  -- 79E9 = 49
      when "111100111101010" =>  data <= "00000001";  -- 79EA = 1
      when "111100111101011" =>  data <= "10000101";  -- 79EB = 85
      when "111100111101100" =>  data <= "10111001";  -- 79EC = B9
      when "111100111101101" =>  data <= "11110000";  -- 79ED = F0
      when "111100111101110" =>  data <= "00100001";  -- 79EE = 21
      when "111100111101111" =>  data <= "10000110";  -- 79EF = 86
      when "111100111110000" =>  data <= "11011001";  -- 79F0 = D9
      when "111100111110001" =>  data <= "10100101";  -- 79F1 = A5
      when "111100111110010" =>  data <= "11001110";  -- 79F2 = CE
      when "111100111110011" =>  data <= "11110000";  -- 79F3 = F0
      when "111100111110100" =>  data <= "00011000";  -- 79F4 = 18
      when "111100111110101" =>  data <= "00101100";  -- 79F5 = 2C
      when "111100111110110" =>  data <= "01001101";  -- 79F6 = 4D
      when "111100111110111" =>  data <= "11101000";  -- 79F7 = E8
      when "111100111111000" =>  data <= "01010000";  -- 79F8 = 50
      when "111100111111001" =>  data <= "00010011";  -- 79F9 = 13
      when "111100111111010" =>  data <= "10101001";  -- 79FA = A9
      when "111100111111011" =>  data <= "00000000";  -- 79FB = 0
      when "111100111111100" =>  data <= "10000101";  -- 79FC = 85
      when "111100111111101" =>  data <= "10111001";  -- 79FD = B9
      when "111100111111110" =>  data <= "10100101";  -- 79FE = A5
      when "111100111111111" =>  data <= "10110111";  -- 79FF = B7
      when "111101000000000" =>  data <= "00010000";  -- 7A00 = 10
      when "111101000000001" =>  data <= "00110001";  -- 7A01 = 31
      when "111101000000010" =>  data <= "00110000";  -- 7A02 = 30
      when "111101000000011" =>  data <= "11001001";  -- 7A03 = C9
      when "111101000000100" =>  data <= "10100010";  -- 7A04 = A2
      when "111101000000101" =>  data <= "10100110";  -- 7A05 = A6
      when "111101000000110" =>  data <= "00100000";  -- 7A06 = 20
      when "111101000000111" =>  data <= "01000101";  -- 7A07 = 45
      when "111101000001000" =>  data <= "11111001";  -- 7A08 = F9
      when "111101000001001" =>  data <= "10100101";  -- 7A09 = A5
      when "111101000001010" =>  data <= "10110001";  -- 7A0A = B1
      when "111101000001011" =>  data <= "11010000";  -- 7A0B = D0
      when "111101000001100" =>  data <= "11000011";  -- 7A0C = C3
      when "111101000001101" =>  data <= "01001100";  -- 7A0D = 4C
      when "111101000001110" =>  data <= "00000000";  -- 7A0E = 0
      when "111101000001111" =>  data <= "11100110";  -- 7A0F = E6
      when "111101000010000" =>  data <= "10100101";  -- 7A10 = A5
      when "111101000010001" =>  data <= "10011100";  -- 7A11 = 9C
      when "111101000010010" =>  data <= "11110000";  -- 7A12 = F0
      when "111101000010011" =>  data <= "00001000";  -- 7A13 = 8
      when "111101000010100" =>  data <= "00110000";  -- 7A14 = 30
      when "111101000010101" =>  data <= "00000100";  -- 7A15 = 4
      when "111101000010110" =>  data <= "11000110";  -- 7A16 = C6
      when "111101000010111" =>  data <= "11001011";  -- 7A17 = CB
      when "111101000011000" =>  data <= "11000110";  -- 7A18 = C6
      when "111101000011001" =>  data <= "11001011";  -- 7A19 = CB
      when "111101000011010" =>  data <= "11100110";  -- 7A1A = E6
      when "111101000011011" =>  data <= "11001011";  -- 7A1B = CB
      when "111101000011100" =>  data <= "10101001";  -- 7A1C = A9
      when "111101000011101" =>  data <= "00000000";  -- 7A1D = 0
      when "111101000011110" =>  data <= "10000101";  -- 7A1E = 85
      when "111101000011111" =>  data <= "10011100";  -- 7A1F = 9C
      when "111101000100000" =>  data <= "11100100";  -- 7A20 = E4
      when "111101000100001" =>  data <= "11011001";  -- 7A21 = D9
      when "111101000100010" =>  data <= "11010000";  -- 7A22 = D0
      when "111101000100011" =>  data <= "00001111";  -- 7A23 = F
      when "111101000100100" =>  data <= "10001010";  -- 7A24 = 8A
      when "111101000100101" =>  data <= "11010000";  -- 7A25 = D0
      when "111101000100110" =>  data <= "10101001";  -- 7A26 = A9
      when "111101000100111" =>  data <= "10100101";  -- 7A27 = A5
      when "111101000101000" =>  data <= "10111111";  -- 7A28 = BF
      when "111101000101001" =>  data <= "00110000";  -- 7A29 = 30
      when "111101000101010" =>  data <= "11000110";  -- 7A2A = C6
      when "111101000101011" =>  data <= "11001001";  -- 7A2B = C9
      when "111101000101100" =>  data <= "00010000";  -- 7A2C = 10
      when "111101000101101" =>  data <= "10010000";  -- 7A2D = 90
      when "111101000101110" =>  data <= "11000010";  -- 7A2E = C2
      when "111101000101111" =>  data <= "10000101";  -- 7A2F = 85
      when "111101000110000" =>  data <= "10101011";  -- 7A30 = AB
      when "111101000110001" =>  data <= "10110000";  -- 7A31 = B0
      when "111101000110010" =>  data <= "10111110";  -- 7A32 = BE
      when "111101000110011" =>  data <= "10001010";  -- 7A33 = 8A
      when "111101000110100" =>  data <= "01000101";  -- 7A34 = 45
      when "111101000110101" =>  data <= "10110001";  -- 7A35 = B1
      when "111101000110110" =>  data <= "10000101";  -- 7A36 = 85
      when "111101000110111" =>  data <= "10110001";  -- 7A37 = B1
      when "111101000111000" =>  data <= "10100101";  -- 7A38 = A5
      when "111101000111001" =>  data <= "11001110";  -- 7A39 = CE
      when "111101000111010" =>  data <= "11110000";  -- 7A3A = F0
      when "111101000111011" =>  data <= "11010001";  -- 7A3B = D1
      when "111101000111100" =>  data <= "11000110";  -- 7A3C = C6
      when "111101000111101" =>  data <= "10110111";  -- 7A3D = B7
      when "111101000111110" =>  data <= "00110000";  -- 7A3E = 30
      when "111101000111111" =>  data <= "11000100";  -- 7A3F = C4
      when "111101001000000" =>  data <= "01000110";  -- 7A40 = 46
      when "111101001000001" =>  data <= "11011001";  -- 7A41 = D9
      when "111101001000010" =>  data <= "01100110";  -- 7A42 = 66
      when "111101001000011" =>  data <= "11011111";  -- 7A43 = DF
      when "111101001000100" =>  data <= "10100010";  -- 7A44 = A2
      when "111101001000101" =>  data <= "11011010";  -- 7A45 = DA
      when "111101001000110" =>  data <= "00100000";  -- 7A46 = 20
      when "111101001000111" =>  data <= "01000101";  -- 7A47 = 45
      when "111101001001000" =>  data <= "11111001";  -- 7A48 = F9
      when "111101001001001" =>  data <= "01001100";  -- 7A49 = 4C
      when "111101001001010" =>  data <= "00000000";  -- 7A4A = 0
      when "111101001001011" =>  data <= "11100110";  -- 7A4B = E6
      when "111101001001100" =>  data <= "10100101";  -- 7A4C = A5
      when "111101001001101" =>  data <= "10101011";  -- 7A4D = AB
      when "111101001001110" =>  data <= "11110000";  -- 7A4E = F0
      when "111101001001111" =>  data <= "00000100";  -- 7A4F = 4
      when "111101001010000" =>  data <= "10100101";  -- 7A50 = A5
      when "111101001010001" =>  data <= "11001110";  -- 7A51 = CE
      when "111101001010010" =>  data <= "11110000";  -- 7A52 = F0
      when "111101001010011" =>  data <= "00000111";  -- 7A53 = 7
      when "111101001010100" =>  data <= "10100101";  -- 7A54 = A5
      when "111101001010101" =>  data <= "10110111";  -- 7A55 = B7
      when "111101001010110" =>  data <= "00110000";  -- 7A56 = 30
      when "111101001010111" =>  data <= "00000011";  -- 7A57 = 3
      when "111101001011000" =>  data <= "01001100";  -- 7A58 = 4C
      when "111101001011001" =>  data <= "11011100";  -- 7A59 = DC
      when "111101001011010" =>  data <= "11111001";  -- 7A5A = F9
      when "111101001011011" =>  data <= "01000110";  -- 7A5B = 46
      when "111101001011100" =>  data <= "11001100";  -- 7A5C = CC
      when "111101001011101" =>  data <= "10101001";  -- 7A5D = A9
      when "111101001011110" =>  data <= "10010011";  -- 7A5E = 93
      when "111101001011111" =>  data <= "00111000";  -- 7A5F = 38
      when "111101001100000" =>  data <= "11100101";  -- 7A60 = E5
      when "111101001100001" =>  data <= "11001100";  -- 7A61 = CC
      when "111101001100010" =>  data <= "01100101";  -- 7A62 = 65
      when "111101001100011" =>  data <= "11001011";  -- 7A63 = CB
      when "111101001100100" =>  data <= "00001010";  -- 7A64 = A
      when "111101001100101" =>  data <= "10101010";  -- 7A65 = AA
      when "111101001100110" =>  data <= "00100000";  -- 7A66 = 20
      when "111101001100111" =>  data <= "01000101";  -- 7A67 = 45
      when "111101001101000" =>  data <= "11111001";  -- 7A68 = F9
      when "111101001101001" =>  data <= "11100110";  -- 7A69 = E6
      when "111101001101010" =>  data <= "10110010";  -- 7A6A = B2
      when "111101001101011" =>  data <= "10100101";  -- 7A6B = A5
      when "111101001101100" =>  data <= "11001110";  -- 7A6C = CE
      when "111101001101101" =>  data <= "11010000";  -- 7A6D = D0
      when "111101001101110" =>  data <= "00010001";  -- 7A6E = 11
      when "111101001101111" =>  data <= "10100101";  -- 7A6F = A5
      when "111101001110000" =>  data <= "10101011";  -- 7A70 = AB
      when "111101001110001" =>  data <= "11110000";  -- 7A71 = F0
      when "111101001110010" =>  data <= "00100110";  -- 7A72 = 26
      when "111101001110011" =>  data <= "10000101";  -- 7A73 = 85
      when "111101001110100" =>  data <= "10111110";  -- 7A74 = BE
      when "111101001110101" =>  data <= "10101001";  -- 7A75 = A9
      when "111101001110110" =>  data <= "00000000";  -- 7A76 = 0
      when "111101001110111" =>  data <= "10000101";  -- 7A77 = 85
      when "111101001111000" =>  data <= "10101011";  -- 7A78 = AB
      when "111101001111001" =>  data <= "10101001";  -- 7A79 = A9
      when "111101001111010" =>  data <= "11000000";  -- 7A7A = C0
      when "111101001111011" =>  data <= "10001101";  -- 7A7B = 8D
      when "111101001111100" =>  data <= "01001110";  -- 7A7C = 4E
      when "111101001111101" =>  data <= "11101000";  -- 7A7D = E8
      when "111101001111110" =>  data <= "10000101";  -- 7A7E = 85
      when "111101001111111" =>  data <= "11001110";  -- 7A7F = CE
      when "111101010000000" =>  data <= "10100101";  -- 7A80 = A5
      when "111101010000001" =>  data <= "10101011";  -- 7A81 = AB
      when "111101010000010" =>  data <= "10000101";  -- 7A82 = 85
      when "111101010000011" =>  data <= "11001111";  -- 7A83 = CF
      when "111101010000100" =>  data <= "11110000";  -- 7A84 = F0
      when "111101010000101" =>  data <= "00001001";  -- 7A85 = 9
      when "111101010000110" =>  data <= "10101001";  -- 7A86 = A9
      when "111101010000111" =>  data <= "00000000";  -- 7A87 = 0
      when "111101010001000" =>  data <= "10000101";  -- 7A88 = 85
      when "111101010001001" =>  data <= "11001110";  -- 7A89 = CE
      when "111101010001010" =>  data <= "10101001";  -- 7A8A = A9
      when "111101010001011" =>  data <= "01000000";  -- 7A8B = 40
      when "111101010001100" =>  data <= "10001101";  -- 7A8C = 8D
      when "111101010001101" =>  data <= "01001110";  -- 7A8D = 4E
      when "111101010001110" =>  data <= "11101000";  -- 7A8E = E8
      when "111101010001111" =>  data <= "10100101";  -- 7A8F = A5
      when "111101010010000" =>  data <= "11011111";  -- 7A90 = DF
      when "111101010010001" =>  data <= "10000101";  -- 7A91 = 85
      when "111101010010010" =>  data <= "11011101";  -- 7A92 = DD
      when "111101010010011" =>  data <= "10100101";  -- 7A93 = A5
      when "111101010010100" =>  data <= "10111110";  -- 7A94 = BE
      when "111101010010101" =>  data <= "00000101";  -- 7A95 = 5
      when "111101010010110" =>  data <= "10111111";  -- 7A96 = BF
      when "111101010010111" =>  data <= "10000101";  -- 7A97 = 85
      when "111101010011000" =>  data <= "11010000";  -- 7A98 = D0
      when "111101010011001" =>  data <= "01001100";  -- 7A99 = 4C
      when "111101010011010" =>  data <= "00000000";  -- 7A9A = 0
      when "111101010011011" =>  data <= "11100110";  -- 7A9B = E6
      when "111101010011100" =>  data <= "00100000";  -- 7A9C = 20
      when "111101010011101" =>  data <= "11001001";  -- 7A9D = C9
      when "111101010011110" =>  data <= "11111011";  -- 7A9E = FB
      when "111101010011111" =>  data <= "10000101";  -- 7A9F = 85
      when "111101010100000" =>  data <= "10110010";  -- 7AA0 = B2
      when "111101010100001" =>  data <= "10100010";  -- 7AA1 = A2
      when "111101010100010" =>  data <= "11011010";  -- 7AA2 = DA
      when "111101010100011" =>  data <= "00100000";  -- 7AA3 = 20
      when "111101010100100" =>  data <= "01000101";  -- 7AA4 = 45
      when "111101010100101" =>  data <= "11111001";  -- 7AA5 = F9
      when "111101010100110" =>  data <= "10100101";  -- 7AA6 = A5
      when "111101010100111" =>  data <= "11011110";  -- 7AA7 = DE
      when "111101010101000" =>  data <= "11110000";  -- 7AA8 = F0
      when "111101010101001" =>  data <= "00000010";  -- 7AA9 = 2
      when "111101010101010" =>  data <= "10000101";  -- 7AAA = 85
      when "111101010101011" =>  data <= "10111101";  -- 7AAB = BD
      when "111101010101100" =>  data <= "10101001";  -- 7AAC = A9
      when "111101010101101" =>  data <= "00001111";  -- 7AAD = F
      when "111101010101110" =>  data <= "00100100";  -- 7AAE = 24
      when "111101010101111" =>  data <= "11000010";  -- 7AAF = C2
      when "111101010110000" =>  data <= "00010000";  -- 7AB0 = 10
      when "111101010110001" =>  data <= "00010111";  -- 7AB1 = 17
      when "111101010110010" =>  data <= "10100101";  -- 7AB2 = A5
      when "111101010110011" =>  data <= "11001111";  -- 7AB3 = CF
      when "111101010110100" =>  data <= "11010000";  -- 7AB4 = D0
      when "111101010110101" =>  data <= "00001100";  -- 7AB5 = C
      when "111101010110110" =>  data <= "10100110";  -- 7AB6 = A6
      when "111101010110111" =>  data <= "11011110";  -- 7AB7 = DE
      when "111101010111000" =>  data <= "11001010";  -- 7AB8 = CA
      when "111101010111001" =>  data <= "11010000";  -- 7AB9 = D0
      when "111101010111010" =>  data <= "00001011";  -- 7ABA = B
      when "111101010111011" =>  data <= "10101001";  -- 7ABB = A9
      when "111101010111100" =>  data <= "00001000";  -- 7ABC = 8
      when "111101010111101" =>  data <= "00100000";  -- 7ABD = 20
      when "111101010111110" =>  data <= "11000100";  -- 7ABE = C4
      when "111101010111111" =>  data <= "11111011";  -- 7ABF = FB
      when "111101011000000" =>  data <= "11010000";  -- 7AC0 = D0
      when "111101011000001" =>  data <= "00000100";  -- 7AC1 = 4
      when "111101011000010" =>  data <= "10101001";  -- 7AC2 = A9
      when "111101011000011" =>  data <= "00000000";  -- 7AC3 = 0
      when "111101011000100" =>  data <= "10000101";  -- 7AC4 = 85
      when "111101011000101" =>  data <= "11000010";  -- 7AC5 = C2
      when "111101011000110" =>  data <= "01001100";  -- 7AC6 = 4C
      when "111101011000111" =>  data <= "00000000";  -- 7AC7 = 0
      when "111101011001000" =>  data <= "11100110";  -- 7AC8 = E6
      when "111101011001001" =>  data <= "01110000";  -- 7AC9 = 70
      when "111101011001010" =>  data <= "00110001";  -- 7ACA = 31
      when "111101011001011" =>  data <= "11010000";  -- 7ACB = D0
      when "111101011001100" =>  data <= "00011000";  -- 7ACC = 18
      when "111101011001101" =>  data <= "10100101";  -- 7ACD = A5
      when "111101011001110" =>  data <= "11001111";  -- 7ACE = CF
      when "111101011001111" =>  data <= "11010000";  -- 7ACF = D0
      when "111101011010000" =>  data <= "11110101";  -- 7AD0 = F5
      when "111101011010001" =>  data <= "10100101";  -- 7AD1 = A5
      when "111101011010010" =>  data <= "11010000";  -- 7AD2 = D0
      when "111101011010011" =>  data <= "11010000";  -- 7AD3 = D0
      when "111101011010100" =>  data <= "11110001";  -- 7AD4 = F1
      when "111101011010101" =>  data <= "10100101";  -- 7AD5 = A5
      when "111101011010110" =>  data <= "10111101";  -- 7AD6 = BD
      when "111101011010111" =>  data <= "01001010";  -- 7AD7 = 4A
      when "111101011011000" =>  data <= "10100101";  -- 7AD8 = A5
      when "111101011011001" =>  data <= "11011101";  -- 7AD9 = DD
      when "111101011011010" =>  data <= "00110000";  -- 7ADA = 30
      when "111101011011011" =>  data <= "00000011";  -- 7ADB = 3
      when "111101011011100" =>  data <= "10010000";  -- 7ADC = 90
      when "111101011011101" =>  data <= "00011000";  -- 7ADD = 18
      when "111101011011110" =>  data <= "00011000";  -- 7ADE = 18
      when "111101011011111" =>  data <= "10110000";  -- 7ADF = B0
      when "111101011100000" =>  data <= "00010101";  -- 7AE0 = 15
      when "111101011100001" =>  data <= "00101001";  -- 7AE1 = 29
      when "111101011100010" =>  data <= "00001111";  -- 7AE2 = F
      when "111101011100011" =>  data <= "10000101";  -- 7AE3 = 85
      when "111101011100100" =>  data <= "11000010";  -- 7AE4 = C2
      when "111101011100101" =>  data <= "11000110";  -- 7AE5 = C6
      when "111101011100110" =>  data <= "11000010";  -- 7AE6 = C2
      when "111101011100111" =>  data <= "11010000";  -- 7AE7 = D0
      when "111101011101000" =>  data <= "11011101";  -- 7AE8 = DD
      when "111101011101001" =>  data <= "10101001";  -- 7AE9 = A9
      when "111101011101010" =>  data <= "01000000";  -- 7AEA = 40
      when "111101011101011" =>  data <= "10000101";  -- 7AEB = 85
      when "111101011101100" =>  data <= "11000010";  -- 7AEC = C2
      when "111101011101101" =>  data <= "00100000";  -- 7AED = 20
      when "111101011101110" =>  data <= "10111011";  -- 7AEE = BB
      when "111101011101111" =>  data <= "11111011";  -- 7AEF = FB
      when "111101011110000" =>  data <= "10101001";  -- 7AF0 = A9
      when "111101011110001" =>  data <= "00000000";  -- 7AF1 = 0
      when "111101011110010" =>  data <= "10000101";  -- 7AF2 = 85
      when "111101011110011" =>  data <= "11000011";  -- 7AF3 = C3
      when "111101011110100" =>  data <= "11110000";  -- 7AF4 = F0
      when "111101011110101" =>  data <= "11010000";  -- 7AF5 = D0
      when "111101011110110" =>  data <= "10101001";  -- 7AF6 = A9
      when "111101011110111" =>  data <= "10000000";  -- 7AF7 = 80
      when "111101011111000" =>  data <= "10000101";  -- 7AF8 = 85
      when "111101011111001" =>  data <= "11000010";  -- 7AF9 = C2
      when "111101011111010" =>  data <= "11010000";  -- 7AFA = D0
      when "111101011111011" =>  data <= "11001010";  -- 7AFB = CA
      when "111101011111100" =>  data <= "10100101";  -- 7AFC = A5
      when "111101011111101" =>  data <= "11001111";  -- 7AFD = CF
      when "111101011111110" =>  data <= "11110000";  -- 7AFE = F0
      when "111101011111111" =>  data <= "00001010";  -- 7AFF = A
      when "111101100000000" =>  data <= "10101001";  -- 7B00 = A9
      when "111101100000001" =>  data <= "00000100";  -- 7B01 = 4
      when "111101100000010" =>  data <= "00100000";  -- 7B02 = 20
      when "111101100000011" =>  data <= "11000100";  -- 7B03 = C4
      when "111101100000100" =>  data <= "11111011";  -- 7B04 = FB
      when "111101100000101" =>  data <= "10101001";  -- 7B05 = A9
      when "111101100000110" =>  data <= "00000000";  -- 7B06 = 0
      when "111101100000111" =>  data <= "01001100";  -- 7B07 = 4C
      when "111101100001000" =>  data <= "10001011";  -- 7B08 = 8B
      when "111101100001001" =>  data <= "11111011";  -- 7B09 = FB
      when "111101100001010" =>  data <= "00100000";  -- 7B0A = 20
      when "111101100001011" =>  data <= "00001011";  -- 7B0B = B
      when "111101100001100" =>  data <= "11111101";  -- 7B0C = FD
      when "111101100001101" =>  data <= "11010000";  -- 7B0D = D0
      when "111101100001110" =>  data <= "00000011";  -- 7B0E = 3
      when "111101100001111" =>  data <= "01001100";  -- 7B0F = 4C
      when "111101100010000" =>  data <= "10001001";  -- 7B10 = 89
      when "111101100010001" =>  data <= "11111011";  -- 7B11 = FB
      when "111101100010010" =>  data <= "10100110";  -- 7B12 = A6
      when "111101100010011" =>  data <= "10111101";  -- 7B13 = BD
      when "111101100010100" =>  data <= "11001010";  -- 7B14 = CA
      when "111101100010101" =>  data <= "11110000";  -- 7B15 = F0
      when "111101100010110" =>  data <= "00101101";  -- 7B16 = 2D
      when "111101100010111" =>  data <= "10100101";  -- 7B17 = A5
      when "111101100011000" =>  data <= "10011101";  -- 7B18 = 9D
      when "111101100011001" =>  data <= "11110000";  -- 7B19 = F0
      when "111101100011010" =>  data <= "00001100";  -- 7B1A = C
      when "111101100011011" =>  data <= "10100000";  -- 7B1B = A0
      when "111101100011100" =>  data <= "00000000";  -- 7B1C = 0
      when "111101100011101" =>  data <= "10100101";  -- 7B1D = A5
      when "111101100011110" =>  data <= "11011101";  -- 7B1E = DD
      when "111101100011111" =>  data <= "11010001";  -- 7B1F = D1
      when "111101100100000" =>  data <= "11000111";  -- 7B20 = C7
      when "111101100100001" =>  data <= "11110000";  -- 7B21 = F0
      when "111101100100010" =>  data <= "00000100";  -- 7B22 = 4
      when "111101100100011" =>  data <= "10101001";  -- 7B23 = A9
      when "111101100100100" =>  data <= "00000001";  -- 7B24 = 1
      when "111101100100101" =>  data <= "10000101";  -- 7B25 = 85
      when "111101100100110" =>  data <= "11010000";  -- 7B26 = D0
      when "111101100100111" =>  data <= "10100101";  -- 7B27 = A5
      when "111101100101000" =>  data <= "11010000";  -- 7B28 = D0
      when "111101100101001" =>  data <= "11110000";  -- 7B29 = F0
      when "111101100101010" =>  data <= "01001100";  -- 7B2A = 4C
      when "111101100101011" =>  data <= "10100010";  -- 7B2B = A2
      when "111101100101100" =>  data <= "00111101";  -- 7B2C = 3D
      when "111101100101101" =>  data <= "11100100";  -- 7B2D = E4
      when "111101100101110" =>  data <= "11000000";  -- 7B2E = C0
      when "111101100101111" =>  data <= "10010000";  -- 7B2F = 90
      when "111101100110000" =>  data <= "00111111";  -- 7B30 = 3F
      when "111101100110001" =>  data <= "10100110";  -- 7B31 = A6
      when "111101100110010" =>  data <= "11000000";  -- 7B32 = C0
      when "111101100110011" =>  data <= "10100101";  -- 7B33 = A5
      when "111101100110100" =>  data <= "11001000";  -- 7B34 = C8
      when "111101100110101" =>  data <= "10011101";  -- 7B35 = 9D
      when "111101100110110" =>  data <= "00000001";  -- 7B36 = 1
      when "111101100110111" =>  data <= "00000001";  -- 7B37 = 1
      when "111101100111000" =>  data <= "10100101";  -- 7B38 = A5
      when "111101100111001" =>  data <= "11000111";  -- 7B39 = C7
      when "111101100111010" =>  data <= "10011101";  -- 7B3A = 9D
      when "111101100111011" =>  data <= "00000000";  -- 7B3B = 0
      when "111101100111100" =>  data <= "00000001";  -- 7B3C = 1
      when "111101100111101" =>  data <= "11101000";  -- 7B3D = E8
      when "111101100111110" =>  data <= "11101000";  -- 7B3E = E8
      when "111101100111111" =>  data <= "10000110";  -- 7B3F = 86
      when "111101101000000" =>  data <= "11000000";  -- 7B40 = C0
      when "111101101000001" =>  data <= "01001100";  -- 7B41 = 4C
      when "111101101000010" =>  data <= "01110111";  -- 7B42 = 77
      when "111101101000011" =>  data <= "11111011";  -- 7B43 = FB
      when "111101101000100" =>  data <= "10100110";  -- 7B44 = A6
      when "111101101000101" =>  data <= "11000001";  -- 7B45 = C1
      when "111101101000110" =>  data <= "11100100";  -- 7B46 = E4
      when "111101101000111" =>  data <= "11000000";  -- 7B47 = C0
      when "111101101001000" =>  data <= "11110000";  -- 7B48 = F0
      when "111101101001001" =>  data <= "00110111";  -- 7B49 = 37
      when "111101101001010" =>  data <= "10100101";  -- 7B4A = A5
      when "111101101001011" =>  data <= "11000111";  -- 7B4B = C7
      when "111101101001100" =>  data <= "11011101";  -- 7B4C = DD
      when "111101101001101" =>  data <= "00000000";  -- 7B4D = 0
      when "111101101001110" =>  data <= "00000001";  -- 7B4E = 1
      when "111101101001111" =>  data <= "11010000";  -- 7B4F = D0
      when "111101101010000" =>  data <= "00110000";  -- 7B50 = 30
      when "111101101010001" =>  data <= "10100101";  -- 7B51 = A5
      when "111101101010010" =>  data <= "11001000";  -- 7B52 = C8
      when "111101101010011" =>  data <= "11011101";  -- 7B53 = DD
      when "111101101010100" =>  data <= "00000001";  -- 7B54 = 1
      when "111101101010101" =>  data <= "00000001";  -- 7B55 = 1
      when "111101101010110" =>  data <= "11010000";  -- 7B56 = D0
      when "111101101010111" =>  data <= "00101001";  -- 7B57 = 29
      when "111101101011000" =>  data <= "11100110";  -- 7B58 = E6
      when "111101101011001" =>  data <= "11000001";  -- 7B59 = C1
      when "111101101011010" =>  data <= "11100110";  -- 7B5A = E6
      when "111101101011011" =>  data <= "11000001";  -- 7B5B = C1
      when "111101101011100" =>  data <= "10100101";  -- 7B5C = A5
      when "111101101011101" =>  data <= "10011101";  -- 7B5D = 9D
      when "111101101011110" =>  data <= "11110000";  -- 7B5E = F0
      when "111101101011111" =>  data <= "00001100";  -- 7B5F = C
      when "111101101100000" =>  data <= "10100101";  -- 7B60 = A5
      when "111101101100001" =>  data <= "11011101";  -- 7B61 = DD
      when "111101101100010" =>  data <= "10100000";  -- 7B62 = A0
      when "111101101100011" =>  data <= "00000000";  -- 7B63 = 0
      when "111101101100100" =>  data <= "11010001";  -- 7B64 = D1
      when "111101101100101" =>  data <= "11000111";  -- 7B65 = C7
      when "111101101100110" =>  data <= "11110000";  -- 7B66 = F0
      when "111101101100111" =>  data <= "00011001";  -- 7B67 = 19
      when "111101101101000" =>  data <= "10101001";  -- 7B68 = A9
      when "111101101101001" =>  data <= "00000001";  -- 7B69 = 1
      when "111101101101010" =>  data <= "10000101";  -- 7B6A = 85
      when "111101101101011" =>  data <= "11010000";  -- 7B6B = D0
      when "111101101101100" =>  data <= "10100101";  -- 7B6C = A5
      when "111101101101101" =>  data <= "11010000";  -- 7B6D = D0
      when "111101101101110" =>  data <= "11110000";  -- 7B6E = F0
      when "111101101101111" =>  data <= "00000111";  -- 7B6F = 7
      when "111101101110000" =>  data <= "10101001";  -- 7B70 = A9
      when "111101101110001" =>  data <= "00010000";  -- 7B71 = 10
      when "111101101110010" =>  data <= "00100000";  -- 7B72 = 20
      when "111101101110011" =>  data <= "11000100";  -- 7B73 = C4
      when "111101101110100" =>  data <= "11111011";  -- 7B74 = FB
      when "111101101110101" =>  data <= "11010000";  -- 7B75 = D0
      when "111101101110110" =>  data <= "00001010";  -- 7B76 = A
      when "111101101110111" =>  data <= "10100101";  -- 7B77 = A5
      when "111101101111000" =>  data <= "10011101";  -- 7B78 = 9D
      when "111101101111001" =>  data <= "11010000";  -- 7B79 = D0
      when "111101101111010" =>  data <= "00000110";  -- 7B7A = 6
      when "111101101111011" =>  data <= "10100101";  -- 7B7B = A5
      when "111101101111100" =>  data <= "11011101";  -- 7B7C = DD
      when "111101101111101" =>  data <= "10100000";  -- 7B7D = A0
      when "111101101111110" =>  data <= "00000000";  -- 7B7E = 0
      when "111101101111111" =>  data <= "10010001";  -- 7B7F = 91
      when "111101110000000" =>  data <= "11000111";  -- 7B80 = C7
      when "111101110000001" =>  data <= "11100110";  -- 7B81 = E6
      when "111101110000010" =>  data <= "11000111";  -- 7B82 = C7
      when "111101110000011" =>  data <= "11010000";  -- 7B83 = D0
      when "111101110000100" =>  data <= "00110011";  -- 7B84 = 33
      when "111101110000101" =>  data <= "11100110";  -- 7B85 = E6
      when "111101110000110" =>  data <= "11001000";  -- 7B86 = C8
      when "111101110000111" =>  data <= "11010000";  -- 7B87 = D0
      when "111101110001000" =>  data <= "00101111";  -- 7B88 = 2F
      when "111101110001001" =>  data <= "10101001";  -- 7B89 = A9
      when "111101110001010" =>  data <= "10000000";  -- 7B8A = 80
      when "111101110001011" =>  data <= "10000101";  -- 7B8B = 85
      when "111101110001100" =>  data <= "11000010";  -- 7B8C = C2
      when "111101110001101" =>  data <= "10100110";  -- 7B8D = A6
      when "111101110001110" =>  data <= "11011110";  -- 7B8E = DE
      when "111101110001111" =>  data <= "11001010";  -- 7B8F = CA
      when "111101110010000" =>  data <= "00110000";  -- 7B90 = 30
      when "111101110010001" =>  data <= "00000010";  -- 7B91 = 2
      when "111101110010010" =>  data <= "10000110";  -- 7B92 = 86
      when "111101110010011" =>  data <= "11011110";  -- 7B93 = DE
      when "111101110010100" =>  data <= "11000110";  -- 7B94 = C6
      when "111101110010101" =>  data <= "10111101";  -- 7B95 = BD
      when "111101110010110" =>  data <= "11110000";  -- 7B96 = F0
      when "111101110010111" =>  data <= "00001000";  -- 7B97 = 8
      when "111101110011000" =>  data <= "10100101";  -- 7B98 = A5
      when "111101110011001" =>  data <= "11000000";  -- 7B99 = C0
      when "111101110011010" =>  data <= "11010000";  -- 7B9A = D0
      when "111101110011011" =>  data <= "00011100";  -- 7B9B = 1C
      when "111101110011100" =>  data <= "10000101";  -- 7B9C = 85
      when "111101110011101" =>  data <= "11011110";  -- 7B9D = DE
      when "111101110011110" =>  data <= "11110000";  -- 7B9E = F0
      when "111101110011111" =>  data <= "00011000";  -- 7B9F = 18
      when "111101110100000" =>  data <= "00100000";  -- 7BA0 = 20
      when "111101110100001" =>  data <= "11000000";  -- 7BA1 = C0
      when "111101110100010" =>  data <= "11111100";  -- 7BA2 = FC
      when "111101110100011" =>  data <= "00100000";  -- 7BA3 = 20
      when "111101110100100" =>  data <= "10111011";  -- 7BA4 = BB
      when "111101110100101" =>  data <= "11111011";  -- 7BA5 = FB
      when "111101110100110" =>  data <= "10100000";  -- 7BA6 = A0
      when "111101110100111" =>  data <= "00000000";  -- 7BA7 = 0
      when "111101110101000" =>  data <= "10000100";  -- 7BA8 = 84
      when "111101110101001" =>  data <= "11000011";  -- 7BA9 = C3
      when "111101110101010" =>  data <= "00100000";  -- 7BAA = 20
      when "111101110101011" =>  data <= "11111001";  -- 7BAB = F9
      when "111101110101100" =>  data <= "11111100";  -- 7BAC = FC
      when "111101110101101" =>  data <= "10100101";  -- 7BAD = A5
      when "111101110101110" =>  data <= "11000011";  -- 7BAE = C3
      when "111101110101111" =>  data <= "01000101";  -- 7BAF = 45
      when "111101110110000" =>  data <= "11011101";  -- 7BB0 = DD
      when "111101110110001" =>  data <= "11110000";  -- 7BB1 = F0
      when "111101110110010" =>  data <= "00000101";  -- 7BB2 = 5
      when "111101110110011" =>  data <= "10101001";  -- 7BB3 = A9
      when "111101110110100" =>  data <= "00100000";  -- 7BB4 = 20
      when "111101110110101" =>  data <= "00100000";  -- 7BB5 = 20
      when "111101110110110" =>  data <= "11000100";  -- 7BB6 = C4
      when "111101110110111" =>  data <= "11111011";  -- 7BB7 = FB
      when "111101110111000" =>  data <= "01001100";  -- 7BB8 = 4C
      when "111101110111001" =>  data <= "00000000";  -- 7BB9 = 0
      when "111101110111010" =>  data <= "11100110";  -- 7BBA = E6
      when "111101110111011" =>  data <= "10100101";  -- 7BBB = A5
      when "111101110111100" =>  data <= "11111100";  -- 7BBC = FC
      when "111101110111101" =>  data <= "10000101";  -- 7BBD = 85
      when "111101110111110" =>  data <= "11001000";  -- 7BBE = C8
      when "111101110111111" =>  data <= "10100101";  -- 7BBF = A5
      when "111101111000000" =>  data <= "11111011";  -- 7BC0 = FB
      when "111101111000001" =>  data <= "10000101";  -- 7BC1 = 85
      when "111101111000010" =>  data <= "11000111";  -- 7BC2 = C7
      when "111101111000011" =>  data <= "01100000";  -- 7BC3 = 60
      when "111101111000100" =>  data <= "00000101";  -- 7BC4 = 5
      when "111101111000101" =>  data <= "10010110";  -- 7BC5 = 96
      when "111101111000110" =>  data <= "10000101";  -- 7BC6 = 85
      when "111101111000111" =>  data <= "10010110";  -- 7BC7 = 96
      when "111101111001000" =>  data <= "01100000";  -- 7BC8 = 60
      when "111101111001001" =>  data <= "10101001";  -- 7BC9 = A9
      when "111101111001010" =>  data <= "00001000";  -- 7BCA = 8
      when "111101111001011" =>  data <= "10000101";  -- 7BCB = 85
      when "111101111001100" =>  data <= "10110111";  -- 7BCC = B7
      when "111101111001101" =>  data <= "10101001";  -- 7BCD = A9
      when "111101111001110" =>  data <= "00000000";  -- 7BCE = 0
      when "111101111001111" =>  data <= "10000101";  -- 7BCF = 85
      when "111101111010000" =>  data <= "10111001";  -- 7BD0 = B9
      when "111101111010001" =>  data <= "10000101";  -- 7BD1 = 85
      when "111101111010010" =>  data <= "10111110";  -- 7BD2 = BE
      when "111101111010011" =>  data <= "10000101";  -- 7BD3 = 85
      when "111101111010100" =>  data <= "10110001";  -- 7BD4 = B1
      when "111101111010101" =>  data <= "10000101";  -- 7BD5 = 85
      when "111101111010110" =>  data <= "10111111";  -- 7BD6 = BF
      when "111101111010111" =>  data <= "01100000";  -- 7BD7 = 60
      when "111101111011000" =>  data <= "10100101";  -- 7BD8 = A5
      when "111101111011001" =>  data <= "11011101";  -- 7BD9 = DD
      when "111101111011010" =>  data <= "01001010";  -- 7BDA = 4A
      when "111101111011011" =>  data <= "10101001";  -- 7BDB = A9
      when "111101111011100" =>  data <= "01100000";  -- 7BDC = 60
      when "111101111011101" =>  data <= "10010000";  -- 7BDD = 90
      when "111101111011110" =>  data <= "00000010";  -- 7BDE = 2
      when "111101111011111" =>  data <= "10101001";  -- 7BDF = A9
      when "111101111100000" =>  data <= "10110000";  -- 7BE0 = B0
      when "111101111100001" =>  data <= "10100010";  -- 7BE1 = A2
      when "111101111100010" =>  data <= "00000000";  -- 7BE2 = 0
      when "111101111100011" =>  data <= "10001101";  -- 7BE3 = 8D
      when "111101111100100" =>  data <= "01001000";  -- 7BE4 = 48
      when "111101111100101" =>  data <= "11101000";  -- 7BE5 = E8
      when "111101111100110" =>  data <= "10001110";  -- 7BE6 = 8E
      when "111101111100111" =>  data <= "01001001";  -- 7BE7 = 49
      when "111101111101000" =>  data <= "11101000";  -- 7BE8 = E8
      when "111101111101001" =>  data <= "10101101";  -- 7BE9 = AD
      when "111101111101010" =>  data <= "01000000";  -- 7BEA = 40
      when "111101111101011" =>  data <= "11101000";  -- 7BEB = E8
      when "111101111101100" =>  data <= "01001001";  -- 7BEC = 49
      when "111101111101101" =>  data <= "00001000";  -- 7BED = 8
      when "111101111101110" =>  data <= "10001101";  -- 7BEE = 8D
      when "111101111101111" =>  data <= "01000000";  -- 7BEF = 40
      when "111101111110000" =>  data <= "11101000";  -- 7BF0 = E8
      when "111101111110001" =>  data <= "00101001";  -- 7BF1 = 29
      when "111101111110010" =>  data <= "00001000";  -- 7BF2 = 8
      when "111101111110011" =>  data <= "01100000";  -- 7BF3 = 60
      when "111101111110100" =>  data <= "00111000";  -- 7BF4 = 38
      when "111101111110101" =>  data <= "01100110";  -- 7BF5 = 66
      when "111101111110110" =>  data <= "11001000";  -- 7BF6 = C8
      when "111101111110111" =>  data <= "00110000";  -- 7BF7 = 30
      when "111101111111000" =>  data <= "00111100";  -- 7BF8 = 3C
      when "111101111111001" =>  data <= "10100101";  -- 7BF9 = A5
      when "111101111111010" =>  data <= "10111110";  -- 7BFA = BE
      when "111101111111011" =>  data <= "11010000";  -- 7BFB = D0
      when "111101111111100" =>  data <= "00010010";  -- 7BFC = 12
      when "111101111111101" =>  data <= "10101001";  -- 7BFD = A9
      when "111101111111110" =>  data <= "00010000";  -- 7BFE = 10
      when "111101111111111" =>  data <= "10100010";  -- 7BFF = A2
      when "111110000000000" =>  data <= "00000001";  -- 7C00 = 1
      when "111110000000001" =>  data <= "00100000";  -- 7C01 = 20
      when "111110000000010" =>  data <= "11100011";  -- 7C02 = E3
      when "111110000000011" =>  data <= "11111011";  -- 7C03 = FB
      when "111110000000100" =>  data <= "11010000";  -- 7C04 = D0
      when "111110000000101" =>  data <= "00101111";  -- 7C05 = 2F
      when "111110000000110" =>  data <= "11100110";  -- 7C06 = E6
      when "111110000000111" =>  data <= "10111110";  -- 7C07 = BE
      when "111110000001000" =>  data <= "10100101";  -- 7C08 = A5
      when "111110000001001" =>  data <= "11001000";  -- 7C09 = C8
      when "111110000001010" =>  data <= "00010000";  -- 7C0A = 10
      when "111110000001011" =>  data <= "00101001";  -- 7C0B = 29
      when "111110000001100" =>  data <= "01001100";  -- 7C0C = 4C
      when "111110000001101" =>  data <= "10000110";  -- 7C0D = 86
      when "111110000001110" =>  data <= "11111100";  -- 7C0E = FC
      when "111110000001111" =>  data <= "10100101";  -- 7C0F = A5
      when "111110000010000" =>  data <= "10111111";  -- 7C10 = BF
      when "111110000010001" =>  data <= "11010000";  -- 7C11 = D0
      when "111110000010010" =>  data <= "00001001";  -- 7C12 = 9
      when "111110000010011" =>  data <= "00100000";  -- 7C13 = 20
      when "111110000010100" =>  data <= "11011111";  -- 7C14 = DF
      when "111110000010101" =>  data <= "11111011";  -- 7C15 = FB
      when "111110000010110" =>  data <= "11010000";  -- 7C16 = D0
      when "111110000010111" =>  data <= "00011101";  -- 7C17 = 1D
      when "111110000011000" =>  data <= "11100110";  -- 7C18 = E6
      when "111110000011001" =>  data <= "10111111";  -- 7C19 = BF
      when "111110000011010" =>  data <= "11010000";  -- 7C1A = D0
      when "111110000011011" =>  data <= "00011001";  -- 7C1B = 19
      when "111110000011100" =>  data <= "00100000";  -- 7C1C = 20
      when "111110000011101" =>  data <= "11011000";  -- 7C1D = D8
      when "111110000011110" =>  data <= "11111011";  -- 7C1E = FB
      when "111110000011111" =>  data <= "11010000";  -- 7C1F = D0
      when "111110000100000" =>  data <= "00010100";  -- 7C20 = 14
      when "111110000100001" =>  data <= "10100101";  -- 7C21 = A5
      when "111110000100010" =>  data <= "10111001";  -- 7C22 = B9
      when "111110000100011" =>  data <= "01001001";  -- 7C23 = 49
      when "111110000100100" =>  data <= "00000001";  -- 7C24 = 1
      when "111110000100101" =>  data <= "10000101";  -- 7C25 = 85
      when "111110000100110" =>  data <= "10111001";  -- 7C26 = B9
      when "111110000100111" =>  data <= "11110000";  -- 7C27 = F0
      when "111110000101000" =>  data <= "00001111";  -- 7C28 = F
      when "111110000101001" =>  data <= "10100101";  -- 7C29 = A5
      when "111110000101010" =>  data <= "11011101";  -- 7C2A = DD
      when "111110000101011" =>  data <= "01001001";  -- 7C2B = 49
      when "111110000101100" =>  data <= "00000001";  -- 7C2C = 1
      when "111110000101101" =>  data <= "10000101";  -- 7C2D = 85
      when "111110000101110" =>  data <= "11011101";  -- 7C2E = DD
      when "111110000101111" =>  data <= "00101001";  -- 7C2F = 29
      when "111110000110000" =>  data <= "00000001";  -- 7C30 = 1
      when "111110000110001" =>  data <= "01000101";  -- 7C31 = 45
      when "111110000110010" =>  data <= "10110001";  -- 7C32 = B1
      when "111110000110011" =>  data <= "10000101";  -- 7C33 = 85
      when "111110000110100" =>  data <= "10110001";  -- 7C34 = B1
      when "111110000110101" =>  data <= "01001100";  -- 7C35 = 4C
      when "111110000110110" =>  data <= "00000000";  -- 7C36 = 0
      when "111110000110111" =>  data <= "11100110";  -- 7C37 = E6
      when "111110000111000" =>  data <= "01000110";  -- 7C38 = 46
      when "111110000111001" =>  data <= "11011101";  -- 7C39 = DD
      when "111110000111010" =>  data <= "11000110";  -- 7C3A = C6
      when "111110000111011" =>  data <= "10110111";  -- 7C3B = B7
      when "111110000111100" =>  data <= "10100101";  -- 7C3C = A5
      when "111110000111101" =>  data <= "10110111";  -- 7C3D = B7
      when "111110000111110" =>  data <= "11110000";  -- 7C3E = F0
      when "111110000111111" =>  data <= "00111101";  -- 7C3F = 3D
      when "111110001000000" =>  data <= "00010000";  -- 7C40 = 10
      when "111110001000001" =>  data <= "11110011";  -- 7C41 = F3
      when "111110001000010" =>  data <= "00100000";  -- 7C42 = 20
      when "111110001000011" =>  data <= "11001001";  -- 7C43 = C9
      when "111110001000100" =>  data <= "11111011";  -- 7C44 = FB
      when "111110001000101" =>  data <= "01011000";  -- 7C45 = 58
      when "111110001000110" =>  data <= "10100101";  -- 7C46 = A5
      when "111110001000111" =>  data <= "10111010";  -- 7C47 = BA
      when "111110001001000" =>  data <= "11110000";  -- 7C48 = F0
      when "111110001001001" =>  data <= "00010010";  -- 7C49 = 12
      when "111110001001010" =>  data <= "10100010";  -- 7C4A = A2
      when "111110001001011" =>  data <= "00000000";  -- 7C4B = 0
      when "111110001001100" =>  data <= "10000110";  -- 7C4C = 86
      when "111110001001101" =>  data <= "11011001";  -- 7C4D = D9
      when "111110001001110" =>  data <= "11000110";  -- 7C4E = C6
      when "111110001001111" =>  data <= "10111010";  -- 7C4F = BA
      when "111110001010000" =>  data <= "10100110";  -- 7C50 = A6
      when "111110001010001" =>  data <= "11011110";  -- 7C51 = DE
      when "111110001010010" =>  data <= "11100000";  -- 7C52 = E0
      when "111110001010011" =>  data <= "00000010";  -- 7C53 = 2
      when "111110001010100" =>  data <= "11010000";  -- 7C54 = D0
      when "111110001010101" =>  data <= "00000010";  -- 7C55 = 2
      when "111110001010110" =>  data <= "00001001";  -- 7C56 = 9
      when "111110001010111" =>  data <= "10000000";  -- 7C57 = 80
      when "111110001011000" =>  data <= "10000101";  -- 7C58 = 85
      when "111110001011001" =>  data <= "11011101";  -- 7C59 = DD
      when "111110001011010" =>  data <= "11010000";  -- 7C5A = D0
      when "111110001011011" =>  data <= "11011001";  -- 7C5B = D9
      when "111110001011100" =>  data <= "00100000";  -- 7C5C = 20
      when "111110001011101" =>  data <= "00001011";  -- 7C5D = B
      when "111110001011110" =>  data <= "11111101";  -- 7C5E = FD
      when "111110001011111" =>  data <= "10010000";  -- 7C5F = 90
      when "111110001100000" =>  data <= "00001010";  -- 7C60 = A
      when "111110001100001" =>  data <= "11010000";  -- 7C61 = D0
      when "111110001100010" =>  data <= "10010001";  -- 7C62 = 91
      when "111110001100011" =>  data <= "11100110";  -- 7C63 = E6
      when "111110001100100" =>  data <= "11001000";  -- 7C64 = C8
      when "111110001100101" =>  data <= "10100101";  -- 7C65 = A5
      when "111110001100110" =>  data <= "11011001";  -- 7C66 = D9
      when "111110001100111" =>  data <= "10000101";  -- 7C67 = 85
      when "111110001101000" =>  data <= "11011101";  -- 7C68 = DD
      when "111110001101001" =>  data <= "10110000";  -- 7C69 = B0
      when "111110001101010" =>  data <= "11001010";  -- 7C6A = CA
      when "111110001101011" =>  data <= "10100000";  -- 7C6B = A0
      when "111110001101100" =>  data <= "00000000";  -- 7C6C = 0
      when "111110001101101" =>  data <= "10110001";  -- 7C6D = B1
      when "111110001101110" =>  data <= "11000111";  -- 7C6E = C7
      when "111110001101111" =>  data <= "10000101";  -- 7C6F = 85
      when "111110001110000" =>  data <= "11011101";  -- 7C70 = DD
      when "111110001110001" =>  data <= "01000101";  -- 7C71 = 45
      when "111110001110010" =>  data <= "11011001";  -- 7C72 = D9
      when "111110001110011" =>  data <= "10000101";  -- 7C73 = 85
      when "111110001110100" =>  data <= "11011001";  -- 7C74 = D9
      when "111110001110101" =>  data <= "11100110";  -- 7C75 = E6
      when "111110001110110" =>  data <= "11000111";  -- 7C76 = C7
      when "111110001110111" =>  data <= "11010000";  -- 7C77 = D0
      when "111110001111000" =>  data <= "10111100";  -- 7C78 = BC
      when "111110001111001" =>  data <= "11100110";  -- 7C79 = E6
      when "111110001111010" =>  data <= "11001000";  -- 7C7A = C8
      when "111110001111011" =>  data <= "11010000";  -- 7C7B = D0
      when "111110001111100" =>  data <= "10111000";  -- 7C7C = B8
      when "111110001111101" =>  data <= "10100101";  -- 7C7D = A5
      when "111110001111110" =>  data <= "10110001";  -- 7C7E = B1
      when "111110001111111" =>  data <= "01001001";  -- 7C7F = 49
      when "111110010000000" =>  data <= "00000001";  -- 7C80 = 1
      when "111110010000001" =>  data <= "10000101";  -- 7C81 = 85
      when "111110010000010" =>  data <= "11011101";  -- 7C82 = DD
      when "111110010000011" =>  data <= "01001100";  -- 7C83 = 4C
      when "111110010000100" =>  data <= "00000000";  -- 7C84 = 0
      when "111110010000101" =>  data <= "11100110";  -- 7C85 = E6
      when "111110010000110" =>  data <= "11000110";  -- 7C86 = C6
      when "111110010000111" =>  data <= "11011110";  -- 7C87 = DE
      when "111110010001000" =>  data <= "11010000";  -- 7C88 = D0
      when "111110010001001" =>  data <= "00000011";  -- 7C89 = 3
      when "111110010001010" =>  data <= "00100000";  -- 7C8A = 20
      when "111110010001011" =>  data <= "11101011";  -- 7C8B = EB
      when "111110010001100" =>  data <= "11111100";  -- 7C8C = FC
      when "111110010001101" =>  data <= "10101001";  -- 7C8D = A9
      when "111110010001110" =>  data <= "01010000";  -- 7C8E = 50
      when "111110010001111" =>  data <= "10000101";  -- 7C8F = 85
      when "111110010010000" =>  data <= "10111101";  -- 7C90 = BD
      when "111110010010001" =>  data <= "10100010";  -- 7C91 = A2
      when "111110010010010" =>  data <= "00001000";  -- 7C92 = 8
      when "111110010010011" =>  data <= "01111000";  -- 7C93 = 78
      when "111110010010100" =>  data <= "00100000";  -- 7C94 = 20
      when "111110010010101" =>  data <= "11100000";  -- 7C95 = E0
      when "111110010010110" =>  data <= "11111100";  -- 7C96 = FC
      when "111110010010111" =>  data <= "11010000";  -- 7C97 = D0
      when "111110010011000" =>  data <= "11101010";  -- 7C98 = EA
      when "111110010011001" =>  data <= "10101001";  -- 7C99 = A9
      when "111110010011010" =>  data <= "01111000";  -- 7C9A = 78
      when "111110010011011" =>  data <= "00100000";  -- 7C9B = 20
      when "111110010011100" =>  data <= "11100001";  -- 7C9C = E1
      when "111110010011101" =>  data <= "11111011";  -- 7C9D = FB
      when "111110010011110" =>  data <= "11010000";  -- 7C9E = D0
      when "111110010011111" =>  data <= "11100011";  -- 7C9F = E3
      when "111110010100000" =>  data <= "11000110";  -- 7CA0 = C6
      when "111110010100001" =>  data <= "10111101";  -- 7CA1 = BD
      when "111110010100010" =>  data <= "11010000";  -- 7CA2 = D0
      when "111110010100011" =>  data <= "11011111";  -- 7CA3 = DF
      when "111110010100100" =>  data <= "00100000";  -- 7CA4 = 20
      when "111110010100101" =>  data <= "11001001";  -- 7CA5 = C9
      when "111110010100110" =>  data <= "11111011";  -- 7CA6 = FB
      when "111110010100111" =>  data <= "11000110";  -- 7CA7 = C6
      when "111110010101000" =>  data <= "11000011";  -- 7CA8 = C3
      when "111110010101001" =>  data <= "00010000";  -- 7CA9 = 10
      when "111110010101010" =>  data <= "11011000";  -- 7CAA = D8
      when "111110010101011" =>  data <= "10100010";  -- 7CAB = A2
      when "111110010101100" =>  data <= "00001010";  -- 7CAC = A
      when "111110010101101" =>  data <= "00100000";  -- 7CAD = 20
      when "111110010101110" =>  data <= "11100000";  -- 7CAE = E0
      when "111110010101111" =>  data <= "11111100";  -- 7CAF = FC
      when "111110010110000" =>  data <= "01011000";  -- 7CB0 = 58
      when "111110010110001" =>  data <= "11100110";  -- 7CB1 = E6
      when "111110010110010" =>  data <= "11000011";  -- 7CB2 = C3
      when "111110010110011" =>  data <= "10100101";  -- 7CB3 = A5
      when "111110010110100" =>  data <= "11011110";  -- 7CB4 = DE
      when "111110010110101" =>  data <= "11110000";  -- 7CB5 = F0
      when "111110010110110" =>  data <= "00100100";  -- 7CB6 = 24
      when "111110010110111" =>  data <= "00100000";  -- 7CB7 = 20
      when "111110010111000" =>  data <= "10111011";  -- 7CB8 = BB
      when "111110010111001" =>  data <= "11111011";  -- 7CB9 = FB
      when "111110010111010" =>  data <= "10100010";  -- 7CBA = A2
      when "111110010111011" =>  data <= "00001001";  -- 7CBB = 9
      when "111110010111100" =>  data <= "10000110";  -- 7CBC = 86
      when "111110010111101" =>  data <= "10111010";  -- 7CBD = BA
      when "111110010111110" =>  data <= "11010000";  -- 7CBE = D0
      when "111110010111111" =>  data <= "10000010";  -- 7CBF = 82
      when "111110011000000" =>  data <= "00001000";  -- 7CC0 = 8
      when "111110011000001" =>  data <= "01111000";  -- 7CC1 = 78
      when "111110011000010" =>  data <= "00100000";  -- 7CC2 = 20
      when "111110011000011" =>  data <= "11101011";  -- 7CC3 = EB
      when "111110011000100" =>  data <= "11111100";  -- 7CC4 = FC
      when "111110011000101" =>  data <= "10101001";  -- 7CC5 = A9
      when "111110011000110" =>  data <= "01111111";  -- 7CC6 = 7F
      when "111110011000111" =>  data <= "10001101";  -- 7CC7 = 8D
      when "111110011001000" =>  data <= "01001110";  -- 7CC8 = 4E
      when "111110011001001" =>  data <= "11101000";  -- 7CC9 = E8
      when "111110011001010" =>  data <= "10101001";  -- 7CCA = A9
      when "111110011001011" =>  data <= "00111100";  -- 7CCB = 3C
      when "111110011001100" =>  data <= "10001101";  -- 7CCC = 8D
      when "111110011001101" =>  data <= "00010001";  -- 7CCD = 11
      when "111110011001110" =>  data <= "11101000";  -- 7CCE = E8
      when "111110011001111" =>  data <= "10101001";  -- 7CCF = A9
      when "111110011010000" =>  data <= "00111101";  -- 7CD0 = 3D
      when "111110011010001" =>  data <= "10001101";  -- 7CD1 = 8D
      when "111110011010010" =>  data <= "00010011";  -- 7CD2 = 13
      when "111110011010011" =>  data <= "11101000";  -- 7CD3 = E8
      when "111110011010100" =>  data <= "10100010";  -- 7CD4 = A2
      when "111110011010101" =>  data <= "00001100";  -- 7CD5 = C
      when "111110011010110" =>  data <= "00100000";  -- 7CD6 = 20
      when "111110011010111" =>  data <= "11100000";  -- 7CD7 = E0
      when "111110011011000" =>  data <= "11111100";  -- 7CD8 = FC
      when "111110011011001" =>  data <= "00101000";  -- 7CD9 = 28
      when "111110011011010" =>  data <= "01100000";  -- 7CDA = 60
      when "111110011011011" =>  data <= "00100000";  -- 7CDB = 20
      when "111110011011100" =>  data <= "11000000";  -- 7CDC = C0
      when "111110011011101" =>  data <= "11111100";  -- 7CDD = FC
      when "111110011011110" =>  data <= "11110000";  -- 7CDE = F0
      when "111110011011111" =>  data <= "10100011";  -- 7CDF = A3
      when "111110011100000" =>  data <= "10111101";  -- 7CE0 = BD
      when "111110011100001" =>  data <= "01001100";  -- 7CE1 = 4C
      when "111110011100010" =>  data <= "11111101";  -- 7CE2 = FD
      when "111110011100011" =>  data <= "10000101";  -- 7CE3 = 85
      when "111110011100100" =>  data <= "10010000";  -- 7CE4 = 90
      when "111110011100101" =>  data <= "10111101";  -- 7CE5 = BD
      when "111110011100110" =>  data <= "01001101";  -- 7CE6 = 4D
      when "111110011100111" =>  data <= "11111101";  -- 7CE7 = FD
      when "111110011101000" =>  data <= "10000101";  -- 7CE8 = 85
      when "111110011101001" =>  data <= "10010001";  -- 7CE9 = 91
      when "111110011101010" =>  data <= "01100000";  -- 7CEA = 60
      when "111110011101011" =>  data <= "10101001";  -- 7CEB = A9
      when "111110011101100" =>  data <= "00111100";  -- 7CEC = 3C
      when "111110011101101" =>  data <= "10001101";  -- 7CED = 8D
      when "111110011101110" =>  data <= "00010011";  -- 7CEE = 13
      when "111110011101111" =>  data <= "11101000";  -- 7CEF = E8
      when "111110011110000" =>  data <= "10101101";  -- 7CF0 = AD
      when "111110011110001" =>  data <= "01000000";  -- 7CF1 = 40
      when "111110011110010" =>  data <= "11101000";  -- 7CF2 = E8
      when "111110011110011" =>  data <= "00001001";  -- 7CF3 = 9
      when "111110011110100" =>  data <= "00010000";  -- 7CF4 = 10
      when "111110011110101" =>  data <= "10001101";  -- 7CF5 = 8D
      when "111110011110110" =>  data <= "01000000";  -- 7CF6 = 40
      when "111110011110111" =>  data <= "11101000";  -- 7CF7 = E8
      when "111110011111000" =>  data <= "01100000";  -- 7CF8 = 60
      when "111110011111001" =>  data <= "10110001";  -- 7CF9 = B1
      when "111110011111010" =>  data <= "11000111";  -- 7CFA = C7
      when "111110011111011" =>  data <= "01000101";  -- 7CFB = 45
      when "111110011111100" =>  data <= "11000011";  -- 7CFC = C3
      when "111110011111101" =>  data <= "10000101";  -- 7CFD = 85
      when "111110011111110" =>  data <= "11000011";  -- 7CFE = C3
      when "111110011111111" =>  data <= "11100110";  -- 7CFF = E6
      when "111110100000000" =>  data <= "11000111";  -- 7D00 = C7
      when "111110100000001" =>  data <= "11010000";  -- 7D01 = D0
      when "111110100000010" =>  data <= "00000010";  -- 7D02 = 2
      when "111110100000011" =>  data <= "11100110";  -- 7D03 = E6
      when "111110100000100" =>  data <= "11001000";  -- 7D04 = C8
      when "111110100000101" =>  data <= "00100000";  -- 7D05 = 20
      when "111110100000110" =>  data <= "00001011";  -- 7D06 = B
      when "111110100000111" =>  data <= "11111101";  -- 7D07 = FD
      when "111110100001000" =>  data <= "11010000";  -- 7D08 = D0
      when "111110100001001" =>  data <= "11101111";  -- 7D09 = EF
      when "111110100001010" =>  data <= "01100000";  -- 7D0A = 60
      when "111110100001011" =>  data <= "10100101";  -- 7D0B = A5
      when "111110100001100" =>  data <= "11001000";  -- 7D0C = C8
      when "111110100001101" =>  data <= "11000101";  -- 7D0D = C5
      when "111110100001110" =>  data <= "11001010";  -- 7D0E = CA
      when "111110100001111" =>  data <= "11010000";  -- 7D0F = D0
      when "111110100010000" =>  data <= "00000100";  -- 7D10 = 4
      when "111110100010001" =>  data <= "10100101";  -- 7D11 = A5
      when "111110100010010" =>  data <= "11000111";  -- 7D12 = C7
      when "111110100010011" =>  data <= "11000101";  -- 7D13 = C5
      when "111110100010100" =>  data <= "11001001";  -- 7D14 = C9
      when "111110100010101" =>  data <= "01100000";  -- 7D15 = 60
      when "111110100010110" =>  data <= "10100010";  -- 7D16 = A2
      when "111110100010111" =>  data <= "11111111";  -- 7D17 = FF
      when "111110100011000" =>  data <= "01111000";  -- 7D18 = 78
      when "111110100011001" =>  data <= "10011010";  -- 7D19 = 9A
      when "111110100011010" =>  data <= "11011000";  -- 7D1A = D8
      when "111110100011011" =>  data <= "00100000";  -- 7D1B = 20
      when "111110100011100" =>  data <= "00000000";  -- 7D1C = 0
      when "111110100011101" =>  data <= "11100000";  -- 7D1D = E0
      when "111110100011110" =>  data <= "10101001";  -- 7D1E = A9
      when "111110100011111" =>  data <= "11111111";  -- 7D1F = FF
      when "111110100100000" =>  data <= "10000101";  -- 7D20 = 85
      when "111110100100001" =>  data <= "10010100";  -- 7D21 = 94
      when "111110100100010" =>  data <= "10101001";  -- 7D22 = A9
      when "111110100100011" =>  data <= "10110011";  -- 7D23 = B3
      when "111110100100100" =>  data <= "10000101";  -- 7D24 = 85
      when "111110100100101" =>  data <= "10010101";  -- 7D25 = 95
      when "111110100100110" =>  data <= "10101001";  -- 7D26 = A9
      when "111110100100111" =>  data <= "01111000";  -- 7D27 = 78
      when "111110100101000" =>  data <= "10000101";  -- 7D28 = 85
      when "111110100101001" =>  data <= "10010010";  -- 7D29 = 92
      when "111110100101010" =>  data <= "10101001";  -- 7D2A = A9
      when "111110100101011" =>  data <= "11010100";  -- 7D2B = D4
      when "111110100101100" =>  data <= "10000101";  -- 7D2C = 85
      when "111110100101101" =>  data <= "10010011";  -- 7D2D = 93
      when "111110100101110" =>  data <= "10101001";  -- 7D2E = A9
      when "111110100101111" =>  data <= "10100100";  -- 7D2F = A4
      when "111110100110000" =>  data <= "10001101";  -- 7D30 = 8D
      when "111110100110001" =>  data <= "11111010";  -- 7D31 = FA
      when "111110100110010" =>  data <= "00000011";  -- 7D32 = 3
      when "111110100110011" =>  data <= "10101001";  -- 7D33 = A9
      when "111110100110100" =>  data <= "11010111";  -- 7D34 = D7
      when "111110100110101" =>  data <= "10001101";  -- 7D35 = 8D
      when "111110100110110" =>  data <= "11111011";  -- 7D36 = FB
      when "111110100110111" =>  data <= "00000011";  -- 7D37 = 3
      when "111110100111000" =>  data <= "10101001";  -- 7D38 = A9
      when "111110100111001" =>  data <= "00000000";  -- 7D39 = 0
      when "111110100111010" =>  data <= "10001101";  -- 7D3A = 8D
      when "111110100111011" =>  data <= "11111100";  -- 7D3B = FC
      when "111110100111100" =>  data <= "00000011";  -- 7D3C = 3
      when "111110100111101" =>  data <= "01011000";  -- 7D3D = 58
      when "111110100111110" =>  data <= "10101101";  -- 7D3E = AD
      when "111110100111111" =>  data <= "00010000";  -- 7D3F = 10
      when "111110101000000" =>  data <= "11101000";  -- 7D40 = E8
      when "111110101000001" =>  data <= "00110000";  -- 7D41 = 30
      when "111110101000010" =>  data <= "00000011";  -- 7D42 = 3
      when "111110101000011" =>  data <= "01001100";  -- 7D43 = 4C
      when "111110101000100" =>  data <= "01110010";  -- 7D44 = 72
      when "111110101000101" =>  data <= "11010100";  -- 7D45 = D4
      when "111110101000110" =>  data <= "01001100";  -- 7D46 = 4C
      when "111110101000111" =>  data <= "10110110";  -- 7D47 = B6
      when "111110101001000" =>  data <= "11010011";  -- 7D48 = D3
      when "111110101001001" =>  data <= "01101100";  -- 7D49 = 6C
      when "111110101001010" =>  data <= "10010100";  -- 7D4A = 94
      when "111110101001011" =>  data <= "00000000";  -- 7D4B = 0
      when "111110101001100" =>  data <= "00000000";  -- 7D4C = 0
      when "111110101001101" =>  data <= "00000000";  -- 7D4D = 0
      when "111110101001110" =>  data <= "00000000";  -- 7D4E = 0
      when "111110101001111" =>  data <= "00000000";  -- 7D4F = 0
      when "111110101010000" =>  data <= "00000000";  -- 7D50 = 0
      when "111110101010001" =>  data <= "00000000";  -- 7D51 = 0
      when "111110101010010" =>  data <= "00000000";  -- 7D52 = 0
      when "111110101010011" =>  data <= "00000000";  -- 7D53 = 0
      when "111110101010100" =>  data <= "10011001";  -- 7D54 = 99
      when "111110101010101" =>  data <= "11111100";  -- 7D55 = FC
      when "111110101010110" =>  data <= "11111001";  -- 7D56 = F9
      when "111110101010111" =>  data <= "11111011";  -- 7D57 = FB
      when "111110101011000" =>  data <= "01010101";  -- 7D58 = 55
      when "111110101011001" =>  data <= "11100100";  -- 7D59 = E4
      when "111110101011010" =>  data <= "01110110";  -- 7D5A = 76
      when "111110101011011" =>  data <= "11111001";  -- 7D5B = F9
      when "111110101011100" =>  data <= "11110101";  -- 7D5C = F5
      when "111110101011101" =>  data <= "10101010";  -- 7D5D = AA
      when "111110101011110" =>  data <= "10101010";  -- 7D5E = AA
      when "111110101011111" =>  data <= "10101010";  -- 7D5F = AA
      when "111110101100000" =>  data <= "10101010";  -- 7D60 = AA
      when "111110101100001" =>  data <= "10101010";  -- 7D61 = AA
      when "111110101100010" =>  data <= "10101010";  -- 7D62 = AA
      when "111110101100011" =>  data <= "10101010";  -- 7D63 = AA
      when "111110101100100" =>  data <= "10101010";  -- 7D64 = AA
      when "111110101100101" =>  data <= "10101010";  -- 7D65 = AA
      when "111110101100110" =>  data <= "10101010";  -- 7D66 = AA
      when "111110101100111" =>  data <= "10101010";  -- 7D67 = AA
      when "111110101101000" =>  data <= "10101010";  -- 7D68 = AA
      when "111110101101001" =>  data <= "10101010";  -- 7D69 = AA
      when "111110101101010" =>  data <= "10101010";  -- 7D6A = AA
      when "111110101101011" =>  data <= "10101010";  -- 7D6B = AA
      when "111110101101100" =>  data <= "10101010";  -- 7D6C = AA
      when "111110101101101" =>  data <= "10101010";  -- 7D6D = AA
      when "111110101101110" =>  data <= "10101010";  -- 7D6E = AA
      when "111110101101111" =>  data <= "10101010";  -- 7D6F = AA
      when "111110101110000" =>  data <= "10101010";  -- 7D70 = AA
      when "111110101110001" =>  data <= "10101010";  -- 7D71 = AA
      when "111110101110010" =>  data <= "10101010";  -- 7D72 = AA
      when "111110101110011" =>  data <= "10101010";  -- 7D73 = AA
      when "111110101110100" =>  data <= "10101010";  -- 7D74 = AA
      when "111110101110101" =>  data <= "10101010";  -- 7D75 = AA
      when "111110101110110" =>  data <= "10101010";  -- 7D76 = AA
      when "111110101110111" =>  data <= "10101010";  -- 7D77 = AA
      when "111110101111000" =>  data <= "10101010";  -- 7D78 = AA
      when "111110101111001" =>  data <= "10101010";  -- 7D79 = AA
      when "111110101111010" =>  data <= "10101010";  -- 7D7A = AA
      when "111110101111011" =>  data <= "10101010";  -- 7D7B = AA
      when "111110101111100" =>  data <= "10101010";  -- 7D7C = AA
      when "111110101111101" =>  data <= "10101010";  -- 7D7D = AA
      when "111110101111110" =>  data <= "10101010";  -- 7D7E = AA
      when "111110101111111" =>  data <= "10101010";  -- 7D7F = AA
      when "111110110000000" =>  data <= "10101010";  -- 7D80 = AA
      when "111110110000001" =>  data <= "10101010";  -- 7D81 = AA
      when "111110110000010" =>  data <= "10101010";  -- 7D82 = AA
      when "111110110000011" =>  data <= "10101010";  -- 7D83 = AA
      when "111110110000100" =>  data <= "10101010";  -- 7D84 = AA
      when "111110110000101" =>  data <= "10101010";  -- 7D85 = AA
      when "111110110000110" =>  data <= "10101010";  -- 7D86 = AA
      when "111110110000111" =>  data <= "10101010";  -- 7D87 = AA
      when "111110110001000" =>  data <= "10101010";  -- 7D88 = AA
      when "111110110001001" =>  data <= "10101010";  -- 7D89 = AA
      when "111110110001010" =>  data <= "10101010";  -- 7D8A = AA
      when "111110110001011" =>  data <= "10101010";  -- 7D8B = AA
      when "111110110001100" =>  data <= "10101010";  -- 7D8C = AA
      when "111110110001101" =>  data <= "10101010";  -- 7D8D = AA
      when "111110110001110" =>  data <= "10101010";  -- 7D8E = AA
      when "111110110001111" =>  data <= "10101010";  -- 7D8F = AA
      when "111110110010000" =>  data <= "10101010";  -- 7D90 = AA
      when "111110110010001" =>  data <= "10101010";  -- 7D91 = AA
      when "111110110010010" =>  data <= "10101010";  -- 7D92 = AA
      when "111110110010011" =>  data <= "10101010";  -- 7D93 = AA
      when "111110110010100" =>  data <= "10101010";  -- 7D94 = AA
      when "111110110010101" =>  data <= "10101010";  -- 7D95 = AA
      when "111110110010110" =>  data <= "10101010";  -- 7D96 = AA
      when "111110110010111" =>  data <= "10101010";  -- 7D97 = AA
      when "111110110011000" =>  data <= "10101010";  -- 7D98 = AA
      when "111110110011001" =>  data <= "10101010";  -- 7D99 = AA
      when "111110110011010" =>  data <= "10101010";  -- 7D9A = AA
      when "111110110011011" =>  data <= "10101010";  -- 7D9B = AA
      when "111110110011100" =>  data <= "10101010";  -- 7D9C = AA
      when "111110110011101" =>  data <= "10101010";  -- 7D9D = AA
      when "111110110011110" =>  data <= "10101010";  -- 7D9E = AA
      when "111110110011111" =>  data <= "10101010";  -- 7D9F = AA
      when "111110110100000" =>  data <= "10101010";  -- 7DA0 = AA
      when "111110110100001" =>  data <= "10101010";  -- 7DA1 = AA
      when "111110110100010" =>  data <= "10101010";  -- 7DA2 = AA
      when "111110110100011" =>  data <= "10101010";  -- 7DA3 = AA
      when "111110110100100" =>  data <= "10101010";  -- 7DA4 = AA
      when "111110110100101" =>  data <= "10101010";  -- 7DA5 = AA
      when "111110110100110" =>  data <= "10101010";  -- 7DA6 = AA
      when "111110110100111" =>  data <= "10101010";  -- 7DA7 = AA
      when "111110110101000" =>  data <= "10101010";  -- 7DA8 = AA
      when "111110110101001" =>  data <= "10101010";  -- 7DA9 = AA
      when "111110110101010" =>  data <= "10101010";  -- 7DAA = AA
      when "111110110101011" =>  data <= "10101010";  -- 7DAB = AA
      when "111110110101100" =>  data <= "10101010";  -- 7DAC = AA
      when "111110110101101" =>  data <= "10101010";  -- 7DAD = AA
      when "111110110101110" =>  data <= "10101010";  -- 7DAE = AA
      when "111110110101111" =>  data <= "10101010";  -- 7DAF = AA
      when "111110110110000" =>  data <= "10101010";  -- 7DB0 = AA
      when "111110110110001" =>  data <= "10101010";  -- 7DB1 = AA
      when "111110110110010" =>  data <= "10101010";  -- 7DB2 = AA
      when "111110110110011" =>  data <= "10101010";  -- 7DB3 = AA
      when "111110110110100" =>  data <= "10101010";  -- 7DB4 = AA
      when "111110110110101" =>  data <= "10101010";  -- 7DB5 = AA
      when "111110110110110" =>  data <= "10101010";  -- 7DB6 = AA
      when "111110110110111" =>  data <= "10101010";  -- 7DB7 = AA
      when "111110110111000" =>  data <= "10101010";  -- 7DB8 = AA
      when "111110110111001" =>  data <= "10101010";  -- 7DB9 = AA
      when "111110110111010" =>  data <= "10101010";  -- 7DBA = AA
      when "111110110111011" =>  data <= "10101010";  -- 7DBB = AA
      when "111110110111100" =>  data <= "10101010";  -- 7DBC = AA
      when "111110110111101" =>  data <= "10101010";  -- 7DBD = AA
      when "111110110111110" =>  data <= "10101010";  -- 7DBE = AA
      when "111110110111111" =>  data <= "10101010";  -- 7DBF = AA
      when "111110111000000" =>  data <= "10101010";  -- 7DC0 = AA
      when "111110111000001" =>  data <= "10101010";  -- 7DC1 = AA
      when "111110111000010" =>  data <= "10101010";  -- 7DC2 = AA
      when "111110111000011" =>  data <= "10101010";  -- 7DC3 = AA
      when "111110111000100" =>  data <= "10101010";  -- 7DC4 = AA
      when "111110111000101" =>  data <= "10101010";  -- 7DC5 = AA
      when "111110111000110" =>  data <= "10101010";  -- 7DC6 = AA
      when "111110111000111" =>  data <= "10101010";  -- 7DC7 = AA
      when "111110111001000" =>  data <= "10101010";  -- 7DC8 = AA
      when "111110111001001" =>  data <= "10101010";  -- 7DC9 = AA
      when "111110111001010" =>  data <= "10101010";  -- 7DCA = AA
      when "111110111001011" =>  data <= "10101010";  -- 7DCB = AA
      when "111110111001100" =>  data <= "10101010";  -- 7DCC = AA
      when "111110111001101" =>  data <= "10101010";  -- 7DCD = AA
      when "111110111001110" =>  data <= "10101010";  -- 7DCE = AA
      when "111110111001111" =>  data <= "10101010";  -- 7DCF = AA
      when "111110111010000" =>  data <= "10101010";  -- 7DD0 = AA
      when "111110111010001" =>  data <= "10101010";  -- 7DD1 = AA
      when "111110111010010" =>  data <= "10101010";  -- 7DD2 = AA
      when "111110111010011" =>  data <= "10101010";  -- 7DD3 = AA
      when "111110111010100" =>  data <= "10101010";  -- 7DD4 = AA
      when "111110111010101" =>  data <= "10101010";  -- 7DD5 = AA
      when "111110111010110" =>  data <= "10101010";  -- 7DD6 = AA
      when "111110111010111" =>  data <= "10101010";  -- 7DD7 = AA
      when "111110111011000" =>  data <= "10101010";  -- 7DD8 = AA
      when "111110111011001" =>  data <= "10101010";  -- 7DD9 = AA
      when "111110111011010" =>  data <= "10101010";  -- 7DDA = AA
      when "111110111011011" =>  data <= "10101010";  -- 7DDB = AA
      when "111110111011100" =>  data <= "10101010";  -- 7DDC = AA
      when "111110111011101" =>  data <= "10101010";  -- 7DDD = AA
      when "111110111011110" =>  data <= "10101010";  -- 7DDE = AA
      when "111110111011111" =>  data <= "10101010";  -- 7DDF = AA
      when "111110111100000" =>  data <= "10101010";  -- 7DE0 = AA
      when "111110111100001" =>  data <= "10101010";  -- 7DE1 = AA
      when "111110111100010" =>  data <= "10101010";  -- 7DE2 = AA
      when "111110111100011" =>  data <= "10101010";  -- 7DE3 = AA
      when "111110111100100" =>  data <= "10101010";  -- 7DE4 = AA
      when "111110111100101" =>  data <= "10101010";  -- 7DE5 = AA
      when "111110111100110" =>  data <= "10101010";  -- 7DE6 = AA
      when "111110111100111" =>  data <= "10101010";  -- 7DE7 = AA
      when "111110111101000" =>  data <= "10101010";  -- 7DE8 = AA
      when "111110111101001" =>  data <= "10101010";  -- 7DE9 = AA
      when "111110111101010" =>  data <= "10101010";  -- 7DEA = AA
      when "111110111101011" =>  data <= "10101010";  -- 7DEB = AA
      when "111110111101100" =>  data <= "10101010";  -- 7DEC = AA
      when "111110111101101" =>  data <= "10101010";  -- 7DED = AA
      when "111110111101110" =>  data <= "10101010";  -- 7DEE = AA
      when "111110111101111" =>  data <= "10101010";  -- 7DEF = AA
      when "111110111110000" =>  data <= "10101010";  -- 7DF0 = AA
      when "111110111110001" =>  data <= "10101010";  -- 7DF1 = AA
      when "111110111110010" =>  data <= "10101010";  -- 7DF2 = AA
      when "111110111110011" =>  data <= "10101010";  -- 7DF3 = AA
      when "111110111110100" =>  data <= "10101010";  -- 7DF4 = AA
      when "111110111110101" =>  data <= "10101010";  -- 7DF5 = AA
      when "111110111110110" =>  data <= "10101010";  -- 7DF6 = AA
      when "111110111110111" =>  data <= "10101010";  -- 7DF7 = AA
      when "111110111111000" =>  data <= "10101010";  -- 7DF8 = AA
      when "111110111111001" =>  data <= "10101010";  -- 7DF9 = AA
      when "111110111111010" =>  data <= "10101010";  -- 7DFA = AA
      when "111110111111011" =>  data <= "10101010";  -- 7DFB = AA
      when "111110111111100" =>  data <= "10101010";  -- 7DFC = AA
      when "111110111111101" =>  data <= "10101010";  -- 7DFD = AA
      when "111110111111110" =>  data <= "10101010";  -- 7DFE = AA
      when "111110111111111" =>  data <= "10101010";  -- 7DFF = AA
      when "111111000000000" =>  data <= "10101010";  -- 7E00 = AA
      when "111111000000001" =>  data <= "10101010";  -- 7E01 = AA
      when "111111000000010" =>  data <= "10101010";  -- 7E02 = AA
      when "111111000000011" =>  data <= "10101010";  -- 7E03 = AA
      when "111111000000100" =>  data <= "10101010";  -- 7E04 = AA
      when "111111000000101" =>  data <= "10101010";  -- 7E05 = AA
      when "111111000000110" =>  data <= "10101010";  -- 7E06 = AA
      when "111111000000111" =>  data <= "10101010";  -- 7E07 = AA
      when "111111000001000" =>  data <= "10101010";  -- 7E08 = AA
      when "111111000001001" =>  data <= "10101010";  -- 7E09 = AA
      when "111111000001010" =>  data <= "10101010";  -- 7E0A = AA
      when "111111000001011" =>  data <= "10101010";  -- 7E0B = AA
      when "111111000001100" =>  data <= "10101010";  -- 7E0C = AA
      when "111111000001101" =>  data <= "10101010";  -- 7E0D = AA
      when "111111000001110" =>  data <= "10101010";  -- 7E0E = AA
      when "111111000001111" =>  data <= "10101010";  -- 7E0F = AA
      when "111111000010000" =>  data <= "10101010";  -- 7E10 = AA
      when "111111000010001" =>  data <= "10101010";  -- 7E11 = AA
      when "111111000010010" =>  data <= "10101010";  -- 7E12 = AA
      when "111111000010011" =>  data <= "10101010";  -- 7E13 = AA
      when "111111000010100" =>  data <= "10101010";  -- 7E14 = AA
      when "111111000010101" =>  data <= "10101010";  -- 7E15 = AA
      when "111111000010110" =>  data <= "10101010";  -- 7E16 = AA
      when "111111000010111" =>  data <= "10101010";  -- 7E17 = AA
      when "111111000011000" =>  data <= "10101010";  -- 7E18 = AA
      when "111111000011001" =>  data <= "10101010";  -- 7E19 = AA
      when "111111000011010" =>  data <= "10101010";  -- 7E1A = AA
      when "111111000011011" =>  data <= "10101010";  -- 7E1B = AA
      when "111111000011100" =>  data <= "10101010";  -- 7E1C = AA
      when "111111000011101" =>  data <= "10101010";  -- 7E1D = AA
      when "111111000011110" =>  data <= "10101010";  -- 7E1E = AA
      when "111111000011111" =>  data <= "10101010";  -- 7E1F = AA
      when "111111000100000" =>  data <= "10101010";  -- 7E20 = AA
      when "111111000100001" =>  data <= "10101010";  -- 7E21 = AA
      when "111111000100010" =>  data <= "10101010";  -- 7E22 = AA
      when "111111000100011" =>  data <= "10101010";  -- 7E23 = AA
      when "111111000100100" =>  data <= "10101010";  -- 7E24 = AA
      when "111111000100101" =>  data <= "10101010";  -- 7E25 = AA
      when "111111000100110" =>  data <= "10101010";  -- 7E26 = AA
      when "111111000100111" =>  data <= "10101010";  -- 7E27 = AA
      when "111111000101000" =>  data <= "10101010";  -- 7E28 = AA
      when "111111000101001" =>  data <= "10101010";  -- 7E29 = AA
      when "111111000101010" =>  data <= "10101010";  -- 7E2A = AA
      when "111111000101011" =>  data <= "10101010";  -- 7E2B = AA
      when "111111000101100" =>  data <= "10101010";  -- 7E2C = AA
      when "111111000101101" =>  data <= "10101010";  -- 7E2D = AA
      when "111111000101110" =>  data <= "10101010";  -- 7E2E = AA
      when "111111000101111" =>  data <= "10101010";  -- 7E2F = AA
      when "111111000110000" =>  data <= "10101010";  -- 7E30 = AA
      when "111111000110001" =>  data <= "10101010";  -- 7E31 = AA
      when "111111000110010" =>  data <= "10101010";  -- 7E32 = AA
      when "111111000110011" =>  data <= "10101010";  -- 7E33 = AA
      when "111111000110100" =>  data <= "10101010";  -- 7E34 = AA
      when "111111000110101" =>  data <= "10101010";  -- 7E35 = AA
      when "111111000110110" =>  data <= "10101010";  -- 7E36 = AA
      when "111111000110111" =>  data <= "10101010";  -- 7E37 = AA
      when "111111000111000" =>  data <= "10101010";  -- 7E38 = AA
      when "111111000111001" =>  data <= "10101010";  -- 7E39 = AA
      when "111111000111010" =>  data <= "10101010";  -- 7E3A = AA
      when "111111000111011" =>  data <= "10101010";  -- 7E3B = AA
      when "111111000111100" =>  data <= "10101010";  -- 7E3C = AA
      when "111111000111101" =>  data <= "10101010";  -- 7E3D = AA
      when "111111000111110" =>  data <= "10101010";  -- 7E3E = AA
      when "111111000111111" =>  data <= "10101010";  -- 7E3F = AA
      when "111111001000000" =>  data <= "10101010";  -- 7E40 = AA
      when "111111001000001" =>  data <= "10101010";  -- 7E41 = AA
      when "111111001000010" =>  data <= "10101010";  -- 7E42 = AA
      when "111111001000011" =>  data <= "10101010";  -- 7E43 = AA
      when "111111001000100" =>  data <= "10101010";  -- 7E44 = AA
      when "111111001000101" =>  data <= "10101010";  -- 7E45 = AA
      when "111111001000110" =>  data <= "10101010";  -- 7E46 = AA
      when "111111001000111" =>  data <= "10101010";  -- 7E47 = AA
      when "111111001001000" =>  data <= "10101010";  -- 7E48 = AA
      when "111111001001001" =>  data <= "10101010";  -- 7E49 = AA
      when "111111001001010" =>  data <= "10101010";  -- 7E4A = AA
      when "111111001001011" =>  data <= "10101010";  -- 7E4B = AA
      when "111111001001100" =>  data <= "10101010";  -- 7E4C = AA
      when "111111001001101" =>  data <= "10101010";  -- 7E4D = AA
      when "111111001001110" =>  data <= "10101010";  -- 7E4E = AA
      when "111111001001111" =>  data <= "10101010";  -- 7E4F = AA
      when "111111001010000" =>  data <= "10101010";  -- 7E50 = AA
      when "111111001010001" =>  data <= "10101010";  -- 7E51 = AA
      when "111111001010010" =>  data <= "10101010";  -- 7E52 = AA
      when "111111001010011" =>  data <= "10101010";  -- 7E53 = AA
      when "111111001010100" =>  data <= "10101010";  -- 7E54 = AA
      when "111111001010101" =>  data <= "10101010";  -- 7E55 = AA
      when "111111001010110" =>  data <= "10101010";  -- 7E56 = AA
      when "111111001010111" =>  data <= "10101010";  -- 7E57 = AA
      when "111111001011000" =>  data <= "10101010";  -- 7E58 = AA
      when "111111001011001" =>  data <= "10101010";  -- 7E59 = AA
      when "111111001011010" =>  data <= "10101010";  -- 7E5A = AA
      when "111111001011011" =>  data <= "10101010";  -- 7E5B = AA
      when "111111001011100" =>  data <= "10101010";  -- 7E5C = AA
      when "111111001011101" =>  data <= "10101010";  -- 7E5D = AA
      when "111111001011110" =>  data <= "10101010";  -- 7E5E = AA
      when "111111001011111" =>  data <= "10101010";  -- 7E5F = AA
      when "111111001100000" =>  data <= "10101010";  -- 7E60 = AA
      when "111111001100001" =>  data <= "10101010";  -- 7E61 = AA
      when "111111001100010" =>  data <= "10101010";  -- 7E62 = AA
      when "111111001100011" =>  data <= "10101010";  -- 7E63 = AA
      when "111111001100100" =>  data <= "10101010";  -- 7E64 = AA
      when "111111001100101" =>  data <= "10101010";  -- 7E65 = AA
      when "111111001100110" =>  data <= "10101010";  -- 7E66 = AA
      when "111111001100111" =>  data <= "10101010";  -- 7E67 = AA
      when "111111001101000" =>  data <= "10101010";  -- 7E68 = AA
      when "111111001101001" =>  data <= "10101010";  -- 7E69 = AA
      when "111111001101010" =>  data <= "10101010";  -- 7E6A = AA
      when "111111001101011" =>  data <= "10101010";  -- 7E6B = AA
      when "111111001101100" =>  data <= "10101010";  -- 7E6C = AA
      when "111111001101101" =>  data <= "10101010";  -- 7E6D = AA
      when "111111001101110" =>  data <= "10101010";  -- 7E6E = AA
      when "111111001101111" =>  data <= "10101010";  -- 7E6F = AA
      when "111111001110000" =>  data <= "10101010";  -- 7E70 = AA
      when "111111001110001" =>  data <= "10101010";  -- 7E71 = AA
      when "111111001110010" =>  data <= "10101010";  -- 7E72 = AA
      when "111111001110011" =>  data <= "10101010";  -- 7E73 = AA
      when "111111001110100" =>  data <= "10101010";  -- 7E74 = AA
      when "111111001110101" =>  data <= "10101010";  -- 7E75 = AA
      when "111111001110110" =>  data <= "10101010";  -- 7E76 = AA
      when "111111001110111" =>  data <= "10101010";  -- 7E77 = AA
      when "111111001111000" =>  data <= "10101010";  -- 7E78 = AA
      when "111111001111001" =>  data <= "10101010";  -- 7E79 = AA
      when "111111001111010" =>  data <= "10101010";  -- 7E7A = AA
      when "111111001111011" =>  data <= "10101010";  -- 7E7B = AA
      when "111111001111100" =>  data <= "10101010";  -- 7E7C = AA
      when "111111001111101" =>  data <= "10101010";  -- 7E7D = AA
      when "111111001111110" =>  data <= "10101010";  -- 7E7E = AA
      when "111111001111111" =>  data <= "10101010";  -- 7E7F = AA
      when "111111010000000" =>  data <= "10101010";  -- 7E80 = AA
      when "111111010000001" =>  data <= "10101010";  -- 7E81 = AA
      when "111111010000010" =>  data <= "10101010";  -- 7E82 = AA
      when "111111010000011" =>  data <= "10101010";  -- 7E83 = AA
      when "111111010000100" =>  data <= "10101010";  -- 7E84 = AA
      when "111111010000101" =>  data <= "10101010";  -- 7E85 = AA
      when "111111010000110" =>  data <= "10101010";  -- 7E86 = AA
      when "111111010000111" =>  data <= "10101010";  -- 7E87 = AA
      when "111111010001000" =>  data <= "10101010";  -- 7E88 = AA
      when "111111010001001" =>  data <= "10101010";  -- 7E89 = AA
      when "111111010001010" =>  data <= "10101010";  -- 7E8A = AA
      when "111111010001011" =>  data <= "10101010";  -- 7E8B = AA
      when "111111010001100" =>  data <= "10101010";  -- 7E8C = AA
      when "111111010001101" =>  data <= "10101010";  -- 7E8D = AA
      when "111111010001110" =>  data <= "10101010";  -- 7E8E = AA
      when "111111010001111" =>  data <= "10101010";  -- 7E8F = AA
      when "111111010010000" =>  data <= "10101010";  -- 7E90 = AA
      when "111111010010001" =>  data <= "10101010";  -- 7E91 = AA
      when "111111010010010" =>  data <= "10101010";  -- 7E92 = AA
      when "111111010010011" =>  data <= "10101010";  -- 7E93 = AA
      when "111111010010100" =>  data <= "10101010";  -- 7E94 = AA
      when "111111010010101" =>  data <= "10101010";  -- 7E95 = AA
      when "111111010010110" =>  data <= "10101010";  -- 7E96 = AA
      when "111111010010111" =>  data <= "10101010";  -- 7E97 = AA
      when "111111010011000" =>  data <= "10101010";  -- 7E98 = AA
      when "111111010011001" =>  data <= "10101010";  -- 7E99 = AA
      when "111111010011010" =>  data <= "10101010";  -- 7E9A = AA
      when "111111010011011" =>  data <= "10101010";  -- 7E9B = AA
      when "111111010011100" =>  data <= "10101010";  -- 7E9C = AA
      when "111111010011101" =>  data <= "10101010";  -- 7E9D = AA
      when "111111010011110" =>  data <= "10101010";  -- 7E9E = AA
      when "111111010011111" =>  data <= "10101010";  -- 7E9F = AA
      when "111111010100000" =>  data <= "10101010";  -- 7EA0 = AA
      when "111111010100001" =>  data <= "10101010";  -- 7EA1 = AA
      when "111111010100010" =>  data <= "10101010";  -- 7EA2 = AA
      when "111111010100011" =>  data <= "10101010";  -- 7EA3 = AA
      when "111111010100100" =>  data <= "10101010";  -- 7EA4 = AA
      when "111111010100101" =>  data <= "10101010";  -- 7EA5 = AA
      when "111111010100110" =>  data <= "10101010";  -- 7EA6 = AA
      when "111111010100111" =>  data <= "10101010";  -- 7EA7 = AA
      when "111111010101000" =>  data <= "10101010";  -- 7EA8 = AA
      when "111111010101001" =>  data <= "10101010";  -- 7EA9 = AA
      when "111111010101010" =>  data <= "10101010";  -- 7EAA = AA
      when "111111010101011" =>  data <= "10101010";  -- 7EAB = AA
      when "111111010101100" =>  data <= "10101010";  -- 7EAC = AA
      when "111111010101101" =>  data <= "10101010";  -- 7EAD = AA
      when "111111010101110" =>  data <= "10101010";  -- 7EAE = AA
      when "111111010101111" =>  data <= "10101010";  -- 7EAF = AA
      when "111111010110000" =>  data <= "10101010";  -- 7EB0 = AA
      when "111111010110001" =>  data <= "10101010";  -- 7EB1 = AA
      when "111111010110010" =>  data <= "10101010";  -- 7EB2 = AA
      when "111111010110011" =>  data <= "10101010";  -- 7EB3 = AA
      when "111111010110100" =>  data <= "10101010";  -- 7EB4 = AA
      when "111111010110101" =>  data <= "10101010";  -- 7EB5 = AA
      when "111111010110110" =>  data <= "10101010";  -- 7EB6 = AA
      when "111111010110111" =>  data <= "10101010";  -- 7EB7 = AA
      when "111111010111000" =>  data <= "10101010";  -- 7EB8 = AA
      when "111111010111001" =>  data <= "10101010";  -- 7EB9 = AA
      when "111111010111010" =>  data <= "10101010";  -- 7EBA = AA
      when "111111010111011" =>  data <= "10101010";  -- 7EBB = AA
      when "111111010111100" =>  data <= "10101010";  -- 7EBC = AA
      when "111111010111101" =>  data <= "10101010";  -- 7EBD = AA
      when "111111010111110" =>  data <= "10101010";  -- 7EBE = AA
      when "111111010111111" =>  data <= "10101010";  -- 7EBF = AA
      when "111111011000000" =>  data <= "10101010";  -- 7EC0 = AA
      when "111111011000001" =>  data <= "10101010";  -- 7EC1 = AA
      when "111111011000010" =>  data <= "10101010";  -- 7EC2 = AA
      when "111111011000011" =>  data <= "10101010";  -- 7EC3 = AA
      when "111111011000100" =>  data <= "10101010";  -- 7EC4 = AA
      when "111111011000101" =>  data <= "10101010";  -- 7EC5 = AA
      when "111111011000110" =>  data <= "10101010";  -- 7EC6 = AA
      when "111111011000111" =>  data <= "10101010";  -- 7EC7 = AA
      when "111111011001000" =>  data <= "10101010";  -- 7EC8 = AA
      when "111111011001001" =>  data <= "10101010";  -- 7EC9 = AA
      when "111111011001010" =>  data <= "10101010";  -- 7ECA = AA
      when "111111011001011" =>  data <= "10101010";  -- 7ECB = AA
      when "111111011001100" =>  data <= "10101010";  -- 7ECC = AA
      when "111111011001101" =>  data <= "10101010";  -- 7ECD = AA
      when "111111011001110" =>  data <= "10101010";  -- 7ECE = AA
      when "111111011001111" =>  data <= "10101010";  -- 7ECF = AA
      when "111111011010000" =>  data <= "10101010";  -- 7ED0 = AA
      when "111111011010001" =>  data <= "10101010";  -- 7ED1 = AA
      when "111111011010010" =>  data <= "10101010";  -- 7ED2 = AA
      when "111111011010011" =>  data <= "10101010";  -- 7ED3 = AA
      when "111111011010100" =>  data <= "10101010";  -- 7ED4 = AA
      when "111111011010101" =>  data <= "10101010";  -- 7ED5 = AA
      when "111111011010110" =>  data <= "10101010";  -- 7ED6 = AA
      when "111111011010111" =>  data <= "10101010";  -- 7ED7 = AA
      when "111111011011000" =>  data <= "10101010";  -- 7ED8 = AA
      when "111111011011001" =>  data <= "10101010";  -- 7ED9 = AA
      when "111111011011010" =>  data <= "10101010";  -- 7EDA = AA
      when "111111011011011" =>  data <= "10101010";  -- 7EDB = AA
      when "111111011011100" =>  data <= "10101010";  -- 7EDC = AA
      when "111111011011101" =>  data <= "10101010";  -- 7EDD = AA
      when "111111011011110" =>  data <= "10101010";  -- 7EDE = AA
      when "111111011011111" =>  data <= "10101010";  -- 7EDF = AA
      when "111111011100000" =>  data <= "10101010";  -- 7EE0 = AA
      when "111111011100001" =>  data <= "10101010";  -- 7EE1 = AA
      when "111111011100010" =>  data <= "10101010";  -- 7EE2 = AA
      when "111111011100011" =>  data <= "10101010";  -- 7EE3 = AA
      when "111111011100100" =>  data <= "10101010";  -- 7EE4 = AA
      when "111111011100101" =>  data <= "10101010";  -- 7EE5 = AA
      when "111111011100110" =>  data <= "10101010";  -- 7EE6 = AA
      when "111111011100111" =>  data <= "10101010";  -- 7EE7 = AA
      when "111111011101000" =>  data <= "10101010";  -- 7EE8 = AA
      when "111111011101001" =>  data <= "10101010";  -- 7EE9 = AA
      when "111111011101010" =>  data <= "10101010";  -- 7EEA = AA
      when "111111011101011" =>  data <= "10101010";  -- 7EEB = AA
      when "111111011101100" =>  data <= "10101010";  -- 7EEC = AA
      when "111111011101101" =>  data <= "10101010";  -- 7EED = AA
      when "111111011101110" =>  data <= "10101010";  -- 7EEE = AA
      when "111111011101111" =>  data <= "10101010";  -- 7EEF = AA
      when "111111011110000" =>  data <= "10101010";  -- 7EF0 = AA
      when "111111011110001" =>  data <= "10101010";  -- 7EF1 = AA
      when "111111011110010" =>  data <= "10101010";  -- 7EF2 = AA
      when "111111011110011" =>  data <= "10101010";  -- 7EF3 = AA
      when "111111011110100" =>  data <= "10101010";  -- 7EF4 = AA
      when "111111011110101" =>  data <= "10101010";  -- 7EF5 = AA
      when "111111011110110" =>  data <= "10101010";  -- 7EF6 = AA
      when "111111011110111" =>  data <= "10101010";  -- 7EF7 = AA
      when "111111011111000" =>  data <= "10101010";  -- 7EF8 = AA
      when "111111011111001" =>  data <= "10101010";  -- 7EF9 = AA
      when "111111011111010" =>  data <= "10101010";  -- 7EFA = AA
      when "111111011111011" =>  data <= "10101010";  -- 7EFB = AA
      when "111111011111100" =>  data <= "10101010";  -- 7EFC = AA
      when "111111011111101" =>  data <= "10101010";  -- 7EFD = AA
      when "111111011111110" =>  data <= "10101010";  -- 7EFE = AA
      when "111111011111111" =>  data <= "10101010";  -- 7EFF = AA
      when "111111100000000" =>  data <= "10101010";  -- 7F00 = AA
      when "111111100000001" =>  data <= "10101010";  -- 7F01 = AA
      when "111111100000010" =>  data <= "10101010";  -- 7F02 = AA
      when "111111100000011" =>  data <= "10101010";  -- 7F03 = AA
      when "111111100000100" =>  data <= "10101010";  -- 7F04 = AA
      when "111111100000101" =>  data <= "10101010";  -- 7F05 = AA
      when "111111100000110" =>  data <= "10101010";  -- 7F06 = AA
      when "111111100000111" =>  data <= "10101010";  -- 7F07 = AA
      when "111111100001000" =>  data <= "10101010";  -- 7F08 = AA
      when "111111100001001" =>  data <= "10101010";  -- 7F09 = AA
      when "111111100001010" =>  data <= "10101010";  -- 7F0A = AA
      when "111111100001011" =>  data <= "10101010";  -- 7F0B = AA
      when "111111100001100" =>  data <= "10101010";  -- 7F0C = AA
      when "111111100001101" =>  data <= "10101010";  -- 7F0D = AA
      when "111111100001110" =>  data <= "10101010";  -- 7F0E = AA
      when "111111100001111" =>  data <= "10101010";  -- 7F0F = AA
      when "111111100010000" =>  data <= "10101010";  -- 7F10 = AA
      when "111111100010001" =>  data <= "10101010";  -- 7F11 = AA
      when "111111100010010" =>  data <= "10101010";  -- 7F12 = AA
      when "111111100010011" =>  data <= "10101010";  -- 7F13 = AA
      when "111111100010100" =>  data <= "10101010";  -- 7F14 = AA
      when "111111100010101" =>  data <= "10101010";  -- 7F15 = AA
      when "111111100010110" =>  data <= "10101010";  -- 7F16 = AA
      when "111111100010111" =>  data <= "10101010";  -- 7F17 = AA
      when "111111100011000" =>  data <= "10101010";  -- 7F18 = AA
      when "111111100011001" =>  data <= "10101010";  -- 7F19 = AA
      when "111111100011010" =>  data <= "10101010";  -- 7F1A = AA
      when "111111100011011" =>  data <= "10101010";  -- 7F1B = AA
      when "111111100011100" =>  data <= "10101010";  -- 7F1C = AA
      when "111111100011101" =>  data <= "10101010";  -- 7F1D = AA
      when "111111100011110" =>  data <= "10101010";  -- 7F1E = AA
      when "111111100011111" =>  data <= "10101010";  -- 7F1F = AA
      when "111111100100000" =>  data <= "10101010";  -- 7F20 = AA
      when "111111100100001" =>  data <= "10101010";  -- 7F21 = AA
      when "111111100100010" =>  data <= "10101010";  -- 7F22 = AA
      when "111111100100011" =>  data <= "10101010";  -- 7F23 = AA
      when "111111100100100" =>  data <= "10101010";  -- 7F24 = AA
      when "111111100100101" =>  data <= "10101010";  -- 7F25 = AA
      when "111111100100110" =>  data <= "10101010";  -- 7F26 = AA
      when "111111100100111" =>  data <= "10101010";  -- 7F27 = AA
      when "111111100101000" =>  data <= "10101010";  -- 7F28 = AA
      when "111111100101001" =>  data <= "10101010";  -- 7F29 = AA
      when "111111100101010" =>  data <= "10101010";  -- 7F2A = AA
      when "111111100101011" =>  data <= "10101010";  -- 7F2B = AA
      when "111111100101100" =>  data <= "10101010";  -- 7F2C = AA
      when "111111100101101" =>  data <= "10101010";  -- 7F2D = AA
      when "111111100101110" =>  data <= "10101010";  -- 7F2E = AA
      when "111111100101111" =>  data <= "10101010";  -- 7F2F = AA
      when "111111100110000" =>  data <= "10101010";  -- 7F30 = AA
      when "111111100110001" =>  data <= "10101010";  -- 7F31 = AA
      when "111111100110010" =>  data <= "10101010";  -- 7F32 = AA
      when "111111100110011" =>  data <= "10101010";  -- 7F33 = AA
      when "111111100110100" =>  data <= "10101010";  -- 7F34 = AA
      when "111111100110101" =>  data <= "10101010";  -- 7F35 = AA
      when "111111100110110" =>  data <= "10101010";  -- 7F36 = AA
      when "111111100110111" =>  data <= "10101010";  -- 7F37 = AA
      when "111111100111000" =>  data <= "10101010";  -- 7F38 = AA
      when "111111100111001" =>  data <= "10101010";  -- 7F39 = AA
      when "111111100111010" =>  data <= "10101010";  -- 7F3A = AA
      when "111111100111011" =>  data <= "10101010";  -- 7F3B = AA
      when "111111100111100" =>  data <= "10101010";  -- 7F3C = AA
      when "111111100111101" =>  data <= "10101010";  -- 7F3D = AA
      when "111111100111110" =>  data <= "10101010";  -- 7F3E = AA
      when "111111100111111" =>  data <= "10101010";  -- 7F3F = AA
      when "111111101000000" =>  data <= "10101010";  -- 7F40 = AA
      when "111111101000001" =>  data <= "10101010";  -- 7F41 = AA
      when "111111101000010" =>  data <= "10101010";  -- 7F42 = AA
      when "111111101000011" =>  data <= "10101010";  -- 7F43 = AA
      when "111111101000100" =>  data <= "10101010";  -- 7F44 = AA
      when "111111101000101" =>  data <= "10101010";  -- 7F45 = AA
      when "111111101000110" =>  data <= "10101010";  -- 7F46 = AA
      when "111111101000111" =>  data <= "10101010";  -- 7F47 = AA
      when "111111101001000" =>  data <= "10101010";  -- 7F48 = AA
      when "111111101001001" =>  data <= "10101010";  -- 7F49 = AA
      when "111111101001010" =>  data <= "10101010";  -- 7F4A = AA
      when "111111101001011" =>  data <= "10101010";  -- 7F4B = AA
      when "111111101001100" =>  data <= "10101010";  -- 7F4C = AA
      when "111111101001101" =>  data <= "10101010";  -- 7F4D = AA
      when "111111101001110" =>  data <= "10101010";  -- 7F4E = AA
      when "111111101001111" =>  data <= "10101010";  -- 7F4F = AA
      when "111111101010000" =>  data <= "10101010";  -- 7F50 = AA
      when "111111101010001" =>  data <= "10101010";  -- 7F51 = AA
      when "111111101010010" =>  data <= "10101010";  -- 7F52 = AA
      when "111111101010011" =>  data <= "10101010";  -- 7F53 = AA
      when "111111101010100" =>  data <= "10101010";  -- 7F54 = AA
      when "111111101010101" =>  data <= "10101010";  -- 7F55 = AA
      when "111111101010110" =>  data <= "10101010";  -- 7F56 = AA
      when "111111101010111" =>  data <= "10101010";  -- 7F57 = AA
      when "111111101011000" =>  data <= "10101010";  -- 7F58 = AA
      when "111111101011001" =>  data <= "10101010";  -- 7F59 = AA
      when "111111101011010" =>  data <= "10101010";  -- 7F5A = AA
      when "111111101011011" =>  data <= "10101010";  -- 7F5B = AA
      when "111111101011100" =>  data <= "10101010";  -- 7F5C = AA
      when "111111101011101" =>  data <= "10101010";  -- 7F5D = AA
      when "111111101011110" =>  data <= "10101010";  -- 7F5E = AA
      when "111111101011111" =>  data <= "10101010";  -- 7F5F = AA
      when "111111101100000" =>  data <= "10101010";  -- 7F60 = AA
      when "111111101100001" =>  data <= "10101010";  -- 7F61 = AA
      when "111111101100010" =>  data <= "10101010";  -- 7F62 = AA
      when "111111101100011" =>  data <= "10101010";  -- 7F63 = AA
      when "111111101100100" =>  data <= "10101010";  -- 7F64 = AA
      when "111111101100101" =>  data <= "10101010";  -- 7F65 = AA
      when "111111101100110" =>  data <= "10101010";  -- 7F66 = AA
      when "111111101100111" =>  data <= "10101010";  -- 7F67 = AA
      when "111111101101000" =>  data <= "10101010";  -- 7F68 = AA
      when "111111101101001" =>  data <= "10101010";  -- 7F69 = AA
      when "111111101101010" =>  data <= "10101010";  -- 7F6A = AA
      when "111111101101011" =>  data <= "10101010";  -- 7F6B = AA
      when "111111101101100" =>  data <= "10101010";  -- 7F6C = AA
      when "111111101101101" =>  data <= "10101010";  -- 7F6D = AA
      when "111111101101110" =>  data <= "10101010";  -- 7F6E = AA
      when "111111101101111" =>  data <= "10101010";  -- 7F6F = AA
      when "111111101110000" =>  data <= "10101010";  -- 7F70 = AA
      when "111111101110001" =>  data <= "10101010";  -- 7F71 = AA
      when "111111101110010" =>  data <= "10101010";  -- 7F72 = AA
      when "111111101110011" =>  data <= "10101010";  -- 7F73 = AA
      when "111111101110100" =>  data <= "10101010";  -- 7F74 = AA
      when "111111101110101" =>  data <= "10101010";  -- 7F75 = AA
      when "111111101110110" =>  data <= "10101010";  -- 7F76 = AA
      when "111111101110111" =>  data <= "10101010";  -- 7F77 = AA
      when "111111101111000" =>  data <= "10101010";  -- 7F78 = AA
      when "111111101111001" =>  data <= "10101010";  -- 7F79 = AA
      when "111111101111010" =>  data <= "10101010";  -- 7F7A = AA
      when "111111101111011" =>  data <= "10101010";  -- 7F7B = AA
      when "111111101111100" =>  data <= "10101010";  -- 7F7C = AA
      when "111111101111101" =>  data <= "10101010";  -- 7F7D = AA
      when "111111101111110" =>  data <= "10101010";  -- 7F7E = AA
      when "111111101111111" =>  data <= "10101010";  -- 7F7F = AA
      when "111111110000000" =>  data <= "10101010";  -- 7F80 = AA
      when "111111110000001" =>  data <= "10101010";  -- 7F81 = AA
      when "111111110000010" =>  data <= "10101010";  -- 7F82 = AA
      when "111111110000011" =>  data <= "10101010";  -- 7F83 = AA
      when "111111110000100" =>  data <= "10101010";  -- 7F84 = AA
      when "111111110000101" =>  data <= "10101010";  -- 7F85 = AA
      when "111111110000110" =>  data <= "10101010";  -- 7F86 = AA
      when "111111110000111" =>  data <= "10101010";  -- 7F87 = AA
      when "111111110001000" =>  data <= "10101010";  -- 7F88 = AA
      when "111111110001001" =>  data <= "10101010";  -- 7F89 = AA
      when "111111110001010" =>  data <= "10101010";  -- 7F8A = AA
      when "111111110001011" =>  data <= "10101010";  -- 7F8B = AA
      when "111111110001100" =>  data <= "10101010";  -- 7F8C = AA
      when "111111110001101" =>  data <= "10101010";  -- 7F8D = AA
      when "111111110001110" =>  data <= "10101010";  -- 7F8E = AA
      when "111111110001111" =>  data <= "10101010";  -- 7F8F = AA
      when "111111110010000" =>  data <= "10101010";  -- 7F90 = AA
      when "111111110010001" =>  data <= "10101010";  -- 7F91 = AA
      when "111111110010010" =>  data <= "10101010";  -- 7F92 = AA
      when "111111110010011" =>  data <= "01001100";  -- 7F93 = 4C
      when "111111110010100" =>  data <= "11000111";  -- 7F94 = C7
      when "111111110010101" =>  data <= "11011010";  -- 7F95 = DA
      when "111111110010110" =>  data <= "01001100";  -- 7F96 = 4C
      when "111111110010111" =>  data <= "01000010";  -- 7F97 = 42
      when "111111110011000" =>  data <= "11011001";  -- 7F98 = D9
      when "111111110011001" =>  data <= "01001100";  -- 7F99 = 4C
      when "111111110011010" =>  data <= "00000111";  -- 7F9A = 7
      when "111111110011011" =>  data <= "11011010";  -- 7F9B = DA
      when "111111110011100" =>  data <= "01001100";  -- 7F9C = 4C
      when "111111110011101" =>  data <= "10101111";  -- 7F9D = AF
      when "111111110011110" =>  data <= "11010111";  -- 7F9E = D7
      when "111111110011111" =>  data <= "01001100";  -- 7F9F = 4C
      when "111111110100000" =>  data <= "11010010";  -- 7FA0 = D2
      when "111111110100001" =>  data <= "11011001";  -- 7FA1 = D9
      when "111111110100010" =>  data <= "01001100";  -- 7FA2 = 4C
      when "111111110100011" =>  data <= "01100101";  -- 7FA3 = 65
      when "111111110100100" =>  data <= "11011010";  -- 7FA4 = DA
      when "111111110100101" =>  data <= "01001100";  -- 7FA5 = 4C
      when "111111110100110" =>  data <= "01111110";  -- 7FA6 = 7E
      when "111111110100111" =>  data <= "11011010";  -- 7FA7 = DA
      when "111111110101000" =>  data <= "01001100";  -- 7FA8 = 4C
      when "111111110101001" =>  data <= "10100111";  -- 7FA9 = A7
      when "111111110101010" =>  data <= "11011010";  -- 7FAA = DA
      when "111111110101011" =>  data <= "01001100";  -- 7FAB = 4C
      when "111111110101100" =>  data <= "01110111";  -- 7FAC = 77
      when "111111110101101" =>  data <= "11011001";  -- 7FAD = D9
      when "111111110101110" =>  data <= "01001100";  -- 7FAE = 4C
      when "111111110101111" =>  data <= "00001101";  -- 7FAF = D
      when "111111110110000" =>  data <= "11011011";  -- 7FB0 = DB
      when "111111110110001" =>  data <= "01001100";  -- 7FB1 = 4C
      when "111111110110010" =>  data <= "00111010";  -- 7FB2 = 3A
      when "111111110110011" =>  data <= "11011011";  -- 7FB3 = DB
      when "111111110110100" =>  data <= "01001100";  -- 7FB4 = 4C
      when "111111110110101" =>  data <= "01110011";  -- 7FB5 = 73
      when "111111110110110" =>  data <= "11011000";  -- 7FB6 = D8
      when "111111110110111" =>  data <= "01001100";  -- 7FB7 = 4C
      when "111111110111000" =>  data <= "01010101";  -- 7FB8 = 55
      when "111111110111001" =>  data <= "11011011";  -- 7FB9 = DB
      when "111111110111010" =>  data <= "01001100";  -- 7FBA = 4C
      when "111111110111011" =>  data <= "01100110";  -- 7FBB = 66
      when "111111110111100" =>  data <= "11011011";  -- 7FBC = DB
      when "111111110111101" =>  data <= "01001100";  -- 7FBD = 4C
      when "111111110111110" =>  data <= "10010101";  -- 7FBE = 95
      when "111111110111111" =>  data <= "11011001";  -- 7FBF = D9
      when "111111111000000" =>  data <= "01001100";  -- 7FC0 = 4C
      when "111111111000001" =>  data <= "01100000";  -- 7FC1 = 60
      when "111111111000010" =>  data <= "11110101";  -- 7FC2 = F5
      when "111111111000011" =>  data <= "01001100";  -- 7FC3 = 4C
      when "111111111000100" =>  data <= "11011101";  -- 7FC4 = DD
      when "111111111000101" =>  data <= "11110010";  -- 7FC5 = F2
      when "111111111000110" =>  data <= "01001100";  -- 7FC6 = 4C
      when "111111111000111" =>  data <= "10101111";  -- 7FC7 = AF
      when "111111111001000" =>  data <= "11110111";  -- 7FC8 = F7
      when "111111111001001" =>  data <= "01001100";  -- 7FC9 = 4C
      when "111111111001010" =>  data <= "11111110";  -- 7FCA = FE
      when "111111111001011" =>  data <= "11110111";  -- 7FCB = F7
      when "111111111001100" =>  data <= "01001100";  -- 7FCC = 4C
      when "111111111001101" =>  data <= "10100110";  -- 7FCD = A6
      when "111111111001110" =>  data <= "11110010";  -- 7FCE = F2
      when "111111111001111" =>  data <= "01001100";  -- 7FCF = 4C
      when "111111111010000" =>  data <= "00010101";  -- 7FD0 = 15
      when "111111111010001" =>  data <= "11110010";  -- 7FD1 = F2
      when "111111111010010" =>  data <= "01001100";  -- 7FD2 = 4C
      when "111111111010011" =>  data <= "01100110";  -- 7FD3 = 66
      when "111111111010100" =>  data <= "11110010";  -- 7FD4 = F2
      when "111111111010101" =>  data <= "01001100";  -- 7FD5 = 4C
      when "111111111010110" =>  data <= "00000001";  -- 7FD6 = 1
      when "111111111010111" =>  data <= "11110100";  -- 7FD7 = F4
      when "111111111011000" =>  data <= "01001100";  -- 7FD8 = 4C
      when "111111111011001" =>  data <= "11011101";  -- 7FD9 = DD
      when "111111111011010" =>  data <= "11110110";  -- 7FDA = F6
      when "111111111011011" =>  data <= "01001100";  -- 7FDB = 4C
      when "111111111011100" =>  data <= "11110110";  -- 7FDC = F6
      when "111111111011101" =>  data <= "11110100";  -- 7FDD = F4
      when "111111111011110" =>  data <= "01001100";  -- 7FDE = 4C
      when "111111111011111" =>  data <= "11000011";  -- 7FDF = C3
      when "111111111100000" =>  data <= "11110110";  -- 7FE0 = F6
      when "111111111100001" =>  data <= "01001100";  -- 7FE1 = 4C
      when "111111111100010" =>  data <= "01000011";  -- 7FE2 = 43
      when "111111111100011" =>  data <= "11110011";  -- 7FE3 = F3
      when "111111111100100" =>  data <= "01001100";  -- 7FE4 = 4C
      when "111111111100101" =>  data <= "00000101";  -- 7FE5 = 5
      when "111111111100110" =>  data <= "11110010";  -- 7FE6 = F2
      when "111111111100111" =>  data <= "01001100";  -- 7FE7 = 4C
      when "111111111101000" =>  data <= "10100010";  -- 7FE8 = A2
      when "111111111101001" =>  data <= "11110010";  -- 7FE9 = F2
      when "111111111101010" =>  data <= "01001100";  -- 7FEA = 4C
      when "111111111101011" =>  data <= "01101000";  -- 7FEB = 68
      when "111111111101100" =>  data <= "11110111";  -- 7FEC = F7
      when "111111111101101" =>  data <= "10101010";  -- 7FED = AA
      when "111111111101110" =>  data <= "10101010";  -- 7FEE = AA
      when "111111111101111" =>  data <= "10101010";  -- 7FEF = AA
      when "111111111110000" =>  data <= "10101010";  -- 7FF0 = AA
      when "111111111110001" =>  data <= "10101010";  -- 7FF1 = AA
      when "111111111110010" =>  data <= "10101010";  -- 7FF2 = AA
      when "111111111110011" =>  data <= "10101010";  -- 7FF3 = AA
      when "111111111110100" =>  data <= "10101010";  -- 7FF4 = AA
      when "111111111110101" =>  data <= "10101010";  -- 7FF5 = AA
      when "111111111110110" =>  data <= "10101010";  -- 7FF6 = AA
      when "111111111110111" =>  data <= "10101010";  -- 7FF7 = AA
      when "111111111111000" =>  data <= "10101010";  -- 7FF8 = AA
      when "111111111111001" =>  data <= "10101010";  -- 7FF9 = AA
      when "111111111111010" =>  data <= "01001001";  -- 7FFA = 49
      when "111111111111011" =>  data <= "11111101";  -- 7FFB = FD
      when "111111111111100" =>  data <= "00010110";  -- 7FFC = 16
      when "111111111111101" =>  data <= "11111101";  -- 7FFD = FD
      when "111111111111110" =>  data <= "01000010";  -- 7FFE = 42
      when "111111111111111" =>  data <= "11100100";  -- 7FFF = E4
      --end_of_rom
      when others =>  data <= "00000000";
    end case;
  end process;

end arch_test_rom;

------------------------------------------------------------------------------
------------------------------------------------------------------------------

